#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 9
#define STATE_COUNT 84
#define SYMBOL_COUNT 59
#define ALIAS_COUNT 5
#define TOKEN_COUNT 39
#define EXTERNAL_TOKEN_COUNT 0
#define MAX_ALIAS_SEQUENCE_LENGTH 6

enum {
  anon_sym_PIPE = 1,
  anon_sym_LBRACE = 2,
  sym_any_character = 3,
  anon_sym_CARET = 4,
  sym_end_assertion = 5,
  sym_boundary_assertion = 6,
  sym_non_boundary_assertion = 7,
  anon_sym_LPAREN_QMARK = 8,
  anon_sym_EQ = 9,
  anon_sym_BANG = 10,
  anon_sym_LT_EQ = 11,
  anon_sym_LT_BANG = 12,
  anon_sym_RPAREN = 13,
  sym_pattern_character = 14,
  anon_sym_LBRACK = 15,
  anon_sym_RBRACK = 16,
  anon_sym_DASH = 17,
  anon_sym_BSLASH_DASH = 18,
  sym_class_character = 19,
  anon_sym_LPAREN = 20,
  anon_sym_LPAREN_QMARK_LT = 21,
  anon_sym_GT = 22,
  anon_sym_LPAREN_QMARK_COLON = 23,
  anon_sym_STAR = 24,
  anon_sym_QMARK = 25,
  anon_sym_PLUS = 26,
  anon_sym_COMMA = 27,
  anon_sym_RBRACE = 28,
  anon_sym_BSLASHk = 29,
  sym_decimal_escape = 30,
  aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH = 31,
  aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH = 32,
  sym_unicode_property = 33,
  sym_control_escape = 34,
  sym_control_letter_escape = 35,
  sym_identity_escape = 36,
  sym_group_name = 37,
  sym_decimal_digits = 38,
  sym_pattern = 39,
  sym_disjunction = 40,
  sym_term = 41,
  sym_start_assertion = 42,
  sym_lookahead_assertion = 43,
  sym_character_class = 44,
  sym_class_range = 45,
  sym_anonymous_capturing_group = 46,
  sym_named_capturing_group = 47,
  sym_non_capturing_group = 48,
  sym_zero_or_more = 49,
  sym_one_or_more = 50,
  sym_optional = 51,
  sym_count_quantifier = 52,
  sym_backreference_escape = 53,
  sym_character_class_escape = 54,
  sym_unicode_property_value_expression = 55,
  aux_sym_disjunction_repeat1 = 56,
  aux_sym_term_repeat1 = 57,
  aux_sym_character_class_repeat1 = 58,
  alias_sym_class_character = 59,
  alias_sym_lazy = 60,
  alias_sym_pattern_character = 61,
  alias_sym_unicode_property_name = 62,
  alias_sym_unicode_property_value = 63,
};

static const char *ts_symbol_names[] = {
  [ts_builtin_sym_end] = "END",
  [anon_sym_PIPE] = "|",
  [anon_sym_LBRACE] = "{",
  [sym_any_character] = "any_character",
  [anon_sym_CARET] = "^",
  [sym_end_assertion] = "end_assertion",
  [sym_boundary_assertion] = "boundary_assertion",
  [sym_non_boundary_assertion] = "non_boundary_assertion",
  [anon_sym_LPAREN_QMARK] = "(?",
  [anon_sym_EQ] = "=",
  [anon_sym_BANG] = "!",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_LT_BANG] = "<!",
  [anon_sym_RPAREN] = ")",
  [sym_pattern_character] = "pattern_character",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_DASH] = "-",
  [anon_sym_BSLASH_DASH] = "identity_escape",
  [sym_class_character] = "class_character",
  [anon_sym_LPAREN] = "(",
  [anon_sym_LPAREN_QMARK_LT] = "(?<",
  [anon_sym_GT] = ">",
  [anon_sym_LPAREN_QMARK_COLON] = "(?:",
  [anon_sym_STAR] = "*",
  [anon_sym_QMARK] = "?",
  [anon_sym_PLUS] = "+",
  [anon_sym_COMMA] = ",",
  [anon_sym_RBRACE] = "}",
  [anon_sym_BSLASHk] = "\\k",
  [sym_decimal_escape] = "decimal_escape",
  [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = "/\\\\[dDsSwW]/",
  [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = "/\\\\[pP]/",
  [sym_unicode_property] = "unicode_property",
  [sym_control_escape] = "control_escape",
  [sym_control_letter_escape] = "control_letter_escape",
  [sym_identity_escape] = "identity_escape",
  [sym_group_name] = "group_name",
  [sym_decimal_digits] = "decimal_digits",
  [sym_pattern] = "pattern",
  [sym_disjunction] = "disjunction",
  [sym_term] = "term",
  [sym_start_assertion] = "start_assertion",
  [sym_lookahead_assertion] = "lookahead_assertion",
  [sym_character_class] = "character_class",
  [sym_class_range] = "class_range",
  [sym_anonymous_capturing_group] = "anonymous_capturing_group",
  [sym_named_capturing_group] = "named_capturing_group",
  [sym_non_capturing_group] = "non_capturing_group",
  [sym_zero_or_more] = "zero_or_more",
  [sym_one_or_more] = "one_or_more",
  [sym_optional] = "optional",
  [sym_count_quantifier] = "count_quantifier",
  [sym_backreference_escape] = "backreference_escape",
  [sym_character_class_escape] = "character_class_escape",
  [sym_unicode_property_value_expression] = "unicode_property_value_expression",
  [aux_sym_disjunction_repeat1] = "disjunction_repeat1",
  [aux_sym_term_repeat1] = "term_repeat1",
  [aux_sym_character_class_repeat1] = "character_class_repeat1",
  [alias_sym_class_character] = "class_character",
  [alias_sym_lazy] = "lazy",
  [alias_sym_pattern_character] = "pattern_character",
  [alias_sym_unicode_property_name] = "unicode_property_name",
  [alias_sym_unicode_property_value] = "unicode_property_value",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [sym_any_character] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [sym_end_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_boundary_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_non_boundary_assertion] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [sym_pattern_character] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASH_DASH] = {
    .visible = true,
    .named = true,
  },
  [sym_class_character] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_QMARK_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_QMARK_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_QMARK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BSLASHk] = {
    .visible = true,
    .named = false,
  },
  [sym_decimal_escape] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = {
    .visible = false,
    .named = false,
  },
  [sym_unicode_property] = {
    .visible = true,
    .named = true,
  },
  [sym_control_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_control_letter_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_identity_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_group_name] = {
    .visible = true,
    .named = true,
  },
  [sym_decimal_digits] = {
    .visible = true,
    .named = true,
  },
  [sym_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_disjunction] = {
    .visible = true,
    .named = true,
  },
  [sym_term] = {
    .visible = true,
    .named = true,
  },
  [sym_start_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_lookahead_assertion] = {
    .visible = true,
    .named = true,
  },
  [sym_character_class] = {
    .visible = true,
    .named = true,
  },
  [sym_class_range] = {
    .visible = true,
    .named = true,
  },
  [sym_anonymous_capturing_group] = {
    .visible = true,
    .named = true,
  },
  [sym_named_capturing_group] = {
    .visible = true,
    .named = true,
  },
  [sym_non_capturing_group] = {
    .visible = true,
    .named = true,
  },
  [sym_zero_or_more] = {
    .visible = true,
    .named = true,
  },
  [sym_one_or_more] = {
    .visible = true,
    .named = true,
  },
  [sym_optional] = {
    .visible = true,
    .named = true,
  },
  [sym_count_quantifier] = {
    .visible = true,
    .named = true,
  },
  [sym_backreference_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_character_class_escape] = {
    .visible = true,
    .named = true,
  },
  [sym_unicode_property_value_expression] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_disjunction_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_term_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_character_class_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_class_character] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_lazy] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_pattern_character] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_unicode_property_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_unicode_property_value] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[10][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [1] = {
    [0] = alias_sym_pattern_character,
  },
  [2] = {
    [0] = alias_sym_class_character,
  },
  [3] = {
    [1] = alias_sym_lazy,
  },
  [4] = {
    [0] = alias_sym_unicode_property_value,
  },
  [5] = {
    [0] = alias_sym_class_character,
    [2] = alias_sym_class_character,
  },
  [6] = {
    [2] = alias_sym_class_character,
  },
  [7] = {
    [3] = alias_sym_lazy,
  },
  [8] = {
    [0] = alias_sym_unicode_property_name,
    [2] = alias_sym_unicode_property_value,
  },
  [9] = {
    [5] = alias_sym_lazy,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        SKIP(0);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '$')
        ADVANCE(3);
      if (lookahead == '(')
        ADVANCE(4);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(9);
      if (lookahead == '+')
        ADVANCE(10);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '-')
        ADVANCE(12);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '=')
        ADVANCE(14);
      if (lookahead == '>')
        ADVANCE(15);
      if (lookahead == '?')
        ADVANCE(16);
      if (lookahead == '[')
        ADVANCE(17);
      if (lookahead == '\\')
        ADVANCE(18);
      if (lookahead == ']')
        ADVANCE(31);
      if (lookahead == '^')
        ADVANCE(32);
      if (lookahead == '_')
        ADVANCE(33);
      if (lookahead == '{')
        ADVANCE(34);
      if (lookahead == '|')
        ADVANCE(35);
      if (lookahead == '}')
        ADVANCE(36);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(37);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(38);
      ADVANCE(39);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(sym_end_assertion);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead == '?')
        ADVANCE(5);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(anon_sym_LPAREN_QMARK);
      if (lookahead == ':')
        ADVANCE(6);
      if (lookahead == '<')
        ADVANCE(7);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(anon_sym_LPAREN_QMARK_COLON);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(anon_sym_LPAREN_QMARK_LT);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(sym_any_character);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(anon_sym_GT);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(anon_sym_QMARK);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 18:
      if (lookahead == '-')
        ADVANCE(19);
      if (lookahead == 'B')
        ADVANCE(20);
      if (lookahead == 'b')
        ADVANCE(21);
      if (lookahead == 'c')
        ADVANCE(22);
      if (lookahead == 'k')
        ADVANCE(24);
      if (lookahead == 'P' ||
          lookahead == 'p')
        ADVANCE(25);
      if (lookahead == '0' ||
          lookahead == 'f' ||
          lookahead == 'n' ||
          lookahead == 'r' ||
          lookahead == 't' ||
          lookahead == 'v')
        ADVANCE(26);
      if (lookahead == 'D' ||
          lookahead == 'S' ||
          lookahead == 'W' ||
          lookahead == 'd' ||
          lookahead == 's' ||
          lookahead == 'w')
        ADVANCE(27);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(28);
      if (lookahead != 0)
        ADVANCE(30);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_BSLASH_DASH);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(sym_non_boundary_assertion);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(sym_boundary_assertion);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(sym_identity_escape);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(23);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(sym_control_letter_escape);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(anon_sym_BSLASHk);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(sym_control_escape);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH);
      END_STATE();
    case 28:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(29);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(sym_decimal_escape);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(29);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(sym_identity_escape);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(sym_unicode_property);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(33);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 36:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 37:
      ACCEPT_TOKEN(sym_unicode_property);
      if (lookahead == '_')
        ADVANCE(33);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(37);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(38);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(sym_unicode_property);
      if (lookahead == '_')
        ADVANCE(33);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(38);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(sym_pattern_character);
      END_STATE();
    case 40:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        SKIP(40);
      if (lookahead == '$')
        ADVANCE(3);
      if (lookahead == '(')
        ADVANCE(4);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '[')
        ADVANCE(17);
      if (lookahead == '\\')
        ADVANCE(41);
      if (lookahead == '^')
        ADVANCE(32);
      if (lookahead == '{')
        ADVANCE(34);
      if (lookahead == '|')
        ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(42);
      if ((lookahead < '(' || lookahead > '+') &&
          lookahead != '?' &&
          (lookahead < '[' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(39);
      END_STATE();
    case 41:
      if (lookahead == 'B')
        ADVANCE(20);
      if (lookahead == 'b')
        ADVANCE(21);
      if (lookahead == 'c')
        ADVANCE(22);
      if (lookahead == 'k')
        ADVANCE(24);
      if (lookahead == 'P' ||
          lookahead == 'p')
        ADVANCE(25);
      if (lookahead == '0' ||
          lookahead == 'f' ||
          lookahead == 'n' ||
          lookahead == 'r' ||
          lookahead == 't' ||
          lookahead == 'v')
        ADVANCE(26);
      if (lookahead == 'D' ||
          lookahead == 'S' ||
          lookahead == 'W' ||
          lookahead == 'd' ||
          lookahead == 's' ||
          lookahead == 'w')
        ADVANCE(27);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(28);
      if (lookahead != 0)
        ADVANCE(30);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(sym_decimal_digits);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(42);
      END_STATE();
    case 43:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        SKIP(43);
      if (lookahead == '$')
        ADVANCE(3);
      if (lookahead == '(')
        ADVANCE(4);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '*')
        ADVANCE(9);
      if (lookahead == '+')
        ADVANCE(10);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '?')
        ADVANCE(16);
      if (lookahead == '[')
        ADVANCE(17);
      if (lookahead == '\\')
        ADVANCE(41);
      if (lookahead == '^')
        ADVANCE(32);
      if (lookahead == '{')
        ADVANCE(34);
      if (lookahead == '|')
        ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(42);
      if ((lookahead < '[' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(39);
      END_STATE();
    case 44:
      if (lookahead == '\n')
        SKIP(44);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '<')
        ADVANCE(45);
      if (lookahead == '=')
        ADVANCE(14);
      END_STATE();
    case 45:
      if (lookahead == '!')
        ADVANCE(46);
      if (lookahead == '=')
        ADVANCE(47);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(anon_sym_LT_BANG);
      END_STATE();
    case 47:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 48:
      if (lookahead == '\n')
        ADVANCE(49);
      if (lookahead == '-')
        ADVANCE(12);
      if (lookahead == '\\')
        ADVANCE(50);
      if (lookahead == ']')
        ADVANCE(31);
      if (lookahead == '^')
        ADVANCE(32);
      if (lookahead != 0)
        ADVANCE(49);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(sym_class_character);
      END_STATE();
    case 50:
      if (lookahead == '-')
        ADVANCE(19);
      if (lookahead == 'c')
        ADVANCE(22);
      if (lookahead == 'P' ||
          lookahead == 'p')
        ADVANCE(25);
      if (lookahead == 'D' ||
          lookahead == 'S' ||
          lookahead == 'W' ||
          lookahead == 'd' ||
          lookahead == 's' ||
          lookahead == 'w')
        ADVANCE(27);
      if (lookahead == '0' ||
          lookahead == 'b' ||
          lookahead == 'f' ||
          lookahead == 'n' ||
          ('r' <= lookahead && lookahead <= 't') ||
          lookahead == 'v')
        ADVANCE(26);
      if (lookahead != 0 &&
          (lookahead < '0' || lookahead > '9') &&
          lookahead != 'k')
        ADVANCE(30);
      END_STATE();
    case 51:
      if (lookahead == '\n')
        SKIP(51);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(52);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(sym_group_name);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(52);
      END_STATE();
    case 53:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        SKIP(53);
      END_STATE();
    case 54:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        SKIP(54);
      if (lookahead == ')')
        ADVANCE(8);
      END_STATE();
    case 55:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        SKIP(55);
      if (lookahead == '|')
        ADVANCE(35);
      END_STATE();
    case 56:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        SKIP(56);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '|')
        ADVANCE(35);
      END_STATE();
    case 57:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        SKIP(57);
      if (lookahead == '$')
        ADVANCE(3);
      if (lookahead == '(')
        ADVANCE(4);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '?')
        ADVANCE(16);
      if (lookahead == '[')
        ADVANCE(17);
      if (lookahead == '\\')
        ADVANCE(41);
      if (lookahead == '^')
        ADVANCE(32);
      if (lookahead == '{')
        ADVANCE(34);
      if (lookahead == '|')
        ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(42);
      if ((lookahead < '(' || lookahead > '+') &&
          (lookahead < '[' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(39);
      END_STATE();
    case 58:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '\n')
        SKIP(58);
      if (lookahead == '$')
        ADVANCE(3);
      if (lookahead == '(')
        ADVANCE(4);
      if (lookahead == ')')
        ADVANCE(8);
      if (lookahead == '.')
        ADVANCE(13);
      if (lookahead == '[')
        ADVANCE(17);
      if (lookahead == '\\')
        ADVANCE(41);
      if (lookahead == '^')
        ADVANCE(32);
      if (lookahead == '{')
        ADVANCE(34);
      if (lookahead == '|')
        ADVANCE(35);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(42);
      if ((lookahead < '(' || lookahead > '+') &&
          lookahead != '?' &&
          (lookahead < '[' || lookahead > '^') &&
          (lookahead < '{' || lookahead > '}'))
        ADVANCE(39);
      END_STATE();
    case 59:
      if (lookahead == '\n')
        ADVANCE(49);
      if (lookahead == '-')
        ADVANCE(12);
      if (lookahead == '\\')
        ADVANCE(50);
      if (lookahead == ']')
        ADVANCE(31);
      if (lookahead != 0)
        ADVANCE(49);
      END_STATE();
    case 60:
      if (lookahead == '\n')
        SKIP(60);
      if (lookahead == '>')
        ADVANCE(15);
      END_STATE();
    case 61:
      if (lookahead == '\n')
        SKIP(61);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(33);
      END_STATE();
    case 62:
      if (lookahead == '\n')
        SKIP(62);
      if (lookahead == ',')
        ADVANCE(11);
      if (lookahead == '}')
        ADVANCE(36);
      END_STATE();
    case 63:
      if (lookahead == '\n')
        SKIP(63);
      if (lookahead == '=')
        ADVANCE(14);
      if (lookahead == '}')
        ADVANCE(36);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0},
  [1] = {.lex_state = 40},
  [2] = {.lex_state = 40},
  [3] = {.lex_state = 43},
  [4] = {.lex_state = 43},
  [5] = {.lex_state = 43},
  [6] = {.lex_state = 44},
  [7] = {.lex_state = 48},
  [8] = {.lex_state = 40},
  [9] = {.lex_state = 51},
  [10] = {.lex_state = 40},
  [11] = {.lex_state = 51},
  [12] = {.lex_state = 43},
  [13] = {.lex_state = 40},
  [14] = {.lex_state = 53},
  [15] = {.lex_state = 54},
  [16] = {.lex_state = 55},
  [17] = {.lex_state = 55},
  [18] = {.lex_state = 40},
  [19] = {.lex_state = 56},
  [20] = {.lex_state = 40},
  [21] = {.lex_state = 57},
  [22] = {.lex_state = 57},
  [23] = {.lex_state = 57},
  [24] = {.lex_state = 58},
  [25] = {.lex_state = 58},
  [26] = {.lex_state = 40},
  [27] = {.lex_state = 59},
  [28] = {.lex_state = 43},
  [29] = {.lex_state = 59},
  [30] = {.lex_state = 59},
  [31] = {.lex_state = 59},
  [32] = {.lex_state = 40},
  [33] = {.lex_state = 59},
  [34] = {.lex_state = 43},
  [35] = {.lex_state = 43},
  [36] = {.lex_state = 43},
  [37] = {.lex_state = 43},
  [38] = {.lex_state = 43},
  [39] = {.lex_state = 60},
  [40] = {.lex_state = 43},
  [41] = {.lex_state = 43},
  [42] = {.lex_state = 61},
  [43] = {.lex_state = 55},
  [44] = {.lex_state = 55},
  [45] = {.lex_state = 40},
  [46] = {.lex_state = 62},
  [47] = {.lex_state = 58},
  [48] = {.lex_state = 58},
  [49] = {.lex_state = 58},
  [50] = {.lex_state = 43},
  [51] = {.lex_state = 43},
  [52] = {.lex_state = 59},
  [53] = {.lex_state = 59},
  [54] = {.lex_state = 59},
  [55] = {.lex_state = 61},
  [56] = {.lex_state = 59},
  [57] = {.lex_state = 43},
  [58] = {.lex_state = 43},
  [59] = {.lex_state = 43},
  [60] = {.lex_state = 43},
  [61] = {.lex_state = 40},
  [62] = {.lex_state = 43},
  [63] = {.lex_state = 63},
  [64] = {.lex_state = 62},
  [65] = {.lex_state = 40},
  [66] = {.lex_state = 57},
  [67] = {.lex_state = 43},
  [68] = {.lex_state = 43},
  [69] = {.lex_state = 59},
  [70] = {.lex_state = 59},
  [71] = {.lex_state = 59},
  [72] = {.lex_state = 59},
  [73] = {.lex_state = 62},
  [74] = {.lex_state = 43},
  [75] = {.lex_state = 61},
  [76] = {.lex_state = 43},
  [77] = {.lex_state = 62},
  [78] = {.lex_state = 58},
  [79] = {.lex_state = 59},
  [80] = {.lex_state = 43},
  [81] = {.lex_state = 62},
  [82] = {.lex_state = 57},
  [83] = {.lex_state = 58},
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_PIPE] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [sym_any_character] = ACTIONS(1),
    [anon_sym_CARET] = ACTIONS(1),
    [sym_end_assertion] = ACTIONS(1),
    [sym_boundary_assertion] = ACTIONS(1),
    [sym_non_boundary_assertion] = ACTIONS(1),
    [anon_sym_LPAREN_QMARK] = ACTIONS(3),
    [anon_sym_EQ] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [sym_pattern_character] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_DASH] = ACTIONS(1),
    [anon_sym_BSLASH_DASH] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(3),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(1),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(1),
    [anon_sym_STAR] = ACTIONS(1),
    [anon_sym_QMARK] = ACTIONS(1),
    [anon_sym_PLUS] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym_BSLASHk] = ACTIONS(1),
    [sym_decimal_escape] = ACTIONS(1),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(1),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(1),
    [sym_unicode_property] = ACTIONS(1),
    [sym_control_escape] = ACTIONS(3),
    [sym_control_letter_escape] = ACTIONS(1),
    [sym_identity_escape] = ACTIONS(3),
    [sym_group_name] = ACTIONS(3),
    [sym_decimal_digits] = ACTIONS(3),
  },
  [1] = {
    [sym_pattern] = STATE(14),
    [sym_disjunction] = STATE(15),
    [sym_term] = STATE(16),
    [sym_start_assertion] = STATE(4),
    [sym_lookahead_assertion] = STATE(4),
    [sym_character_class] = STATE(4),
    [sym_anonymous_capturing_group] = STATE(4),
    [sym_named_capturing_group] = STATE(4),
    [sym_non_capturing_group] = STATE(4),
    [sym_backreference_escape] = STATE(4),
    [sym_character_class_escape] = STATE(4),
    [aux_sym_disjunction_repeat1] = STATE(17),
    [aux_sym_term_repeat1] = STATE(18),
    [anon_sym_PIPE] = ACTIONS(5),
    [anon_sym_LBRACE] = ACTIONS(7),
    [sym_any_character] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [sym_end_assertion] = ACTIONS(9),
    [sym_boundary_assertion] = ACTIONS(9),
    [sym_non_boundary_assertion] = ACTIONS(9),
    [anon_sym_LPAREN_QMARK] = ACTIONS(13),
    [sym_pattern_character] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(21),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(23),
    [anon_sym_BSLASHk] = ACTIONS(25),
    [sym_decimal_escape] = ACTIONS(9),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(27),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(29),
    [sym_control_escape] = ACTIONS(15),
    [sym_control_letter_escape] = ACTIONS(9),
    [sym_identity_escape] = ACTIONS(15),
    [sym_decimal_digits] = ACTIONS(7),
  },
  [2] = {
    [sym_term] = STATE(19),
    [sym_start_assertion] = STATE(4),
    [sym_lookahead_assertion] = STATE(4),
    [sym_character_class] = STATE(4),
    [sym_anonymous_capturing_group] = STATE(4),
    [sym_named_capturing_group] = STATE(4),
    [sym_non_capturing_group] = STATE(4),
    [sym_backreference_escape] = STATE(4),
    [sym_character_class_escape] = STATE(4),
    [aux_sym_term_repeat1] = STATE(18),
    [ts_builtin_sym_end] = ACTIONS(31),
    [anon_sym_PIPE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(7),
    [sym_any_character] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [sym_end_assertion] = ACTIONS(9),
    [sym_boundary_assertion] = ACTIONS(9),
    [sym_non_boundary_assertion] = ACTIONS(9),
    [anon_sym_LPAREN_QMARK] = ACTIONS(13),
    [sym_pattern_character] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(21),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(23),
    [anon_sym_BSLASHk] = ACTIONS(25),
    [sym_decimal_escape] = ACTIONS(9),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(27),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(29),
    [sym_control_escape] = ACTIONS(15),
    [sym_control_letter_escape] = ACTIONS(9),
    [sym_identity_escape] = ACTIONS(15),
    [sym_decimal_digits] = ACTIONS(7),
  },
  [3] = {
    [sym_zero_or_more] = STATE(24),
    [sym_one_or_more] = STATE(24),
    [sym_optional] = STATE(24),
    [sym_count_quantifier] = STATE(24),
    [ts_builtin_sym_end] = ACTIONS(33),
    [anon_sym_PIPE] = ACTIONS(33),
    [anon_sym_LBRACE] = ACTIONS(35),
    [sym_any_character] = ACTIONS(33),
    [anon_sym_CARET] = ACTIONS(33),
    [sym_end_assertion] = ACTIONS(33),
    [sym_boundary_assertion] = ACTIONS(33),
    [sym_non_boundary_assertion] = ACTIONS(33),
    [anon_sym_LPAREN_QMARK] = ACTIONS(38),
    [anon_sym_RPAREN] = ACTIONS(33),
    [sym_pattern_character] = ACTIONS(38),
    [anon_sym_LBRACK] = ACTIONS(33),
    [anon_sym_LPAREN] = ACTIONS(38),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(33),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(33),
    [anon_sym_STAR] = ACTIONS(40),
    [anon_sym_QMARK] = ACTIONS(42),
    [anon_sym_PLUS] = ACTIONS(44),
    [anon_sym_BSLASHk] = ACTIONS(33),
    [sym_decimal_escape] = ACTIONS(33),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(33),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(33),
    [sym_control_escape] = ACTIONS(38),
    [sym_control_letter_escape] = ACTIONS(33),
    [sym_identity_escape] = ACTIONS(38),
    [sym_decimal_digits] = ACTIONS(33),
  },
  [4] = {
    [sym_zero_or_more] = STATE(25),
    [sym_one_or_more] = STATE(25),
    [sym_optional] = STATE(25),
    [sym_count_quantifier] = STATE(25),
    [ts_builtin_sym_end] = ACTIONS(46),
    [anon_sym_PIPE] = ACTIONS(46),
    [anon_sym_LBRACE] = ACTIONS(48),
    [sym_any_character] = ACTIONS(46),
    [anon_sym_CARET] = ACTIONS(46),
    [sym_end_assertion] = ACTIONS(46),
    [sym_boundary_assertion] = ACTIONS(46),
    [sym_non_boundary_assertion] = ACTIONS(46),
    [anon_sym_LPAREN_QMARK] = ACTIONS(51),
    [anon_sym_RPAREN] = ACTIONS(46),
    [sym_pattern_character] = ACTIONS(51),
    [anon_sym_LBRACK] = ACTIONS(46),
    [anon_sym_LPAREN] = ACTIONS(51),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(46),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(46),
    [anon_sym_STAR] = ACTIONS(40),
    [anon_sym_QMARK] = ACTIONS(42),
    [anon_sym_PLUS] = ACTIONS(44),
    [anon_sym_BSLASHk] = ACTIONS(46),
    [sym_decimal_escape] = ACTIONS(46),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(46),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(46),
    [sym_control_escape] = ACTIONS(51),
    [sym_control_letter_escape] = ACTIONS(46),
    [sym_identity_escape] = ACTIONS(51),
    [sym_decimal_digits] = ACTIONS(46),
  },
  [5] = {
    [ts_builtin_sym_end] = ACTIONS(53),
    [anon_sym_PIPE] = ACTIONS(53),
    [anon_sym_LBRACE] = ACTIONS(53),
    [sym_any_character] = ACTIONS(53),
    [anon_sym_CARET] = ACTIONS(53),
    [sym_end_assertion] = ACTIONS(53),
    [sym_boundary_assertion] = ACTIONS(53),
    [sym_non_boundary_assertion] = ACTIONS(53),
    [anon_sym_LPAREN_QMARK] = ACTIONS(55),
    [anon_sym_RPAREN] = ACTIONS(53),
    [sym_pattern_character] = ACTIONS(55),
    [anon_sym_LBRACK] = ACTIONS(53),
    [anon_sym_LPAREN] = ACTIONS(55),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(53),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(53),
    [anon_sym_STAR] = ACTIONS(53),
    [anon_sym_QMARK] = ACTIONS(53),
    [anon_sym_PLUS] = ACTIONS(53),
    [anon_sym_BSLASHk] = ACTIONS(53),
    [sym_decimal_escape] = ACTIONS(53),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(53),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(53),
    [sym_control_escape] = ACTIONS(55),
    [sym_control_letter_escape] = ACTIONS(53),
    [sym_identity_escape] = ACTIONS(55),
    [sym_decimal_digits] = ACTIONS(53),
  },
  [6] = {
    [anon_sym_EQ] = ACTIONS(57),
    [anon_sym_BANG] = ACTIONS(57),
    [anon_sym_LT_EQ] = ACTIONS(57),
    [anon_sym_LT_BANG] = ACTIONS(57),
  },
  [7] = {
    [sym_class_range] = STATE(33),
    [sym_character_class_escape] = STATE(30),
    [aux_sym_character_class_repeat1] = STATE(33),
    [anon_sym_CARET] = ACTIONS(59),
    [anon_sym_RBRACK] = ACTIONS(61),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_BSLASH_DASH] = ACTIONS(65),
    [sym_class_character] = ACTIONS(65),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(67),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(69),
    [sym_control_escape] = ACTIONS(65),
    [sym_control_letter_escape] = ACTIONS(65),
    [sym_identity_escape] = ACTIONS(65),
  },
  [8] = {
    [sym_pattern] = STATE(35),
    [sym_disjunction] = STATE(15),
    [sym_term] = STATE(36),
    [sym_start_assertion] = STATE(4),
    [sym_lookahead_assertion] = STATE(4),
    [sym_character_class] = STATE(4),
    [sym_anonymous_capturing_group] = STATE(4),
    [sym_named_capturing_group] = STATE(4),
    [sym_non_capturing_group] = STATE(4),
    [sym_backreference_escape] = STATE(4),
    [sym_character_class_escape] = STATE(4),
    [aux_sym_disjunction_repeat1] = STATE(37),
    [aux_sym_term_repeat1] = STATE(38),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_LBRACE] = ACTIONS(7),
    [sym_any_character] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [sym_end_assertion] = ACTIONS(9),
    [sym_boundary_assertion] = ACTIONS(9),
    [sym_non_boundary_assertion] = ACTIONS(9),
    [anon_sym_LPAREN_QMARK] = ACTIONS(13),
    [sym_pattern_character] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(21),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(23),
    [anon_sym_BSLASHk] = ACTIONS(25),
    [sym_decimal_escape] = ACTIONS(9),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(27),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(29),
    [sym_control_escape] = ACTIONS(15),
    [sym_control_letter_escape] = ACTIONS(9),
    [sym_identity_escape] = ACTIONS(15),
    [sym_decimal_digits] = ACTIONS(7),
  },
  [9] = {
    [sym_group_name] = ACTIONS(73),
  },
  [10] = {
    [sym_pattern] = STATE(40),
    [sym_disjunction] = STATE(15),
    [sym_term] = STATE(36),
    [sym_start_assertion] = STATE(4),
    [sym_lookahead_assertion] = STATE(4),
    [sym_character_class] = STATE(4),
    [sym_anonymous_capturing_group] = STATE(4),
    [sym_named_capturing_group] = STATE(4),
    [sym_non_capturing_group] = STATE(4),
    [sym_backreference_escape] = STATE(4),
    [sym_character_class_escape] = STATE(4),
    [aux_sym_disjunction_repeat1] = STATE(37),
    [aux_sym_term_repeat1] = STATE(38),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_LBRACE] = ACTIONS(7),
    [sym_any_character] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [sym_end_assertion] = ACTIONS(9),
    [sym_boundary_assertion] = ACTIONS(9),
    [sym_non_boundary_assertion] = ACTIONS(9),
    [anon_sym_LPAREN_QMARK] = ACTIONS(13),
    [sym_pattern_character] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(21),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(23),
    [anon_sym_BSLASHk] = ACTIONS(25),
    [sym_decimal_escape] = ACTIONS(9),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(27),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(29),
    [sym_control_escape] = ACTIONS(15),
    [sym_control_letter_escape] = ACTIONS(9),
    [sym_identity_escape] = ACTIONS(15),
    [sym_decimal_digits] = ACTIONS(7),
  },
  [11] = {
    [sym_group_name] = ACTIONS(75),
  },
  [12] = {
    [ts_builtin_sym_end] = ACTIONS(77),
    [anon_sym_PIPE] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(77),
    [sym_any_character] = ACTIONS(77),
    [anon_sym_CARET] = ACTIONS(77),
    [sym_end_assertion] = ACTIONS(77),
    [sym_boundary_assertion] = ACTIONS(77),
    [sym_non_boundary_assertion] = ACTIONS(77),
    [anon_sym_LPAREN_QMARK] = ACTIONS(79),
    [anon_sym_RPAREN] = ACTIONS(77),
    [sym_pattern_character] = ACTIONS(79),
    [anon_sym_LBRACK] = ACTIONS(77),
    [anon_sym_LPAREN] = ACTIONS(79),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(77),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(77),
    [anon_sym_STAR] = ACTIONS(77),
    [anon_sym_QMARK] = ACTIONS(77),
    [anon_sym_PLUS] = ACTIONS(77),
    [anon_sym_BSLASHk] = ACTIONS(77),
    [sym_decimal_escape] = ACTIONS(77),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(77),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(77),
    [sym_control_escape] = ACTIONS(79),
    [sym_control_letter_escape] = ACTIONS(77),
    [sym_identity_escape] = ACTIONS(79),
    [sym_decimal_digits] = ACTIONS(77),
  },
  [13] = {
    [anon_sym_LBRACE] = ACTIONS(81),
  },
  [14] = {
    [ts_builtin_sym_end] = ACTIONS(83),
  },
  [15] = {
    [ts_builtin_sym_end] = ACTIONS(85),
    [anon_sym_RPAREN] = ACTIONS(85),
  },
  [16] = {
    [aux_sym_disjunction_repeat1] = STATE(43),
    [ts_builtin_sym_end] = ACTIONS(85),
    [anon_sym_PIPE] = ACTIONS(5),
  },
  [17] = {
    [aux_sym_disjunction_repeat1] = STATE(44),
    [ts_builtin_sym_end] = ACTIONS(87),
    [anon_sym_PIPE] = ACTIONS(5),
  },
  [18] = {
    [sym_start_assertion] = STATE(4),
    [sym_lookahead_assertion] = STATE(4),
    [sym_character_class] = STATE(4),
    [sym_anonymous_capturing_group] = STATE(4),
    [sym_named_capturing_group] = STATE(4),
    [sym_non_capturing_group] = STATE(4),
    [sym_backreference_escape] = STATE(4),
    [sym_character_class_escape] = STATE(4),
    [aux_sym_term_repeat1] = STATE(45),
    [ts_builtin_sym_end] = ACTIONS(89),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_LBRACE] = ACTIONS(7),
    [sym_any_character] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [sym_end_assertion] = ACTIONS(9),
    [sym_boundary_assertion] = ACTIONS(9),
    [sym_non_boundary_assertion] = ACTIONS(9),
    [anon_sym_LPAREN_QMARK] = ACTIONS(13),
    [sym_pattern_character] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(21),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(23),
    [anon_sym_BSLASHk] = ACTIONS(25),
    [sym_decimal_escape] = ACTIONS(9),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(27),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(29),
    [sym_control_escape] = ACTIONS(15),
    [sym_control_letter_escape] = ACTIONS(9),
    [sym_identity_escape] = ACTIONS(15),
    [sym_decimal_digits] = ACTIONS(7),
  },
  [19] = {
    [ts_builtin_sym_end] = ACTIONS(91),
    [anon_sym_PIPE] = ACTIONS(91),
    [anon_sym_RPAREN] = ACTIONS(91),
  },
  [20] = {
    [sym_decimal_digits] = ACTIONS(93),
  },
  [21] = {
    [ts_builtin_sym_end] = ACTIONS(95),
    [anon_sym_PIPE] = ACTIONS(95),
    [anon_sym_LBRACE] = ACTIONS(95),
    [sym_any_character] = ACTIONS(95),
    [anon_sym_CARET] = ACTIONS(95),
    [sym_end_assertion] = ACTIONS(95),
    [sym_boundary_assertion] = ACTIONS(95),
    [sym_non_boundary_assertion] = ACTIONS(95),
    [anon_sym_LPAREN_QMARK] = ACTIONS(97),
    [anon_sym_RPAREN] = ACTIONS(95),
    [sym_pattern_character] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(95),
    [anon_sym_LPAREN] = ACTIONS(97),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(95),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(95),
    [anon_sym_QMARK] = ACTIONS(99),
    [anon_sym_BSLASHk] = ACTIONS(95),
    [sym_decimal_escape] = ACTIONS(95),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(95),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(95),
    [sym_control_escape] = ACTIONS(97),
    [sym_control_letter_escape] = ACTIONS(95),
    [sym_identity_escape] = ACTIONS(97),
    [sym_decimal_digits] = ACTIONS(95),
  },
  [22] = {
    [ts_builtin_sym_end] = ACTIONS(101),
    [anon_sym_PIPE] = ACTIONS(101),
    [anon_sym_LBRACE] = ACTIONS(101),
    [sym_any_character] = ACTIONS(101),
    [anon_sym_CARET] = ACTIONS(101),
    [sym_end_assertion] = ACTIONS(101),
    [sym_boundary_assertion] = ACTIONS(101),
    [sym_non_boundary_assertion] = ACTIONS(101),
    [anon_sym_LPAREN_QMARK] = ACTIONS(103),
    [anon_sym_RPAREN] = ACTIONS(101),
    [sym_pattern_character] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(101),
    [anon_sym_LPAREN] = ACTIONS(103),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(101),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(101),
    [anon_sym_QMARK] = ACTIONS(105),
    [anon_sym_BSLASHk] = ACTIONS(101),
    [sym_decimal_escape] = ACTIONS(101),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(101),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(101),
    [sym_control_escape] = ACTIONS(103),
    [sym_control_letter_escape] = ACTIONS(101),
    [sym_identity_escape] = ACTIONS(103),
    [sym_decimal_digits] = ACTIONS(101),
  },
  [23] = {
    [ts_builtin_sym_end] = ACTIONS(107),
    [anon_sym_PIPE] = ACTIONS(107),
    [anon_sym_LBRACE] = ACTIONS(107),
    [sym_any_character] = ACTIONS(107),
    [anon_sym_CARET] = ACTIONS(107),
    [sym_end_assertion] = ACTIONS(107),
    [sym_boundary_assertion] = ACTIONS(107),
    [sym_non_boundary_assertion] = ACTIONS(107),
    [anon_sym_LPAREN_QMARK] = ACTIONS(109),
    [anon_sym_RPAREN] = ACTIONS(107),
    [sym_pattern_character] = ACTIONS(109),
    [anon_sym_LBRACK] = ACTIONS(107),
    [anon_sym_LPAREN] = ACTIONS(109),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(107),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(107),
    [anon_sym_QMARK] = ACTIONS(111),
    [anon_sym_BSLASHk] = ACTIONS(107),
    [sym_decimal_escape] = ACTIONS(107),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(107),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(107),
    [sym_control_escape] = ACTIONS(109),
    [sym_control_letter_escape] = ACTIONS(107),
    [sym_identity_escape] = ACTIONS(109),
    [sym_decimal_digits] = ACTIONS(107),
  },
  [24] = {
    [ts_builtin_sym_end] = ACTIONS(113),
    [anon_sym_PIPE] = ACTIONS(113),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_any_character] = ACTIONS(113),
    [anon_sym_CARET] = ACTIONS(113),
    [sym_end_assertion] = ACTIONS(113),
    [sym_boundary_assertion] = ACTIONS(113),
    [sym_non_boundary_assertion] = ACTIONS(113),
    [anon_sym_LPAREN_QMARK] = ACTIONS(115),
    [anon_sym_RPAREN] = ACTIONS(113),
    [sym_pattern_character] = ACTIONS(115),
    [anon_sym_LBRACK] = ACTIONS(113),
    [anon_sym_LPAREN] = ACTIONS(115),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(113),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(113),
    [anon_sym_BSLASHk] = ACTIONS(113),
    [sym_decimal_escape] = ACTIONS(113),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(113),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(113),
    [sym_control_escape] = ACTIONS(115),
    [sym_control_letter_escape] = ACTIONS(113),
    [sym_identity_escape] = ACTIONS(115),
    [sym_decimal_digits] = ACTIONS(113),
  },
  [25] = {
    [ts_builtin_sym_end] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(117),
    [anon_sym_LBRACE] = ACTIONS(117),
    [sym_any_character] = ACTIONS(117),
    [anon_sym_CARET] = ACTIONS(117),
    [sym_end_assertion] = ACTIONS(117),
    [sym_boundary_assertion] = ACTIONS(117),
    [sym_non_boundary_assertion] = ACTIONS(117),
    [anon_sym_LPAREN_QMARK] = ACTIONS(119),
    [anon_sym_RPAREN] = ACTIONS(117),
    [sym_pattern_character] = ACTIONS(119),
    [anon_sym_LBRACK] = ACTIONS(117),
    [anon_sym_LPAREN] = ACTIONS(119),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(117),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(117),
    [anon_sym_BSLASHk] = ACTIONS(117),
    [sym_decimal_escape] = ACTIONS(117),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(117),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(117),
    [sym_control_escape] = ACTIONS(119),
    [sym_control_letter_escape] = ACTIONS(117),
    [sym_identity_escape] = ACTIONS(119),
    [sym_decimal_digits] = ACTIONS(117),
  },
  [26] = {
    [sym_pattern] = STATE(50),
    [sym_disjunction] = STATE(15),
    [sym_term] = STATE(36),
    [sym_start_assertion] = STATE(4),
    [sym_lookahead_assertion] = STATE(4),
    [sym_character_class] = STATE(4),
    [sym_anonymous_capturing_group] = STATE(4),
    [sym_named_capturing_group] = STATE(4),
    [sym_non_capturing_group] = STATE(4),
    [sym_backreference_escape] = STATE(4),
    [sym_character_class_escape] = STATE(4),
    [aux_sym_disjunction_repeat1] = STATE(37),
    [aux_sym_term_repeat1] = STATE(38),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_LBRACE] = ACTIONS(7),
    [sym_any_character] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [sym_end_assertion] = ACTIONS(9),
    [sym_boundary_assertion] = ACTIONS(9),
    [sym_non_boundary_assertion] = ACTIONS(9),
    [anon_sym_LPAREN_QMARK] = ACTIONS(13),
    [sym_pattern_character] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(21),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(23),
    [anon_sym_BSLASHk] = ACTIONS(25),
    [sym_decimal_escape] = ACTIONS(9),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(27),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(29),
    [sym_control_escape] = ACTIONS(15),
    [sym_control_letter_escape] = ACTIONS(9),
    [sym_identity_escape] = ACTIONS(15),
    [sym_decimal_digits] = ACTIONS(7),
  },
  [27] = {
    [sym_class_range] = STATE(52),
    [sym_character_class_escape] = STATE(30),
    [aux_sym_character_class_repeat1] = STATE(52),
    [anon_sym_RBRACK] = ACTIONS(121),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_BSLASH_DASH] = ACTIONS(65),
    [sym_class_character] = ACTIONS(123),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(67),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(69),
    [sym_control_escape] = ACTIONS(65),
    [sym_control_letter_escape] = ACTIONS(65),
    [sym_identity_escape] = ACTIONS(65),
  },
  [28] = {
    [ts_builtin_sym_end] = ACTIONS(125),
    [anon_sym_PIPE] = ACTIONS(125),
    [anon_sym_LBRACE] = ACTIONS(125),
    [sym_any_character] = ACTIONS(125),
    [anon_sym_CARET] = ACTIONS(125),
    [sym_end_assertion] = ACTIONS(125),
    [sym_boundary_assertion] = ACTIONS(125),
    [sym_non_boundary_assertion] = ACTIONS(125),
    [anon_sym_LPAREN_QMARK] = ACTIONS(127),
    [anon_sym_RPAREN] = ACTIONS(125),
    [sym_pattern_character] = ACTIONS(127),
    [anon_sym_LBRACK] = ACTIONS(125),
    [anon_sym_LPAREN] = ACTIONS(127),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(125),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(125),
    [anon_sym_STAR] = ACTIONS(125),
    [anon_sym_QMARK] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(125),
    [anon_sym_BSLASHk] = ACTIONS(125),
    [sym_decimal_escape] = ACTIONS(125),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(125),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(125),
    [sym_control_escape] = ACTIONS(127),
    [sym_control_letter_escape] = ACTIONS(125),
    [sym_identity_escape] = ACTIONS(127),
    [sym_decimal_digits] = ACTIONS(125),
  },
  [29] = {
    [anon_sym_RBRACK] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(131),
    [anon_sym_BSLASH_DASH] = ACTIONS(129),
    [sym_class_character] = ACTIONS(133),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(129),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(129),
    [sym_control_escape] = ACTIONS(129),
    [sym_control_letter_escape] = ACTIONS(129),
    [sym_identity_escape] = ACTIONS(129),
  },
  [30] = {
    [anon_sym_RBRACK] = ACTIONS(135),
    [anon_sym_DASH] = ACTIONS(137),
    [anon_sym_BSLASH_DASH] = ACTIONS(135),
    [sym_class_character] = ACTIONS(139),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(135),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(135),
    [sym_control_escape] = ACTIONS(135),
    [sym_control_letter_escape] = ACTIONS(135),
    [sym_identity_escape] = ACTIONS(135),
  },
  [31] = {
    [anon_sym_RBRACK] = ACTIONS(79),
    [anon_sym_DASH] = ACTIONS(79),
    [anon_sym_BSLASH_DASH] = ACTIONS(79),
    [sym_class_character] = ACTIONS(77),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(79),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(79),
    [sym_control_escape] = ACTIONS(79),
    [sym_control_letter_escape] = ACTIONS(79),
    [sym_identity_escape] = ACTIONS(79),
  },
  [32] = {
    [anon_sym_LBRACE] = ACTIONS(141),
  },
  [33] = {
    [sym_class_range] = STATE(56),
    [sym_character_class_escape] = STATE(30),
    [aux_sym_character_class_repeat1] = STATE(56),
    [anon_sym_RBRACK] = ACTIONS(121),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_BSLASH_DASH] = ACTIONS(65),
    [sym_class_character] = ACTIONS(123),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(67),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(69),
    [sym_control_escape] = ACTIONS(65),
    [sym_control_letter_escape] = ACTIONS(65),
    [sym_identity_escape] = ACTIONS(65),
  },
  [34] = {
    [sym_term] = STATE(19),
    [sym_start_assertion] = STATE(4),
    [sym_lookahead_assertion] = STATE(4),
    [sym_character_class] = STATE(4),
    [sym_anonymous_capturing_group] = STATE(4),
    [sym_named_capturing_group] = STATE(4),
    [sym_non_capturing_group] = STATE(4),
    [sym_backreference_escape] = STATE(4),
    [sym_character_class_escape] = STATE(4),
    [aux_sym_term_repeat1] = STATE(38),
    [anon_sym_PIPE] = ACTIONS(31),
    [anon_sym_LBRACE] = ACTIONS(7),
    [sym_any_character] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [sym_end_assertion] = ACTIONS(9),
    [sym_boundary_assertion] = ACTIONS(9),
    [sym_non_boundary_assertion] = ACTIONS(9),
    [anon_sym_LPAREN_QMARK] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(31),
    [sym_pattern_character] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(21),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(23),
    [anon_sym_BSLASHk] = ACTIONS(25),
    [sym_decimal_escape] = ACTIONS(9),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(27),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(29),
    [sym_control_escape] = ACTIONS(15),
    [sym_control_letter_escape] = ACTIONS(9),
    [sym_identity_escape] = ACTIONS(15),
    [sym_decimal_digits] = ACTIONS(7),
  },
  [35] = {
    [anon_sym_RPAREN] = ACTIONS(143),
  },
  [36] = {
    [aux_sym_disjunction_repeat1] = STATE(58),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_RPAREN] = ACTIONS(85),
  },
  [37] = {
    [aux_sym_disjunction_repeat1] = STATE(59),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_RPAREN] = ACTIONS(87),
  },
  [38] = {
    [sym_start_assertion] = STATE(4),
    [sym_lookahead_assertion] = STATE(4),
    [sym_character_class] = STATE(4),
    [sym_anonymous_capturing_group] = STATE(4),
    [sym_named_capturing_group] = STATE(4),
    [sym_non_capturing_group] = STATE(4),
    [sym_backreference_escape] = STATE(4),
    [sym_character_class_escape] = STATE(4),
    [aux_sym_term_repeat1] = STATE(60),
    [anon_sym_PIPE] = ACTIONS(89),
    [anon_sym_LBRACE] = ACTIONS(7),
    [sym_any_character] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [sym_end_assertion] = ACTIONS(9),
    [sym_boundary_assertion] = ACTIONS(9),
    [sym_non_boundary_assertion] = ACTIONS(9),
    [anon_sym_LPAREN_QMARK] = ACTIONS(13),
    [anon_sym_RPAREN] = ACTIONS(89),
    [sym_pattern_character] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(21),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(23),
    [anon_sym_BSLASHk] = ACTIONS(25),
    [sym_decimal_escape] = ACTIONS(9),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(27),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(29),
    [sym_control_escape] = ACTIONS(15),
    [sym_control_letter_escape] = ACTIONS(9),
    [sym_identity_escape] = ACTIONS(15),
    [sym_decimal_digits] = ACTIONS(7),
  },
  [39] = {
    [anon_sym_GT] = ACTIONS(145),
  },
  [40] = {
    [anon_sym_RPAREN] = ACTIONS(147),
  },
  [41] = {
    [ts_builtin_sym_end] = ACTIONS(149),
    [anon_sym_PIPE] = ACTIONS(149),
    [anon_sym_LBRACE] = ACTIONS(149),
    [sym_any_character] = ACTIONS(149),
    [anon_sym_CARET] = ACTIONS(149),
    [sym_end_assertion] = ACTIONS(149),
    [sym_boundary_assertion] = ACTIONS(149),
    [sym_non_boundary_assertion] = ACTIONS(149),
    [anon_sym_LPAREN_QMARK] = ACTIONS(151),
    [anon_sym_RPAREN] = ACTIONS(149),
    [sym_pattern_character] = ACTIONS(151),
    [anon_sym_LBRACK] = ACTIONS(149),
    [anon_sym_LPAREN] = ACTIONS(151),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(149),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(149),
    [anon_sym_STAR] = ACTIONS(149),
    [anon_sym_QMARK] = ACTIONS(149),
    [anon_sym_PLUS] = ACTIONS(149),
    [anon_sym_BSLASHk] = ACTIONS(149),
    [sym_decimal_escape] = ACTIONS(149),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(149),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(149),
    [sym_control_escape] = ACTIONS(151),
    [sym_control_letter_escape] = ACTIONS(149),
    [sym_identity_escape] = ACTIONS(151),
    [sym_decimal_digits] = ACTIONS(149),
  },
  [42] = {
    [sym_unicode_property_value_expression] = STATE(64),
    [sym_unicode_property] = ACTIONS(153),
  },
  [43] = {
    [aux_sym_disjunction_repeat1] = STATE(44),
    [ts_builtin_sym_end] = ACTIONS(155),
    [anon_sym_PIPE] = ACTIONS(5),
  },
  [44] = {
    [aux_sym_disjunction_repeat1] = STATE(44),
    [ts_builtin_sym_end] = ACTIONS(91),
    [anon_sym_PIPE] = ACTIONS(157),
  },
  [45] = {
    [sym_start_assertion] = STATE(4),
    [sym_lookahead_assertion] = STATE(4),
    [sym_character_class] = STATE(4),
    [sym_anonymous_capturing_group] = STATE(4),
    [sym_named_capturing_group] = STATE(4),
    [sym_non_capturing_group] = STATE(4),
    [sym_backreference_escape] = STATE(4),
    [sym_character_class_escape] = STATE(4),
    [aux_sym_term_repeat1] = STATE(45),
    [ts_builtin_sym_end] = ACTIONS(117),
    [anon_sym_PIPE] = ACTIONS(117),
    [anon_sym_LBRACE] = ACTIONS(160),
    [sym_any_character] = ACTIONS(163),
    [anon_sym_CARET] = ACTIONS(166),
    [sym_end_assertion] = ACTIONS(163),
    [sym_boundary_assertion] = ACTIONS(163),
    [sym_non_boundary_assertion] = ACTIONS(163),
    [anon_sym_LPAREN_QMARK] = ACTIONS(169),
    [sym_pattern_character] = ACTIONS(172),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(178),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(181),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(184),
    [anon_sym_BSLASHk] = ACTIONS(187),
    [sym_decimal_escape] = ACTIONS(163),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(190),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(193),
    [sym_control_escape] = ACTIONS(172),
    [sym_control_letter_escape] = ACTIONS(163),
    [sym_identity_escape] = ACTIONS(172),
    [sym_decimal_digits] = ACTIONS(160),
  },
  [46] = {
    [anon_sym_COMMA] = ACTIONS(196),
    [anon_sym_RBRACE] = ACTIONS(198),
  },
  [47] = {
    [ts_builtin_sym_end] = ACTIONS(200),
    [anon_sym_PIPE] = ACTIONS(200),
    [anon_sym_LBRACE] = ACTIONS(200),
    [sym_any_character] = ACTIONS(200),
    [anon_sym_CARET] = ACTIONS(200),
    [sym_end_assertion] = ACTIONS(200),
    [sym_boundary_assertion] = ACTIONS(200),
    [sym_non_boundary_assertion] = ACTIONS(200),
    [anon_sym_LPAREN_QMARK] = ACTIONS(202),
    [anon_sym_RPAREN] = ACTIONS(200),
    [sym_pattern_character] = ACTIONS(202),
    [anon_sym_LBRACK] = ACTIONS(200),
    [anon_sym_LPAREN] = ACTIONS(202),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(200),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(200),
    [anon_sym_BSLASHk] = ACTIONS(200),
    [sym_decimal_escape] = ACTIONS(200),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(200),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(200),
    [sym_control_escape] = ACTIONS(202),
    [sym_control_letter_escape] = ACTIONS(200),
    [sym_identity_escape] = ACTIONS(202),
    [sym_decimal_digits] = ACTIONS(200),
  },
  [48] = {
    [ts_builtin_sym_end] = ACTIONS(204),
    [anon_sym_PIPE] = ACTIONS(204),
    [anon_sym_LBRACE] = ACTIONS(204),
    [sym_any_character] = ACTIONS(204),
    [anon_sym_CARET] = ACTIONS(204),
    [sym_end_assertion] = ACTIONS(204),
    [sym_boundary_assertion] = ACTIONS(204),
    [sym_non_boundary_assertion] = ACTIONS(204),
    [anon_sym_LPAREN_QMARK] = ACTIONS(206),
    [anon_sym_RPAREN] = ACTIONS(204),
    [sym_pattern_character] = ACTIONS(206),
    [anon_sym_LBRACK] = ACTIONS(204),
    [anon_sym_LPAREN] = ACTIONS(206),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(204),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(204),
    [anon_sym_BSLASHk] = ACTIONS(204),
    [sym_decimal_escape] = ACTIONS(204),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(204),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(204),
    [sym_control_escape] = ACTIONS(206),
    [sym_control_letter_escape] = ACTIONS(204),
    [sym_identity_escape] = ACTIONS(206),
    [sym_decimal_digits] = ACTIONS(204),
  },
  [49] = {
    [ts_builtin_sym_end] = ACTIONS(208),
    [anon_sym_PIPE] = ACTIONS(208),
    [anon_sym_LBRACE] = ACTIONS(208),
    [sym_any_character] = ACTIONS(208),
    [anon_sym_CARET] = ACTIONS(208),
    [sym_end_assertion] = ACTIONS(208),
    [sym_boundary_assertion] = ACTIONS(208),
    [sym_non_boundary_assertion] = ACTIONS(208),
    [anon_sym_LPAREN_QMARK] = ACTIONS(210),
    [anon_sym_RPAREN] = ACTIONS(208),
    [sym_pattern_character] = ACTIONS(210),
    [anon_sym_LBRACK] = ACTIONS(208),
    [anon_sym_LPAREN] = ACTIONS(210),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(208),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(208),
    [anon_sym_BSLASHk] = ACTIONS(208),
    [sym_decimal_escape] = ACTIONS(208),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(208),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(208),
    [sym_control_escape] = ACTIONS(210),
    [sym_control_letter_escape] = ACTIONS(208),
    [sym_identity_escape] = ACTIONS(210),
    [sym_decimal_digits] = ACTIONS(208),
  },
  [50] = {
    [anon_sym_RPAREN] = ACTIONS(212),
  },
  [51] = {
    [ts_builtin_sym_end] = ACTIONS(214),
    [anon_sym_PIPE] = ACTIONS(214),
    [anon_sym_LBRACE] = ACTIONS(214),
    [sym_any_character] = ACTIONS(214),
    [anon_sym_CARET] = ACTIONS(214),
    [sym_end_assertion] = ACTIONS(214),
    [sym_boundary_assertion] = ACTIONS(214),
    [sym_non_boundary_assertion] = ACTIONS(214),
    [anon_sym_LPAREN_QMARK] = ACTIONS(216),
    [anon_sym_RPAREN] = ACTIONS(214),
    [sym_pattern_character] = ACTIONS(216),
    [anon_sym_LBRACK] = ACTIONS(214),
    [anon_sym_LPAREN] = ACTIONS(216),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(214),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(214),
    [anon_sym_STAR] = ACTIONS(214),
    [anon_sym_QMARK] = ACTIONS(214),
    [anon_sym_PLUS] = ACTIONS(214),
    [anon_sym_BSLASHk] = ACTIONS(214),
    [sym_decimal_escape] = ACTIONS(214),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(214),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(214),
    [sym_control_escape] = ACTIONS(216),
    [sym_control_letter_escape] = ACTIONS(214),
    [sym_identity_escape] = ACTIONS(216),
    [sym_decimal_digits] = ACTIONS(214),
  },
  [52] = {
    [sym_class_range] = STATE(56),
    [sym_character_class_escape] = STATE(30),
    [aux_sym_character_class_repeat1] = STATE(56),
    [anon_sym_RBRACK] = ACTIONS(218),
    [anon_sym_DASH] = ACTIONS(63),
    [anon_sym_BSLASH_DASH] = ACTIONS(65),
    [sym_class_character] = ACTIONS(123),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(67),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(69),
    [sym_control_escape] = ACTIONS(65),
    [sym_control_letter_escape] = ACTIONS(65),
    [sym_identity_escape] = ACTIONS(65),
  },
  [53] = {
    [sym_character_class_escape] = STATE(70),
    [anon_sym_DASH] = ACTIONS(220),
    [anon_sym_BSLASH_DASH] = ACTIONS(222),
    [sym_class_character] = ACTIONS(224),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(67),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(69),
    [sym_control_escape] = ACTIONS(222),
    [sym_control_letter_escape] = ACTIONS(222),
    [sym_identity_escape] = ACTIONS(222),
  },
  [54] = {
    [sym_character_class_escape] = STATE(72),
    [anon_sym_DASH] = ACTIONS(226),
    [anon_sym_BSLASH_DASH] = ACTIONS(228),
    [sym_class_character] = ACTIONS(230),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(67),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(69),
    [sym_control_escape] = ACTIONS(228),
    [sym_control_letter_escape] = ACTIONS(228),
    [sym_identity_escape] = ACTIONS(228),
  },
  [55] = {
    [sym_unicode_property_value_expression] = STATE(73),
    [sym_unicode_property] = ACTIONS(153),
  },
  [56] = {
    [sym_class_range] = STATE(56),
    [sym_character_class_escape] = STATE(30),
    [aux_sym_character_class_repeat1] = STATE(56),
    [anon_sym_RBRACK] = ACTIONS(232),
    [anon_sym_DASH] = ACTIONS(234),
    [anon_sym_BSLASH_DASH] = ACTIONS(237),
    [sym_class_character] = ACTIONS(240),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(243),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(246),
    [sym_control_escape] = ACTIONS(237),
    [sym_control_letter_escape] = ACTIONS(237),
    [sym_identity_escape] = ACTIONS(237),
  },
  [57] = {
    [ts_builtin_sym_end] = ACTIONS(249),
    [anon_sym_PIPE] = ACTIONS(249),
    [anon_sym_LBRACE] = ACTIONS(249),
    [sym_any_character] = ACTIONS(249),
    [anon_sym_CARET] = ACTIONS(249),
    [sym_end_assertion] = ACTIONS(249),
    [sym_boundary_assertion] = ACTIONS(249),
    [sym_non_boundary_assertion] = ACTIONS(249),
    [anon_sym_LPAREN_QMARK] = ACTIONS(251),
    [anon_sym_RPAREN] = ACTIONS(249),
    [sym_pattern_character] = ACTIONS(251),
    [anon_sym_LBRACK] = ACTIONS(249),
    [anon_sym_LPAREN] = ACTIONS(251),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(249),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(249),
    [anon_sym_STAR] = ACTIONS(249),
    [anon_sym_QMARK] = ACTIONS(249),
    [anon_sym_PLUS] = ACTIONS(249),
    [anon_sym_BSLASHk] = ACTIONS(249),
    [sym_decimal_escape] = ACTIONS(249),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(249),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(249),
    [sym_control_escape] = ACTIONS(251),
    [sym_control_letter_escape] = ACTIONS(249),
    [sym_identity_escape] = ACTIONS(251),
    [sym_decimal_digits] = ACTIONS(249),
  },
  [58] = {
    [aux_sym_disjunction_repeat1] = STATE(59),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_RPAREN] = ACTIONS(155),
  },
  [59] = {
    [aux_sym_disjunction_repeat1] = STATE(59),
    [anon_sym_PIPE] = ACTIONS(253),
    [anon_sym_RPAREN] = ACTIONS(91),
  },
  [60] = {
    [sym_start_assertion] = STATE(4),
    [sym_lookahead_assertion] = STATE(4),
    [sym_character_class] = STATE(4),
    [sym_anonymous_capturing_group] = STATE(4),
    [sym_named_capturing_group] = STATE(4),
    [sym_non_capturing_group] = STATE(4),
    [sym_backreference_escape] = STATE(4),
    [sym_character_class_escape] = STATE(4),
    [aux_sym_term_repeat1] = STATE(60),
    [anon_sym_PIPE] = ACTIONS(117),
    [anon_sym_LBRACE] = ACTIONS(160),
    [sym_any_character] = ACTIONS(163),
    [anon_sym_CARET] = ACTIONS(166),
    [sym_end_assertion] = ACTIONS(163),
    [sym_boundary_assertion] = ACTIONS(163),
    [sym_non_boundary_assertion] = ACTIONS(163),
    [anon_sym_LPAREN_QMARK] = ACTIONS(169),
    [anon_sym_RPAREN] = ACTIONS(117),
    [sym_pattern_character] = ACTIONS(172),
    [anon_sym_LBRACK] = ACTIONS(175),
    [anon_sym_LPAREN] = ACTIONS(178),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(181),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(184),
    [anon_sym_BSLASHk] = ACTIONS(187),
    [sym_decimal_escape] = ACTIONS(163),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(190),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(193),
    [sym_control_escape] = ACTIONS(172),
    [sym_control_letter_escape] = ACTIONS(163),
    [sym_identity_escape] = ACTIONS(172),
    [sym_decimal_digits] = ACTIONS(160),
  },
  [61] = {
    [sym_pattern] = STATE(74),
    [sym_disjunction] = STATE(15),
    [sym_term] = STATE(36),
    [sym_start_assertion] = STATE(4),
    [sym_lookahead_assertion] = STATE(4),
    [sym_character_class] = STATE(4),
    [sym_anonymous_capturing_group] = STATE(4),
    [sym_named_capturing_group] = STATE(4),
    [sym_non_capturing_group] = STATE(4),
    [sym_backreference_escape] = STATE(4),
    [sym_character_class_escape] = STATE(4),
    [aux_sym_disjunction_repeat1] = STATE(37),
    [aux_sym_term_repeat1] = STATE(38),
    [anon_sym_PIPE] = ACTIONS(71),
    [anon_sym_LBRACE] = ACTIONS(7),
    [sym_any_character] = ACTIONS(9),
    [anon_sym_CARET] = ACTIONS(11),
    [sym_end_assertion] = ACTIONS(9),
    [sym_boundary_assertion] = ACTIONS(9),
    [sym_non_boundary_assertion] = ACTIONS(9),
    [anon_sym_LPAREN_QMARK] = ACTIONS(13),
    [sym_pattern_character] = ACTIONS(15),
    [anon_sym_LBRACK] = ACTIONS(17),
    [anon_sym_LPAREN] = ACTIONS(19),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(21),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(23),
    [anon_sym_BSLASHk] = ACTIONS(25),
    [sym_decimal_escape] = ACTIONS(9),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(27),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(29),
    [sym_control_escape] = ACTIONS(15),
    [sym_control_letter_escape] = ACTIONS(9),
    [sym_identity_escape] = ACTIONS(15),
    [sym_decimal_digits] = ACTIONS(7),
  },
  [62] = {
    [ts_builtin_sym_end] = ACTIONS(256),
    [anon_sym_PIPE] = ACTIONS(256),
    [anon_sym_LBRACE] = ACTIONS(256),
    [sym_any_character] = ACTIONS(256),
    [anon_sym_CARET] = ACTIONS(256),
    [sym_end_assertion] = ACTIONS(256),
    [sym_boundary_assertion] = ACTIONS(256),
    [sym_non_boundary_assertion] = ACTIONS(256),
    [anon_sym_LPAREN_QMARK] = ACTIONS(258),
    [anon_sym_RPAREN] = ACTIONS(256),
    [sym_pattern_character] = ACTIONS(258),
    [anon_sym_LBRACK] = ACTIONS(256),
    [anon_sym_LPAREN] = ACTIONS(258),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(256),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(256),
    [anon_sym_STAR] = ACTIONS(256),
    [anon_sym_QMARK] = ACTIONS(256),
    [anon_sym_PLUS] = ACTIONS(256),
    [anon_sym_BSLASHk] = ACTIONS(256),
    [sym_decimal_escape] = ACTIONS(256),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(256),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(256),
    [sym_control_escape] = ACTIONS(258),
    [sym_control_letter_escape] = ACTIONS(256),
    [sym_identity_escape] = ACTIONS(258),
    [sym_decimal_digits] = ACTIONS(256),
  },
  [63] = {
    [anon_sym_EQ] = ACTIONS(260),
    [anon_sym_RBRACE] = ACTIONS(262),
  },
  [64] = {
    [anon_sym_RBRACE] = ACTIONS(264),
  },
  [65] = {
    [sym_decimal_digits] = ACTIONS(266),
  },
  [66] = {
    [ts_builtin_sym_end] = ACTIONS(268),
    [anon_sym_PIPE] = ACTIONS(268),
    [anon_sym_LBRACE] = ACTIONS(268),
    [sym_any_character] = ACTIONS(268),
    [anon_sym_CARET] = ACTIONS(268),
    [sym_end_assertion] = ACTIONS(268),
    [sym_boundary_assertion] = ACTIONS(268),
    [sym_non_boundary_assertion] = ACTIONS(268),
    [anon_sym_LPAREN_QMARK] = ACTIONS(270),
    [anon_sym_RPAREN] = ACTIONS(268),
    [sym_pattern_character] = ACTIONS(270),
    [anon_sym_LBRACK] = ACTIONS(268),
    [anon_sym_LPAREN] = ACTIONS(270),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(268),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(268),
    [anon_sym_QMARK] = ACTIONS(272),
    [anon_sym_BSLASHk] = ACTIONS(268),
    [sym_decimal_escape] = ACTIONS(268),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(268),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(268),
    [sym_control_escape] = ACTIONS(270),
    [sym_control_letter_escape] = ACTIONS(268),
    [sym_identity_escape] = ACTIONS(270),
    [sym_decimal_digits] = ACTIONS(268),
  },
  [67] = {
    [ts_builtin_sym_end] = ACTIONS(274),
    [anon_sym_PIPE] = ACTIONS(274),
    [anon_sym_LBRACE] = ACTIONS(274),
    [sym_any_character] = ACTIONS(274),
    [anon_sym_CARET] = ACTIONS(274),
    [sym_end_assertion] = ACTIONS(274),
    [sym_boundary_assertion] = ACTIONS(274),
    [sym_non_boundary_assertion] = ACTIONS(274),
    [anon_sym_LPAREN_QMARK] = ACTIONS(276),
    [anon_sym_RPAREN] = ACTIONS(274),
    [sym_pattern_character] = ACTIONS(276),
    [anon_sym_LBRACK] = ACTIONS(274),
    [anon_sym_LPAREN] = ACTIONS(276),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(274),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(274),
    [anon_sym_STAR] = ACTIONS(274),
    [anon_sym_QMARK] = ACTIONS(274),
    [anon_sym_PLUS] = ACTIONS(274),
    [anon_sym_BSLASHk] = ACTIONS(274),
    [sym_decimal_escape] = ACTIONS(274),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(274),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(274),
    [sym_control_escape] = ACTIONS(276),
    [sym_control_letter_escape] = ACTIONS(274),
    [sym_identity_escape] = ACTIONS(276),
    [sym_decimal_digits] = ACTIONS(274),
  },
  [68] = {
    [ts_builtin_sym_end] = ACTIONS(278),
    [anon_sym_PIPE] = ACTIONS(278),
    [anon_sym_LBRACE] = ACTIONS(278),
    [sym_any_character] = ACTIONS(278),
    [anon_sym_CARET] = ACTIONS(278),
    [sym_end_assertion] = ACTIONS(278),
    [sym_boundary_assertion] = ACTIONS(278),
    [sym_non_boundary_assertion] = ACTIONS(278),
    [anon_sym_LPAREN_QMARK] = ACTIONS(280),
    [anon_sym_RPAREN] = ACTIONS(278),
    [sym_pattern_character] = ACTIONS(280),
    [anon_sym_LBRACK] = ACTIONS(278),
    [anon_sym_LPAREN] = ACTIONS(280),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(278),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(278),
    [anon_sym_STAR] = ACTIONS(278),
    [anon_sym_QMARK] = ACTIONS(278),
    [anon_sym_PLUS] = ACTIONS(278),
    [anon_sym_BSLASHk] = ACTIONS(278),
    [sym_decimal_escape] = ACTIONS(278),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(278),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(278),
    [sym_control_escape] = ACTIONS(280),
    [sym_control_letter_escape] = ACTIONS(278),
    [sym_identity_escape] = ACTIONS(280),
    [sym_decimal_digits] = ACTIONS(278),
  },
  [69] = {
    [anon_sym_RBRACK] = ACTIONS(282),
    [anon_sym_DASH] = ACTIONS(282),
    [anon_sym_BSLASH_DASH] = ACTIONS(282),
    [sym_class_character] = ACTIONS(284),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(282),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(282),
    [sym_control_escape] = ACTIONS(282),
    [sym_control_letter_escape] = ACTIONS(282),
    [sym_identity_escape] = ACTIONS(282),
  },
  [70] = {
    [anon_sym_RBRACK] = ACTIONS(286),
    [anon_sym_DASH] = ACTIONS(286),
    [anon_sym_BSLASH_DASH] = ACTIONS(286),
    [sym_class_character] = ACTIONS(288),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(286),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(286),
    [sym_control_escape] = ACTIONS(286),
    [sym_control_letter_escape] = ACTIONS(286),
    [sym_identity_escape] = ACTIONS(286),
  },
  [71] = {
    [anon_sym_RBRACK] = ACTIONS(290),
    [anon_sym_DASH] = ACTIONS(290),
    [anon_sym_BSLASH_DASH] = ACTIONS(290),
    [sym_class_character] = ACTIONS(292),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(290),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(290),
    [sym_control_escape] = ACTIONS(290),
    [sym_control_letter_escape] = ACTIONS(290),
    [sym_identity_escape] = ACTIONS(290),
  },
  [72] = {
    [anon_sym_RBRACK] = ACTIONS(294),
    [anon_sym_DASH] = ACTIONS(294),
    [anon_sym_BSLASH_DASH] = ACTIONS(294),
    [sym_class_character] = ACTIONS(296),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(294),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(294),
    [sym_control_escape] = ACTIONS(294),
    [sym_control_letter_escape] = ACTIONS(294),
    [sym_identity_escape] = ACTIONS(294),
  },
  [73] = {
    [anon_sym_RBRACE] = ACTIONS(298),
  },
  [74] = {
    [anon_sym_RPAREN] = ACTIONS(300),
  },
  [75] = {
    [sym_unicode_property] = ACTIONS(302),
  },
  [76] = {
    [ts_builtin_sym_end] = ACTIONS(304),
    [anon_sym_PIPE] = ACTIONS(304),
    [anon_sym_LBRACE] = ACTIONS(304),
    [sym_any_character] = ACTIONS(304),
    [anon_sym_CARET] = ACTIONS(304),
    [sym_end_assertion] = ACTIONS(304),
    [sym_boundary_assertion] = ACTIONS(304),
    [sym_non_boundary_assertion] = ACTIONS(304),
    [anon_sym_LPAREN_QMARK] = ACTIONS(306),
    [anon_sym_RPAREN] = ACTIONS(304),
    [sym_pattern_character] = ACTIONS(306),
    [anon_sym_LBRACK] = ACTIONS(304),
    [anon_sym_LPAREN] = ACTIONS(306),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(304),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(304),
    [anon_sym_STAR] = ACTIONS(304),
    [anon_sym_QMARK] = ACTIONS(304),
    [anon_sym_PLUS] = ACTIONS(304),
    [anon_sym_BSLASHk] = ACTIONS(304),
    [sym_decimal_escape] = ACTIONS(304),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(304),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(304),
    [sym_control_escape] = ACTIONS(306),
    [sym_control_letter_escape] = ACTIONS(304),
    [sym_identity_escape] = ACTIONS(306),
    [sym_decimal_digits] = ACTIONS(304),
  },
  [77] = {
    [anon_sym_RBRACE] = ACTIONS(308),
  },
  [78] = {
    [ts_builtin_sym_end] = ACTIONS(310),
    [anon_sym_PIPE] = ACTIONS(310),
    [anon_sym_LBRACE] = ACTIONS(310),
    [sym_any_character] = ACTIONS(310),
    [anon_sym_CARET] = ACTIONS(310),
    [sym_end_assertion] = ACTIONS(310),
    [sym_boundary_assertion] = ACTIONS(310),
    [sym_non_boundary_assertion] = ACTIONS(310),
    [anon_sym_LPAREN_QMARK] = ACTIONS(312),
    [anon_sym_RPAREN] = ACTIONS(310),
    [sym_pattern_character] = ACTIONS(312),
    [anon_sym_LBRACK] = ACTIONS(310),
    [anon_sym_LPAREN] = ACTIONS(312),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(310),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(310),
    [anon_sym_BSLASHk] = ACTIONS(310),
    [sym_decimal_escape] = ACTIONS(310),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(310),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(310),
    [sym_control_escape] = ACTIONS(312),
    [sym_control_letter_escape] = ACTIONS(310),
    [sym_identity_escape] = ACTIONS(312),
    [sym_decimal_digits] = ACTIONS(310),
  },
  [79] = {
    [anon_sym_RBRACK] = ACTIONS(306),
    [anon_sym_DASH] = ACTIONS(306),
    [anon_sym_BSLASH_DASH] = ACTIONS(306),
    [sym_class_character] = ACTIONS(304),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(306),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(306),
    [sym_control_escape] = ACTIONS(306),
    [sym_control_letter_escape] = ACTIONS(306),
    [sym_identity_escape] = ACTIONS(306),
  },
  [80] = {
    [ts_builtin_sym_end] = ACTIONS(314),
    [anon_sym_PIPE] = ACTIONS(314),
    [anon_sym_LBRACE] = ACTIONS(314),
    [sym_any_character] = ACTIONS(314),
    [anon_sym_CARET] = ACTIONS(314),
    [sym_end_assertion] = ACTIONS(314),
    [sym_boundary_assertion] = ACTIONS(314),
    [sym_non_boundary_assertion] = ACTIONS(314),
    [anon_sym_LPAREN_QMARK] = ACTIONS(316),
    [anon_sym_RPAREN] = ACTIONS(314),
    [sym_pattern_character] = ACTIONS(316),
    [anon_sym_LBRACK] = ACTIONS(314),
    [anon_sym_LPAREN] = ACTIONS(316),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(314),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(314),
    [anon_sym_STAR] = ACTIONS(314),
    [anon_sym_QMARK] = ACTIONS(314),
    [anon_sym_PLUS] = ACTIONS(314),
    [anon_sym_BSLASHk] = ACTIONS(314),
    [sym_decimal_escape] = ACTIONS(314),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(314),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(314),
    [sym_control_escape] = ACTIONS(316),
    [sym_control_letter_escape] = ACTIONS(314),
    [sym_identity_escape] = ACTIONS(316),
    [sym_decimal_digits] = ACTIONS(314),
  },
  [81] = {
    [anon_sym_RBRACE] = ACTIONS(318),
  },
  [82] = {
    [ts_builtin_sym_end] = ACTIONS(320),
    [anon_sym_PIPE] = ACTIONS(320),
    [anon_sym_LBRACE] = ACTIONS(320),
    [sym_any_character] = ACTIONS(320),
    [anon_sym_CARET] = ACTIONS(320),
    [sym_end_assertion] = ACTIONS(320),
    [sym_boundary_assertion] = ACTIONS(320),
    [sym_non_boundary_assertion] = ACTIONS(320),
    [anon_sym_LPAREN_QMARK] = ACTIONS(322),
    [anon_sym_RPAREN] = ACTIONS(320),
    [sym_pattern_character] = ACTIONS(322),
    [anon_sym_LBRACK] = ACTIONS(320),
    [anon_sym_LPAREN] = ACTIONS(322),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(320),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(320),
    [anon_sym_QMARK] = ACTIONS(324),
    [anon_sym_BSLASHk] = ACTIONS(320),
    [sym_decimal_escape] = ACTIONS(320),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(320),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(320),
    [sym_control_escape] = ACTIONS(322),
    [sym_control_letter_escape] = ACTIONS(320),
    [sym_identity_escape] = ACTIONS(322),
    [sym_decimal_digits] = ACTIONS(320),
  },
  [83] = {
    [ts_builtin_sym_end] = ACTIONS(326),
    [anon_sym_PIPE] = ACTIONS(326),
    [anon_sym_LBRACE] = ACTIONS(326),
    [sym_any_character] = ACTIONS(326),
    [anon_sym_CARET] = ACTIONS(326),
    [sym_end_assertion] = ACTIONS(326),
    [sym_boundary_assertion] = ACTIONS(326),
    [sym_non_boundary_assertion] = ACTIONS(326),
    [anon_sym_LPAREN_QMARK] = ACTIONS(328),
    [anon_sym_RPAREN] = ACTIONS(326),
    [sym_pattern_character] = ACTIONS(328),
    [anon_sym_LBRACK] = ACTIONS(326),
    [anon_sym_LPAREN] = ACTIONS(328),
    [anon_sym_LPAREN_QMARK_LT] = ACTIONS(326),
    [anon_sym_LPAREN_QMARK_COLON] = ACTIONS(326),
    [anon_sym_BSLASHk] = ACTIONS(326),
    [sym_decimal_escape] = ACTIONS(326),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKdDsSwW_RBRACK_SLASH] = ACTIONS(326),
    [aux_sym_SLASH_BSLASH_BSLASH_LBRACKpP_RBRACK_SLASH] = ACTIONS(326),
    [sym_control_escape] = ACTIONS(328),
    [sym_control_letter_escape] = ACTIONS(326),
    [sym_identity_escape] = ACTIONS(328),
    [sym_decimal_digits] = ACTIONS(326),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = true}, RECOVER(),
  [3] = {.count = 1, .reusable = false}, RECOVER(),
  [5] = {.count = 1, .reusable = true}, SHIFT(2),
  [7] = {.count = 1, .reusable = true}, SHIFT(3),
  [9] = {.count = 1, .reusable = true}, SHIFT(4),
  [11] = {.count = 1, .reusable = true}, SHIFT(5),
  [13] = {.count = 1, .reusable = false}, SHIFT(6),
  [15] = {.count = 1, .reusable = false}, SHIFT(4),
  [17] = {.count = 1, .reusable = true}, SHIFT(7),
  [19] = {.count = 1, .reusable = false}, SHIFT(8),
  [21] = {.count = 1, .reusable = true}, SHIFT(9),
  [23] = {.count = 1, .reusable = true}, SHIFT(10),
  [25] = {.count = 1, .reusable = true}, SHIFT(11),
  [27] = {.count = 1, .reusable = true}, SHIFT(12),
  [29] = {.count = 1, .reusable = true}, SHIFT(13),
  [31] = {.count = 1, .reusable = true}, REDUCE(aux_sym_disjunction_repeat1, 1),
  [33] = {.count = 1, .reusable = true}, REDUCE(aux_sym_term_repeat1, 1, .alias_sequence_id = 1),
  [35] = {.count = 2, .reusable = true}, REDUCE(aux_sym_term_repeat1, 1, .alias_sequence_id = 1), SHIFT_REPEAT(20),
  [38] = {.count = 1, .reusable = false}, REDUCE(aux_sym_term_repeat1, 1, .alias_sequence_id = 1),
  [40] = {.count = 1, .reusable = true}, SHIFT(21),
  [42] = {.count = 1, .reusable = true}, SHIFT(22),
  [44] = {.count = 1, .reusable = true}, SHIFT(23),
  [46] = {.count = 1, .reusable = true}, REDUCE(aux_sym_term_repeat1, 1),
  [48] = {.count = 2, .reusable = true}, REDUCE(aux_sym_term_repeat1, 1), SHIFT_REPEAT(20),
  [51] = {.count = 1, .reusable = false}, REDUCE(aux_sym_term_repeat1, 1),
  [53] = {.count = 1, .reusable = true}, REDUCE(sym_start_assertion, 1),
  [55] = {.count = 1, .reusable = false}, REDUCE(sym_start_assertion, 1),
  [57] = {.count = 1, .reusable = true}, SHIFT(26),
  [59] = {.count = 1, .reusable = false}, SHIFT(27),
  [61] = {.count = 1, .reusable = false}, SHIFT(28),
  [63] = {.count = 1, .reusable = false}, SHIFT(29),
  [65] = {.count = 1, .reusable = false}, SHIFT(30),
  [67] = {.count = 1, .reusable = false}, SHIFT(31),
  [69] = {.count = 1, .reusable = false}, SHIFT(32),
  [71] = {.count = 1, .reusable = true}, SHIFT(34),
  [73] = {.count = 1, .reusable = true}, SHIFT(39),
  [75] = {.count = 1, .reusable = true}, SHIFT(41),
  [77] = {.count = 1, .reusable = true}, REDUCE(sym_character_class_escape, 1),
  [79] = {.count = 1, .reusable = false}, REDUCE(sym_character_class_escape, 1),
  [81] = {.count = 1, .reusable = true}, SHIFT(42),
  [83] = {.count = 1, .reusable = true}, ACCEPT_INPUT(),
  [85] = {.count = 1, .reusable = true}, REDUCE(sym_pattern, 1),
  [87] = {.count = 1, .reusable = true}, REDUCE(sym_disjunction, 1),
  [89] = {.count = 1, .reusable = true}, REDUCE(sym_term, 1),
  [91] = {.count = 1, .reusable = true}, REDUCE(aux_sym_disjunction_repeat1, 2),
  [93] = {.count = 1, .reusable = true}, SHIFT(46),
  [95] = {.count = 1, .reusable = true}, REDUCE(sym_zero_or_more, 1),
  [97] = {.count = 1, .reusable = false}, REDUCE(sym_zero_or_more, 1),
  [99] = {.count = 1, .reusable = true}, SHIFT(47),
  [101] = {.count = 1, .reusable = true}, REDUCE(sym_optional, 1),
  [103] = {.count = 1, .reusable = false}, REDUCE(sym_optional, 1),
  [105] = {.count = 1, .reusable = true}, SHIFT(48),
  [107] = {.count = 1, .reusable = true}, REDUCE(sym_one_or_more, 1),
  [109] = {.count = 1, .reusable = false}, REDUCE(sym_one_or_more, 1),
  [111] = {.count = 1, .reusable = true}, SHIFT(49),
  [113] = {.count = 1, .reusable = true}, REDUCE(aux_sym_term_repeat1, 2, .alias_sequence_id = 1),
  [115] = {.count = 1, .reusable = false}, REDUCE(aux_sym_term_repeat1, 2, .alias_sequence_id = 1),
  [117] = {.count = 1, .reusable = true}, REDUCE(aux_sym_term_repeat1, 2),
  [119] = {.count = 1, .reusable = false}, REDUCE(aux_sym_term_repeat1, 2),
  [121] = {.count = 1, .reusable = false}, SHIFT(51),
  [123] = {.count = 1, .reusable = true}, SHIFT(30),
  [125] = {.count = 1, .reusable = true}, REDUCE(sym_character_class, 2),
  [127] = {.count = 1, .reusable = false}, REDUCE(sym_character_class, 2),
  [129] = {.count = 1, .reusable = false}, REDUCE(aux_sym_character_class_repeat1, 1, .alias_sequence_id = 2),
  [131] = {.count = 1, .reusable = false}, SHIFT(53),
  [133] = {.count = 1, .reusable = true}, REDUCE(aux_sym_character_class_repeat1, 1, .alias_sequence_id = 2),
  [135] = {.count = 1, .reusable = false}, REDUCE(aux_sym_character_class_repeat1, 1),
  [137] = {.count = 1, .reusable = false}, SHIFT(54),
  [139] = {.count = 1, .reusable = true}, REDUCE(aux_sym_character_class_repeat1, 1),
  [141] = {.count = 1, .reusable = true}, SHIFT(55),
  [143] = {.count = 1, .reusable = true}, SHIFT(57),
  [145] = {.count = 1, .reusable = true}, SHIFT(61),
  [147] = {.count = 1, .reusable = true}, SHIFT(62),
  [149] = {.count = 1, .reusable = true}, REDUCE(sym_backreference_escape, 2),
  [151] = {.count = 1, .reusable = false}, REDUCE(sym_backreference_escape, 2),
  [153] = {.count = 1, .reusable = true}, SHIFT(63),
  [155] = {.count = 1, .reusable = true}, REDUCE(sym_disjunction, 2),
  [157] = {.count = 2, .reusable = true}, REDUCE(aux_sym_disjunction_repeat1, 2), SHIFT_REPEAT(2),
  [160] = {.count = 2, .reusable = true}, REDUCE(aux_sym_term_repeat1, 2), SHIFT_REPEAT(3),
  [163] = {.count = 2, .reusable = true}, REDUCE(aux_sym_term_repeat1, 2), SHIFT_REPEAT(4),
  [166] = {.count = 2, .reusable = true}, REDUCE(aux_sym_term_repeat1, 2), SHIFT_REPEAT(5),
  [169] = {.count = 2, .reusable = false}, REDUCE(aux_sym_term_repeat1, 2), SHIFT_REPEAT(6),
  [172] = {.count = 2, .reusable = false}, REDUCE(aux_sym_term_repeat1, 2), SHIFT_REPEAT(4),
  [175] = {.count = 2, .reusable = true}, REDUCE(aux_sym_term_repeat1, 2), SHIFT_REPEAT(7),
  [178] = {.count = 2, .reusable = false}, REDUCE(aux_sym_term_repeat1, 2), SHIFT_REPEAT(8),
  [181] = {.count = 2, .reusable = true}, REDUCE(aux_sym_term_repeat1, 2), SHIFT_REPEAT(9),
  [184] = {.count = 2, .reusable = true}, REDUCE(aux_sym_term_repeat1, 2), SHIFT_REPEAT(10),
  [187] = {.count = 2, .reusable = true}, REDUCE(aux_sym_term_repeat1, 2), SHIFT_REPEAT(11),
  [190] = {.count = 2, .reusable = true}, REDUCE(aux_sym_term_repeat1, 2), SHIFT_REPEAT(12),
  [193] = {.count = 2, .reusable = true}, REDUCE(aux_sym_term_repeat1, 2), SHIFT_REPEAT(13),
  [196] = {.count = 1, .reusable = true}, SHIFT(65),
  [198] = {.count = 1, .reusable = true}, SHIFT(66),
  [200] = {.count = 1, .reusable = true}, REDUCE(sym_zero_or_more, 2, .alias_sequence_id = 3),
  [202] = {.count = 1, .reusable = false}, REDUCE(sym_zero_or_more, 2, .alias_sequence_id = 3),
  [204] = {.count = 1, .reusable = true}, REDUCE(sym_optional, 2, .alias_sequence_id = 3),
  [206] = {.count = 1, .reusable = false}, REDUCE(sym_optional, 2, .alias_sequence_id = 3),
  [208] = {.count = 1, .reusable = true}, REDUCE(sym_one_or_more, 2, .alias_sequence_id = 3),
  [210] = {.count = 1, .reusable = false}, REDUCE(sym_one_or_more, 2, .alias_sequence_id = 3),
  [212] = {.count = 1, .reusable = true}, SHIFT(67),
  [214] = {.count = 1, .reusable = true}, REDUCE(sym_character_class, 3),
  [216] = {.count = 1, .reusable = false}, REDUCE(sym_character_class, 3),
  [218] = {.count = 1, .reusable = false}, SHIFT(68),
  [220] = {.count = 1, .reusable = false}, SHIFT(69),
  [222] = {.count = 1, .reusable = false}, SHIFT(70),
  [224] = {.count = 1, .reusable = true}, SHIFT(70),
  [226] = {.count = 1, .reusable = false}, SHIFT(71),
  [228] = {.count = 1, .reusable = false}, SHIFT(72),
  [230] = {.count = 1, .reusable = true}, SHIFT(72),
  [232] = {.count = 1, .reusable = false}, REDUCE(aux_sym_character_class_repeat1, 2),
  [234] = {.count = 2, .reusable = false}, REDUCE(aux_sym_character_class_repeat1, 2), SHIFT_REPEAT(29),
  [237] = {.count = 2, .reusable = false}, REDUCE(aux_sym_character_class_repeat1, 2), SHIFT_REPEAT(30),
  [240] = {.count = 2, .reusable = true}, REDUCE(aux_sym_character_class_repeat1, 2), SHIFT_REPEAT(30),
  [243] = {.count = 2, .reusable = false}, REDUCE(aux_sym_character_class_repeat1, 2), SHIFT_REPEAT(31),
  [246] = {.count = 2, .reusable = false}, REDUCE(aux_sym_character_class_repeat1, 2), SHIFT_REPEAT(32),
  [249] = {.count = 1, .reusable = true}, REDUCE(sym_anonymous_capturing_group, 3),
  [251] = {.count = 1, .reusable = false}, REDUCE(sym_anonymous_capturing_group, 3),
  [253] = {.count = 2, .reusable = true}, REDUCE(aux_sym_disjunction_repeat1, 2), SHIFT_REPEAT(34),
  [256] = {.count = 1, .reusable = true}, REDUCE(sym_non_capturing_group, 3),
  [258] = {.count = 1, .reusable = false}, REDUCE(sym_non_capturing_group, 3),
  [260] = {.count = 1, .reusable = true}, SHIFT(75),
  [262] = {.count = 1, .reusable = true}, REDUCE(sym_unicode_property_value_expression, 1, .alias_sequence_id = 4),
  [264] = {.count = 1, .reusable = true}, SHIFT(76),
  [266] = {.count = 1, .reusable = true}, SHIFT(77),
  [268] = {.count = 1, .reusable = true}, REDUCE(sym_count_quantifier, 3),
  [270] = {.count = 1, .reusable = false}, REDUCE(sym_count_quantifier, 3),
  [272] = {.count = 1, .reusable = true}, SHIFT(78),
  [274] = {.count = 1, .reusable = true}, REDUCE(sym_lookahead_assertion, 4),
  [276] = {.count = 1, .reusable = false}, REDUCE(sym_lookahead_assertion, 4),
  [278] = {.count = 1, .reusable = true}, REDUCE(sym_character_class, 4),
  [280] = {.count = 1, .reusable = false}, REDUCE(sym_character_class, 4),
  [282] = {.count = 1, .reusable = false}, REDUCE(sym_class_range, 3, .alias_sequence_id = 5),
  [284] = {.count = 1, .reusable = true}, REDUCE(sym_class_range, 3, .alias_sequence_id = 5),
  [286] = {.count = 1, .reusable = false}, REDUCE(sym_class_range, 3, .alias_sequence_id = 2),
  [288] = {.count = 1, .reusable = true}, REDUCE(sym_class_range, 3, .alias_sequence_id = 2),
  [290] = {.count = 1, .reusable = false}, REDUCE(sym_class_range, 3, .alias_sequence_id = 6),
  [292] = {.count = 1, .reusable = true}, REDUCE(sym_class_range, 3, .alias_sequence_id = 6),
  [294] = {.count = 1, .reusable = false}, REDUCE(sym_class_range, 3),
  [296] = {.count = 1, .reusable = true}, REDUCE(sym_class_range, 3),
  [298] = {.count = 1, .reusable = true}, SHIFT(79),
  [300] = {.count = 1, .reusable = true}, SHIFT(80),
  [302] = {.count = 1, .reusable = true}, SHIFT(81),
  [304] = {.count = 1, .reusable = true}, REDUCE(sym_character_class_escape, 4),
  [306] = {.count = 1, .reusable = false}, REDUCE(sym_character_class_escape, 4),
  [308] = {.count = 1, .reusable = true}, SHIFT(82),
  [310] = {.count = 1, .reusable = true}, REDUCE(sym_count_quantifier, 4, .alias_sequence_id = 7),
  [312] = {.count = 1, .reusable = false}, REDUCE(sym_count_quantifier, 4, .alias_sequence_id = 7),
  [314] = {.count = 1, .reusable = true}, REDUCE(sym_named_capturing_group, 5),
  [316] = {.count = 1, .reusable = false}, REDUCE(sym_named_capturing_group, 5),
  [318] = {.count = 1, .reusable = true}, REDUCE(sym_unicode_property_value_expression, 3, .alias_sequence_id = 8),
  [320] = {.count = 1, .reusable = true}, REDUCE(sym_count_quantifier, 5),
  [322] = {.count = 1, .reusable = false}, REDUCE(sym_count_quantifier, 5),
  [324] = {.count = 1, .reusable = true}, SHIFT(83),
  [326] = {.count = 1, .reusable = true}, REDUCE(sym_count_quantifier, 6, .alias_sequence_id = 9),
  [328] = {.count = 1, .reusable = false}, REDUCE(sym_count_quantifier, 6, .alias_sequence_id = 9),
};

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_regex() {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
  };
  return &language;
}
