#include <tree_sitter/parser.h>

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic push
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#define LANGUAGE_VERSION 9
#define STATE_COUNT 1948
#define SYMBOL_COUNT 210
#define ALIAS_COUNT 1
#define TOKEN_COUNT 98
#define EXTERNAL_TOKEN_COUNT 6
#define MAX_ALIAS_SEQUENCE_LENGTH 5

enum {
  sym__newline = 1,
  sym__indent = 2,
  sym__dedent = 3,
  sym__string_start = 4,
  sym__string_content = 5,
  sym__string_end = 6,
  anon_sym_import = 7,
  anon_sym_DOT = 8,
  anon_sym_from = 9,
  anon_sym___future__ = 10,
  anon_sym_LPAREN = 11,
  anon_sym_RPAREN = 12,
  anon_sym_COMMA = 13,
  anon_sym_as = 14,
  anon_sym_STAR = 15,
  anon_sym_print = 16,
  anon_sym_GT_GT = 17,
  anon_sym_assert = 18,
  anon_sym_return = 19,
  anon_sym_del = 20,
  anon_sym_raise = 21,
  anon_sym_pass = 22,
  anon_sym_break = 23,
  anon_sym_continue = 24,
  anon_sym_if = 25,
  anon_sym_COLON = 26,
  anon_sym_elif = 27,
  anon_sym_else = 28,
  anon_sym_async = 29,
  anon_sym_for = 30,
  anon_sym_in = 31,
  anon_sym_while = 32,
  anon_sym_try = 33,
  anon_sym_except = 34,
  anon_sym_finally = 35,
  anon_sym_with = 36,
  anon_sym_def = 37,
  anon_sym_DASH_GT = 38,
  anon_sym_EQ = 39,
  anon_sym_global = 40,
  anon_sym_nonlocal = 41,
  anon_sym_exec = 42,
  anon_sym_class = 43,
  anon_sym_AT = 44,
  anon_sym_not = 45,
  anon_sym_and = 46,
  anon_sym_or = 47,
  anon_sym_PLUS = 48,
  anon_sym_DASH = 49,
  anon_sym_SLASH = 50,
  anon_sym_PERCENT = 51,
  anon_sym_SLASH_SLASH = 52,
  anon_sym_STAR_STAR = 53,
  anon_sym_PIPE = 54,
  anon_sym_AMP = 55,
  anon_sym_CARET = 56,
  anon_sym_LT_LT = 57,
  anon_sym_TILDE = 58,
  anon_sym_LT = 59,
  anon_sym_LT_EQ = 60,
  anon_sym_EQ_EQ = 61,
  anon_sym_BANG_EQ = 62,
  anon_sym_GT_EQ = 63,
  anon_sym_GT = 64,
  anon_sym_LT_GT = 65,
  anon_sym_is = 66,
  anon_sym_lambda = 67,
  anon_sym_PLUS_EQ = 68,
  anon_sym_DASH_EQ = 69,
  anon_sym_STAR_EQ = 70,
  anon_sym_SLASH_EQ = 71,
  anon_sym_AT_EQ = 72,
  anon_sym_SLASH_SLASH_EQ = 73,
  anon_sym_PERCENT_EQ = 74,
  anon_sym_STAR_STAR_EQ = 75,
  anon_sym_GT_GT_EQ = 76,
  anon_sym_LT_LT_EQ = 77,
  anon_sym_AMP_EQ = 78,
  anon_sym_CARET_EQ = 79,
  anon_sym_PIPE_EQ = 80,
  anon_sym_yield = 81,
  anon_sym_LBRACK = 82,
  anon_sym_RBRACK = 83,
  sym_ellipsis = 84,
  anon_sym_LBRACE = 85,
  anon_sym_RBRACE = 86,
  sym_escape_sequence = 87,
  sym_type_conversion = 88,
  sym_integer = 89,
  sym_float = 90,
  sym_identifier = 91,
  sym_true = 92,
  sym_false = 93,
  sym_none = 94,
  anon_sym_await = 95,
  sym_comment = 96,
  sym__semicolon = 97,
  sym_module = 98,
  sym__statement = 99,
  sym__simple_statements = 100,
  sym_import_statement = 101,
  sym_import_prefix = 102,
  sym_relative_import = 103,
  sym_future_import_statement = 104,
  sym_import_from_statement = 105,
  sym__import_list = 106,
  sym_aliased_import = 107,
  sym_wildcard_import = 108,
  sym_print_statement = 109,
  sym_chevron = 110,
  sym_assert_statement = 111,
  sym_expression_statement = 112,
  sym_return_statement = 113,
  sym_delete_statement = 114,
  sym_raise_statement = 115,
  sym_pass_statement = 116,
  sym_break_statement = 117,
  sym_continue_statement = 118,
  sym_if_statement = 119,
  sym_elif_clause = 120,
  sym_else_clause = 121,
  sym_for_statement = 122,
  sym_while_statement = 123,
  sym_try_statement = 124,
  sym_except_clause = 125,
  sym_finally_clause = 126,
  sym_with_statement = 127,
  sym_with_item = 128,
  sym_function_definition = 129,
  sym_parameters = 130,
  sym_lambda_parameters = 131,
  sym__parameters = 132,
  sym_default_parameter = 133,
  sym_typed_default_parameter = 134,
  sym_list_splat = 135,
  sym_dictionary_splat = 136,
  sym_global_statement = 137,
  sym_nonlocal_statement = 138,
  sym_exec_statement = 139,
  sym_class_definition = 140,
  sym_argument_list = 141,
  sym_decorated_definition = 142,
  sym_decorator = 143,
  sym__suite = 144,
  sym_variables = 145,
  sym_expression_list = 146,
  sym_dotted_name = 147,
  sym__expression_within_for_in_clause = 148,
  sym__expression = 149,
  sym__primary_expression = 150,
  sym_not_operator = 151,
  sym_boolean_operator = 152,
  sym_binary_operator = 153,
  sym_unary_operator = 154,
  sym_comparison_operator = 155,
  sym_lambda = 156,
  sym_lambda_within_for_in_clause = 157,
  sym_assignment = 158,
  sym_augmented_assignment = 159,
  sym__right_hand_side = 160,
  sym_yield = 161,
  sym_attribute = 162,
  sym_subscript = 163,
  sym_slice = 164,
  sym_call = 165,
  sym_typed_parameter = 166,
  sym_type = 167,
  sym_keyword_argument = 168,
  sym_list = 169,
  sym__comprehension_body = 170,
  sym_list_comprehension = 171,
  sym_dictionary = 172,
  sym_dictionary_comprehension = 173,
  sym_pair = 174,
  sym_set = 175,
  sym_set_comprehension = 176,
  sym_parenthesized_expression = 177,
  sym_tuple = 178,
  sym_generator_expression = 179,
  sym_for_in_clause = 180,
  sym_if_clause = 181,
  sym_conditional_expression = 182,
  sym_concatenated_string = 183,
  sym_string = 184,
  sym_interpolation = 185,
  sym_await = 186,
  aux_sym_module_repeat1 = 187,
  aux_sym__simple_statements_repeat1 = 188,
  aux_sym_import_prefix_repeat1 = 189,
  aux_sym__import_list_repeat1 = 190,
  aux_sym_print_statement_repeat1 = 191,
  aux_sym_if_statement_repeat1 = 192,
  aux_sym_try_statement_repeat1 = 193,
  aux_sym_with_statement_repeat1 = 194,
  aux_sym__parameters_repeat1 = 195,
  aux_sym_global_statement_repeat1 = 196,
  aux_sym_argument_list_repeat1 = 197,
  aux_sym_decorated_definition_repeat1 = 198,
  aux_sym_variables_repeat1 = 199,
  aux_sym_dotted_name_repeat1 = 200,
  aux_sym_comparison_operator_repeat1 = 201,
  aux_sym_subscript_repeat1 = 202,
  aux_sym_list_repeat1 = 203,
  aux_sym__comprehension_body_repeat1 = 204,
  aux_sym_dictionary_repeat1 = 205,
  aux_sym_tuple_repeat1 = 206,
  aux_sym_for_in_clause_repeat1 = 207,
  aux_sym_concatenated_string_repeat1 = 208,
  aux_sym_string_repeat1 = 209,
  alias_sym_identifier = 210,
};

static const char *ts_symbol_names[] = {
  [sym__newline] = "_newline",
  [sym__indent] = "_indent",
  [sym__dedent] = "_dedent",
  [sym__string_start] = "\"",
  [sym__string_content] = "_string_content",
  [sym__string_end] = "\"",
  [ts_builtin_sym_end] = "END",
  [anon_sym_import] = "import",
  [anon_sym_DOT] = ".",
  [anon_sym_from] = "from",
  [anon_sym___future__] = "__future__",
  [anon_sym_LPAREN] = "(",
  [anon_sym_RPAREN] = ")",
  [anon_sym_COMMA] = ",",
  [anon_sym_as] = "as",
  [anon_sym_STAR] = "*",
  [anon_sym_print] = "print",
  [anon_sym_GT_GT] = ">>",
  [anon_sym_assert] = "assert",
  [anon_sym_return] = "return",
  [anon_sym_del] = "del",
  [anon_sym_raise] = "raise",
  [anon_sym_pass] = "pass",
  [anon_sym_break] = "break",
  [anon_sym_continue] = "continue",
  [anon_sym_if] = "if",
  [anon_sym_COLON] = ":",
  [anon_sym_elif] = "elif",
  [anon_sym_else] = "else",
  [anon_sym_async] = "async",
  [anon_sym_for] = "for",
  [anon_sym_in] = "in",
  [anon_sym_while] = "while",
  [anon_sym_try] = "try",
  [anon_sym_except] = "except",
  [anon_sym_finally] = "finally",
  [anon_sym_with] = "with",
  [anon_sym_def] = "def",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_EQ] = "=",
  [anon_sym_global] = "global",
  [anon_sym_nonlocal] = "nonlocal",
  [anon_sym_exec] = "exec",
  [anon_sym_class] = "class",
  [anon_sym_AT] = "@",
  [anon_sym_not] = "not",
  [anon_sym_and] = "and",
  [anon_sym_or] = "or",
  [anon_sym_PLUS] = "+",
  [anon_sym_DASH] = "-",
  [anon_sym_SLASH] = "/",
  [anon_sym_PERCENT] = "%",
  [anon_sym_SLASH_SLASH] = "//",
  [anon_sym_STAR_STAR] = "**",
  [anon_sym_PIPE] = "|",
  [anon_sym_AMP] = "&",
  [anon_sym_CARET] = "^",
  [anon_sym_LT_LT] = "<<",
  [anon_sym_TILDE] = "~",
  [anon_sym_LT] = "<",
  [anon_sym_LT_EQ] = "<=",
  [anon_sym_EQ_EQ] = "==",
  [anon_sym_BANG_EQ] = "!=",
  [anon_sym_GT_EQ] = ">=",
  [anon_sym_GT] = ">",
  [anon_sym_LT_GT] = "<>",
  [anon_sym_is] = "is",
  [anon_sym_lambda] = "lambda",
  [anon_sym_PLUS_EQ] = "+=",
  [anon_sym_DASH_EQ] = "-=",
  [anon_sym_STAR_EQ] = "*=",
  [anon_sym_SLASH_EQ] = "/=",
  [anon_sym_AT_EQ] = "@=",
  [anon_sym_SLASH_SLASH_EQ] = "//=",
  [anon_sym_PERCENT_EQ] = "%=",
  [anon_sym_STAR_STAR_EQ] = "**=",
  [anon_sym_GT_GT_EQ] = ">>=",
  [anon_sym_LT_LT_EQ] = "<<=",
  [anon_sym_AMP_EQ] = "&=",
  [anon_sym_CARET_EQ] = "^=",
  [anon_sym_PIPE_EQ] = "|=",
  [anon_sym_yield] = "yield",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [sym_ellipsis] = "ellipsis",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [sym_escape_sequence] = "escape_sequence",
  [sym_type_conversion] = "type_conversion",
  [sym_integer] = "integer",
  [sym_float] = "float",
  [sym_identifier] = "identifier",
  [sym_true] = "true",
  [sym_false] = "false",
  [sym_none] = "none",
  [anon_sym_await] = "await",
  [sym_comment] = "comment",
  [sym__semicolon] = "_semicolon",
  [sym_module] = "module",
  [sym__statement] = "_statement",
  [sym__simple_statements] = "_simple_statements",
  [sym_import_statement] = "import_statement",
  [sym_import_prefix] = "import_prefix",
  [sym_relative_import] = "relative_import",
  [sym_future_import_statement] = "future_import_statement",
  [sym_import_from_statement] = "import_from_statement",
  [sym__import_list] = "_import_list",
  [sym_aliased_import] = "aliased_import",
  [sym_wildcard_import] = "wildcard_import",
  [sym_print_statement] = "print_statement",
  [sym_chevron] = "chevron",
  [sym_assert_statement] = "assert_statement",
  [sym_expression_statement] = "expression_statement",
  [sym_return_statement] = "return_statement",
  [sym_delete_statement] = "delete_statement",
  [sym_raise_statement] = "raise_statement",
  [sym_pass_statement] = "pass_statement",
  [sym_break_statement] = "break_statement",
  [sym_continue_statement] = "continue_statement",
  [sym_if_statement] = "if_statement",
  [sym_elif_clause] = "elif_clause",
  [sym_else_clause] = "else_clause",
  [sym_for_statement] = "for_statement",
  [sym_while_statement] = "while_statement",
  [sym_try_statement] = "try_statement",
  [sym_except_clause] = "except_clause",
  [sym_finally_clause] = "finally_clause",
  [sym_with_statement] = "with_statement",
  [sym_with_item] = "with_item",
  [sym_function_definition] = "function_definition",
  [sym_parameters] = "parameters",
  [sym_lambda_parameters] = "lambda_parameters",
  [sym__parameters] = "_parameters",
  [sym_default_parameter] = "default_parameter",
  [sym_typed_default_parameter] = "typed_default_parameter",
  [sym_list_splat] = "list_splat",
  [sym_dictionary_splat] = "dictionary_splat",
  [sym_global_statement] = "global_statement",
  [sym_nonlocal_statement] = "nonlocal_statement",
  [sym_exec_statement] = "exec_statement",
  [sym_class_definition] = "class_definition",
  [sym_argument_list] = "argument_list",
  [sym_decorated_definition] = "decorated_definition",
  [sym_decorator] = "decorator",
  [sym__suite] = "_suite",
  [sym_variables] = "variables",
  [sym_expression_list] = "expression_list",
  [sym_dotted_name] = "dotted_name",
  [sym__expression_within_for_in_clause] = "_expression_within_for_in_clause",
  [sym__expression] = "_expression",
  [sym__primary_expression] = "_primary_expression",
  [sym_not_operator] = "not_operator",
  [sym_boolean_operator] = "boolean_operator",
  [sym_binary_operator] = "binary_operator",
  [sym_unary_operator] = "unary_operator",
  [sym_comparison_operator] = "comparison_operator",
  [sym_lambda] = "lambda",
  [sym_lambda_within_for_in_clause] = "lambda",
  [sym_assignment] = "assignment",
  [sym_augmented_assignment] = "augmented_assignment",
  [sym__right_hand_side] = "_right_hand_side",
  [sym_yield] = "yield",
  [sym_attribute] = "attribute",
  [sym_subscript] = "subscript",
  [sym_slice] = "slice",
  [sym_call] = "call",
  [sym_typed_parameter] = "typed_parameter",
  [sym_type] = "type",
  [sym_keyword_argument] = "keyword_argument",
  [sym_list] = "list",
  [sym__comprehension_body] = "_comprehension_body",
  [sym_list_comprehension] = "list_comprehension",
  [sym_dictionary] = "dictionary",
  [sym_dictionary_comprehension] = "dictionary_comprehension",
  [sym_pair] = "pair",
  [sym_set] = "set",
  [sym_set_comprehension] = "set_comprehension",
  [sym_parenthesized_expression] = "parenthesized_expression",
  [sym_tuple] = "tuple",
  [sym_generator_expression] = "generator_expression",
  [sym_for_in_clause] = "for_in_clause",
  [sym_if_clause] = "if_clause",
  [sym_conditional_expression] = "conditional_expression",
  [sym_concatenated_string] = "concatenated_string",
  [sym_string] = "string",
  [sym_interpolation] = "interpolation",
  [sym_await] = "await",
  [aux_sym_module_repeat1] = "module_repeat1",
  [aux_sym__simple_statements_repeat1] = "_simple_statements_repeat1",
  [aux_sym_import_prefix_repeat1] = "import_prefix_repeat1",
  [aux_sym__import_list_repeat1] = "_import_list_repeat1",
  [aux_sym_print_statement_repeat1] = "print_statement_repeat1",
  [aux_sym_if_statement_repeat1] = "if_statement_repeat1",
  [aux_sym_try_statement_repeat1] = "try_statement_repeat1",
  [aux_sym_with_statement_repeat1] = "with_statement_repeat1",
  [aux_sym__parameters_repeat1] = "_parameters_repeat1",
  [aux_sym_global_statement_repeat1] = "global_statement_repeat1",
  [aux_sym_argument_list_repeat1] = "argument_list_repeat1",
  [aux_sym_decorated_definition_repeat1] = "decorated_definition_repeat1",
  [aux_sym_variables_repeat1] = "variables_repeat1",
  [aux_sym_dotted_name_repeat1] = "dotted_name_repeat1",
  [aux_sym_comparison_operator_repeat1] = "comparison_operator_repeat1",
  [aux_sym_subscript_repeat1] = "subscript_repeat1",
  [aux_sym_list_repeat1] = "list_repeat1",
  [aux_sym__comprehension_body_repeat1] = "_comprehension_body_repeat1",
  [aux_sym_dictionary_repeat1] = "dictionary_repeat1",
  [aux_sym_tuple_repeat1] = "tuple_repeat1",
  [aux_sym_for_in_clause_repeat1] = "for_in_clause_repeat1",
  [aux_sym_concatenated_string_repeat1] = "concatenated_string_repeat1",
  [aux_sym_string_repeat1] = "string_repeat1",
  [alias_sym_identifier] = "identifier",
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [sym__newline] = {
    .visible = false,
    .named = true,
  },
  [sym__indent] = {
    .visible = false,
    .named = true,
  },
  [sym__dedent] = {
    .visible = false,
    .named = true,
  },
  [sym__string_start] = {
    .visible = true,
    .named = false,
  },
  [sym__string_content] = {
    .visible = false,
    .named = true,
  },
  [sym__string_end] = {
    .visible = true,
    .named = false,
  },
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_import] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_from] = {
    .visible = true,
    .named = false,
  },
  [anon_sym___future__] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_as] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_print] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_assert] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_return] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_del] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_raise] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_pass] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_break] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_continue] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_elif] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_async] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_for] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_in] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_while] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_try] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_except] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_finally] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_with] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_def] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_global] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_nonlocal] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_exec] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_class] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_not] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_and] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_or] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_TILDE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_EQ_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_is] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_lambda] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SLASH_SLASH_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PERCENT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_STAR_STAR_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_GT_GT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LT_LT_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_AMP_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_CARET_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PIPE_EQ] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_yield] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [sym_ellipsis] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [sym_escape_sequence] = {
    .visible = true,
    .named = true,
  },
  [sym_type_conversion] = {
    .visible = true,
    .named = true,
  },
  [sym_integer] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [sym_identifier] = {
    .visible = true,
    .named = true,
  },
  [sym_true] = {
    .visible = true,
    .named = true,
  },
  [sym_false] = {
    .visible = true,
    .named = true,
  },
  [sym_none] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_await] = {
    .visible = true,
    .named = false,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym__semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym_module] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym__simple_statements] = {
    .visible = false,
    .named = true,
  },
  [sym_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_prefix] = {
    .visible = true,
    .named = true,
  },
  [sym_relative_import] = {
    .visible = true,
    .named = true,
  },
  [sym_future_import_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_import_from_statement] = {
    .visible = true,
    .named = true,
  },
  [sym__import_list] = {
    .visible = false,
    .named = true,
  },
  [sym_aliased_import] = {
    .visible = true,
    .named = true,
  },
  [sym_wildcard_import] = {
    .visible = true,
    .named = true,
  },
  [sym_print_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_chevron] = {
    .visible = true,
    .named = true,
  },
  [sym_assert_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_return_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_delete_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_raise_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_pass_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_break_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_continue_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_if_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_elif_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_else_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_for_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_while_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_try_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_except_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_finally_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_with_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_with_item] = {
    .visible = true,
    .named = true,
  },
  [sym_function_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_parameters] = {
    .visible = true,
    .named = true,
  },
  [sym__parameters] = {
    .visible = false,
    .named = true,
  },
  [sym_default_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_default_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_list_splat] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary_splat] = {
    .visible = true,
    .named = true,
  },
  [sym_global_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_nonlocal_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_exec_statement] = {
    .visible = true,
    .named = true,
  },
  [sym_class_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_argument_list] = {
    .visible = true,
    .named = true,
  },
  [sym_decorated_definition] = {
    .visible = true,
    .named = true,
  },
  [sym_decorator] = {
    .visible = true,
    .named = true,
  },
  [sym__suite] = {
    .visible = false,
    .named = true,
  },
  [sym_variables] = {
    .visible = true,
    .named = true,
  },
  [sym_expression_list] = {
    .visible = true,
    .named = true,
  },
  [sym_dotted_name] = {
    .visible = true,
    .named = true,
  },
  [sym__expression_within_for_in_clause] = {
    .visible = false,
    .named = true,
  },
  [sym__expression] = {
    .visible = false,
    .named = true,
  },
  [sym__primary_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_not_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_boolean_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_binary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_unary_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_comparison_operator] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda] = {
    .visible = true,
    .named = true,
  },
  [sym_lambda_within_for_in_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym_augmented_assignment] = {
    .visible = true,
    .named = true,
  },
  [sym__right_hand_side] = {
    .visible = false,
    .named = true,
  },
  [sym_yield] = {
    .visible = true,
    .named = true,
  },
  [sym_attribute] = {
    .visible = true,
    .named = true,
  },
  [sym_subscript] = {
    .visible = true,
    .named = true,
  },
  [sym_slice] = {
    .visible = true,
    .named = true,
  },
  [sym_call] = {
    .visible = true,
    .named = true,
  },
  [sym_typed_parameter] = {
    .visible = true,
    .named = true,
  },
  [sym_type] = {
    .visible = true,
    .named = true,
  },
  [sym_keyword_argument] = {
    .visible = true,
    .named = true,
  },
  [sym_list] = {
    .visible = true,
    .named = true,
  },
  [sym__comprehension_body] = {
    .visible = false,
    .named = true,
  },
  [sym_list_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary] = {
    .visible = true,
    .named = true,
  },
  [sym_dictionary_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_pair] = {
    .visible = true,
    .named = true,
  },
  [sym_set] = {
    .visible = true,
    .named = true,
  },
  [sym_set_comprehension] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple] = {
    .visible = true,
    .named = true,
  },
  [sym_generator_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_for_in_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_if_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_conditional_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_concatenated_string] = {
    .visible = true,
    .named = true,
  },
  [sym_string] = {
    .visible = true,
    .named = true,
  },
  [sym_interpolation] = {
    .visible = true,
    .named = true,
  },
  [sym_await] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_module_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__simple_statements_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_import_prefix_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__import_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_print_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_if_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_try_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_with_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__parameters_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_global_statement_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_argument_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_decorated_definition_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_variables_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dotted_name_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_comparison_operator_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_subscript_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_list_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__comprehension_body_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_dictionary_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_for_in_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_concatenated_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_string_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_identifier] = {
    .visible = true,
    .named = true,
  },
};

static TSSymbol ts_alias_sequences[3][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [1] = {
    [0] = alias_sym_identifier,
  },
  [2] = {
    [1] = alias_sym_identifier,
  },
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == '*')
        ADVANCE(12);
      if (lookahead == '+')
        ADVANCE(16);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(19);
      if (lookahead == '.')
        ADVANCE(22);
      if (lookahead == '/')
        ADVANCE(31);
      if (lookahead == '0')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(50);
      if (lookahead == ';')
        ADVANCE(51);
      if (lookahead == '<')
        ADVANCE(52);
      if (lookahead == '=')
        ADVANCE(57);
      if (lookahead == '>')
        ADVANCE(59);
      if (lookahead == '@')
        ADVANCE(63);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(66);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '^')
        ADVANCE(69);
      if (lookahead == '{')
        ADVANCE(71);
      if (lookahead == '|')
        ADVANCE(72);
      if (lookahead == '}')
        ADVANCE(74);
      if (lookahead == '~')
        ADVANCE(75);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(0);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(49);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 1:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 2:
      if (lookahead == '=')
        ADVANCE(3);
      if (('a' <= lookahead && lookahead <= 'z'))
        ADVANCE(4);
      END_STATE();
    case 3:
      ACCEPT_TOKEN(anon_sym_BANG_EQ);
      END_STATE();
    case 4:
      ACCEPT_TOKEN(sym_type_conversion);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(sym_comment);
      if (lookahead != 0 &&
          lookahead != '\n')
        ADVANCE(5);
      END_STATE();
    case 6:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      if (lookahead == '=')
        ADVANCE(7);
      END_STATE();
    case 7:
      ACCEPT_TOKEN(anon_sym_PERCENT_EQ);
      END_STATE();
    case 8:
      ACCEPT_TOKEN(anon_sym_AMP);
      if (lookahead == '=')
        ADVANCE(9);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(anon_sym_AMP_EQ);
      END_STATE();
    case 10:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 11:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 12:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*')
        ADVANCE(13);
      if (lookahead == '=')
        ADVANCE(15);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      if (lookahead == '=')
        ADVANCE(14);
      END_STATE();
    case 14:
      ACCEPT_TOKEN(anon_sym_STAR_STAR_EQ);
      END_STATE();
    case 15:
      ACCEPT_TOKEN(anon_sym_STAR_EQ);
      END_STATE();
    case 16:
      ACCEPT_TOKEN(anon_sym_PLUS);
      if (lookahead == '=')
        ADVANCE(17);
      END_STATE();
    case 17:
      ACCEPT_TOKEN(anon_sym_PLUS_EQ);
      END_STATE();
    case 18:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 19:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=')
        ADVANCE(20);
      if (lookahead == '>')
        ADVANCE(21);
      END_STATE();
    case 20:
      ACCEPT_TOKEN(anon_sym_DASH_EQ);
      END_STATE();
    case 21:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 22:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (lookahead == '.')
        ADVANCE(23);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(25);
      if (lookahead == 'J' ||
          lookahead == 'j')
        ADVANCE(27);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(29);
      END_STATE();
    case 23:
      if (lookahead == '.')
        ADVANCE(24);
      END_STATE();
    case 24:
      ACCEPT_TOKEN(sym_ellipsis);
      END_STATE();
    case 25:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '+' ||
          lookahead == '-')
        ADVANCE(26);
      if (lookahead == 'J' ||
          lookahead == 'j')
        ADVANCE(27);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(28);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'J' ||
          lookahead == 'j')
        ADVANCE(27);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(28);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(sym_float);
      END_STATE();
    case 28:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_')
        ADVANCE(26);
      if (lookahead == 'J' ||
          lookahead == 'j')
        ADVANCE(27);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(28);
      END_STATE();
    case 29:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_')
        ADVANCE(30);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(25);
      if (lookahead == 'J' ||
          lookahead == 'j')
        ADVANCE(27);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(29);
      END_STATE();
    case 30:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(25);
      if (lookahead == 'J' ||
          lookahead == 'j')
        ADVANCE(27);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(29);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/')
        ADVANCE(32);
      if (lookahead == '=')
        ADVANCE(34);
      END_STATE();
    case 32:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      if (lookahead == '=')
        ADVANCE(33);
      END_STATE();
    case 33:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH_EQ);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_SLASH_EQ);
      END_STATE();
    case 35:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.')
        ADVANCE(30);
      if (lookahead == 'B')
        ADVANCE(36);
      if (lookahead == 'O')
        ADVANCE(40);
      if (lookahead == 'X')
        ADVANCE(43);
      if (lookahead == '_')
        ADVANCE(46);
      if (lookahead == 'b')
        ADVANCE(36);
      if (lookahead == 'o')
        ADVANCE(40);
      if (lookahead == 'x')
        ADVANCE(43);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(47);
      if (lookahead == 'J' ||
          lookahead == 'j')
        ADVANCE(39);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(39);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(49);
      END_STATE();
    case 36:
      if (lookahead == '_')
        ADVANCE(37);
      if (lookahead == '0' ||
          lookahead == '1')
        ADVANCE(38);
      END_STATE();
    case 37:
      if (lookahead == '0' ||
          lookahead == '1')
        ADVANCE(38);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_')
        ADVANCE(37);
      if (lookahead == '0' ||
          lookahead == '1')
        ADVANCE(38);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(39);
      END_STATE();
    case 39:
      ACCEPT_TOKEN(sym_integer);
      END_STATE();
    case 40:
      if (lookahead == '_')
        ADVANCE(41);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(42);
      END_STATE();
    case 41:
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(42);
      END_STATE();
    case 42:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_')
        ADVANCE(41);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(39);
      if (('0' <= lookahead && lookahead <= '7'))
        ADVANCE(42);
      END_STATE();
    case 43:
      if (lookahead == '_')
        ADVANCE(44);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(45);
      END_STATE();
    case 44:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(45);
      END_STATE();
    case 45:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '_')
        ADVANCE(44);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(39);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(45);
      END_STATE();
    case 46:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.')
        ADVANCE(30);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(47);
      if (lookahead == 'J' ||
          lookahead == 'j')
        ADVANCE(39);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(39);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(49);
      END_STATE();
    case 47:
      if (lookahead == '+' ||
          lookahead == '-')
        ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(28);
      END_STATE();
    case 48:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(28);
      END_STATE();
    case 49:
      ACCEPT_TOKEN(sym_integer);
      if (lookahead == '.')
        ADVANCE(30);
      if (lookahead == '_')
        ADVANCE(46);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(47);
      if (lookahead == 'J' ||
          lookahead == 'j')
        ADVANCE(39);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(39);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(49);
      END_STATE();
    case 50:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 51:
      ACCEPT_TOKEN(sym__semicolon);
      END_STATE();
    case 52:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<')
        ADVANCE(53);
      if (lookahead == '=')
        ADVANCE(55);
      if (lookahead == '>')
        ADVANCE(56);
      END_STATE();
    case 53:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      if (lookahead == '=')
        ADVANCE(54);
      END_STATE();
    case 54:
      ACCEPT_TOKEN(anon_sym_LT_LT_EQ);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_LT_EQ);
      END_STATE();
    case 56:
      ACCEPT_TOKEN(anon_sym_LT_GT);
      END_STATE();
    case 57:
      ACCEPT_TOKEN(anon_sym_EQ);
      if (lookahead == '=')
        ADVANCE(58);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_EQ_EQ);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(60);
      if (lookahead == '>')
        ADVANCE(61);
      END_STATE();
    case 60:
      ACCEPT_TOKEN(anon_sym_GT_EQ);
      END_STATE();
    case 61:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      if (lookahead == '=')
        ADVANCE(62);
      END_STATE();
    case 62:
      ACCEPT_TOKEN(anon_sym_GT_GT_EQ);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == '=')
        ADVANCE(64);
      END_STATE();
    case 64:
      ACCEPT_TOKEN(anon_sym_AT_EQ);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 66:
      if (lookahead == '\n')
        SKIP(0);
      if (lookahead == '\r')
        SKIP(67);
      END_STATE();
    case 67:
      if (lookahead == '\n')
        SKIP(0);
      END_STATE();
    case 68:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 69:
      ACCEPT_TOKEN(anon_sym_CARET);
      if (lookahead == '=')
        ADVANCE(70);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_CARET_EQ);
      END_STATE();
    case 71:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_PIPE);
      if (lookahead == '=')
        ADVANCE(73);
      END_STATE();
    case 73:
      ACCEPT_TOKEN(anon_sym_PIPE_EQ);
      END_STATE();
    case 74:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 75:
      ACCEPT_TOKEN(anon_sym_TILDE);
      END_STATE();
    case 76:
      ACCEPT_TOKEN(sym_identifier);
      if (lookahead == '+' ||
          lookahead == '-')
        ADVANCE(48);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(77);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 77:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '_')
        ADVANCE(78);
      if (lookahead == 'J' ||
          lookahead == 'j')
        ADVANCE(79);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(79);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(77);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 78:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'J' ||
          lookahead == 'j')
        ADVANCE(79);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(79);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(77);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(sym_float);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 80:
      ACCEPT_TOKEN(sym_identifier);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 81:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(84);
      if (lookahead == '0')
        ADVANCE(35);
      if (lookahead == '@')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(86);
      if (lookahead == '{')
        ADVANCE(71);
      if (lookahead == '~')
        ADVANCE(75);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(81);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(49);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 82:
      ACCEPT_TOKEN(anon_sym_PLUS);
      END_STATE();
    case 83:
      ACCEPT_TOKEN(anon_sym_DASH);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == '.')
        ADVANCE(23);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(25);
      if (lookahead == 'J' ||
          lookahead == 'j')
        ADVANCE(27);
      if (lookahead == 'L' ||
          lookahead == 'l')
        ADVANCE(27);
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(29);
      END_STATE();
    case 85:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 86:
      if (lookahead == '\n')
        SKIP(81);
      if (lookahead == '\r')
        SKIP(87);
      END_STATE();
    case 87:
      if (lookahead == '\n')
        SKIP(81);
      END_STATE();
    case 88:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '\\')
        ADVANCE(89);
      if (lookahead == '{')
        ADVANCE(71);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(88);
      END_STATE();
    case 89:
      if (lookahead == '\n')
        ADVANCE(90);
      if (lookahead == '\r')
        ADVANCE(91);
      if (lookahead == 'U')
        ADVANCE(92);
      if (lookahead == 'o')
        ADVANCE(100);
      if (lookahead == 'u')
        ADVANCE(96);
      if (lookahead == 'x')
        ADVANCE(98);
      if (lookahead != 0)
        ADVANCE(90);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(sym_escape_sequence);
      END_STATE();
    case 91:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (lookahead == '\n')
        ADVANCE(90);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(sym_escape_sequence);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(93);
      END_STATE();
    case 93:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(94);
      END_STATE();
    case 94:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(95);
      END_STATE();
    case 95:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(96);
      END_STATE();
    case 96:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(97);
      END_STATE();
    case 97:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(98);
      END_STATE();
    case 98:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(99);
      END_STATE();
    case 99:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f'))
        ADVANCE(90);
      END_STATE();
    case 100:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(101);
      END_STATE();
    case 101:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(102);
      END_STATE();
    case 102:
      if (('0' <= lookahead && lookahead <= '9'))
        ADVANCE(90);
      END_STATE();
    case 103:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '.')
        ADVANCE(104);
      if (lookahead == ';')
        ADVANCE(51);
      if (lookahead == '@')
        ADVANCE(85);
      if (lookahead == '\\')
        SKIP(105);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(103);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 104:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 105:
      if (lookahead == '\n')
        SKIP(103);
      if (lookahead == '\r')
        SKIP(106);
      END_STATE();
    case 106:
      if (lookahead == '\n')
        SKIP(103);
      END_STATE();
    case 107:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(84);
      if (lookahead == '0')
        ADVANCE(35);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(108);
      if (lookahead == '{')
        ADVANCE(71);
      if (lookahead == '~')
        ADVANCE(75);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(107);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(49);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 108:
      if (lookahead == '\n')
        SKIP(107);
      if (lookahead == '\r')
        SKIP(109);
      END_STATE();
    case 109:
      if (lookahead == '\n')
        SKIP(107);
      END_STATE();
    case 110:
      if (lookahead == '!')
        ADVANCE(111);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(12);
      if (lookahead == '+')
        ADVANCE(16);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(112);
      if (lookahead == '.')
        ADVANCE(22);
      if (lookahead == '/')
        ADVANCE(31);
      if (lookahead == '0')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(50);
      if (lookahead == ';')
        ADVANCE(51);
      if (lookahead == '<')
        ADVANCE(52);
      if (lookahead == '=')
        ADVANCE(57);
      if (lookahead == '>')
        ADVANCE(59);
      if (lookahead == '@')
        ADVANCE(63);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(113);
      if (lookahead == '^')
        ADVANCE(69);
      if (lookahead == '{')
        ADVANCE(71);
      if (lookahead == '|')
        ADVANCE(72);
      if (lookahead == '~')
        ADVANCE(75);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(110);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(49);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 111:
      if (lookahead == '=')
        ADVANCE(3);
      END_STATE();
    case 112:
      ACCEPT_TOKEN(anon_sym_DASH);
      if (lookahead == '=')
        ADVANCE(20);
      END_STATE();
    case 113:
      if (lookahead == '\n')
        SKIP(110);
      if (lookahead == '\r')
        SKIP(114);
      END_STATE();
    case 114:
      if (lookahead == '\n')
        SKIP(110);
      END_STATE();
    case 115:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(84);
      if (lookahead == '0')
        ADVANCE(35);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(116);
      if (lookahead == '{')
        ADVANCE(71);
      if (lookahead == '~')
        ADVANCE(75);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(115);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(49);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 116:
      if (lookahead == '\n')
        SKIP(115);
      if (lookahead == '\r')
        SKIP(117);
      END_STATE();
    case 117:
      if (lookahead == '\n')
        SKIP(115);
      END_STATE();
    case 118:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(84);
      if (lookahead == '0')
        ADVANCE(35);
      if (lookahead == ';')
        ADVANCE(51);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(119);
      if (lookahead == '{')
        ADVANCE(71);
      if (lookahead == '~')
        ADVANCE(75);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(118);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(49);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 119:
      if (lookahead == '\n')
        SKIP(118);
      if (lookahead == '\r')
        SKIP(120);
      END_STATE();
    case 120:
      if (lookahead == '\n')
        SKIP(118);
      END_STATE();
    case 121:
      if (lookahead == '!')
        ADVANCE(111);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(6);
      if (lookahead == '&')
        ADVANCE(8);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(12);
      if (lookahead == '+')
        ADVANCE(16);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(112);
      if (lookahead == '.')
        ADVANCE(104);
      if (lookahead == '/')
        ADVANCE(31);
      if (lookahead == ':')
        ADVANCE(50);
      if (lookahead == ';')
        ADVANCE(51);
      if (lookahead == '<')
        ADVANCE(52);
      if (lookahead == '=')
        ADVANCE(57);
      if (lookahead == '>')
        ADVANCE(59);
      if (lookahead == '@')
        ADVANCE(63);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(122);
      if (lookahead == '^')
        ADVANCE(69);
      if (lookahead == '|')
        ADVANCE(72);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(121);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 122:
      if (lookahead == '\n')
        SKIP(121);
      if (lookahead == '\r')
        SKIP(123);
      END_STATE();
    case 123:
      if (lookahead == '\n')
        SKIP(121);
      END_STATE();
    case 124:
      if (lookahead == '!')
        ADVANCE(111);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == '*')
        ADVANCE(125);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '.')
        ADVANCE(104);
      if (lookahead == ':')
        ADVANCE(50);
      if (lookahead == '<')
        ADVANCE(126);
      if (lookahead == '=')
        ADVANCE(57);
      if (lookahead == '>')
        ADVANCE(127);
      if (lookahead == '\\')
        SKIP(128);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(124);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 125:
      ACCEPT_TOKEN(anon_sym_STAR);
      END_STATE();
    case 126:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '=')
        ADVANCE(55);
      if (lookahead == '>')
        ADVANCE(56);
      END_STATE();
    case 127:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(60);
      END_STATE();
    case 128:
      if (lookahead == '\n')
        SKIP(124);
      if (lookahead == '\r')
        SKIP(129);
      END_STATE();
    case 129:
      if (lookahead == '\n')
        SKIP(124);
      END_STATE();
    case 130:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(125);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(84);
      if (lookahead == '0')
        ADVANCE(35);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(131);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '{')
        ADVANCE(71);
      if (lookahead == '~')
        ADVANCE(75);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(130);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(49);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 131:
      if (lookahead == '\n')
        SKIP(130);
      if (lookahead == '\r')
        SKIP(132);
      END_STATE();
    case 132:
      if (lookahead == '\n')
        SKIP(130);
      END_STATE();
    case 133:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(125);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(84);
      if (lookahead == '0')
        ADVANCE(35);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(134);
      if (lookahead == '{')
        ADVANCE(71);
      if (lookahead == '}')
        ADVANCE(74);
      if (lookahead == '~')
        ADVANCE(75);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(133);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(49);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 134:
      if (lookahead == '\n')
        SKIP(133);
      if (lookahead == '\r')
        SKIP(135);
      END_STATE();
    case 135:
      if (lookahead == '\n')
        SKIP(133);
      END_STATE();
    case 136:
      if (lookahead == 0)
        ADVANCE(1);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '\\')
        SKIP(137);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(136);
      END_STATE();
    case 137:
      if (lookahead == '\n')
        SKIP(136);
      if (lookahead == '\r')
        SKIP(138);
      END_STATE();
    case 138:
      if (lookahead == '\n')
        SKIP(136);
      END_STATE();
    case 139:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(140);
      if (lookahead == '&')
        ADVANCE(141);
      if (lookahead == '*')
        ADVANCE(142);
      if (lookahead == '+')
        ADVANCE(144);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(145);
      if (lookahead == '/')
        ADVANCE(146);
      if (lookahead == ':')
        ADVANCE(50);
      if (lookahead == ';')
        ADVANCE(51);
      if (lookahead == '<')
        ADVANCE(148);
      if (lookahead == '=')
        ADVANCE(150);
      if (lookahead == '>')
        ADVANCE(151);
      if (lookahead == '@')
        ADVANCE(153);
      if (lookahead == '\\')
        SKIP(154);
      if (lookahead == '^')
        ADVANCE(156);
      if (lookahead == '|')
        ADVANCE(157);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(139);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 140:
      if (lookahead == '=')
        ADVANCE(7);
      END_STATE();
    case 141:
      if (lookahead == '=')
        ADVANCE(9);
      END_STATE();
    case 142:
      if (lookahead == '*')
        ADVANCE(143);
      if (lookahead == '=')
        ADVANCE(15);
      END_STATE();
    case 143:
      if (lookahead == '=')
        ADVANCE(14);
      END_STATE();
    case 144:
      if (lookahead == '=')
        ADVANCE(17);
      END_STATE();
    case 145:
      if (lookahead == '=')
        ADVANCE(20);
      END_STATE();
    case 146:
      if (lookahead == '/')
        ADVANCE(147);
      if (lookahead == '=')
        ADVANCE(34);
      END_STATE();
    case 147:
      if (lookahead == '=')
        ADVANCE(33);
      END_STATE();
    case 148:
      if (lookahead == '<')
        ADVANCE(149);
      END_STATE();
    case 149:
      if (lookahead == '=')
        ADVANCE(54);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_EQ);
      END_STATE();
    case 151:
      if (lookahead == '>')
        ADVANCE(152);
      END_STATE();
    case 152:
      if (lookahead == '=')
        ADVANCE(62);
      END_STATE();
    case 153:
      if (lookahead == '=')
        ADVANCE(64);
      END_STATE();
    case 154:
      if (lookahead == '\n')
        SKIP(139);
      if (lookahead == '\r')
        SKIP(155);
      END_STATE();
    case 155:
      if (lookahead == '\n')
        SKIP(139);
      END_STATE();
    case 156:
      if (lookahead == '=')
        ADVANCE(70);
      END_STATE();
    case 157:
      if (lookahead == '=')
        ADVANCE(73);
      END_STATE();
    case 158:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '.')
        ADVANCE(104);
      if (lookahead == ';')
        ADVANCE(51);
      if (lookahead == '\\')
        SKIP(159);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(158);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 159:
      if (lookahead == '\n')
        SKIP(158);
      if (lookahead == '\r')
        SKIP(160);
      END_STATE();
    case 160:
      if (lookahead == '\n')
        SKIP(158);
      END_STATE();
    case 161:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(162);
      if (lookahead == '&')
        ADVANCE(163);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == '*')
        ADVANCE(164);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(104);
      if (lookahead == '/')
        ADVANCE(166);
      if (lookahead == ':')
        ADVANCE(50);
      if (lookahead == '<')
        ADVANCE(168);
      if (lookahead == '=')
        ADVANCE(57);
      if (lookahead == '>')
        ADVANCE(170);
      if (lookahead == '@')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(172);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(161);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 162:
      ACCEPT_TOKEN(anon_sym_PERCENT);
      END_STATE();
    case 163:
      ACCEPT_TOKEN(anon_sym_AMP);
      END_STATE();
    case 164:
      ACCEPT_TOKEN(anon_sym_STAR);
      if (lookahead == '*')
        ADVANCE(165);
      END_STATE();
    case 165:
      ACCEPT_TOKEN(anon_sym_STAR_STAR);
      END_STATE();
    case 166:
      ACCEPT_TOKEN(anon_sym_SLASH);
      if (lookahead == '/')
        ADVANCE(167);
      END_STATE();
    case 167:
      ACCEPT_TOKEN(anon_sym_SLASH_SLASH);
      END_STATE();
    case 168:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<')
        ADVANCE(169);
      if (lookahead == '=')
        ADVANCE(55);
      if (lookahead == '>')
        ADVANCE(56);
      END_STATE();
    case 169:
      ACCEPT_TOKEN(anon_sym_LT_LT);
      END_STATE();
    case 170:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(60);
      if (lookahead == '>')
        ADVANCE(171);
      END_STATE();
    case 171:
      ACCEPT_TOKEN(anon_sym_GT_GT);
      END_STATE();
    case 172:
      if (lookahead == '\n')
        SKIP(161);
      if (lookahead == '\r')
        SKIP(173);
      END_STATE();
    case 173:
      if (lookahead == '\n')
        SKIP(161);
      END_STATE();
    case 174:
      ACCEPT_TOKEN(anon_sym_CARET);
      END_STATE();
    case 175:
      ACCEPT_TOKEN(anon_sym_PIPE);
      END_STATE();
    case 176:
      if (lookahead == '!')
        ADVANCE(111);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(162);
      if (lookahead == '&')
        ADVANCE(163);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == '*')
        ADVANCE(164);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(104);
      if (lookahead == '/')
        ADVANCE(166);
      if (lookahead == '<')
        ADVANCE(168);
      if (lookahead == '=')
        ADVANCE(177);
      if (lookahead == '>')
        ADVANCE(170);
      if (lookahead == '@')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(178);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(176);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 177:
      if (lookahead == '=')
        ADVANCE(58);
      END_STATE();
    case 178:
      if (lookahead == '\n')
        SKIP(176);
      if (lookahead == '\r')
        SKIP(179);
      END_STATE();
    case 179:
      if (lookahead == '\n')
        SKIP(176);
      END_STATE();
    case 180:
      if (lookahead == '!')
        ADVANCE(111);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(162);
      if (lookahead == '&')
        ADVANCE(163);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(164);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(104);
      if (lookahead == '/')
        ADVANCE(166);
      if (lookahead == ';')
        ADVANCE(51);
      if (lookahead == '<')
        ADVANCE(168);
      if (lookahead == '=')
        ADVANCE(57);
      if (lookahead == '>')
        ADVANCE(170);
      if (lookahead == '@')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(181);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(180);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 181:
      if (lookahead == '\n')
        SKIP(180);
      if (lookahead == '\r')
        SKIP(182);
      END_STATE();
    case 182:
      if (lookahead == '\n')
        SKIP(180);
      END_STATE();
    case 183:
      if (lookahead == '!')
        ADVANCE(111);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(162);
      if (lookahead == '&')
        ADVANCE(163);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(164);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(104);
      if (lookahead == '/')
        ADVANCE(166);
      if (lookahead == ';')
        ADVANCE(51);
      if (lookahead == '<')
        ADVANCE(168);
      if (lookahead == '=')
        ADVANCE(177);
      if (lookahead == '>')
        ADVANCE(170);
      if (lookahead == '@')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(184);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(183);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 184:
      if (lookahead == '\n')
        SKIP(183);
      if (lookahead == '\r')
        SKIP(185);
      END_STATE();
    case 185:
      if (lookahead == '\n')
        SKIP(183);
      END_STATE();
    case 186:
      if (lookahead == '!')
        ADVANCE(111);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(162);
      if (lookahead == '&')
        ADVANCE(163);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(164);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(104);
      if (lookahead == '/')
        ADVANCE(166);
      if (lookahead == ':')
        ADVANCE(50);
      if (lookahead == '<')
        ADVANCE(168);
      if (lookahead == '=')
        ADVANCE(177);
      if (lookahead == '>')
        ADVANCE(170);
      if (lookahead == '@')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(187);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(186);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 187:
      if (lookahead == '\n')
        SKIP(186);
      if (lookahead == '\r')
        SKIP(188);
      END_STATE();
    case 188:
      if (lookahead == '\n')
        SKIP(186);
      END_STATE();
    case 189:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(162);
      if (lookahead == '&')
        ADVANCE(163);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(164);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(104);
      if (lookahead == '/')
        ADVANCE(166);
      if (lookahead == '<')
        ADVANCE(190);
      if (lookahead == '>')
        ADVANCE(191);
      if (lookahead == '@')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(192);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(189);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 190:
      if (lookahead == '<')
        ADVANCE(169);
      END_STATE();
    case 191:
      if (lookahead == '>')
        ADVANCE(171);
      END_STATE();
    case 192:
      if (lookahead == '\n')
        SKIP(189);
      if (lookahead == '\r')
        SKIP(193);
      END_STATE();
    case 193:
      if (lookahead == '\n')
        SKIP(189);
      END_STATE();
    case 194:
      if (lookahead == '!')
        ADVANCE(111);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(162);
      if (lookahead == '&')
        ADVANCE(163);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(164);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(104);
      if (lookahead == '/')
        ADVANCE(166);
      if (lookahead == ':')
        ADVANCE(50);
      if (lookahead == '<')
        ADVANCE(168);
      if (lookahead == '=')
        ADVANCE(177);
      if (lookahead == '>')
        ADVANCE(170);
      if (lookahead == '@')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(195);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(194);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 195:
      if (lookahead == '\n')
        SKIP(194);
      if (lookahead == '\r')
        SKIP(196);
      END_STATE();
    case 196:
      if (lookahead == '\n')
        SKIP(194);
      END_STATE();
    case 197:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '.')
        ADVANCE(104);
      if (lookahead == '\\')
        SKIP(198);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(197);
      END_STATE();
    case 198:
      if (lookahead == '\n')
        SKIP(197);
      if (lookahead == '\r')
        SKIP(199);
      END_STATE();
    case 199:
      if (lookahead == '\n')
        SKIP(197);
      END_STATE();
    case 200:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(125);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(84);
      if (lookahead == '0')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(50);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(201);
      if (lookahead == '{')
        ADVANCE(71);
      if (lookahead == '~')
        ADVANCE(75);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(200);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(49);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 201:
      if (lookahead == '\n')
        SKIP(200);
      if (lookahead == '\r')
        SKIP(202);
      END_STATE();
    case 202:
      if (lookahead == '\n')
        SKIP(200);
      END_STATE();
    case 203:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(84);
      if (lookahead == '0')
        ADVANCE(35);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(204);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '{')
        ADVANCE(71);
      if (lookahead == '~')
        ADVANCE(75);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(203);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(49);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 204:
      if (lookahead == '\n')
        SKIP(203);
      if (lookahead == '\r')
        SKIP(205);
      END_STATE();
    case 205:
      if (lookahead == '\n')
        SKIP(203);
      END_STATE();
    case 206:
      if (lookahead == '!')
        ADVANCE(111);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(162);
      if (lookahead == '&')
        ADVANCE(163);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(164);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(104);
      if (lookahead == '/')
        ADVANCE(166);
      if (lookahead == '<')
        ADVANCE(168);
      if (lookahead == '=')
        ADVANCE(177);
      if (lookahead == '>')
        ADVANCE(170);
      if (lookahead == '@')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(207);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(206);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 207:
      if (lookahead == '\n')
        SKIP(206);
      if (lookahead == '\r')
        SKIP(208);
      END_STATE();
    case 208:
      if (lookahead == '\n')
        SKIP(206);
      END_STATE();
    case 209:
      if (lookahead == '!')
        ADVANCE(111);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(162);
      if (lookahead == '&')
        ADVANCE(163);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(164);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(104);
      if (lookahead == '/')
        ADVANCE(166);
      if (lookahead == ':')
        ADVANCE(50);
      if (lookahead == '<')
        ADVANCE(168);
      if (lookahead == '=')
        ADVANCE(177);
      if (lookahead == '>')
        ADVANCE(170);
      if (lookahead == '@')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(210);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(209);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 210:
      if (lookahead == '\n')
        SKIP(209);
      if (lookahead == '\r')
        SKIP(211);
      END_STATE();
    case 211:
      if (lookahead == '\n')
        SKIP(209);
      END_STATE();
    case 212:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(140);
      if (lookahead == '&')
        ADVANCE(141);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(142);
      if (lookahead == '+')
        ADVANCE(16);
      if (lookahead == '-')
        ADVANCE(112);
      if (lookahead == '.')
        ADVANCE(84);
      if (lookahead == '/')
        ADVANCE(146);
      if (lookahead == '0')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(50);
      if (lookahead == ';')
        ADVANCE(51);
      if (lookahead == '<')
        ADVANCE(148);
      if (lookahead == '=')
        ADVANCE(150);
      if (lookahead == '>')
        ADVANCE(151);
      if (lookahead == '@')
        ADVANCE(153);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(213);
      if (lookahead == '^')
        ADVANCE(156);
      if (lookahead == '{')
        ADVANCE(71);
      if (lookahead == '|')
        ADVANCE(157);
      if (lookahead == '~')
        ADVANCE(75);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(212);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(49);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 213:
      if (lookahead == '\n')
        SKIP(212);
      if (lookahead == '\r')
        SKIP(214);
      END_STATE();
    case 214:
      if (lookahead == '\n')
        SKIP(212);
      END_STATE();
    case 215:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == '*')
        ADVANCE(125);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(84);
      if (lookahead == '0')
        ADVANCE(35);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(216);
      if (lookahead == '{')
        ADVANCE(71);
      if (lookahead == '~')
        ADVANCE(75);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(215);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(49);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 216:
      if (lookahead == '\n')
        SKIP(215);
      if (lookahead == '\r')
        SKIP(217);
      END_STATE();
    case 217:
      if (lookahead == '\n')
        SKIP(215);
      END_STATE();
    case 218:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(84);
      if (lookahead == '0')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(50);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(219);
      if (lookahead == '{')
        ADVANCE(71);
      if (lookahead == '~')
        ADVANCE(75);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(218);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(49);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 219:
      if (lookahead == '\n')
        SKIP(218);
      if (lookahead == '\r')
        SKIP(220);
      END_STATE();
    case 220:
      if (lookahead == '\n')
        SKIP(218);
      END_STATE();
    case 221:
      if (lookahead == '!')
        ADVANCE(111);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(140);
      if (lookahead == '&')
        ADVANCE(141);
      if (lookahead == '*')
        ADVANCE(142);
      if (lookahead == '+')
        ADVANCE(144);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(145);
      if (lookahead == '/')
        ADVANCE(146);
      if (lookahead == ':')
        ADVANCE(50);
      if (lookahead == ';')
        ADVANCE(51);
      if (lookahead == '<')
        ADVANCE(222);
      if (lookahead == '=')
        ADVANCE(57);
      if (lookahead == '>')
        ADVANCE(223);
      if (lookahead == '@')
        ADVANCE(153);
      if (lookahead == '\\')
        SKIP(224);
      if (lookahead == '^')
        ADVANCE(156);
      if (lookahead == '|')
        ADVANCE(157);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(221);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 222:
      ACCEPT_TOKEN(anon_sym_LT);
      if (lookahead == '<')
        ADVANCE(149);
      if (lookahead == '=')
        ADVANCE(55);
      if (lookahead == '>')
        ADVANCE(56);
      END_STATE();
    case 223:
      ACCEPT_TOKEN(anon_sym_GT);
      if (lookahead == '=')
        ADVANCE(60);
      if (lookahead == '>')
        ADVANCE(152);
      END_STATE();
    case 224:
      if (lookahead == '\n')
        SKIP(221);
      if (lookahead == '\r')
        SKIP(225);
      END_STATE();
    case 225:
      if (lookahead == '\n')
        SKIP(221);
      END_STATE();
    case 226:
      if (lookahead == '!')
        ADVANCE(2);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(162);
      if (lookahead == '&')
        ADVANCE(163);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(164);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(104);
      if (lookahead == '/')
        ADVANCE(166);
      if (lookahead == '<')
        ADVANCE(168);
      if (lookahead == '=')
        ADVANCE(177);
      if (lookahead == '>')
        ADVANCE(170);
      if (lookahead == '@')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(227);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(226);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 227:
      if (lookahead == '\n')
        SKIP(226);
      if (lookahead == '\r')
        SKIP(228);
      END_STATE();
    case 228:
      if (lookahead == '\n')
        SKIP(226);
      END_STATE();
    case 229:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(84);
      if (lookahead == '0')
        ADVANCE(35);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(230);
      if (lookahead == '{')
        ADVANCE(71);
      if (lookahead == '~')
        ADVANCE(75);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(229);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(49);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 230:
      if (lookahead == '\n')
        SKIP(229);
      if (lookahead == '\r')
        SKIP(231);
      END_STATE();
    case 231:
      if (lookahead == '\n')
        SKIP(229);
      END_STATE();
    case 232:
      if (lookahead == '!')
        ADVANCE(111);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == ';')
        ADVANCE(51);
      if (lookahead == '<')
        ADVANCE(126);
      if (lookahead == '=')
        ADVANCE(177);
      if (lookahead == '>')
        ADVANCE(127);
      if (lookahead == '\\')
        SKIP(233);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(232);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 233:
      if (lookahead == '\n')
        SKIP(232);
      if (lookahead == '\r')
        SKIP(234);
      END_STATE();
    case 234:
      if (lookahead == '\n')
        SKIP(232);
      END_STATE();
    case 235:
      if (lookahead == '!')
        ADVANCE(111);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(162);
      if (lookahead == '&')
        ADVANCE(163);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(164);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(104);
      if (lookahead == '/')
        ADVANCE(166);
      if (lookahead == ';')
        ADVANCE(51);
      if (lookahead == '<')
        ADVANCE(168);
      if (lookahead == '=')
        ADVANCE(177);
      if (lookahead == '>')
        ADVANCE(170);
      if (lookahead == '@')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(236);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(235);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 236:
      if (lookahead == '\n')
        SKIP(235);
      if (lookahead == '\r')
        SKIP(237);
      END_STATE();
    case 237:
      if (lookahead == '\n')
        SKIP(235);
      END_STATE();
    case 238:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '-')
        ADVANCE(239);
      if (lookahead == ':')
        ADVANCE(50);
      if (lookahead == '\\')
        SKIP(240);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(238);
      END_STATE();
    case 239:
      if (lookahead == '>')
        ADVANCE(21);
      END_STATE();
    case 240:
      if (lookahead == '\n')
        SKIP(238);
      if (lookahead == '\r')
        SKIP(241);
      END_STATE();
    case 241:
      if (lookahead == '\n')
        SKIP(238);
      END_STATE();
    case 242:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(125);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(84);
      if (lookahead == '0')
        ADVANCE(35);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(243);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '{')
        ADVANCE(71);
      if (lookahead == '~')
        ADVANCE(75);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(242);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(49);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 243:
      if (lookahead == '\n')
        SKIP(242);
      if (lookahead == '\r')
        SKIP(244);
      END_STATE();
    case 244:
      if (lookahead == '\n')
        SKIP(242);
      END_STATE();
    case 245:
      if (lookahead == '!')
        ADVANCE(111);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(162);
      if (lookahead == '&')
        ADVANCE(163);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(164);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(104);
      if (lookahead == '/')
        ADVANCE(166);
      if (lookahead == '<')
        ADVANCE(168);
      if (lookahead == '=')
        ADVANCE(177);
      if (lookahead == '>')
        ADVANCE(170);
      if (lookahead == '@')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(246);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(245);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 246:
      if (lookahead == '\n')
        SKIP(245);
      if (lookahead == '\r')
        SKIP(247);
      END_STATE();
    case 247:
      if (lookahead == '\n')
        SKIP(245);
      END_STATE();
    case 248:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(125);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(84);
      if (lookahead == '0')
        ADVANCE(35);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(249);
      if (lookahead == '{')
        ADVANCE(71);
      if (lookahead == '}')
        ADVANCE(74);
      if (lookahead == '~')
        ADVANCE(75);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(248);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(49);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 249:
      if (lookahead == '\n')
        SKIP(248);
      if (lookahead == '\r')
        SKIP(250);
      END_STATE();
    case 250:
      if (lookahead == '\n')
        SKIP(248);
      END_STATE();
    case 251:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == ';')
        ADVANCE(51);
      if (lookahead == '=')
        ADVANCE(150);
      if (lookahead == '\\')
        SKIP(252);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(251);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 252:
      if (lookahead == '\n')
        SKIP(251);
      if (lookahead == '\r')
        SKIP(253);
      END_STATE();
    case 253:
      if (lookahead == '\n')
        SKIP(251);
      END_STATE();
    case 254:
      if (lookahead == '!')
        ADVANCE(111);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(162);
      if (lookahead == '&')
        ADVANCE(163);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(164);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(104);
      if (lookahead == '/')
        ADVANCE(166);
      if (lookahead == ';')
        ADVANCE(51);
      if (lookahead == '<')
        ADVANCE(168);
      if (lookahead == '=')
        ADVANCE(57);
      if (lookahead == '>')
        ADVANCE(170);
      if (lookahead == '@')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(255);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(254);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 255:
      if (lookahead == '\n')
        SKIP(254);
      if (lookahead == '\r')
        SKIP(256);
      END_STATE();
    case 256:
      if (lookahead == '\n')
        SKIP(254);
      END_STATE();
    case 257:
      if (lookahead == '!')
        ADVANCE(111);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(162);
      if (lookahead == '&')
        ADVANCE(163);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(164);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(104);
      if (lookahead == '/')
        ADVANCE(166);
      if (lookahead == '<')
        ADVANCE(168);
      if (lookahead == '=')
        ADVANCE(177);
      if (lookahead == '>')
        ADVANCE(170);
      if (lookahead == '@')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(258);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(257);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 258:
      if (lookahead == '\n')
        SKIP(257);
      if (lookahead == '\r')
        SKIP(259);
      END_STATE();
    case 259:
      if (lookahead == '\n')
        SKIP(257);
      END_STATE();
    case 260:
      if (lookahead == '!')
        ADVANCE(111);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(162);
      if (lookahead == '&')
        ADVANCE(163);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == '*')
        ADVANCE(164);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(104);
      if (lookahead == '/')
        ADVANCE(166);
      if (lookahead == ':')
        ADVANCE(50);
      if (lookahead == '<')
        ADVANCE(168);
      if (lookahead == '=')
        ADVANCE(57);
      if (lookahead == '>')
        ADVANCE(170);
      if (lookahead == '@')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(261);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(260);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 261:
      if (lookahead == '\n')
        SKIP(260);
      if (lookahead == '\r')
        SKIP(262);
      END_STATE();
    case 262:
      if (lookahead == '\n')
        SKIP(260);
      END_STATE();
    case 263:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(84);
      if (lookahead == '0')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(50);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(264);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '{')
        ADVANCE(71);
      if (lookahead == '~')
        ADVANCE(75);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(263);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(49);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 264:
      if (lookahead == '\n')
        SKIP(263);
      if (lookahead == '\r')
        SKIP(265);
      END_STATE();
    case 265:
      if (lookahead == '\n')
        SKIP(263);
      END_STATE();
    case 266:
      if (lookahead == '!')
        ADVANCE(111);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(162);
      if (lookahead == '&')
        ADVANCE(163);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(164);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(104);
      if (lookahead == '/')
        ADVANCE(166);
      if (lookahead == ':')
        ADVANCE(50);
      if (lookahead == '<')
        ADVANCE(168);
      if (lookahead == '=')
        ADVANCE(177);
      if (lookahead == '>')
        ADVANCE(170);
      if (lookahead == '@')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(267);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(266);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 267:
      if (lookahead == '\n')
        SKIP(266);
      if (lookahead == '\r')
        SKIP(268);
      END_STATE();
    case 268:
      if (lookahead == '\n')
        SKIP(266);
      END_STATE();
    case 269:
      if (lookahead == '!')
        ADVANCE(111);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == ';')
        ADVANCE(51);
      if (lookahead == '<')
        ADVANCE(126);
      if (lookahead == '=')
        ADVANCE(177);
      if (lookahead == '>')
        ADVANCE(127);
      if (lookahead == '\\')
        SKIP(270);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(269);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 270:
      if (lookahead == '\n')
        SKIP(269);
      if (lookahead == '\r')
        SKIP(271);
      END_STATE();
    case 271:
      if (lookahead == '\n')
        SKIP(269);
      END_STATE();
    case 272:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == '*')
        ADVANCE(125);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(84);
      if (lookahead == '0')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(50);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(273);
      if (lookahead == '{')
        ADVANCE(71);
      if (lookahead == '~')
        ADVANCE(75);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(272);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(49);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 273:
      if (lookahead == '\n')
        SKIP(272);
      if (lookahead == '\r')
        SKIP(274);
      END_STATE();
    case 274:
      if (lookahead == '\n')
        SKIP(272);
      END_STATE();
    case 275:
      if (lookahead == '!')
        ADVANCE(111);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(162);
      if (lookahead == '&')
        ADVANCE(163);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(164);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(104);
      if (lookahead == '/')
        ADVANCE(166);
      if (lookahead == '<')
        ADVANCE(168);
      if (lookahead == '=')
        ADVANCE(57);
      if (lookahead == '>')
        ADVANCE(170);
      if (lookahead == '@')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(276);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(275);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 276:
      if (lookahead == '\n')
        SKIP(275);
      if (lookahead == '\r')
        SKIP(277);
      END_STATE();
    case 277:
      if (lookahead == '\n')
        SKIP(275);
      END_STATE();
    case 278:
      if (lookahead == '!')
        ADVANCE(111);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(162);
      if (lookahead == '&')
        ADVANCE(163);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(164);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(104);
      if (lookahead == '/')
        ADVANCE(166);
      if (lookahead == ':')
        ADVANCE(50);
      if (lookahead == '<')
        ADVANCE(168);
      if (lookahead == '=')
        ADVANCE(57);
      if (lookahead == '>')
        ADVANCE(170);
      if (lookahead == '@')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(279);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(278);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 279:
      if (lookahead == '\n')
        SKIP(278);
      if (lookahead == '\r')
        SKIP(280);
      END_STATE();
    case 280:
      if (lookahead == '\n')
        SKIP(278);
      END_STATE();
    case 281:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '\\')
        SKIP(282);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '}')
        ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(281);
      END_STATE();
    case 282:
      if (lookahead == '\n')
        SKIP(281);
      if (lookahead == '\r')
        SKIP(283);
      END_STATE();
    case 283:
      if (lookahead == '\n')
        SKIP(281);
      END_STATE();
    case 284:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(84);
      if (lookahead == '0')
        ADVANCE(35);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(285);
      if (lookahead == '{')
        ADVANCE(71);
      if (lookahead == '}')
        ADVANCE(74);
      if (lookahead == '~')
        ADVANCE(75);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(284);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(49);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 285:
      if (lookahead == '\n')
        SKIP(284);
      if (lookahead == '\r')
        SKIP(286);
      END_STATE();
    case 286:
      if (lookahead == '\n')
        SKIP(284);
      END_STATE();
    case 287:
      if (lookahead == '!')
        ADVANCE(111);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == ';')
        ADVANCE(51);
      if (lookahead == '<')
        ADVANCE(126);
      if (lookahead == '=')
        ADVANCE(57);
      if (lookahead == '>')
        ADVANCE(127);
      if (lookahead == '\\')
        SKIP(288);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(287);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 288:
      if (lookahead == '\n')
        SKIP(287);
      if (lookahead == '\r')
        SKIP(289);
      END_STATE();
    case 289:
      if (lookahead == '\n')
        SKIP(287);
      END_STATE();
    case 290:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == '*')
        ADVANCE(125);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(84);
      if (lookahead == '0')
        ADVANCE(35);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(291);
      if (lookahead == '{')
        ADVANCE(71);
      if (lookahead == '~')
        ADVANCE(75);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(290);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(49);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 291:
      if (lookahead == '\n')
        SKIP(290);
      if (lookahead == '\r')
        SKIP(292);
      END_STATE();
    case 292:
      if (lookahead == '\n')
        SKIP(290);
      END_STATE();
    case 293:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(84);
      if (lookahead == '0')
        ADVANCE(35);
      if (lookahead == ':')
        ADVANCE(50);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(294);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '{')
        ADVANCE(71);
      if (lookahead == '~')
        ADVANCE(75);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(293);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(49);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 294:
      if (lookahead == '\n')
        SKIP(293);
      if (lookahead == '\r')
        SKIP(295);
      END_STATE();
    case 295:
      if (lookahead == '\n')
        SKIP(293);
      END_STATE();
    case 296:
      if (lookahead == '!')
        ADVANCE(111);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(162);
      if (lookahead == '&')
        ADVANCE(163);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == '*')
        ADVANCE(164);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(104);
      if (lookahead == '/')
        ADVANCE(166);
      if (lookahead == '<')
        ADVANCE(168);
      if (lookahead == '=')
        ADVANCE(177);
      if (lookahead == '>')
        ADVANCE(170);
      if (lookahead == '@')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(297);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(296);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 297:
      if (lookahead == '\n')
        SKIP(296);
      if (lookahead == '\r')
        SKIP(298);
      END_STATE();
    case 298:
      if (lookahead == '\n')
        SKIP(296);
      END_STATE();
    case 299:
      if (lookahead == '!')
        ADVANCE(111);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(162);
      if (lookahead == '&')
        ADVANCE(163);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == '*')
        ADVANCE(164);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(104);
      if (lookahead == '/')
        ADVANCE(166);
      if (lookahead == ':')
        ADVANCE(50);
      if (lookahead == '<')
        ADVANCE(168);
      if (lookahead == '=')
        ADVANCE(177);
      if (lookahead == '>')
        ADVANCE(170);
      if (lookahead == '@')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(300);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(299);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 300:
      if (lookahead == '\n')
        SKIP(299);
      if (lookahead == '\r')
        SKIP(301);
      END_STATE();
    case 301:
      if (lookahead == '\n')
        SKIP(299);
      END_STATE();
    case 302:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(125);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(84);
      if (lookahead == '0')
        ADVANCE(35);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(303);
      if (lookahead == '{')
        ADVANCE(71);
      if (lookahead == '~')
        ADVANCE(75);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(302);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(49);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 303:
      if (lookahead == '\n')
        SKIP(302);
      if (lookahead == '\r')
        SKIP(304);
      END_STATE();
    case 304:
      if (lookahead == '\n')
        SKIP(302);
      END_STATE();
    case 305:
      if (lookahead == '!')
        ADVANCE(111);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(162);
      if (lookahead == '&')
        ADVANCE(163);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(164);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(104);
      if (lookahead == '/')
        ADVANCE(166);
      if (lookahead == '<')
        ADVANCE(168);
      if (lookahead == '=')
        ADVANCE(177);
      if (lookahead == '>')
        ADVANCE(170);
      if (lookahead == '@')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(306);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(305);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 306:
      if (lookahead == '\n')
        SKIP(305);
      if (lookahead == '\r')
        SKIP(307);
      END_STATE();
    case 307:
      if (lookahead == '\n')
        SKIP(305);
      END_STATE();
    case 308:
      if (lookahead == '!')
        ADVANCE(111);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(162);
      if (lookahead == '&')
        ADVANCE(163);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '*')
        ADVANCE(164);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(104);
      if (lookahead == '/')
        ADVANCE(166);
      if (lookahead == '<')
        ADVANCE(168);
      if (lookahead == '=')
        ADVANCE(177);
      if (lookahead == '>')
        ADVANCE(170);
      if (lookahead == '@')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(309);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '}')
        ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(308);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 309:
      if (lookahead == '\n')
        SKIP(308);
      if (lookahead == '\r')
        SKIP(310);
      END_STATE();
    case 310:
      if (lookahead == '\n')
        SKIP(308);
      END_STATE();
    case 311:
      if (lookahead == '!')
        ADVANCE(111);
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '%')
        ADVANCE(162);
      if (lookahead == '&')
        ADVANCE(163);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == '*')
        ADVANCE(164);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(104);
      if (lookahead == '/')
        ADVANCE(166);
      if (lookahead == '<')
        ADVANCE(168);
      if (lookahead == '=')
        ADVANCE(57);
      if (lookahead == '>')
        ADVANCE(170);
      if (lookahead == '@')
        ADVANCE(85);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(312);
      if (lookahead == '^')
        ADVANCE(174);
      if (lookahead == '|')
        ADVANCE(175);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(311);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 312:
      if (lookahead == '\n')
        SKIP(311);
      if (lookahead == '\r')
        SKIP(313);
      END_STATE();
    case 313:
      if (lookahead == '\n')
        SKIP(311);
      END_STATE();
    case 314:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(84);
      if (lookahead == '0')
        ADVANCE(35);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(315);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '{')
        ADVANCE(71);
      if (lookahead == '~')
        ADVANCE(75);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(314);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(49);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 315:
      if (lookahead == '\n')
        SKIP(314);
      if (lookahead == '\r')
        SKIP(316);
      END_STATE();
    case 316:
      if (lookahead == '\n')
        SKIP(314);
      END_STATE();
    case 317:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == '(')
        ADVANCE(10);
      if (lookahead == '+')
        ADVANCE(82);
      if (lookahead == '-')
        ADVANCE(83);
      if (lookahead == '.')
        ADVANCE(84);
      if (lookahead == '0')
        ADVANCE(35);
      if (lookahead == '[')
        ADVANCE(65);
      if (lookahead == '\\')
        SKIP(318);
      if (lookahead == '{')
        ADVANCE(71);
      if (lookahead == '}')
        ADVANCE(74);
      if (lookahead == '~')
        ADVANCE(75);
      if (lookahead == 'E' ||
          lookahead == 'e')
        ADVANCE(76);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(317);
      if (('1' <= lookahead && lookahead <= '9'))
        ADVANCE(49);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 318:
      if (lookahead == '\n')
        SKIP(317);
      if (lookahead == '\r')
        SKIP(319);
      END_STATE();
    case 319:
      if (lookahead == '\n')
        SKIP(317);
      END_STATE();
    case 320:
      if (lookahead == '#')
        ADVANCE(5);
      if (lookahead == ')')
        ADVANCE(11);
      if (lookahead == ',')
        ADVANCE(18);
      if (lookahead == '\\')
        SKIP(321);
      if (lookahead == ']')
        ADVANCE(68);
      if (lookahead == '}')
        ADVANCE(74);
      if (lookahead == '\t' ||
          lookahead == '\n' ||
          lookahead == '\r' ||
          lookahead == ' ' ||
          lookahead == 8203 ||
          lookahead == 8288 ||
          lookahead == 65279)
        SKIP(320);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (913 <= lookahead && lookahead <= 937) ||
          (945 <= lookahead && lookahead <= 969))
        ADVANCE(80);
      END_STATE();
    case 321:
      if (lookahead == '\n')
        SKIP(320);
      if (lookahead == '\r')
        SKIP(322);
      END_STATE();
    case 322:
      if (lookahead == '\n')
        SKIP(320);
      END_STATE();
    default:
      return false;
  }
}

static bool ts_lex_keywords(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  switch (state) {
    case 0:
      if (lookahead == 'F')
        ADVANCE(1);
      if (lookahead == 'N')
        ADVANCE(6);
      if (lookahead == 'T')
        ADVANCE(10);
      if (lookahead == '_')
        ADVANCE(14);
      if (lookahead == 'a')
        ADVANCE(24);
      if (lookahead == 'b')
        ADVANCE(39);
      if (lookahead == 'c')
        ADVANCE(44);
      if (lookahead == 'd')
        ADVANCE(56);
      if (lookahead == 'e')
        ADVANCE(60);
      if (lookahead == 'f')
        ADVANCE(73);
      if (lookahead == 'g')
        ADVANCE(85);
      if (lookahead == 'i')
        ADVANCE(91);
      if (lookahead == 'l')
        ADVANCE(100);
      if (lookahead == 'n')
        ADVANCE(106);
      if (lookahead == 'o')
        ADVANCE(115);
      if (lookahead == 'p')
        ADVANCE(117);
      if (lookahead == 'r')
        ADVANCE(125);
      if (lookahead == 't')
        ADVANCE(135);
      if (lookahead == 'w')
        ADVANCE(138);
      if (lookahead == 'y')
        ADVANCE(146);
      END_STATE();
    case 1:
      if (lookahead == 'a')
        ADVANCE(2);
      END_STATE();
    case 2:
      if (lookahead == 'l')
        ADVANCE(3);
      END_STATE();
    case 3:
      if (lookahead == 's')
        ADVANCE(4);
      END_STATE();
    case 4:
      if (lookahead == 'e')
        ADVANCE(5);
      END_STATE();
    case 5:
      ACCEPT_TOKEN(sym_false);
      END_STATE();
    case 6:
      if (lookahead == 'o')
        ADVANCE(7);
      END_STATE();
    case 7:
      if (lookahead == 'n')
        ADVANCE(8);
      END_STATE();
    case 8:
      if (lookahead == 'e')
        ADVANCE(9);
      END_STATE();
    case 9:
      ACCEPT_TOKEN(sym_none);
      END_STATE();
    case 10:
      if (lookahead == 'r')
        ADVANCE(11);
      END_STATE();
    case 11:
      if (lookahead == 'u')
        ADVANCE(12);
      END_STATE();
    case 12:
      if (lookahead == 'e')
        ADVANCE(13);
      END_STATE();
    case 13:
      ACCEPT_TOKEN(sym_true);
      END_STATE();
    case 14:
      if (lookahead == '_')
        ADVANCE(15);
      END_STATE();
    case 15:
      if (lookahead == 'f')
        ADVANCE(16);
      END_STATE();
    case 16:
      if (lookahead == 'u')
        ADVANCE(17);
      END_STATE();
    case 17:
      if (lookahead == 't')
        ADVANCE(18);
      END_STATE();
    case 18:
      if (lookahead == 'u')
        ADVANCE(19);
      END_STATE();
    case 19:
      if (lookahead == 'r')
        ADVANCE(20);
      END_STATE();
    case 20:
      if (lookahead == 'e')
        ADVANCE(21);
      END_STATE();
    case 21:
      if (lookahead == '_')
        ADVANCE(22);
      END_STATE();
    case 22:
      if (lookahead == '_')
        ADVANCE(23);
      END_STATE();
    case 23:
      ACCEPT_TOKEN(anon_sym___future__);
      END_STATE();
    case 24:
      if (lookahead == 'n')
        ADVANCE(25);
      if (lookahead == 's')
        ADVANCE(27);
      if (lookahead == 'w')
        ADVANCE(35);
      END_STATE();
    case 25:
      if (lookahead == 'd')
        ADVANCE(26);
      END_STATE();
    case 26:
      ACCEPT_TOKEN(anon_sym_and);
      END_STATE();
    case 27:
      ACCEPT_TOKEN(anon_sym_as);
      if (lookahead == 's')
        ADVANCE(28);
      if (lookahead == 'y')
        ADVANCE(32);
      END_STATE();
    case 28:
      if (lookahead == 'e')
        ADVANCE(29);
      END_STATE();
    case 29:
      if (lookahead == 'r')
        ADVANCE(30);
      END_STATE();
    case 30:
      if (lookahead == 't')
        ADVANCE(31);
      END_STATE();
    case 31:
      ACCEPT_TOKEN(anon_sym_assert);
      END_STATE();
    case 32:
      if (lookahead == 'n')
        ADVANCE(33);
      END_STATE();
    case 33:
      if (lookahead == 'c')
        ADVANCE(34);
      END_STATE();
    case 34:
      ACCEPT_TOKEN(anon_sym_async);
      END_STATE();
    case 35:
      if (lookahead == 'a')
        ADVANCE(36);
      END_STATE();
    case 36:
      if (lookahead == 'i')
        ADVANCE(37);
      END_STATE();
    case 37:
      if (lookahead == 't')
        ADVANCE(38);
      END_STATE();
    case 38:
      ACCEPT_TOKEN(anon_sym_await);
      END_STATE();
    case 39:
      if (lookahead == 'r')
        ADVANCE(40);
      END_STATE();
    case 40:
      if (lookahead == 'e')
        ADVANCE(41);
      END_STATE();
    case 41:
      if (lookahead == 'a')
        ADVANCE(42);
      END_STATE();
    case 42:
      if (lookahead == 'k')
        ADVANCE(43);
      END_STATE();
    case 43:
      ACCEPT_TOKEN(anon_sym_break);
      END_STATE();
    case 44:
      if (lookahead == 'l')
        ADVANCE(45);
      if (lookahead == 'o')
        ADVANCE(49);
      END_STATE();
    case 45:
      if (lookahead == 'a')
        ADVANCE(46);
      END_STATE();
    case 46:
      if (lookahead == 's')
        ADVANCE(47);
      END_STATE();
    case 47:
      if (lookahead == 's')
        ADVANCE(48);
      END_STATE();
    case 48:
      ACCEPT_TOKEN(anon_sym_class);
      END_STATE();
    case 49:
      if (lookahead == 'n')
        ADVANCE(50);
      END_STATE();
    case 50:
      if (lookahead == 't')
        ADVANCE(51);
      END_STATE();
    case 51:
      if (lookahead == 'i')
        ADVANCE(52);
      END_STATE();
    case 52:
      if (lookahead == 'n')
        ADVANCE(53);
      END_STATE();
    case 53:
      if (lookahead == 'u')
        ADVANCE(54);
      END_STATE();
    case 54:
      if (lookahead == 'e')
        ADVANCE(55);
      END_STATE();
    case 55:
      ACCEPT_TOKEN(anon_sym_continue);
      END_STATE();
    case 56:
      if (lookahead == 'e')
        ADVANCE(57);
      END_STATE();
    case 57:
      if (lookahead == 'f')
        ADVANCE(58);
      if (lookahead == 'l')
        ADVANCE(59);
      END_STATE();
    case 58:
      ACCEPT_TOKEN(anon_sym_def);
      END_STATE();
    case 59:
      ACCEPT_TOKEN(anon_sym_del);
      END_STATE();
    case 60:
      if (lookahead == 'l')
        ADVANCE(61);
      if (lookahead == 'x')
        ADVANCE(66);
      END_STATE();
    case 61:
      if (lookahead == 'i')
        ADVANCE(62);
      if (lookahead == 's')
        ADVANCE(64);
      END_STATE();
    case 62:
      if (lookahead == 'f')
        ADVANCE(63);
      END_STATE();
    case 63:
      ACCEPT_TOKEN(anon_sym_elif);
      END_STATE();
    case 64:
      if (lookahead == 'e')
        ADVANCE(65);
      END_STATE();
    case 65:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 66:
      if (lookahead == 'c')
        ADVANCE(67);
      if (lookahead == 'e')
        ADVANCE(71);
      END_STATE();
    case 67:
      if (lookahead == 'e')
        ADVANCE(68);
      END_STATE();
    case 68:
      if (lookahead == 'p')
        ADVANCE(69);
      END_STATE();
    case 69:
      if (lookahead == 't')
        ADVANCE(70);
      END_STATE();
    case 70:
      ACCEPT_TOKEN(anon_sym_except);
      END_STATE();
    case 71:
      if (lookahead == 'c')
        ADVANCE(72);
      END_STATE();
    case 72:
      ACCEPT_TOKEN(anon_sym_exec);
      END_STATE();
    case 73:
      if (lookahead == 'i')
        ADVANCE(74);
      if (lookahead == 'o')
        ADVANCE(80);
      if (lookahead == 'r')
        ADVANCE(82);
      END_STATE();
    case 74:
      if (lookahead == 'n')
        ADVANCE(75);
      END_STATE();
    case 75:
      if (lookahead == 'a')
        ADVANCE(76);
      END_STATE();
    case 76:
      if (lookahead == 'l')
        ADVANCE(77);
      END_STATE();
    case 77:
      if (lookahead == 'l')
        ADVANCE(78);
      END_STATE();
    case 78:
      if (lookahead == 'y')
        ADVANCE(79);
      END_STATE();
    case 79:
      ACCEPT_TOKEN(anon_sym_finally);
      END_STATE();
    case 80:
      if (lookahead == 'r')
        ADVANCE(81);
      END_STATE();
    case 81:
      ACCEPT_TOKEN(anon_sym_for);
      END_STATE();
    case 82:
      if (lookahead == 'o')
        ADVANCE(83);
      END_STATE();
    case 83:
      if (lookahead == 'm')
        ADVANCE(84);
      END_STATE();
    case 84:
      ACCEPT_TOKEN(anon_sym_from);
      END_STATE();
    case 85:
      if (lookahead == 'l')
        ADVANCE(86);
      END_STATE();
    case 86:
      if (lookahead == 'o')
        ADVANCE(87);
      END_STATE();
    case 87:
      if (lookahead == 'b')
        ADVANCE(88);
      END_STATE();
    case 88:
      if (lookahead == 'a')
        ADVANCE(89);
      END_STATE();
    case 89:
      if (lookahead == 'l')
        ADVANCE(90);
      END_STATE();
    case 90:
      ACCEPT_TOKEN(anon_sym_global);
      END_STATE();
    case 91:
      if (lookahead == 'f')
        ADVANCE(92);
      if (lookahead == 'm')
        ADVANCE(93);
      if (lookahead == 'n')
        ADVANCE(98);
      if (lookahead == 's')
        ADVANCE(99);
      END_STATE();
    case 92:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 93:
      if (lookahead == 'p')
        ADVANCE(94);
      END_STATE();
    case 94:
      if (lookahead == 'o')
        ADVANCE(95);
      END_STATE();
    case 95:
      if (lookahead == 'r')
        ADVANCE(96);
      END_STATE();
    case 96:
      if (lookahead == 't')
        ADVANCE(97);
      END_STATE();
    case 97:
      ACCEPT_TOKEN(anon_sym_import);
      END_STATE();
    case 98:
      ACCEPT_TOKEN(anon_sym_in);
      END_STATE();
    case 99:
      ACCEPT_TOKEN(anon_sym_is);
      END_STATE();
    case 100:
      if (lookahead == 'a')
        ADVANCE(101);
      END_STATE();
    case 101:
      if (lookahead == 'm')
        ADVANCE(102);
      END_STATE();
    case 102:
      if (lookahead == 'b')
        ADVANCE(103);
      END_STATE();
    case 103:
      if (lookahead == 'd')
        ADVANCE(104);
      END_STATE();
    case 104:
      if (lookahead == 'a')
        ADVANCE(105);
      END_STATE();
    case 105:
      ACCEPT_TOKEN(anon_sym_lambda);
      END_STATE();
    case 106:
      if (lookahead == 'o')
        ADVANCE(107);
      END_STATE();
    case 107:
      if (lookahead == 'n')
        ADVANCE(108);
      if (lookahead == 't')
        ADVANCE(114);
      END_STATE();
    case 108:
      if (lookahead == 'l')
        ADVANCE(109);
      END_STATE();
    case 109:
      if (lookahead == 'o')
        ADVANCE(110);
      END_STATE();
    case 110:
      if (lookahead == 'c')
        ADVANCE(111);
      END_STATE();
    case 111:
      if (lookahead == 'a')
        ADVANCE(112);
      END_STATE();
    case 112:
      if (lookahead == 'l')
        ADVANCE(113);
      END_STATE();
    case 113:
      ACCEPT_TOKEN(anon_sym_nonlocal);
      END_STATE();
    case 114:
      ACCEPT_TOKEN(anon_sym_not);
      END_STATE();
    case 115:
      if (lookahead == 'r')
        ADVANCE(116);
      END_STATE();
    case 116:
      ACCEPT_TOKEN(anon_sym_or);
      END_STATE();
    case 117:
      if (lookahead == 'a')
        ADVANCE(118);
      if (lookahead == 'r')
        ADVANCE(121);
      END_STATE();
    case 118:
      if (lookahead == 's')
        ADVANCE(119);
      END_STATE();
    case 119:
      if (lookahead == 's')
        ADVANCE(120);
      END_STATE();
    case 120:
      ACCEPT_TOKEN(anon_sym_pass);
      END_STATE();
    case 121:
      if (lookahead == 'i')
        ADVANCE(122);
      END_STATE();
    case 122:
      if (lookahead == 'n')
        ADVANCE(123);
      END_STATE();
    case 123:
      if (lookahead == 't')
        ADVANCE(124);
      END_STATE();
    case 124:
      ACCEPT_TOKEN(anon_sym_print);
      END_STATE();
    case 125:
      if (lookahead == 'a')
        ADVANCE(126);
      if (lookahead == 'e')
        ADVANCE(130);
      END_STATE();
    case 126:
      if (lookahead == 'i')
        ADVANCE(127);
      END_STATE();
    case 127:
      if (lookahead == 's')
        ADVANCE(128);
      END_STATE();
    case 128:
      if (lookahead == 'e')
        ADVANCE(129);
      END_STATE();
    case 129:
      ACCEPT_TOKEN(anon_sym_raise);
      END_STATE();
    case 130:
      if (lookahead == 't')
        ADVANCE(131);
      END_STATE();
    case 131:
      if (lookahead == 'u')
        ADVANCE(132);
      END_STATE();
    case 132:
      if (lookahead == 'r')
        ADVANCE(133);
      END_STATE();
    case 133:
      if (lookahead == 'n')
        ADVANCE(134);
      END_STATE();
    case 134:
      ACCEPT_TOKEN(anon_sym_return);
      END_STATE();
    case 135:
      if (lookahead == 'r')
        ADVANCE(136);
      END_STATE();
    case 136:
      if (lookahead == 'y')
        ADVANCE(137);
      END_STATE();
    case 137:
      ACCEPT_TOKEN(anon_sym_try);
      END_STATE();
    case 138:
      if (lookahead == 'h')
        ADVANCE(139);
      if (lookahead == 'i')
        ADVANCE(143);
      END_STATE();
    case 139:
      if (lookahead == 'i')
        ADVANCE(140);
      END_STATE();
    case 140:
      if (lookahead == 'l')
        ADVANCE(141);
      END_STATE();
    case 141:
      if (lookahead == 'e')
        ADVANCE(142);
      END_STATE();
    case 142:
      ACCEPT_TOKEN(anon_sym_while);
      END_STATE();
    case 143:
      if (lookahead == 't')
        ADVANCE(144);
      END_STATE();
    case 144:
      if (lookahead == 'h')
        ADVANCE(145);
      END_STATE();
    case 145:
      ACCEPT_TOKEN(anon_sym_with);
      END_STATE();
    case 146:
      if (lookahead == 'i')
        ADVANCE(147);
      END_STATE();
    case 147:
      if (lookahead == 'e')
        ADVANCE(148);
      END_STATE();
    case 148:
      if (lookahead == 'l')
        ADVANCE(149);
      END_STATE();
    case 149:
      if (lookahead == 'd')
        ADVANCE(150);
      END_STATE();
    case 150:
      ACCEPT_TOKEN(anon_sym_yield);
      END_STATE();
    default:
      return false;
  }
}

static TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 81, .external_lex_state = 2},
  [2] = {.lex_state = 88, .external_lex_state = 3},
  [3] = {.lex_state = 103},
  [4] = {.lex_state = 103},
  [5] = {.lex_state = 107, .external_lex_state = 2},
  [6] = {.lex_state = 110, .external_lex_state = 4},
  [7] = {.lex_state = 115, .external_lex_state = 2},
  [8] = {.lex_state = 118, .external_lex_state = 4},
  [9] = {.lex_state = 115, .external_lex_state = 2},
  [10] = {.lex_state = 118, .external_lex_state = 4},
  [11] = {.lex_state = 103, .external_lex_state = 5},
  [12] = {.lex_state = 103, .external_lex_state = 5},
  [13] = {.lex_state = 103, .external_lex_state = 5},
  [14] = {.lex_state = 115, .external_lex_state = 2},
  [15] = {.lex_state = 103},
  [16] = {.lex_state = 115, .external_lex_state = 2},
  [17] = {.lex_state = 115, .external_lex_state = 2},
  [18] = {.lex_state = 110},
  [19] = {.lex_state = 115, .external_lex_state = 2},
  [20] = {.lex_state = 103},
  [21] = {.lex_state = 103},
  [22] = {.lex_state = 103},
  [23] = {.lex_state = 121, .external_lex_state = 4},
  [24] = {.lex_state = 103},
  [25] = {.lex_state = 103},
  [26] = {.lex_state = 115, .external_lex_state = 2},
  [27] = {.lex_state = 115, .external_lex_state = 2},
  [28] = {.lex_state = 124},
  [29] = {.lex_state = 118, .external_lex_state = 4},
  [30] = {.lex_state = 130, .external_lex_state = 2},
  [31] = {.lex_state = 133, .external_lex_state = 2},
  [32] = {.lex_state = 115, .external_lex_state = 2},
  [33] = {.lex_state = 136},
  [34] = {.lex_state = 103, .external_lex_state = 5},
  [35] = {.lex_state = 110},
  [36] = {.lex_state = 139, .external_lex_state = 5},
  [37] = {.lex_state = 121, .external_lex_state = 5},
  [38] = {.lex_state = 103, .external_lex_state = 5},
  [39] = {.lex_state = 121, .external_lex_state = 4},
  [40] = {.lex_state = 81, .external_lex_state = 2},
  [41] = {.lex_state = 103},
  [42] = {.lex_state = 121, .external_lex_state = 4},
  [43] = {.lex_state = 115, .external_lex_state = 2},
  [44] = {.lex_state = 88, .external_lex_state = 3},
  [45] = {.lex_state = 158, .external_lex_state = 5},
  [46] = {.lex_state = 103, .external_lex_state = 5},
  [47] = {.lex_state = 158, .external_lex_state = 5},
  [48] = {.lex_state = 158, .external_lex_state = 5},
  [49] = {.lex_state = 103},
  [50] = {.lex_state = 103},
  [51] = {.lex_state = 103},
  [52] = {.lex_state = 103},
  [53] = {.lex_state = 103},
  [54] = {.lex_state = 88, .external_lex_state = 3},
  [55] = {.lex_state = 107, .external_lex_state = 2},
  [56] = {.lex_state = 121, .external_lex_state = 5},
  [57] = {.lex_state = 107},
  [58] = {.lex_state = 161},
  [59] = {.lex_state = 115, .external_lex_state = 2},
  [60] = {.lex_state = 115, .external_lex_state = 2},
  [61] = {.lex_state = 124},
  [62] = {.lex_state = 107, .external_lex_state = 2},
  [63] = {.lex_state = 130, .external_lex_state = 2},
  [64] = {.lex_state = 133, .external_lex_state = 2},
  [65] = {.lex_state = 115, .external_lex_state = 2},
  [66] = {.lex_state = 124},
  [67] = {.lex_state = 176},
  [68] = {.lex_state = 107},
  [69] = {.lex_state = 176, .external_lex_state = 2},
  [70] = {.lex_state = 88, .external_lex_state = 3},
  [71] = {.lex_state = 107, .external_lex_state = 2},
  [72] = {.lex_state = 180, .external_lex_state = 5},
  [73] = {.lex_state = 115, .external_lex_state = 2},
  [74] = {.lex_state = 115, .external_lex_state = 2},
  [75] = {.lex_state = 115, .external_lex_state = 2},
  [76] = {.lex_state = 124},
  [77] = {.lex_state = 130, .external_lex_state = 2},
  [78] = {.lex_state = 133, .external_lex_state = 2},
  [79] = {.lex_state = 115, .external_lex_state = 2},
  [80] = {.lex_state = 158, .external_lex_state = 5},
  [81] = {.lex_state = 158, .external_lex_state = 5},
  [82] = {.lex_state = 183, .external_lex_state = 5},
  [83] = {.lex_state = 183, .external_lex_state = 4},
  [84] = {.lex_state = 158, .external_lex_state = 5},
  [85] = {.lex_state = 103, .external_lex_state = 5},
  [86] = {.lex_state = 158, .external_lex_state = 5},
  [87] = {.lex_state = 103, .external_lex_state = 5},
  [88] = {.lex_state = 115, .external_lex_state = 2},
  [89] = {.lex_state = 115, .external_lex_state = 2},
  [90] = {.lex_state = 115, .external_lex_state = 2},
  [91] = {.lex_state = 124},
  [92] = {.lex_state = 115, .external_lex_state = 2},
  [93] = {.lex_state = 103, .external_lex_state = 5},
  [94] = {.lex_state = 158, .external_lex_state = 5},
  [95] = {.lex_state = 183, .external_lex_state = 5},
  [96] = {.lex_state = 183, .external_lex_state = 4},
  [97] = {.lex_state = 115, .external_lex_state = 2},
  [98] = {.lex_state = 115, .external_lex_state = 2},
  [99] = {.lex_state = 124},
  [100] = {.lex_state = 115, .external_lex_state = 2},
  [101] = {.lex_state = 121},
  [102] = {.lex_state = 186},
  [103] = {.lex_state = 186, .external_lex_state = 2},
  [104] = {.lex_state = 115, .external_lex_state = 2},
  [105] = {.lex_state = 115, .external_lex_state = 2},
  [106] = {.lex_state = 103},
  [107] = {.lex_state = 115, .external_lex_state = 2},
  [108] = {.lex_state = 103},
  [109] = {.lex_state = 176},
  [110] = {.lex_state = 189, .external_lex_state = 2},
  [111] = {.lex_state = 121},
  [112] = {.lex_state = 115, .external_lex_state = 6},
  [113] = {.lex_state = 115, .external_lex_state = 2},
  [114] = {.lex_state = 115, .external_lex_state = 2},
  [115] = {.lex_state = 124},
  [116] = {.lex_state = 115, .external_lex_state = 2},
  [117] = {.lex_state = 110},
  [118] = {.lex_state = 121},
  [119] = {.lex_state = 194},
  [120] = {.lex_state = 194, .external_lex_state = 2},
  [121] = {.lex_state = 81},
  [122] = {.lex_state = 158, .external_lex_state = 5},
  [123] = {.lex_state = 158, .external_lex_state = 5},
  [124] = {.lex_state = 88, .external_lex_state = 3},
  [125] = {.lex_state = 103, .external_lex_state = 5},
  [126] = {.lex_state = 110},
  [127] = {.lex_state = 197, .external_lex_state = 5},
  [128] = {.lex_state = 81, .external_lex_state = 5},
  [129] = {.lex_state = 121, .external_lex_state = 5},
  [130] = {.lex_state = 139, .external_lex_state = 5},
  [131] = {.lex_state = 121, .external_lex_state = 5},
  [132] = {.lex_state = 107, .external_lex_state = 2},
  [133] = {.lex_state = 200, .external_lex_state = 2},
  [134] = {.lex_state = 110},
  [135] = {.lex_state = 115, .external_lex_state = 2},
  [136] = {.lex_state = 110},
  [137] = {.lex_state = 110},
  [138] = {.lex_state = 110},
  [139] = {.lex_state = 110},
  [140] = {.lex_state = 110},
  [141] = {.lex_state = 115, .external_lex_state = 2},
  [142] = {.lex_state = 103, .external_lex_state = 5},
  [143] = {.lex_state = 130},
  [144] = {.lex_state = 203, .external_lex_state = 2},
  [145] = {.lex_state = 115, .external_lex_state = 2},
  [146] = {.lex_state = 115, .external_lex_state = 2},
  [147] = {.lex_state = 124},
  [148] = {.lex_state = 121, .external_lex_state = 5},
  [149] = {.lex_state = 115, .external_lex_state = 2},
  [150] = {.lex_state = 130},
  [151] = {.lex_state = 206},
  [152] = {.lex_state = 206},
  [153] = {.lex_state = 206, .external_lex_state = 2},
  [154] = {.lex_state = 133},
  [155] = {.lex_state = 133, .external_lex_state = 2},
  [156] = {.lex_state = 115, .external_lex_state = 2},
  [157] = {.lex_state = 115, .external_lex_state = 2},
  [158] = {.lex_state = 124},
  [159] = {.lex_state = 121, .external_lex_state = 5},
  [160] = {.lex_state = 115, .external_lex_state = 2},
  [161] = {.lex_state = 133},
  [162] = {.lex_state = 133},
  [163] = {.lex_state = 209},
  [164] = {.lex_state = 209},
  [165] = {.lex_state = 209},
  [166] = {.lex_state = 209, .external_lex_state = 2},
  [167] = {.lex_state = 139, .external_lex_state = 5},
  [168] = {.lex_state = 81, .external_lex_state = 2},
  [169] = {.lex_state = 115, .external_lex_state = 4},
  [170] = {.lex_state = 103, .external_lex_state = 5},
  [171] = {.lex_state = 115, .external_lex_state = 2},
  [172] = {.lex_state = 115, .external_lex_state = 2},
  [173] = {.lex_state = 115, .external_lex_state = 2},
  [174] = {.lex_state = 212, .external_lex_state = 4},
  [175] = {.lex_state = 115, .external_lex_state = 2},
  [176] = {.lex_state = 115, .external_lex_state = 2},
  [177] = {.lex_state = 115, .external_lex_state = 2},
  [178] = {.lex_state = 139, .external_lex_state = 5},
  [179] = {.lex_state = 103},
  [180] = {.lex_state = 215, .external_lex_state = 2},
  [181] = {.lex_state = 115, .external_lex_state = 2},
  [182] = {.lex_state = 115, .external_lex_state = 2},
  [183] = {.lex_state = 115, .external_lex_state = 2},
  [184] = {.lex_state = 103},
  [185] = {.lex_state = 115, .external_lex_state = 2},
  [186] = {.lex_state = 115, .external_lex_state = 2},
  [187] = {.lex_state = 115, .external_lex_state = 2},
  [188] = {.lex_state = 115, .external_lex_state = 2},
  [189] = {.lex_state = 115, .external_lex_state = 2},
  [190] = {.lex_state = 115, .external_lex_state = 2},
  [191] = {.lex_state = 218, .external_lex_state = 2},
  [192] = {.lex_state = 121, .external_lex_state = 5},
  [193] = {.lex_state = 221, .external_lex_state = 5},
  [194] = {.lex_state = 121, .external_lex_state = 4},
  [195] = {.lex_state = 81, .external_lex_state = 2},
  [196] = {.lex_state = 103},
  [197] = {.lex_state = 81, .external_lex_state = 2},
  [198] = {.lex_state = 103},
  [199] = {.lex_state = 115, .external_lex_state = 2},
  [200] = {.lex_state = 115, .external_lex_state = 2},
  [201] = {.lex_state = 124},
  [202] = {.lex_state = 115, .external_lex_state = 2},
  [203] = {.lex_state = 226},
  [204] = {.lex_state = 226},
  [205] = {.lex_state = 226, .external_lex_state = 2},
  [206] = {.lex_state = 121, .external_lex_state = 4},
  [207] = {.lex_state = 88, .external_lex_state = 3},
  [208] = {.lex_state = 103},
  [209] = {.lex_state = 158, .external_lex_state = 5},
  [210] = {.lex_state = 103, .external_lex_state = 5},
  [211] = {.lex_state = 158, .external_lex_state = 5},
  [212] = {.lex_state = 103},
  [213] = {.lex_state = 103},
  [214] = {.lex_state = 103},
  [215] = {.lex_state = 103},
  [216] = {.lex_state = 103},
  [217] = {.lex_state = 124},
  [218] = {.lex_state = 103},
  [219] = {.lex_state = 161, .external_lex_state = 2},
  [220] = {.lex_state = 88, .external_lex_state = 3},
  [221] = {.lex_state = 161},
  [222] = {.lex_state = 107},
  [223] = {.lex_state = 124},
  [224] = {.lex_state = 107},
  [225] = {.lex_state = 121, .external_lex_state = 5},
  [226] = {.lex_state = 124},
  [227] = {.lex_state = 161},
  [228] = {.lex_state = 115, .external_lex_state = 2},
  [229] = {.lex_state = 110},
  [230] = {.lex_state = 115, .external_lex_state = 2},
  [231] = {.lex_state = 115, .external_lex_state = 2},
  [232] = {.lex_state = 115, .external_lex_state = 2},
  [233] = {.lex_state = 124},
  [234] = {.lex_state = 115, .external_lex_state = 2},
  [235] = {.lex_state = 107},
  [236] = {.lex_state = 124},
  [237] = {.lex_state = 176},
  [238] = {.lex_state = 176, .external_lex_state = 2},
  [239] = {.lex_state = 130},
  [240] = {.lex_state = 161},
  [241] = {.lex_state = 130},
  [242] = {.lex_state = 206},
  [243] = {.lex_state = 133},
  [244] = {.lex_state = 161},
  [245] = {.lex_state = 133},
  [246] = {.lex_state = 133},
  [247] = {.lex_state = 209},
  [248] = {.lex_state = 209},
  [249] = {.lex_state = 161},
  [250] = {.lex_state = 121, .external_lex_state = 5},
  [251] = {.lex_state = 229, .external_lex_state = 2},
  [252] = {.lex_state = 115, .external_lex_state = 2},
  [253] = {.lex_state = 103},
  [254] = {.lex_state = 115, .external_lex_state = 2},
  [255] = {.lex_state = 115, .external_lex_state = 2},
  [256] = {.lex_state = 115, .external_lex_state = 2},
  [257] = {.lex_state = 107},
  [258] = {.lex_state = 124},
  [259] = {.lex_state = 107},
  [260] = {.lex_state = 103},
  [261] = {.lex_state = 215, .external_lex_state = 2},
  [262] = {.lex_state = 115, .external_lex_state = 2},
  [263] = {.lex_state = 115, .external_lex_state = 2},
  [264] = {.lex_state = 115, .external_lex_state = 2},
  [265] = {.lex_state = 103},
  [266] = {.lex_state = 115, .external_lex_state = 2},
  [267] = {.lex_state = 115, .external_lex_state = 2},
  [268] = {.lex_state = 115, .external_lex_state = 2},
  [269] = {.lex_state = 115, .external_lex_state = 2},
  [270] = {.lex_state = 115, .external_lex_state = 2},
  [271] = {.lex_state = 115, .external_lex_state = 2},
  [272] = {.lex_state = 218, .external_lex_state = 2},
  [273] = {.lex_state = 161},
  [274] = {.lex_state = 124},
  [275] = {.lex_state = 176, .external_lex_state = 2},
  [276] = {.lex_state = 180, .external_lex_state = 4},
  [277] = {.lex_state = 88, .external_lex_state = 3},
  [278] = {.lex_state = 180, .external_lex_state = 5},
  [279] = {.lex_state = 107},
  [280] = {.lex_state = 124},
  [281] = {.lex_state = 107},
  [282] = {.lex_state = 158, .external_lex_state = 5},
  [283] = {.lex_state = 158, .external_lex_state = 5},
  [284] = {.lex_state = 180, .external_lex_state = 5},
  [285] = {.lex_state = 115, .external_lex_state = 2},
  [286] = {.lex_state = 110},
  [287] = {.lex_state = 130},
  [288] = {.lex_state = 180, .external_lex_state = 5},
  [289] = {.lex_state = 130},
  [290] = {.lex_state = 206},
  [291] = {.lex_state = 133},
  [292] = {.lex_state = 180, .external_lex_state = 5},
  [293] = {.lex_state = 133},
  [294] = {.lex_state = 133},
  [295] = {.lex_state = 209},
  [296] = {.lex_state = 209},
  [297] = {.lex_state = 118, .external_lex_state = 4},
  [298] = {.lex_state = 158, .external_lex_state = 5},
  [299] = {.lex_state = 115, .external_lex_state = 2},
  [300] = {.lex_state = 115, .external_lex_state = 2},
  [301] = {.lex_state = 115, .external_lex_state = 2},
  [302] = {.lex_state = 103},
  [303] = {.lex_state = 215, .external_lex_state = 2},
  [304] = {.lex_state = 115, .external_lex_state = 2},
  [305] = {.lex_state = 115, .external_lex_state = 2},
  [306] = {.lex_state = 115, .external_lex_state = 2},
  [307] = {.lex_state = 103},
  [308] = {.lex_state = 115, .external_lex_state = 2},
  [309] = {.lex_state = 115, .external_lex_state = 2},
  [310] = {.lex_state = 115, .external_lex_state = 2},
  [311] = {.lex_state = 115, .external_lex_state = 2},
  [312] = {.lex_state = 115, .external_lex_state = 2},
  [313] = {.lex_state = 115, .external_lex_state = 2},
  [314] = {.lex_state = 218, .external_lex_state = 2},
  [315] = {.lex_state = 180, .external_lex_state = 5},
  [316] = {.lex_state = 232, .external_lex_state = 5},
  [317] = {.lex_state = 183, .external_lex_state = 4},
  [318] = {.lex_state = 115, .external_lex_state = 2},
  [319] = {.lex_state = 158, .external_lex_state = 5},
  [320] = {.lex_state = 118, .external_lex_state = 4},
  [321] = {.lex_state = 158, .external_lex_state = 5},
  [322] = {.lex_state = 115, .external_lex_state = 2},
  [323] = {.lex_state = 115, .external_lex_state = 2},
  [324] = {.lex_state = 124},
  [325] = {.lex_state = 115, .external_lex_state = 2},
  [326] = {.lex_state = 103, .external_lex_state = 5},
  [327] = {.lex_state = 235, .external_lex_state = 5},
  [328] = {.lex_state = 235, .external_lex_state = 4},
  [329] = {.lex_state = 158, .external_lex_state = 5},
  [330] = {.lex_state = 115, .external_lex_state = 2},
  [331] = {.lex_state = 110},
  [332] = {.lex_state = 115, .external_lex_state = 2},
  [333] = {.lex_state = 118, .external_lex_state = 4},
  [334] = {.lex_state = 115, .external_lex_state = 2},
  [335] = {.lex_state = 115, .external_lex_state = 2},
  [336] = {.lex_state = 115, .external_lex_state = 2},
  [337] = {.lex_state = 158, .external_lex_state = 5},
  [338] = {.lex_state = 115, .external_lex_state = 2},
  [339] = {.lex_state = 115, .external_lex_state = 2},
  [340] = {.lex_state = 115, .external_lex_state = 2},
  [341] = {.lex_state = 103},
  [342] = {.lex_state = 115, .external_lex_state = 2},
  [343] = {.lex_state = 115, .external_lex_state = 2},
  [344] = {.lex_state = 115, .external_lex_state = 2},
  [345] = {.lex_state = 115, .external_lex_state = 2},
  [346] = {.lex_state = 115, .external_lex_state = 2},
  [347] = {.lex_state = 115, .external_lex_state = 2},
  [348] = {.lex_state = 232, .external_lex_state = 5},
  [349] = {.lex_state = 183, .external_lex_state = 4},
  [350] = {.lex_state = 121},
  [351] = {.lex_state = 115, .external_lex_state = 2},
  [352] = {.lex_state = 110},
  [353] = {.lex_state = 115, .external_lex_state = 2},
  [354] = {.lex_state = 115, .external_lex_state = 6},
  [355] = {.lex_state = 115, .external_lex_state = 2},
  [356] = {.lex_state = 115, .external_lex_state = 2},
  [357] = {.lex_state = 115, .external_lex_state = 2},
  [358] = {.lex_state = 115, .external_lex_state = 2},
  [359] = {.lex_state = 115, .external_lex_state = 2},
  [360] = {.lex_state = 103},
  [361] = {.lex_state = 115, .external_lex_state = 2},
  [362] = {.lex_state = 115, .external_lex_state = 2},
  [363] = {.lex_state = 115, .external_lex_state = 2},
  [364] = {.lex_state = 115, .external_lex_state = 2},
  [365] = {.lex_state = 115, .external_lex_state = 2},
  [366] = {.lex_state = 115, .external_lex_state = 2},
  [367] = {.lex_state = 121},
  [368] = {.lex_state = 186, .external_lex_state = 2},
  [369] = {.lex_state = 103},
  [370] = {.lex_state = 110},
  [371] = {.lex_state = 81},
  [372] = {.lex_state = 115, .external_lex_state = 2},
  [373] = {.lex_state = 115, .external_lex_state = 2},
  [374] = {.lex_state = 115, .external_lex_state = 2},
  [375] = {.lex_state = 115, .external_lex_state = 2},
  [376] = {.lex_state = 115, .external_lex_state = 2},
  [377] = {.lex_state = 115, .external_lex_state = 2},
  [378] = {.lex_state = 115, .external_lex_state = 2},
  [379] = {.lex_state = 115, .external_lex_state = 2},
  [380] = {.lex_state = 115, .external_lex_state = 2},
  [381] = {.lex_state = 121},
  [382] = {.lex_state = 189, .external_lex_state = 2},
  [383] = {.lex_state = 115, .external_lex_state = 6},
  [384] = {.lex_state = 81, .external_lex_state = 7},
  [385] = {.lex_state = 103, .external_lex_state = 5},
  [386] = {.lex_state = 103},
  [387] = {.lex_state = 121},
  [388] = {.lex_state = 115, .external_lex_state = 2},
  [389] = {.lex_state = 110},
  [390] = {.lex_state = 115, .external_lex_state = 2},
  [391] = {.lex_state = 115, .external_lex_state = 6},
  [392] = {.lex_state = 110},
  [393] = {.lex_state = 115, .external_lex_state = 2},
  [394] = {.lex_state = 115, .external_lex_state = 2},
  [395] = {.lex_state = 115, .external_lex_state = 2},
  [396] = {.lex_state = 115, .external_lex_state = 2},
  [397] = {.lex_state = 115, .external_lex_state = 2},
  [398] = {.lex_state = 115, .external_lex_state = 2},
  [399] = {.lex_state = 115, .external_lex_state = 2},
  [400] = {.lex_state = 103},
  [401] = {.lex_state = 115, .external_lex_state = 2},
  [402] = {.lex_state = 115, .external_lex_state = 2},
  [403] = {.lex_state = 115, .external_lex_state = 2},
  [404] = {.lex_state = 115, .external_lex_state = 2},
  [405] = {.lex_state = 115, .external_lex_state = 2},
  [406] = {.lex_state = 115, .external_lex_state = 2},
  [407] = {.lex_state = 121},
  [408] = {.lex_state = 194, .external_lex_state = 2},
  [409] = {.lex_state = 124},
  [410] = {.lex_state = 238},
  [411] = {.lex_state = 103},
  [412] = {.lex_state = 158, .external_lex_state = 5},
  [413] = {.lex_state = 158, .external_lex_state = 5},
  [414] = {.lex_state = 103, .external_lex_state = 5},
  [415] = {.lex_state = 88, .external_lex_state = 3},
  [416] = {.lex_state = 115, .external_lex_state = 2},
  [417] = {.lex_state = 215, .external_lex_state = 2},
  [418] = {.lex_state = 115, .external_lex_state = 6},
  [419] = {.lex_state = 110},
  [420] = {.lex_state = 197, .external_lex_state = 5},
  [421] = {.lex_state = 103},
  [422] = {.lex_state = 215, .external_lex_state = 2},
  [423] = {.lex_state = 81, .external_lex_state = 5},
  [424] = {.lex_state = 124},
  [425] = {.lex_state = 107},
  [426] = {.lex_state = 115, .external_lex_state = 2},
  [427] = {.lex_state = 115, .external_lex_state = 2},
  [428] = {.lex_state = 115, .external_lex_state = 2},
  [429] = {.lex_state = 124},
  [430] = {.lex_state = 115, .external_lex_state = 2},
  [431] = {.lex_state = 121},
  [432] = {.lex_state = 194},
  [433] = {.lex_state = 194, .external_lex_state = 2},
  [434] = {.lex_state = 124},
  [435] = {.lex_state = 115, .external_lex_state = 2},
  [436] = {.lex_state = 115, .external_lex_state = 2},
  [437] = {.lex_state = 110},
  [438] = {.lex_state = 139, .external_lex_state = 5},
  [439] = {.lex_state = 124},
  [440] = {.lex_state = 115, .external_lex_state = 2},
  [441] = {.lex_state = 115, .external_lex_state = 2},
  [442] = {.lex_state = 110},
  [443] = {.lex_state = 115, .external_lex_state = 2},
  [444] = {.lex_state = 115, .external_lex_state = 2},
  [445] = {.lex_state = 103, .external_lex_state = 5},
  [446] = {.lex_state = 121, .external_lex_state = 5},
  [447] = {.lex_state = 115, .external_lex_state = 2},
  [448] = {.lex_state = 115, .external_lex_state = 2},
  [449] = {.lex_state = 124},
  [450] = {.lex_state = 115, .external_lex_state = 2},
  [451] = {.lex_state = 206},
  [452] = {.lex_state = 206},
  [453] = {.lex_state = 206, .external_lex_state = 2},
  [454] = {.lex_state = 206},
  [455] = {.lex_state = 115, .external_lex_state = 2},
  [456] = {.lex_state = 110},
  [457] = {.lex_state = 242, .external_lex_state = 2},
  [458] = {.lex_state = 130},
  [459] = {.lex_state = 115, .external_lex_state = 2},
  [460] = {.lex_state = 103},
  [461] = {.lex_state = 115, .external_lex_state = 2},
  [462] = {.lex_state = 115, .external_lex_state = 2},
  [463] = {.lex_state = 115, .external_lex_state = 2},
  [464] = {.lex_state = 130},
  [465] = {.lex_state = 206},
  [466] = {.lex_state = 115, .external_lex_state = 2},
  [467] = {.lex_state = 115, .external_lex_state = 2},
  [468] = {.lex_state = 115, .external_lex_state = 2},
  [469] = {.lex_state = 103},
  [470] = {.lex_state = 115, .external_lex_state = 2},
  [471] = {.lex_state = 115, .external_lex_state = 2},
  [472] = {.lex_state = 115, .external_lex_state = 2},
  [473] = {.lex_state = 115, .external_lex_state = 2},
  [474] = {.lex_state = 115, .external_lex_state = 2},
  [475] = {.lex_state = 115, .external_lex_state = 2},
  [476] = {.lex_state = 206},
  [477] = {.lex_state = 206, .external_lex_state = 2},
  [478] = {.lex_state = 121, .external_lex_state = 5},
  [479] = {.lex_state = 115, .external_lex_state = 2},
  [480] = {.lex_state = 115, .external_lex_state = 2},
  [481] = {.lex_state = 115, .external_lex_state = 2},
  [482] = {.lex_state = 124},
  [483] = {.lex_state = 115, .external_lex_state = 2},
  [484] = {.lex_state = 209},
  [485] = {.lex_state = 209},
  [486] = {.lex_state = 245, .external_lex_state = 2},
  [487] = {.lex_state = 209},
  [488] = {.lex_state = 115, .external_lex_state = 2},
  [489] = {.lex_state = 110},
  [490] = {.lex_state = 248, .external_lex_state = 2},
  [491] = {.lex_state = 121, .external_lex_state = 5},
  [492] = {.lex_state = 133},
  [493] = {.lex_state = 248, .external_lex_state = 2},
  [494] = {.lex_state = 133},
  [495] = {.lex_state = 115, .external_lex_state = 2},
  [496] = {.lex_state = 115, .external_lex_state = 2},
  [497] = {.lex_state = 103},
  [498] = {.lex_state = 115, .external_lex_state = 2},
  [499] = {.lex_state = 115, .external_lex_state = 2},
  [500] = {.lex_state = 115, .external_lex_state = 2},
  [501] = {.lex_state = 133},
  [502] = {.lex_state = 209},
  [503] = {.lex_state = 115, .external_lex_state = 2},
  [504] = {.lex_state = 115, .external_lex_state = 2},
  [505] = {.lex_state = 115, .external_lex_state = 2},
  [506] = {.lex_state = 103},
  [507] = {.lex_state = 115, .external_lex_state = 2},
  [508] = {.lex_state = 115, .external_lex_state = 2},
  [509] = {.lex_state = 115, .external_lex_state = 2},
  [510] = {.lex_state = 115, .external_lex_state = 2},
  [511] = {.lex_state = 115, .external_lex_state = 2},
  [512] = {.lex_state = 115, .external_lex_state = 2},
  [513] = {.lex_state = 209},
  [514] = {.lex_state = 133},
  [515] = {.lex_state = 209, .external_lex_state = 2},
  [516] = {.lex_state = 81, .external_lex_state = 2},
  [517] = {.lex_state = 103, .external_lex_state = 5},
  [518] = {.lex_state = 115, .external_lex_state = 4},
  [519] = {.lex_state = 103, .external_lex_state = 5},
  [520] = {.lex_state = 115, .external_lex_state = 2},
  [521] = {.lex_state = 115, .external_lex_state = 2},
  [522] = {.lex_state = 124},
  [523] = {.lex_state = 115, .external_lex_state = 2},
  [524] = {.lex_state = 251, .external_lex_state = 5},
  [525] = {.lex_state = 254, .external_lex_state = 5},
  [526] = {.lex_state = 251, .external_lex_state = 5},
  [527] = {.lex_state = 254, .external_lex_state = 4},
  [528] = {.lex_state = 212, .external_lex_state = 5},
  [529] = {.lex_state = 139, .external_lex_state = 5},
  [530] = {.lex_state = 103, .external_lex_state = 5},
  [531] = {.lex_state = 103, .external_lex_state = 5},
  [532] = {.lex_state = 139, .external_lex_state = 5},
  [533] = {.lex_state = 115, .external_lex_state = 2},
  [534] = {.lex_state = 115, .external_lex_state = 2},
  [535] = {.lex_state = 124},
  [536] = {.lex_state = 115, .external_lex_state = 2},
  [537] = {.lex_state = 103},
  [538] = {.lex_state = 176},
  [539] = {.lex_state = 257, .external_lex_state = 2},
  [540] = {.lex_state = 139, .external_lex_state = 5},
  [541] = {.lex_state = 139, .external_lex_state = 5},
  [542] = {.lex_state = 212, .external_lex_state = 4},
  [543] = {.lex_state = 139, .external_lex_state = 5},
  [544] = {.lex_state = 121, .external_lex_state = 5},
  [545] = {.lex_state = 121, .external_lex_state = 5},
  [546] = {.lex_state = 107},
  [547] = {.lex_state = 215, .external_lex_state = 2},
  [548] = {.lex_state = 260},
  [549] = {.lex_state = 260},
  [550] = {.lex_state = 107},
  [551] = {.lex_state = 124},
  [552] = {.lex_state = 121, .external_lex_state = 5},
  [553] = {.lex_state = 121, .external_lex_state = 5},
  [554] = {.lex_state = 121, .external_lex_state = 5},
  [555] = {.lex_state = 115, .external_lex_state = 2},
  [556] = {.lex_state = 121, .external_lex_state = 5},
  [557] = {.lex_state = 121, .external_lex_state = 5},
  [558] = {.lex_state = 121, .external_lex_state = 5},
  [559] = {.lex_state = 121, .external_lex_state = 5},
  [560] = {.lex_state = 121, .external_lex_state = 5},
  [561] = {.lex_state = 263, .external_lex_state = 2},
  [562] = {.lex_state = 115, .external_lex_state = 2},
  [563] = {.lex_state = 115, .external_lex_state = 2},
  [564] = {.lex_state = 124},
  [565] = {.lex_state = 115, .external_lex_state = 2},
  [566] = {.lex_state = 266},
  [567] = {.lex_state = 266},
  [568] = {.lex_state = 130},
  [569] = {.lex_state = 266, .external_lex_state = 2},
  [570] = {.lex_state = 221, .external_lex_state = 5},
  [571] = {.lex_state = 121, .external_lex_state = 4},
  [572] = {.lex_state = 226},
  [573] = {.lex_state = 115, .external_lex_state = 2},
  [574] = {.lex_state = 110},
  [575] = {.lex_state = 115, .external_lex_state = 2},
  [576] = {.lex_state = 115, .external_lex_state = 2},
  [577] = {.lex_state = 115, .external_lex_state = 2},
  [578] = {.lex_state = 88, .external_lex_state = 3},
  [579] = {.lex_state = 133},
  [580] = {.lex_state = 115, .external_lex_state = 2},
  [581] = {.lex_state = 115, .external_lex_state = 2},
  [582] = {.lex_state = 115, .external_lex_state = 2},
  [583] = {.lex_state = 103},
  [584] = {.lex_state = 115, .external_lex_state = 2},
  [585] = {.lex_state = 115, .external_lex_state = 2},
  [586] = {.lex_state = 115, .external_lex_state = 2},
  [587] = {.lex_state = 115, .external_lex_state = 2},
  [588] = {.lex_state = 115, .external_lex_state = 2},
  [589] = {.lex_state = 115, .external_lex_state = 2},
  [590] = {.lex_state = 226},
  [591] = {.lex_state = 226, .external_lex_state = 2},
  [592] = {.lex_state = 158, .external_lex_state = 5},
  [593] = {.lex_state = 158, .external_lex_state = 5},
  [594] = {.lex_state = 158, .external_lex_state = 5},
  [595] = {.lex_state = 158, .external_lex_state = 5},
  [596] = {.lex_state = 103, .external_lex_state = 5},
  [597] = {.lex_state = 158, .external_lex_state = 5},
  [598] = {.lex_state = 158, .external_lex_state = 5},
  [599] = {.lex_state = 103, .external_lex_state = 5},
  [600] = {.lex_state = 124},
  [601] = {.lex_state = 103},
  [602] = {.lex_state = 103},
  [603] = {.lex_state = 103, .external_lex_state = 5},
  [604] = {.lex_state = 103, .external_lex_state = 5},
  [605] = {.lex_state = 161, .external_lex_state = 2},
  [606] = {.lex_state = 161},
  [607] = {.lex_state = 161},
  [608] = {.lex_state = 229, .external_lex_state = 2},
  [609] = {.lex_state = 107},
  [610] = {.lex_state = 107},
  [611] = {.lex_state = 124},
  [612] = {.lex_state = 115, .external_lex_state = 2},
  [613] = {.lex_state = 124},
  [614] = {.lex_state = 124},
  [615] = {.lex_state = 115, .external_lex_state = 2},
  [616] = {.lex_state = 110},
  [617] = {.lex_state = 107, .external_lex_state = 2},
  [618] = {.lex_state = 115, .external_lex_state = 2},
  [619] = {.lex_state = 115, .external_lex_state = 2},
  [620] = {.lex_state = 115, .external_lex_state = 2},
  [621] = {.lex_state = 107},
  [622] = {.lex_state = 115, .external_lex_state = 2},
  [623] = {.lex_state = 115, .external_lex_state = 2},
  [624] = {.lex_state = 115, .external_lex_state = 2},
  [625] = {.lex_state = 103},
  [626] = {.lex_state = 115, .external_lex_state = 2},
  [627] = {.lex_state = 115, .external_lex_state = 2},
  [628] = {.lex_state = 115, .external_lex_state = 2},
  [629] = {.lex_state = 115, .external_lex_state = 2},
  [630] = {.lex_state = 115, .external_lex_state = 2},
  [631] = {.lex_state = 115, .external_lex_state = 2},
  [632] = {.lex_state = 124},
  [633] = {.lex_state = 176, .external_lex_state = 2},
  [634] = {.lex_state = 161},
  [635] = {.lex_state = 242, .external_lex_state = 2},
  [636] = {.lex_state = 130},
  [637] = {.lex_state = 130},
  [638] = {.lex_state = 161},
  [639] = {.lex_state = 248, .external_lex_state = 2},
  [640] = {.lex_state = 161},
  [641] = {.lex_state = 133},
  [642] = {.lex_state = 248, .external_lex_state = 2},
  [643] = {.lex_state = 133},
  [644] = {.lex_state = 133},
  [645] = {.lex_state = 133},
  [646] = {.lex_state = 121, .external_lex_state = 5},
  [647] = {.lex_state = 124},
  [648] = {.lex_state = 107},
  [649] = {.lex_state = 103},
  [650] = {.lex_state = 115, .external_lex_state = 2},
  [651] = {.lex_state = 103},
  [652] = {.lex_state = 161},
  [653] = {.lex_state = 124},
  [654] = {.lex_state = 121, .external_lex_state = 5},
  [655] = {.lex_state = 115, .external_lex_state = 2},
  [656] = {.lex_state = 124},
  [657] = {.lex_state = 229, .external_lex_state = 2},
  [658] = {.lex_state = 107},
  [659] = {.lex_state = 161},
  [660] = {.lex_state = 161},
  [661] = {.lex_state = 107},
  [662] = {.lex_state = 107},
  [663] = {.lex_state = 124},
  [664] = {.lex_state = 176},
  [665] = {.lex_state = 176},
  [666] = {.lex_state = 176},
  [667] = {.lex_state = 115, .external_lex_state = 2},
  [668] = {.lex_state = 176},
  [669] = {.lex_state = 161},
  [670] = {.lex_state = 176},
  [671] = {.lex_state = 176},
  [672] = {.lex_state = 176},
  [673] = {.lex_state = 266},
  [674] = {.lex_state = 130},
  [675] = {.lex_state = 124},
  [676] = {.lex_state = 176, .external_lex_state = 2},
  [677] = {.lex_state = 180, .external_lex_state = 4},
  [678] = {.lex_state = 180, .external_lex_state = 5},
  [679] = {.lex_state = 180, .external_lex_state = 5},
  [680] = {.lex_state = 229, .external_lex_state = 2},
  [681] = {.lex_state = 107},
  [682] = {.lex_state = 107},
  [683] = {.lex_state = 158, .external_lex_state = 5},
  [684] = {.lex_state = 115, .external_lex_state = 2},
  [685] = {.lex_state = 180, .external_lex_state = 5},
  [686] = {.lex_state = 242, .external_lex_state = 2},
  [687] = {.lex_state = 130},
  [688] = {.lex_state = 130},
  [689] = {.lex_state = 180, .external_lex_state = 5},
  [690] = {.lex_state = 248, .external_lex_state = 2},
  [691] = {.lex_state = 180, .external_lex_state = 5},
  [692] = {.lex_state = 133},
  [693] = {.lex_state = 248, .external_lex_state = 2},
  [694] = {.lex_state = 133},
  [695] = {.lex_state = 133},
  [696] = {.lex_state = 133},
  [697] = {.lex_state = 158, .external_lex_state = 5},
  [698] = {.lex_state = 118, .external_lex_state = 4},
  [699] = {.lex_state = 158, .external_lex_state = 5},
  [700] = {.lex_state = 103},
  [701] = {.lex_state = 158, .external_lex_state = 5},
  [702] = {.lex_state = 180, .external_lex_state = 5},
  [703] = {.lex_state = 180, .external_lex_state = 5},
  [704] = {.lex_state = 107},
  [705] = {.lex_state = 107},
  [706] = {.lex_state = 124},
  [707] = {.lex_state = 183, .external_lex_state = 5},
  [708] = {.lex_state = 183, .external_lex_state = 5},
  [709] = {.lex_state = 183, .external_lex_state = 5},
  [710] = {.lex_state = 115, .external_lex_state = 2},
  [711] = {.lex_state = 183, .external_lex_state = 5},
  [712] = {.lex_state = 180, .external_lex_state = 5},
  [713] = {.lex_state = 183, .external_lex_state = 5},
  [714] = {.lex_state = 183, .external_lex_state = 5},
  [715] = {.lex_state = 183, .external_lex_state = 5},
  [716] = {.lex_state = 266},
  [717] = {.lex_state = 130},
  [718] = {.lex_state = 232, .external_lex_state = 5},
  [719] = {.lex_state = 183, .external_lex_state = 4},
  [720] = {.lex_state = 118, .external_lex_state = 4},
  [721] = {.lex_state = 103, .external_lex_state = 5},
  [722] = {.lex_state = 115, .external_lex_state = 2},
  [723] = {.lex_state = 110},
  [724] = {.lex_state = 115, .external_lex_state = 2},
  [725] = {.lex_state = 115, .external_lex_state = 2},
  [726] = {.lex_state = 115, .external_lex_state = 2},
  [727] = {.lex_state = 115, .external_lex_state = 2},
  [728] = {.lex_state = 115, .external_lex_state = 2},
  [729] = {.lex_state = 115, .external_lex_state = 2},
  [730] = {.lex_state = 103},
  [731] = {.lex_state = 115, .external_lex_state = 2},
  [732] = {.lex_state = 115, .external_lex_state = 2},
  [733] = {.lex_state = 115, .external_lex_state = 2},
  [734] = {.lex_state = 115, .external_lex_state = 2},
  [735] = {.lex_state = 115, .external_lex_state = 2},
  [736] = {.lex_state = 115, .external_lex_state = 2},
  [737] = {.lex_state = 269, .external_lex_state = 5},
  [738] = {.lex_state = 235, .external_lex_state = 4},
  [739] = {.lex_state = 158, .external_lex_state = 5},
  [740] = {.lex_state = 115, .external_lex_state = 2},
  [741] = {.lex_state = 103, .external_lex_state = 5},
  [742] = {.lex_state = 158, .external_lex_state = 5},
  [743] = {.lex_state = 103},
  [744] = {.lex_state = 158, .external_lex_state = 5},
  [745] = {.lex_state = 118, .external_lex_state = 4},
  [746] = {.lex_state = 158, .external_lex_state = 5},
  [747] = {.lex_state = 183, .external_lex_state = 5},
  [748] = {.lex_state = 183, .external_lex_state = 5},
  [749] = {.lex_state = 183, .external_lex_state = 5},
  [750] = {.lex_state = 115, .external_lex_state = 2},
  [751] = {.lex_state = 183, .external_lex_state = 5},
  [752] = {.lex_state = 183, .external_lex_state = 5},
  [753] = {.lex_state = 183, .external_lex_state = 5},
  [754] = {.lex_state = 183, .external_lex_state = 5},
  [755] = {.lex_state = 232, .external_lex_state = 5},
  [756] = {.lex_state = 183, .external_lex_state = 4},
  [757] = {.lex_state = 121},
  [758] = {.lex_state = 115, .external_lex_state = 2},
  [759] = {.lex_state = 103},
  [760] = {.lex_state = 81, .external_lex_state = 7},
  [761] = {.lex_state = 81, .external_lex_state = 2},
  [762] = {.lex_state = 121},
  [763] = {.lex_state = 186},
  [764] = {.lex_state = 186},
  [765] = {.lex_state = 186},
  [766] = {.lex_state = 115, .external_lex_state = 2},
  [767] = {.lex_state = 186},
  [768] = {.lex_state = 186},
  [769] = {.lex_state = 186},
  [770] = {.lex_state = 186},
  [771] = {.lex_state = 121},
  [772] = {.lex_state = 186, .external_lex_state = 2},
  [773] = {.lex_state = 115, .external_lex_state = 2},
  [774] = {.lex_state = 115, .external_lex_state = 6},
  [775] = {.lex_state = 110},
  [776] = {.lex_state = 238},
  [777] = {.lex_state = 110},
  [778] = {.lex_state = 121},
  [779] = {.lex_state = 176},
  [780] = {.lex_state = 176},
  [781] = {.lex_state = 176},
  [782] = {.lex_state = 176},
  [783] = {.lex_state = 176},
  [784] = {.lex_state = 176},
  [785] = {.lex_state = 176},
  [786] = {.lex_state = 115, .external_lex_state = 2},
  [787] = {.lex_state = 121},
  [788] = {.lex_state = 189, .external_lex_state = 2},
  [789] = {.lex_state = 81, .external_lex_state = 2},
  [790] = {.lex_state = 103},
  [791] = {.lex_state = 115, .external_lex_state = 2},
  [792] = {.lex_state = 103},
  [793] = {.lex_state = 115, .external_lex_state = 2},
  [794] = {.lex_state = 115, .external_lex_state = 2},
  [795] = {.lex_state = 110},
  [796] = {.lex_state = 115, .external_lex_state = 2},
  [797] = {.lex_state = 103},
  [798] = {.lex_state = 103},
  [799] = {.lex_state = 103, .external_lex_state = 5},
  [800] = {.lex_state = 81, .external_lex_state = 7},
  [801] = {.lex_state = 103},
  [802] = {.lex_state = 103},
  [803] = {.lex_state = 115, .external_lex_state = 4},
  [804] = {.lex_state = 103, .external_lex_state = 5},
  [805] = {.lex_state = 218, .external_lex_state = 2},
  [806] = {.lex_state = 110},
  [807] = {.lex_state = 81, .external_lex_state = 2},
  [808] = {.lex_state = 81, .external_lex_state = 2},
  [809] = {.lex_state = 121},
  [810] = {.lex_state = 115, .external_lex_state = 2},
  [811] = {.lex_state = 110},
  [812] = {.lex_state = 81, .external_lex_state = 2},
  [813] = {.lex_state = 110},
  [814] = {.lex_state = 121},
  [815] = {.lex_state = 103},
  [816] = {.lex_state = 121},
  [817] = {.lex_state = 194},
  [818] = {.lex_state = 194},
  [819] = {.lex_state = 194},
  [820] = {.lex_state = 115, .external_lex_state = 2},
  [821] = {.lex_state = 194},
  [822] = {.lex_state = 194},
  [823] = {.lex_state = 194},
  [824] = {.lex_state = 194},
  [825] = {.lex_state = 121},
  [826] = {.lex_state = 194, .external_lex_state = 2},
  [827] = {.lex_state = 238},
  [828] = {.lex_state = 272, .external_lex_state = 2},
  [829] = {.lex_state = 124},
  [830] = {.lex_state = 124},
  [831] = {.lex_state = 107},
  [832] = {.lex_state = 107},
  [833] = {.lex_state = 124},
  [834] = {.lex_state = 115, .external_lex_state = 6},
  [835] = {.lex_state = 115, .external_lex_state = 2},
  [836] = {.lex_state = 158, .external_lex_state = 5},
  [837] = {.lex_state = 158, .external_lex_state = 5},
  [838] = {.lex_state = 103, .external_lex_state = 5},
  [839] = {.lex_state = 158, .external_lex_state = 5},
  [840] = {.lex_state = 124},
  [841] = {.lex_state = 81, .external_lex_state = 2},
  [842] = {.lex_state = 115, .external_lex_state = 6},
  [843] = {.lex_state = 197, .external_lex_state = 5},
  [844] = {.lex_state = 124},
  [845] = {.lex_state = 103},
  [846] = {.lex_state = 121},
  [847] = {.lex_state = 121},
  [848] = {.lex_state = 115, .external_lex_state = 2},
  [849] = {.lex_state = 110},
  [850] = {.lex_state = 115, .external_lex_state = 2},
  [851] = {.lex_state = 115, .external_lex_state = 2},
  [852] = {.lex_state = 115, .external_lex_state = 2},
  [853] = {.lex_state = 115, .external_lex_state = 2},
  [854] = {.lex_state = 115, .external_lex_state = 2},
  [855] = {.lex_state = 115, .external_lex_state = 2},
  [856] = {.lex_state = 103},
  [857] = {.lex_state = 115, .external_lex_state = 2},
  [858] = {.lex_state = 115, .external_lex_state = 2},
  [859] = {.lex_state = 115, .external_lex_state = 2},
  [860] = {.lex_state = 115, .external_lex_state = 2},
  [861] = {.lex_state = 115, .external_lex_state = 2},
  [862] = {.lex_state = 115, .external_lex_state = 2},
  [863] = {.lex_state = 121},
  [864] = {.lex_state = 194, .external_lex_state = 2},
  [865] = {.lex_state = 110},
  [866] = {.lex_state = 110},
  [867] = {.lex_state = 124},
  [868] = {.lex_state = 110},
  [869] = {.lex_state = 115, .external_lex_state = 2},
  [870] = {.lex_state = 115, .external_lex_state = 2},
  [871] = {.lex_state = 124},
  [872] = {.lex_state = 115, .external_lex_state = 2},
  [873] = {.lex_state = 121},
  [874] = {.lex_state = 180},
  [875] = {.lex_state = 110},
  [876] = {.lex_state = 275, .external_lex_state = 2},
  [877] = {.lex_state = 121},
  [878] = {.lex_state = 124},
  [879] = {.lex_state = 110},
  [880] = {.lex_state = 115, .external_lex_state = 2},
  [881] = {.lex_state = 115, .external_lex_state = 2},
  [882] = {.lex_state = 124},
  [883] = {.lex_state = 115, .external_lex_state = 2},
  [884] = {.lex_state = 121},
  [885] = {.lex_state = 260},
  [886] = {.lex_state = 110},
  [887] = {.lex_state = 278, .external_lex_state = 2},
  [888] = {.lex_state = 121},
  [889] = {.lex_state = 124},
  [890] = {.lex_state = 139, .external_lex_state = 5},
  [891] = {.lex_state = 121},
  [892] = {.lex_state = 124},
  [893] = {.lex_state = 206},
  [894] = {.lex_state = 115, .external_lex_state = 2},
  [895] = {.lex_state = 110},
  [896] = {.lex_state = 115, .external_lex_state = 2},
  [897] = {.lex_state = 115, .external_lex_state = 2},
  [898] = {.lex_state = 115, .external_lex_state = 2},
  [899] = {.lex_state = 115, .external_lex_state = 2},
  [900] = {.lex_state = 115, .external_lex_state = 2},
  [901] = {.lex_state = 115, .external_lex_state = 2},
  [902] = {.lex_state = 103},
  [903] = {.lex_state = 115, .external_lex_state = 2},
  [904] = {.lex_state = 115, .external_lex_state = 2},
  [905] = {.lex_state = 115, .external_lex_state = 2},
  [906] = {.lex_state = 115, .external_lex_state = 2},
  [907] = {.lex_state = 115, .external_lex_state = 2},
  [908] = {.lex_state = 115, .external_lex_state = 2},
  [909] = {.lex_state = 206},
  [910] = {.lex_state = 206, .external_lex_state = 2},
  [911] = {.lex_state = 206},
  [912] = {.lex_state = 115, .external_lex_state = 2},
  [913] = {.lex_state = 121, .external_lex_state = 5},
  [914] = {.lex_state = 281},
  [915] = {.lex_state = 206},
  [916] = {.lex_state = 242, .external_lex_state = 2},
  [917] = {.lex_state = 130},
  [918] = {.lex_state = 103},
  [919] = {.lex_state = 115, .external_lex_state = 2},
  [920] = {.lex_state = 103},
  [921] = {.lex_state = 206},
  [922] = {.lex_state = 121, .external_lex_state = 5},
  [923] = {.lex_state = 115, .external_lex_state = 2},
  [924] = {.lex_state = 206},
  [925] = {.lex_state = 206},
  [926] = {.lex_state = 206},
  [927] = {.lex_state = 206},
  [928] = {.lex_state = 115, .external_lex_state = 2},
  [929] = {.lex_state = 206},
  [930] = {.lex_state = 206},
  [931] = {.lex_state = 206},
  [932] = {.lex_state = 206},
  [933] = {.lex_state = 206},
  [934] = {.lex_state = 206, .external_lex_state = 2},
  [935] = {.lex_state = 209},
  [936] = {.lex_state = 209},
  [937] = {.lex_state = 115, .external_lex_state = 2},
  [938] = {.lex_state = 110},
  [939] = {.lex_state = 115, .external_lex_state = 2},
  [940] = {.lex_state = 115, .external_lex_state = 2},
  [941] = {.lex_state = 115, .external_lex_state = 2},
  [942] = {.lex_state = 115, .external_lex_state = 2},
  [943] = {.lex_state = 115, .external_lex_state = 2},
  [944] = {.lex_state = 115, .external_lex_state = 2},
  [945] = {.lex_state = 103},
  [946] = {.lex_state = 115, .external_lex_state = 2},
  [947] = {.lex_state = 115, .external_lex_state = 2},
  [948] = {.lex_state = 115, .external_lex_state = 2},
  [949] = {.lex_state = 115, .external_lex_state = 2},
  [950] = {.lex_state = 115, .external_lex_state = 2},
  [951] = {.lex_state = 115, .external_lex_state = 2},
  [952] = {.lex_state = 209},
  [953] = {.lex_state = 245, .external_lex_state = 2},
  [954] = {.lex_state = 209},
  [955] = {.lex_state = 115, .external_lex_state = 2},
  [956] = {.lex_state = 284, .external_lex_state = 2},
  [957] = {.lex_state = 121, .external_lex_state = 5},
  [958] = {.lex_state = 209},
  [959] = {.lex_state = 248, .external_lex_state = 2},
  [960] = {.lex_state = 133},
  [961] = {.lex_state = 124},
  [962] = {.lex_state = 121, .external_lex_state = 5},
  [963] = {.lex_state = 133},
  [964] = {.lex_state = 121},
  [965] = {.lex_state = 248, .external_lex_state = 2},
  [966] = {.lex_state = 133},
  [967] = {.lex_state = 103},
  [968] = {.lex_state = 115, .external_lex_state = 2},
  [969] = {.lex_state = 115, .external_lex_state = 2},
  [970] = {.lex_state = 124},
  [971] = {.lex_state = 115, .external_lex_state = 2},
  [972] = {.lex_state = 209},
  [973] = {.lex_state = 209},
  [974] = {.lex_state = 245, .external_lex_state = 2},
  [975] = {.lex_state = 115, .external_lex_state = 2},
  [976] = {.lex_state = 103},
  [977] = {.lex_state = 209},
  [978] = {.lex_state = 121, .external_lex_state = 5},
  [979] = {.lex_state = 115, .external_lex_state = 2},
  [980] = {.lex_state = 209},
  [981] = {.lex_state = 209},
  [982] = {.lex_state = 209},
  [983] = {.lex_state = 209},
  [984] = {.lex_state = 115, .external_lex_state = 2},
  [985] = {.lex_state = 209},
  [986] = {.lex_state = 209},
  [987] = {.lex_state = 209},
  [988] = {.lex_state = 209},
  [989] = {.lex_state = 209},
  [990] = {.lex_state = 121, .external_lex_state = 5},
  [991] = {.lex_state = 209, .external_lex_state = 2},
  [992] = {.lex_state = 81, .external_lex_state = 2},
  [993] = {.lex_state = 115, .external_lex_state = 2},
  [994] = {.lex_state = 251, .external_lex_state = 5},
  [995] = {.lex_state = 115, .external_lex_state = 2},
  [996] = {.lex_state = 110},
  [997] = {.lex_state = 115, .external_lex_state = 2},
  [998] = {.lex_state = 115, .external_lex_state = 2},
  [999] = {.lex_state = 115, .external_lex_state = 2},
  [1000] = {.lex_state = 115, .external_lex_state = 2},
  [1001] = {.lex_state = 115, .external_lex_state = 2},
  [1002] = {.lex_state = 115, .external_lex_state = 2},
  [1003] = {.lex_state = 103},
  [1004] = {.lex_state = 115, .external_lex_state = 2},
  [1005] = {.lex_state = 115, .external_lex_state = 2},
  [1006] = {.lex_state = 115, .external_lex_state = 2},
  [1007] = {.lex_state = 115, .external_lex_state = 2},
  [1008] = {.lex_state = 115, .external_lex_state = 2},
  [1009] = {.lex_state = 115, .external_lex_state = 2},
  [1010] = {.lex_state = 287, .external_lex_state = 5},
  [1011] = {.lex_state = 115, .external_lex_state = 2},
  [1012] = {.lex_state = 254, .external_lex_state = 4},
  [1013] = {.lex_state = 212, .external_lex_state = 4},
  [1014] = {.lex_state = 139, .external_lex_state = 5},
  [1015] = {.lex_state = 103},
  [1016] = {.lex_state = 115, .external_lex_state = 2},
  [1017] = {.lex_state = 110},
  [1018] = {.lex_state = 115, .external_lex_state = 2},
  [1019] = {.lex_state = 115, .external_lex_state = 2},
  [1020] = {.lex_state = 115, .external_lex_state = 2},
  [1021] = {.lex_state = 115, .external_lex_state = 2},
  [1022] = {.lex_state = 115, .external_lex_state = 2},
  [1023] = {.lex_state = 115, .external_lex_state = 2},
  [1024] = {.lex_state = 115, .external_lex_state = 2},
  [1025] = {.lex_state = 103},
  [1026] = {.lex_state = 115, .external_lex_state = 2},
  [1027] = {.lex_state = 115, .external_lex_state = 2},
  [1028] = {.lex_state = 115, .external_lex_state = 2},
  [1029] = {.lex_state = 115, .external_lex_state = 2},
  [1030] = {.lex_state = 115, .external_lex_state = 2},
  [1031] = {.lex_state = 115, .external_lex_state = 2},
  [1032] = {.lex_state = 121},
  [1033] = {.lex_state = 257, .external_lex_state = 2},
  [1034] = {.lex_state = 115, .external_lex_state = 2},
  [1035] = {.lex_state = 121, .external_lex_state = 5},
  [1036] = {.lex_state = 115, .external_lex_state = 2},
  [1037] = {.lex_state = 124},
  [1038] = {.lex_state = 115, .external_lex_state = 2},
  [1039] = {.lex_state = 115, .external_lex_state = 2},
  [1040] = {.lex_state = 290, .external_lex_state = 2},
  [1041] = {.lex_state = 107},
  [1042] = {.lex_state = 121, .external_lex_state = 5},
  [1043] = {.lex_state = 203, .external_lex_state = 2},
  [1044] = {.lex_state = 266},
  [1045] = {.lex_state = 266},
  [1046] = {.lex_state = 115, .external_lex_state = 2},
  [1047] = {.lex_state = 110},
  [1048] = {.lex_state = 293, .external_lex_state = 2},
  [1049] = {.lex_state = 115, .external_lex_state = 2},
  [1050] = {.lex_state = 263, .external_lex_state = 2},
  [1051] = {.lex_state = 115, .external_lex_state = 2},
  [1052] = {.lex_state = 115, .external_lex_state = 2},
  [1053] = {.lex_state = 121, .external_lex_state = 5},
  [1054] = {.lex_state = 130},
  [1055] = {.lex_state = 115, .external_lex_state = 2},
  [1056] = {.lex_state = 115, .external_lex_state = 2},
  [1057] = {.lex_state = 115, .external_lex_state = 2},
  [1058] = {.lex_state = 103},
  [1059] = {.lex_state = 115, .external_lex_state = 2},
  [1060] = {.lex_state = 115, .external_lex_state = 2},
  [1061] = {.lex_state = 115, .external_lex_state = 2},
  [1062] = {.lex_state = 115, .external_lex_state = 2},
  [1063] = {.lex_state = 115, .external_lex_state = 2},
  [1064] = {.lex_state = 115, .external_lex_state = 2},
  [1065] = {.lex_state = 266},
  [1066] = {.lex_state = 266, .external_lex_state = 2},
  [1067] = {.lex_state = 226},
  [1068] = {.lex_state = 115, .external_lex_state = 2},
  [1069] = {.lex_state = 103},
  [1070] = {.lex_state = 226},
  [1071] = {.lex_state = 88, .external_lex_state = 3},
  [1072] = {.lex_state = 226},
  [1073] = {.lex_state = 226},
  [1074] = {.lex_state = 226},
  [1075] = {.lex_state = 115, .external_lex_state = 2},
  [1076] = {.lex_state = 226},
  [1077] = {.lex_state = 226},
  [1078] = {.lex_state = 226},
  [1079] = {.lex_state = 226},
  [1080] = {.lex_state = 226},
  [1081] = {.lex_state = 226, .external_lex_state = 2},
  [1082] = {.lex_state = 103},
  [1083] = {.lex_state = 124},
  [1084] = {.lex_state = 107},
  [1085] = {.lex_state = 107},
  [1086] = {.lex_state = 124},
  [1087] = {.lex_state = 161},
  [1088] = {.lex_state = 161},
  [1089] = {.lex_state = 229, .external_lex_state = 2},
  [1090] = {.lex_state = 124},
  [1091] = {.lex_state = 124},
  [1092] = {.lex_state = 115, .external_lex_state = 2},
  [1093] = {.lex_state = 124},
  [1094] = {.lex_state = 103},
  [1095] = {.lex_state = 124},
  [1096] = {.lex_state = 107, .external_lex_state = 2},
  [1097] = {.lex_state = 107},
  [1098] = {.lex_state = 176},
  [1099] = {.lex_state = 176},
  [1100] = {.lex_state = 176},
  [1101] = {.lex_state = 115, .external_lex_state = 2},
  [1102] = {.lex_state = 176},
  [1103] = {.lex_state = 176},
  [1104] = {.lex_state = 176},
  [1105] = {.lex_state = 176},
  [1106] = {.lex_state = 124},
  [1107] = {.lex_state = 176, .external_lex_state = 2},
  [1108] = {.lex_state = 161},
  [1109] = {.lex_state = 242, .external_lex_state = 2},
  [1110] = {.lex_state = 161},
  [1111] = {.lex_state = 161},
  [1112] = {.lex_state = 248, .external_lex_state = 2},
  [1113] = {.lex_state = 161},
  [1114] = {.lex_state = 248, .external_lex_state = 2},
  [1115] = {.lex_state = 161},
  [1116] = {.lex_state = 161},
  [1117] = {.lex_state = 115, .external_lex_state = 2},
  [1118] = {.lex_state = 103},
  [1119] = {.lex_state = 115, .external_lex_state = 2},
  [1120] = {.lex_state = 115, .external_lex_state = 2},
  [1121] = {.lex_state = 115, .external_lex_state = 2},
  [1122] = {.lex_state = 124},
  [1123] = {.lex_state = 115, .external_lex_state = 2},
  [1124] = {.lex_state = 124},
  [1125] = {.lex_state = 176},
  [1126] = {.lex_state = 296, .external_lex_state = 2},
  [1127] = {.lex_state = 124},
  [1128] = {.lex_state = 121, .external_lex_state = 5},
  [1129] = {.lex_state = 115, .external_lex_state = 2},
  [1130] = {.lex_state = 161},
  [1131] = {.lex_state = 290, .external_lex_state = 2},
  [1132] = {.lex_state = 107},
  [1133] = {.lex_state = 176},
  [1134] = {.lex_state = 293, .external_lex_state = 2},
  [1135] = {.lex_state = 161},
  [1136] = {.lex_state = 130},
  [1137] = {.lex_state = 180, .external_lex_state = 5},
  [1138] = {.lex_state = 180, .external_lex_state = 5},
  [1139] = {.lex_state = 229, .external_lex_state = 2},
  [1140] = {.lex_state = 158, .external_lex_state = 5},
  [1141] = {.lex_state = 180, .external_lex_state = 5},
  [1142] = {.lex_state = 242, .external_lex_state = 2},
  [1143] = {.lex_state = 180, .external_lex_state = 5},
  [1144] = {.lex_state = 180, .external_lex_state = 5},
  [1145] = {.lex_state = 248, .external_lex_state = 2},
  [1146] = {.lex_state = 180, .external_lex_state = 5},
  [1147] = {.lex_state = 248, .external_lex_state = 2},
  [1148] = {.lex_state = 180, .external_lex_state = 5},
  [1149] = {.lex_state = 180, .external_lex_state = 5},
  [1150] = {.lex_state = 115, .external_lex_state = 2},
  [1151] = {.lex_state = 180, .external_lex_state = 5},
  [1152] = {.lex_state = 290, .external_lex_state = 2},
  [1153] = {.lex_state = 107},
  [1154] = {.lex_state = 183, .external_lex_state = 5},
  [1155] = {.lex_state = 293, .external_lex_state = 2},
  [1156] = {.lex_state = 180, .external_lex_state = 5},
  [1157] = {.lex_state = 130},
  [1158] = {.lex_state = 103, .external_lex_state = 5},
  [1159] = {.lex_state = 115, .external_lex_state = 2},
  [1160] = {.lex_state = 103},
  [1161] = {.lex_state = 103, .external_lex_state = 5},
  [1162] = {.lex_state = 235, .external_lex_state = 5},
  [1163] = {.lex_state = 235, .external_lex_state = 5},
  [1164] = {.lex_state = 235, .external_lex_state = 5},
  [1165] = {.lex_state = 115, .external_lex_state = 2},
  [1166] = {.lex_state = 235, .external_lex_state = 5},
  [1167] = {.lex_state = 235, .external_lex_state = 5},
  [1168] = {.lex_state = 235, .external_lex_state = 5},
  [1169] = {.lex_state = 235, .external_lex_state = 5},
  [1170] = {.lex_state = 269, .external_lex_state = 5},
  [1171] = {.lex_state = 235, .external_lex_state = 4},
  [1172] = {.lex_state = 158, .external_lex_state = 5},
  [1173] = {.lex_state = 115, .external_lex_state = 2},
  [1174] = {.lex_state = 115, .external_lex_state = 2},
  [1175] = {.lex_state = 183, .external_lex_state = 5},
  [1176] = {.lex_state = 121},
  [1177] = {.lex_state = 115, .external_lex_state = 2},
  [1178] = {.lex_state = 81, .external_lex_state = 2},
  [1179] = {.lex_state = 81, .external_lex_state = 7},
  [1180] = {.lex_state = 115, .external_lex_state = 2},
  [1181] = {.lex_state = 110},
  [1182] = {.lex_state = 81, .external_lex_state = 2},
  [1183] = {.lex_state = 81, .external_lex_state = 2},
  [1184] = {.lex_state = 186},
  [1185] = {.lex_state = 110},
  [1186] = {.lex_state = 81, .external_lex_state = 2},
  [1187] = {.lex_state = 115, .external_lex_state = 6},
  [1188] = {.lex_state = 115, .external_lex_state = 6},
  [1189] = {.lex_state = 115, .external_lex_state = 2},
  [1190] = {.lex_state = 115, .external_lex_state = 6},
  [1191] = {.lex_state = 218, .external_lex_state = 2},
  [1192] = {.lex_state = 110},
  [1193] = {.lex_state = 115, .external_lex_state = 2},
  [1194] = {.lex_state = 81, .external_lex_state = 2},
  [1195] = {.lex_state = 121},
  [1196] = {.lex_state = 115, .external_lex_state = 2},
  [1197] = {.lex_state = 115, .external_lex_state = 2},
  [1198] = {.lex_state = 103},
  [1199] = {.lex_state = 103},
  [1200] = {.lex_state = 121},
  [1201] = {.lex_state = 115, .external_lex_state = 6},
  [1202] = {.lex_state = 110},
  [1203] = {.lex_state = 81},
  [1204] = {.lex_state = 110},
  [1205] = {.lex_state = 81, .external_lex_state = 7},
  [1206] = {.lex_state = 115, .external_lex_state = 4},
  [1207] = {.lex_state = 103, .external_lex_state = 5},
  [1208] = {.lex_state = 103},
  [1209] = {.lex_state = 81, .external_lex_state = 7},
  [1210] = {.lex_state = 103},
  [1211] = {.lex_state = 81, .external_lex_state = 7},
  [1212] = {.lex_state = 103},
  [1213] = {.lex_state = 115, .external_lex_state = 4},
  [1214] = {.lex_state = 115, .external_lex_state = 6},
  [1215] = {.lex_state = 121},
  [1216] = {.lex_state = 115, .external_lex_state = 6},
  [1217] = {.lex_state = 81, .external_lex_state = 2},
  [1218] = {.lex_state = 81, .external_lex_state = 2},
  [1219] = {.lex_state = 81, .external_lex_state = 2},
  [1220] = {.lex_state = 121},
  [1221] = {.lex_state = 115, .external_lex_state = 2},
  [1222] = {.lex_state = 194},
  [1223] = {.lex_state = 115, .external_lex_state = 2},
  [1224] = {.lex_state = 115, .external_lex_state = 2},
  [1225] = {.lex_state = 115, .external_lex_state = 2},
  [1226] = {.lex_state = 124},
  [1227] = {.lex_state = 115, .external_lex_state = 2},
  [1228] = {.lex_state = 124},
  [1229] = {.lex_state = 260},
  [1230] = {.lex_state = 299, .external_lex_state = 2},
  [1231] = {.lex_state = 124},
  [1232] = {.lex_state = 115, .external_lex_state = 2},
  [1233] = {.lex_state = 115, .external_lex_state = 2},
  [1234] = {.lex_state = 107},
  [1235] = {.lex_state = 124},
  [1236] = {.lex_state = 115, .external_lex_state = 2},
  [1237] = {.lex_state = 115, .external_lex_state = 2},
  [1238] = {.lex_state = 107},
  [1239] = {.lex_state = 238},
  [1240] = {.lex_state = 115, .external_lex_state = 2},
  [1241] = {.lex_state = 81, .external_lex_state = 2},
  [1242] = {.lex_state = 121},
  [1243] = {.lex_state = 110},
  [1244] = {.lex_state = 158, .external_lex_state = 5},
  [1245] = {.lex_state = 81, .external_lex_state = 2},
  [1246] = {.lex_state = 121},
  [1247] = {.lex_state = 115, .external_lex_state = 2},
  [1248] = {.lex_state = 103},
  [1249] = {.lex_state = 121},
  [1250] = {.lex_state = 194},
  [1251] = {.lex_state = 194},
  [1252] = {.lex_state = 194},
  [1253] = {.lex_state = 115, .external_lex_state = 2},
  [1254] = {.lex_state = 194},
  [1255] = {.lex_state = 194},
  [1256] = {.lex_state = 194},
  [1257] = {.lex_state = 194},
  [1258] = {.lex_state = 121},
  [1259] = {.lex_state = 194, .external_lex_state = 2},
  [1260] = {.lex_state = 121},
  [1261] = {.lex_state = 115, .external_lex_state = 2},
  [1262] = {.lex_state = 110},
  [1263] = {.lex_state = 115, .external_lex_state = 2},
  [1264] = {.lex_state = 115, .external_lex_state = 2},
  [1265] = {.lex_state = 115, .external_lex_state = 2},
  [1266] = {.lex_state = 115, .external_lex_state = 2},
  [1267] = {.lex_state = 115, .external_lex_state = 2},
  [1268] = {.lex_state = 115, .external_lex_state = 2},
  [1269] = {.lex_state = 103},
  [1270] = {.lex_state = 115, .external_lex_state = 2},
  [1271] = {.lex_state = 115, .external_lex_state = 2},
  [1272] = {.lex_state = 115, .external_lex_state = 2},
  [1273] = {.lex_state = 115, .external_lex_state = 2},
  [1274] = {.lex_state = 115, .external_lex_state = 2},
  [1275] = {.lex_state = 115, .external_lex_state = 2},
  [1276] = {.lex_state = 121},
  [1277] = {.lex_state = 115, .external_lex_state = 2},
  [1278] = {.lex_state = 275, .external_lex_state = 2},
  [1279] = {.lex_state = 124},
  [1280] = {.lex_state = 121},
  [1281] = {.lex_state = 115, .external_lex_state = 2},
  [1282] = {.lex_state = 110},
  [1283] = {.lex_state = 115, .external_lex_state = 2},
  [1284] = {.lex_state = 115, .external_lex_state = 2},
  [1285] = {.lex_state = 115, .external_lex_state = 2},
  [1286] = {.lex_state = 115, .external_lex_state = 2},
  [1287] = {.lex_state = 115, .external_lex_state = 2},
  [1288] = {.lex_state = 115, .external_lex_state = 2},
  [1289] = {.lex_state = 103},
  [1290] = {.lex_state = 115, .external_lex_state = 2},
  [1291] = {.lex_state = 115, .external_lex_state = 2},
  [1292] = {.lex_state = 115, .external_lex_state = 2},
  [1293] = {.lex_state = 115, .external_lex_state = 2},
  [1294] = {.lex_state = 115, .external_lex_state = 2},
  [1295] = {.lex_state = 115, .external_lex_state = 2},
  [1296] = {.lex_state = 121},
  [1297] = {.lex_state = 115, .external_lex_state = 2},
  [1298] = {.lex_state = 278, .external_lex_state = 2},
  [1299] = {.lex_state = 206},
  [1300] = {.lex_state = 115, .external_lex_state = 2},
  [1301] = {.lex_state = 103},
  [1302] = {.lex_state = 206},
  [1303] = {.lex_state = 206},
  [1304] = {.lex_state = 206},
  [1305] = {.lex_state = 206},
  [1306] = {.lex_state = 115, .external_lex_state = 2},
  [1307] = {.lex_state = 206},
  [1308] = {.lex_state = 206},
  [1309] = {.lex_state = 206},
  [1310] = {.lex_state = 206},
  [1311] = {.lex_state = 206},
  [1312] = {.lex_state = 206, .external_lex_state = 2},
  [1313] = {.lex_state = 206},
  [1314] = {.lex_state = 121, .external_lex_state = 5},
  [1315] = {.lex_state = 302, .external_lex_state = 2},
  [1316] = {.lex_state = 115, .external_lex_state = 2},
  [1317] = {.lex_state = 103},
  [1318] = {.lex_state = 115, .external_lex_state = 2},
  [1319] = {.lex_state = 115, .external_lex_state = 2},
  [1320] = {.lex_state = 115, .external_lex_state = 2},
  [1321] = {.lex_state = 124},
  [1322] = {.lex_state = 115, .external_lex_state = 2},
  [1323] = {.lex_state = 206},
  [1324] = {.lex_state = 206},
  [1325] = {.lex_state = 305, .external_lex_state = 2},
  [1326] = {.lex_state = 206},
  [1327] = {.lex_state = 206},
  [1328] = {.lex_state = 209},
  [1329] = {.lex_state = 115, .external_lex_state = 2},
  [1330] = {.lex_state = 103},
  [1331] = {.lex_state = 209},
  [1332] = {.lex_state = 209},
  [1333] = {.lex_state = 209},
  [1334] = {.lex_state = 209},
  [1335] = {.lex_state = 115, .external_lex_state = 2},
  [1336] = {.lex_state = 209},
  [1337] = {.lex_state = 209},
  [1338] = {.lex_state = 209},
  [1339] = {.lex_state = 209},
  [1340] = {.lex_state = 209},
  [1341] = {.lex_state = 245, .external_lex_state = 2},
  [1342] = {.lex_state = 209},
  [1343] = {.lex_state = 121, .external_lex_state = 5},
  [1344] = {.lex_state = 302, .external_lex_state = 2},
  [1345] = {.lex_state = 115, .external_lex_state = 2},
  [1346] = {.lex_state = 121, .external_lex_state = 5},
  [1347] = {.lex_state = 302, .external_lex_state = 2},
  [1348] = {.lex_state = 115, .external_lex_state = 2},
  [1349] = {.lex_state = 209},
  [1350] = {.lex_state = 115, .external_lex_state = 2},
  [1351] = {.lex_state = 110},
  [1352] = {.lex_state = 115, .external_lex_state = 2},
  [1353] = {.lex_state = 115, .external_lex_state = 2},
  [1354] = {.lex_state = 115, .external_lex_state = 2},
  [1355] = {.lex_state = 115, .external_lex_state = 2},
  [1356] = {.lex_state = 115, .external_lex_state = 2},
  [1357] = {.lex_state = 115, .external_lex_state = 2},
  [1358] = {.lex_state = 103},
  [1359] = {.lex_state = 115, .external_lex_state = 2},
  [1360] = {.lex_state = 115, .external_lex_state = 2},
  [1361] = {.lex_state = 115, .external_lex_state = 2},
  [1362] = {.lex_state = 115, .external_lex_state = 2},
  [1363] = {.lex_state = 115, .external_lex_state = 2},
  [1364] = {.lex_state = 115, .external_lex_state = 2},
  [1365] = {.lex_state = 209},
  [1366] = {.lex_state = 245, .external_lex_state = 2},
  [1367] = {.lex_state = 103},
  [1368] = {.lex_state = 115, .external_lex_state = 2},
  [1369] = {.lex_state = 115, .external_lex_state = 2},
  [1370] = {.lex_state = 115, .external_lex_state = 2},
  [1371] = {.lex_state = 124},
  [1372] = {.lex_state = 115, .external_lex_state = 2},
  [1373] = {.lex_state = 209},
  [1374] = {.lex_state = 209},
  [1375] = {.lex_state = 308, .external_lex_state = 2},
  [1376] = {.lex_state = 209},
  [1377] = {.lex_state = 209},
  [1378] = {.lex_state = 251, .external_lex_state = 5},
  [1379] = {.lex_state = 115, .external_lex_state = 2},
  [1380] = {.lex_state = 103},
  [1381] = {.lex_state = 251, .external_lex_state = 5},
  [1382] = {.lex_state = 254, .external_lex_state = 5},
  [1383] = {.lex_state = 254, .external_lex_state = 5},
  [1384] = {.lex_state = 254, .external_lex_state = 5},
  [1385] = {.lex_state = 115, .external_lex_state = 2},
  [1386] = {.lex_state = 254, .external_lex_state = 5},
  [1387] = {.lex_state = 254, .external_lex_state = 5},
  [1388] = {.lex_state = 254, .external_lex_state = 5},
  [1389] = {.lex_state = 254, .external_lex_state = 5},
  [1390] = {.lex_state = 287, .external_lex_state = 5},
  [1391] = {.lex_state = 103, .external_lex_state = 5},
  [1392] = {.lex_state = 254, .external_lex_state = 4},
  [1393] = {.lex_state = 212, .external_lex_state = 4},
  [1394] = {.lex_state = 103},
  [1395] = {.lex_state = 115, .external_lex_state = 2},
  [1396] = {.lex_state = 103},
  [1397] = {.lex_state = 139, .external_lex_state = 5},
  [1398] = {.lex_state = 103},
  [1399] = {.lex_state = 176},
  [1400] = {.lex_state = 176},
  [1401] = {.lex_state = 176},
  [1402] = {.lex_state = 115, .external_lex_state = 2},
  [1403] = {.lex_state = 176},
  [1404] = {.lex_state = 176},
  [1405] = {.lex_state = 176},
  [1406] = {.lex_state = 176},
  [1407] = {.lex_state = 121},
  [1408] = {.lex_state = 257, .external_lex_state = 2},
  [1409] = {.lex_state = 124},
  [1410] = {.lex_state = 124},
  [1411] = {.lex_state = 124},
  [1412] = {.lex_state = 121, .external_lex_state = 5},
  [1413] = {.lex_state = 107},
  [1414] = {.lex_state = 124},
  [1415] = {.lex_state = 290, .external_lex_state = 2},
  [1416] = {.lex_state = 107},
  [1417] = {.lex_state = 206},
  [1418] = {.lex_state = 203, .external_lex_state = 2},
  [1419] = {.lex_state = 266},
  [1420] = {.lex_state = 115, .external_lex_state = 2},
  [1421] = {.lex_state = 121, .external_lex_state = 5},
  [1422] = {.lex_state = 266},
  [1423] = {.lex_state = 130},
  [1424] = {.lex_state = 103},
  [1425] = {.lex_state = 266},
  [1426] = {.lex_state = 266},
  [1427] = {.lex_state = 293, .external_lex_state = 2},
  [1428] = {.lex_state = 130},
  [1429] = {.lex_state = 266},
  [1430] = {.lex_state = 266},
  [1431] = {.lex_state = 266},
  [1432] = {.lex_state = 115, .external_lex_state = 2},
  [1433] = {.lex_state = 266},
  [1434] = {.lex_state = 266},
  [1435] = {.lex_state = 266},
  [1436] = {.lex_state = 266},
  [1437] = {.lex_state = 266},
  [1438] = {.lex_state = 266, .external_lex_state = 2},
  [1439] = {.lex_state = 226},
  [1440] = {.lex_state = 115, .external_lex_state = 2},
  [1441] = {.lex_state = 226},
  [1442] = {.lex_state = 124},
  [1443] = {.lex_state = 103, .external_lex_state = 5},
  [1444] = {.lex_state = 124},
  [1445] = {.lex_state = 107},
  [1446] = {.lex_state = 103},
  [1447] = {.lex_state = 161},
  [1448] = {.lex_state = 124},
  [1449] = {.lex_state = 115, .external_lex_state = 2},
  [1450] = {.lex_state = 115, .external_lex_state = 2},
  [1451] = {.lex_state = 176},
  [1452] = {.lex_state = 161},
  [1453] = {.lex_state = 161},
  [1454] = {.lex_state = 161},
  [1455] = {.lex_state = 124},
  [1456] = {.lex_state = 115, .external_lex_state = 2},
  [1457] = {.lex_state = 124},
  [1458] = {.lex_state = 124},
  [1459] = {.lex_state = 124},
  [1460] = {.lex_state = 124},
  [1461] = {.lex_state = 115, .external_lex_state = 2},
  [1462] = {.lex_state = 110},
  [1463] = {.lex_state = 115, .external_lex_state = 2},
  [1464] = {.lex_state = 115, .external_lex_state = 2},
  [1465] = {.lex_state = 115, .external_lex_state = 2},
  [1466] = {.lex_state = 115, .external_lex_state = 2},
  [1467] = {.lex_state = 115, .external_lex_state = 2},
  [1468] = {.lex_state = 115, .external_lex_state = 2},
  [1469] = {.lex_state = 103},
  [1470] = {.lex_state = 115, .external_lex_state = 2},
  [1471] = {.lex_state = 115, .external_lex_state = 2},
  [1472] = {.lex_state = 115, .external_lex_state = 2},
  [1473] = {.lex_state = 115, .external_lex_state = 2},
  [1474] = {.lex_state = 115, .external_lex_state = 2},
  [1475] = {.lex_state = 115, .external_lex_state = 2},
  [1476] = {.lex_state = 124},
  [1477] = {.lex_state = 296, .external_lex_state = 2},
  [1478] = {.lex_state = 161},
  [1479] = {.lex_state = 290, .external_lex_state = 2},
  [1480] = {.lex_state = 161},
  [1481] = {.lex_state = 293, .external_lex_state = 2},
  [1482] = {.lex_state = 180, .external_lex_state = 5},
  [1483] = {.lex_state = 180, .external_lex_state = 5},
  [1484] = {.lex_state = 180, .external_lex_state = 5},
  [1485] = {.lex_state = 180, .external_lex_state = 5},
  [1486] = {.lex_state = 158, .external_lex_state = 5},
  [1487] = {.lex_state = 180, .external_lex_state = 5},
  [1488] = {.lex_state = 290, .external_lex_state = 2},
  [1489] = {.lex_state = 180, .external_lex_state = 5},
  [1490] = {.lex_state = 293, .external_lex_state = 2},
  [1491] = {.lex_state = 103, .external_lex_state = 5},
  [1492] = {.lex_state = 115, .external_lex_state = 2},
  [1493] = {.lex_state = 235, .external_lex_state = 5},
  [1494] = {.lex_state = 158, .external_lex_state = 5},
  [1495] = {.lex_state = 121},
  [1496] = {.lex_state = 81, .external_lex_state = 2},
  [1497] = {.lex_state = 121},
  [1498] = {.lex_state = 115, .external_lex_state = 6},
  [1499] = {.lex_state = 81, .external_lex_state = 2},
  [1500] = {.lex_state = 81, .external_lex_state = 2},
  [1501] = {.lex_state = 115, .external_lex_state = 6},
  [1502] = {.lex_state = 81, .external_lex_state = 2},
  [1503] = {.lex_state = 81, .external_lex_state = 2},
  [1504] = {.lex_state = 110},
  [1505] = {.lex_state = 81, .external_lex_state = 2},
  [1506] = {.lex_state = 121},
  [1507] = {.lex_state = 218, .external_lex_state = 2},
  [1508] = {.lex_state = 110},
  [1509] = {.lex_state = 115, .external_lex_state = 6},
  [1510] = {.lex_state = 103},
  [1511] = {.lex_state = 110},
  [1512] = {.lex_state = 81},
  [1513] = {.lex_state = 115, .external_lex_state = 2},
  [1514] = {.lex_state = 115, .external_lex_state = 6},
  [1515] = {.lex_state = 103},
  [1516] = {.lex_state = 115, .external_lex_state = 6},
  [1517] = {.lex_state = 110},
  [1518] = {.lex_state = 238},
  [1519] = {.lex_state = 115, .external_lex_state = 6},
  [1520] = {.lex_state = 110},
  [1521] = {.lex_state = 81, .external_lex_state = 7},
  [1522] = {.lex_state = 115, .external_lex_state = 4},
  [1523] = {.lex_state = 103},
  [1524] = {.lex_state = 81, .external_lex_state = 2},
  [1525] = {.lex_state = 115, .external_lex_state = 2},
  [1526] = {.lex_state = 115, .external_lex_state = 6},
  [1527] = {.lex_state = 81, .external_lex_state = 2},
  [1528] = {.lex_state = 81, .external_lex_state = 2},
  [1529] = {.lex_state = 121},
  [1530] = {.lex_state = 124},
  [1531] = {.lex_state = 124},
  [1532] = {.lex_state = 115, .external_lex_state = 2},
  [1533] = {.lex_state = 110},
  [1534] = {.lex_state = 115, .external_lex_state = 2},
  [1535] = {.lex_state = 115, .external_lex_state = 2},
  [1536] = {.lex_state = 115, .external_lex_state = 2},
  [1537] = {.lex_state = 115, .external_lex_state = 2},
  [1538] = {.lex_state = 115, .external_lex_state = 2},
  [1539] = {.lex_state = 115, .external_lex_state = 2},
  [1540] = {.lex_state = 103},
  [1541] = {.lex_state = 115, .external_lex_state = 2},
  [1542] = {.lex_state = 115, .external_lex_state = 2},
  [1543] = {.lex_state = 115, .external_lex_state = 2},
  [1544] = {.lex_state = 115, .external_lex_state = 2},
  [1545] = {.lex_state = 115, .external_lex_state = 2},
  [1546] = {.lex_state = 115, .external_lex_state = 2},
  [1547] = {.lex_state = 124},
  [1548] = {.lex_state = 299, .external_lex_state = 2},
  [1549] = {.lex_state = 124},
  [1550] = {.lex_state = 124},
  [1551] = {.lex_state = 124},
  [1552] = {.lex_state = 110},
  [1553] = {.lex_state = 124},
  [1554] = {.lex_state = 124},
  [1555] = {.lex_state = 107},
  [1556] = {.lex_state = 115, .external_lex_state = 2},
  [1557] = {.lex_state = 115, .external_lex_state = 2},
  [1558] = {.lex_state = 124},
  [1559] = {.lex_state = 115, .external_lex_state = 2},
  [1560] = {.lex_state = 124},
  [1561] = {.lex_state = 260},
  [1562] = {.lex_state = 124},
  [1563] = {.lex_state = 311, .external_lex_state = 2},
  [1564] = {.lex_state = 124},
  [1565] = {.lex_state = 124},
  [1566] = {.lex_state = 124},
  [1567] = {.lex_state = 115, .external_lex_state = 6},
  [1568] = {.lex_state = 121},
  [1569] = {.lex_state = 115, .external_lex_state = 2},
  [1570] = {.lex_state = 194},
  [1571] = {.lex_state = 121},
  [1572] = {.lex_state = 115, .external_lex_state = 2},
  [1573] = {.lex_state = 103},
  [1574] = {.lex_state = 121},
  [1575] = {.lex_state = 180},
  [1576] = {.lex_state = 180},
  [1577] = {.lex_state = 180},
  [1578] = {.lex_state = 115, .external_lex_state = 2},
  [1579] = {.lex_state = 180},
  [1580] = {.lex_state = 180},
  [1581] = {.lex_state = 180},
  [1582] = {.lex_state = 180},
  [1583] = {.lex_state = 121},
  [1584] = {.lex_state = 121},
  [1585] = {.lex_state = 275, .external_lex_state = 2},
  [1586] = {.lex_state = 121},
  [1587] = {.lex_state = 115, .external_lex_state = 2},
  [1588] = {.lex_state = 103},
  [1589] = {.lex_state = 121},
  [1590] = {.lex_state = 260},
  [1591] = {.lex_state = 260},
  [1592] = {.lex_state = 260},
  [1593] = {.lex_state = 115, .external_lex_state = 2},
  [1594] = {.lex_state = 260},
  [1595] = {.lex_state = 260},
  [1596] = {.lex_state = 260},
  [1597] = {.lex_state = 260},
  [1598] = {.lex_state = 121},
  [1599] = {.lex_state = 121},
  [1600] = {.lex_state = 278, .external_lex_state = 2},
  [1601] = {.lex_state = 206},
  [1602] = {.lex_state = 115, .external_lex_state = 2},
  [1603] = {.lex_state = 206},
  [1604] = {.lex_state = 206},
  [1605] = {.lex_state = 115, .external_lex_state = 2},
  [1606] = {.lex_state = 124},
  [1607] = {.lex_state = 206},
  [1608] = {.lex_state = 206},
  [1609] = {.lex_state = 206},
  [1610] = {.lex_state = 115, .external_lex_state = 2},
  [1611] = {.lex_state = 110},
  [1612] = {.lex_state = 115, .external_lex_state = 2},
  [1613] = {.lex_state = 115, .external_lex_state = 2},
  [1614] = {.lex_state = 115, .external_lex_state = 2},
  [1615] = {.lex_state = 115, .external_lex_state = 2},
  [1616] = {.lex_state = 115, .external_lex_state = 2},
  [1617] = {.lex_state = 115, .external_lex_state = 2},
  [1618] = {.lex_state = 103},
  [1619] = {.lex_state = 115, .external_lex_state = 2},
  [1620] = {.lex_state = 115, .external_lex_state = 2},
  [1621] = {.lex_state = 115, .external_lex_state = 2},
  [1622] = {.lex_state = 115, .external_lex_state = 2},
  [1623] = {.lex_state = 115, .external_lex_state = 2},
  [1624] = {.lex_state = 115, .external_lex_state = 2},
  [1625] = {.lex_state = 206},
  [1626] = {.lex_state = 305, .external_lex_state = 2},
  [1627] = {.lex_state = 209},
  [1628] = {.lex_state = 115, .external_lex_state = 2},
  [1629] = {.lex_state = 209},
  [1630] = {.lex_state = 209},
  [1631] = {.lex_state = 209},
  [1632] = {.lex_state = 209},
  [1633] = {.lex_state = 115, .external_lex_state = 2},
  [1634] = {.lex_state = 103},
  [1635] = {.lex_state = 209},
  [1636] = {.lex_state = 209},
  [1637] = {.lex_state = 209},
  [1638] = {.lex_state = 209},
  [1639] = {.lex_state = 115, .external_lex_state = 2},
  [1640] = {.lex_state = 209},
  [1641] = {.lex_state = 209},
  [1642] = {.lex_state = 209},
  [1643] = {.lex_state = 209},
  [1644] = {.lex_state = 209},
  [1645] = {.lex_state = 245, .external_lex_state = 2},
  [1646] = {.lex_state = 115, .external_lex_state = 2},
  [1647] = {.lex_state = 124},
  [1648] = {.lex_state = 209},
  [1649] = {.lex_state = 209},
  [1650] = {.lex_state = 209},
  [1651] = {.lex_state = 115, .external_lex_state = 2},
  [1652] = {.lex_state = 110},
  [1653] = {.lex_state = 115, .external_lex_state = 2},
  [1654] = {.lex_state = 115, .external_lex_state = 2},
  [1655] = {.lex_state = 115, .external_lex_state = 2},
  [1656] = {.lex_state = 115, .external_lex_state = 2},
  [1657] = {.lex_state = 115, .external_lex_state = 2},
  [1658] = {.lex_state = 115, .external_lex_state = 2},
  [1659] = {.lex_state = 103},
  [1660] = {.lex_state = 115, .external_lex_state = 2},
  [1661] = {.lex_state = 115, .external_lex_state = 2},
  [1662] = {.lex_state = 115, .external_lex_state = 2},
  [1663] = {.lex_state = 115, .external_lex_state = 2},
  [1664] = {.lex_state = 115, .external_lex_state = 2},
  [1665] = {.lex_state = 115, .external_lex_state = 2},
  [1666] = {.lex_state = 209},
  [1667] = {.lex_state = 308, .external_lex_state = 2},
  [1668] = {.lex_state = 251, .external_lex_state = 5},
  [1669] = {.lex_state = 115, .external_lex_state = 2},
  [1670] = {.lex_state = 254, .external_lex_state = 5},
  [1671] = {.lex_state = 103},
  [1672] = {.lex_state = 115, .external_lex_state = 2},
  [1673] = {.lex_state = 176},
  [1674] = {.lex_state = 121, .external_lex_state = 5},
  [1675] = {.lex_state = 302, .external_lex_state = 2},
  [1676] = {.lex_state = 206},
  [1677] = {.lex_state = 266},
  [1678] = {.lex_state = 115, .external_lex_state = 2},
  [1679] = {.lex_state = 203, .external_lex_state = 2},
  [1680] = {.lex_state = 121, .external_lex_state = 5},
  [1681] = {.lex_state = 218, .external_lex_state = 2},
  [1682] = {.lex_state = 266},
  [1683] = {.lex_state = 226},
  [1684] = {.lex_state = 124},
  [1685] = {.lex_state = 107},
  [1686] = {.lex_state = 124},
  [1687] = {.lex_state = 124},
  [1688] = {.lex_state = 107},
  [1689] = {.lex_state = 107},
  [1690] = {.lex_state = 124},
  [1691] = {.lex_state = 124},
  [1692] = {.lex_state = 115, .external_lex_state = 2},
  [1693] = {.lex_state = 110},
  [1694] = {.lex_state = 229, .external_lex_state = 2},
  [1695] = {.lex_state = 124},
  [1696] = {.lex_state = 124},
  [1697] = {.lex_state = 115, .external_lex_state = 2},
  [1698] = {.lex_state = 103},
  [1699] = {.lex_state = 124},
  [1700] = {.lex_state = 176},
  [1701] = {.lex_state = 176},
  [1702] = {.lex_state = 176},
  [1703] = {.lex_state = 115, .external_lex_state = 2},
  [1704] = {.lex_state = 176},
  [1705] = {.lex_state = 176},
  [1706] = {.lex_state = 176},
  [1707] = {.lex_state = 176},
  [1708] = {.lex_state = 124},
  [1709] = {.lex_state = 296, .external_lex_state = 2},
  [1710] = {.lex_state = 161},
  [1711] = {.lex_state = 161},
  [1712] = {.lex_state = 180, .external_lex_state = 5},
  [1713] = {.lex_state = 180, .external_lex_state = 5},
  [1714] = {.lex_state = 103, .external_lex_state = 5},
  [1715] = {.lex_state = 115, .external_lex_state = 6},
  [1716] = {.lex_state = 81, .external_lex_state = 2},
  [1717] = {.lex_state = 81, .external_lex_state = 2},
  [1718] = {.lex_state = 115, .external_lex_state = 6},
  [1719] = {.lex_state = 81, .external_lex_state = 2},
  [1720] = {.lex_state = 115, .external_lex_state = 2},
  [1721] = {.lex_state = 81, .external_lex_state = 7},
  [1722] = {.lex_state = 81, .external_lex_state = 7},
  [1723] = {.lex_state = 115, .external_lex_state = 2},
  [1724] = {.lex_state = 115, .external_lex_state = 6},
  [1725] = {.lex_state = 110},
  [1726] = {.lex_state = 238},
  [1727] = {.lex_state = 110},
  [1728] = {.lex_state = 81, .external_lex_state = 7},
  [1729] = {.lex_state = 218, .external_lex_state = 2},
  [1730] = {.lex_state = 110},
  [1731] = {.lex_state = 81, .external_lex_state = 7},
  [1732] = {.lex_state = 81, .external_lex_state = 7},
  [1733] = {.lex_state = 81, .external_lex_state = 7},
  [1734] = {.lex_state = 115, .external_lex_state = 6},
  [1735] = {.lex_state = 115, .external_lex_state = 2},
  [1736] = {.lex_state = 81, .external_lex_state = 7},
  [1737] = {.lex_state = 115, .external_lex_state = 6},
  [1738] = {.lex_state = 81, .external_lex_state = 7},
  [1739] = {.lex_state = 121},
  [1740] = {.lex_state = 81, .external_lex_state = 2},
  [1741] = {.lex_state = 124},
  [1742] = {.lex_state = 115, .external_lex_state = 2},
  [1743] = {.lex_state = 103},
  [1744] = {.lex_state = 124},
  [1745] = {.lex_state = 260},
  [1746] = {.lex_state = 260},
  [1747] = {.lex_state = 260},
  [1748] = {.lex_state = 115, .external_lex_state = 2},
  [1749] = {.lex_state = 260},
  [1750] = {.lex_state = 260},
  [1751] = {.lex_state = 260},
  [1752] = {.lex_state = 260},
  [1753] = {.lex_state = 124},
  [1754] = {.lex_state = 299, .external_lex_state = 2},
  [1755] = {.lex_state = 115, .external_lex_state = 2},
  [1756] = {.lex_state = 124},
  [1757] = {.lex_state = 124},
  [1758] = {.lex_state = 115, .external_lex_state = 2},
  [1759] = {.lex_state = 110},
  [1760] = {.lex_state = 115, .external_lex_state = 2},
  [1761] = {.lex_state = 115, .external_lex_state = 2},
  [1762] = {.lex_state = 115, .external_lex_state = 2},
  [1763] = {.lex_state = 115, .external_lex_state = 2},
  [1764] = {.lex_state = 115, .external_lex_state = 2},
  [1765] = {.lex_state = 115, .external_lex_state = 2},
  [1766] = {.lex_state = 103},
  [1767] = {.lex_state = 115, .external_lex_state = 2},
  [1768] = {.lex_state = 115, .external_lex_state = 2},
  [1769] = {.lex_state = 115, .external_lex_state = 2},
  [1770] = {.lex_state = 115, .external_lex_state = 2},
  [1771] = {.lex_state = 115, .external_lex_state = 2},
  [1772] = {.lex_state = 115, .external_lex_state = 2},
  [1773] = {.lex_state = 124},
  [1774] = {.lex_state = 115, .external_lex_state = 2},
  [1775] = {.lex_state = 311, .external_lex_state = 2},
  [1776] = {.lex_state = 81, .external_lex_state = 2},
  [1777] = {.lex_state = 121},
  [1778] = {.lex_state = 121},
  [1779] = {.lex_state = 115, .external_lex_state = 2},
  [1780] = {.lex_state = 180},
  [1781] = {.lex_state = 121},
  [1782] = {.lex_state = 115, .external_lex_state = 2},
  [1783] = {.lex_state = 260},
  [1784] = {.lex_state = 206},
  [1785] = {.lex_state = 206},
  [1786] = {.lex_state = 115, .external_lex_state = 2},
  [1787] = {.lex_state = 110},
  [1788] = {.lex_state = 314, .external_lex_state = 2},
  [1789] = {.lex_state = 206},
  [1790] = {.lex_state = 206},
  [1791] = {.lex_state = 115, .external_lex_state = 2},
  [1792] = {.lex_state = 103},
  [1793] = {.lex_state = 206},
  [1794] = {.lex_state = 206},
  [1795] = {.lex_state = 206},
  [1796] = {.lex_state = 206},
  [1797] = {.lex_state = 115, .external_lex_state = 2},
  [1798] = {.lex_state = 206},
  [1799] = {.lex_state = 206},
  [1800] = {.lex_state = 206},
  [1801] = {.lex_state = 206},
  [1802] = {.lex_state = 206},
  [1803] = {.lex_state = 305, .external_lex_state = 2},
  [1804] = {.lex_state = 209},
  [1805] = {.lex_state = 209},
  [1806] = {.lex_state = 115, .external_lex_state = 2},
  [1807] = {.lex_state = 209},
  [1808] = {.lex_state = 209},
  [1809] = {.lex_state = 115, .external_lex_state = 2},
  [1810] = {.lex_state = 110},
  [1811] = {.lex_state = 317, .external_lex_state = 2},
  [1812] = {.lex_state = 209},
  [1813] = {.lex_state = 209},
  [1814] = {.lex_state = 115, .external_lex_state = 2},
  [1815] = {.lex_state = 103},
  [1816] = {.lex_state = 209},
  [1817] = {.lex_state = 209},
  [1818] = {.lex_state = 209},
  [1819] = {.lex_state = 209},
  [1820] = {.lex_state = 115, .external_lex_state = 2},
  [1821] = {.lex_state = 209},
  [1822] = {.lex_state = 209},
  [1823] = {.lex_state = 209},
  [1824] = {.lex_state = 209},
  [1825] = {.lex_state = 209},
  [1826] = {.lex_state = 308, .external_lex_state = 2},
  [1827] = {.lex_state = 251, .external_lex_state = 5},
  [1828] = {.lex_state = 103},
  [1829] = {.lex_state = 266},
  [1830] = {.lex_state = 206},
  [1831] = {.lex_state = 103},
  [1832] = {.lex_state = 229, .external_lex_state = 2},
  [1833] = {.lex_state = 124},
  [1834] = {.lex_state = 320},
  [1835] = {.lex_state = 115, .external_lex_state = 2},
  [1836] = {.lex_state = 320},
  [1837] = {.lex_state = 124},
  [1838] = {.lex_state = 124},
  [1839] = {.lex_state = 115, .external_lex_state = 2},
  [1840] = {.lex_state = 176},
  [1841] = {.lex_state = 81, .external_lex_state = 2},
  [1842] = {.lex_state = 81, .external_lex_state = 2},
  [1843] = {.lex_state = 81, .external_lex_state = 2},
  [1844] = {.lex_state = 81, .external_lex_state = 7},
  [1845] = {.lex_state = 81, .external_lex_state = 7},
  [1846] = {.lex_state = 115, .external_lex_state = 2},
  [1847] = {.lex_state = 110},
  [1848] = {.lex_state = 81, .external_lex_state = 7},
  [1849] = {.lex_state = 81, .external_lex_state = 7},
  [1850] = {.lex_state = 110},
  [1851] = {.lex_state = 81, .external_lex_state = 7},
  [1852] = {.lex_state = 115, .external_lex_state = 6},
  [1853] = {.lex_state = 115, .external_lex_state = 6},
  [1854] = {.lex_state = 115, .external_lex_state = 2},
  [1855] = {.lex_state = 115, .external_lex_state = 6},
  [1856] = {.lex_state = 81, .external_lex_state = 7},
  [1857] = {.lex_state = 115, .external_lex_state = 6},
  [1858] = {.lex_state = 121},
  [1859] = {.lex_state = 115, .external_lex_state = 6},
  [1860] = {.lex_state = 81, .external_lex_state = 7},
  [1861] = {.lex_state = 81, .external_lex_state = 7},
  [1862] = {.lex_state = 81, .external_lex_state = 7},
  [1863] = {.lex_state = 81, .external_lex_state = 7},
  [1864] = {.lex_state = 110},
  [1865] = {.lex_state = 81, .external_lex_state = 7},
  [1866] = {.lex_state = 115, .external_lex_state = 6},
  [1867] = {.lex_state = 124},
  [1868] = {.lex_state = 115, .external_lex_state = 2},
  [1869] = {.lex_state = 260},
  [1870] = {.lex_state = 124},
  [1871] = {.lex_state = 124},
  [1872] = {.lex_state = 115, .external_lex_state = 2},
  [1873] = {.lex_state = 103},
  [1874] = {.lex_state = 124},
  [1875] = {.lex_state = 260},
  [1876] = {.lex_state = 260},
  [1877] = {.lex_state = 260},
  [1878] = {.lex_state = 115, .external_lex_state = 2},
  [1879] = {.lex_state = 260},
  [1880] = {.lex_state = 260},
  [1881] = {.lex_state = 260},
  [1882] = {.lex_state = 260},
  [1883] = {.lex_state = 124},
  [1884] = {.lex_state = 124},
  [1885] = {.lex_state = 311, .external_lex_state = 2},
  [1886] = {.lex_state = 121},
  [1887] = {.lex_state = 121},
  [1888] = {.lex_state = 314, .external_lex_state = 2},
  [1889] = {.lex_state = 206},
  [1890] = {.lex_state = 115, .external_lex_state = 2},
  [1891] = {.lex_state = 206},
  [1892] = {.lex_state = 206},
  [1893] = {.lex_state = 115, .external_lex_state = 2},
  [1894] = {.lex_state = 206},
  [1895] = {.lex_state = 209},
  [1896] = {.lex_state = 317, .external_lex_state = 2},
  [1897] = {.lex_state = 209},
  [1898] = {.lex_state = 115, .external_lex_state = 2},
  [1899] = {.lex_state = 209},
  [1900] = {.lex_state = 209},
  [1901] = {.lex_state = 115, .external_lex_state = 2},
  [1902] = {.lex_state = 209},
  [1903] = {.lex_state = 229, .external_lex_state = 2},
  [1904] = {.lex_state = 320},
  [1905] = {.lex_state = 115, .external_lex_state = 2},
  [1906] = {.lex_state = 124},
  [1907] = {.lex_state = 81, .external_lex_state = 7},
  [1908] = {.lex_state = 121},
  [1909] = {.lex_state = 115, .external_lex_state = 6},
  [1910] = {.lex_state = 81, .external_lex_state = 7},
  [1911] = {.lex_state = 81, .external_lex_state = 7},
  [1912] = {.lex_state = 115, .external_lex_state = 6},
  [1913] = {.lex_state = 81, .external_lex_state = 7},
  [1914] = {.lex_state = 81, .external_lex_state = 7},
  [1915] = {.lex_state = 110},
  [1916] = {.lex_state = 81, .external_lex_state = 7},
  [1917] = {.lex_state = 81, .external_lex_state = 7},
  [1918] = {.lex_state = 115, .external_lex_state = 2},
  [1919] = {.lex_state = 115, .external_lex_state = 6},
  [1920] = {.lex_state = 81, .external_lex_state = 7},
  [1921] = {.lex_state = 81, .external_lex_state = 7},
  [1922] = {.lex_state = 115, .external_lex_state = 6},
  [1923] = {.lex_state = 81, .external_lex_state = 2},
  [1924] = {.lex_state = 124},
  [1925] = {.lex_state = 124},
  [1926] = {.lex_state = 115, .external_lex_state = 2},
  [1927] = {.lex_state = 260},
  [1928] = {.lex_state = 314, .external_lex_state = 2},
  [1929] = {.lex_state = 115, .external_lex_state = 2},
  [1930] = {.lex_state = 206},
  [1931] = {.lex_state = 317, .external_lex_state = 2},
  [1932] = {.lex_state = 115, .external_lex_state = 2},
  [1933] = {.lex_state = 209},
  [1934] = {.lex_state = 115, .external_lex_state = 6},
  [1935] = {.lex_state = 81, .external_lex_state = 7},
  [1936] = {.lex_state = 81, .external_lex_state = 7},
  [1937] = {.lex_state = 115, .external_lex_state = 6},
  [1938] = {.lex_state = 81, .external_lex_state = 7},
  [1939] = {.lex_state = 121},
  [1940] = {.lex_state = 81, .external_lex_state = 7},
  [1941] = {.lex_state = 81, .external_lex_state = 7},
  [1942] = {.lex_state = 124},
  [1943] = {.lex_state = 81, .external_lex_state = 7},
  [1944] = {.lex_state = 81, .external_lex_state = 7},
  [1945] = {.lex_state = 81, .external_lex_state = 7},
  [1946] = {.lex_state = 115, .external_lex_state = 6},
  [1947] = {.lex_state = 81, .external_lex_state = 7},
};

enum {
  ts_external_token__newline,
  ts_external_token__indent,
  ts_external_token__dedent,
  ts_external_token__string_start,
  ts_external_token__string_content,
  ts_external_token__string_end,
};

static TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__newline] = sym__newline,
  [ts_external_token__indent] = sym__indent,
  [ts_external_token__dedent] = sym__dedent,
  [ts_external_token__string_start] = sym__string_start,
  [ts_external_token__string_content] = sym__string_content,
  [ts_external_token__string_end] = sym__string_end,
};

static bool ts_external_scanner_states[8][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__newline] = true,
    [ts_external_token__indent] = true,
    [ts_external_token__dedent] = true,
    [ts_external_token__string_start] = true,
    [ts_external_token__string_content] = true,
    [ts_external_token__string_end] = true,
  },
  [2] = {
    [ts_external_token__string_start] = true,
  },
  [3] = {
    [ts_external_token__string_content] = true,
    [ts_external_token__string_end] = true,
  },
  [4] = {
    [ts_external_token__newline] = true,
    [ts_external_token__string_start] = true,
  },
  [5] = {
    [ts_external_token__newline] = true,
  },
  [6] = {
    [ts_external_token__indent] = true,
    [ts_external_token__string_start] = true,
  },
  [7] = {
    [ts_external_token__dedent] = true,
    [ts_external_token__string_start] = true,
  },
};

static uint16_t ts_parse_table[STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [sym__newline] = ACTIONS(1),
    [sym__indent] = ACTIONS(1),
    [sym__dedent] = ACTIONS(1),
    [sym__string_start] = ACTIONS(1),
    [sym__string_content] = ACTIONS(1),
    [sym__string_end] = ACTIONS(1),
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_import] = ACTIONS(3),
    [anon_sym_DOT] = ACTIONS(3),
    [anon_sym_from] = ACTIONS(3),
    [anon_sym___future__] = ACTIONS(3),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_as] = ACTIONS(3),
    [anon_sym_STAR] = ACTIONS(3),
    [anon_sym_print] = ACTIONS(3),
    [anon_sym_GT_GT] = ACTIONS(3),
    [anon_sym_assert] = ACTIONS(3),
    [anon_sym_return] = ACTIONS(3),
    [anon_sym_del] = ACTIONS(3),
    [anon_sym_raise] = ACTIONS(3),
    [anon_sym_pass] = ACTIONS(3),
    [anon_sym_break] = ACTIONS(3),
    [anon_sym_continue] = ACTIONS(3),
    [anon_sym_if] = ACTIONS(3),
    [anon_sym_COLON] = ACTIONS(1),
    [anon_sym_elif] = ACTIONS(3),
    [anon_sym_else] = ACTIONS(3),
    [anon_sym_async] = ACTIONS(3),
    [anon_sym_for] = ACTIONS(3),
    [anon_sym_in] = ACTIONS(3),
    [anon_sym_while] = ACTIONS(3),
    [anon_sym_try] = ACTIONS(3),
    [anon_sym_except] = ACTIONS(3),
    [anon_sym_finally] = ACTIONS(3),
    [anon_sym_with] = ACTIONS(3),
    [anon_sym_def] = ACTIONS(3),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_EQ] = ACTIONS(3),
    [anon_sym_global] = ACTIONS(3),
    [anon_sym_nonlocal] = ACTIONS(3),
    [anon_sym_exec] = ACTIONS(3),
    [anon_sym_class] = ACTIONS(3),
    [anon_sym_AT] = ACTIONS(3),
    [anon_sym_not] = ACTIONS(3),
    [anon_sym_and] = ACTIONS(3),
    [anon_sym_or] = ACTIONS(3),
    [anon_sym_PLUS] = ACTIONS(3),
    [anon_sym_DASH] = ACTIONS(3),
    [anon_sym_SLASH] = ACTIONS(3),
    [anon_sym_PERCENT] = ACTIONS(3),
    [anon_sym_SLASH_SLASH] = ACTIONS(3),
    [anon_sym_STAR_STAR] = ACTIONS(3),
    [anon_sym_PIPE] = ACTIONS(3),
    [anon_sym_AMP] = ACTIONS(3),
    [anon_sym_CARET] = ACTIONS(3),
    [anon_sym_LT_LT] = ACTIONS(3),
    [anon_sym_TILDE] = ACTIONS(1),
    [anon_sym_LT] = ACTIONS(3),
    [anon_sym_LT_EQ] = ACTIONS(1),
    [anon_sym_EQ_EQ] = ACTIONS(1),
    [anon_sym_BANG_EQ] = ACTIONS(1),
    [anon_sym_GT_EQ] = ACTIONS(1),
    [anon_sym_GT] = ACTIONS(3),
    [anon_sym_LT_GT] = ACTIONS(1),
    [anon_sym_is] = ACTIONS(3),
    [anon_sym_lambda] = ACTIONS(3),
    [anon_sym_PLUS_EQ] = ACTIONS(1),
    [anon_sym_DASH_EQ] = ACTIONS(1),
    [anon_sym_STAR_EQ] = ACTIONS(1),
    [anon_sym_SLASH_EQ] = ACTIONS(1),
    [anon_sym_AT_EQ] = ACTIONS(1),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1),
    [anon_sym_PERCENT_EQ] = ACTIONS(1),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1),
    [anon_sym_GT_GT_EQ] = ACTIONS(1),
    [anon_sym_LT_LT_EQ] = ACTIONS(1),
    [anon_sym_AMP_EQ] = ACTIONS(1),
    [anon_sym_CARET_EQ] = ACTIONS(1),
    [anon_sym_PIPE_EQ] = ACTIONS(1),
    [anon_sym_yield] = ACTIONS(3),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [sym_ellipsis] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [sym_type_conversion] = ACTIONS(1),
    [sym_integer] = ACTIONS(3),
    [sym_float] = ACTIONS(3),
    [sym_identifier] = ACTIONS(3),
    [sym_true] = ACTIONS(3),
    [sym_false] = ACTIONS(3),
    [sym_none] = ACTIONS(3),
    [anon_sym_await] = ACTIONS(3),
    [sym_comment] = ACTIONS(1),
    [sym__semicolon] = ACTIONS(1),
  },
  [1] = {
    [sym_module] = STATE(33),
    [sym__statement] = STATE(40),
    [sym__simple_statements] = STATE(40),
    [sym_import_statement] = STATE(34),
    [sym_future_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_if_statement] = STATE(40),
    [sym_for_statement] = STATE(40),
    [sym_while_statement] = STATE(40),
    [sym_try_statement] = STATE(40),
    [sym_with_statement] = STATE(40),
    [sym_function_definition] = STATE(40),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym_class_definition] = STATE(40),
    [sym_decorated_definition] = STATE(40),
    [sym_decorator] = STATE(41),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [aux_sym_module_repeat1] = STATE(40),
    [aux_sym_decorated_definition_repeat1] = STATE(41),
    [sym__string_start] = ACTIONS(5),
    [ts_builtin_sym_end] = ACTIONS(7),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_with] = ACTIONS(41),
    [anon_sym_def] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [2] = {
    [sym_interpolation] = STATE(44),
    [aux_sym_string_repeat1] = STATE(44),
    [sym__string_content] = ACTIONS(75),
    [sym__string_end] = ACTIONS(77),
    [anon_sym_LBRACE] = ACTIONS(79),
    [sym_escape_sequence] = ACTIONS(75),
    [sym_comment] = ACTIONS(81),
  },
  [3] = {
    [sym__import_list] = STATE(46),
    [sym_aliased_import] = STATE(47),
    [sym_dotted_name] = STATE(48),
    [sym_identifier] = ACTIONS(83),
    [sym_comment] = ACTIONS(73),
  },
  [4] = {
    [sym_import_prefix] = STATE(51),
    [sym_relative_import] = STATE(52),
    [sym_dotted_name] = STATE(52),
    [aux_sym_import_prefix_repeat1] = STATE(53),
    [anon_sym_DOT] = ACTIONS(85),
    [anon_sym___future__] = ACTIONS(87),
    [sym_identifier] = ACTIONS(89),
    [sym_comment] = ACTIONS(73),
  },
  [5] = {
    [sym__expression] = STATE(66),
    [sym__primary_expression] = STATE(67),
    [sym_not_operator] = STATE(66),
    [sym_boolean_operator] = STATE(66),
    [sym_binary_operator] = STATE(67),
    [sym_unary_operator] = STATE(67),
    [sym_comparison_operator] = STATE(66),
    [sym_lambda] = STATE(66),
    [sym_yield] = STATE(68),
    [sym_attribute] = STATE(67),
    [sym_subscript] = STATE(67),
    [sym_call] = STATE(67),
    [sym_list] = STATE(67),
    [sym_list_comprehension] = STATE(67),
    [sym_dictionary] = STATE(67),
    [sym_dictionary_comprehension] = STATE(67),
    [sym_set] = STATE(67),
    [sym_set_comprehension] = STATE(67),
    [sym_parenthesized_expression] = STATE(67),
    [sym_tuple] = STATE(67),
    [sym_generator_expression] = STATE(67),
    [sym_conditional_expression] = STATE(66),
    [sym_concatenated_string] = STATE(67),
    [sym_string] = STATE(69),
    [sym_await] = STATE(66),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(95),
    [anon_sym_COMMA] = ACTIONS(97),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(105),
    [anon_sym_yield] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [6] = {
    [sym_chevron] = STATE(80),
    [sym__expression] = STATE(81),
    [sym__primary_expression] = STATE(82),
    [sym_not_operator] = STATE(81),
    [sym_boolean_operator] = STATE(81),
    [sym_binary_operator] = STATE(82),
    [sym_unary_operator] = STATE(82),
    [sym_comparison_operator] = STATE(81),
    [sym_lambda] = STATE(81),
    [sym_attribute] = STATE(82),
    [sym_subscript] = STATE(82),
    [sym_call] = STATE(82),
    [sym_list] = STATE(82),
    [sym_list_comprehension] = STATE(82),
    [sym_dictionary] = STATE(82),
    [sym_dictionary_comprehension] = STATE(82),
    [sym_set] = STATE(82),
    [sym_set_comprehension] = STATE(82),
    [sym_parenthesized_expression] = STATE(82),
    [sym_tuple] = STATE(82),
    [sym_generator_expression] = STATE(82),
    [sym_conditional_expression] = STATE(81),
    [sym_concatenated_string] = STATE(82),
    [sym_string] = STATE(83),
    [sym_await] = STATE(81),
    [sym__newline] = ACTIONS(119),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_DOT] = ACTIONS(123),
    [anon_sym_LPAREN] = ACTIONS(119),
    [anon_sym_COMMA] = ACTIONS(119),
    [anon_sym_STAR] = ACTIONS(123),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_GT_GT] = ACTIONS(127),
    [anon_sym_if] = ACTIONS(123),
    [anon_sym_COLON] = ACTIONS(119),
    [anon_sym_in] = ACTIONS(123),
    [anon_sym_EQ] = ACTIONS(123),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_AT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(123),
    [anon_sym_and] = ACTIONS(123),
    [anon_sym_or] = ACTIONS(123),
    [anon_sym_PLUS] = ACTIONS(123),
    [anon_sym_DASH] = ACTIONS(123),
    [anon_sym_SLASH] = ACTIONS(123),
    [anon_sym_PERCENT] = ACTIONS(123),
    [anon_sym_SLASH_SLASH] = ACTIONS(123),
    [anon_sym_STAR_STAR] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(123),
    [anon_sym_LT_LT] = ACTIONS(123),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_LT] = ACTIONS(123),
    [anon_sym_LT_EQ] = ACTIONS(119),
    [anon_sym_EQ_EQ] = ACTIONS(119),
    [anon_sym_BANG_EQ] = ACTIONS(119),
    [anon_sym_GT_EQ] = ACTIONS(119),
    [anon_sym_GT] = ACTIONS(123),
    [anon_sym_LT_GT] = ACTIONS(119),
    [anon_sym_is] = ACTIONS(123),
    [anon_sym_lambda] = ACTIONS(131),
    [anon_sym_PLUS_EQ] = ACTIONS(119),
    [anon_sym_DASH_EQ] = ACTIONS(119),
    [anon_sym_STAR_EQ] = ACTIONS(119),
    [anon_sym_SLASH_EQ] = ACTIONS(119),
    [anon_sym_AT_EQ] = ACTIONS(119),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(119),
    [anon_sym_PERCENT_EQ] = ACTIONS(119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(119),
    [anon_sym_GT_GT_EQ] = ACTIONS(119),
    [anon_sym_LT_LT_EQ] = ACTIONS(119),
    [anon_sym_AMP_EQ] = ACTIONS(119),
    [anon_sym_CARET_EQ] = ACTIONS(119),
    [anon_sym_PIPE_EQ] = ACTIONS(119),
    [anon_sym_LBRACK] = ACTIONS(119),
    [sym_ellipsis] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(137),
    [sym_float] = ACTIONS(137),
    [sym_identifier] = ACTIONS(137),
    [sym_true] = ACTIONS(137),
    [sym_false] = ACTIONS(137),
    [sym_none] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(119),
  },
  [7] = {
    [sym__expression] = STATE(84),
    [sym__primary_expression] = STATE(82),
    [sym_not_operator] = STATE(84),
    [sym_boolean_operator] = STATE(84),
    [sym_binary_operator] = STATE(82),
    [sym_unary_operator] = STATE(82),
    [sym_comparison_operator] = STATE(84),
    [sym_lambda] = STATE(84),
    [sym_attribute] = STATE(82),
    [sym_subscript] = STATE(82),
    [sym_call] = STATE(82),
    [sym_list] = STATE(82),
    [sym_list_comprehension] = STATE(82),
    [sym_dictionary] = STATE(82),
    [sym_dictionary_comprehension] = STATE(82),
    [sym_set] = STATE(82),
    [sym_set_comprehension] = STATE(82),
    [sym_parenthesized_expression] = STATE(82),
    [sym_tuple] = STATE(82),
    [sym_generator_expression] = STATE(82),
    [sym_conditional_expression] = STATE(84),
    [sym_concatenated_string] = STATE(82),
    [sym_string] = STATE(83),
    [sym_await] = STATE(84),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_lambda] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(137),
    [sym_float] = ACTIONS(137),
    [sym_identifier] = ACTIONS(137),
    [sym_true] = ACTIONS(137),
    [sym_false] = ACTIONS(137),
    [sym_none] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
  },
  [8] = {
    [sym_expression_list] = STATE(85),
    [sym__expression] = STATE(86),
    [sym__primary_expression] = STATE(82),
    [sym_not_operator] = STATE(86),
    [sym_boolean_operator] = STATE(86),
    [sym_binary_operator] = STATE(82),
    [sym_unary_operator] = STATE(82),
    [sym_comparison_operator] = STATE(86),
    [sym_lambda] = STATE(86),
    [sym_attribute] = STATE(82),
    [sym_subscript] = STATE(82),
    [sym_call] = STATE(82),
    [sym_list] = STATE(82),
    [sym_list_comprehension] = STATE(82),
    [sym_dictionary] = STATE(82),
    [sym_dictionary_comprehension] = STATE(82),
    [sym_set] = STATE(82),
    [sym_set_comprehension] = STATE(82),
    [sym_parenthesized_expression] = STATE(82),
    [sym_tuple] = STATE(82),
    [sym_generator_expression] = STATE(82),
    [sym_conditional_expression] = STATE(86),
    [sym_concatenated_string] = STATE(82),
    [sym_string] = STATE(83),
    [sym_await] = STATE(86),
    [sym__newline] = ACTIONS(147),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_lambda] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(137),
    [sym_float] = ACTIONS(137),
    [sym_identifier] = ACTIONS(137),
    [sym_true] = ACTIONS(137),
    [sym_false] = ACTIONS(137),
    [sym_none] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(147),
  },
  [9] = {
    [sym_expression_list] = STATE(87),
    [sym__expression] = STATE(86),
    [sym__primary_expression] = STATE(82),
    [sym_not_operator] = STATE(86),
    [sym_boolean_operator] = STATE(86),
    [sym_binary_operator] = STATE(82),
    [sym_unary_operator] = STATE(82),
    [sym_comparison_operator] = STATE(86),
    [sym_lambda] = STATE(86),
    [sym_attribute] = STATE(82),
    [sym_subscript] = STATE(82),
    [sym_call] = STATE(82),
    [sym_list] = STATE(82),
    [sym_list_comprehension] = STATE(82),
    [sym_dictionary] = STATE(82),
    [sym_dictionary_comprehension] = STATE(82),
    [sym_set] = STATE(82),
    [sym_set_comprehension] = STATE(82),
    [sym_parenthesized_expression] = STATE(82),
    [sym_tuple] = STATE(82),
    [sym_generator_expression] = STATE(82),
    [sym_conditional_expression] = STATE(86),
    [sym_concatenated_string] = STATE(82),
    [sym_string] = STATE(83),
    [sym_await] = STATE(86),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_lambda] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(137),
    [sym_float] = ACTIONS(137),
    [sym_identifier] = ACTIONS(137),
    [sym_true] = ACTIONS(137),
    [sym_false] = ACTIONS(137),
    [sym_none] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
  },
  [10] = {
    [sym_expression_list] = STATE(93),
    [sym__expression] = STATE(94),
    [sym__primary_expression] = STATE(95),
    [sym_not_operator] = STATE(94),
    [sym_boolean_operator] = STATE(94),
    [sym_binary_operator] = STATE(95),
    [sym_unary_operator] = STATE(95),
    [sym_comparison_operator] = STATE(94),
    [sym_lambda] = STATE(94),
    [sym_attribute] = STATE(95),
    [sym_subscript] = STATE(95),
    [sym_call] = STATE(95),
    [sym_list] = STATE(95),
    [sym_list_comprehension] = STATE(95),
    [sym_dictionary] = STATE(95),
    [sym_dictionary_comprehension] = STATE(95),
    [sym_set] = STATE(95),
    [sym_set_comprehension] = STATE(95),
    [sym_parenthesized_expression] = STATE(95),
    [sym_tuple] = STATE(95),
    [sym_generator_expression] = STATE(95),
    [sym_conditional_expression] = STATE(94),
    [sym_concatenated_string] = STATE(95),
    [sym_string] = STATE(96),
    [sym_await] = STATE(94),
    [sym__newline] = ACTIONS(149),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(151),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_lambda] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(159),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(161),
    [sym_float] = ACTIONS(161),
    [sym_identifier] = ACTIONS(161),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [sym_none] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(149),
  },
  [11] = {
    [sym__newline] = ACTIONS(165),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(165),
  },
  [12] = {
    [sym__newline] = ACTIONS(167),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(167),
  },
  [13] = {
    [sym__newline] = ACTIONS(169),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(169),
  },
  [14] = {
    [sym__expression] = STATE(101),
    [sym__primary_expression] = STATE(102),
    [sym_not_operator] = STATE(101),
    [sym_boolean_operator] = STATE(101),
    [sym_binary_operator] = STATE(102),
    [sym_unary_operator] = STATE(102),
    [sym_comparison_operator] = STATE(101),
    [sym_lambda] = STATE(101),
    [sym_attribute] = STATE(102),
    [sym_subscript] = STATE(102),
    [sym_call] = STATE(102),
    [sym_list] = STATE(102),
    [sym_list_comprehension] = STATE(102),
    [sym_dictionary] = STATE(102),
    [sym_dictionary_comprehension] = STATE(102),
    [sym_set] = STATE(102),
    [sym_set_comprehension] = STATE(102),
    [sym_parenthesized_expression] = STATE(102),
    [sym_tuple] = STATE(102),
    [sym_generator_expression] = STATE(102),
    [sym_conditional_expression] = STATE(101),
    [sym_concatenated_string] = STATE(102),
    [sym_string] = STATE(103),
    [sym_await] = STATE(101),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [15] = {
    [anon_sym_for] = ACTIONS(183),
    [anon_sym_with] = ACTIONS(185),
    [anon_sym_def] = ACTIONS(187),
    [sym_comment] = ACTIONS(73),
  },
  [16] = {
    [sym_variables] = STATE(108),
    [sym__primary_expression] = STATE(109),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(110),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(191),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(193),
    [sym_float] = ACTIONS(193),
    [sym_identifier] = ACTIONS(193),
    [sym_true] = ACTIONS(193),
    [sym_false] = ACTIONS(193),
    [sym_none] = ACTIONS(193),
    [sym_comment] = ACTIONS(73),
  },
  [17] = {
    [sym__expression] = STATE(111),
    [sym__primary_expression] = STATE(102),
    [sym_not_operator] = STATE(111),
    [sym_boolean_operator] = STATE(111),
    [sym_binary_operator] = STATE(102),
    [sym_unary_operator] = STATE(102),
    [sym_comparison_operator] = STATE(111),
    [sym_lambda] = STATE(111),
    [sym_attribute] = STATE(102),
    [sym_subscript] = STATE(102),
    [sym_call] = STATE(102),
    [sym_list] = STATE(102),
    [sym_list_comprehension] = STATE(102),
    [sym_dictionary] = STATE(102),
    [sym_dictionary_comprehension] = STATE(102),
    [sym_set] = STATE(102),
    [sym_set_comprehension] = STATE(102),
    [sym_parenthesized_expression] = STATE(102),
    [sym_tuple] = STATE(102),
    [sym_generator_expression] = STATE(102),
    [sym_conditional_expression] = STATE(111),
    [sym_concatenated_string] = STATE(102),
    [sym_string] = STATE(103),
    [sym_await] = STATE(111),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [18] = {
    [anon_sym_COLON] = ACTIONS(195),
    [sym_comment] = ACTIONS(73),
  },
  [19] = {
    [sym_with_item] = STATE(117),
    [sym__expression] = STATE(118),
    [sym__primary_expression] = STATE(119),
    [sym_not_operator] = STATE(118),
    [sym_boolean_operator] = STATE(118),
    [sym_binary_operator] = STATE(119),
    [sym_unary_operator] = STATE(119),
    [sym_comparison_operator] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym_attribute] = STATE(119),
    [sym_subscript] = STATE(119),
    [sym_call] = STATE(119),
    [sym_list] = STATE(119),
    [sym_list_comprehension] = STATE(119),
    [sym_dictionary] = STATE(119),
    [sym_dictionary_comprehension] = STATE(119),
    [sym_set] = STATE(119),
    [sym_set_comprehension] = STATE(119),
    [sym_parenthesized_expression] = STATE(119),
    [sym_tuple] = STATE(119),
    [sym_generator_expression] = STATE(119),
    [sym_conditional_expression] = STATE(118),
    [sym_concatenated_string] = STATE(119),
    [sym_string] = STATE(120),
    [sym_await] = STATE(118),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(197),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_lambda] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(203),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(205),
    [sym_float] = ACTIONS(205),
    [sym_identifier] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_none] = ACTIONS(205),
    [anon_sym_await] = ACTIONS(207),
    [sym_comment] = ACTIONS(73),
  },
  [20] = {
    [sym_identifier] = ACTIONS(209),
    [sym_comment] = ACTIONS(73),
  },
  [21] = {
    [sym_identifier] = ACTIONS(211),
    [sym_comment] = ACTIONS(73),
  },
  [22] = {
    [sym_identifier] = ACTIONS(213),
    [sym_comment] = ACTIONS(73),
  },
  [23] = {
    [sym_string] = STATE(125),
    [sym__newline] = ACTIONS(119),
    [sym__string_start] = ACTIONS(215),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_LPAREN] = ACTIONS(119),
    [anon_sym_COMMA] = ACTIONS(119),
    [anon_sym_STAR] = ACTIONS(123),
    [anon_sym_GT_GT] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_COLON] = ACTIONS(119),
    [anon_sym_in] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(123),
    [anon_sym_AT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(119),
    [anon_sym_and] = ACTIONS(119),
    [anon_sym_or] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(123),
    [anon_sym_DASH] = ACTIONS(123),
    [anon_sym_SLASH] = ACTIONS(123),
    [anon_sym_PERCENT] = ACTIONS(123),
    [anon_sym_SLASH_SLASH] = ACTIONS(123),
    [anon_sym_STAR_STAR] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(123),
    [anon_sym_LT_LT] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(123),
    [anon_sym_LT_EQ] = ACTIONS(119),
    [anon_sym_EQ_EQ] = ACTIONS(119),
    [anon_sym_BANG_EQ] = ACTIONS(119),
    [anon_sym_GT_EQ] = ACTIONS(119),
    [anon_sym_GT] = ACTIONS(123),
    [anon_sym_LT_GT] = ACTIONS(119),
    [anon_sym_is] = ACTIONS(119),
    [anon_sym_PLUS_EQ] = ACTIONS(119),
    [anon_sym_DASH_EQ] = ACTIONS(119),
    [anon_sym_STAR_EQ] = ACTIONS(119),
    [anon_sym_SLASH_EQ] = ACTIONS(119),
    [anon_sym_AT_EQ] = ACTIONS(119),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(119),
    [anon_sym_PERCENT_EQ] = ACTIONS(119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(119),
    [anon_sym_GT_GT_EQ] = ACTIONS(119),
    [anon_sym_LT_LT_EQ] = ACTIONS(119),
    [anon_sym_AMP_EQ] = ACTIONS(119),
    [anon_sym_CARET_EQ] = ACTIONS(119),
    [anon_sym_PIPE_EQ] = ACTIONS(119),
    [anon_sym_LBRACK] = ACTIONS(119),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(119),
  },
  [24] = {
    [sym_identifier] = ACTIONS(217),
    [sym_comment] = ACTIONS(73),
  },
  [25] = {
    [sym_dotted_name] = STATE(128),
    [sym_identifier] = ACTIONS(219),
    [sym_comment] = ACTIONS(73),
  },
  [26] = {
    [sym__expression] = STATE(130),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(130),
    [sym_boolean_operator] = STATE(130),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(130),
    [sym_lambda] = STATE(130),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(130),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(130),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [27] = {
    [sym__primary_expression] = STATE(131),
    [sym_binary_operator] = STATE(131),
    [sym_unary_operator] = STATE(131),
    [sym_attribute] = STATE(131),
    [sym_subscript] = STATE(131),
    [sym_call] = STATE(131),
    [sym_list] = STATE(131),
    [sym_list_comprehension] = STATE(131),
    [sym_dictionary] = STATE(131),
    [sym_dictionary_comprehension] = STATE(131),
    [sym_set] = STATE(131),
    [sym_set_comprehension] = STATE(131),
    [sym_parenthesized_expression] = STATE(131),
    [sym_tuple] = STATE(131),
    [sym_generator_expression] = STATE(131),
    [sym_concatenated_string] = STATE(131),
    [sym_string] = STATE(39),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(223),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(225),
    [sym_float] = ACTIONS(225),
    [sym_identifier] = ACTIONS(225),
    [sym_true] = ACTIONS(225),
    [sym_false] = ACTIONS(225),
    [sym_none] = ACTIONS(225),
    [sym_comment] = ACTIONS(73),
  },
  [28] = {
    [sym_lambda_parameters] = STATE(137),
    [sym__parameters] = STATE(138),
    [sym_default_parameter] = STATE(139),
    [sym_typed_default_parameter] = STATE(139),
    [sym_list_splat] = STATE(140),
    [sym_dictionary_splat] = STATE(140),
    [sym_typed_parameter] = STATE(139),
    [sym_tuple] = STATE(139),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(233),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [29] = {
    [sym_expression_list] = STATE(142),
    [sym__expression] = STATE(86),
    [sym__primary_expression] = STATE(82),
    [sym_not_operator] = STATE(86),
    [sym_boolean_operator] = STATE(86),
    [sym_binary_operator] = STATE(82),
    [sym_unary_operator] = STATE(82),
    [sym_comparison_operator] = STATE(86),
    [sym_lambda] = STATE(86),
    [sym_attribute] = STATE(82),
    [sym_subscript] = STATE(82),
    [sym_call] = STATE(82),
    [sym_list] = STATE(82),
    [sym_list_comprehension] = STATE(82),
    [sym_dictionary] = STATE(82),
    [sym_dictionary_comprehension] = STATE(82),
    [sym_set] = STATE(82),
    [sym_set_comprehension] = STATE(82),
    [sym_parenthesized_expression] = STATE(82),
    [sym_tuple] = STATE(82),
    [sym_generator_expression] = STATE(82),
    [sym_conditional_expression] = STATE(86),
    [sym_concatenated_string] = STATE(82),
    [sym_string] = STATE(83),
    [sym_await] = STATE(86),
    [sym__newline] = ACTIONS(237),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(239),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_lambda] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(137),
    [sym_float] = ACTIONS(137),
    [sym_identifier] = ACTIONS(137),
    [sym_true] = ACTIONS(137),
    [sym_false] = ACTIONS(137),
    [sym_none] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(237),
  },
  [30] = {
    [sym_list_splat] = STATE(150),
    [sym__expression] = STATE(151),
    [sym__primary_expression] = STATE(152),
    [sym_not_operator] = STATE(151),
    [sym_boolean_operator] = STATE(151),
    [sym_binary_operator] = STATE(152),
    [sym_unary_operator] = STATE(152),
    [sym_comparison_operator] = STATE(151),
    [sym_lambda] = STATE(151),
    [sym_attribute] = STATE(152),
    [sym_subscript] = STATE(152),
    [sym_call] = STATE(152),
    [sym_list] = STATE(152),
    [sym_list_comprehension] = STATE(152),
    [sym_dictionary] = STATE(152),
    [sym_dictionary_comprehension] = STATE(152),
    [sym_set] = STATE(152),
    [sym_set_comprehension] = STATE(152),
    [sym_parenthesized_expression] = STATE(152),
    [sym_tuple] = STATE(152),
    [sym_generator_expression] = STATE(152),
    [sym_conditional_expression] = STATE(151),
    [sym_concatenated_string] = STATE(152),
    [sym_string] = STATE(153),
    [sym_await] = STATE(151),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_COMMA] = ACTIONS(241),
    [anon_sym_STAR] = ACTIONS(243),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_lambda] = ACTIONS(249),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(251),
    [sym_ellipsis] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(255),
    [sym_float] = ACTIONS(255),
    [sym_identifier] = ACTIONS(255),
    [sym_true] = ACTIONS(255),
    [sym_false] = ACTIONS(255),
    [sym_none] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [sym_comment] = ACTIONS(73),
  },
  [31] = {
    [sym_list_splat] = STATE(161),
    [sym_dictionary_splat] = STATE(162),
    [sym__expression] = STATE(163),
    [sym__primary_expression] = STATE(164),
    [sym_not_operator] = STATE(163),
    [sym_boolean_operator] = STATE(163),
    [sym_binary_operator] = STATE(164),
    [sym_unary_operator] = STATE(164),
    [sym_comparison_operator] = STATE(163),
    [sym_lambda] = STATE(163),
    [sym_attribute] = STATE(164),
    [sym_subscript] = STATE(164),
    [sym_call] = STATE(164),
    [sym_list] = STATE(164),
    [sym_list_comprehension] = STATE(164),
    [sym_dictionary] = STATE(164),
    [sym_dictionary_comprehension] = STATE(164),
    [sym_pair] = STATE(165),
    [sym_set] = STATE(164),
    [sym_set_comprehension] = STATE(164),
    [sym_parenthesized_expression] = STATE(164),
    [sym_tuple] = STATE(164),
    [sym_generator_expression] = STATE(164),
    [sym_conditional_expression] = STATE(163),
    [sym_concatenated_string] = STATE(164),
    [sym_string] = STATE(166),
    [sym_await] = STATE(163),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_COMMA] = ACTIONS(259),
    [anon_sym_STAR] = ACTIONS(261),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_lambda] = ACTIONS(267),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(271),
    [sym_integer] = ACTIONS(273),
    [sym_float] = ACTIONS(273),
    [sym_identifier] = ACTIONS(273),
    [sym_true] = ACTIONS(273),
    [sym_false] = ACTIONS(273),
    [sym_none] = ACTIONS(273),
    [anon_sym_await] = ACTIONS(275),
    [sym_comment] = ACTIONS(73),
  },
  [32] = {
    [sym__expression] = STATE(167),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(167),
    [sym_boolean_operator] = STATE(167),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(167),
    [sym_lambda] = STATE(167),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(167),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(167),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [33] = {
    [ts_builtin_sym_end] = ACTIONS(277),
    [sym_comment] = ACTIONS(73),
  },
  [34] = {
    [aux_sym__simple_statements_repeat1] = STATE(170),
    [sym__newline] = ACTIONS(279),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(281),
  },
  [35] = {
    [anon_sym_COLON] = ACTIONS(283),
    [anon_sym_EQ] = ACTIONS(285),
    [anon_sym_PLUS_EQ] = ACTIONS(287),
    [anon_sym_DASH_EQ] = ACTIONS(287),
    [anon_sym_STAR_EQ] = ACTIONS(287),
    [anon_sym_SLASH_EQ] = ACTIONS(287),
    [anon_sym_AT_EQ] = ACTIONS(287),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(287),
    [anon_sym_PERCENT_EQ] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(287),
    [anon_sym_GT_GT_EQ] = ACTIONS(287),
    [anon_sym_LT_LT_EQ] = ACTIONS(287),
    [anon_sym_AMP_EQ] = ACTIONS(287),
    [anon_sym_CARET_EQ] = ACTIONS(287),
    [anon_sym_PIPE_EQ] = ACTIONS(287),
    [sym_comment] = ACTIONS(73),
  },
  [36] = {
    [aux_sym_print_statement_repeat1] = STATE(178),
    [sym__newline] = ACTIONS(289),
    [anon_sym_COMMA] = ACTIONS(291),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_COLON] = ACTIONS(295),
    [anon_sym_EQ] = ACTIONS(295),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(299),
    [anon_sym_PLUS_EQ] = ACTIONS(295),
    [anon_sym_DASH_EQ] = ACTIONS(295),
    [anon_sym_STAR_EQ] = ACTIONS(295),
    [anon_sym_SLASH_EQ] = ACTIONS(295),
    [anon_sym_AT_EQ] = ACTIONS(295),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(295),
    [anon_sym_PERCENT_EQ] = ACTIONS(295),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(295),
    [anon_sym_GT_GT_EQ] = ACTIONS(295),
    [anon_sym_LT_LT_EQ] = ACTIONS(295),
    [anon_sym_AMP_EQ] = ACTIONS(295),
    [anon_sym_CARET_EQ] = ACTIONS(295),
    [anon_sym_PIPE_EQ] = ACTIONS(295),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(289),
  },
  [37] = {
    [sym_argument_list] = STATE(192),
    [sym_generator_expression] = STATE(192),
    [aux_sym_comparison_operator_repeat1] = STATE(193),
    [sym__newline] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(303),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(307),
    [anon_sym_GT_GT] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_EQ] = ACTIONS(313),
    [anon_sym_AT] = ACTIONS(307),
    [anon_sym_not] = ACTIONS(315),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(317),
    [anon_sym_SLASH] = ACTIONS(307),
    [anon_sym_PERCENT] = ACTIONS(307),
    [anon_sym_SLASH_SLASH] = ACTIONS(307),
    [anon_sym_STAR_STAR] = ACTIONS(319),
    [anon_sym_PIPE] = ACTIONS(321),
    [anon_sym_AMP] = ACTIONS(323),
    [anon_sym_CARET] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_LT_EQ] = ACTIONS(311),
    [anon_sym_EQ_EQ] = ACTIONS(311),
    [anon_sym_BANG_EQ] = ACTIONS(311),
    [anon_sym_GT_EQ] = ACTIONS(311),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_LT_GT] = ACTIONS(311),
    [anon_sym_is] = ACTIONS(329),
    [anon_sym_PLUS_EQ] = ACTIONS(301),
    [anon_sym_DASH_EQ] = ACTIONS(301),
    [anon_sym_STAR_EQ] = ACTIONS(301),
    [anon_sym_SLASH_EQ] = ACTIONS(301),
    [anon_sym_AT_EQ] = ACTIONS(301),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(301),
    [anon_sym_PERCENT_EQ] = ACTIONS(301),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(301),
    [anon_sym_GT_GT_EQ] = ACTIONS(301),
    [anon_sym_LT_LT_EQ] = ACTIONS(301),
    [anon_sym_AMP_EQ] = ACTIONS(301),
    [anon_sym_CARET_EQ] = ACTIONS(301),
    [anon_sym_PIPE_EQ] = ACTIONS(301),
    [anon_sym_LBRACK] = ACTIONS(331),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(301),
  },
  [38] = {
    [sym__newline] = ACTIONS(289),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(289),
  },
  [39] = {
    [sym_string] = STATE(194),
    [aux_sym_concatenated_string_repeat1] = STATE(194),
    [sym__newline] = ACTIONS(333),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(335),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_COLON] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_EQ] = ACTIONS(335),
    [anon_sym_AT] = ACTIONS(335),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(335),
    [anon_sym_DASH] = ACTIONS(335),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(335),
    [anon_sym_SLASH_SLASH] = ACTIONS(335),
    [anon_sym_STAR_STAR] = ACTIONS(335),
    [anon_sym_PIPE] = ACTIONS(335),
    [anon_sym_AMP] = ACTIONS(335),
    [anon_sym_CARET] = ACTIONS(335),
    [anon_sym_LT_LT] = ACTIONS(335),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_PLUS_EQ] = ACTIONS(333),
    [anon_sym_DASH_EQ] = ACTIONS(333),
    [anon_sym_STAR_EQ] = ACTIONS(333),
    [anon_sym_SLASH_EQ] = ACTIONS(333),
    [anon_sym_AT_EQ] = ACTIONS(333),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(333),
    [anon_sym_PERCENT_EQ] = ACTIONS(333),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(333),
    [anon_sym_GT_GT_EQ] = ACTIONS(333),
    [anon_sym_LT_LT_EQ] = ACTIONS(333),
    [anon_sym_AMP_EQ] = ACTIONS(333),
    [anon_sym_CARET_EQ] = ACTIONS(333),
    [anon_sym_PIPE_EQ] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(333),
  },
  [40] = {
    [sym__statement] = STATE(195),
    [sym__simple_statements] = STATE(195),
    [sym_import_statement] = STATE(34),
    [sym_future_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_if_statement] = STATE(195),
    [sym_for_statement] = STATE(195),
    [sym_while_statement] = STATE(195),
    [sym_try_statement] = STATE(195),
    [sym_with_statement] = STATE(195),
    [sym_function_definition] = STATE(195),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym_class_definition] = STATE(195),
    [sym_decorated_definition] = STATE(195),
    [sym_decorator] = STATE(41),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [aux_sym_module_repeat1] = STATE(195),
    [aux_sym_decorated_definition_repeat1] = STATE(41),
    [sym__string_start] = ACTIONS(5),
    [ts_builtin_sym_end] = ACTIONS(337),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(31),
    [anon_sym_async] = ACTIONS(33),
    [anon_sym_for] = ACTIONS(35),
    [anon_sym_while] = ACTIONS(37),
    [anon_sym_try] = ACTIONS(39),
    [anon_sym_with] = ACTIONS(41),
    [anon_sym_def] = ACTIONS(43),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(51),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [41] = {
    [sym_function_definition] = STATE(197),
    [sym_class_definition] = STATE(197),
    [sym_decorator] = STATE(198),
    [aux_sym_decorated_definition_repeat1] = STATE(198),
    [anon_sym_async] = ACTIONS(339),
    [anon_sym_def] = ACTIONS(341),
    [anon_sym_class] = ACTIONS(343),
    [anon_sym_AT] = ACTIONS(53),
    [sym_comment] = ACTIONS(73),
  },
  [42] = {
    [sym__newline] = ACTIONS(345),
    [sym__string_start] = ACTIONS(345),
    [anon_sym_DOT] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(345),
    [anon_sym_STAR] = ACTIONS(347),
    [anon_sym_GT_GT] = ACTIONS(347),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_COLON] = ACTIONS(345),
    [anon_sym_in] = ACTIONS(345),
    [anon_sym_EQ] = ACTIONS(347),
    [anon_sym_AT] = ACTIONS(347),
    [anon_sym_not] = ACTIONS(345),
    [anon_sym_and] = ACTIONS(345),
    [anon_sym_or] = ACTIONS(345),
    [anon_sym_PLUS] = ACTIONS(347),
    [anon_sym_DASH] = ACTIONS(347),
    [anon_sym_SLASH] = ACTIONS(347),
    [anon_sym_PERCENT] = ACTIONS(347),
    [anon_sym_SLASH_SLASH] = ACTIONS(347),
    [anon_sym_STAR_STAR] = ACTIONS(347),
    [anon_sym_PIPE] = ACTIONS(347),
    [anon_sym_AMP] = ACTIONS(347),
    [anon_sym_CARET] = ACTIONS(347),
    [anon_sym_LT_LT] = ACTIONS(347),
    [anon_sym_LT] = ACTIONS(347),
    [anon_sym_LT_EQ] = ACTIONS(345),
    [anon_sym_EQ_EQ] = ACTIONS(345),
    [anon_sym_BANG_EQ] = ACTIONS(345),
    [anon_sym_GT_EQ] = ACTIONS(345),
    [anon_sym_GT] = ACTIONS(347),
    [anon_sym_LT_GT] = ACTIONS(345),
    [anon_sym_is] = ACTIONS(345),
    [anon_sym_PLUS_EQ] = ACTIONS(345),
    [anon_sym_DASH_EQ] = ACTIONS(345),
    [anon_sym_STAR_EQ] = ACTIONS(345),
    [anon_sym_SLASH_EQ] = ACTIONS(345),
    [anon_sym_AT_EQ] = ACTIONS(345),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(345),
    [anon_sym_PERCENT_EQ] = ACTIONS(345),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(345),
    [anon_sym_GT_GT_EQ] = ACTIONS(345),
    [anon_sym_LT_LT_EQ] = ACTIONS(345),
    [anon_sym_AMP_EQ] = ACTIONS(345),
    [anon_sym_CARET_EQ] = ACTIONS(345),
    [anon_sym_PIPE_EQ] = ACTIONS(345),
    [anon_sym_LBRACK] = ACTIONS(345),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(345),
  },
  [43] = {
    [sym__expression] = STATE(203),
    [sym__primary_expression] = STATE(204),
    [sym_not_operator] = STATE(203),
    [sym_boolean_operator] = STATE(203),
    [sym_binary_operator] = STATE(204),
    [sym_unary_operator] = STATE(204),
    [sym_comparison_operator] = STATE(203),
    [sym_lambda] = STATE(203),
    [sym_attribute] = STATE(204),
    [sym_subscript] = STATE(204),
    [sym_call] = STATE(204),
    [sym_list] = STATE(204),
    [sym_list_comprehension] = STATE(204),
    [sym_dictionary] = STATE(204),
    [sym_dictionary_comprehension] = STATE(204),
    [sym_set] = STATE(204),
    [sym_set_comprehension] = STATE(204),
    [sym_parenthesized_expression] = STATE(204),
    [sym_tuple] = STATE(204),
    [sym_generator_expression] = STATE(204),
    [sym_conditional_expression] = STATE(203),
    [sym_concatenated_string] = STATE(204),
    [sym_string] = STATE(205),
    [sym_await] = STATE(203),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(349),
    [anon_sym_PLUS] = ACTIONS(351),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_lambda] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_identifier] = ACTIONS(357),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_none] = ACTIONS(357),
    [anon_sym_await] = ACTIONS(359),
    [sym_comment] = ACTIONS(73),
  },
  [44] = {
    [sym_interpolation] = STATE(207),
    [aux_sym_string_repeat1] = STATE(207),
    [sym__string_content] = ACTIONS(361),
    [sym__string_end] = ACTIONS(363),
    [anon_sym_LBRACE] = ACTIONS(79),
    [sym_escape_sequence] = ACTIONS(361),
    [sym_comment] = ACTIONS(81),
  },
  [45] = {
    [aux_sym_dotted_name_repeat1] = STATE(209),
    [sym__newline] = ACTIONS(365),
    [anon_sym_DOT] = ACTIONS(367),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_as] = ACTIONS(365),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(365),
  },
  [46] = {
    [sym__newline] = ACTIONS(369),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(369),
  },
  [47] = {
    [aux_sym__import_list_repeat1] = STATE(211),
    [sym__newline] = ACTIONS(371),
    [anon_sym_COMMA] = ACTIONS(373),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(371),
  },
  [48] = {
    [aux_sym__import_list_repeat1] = STATE(211),
    [sym__newline] = ACTIONS(371),
    [anon_sym_COMMA] = ACTIONS(373),
    [anon_sym_as] = ACTIONS(375),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(371),
  },
  [49] = {
    [anon_sym_import] = ACTIONS(377),
    [sym_comment] = ACTIONS(73),
  },
  [50] = {
    [aux_sym_dotted_name_repeat1] = STATE(215),
    [anon_sym_import] = ACTIONS(365),
    [anon_sym_DOT] = ACTIONS(379),
    [sym_comment] = ACTIONS(73),
  },
  [51] = {
    [sym_dotted_name] = STATE(216),
    [anon_sym_import] = ACTIONS(381),
    [sym_identifier] = ACTIONS(89),
    [sym_comment] = ACTIONS(73),
  },
  [52] = {
    [anon_sym_import] = ACTIONS(383),
    [sym_comment] = ACTIONS(73),
  },
  [53] = {
    [aux_sym_import_prefix_repeat1] = STATE(218),
    [anon_sym_import] = ACTIONS(385),
    [anon_sym_DOT] = ACTIONS(387),
    [sym_identifier] = ACTIONS(385),
    [sym_comment] = ACTIONS(73),
  },
  [54] = {
    [sym_interpolation] = STATE(220),
    [aux_sym_string_repeat1] = STATE(220),
    [sym__string_content] = ACTIONS(389),
    [sym__string_end] = ACTIONS(391),
    [anon_sym_LBRACE] = ACTIONS(79),
    [sym_escape_sequence] = ACTIONS(389),
    [sym_comment] = ACTIONS(81),
  },
  [55] = {
    [sym__expression] = STATE(223),
    [sym__primary_expression] = STATE(67),
    [sym_not_operator] = STATE(223),
    [sym_boolean_operator] = STATE(223),
    [sym_binary_operator] = STATE(67),
    [sym_unary_operator] = STATE(67),
    [sym_comparison_operator] = STATE(223),
    [sym_lambda] = STATE(223),
    [sym_yield] = STATE(224),
    [sym_attribute] = STATE(67),
    [sym_subscript] = STATE(67),
    [sym_call] = STATE(67),
    [sym_list] = STATE(67),
    [sym_list_comprehension] = STATE(67),
    [sym_dictionary] = STATE(67),
    [sym_dictionary_comprehension] = STATE(67),
    [sym_set] = STATE(67),
    [sym_set_comprehension] = STATE(67),
    [sym_parenthesized_expression] = STATE(67),
    [sym_tuple] = STATE(67),
    [sym_generator_expression] = STATE(67),
    [sym_conditional_expression] = STATE(223),
    [sym_concatenated_string] = STATE(67),
    [sym_string] = STATE(69),
    [sym_await] = STATE(223),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(393),
    [anon_sym_COMMA] = ACTIONS(395),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(105),
    [anon_sym_yield] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [56] = {
    [sym__newline] = ACTIONS(397),
    [anon_sym_DOT] = ACTIONS(397),
    [anon_sym_LPAREN] = ACTIONS(397),
    [anon_sym_COMMA] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_GT_GT] = ACTIONS(399),
    [anon_sym_if] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(397),
    [anon_sym_in] = ACTIONS(397),
    [anon_sym_EQ] = ACTIONS(399),
    [anon_sym_AT] = ACTIONS(399),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_and] = ACTIONS(397),
    [anon_sym_or] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(399),
    [anon_sym_DASH] = ACTIONS(399),
    [anon_sym_SLASH] = ACTIONS(399),
    [anon_sym_PERCENT] = ACTIONS(399),
    [anon_sym_SLASH_SLASH] = ACTIONS(399),
    [anon_sym_STAR_STAR] = ACTIONS(399),
    [anon_sym_PIPE] = ACTIONS(399),
    [anon_sym_AMP] = ACTIONS(399),
    [anon_sym_CARET] = ACTIONS(399),
    [anon_sym_LT_LT] = ACTIONS(399),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_LT_EQ] = ACTIONS(397),
    [anon_sym_EQ_EQ] = ACTIONS(397),
    [anon_sym_BANG_EQ] = ACTIONS(397),
    [anon_sym_GT_EQ] = ACTIONS(397),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_LT_GT] = ACTIONS(397),
    [anon_sym_is] = ACTIONS(397),
    [anon_sym_PLUS_EQ] = ACTIONS(397),
    [anon_sym_DASH_EQ] = ACTIONS(397),
    [anon_sym_STAR_EQ] = ACTIONS(397),
    [anon_sym_SLASH_EQ] = ACTIONS(397),
    [anon_sym_AT_EQ] = ACTIONS(397),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(397),
    [anon_sym_PERCENT_EQ] = ACTIONS(397),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(397),
    [anon_sym_GT_GT_EQ] = ACTIONS(397),
    [anon_sym_LT_LT_EQ] = ACTIONS(397),
    [anon_sym_AMP_EQ] = ACTIONS(397),
    [anon_sym_CARET_EQ] = ACTIONS(397),
    [anon_sym_PIPE_EQ] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(397),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(397),
  },
  [57] = {
    [anon_sym_RPAREN] = ACTIONS(401),
    [sym_comment] = ACTIONS(73),
  },
  [58] = {
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_LPAREN] = ACTIONS(119),
    [anon_sym_RPAREN] = ACTIONS(119),
    [anon_sym_COMMA] = ACTIONS(119),
    [anon_sym_as] = ACTIONS(123),
    [anon_sym_STAR] = ACTIONS(123),
    [anon_sym_GT_GT] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_COLON] = ACTIONS(119),
    [anon_sym_else] = ACTIONS(119),
    [anon_sym_async] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(119),
    [anon_sym_in] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(123),
    [anon_sym_AT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(119),
    [anon_sym_and] = ACTIONS(119),
    [anon_sym_or] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_SLASH] = ACTIONS(123),
    [anon_sym_PERCENT] = ACTIONS(119),
    [anon_sym_SLASH_SLASH] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(119),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(119),
    [anon_sym_LT_LT] = ACTIONS(119),
    [anon_sym_LT] = ACTIONS(123),
    [anon_sym_LT_EQ] = ACTIONS(119),
    [anon_sym_EQ_EQ] = ACTIONS(119),
    [anon_sym_BANG_EQ] = ACTIONS(119),
    [anon_sym_GT_EQ] = ACTIONS(119),
    [anon_sym_GT] = ACTIONS(123),
    [anon_sym_LT_GT] = ACTIONS(119),
    [anon_sym_is] = ACTIONS(119),
    [anon_sym_LBRACK] = ACTIONS(119),
    [anon_sym_RBRACK] = ACTIONS(119),
    [anon_sym_RBRACE] = ACTIONS(119),
    [sym_type_conversion] = ACTIONS(119),
    [sym_comment] = ACTIONS(73),
  },
  [59] = {
    [sym__expression] = STATE(226),
    [sym__primary_expression] = STATE(67),
    [sym_not_operator] = STATE(226),
    [sym_boolean_operator] = STATE(226),
    [sym_binary_operator] = STATE(67),
    [sym_unary_operator] = STATE(67),
    [sym_comparison_operator] = STATE(226),
    [sym_lambda] = STATE(226),
    [sym_attribute] = STATE(67),
    [sym_subscript] = STATE(67),
    [sym_call] = STATE(67),
    [sym_list] = STATE(67),
    [sym_list_comprehension] = STATE(67),
    [sym_dictionary] = STATE(67),
    [sym_dictionary_comprehension] = STATE(67),
    [sym_set] = STATE(67),
    [sym_set_comprehension] = STATE(67),
    [sym_parenthesized_expression] = STATE(67),
    [sym_tuple] = STATE(67),
    [sym_generator_expression] = STATE(67),
    [sym_conditional_expression] = STATE(226),
    [sym_concatenated_string] = STATE(67),
    [sym_string] = STATE(69),
    [sym_await] = STATE(226),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [60] = {
    [sym__primary_expression] = STATE(227),
    [sym_binary_operator] = STATE(227),
    [sym_unary_operator] = STATE(227),
    [sym_attribute] = STATE(227),
    [sym_subscript] = STATE(227),
    [sym_call] = STATE(227),
    [sym_list] = STATE(227),
    [sym_list_comprehension] = STATE(227),
    [sym_dictionary] = STATE(227),
    [sym_dictionary_comprehension] = STATE(227),
    [sym_set] = STATE(227),
    [sym_set_comprehension] = STATE(227),
    [sym_parenthesized_expression] = STATE(227),
    [sym_tuple] = STATE(227),
    [sym_generator_expression] = STATE(227),
    [sym_concatenated_string] = STATE(227),
    [sym_string] = STATE(69),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(403),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(405),
    [sym_float] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_true] = ACTIONS(405),
    [sym_false] = ACTIONS(405),
    [sym_none] = ACTIONS(405),
    [sym_comment] = ACTIONS(73),
  },
  [61] = {
    [sym_lambda_parameters] = STATE(229),
    [sym__parameters] = STATE(138),
    [sym_default_parameter] = STATE(139),
    [sym_typed_default_parameter] = STATE(139),
    [sym_list_splat] = STATE(140),
    [sym_dictionary_splat] = STATE(140),
    [sym_typed_parameter] = STATE(139),
    [sym_tuple] = STATE(139),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(407),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [62] = {
    [sym_expression_list] = STATE(235),
    [sym__expression] = STATE(236),
    [sym__primary_expression] = STATE(237),
    [sym_not_operator] = STATE(236),
    [sym_boolean_operator] = STATE(236),
    [sym_binary_operator] = STATE(237),
    [sym_unary_operator] = STATE(237),
    [sym_comparison_operator] = STATE(236),
    [sym_lambda] = STATE(236),
    [sym_attribute] = STATE(237),
    [sym_subscript] = STATE(237),
    [sym_call] = STATE(237),
    [sym_list] = STATE(237),
    [sym_list_comprehension] = STATE(237),
    [sym_dictionary] = STATE(237),
    [sym_dictionary_comprehension] = STATE(237),
    [sym_set] = STATE(237),
    [sym_set_comprehension] = STATE(237),
    [sym_parenthesized_expression] = STATE(237),
    [sym_tuple] = STATE(237),
    [sym_generator_expression] = STATE(237),
    [sym_conditional_expression] = STATE(236),
    [sym_concatenated_string] = STATE(237),
    [sym_string] = STATE(238),
    [sym_await] = STATE(236),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_from] = ACTIONS(409),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(237),
    [anon_sym_COMMA] = ACTIONS(237),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_lambda] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(419),
    [sym_float] = ACTIONS(419),
    [sym_identifier] = ACTIONS(419),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_none] = ACTIONS(419),
    [anon_sym_await] = ACTIONS(421),
    [sym_comment] = ACTIONS(73),
  },
  [63] = {
    [sym_list_splat] = STATE(241),
    [sym__expression] = STATE(242),
    [sym__primary_expression] = STATE(152),
    [sym_not_operator] = STATE(242),
    [sym_boolean_operator] = STATE(242),
    [sym_binary_operator] = STATE(152),
    [sym_unary_operator] = STATE(152),
    [sym_comparison_operator] = STATE(242),
    [sym_lambda] = STATE(242),
    [sym_attribute] = STATE(152),
    [sym_subscript] = STATE(152),
    [sym_call] = STATE(152),
    [sym_list] = STATE(152),
    [sym_list_comprehension] = STATE(152),
    [sym_dictionary] = STATE(152),
    [sym_dictionary_comprehension] = STATE(152),
    [sym_set] = STATE(152),
    [sym_set_comprehension] = STATE(152),
    [sym_parenthesized_expression] = STATE(152),
    [sym_tuple] = STATE(152),
    [sym_generator_expression] = STATE(152),
    [sym_conditional_expression] = STATE(242),
    [sym_concatenated_string] = STATE(152),
    [sym_string] = STATE(153),
    [sym_await] = STATE(242),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_COMMA] = ACTIONS(423),
    [anon_sym_STAR] = ACTIONS(243),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_lambda] = ACTIONS(249),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(425),
    [sym_ellipsis] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(255),
    [sym_float] = ACTIONS(255),
    [sym_identifier] = ACTIONS(255),
    [sym_true] = ACTIONS(255),
    [sym_false] = ACTIONS(255),
    [sym_none] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [sym_comment] = ACTIONS(73),
  },
  [64] = {
    [sym_list_splat] = STATE(245),
    [sym_dictionary_splat] = STATE(246),
    [sym__expression] = STATE(247),
    [sym__primary_expression] = STATE(164),
    [sym_not_operator] = STATE(247),
    [sym_boolean_operator] = STATE(247),
    [sym_binary_operator] = STATE(164),
    [sym_unary_operator] = STATE(164),
    [sym_comparison_operator] = STATE(247),
    [sym_lambda] = STATE(247),
    [sym_attribute] = STATE(164),
    [sym_subscript] = STATE(164),
    [sym_call] = STATE(164),
    [sym_list] = STATE(164),
    [sym_list_comprehension] = STATE(164),
    [sym_dictionary] = STATE(164),
    [sym_dictionary_comprehension] = STATE(164),
    [sym_pair] = STATE(248),
    [sym_set] = STATE(164),
    [sym_set_comprehension] = STATE(164),
    [sym_parenthesized_expression] = STATE(164),
    [sym_tuple] = STATE(164),
    [sym_generator_expression] = STATE(164),
    [sym_conditional_expression] = STATE(247),
    [sym_concatenated_string] = STATE(164),
    [sym_string] = STATE(166),
    [sym_await] = STATE(247),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_COMMA] = ACTIONS(427),
    [anon_sym_STAR] = ACTIONS(261),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_lambda] = ACTIONS(267),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(429),
    [sym_integer] = ACTIONS(273),
    [sym_float] = ACTIONS(273),
    [sym_identifier] = ACTIONS(273),
    [sym_true] = ACTIONS(273),
    [sym_false] = ACTIONS(273),
    [sym_none] = ACTIONS(273),
    [anon_sym_await] = ACTIONS(275),
    [sym_comment] = ACTIONS(73),
  },
  [65] = {
    [sym__expression] = STATE(249),
    [sym__primary_expression] = STATE(67),
    [sym_not_operator] = STATE(249),
    [sym_boolean_operator] = STATE(249),
    [sym_binary_operator] = STATE(67),
    [sym_unary_operator] = STATE(67),
    [sym_comparison_operator] = STATE(249),
    [sym_lambda] = STATE(249),
    [sym_attribute] = STATE(67),
    [sym_subscript] = STATE(67),
    [sym_call] = STATE(67),
    [sym_list] = STATE(67),
    [sym_list_comprehension] = STATE(67),
    [sym_dictionary] = STATE(67),
    [sym_dictionary_comprehension] = STATE(67),
    [sym_set] = STATE(67),
    [sym_set_comprehension] = STATE(67),
    [sym_parenthesized_expression] = STATE(67),
    [sym_tuple] = STATE(67),
    [sym_generator_expression] = STATE(67),
    [sym_conditional_expression] = STATE(249),
    [sym_concatenated_string] = STATE(67),
    [sym_string] = STATE(69),
    [sym_await] = STATE(249),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [66] = {
    [sym__comprehension_body] = STATE(257),
    [sym_for_in_clause] = STATE(258),
    [aux_sym_tuple_repeat1] = STATE(259),
    [anon_sym_RPAREN] = ACTIONS(431),
    [anon_sym_COMMA] = ACTIONS(433),
    [anon_sym_if] = ACTIONS(435),
    [anon_sym_async] = ACTIONS(437),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_and] = ACTIONS(441),
    [anon_sym_or] = ACTIONS(443),
    [sym_comment] = ACTIONS(73),
  },
  [67] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [aux_sym_comparison_operator_repeat1] = STATE(274),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(301),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(449),
    [anon_sym_GT_GT] = ACTIONS(451),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(453),
    [anon_sym_AT] = ACTIONS(455),
    [anon_sym_not] = ACTIONS(457),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_PERCENT] = ACTIONS(455),
    [anon_sym_SLASH_SLASH] = ACTIONS(455),
    [anon_sym_STAR_STAR] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_CARET] = ACTIONS(467),
    [anon_sym_LT_LT] = ACTIONS(451),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_LT_GT] = ACTIONS(453),
    [anon_sym_is] = ACTIONS(471),
    [anon_sym_LBRACK] = ACTIONS(473),
    [sym_comment] = ACTIONS(73),
  },
  [68] = {
    [aux_sym_tuple_repeat1] = STATE(259),
    [anon_sym_RPAREN] = ACTIONS(431),
    [anon_sym_COMMA] = ACTIONS(433),
    [sym_comment] = ACTIONS(73),
  },
  [69] = {
    [sym_string] = STATE(275),
    [aux_sym_concatenated_string_repeat1] = STATE(275),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_RPAREN] = ACTIONS(333),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_async] = ACTIONS(333),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [70] = {
    [sym_interpolation] = STATE(277),
    [aux_sym_string_repeat1] = STATE(277),
    [sym__string_content] = ACTIONS(475),
    [sym__string_end] = ACTIONS(477),
    [anon_sym_LBRACE] = ACTIONS(79),
    [sym_escape_sequence] = ACTIONS(475),
    [sym_comment] = ACTIONS(81),
  },
  [71] = {
    [sym__expression] = STATE(280),
    [sym__primary_expression] = STATE(67),
    [sym_not_operator] = STATE(280),
    [sym_boolean_operator] = STATE(280),
    [sym_binary_operator] = STATE(67),
    [sym_unary_operator] = STATE(67),
    [sym_comparison_operator] = STATE(280),
    [sym_lambda] = STATE(280),
    [sym_yield] = STATE(281),
    [sym_attribute] = STATE(67),
    [sym_subscript] = STATE(67),
    [sym_call] = STATE(67),
    [sym_list] = STATE(67),
    [sym_list_comprehension] = STATE(67),
    [sym_dictionary] = STATE(67),
    [sym_dictionary_comprehension] = STATE(67),
    [sym_set] = STATE(67),
    [sym_set_comprehension] = STATE(67),
    [sym_parenthesized_expression] = STATE(67),
    [sym_tuple] = STATE(67),
    [sym_generator_expression] = STATE(67),
    [sym_conditional_expression] = STATE(280),
    [sym_concatenated_string] = STATE(67),
    [sym_string] = STATE(69),
    [sym_await] = STATE(280),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(479),
    [anon_sym_COMMA] = ACTIONS(481),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(105),
    [anon_sym_yield] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [72] = {
    [sym__newline] = ACTIONS(119),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_from] = ACTIONS(119),
    [anon_sym_LPAREN] = ACTIONS(119),
    [anon_sym_COMMA] = ACTIONS(119),
    [anon_sym_STAR] = ACTIONS(123),
    [anon_sym_GT_GT] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_in] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(123),
    [anon_sym_AT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(119),
    [anon_sym_and] = ACTIONS(119),
    [anon_sym_or] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_SLASH] = ACTIONS(123),
    [anon_sym_PERCENT] = ACTIONS(119),
    [anon_sym_SLASH_SLASH] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(119),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(119),
    [anon_sym_LT_LT] = ACTIONS(119),
    [anon_sym_LT] = ACTIONS(123),
    [anon_sym_LT_EQ] = ACTIONS(119),
    [anon_sym_EQ_EQ] = ACTIONS(119),
    [anon_sym_BANG_EQ] = ACTIONS(119),
    [anon_sym_GT_EQ] = ACTIONS(119),
    [anon_sym_GT] = ACTIONS(123),
    [anon_sym_LT_GT] = ACTIONS(119),
    [anon_sym_is] = ACTIONS(119),
    [anon_sym_LBRACK] = ACTIONS(119),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(119),
  },
  [73] = {
    [sym__expression] = STATE(282),
    [sym__primary_expression] = STATE(82),
    [sym_not_operator] = STATE(282),
    [sym_boolean_operator] = STATE(282),
    [sym_binary_operator] = STATE(82),
    [sym_unary_operator] = STATE(82),
    [sym_comparison_operator] = STATE(282),
    [sym_lambda] = STATE(282),
    [sym_attribute] = STATE(82),
    [sym_subscript] = STATE(82),
    [sym_call] = STATE(82),
    [sym_list] = STATE(82),
    [sym_list_comprehension] = STATE(82),
    [sym_dictionary] = STATE(82),
    [sym_dictionary_comprehension] = STATE(82),
    [sym_set] = STATE(82),
    [sym_set_comprehension] = STATE(82),
    [sym_parenthesized_expression] = STATE(82),
    [sym_tuple] = STATE(82),
    [sym_generator_expression] = STATE(82),
    [sym_conditional_expression] = STATE(282),
    [sym_concatenated_string] = STATE(82),
    [sym_string] = STATE(83),
    [sym_await] = STATE(282),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_lambda] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(137),
    [sym_float] = ACTIONS(137),
    [sym_identifier] = ACTIONS(137),
    [sym_true] = ACTIONS(137),
    [sym_false] = ACTIONS(137),
    [sym_none] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
  },
  [74] = {
    [sym__expression] = STATE(283),
    [sym__primary_expression] = STATE(82),
    [sym_not_operator] = STATE(283),
    [sym_boolean_operator] = STATE(283),
    [sym_binary_operator] = STATE(82),
    [sym_unary_operator] = STATE(82),
    [sym_comparison_operator] = STATE(283),
    [sym_lambda] = STATE(283),
    [sym_attribute] = STATE(82),
    [sym_subscript] = STATE(82),
    [sym_call] = STATE(82),
    [sym_list] = STATE(82),
    [sym_list_comprehension] = STATE(82),
    [sym_dictionary] = STATE(82),
    [sym_dictionary_comprehension] = STATE(82),
    [sym_set] = STATE(82),
    [sym_set_comprehension] = STATE(82),
    [sym_parenthesized_expression] = STATE(82),
    [sym_tuple] = STATE(82),
    [sym_generator_expression] = STATE(82),
    [sym_conditional_expression] = STATE(283),
    [sym_concatenated_string] = STATE(82),
    [sym_string] = STATE(83),
    [sym_await] = STATE(283),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_lambda] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(137),
    [sym_float] = ACTIONS(137),
    [sym_identifier] = ACTIONS(137),
    [sym_true] = ACTIONS(137),
    [sym_false] = ACTIONS(137),
    [sym_none] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
  },
  [75] = {
    [sym__primary_expression] = STATE(284),
    [sym_binary_operator] = STATE(284),
    [sym_unary_operator] = STATE(284),
    [sym_attribute] = STATE(284),
    [sym_subscript] = STATE(284),
    [sym_call] = STATE(284),
    [sym_list] = STATE(284),
    [sym_list_comprehension] = STATE(284),
    [sym_dictionary] = STATE(284),
    [sym_dictionary_comprehension] = STATE(284),
    [sym_set] = STATE(284),
    [sym_set_comprehension] = STATE(284),
    [sym_parenthesized_expression] = STATE(284),
    [sym_tuple] = STATE(284),
    [sym_generator_expression] = STATE(284),
    [sym_concatenated_string] = STATE(284),
    [sym_string] = STATE(83),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(485),
    [sym_float] = ACTIONS(485),
    [sym_identifier] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_none] = ACTIONS(485),
    [sym_comment] = ACTIONS(73),
  },
  [76] = {
    [sym_lambda_parameters] = STATE(286),
    [sym__parameters] = STATE(138),
    [sym_default_parameter] = STATE(139),
    [sym_typed_default_parameter] = STATE(139),
    [sym_list_splat] = STATE(140),
    [sym_dictionary_splat] = STATE(140),
    [sym_typed_parameter] = STATE(139),
    [sym_tuple] = STATE(139),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(487),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [77] = {
    [sym_list_splat] = STATE(289),
    [sym__expression] = STATE(290),
    [sym__primary_expression] = STATE(152),
    [sym_not_operator] = STATE(290),
    [sym_boolean_operator] = STATE(290),
    [sym_binary_operator] = STATE(152),
    [sym_unary_operator] = STATE(152),
    [sym_comparison_operator] = STATE(290),
    [sym_lambda] = STATE(290),
    [sym_attribute] = STATE(152),
    [sym_subscript] = STATE(152),
    [sym_call] = STATE(152),
    [sym_list] = STATE(152),
    [sym_list_comprehension] = STATE(152),
    [sym_dictionary] = STATE(152),
    [sym_dictionary_comprehension] = STATE(152),
    [sym_set] = STATE(152),
    [sym_set_comprehension] = STATE(152),
    [sym_parenthesized_expression] = STATE(152),
    [sym_tuple] = STATE(152),
    [sym_generator_expression] = STATE(152),
    [sym_conditional_expression] = STATE(290),
    [sym_concatenated_string] = STATE(152),
    [sym_string] = STATE(153),
    [sym_await] = STATE(290),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_COMMA] = ACTIONS(489),
    [anon_sym_STAR] = ACTIONS(243),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_lambda] = ACTIONS(249),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(491),
    [sym_ellipsis] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(255),
    [sym_float] = ACTIONS(255),
    [sym_identifier] = ACTIONS(255),
    [sym_true] = ACTIONS(255),
    [sym_false] = ACTIONS(255),
    [sym_none] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [sym_comment] = ACTIONS(73),
  },
  [78] = {
    [sym_list_splat] = STATE(293),
    [sym_dictionary_splat] = STATE(294),
    [sym__expression] = STATE(295),
    [sym__primary_expression] = STATE(164),
    [sym_not_operator] = STATE(295),
    [sym_boolean_operator] = STATE(295),
    [sym_binary_operator] = STATE(164),
    [sym_unary_operator] = STATE(164),
    [sym_comparison_operator] = STATE(295),
    [sym_lambda] = STATE(295),
    [sym_attribute] = STATE(164),
    [sym_subscript] = STATE(164),
    [sym_call] = STATE(164),
    [sym_list] = STATE(164),
    [sym_list_comprehension] = STATE(164),
    [sym_dictionary] = STATE(164),
    [sym_dictionary_comprehension] = STATE(164),
    [sym_pair] = STATE(296),
    [sym_set] = STATE(164),
    [sym_set_comprehension] = STATE(164),
    [sym_parenthesized_expression] = STATE(164),
    [sym_tuple] = STATE(164),
    [sym_generator_expression] = STATE(164),
    [sym_conditional_expression] = STATE(295),
    [sym_concatenated_string] = STATE(164),
    [sym_string] = STATE(166),
    [sym_await] = STATE(295),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_COMMA] = ACTIONS(493),
    [anon_sym_STAR] = ACTIONS(261),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_lambda] = ACTIONS(267),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(495),
    [sym_integer] = ACTIONS(273),
    [sym_float] = ACTIONS(273),
    [sym_identifier] = ACTIONS(273),
    [sym_true] = ACTIONS(273),
    [sym_false] = ACTIONS(273),
    [sym_none] = ACTIONS(273),
    [anon_sym_await] = ACTIONS(275),
    [sym_comment] = ACTIONS(73),
  },
  [79] = {
    [sym__expression] = STATE(167),
    [sym__primary_expression] = STATE(82),
    [sym_not_operator] = STATE(167),
    [sym_boolean_operator] = STATE(167),
    [sym_binary_operator] = STATE(82),
    [sym_unary_operator] = STATE(82),
    [sym_comparison_operator] = STATE(167),
    [sym_lambda] = STATE(167),
    [sym_attribute] = STATE(82),
    [sym_subscript] = STATE(82),
    [sym_call] = STATE(82),
    [sym_list] = STATE(82),
    [sym_list_comprehension] = STATE(82),
    [sym_dictionary] = STATE(82),
    [sym_dictionary_comprehension] = STATE(82),
    [sym_set] = STATE(82),
    [sym_set_comprehension] = STATE(82),
    [sym_parenthesized_expression] = STATE(82),
    [sym_tuple] = STATE(82),
    [sym_generator_expression] = STATE(82),
    [sym_conditional_expression] = STATE(167),
    [sym_concatenated_string] = STATE(82),
    [sym_string] = STATE(83),
    [sym_await] = STATE(167),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_lambda] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(137),
    [sym_float] = ACTIONS(137),
    [sym_identifier] = ACTIONS(137),
    [sym_true] = ACTIONS(137),
    [sym_false] = ACTIONS(137),
    [sym_none] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
  },
  [80] = {
    [aux_sym_print_statement_repeat1] = STATE(298),
    [sym__newline] = ACTIONS(497),
    [anon_sym_COMMA] = ACTIONS(499),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(497),
  },
  [81] = {
    [aux_sym_print_statement_repeat1] = STATE(298),
    [sym__newline] = ACTIONS(497),
    [anon_sym_COMMA] = ACTIONS(499),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_and] = ACTIONS(503),
    [anon_sym_or] = ACTIONS(505),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(497),
  },
  [82] = {
    [sym_argument_list] = STATE(315),
    [sym_generator_expression] = STATE(315),
    [aux_sym_comparison_operator_repeat1] = STATE(316),
    [sym__newline] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(511),
    [anon_sym_GT_GT] = ACTIONS(513),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(515),
    [anon_sym_AT] = ACTIONS(517),
    [anon_sym_not] = ACTIONS(519),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(511),
    [anon_sym_PERCENT] = ACTIONS(517),
    [anon_sym_SLASH_SLASH] = ACTIONS(517),
    [anon_sym_STAR_STAR] = ACTIONS(523),
    [anon_sym_PIPE] = ACTIONS(525),
    [anon_sym_AMP] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(529),
    [anon_sym_LT_LT] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(531),
    [anon_sym_LT_EQ] = ACTIONS(515),
    [anon_sym_EQ_EQ] = ACTIONS(515),
    [anon_sym_BANG_EQ] = ACTIONS(515),
    [anon_sym_GT_EQ] = ACTIONS(515),
    [anon_sym_GT] = ACTIONS(531),
    [anon_sym_LT_GT] = ACTIONS(515),
    [anon_sym_is] = ACTIONS(533),
    [anon_sym_LBRACK] = ACTIONS(535),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(301),
  },
  [83] = {
    [sym_string] = STATE(317),
    [aux_sym_concatenated_string_repeat1] = STATE(317),
    [sym__newline] = ACTIONS(333),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(333),
  },
  [84] = {
    [aux_sym_print_statement_repeat1] = STATE(319),
    [sym__newline] = ACTIONS(537),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_and] = ACTIONS(503),
    [anon_sym_or] = ACTIONS(505),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(537),
  },
  [85] = {
    [sym__newline] = ACTIONS(541),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(541),
  },
  [86] = {
    [aux_sym_print_statement_repeat1] = STATE(321),
    [sym__newline] = ACTIONS(295),
    [anon_sym_COMMA] = ACTIONS(543),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_and] = ACTIONS(503),
    [anon_sym_or] = ACTIONS(505),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(295),
  },
  [87] = {
    [sym__newline] = ACTIONS(545),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(545),
  },
  [88] = {
    [sym__expression] = STATE(326),
    [sym__primary_expression] = STATE(327),
    [sym_not_operator] = STATE(326),
    [sym_boolean_operator] = STATE(326),
    [sym_binary_operator] = STATE(327),
    [sym_unary_operator] = STATE(327),
    [sym_comparison_operator] = STATE(326),
    [sym_lambda] = STATE(326),
    [sym_attribute] = STATE(327),
    [sym_subscript] = STATE(327),
    [sym_call] = STATE(327),
    [sym_list] = STATE(327),
    [sym_list_comprehension] = STATE(327),
    [sym_dictionary] = STATE(327),
    [sym_dictionary_comprehension] = STATE(327),
    [sym_set] = STATE(327),
    [sym_set_comprehension] = STATE(327),
    [sym_parenthesized_expression] = STATE(327),
    [sym_tuple] = STATE(327),
    [sym_generator_expression] = STATE(327),
    [sym_conditional_expression] = STATE(326),
    [sym_concatenated_string] = STATE(327),
    [sym_string] = STATE(328),
    [sym_await] = STATE(326),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(547),
    [anon_sym_PLUS] = ACTIONS(549),
    [anon_sym_DASH] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_lambda] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(553),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(555),
    [sym_float] = ACTIONS(555),
    [sym_identifier] = ACTIONS(555),
    [sym_true] = ACTIONS(555),
    [sym_false] = ACTIONS(555),
    [sym_none] = ACTIONS(555),
    [anon_sym_await] = ACTIONS(557),
    [sym_comment] = ACTIONS(73),
  },
  [89] = {
    [sym__expression] = STATE(329),
    [sym__primary_expression] = STATE(95),
    [sym_not_operator] = STATE(329),
    [sym_boolean_operator] = STATE(329),
    [sym_binary_operator] = STATE(95),
    [sym_unary_operator] = STATE(95),
    [sym_comparison_operator] = STATE(329),
    [sym_lambda] = STATE(329),
    [sym_attribute] = STATE(95),
    [sym_subscript] = STATE(95),
    [sym_call] = STATE(95),
    [sym_list] = STATE(95),
    [sym_list_comprehension] = STATE(95),
    [sym_dictionary] = STATE(95),
    [sym_dictionary_comprehension] = STATE(95),
    [sym_set] = STATE(95),
    [sym_set_comprehension] = STATE(95),
    [sym_parenthesized_expression] = STATE(95),
    [sym_tuple] = STATE(95),
    [sym_generator_expression] = STATE(95),
    [sym_conditional_expression] = STATE(329),
    [sym_concatenated_string] = STATE(95),
    [sym_string] = STATE(96),
    [sym_await] = STATE(329),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_lambda] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(159),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(161),
    [sym_float] = ACTIONS(161),
    [sym_identifier] = ACTIONS(161),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [sym_none] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [sym_comment] = ACTIONS(73),
  },
  [90] = {
    [sym__primary_expression] = STATE(284),
    [sym_binary_operator] = STATE(284),
    [sym_unary_operator] = STATE(284),
    [sym_attribute] = STATE(284),
    [sym_subscript] = STATE(284),
    [sym_call] = STATE(284),
    [sym_list] = STATE(284),
    [sym_list_comprehension] = STATE(284),
    [sym_dictionary] = STATE(284),
    [sym_dictionary_comprehension] = STATE(284),
    [sym_set] = STATE(284),
    [sym_set_comprehension] = STATE(284),
    [sym_parenthesized_expression] = STATE(284),
    [sym_tuple] = STATE(284),
    [sym_generator_expression] = STATE(284),
    [sym_concatenated_string] = STATE(284),
    [sym_string] = STATE(96),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(485),
    [sym_float] = ACTIONS(485),
    [sym_identifier] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_none] = ACTIONS(485),
    [sym_comment] = ACTIONS(73),
  },
  [91] = {
    [sym_lambda_parameters] = STATE(331),
    [sym__parameters] = STATE(138),
    [sym_default_parameter] = STATE(139),
    [sym_typed_default_parameter] = STATE(139),
    [sym_list_splat] = STATE(140),
    [sym_dictionary_splat] = STATE(140),
    [sym_typed_parameter] = STATE(139),
    [sym_tuple] = STATE(139),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(559),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [92] = {
    [sym__expression] = STATE(167),
    [sym__primary_expression] = STATE(95),
    [sym_not_operator] = STATE(167),
    [sym_boolean_operator] = STATE(167),
    [sym_binary_operator] = STATE(95),
    [sym_unary_operator] = STATE(95),
    [sym_comparison_operator] = STATE(167),
    [sym_lambda] = STATE(167),
    [sym_attribute] = STATE(95),
    [sym_subscript] = STATE(95),
    [sym_call] = STATE(95),
    [sym_list] = STATE(95),
    [sym_list_comprehension] = STATE(95),
    [sym_dictionary] = STATE(95),
    [sym_dictionary_comprehension] = STATE(95),
    [sym_set] = STATE(95),
    [sym_set_comprehension] = STATE(95),
    [sym_parenthesized_expression] = STATE(95),
    [sym_tuple] = STATE(95),
    [sym_generator_expression] = STATE(95),
    [sym_conditional_expression] = STATE(167),
    [sym_concatenated_string] = STATE(95),
    [sym_string] = STATE(96),
    [sym_await] = STATE(167),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_lambda] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(159),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(161),
    [sym_float] = ACTIONS(161),
    [sym_identifier] = ACTIONS(161),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [sym_none] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [sym_comment] = ACTIONS(73),
  },
  [93] = {
    [sym__newline] = ACTIONS(561),
    [anon_sym_from] = ACTIONS(563),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(561),
  },
  [94] = {
    [aux_sym_print_statement_repeat1] = STATE(337),
    [sym__newline] = ACTIONS(295),
    [anon_sym_from] = ACTIONS(295),
    [anon_sym_COMMA] = ACTIONS(565),
    [anon_sym_if] = ACTIONS(567),
    [anon_sym_and] = ACTIONS(569),
    [anon_sym_or] = ACTIONS(571),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(295),
  },
  [95] = {
    [sym_argument_list] = STATE(315),
    [sym_generator_expression] = STATE(315),
    [aux_sym_comparison_operator_repeat1] = STATE(348),
    [sym__newline] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(507),
    [anon_sym_from] = ACTIONS(301),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_GT_GT] = ACTIONS(575),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(577),
    [anon_sym_AT] = ACTIONS(579),
    [anon_sym_not] = ACTIONS(581),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(583),
    [anon_sym_DASH] = ACTIONS(583),
    [anon_sym_SLASH] = ACTIONS(573),
    [anon_sym_PERCENT] = ACTIONS(579),
    [anon_sym_SLASH_SLASH] = ACTIONS(579),
    [anon_sym_STAR_STAR] = ACTIONS(585),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_CARET] = ACTIONS(591),
    [anon_sym_LT_LT] = ACTIONS(575),
    [anon_sym_LT] = ACTIONS(593),
    [anon_sym_LT_EQ] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(577),
    [anon_sym_BANG_EQ] = ACTIONS(577),
    [anon_sym_GT_EQ] = ACTIONS(577),
    [anon_sym_GT] = ACTIONS(593),
    [anon_sym_LT_GT] = ACTIONS(577),
    [anon_sym_is] = ACTIONS(595),
    [anon_sym_LBRACK] = ACTIONS(535),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(301),
  },
  [96] = {
    [sym_string] = STATE(349),
    [aux_sym_concatenated_string_repeat1] = STATE(349),
    [sym__newline] = ACTIONS(333),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_from] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(333),
  },
  [97] = {
    [sym__expression] = STATE(350),
    [sym__primary_expression] = STATE(102),
    [sym_not_operator] = STATE(350),
    [sym_boolean_operator] = STATE(350),
    [sym_binary_operator] = STATE(102),
    [sym_unary_operator] = STATE(102),
    [sym_comparison_operator] = STATE(350),
    [sym_lambda] = STATE(350),
    [sym_attribute] = STATE(102),
    [sym_subscript] = STATE(102),
    [sym_call] = STATE(102),
    [sym_list] = STATE(102),
    [sym_list_comprehension] = STATE(102),
    [sym_dictionary] = STATE(102),
    [sym_dictionary_comprehension] = STATE(102),
    [sym_set] = STATE(102),
    [sym_set_comprehension] = STATE(102),
    [sym_parenthesized_expression] = STATE(102),
    [sym_tuple] = STATE(102),
    [sym_generator_expression] = STATE(102),
    [sym_conditional_expression] = STATE(350),
    [sym_concatenated_string] = STATE(102),
    [sym_string] = STATE(103),
    [sym_await] = STATE(350),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [98] = {
    [sym__primary_expression] = STATE(227),
    [sym_binary_operator] = STATE(227),
    [sym_unary_operator] = STATE(227),
    [sym_attribute] = STATE(227),
    [sym_subscript] = STATE(227),
    [sym_call] = STATE(227),
    [sym_list] = STATE(227),
    [sym_list_comprehension] = STATE(227),
    [sym_dictionary] = STATE(227),
    [sym_dictionary_comprehension] = STATE(227),
    [sym_set] = STATE(227),
    [sym_set_comprehension] = STATE(227),
    [sym_parenthesized_expression] = STATE(227),
    [sym_tuple] = STATE(227),
    [sym_generator_expression] = STATE(227),
    [sym_concatenated_string] = STATE(227),
    [sym_string] = STATE(103),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(403),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(405),
    [sym_float] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_true] = ACTIONS(405),
    [sym_false] = ACTIONS(405),
    [sym_none] = ACTIONS(405),
    [sym_comment] = ACTIONS(73),
  },
  [99] = {
    [sym_lambda_parameters] = STATE(352),
    [sym__parameters] = STATE(138),
    [sym_default_parameter] = STATE(139),
    [sym_typed_default_parameter] = STATE(139),
    [sym_list_splat] = STATE(140),
    [sym_dictionary_splat] = STATE(140),
    [sym_typed_parameter] = STATE(139),
    [sym_tuple] = STATE(139),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(597),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [100] = {
    [sym__expression] = STATE(249),
    [sym__primary_expression] = STATE(102),
    [sym_not_operator] = STATE(249),
    [sym_boolean_operator] = STATE(249),
    [sym_binary_operator] = STATE(102),
    [sym_unary_operator] = STATE(102),
    [sym_comparison_operator] = STATE(249),
    [sym_lambda] = STATE(249),
    [sym_attribute] = STATE(102),
    [sym_subscript] = STATE(102),
    [sym_call] = STATE(102),
    [sym_list] = STATE(102),
    [sym_list_comprehension] = STATE(102),
    [sym_dictionary] = STATE(102),
    [sym_dictionary_comprehension] = STATE(102),
    [sym_set] = STATE(102),
    [sym_set_comprehension] = STATE(102),
    [sym_parenthesized_expression] = STATE(102),
    [sym_tuple] = STATE(102),
    [sym_generator_expression] = STATE(102),
    [sym_conditional_expression] = STATE(249),
    [sym_concatenated_string] = STATE(102),
    [sym_string] = STATE(103),
    [sym_await] = STATE(249),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [101] = {
    [anon_sym_if] = ACTIONS(599),
    [anon_sym_COLON] = ACTIONS(601),
    [anon_sym_and] = ACTIONS(603),
    [anon_sym_or] = ACTIONS(605),
    [sym_comment] = ACTIONS(73),
  },
  [102] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [aux_sym_comparison_operator_repeat1] = STATE(367),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_GT_GT] = ACTIONS(609),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(611),
    [anon_sym_AT] = ACTIONS(613),
    [anon_sym_not] = ACTIONS(615),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_SLASH] = ACTIONS(607),
    [anon_sym_PERCENT] = ACTIONS(613),
    [anon_sym_SLASH_SLASH] = ACTIONS(613),
    [anon_sym_STAR_STAR] = ACTIONS(619),
    [anon_sym_PIPE] = ACTIONS(621),
    [anon_sym_AMP] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(625),
    [anon_sym_LT_LT] = ACTIONS(609),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_EQ] = ACTIONS(611),
    [anon_sym_EQ_EQ] = ACTIONS(611),
    [anon_sym_BANG_EQ] = ACTIONS(611),
    [anon_sym_GT_EQ] = ACTIONS(611),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_LT_GT] = ACTIONS(611),
    [anon_sym_is] = ACTIONS(629),
    [anon_sym_LBRACK] = ACTIONS(473),
    [sym_comment] = ACTIONS(73),
  },
  [103] = {
    [sym_string] = STATE(368),
    [aux_sym_concatenated_string_repeat1] = STATE(368),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_COLON] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [104] = {
    [sym_variables] = STATE(369),
    [sym__primary_expression] = STATE(109),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(110),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(191),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(193),
    [sym_float] = ACTIONS(193),
    [sym_identifier] = ACTIONS(193),
    [sym_true] = ACTIONS(193),
    [sym_false] = ACTIONS(193),
    [sym_none] = ACTIONS(193),
    [sym_comment] = ACTIONS(73),
  },
  [105] = {
    [sym_with_item] = STATE(370),
    [sym__expression] = STATE(118),
    [sym__primary_expression] = STATE(119),
    [sym_not_operator] = STATE(118),
    [sym_boolean_operator] = STATE(118),
    [sym_binary_operator] = STATE(119),
    [sym_unary_operator] = STATE(119),
    [sym_comparison_operator] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym_attribute] = STATE(119),
    [sym_subscript] = STATE(119),
    [sym_call] = STATE(119),
    [sym_list] = STATE(119),
    [sym_list_comprehension] = STATE(119),
    [sym_dictionary] = STATE(119),
    [sym_dictionary_comprehension] = STATE(119),
    [sym_set] = STATE(119),
    [sym_set_comprehension] = STATE(119),
    [sym_parenthesized_expression] = STATE(119),
    [sym_tuple] = STATE(119),
    [sym_generator_expression] = STATE(119),
    [sym_conditional_expression] = STATE(118),
    [sym_concatenated_string] = STATE(119),
    [sym_string] = STATE(120),
    [sym_await] = STATE(118),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(197),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_lambda] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(203),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(205),
    [sym_float] = ACTIONS(205),
    [sym_identifier] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_none] = ACTIONS(205),
    [anon_sym_await] = ACTIONS(207),
    [sym_comment] = ACTIONS(73),
  },
  [106] = {
    [sym_identifier] = ACTIONS(631),
    [sym_comment] = ACTIONS(73),
  },
  [107] = {
    [sym__primary_expression] = STATE(227),
    [sym_binary_operator] = STATE(227),
    [sym_unary_operator] = STATE(227),
    [sym_attribute] = STATE(227),
    [sym_subscript] = STATE(227),
    [sym_call] = STATE(227),
    [sym_list] = STATE(227),
    [sym_list_comprehension] = STATE(227),
    [sym_dictionary] = STATE(227),
    [sym_dictionary_comprehension] = STATE(227),
    [sym_set] = STATE(227),
    [sym_set_comprehension] = STATE(227),
    [sym_parenthesized_expression] = STATE(227),
    [sym_tuple] = STATE(227),
    [sym_generator_expression] = STATE(227),
    [sym_concatenated_string] = STATE(227),
    [sym_string] = STATE(110),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(403),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(405),
    [sym_float] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_true] = ACTIONS(405),
    [sym_false] = ACTIONS(405),
    [sym_none] = ACTIONS(405),
    [sym_comment] = ACTIONS(73),
  },
  [108] = {
    [anon_sym_in] = ACTIONS(633),
    [sym_comment] = ACTIONS(73),
  },
  [109] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [aux_sym_variables_repeat1] = STATE(381),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(635),
    [anon_sym_STAR] = ACTIONS(637),
    [anon_sym_GT_GT] = ACTIONS(639),
    [anon_sym_in] = ACTIONS(641),
    [anon_sym_AT] = ACTIONS(643),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(645),
    [anon_sym_SLASH] = ACTIONS(637),
    [anon_sym_PERCENT] = ACTIONS(643),
    [anon_sym_SLASH_SLASH] = ACTIONS(643),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(649),
    [anon_sym_AMP] = ACTIONS(651),
    [anon_sym_CARET] = ACTIONS(653),
    [anon_sym_LT_LT] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(473),
    [sym_comment] = ACTIONS(73),
  },
  [110] = {
    [sym_string] = STATE(382),
    [aux_sym_concatenated_string_repeat1] = STATE(382),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [111] = {
    [anon_sym_if] = ACTIONS(599),
    [anon_sym_COLON] = ACTIONS(655),
    [anon_sym_and] = ACTIONS(603),
    [anon_sym_or] = ACTIONS(605),
    [sym_comment] = ACTIONS(73),
  },
  [112] = {
    [sym__simple_statements] = STATE(386),
    [sym_import_statement] = STATE(385),
    [sym_future_import_statement] = STATE(385),
    [sym_import_from_statement] = STATE(385),
    [sym_print_statement] = STATE(385),
    [sym_assert_statement] = STATE(385),
    [sym_expression_statement] = STATE(385),
    [sym_return_statement] = STATE(385),
    [sym_delete_statement] = STATE(385),
    [sym_raise_statement] = STATE(385),
    [sym_pass_statement] = STATE(385),
    [sym_break_statement] = STATE(385),
    [sym_continue_statement] = STATE(385),
    [sym_global_statement] = STATE(385),
    [sym_nonlocal_statement] = STATE(385),
    [sym_exec_statement] = STATE(385),
    [sym__suite] = STATE(386),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(657),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [113] = {
    [sym__expression] = STATE(387),
    [sym__primary_expression] = STATE(119),
    [sym_not_operator] = STATE(387),
    [sym_boolean_operator] = STATE(387),
    [sym_binary_operator] = STATE(119),
    [sym_unary_operator] = STATE(119),
    [sym_comparison_operator] = STATE(387),
    [sym_lambda] = STATE(387),
    [sym_attribute] = STATE(119),
    [sym_subscript] = STATE(119),
    [sym_call] = STATE(119),
    [sym_list] = STATE(119),
    [sym_list_comprehension] = STATE(119),
    [sym_dictionary] = STATE(119),
    [sym_dictionary_comprehension] = STATE(119),
    [sym_set] = STATE(119),
    [sym_set_comprehension] = STATE(119),
    [sym_parenthesized_expression] = STATE(119),
    [sym_tuple] = STATE(119),
    [sym_generator_expression] = STATE(119),
    [sym_conditional_expression] = STATE(387),
    [sym_concatenated_string] = STATE(119),
    [sym_string] = STATE(120),
    [sym_await] = STATE(387),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(197),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_lambda] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(203),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(205),
    [sym_float] = ACTIONS(205),
    [sym_identifier] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_none] = ACTIONS(205),
    [anon_sym_await] = ACTIONS(207),
    [sym_comment] = ACTIONS(73),
  },
  [114] = {
    [sym__primary_expression] = STATE(227),
    [sym_binary_operator] = STATE(227),
    [sym_unary_operator] = STATE(227),
    [sym_attribute] = STATE(227),
    [sym_subscript] = STATE(227),
    [sym_call] = STATE(227),
    [sym_list] = STATE(227),
    [sym_list_comprehension] = STATE(227),
    [sym_dictionary] = STATE(227),
    [sym_dictionary_comprehension] = STATE(227),
    [sym_set] = STATE(227),
    [sym_set_comprehension] = STATE(227),
    [sym_parenthesized_expression] = STATE(227),
    [sym_tuple] = STATE(227),
    [sym_generator_expression] = STATE(227),
    [sym_concatenated_string] = STATE(227),
    [sym_string] = STATE(120),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(403),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(405),
    [sym_float] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_true] = ACTIONS(405),
    [sym_false] = ACTIONS(405),
    [sym_none] = ACTIONS(405),
    [sym_comment] = ACTIONS(73),
  },
  [115] = {
    [sym_lambda_parameters] = STATE(389),
    [sym__parameters] = STATE(138),
    [sym_default_parameter] = STATE(139),
    [sym_typed_default_parameter] = STATE(139),
    [sym_list_splat] = STATE(140),
    [sym_dictionary_splat] = STATE(140),
    [sym_typed_parameter] = STATE(139),
    [sym_tuple] = STATE(139),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(659),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [116] = {
    [sym__expression] = STATE(249),
    [sym__primary_expression] = STATE(119),
    [sym_not_operator] = STATE(249),
    [sym_boolean_operator] = STATE(249),
    [sym_binary_operator] = STATE(119),
    [sym_unary_operator] = STATE(119),
    [sym_comparison_operator] = STATE(249),
    [sym_lambda] = STATE(249),
    [sym_attribute] = STATE(119),
    [sym_subscript] = STATE(119),
    [sym_call] = STATE(119),
    [sym_list] = STATE(119),
    [sym_list_comprehension] = STATE(119),
    [sym_dictionary] = STATE(119),
    [sym_dictionary_comprehension] = STATE(119),
    [sym_set] = STATE(119),
    [sym_set_comprehension] = STATE(119),
    [sym_parenthesized_expression] = STATE(119),
    [sym_tuple] = STATE(119),
    [sym_generator_expression] = STATE(119),
    [sym_conditional_expression] = STATE(249),
    [sym_concatenated_string] = STATE(119),
    [sym_string] = STATE(120),
    [sym_await] = STATE(249),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(197),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_lambda] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(203),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(205),
    [sym_float] = ACTIONS(205),
    [sym_identifier] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_none] = ACTIONS(205),
    [anon_sym_await] = ACTIONS(207),
    [sym_comment] = ACTIONS(73),
  },
  [117] = {
    [aux_sym_with_statement_repeat1] = STATE(392),
    [anon_sym_COMMA] = ACTIONS(661),
    [anon_sym_COLON] = ACTIONS(663),
    [sym_comment] = ACTIONS(73),
  },
  [118] = {
    [anon_sym_COMMA] = ACTIONS(665),
    [anon_sym_as] = ACTIONS(667),
    [anon_sym_if] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(665),
    [anon_sym_and] = ACTIONS(671),
    [anon_sym_or] = ACTIONS(673),
    [sym_comment] = ACTIONS(73),
  },
  [119] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [aux_sym_comparison_operator_repeat1] = STATE(407),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_as] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(675),
    [anon_sym_GT_GT] = ACTIONS(677),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(679),
    [anon_sym_AT] = ACTIONS(681),
    [anon_sym_not] = ACTIONS(683),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_DASH] = ACTIONS(685),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_PERCENT] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(681),
    [anon_sym_STAR_STAR] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(689),
    [anon_sym_AMP] = ACTIONS(691),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_LT_LT] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_LT_EQ] = ACTIONS(679),
    [anon_sym_EQ_EQ] = ACTIONS(679),
    [anon_sym_BANG_EQ] = ACTIONS(679),
    [anon_sym_GT_EQ] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_LT_GT] = ACTIONS(679),
    [anon_sym_is] = ACTIONS(697),
    [anon_sym_LBRACK] = ACTIONS(473),
    [sym_comment] = ACTIONS(73),
  },
  [120] = {
    [sym_string] = STATE(408),
    [aux_sym_concatenated_string_repeat1] = STATE(408),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_as] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_COLON] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [121] = {
    [sym_parameters] = STATE(410),
    [anon_sym_LPAREN] = ACTIONS(699),
    [sym_comment] = ACTIONS(73),
  },
  [122] = {
    [aux_sym_global_statement_repeat1] = STATE(412),
    [sym__newline] = ACTIONS(701),
    [anon_sym_COMMA] = ACTIONS(703),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(701),
  },
  [123] = {
    [aux_sym_global_statement_repeat1] = STATE(413),
    [sym__newline] = ACTIONS(705),
    [anon_sym_COMMA] = ACTIONS(703),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(705),
  },
  [124] = {
    [sym_interpolation] = STATE(415),
    [aux_sym_string_repeat1] = STATE(415),
    [sym__string_content] = ACTIONS(707),
    [sym__string_end] = ACTIONS(709),
    [anon_sym_LBRACE] = ACTIONS(79),
    [sym_escape_sequence] = ACTIONS(707),
    [sym_comment] = ACTIONS(81),
  },
  [125] = {
    [sym__newline] = ACTIONS(711),
    [anon_sym_in] = ACTIONS(713),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(711),
  },
  [126] = {
    [sym_argument_list] = STATE(419),
    [anon_sym_LPAREN] = ACTIONS(715),
    [anon_sym_COLON] = ACTIONS(717),
    [sym_comment] = ACTIONS(73),
  },
  [127] = {
    [aux_sym_dotted_name_repeat1] = STATE(420),
    [sym__newline] = ACTIONS(365),
    [anon_sym_DOT] = ACTIONS(367),
    [anon_sym_LPAREN] = ACTIONS(365),
    [sym_comment] = ACTIONS(73),
  },
  [128] = {
    [sym_argument_list] = STATE(423),
    [sym__newline] = ACTIONS(719),
    [anon_sym_LPAREN] = ACTIONS(721),
    [sym_comment] = ACTIONS(73),
  },
  [129] = {
    [sym__newline] = ACTIONS(119),
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_LPAREN] = ACTIONS(119),
    [anon_sym_COMMA] = ACTIONS(119),
    [anon_sym_STAR] = ACTIONS(123),
    [anon_sym_GT_GT] = ACTIONS(123),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_COLON] = ACTIONS(119),
    [anon_sym_in] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(123),
    [anon_sym_AT] = ACTIONS(123),
    [anon_sym_not] = ACTIONS(119),
    [anon_sym_and] = ACTIONS(119),
    [anon_sym_or] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(123),
    [anon_sym_DASH] = ACTIONS(123),
    [anon_sym_SLASH] = ACTIONS(123),
    [anon_sym_PERCENT] = ACTIONS(123),
    [anon_sym_SLASH_SLASH] = ACTIONS(123),
    [anon_sym_STAR_STAR] = ACTIONS(123),
    [anon_sym_PIPE] = ACTIONS(123),
    [anon_sym_AMP] = ACTIONS(123),
    [anon_sym_CARET] = ACTIONS(123),
    [anon_sym_LT_LT] = ACTIONS(123),
    [anon_sym_LT] = ACTIONS(123),
    [anon_sym_LT_EQ] = ACTIONS(119),
    [anon_sym_EQ_EQ] = ACTIONS(119),
    [anon_sym_BANG_EQ] = ACTIONS(119),
    [anon_sym_GT_EQ] = ACTIONS(119),
    [anon_sym_GT] = ACTIONS(123),
    [anon_sym_LT_GT] = ACTIONS(119),
    [anon_sym_is] = ACTIONS(119),
    [anon_sym_PLUS_EQ] = ACTIONS(119),
    [anon_sym_DASH_EQ] = ACTIONS(119),
    [anon_sym_STAR_EQ] = ACTIONS(119),
    [anon_sym_SLASH_EQ] = ACTIONS(119),
    [anon_sym_AT_EQ] = ACTIONS(119),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(119),
    [anon_sym_PERCENT_EQ] = ACTIONS(119),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(119),
    [anon_sym_GT_GT_EQ] = ACTIONS(119),
    [anon_sym_LT_LT_EQ] = ACTIONS(119),
    [anon_sym_AMP_EQ] = ACTIONS(119),
    [anon_sym_CARET_EQ] = ACTIONS(119),
    [anon_sym_PIPE_EQ] = ACTIONS(119),
    [anon_sym_LBRACK] = ACTIONS(119),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(119),
  },
  [130] = {
    [sym__newline] = ACTIONS(723),
    [anon_sym_COMMA] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(723),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_EQ] = ACTIONS(723),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(299),
    [anon_sym_PLUS_EQ] = ACTIONS(723),
    [anon_sym_DASH_EQ] = ACTIONS(723),
    [anon_sym_STAR_EQ] = ACTIONS(723),
    [anon_sym_SLASH_EQ] = ACTIONS(723),
    [anon_sym_AT_EQ] = ACTIONS(723),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(723),
    [anon_sym_PERCENT_EQ] = ACTIONS(723),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(723),
    [anon_sym_GT_GT_EQ] = ACTIONS(723),
    [anon_sym_LT_LT_EQ] = ACTIONS(723),
    [anon_sym_AMP_EQ] = ACTIONS(723),
    [anon_sym_CARET_EQ] = ACTIONS(723),
    [anon_sym_PIPE_EQ] = ACTIONS(723),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(723),
  },
  [131] = {
    [sym_argument_list] = STATE(192),
    [sym_generator_expression] = STATE(192),
    [sym__newline] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(727),
    [anon_sym_GT_GT] = ACTIONS(727),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_in] = ACTIONS(725),
    [anon_sym_EQ] = ACTIONS(727),
    [anon_sym_AT] = ACTIONS(727),
    [anon_sym_not] = ACTIONS(725),
    [anon_sym_and] = ACTIONS(725),
    [anon_sym_or] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(727),
    [anon_sym_DASH] = ACTIONS(727),
    [anon_sym_SLASH] = ACTIONS(727),
    [anon_sym_PERCENT] = ACTIONS(727),
    [anon_sym_SLASH_SLASH] = ACTIONS(727),
    [anon_sym_STAR_STAR] = ACTIONS(727),
    [anon_sym_PIPE] = ACTIONS(727),
    [anon_sym_AMP] = ACTIONS(727),
    [anon_sym_CARET] = ACTIONS(727),
    [anon_sym_LT_LT] = ACTIONS(727),
    [anon_sym_LT] = ACTIONS(727),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_GT] = ACTIONS(727),
    [anon_sym_LT_GT] = ACTIONS(725),
    [anon_sym_is] = ACTIONS(725),
    [anon_sym_PLUS_EQ] = ACTIONS(725),
    [anon_sym_DASH_EQ] = ACTIONS(725),
    [anon_sym_STAR_EQ] = ACTIONS(725),
    [anon_sym_SLASH_EQ] = ACTIONS(725),
    [anon_sym_AT_EQ] = ACTIONS(725),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(725),
    [anon_sym_PERCENT_EQ] = ACTIONS(725),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(725),
    [anon_sym_GT_GT_EQ] = ACTIONS(725),
    [anon_sym_LT_LT_EQ] = ACTIONS(725),
    [anon_sym_AMP_EQ] = ACTIONS(725),
    [anon_sym_CARET_EQ] = ACTIONS(725),
    [anon_sym_PIPE_EQ] = ACTIONS(725),
    [anon_sym_LBRACK] = ACTIONS(725),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(725),
  },
  [132] = {
    [sym__expression] = STATE(424),
    [sym__primary_expression] = STATE(237),
    [sym_not_operator] = STATE(424),
    [sym_boolean_operator] = STATE(424),
    [sym_binary_operator] = STATE(237),
    [sym_unary_operator] = STATE(237),
    [sym_comparison_operator] = STATE(424),
    [sym_lambda] = STATE(424),
    [sym_yield] = STATE(425),
    [sym_attribute] = STATE(237),
    [sym_subscript] = STATE(237),
    [sym_call] = STATE(237),
    [sym_list] = STATE(237),
    [sym_list_comprehension] = STATE(237),
    [sym_dictionary] = STATE(237),
    [sym_dictionary_comprehension] = STATE(237),
    [sym_set] = STATE(237),
    [sym_set_comprehension] = STATE(237),
    [sym_parenthesized_expression] = STATE(237),
    [sym_tuple] = STATE(237),
    [sym_generator_expression] = STATE(237),
    [sym_conditional_expression] = STATE(424),
    [sym_concatenated_string] = STATE(237),
    [sym_string] = STATE(238),
    [sym_await] = STATE(424),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(393),
    [anon_sym_COMMA] = ACTIONS(395),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_lambda] = ACTIONS(415),
    [anon_sym_yield] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(419),
    [sym_float] = ACTIONS(419),
    [sym_identifier] = ACTIONS(419),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_none] = ACTIONS(419),
    [anon_sym_await] = ACTIONS(421),
    [sym_comment] = ACTIONS(73),
  },
  [133] = {
    [sym__expression] = STATE(431),
    [sym__primary_expression] = STATE(432),
    [sym_not_operator] = STATE(431),
    [sym_boolean_operator] = STATE(431),
    [sym_binary_operator] = STATE(432),
    [sym_unary_operator] = STATE(432),
    [sym_comparison_operator] = STATE(431),
    [sym_lambda] = STATE(431),
    [sym_attribute] = STATE(432),
    [sym_subscript] = STATE(432),
    [sym_call] = STATE(432),
    [sym_list] = STATE(432),
    [sym_list_comprehension] = STATE(432),
    [sym_dictionary] = STATE(432),
    [sym_dictionary_comprehension] = STATE(432),
    [sym_set] = STATE(432),
    [sym_set_comprehension] = STATE(432),
    [sym_parenthesized_expression] = STATE(432),
    [sym_tuple] = STATE(432),
    [sym_generator_expression] = STATE(432),
    [sym_conditional_expression] = STATE(431),
    [sym_concatenated_string] = STATE(432),
    [sym_string] = STATE(433),
    [sym_await] = STATE(431),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_COMMA] = ACTIONS(729),
    [anon_sym_STAR] = ACTIONS(731),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(729),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(735),
    [anon_sym_lambda] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(741),
    [sym_float] = ACTIONS(741),
    [sym_identifier] = ACTIONS(741),
    [sym_true] = ACTIONS(741),
    [sym_false] = ACTIONS(741),
    [sym_none] = ACTIONS(741),
    [anon_sym_await] = ACTIONS(743),
    [sym_comment] = ACTIONS(73),
  },
  [134] = {
    [aux_sym__parameters_repeat1] = STATE(437),
    [anon_sym_COMMA] = ACTIONS(745),
    [anon_sym_COLON] = ACTIONS(747),
    [anon_sym_EQ] = ACTIONS(749),
    [sym_comment] = ACTIONS(73),
  },
  [135] = {
    [sym__expression] = STATE(438),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(438),
    [sym_boolean_operator] = STATE(438),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(438),
    [sym_lambda] = STATE(438),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(438),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(438),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [136] = {
    [aux_sym__parameters_repeat1] = STATE(442),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_COLON] = ACTIONS(753),
    [anon_sym_EQ] = ACTIONS(755),
    [sym_comment] = ACTIONS(73),
  },
  [137] = {
    [anon_sym_COLON] = ACTIONS(757),
    [sym_comment] = ACTIONS(73),
  },
  [138] = {
    [anon_sym_COLON] = ACTIONS(759),
    [sym_comment] = ACTIONS(73),
  },
  [139] = {
    [aux_sym__parameters_repeat1] = STATE(442),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_COLON] = ACTIONS(753),
    [sym_comment] = ACTIONS(73),
  },
  [140] = {
    [aux_sym__parameters_repeat1] = STATE(442),
    [anon_sym_COMMA] = ACTIONS(751),
    [anon_sym_COLON] = ACTIONS(753),
    [sym_comment] = ACTIONS(73),
  },
  [141] = {
    [sym__expression] = STATE(445),
    [sym__primary_expression] = STATE(327),
    [sym_not_operator] = STATE(445),
    [sym_boolean_operator] = STATE(445),
    [sym_binary_operator] = STATE(327),
    [sym_unary_operator] = STATE(327),
    [sym_comparison_operator] = STATE(445),
    [sym_lambda] = STATE(445),
    [sym_attribute] = STATE(327),
    [sym_subscript] = STATE(327),
    [sym_call] = STATE(327),
    [sym_list] = STATE(327),
    [sym_list_comprehension] = STATE(327),
    [sym_dictionary] = STATE(327),
    [sym_dictionary_comprehension] = STATE(327),
    [sym_set] = STATE(327),
    [sym_set_comprehension] = STATE(327),
    [sym_parenthesized_expression] = STATE(327),
    [sym_tuple] = STATE(327),
    [sym_generator_expression] = STATE(327),
    [sym_conditional_expression] = STATE(445),
    [sym_concatenated_string] = STATE(327),
    [sym_string] = STATE(328),
    [sym_await] = STATE(445),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(547),
    [anon_sym_PLUS] = ACTIONS(549),
    [anon_sym_DASH] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_lambda] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(553),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(555),
    [sym_float] = ACTIONS(555),
    [sym_identifier] = ACTIONS(555),
    [sym_true] = ACTIONS(555),
    [sym_false] = ACTIONS(555),
    [sym_none] = ACTIONS(555),
    [anon_sym_await] = ACTIONS(557),
    [sym_comment] = ACTIONS(73),
  },
  [142] = {
    [sym__newline] = ACTIONS(761),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(761),
  },
  [143] = {
    [anon_sym_RBRACK] = ACTIONS(763),
    [sym_comment] = ACTIONS(73),
  },
  [144] = {
    [sym__expression] = STATE(451),
    [sym__primary_expression] = STATE(452),
    [sym_not_operator] = STATE(451),
    [sym_boolean_operator] = STATE(451),
    [sym_binary_operator] = STATE(452),
    [sym_unary_operator] = STATE(452),
    [sym_comparison_operator] = STATE(451),
    [sym_lambda] = STATE(451),
    [sym_attribute] = STATE(452),
    [sym_subscript] = STATE(452),
    [sym_call] = STATE(452),
    [sym_list] = STATE(452),
    [sym_list_comprehension] = STATE(452),
    [sym_dictionary] = STATE(452),
    [sym_dictionary_comprehension] = STATE(452),
    [sym_set] = STATE(452),
    [sym_set_comprehension] = STATE(452),
    [sym_parenthesized_expression] = STATE(452),
    [sym_tuple] = STATE(452),
    [sym_generator_expression] = STATE(452),
    [sym_conditional_expression] = STATE(451),
    [sym_concatenated_string] = STATE(452),
    [sym_string] = STATE(453),
    [sym_await] = STATE(451),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_COMMA] = ACTIONS(729),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_lambda] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(729),
    [sym_ellipsis] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(773),
    [sym_float] = ACTIONS(773),
    [sym_identifier] = ACTIONS(773),
    [sym_true] = ACTIONS(773),
    [sym_false] = ACTIONS(773),
    [sym_none] = ACTIONS(773),
    [anon_sym_await] = ACTIONS(775),
    [sym_comment] = ACTIONS(73),
  },
  [145] = {
    [sym__expression] = STATE(454),
    [sym__primary_expression] = STATE(152),
    [sym_not_operator] = STATE(454),
    [sym_boolean_operator] = STATE(454),
    [sym_binary_operator] = STATE(152),
    [sym_unary_operator] = STATE(152),
    [sym_comparison_operator] = STATE(454),
    [sym_lambda] = STATE(454),
    [sym_attribute] = STATE(152),
    [sym_subscript] = STATE(152),
    [sym_call] = STATE(152),
    [sym_list] = STATE(152),
    [sym_list_comprehension] = STATE(152),
    [sym_dictionary] = STATE(152),
    [sym_dictionary_comprehension] = STATE(152),
    [sym_set] = STATE(152),
    [sym_set_comprehension] = STATE(152),
    [sym_parenthesized_expression] = STATE(152),
    [sym_tuple] = STATE(152),
    [sym_generator_expression] = STATE(152),
    [sym_conditional_expression] = STATE(454),
    [sym_concatenated_string] = STATE(152),
    [sym_string] = STATE(153),
    [sym_await] = STATE(454),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_lambda] = ACTIONS(249),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(255),
    [sym_float] = ACTIONS(255),
    [sym_identifier] = ACTIONS(255),
    [sym_true] = ACTIONS(255),
    [sym_false] = ACTIONS(255),
    [sym_none] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [sym_comment] = ACTIONS(73),
  },
  [146] = {
    [sym__primary_expression] = STATE(227),
    [sym_binary_operator] = STATE(227),
    [sym_unary_operator] = STATE(227),
    [sym_attribute] = STATE(227),
    [sym_subscript] = STATE(227),
    [sym_call] = STATE(227),
    [sym_list] = STATE(227),
    [sym_list_comprehension] = STATE(227),
    [sym_dictionary] = STATE(227),
    [sym_dictionary_comprehension] = STATE(227),
    [sym_set] = STATE(227),
    [sym_set_comprehension] = STATE(227),
    [sym_parenthesized_expression] = STATE(227),
    [sym_tuple] = STATE(227),
    [sym_generator_expression] = STATE(227),
    [sym_concatenated_string] = STATE(227),
    [sym_string] = STATE(153),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(403),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(405),
    [sym_float] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_true] = ACTIONS(405),
    [sym_false] = ACTIONS(405),
    [sym_none] = ACTIONS(405),
    [sym_comment] = ACTIONS(73),
  },
  [147] = {
    [sym_lambda_parameters] = STATE(456),
    [sym__parameters] = STATE(138),
    [sym_default_parameter] = STATE(139),
    [sym_typed_default_parameter] = STATE(139),
    [sym_list_splat] = STATE(140),
    [sym_dictionary_splat] = STATE(140),
    [sym_typed_parameter] = STATE(139),
    [sym_tuple] = STATE(139),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(777),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [148] = {
    [sym__newline] = ACTIONS(779),
    [anon_sym_DOT] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(779),
    [anon_sym_COMMA] = ACTIONS(779),
    [anon_sym_STAR] = ACTIONS(781),
    [anon_sym_GT_GT] = ACTIONS(781),
    [anon_sym_if] = ACTIONS(779),
    [anon_sym_COLON] = ACTIONS(779),
    [anon_sym_in] = ACTIONS(779),
    [anon_sym_EQ] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(781),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_and] = ACTIONS(779),
    [anon_sym_or] = ACTIONS(779),
    [anon_sym_PLUS] = ACTIONS(781),
    [anon_sym_DASH] = ACTIONS(781),
    [anon_sym_SLASH] = ACTIONS(781),
    [anon_sym_PERCENT] = ACTIONS(781),
    [anon_sym_SLASH_SLASH] = ACTIONS(781),
    [anon_sym_STAR_STAR] = ACTIONS(781),
    [anon_sym_PIPE] = ACTIONS(781),
    [anon_sym_AMP] = ACTIONS(781),
    [anon_sym_CARET] = ACTIONS(781),
    [anon_sym_LT_LT] = ACTIONS(781),
    [anon_sym_LT] = ACTIONS(781),
    [anon_sym_LT_EQ] = ACTIONS(779),
    [anon_sym_EQ_EQ] = ACTIONS(779),
    [anon_sym_BANG_EQ] = ACTIONS(779),
    [anon_sym_GT_EQ] = ACTIONS(779),
    [anon_sym_GT] = ACTIONS(781),
    [anon_sym_LT_GT] = ACTIONS(779),
    [anon_sym_is] = ACTIONS(779),
    [anon_sym_PLUS_EQ] = ACTIONS(779),
    [anon_sym_DASH_EQ] = ACTIONS(779),
    [anon_sym_STAR_EQ] = ACTIONS(779),
    [anon_sym_SLASH_EQ] = ACTIONS(779),
    [anon_sym_AT_EQ] = ACTIONS(779),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(779),
    [anon_sym_PERCENT_EQ] = ACTIONS(779),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(779),
    [anon_sym_GT_GT_EQ] = ACTIONS(779),
    [anon_sym_LT_LT_EQ] = ACTIONS(779),
    [anon_sym_AMP_EQ] = ACTIONS(779),
    [anon_sym_CARET_EQ] = ACTIONS(779),
    [anon_sym_PIPE_EQ] = ACTIONS(779),
    [anon_sym_LBRACK] = ACTIONS(779),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(779),
  },
  [149] = {
    [sym__expression] = STATE(249),
    [sym__primary_expression] = STATE(152),
    [sym_not_operator] = STATE(249),
    [sym_boolean_operator] = STATE(249),
    [sym_binary_operator] = STATE(152),
    [sym_unary_operator] = STATE(152),
    [sym_comparison_operator] = STATE(249),
    [sym_lambda] = STATE(249),
    [sym_attribute] = STATE(152),
    [sym_subscript] = STATE(152),
    [sym_call] = STATE(152),
    [sym_list] = STATE(152),
    [sym_list_comprehension] = STATE(152),
    [sym_dictionary] = STATE(152),
    [sym_dictionary_comprehension] = STATE(152),
    [sym_set] = STATE(152),
    [sym_set_comprehension] = STATE(152),
    [sym_parenthesized_expression] = STATE(152),
    [sym_tuple] = STATE(152),
    [sym_generator_expression] = STATE(152),
    [sym_conditional_expression] = STATE(249),
    [sym_concatenated_string] = STATE(152),
    [sym_string] = STATE(153),
    [sym_await] = STATE(249),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_lambda] = ACTIONS(249),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(255),
    [sym_float] = ACTIONS(255),
    [sym_identifier] = ACTIONS(255),
    [sym_true] = ACTIONS(255),
    [sym_false] = ACTIONS(255),
    [sym_none] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [sym_comment] = ACTIONS(73),
  },
  [150] = {
    [aux_sym_list_repeat1] = STATE(458),
    [anon_sym_COMMA] = ACTIONS(783),
    [anon_sym_RBRACK] = ACTIONS(763),
    [sym_comment] = ACTIONS(73),
  },
  [151] = {
    [sym__comprehension_body] = STATE(464),
    [sym_for_in_clause] = STATE(465),
    [aux_sym_list_repeat1] = STATE(458),
    [anon_sym_COMMA] = ACTIONS(783),
    [anon_sym_if] = ACTIONS(785),
    [anon_sym_async] = ACTIONS(787),
    [anon_sym_for] = ACTIONS(789),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_or] = ACTIONS(793),
    [anon_sym_RBRACK] = ACTIONS(763),
    [sym_comment] = ACTIONS(73),
  },
  [152] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [aux_sym_comparison_operator_repeat1] = STATE(476),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(795),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(799),
    [anon_sym_AT] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(803),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(805),
    [anon_sym_DASH] = ACTIONS(805),
    [anon_sym_SLASH] = ACTIONS(795),
    [anon_sym_PERCENT] = ACTIONS(801),
    [anon_sym_SLASH_SLASH] = ACTIONS(801),
    [anon_sym_STAR_STAR] = ACTIONS(807),
    [anon_sym_PIPE] = ACTIONS(809),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(799),
    [anon_sym_EQ_EQ] = ACTIONS(799),
    [anon_sym_BANG_EQ] = ACTIONS(799),
    [anon_sym_GT_EQ] = ACTIONS(799),
    [anon_sym_GT] = ACTIONS(815),
    [anon_sym_LT_GT] = ACTIONS(799),
    [anon_sym_is] = ACTIONS(817),
    [anon_sym_LBRACK] = ACTIONS(473),
    [anon_sym_RBRACK] = ACTIONS(301),
    [sym_comment] = ACTIONS(73),
  },
  [153] = {
    [sym_string] = STATE(477),
    [aux_sym_concatenated_string_repeat1] = STATE(477),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_async] = ACTIONS(333),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_RBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [154] = {
    [anon_sym_RBRACE] = ACTIONS(819),
    [sym_comment] = ACTIONS(73),
  },
  [155] = {
    [sym__expression] = STATE(484),
    [sym__primary_expression] = STATE(485),
    [sym_not_operator] = STATE(484),
    [sym_boolean_operator] = STATE(484),
    [sym_binary_operator] = STATE(485),
    [sym_unary_operator] = STATE(485),
    [sym_comparison_operator] = STATE(484),
    [sym_lambda] = STATE(484),
    [sym_attribute] = STATE(485),
    [sym_subscript] = STATE(485),
    [sym_call] = STATE(485),
    [sym_list] = STATE(485),
    [sym_list_comprehension] = STATE(485),
    [sym_dictionary] = STATE(485),
    [sym_dictionary_comprehension] = STATE(485),
    [sym_set] = STATE(485),
    [sym_set_comprehension] = STATE(485),
    [sym_parenthesized_expression] = STATE(485),
    [sym_tuple] = STATE(485),
    [sym_generator_expression] = STATE(485),
    [sym_conditional_expression] = STATE(484),
    [sym_concatenated_string] = STATE(485),
    [sym_string] = STATE(486),
    [sym_await] = STATE(484),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_COMMA] = ACTIONS(729),
    [anon_sym_STAR] = ACTIONS(821),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(823),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_TILDE] = ACTIONS(825),
    [anon_sym_lambda] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(829),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(729),
    [sym_integer] = ACTIONS(831),
    [sym_float] = ACTIONS(831),
    [sym_identifier] = ACTIONS(831),
    [sym_true] = ACTIONS(831),
    [sym_false] = ACTIONS(831),
    [sym_none] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [sym_comment] = ACTIONS(73),
  },
  [156] = {
    [sym__expression] = STATE(487),
    [sym__primary_expression] = STATE(164),
    [sym_not_operator] = STATE(487),
    [sym_boolean_operator] = STATE(487),
    [sym_binary_operator] = STATE(164),
    [sym_unary_operator] = STATE(164),
    [sym_comparison_operator] = STATE(487),
    [sym_lambda] = STATE(487),
    [sym_attribute] = STATE(164),
    [sym_subscript] = STATE(164),
    [sym_call] = STATE(164),
    [sym_list] = STATE(164),
    [sym_list_comprehension] = STATE(164),
    [sym_dictionary] = STATE(164),
    [sym_dictionary_comprehension] = STATE(164),
    [sym_set] = STATE(164),
    [sym_set_comprehension] = STATE(164),
    [sym_parenthesized_expression] = STATE(164),
    [sym_tuple] = STATE(164),
    [sym_generator_expression] = STATE(164),
    [sym_conditional_expression] = STATE(487),
    [sym_concatenated_string] = STATE(164),
    [sym_string] = STATE(166),
    [sym_await] = STATE(487),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_lambda] = ACTIONS(267),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(273),
    [sym_float] = ACTIONS(273),
    [sym_identifier] = ACTIONS(273),
    [sym_true] = ACTIONS(273),
    [sym_false] = ACTIONS(273),
    [sym_none] = ACTIONS(273),
    [anon_sym_await] = ACTIONS(275),
    [sym_comment] = ACTIONS(73),
  },
  [157] = {
    [sym__primary_expression] = STATE(227),
    [sym_binary_operator] = STATE(227),
    [sym_unary_operator] = STATE(227),
    [sym_attribute] = STATE(227),
    [sym_subscript] = STATE(227),
    [sym_call] = STATE(227),
    [sym_list] = STATE(227),
    [sym_list_comprehension] = STATE(227),
    [sym_dictionary] = STATE(227),
    [sym_dictionary_comprehension] = STATE(227),
    [sym_set] = STATE(227),
    [sym_set_comprehension] = STATE(227),
    [sym_parenthesized_expression] = STATE(227),
    [sym_tuple] = STATE(227),
    [sym_generator_expression] = STATE(227),
    [sym_concatenated_string] = STATE(227),
    [sym_string] = STATE(166),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(403),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(405),
    [sym_float] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_true] = ACTIONS(405),
    [sym_false] = ACTIONS(405),
    [sym_none] = ACTIONS(405),
    [sym_comment] = ACTIONS(73),
  },
  [158] = {
    [sym_lambda_parameters] = STATE(489),
    [sym__parameters] = STATE(138),
    [sym_default_parameter] = STATE(139),
    [sym_typed_default_parameter] = STATE(139),
    [sym_list_splat] = STATE(140),
    [sym_dictionary_splat] = STATE(140),
    [sym_typed_parameter] = STATE(139),
    [sym_tuple] = STATE(139),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(835),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [159] = {
    [sym__newline] = ACTIONS(837),
    [anon_sym_DOT] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_STAR] = ACTIONS(839),
    [anon_sym_GT_GT] = ACTIONS(839),
    [anon_sym_if] = ACTIONS(837),
    [anon_sym_COLON] = ACTIONS(837),
    [anon_sym_in] = ACTIONS(837),
    [anon_sym_EQ] = ACTIONS(839),
    [anon_sym_AT] = ACTIONS(839),
    [anon_sym_not] = ACTIONS(837),
    [anon_sym_and] = ACTIONS(837),
    [anon_sym_or] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(839),
    [anon_sym_DASH] = ACTIONS(839),
    [anon_sym_SLASH] = ACTIONS(839),
    [anon_sym_PERCENT] = ACTIONS(839),
    [anon_sym_SLASH_SLASH] = ACTIONS(839),
    [anon_sym_STAR_STAR] = ACTIONS(839),
    [anon_sym_PIPE] = ACTIONS(839),
    [anon_sym_AMP] = ACTIONS(839),
    [anon_sym_CARET] = ACTIONS(839),
    [anon_sym_LT_LT] = ACTIONS(839),
    [anon_sym_LT] = ACTIONS(839),
    [anon_sym_LT_EQ] = ACTIONS(837),
    [anon_sym_EQ_EQ] = ACTIONS(837),
    [anon_sym_BANG_EQ] = ACTIONS(837),
    [anon_sym_GT_EQ] = ACTIONS(837),
    [anon_sym_GT] = ACTIONS(839),
    [anon_sym_LT_GT] = ACTIONS(837),
    [anon_sym_is] = ACTIONS(837),
    [anon_sym_PLUS_EQ] = ACTIONS(837),
    [anon_sym_DASH_EQ] = ACTIONS(837),
    [anon_sym_STAR_EQ] = ACTIONS(837),
    [anon_sym_SLASH_EQ] = ACTIONS(837),
    [anon_sym_AT_EQ] = ACTIONS(837),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(837),
    [anon_sym_PERCENT_EQ] = ACTIONS(837),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(837),
    [anon_sym_GT_GT_EQ] = ACTIONS(837),
    [anon_sym_LT_LT_EQ] = ACTIONS(837),
    [anon_sym_AMP_EQ] = ACTIONS(837),
    [anon_sym_CARET_EQ] = ACTIONS(837),
    [anon_sym_PIPE_EQ] = ACTIONS(837),
    [anon_sym_LBRACK] = ACTIONS(837),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(837),
  },
  [160] = {
    [sym__expression] = STATE(249),
    [sym__primary_expression] = STATE(164),
    [sym_not_operator] = STATE(249),
    [sym_boolean_operator] = STATE(249),
    [sym_binary_operator] = STATE(164),
    [sym_unary_operator] = STATE(164),
    [sym_comparison_operator] = STATE(249),
    [sym_lambda] = STATE(249),
    [sym_attribute] = STATE(164),
    [sym_subscript] = STATE(164),
    [sym_call] = STATE(164),
    [sym_list] = STATE(164),
    [sym_list_comprehension] = STATE(164),
    [sym_dictionary] = STATE(164),
    [sym_dictionary_comprehension] = STATE(164),
    [sym_set] = STATE(164),
    [sym_set_comprehension] = STATE(164),
    [sym_parenthesized_expression] = STATE(164),
    [sym_tuple] = STATE(164),
    [sym_generator_expression] = STATE(164),
    [sym_conditional_expression] = STATE(249),
    [sym_concatenated_string] = STATE(164),
    [sym_string] = STATE(166),
    [sym_await] = STATE(249),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_lambda] = ACTIONS(267),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(273),
    [sym_float] = ACTIONS(273),
    [sym_identifier] = ACTIONS(273),
    [sym_true] = ACTIONS(273),
    [sym_false] = ACTIONS(273),
    [sym_none] = ACTIONS(273),
    [anon_sym_await] = ACTIONS(275),
    [sym_comment] = ACTIONS(73),
  },
  [161] = {
    [aux_sym_list_repeat1] = STATE(492),
    [anon_sym_COMMA] = ACTIONS(841),
    [anon_sym_RBRACE] = ACTIONS(843),
    [sym_comment] = ACTIONS(73),
  },
  [162] = {
    [aux_sym_dictionary_repeat1] = STATE(494),
    [anon_sym_COMMA] = ACTIONS(845),
    [anon_sym_RBRACE] = ACTIONS(819),
    [sym_comment] = ACTIONS(73),
  },
  [163] = {
    [sym__comprehension_body] = STATE(501),
    [sym_for_in_clause] = STATE(502),
    [aux_sym_list_repeat1] = STATE(492),
    [anon_sym_COMMA] = ACTIONS(841),
    [anon_sym_if] = ACTIONS(847),
    [anon_sym_COLON] = ACTIONS(849),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_and] = ACTIONS(855),
    [anon_sym_or] = ACTIONS(857),
    [anon_sym_RBRACE] = ACTIONS(843),
    [sym_comment] = ACTIONS(73),
  },
  [164] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [aux_sym_comparison_operator_repeat1] = STATE(513),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(301),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(863),
    [anon_sym_AT] = ACTIONS(865),
    [anon_sym_not] = ACTIONS(867),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(869),
    [anon_sym_DASH] = ACTIONS(869),
    [anon_sym_SLASH] = ACTIONS(859),
    [anon_sym_PERCENT] = ACTIONS(865),
    [anon_sym_SLASH_SLASH] = ACTIONS(865),
    [anon_sym_STAR_STAR] = ACTIONS(871),
    [anon_sym_PIPE] = ACTIONS(873),
    [anon_sym_AMP] = ACTIONS(875),
    [anon_sym_CARET] = ACTIONS(877),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(879),
    [anon_sym_LT_EQ] = ACTIONS(863),
    [anon_sym_EQ_EQ] = ACTIONS(863),
    [anon_sym_BANG_EQ] = ACTIONS(863),
    [anon_sym_GT_EQ] = ACTIONS(863),
    [anon_sym_GT] = ACTIONS(879),
    [anon_sym_LT_GT] = ACTIONS(863),
    [anon_sym_is] = ACTIONS(881),
    [anon_sym_LBRACK] = ACTIONS(473),
    [anon_sym_RBRACE] = ACTIONS(301),
    [sym_comment] = ACTIONS(73),
  },
  [165] = {
    [sym__comprehension_body] = STATE(514),
    [sym_for_in_clause] = STATE(502),
    [aux_sym_dictionary_repeat1] = STATE(494),
    [anon_sym_COMMA] = ACTIONS(845),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_RBRACE] = ACTIONS(819),
    [sym_comment] = ACTIONS(73),
  },
  [166] = {
    [sym_string] = STATE(515),
    [aux_sym_concatenated_string_repeat1] = STATE(515),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_COLON] = ACTIONS(333),
    [anon_sym_async] = ACTIONS(333),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_RBRACE] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [167] = {
    [sym__newline] = ACTIONS(883),
    [anon_sym_from] = ACTIONS(883),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_if] = ACTIONS(883),
    [anon_sym_COLON] = ACTIONS(883),
    [anon_sym_EQ] = ACTIONS(883),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_PLUS_EQ] = ACTIONS(883),
    [anon_sym_DASH_EQ] = ACTIONS(883),
    [anon_sym_STAR_EQ] = ACTIONS(883),
    [anon_sym_SLASH_EQ] = ACTIONS(883),
    [anon_sym_AT_EQ] = ACTIONS(883),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(883),
    [anon_sym_PERCENT_EQ] = ACTIONS(883),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(883),
    [anon_sym_GT_GT_EQ] = ACTIONS(883),
    [anon_sym_LT_LT_EQ] = ACTIONS(883),
    [anon_sym_AMP_EQ] = ACTIONS(883),
    [anon_sym_CARET_EQ] = ACTIONS(883),
    [anon_sym_PIPE_EQ] = ACTIONS(883),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(883),
  },
  [168] = {
    [sym__string_start] = ACTIONS(885),
    [ts_builtin_sym_end] = ACTIONS(885),
    [anon_sym_import] = ACTIONS(887),
    [anon_sym_from] = ACTIONS(887),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_print] = ACTIONS(887),
    [anon_sym_assert] = ACTIONS(887),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_del] = ACTIONS(887),
    [anon_sym_raise] = ACTIONS(887),
    [anon_sym_pass] = ACTIONS(887),
    [anon_sym_break] = ACTIONS(887),
    [anon_sym_continue] = ACTIONS(887),
    [anon_sym_if] = ACTIONS(887),
    [anon_sym_elif] = ACTIONS(887),
    [anon_sym_else] = ACTIONS(887),
    [anon_sym_async] = ACTIONS(887),
    [anon_sym_for] = ACTIONS(887),
    [anon_sym_while] = ACTIONS(887),
    [anon_sym_try] = ACTIONS(887),
    [anon_sym_except] = ACTIONS(887),
    [anon_sym_finally] = ACTIONS(887),
    [anon_sym_with] = ACTIONS(887),
    [anon_sym_def] = ACTIONS(887),
    [anon_sym_global] = ACTIONS(887),
    [anon_sym_nonlocal] = ACTIONS(887),
    [anon_sym_exec] = ACTIONS(887),
    [anon_sym_class] = ACTIONS(887),
    [anon_sym_AT] = ACTIONS(885),
    [anon_sym_not] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(885),
    [anon_sym_DASH] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_lambda] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(887),
    [anon_sym_LBRACK] = ACTIONS(885),
    [sym_ellipsis] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(885),
    [sym_integer] = ACTIONS(887),
    [sym_float] = ACTIONS(887),
    [sym_identifier] = ACTIONS(887),
    [sym_true] = ACTIONS(887),
    [sym_false] = ACTIONS(887),
    [sym_none] = ACTIONS(887),
    [anon_sym_await] = ACTIONS(887),
    [sym_comment] = ACTIONS(73),
  },
  [169] = {
    [sym_import_statement] = STATE(517),
    [sym_future_import_statement] = STATE(517),
    [sym_import_from_statement] = STATE(517),
    [sym_print_statement] = STATE(517),
    [sym_assert_statement] = STATE(517),
    [sym_expression_statement] = STATE(517),
    [sym_return_statement] = STATE(517),
    [sym_delete_statement] = STATE(517),
    [sym_raise_statement] = STATE(517),
    [sym_pass_statement] = STATE(517),
    [sym_break_statement] = STATE(517),
    [sym_continue_statement] = STATE(517),
    [sym_global_statement] = STATE(517),
    [sym_nonlocal_statement] = STATE(517),
    [sym_exec_statement] = STATE(517),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__newline] = ACTIONS(889),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [170] = {
    [aux_sym__simple_statements_repeat1] = STATE(519),
    [sym__newline] = ACTIONS(889),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(891),
  },
  [171] = {
    [sym__expression] = STATE(524),
    [sym__primary_expression] = STATE(525),
    [sym_not_operator] = STATE(524),
    [sym_boolean_operator] = STATE(524),
    [sym_binary_operator] = STATE(525),
    [sym_unary_operator] = STATE(525),
    [sym_comparison_operator] = STATE(524),
    [sym_lambda] = STATE(524),
    [sym_attribute] = STATE(525),
    [sym_subscript] = STATE(525),
    [sym_call] = STATE(525),
    [sym_type] = STATE(526),
    [sym_list] = STATE(525),
    [sym_list_comprehension] = STATE(525),
    [sym_dictionary] = STATE(525),
    [sym_dictionary_comprehension] = STATE(525),
    [sym_set] = STATE(525),
    [sym_set_comprehension] = STATE(525),
    [sym_parenthesized_expression] = STATE(525),
    [sym_tuple] = STATE(525),
    [sym_generator_expression] = STATE(525),
    [sym_conditional_expression] = STATE(524),
    [sym_concatenated_string] = STATE(525),
    [sym_string] = STATE(527),
    [sym_await] = STATE(524),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(893),
    [anon_sym_PLUS] = ACTIONS(895),
    [anon_sym_DASH] = ACTIONS(895),
    [anon_sym_TILDE] = ACTIONS(895),
    [anon_sym_lambda] = ACTIONS(897),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(901),
    [sym_float] = ACTIONS(901),
    [sym_identifier] = ACTIONS(901),
    [sym_true] = ACTIONS(901),
    [sym_false] = ACTIONS(901),
    [sym_none] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(903),
    [sym_comment] = ACTIONS(73),
  },
  [172] = {
    [sym_expression_list] = STATE(528),
    [sym__expression] = STATE(529),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(529),
    [sym_boolean_operator] = STATE(529),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(529),
    [sym_lambda] = STATE(529),
    [sym_assignment] = STATE(530),
    [sym_augmented_assignment] = STATE(530),
    [sym__right_hand_side] = STATE(530),
    [sym_yield] = STATE(530),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(529),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(529),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [173] = {
    [sym_expression_list] = STATE(528),
    [sym__expression] = STATE(529),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(529),
    [sym_boolean_operator] = STATE(529),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(529),
    [sym_lambda] = STATE(529),
    [sym_assignment] = STATE(531),
    [sym_augmented_assignment] = STATE(531),
    [sym__right_hand_side] = STATE(531),
    [sym_yield] = STATE(531),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(529),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(529),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [174] = {
    [sym__expression] = STATE(532),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(532),
    [sym_boolean_operator] = STATE(532),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(532),
    [sym_lambda] = STATE(532),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(532),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(532),
    [sym__newline] = ACTIONS(905),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_COLON] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(907),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_PLUS_EQ] = ACTIONS(907),
    [anon_sym_DASH_EQ] = ACTIONS(907),
    [anon_sym_STAR_EQ] = ACTIONS(907),
    [anon_sym_SLASH_EQ] = ACTIONS(907),
    [anon_sym_AT_EQ] = ACTIONS(907),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(907),
    [anon_sym_PERCENT_EQ] = ACTIONS(907),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(907),
    [anon_sym_GT_GT_EQ] = ACTIONS(907),
    [anon_sym_LT_LT_EQ] = ACTIONS(907),
    [anon_sym_AMP_EQ] = ACTIONS(907),
    [anon_sym_CARET_EQ] = ACTIONS(907),
    [anon_sym_PIPE_EQ] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(905),
  },
  [175] = {
    [sym__expression] = STATE(537),
    [sym__primary_expression] = STATE(538),
    [sym_not_operator] = STATE(537),
    [sym_boolean_operator] = STATE(537),
    [sym_binary_operator] = STATE(538),
    [sym_unary_operator] = STATE(538),
    [sym_comparison_operator] = STATE(537),
    [sym_lambda] = STATE(537),
    [sym_attribute] = STATE(538),
    [sym_subscript] = STATE(538),
    [sym_call] = STATE(538),
    [sym_list] = STATE(538),
    [sym_list_comprehension] = STATE(538),
    [sym_dictionary] = STATE(538),
    [sym_dictionary_comprehension] = STATE(538),
    [sym_set] = STATE(538),
    [sym_set_comprehension] = STATE(538),
    [sym_parenthesized_expression] = STATE(538),
    [sym_tuple] = STATE(538),
    [sym_generator_expression] = STATE(538),
    [sym_conditional_expression] = STATE(537),
    [sym_concatenated_string] = STATE(538),
    [sym_string] = STATE(539),
    [sym_await] = STATE(537),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_lambda] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(917),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(919),
    [sym_float] = ACTIONS(919),
    [sym_identifier] = ACTIONS(919),
    [sym_true] = ACTIONS(919),
    [sym_false] = ACTIONS(919),
    [sym_none] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(921),
    [sym_comment] = ACTIONS(73),
  },
  [176] = {
    [sym__expression] = STATE(540),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(540),
    [sym_boolean_operator] = STATE(540),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(540),
    [sym_lambda] = STATE(540),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(540),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(540),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [177] = {
    [sym__expression] = STATE(541),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(541),
    [sym_boolean_operator] = STATE(541),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(541),
    [sym_lambda] = STATE(541),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(541),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(541),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [178] = {
    [aux_sym_print_statement_repeat1] = STATE(543),
    [sym__newline] = ACTIONS(905),
    [anon_sym_COMMA] = ACTIONS(923),
    [anon_sym_COLON] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(907),
    [anon_sym_PLUS_EQ] = ACTIONS(907),
    [anon_sym_DASH_EQ] = ACTIONS(907),
    [anon_sym_STAR_EQ] = ACTIONS(907),
    [anon_sym_SLASH_EQ] = ACTIONS(907),
    [anon_sym_AT_EQ] = ACTIONS(907),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(907),
    [anon_sym_PERCENT_EQ] = ACTIONS(907),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(907),
    [anon_sym_GT_GT_EQ] = ACTIONS(907),
    [anon_sym_LT_LT_EQ] = ACTIONS(907),
    [anon_sym_AMP_EQ] = ACTIONS(907),
    [anon_sym_CARET_EQ] = ACTIONS(907),
    [anon_sym_PIPE_EQ] = ACTIONS(907),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(905),
  },
  [179] = {
    [sym_identifier] = ACTIONS(925),
    [sym_comment] = ACTIONS(73),
  },
  [180] = {
    [sym_list_splat] = STATE(550),
    [sym_dictionary_splat] = STATE(550),
    [sym__expression] = STATE(551),
    [sym__primary_expression] = STATE(67),
    [sym_not_operator] = STATE(551),
    [sym_boolean_operator] = STATE(551),
    [sym_binary_operator] = STATE(67),
    [sym_unary_operator] = STATE(67),
    [sym_comparison_operator] = STATE(551),
    [sym_lambda] = STATE(551),
    [sym_attribute] = STATE(67),
    [sym_subscript] = STATE(67),
    [sym_call] = STATE(67),
    [sym_keyword_argument] = STATE(550),
    [sym_list] = STATE(67),
    [sym_list_comprehension] = STATE(67),
    [sym_dictionary] = STATE(67),
    [sym_dictionary_comprehension] = STATE(67),
    [sym_set] = STATE(67),
    [sym_set_comprehension] = STATE(67),
    [sym_parenthesized_expression] = STATE(67),
    [sym_tuple] = STATE(67),
    [sym_generator_expression] = STATE(67),
    [sym_conditional_expression] = STATE(551),
    [sym_concatenated_string] = STATE(67),
    [sym_string] = STATE(69),
    [sym_await] = STATE(551),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(927),
    [anon_sym_COMMA] = ACTIONS(929),
    [anon_sym_STAR] = ACTIONS(931),
    [anon_sym_print] = ACTIONS(933),
    [anon_sym_exec] = ACTIONS(933),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(935),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [181] = {
    [sym__primary_expression] = STATE(552),
    [sym_binary_operator] = STATE(552),
    [sym_unary_operator] = STATE(552),
    [sym_attribute] = STATE(552),
    [sym_subscript] = STATE(552),
    [sym_call] = STATE(552),
    [sym_list] = STATE(552),
    [sym_list_comprehension] = STATE(552),
    [sym_dictionary] = STATE(552),
    [sym_dictionary_comprehension] = STATE(552),
    [sym_set] = STATE(552),
    [sym_set_comprehension] = STATE(552),
    [sym_parenthesized_expression] = STATE(552),
    [sym_tuple] = STATE(552),
    [sym_generator_expression] = STATE(552),
    [sym_concatenated_string] = STATE(552),
    [sym_string] = STATE(39),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(937),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(939),
    [sym_float] = ACTIONS(939),
    [sym_identifier] = ACTIONS(939),
    [sym_true] = ACTIONS(939),
    [sym_false] = ACTIONS(939),
    [sym_none] = ACTIONS(939),
    [sym_comment] = ACTIONS(73),
  },
  [182] = {
    [sym__primary_expression] = STATE(553),
    [sym_binary_operator] = STATE(553),
    [sym_unary_operator] = STATE(553),
    [sym_attribute] = STATE(553),
    [sym_subscript] = STATE(553),
    [sym_call] = STATE(553),
    [sym_list] = STATE(553),
    [sym_list_comprehension] = STATE(553),
    [sym_dictionary] = STATE(553),
    [sym_dictionary_comprehension] = STATE(553),
    [sym_set] = STATE(553),
    [sym_set_comprehension] = STATE(553),
    [sym_parenthesized_expression] = STATE(553),
    [sym_tuple] = STATE(553),
    [sym_generator_expression] = STATE(553),
    [sym_concatenated_string] = STATE(553),
    [sym_string] = STATE(39),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(941),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(943),
    [sym_float] = ACTIONS(943),
    [sym_identifier] = ACTIONS(943),
    [sym_true] = ACTIONS(943),
    [sym_false] = ACTIONS(943),
    [sym_none] = ACTIONS(943),
    [sym_comment] = ACTIONS(73),
  },
  [183] = {
    [sym__primary_expression] = STATE(554),
    [sym_binary_operator] = STATE(554),
    [sym_unary_operator] = STATE(554),
    [sym_attribute] = STATE(554),
    [sym_subscript] = STATE(554),
    [sym_call] = STATE(554),
    [sym_list] = STATE(554),
    [sym_list_comprehension] = STATE(554),
    [sym_dictionary] = STATE(554),
    [sym_dictionary_comprehension] = STATE(554),
    [sym_set] = STATE(554),
    [sym_set_comprehension] = STATE(554),
    [sym_parenthesized_expression] = STATE(554),
    [sym_tuple] = STATE(554),
    [sym_generator_expression] = STATE(554),
    [sym_concatenated_string] = STATE(554),
    [sym_string] = STATE(39),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(947),
    [sym_float] = ACTIONS(947),
    [sym_identifier] = ACTIONS(947),
    [sym_true] = ACTIONS(947),
    [sym_false] = ACTIONS(947),
    [sym_none] = ACTIONS(947),
    [sym_comment] = ACTIONS(73),
  },
  [184] = {
    [anon_sym_in] = ACTIONS(949),
    [sym_comment] = ACTIONS(73),
  },
  [185] = {
    [sym__primary_expression] = STATE(556),
    [sym_binary_operator] = STATE(556),
    [sym_unary_operator] = STATE(556),
    [sym_attribute] = STATE(556),
    [sym_subscript] = STATE(556),
    [sym_call] = STATE(556),
    [sym_list] = STATE(556),
    [sym_list_comprehension] = STATE(556),
    [sym_dictionary] = STATE(556),
    [sym_dictionary_comprehension] = STATE(556),
    [sym_set] = STATE(556),
    [sym_set_comprehension] = STATE(556),
    [sym_parenthesized_expression] = STATE(556),
    [sym_tuple] = STATE(556),
    [sym_generator_expression] = STATE(556),
    [sym_concatenated_string] = STATE(556),
    [sym_string] = STATE(39),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(951),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(953),
    [sym_float] = ACTIONS(953),
    [sym_identifier] = ACTIONS(953),
    [sym_true] = ACTIONS(953),
    [sym_false] = ACTIONS(953),
    [sym_none] = ACTIONS(953),
    [sym_comment] = ACTIONS(73),
  },
  [186] = {
    [sym__primary_expression] = STATE(557),
    [sym_binary_operator] = STATE(557),
    [sym_unary_operator] = STATE(557),
    [sym_attribute] = STATE(557),
    [sym_subscript] = STATE(557),
    [sym_call] = STATE(557),
    [sym_list] = STATE(557),
    [sym_list_comprehension] = STATE(557),
    [sym_dictionary] = STATE(557),
    [sym_dictionary_comprehension] = STATE(557),
    [sym_set] = STATE(557),
    [sym_set_comprehension] = STATE(557),
    [sym_parenthesized_expression] = STATE(557),
    [sym_tuple] = STATE(557),
    [sym_generator_expression] = STATE(557),
    [sym_concatenated_string] = STATE(557),
    [sym_string] = STATE(39),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(955),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(957),
    [sym_float] = ACTIONS(957),
    [sym_identifier] = ACTIONS(957),
    [sym_true] = ACTIONS(957),
    [sym_false] = ACTIONS(957),
    [sym_none] = ACTIONS(957),
    [sym_comment] = ACTIONS(73),
  },
  [187] = {
    [sym__primary_expression] = STATE(558),
    [sym_binary_operator] = STATE(558),
    [sym_unary_operator] = STATE(558),
    [sym_attribute] = STATE(558),
    [sym_subscript] = STATE(558),
    [sym_call] = STATE(558),
    [sym_list] = STATE(558),
    [sym_list_comprehension] = STATE(558),
    [sym_dictionary] = STATE(558),
    [sym_dictionary_comprehension] = STATE(558),
    [sym_set] = STATE(558),
    [sym_set_comprehension] = STATE(558),
    [sym_parenthesized_expression] = STATE(558),
    [sym_tuple] = STATE(558),
    [sym_generator_expression] = STATE(558),
    [sym_concatenated_string] = STATE(558),
    [sym_string] = STATE(39),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(959),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(961),
    [sym_float] = ACTIONS(961),
    [sym_identifier] = ACTIONS(961),
    [sym_true] = ACTIONS(961),
    [sym_false] = ACTIONS(961),
    [sym_none] = ACTIONS(961),
    [sym_comment] = ACTIONS(73),
  },
  [188] = {
    [sym__primary_expression] = STATE(559),
    [sym_binary_operator] = STATE(559),
    [sym_unary_operator] = STATE(559),
    [sym_attribute] = STATE(559),
    [sym_subscript] = STATE(559),
    [sym_call] = STATE(559),
    [sym_list] = STATE(559),
    [sym_list_comprehension] = STATE(559),
    [sym_dictionary] = STATE(559),
    [sym_dictionary_comprehension] = STATE(559),
    [sym_set] = STATE(559),
    [sym_set_comprehension] = STATE(559),
    [sym_parenthesized_expression] = STATE(559),
    [sym_tuple] = STATE(559),
    [sym_generator_expression] = STATE(559),
    [sym_concatenated_string] = STATE(559),
    [sym_string] = STATE(39),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(963),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(965),
    [sym_float] = ACTIONS(965),
    [sym_identifier] = ACTIONS(965),
    [sym_true] = ACTIONS(965),
    [sym_false] = ACTIONS(965),
    [sym_none] = ACTIONS(965),
    [sym_comment] = ACTIONS(73),
  },
  [189] = {
    [sym__primary_expression] = STATE(560),
    [sym_binary_operator] = STATE(560),
    [sym_unary_operator] = STATE(560),
    [sym_attribute] = STATE(560),
    [sym_subscript] = STATE(560),
    [sym_call] = STATE(560),
    [sym_list] = STATE(560),
    [sym_list_comprehension] = STATE(560),
    [sym_dictionary] = STATE(560),
    [sym_dictionary_comprehension] = STATE(560),
    [sym_set] = STATE(560),
    [sym_set_comprehension] = STATE(560),
    [sym_parenthesized_expression] = STATE(560),
    [sym_tuple] = STATE(560),
    [sym_generator_expression] = STATE(560),
    [sym_concatenated_string] = STATE(560),
    [sym_string] = STATE(39),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(967),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(969),
    [sym_float] = ACTIONS(969),
    [sym_identifier] = ACTIONS(969),
    [sym_true] = ACTIONS(969),
    [sym_false] = ACTIONS(969),
    [sym_none] = ACTIONS(969),
    [sym_comment] = ACTIONS(73),
  },
  [190] = {
    [sym__primary_expression] = STATE(554),
    [sym_binary_operator] = STATE(554),
    [sym_unary_operator] = STATE(554),
    [sym_attribute] = STATE(554),
    [sym_subscript] = STATE(554),
    [sym_call] = STATE(554),
    [sym_list] = STATE(554),
    [sym_list_comprehension] = STATE(554),
    [sym_dictionary] = STATE(554),
    [sym_dictionary_comprehension] = STATE(554),
    [sym_set] = STATE(554),
    [sym_set_comprehension] = STATE(554),
    [sym_parenthesized_expression] = STATE(554),
    [sym_tuple] = STATE(554),
    [sym_generator_expression] = STATE(554),
    [sym_concatenated_string] = STATE(554),
    [sym_string] = STATE(39),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_not] = ACTIONS(971),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(945),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(947),
    [sym_float] = ACTIONS(947),
    [sym_identifier] = ACTIONS(947),
    [sym_true] = ACTIONS(947),
    [sym_false] = ACTIONS(947),
    [sym_none] = ACTIONS(947),
    [sym_comment] = ACTIONS(73),
  },
  [191] = {
    [sym__expression] = STATE(566),
    [sym__primary_expression] = STATE(567),
    [sym_not_operator] = STATE(566),
    [sym_boolean_operator] = STATE(566),
    [sym_binary_operator] = STATE(567),
    [sym_unary_operator] = STATE(567),
    [sym_comparison_operator] = STATE(566),
    [sym_lambda] = STATE(566),
    [sym_attribute] = STATE(567),
    [sym_subscript] = STATE(567),
    [sym_slice] = STATE(568),
    [sym_call] = STATE(567),
    [sym_list] = STATE(567),
    [sym_list_comprehension] = STATE(567),
    [sym_dictionary] = STATE(567),
    [sym_dictionary_comprehension] = STATE(567),
    [sym_set] = STATE(567),
    [sym_set_comprehension] = STATE(567),
    [sym_parenthesized_expression] = STATE(567),
    [sym_tuple] = STATE(567),
    [sym_generator_expression] = STATE(567),
    [sym_conditional_expression] = STATE(566),
    [sym_concatenated_string] = STATE(567),
    [sym_string] = STATE(569),
    [sym_await] = STATE(566),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(973),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(975),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(977),
    [anon_sym_lambda] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(981),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(983),
    [sym_float] = ACTIONS(983),
    [sym_identifier] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_none] = ACTIONS(983),
    [anon_sym_await] = ACTIONS(985),
    [sym_comment] = ACTIONS(73),
  },
  [192] = {
    [sym__newline] = ACTIONS(987),
    [anon_sym_DOT] = ACTIONS(987),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_COMMA] = ACTIONS(987),
    [anon_sym_STAR] = ACTIONS(989),
    [anon_sym_GT_GT] = ACTIONS(989),
    [anon_sym_if] = ACTIONS(987),
    [anon_sym_COLON] = ACTIONS(987),
    [anon_sym_in] = ACTIONS(987),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_AT] = ACTIONS(989),
    [anon_sym_not] = ACTIONS(987),
    [anon_sym_and] = ACTIONS(987),
    [anon_sym_or] = ACTIONS(987),
    [anon_sym_PLUS] = ACTIONS(989),
    [anon_sym_DASH] = ACTIONS(989),
    [anon_sym_SLASH] = ACTIONS(989),
    [anon_sym_PERCENT] = ACTIONS(989),
    [anon_sym_SLASH_SLASH] = ACTIONS(989),
    [anon_sym_STAR_STAR] = ACTIONS(989),
    [anon_sym_PIPE] = ACTIONS(989),
    [anon_sym_AMP] = ACTIONS(989),
    [anon_sym_CARET] = ACTIONS(989),
    [anon_sym_LT_LT] = ACTIONS(989),
    [anon_sym_LT] = ACTIONS(989),
    [anon_sym_LT_EQ] = ACTIONS(987),
    [anon_sym_EQ_EQ] = ACTIONS(987),
    [anon_sym_BANG_EQ] = ACTIONS(987),
    [anon_sym_GT_EQ] = ACTIONS(987),
    [anon_sym_GT] = ACTIONS(989),
    [anon_sym_LT_GT] = ACTIONS(987),
    [anon_sym_is] = ACTIONS(987),
    [anon_sym_PLUS_EQ] = ACTIONS(987),
    [anon_sym_DASH_EQ] = ACTIONS(987),
    [anon_sym_STAR_EQ] = ACTIONS(987),
    [anon_sym_SLASH_EQ] = ACTIONS(987),
    [anon_sym_AT_EQ] = ACTIONS(987),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(987),
    [anon_sym_PERCENT_EQ] = ACTIONS(987),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(987),
    [anon_sym_GT_GT_EQ] = ACTIONS(987),
    [anon_sym_LT_LT_EQ] = ACTIONS(987),
    [anon_sym_AMP_EQ] = ACTIONS(987),
    [anon_sym_CARET_EQ] = ACTIONS(987),
    [anon_sym_PIPE_EQ] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(987),
  },
  [193] = {
    [aux_sym_comparison_operator_repeat1] = STATE(570),
    [sym__newline] = ACTIONS(991),
    [anon_sym_COMMA] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(991),
    [anon_sym_COLON] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(311),
    [anon_sym_EQ] = ACTIONS(993),
    [anon_sym_not] = ACTIONS(315),
    [anon_sym_and] = ACTIONS(991),
    [anon_sym_or] = ACTIONS(991),
    [anon_sym_LT] = ACTIONS(327),
    [anon_sym_LT_EQ] = ACTIONS(311),
    [anon_sym_EQ_EQ] = ACTIONS(311),
    [anon_sym_BANG_EQ] = ACTIONS(311),
    [anon_sym_GT_EQ] = ACTIONS(311),
    [anon_sym_GT] = ACTIONS(327),
    [anon_sym_LT_GT] = ACTIONS(311),
    [anon_sym_is] = ACTIONS(329),
    [anon_sym_PLUS_EQ] = ACTIONS(991),
    [anon_sym_DASH_EQ] = ACTIONS(991),
    [anon_sym_STAR_EQ] = ACTIONS(991),
    [anon_sym_SLASH_EQ] = ACTIONS(991),
    [anon_sym_AT_EQ] = ACTIONS(991),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(991),
    [anon_sym_PERCENT_EQ] = ACTIONS(991),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(991),
    [anon_sym_GT_GT_EQ] = ACTIONS(991),
    [anon_sym_LT_LT_EQ] = ACTIONS(991),
    [anon_sym_AMP_EQ] = ACTIONS(991),
    [anon_sym_CARET_EQ] = ACTIONS(991),
    [anon_sym_PIPE_EQ] = ACTIONS(991),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(991),
  },
  [194] = {
    [sym_string] = STATE(571),
    [aux_sym_concatenated_string_repeat1] = STATE(571),
    [sym__newline] = ACTIONS(995),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(997),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_COLON] = ACTIONS(995),
    [anon_sym_in] = ACTIONS(995),
    [anon_sym_EQ] = ACTIONS(997),
    [anon_sym_AT] = ACTIONS(997),
    [anon_sym_not] = ACTIONS(995),
    [anon_sym_and] = ACTIONS(995),
    [anon_sym_or] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(997),
    [anon_sym_DASH] = ACTIONS(997),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(997),
    [anon_sym_SLASH_SLASH] = ACTIONS(997),
    [anon_sym_STAR_STAR] = ACTIONS(997),
    [anon_sym_PIPE] = ACTIONS(997),
    [anon_sym_AMP] = ACTIONS(997),
    [anon_sym_CARET] = ACTIONS(997),
    [anon_sym_LT_LT] = ACTIONS(997),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_GT] = ACTIONS(995),
    [anon_sym_is] = ACTIONS(995),
    [anon_sym_PLUS_EQ] = ACTIONS(995),
    [anon_sym_DASH_EQ] = ACTIONS(995),
    [anon_sym_STAR_EQ] = ACTIONS(995),
    [anon_sym_SLASH_EQ] = ACTIONS(995),
    [anon_sym_AT_EQ] = ACTIONS(995),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(995),
    [anon_sym_PERCENT_EQ] = ACTIONS(995),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(995),
    [anon_sym_GT_GT_EQ] = ACTIONS(995),
    [anon_sym_LT_LT_EQ] = ACTIONS(995),
    [anon_sym_AMP_EQ] = ACTIONS(995),
    [anon_sym_CARET_EQ] = ACTIONS(995),
    [anon_sym_PIPE_EQ] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(995),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(995),
  },
  [195] = {
    [sym__statement] = STATE(195),
    [sym__simple_statements] = STATE(195),
    [sym_import_statement] = STATE(34),
    [sym_future_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_if_statement] = STATE(195),
    [sym_for_statement] = STATE(195),
    [sym_while_statement] = STATE(195),
    [sym_try_statement] = STATE(195),
    [sym_with_statement] = STATE(195),
    [sym_function_definition] = STATE(195),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym_class_definition] = STATE(195),
    [sym_decorated_definition] = STATE(195),
    [sym_decorator] = STATE(41),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [aux_sym_module_repeat1] = STATE(195),
    [aux_sym_decorated_definition_repeat1] = STATE(41),
    [sym__string_start] = ACTIONS(999),
    [ts_builtin_sym_end] = ACTIONS(1002),
    [anon_sym_import] = ACTIONS(1004),
    [anon_sym_from] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(1010),
    [anon_sym_print] = ACTIONS(1013),
    [anon_sym_assert] = ACTIONS(1016),
    [anon_sym_return] = ACTIONS(1019),
    [anon_sym_del] = ACTIONS(1022),
    [anon_sym_raise] = ACTIONS(1025),
    [anon_sym_pass] = ACTIONS(1028),
    [anon_sym_break] = ACTIONS(1031),
    [anon_sym_continue] = ACTIONS(1034),
    [anon_sym_if] = ACTIONS(1037),
    [anon_sym_async] = ACTIONS(1040),
    [anon_sym_for] = ACTIONS(1043),
    [anon_sym_while] = ACTIONS(1046),
    [anon_sym_try] = ACTIONS(1049),
    [anon_sym_with] = ACTIONS(1052),
    [anon_sym_def] = ACTIONS(1055),
    [anon_sym_global] = ACTIONS(1058),
    [anon_sym_nonlocal] = ACTIONS(1061),
    [anon_sym_exec] = ACTIONS(1064),
    [anon_sym_class] = ACTIONS(1067),
    [anon_sym_AT] = ACTIONS(1070),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_PLUS] = ACTIONS(1076),
    [anon_sym_DASH] = ACTIONS(1076),
    [anon_sym_TILDE] = ACTIONS(1076),
    [anon_sym_lambda] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(1082),
    [anon_sym_LBRACK] = ACTIONS(1085),
    [sym_ellipsis] = ACTIONS(1088),
    [anon_sym_LBRACE] = ACTIONS(1091),
    [sym_integer] = ACTIONS(1094),
    [sym_float] = ACTIONS(1094),
    [sym_identifier] = ACTIONS(1094),
    [sym_true] = ACTIONS(1094),
    [sym_false] = ACTIONS(1094),
    [sym_none] = ACTIONS(1094),
    [anon_sym_await] = ACTIONS(1097),
    [sym_comment] = ACTIONS(73),
  },
  [196] = {
    [anon_sym_def] = ACTIONS(187),
    [sym_comment] = ACTIONS(73),
  },
  [197] = {
    [sym__string_start] = ACTIONS(1100),
    [ts_builtin_sym_end] = ACTIONS(1100),
    [anon_sym_import] = ACTIONS(1102),
    [anon_sym_from] = ACTIONS(1102),
    [anon_sym_LPAREN] = ACTIONS(1100),
    [anon_sym_print] = ACTIONS(1102),
    [anon_sym_assert] = ACTIONS(1102),
    [anon_sym_return] = ACTIONS(1102),
    [anon_sym_del] = ACTIONS(1102),
    [anon_sym_raise] = ACTIONS(1102),
    [anon_sym_pass] = ACTIONS(1102),
    [anon_sym_break] = ACTIONS(1102),
    [anon_sym_continue] = ACTIONS(1102),
    [anon_sym_if] = ACTIONS(1102),
    [anon_sym_async] = ACTIONS(1102),
    [anon_sym_for] = ACTIONS(1102),
    [anon_sym_while] = ACTIONS(1102),
    [anon_sym_try] = ACTIONS(1102),
    [anon_sym_with] = ACTIONS(1102),
    [anon_sym_def] = ACTIONS(1102),
    [anon_sym_global] = ACTIONS(1102),
    [anon_sym_nonlocal] = ACTIONS(1102),
    [anon_sym_exec] = ACTIONS(1102),
    [anon_sym_class] = ACTIONS(1102),
    [anon_sym_AT] = ACTIONS(1100),
    [anon_sym_not] = ACTIONS(1102),
    [anon_sym_PLUS] = ACTIONS(1100),
    [anon_sym_DASH] = ACTIONS(1100),
    [anon_sym_TILDE] = ACTIONS(1100),
    [anon_sym_lambda] = ACTIONS(1102),
    [anon_sym_yield] = ACTIONS(1102),
    [anon_sym_LBRACK] = ACTIONS(1100),
    [sym_ellipsis] = ACTIONS(1100),
    [anon_sym_LBRACE] = ACTIONS(1100),
    [sym_integer] = ACTIONS(1102),
    [sym_float] = ACTIONS(1102),
    [sym_identifier] = ACTIONS(1102),
    [sym_true] = ACTIONS(1102),
    [sym_false] = ACTIONS(1102),
    [sym_none] = ACTIONS(1102),
    [anon_sym_await] = ACTIONS(1102),
    [sym_comment] = ACTIONS(73),
  },
  [198] = {
    [sym_decorator] = STATE(198),
    [aux_sym_decorated_definition_repeat1] = STATE(198),
    [anon_sym_async] = ACTIONS(1104),
    [anon_sym_def] = ACTIONS(1104),
    [anon_sym_class] = ACTIONS(1104),
    [anon_sym_AT] = ACTIONS(1106),
    [sym_comment] = ACTIONS(73),
  },
  [199] = {
    [sym__expression] = STATE(572),
    [sym__primary_expression] = STATE(204),
    [sym_not_operator] = STATE(572),
    [sym_boolean_operator] = STATE(572),
    [sym_binary_operator] = STATE(204),
    [sym_unary_operator] = STATE(204),
    [sym_comparison_operator] = STATE(572),
    [sym_lambda] = STATE(572),
    [sym_attribute] = STATE(204),
    [sym_subscript] = STATE(204),
    [sym_call] = STATE(204),
    [sym_list] = STATE(204),
    [sym_list_comprehension] = STATE(204),
    [sym_dictionary] = STATE(204),
    [sym_dictionary_comprehension] = STATE(204),
    [sym_set] = STATE(204),
    [sym_set_comprehension] = STATE(204),
    [sym_parenthesized_expression] = STATE(204),
    [sym_tuple] = STATE(204),
    [sym_generator_expression] = STATE(204),
    [sym_conditional_expression] = STATE(572),
    [sym_concatenated_string] = STATE(204),
    [sym_string] = STATE(205),
    [sym_await] = STATE(572),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(349),
    [anon_sym_PLUS] = ACTIONS(351),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_lambda] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_identifier] = ACTIONS(357),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_none] = ACTIONS(357),
    [anon_sym_await] = ACTIONS(359),
    [sym_comment] = ACTIONS(73),
  },
  [200] = {
    [sym__primary_expression] = STATE(227),
    [sym_binary_operator] = STATE(227),
    [sym_unary_operator] = STATE(227),
    [sym_attribute] = STATE(227),
    [sym_subscript] = STATE(227),
    [sym_call] = STATE(227),
    [sym_list] = STATE(227),
    [sym_list_comprehension] = STATE(227),
    [sym_dictionary] = STATE(227),
    [sym_dictionary_comprehension] = STATE(227),
    [sym_set] = STATE(227),
    [sym_set_comprehension] = STATE(227),
    [sym_parenthesized_expression] = STATE(227),
    [sym_tuple] = STATE(227),
    [sym_generator_expression] = STATE(227),
    [sym_concatenated_string] = STATE(227),
    [sym_string] = STATE(205),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(351),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(403),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(405),
    [sym_float] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_true] = ACTIONS(405),
    [sym_false] = ACTIONS(405),
    [sym_none] = ACTIONS(405),
    [sym_comment] = ACTIONS(73),
  },
  [201] = {
    [sym_lambda_parameters] = STATE(574),
    [sym__parameters] = STATE(138),
    [sym_default_parameter] = STATE(139),
    [sym_typed_default_parameter] = STATE(139),
    [sym_list_splat] = STATE(140),
    [sym_dictionary_splat] = STATE(140),
    [sym_typed_parameter] = STATE(139),
    [sym_tuple] = STATE(139),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(1109),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [202] = {
    [sym__expression] = STATE(249),
    [sym__primary_expression] = STATE(204),
    [sym_not_operator] = STATE(249),
    [sym_boolean_operator] = STATE(249),
    [sym_binary_operator] = STATE(204),
    [sym_unary_operator] = STATE(204),
    [sym_comparison_operator] = STATE(249),
    [sym_lambda] = STATE(249),
    [sym_attribute] = STATE(204),
    [sym_subscript] = STATE(204),
    [sym_call] = STATE(204),
    [sym_list] = STATE(204),
    [sym_list_comprehension] = STATE(204),
    [sym_dictionary] = STATE(204),
    [sym_dictionary_comprehension] = STATE(204),
    [sym_set] = STATE(204),
    [sym_set_comprehension] = STATE(204),
    [sym_parenthesized_expression] = STATE(204),
    [sym_tuple] = STATE(204),
    [sym_generator_expression] = STATE(204),
    [sym_conditional_expression] = STATE(249),
    [sym_concatenated_string] = STATE(204),
    [sym_string] = STATE(205),
    [sym_await] = STATE(249),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(349),
    [anon_sym_PLUS] = ACTIONS(351),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_lambda] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_identifier] = ACTIONS(357),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_none] = ACTIONS(357),
    [anon_sym_await] = ACTIONS(359),
    [sym_comment] = ACTIONS(73),
  },
  [203] = {
    [anon_sym_if] = ACTIONS(1111),
    [anon_sym_and] = ACTIONS(1113),
    [anon_sym_or] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(1117),
    [sym_type_conversion] = ACTIONS(1119),
    [sym_comment] = ACTIONS(73),
  },
  [204] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [aux_sym_comparison_operator_repeat1] = STATE(590),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_GT_GT] = ACTIONS(1123),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(1125),
    [anon_sym_AT] = ACTIONS(1127),
    [anon_sym_not] = ACTIONS(1129),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1127),
    [anon_sym_SLASH_SLASH] = ACTIONS(1127),
    [anon_sym_STAR_STAR] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1137),
    [anon_sym_CARET] = ACTIONS(1139),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1141),
    [anon_sym_LT_EQ] = ACTIONS(1125),
    [anon_sym_EQ_EQ] = ACTIONS(1125),
    [anon_sym_BANG_EQ] = ACTIONS(1125),
    [anon_sym_GT_EQ] = ACTIONS(1125),
    [anon_sym_GT] = ACTIONS(1141),
    [anon_sym_LT_GT] = ACTIONS(1125),
    [anon_sym_is] = ACTIONS(1143),
    [anon_sym_LBRACK] = ACTIONS(473),
    [anon_sym_RBRACE] = ACTIONS(301),
    [sym_type_conversion] = ACTIONS(301),
    [sym_comment] = ACTIONS(73),
  },
  [205] = {
    [sym_string] = STATE(591),
    [aux_sym_concatenated_string_repeat1] = STATE(591),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_RBRACE] = ACTIONS(333),
    [sym_type_conversion] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [206] = {
    [sym__newline] = ACTIONS(1145),
    [sym__string_start] = ACTIONS(1145),
    [anon_sym_DOT] = ACTIONS(1145),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [anon_sym_COMMA] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1147),
    [anon_sym_GT_GT] = ACTIONS(1147),
    [anon_sym_if] = ACTIONS(1145),
    [anon_sym_COLON] = ACTIONS(1145),
    [anon_sym_in] = ACTIONS(1145),
    [anon_sym_EQ] = ACTIONS(1147),
    [anon_sym_AT] = ACTIONS(1147),
    [anon_sym_not] = ACTIONS(1145),
    [anon_sym_and] = ACTIONS(1145),
    [anon_sym_or] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1147),
    [anon_sym_DASH] = ACTIONS(1147),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1147),
    [anon_sym_SLASH_SLASH] = ACTIONS(1147),
    [anon_sym_STAR_STAR] = ACTIONS(1147),
    [anon_sym_PIPE] = ACTIONS(1147),
    [anon_sym_AMP] = ACTIONS(1147),
    [anon_sym_CARET] = ACTIONS(1147),
    [anon_sym_LT_LT] = ACTIONS(1147),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_LT_EQ] = ACTIONS(1145),
    [anon_sym_EQ_EQ] = ACTIONS(1145),
    [anon_sym_BANG_EQ] = ACTIONS(1145),
    [anon_sym_GT_EQ] = ACTIONS(1145),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_LT_GT] = ACTIONS(1145),
    [anon_sym_is] = ACTIONS(1145),
    [anon_sym_PLUS_EQ] = ACTIONS(1145),
    [anon_sym_DASH_EQ] = ACTIONS(1145),
    [anon_sym_STAR_EQ] = ACTIONS(1145),
    [anon_sym_SLASH_EQ] = ACTIONS(1145),
    [anon_sym_AT_EQ] = ACTIONS(1145),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1145),
    [anon_sym_PERCENT_EQ] = ACTIONS(1145),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1145),
    [anon_sym_GT_GT_EQ] = ACTIONS(1145),
    [anon_sym_LT_LT_EQ] = ACTIONS(1145),
    [anon_sym_AMP_EQ] = ACTIONS(1145),
    [anon_sym_CARET_EQ] = ACTIONS(1145),
    [anon_sym_PIPE_EQ] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1145),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1145),
  },
  [207] = {
    [sym_interpolation] = STATE(207),
    [aux_sym_string_repeat1] = STATE(207),
    [sym__string_content] = ACTIONS(1149),
    [sym__string_end] = ACTIONS(1152),
    [anon_sym_LBRACE] = ACTIONS(1154),
    [sym_escape_sequence] = ACTIONS(1149),
    [sym_comment] = ACTIONS(81),
  },
  [208] = {
    [sym_identifier] = ACTIONS(1157),
    [sym_comment] = ACTIONS(73),
  },
  [209] = {
    [aux_sym_dotted_name_repeat1] = STATE(593),
    [sym__newline] = ACTIONS(1159),
    [anon_sym_DOT] = ACTIONS(367),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_as] = ACTIONS(1159),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1159),
  },
  [210] = {
    [sym_aliased_import] = STATE(594),
    [sym_dotted_name] = STATE(595),
    [sym__newline] = ACTIONS(1161),
    [sym_identifier] = ACTIONS(83),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1161),
  },
  [211] = {
    [aux_sym__import_list_repeat1] = STATE(597),
    [sym__newline] = ACTIONS(1161),
    [anon_sym_COMMA] = ACTIONS(1163),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1161),
  },
  [212] = {
    [sym_identifier] = ACTIONS(1165),
    [sym_comment] = ACTIONS(73),
  },
  [213] = {
    [sym__import_list] = STATE(599),
    [sym_aliased_import] = STATE(47),
    [sym_dotted_name] = STATE(48),
    [sym_identifier] = ACTIONS(83),
    [sym_comment] = ACTIONS(73),
  },
  [214] = {
    [sym_identifier] = ACTIONS(1167),
    [sym_comment] = ACTIONS(73),
  },
  [215] = {
    [aux_sym_dotted_name_repeat1] = STATE(601),
    [anon_sym_import] = ACTIONS(1159),
    [anon_sym_DOT] = ACTIONS(379),
    [sym_comment] = ACTIONS(73),
  },
  [216] = {
    [anon_sym_import] = ACTIONS(1169),
    [sym_comment] = ACTIONS(73),
  },
  [217] = {
    [sym__import_list] = STATE(604),
    [sym_aliased_import] = STATE(47),
    [sym_wildcard_import] = STATE(604),
    [sym_dotted_name] = STATE(48),
    [anon_sym_LPAREN] = ACTIONS(1171),
    [anon_sym_STAR] = ACTIONS(1173),
    [sym_identifier] = ACTIONS(83),
    [sym_comment] = ACTIONS(73),
  },
  [218] = {
    [aux_sym_import_prefix_repeat1] = STATE(218),
    [anon_sym_import] = ACTIONS(1175),
    [anon_sym_DOT] = ACTIONS(1177),
    [sym_identifier] = ACTIONS(1175),
    [sym_comment] = ACTIONS(73),
  },
  [219] = {
    [sym__string_start] = ACTIONS(345),
    [anon_sym_DOT] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(345),
    [anon_sym_RPAREN] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(345),
    [anon_sym_as] = ACTIONS(347),
    [anon_sym_STAR] = ACTIONS(347),
    [anon_sym_GT_GT] = ACTIONS(345),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_COLON] = ACTIONS(345),
    [anon_sym_else] = ACTIONS(345),
    [anon_sym_async] = ACTIONS(345),
    [anon_sym_for] = ACTIONS(345),
    [anon_sym_in] = ACTIONS(345),
    [anon_sym_EQ] = ACTIONS(347),
    [anon_sym_AT] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(345),
    [anon_sym_and] = ACTIONS(345),
    [anon_sym_or] = ACTIONS(345),
    [anon_sym_PLUS] = ACTIONS(345),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_SLASH] = ACTIONS(347),
    [anon_sym_PERCENT] = ACTIONS(345),
    [anon_sym_SLASH_SLASH] = ACTIONS(345),
    [anon_sym_STAR_STAR] = ACTIONS(345),
    [anon_sym_PIPE] = ACTIONS(345),
    [anon_sym_AMP] = ACTIONS(345),
    [anon_sym_CARET] = ACTIONS(345),
    [anon_sym_LT_LT] = ACTIONS(345),
    [anon_sym_LT] = ACTIONS(347),
    [anon_sym_LT_EQ] = ACTIONS(345),
    [anon_sym_EQ_EQ] = ACTIONS(345),
    [anon_sym_BANG_EQ] = ACTIONS(345),
    [anon_sym_GT_EQ] = ACTIONS(345),
    [anon_sym_GT] = ACTIONS(347),
    [anon_sym_LT_GT] = ACTIONS(345),
    [anon_sym_is] = ACTIONS(345),
    [anon_sym_LBRACK] = ACTIONS(345),
    [anon_sym_RBRACK] = ACTIONS(345),
    [anon_sym_RBRACE] = ACTIONS(345),
    [sym_type_conversion] = ACTIONS(345),
    [sym_comment] = ACTIONS(73),
  },
  [220] = {
    [sym_interpolation] = STATE(207),
    [aux_sym_string_repeat1] = STATE(207),
    [sym__string_content] = ACTIONS(361),
    [sym__string_end] = ACTIONS(1180),
    [anon_sym_LBRACE] = ACTIONS(79),
    [sym_escape_sequence] = ACTIONS(361),
    [sym_comment] = ACTIONS(81),
  },
  [221] = {
    [anon_sym_DOT] = ACTIONS(397),
    [anon_sym_LPAREN] = ACTIONS(397),
    [anon_sym_RPAREN] = ACTIONS(397),
    [anon_sym_COMMA] = ACTIONS(397),
    [anon_sym_as] = ACTIONS(399),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_GT_GT] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(397),
    [anon_sym_COLON] = ACTIONS(397),
    [anon_sym_else] = ACTIONS(397),
    [anon_sym_async] = ACTIONS(397),
    [anon_sym_for] = ACTIONS(397),
    [anon_sym_in] = ACTIONS(397),
    [anon_sym_EQ] = ACTIONS(399),
    [anon_sym_AT] = ACTIONS(397),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_and] = ACTIONS(397),
    [anon_sym_or] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(397),
    [anon_sym_DASH] = ACTIONS(397),
    [anon_sym_SLASH] = ACTIONS(399),
    [anon_sym_PERCENT] = ACTIONS(397),
    [anon_sym_SLASH_SLASH] = ACTIONS(397),
    [anon_sym_STAR_STAR] = ACTIONS(397),
    [anon_sym_PIPE] = ACTIONS(397),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_CARET] = ACTIONS(397),
    [anon_sym_LT_LT] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_LT_EQ] = ACTIONS(397),
    [anon_sym_EQ_EQ] = ACTIONS(397),
    [anon_sym_BANG_EQ] = ACTIONS(397),
    [anon_sym_GT_EQ] = ACTIONS(397),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_LT_GT] = ACTIONS(397),
    [anon_sym_is] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(397),
    [anon_sym_RBRACE] = ACTIONS(397),
    [sym_type_conversion] = ACTIONS(397),
    [sym_comment] = ACTIONS(73),
  },
  [222] = {
    [anon_sym_RPAREN] = ACTIONS(1182),
    [sym_comment] = ACTIONS(73),
  },
  [223] = {
    [sym__comprehension_body] = STATE(609),
    [sym_for_in_clause] = STATE(258),
    [aux_sym_tuple_repeat1] = STATE(610),
    [anon_sym_RPAREN] = ACTIONS(1184),
    [anon_sym_COMMA] = ACTIONS(1186),
    [anon_sym_if] = ACTIONS(435),
    [anon_sym_async] = ACTIONS(437),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_and] = ACTIONS(441),
    [anon_sym_or] = ACTIONS(443),
    [sym_comment] = ACTIONS(73),
  },
  [224] = {
    [aux_sym_tuple_repeat1] = STATE(610),
    [anon_sym_RPAREN] = ACTIONS(1184),
    [anon_sym_COMMA] = ACTIONS(1186),
    [sym_comment] = ACTIONS(73),
  },
  [225] = {
    [sym__newline] = ACTIONS(1188),
    [anon_sym_DOT] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1188),
    [anon_sym_COMMA] = ACTIONS(1188),
    [anon_sym_STAR] = ACTIONS(1190),
    [anon_sym_GT_GT] = ACTIONS(1190),
    [anon_sym_if] = ACTIONS(1188),
    [anon_sym_COLON] = ACTIONS(1188),
    [anon_sym_in] = ACTIONS(1188),
    [anon_sym_EQ] = ACTIONS(1190),
    [anon_sym_AT] = ACTIONS(1190),
    [anon_sym_not] = ACTIONS(1188),
    [anon_sym_and] = ACTIONS(1188),
    [anon_sym_or] = ACTIONS(1188),
    [anon_sym_PLUS] = ACTIONS(1190),
    [anon_sym_DASH] = ACTIONS(1190),
    [anon_sym_SLASH] = ACTIONS(1190),
    [anon_sym_PERCENT] = ACTIONS(1190),
    [anon_sym_SLASH_SLASH] = ACTIONS(1190),
    [anon_sym_STAR_STAR] = ACTIONS(1190),
    [anon_sym_PIPE] = ACTIONS(1190),
    [anon_sym_AMP] = ACTIONS(1190),
    [anon_sym_CARET] = ACTIONS(1190),
    [anon_sym_LT_LT] = ACTIONS(1190),
    [anon_sym_LT] = ACTIONS(1190),
    [anon_sym_LT_EQ] = ACTIONS(1188),
    [anon_sym_EQ_EQ] = ACTIONS(1188),
    [anon_sym_BANG_EQ] = ACTIONS(1188),
    [anon_sym_GT_EQ] = ACTIONS(1188),
    [anon_sym_GT] = ACTIONS(1190),
    [anon_sym_LT_GT] = ACTIONS(1188),
    [anon_sym_is] = ACTIONS(1188),
    [anon_sym_PLUS_EQ] = ACTIONS(1188),
    [anon_sym_DASH_EQ] = ACTIONS(1188),
    [anon_sym_STAR_EQ] = ACTIONS(1188),
    [anon_sym_SLASH_EQ] = ACTIONS(1188),
    [anon_sym_AT_EQ] = ACTIONS(1188),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1188),
    [anon_sym_PERCENT_EQ] = ACTIONS(1188),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1188),
    [anon_sym_GT_GT_EQ] = ACTIONS(1188),
    [anon_sym_LT_LT_EQ] = ACTIONS(1188),
    [anon_sym_AMP_EQ] = ACTIONS(1188),
    [anon_sym_CARET_EQ] = ACTIONS(1188),
    [anon_sym_PIPE_EQ] = ACTIONS(1188),
    [anon_sym_LBRACK] = ACTIONS(1188),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1188),
  },
  [226] = {
    [anon_sym_RPAREN] = ACTIONS(723),
    [anon_sym_COMMA] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(723),
    [anon_sym_async] = ACTIONS(723),
    [anon_sym_for] = ACTIONS(723),
    [anon_sym_and] = ACTIONS(441),
    [anon_sym_or] = ACTIONS(443),
    [sym_comment] = ACTIONS(73),
  },
  [227] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(725),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_as] = ACTIONS(727),
    [anon_sym_STAR] = ACTIONS(727),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_COLON] = ACTIONS(725),
    [anon_sym_else] = ACTIONS(725),
    [anon_sym_async] = ACTIONS(725),
    [anon_sym_for] = ACTIONS(725),
    [anon_sym_in] = ACTIONS(725),
    [anon_sym_EQ] = ACTIONS(727),
    [anon_sym_AT] = ACTIONS(725),
    [anon_sym_not] = ACTIONS(725),
    [anon_sym_and] = ACTIONS(725),
    [anon_sym_or] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_SLASH] = ACTIONS(727),
    [anon_sym_PERCENT] = ACTIONS(725),
    [anon_sym_SLASH_SLASH] = ACTIONS(725),
    [anon_sym_STAR_STAR] = ACTIONS(725),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(725),
    [anon_sym_CARET] = ACTIONS(725),
    [anon_sym_LT_LT] = ACTIONS(725),
    [anon_sym_LT] = ACTIONS(727),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_GT] = ACTIONS(727),
    [anon_sym_LT_GT] = ACTIONS(725),
    [anon_sym_is] = ACTIONS(725),
    [anon_sym_LBRACK] = ACTIONS(725),
    [anon_sym_RBRACK] = ACTIONS(725),
    [anon_sym_RBRACE] = ACTIONS(725),
    [sym_type_conversion] = ACTIONS(725),
    [sym_comment] = ACTIONS(73),
  },
  [228] = {
    [sym__expression] = STATE(611),
    [sym__primary_expression] = STATE(67),
    [sym_not_operator] = STATE(611),
    [sym_boolean_operator] = STATE(611),
    [sym_binary_operator] = STATE(67),
    [sym_unary_operator] = STATE(67),
    [sym_comparison_operator] = STATE(611),
    [sym_lambda] = STATE(611),
    [sym_attribute] = STATE(67),
    [sym_subscript] = STATE(67),
    [sym_call] = STATE(67),
    [sym_list] = STATE(67),
    [sym_list_comprehension] = STATE(67),
    [sym_dictionary] = STATE(67),
    [sym_dictionary_comprehension] = STATE(67),
    [sym_set] = STATE(67),
    [sym_set_comprehension] = STATE(67),
    [sym_parenthesized_expression] = STATE(67),
    [sym_tuple] = STATE(67),
    [sym_generator_expression] = STATE(67),
    [sym_conditional_expression] = STATE(611),
    [sym_concatenated_string] = STATE(67),
    [sym_string] = STATE(69),
    [sym_await] = STATE(611),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [229] = {
    [anon_sym_COLON] = ACTIONS(1192),
    [sym_comment] = ACTIONS(73),
  },
  [230] = {
    [sym__expression] = STATE(613),
    [sym__primary_expression] = STATE(237),
    [sym_not_operator] = STATE(613),
    [sym_boolean_operator] = STATE(613),
    [sym_binary_operator] = STATE(237),
    [sym_unary_operator] = STATE(237),
    [sym_comparison_operator] = STATE(613),
    [sym_lambda] = STATE(613),
    [sym_attribute] = STATE(237),
    [sym_subscript] = STATE(237),
    [sym_call] = STATE(237),
    [sym_list] = STATE(237),
    [sym_list_comprehension] = STATE(237),
    [sym_dictionary] = STATE(237),
    [sym_dictionary_comprehension] = STATE(237),
    [sym_set] = STATE(237),
    [sym_set_comprehension] = STATE(237),
    [sym_parenthesized_expression] = STATE(237),
    [sym_tuple] = STATE(237),
    [sym_generator_expression] = STATE(237),
    [sym_conditional_expression] = STATE(613),
    [sym_concatenated_string] = STATE(237),
    [sym_string] = STATE(238),
    [sym_await] = STATE(613),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_lambda] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(419),
    [sym_float] = ACTIONS(419),
    [sym_identifier] = ACTIONS(419),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_none] = ACTIONS(419),
    [anon_sym_await] = ACTIONS(421),
    [sym_comment] = ACTIONS(73),
  },
  [231] = {
    [sym__expression] = STATE(614),
    [sym__primary_expression] = STATE(237),
    [sym_not_operator] = STATE(614),
    [sym_boolean_operator] = STATE(614),
    [sym_binary_operator] = STATE(237),
    [sym_unary_operator] = STATE(237),
    [sym_comparison_operator] = STATE(614),
    [sym_lambda] = STATE(614),
    [sym_attribute] = STATE(237),
    [sym_subscript] = STATE(237),
    [sym_call] = STATE(237),
    [sym_list] = STATE(237),
    [sym_list_comprehension] = STATE(237),
    [sym_dictionary] = STATE(237),
    [sym_dictionary_comprehension] = STATE(237),
    [sym_set] = STATE(237),
    [sym_set_comprehension] = STATE(237),
    [sym_parenthesized_expression] = STATE(237),
    [sym_tuple] = STATE(237),
    [sym_generator_expression] = STATE(237),
    [sym_conditional_expression] = STATE(614),
    [sym_concatenated_string] = STATE(237),
    [sym_string] = STATE(238),
    [sym_await] = STATE(614),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_lambda] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(419),
    [sym_float] = ACTIONS(419),
    [sym_identifier] = ACTIONS(419),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_none] = ACTIONS(419),
    [anon_sym_await] = ACTIONS(421),
    [sym_comment] = ACTIONS(73),
  },
  [232] = {
    [sym__primary_expression] = STATE(227),
    [sym_binary_operator] = STATE(227),
    [sym_unary_operator] = STATE(227),
    [sym_attribute] = STATE(227),
    [sym_subscript] = STATE(227),
    [sym_call] = STATE(227),
    [sym_list] = STATE(227),
    [sym_list_comprehension] = STATE(227),
    [sym_dictionary] = STATE(227),
    [sym_dictionary_comprehension] = STATE(227),
    [sym_set] = STATE(227),
    [sym_set_comprehension] = STATE(227),
    [sym_parenthesized_expression] = STATE(227),
    [sym_tuple] = STATE(227),
    [sym_generator_expression] = STATE(227),
    [sym_concatenated_string] = STATE(227),
    [sym_string] = STATE(238),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(403),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(405),
    [sym_float] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_true] = ACTIONS(405),
    [sym_false] = ACTIONS(405),
    [sym_none] = ACTIONS(405),
    [sym_comment] = ACTIONS(73),
  },
  [233] = {
    [sym_lambda_parameters] = STATE(616),
    [sym__parameters] = STATE(138),
    [sym_default_parameter] = STATE(139),
    [sym_typed_default_parameter] = STATE(139),
    [sym_list_splat] = STATE(140),
    [sym_dictionary_splat] = STATE(140),
    [sym_typed_parameter] = STATE(139),
    [sym_tuple] = STATE(139),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(1194),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [234] = {
    [sym__expression] = STATE(249),
    [sym__primary_expression] = STATE(237),
    [sym_not_operator] = STATE(249),
    [sym_boolean_operator] = STATE(249),
    [sym_binary_operator] = STATE(237),
    [sym_unary_operator] = STATE(237),
    [sym_comparison_operator] = STATE(249),
    [sym_lambda] = STATE(249),
    [sym_attribute] = STATE(237),
    [sym_subscript] = STATE(237),
    [sym_call] = STATE(237),
    [sym_list] = STATE(237),
    [sym_list_comprehension] = STATE(237),
    [sym_dictionary] = STATE(237),
    [sym_dictionary_comprehension] = STATE(237),
    [sym_set] = STATE(237),
    [sym_set_comprehension] = STATE(237),
    [sym_parenthesized_expression] = STATE(237),
    [sym_tuple] = STATE(237),
    [sym_generator_expression] = STATE(237),
    [sym_conditional_expression] = STATE(249),
    [sym_concatenated_string] = STATE(237),
    [sym_string] = STATE(238),
    [sym_await] = STATE(249),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_lambda] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(419),
    [sym_float] = ACTIONS(419),
    [sym_identifier] = ACTIONS(419),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_none] = ACTIONS(419),
    [anon_sym_await] = ACTIONS(421),
    [sym_comment] = ACTIONS(73),
  },
  [235] = {
    [anon_sym_RPAREN] = ACTIONS(761),
    [anon_sym_COMMA] = ACTIONS(761),
    [sym_comment] = ACTIONS(73),
  },
  [236] = {
    [aux_sym_print_statement_repeat1] = STATE(621),
    [anon_sym_RPAREN] = ACTIONS(295),
    [anon_sym_COMMA] = ACTIONS(1196),
    [anon_sym_if] = ACTIONS(1198),
    [anon_sym_and] = ACTIONS(1200),
    [anon_sym_or] = ACTIONS(1202),
    [sym_comment] = ACTIONS(73),
  },
  [237] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [aux_sym_comparison_operator_repeat1] = STATE(632),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(301),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(1204),
    [anon_sym_GT_GT] = ACTIONS(1206),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(1208),
    [anon_sym_AT] = ACTIONS(1210),
    [anon_sym_not] = ACTIONS(1212),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(1214),
    [anon_sym_DASH] = ACTIONS(1214),
    [anon_sym_SLASH] = ACTIONS(1204),
    [anon_sym_PERCENT] = ACTIONS(1210),
    [anon_sym_SLASH_SLASH] = ACTIONS(1210),
    [anon_sym_STAR_STAR] = ACTIONS(1216),
    [anon_sym_PIPE] = ACTIONS(1218),
    [anon_sym_AMP] = ACTIONS(1220),
    [anon_sym_CARET] = ACTIONS(1222),
    [anon_sym_LT_LT] = ACTIONS(1206),
    [anon_sym_LT] = ACTIONS(1224),
    [anon_sym_LT_EQ] = ACTIONS(1208),
    [anon_sym_EQ_EQ] = ACTIONS(1208),
    [anon_sym_BANG_EQ] = ACTIONS(1208),
    [anon_sym_GT_EQ] = ACTIONS(1208),
    [anon_sym_GT] = ACTIONS(1224),
    [anon_sym_LT_GT] = ACTIONS(1208),
    [anon_sym_is] = ACTIONS(1226),
    [anon_sym_LBRACK] = ACTIONS(473),
    [sym_comment] = ACTIONS(73),
  },
  [238] = {
    [sym_string] = STATE(633),
    [aux_sym_concatenated_string_repeat1] = STATE(633),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_RPAREN] = ACTIONS(333),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [239] = {
    [anon_sym_RBRACK] = ACTIONS(1228),
    [sym_comment] = ACTIONS(73),
  },
  [240] = {
    [anon_sym_DOT] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(779),
    [anon_sym_RPAREN] = ACTIONS(779),
    [anon_sym_COMMA] = ACTIONS(779),
    [anon_sym_as] = ACTIONS(781),
    [anon_sym_STAR] = ACTIONS(781),
    [anon_sym_GT_GT] = ACTIONS(779),
    [anon_sym_if] = ACTIONS(779),
    [anon_sym_COLON] = ACTIONS(779),
    [anon_sym_else] = ACTIONS(779),
    [anon_sym_async] = ACTIONS(779),
    [anon_sym_for] = ACTIONS(779),
    [anon_sym_in] = ACTIONS(779),
    [anon_sym_EQ] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(779),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_and] = ACTIONS(779),
    [anon_sym_or] = ACTIONS(779),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_SLASH] = ACTIONS(781),
    [anon_sym_PERCENT] = ACTIONS(779),
    [anon_sym_SLASH_SLASH] = ACTIONS(779),
    [anon_sym_STAR_STAR] = ACTIONS(779),
    [anon_sym_PIPE] = ACTIONS(779),
    [anon_sym_AMP] = ACTIONS(779),
    [anon_sym_CARET] = ACTIONS(779),
    [anon_sym_LT_LT] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(781),
    [anon_sym_LT_EQ] = ACTIONS(779),
    [anon_sym_EQ_EQ] = ACTIONS(779),
    [anon_sym_BANG_EQ] = ACTIONS(779),
    [anon_sym_GT_EQ] = ACTIONS(779),
    [anon_sym_GT] = ACTIONS(781),
    [anon_sym_LT_GT] = ACTIONS(779),
    [anon_sym_is] = ACTIONS(779),
    [anon_sym_LBRACK] = ACTIONS(779),
    [anon_sym_RBRACK] = ACTIONS(779),
    [anon_sym_RBRACE] = ACTIONS(779),
    [sym_type_conversion] = ACTIONS(779),
    [sym_comment] = ACTIONS(73),
  },
  [241] = {
    [aux_sym_list_repeat1] = STATE(636),
    [anon_sym_COMMA] = ACTIONS(1230),
    [anon_sym_RBRACK] = ACTIONS(1228),
    [sym_comment] = ACTIONS(73),
  },
  [242] = {
    [sym__comprehension_body] = STATE(637),
    [sym_for_in_clause] = STATE(465),
    [aux_sym_list_repeat1] = STATE(636),
    [anon_sym_COMMA] = ACTIONS(1230),
    [anon_sym_if] = ACTIONS(785),
    [anon_sym_async] = ACTIONS(787),
    [anon_sym_for] = ACTIONS(789),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_or] = ACTIONS(793),
    [anon_sym_RBRACK] = ACTIONS(1228),
    [sym_comment] = ACTIONS(73),
  },
  [243] = {
    [anon_sym_RBRACE] = ACTIONS(1232),
    [sym_comment] = ACTIONS(73),
  },
  [244] = {
    [anon_sym_DOT] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(837),
    [anon_sym_RPAREN] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_as] = ACTIONS(839),
    [anon_sym_STAR] = ACTIONS(839),
    [anon_sym_GT_GT] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(837),
    [anon_sym_COLON] = ACTIONS(837),
    [anon_sym_else] = ACTIONS(837),
    [anon_sym_async] = ACTIONS(837),
    [anon_sym_for] = ACTIONS(837),
    [anon_sym_in] = ACTIONS(837),
    [anon_sym_EQ] = ACTIONS(839),
    [anon_sym_AT] = ACTIONS(837),
    [anon_sym_not] = ACTIONS(837),
    [anon_sym_and] = ACTIONS(837),
    [anon_sym_or] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(837),
    [anon_sym_DASH] = ACTIONS(837),
    [anon_sym_SLASH] = ACTIONS(839),
    [anon_sym_PERCENT] = ACTIONS(837),
    [anon_sym_SLASH_SLASH] = ACTIONS(837),
    [anon_sym_STAR_STAR] = ACTIONS(837),
    [anon_sym_PIPE] = ACTIONS(837),
    [anon_sym_AMP] = ACTIONS(837),
    [anon_sym_CARET] = ACTIONS(837),
    [anon_sym_LT_LT] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(839),
    [anon_sym_LT_EQ] = ACTIONS(837),
    [anon_sym_EQ_EQ] = ACTIONS(837),
    [anon_sym_BANG_EQ] = ACTIONS(837),
    [anon_sym_GT_EQ] = ACTIONS(837),
    [anon_sym_GT] = ACTIONS(839),
    [anon_sym_LT_GT] = ACTIONS(837),
    [anon_sym_is] = ACTIONS(837),
    [anon_sym_LBRACK] = ACTIONS(837),
    [anon_sym_RBRACK] = ACTIONS(837),
    [anon_sym_RBRACE] = ACTIONS(837),
    [sym_type_conversion] = ACTIONS(837),
    [sym_comment] = ACTIONS(73),
  },
  [245] = {
    [aux_sym_list_repeat1] = STATE(641),
    [anon_sym_COMMA] = ACTIONS(1234),
    [anon_sym_RBRACE] = ACTIONS(1236),
    [sym_comment] = ACTIONS(73),
  },
  [246] = {
    [aux_sym_dictionary_repeat1] = STATE(643),
    [anon_sym_COMMA] = ACTIONS(1238),
    [anon_sym_RBRACE] = ACTIONS(1232),
    [sym_comment] = ACTIONS(73),
  },
  [247] = {
    [sym__comprehension_body] = STATE(644),
    [sym_for_in_clause] = STATE(502),
    [aux_sym_list_repeat1] = STATE(641),
    [anon_sym_COMMA] = ACTIONS(1234),
    [anon_sym_if] = ACTIONS(847),
    [anon_sym_COLON] = ACTIONS(849),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_and] = ACTIONS(855),
    [anon_sym_or] = ACTIONS(857),
    [anon_sym_RBRACE] = ACTIONS(1236),
    [sym_comment] = ACTIONS(73),
  },
  [248] = {
    [sym__comprehension_body] = STATE(645),
    [sym_for_in_clause] = STATE(502),
    [aux_sym_dictionary_repeat1] = STATE(643),
    [anon_sym_COMMA] = ACTIONS(1238),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_RBRACE] = ACTIONS(1232),
    [sym_comment] = ACTIONS(73),
  },
  [249] = {
    [anon_sym_RPAREN] = ACTIONS(883),
    [anon_sym_COMMA] = ACTIONS(883),
    [anon_sym_as] = ACTIONS(1240),
    [anon_sym_if] = ACTIONS(883),
    [anon_sym_COLON] = ACTIONS(883),
    [anon_sym_else] = ACTIONS(883),
    [anon_sym_async] = ACTIONS(883),
    [anon_sym_for] = ACTIONS(883),
    [anon_sym_EQ] = ACTIONS(883),
    [anon_sym_and] = ACTIONS(883),
    [anon_sym_or] = ACTIONS(883),
    [anon_sym_RBRACK] = ACTIONS(883),
    [anon_sym_RBRACE] = ACTIONS(883),
    [sym_type_conversion] = ACTIONS(883),
    [sym_comment] = ACTIONS(73),
  },
  [250] = {
    [sym__newline] = ACTIONS(1242),
    [anon_sym_DOT] = ACTIONS(1242),
    [anon_sym_LPAREN] = ACTIONS(1242),
    [anon_sym_COMMA] = ACTIONS(1242),
    [anon_sym_STAR] = ACTIONS(1244),
    [anon_sym_GT_GT] = ACTIONS(1244),
    [anon_sym_if] = ACTIONS(1242),
    [anon_sym_COLON] = ACTIONS(1242),
    [anon_sym_in] = ACTIONS(1242),
    [anon_sym_EQ] = ACTIONS(1244),
    [anon_sym_AT] = ACTIONS(1244),
    [anon_sym_not] = ACTIONS(1242),
    [anon_sym_and] = ACTIONS(1242),
    [anon_sym_or] = ACTIONS(1242),
    [anon_sym_PLUS] = ACTIONS(1244),
    [anon_sym_DASH] = ACTIONS(1244),
    [anon_sym_SLASH] = ACTIONS(1244),
    [anon_sym_PERCENT] = ACTIONS(1244),
    [anon_sym_SLASH_SLASH] = ACTIONS(1244),
    [anon_sym_STAR_STAR] = ACTIONS(1244),
    [anon_sym_PIPE] = ACTIONS(1244),
    [anon_sym_AMP] = ACTIONS(1244),
    [anon_sym_CARET] = ACTIONS(1244),
    [anon_sym_LT_LT] = ACTIONS(1244),
    [anon_sym_LT] = ACTIONS(1244),
    [anon_sym_LT_EQ] = ACTIONS(1242),
    [anon_sym_EQ_EQ] = ACTIONS(1242),
    [anon_sym_BANG_EQ] = ACTIONS(1242),
    [anon_sym_GT_EQ] = ACTIONS(1242),
    [anon_sym_GT] = ACTIONS(1244),
    [anon_sym_LT_GT] = ACTIONS(1242),
    [anon_sym_is] = ACTIONS(1242),
    [anon_sym_PLUS_EQ] = ACTIONS(1242),
    [anon_sym_DASH_EQ] = ACTIONS(1242),
    [anon_sym_STAR_EQ] = ACTIONS(1242),
    [anon_sym_SLASH_EQ] = ACTIONS(1242),
    [anon_sym_AT_EQ] = ACTIONS(1242),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1242),
    [anon_sym_PERCENT_EQ] = ACTIONS(1242),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1242),
    [anon_sym_GT_GT_EQ] = ACTIONS(1242),
    [anon_sym_LT_LT_EQ] = ACTIONS(1242),
    [anon_sym_AMP_EQ] = ACTIONS(1242),
    [anon_sym_CARET_EQ] = ACTIONS(1242),
    [anon_sym_PIPE_EQ] = ACTIONS(1242),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1242),
  },
  [251] = {
    [sym__expression] = STATE(647),
    [sym__primary_expression] = STATE(237),
    [sym_not_operator] = STATE(647),
    [sym_boolean_operator] = STATE(647),
    [sym_binary_operator] = STATE(237),
    [sym_unary_operator] = STATE(237),
    [sym_comparison_operator] = STATE(647),
    [sym_lambda] = STATE(647),
    [sym_yield] = STATE(648),
    [sym_attribute] = STATE(237),
    [sym_subscript] = STATE(237),
    [sym_call] = STATE(237),
    [sym_list] = STATE(237),
    [sym_list_comprehension] = STATE(237),
    [sym_dictionary] = STATE(237),
    [sym_dictionary_comprehension] = STATE(237),
    [sym_set] = STATE(237),
    [sym_set_comprehension] = STATE(237),
    [sym_parenthesized_expression] = STATE(237),
    [sym_tuple] = STATE(237),
    [sym_generator_expression] = STATE(237),
    [sym_conditional_expression] = STATE(647),
    [sym_concatenated_string] = STATE(237),
    [sym_string] = STATE(238),
    [sym_await] = STATE(647),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(1246),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_lambda] = ACTIONS(415),
    [anon_sym_yield] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(419),
    [sym_float] = ACTIONS(419),
    [sym_identifier] = ACTIONS(419),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_none] = ACTIONS(419),
    [anon_sym_await] = ACTIONS(421),
    [sym_comment] = ACTIONS(73),
  },
  [252] = {
    [sym__expression] = STATE(649),
    [sym__primary_expression] = STATE(538),
    [sym_not_operator] = STATE(649),
    [sym_boolean_operator] = STATE(649),
    [sym_binary_operator] = STATE(538),
    [sym_unary_operator] = STATE(538),
    [sym_comparison_operator] = STATE(649),
    [sym_lambda] = STATE(649),
    [sym_attribute] = STATE(538),
    [sym_subscript] = STATE(538),
    [sym_call] = STATE(538),
    [sym_list] = STATE(538),
    [sym_list_comprehension] = STATE(538),
    [sym_dictionary] = STATE(538),
    [sym_dictionary_comprehension] = STATE(538),
    [sym_set] = STATE(538),
    [sym_set_comprehension] = STATE(538),
    [sym_parenthesized_expression] = STATE(538),
    [sym_tuple] = STATE(538),
    [sym_generator_expression] = STATE(538),
    [sym_conditional_expression] = STATE(649),
    [sym_concatenated_string] = STATE(538),
    [sym_string] = STATE(539),
    [sym_await] = STATE(649),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_lambda] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(917),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(919),
    [sym_float] = ACTIONS(919),
    [sym_identifier] = ACTIONS(919),
    [sym_true] = ACTIONS(919),
    [sym_false] = ACTIONS(919),
    [sym_none] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(921),
    [sym_comment] = ACTIONS(73),
  },
  [253] = {
    [anon_sym_for] = ACTIONS(1248),
    [sym_comment] = ACTIONS(73),
  },
  [254] = {
    [sym_variables] = STATE(651),
    [sym__primary_expression] = STATE(109),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(110),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(191),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(193),
    [sym_float] = ACTIONS(193),
    [sym_identifier] = ACTIONS(193),
    [sym_true] = ACTIONS(193),
    [sym_false] = ACTIONS(193),
    [sym_none] = ACTIONS(193),
    [sym_comment] = ACTIONS(73),
  },
  [255] = {
    [sym__expression] = STATE(652),
    [sym__primary_expression] = STATE(67),
    [sym_not_operator] = STATE(652),
    [sym_boolean_operator] = STATE(652),
    [sym_binary_operator] = STATE(67),
    [sym_unary_operator] = STATE(67),
    [sym_comparison_operator] = STATE(652),
    [sym_lambda] = STATE(652),
    [sym_attribute] = STATE(67),
    [sym_subscript] = STATE(67),
    [sym_call] = STATE(67),
    [sym_list] = STATE(67),
    [sym_list_comprehension] = STATE(67),
    [sym_dictionary] = STATE(67),
    [sym_dictionary_comprehension] = STATE(67),
    [sym_set] = STATE(67),
    [sym_set_comprehension] = STATE(67),
    [sym_parenthesized_expression] = STATE(67),
    [sym_tuple] = STATE(67),
    [sym_generator_expression] = STATE(67),
    [sym_conditional_expression] = STATE(652),
    [sym_concatenated_string] = STATE(67),
    [sym_string] = STATE(69),
    [sym_await] = STATE(652),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [256] = {
    [sym__expression] = STATE(653),
    [sym__primary_expression] = STATE(67),
    [sym_not_operator] = STATE(653),
    [sym_boolean_operator] = STATE(653),
    [sym_binary_operator] = STATE(67),
    [sym_unary_operator] = STATE(67),
    [sym_comparison_operator] = STATE(653),
    [sym_lambda] = STATE(653),
    [sym_attribute] = STATE(67),
    [sym_subscript] = STATE(67),
    [sym_call] = STATE(67),
    [sym_list] = STATE(67),
    [sym_list_comprehension] = STATE(67),
    [sym_dictionary] = STATE(67),
    [sym_dictionary_comprehension] = STATE(67),
    [sym_set] = STATE(67),
    [sym_set_comprehension] = STATE(67),
    [sym_parenthesized_expression] = STATE(67),
    [sym_tuple] = STATE(67),
    [sym_generator_expression] = STATE(67),
    [sym_conditional_expression] = STATE(653),
    [sym_concatenated_string] = STATE(67),
    [sym_string] = STATE(69),
    [sym_await] = STATE(653),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [257] = {
    [anon_sym_RPAREN] = ACTIONS(1250),
    [sym_comment] = ACTIONS(73),
  },
  [258] = {
    [sym_for_in_clause] = STATE(656),
    [sym_if_clause] = STATE(656),
    [aux_sym__comprehension_body_repeat1] = STATE(656),
    [anon_sym_RPAREN] = ACTIONS(1252),
    [anon_sym_if] = ACTIONS(1254),
    [anon_sym_async] = ACTIONS(437),
    [anon_sym_for] = ACTIONS(439),
    [sym_comment] = ACTIONS(73),
  },
  [259] = {
    [aux_sym_tuple_repeat1] = STATE(658),
    [anon_sym_RPAREN] = ACTIONS(1246),
    [anon_sym_COMMA] = ACTIONS(1256),
    [sym_comment] = ACTIONS(73),
  },
  [260] = {
    [sym_identifier] = ACTIONS(1258),
    [sym_comment] = ACTIONS(73),
  },
  [261] = {
    [sym_list_splat] = STATE(662),
    [sym_dictionary_splat] = STATE(662),
    [sym__expression] = STATE(663),
    [sym__primary_expression] = STATE(67),
    [sym_not_operator] = STATE(663),
    [sym_boolean_operator] = STATE(663),
    [sym_binary_operator] = STATE(67),
    [sym_unary_operator] = STATE(67),
    [sym_comparison_operator] = STATE(663),
    [sym_lambda] = STATE(663),
    [sym_attribute] = STATE(67),
    [sym_subscript] = STATE(67),
    [sym_call] = STATE(67),
    [sym_keyword_argument] = STATE(662),
    [sym_list] = STATE(67),
    [sym_list_comprehension] = STATE(67),
    [sym_dictionary] = STATE(67),
    [sym_dictionary_comprehension] = STATE(67),
    [sym_set] = STATE(67),
    [sym_set_comprehension] = STATE(67),
    [sym_parenthesized_expression] = STATE(67),
    [sym_tuple] = STATE(67),
    [sym_generator_expression] = STATE(67),
    [sym_conditional_expression] = STATE(663),
    [sym_concatenated_string] = STATE(67),
    [sym_string] = STATE(69),
    [sym_await] = STATE(663),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(1260),
    [anon_sym_COMMA] = ACTIONS(1262),
    [anon_sym_STAR] = ACTIONS(931),
    [anon_sym_print] = ACTIONS(933),
    [anon_sym_exec] = ACTIONS(933),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(935),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [262] = {
    [sym__primary_expression] = STATE(664),
    [sym_binary_operator] = STATE(664),
    [sym_unary_operator] = STATE(664),
    [sym_attribute] = STATE(664),
    [sym_subscript] = STATE(664),
    [sym_call] = STATE(664),
    [sym_list] = STATE(664),
    [sym_list_comprehension] = STATE(664),
    [sym_dictionary] = STATE(664),
    [sym_dictionary_comprehension] = STATE(664),
    [sym_set] = STATE(664),
    [sym_set_comprehension] = STATE(664),
    [sym_parenthesized_expression] = STATE(664),
    [sym_tuple] = STATE(664),
    [sym_generator_expression] = STATE(664),
    [sym_concatenated_string] = STATE(664),
    [sym_string] = STATE(69),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1264),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1266),
    [sym_float] = ACTIONS(1266),
    [sym_identifier] = ACTIONS(1266),
    [sym_true] = ACTIONS(1266),
    [sym_false] = ACTIONS(1266),
    [sym_none] = ACTIONS(1266),
    [sym_comment] = ACTIONS(73),
  },
  [263] = {
    [sym__primary_expression] = STATE(665),
    [sym_binary_operator] = STATE(665),
    [sym_unary_operator] = STATE(665),
    [sym_attribute] = STATE(665),
    [sym_subscript] = STATE(665),
    [sym_call] = STATE(665),
    [sym_list] = STATE(665),
    [sym_list_comprehension] = STATE(665),
    [sym_dictionary] = STATE(665),
    [sym_dictionary_comprehension] = STATE(665),
    [sym_set] = STATE(665),
    [sym_set_comprehension] = STATE(665),
    [sym_parenthesized_expression] = STATE(665),
    [sym_tuple] = STATE(665),
    [sym_generator_expression] = STATE(665),
    [sym_concatenated_string] = STATE(665),
    [sym_string] = STATE(69),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1268),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1270),
    [sym_float] = ACTIONS(1270),
    [sym_identifier] = ACTIONS(1270),
    [sym_true] = ACTIONS(1270),
    [sym_false] = ACTIONS(1270),
    [sym_none] = ACTIONS(1270),
    [sym_comment] = ACTIONS(73),
  },
  [264] = {
    [sym__primary_expression] = STATE(666),
    [sym_binary_operator] = STATE(666),
    [sym_unary_operator] = STATE(666),
    [sym_attribute] = STATE(666),
    [sym_subscript] = STATE(666),
    [sym_call] = STATE(666),
    [sym_list] = STATE(666),
    [sym_list_comprehension] = STATE(666),
    [sym_dictionary] = STATE(666),
    [sym_dictionary_comprehension] = STATE(666),
    [sym_set] = STATE(666),
    [sym_set_comprehension] = STATE(666),
    [sym_parenthesized_expression] = STATE(666),
    [sym_tuple] = STATE(666),
    [sym_generator_expression] = STATE(666),
    [sym_concatenated_string] = STATE(666),
    [sym_string] = STATE(69),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1272),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1274),
    [sym_float] = ACTIONS(1274),
    [sym_identifier] = ACTIONS(1274),
    [sym_true] = ACTIONS(1274),
    [sym_false] = ACTIONS(1274),
    [sym_none] = ACTIONS(1274),
    [sym_comment] = ACTIONS(73),
  },
  [265] = {
    [anon_sym_in] = ACTIONS(1276),
    [sym_comment] = ACTIONS(73),
  },
  [266] = {
    [sym__primary_expression] = STATE(668),
    [sym_binary_operator] = STATE(668),
    [sym_unary_operator] = STATE(668),
    [sym_attribute] = STATE(668),
    [sym_subscript] = STATE(668),
    [sym_call] = STATE(668),
    [sym_list] = STATE(668),
    [sym_list_comprehension] = STATE(668),
    [sym_dictionary] = STATE(668),
    [sym_dictionary_comprehension] = STATE(668),
    [sym_set] = STATE(668),
    [sym_set_comprehension] = STATE(668),
    [sym_parenthesized_expression] = STATE(668),
    [sym_tuple] = STATE(668),
    [sym_generator_expression] = STATE(668),
    [sym_concatenated_string] = STATE(668),
    [sym_string] = STATE(69),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1278),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1280),
    [sym_float] = ACTIONS(1280),
    [sym_identifier] = ACTIONS(1280),
    [sym_true] = ACTIONS(1280),
    [sym_false] = ACTIONS(1280),
    [sym_none] = ACTIONS(1280),
    [sym_comment] = ACTIONS(73),
  },
  [267] = {
    [sym__primary_expression] = STATE(669),
    [sym_binary_operator] = STATE(669),
    [sym_unary_operator] = STATE(669),
    [sym_attribute] = STATE(669),
    [sym_subscript] = STATE(669),
    [sym_call] = STATE(669),
    [sym_list] = STATE(669),
    [sym_list_comprehension] = STATE(669),
    [sym_dictionary] = STATE(669),
    [sym_dictionary_comprehension] = STATE(669),
    [sym_set] = STATE(669),
    [sym_set_comprehension] = STATE(669),
    [sym_parenthesized_expression] = STATE(669),
    [sym_tuple] = STATE(669),
    [sym_generator_expression] = STATE(669),
    [sym_concatenated_string] = STATE(669),
    [sym_string] = STATE(69),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1282),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1284),
    [sym_float] = ACTIONS(1284),
    [sym_identifier] = ACTIONS(1284),
    [sym_true] = ACTIONS(1284),
    [sym_false] = ACTIONS(1284),
    [sym_none] = ACTIONS(1284),
    [sym_comment] = ACTIONS(73),
  },
  [268] = {
    [sym__primary_expression] = STATE(670),
    [sym_binary_operator] = STATE(670),
    [sym_unary_operator] = STATE(670),
    [sym_attribute] = STATE(670),
    [sym_subscript] = STATE(670),
    [sym_call] = STATE(670),
    [sym_list] = STATE(670),
    [sym_list_comprehension] = STATE(670),
    [sym_dictionary] = STATE(670),
    [sym_dictionary_comprehension] = STATE(670),
    [sym_set] = STATE(670),
    [sym_set_comprehension] = STATE(670),
    [sym_parenthesized_expression] = STATE(670),
    [sym_tuple] = STATE(670),
    [sym_generator_expression] = STATE(670),
    [sym_concatenated_string] = STATE(670),
    [sym_string] = STATE(69),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1286),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1288),
    [sym_float] = ACTIONS(1288),
    [sym_identifier] = ACTIONS(1288),
    [sym_true] = ACTIONS(1288),
    [sym_false] = ACTIONS(1288),
    [sym_none] = ACTIONS(1288),
    [sym_comment] = ACTIONS(73),
  },
  [269] = {
    [sym__primary_expression] = STATE(671),
    [sym_binary_operator] = STATE(671),
    [sym_unary_operator] = STATE(671),
    [sym_attribute] = STATE(671),
    [sym_subscript] = STATE(671),
    [sym_call] = STATE(671),
    [sym_list] = STATE(671),
    [sym_list_comprehension] = STATE(671),
    [sym_dictionary] = STATE(671),
    [sym_dictionary_comprehension] = STATE(671),
    [sym_set] = STATE(671),
    [sym_set_comprehension] = STATE(671),
    [sym_parenthesized_expression] = STATE(671),
    [sym_tuple] = STATE(671),
    [sym_generator_expression] = STATE(671),
    [sym_concatenated_string] = STATE(671),
    [sym_string] = STATE(69),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1290),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1292),
    [sym_float] = ACTIONS(1292),
    [sym_identifier] = ACTIONS(1292),
    [sym_true] = ACTIONS(1292),
    [sym_false] = ACTIONS(1292),
    [sym_none] = ACTIONS(1292),
    [sym_comment] = ACTIONS(73),
  },
  [270] = {
    [sym__primary_expression] = STATE(672),
    [sym_binary_operator] = STATE(672),
    [sym_unary_operator] = STATE(672),
    [sym_attribute] = STATE(672),
    [sym_subscript] = STATE(672),
    [sym_call] = STATE(672),
    [sym_list] = STATE(672),
    [sym_list_comprehension] = STATE(672),
    [sym_dictionary] = STATE(672),
    [sym_dictionary_comprehension] = STATE(672),
    [sym_set] = STATE(672),
    [sym_set_comprehension] = STATE(672),
    [sym_parenthesized_expression] = STATE(672),
    [sym_tuple] = STATE(672),
    [sym_generator_expression] = STATE(672),
    [sym_concatenated_string] = STATE(672),
    [sym_string] = STATE(69),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1294),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1296),
    [sym_float] = ACTIONS(1296),
    [sym_identifier] = ACTIONS(1296),
    [sym_true] = ACTIONS(1296),
    [sym_false] = ACTIONS(1296),
    [sym_none] = ACTIONS(1296),
    [sym_comment] = ACTIONS(73),
  },
  [271] = {
    [sym__primary_expression] = STATE(666),
    [sym_binary_operator] = STATE(666),
    [sym_unary_operator] = STATE(666),
    [sym_attribute] = STATE(666),
    [sym_subscript] = STATE(666),
    [sym_call] = STATE(666),
    [sym_list] = STATE(666),
    [sym_list_comprehension] = STATE(666),
    [sym_dictionary] = STATE(666),
    [sym_dictionary_comprehension] = STATE(666),
    [sym_set] = STATE(666),
    [sym_set_comprehension] = STATE(666),
    [sym_parenthesized_expression] = STATE(666),
    [sym_tuple] = STATE(666),
    [sym_generator_expression] = STATE(666),
    [sym_concatenated_string] = STATE(666),
    [sym_string] = STATE(69),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1298),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1272),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1274),
    [sym_float] = ACTIONS(1274),
    [sym_identifier] = ACTIONS(1274),
    [sym_true] = ACTIONS(1274),
    [sym_false] = ACTIONS(1274),
    [sym_none] = ACTIONS(1274),
    [sym_comment] = ACTIONS(73),
  },
  [272] = {
    [sym__expression] = STATE(673),
    [sym__primary_expression] = STATE(567),
    [sym_not_operator] = STATE(673),
    [sym_boolean_operator] = STATE(673),
    [sym_binary_operator] = STATE(567),
    [sym_unary_operator] = STATE(567),
    [sym_comparison_operator] = STATE(673),
    [sym_lambda] = STATE(673),
    [sym_attribute] = STATE(567),
    [sym_subscript] = STATE(567),
    [sym_slice] = STATE(674),
    [sym_call] = STATE(567),
    [sym_list] = STATE(567),
    [sym_list_comprehension] = STATE(567),
    [sym_dictionary] = STATE(567),
    [sym_dictionary_comprehension] = STATE(567),
    [sym_set] = STATE(567),
    [sym_set_comprehension] = STATE(567),
    [sym_parenthesized_expression] = STATE(567),
    [sym_tuple] = STATE(567),
    [sym_generator_expression] = STATE(567),
    [sym_conditional_expression] = STATE(673),
    [sym_concatenated_string] = STATE(567),
    [sym_string] = STATE(569),
    [sym_await] = STATE(673),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(973),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(975),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(977),
    [anon_sym_lambda] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(981),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(983),
    [sym_float] = ACTIONS(983),
    [sym_identifier] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_none] = ACTIONS(983),
    [anon_sym_await] = ACTIONS(985),
    [sym_comment] = ACTIONS(73),
  },
  [273] = {
    [anon_sym_DOT] = ACTIONS(987),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_RPAREN] = ACTIONS(987),
    [anon_sym_COMMA] = ACTIONS(987),
    [anon_sym_as] = ACTIONS(989),
    [anon_sym_STAR] = ACTIONS(989),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_if] = ACTIONS(987),
    [anon_sym_COLON] = ACTIONS(987),
    [anon_sym_else] = ACTIONS(987),
    [anon_sym_async] = ACTIONS(987),
    [anon_sym_for] = ACTIONS(987),
    [anon_sym_in] = ACTIONS(987),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_AT] = ACTIONS(987),
    [anon_sym_not] = ACTIONS(987),
    [anon_sym_and] = ACTIONS(987),
    [anon_sym_or] = ACTIONS(987),
    [anon_sym_PLUS] = ACTIONS(987),
    [anon_sym_DASH] = ACTIONS(987),
    [anon_sym_SLASH] = ACTIONS(989),
    [anon_sym_PERCENT] = ACTIONS(987),
    [anon_sym_SLASH_SLASH] = ACTIONS(987),
    [anon_sym_STAR_STAR] = ACTIONS(987),
    [anon_sym_PIPE] = ACTIONS(987),
    [anon_sym_AMP] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(987),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT] = ACTIONS(989),
    [anon_sym_LT_EQ] = ACTIONS(987),
    [anon_sym_EQ_EQ] = ACTIONS(987),
    [anon_sym_BANG_EQ] = ACTIONS(987),
    [anon_sym_GT_EQ] = ACTIONS(987),
    [anon_sym_GT] = ACTIONS(989),
    [anon_sym_LT_GT] = ACTIONS(987),
    [anon_sym_is] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(987),
    [anon_sym_RBRACK] = ACTIONS(987),
    [anon_sym_RBRACE] = ACTIONS(987),
    [sym_type_conversion] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
  },
  [274] = {
    [aux_sym_comparison_operator_repeat1] = STATE(675),
    [anon_sym_RPAREN] = ACTIONS(991),
    [anon_sym_COMMA] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(991),
    [anon_sym_async] = ACTIONS(991),
    [anon_sym_for] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(453),
    [anon_sym_not] = ACTIONS(457),
    [anon_sym_and] = ACTIONS(991),
    [anon_sym_or] = ACTIONS(991),
    [anon_sym_LT] = ACTIONS(469),
    [anon_sym_LT_EQ] = ACTIONS(453),
    [anon_sym_EQ_EQ] = ACTIONS(453),
    [anon_sym_BANG_EQ] = ACTIONS(453),
    [anon_sym_GT_EQ] = ACTIONS(453),
    [anon_sym_GT] = ACTIONS(469),
    [anon_sym_LT_GT] = ACTIONS(453),
    [anon_sym_is] = ACTIONS(471),
    [sym_comment] = ACTIONS(73),
  },
  [275] = {
    [sym_string] = STATE(676),
    [aux_sym_concatenated_string_repeat1] = STATE(676),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_RPAREN] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_async] = ACTIONS(995),
    [anon_sym_for] = ACTIONS(995),
    [anon_sym_in] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(995),
    [anon_sym_not] = ACTIONS(995),
    [anon_sym_and] = ACTIONS(995),
    [anon_sym_or] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(995),
    [anon_sym_SLASH_SLASH] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_GT] = ACTIONS(995),
    [anon_sym_is] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(995),
    [sym_comment] = ACTIONS(73),
  },
  [276] = {
    [sym__newline] = ACTIONS(345),
    [sym__string_start] = ACTIONS(345),
    [anon_sym_DOT] = ACTIONS(345),
    [anon_sym_from] = ACTIONS(345),
    [anon_sym_LPAREN] = ACTIONS(345),
    [anon_sym_COMMA] = ACTIONS(345),
    [anon_sym_STAR] = ACTIONS(347),
    [anon_sym_GT_GT] = ACTIONS(345),
    [anon_sym_if] = ACTIONS(345),
    [anon_sym_in] = ACTIONS(345),
    [anon_sym_EQ] = ACTIONS(347),
    [anon_sym_AT] = ACTIONS(345),
    [anon_sym_not] = ACTIONS(345),
    [anon_sym_and] = ACTIONS(345),
    [anon_sym_or] = ACTIONS(345),
    [anon_sym_PLUS] = ACTIONS(345),
    [anon_sym_DASH] = ACTIONS(345),
    [anon_sym_SLASH] = ACTIONS(347),
    [anon_sym_PERCENT] = ACTIONS(345),
    [anon_sym_SLASH_SLASH] = ACTIONS(345),
    [anon_sym_STAR_STAR] = ACTIONS(345),
    [anon_sym_PIPE] = ACTIONS(345),
    [anon_sym_AMP] = ACTIONS(345),
    [anon_sym_CARET] = ACTIONS(345),
    [anon_sym_LT_LT] = ACTIONS(345),
    [anon_sym_LT] = ACTIONS(347),
    [anon_sym_LT_EQ] = ACTIONS(345),
    [anon_sym_EQ_EQ] = ACTIONS(345),
    [anon_sym_BANG_EQ] = ACTIONS(345),
    [anon_sym_GT_EQ] = ACTIONS(345),
    [anon_sym_GT] = ACTIONS(347),
    [anon_sym_LT_GT] = ACTIONS(345),
    [anon_sym_is] = ACTIONS(345),
    [anon_sym_LBRACK] = ACTIONS(345),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(345),
  },
  [277] = {
    [sym_interpolation] = STATE(207),
    [aux_sym_string_repeat1] = STATE(207),
    [sym__string_content] = ACTIONS(361),
    [sym__string_end] = ACTIONS(1300),
    [anon_sym_LBRACE] = ACTIONS(79),
    [sym_escape_sequence] = ACTIONS(361),
    [sym_comment] = ACTIONS(81),
  },
  [278] = {
    [sym__newline] = ACTIONS(397),
    [anon_sym_DOT] = ACTIONS(397),
    [anon_sym_from] = ACTIONS(397),
    [anon_sym_LPAREN] = ACTIONS(397),
    [anon_sym_COMMA] = ACTIONS(397),
    [anon_sym_STAR] = ACTIONS(399),
    [anon_sym_GT_GT] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(397),
    [anon_sym_in] = ACTIONS(397),
    [anon_sym_EQ] = ACTIONS(399),
    [anon_sym_AT] = ACTIONS(397),
    [anon_sym_not] = ACTIONS(397),
    [anon_sym_and] = ACTIONS(397),
    [anon_sym_or] = ACTIONS(397),
    [anon_sym_PLUS] = ACTIONS(397),
    [anon_sym_DASH] = ACTIONS(397),
    [anon_sym_SLASH] = ACTIONS(399),
    [anon_sym_PERCENT] = ACTIONS(397),
    [anon_sym_SLASH_SLASH] = ACTIONS(397),
    [anon_sym_STAR_STAR] = ACTIONS(397),
    [anon_sym_PIPE] = ACTIONS(397),
    [anon_sym_AMP] = ACTIONS(397),
    [anon_sym_CARET] = ACTIONS(397),
    [anon_sym_LT_LT] = ACTIONS(397),
    [anon_sym_LT] = ACTIONS(399),
    [anon_sym_LT_EQ] = ACTIONS(397),
    [anon_sym_EQ_EQ] = ACTIONS(397),
    [anon_sym_BANG_EQ] = ACTIONS(397),
    [anon_sym_GT_EQ] = ACTIONS(397),
    [anon_sym_GT] = ACTIONS(399),
    [anon_sym_LT_GT] = ACTIONS(397),
    [anon_sym_is] = ACTIONS(397),
    [anon_sym_LBRACK] = ACTIONS(397),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(397),
  },
  [279] = {
    [anon_sym_RPAREN] = ACTIONS(1302),
    [sym_comment] = ACTIONS(73),
  },
  [280] = {
    [sym__comprehension_body] = STATE(681),
    [sym_for_in_clause] = STATE(258),
    [aux_sym_tuple_repeat1] = STATE(682),
    [anon_sym_RPAREN] = ACTIONS(1304),
    [anon_sym_COMMA] = ACTIONS(1306),
    [anon_sym_if] = ACTIONS(435),
    [anon_sym_async] = ACTIONS(437),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_and] = ACTIONS(441),
    [anon_sym_or] = ACTIONS(443),
    [sym_comment] = ACTIONS(73),
  },
  [281] = {
    [aux_sym_tuple_repeat1] = STATE(682),
    [anon_sym_RPAREN] = ACTIONS(1304),
    [anon_sym_COMMA] = ACTIONS(1306),
    [sym_comment] = ACTIONS(73),
  },
  [282] = {
    [sym__newline] = ACTIONS(1308),
    [anon_sym_COMMA] = ACTIONS(1308),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_and] = ACTIONS(503),
    [anon_sym_or] = ACTIONS(505),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1308),
  },
  [283] = {
    [sym__newline] = ACTIONS(723),
    [anon_sym_COMMA] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(723),
    [anon_sym_and] = ACTIONS(503),
    [anon_sym_or] = ACTIONS(505),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(723),
  },
  [284] = {
    [sym_argument_list] = STATE(315),
    [sym_generator_expression] = STATE(315),
    [sym__newline] = ACTIONS(725),
    [anon_sym_DOT] = ACTIONS(725),
    [anon_sym_from] = ACTIONS(725),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_COMMA] = ACTIONS(725),
    [anon_sym_STAR] = ACTIONS(727),
    [anon_sym_GT_GT] = ACTIONS(725),
    [anon_sym_if] = ACTIONS(725),
    [anon_sym_in] = ACTIONS(725),
    [anon_sym_EQ] = ACTIONS(727),
    [anon_sym_AT] = ACTIONS(725),
    [anon_sym_not] = ACTIONS(725),
    [anon_sym_and] = ACTIONS(725),
    [anon_sym_or] = ACTIONS(725),
    [anon_sym_PLUS] = ACTIONS(725),
    [anon_sym_DASH] = ACTIONS(725),
    [anon_sym_SLASH] = ACTIONS(727),
    [anon_sym_PERCENT] = ACTIONS(725),
    [anon_sym_SLASH_SLASH] = ACTIONS(725),
    [anon_sym_STAR_STAR] = ACTIONS(725),
    [anon_sym_PIPE] = ACTIONS(725),
    [anon_sym_AMP] = ACTIONS(725),
    [anon_sym_CARET] = ACTIONS(725),
    [anon_sym_LT_LT] = ACTIONS(725),
    [anon_sym_LT] = ACTIONS(727),
    [anon_sym_LT_EQ] = ACTIONS(725),
    [anon_sym_EQ_EQ] = ACTIONS(725),
    [anon_sym_BANG_EQ] = ACTIONS(725),
    [anon_sym_GT_EQ] = ACTIONS(725),
    [anon_sym_GT] = ACTIONS(727),
    [anon_sym_LT_GT] = ACTIONS(725),
    [anon_sym_is] = ACTIONS(725),
    [anon_sym_LBRACK] = ACTIONS(725),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(725),
  },
  [285] = {
    [sym__expression] = STATE(683),
    [sym__primary_expression] = STATE(82),
    [sym_not_operator] = STATE(683),
    [sym_boolean_operator] = STATE(683),
    [sym_binary_operator] = STATE(82),
    [sym_unary_operator] = STATE(82),
    [sym_comparison_operator] = STATE(683),
    [sym_lambda] = STATE(683),
    [sym_attribute] = STATE(82),
    [sym_subscript] = STATE(82),
    [sym_call] = STATE(82),
    [sym_list] = STATE(82),
    [sym_list_comprehension] = STATE(82),
    [sym_dictionary] = STATE(82),
    [sym_dictionary_comprehension] = STATE(82),
    [sym_set] = STATE(82),
    [sym_set_comprehension] = STATE(82),
    [sym_parenthesized_expression] = STATE(82),
    [sym_tuple] = STATE(82),
    [sym_generator_expression] = STATE(82),
    [sym_conditional_expression] = STATE(683),
    [sym_concatenated_string] = STATE(82),
    [sym_string] = STATE(83),
    [sym_await] = STATE(683),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_lambda] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(137),
    [sym_float] = ACTIONS(137),
    [sym_identifier] = ACTIONS(137),
    [sym_true] = ACTIONS(137),
    [sym_false] = ACTIONS(137),
    [sym_none] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
  },
  [286] = {
    [anon_sym_COLON] = ACTIONS(1310),
    [sym_comment] = ACTIONS(73),
  },
  [287] = {
    [anon_sym_RBRACK] = ACTIONS(1312),
    [sym_comment] = ACTIONS(73),
  },
  [288] = {
    [sym__newline] = ACTIONS(779),
    [anon_sym_DOT] = ACTIONS(779),
    [anon_sym_from] = ACTIONS(779),
    [anon_sym_LPAREN] = ACTIONS(779),
    [anon_sym_COMMA] = ACTIONS(779),
    [anon_sym_STAR] = ACTIONS(781),
    [anon_sym_GT_GT] = ACTIONS(779),
    [anon_sym_if] = ACTIONS(779),
    [anon_sym_in] = ACTIONS(779),
    [anon_sym_EQ] = ACTIONS(781),
    [anon_sym_AT] = ACTIONS(779),
    [anon_sym_not] = ACTIONS(779),
    [anon_sym_and] = ACTIONS(779),
    [anon_sym_or] = ACTIONS(779),
    [anon_sym_PLUS] = ACTIONS(779),
    [anon_sym_DASH] = ACTIONS(779),
    [anon_sym_SLASH] = ACTIONS(781),
    [anon_sym_PERCENT] = ACTIONS(779),
    [anon_sym_SLASH_SLASH] = ACTIONS(779),
    [anon_sym_STAR_STAR] = ACTIONS(779),
    [anon_sym_PIPE] = ACTIONS(779),
    [anon_sym_AMP] = ACTIONS(779),
    [anon_sym_CARET] = ACTIONS(779),
    [anon_sym_LT_LT] = ACTIONS(779),
    [anon_sym_LT] = ACTIONS(781),
    [anon_sym_LT_EQ] = ACTIONS(779),
    [anon_sym_EQ_EQ] = ACTIONS(779),
    [anon_sym_BANG_EQ] = ACTIONS(779),
    [anon_sym_GT_EQ] = ACTIONS(779),
    [anon_sym_GT] = ACTIONS(781),
    [anon_sym_LT_GT] = ACTIONS(779),
    [anon_sym_is] = ACTIONS(779),
    [anon_sym_LBRACK] = ACTIONS(779),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(779),
  },
  [289] = {
    [aux_sym_list_repeat1] = STATE(687),
    [anon_sym_COMMA] = ACTIONS(1314),
    [anon_sym_RBRACK] = ACTIONS(1312),
    [sym_comment] = ACTIONS(73),
  },
  [290] = {
    [sym__comprehension_body] = STATE(688),
    [sym_for_in_clause] = STATE(465),
    [aux_sym_list_repeat1] = STATE(687),
    [anon_sym_COMMA] = ACTIONS(1314),
    [anon_sym_if] = ACTIONS(785),
    [anon_sym_async] = ACTIONS(787),
    [anon_sym_for] = ACTIONS(789),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_or] = ACTIONS(793),
    [anon_sym_RBRACK] = ACTIONS(1312),
    [sym_comment] = ACTIONS(73),
  },
  [291] = {
    [anon_sym_RBRACE] = ACTIONS(1316),
    [sym_comment] = ACTIONS(73),
  },
  [292] = {
    [sym__newline] = ACTIONS(837),
    [anon_sym_DOT] = ACTIONS(837),
    [anon_sym_from] = ACTIONS(837),
    [anon_sym_LPAREN] = ACTIONS(837),
    [anon_sym_COMMA] = ACTIONS(837),
    [anon_sym_STAR] = ACTIONS(839),
    [anon_sym_GT_GT] = ACTIONS(837),
    [anon_sym_if] = ACTIONS(837),
    [anon_sym_in] = ACTIONS(837),
    [anon_sym_EQ] = ACTIONS(839),
    [anon_sym_AT] = ACTIONS(837),
    [anon_sym_not] = ACTIONS(837),
    [anon_sym_and] = ACTIONS(837),
    [anon_sym_or] = ACTIONS(837),
    [anon_sym_PLUS] = ACTIONS(837),
    [anon_sym_DASH] = ACTIONS(837),
    [anon_sym_SLASH] = ACTIONS(839),
    [anon_sym_PERCENT] = ACTIONS(837),
    [anon_sym_SLASH_SLASH] = ACTIONS(837),
    [anon_sym_STAR_STAR] = ACTIONS(837),
    [anon_sym_PIPE] = ACTIONS(837),
    [anon_sym_AMP] = ACTIONS(837),
    [anon_sym_CARET] = ACTIONS(837),
    [anon_sym_LT_LT] = ACTIONS(837),
    [anon_sym_LT] = ACTIONS(839),
    [anon_sym_LT_EQ] = ACTIONS(837),
    [anon_sym_EQ_EQ] = ACTIONS(837),
    [anon_sym_BANG_EQ] = ACTIONS(837),
    [anon_sym_GT_EQ] = ACTIONS(837),
    [anon_sym_GT] = ACTIONS(839),
    [anon_sym_LT_GT] = ACTIONS(837),
    [anon_sym_is] = ACTIONS(837),
    [anon_sym_LBRACK] = ACTIONS(837),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(837),
  },
  [293] = {
    [aux_sym_list_repeat1] = STATE(692),
    [anon_sym_COMMA] = ACTIONS(1318),
    [anon_sym_RBRACE] = ACTIONS(1320),
    [sym_comment] = ACTIONS(73),
  },
  [294] = {
    [aux_sym_dictionary_repeat1] = STATE(694),
    [anon_sym_COMMA] = ACTIONS(1322),
    [anon_sym_RBRACE] = ACTIONS(1316),
    [sym_comment] = ACTIONS(73),
  },
  [295] = {
    [sym__comprehension_body] = STATE(695),
    [sym_for_in_clause] = STATE(502),
    [aux_sym_list_repeat1] = STATE(692),
    [anon_sym_COMMA] = ACTIONS(1318),
    [anon_sym_if] = ACTIONS(847),
    [anon_sym_COLON] = ACTIONS(849),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_and] = ACTIONS(855),
    [anon_sym_or] = ACTIONS(857),
    [anon_sym_RBRACE] = ACTIONS(1320),
    [sym_comment] = ACTIONS(73),
  },
  [296] = {
    [sym__comprehension_body] = STATE(696),
    [sym_for_in_clause] = STATE(502),
    [aux_sym_dictionary_repeat1] = STATE(694),
    [anon_sym_COMMA] = ACTIONS(1322),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_RBRACE] = ACTIONS(1316),
    [sym_comment] = ACTIONS(73),
  },
  [297] = {
    [sym__expression] = STATE(697),
    [sym__primary_expression] = STATE(82),
    [sym_not_operator] = STATE(697),
    [sym_boolean_operator] = STATE(697),
    [sym_binary_operator] = STATE(82),
    [sym_unary_operator] = STATE(82),
    [sym_comparison_operator] = STATE(697),
    [sym_lambda] = STATE(697),
    [sym_attribute] = STATE(82),
    [sym_subscript] = STATE(82),
    [sym_call] = STATE(82),
    [sym_list] = STATE(82),
    [sym_list_comprehension] = STATE(82),
    [sym_dictionary] = STATE(82),
    [sym_dictionary_comprehension] = STATE(82),
    [sym_set] = STATE(82),
    [sym_set_comprehension] = STATE(82),
    [sym_parenthesized_expression] = STATE(82),
    [sym_tuple] = STATE(82),
    [sym_generator_expression] = STATE(82),
    [sym_conditional_expression] = STATE(697),
    [sym_concatenated_string] = STATE(82),
    [sym_string] = STATE(83),
    [sym_await] = STATE(697),
    [sym__newline] = ACTIONS(1324),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_lambda] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(137),
    [sym_float] = ACTIONS(137),
    [sym_identifier] = ACTIONS(137),
    [sym_true] = ACTIONS(137),
    [sym_false] = ACTIONS(137),
    [sym_none] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1324),
  },
  [298] = {
    [aux_sym_print_statement_repeat1] = STATE(699),
    [sym__newline] = ACTIONS(1324),
    [anon_sym_COMMA] = ACTIONS(1326),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1324),
  },
  [299] = {
    [sym__expression] = STATE(700),
    [sym__primary_expression] = STATE(538),
    [sym_not_operator] = STATE(700),
    [sym_boolean_operator] = STATE(700),
    [sym_binary_operator] = STATE(538),
    [sym_unary_operator] = STATE(538),
    [sym_comparison_operator] = STATE(700),
    [sym_lambda] = STATE(700),
    [sym_attribute] = STATE(538),
    [sym_subscript] = STATE(538),
    [sym_call] = STATE(538),
    [sym_list] = STATE(538),
    [sym_list_comprehension] = STATE(538),
    [sym_dictionary] = STATE(538),
    [sym_dictionary_comprehension] = STATE(538),
    [sym_set] = STATE(538),
    [sym_set_comprehension] = STATE(538),
    [sym_parenthesized_expression] = STATE(538),
    [sym_tuple] = STATE(538),
    [sym_generator_expression] = STATE(538),
    [sym_conditional_expression] = STATE(700),
    [sym_concatenated_string] = STATE(538),
    [sym_string] = STATE(539),
    [sym_await] = STATE(700),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_lambda] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(917),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(919),
    [sym_float] = ACTIONS(919),
    [sym_identifier] = ACTIONS(919),
    [sym_true] = ACTIONS(919),
    [sym_false] = ACTIONS(919),
    [sym_none] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(921),
    [sym_comment] = ACTIONS(73),
  },
  [300] = {
    [sym__expression] = STATE(540),
    [sym__primary_expression] = STATE(82),
    [sym_not_operator] = STATE(540),
    [sym_boolean_operator] = STATE(540),
    [sym_binary_operator] = STATE(82),
    [sym_unary_operator] = STATE(82),
    [sym_comparison_operator] = STATE(540),
    [sym_lambda] = STATE(540),
    [sym_attribute] = STATE(82),
    [sym_subscript] = STATE(82),
    [sym_call] = STATE(82),
    [sym_list] = STATE(82),
    [sym_list_comprehension] = STATE(82),
    [sym_dictionary] = STATE(82),
    [sym_dictionary_comprehension] = STATE(82),
    [sym_set] = STATE(82),
    [sym_set_comprehension] = STATE(82),
    [sym_parenthesized_expression] = STATE(82),
    [sym_tuple] = STATE(82),
    [sym_generator_expression] = STATE(82),
    [sym_conditional_expression] = STATE(540),
    [sym_concatenated_string] = STATE(82),
    [sym_string] = STATE(83),
    [sym_await] = STATE(540),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_lambda] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(137),
    [sym_float] = ACTIONS(137),
    [sym_identifier] = ACTIONS(137),
    [sym_true] = ACTIONS(137),
    [sym_false] = ACTIONS(137),
    [sym_none] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
  },
  [301] = {
    [sym__expression] = STATE(701),
    [sym__primary_expression] = STATE(82),
    [sym_not_operator] = STATE(701),
    [sym_boolean_operator] = STATE(701),
    [sym_binary_operator] = STATE(82),
    [sym_unary_operator] = STATE(82),
    [sym_comparison_operator] = STATE(701),
    [sym_lambda] = STATE(701),
    [sym_attribute] = STATE(82),
    [sym_subscript] = STATE(82),
    [sym_call] = STATE(82),
    [sym_list] = STATE(82),
    [sym_list_comprehension] = STATE(82),
    [sym_dictionary] = STATE(82),
    [sym_dictionary_comprehension] = STATE(82),
    [sym_set] = STATE(82),
    [sym_set_comprehension] = STATE(82),
    [sym_parenthesized_expression] = STATE(82),
    [sym_tuple] = STATE(82),
    [sym_generator_expression] = STATE(82),
    [sym_conditional_expression] = STATE(701),
    [sym_concatenated_string] = STATE(82),
    [sym_string] = STATE(83),
    [sym_await] = STATE(701),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_lambda] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(137),
    [sym_float] = ACTIONS(137),
    [sym_identifier] = ACTIONS(137),
    [sym_true] = ACTIONS(137),
    [sym_false] = ACTIONS(137),
    [sym_none] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
  },
  [302] = {
    [sym_identifier] = ACTIONS(1328),
    [sym_comment] = ACTIONS(73),
  },
  [303] = {
    [sym_list_splat] = STATE(705),
    [sym_dictionary_splat] = STATE(705),
    [sym__expression] = STATE(706),
    [sym__primary_expression] = STATE(67),
    [sym_not_operator] = STATE(706),
    [sym_boolean_operator] = STATE(706),
    [sym_binary_operator] = STATE(67),
    [sym_unary_operator] = STATE(67),
    [sym_comparison_operator] = STATE(706),
    [sym_lambda] = STATE(706),
    [sym_attribute] = STATE(67),
    [sym_subscript] = STATE(67),
    [sym_call] = STATE(67),
    [sym_keyword_argument] = STATE(705),
    [sym_list] = STATE(67),
    [sym_list_comprehension] = STATE(67),
    [sym_dictionary] = STATE(67),
    [sym_dictionary_comprehension] = STATE(67),
    [sym_set] = STATE(67),
    [sym_set_comprehension] = STATE(67),
    [sym_parenthesized_expression] = STATE(67),
    [sym_tuple] = STATE(67),
    [sym_generator_expression] = STATE(67),
    [sym_conditional_expression] = STATE(706),
    [sym_concatenated_string] = STATE(67),
    [sym_string] = STATE(69),
    [sym_await] = STATE(706),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(1330),
    [anon_sym_COMMA] = ACTIONS(1332),
    [anon_sym_STAR] = ACTIONS(931),
    [anon_sym_print] = ACTIONS(933),
    [anon_sym_exec] = ACTIONS(933),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(935),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [304] = {
    [sym__primary_expression] = STATE(707),
    [sym_binary_operator] = STATE(707),
    [sym_unary_operator] = STATE(707),
    [sym_attribute] = STATE(707),
    [sym_subscript] = STATE(707),
    [sym_call] = STATE(707),
    [sym_list] = STATE(707),
    [sym_list_comprehension] = STATE(707),
    [sym_dictionary] = STATE(707),
    [sym_dictionary_comprehension] = STATE(707),
    [sym_set] = STATE(707),
    [sym_set_comprehension] = STATE(707),
    [sym_parenthesized_expression] = STATE(707),
    [sym_tuple] = STATE(707),
    [sym_generator_expression] = STATE(707),
    [sym_concatenated_string] = STATE(707),
    [sym_string] = STATE(83),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1334),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1336),
    [sym_float] = ACTIONS(1336),
    [sym_identifier] = ACTIONS(1336),
    [sym_true] = ACTIONS(1336),
    [sym_false] = ACTIONS(1336),
    [sym_none] = ACTIONS(1336),
    [sym_comment] = ACTIONS(73),
  },
  [305] = {
    [sym__primary_expression] = STATE(708),
    [sym_binary_operator] = STATE(708),
    [sym_unary_operator] = STATE(708),
    [sym_attribute] = STATE(708),
    [sym_subscript] = STATE(708),
    [sym_call] = STATE(708),
    [sym_list] = STATE(708),
    [sym_list_comprehension] = STATE(708),
    [sym_dictionary] = STATE(708),
    [sym_dictionary_comprehension] = STATE(708),
    [sym_set] = STATE(708),
    [sym_set_comprehension] = STATE(708),
    [sym_parenthesized_expression] = STATE(708),
    [sym_tuple] = STATE(708),
    [sym_generator_expression] = STATE(708),
    [sym_concatenated_string] = STATE(708),
    [sym_string] = STATE(83),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1338),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1340),
    [sym_float] = ACTIONS(1340),
    [sym_identifier] = ACTIONS(1340),
    [sym_true] = ACTIONS(1340),
    [sym_false] = ACTIONS(1340),
    [sym_none] = ACTIONS(1340),
    [sym_comment] = ACTIONS(73),
  },
  [306] = {
    [sym__primary_expression] = STATE(709),
    [sym_binary_operator] = STATE(709),
    [sym_unary_operator] = STATE(709),
    [sym_attribute] = STATE(709),
    [sym_subscript] = STATE(709),
    [sym_call] = STATE(709),
    [sym_list] = STATE(709),
    [sym_list_comprehension] = STATE(709),
    [sym_dictionary] = STATE(709),
    [sym_dictionary_comprehension] = STATE(709),
    [sym_set] = STATE(709),
    [sym_set_comprehension] = STATE(709),
    [sym_parenthesized_expression] = STATE(709),
    [sym_tuple] = STATE(709),
    [sym_generator_expression] = STATE(709),
    [sym_concatenated_string] = STATE(709),
    [sym_string] = STATE(83),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1342),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1344),
    [sym_float] = ACTIONS(1344),
    [sym_identifier] = ACTIONS(1344),
    [sym_true] = ACTIONS(1344),
    [sym_false] = ACTIONS(1344),
    [sym_none] = ACTIONS(1344),
    [sym_comment] = ACTIONS(73),
  },
  [307] = {
    [anon_sym_in] = ACTIONS(1346),
    [sym_comment] = ACTIONS(73),
  },
  [308] = {
    [sym__primary_expression] = STATE(711),
    [sym_binary_operator] = STATE(711),
    [sym_unary_operator] = STATE(711),
    [sym_attribute] = STATE(711),
    [sym_subscript] = STATE(711),
    [sym_call] = STATE(711),
    [sym_list] = STATE(711),
    [sym_list_comprehension] = STATE(711),
    [sym_dictionary] = STATE(711),
    [sym_dictionary_comprehension] = STATE(711),
    [sym_set] = STATE(711),
    [sym_set_comprehension] = STATE(711),
    [sym_parenthesized_expression] = STATE(711),
    [sym_tuple] = STATE(711),
    [sym_generator_expression] = STATE(711),
    [sym_concatenated_string] = STATE(711),
    [sym_string] = STATE(83),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1348),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1350),
    [sym_float] = ACTIONS(1350),
    [sym_identifier] = ACTIONS(1350),
    [sym_true] = ACTIONS(1350),
    [sym_false] = ACTIONS(1350),
    [sym_none] = ACTIONS(1350),
    [sym_comment] = ACTIONS(73),
  },
  [309] = {
    [sym__primary_expression] = STATE(712),
    [sym_binary_operator] = STATE(712),
    [sym_unary_operator] = STATE(712),
    [sym_attribute] = STATE(712),
    [sym_subscript] = STATE(712),
    [sym_call] = STATE(712),
    [sym_list] = STATE(712),
    [sym_list_comprehension] = STATE(712),
    [sym_dictionary] = STATE(712),
    [sym_dictionary_comprehension] = STATE(712),
    [sym_set] = STATE(712),
    [sym_set_comprehension] = STATE(712),
    [sym_parenthesized_expression] = STATE(712),
    [sym_tuple] = STATE(712),
    [sym_generator_expression] = STATE(712),
    [sym_concatenated_string] = STATE(712),
    [sym_string] = STATE(83),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1354),
    [sym_float] = ACTIONS(1354),
    [sym_identifier] = ACTIONS(1354),
    [sym_true] = ACTIONS(1354),
    [sym_false] = ACTIONS(1354),
    [sym_none] = ACTIONS(1354),
    [sym_comment] = ACTIONS(73),
  },
  [310] = {
    [sym__primary_expression] = STATE(713),
    [sym_binary_operator] = STATE(713),
    [sym_unary_operator] = STATE(713),
    [sym_attribute] = STATE(713),
    [sym_subscript] = STATE(713),
    [sym_call] = STATE(713),
    [sym_list] = STATE(713),
    [sym_list_comprehension] = STATE(713),
    [sym_dictionary] = STATE(713),
    [sym_dictionary_comprehension] = STATE(713),
    [sym_set] = STATE(713),
    [sym_set_comprehension] = STATE(713),
    [sym_parenthesized_expression] = STATE(713),
    [sym_tuple] = STATE(713),
    [sym_generator_expression] = STATE(713),
    [sym_concatenated_string] = STATE(713),
    [sym_string] = STATE(83),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1356),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1358),
    [sym_float] = ACTIONS(1358),
    [sym_identifier] = ACTIONS(1358),
    [sym_true] = ACTIONS(1358),
    [sym_false] = ACTIONS(1358),
    [sym_none] = ACTIONS(1358),
    [sym_comment] = ACTIONS(73),
  },
  [311] = {
    [sym__primary_expression] = STATE(714),
    [sym_binary_operator] = STATE(714),
    [sym_unary_operator] = STATE(714),
    [sym_attribute] = STATE(714),
    [sym_subscript] = STATE(714),
    [sym_call] = STATE(714),
    [sym_list] = STATE(714),
    [sym_list_comprehension] = STATE(714),
    [sym_dictionary] = STATE(714),
    [sym_dictionary_comprehension] = STATE(714),
    [sym_set] = STATE(714),
    [sym_set_comprehension] = STATE(714),
    [sym_parenthesized_expression] = STATE(714),
    [sym_tuple] = STATE(714),
    [sym_generator_expression] = STATE(714),
    [sym_concatenated_string] = STATE(714),
    [sym_string] = STATE(83),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1360),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1362),
    [sym_float] = ACTIONS(1362),
    [sym_identifier] = ACTIONS(1362),
    [sym_true] = ACTIONS(1362),
    [sym_false] = ACTIONS(1362),
    [sym_none] = ACTIONS(1362),
    [sym_comment] = ACTIONS(73),
  },
  [312] = {
    [sym__primary_expression] = STATE(715),
    [sym_binary_operator] = STATE(715),
    [sym_unary_operator] = STATE(715),
    [sym_attribute] = STATE(715),
    [sym_subscript] = STATE(715),
    [sym_call] = STATE(715),
    [sym_list] = STATE(715),
    [sym_list_comprehension] = STATE(715),
    [sym_dictionary] = STATE(715),
    [sym_dictionary_comprehension] = STATE(715),
    [sym_set] = STATE(715),
    [sym_set_comprehension] = STATE(715),
    [sym_parenthesized_expression] = STATE(715),
    [sym_tuple] = STATE(715),
    [sym_generator_expression] = STATE(715),
    [sym_concatenated_string] = STATE(715),
    [sym_string] = STATE(83),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1364),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1366),
    [sym_float] = ACTIONS(1366),
    [sym_identifier] = ACTIONS(1366),
    [sym_true] = ACTIONS(1366),
    [sym_false] = ACTIONS(1366),
    [sym_none] = ACTIONS(1366),
    [sym_comment] = ACTIONS(73),
  },
  [313] = {
    [sym__primary_expression] = STATE(709),
    [sym_binary_operator] = STATE(709),
    [sym_unary_operator] = STATE(709),
    [sym_attribute] = STATE(709),
    [sym_subscript] = STATE(709),
    [sym_call] = STATE(709),
    [sym_list] = STATE(709),
    [sym_list_comprehension] = STATE(709),
    [sym_dictionary] = STATE(709),
    [sym_dictionary_comprehension] = STATE(709),
    [sym_set] = STATE(709),
    [sym_set_comprehension] = STATE(709),
    [sym_parenthesized_expression] = STATE(709),
    [sym_tuple] = STATE(709),
    [sym_generator_expression] = STATE(709),
    [sym_concatenated_string] = STATE(709),
    [sym_string] = STATE(83),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(1368),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1342),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1344),
    [sym_float] = ACTIONS(1344),
    [sym_identifier] = ACTIONS(1344),
    [sym_true] = ACTIONS(1344),
    [sym_false] = ACTIONS(1344),
    [sym_none] = ACTIONS(1344),
    [sym_comment] = ACTIONS(73),
  },
  [314] = {
    [sym__expression] = STATE(716),
    [sym__primary_expression] = STATE(567),
    [sym_not_operator] = STATE(716),
    [sym_boolean_operator] = STATE(716),
    [sym_binary_operator] = STATE(567),
    [sym_unary_operator] = STATE(567),
    [sym_comparison_operator] = STATE(716),
    [sym_lambda] = STATE(716),
    [sym_attribute] = STATE(567),
    [sym_subscript] = STATE(567),
    [sym_slice] = STATE(717),
    [sym_call] = STATE(567),
    [sym_list] = STATE(567),
    [sym_list_comprehension] = STATE(567),
    [sym_dictionary] = STATE(567),
    [sym_dictionary_comprehension] = STATE(567),
    [sym_set] = STATE(567),
    [sym_set_comprehension] = STATE(567),
    [sym_parenthesized_expression] = STATE(567),
    [sym_tuple] = STATE(567),
    [sym_generator_expression] = STATE(567),
    [sym_conditional_expression] = STATE(716),
    [sym_concatenated_string] = STATE(567),
    [sym_string] = STATE(569),
    [sym_await] = STATE(716),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(973),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(975),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(977),
    [anon_sym_lambda] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(981),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(983),
    [sym_float] = ACTIONS(983),
    [sym_identifier] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_none] = ACTIONS(983),
    [anon_sym_await] = ACTIONS(985),
    [sym_comment] = ACTIONS(73),
  },
  [315] = {
    [sym__newline] = ACTIONS(987),
    [anon_sym_DOT] = ACTIONS(987),
    [anon_sym_from] = ACTIONS(987),
    [anon_sym_LPAREN] = ACTIONS(987),
    [anon_sym_COMMA] = ACTIONS(987),
    [anon_sym_STAR] = ACTIONS(989),
    [anon_sym_GT_GT] = ACTIONS(987),
    [anon_sym_if] = ACTIONS(987),
    [anon_sym_in] = ACTIONS(987),
    [anon_sym_EQ] = ACTIONS(989),
    [anon_sym_AT] = ACTIONS(987),
    [anon_sym_not] = ACTIONS(987),
    [anon_sym_and] = ACTIONS(987),
    [anon_sym_or] = ACTIONS(987),
    [anon_sym_PLUS] = ACTIONS(987),
    [anon_sym_DASH] = ACTIONS(987),
    [anon_sym_SLASH] = ACTIONS(989),
    [anon_sym_PERCENT] = ACTIONS(987),
    [anon_sym_SLASH_SLASH] = ACTIONS(987),
    [anon_sym_STAR_STAR] = ACTIONS(987),
    [anon_sym_PIPE] = ACTIONS(987),
    [anon_sym_AMP] = ACTIONS(987),
    [anon_sym_CARET] = ACTIONS(987),
    [anon_sym_LT_LT] = ACTIONS(987),
    [anon_sym_LT] = ACTIONS(989),
    [anon_sym_LT_EQ] = ACTIONS(987),
    [anon_sym_EQ_EQ] = ACTIONS(987),
    [anon_sym_BANG_EQ] = ACTIONS(987),
    [anon_sym_GT_EQ] = ACTIONS(987),
    [anon_sym_GT] = ACTIONS(989),
    [anon_sym_LT_GT] = ACTIONS(987),
    [anon_sym_is] = ACTIONS(987),
    [anon_sym_LBRACK] = ACTIONS(987),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(987),
  },
  [316] = {
    [aux_sym_comparison_operator_repeat1] = STATE(718),
    [sym__newline] = ACTIONS(991),
    [anon_sym_COMMA] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(515),
    [anon_sym_not] = ACTIONS(519),
    [anon_sym_and] = ACTIONS(991),
    [anon_sym_or] = ACTIONS(991),
    [anon_sym_LT] = ACTIONS(531),
    [anon_sym_LT_EQ] = ACTIONS(515),
    [anon_sym_EQ_EQ] = ACTIONS(515),
    [anon_sym_BANG_EQ] = ACTIONS(515),
    [anon_sym_GT_EQ] = ACTIONS(515),
    [anon_sym_GT] = ACTIONS(531),
    [anon_sym_LT_GT] = ACTIONS(515),
    [anon_sym_is] = ACTIONS(533),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(991),
  },
  [317] = {
    [sym_string] = STATE(719),
    [aux_sym_concatenated_string_repeat1] = STATE(719),
    [sym__newline] = ACTIONS(995),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_in] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(995),
    [anon_sym_not] = ACTIONS(995),
    [anon_sym_and] = ACTIONS(995),
    [anon_sym_or] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(995),
    [anon_sym_SLASH_SLASH] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_GT] = ACTIONS(995),
    [anon_sym_is] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(995),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(995),
  },
  [318] = {
    [sym__expression] = STATE(697),
    [sym__primary_expression] = STATE(82),
    [sym_not_operator] = STATE(697),
    [sym_boolean_operator] = STATE(697),
    [sym_binary_operator] = STATE(82),
    [sym_unary_operator] = STATE(82),
    [sym_comparison_operator] = STATE(697),
    [sym_lambda] = STATE(697),
    [sym_attribute] = STATE(82),
    [sym_subscript] = STATE(82),
    [sym_call] = STATE(82),
    [sym_list] = STATE(82),
    [sym_list_comprehension] = STATE(82),
    [sym_dictionary] = STATE(82),
    [sym_dictionary_comprehension] = STATE(82),
    [sym_set] = STATE(82),
    [sym_set_comprehension] = STATE(82),
    [sym_parenthesized_expression] = STATE(82),
    [sym_tuple] = STATE(82),
    [sym_generator_expression] = STATE(82),
    [sym_conditional_expression] = STATE(697),
    [sym_concatenated_string] = STATE(82),
    [sym_string] = STATE(83),
    [sym_await] = STATE(697),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_lambda] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(137),
    [sym_float] = ACTIONS(137),
    [sym_identifier] = ACTIONS(137),
    [sym_true] = ACTIONS(137),
    [sym_false] = ACTIONS(137),
    [sym_none] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
  },
  [319] = {
    [aux_sym_print_statement_repeat1] = STATE(699),
    [sym__newline] = ACTIONS(1370),
    [anon_sym_COMMA] = ACTIONS(539),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1370),
  },
  [320] = {
    [sym__expression] = STATE(697),
    [sym__primary_expression] = STATE(82),
    [sym_not_operator] = STATE(697),
    [sym_boolean_operator] = STATE(697),
    [sym_binary_operator] = STATE(82),
    [sym_unary_operator] = STATE(82),
    [sym_comparison_operator] = STATE(697),
    [sym_lambda] = STATE(697),
    [sym_attribute] = STATE(82),
    [sym_subscript] = STATE(82),
    [sym_call] = STATE(82),
    [sym_list] = STATE(82),
    [sym_list_comprehension] = STATE(82),
    [sym_dictionary] = STATE(82),
    [sym_dictionary_comprehension] = STATE(82),
    [sym_set] = STATE(82),
    [sym_set_comprehension] = STATE(82),
    [sym_parenthesized_expression] = STATE(82),
    [sym_tuple] = STATE(82),
    [sym_generator_expression] = STATE(82),
    [sym_conditional_expression] = STATE(697),
    [sym_concatenated_string] = STATE(82),
    [sym_string] = STATE(83),
    [sym_await] = STATE(697),
    [sym__newline] = ACTIONS(907),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_lambda] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(137),
    [sym_float] = ACTIONS(137),
    [sym_identifier] = ACTIONS(137),
    [sym_true] = ACTIONS(137),
    [sym_false] = ACTIONS(137),
    [sym_none] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(907),
  },
  [321] = {
    [aux_sym_print_statement_repeat1] = STATE(699),
    [sym__newline] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(1372),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(907),
  },
  [322] = {
    [sym__expression] = STATE(721),
    [sym__primary_expression] = STATE(327),
    [sym_not_operator] = STATE(721),
    [sym_boolean_operator] = STATE(721),
    [sym_binary_operator] = STATE(327),
    [sym_unary_operator] = STATE(327),
    [sym_comparison_operator] = STATE(721),
    [sym_lambda] = STATE(721),
    [sym_attribute] = STATE(327),
    [sym_subscript] = STATE(327),
    [sym_call] = STATE(327),
    [sym_list] = STATE(327),
    [sym_list_comprehension] = STATE(327),
    [sym_dictionary] = STATE(327),
    [sym_dictionary_comprehension] = STATE(327),
    [sym_set] = STATE(327),
    [sym_set_comprehension] = STATE(327),
    [sym_parenthesized_expression] = STATE(327),
    [sym_tuple] = STATE(327),
    [sym_generator_expression] = STATE(327),
    [sym_conditional_expression] = STATE(721),
    [sym_concatenated_string] = STATE(327),
    [sym_string] = STATE(328),
    [sym_await] = STATE(721),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(547),
    [anon_sym_PLUS] = ACTIONS(549),
    [anon_sym_DASH] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_lambda] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(553),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(555),
    [sym_float] = ACTIONS(555),
    [sym_identifier] = ACTIONS(555),
    [sym_true] = ACTIONS(555),
    [sym_false] = ACTIONS(555),
    [sym_none] = ACTIONS(555),
    [anon_sym_await] = ACTIONS(557),
    [sym_comment] = ACTIONS(73),
  },
  [323] = {
    [sym__primary_expression] = STATE(284),
    [sym_binary_operator] = STATE(284),
    [sym_unary_operator] = STATE(284),
    [sym_attribute] = STATE(284),
    [sym_subscript] = STATE(284),
    [sym_call] = STATE(284),
    [sym_list] = STATE(284),
    [sym_list_comprehension] = STATE(284),
    [sym_dictionary] = STATE(284),
    [sym_dictionary_comprehension] = STATE(284),
    [sym_set] = STATE(284),
    [sym_set_comprehension] = STATE(284),
    [sym_parenthesized_expression] = STATE(284),
    [sym_tuple] = STATE(284),
    [sym_generator_expression] = STATE(284),
    [sym_concatenated_string] = STATE(284),
    [sym_string] = STATE(328),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(549),
    [anon_sym_DASH] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(485),
    [sym_float] = ACTIONS(485),
    [sym_identifier] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_none] = ACTIONS(485),
    [sym_comment] = ACTIONS(73),
  },
  [324] = {
    [sym_lambda_parameters] = STATE(723),
    [sym__parameters] = STATE(138),
    [sym_default_parameter] = STATE(139),
    [sym_typed_default_parameter] = STATE(139),
    [sym_list_splat] = STATE(140),
    [sym_dictionary_splat] = STATE(140),
    [sym_typed_parameter] = STATE(139),
    [sym_tuple] = STATE(139),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(1374),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [325] = {
    [sym__expression] = STATE(167),
    [sym__primary_expression] = STATE(327),
    [sym_not_operator] = STATE(167),
    [sym_boolean_operator] = STATE(167),
    [sym_binary_operator] = STATE(327),
    [sym_unary_operator] = STATE(327),
    [sym_comparison_operator] = STATE(167),
    [sym_lambda] = STATE(167),
    [sym_attribute] = STATE(327),
    [sym_subscript] = STATE(327),
    [sym_call] = STATE(327),
    [sym_list] = STATE(327),
    [sym_list_comprehension] = STATE(327),
    [sym_dictionary] = STATE(327),
    [sym_dictionary_comprehension] = STATE(327),
    [sym_set] = STATE(327),
    [sym_set_comprehension] = STATE(327),
    [sym_parenthesized_expression] = STATE(327),
    [sym_tuple] = STATE(327),
    [sym_generator_expression] = STATE(327),
    [sym_conditional_expression] = STATE(167),
    [sym_concatenated_string] = STATE(327),
    [sym_string] = STATE(328),
    [sym_await] = STATE(167),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(547),
    [anon_sym_PLUS] = ACTIONS(549),
    [anon_sym_DASH] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_lambda] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(553),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(555),
    [sym_float] = ACTIONS(555),
    [sym_identifier] = ACTIONS(555),
    [sym_true] = ACTIONS(555),
    [sym_false] = ACTIONS(555),
    [sym_none] = ACTIONS(555),
    [anon_sym_await] = ACTIONS(557),
    [sym_comment] = ACTIONS(73),
  },
  [326] = {
    [sym__newline] = ACTIONS(1376),
    [anon_sym_if] = ACTIONS(1378),
    [anon_sym_and] = ACTIONS(1380),
    [anon_sym_or] = ACTIONS(1382),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1376),
  },
  [327] = {
    [sym_argument_list] = STATE(315),
    [sym_generator_expression] = STATE(315),
    [aux_sym_comparison_operator_repeat1] = STATE(737),
    [sym__newline] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_STAR] = ACTIONS(1384),
    [anon_sym_GT_GT] = ACTIONS(1386),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(1388),
    [anon_sym_AT] = ACTIONS(1390),
    [anon_sym_not] = ACTIONS(1392),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(1394),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_SLASH] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH] = ACTIONS(1390),
    [anon_sym_STAR_STAR] = ACTIONS(1396),
    [anon_sym_PIPE] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
    [anon_sym_CARET] = ACTIONS(1402),
    [anon_sym_LT_LT] = ACTIONS(1386),
    [anon_sym_LT] = ACTIONS(1404),
    [anon_sym_LT_EQ] = ACTIONS(1388),
    [anon_sym_EQ_EQ] = ACTIONS(1388),
    [anon_sym_BANG_EQ] = ACTIONS(1388),
    [anon_sym_GT_EQ] = ACTIONS(1388),
    [anon_sym_GT] = ACTIONS(1404),
    [anon_sym_LT_GT] = ACTIONS(1388),
    [anon_sym_is] = ACTIONS(1406),
    [anon_sym_LBRACK] = ACTIONS(535),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(301),
  },
  [328] = {
    [sym_string] = STATE(738),
    [aux_sym_concatenated_string_repeat1] = STATE(738),
    [sym__newline] = ACTIONS(333),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(333),
  },
  [329] = {
    [sym__newline] = ACTIONS(723),
    [anon_sym_from] = ACTIONS(723),
    [anon_sym_COMMA] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(723),
    [anon_sym_and] = ACTIONS(569),
    [anon_sym_or] = ACTIONS(571),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(723),
  },
  [330] = {
    [sym__expression] = STATE(739),
    [sym__primary_expression] = STATE(95),
    [sym_not_operator] = STATE(739),
    [sym_boolean_operator] = STATE(739),
    [sym_binary_operator] = STATE(95),
    [sym_unary_operator] = STATE(95),
    [sym_comparison_operator] = STATE(739),
    [sym_lambda] = STATE(739),
    [sym_attribute] = STATE(95),
    [sym_subscript] = STATE(95),
    [sym_call] = STATE(95),
    [sym_list] = STATE(95),
    [sym_list_comprehension] = STATE(95),
    [sym_dictionary] = STATE(95),
    [sym_dictionary_comprehension] = STATE(95),
    [sym_set] = STATE(95),
    [sym_set_comprehension] = STATE(95),
    [sym_parenthesized_expression] = STATE(95),
    [sym_tuple] = STATE(95),
    [sym_generator_expression] = STATE(95),
    [sym_conditional_expression] = STATE(739),
    [sym_concatenated_string] = STATE(95),
    [sym_string] = STATE(96),
    [sym_await] = STATE(739),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_lambda] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(159),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(161),
    [sym_float] = ACTIONS(161),
    [sym_identifier] = ACTIONS(161),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [sym_none] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [sym_comment] = ACTIONS(73),
  },
  [331] = {
    [anon_sym_COLON] = ACTIONS(1408),
    [sym_comment] = ACTIONS(73),
  },
  [332] = {
    [sym__expression] = STATE(741),
    [sym__primary_expression] = STATE(327),
    [sym_not_operator] = STATE(741),
    [sym_boolean_operator] = STATE(741),
    [sym_binary_operator] = STATE(327),
    [sym_unary_operator] = STATE(327),
    [sym_comparison_operator] = STATE(741),
    [sym_lambda] = STATE(741),
    [sym_attribute] = STATE(327),
    [sym_subscript] = STATE(327),
    [sym_call] = STATE(327),
    [sym_list] = STATE(327),
    [sym_list_comprehension] = STATE(327),
    [sym_dictionary] = STATE(327),
    [sym_dictionary_comprehension] = STATE(327),
    [sym_set] = STATE(327),
    [sym_set_comprehension] = STATE(327),
    [sym_parenthesized_expression] = STATE(327),
    [sym_tuple] = STATE(327),
    [sym_generator_expression] = STATE(327),
    [sym_conditional_expression] = STATE(741),
    [sym_concatenated_string] = STATE(327),
    [sym_string] = STATE(328),
    [sym_await] = STATE(741),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(547),
    [anon_sym_PLUS] = ACTIONS(549),
    [anon_sym_DASH] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_lambda] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(553),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(555),
    [sym_float] = ACTIONS(555),
    [sym_identifier] = ACTIONS(555),
    [sym_true] = ACTIONS(555),
    [sym_false] = ACTIONS(555),
    [sym_none] = ACTIONS(555),
    [anon_sym_await] = ACTIONS(557),
    [sym_comment] = ACTIONS(73),
  },
  [333] = {
    [sym__expression] = STATE(742),
    [sym__primary_expression] = STATE(95),
    [sym_not_operator] = STATE(742),
    [sym_boolean_operator] = STATE(742),
    [sym_binary_operator] = STATE(95),
    [sym_unary_operator] = STATE(95),
    [sym_comparison_operator] = STATE(742),
    [sym_lambda] = STATE(742),
    [sym_attribute] = STATE(95),
    [sym_subscript] = STATE(95),
    [sym_call] = STATE(95),
    [sym_list] = STATE(95),
    [sym_list_comprehension] = STATE(95),
    [sym_dictionary] = STATE(95),
    [sym_dictionary_comprehension] = STATE(95),
    [sym_set] = STATE(95),
    [sym_set_comprehension] = STATE(95),
    [sym_parenthesized_expression] = STATE(95),
    [sym_tuple] = STATE(95),
    [sym_generator_expression] = STATE(95),
    [sym_conditional_expression] = STATE(742),
    [sym_concatenated_string] = STATE(95),
    [sym_string] = STATE(96),
    [sym_await] = STATE(742),
    [sym__newline] = ACTIONS(907),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(1410),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_lambda] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(159),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(161),
    [sym_float] = ACTIONS(161),
    [sym_identifier] = ACTIONS(161),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [sym_none] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(907),
  },
  [334] = {
    [sym__expression] = STATE(743),
    [sym__primary_expression] = STATE(538),
    [sym_not_operator] = STATE(743),
    [sym_boolean_operator] = STATE(743),
    [sym_binary_operator] = STATE(538),
    [sym_unary_operator] = STATE(538),
    [sym_comparison_operator] = STATE(743),
    [sym_lambda] = STATE(743),
    [sym_attribute] = STATE(538),
    [sym_subscript] = STATE(538),
    [sym_call] = STATE(538),
    [sym_list] = STATE(538),
    [sym_list_comprehension] = STATE(538),
    [sym_dictionary] = STATE(538),
    [sym_dictionary_comprehension] = STATE(538),
    [sym_set] = STATE(538),
    [sym_set_comprehension] = STATE(538),
    [sym_parenthesized_expression] = STATE(538),
    [sym_tuple] = STATE(538),
    [sym_generator_expression] = STATE(538),
    [sym_conditional_expression] = STATE(743),
    [sym_concatenated_string] = STATE(538),
    [sym_string] = STATE(539),
    [sym_await] = STATE(743),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_lambda] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(917),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(919),
    [sym_float] = ACTIONS(919),
    [sym_identifier] = ACTIONS(919),
    [sym_true] = ACTIONS(919),
    [sym_false] = ACTIONS(919),
    [sym_none] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(921),
    [sym_comment] = ACTIONS(73),
  },
  [335] = {
    [sym__expression] = STATE(540),
    [sym__primary_expression] = STATE(95),
    [sym_not_operator] = STATE(540),
    [sym_boolean_operator] = STATE(540),
    [sym_binary_operator] = STATE(95),
    [sym_unary_operator] = STATE(95),
    [sym_comparison_operator] = STATE(540),
    [sym_lambda] = STATE(540),
    [sym_attribute] = STATE(95),
    [sym_subscript] = STATE(95),
    [sym_call] = STATE(95),
    [sym_list] = STATE(95),
    [sym_list_comprehension] = STATE(95),
    [sym_dictionary] = STATE(95),
    [sym_dictionary_comprehension] = STATE(95),
    [sym_set] = STATE(95),
    [sym_set_comprehension] = STATE(95),
    [sym_parenthesized_expression] = STATE(95),
    [sym_tuple] = STATE(95),
    [sym_generator_expression] = STATE(95),
    [sym_conditional_expression] = STATE(540),
    [sym_concatenated_string] = STATE(95),
    [sym_string] = STATE(96),
    [sym_await] = STATE(540),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_lambda] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(159),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(161),
    [sym_float] = ACTIONS(161),
    [sym_identifier] = ACTIONS(161),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [sym_none] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [sym_comment] = ACTIONS(73),
  },
  [336] = {
    [sym__expression] = STATE(744),
    [sym__primary_expression] = STATE(95),
    [sym_not_operator] = STATE(744),
    [sym_boolean_operator] = STATE(744),
    [sym_binary_operator] = STATE(95),
    [sym_unary_operator] = STATE(95),
    [sym_comparison_operator] = STATE(744),
    [sym_lambda] = STATE(744),
    [sym_attribute] = STATE(95),
    [sym_subscript] = STATE(95),
    [sym_call] = STATE(95),
    [sym_list] = STATE(95),
    [sym_list_comprehension] = STATE(95),
    [sym_dictionary] = STATE(95),
    [sym_dictionary_comprehension] = STATE(95),
    [sym_set] = STATE(95),
    [sym_set_comprehension] = STATE(95),
    [sym_parenthesized_expression] = STATE(95),
    [sym_tuple] = STATE(95),
    [sym_generator_expression] = STATE(95),
    [sym_conditional_expression] = STATE(744),
    [sym_concatenated_string] = STATE(95),
    [sym_string] = STATE(96),
    [sym_await] = STATE(744),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_lambda] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(159),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(161),
    [sym_float] = ACTIONS(161),
    [sym_identifier] = ACTIONS(161),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [sym_none] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [sym_comment] = ACTIONS(73),
  },
  [337] = {
    [aux_sym_print_statement_repeat1] = STATE(746),
    [sym__newline] = ACTIONS(907),
    [anon_sym_from] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(1412),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(907),
  },
  [338] = {
    [sym__primary_expression] = STATE(747),
    [sym_binary_operator] = STATE(747),
    [sym_unary_operator] = STATE(747),
    [sym_attribute] = STATE(747),
    [sym_subscript] = STATE(747),
    [sym_call] = STATE(747),
    [sym_list] = STATE(747),
    [sym_list_comprehension] = STATE(747),
    [sym_dictionary] = STATE(747),
    [sym_dictionary_comprehension] = STATE(747),
    [sym_set] = STATE(747),
    [sym_set_comprehension] = STATE(747),
    [sym_parenthesized_expression] = STATE(747),
    [sym_tuple] = STATE(747),
    [sym_generator_expression] = STATE(747),
    [sym_concatenated_string] = STATE(747),
    [sym_string] = STATE(96),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1414),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1416),
    [sym_float] = ACTIONS(1416),
    [sym_identifier] = ACTIONS(1416),
    [sym_true] = ACTIONS(1416),
    [sym_false] = ACTIONS(1416),
    [sym_none] = ACTIONS(1416),
    [sym_comment] = ACTIONS(73),
  },
  [339] = {
    [sym__primary_expression] = STATE(748),
    [sym_binary_operator] = STATE(748),
    [sym_unary_operator] = STATE(748),
    [sym_attribute] = STATE(748),
    [sym_subscript] = STATE(748),
    [sym_call] = STATE(748),
    [sym_list] = STATE(748),
    [sym_list_comprehension] = STATE(748),
    [sym_dictionary] = STATE(748),
    [sym_dictionary_comprehension] = STATE(748),
    [sym_set] = STATE(748),
    [sym_set_comprehension] = STATE(748),
    [sym_parenthesized_expression] = STATE(748),
    [sym_tuple] = STATE(748),
    [sym_generator_expression] = STATE(748),
    [sym_concatenated_string] = STATE(748),
    [sym_string] = STATE(96),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1418),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1420),
    [sym_float] = ACTIONS(1420),
    [sym_identifier] = ACTIONS(1420),
    [sym_true] = ACTIONS(1420),
    [sym_false] = ACTIONS(1420),
    [sym_none] = ACTIONS(1420),
    [sym_comment] = ACTIONS(73),
  },
  [340] = {
    [sym__primary_expression] = STATE(749),
    [sym_binary_operator] = STATE(749),
    [sym_unary_operator] = STATE(749),
    [sym_attribute] = STATE(749),
    [sym_subscript] = STATE(749),
    [sym_call] = STATE(749),
    [sym_list] = STATE(749),
    [sym_list_comprehension] = STATE(749),
    [sym_dictionary] = STATE(749),
    [sym_dictionary_comprehension] = STATE(749),
    [sym_set] = STATE(749),
    [sym_set_comprehension] = STATE(749),
    [sym_parenthesized_expression] = STATE(749),
    [sym_tuple] = STATE(749),
    [sym_generator_expression] = STATE(749),
    [sym_concatenated_string] = STATE(749),
    [sym_string] = STATE(96),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1422),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1424),
    [sym_float] = ACTIONS(1424),
    [sym_identifier] = ACTIONS(1424),
    [sym_true] = ACTIONS(1424),
    [sym_false] = ACTIONS(1424),
    [sym_none] = ACTIONS(1424),
    [sym_comment] = ACTIONS(73),
  },
  [341] = {
    [anon_sym_in] = ACTIONS(1426),
    [sym_comment] = ACTIONS(73),
  },
  [342] = {
    [sym__primary_expression] = STATE(751),
    [sym_binary_operator] = STATE(751),
    [sym_unary_operator] = STATE(751),
    [sym_attribute] = STATE(751),
    [sym_subscript] = STATE(751),
    [sym_call] = STATE(751),
    [sym_list] = STATE(751),
    [sym_list_comprehension] = STATE(751),
    [sym_dictionary] = STATE(751),
    [sym_dictionary_comprehension] = STATE(751),
    [sym_set] = STATE(751),
    [sym_set_comprehension] = STATE(751),
    [sym_parenthesized_expression] = STATE(751),
    [sym_tuple] = STATE(751),
    [sym_generator_expression] = STATE(751),
    [sym_concatenated_string] = STATE(751),
    [sym_string] = STATE(96),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1428),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1430),
    [sym_float] = ACTIONS(1430),
    [sym_identifier] = ACTIONS(1430),
    [sym_true] = ACTIONS(1430),
    [sym_false] = ACTIONS(1430),
    [sym_none] = ACTIONS(1430),
    [sym_comment] = ACTIONS(73),
  },
  [343] = {
    [sym__primary_expression] = STATE(712),
    [sym_binary_operator] = STATE(712),
    [sym_unary_operator] = STATE(712),
    [sym_attribute] = STATE(712),
    [sym_subscript] = STATE(712),
    [sym_call] = STATE(712),
    [sym_list] = STATE(712),
    [sym_list_comprehension] = STATE(712),
    [sym_dictionary] = STATE(712),
    [sym_dictionary_comprehension] = STATE(712),
    [sym_set] = STATE(712),
    [sym_set_comprehension] = STATE(712),
    [sym_parenthesized_expression] = STATE(712),
    [sym_tuple] = STATE(712),
    [sym_generator_expression] = STATE(712),
    [sym_concatenated_string] = STATE(712),
    [sym_string] = STATE(96),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1354),
    [sym_float] = ACTIONS(1354),
    [sym_identifier] = ACTIONS(1354),
    [sym_true] = ACTIONS(1354),
    [sym_false] = ACTIONS(1354),
    [sym_none] = ACTIONS(1354),
    [sym_comment] = ACTIONS(73),
  },
  [344] = {
    [sym__primary_expression] = STATE(752),
    [sym_binary_operator] = STATE(752),
    [sym_unary_operator] = STATE(752),
    [sym_attribute] = STATE(752),
    [sym_subscript] = STATE(752),
    [sym_call] = STATE(752),
    [sym_list] = STATE(752),
    [sym_list_comprehension] = STATE(752),
    [sym_dictionary] = STATE(752),
    [sym_dictionary_comprehension] = STATE(752),
    [sym_set] = STATE(752),
    [sym_set_comprehension] = STATE(752),
    [sym_parenthesized_expression] = STATE(752),
    [sym_tuple] = STATE(752),
    [sym_generator_expression] = STATE(752),
    [sym_concatenated_string] = STATE(752),
    [sym_string] = STATE(96),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1432),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1434),
    [sym_float] = ACTIONS(1434),
    [sym_identifier] = ACTIONS(1434),
    [sym_true] = ACTIONS(1434),
    [sym_false] = ACTIONS(1434),
    [sym_none] = ACTIONS(1434),
    [sym_comment] = ACTIONS(73),
  },
  [345] = {
    [sym__primary_expression] = STATE(753),
    [sym_binary_operator] = STATE(753),
    [sym_unary_operator] = STATE(753),
    [sym_attribute] = STATE(753),
    [sym_subscript] = STATE(753),
    [sym_call] = STATE(753),
    [sym_list] = STATE(753),
    [sym_list_comprehension] = STATE(753),
    [sym_dictionary] = STATE(753),
    [sym_dictionary_comprehension] = STATE(753),
    [sym_set] = STATE(753),
    [sym_set_comprehension] = STATE(753),
    [sym_parenthesized_expression] = STATE(753),
    [sym_tuple] = STATE(753),
    [sym_generator_expression] = STATE(753),
    [sym_concatenated_string] = STATE(753),
    [sym_string] = STATE(96),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1436),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1438),
    [sym_float] = ACTIONS(1438),
    [sym_identifier] = ACTIONS(1438),
    [sym_true] = ACTIONS(1438),
    [sym_false] = ACTIONS(1438),
    [sym_none] = ACTIONS(1438),
    [sym_comment] = ACTIONS(73),
  },
  [346] = {
    [sym__primary_expression] = STATE(754),
    [sym_binary_operator] = STATE(754),
    [sym_unary_operator] = STATE(754),
    [sym_attribute] = STATE(754),
    [sym_subscript] = STATE(754),
    [sym_call] = STATE(754),
    [sym_list] = STATE(754),
    [sym_list_comprehension] = STATE(754),
    [sym_dictionary] = STATE(754),
    [sym_dictionary_comprehension] = STATE(754),
    [sym_set] = STATE(754),
    [sym_set_comprehension] = STATE(754),
    [sym_parenthesized_expression] = STATE(754),
    [sym_tuple] = STATE(754),
    [sym_generator_expression] = STATE(754),
    [sym_concatenated_string] = STATE(754),
    [sym_string] = STATE(96),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1440),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1442),
    [sym_float] = ACTIONS(1442),
    [sym_identifier] = ACTIONS(1442),
    [sym_true] = ACTIONS(1442),
    [sym_false] = ACTIONS(1442),
    [sym_none] = ACTIONS(1442),
    [sym_comment] = ACTIONS(73),
  },
  [347] = {
    [sym__primary_expression] = STATE(749),
    [sym_binary_operator] = STATE(749),
    [sym_unary_operator] = STATE(749),
    [sym_attribute] = STATE(749),
    [sym_subscript] = STATE(749),
    [sym_call] = STATE(749),
    [sym_list] = STATE(749),
    [sym_list_comprehension] = STATE(749),
    [sym_dictionary] = STATE(749),
    [sym_dictionary_comprehension] = STATE(749),
    [sym_set] = STATE(749),
    [sym_set_comprehension] = STATE(749),
    [sym_parenthesized_expression] = STATE(749),
    [sym_tuple] = STATE(749),
    [sym_generator_expression] = STATE(749),
    [sym_concatenated_string] = STATE(749),
    [sym_string] = STATE(96),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(1444),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1422),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1424),
    [sym_float] = ACTIONS(1424),
    [sym_identifier] = ACTIONS(1424),
    [sym_true] = ACTIONS(1424),
    [sym_false] = ACTIONS(1424),
    [sym_none] = ACTIONS(1424),
    [sym_comment] = ACTIONS(73),
  },
  [348] = {
    [aux_sym_comparison_operator_repeat1] = STATE(755),
    [sym__newline] = ACTIONS(991),
    [anon_sym_from] = ACTIONS(991),
    [anon_sym_COMMA] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(577),
    [anon_sym_not] = ACTIONS(581),
    [anon_sym_and] = ACTIONS(991),
    [anon_sym_or] = ACTIONS(991),
    [anon_sym_LT] = ACTIONS(593),
    [anon_sym_LT_EQ] = ACTIONS(577),
    [anon_sym_EQ_EQ] = ACTIONS(577),
    [anon_sym_BANG_EQ] = ACTIONS(577),
    [anon_sym_GT_EQ] = ACTIONS(577),
    [anon_sym_GT] = ACTIONS(593),
    [anon_sym_LT_GT] = ACTIONS(577),
    [anon_sym_is] = ACTIONS(595),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(991),
  },
  [349] = {
    [sym_string] = STATE(756),
    [aux_sym_concatenated_string_repeat1] = STATE(756),
    [sym__newline] = ACTIONS(995),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_from] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_in] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(995),
    [anon_sym_not] = ACTIONS(995),
    [anon_sym_and] = ACTIONS(995),
    [anon_sym_or] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(995),
    [anon_sym_SLASH_SLASH] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_GT] = ACTIONS(995),
    [anon_sym_is] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(995),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(995),
  },
  [350] = {
    [anon_sym_if] = ACTIONS(723),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_and] = ACTIONS(603),
    [anon_sym_or] = ACTIONS(605),
    [sym_comment] = ACTIONS(73),
  },
  [351] = {
    [sym__expression] = STATE(757),
    [sym__primary_expression] = STATE(102),
    [sym_not_operator] = STATE(757),
    [sym_boolean_operator] = STATE(757),
    [sym_binary_operator] = STATE(102),
    [sym_unary_operator] = STATE(102),
    [sym_comparison_operator] = STATE(757),
    [sym_lambda] = STATE(757),
    [sym_attribute] = STATE(102),
    [sym_subscript] = STATE(102),
    [sym_call] = STATE(102),
    [sym_list] = STATE(102),
    [sym_list_comprehension] = STATE(102),
    [sym_dictionary] = STATE(102),
    [sym_dictionary_comprehension] = STATE(102),
    [sym_set] = STATE(102),
    [sym_set_comprehension] = STATE(102),
    [sym_parenthesized_expression] = STATE(102),
    [sym_tuple] = STATE(102),
    [sym_generator_expression] = STATE(102),
    [sym_conditional_expression] = STATE(757),
    [sym_concatenated_string] = STATE(102),
    [sym_string] = STATE(103),
    [sym_await] = STATE(757),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [352] = {
    [anon_sym_COLON] = ACTIONS(1446),
    [sym_comment] = ACTIONS(73),
  },
  [353] = {
    [sym__expression] = STATE(759),
    [sym__primary_expression] = STATE(538),
    [sym_not_operator] = STATE(759),
    [sym_boolean_operator] = STATE(759),
    [sym_binary_operator] = STATE(538),
    [sym_unary_operator] = STATE(538),
    [sym_comparison_operator] = STATE(759),
    [sym_lambda] = STATE(759),
    [sym_attribute] = STATE(538),
    [sym_subscript] = STATE(538),
    [sym_call] = STATE(538),
    [sym_list] = STATE(538),
    [sym_list_comprehension] = STATE(538),
    [sym_dictionary] = STATE(538),
    [sym_dictionary_comprehension] = STATE(538),
    [sym_set] = STATE(538),
    [sym_set_comprehension] = STATE(538),
    [sym_parenthesized_expression] = STATE(538),
    [sym_tuple] = STATE(538),
    [sym_generator_expression] = STATE(538),
    [sym_conditional_expression] = STATE(759),
    [sym_concatenated_string] = STATE(538),
    [sym_string] = STATE(539),
    [sym_await] = STATE(759),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_lambda] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(917),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(919),
    [sym_float] = ACTIONS(919),
    [sym_identifier] = ACTIONS(919),
    [sym_true] = ACTIONS(919),
    [sym_false] = ACTIONS(919),
    [sym_none] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(921),
    [sym_comment] = ACTIONS(73),
  },
  [354] = {
    [sym__simple_statements] = STATE(761),
    [sym_import_statement] = STATE(34),
    [sym_future_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym__suite] = STATE(761),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(1448),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [355] = {
    [sym__expression] = STATE(652),
    [sym__primary_expression] = STATE(102),
    [sym_not_operator] = STATE(652),
    [sym_boolean_operator] = STATE(652),
    [sym_binary_operator] = STATE(102),
    [sym_unary_operator] = STATE(102),
    [sym_comparison_operator] = STATE(652),
    [sym_lambda] = STATE(652),
    [sym_attribute] = STATE(102),
    [sym_subscript] = STATE(102),
    [sym_call] = STATE(102),
    [sym_list] = STATE(102),
    [sym_list_comprehension] = STATE(102),
    [sym_dictionary] = STATE(102),
    [sym_dictionary_comprehension] = STATE(102),
    [sym_set] = STATE(102),
    [sym_set_comprehension] = STATE(102),
    [sym_parenthesized_expression] = STATE(102),
    [sym_tuple] = STATE(102),
    [sym_generator_expression] = STATE(102),
    [sym_conditional_expression] = STATE(652),
    [sym_concatenated_string] = STATE(102),
    [sym_string] = STATE(103),
    [sym_await] = STATE(652),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [356] = {
    [sym__expression] = STATE(762),
    [sym__primary_expression] = STATE(102),
    [sym_not_operator] = STATE(762),
    [sym_boolean_operator] = STATE(762),
    [sym_binary_operator] = STATE(102),
    [sym_unary_operator] = STATE(102),
    [sym_comparison_operator] = STATE(762),
    [sym_lambda] = STATE(762),
    [sym_attribute] = STATE(102),
    [sym_subscript] = STATE(102),
    [sym_call] = STATE(102),
    [sym_list] = STATE(102),
    [sym_list_comprehension] = STATE(102),
    [sym_dictionary] = STATE(102),
    [sym_dictionary_comprehension] = STATE(102),
    [sym_set] = STATE(102),
    [sym_set_comprehension] = STATE(102),
    [sym_parenthesized_expression] = STATE(102),
    [sym_tuple] = STATE(102),
    [sym_generator_expression] = STATE(102),
    [sym_conditional_expression] = STATE(762),
    [sym_concatenated_string] = STATE(102),
    [sym_string] = STATE(103),
    [sym_await] = STATE(762),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [357] = {
    [sym__primary_expression] = STATE(763),
    [sym_binary_operator] = STATE(763),
    [sym_unary_operator] = STATE(763),
    [sym_attribute] = STATE(763),
    [sym_subscript] = STATE(763),
    [sym_call] = STATE(763),
    [sym_list] = STATE(763),
    [sym_list_comprehension] = STATE(763),
    [sym_dictionary] = STATE(763),
    [sym_dictionary_comprehension] = STATE(763),
    [sym_set] = STATE(763),
    [sym_set_comprehension] = STATE(763),
    [sym_parenthesized_expression] = STATE(763),
    [sym_tuple] = STATE(763),
    [sym_generator_expression] = STATE(763),
    [sym_concatenated_string] = STATE(763),
    [sym_string] = STATE(103),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1450),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1452),
    [sym_float] = ACTIONS(1452),
    [sym_identifier] = ACTIONS(1452),
    [sym_true] = ACTIONS(1452),
    [sym_false] = ACTIONS(1452),
    [sym_none] = ACTIONS(1452),
    [sym_comment] = ACTIONS(73),
  },
  [358] = {
    [sym__primary_expression] = STATE(764),
    [sym_binary_operator] = STATE(764),
    [sym_unary_operator] = STATE(764),
    [sym_attribute] = STATE(764),
    [sym_subscript] = STATE(764),
    [sym_call] = STATE(764),
    [sym_list] = STATE(764),
    [sym_list_comprehension] = STATE(764),
    [sym_dictionary] = STATE(764),
    [sym_dictionary_comprehension] = STATE(764),
    [sym_set] = STATE(764),
    [sym_set_comprehension] = STATE(764),
    [sym_parenthesized_expression] = STATE(764),
    [sym_tuple] = STATE(764),
    [sym_generator_expression] = STATE(764),
    [sym_concatenated_string] = STATE(764),
    [sym_string] = STATE(103),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1454),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1456),
    [sym_float] = ACTIONS(1456),
    [sym_identifier] = ACTIONS(1456),
    [sym_true] = ACTIONS(1456),
    [sym_false] = ACTIONS(1456),
    [sym_none] = ACTIONS(1456),
    [sym_comment] = ACTIONS(73),
  },
  [359] = {
    [sym__primary_expression] = STATE(765),
    [sym_binary_operator] = STATE(765),
    [sym_unary_operator] = STATE(765),
    [sym_attribute] = STATE(765),
    [sym_subscript] = STATE(765),
    [sym_call] = STATE(765),
    [sym_list] = STATE(765),
    [sym_list_comprehension] = STATE(765),
    [sym_dictionary] = STATE(765),
    [sym_dictionary_comprehension] = STATE(765),
    [sym_set] = STATE(765),
    [sym_set_comprehension] = STATE(765),
    [sym_parenthesized_expression] = STATE(765),
    [sym_tuple] = STATE(765),
    [sym_generator_expression] = STATE(765),
    [sym_concatenated_string] = STATE(765),
    [sym_string] = STATE(103),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1458),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1460),
    [sym_float] = ACTIONS(1460),
    [sym_identifier] = ACTIONS(1460),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [sym_none] = ACTIONS(1460),
    [sym_comment] = ACTIONS(73),
  },
  [360] = {
    [anon_sym_in] = ACTIONS(1462),
    [sym_comment] = ACTIONS(73),
  },
  [361] = {
    [sym__primary_expression] = STATE(767),
    [sym_binary_operator] = STATE(767),
    [sym_unary_operator] = STATE(767),
    [sym_attribute] = STATE(767),
    [sym_subscript] = STATE(767),
    [sym_call] = STATE(767),
    [sym_list] = STATE(767),
    [sym_list_comprehension] = STATE(767),
    [sym_dictionary] = STATE(767),
    [sym_dictionary_comprehension] = STATE(767),
    [sym_set] = STATE(767),
    [sym_set_comprehension] = STATE(767),
    [sym_parenthesized_expression] = STATE(767),
    [sym_tuple] = STATE(767),
    [sym_generator_expression] = STATE(767),
    [sym_concatenated_string] = STATE(767),
    [sym_string] = STATE(103),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1464),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1466),
    [sym_float] = ACTIONS(1466),
    [sym_identifier] = ACTIONS(1466),
    [sym_true] = ACTIONS(1466),
    [sym_false] = ACTIONS(1466),
    [sym_none] = ACTIONS(1466),
    [sym_comment] = ACTIONS(73),
  },
  [362] = {
    [sym__primary_expression] = STATE(669),
    [sym_binary_operator] = STATE(669),
    [sym_unary_operator] = STATE(669),
    [sym_attribute] = STATE(669),
    [sym_subscript] = STATE(669),
    [sym_call] = STATE(669),
    [sym_list] = STATE(669),
    [sym_list_comprehension] = STATE(669),
    [sym_dictionary] = STATE(669),
    [sym_dictionary_comprehension] = STATE(669),
    [sym_set] = STATE(669),
    [sym_set_comprehension] = STATE(669),
    [sym_parenthesized_expression] = STATE(669),
    [sym_tuple] = STATE(669),
    [sym_generator_expression] = STATE(669),
    [sym_concatenated_string] = STATE(669),
    [sym_string] = STATE(103),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1282),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1284),
    [sym_float] = ACTIONS(1284),
    [sym_identifier] = ACTIONS(1284),
    [sym_true] = ACTIONS(1284),
    [sym_false] = ACTIONS(1284),
    [sym_none] = ACTIONS(1284),
    [sym_comment] = ACTIONS(73),
  },
  [363] = {
    [sym__primary_expression] = STATE(768),
    [sym_binary_operator] = STATE(768),
    [sym_unary_operator] = STATE(768),
    [sym_attribute] = STATE(768),
    [sym_subscript] = STATE(768),
    [sym_call] = STATE(768),
    [sym_list] = STATE(768),
    [sym_list_comprehension] = STATE(768),
    [sym_dictionary] = STATE(768),
    [sym_dictionary_comprehension] = STATE(768),
    [sym_set] = STATE(768),
    [sym_set_comprehension] = STATE(768),
    [sym_parenthesized_expression] = STATE(768),
    [sym_tuple] = STATE(768),
    [sym_generator_expression] = STATE(768),
    [sym_concatenated_string] = STATE(768),
    [sym_string] = STATE(103),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1468),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1470),
    [sym_float] = ACTIONS(1470),
    [sym_identifier] = ACTIONS(1470),
    [sym_true] = ACTIONS(1470),
    [sym_false] = ACTIONS(1470),
    [sym_none] = ACTIONS(1470),
    [sym_comment] = ACTIONS(73),
  },
  [364] = {
    [sym__primary_expression] = STATE(769),
    [sym_binary_operator] = STATE(769),
    [sym_unary_operator] = STATE(769),
    [sym_attribute] = STATE(769),
    [sym_subscript] = STATE(769),
    [sym_call] = STATE(769),
    [sym_list] = STATE(769),
    [sym_list_comprehension] = STATE(769),
    [sym_dictionary] = STATE(769),
    [sym_dictionary_comprehension] = STATE(769),
    [sym_set] = STATE(769),
    [sym_set_comprehension] = STATE(769),
    [sym_parenthesized_expression] = STATE(769),
    [sym_tuple] = STATE(769),
    [sym_generator_expression] = STATE(769),
    [sym_concatenated_string] = STATE(769),
    [sym_string] = STATE(103),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1472),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1474),
    [sym_float] = ACTIONS(1474),
    [sym_identifier] = ACTIONS(1474),
    [sym_true] = ACTIONS(1474),
    [sym_false] = ACTIONS(1474),
    [sym_none] = ACTIONS(1474),
    [sym_comment] = ACTIONS(73),
  },
  [365] = {
    [sym__primary_expression] = STATE(770),
    [sym_binary_operator] = STATE(770),
    [sym_unary_operator] = STATE(770),
    [sym_attribute] = STATE(770),
    [sym_subscript] = STATE(770),
    [sym_call] = STATE(770),
    [sym_list] = STATE(770),
    [sym_list_comprehension] = STATE(770),
    [sym_dictionary] = STATE(770),
    [sym_dictionary_comprehension] = STATE(770),
    [sym_set] = STATE(770),
    [sym_set_comprehension] = STATE(770),
    [sym_parenthesized_expression] = STATE(770),
    [sym_tuple] = STATE(770),
    [sym_generator_expression] = STATE(770),
    [sym_concatenated_string] = STATE(770),
    [sym_string] = STATE(103),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1476),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1478),
    [sym_float] = ACTIONS(1478),
    [sym_identifier] = ACTIONS(1478),
    [sym_true] = ACTIONS(1478),
    [sym_false] = ACTIONS(1478),
    [sym_none] = ACTIONS(1478),
    [sym_comment] = ACTIONS(73),
  },
  [366] = {
    [sym__primary_expression] = STATE(765),
    [sym_binary_operator] = STATE(765),
    [sym_unary_operator] = STATE(765),
    [sym_attribute] = STATE(765),
    [sym_subscript] = STATE(765),
    [sym_call] = STATE(765),
    [sym_list] = STATE(765),
    [sym_list_comprehension] = STATE(765),
    [sym_dictionary] = STATE(765),
    [sym_dictionary_comprehension] = STATE(765),
    [sym_set] = STATE(765),
    [sym_set_comprehension] = STATE(765),
    [sym_parenthesized_expression] = STATE(765),
    [sym_tuple] = STATE(765),
    [sym_generator_expression] = STATE(765),
    [sym_concatenated_string] = STATE(765),
    [sym_string] = STATE(103),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1480),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1458),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1460),
    [sym_float] = ACTIONS(1460),
    [sym_identifier] = ACTIONS(1460),
    [sym_true] = ACTIONS(1460),
    [sym_false] = ACTIONS(1460),
    [sym_none] = ACTIONS(1460),
    [sym_comment] = ACTIONS(73),
  },
  [367] = {
    [aux_sym_comparison_operator_repeat1] = STATE(771),
    [anon_sym_if] = ACTIONS(991),
    [anon_sym_COLON] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(611),
    [anon_sym_not] = ACTIONS(615),
    [anon_sym_and] = ACTIONS(991),
    [anon_sym_or] = ACTIONS(991),
    [anon_sym_LT] = ACTIONS(627),
    [anon_sym_LT_EQ] = ACTIONS(611),
    [anon_sym_EQ_EQ] = ACTIONS(611),
    [anon_sym_BANG_EQ] = ACTIONS(611),
    [anon_sym_GT_EQ] = ACTIONS(611),
    [anon_sym_GT] = ACTIONS(627),
    [anon_sym_LT_GT] = ACTIONS(611),
    [anon_sym_is] = ACTIONS(629),
    [sym_comment] = ACTIONS(73),
  },
  [368] = {
    [sym_string] = STATE(772),
    [aux_sym_concatenated_string_repeat1] = STATE(772),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_COLON] = ACTIONS(995),
    [anon_sym_in] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(995),
    [anon_sym_not] = ACTIONS(995),
    [anon_sym_and] = ACTIONS(995),
    [anon_sym_or] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(995),
    [anon_sym_SLASH_SLASH] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_GT] = ACTIONS(995),
    [anon_sym_is] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(995),
    [sym_comment] = ACTIONS(73),
  },
  [369] = {
    [anon_sym_in] = ACTIONS(1482),
    [sym_comment] = ACTIONS(73),
  },
  [370] = {
    [aux_sym_with_statement_repeat1] = STATE(775),
    [anon_sym_COMMA] = ACTIONS(661),
    [anon_sym_COLON] = ACTIONS(1484),
    [sym_comment] = ACTIONS(73),
  },
  [371] = {
    [sym_parameters] = STATE(776),
    [anon_sym_LPAREN] = ACTIONS(699),
    [sym_comment] = ACTIONS(73),
  },
  [372] = {
    [sym_expression_list] = STATE(777),
    [sym__expression] = STATE(778),
    [sym__primary_expression] = STATE(432),
    [sym_not_operator] = STATE(778),
    [sym_boolean_operator] = STATE(778),
    [sym_binary_operator] = STATE(432),
    [sym_unary_operator] = STATE(432),
    [sym_comparison_operator] = STATE(778),
    [sym_lambda] = STATE(778),
    [sym_attribute] = STATE(432),
    [sym_subscript] = STATE(432),
    [sym_call] = STATE(432),
    [sym_list] = STATE(432),
    [sym_list_comprehension] = STATE(432),
    [sym_dictionary] = STATE(432),
    [sym_dictionary_comprehension] = STATE(432),
    [sym_set] = STATE(432),
    [sym_set_comprehension] = STATE(432),
    [sym_parenthesized_expression] = STATE(432),
    [sym_tuple] = STATE(432),
    [sym_generator_expression] = STATE(432),
    [sym_conditional_expression] = STATE(778),
    [sym_concatenated_string] = STATE(432),
    [sym_string] = STATE(433),
    [sym_await] = STATE(778),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(735),
    [anon_sym_lambda] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(741),
    [sym_float] = ACTIONS(741),
    [sym_identifier] = ACTIONS(741),
    [sym_true] = ACTIONS(741),
    [sym_false] = ACTIONS(741),
    [sym_none] = ACTIONS(741),
    [anon_sym_await] = ACTIONS(743),
    [sym_comment] = ACTIONS(73),
  },
  [373] = {
    [sym__primary_expression] = STATE(779),
    [sym_binary_operator] = STATE(779),
    [sym_unary_operator] = STATE(779),
    [sym_attribute] = STATE(779),
    [sym_subscript] = STATE(779),
    [sym_call] = STATE(779),
    [sym_list] = STATE(779),
    [sym_list_comprehension] = STATE(779),
    [sym_dictionary] = STATE(779),
    [sym_dictionary_comprehension] = STATE(779),
    [sym_set] = STATE(779),
    [sym_set_comprehension] = STATE(779),
    [sym_parenthesized_expression] = STATE(779),
    [sym_tuple] = STATE(779),
    [sym_generator_expression] = STATE(779),
    [sym_concatenated_string] = STATE(779),
    [sym_string] = STATE(110),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_in] = ACTIONS(1486),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1488),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1490),
    [sym_float] = ACTIONS(1490),
    [sym_identifier] = ACTIONS(1490),
    [sym_true] = ACTIONS(1490),
    [sym_false] = ACTIONS(1490),
    [sym_none] = ACTIONS(1490),
    [sym_comment] = ACTIONS(73),
  },
  [374] = {
    [sym__primary_expression] = STATE(780),
    [sym_binary_operator] = STATE(780),
    [sym_unary_operator] = STATE(780),
    [sym_attribute] = STATE(780),
    [sym_subscript] = STATE(780),
    [sym_call] = STATE(780),
    [sym_list] = STATE(780),
    [sym_list_comprehension] = STATE(780),
    [sym_dictionary] = STATE(780),
    [sym_dictionary_comprehension] = STATE(780),
    [sym_set] = STATE(780),
    [sym_set_comprehension] = STATE(780),
    [sym_parenthesized_expression] = STATE(780),
    [sym_tuple] = STATE(780),
    [sym_generator_expression] = STATE(780),
    [sym_concatenated_string] = STATE(780),
    [sym_string] = STATE(110),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1492),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1494),
    [sym_float] = ACTIONS(1494),
    [sym_identifier] = ACTIONS(1494),
    [sym_true] = ACTIONS(1494),
    [sym_false] = ACTIONS(1494),
    [sym_none] = ACTIONS(1494),
    [sym_comment] = ACTIONS(73),
  },
  [375] = {
    [sym__primary_expression] = STATE(781),
    [sym_binary_operator] = STATE(781),
    [sym_unary_operator] = STATE(781),
    [sym_attribute] = STATE(781),
    [sym_subscript] = STATE(781),
    [sym_call] = STATE(781),
    [sym_list] = STATE(781),
    [sym_list_comprehension] = STATE(781),
    [sym_dictionary] = STATE(781),
    [sym_dictionary_comprehension] = STATE(781),
    [sym_set] = STATE(781),
    [sym_set_comprehension] = STATE(781),
    [sym_parenthesized_expression] = STATE(781),
    [sym_tuple] = STATE(781),
    [sym_generator_expression] = STATE(781),
    [sym_concatenated_string] = STATE(781),
    [sym_string] = STATE(110),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1496),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1498),
    [sym_float] = ACTIONS(1498),
    [sym_identifier] = ACTIONS(1498),
    [sym_true] = ACTIONS(1498),
    [sym_false] = ACTIONS(1498),
    [sym_none] = ACTIONS(1498),
    [sym_comment] = ACTIONS(73),
  },
  [376] = {
    [sym__primary_expression] = STATE(782),
    [sym_binary_operator] = STATE(782),
    [sym_unary_operator] = STATE(782),
    [sym_attribute] = STATE(782),
    [sym_subscript] = STATE(782),
    [sym_call] = STATE(782),
    [sym_list] = STATE(782),
    [sym_list_comprehension] = STATE(782),
    [sym_dictionary] = STATE(782),
    [sym_dictionary_comprehension] = STATE(782),
    [sym_set] = STATE(782),
    [sym_set_comprehension] = STATE(782),
    [sym_parenthesized_expression] = STATE(782),
    [sym_tuple] = STATE(782),
    [sym_generator_expression] = STATE(782),
    [sym_concatenated_string] = STATE(782),
    [sym_string] = STATE(110),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1500),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1502),
    [sym_float] = ACTIONS(1502),
    [sym_identifier] = ACTIONS(1502),
    [sym_true] = ACTIONS(1502),
    [sym_false] = ACTIONS(1502),
    [sym_none] = ACTIONS(1502),
    [sym_comment] = ACTIONS(73),
  },
  [377] = {
    [sym__primary_expression] = STATE(669),
    [sym_binary_operator] = STATE(669),
    [sym_unary_operator] = STATE(669),
    [sym_attribute] = STATE(669),
    [sym_subscript] = STATE(669),
    [sym_call] = STATE(669),
    [sym_list] = STATE(669),
    [sym_list_comprehension] = STATE(669),
    [sym_dictionary] = STATE(669),
    [sym_dictionary_comprehension] = STATE(669),
    [sym_set] = STATE(669),
    [sym_set_comprehension] = STATE(669),
    [sym_parenthesized_expression] = STATE(669),
    [sym_tuple] = STATE(669),
    [sym_generator_expression] = STATE(669),
    [sym_concatenated_string] = STATE(669),
    [sym_string] = STATE(110),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1282),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1284),
    [sym_float] = ACTIONS(1284),
    [sym_identifier] = ACTIONS(1284),
    [sym_true] = ACTIONS(1284),
    [sym_false] = ACTIONS(1284),
    [sym_none] = ACTIONS(1284),
    [sym_comment] = ACTIONS(73),
  },
  [378] = {
    [sym__primary_expression] = STATE(783),
    [sym_binary_operator] = STATE(783),
    [sym_unary_operator] = STATE(783),
    [sym_attribute] = STATE(783),
    [sym_subscript] = STATE(783),
    [sym_call] = STATE(783),
    [sym_list] = STATE(783),
    [sym_list_comprehension] = STATE(783),
    [sym_dictionary] = STATE(783),
    [sym_dictionary_comprehension] = STATE(783),
    [sym_set] = STATE(783),
    [sym_set_comprehension] = STATE(783),
    [sym_parenthesized_expression] = STATE(783),
    [sym_tuple] = STATE(783),
    [sym_generator_expression] = STATE(783),
    [sym_concatenated_string] = STATE(783),
    [sym_string] = STATE(110),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1504),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1506),
    [sym_float] = ACTIONS(1506),
    [sym_identifier] = ACTIONS(1506),
    [sym_true] = ACTIONS(1506),
    [sym_false] = ACTIONS(1506),
    [sym_none] = ACTIONS(1506),
    [sym_comment] = ACTIONS(73),
  },
  [379] = {
    [sym__primary_expression] = STATE(784),
    [sym_binary_operator] = STATE(784),
    [sym_unary_operator] = STATE(784),
    [sym_attribute] = STATE(784),
    [sym_subscript] = STATE(784),
    [sym_call] = STATE(784),
    [sym_list] = STATE(784),
    [sym_list_comprehension] = STATE(784),
    [sym_dictionary] = STATE(784),
    [sym_dictionary_comprehension] = STATE(784),
    [sym_set] = STATE(784),
    [sym_set_comprehension] = STATE(784),
    [sym_parenthesized_expression] = STATE(784),
    [sym_tuple] = STATE(784),
    [sym_generator_expression] = STATE(784),
    [sym_concatenated_string] = STATE(784),
    [sym_string] = STATE(110),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1508),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1510),
    [sym_float] = ACTIONS(1510),
    [sym_identifier] = ACTIONS(1510),
    [sym_true] = ACTIONS(1510),
    [sym_false] = ACTIONS(1510),
    [sym_none] = ACTIONS(1510),
    [sym_comment] = ACTIONS(73),
  },
  [380] = {
    [sym__primary_expression] = STATE(785),
    [sym_binary_operator] = STATE(785),
    [sym_unary_operator] = STATE(785),
    [sym_attribute] = STATE(785),
    [sym_subscript] = STATE(785),
    [sym_call] = STATE(785),
    [sym_list] = STATE(785),
    [sym_list_comprehension] = STATE(785),
    [sym_dictionary] = STATE(785),
    [sym_dictionary_comprehension] = STATE(785),
    [sym_set] = STATE(785),
    [sym_set_comprehension] = STATE(785),
    [sym_parenthesized_expression] = STATE(785),
    [sym_tuple] = STATE(785),
    [sym_generator_expression] = STATE(785),
    [sym_concatenated_string] = STATE(785),
    [sym_string] = STATE(110),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1512),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1514),
    [sym_float] = ACTIONS(1514),
    [sym_identifier] = ACTIONS(1514),
    [sym_true] = ACTIONS(1514),
    [sym_false] = ACTIONS(1514),
    [sym_none] = ACTIONS(1514),
    [sym_comment] = ACTIONS(73),
  },
  [381] = {
    [aux_sym_variables_repeat1] = STATE(787),
    [anon_sym_COMMA] = ACTIONS(1516),
    [anon_sym_in] = ACTIONS(1518),
    [sym_comment] = ACTIONS(73),
  },
  [382] = {
    [sym_string] = STATE(788),
    [aux_sym_concatenated_string_repeat1] = STATE(788),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_in] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(995),
    [anon_sym_SLASH_SLASH] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(995),
    [sym_comment] = ACTIONS(73),
  },
  [383] = {
    [sym__simple_statements] = STATE(789),
    [sym_import_statement] = STATE(34),
    [sym_future_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym__suite] = STATE(789),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(1448),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [384] = {
    [sym__statement] = STATE(800),
    [sym__simple_statements] = STATE(800),
    [sym_import_statement] = STATE(799),
    [sym_future_import_statement] = STATE(799),
    [sym_import_from_statement] = STATE(799),
    [sym_print_statement] = STATE(799),
    [sym_assert_statement] = STATE(799),
    [sym_expression_statement] = STATE(799),
    [sym_return_statement] = STATE(799),
    [sym_delete_statement] = STATE(799),
    [sym_raise_statement] = STATE(799),
    [sym_pass_statement] = STATE(799),
    [sym_break_statement] = STATE(799),
    [sym_continue_statement] = STATE(799),
    [sym_if_statement] = STATE(800),
    [sym_for_statement] = STATE(800),
    [sym_while_statement] = STATE(800),
    [sym_try_statement] = STATE(800),
    [sym_with_statement] = STATE(800),
    [sym_function_definition] = STATE(800),
    [sym_global_statement] = STATE(799),
    [sym_nonlocal_statement] = STATE(799),
    [sym_exec_statement] = STATE(799),
    [sym_class_definition] = STATE(800),
    [sym_decorated_definition] = STATE(800),
    [sym_decorator] = STATE(801),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [aux_sym_module_repeat1] = STATE(800),
    [aux_sym_decorated_definition_repeat1] = STATE(801),
    [sym__dedent] = ACTIONS(1520),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(1522),
    [anon_sym_async] = ACTIONS(1524),
    [anon_sym_for] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1528),
    [anon_sym_try] = ACTIONS(1530),
    [anon_sym_with] = ACTIONS(1532),
    [anon_sym_def] = ACTIONS(1534),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1536),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [385] = {
    [aux_sym__simple_statements_repeat1] = STATE(804),
    [sym__newline] = ACTIONS(1538),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1540),
  },
  [386] = {
    [sym_except_clause] = STATE(808),
    [sym_finally_clause] = STATE(807),
    [aux_sym_try_statement_repeat1] = STATE(808),
    [anon_sym_except] = ACTIONS(1542),
    [anon_sym_finally] = ACTIONS(1544),
    [sym_comment] = ACTIONS(73),
  },
  [387] = {
    [anon_sym_COMMA] = ACTIONS(723),
    [anon_sym_as] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(723),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_and] = ACTIONS(671),
    [anon_sym_or] = ACTIONS(673),
    [sym_comment] = ACTIONS(73),
  },
  [388] = {
    [sym__expression] = STATE(809),
    [sym__primary_expression] = STATE(119),
    [sym_not_operator] = STATE(809),
    [sym_boolean_operator] = STATE(809),
    [sym_binary_operator] = STATE(119),
    [sym_unary_operator] = STATE(119),
    [sym_comparison_operator] = STATE(809),
    [sym_lambda] = STATE(809),
    [sym_attribute] = STATE(119),
    [sym_subscript] = STATE(119),
    [sym_call] = STATE(119),
    [sym_list] = STATE(119),
    [sym_list_comprehension] = STATE(119),
    [sym_dictionary] = STATE(119),
    [sym_dictionary_comprehension] = STATE(119),
    [sym_set] = STATE(119),
    [sym_set_comprehension] = STATE(119),
    [sym_parenthesized_expression] = STATE(119),
    [sym_tuple] = STATE(119),
    [sym_generator_expression] = STATE(119),
    [sym_conditional_expression] = STATE(809),
    [sym_concatenated_string] = STATE(119),
    [sym_string] = STATE(120),
    [sym_await] = STATE(809),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(197),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_lambda] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(203),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(205),
    [sym_float] = ACTIONS(205),
    [sym_identifier] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_none] = ACTIONS(205),
    [anon_sym_await] = ACTIONS(207),
    [sym_comment] = ACTIONS(73),
  },
  [389] = {
    [anon_sym_COLON] = ACTIONS(1546),
    [sym_comment] = ACTIONS(73),
  },
  [390] = {
    [sym_with_item] = STATE(811),
    [sym__expression] = STATE(118),
    [sym__primary_expression] = STATE(119),
    [sym_not_operator] = STATE(118),
    [sym_boolean_operator] = STATE(118),
    [sym_binary_operator] = STATE(119),
    [sym_unary_operator] = STATE(119),
    [sym_comparison_operator] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym_attribute] = STATE(119),
    [sym_subscript] = STATE(119),
    [sym_call] = STATE(119),
    [sym_list] = STATE(119),
    [sym_list_comprehension] = STATE(119),
    [sym_dictionary] = STATE(119),
    [sym_dictionary_comprehension] = STATE(119),
    [sym_set] = STATE(119),
    [sym_set_comprehension] = STATE(119),
    [sym_parenthesized_expression] = STATE(119),
    [sym_tuple] = STATE(119),
    [sym_generator_expression] = STATE(119),
    [sym_conditional_expression] = STATE(118),
    [sym_concatenated_string] = STATE(119),
    [sym_string] = STATE(120),
    [sym_await] = STATE(118),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(197),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_lambda] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(203),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(205),
    [sym_float] = ACTIONS(205),
    [sym_identifier] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_none] = ACTIONS(205),
    [anon_sym_await] = ACTIONS(207),
    [sym_comment] = ACTIONS(73),
  },
  [391] = {
    [sym__simple_statements] = STATE(812),
    [sym_import_statement] = STATE(34),
    [sym_future_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym__suite] = STATE(812),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(1448),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [392] = {
    [aux_sym_with_statement_repeat1] = STATE(813),
    [anon_sym_COMMA] = ACTIONS(661),
    [anon_sym_COLON] = ACTIONS(1484),
    [sym_comment] = ACTIONS(73),
  },
  [393] = {
    [sym__expression] = STATE(814),
    [sym__primary_expression] = STATE(432),
    [sym_not_operator] = STATE(814),
    [sym_boolean_operator] = STATE(814),
    [sym_binary_operator] = STATE(432),
    [sym_unary_operator] = STATE(432),
    [sym_comparison_operator] = STATE(814),
    [sym_lambda] = STATE(814),
    [sym_attribute] = STATE(432),
    [sym_subscript] = STATE(432),
    [sym_call] = STATE(432),
    [sym_list] = STATE(432),
    [sym_list_comprehension] = STATE(432),
    [sym_dictionary] = STATE(432),
    [sym_dictionary_comprehension] = STATE(432),
    [sym_set] = STATE(432),
    [sym_set_comprehension] = STATE(432),
    [sym_parenthesized_expression] = STATE(432),
    [sym_tuple] = STATE(432),
    [sym_generator_expression] = STATE(432),
    [sym_conditional_expression] = STATE(814),
    [sym_concatenated_string] = STATE(432),
    [sym_string] = STATE(433),
    [sym_await] = STATE(814),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(735),
    [anon_sym_lambda] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(741),
    [sym_float] = ACTIONS(741),
    [sym_identifier] = ACTIONS(741),
    [sym_true] = ACTIONS(741),
    [sym_false] = ACTIONS(741),
    [sym_none] = ACTIONS(741),
    [anon_sym_await] = ACTIONS(743),
    [sym_comment] = ACTIONS(73),
  },
  [394] = {
    [sym__expression] = STATE(815),
    [sym__primary_expression] = STATE(538),
    [sym_not_operator] = STATE(815),
    [sym_boolean_operator] = STATE(815),
    [sym_binary_operator] = STATE(538),
    [sym_unary_operator] = STATE(538),
    [sym_comparison_operator] = STATE(815),
    [sym_lambda] = STATE(815),
    [sym_attribute] = STATE(538),
    [sym_subscript] = STATE(538),
    [sym_call] = STATE(538),
    [sym_list] = STATE(538),
    [sym_list_comprehension] = STATE(538),
    [sym_dictionary] = STATE(538),
    [sym_dictionary_comprehension] = STATE(538),
    [sym_set] = STATE(538),
    [sym_set_comprehension] = STATE(538),
    [sym_parenthesized_expression] = STATE(538),
    [sym_tuple] = STATE(538),
    [sym_generator_expression] = STATE(538),
    [sym_conditional_expression] = STATE(815),
    [sym_concatenated_string] = STATE(538),
    [sym_string] = STATE(539),
    [sym_await] = STATE(815),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_lambda] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(917),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(919),
    [sym_float] = ACTIONS(919),
    [sym_identifier] = ACTIONS(919),
    [sym_true] = ACTIONS(919),
    [sym_false] = ACTIONS(919),
    [sym_none] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(921),
    [sym_comment] = ACTIONS(73),
  },
  [395] = {
    [sym__expression] = STATE(652),
    [sym__primary_expression] = STATE(119),
    [sym_not_operator] = STATE(652),
    [sym_boolean_operator] = STATE(652),
    [sym_binary_operator] = STATE(119),
    [sym_unary_operator] = STATE(119),
    [sym_comparison_operator] = STATE(652),
    [sym_lambda] = STATE(652),
    [sym_attribute] = STATE(119),
    [sym_subscript] = STATE(119),
    [sym_call] = STATE(119),
    [sym_list] = STATE(119),
    [sym_list_comprehension] = STATE(119),
    [sym_dictionary] = STATE(119),
    [sym_dictionary_comprehension] = STATE(119),
    [sym_set] = STATE(119),
    [sym_set_comprehension] = STATE(119),
    [sym_parenthesized_expression] = STATE(119),
    [sym_tuple] = STATE(119),
    [sym_generator_expression] = STATE(119),
    [sym_conditional_expression] = STATE(652),
    [sym_concatenated_string] = STATE(119),
    [sym_string] = STATE(120),
    [sym_await] = STATE(652),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(197),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_lambda] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(203),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(205),
    [sym_float] = ACTIONS(205),
    [sym_identifier] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_none] = ACTIONS(205),
    [anon_sym_await] = ACTIONS(207),
    [sym_comment] = ACTIONS(73),
  },
  [396] = {
    [sym__expression] = STATE(816),
    [sym__primary_expression] = STATE(119),
    [sym_not_operator] = STATE(816),
    [sym_boolean_operator] = STATE(816),
    [sym_binary_operator] = STATE(119),
    [sym_unary_operator] = STATE(119),
    [sym_comparison_operator] = STATE(816),
    [sym_lambda] = STATE(816),
    [sym_attribute] = STATE(119),
    [sym_subscript] = STATE(119),
    [sym_call] = STATE(119),
    [sym_list] = STATE(119),
    [sym_list_comprehension] = STATE(119),
    [sym_dictionary] = STATE(119),
    [sym_dictionary_comprehension] = STATE(119),
    [sym_set] = STATE(119),
    [sym_set_comprehension] = STATE(119),
    [sym_parenthesized_expression] = STATE(119),
    [sym_tuple] = STATE(119),
    [sym_generator_expression] = STATE(119),
    [sym_conditional_expression] = STATE(816),
    [sym_concatenated_string] = STATE(119),
    [sym_string] = STATE(120),
    [sym_await] = STATE(816),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(197),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_lambda] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(203),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(205),
    [sym_float] = ACTIONS(205),
    [sym_identifier] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_none] = ACTIONS(205),
    [anon_sym_await] = ACTIONS(207),
    [sym_comment] = ACTIONS(73),
  },
  [397] = {
    [sym__primary_expression] = STATE(817),
    [sym_binary_operator] = STATE(817),
    [sym_unary_operator] = STATE(817),
    [sym_attribute] = STATE(817),
    [sym_subscript] = STATE(817),
    [sym_call] = STATE(817),
    [sym_list] = STATE(817),
    [sym_list_comprehension] = STATE(817),
    [sym_dictionary] = STATE(817),
    [sym_dictionary_comprehension] = STATE(817),
    [sym_set] = STATE(817),
    [sym_set_comprehension] = STATE(817),
    [sym_parenthesized_expression] = STATE(817),
    [sym_tuple] = STATE(817),
    [sym_generator_expression] = STATE(817),
    [sym_concatenated_string] = STATE(817),
    [sym_string] = STATE(120),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1548),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1550),
    [sym_float] = ACTIONS(1550),
    [sym_identifier] = ACTIONS(1550),
    [sym_true] = ACTIONS(1550),
    [sym_false] = ACTIONS(1550),
    [sym_none] = ACTIONS(1550),
    [sym_comment] = ACTIONS(73),
  },
  [398] = {
    [sym__primary_expression] = STATE(818),
    [sym_binary_operator] = STATE(818),
    [sym_unary_operator] = STATE(818),
    [sym_attribute] = STATE(818),
    [sym_subscript] = STATE(818),
    [sym_call] = STATE(818),
    [sym_list] = STATE(818),
    [sym_list_comprehension] = STATE(818),
    [sym_dictionary] = STATE(818),
    [sym_dictionary_comprehension] = STATE(818),
    [sym_set] = STATE(818),
    [sym_set_comprehension] = STATE(818),
    [sym_parenthesized_expression] = STATE(818),
    [sym_tuple] = STATE(818),
    [sym_generator_expression] = STATE(818),
    [sym_concatenated_string] = STATE(818),
    [sym_string] = STATE(120),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1552),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1554),
    [sym_float] = ACTIONS(1554),
    [sym_identifier] = ACTIONS(1554),
    [sym_true] = ACTIONS(1554),
    [sym_false] = ACTIONS(1554),
    [sym_none] = ACTIONS(1554),
    [sym_comment] = ACTIONS(73),
  },
  [399] = {
    [sym__primary_expression] = STATE(819),
    [sym_binary_operator] = STATE(819),
    [sym_unary_operator] = STATE(819),
    [sym_attribute] = STATE(819),
    [sym_subscript] = STATE(819),
    [sym_call] = STATE(819),
    [sym_list] = STATE(819),
    [sym_list_comprehension] = STATE(819),
    [sym_dictionary] = STATE(819),
    [sym_dictionary_comprehension] = STATE(819),
    [sym_set] = STATE(819),
    [sym_set_comprehension] = STATE(819),
    [sym_parenthesized_expression] = STATE(819),
    [sym_tuple] = STATE(819),
    [sym_generator_expression] = STATE(819),
    [sym_concatenated_string] = STATE(819),
    [sym_string] = STATE(120),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1556),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1558),
    [sym_float] = ACTIONS(1558),
    [sym_identifier] = ACTIONS(1558),
    [sym_true] = ACTIONS(1558),
    [sym_false] = ACTIONS(1558),
    [sym_none] = ACTIONS(1558),
    [sym_comment] = ACTIONS(73),
  },
  [400] = {
    [anon_sym_in] = ACTIONS(1560),
    [sym_comment] = ACTIONS(73),
  },
  [401] = {
    [sym__primary_expression] = STATE(821),
    [sym_binary_operator] = STATE(821),
    [sym_unary_operator] = STATE(821),
    [sym_attribute] = STATE(821),
    [sym_subscript] = STATE(821),
    [sym_call] = STATE(821),
    [sym_list] = STATE(821),
    [sym_list_comprehension] = STATE(821),
    [sym_dictionary] = STATE(821),
    [sym_dictionary_comprehension] = STATE(821),
    [sym_set] = STATE(821),
    [sym_set_comprehension] = STATE(821),
    [sym_parenthesized_expression] = STATE(821),
    [sym_tuple] = STATE(821),
    [sym_generator_expression] = STATE(821),
    [sym_concatenated_string] = STATE(821),
    [sym_string] = STATE(120),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1562),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1564),
    [sym_float] = ACTIONS(1564),
    [sym_identifier] = ACTIONS(1564),
    [sym_true] = ACTIONS(1564),
    [sym_false] = ACTIONS(1564),
    [sym_none] = ACTIONS(1564),
    [sym_comment] = ACTIONS(73),
  },
  [402] = {
    [sym__primary_expression] = STATE(669),
    [sym_binary_operator] = STATE(669),
    [sym_unary_operator] = STATE(669),
    [sym_attribute] = STATE(669),
    [sym_subscript] = STATE(669),
    [sym_call] = STATE(669),
    [sym_list] = STATE(669),
    [sym_list_comprehension] = STATE(669),
    [sym_dictionary] = STATE(669),
    [sym_dictionary_comprehension] = STATE(669),
    [sym_set] = STATE(669),
    [sym_set_comprehension] = STATE(669),
    [sym_parenthesized_expression] = STATE(669),
    [sym_tuple] = STATE(669),
    [sym_generator_expression] = STATE(669),
    [sym_concatenated_string] = STATE(669),
    [sym_string] = STATE(120),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1282),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1284),
    [sym_float] = ACTIONS(1284),
    [sym_identifier] = ACTIONS(1284),
    [sym_true] = ACTIONS(1284),
    [sym_false] = ACTIONS(1284),
    [sym_none] = ACTIONS(1284),
    [sym_comment] = ACTIONS(73),
  },
  [403] = {
    [sym__primary_expression] = STATE(822),
    [sym_binary_operator] = STATE(822),
    [sym_unary_operator] = STATE(822),
    [sym_attribute] = STATE(822),
    [sym_subscript] = STATE(822),
    [sym_call] = STATE(822),
    [sym_list] = STATE(822),
    [sym_list_comprehension] = STATE(822),
    [sym_dictionary] = STATE(822),
    [sym_dictionary_comprehension] = STATE(822),
    [sym_set] = STATE(822),
    [sym_set_comprehension] = STATE(822),
    [sym_parenthesized_expression] = STATE(822),
    [sym_tuple] = STATE(822),
    [sym_generator_expression] = STATE(822),
    [sym_concatenated_string] = STATE(822),
    [sym_string] = STATE(120),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1566),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1568),
    [sym_float] = ACTIONS(1568),
    [sym_identifier] = ACTIONS(1568),
    [sym_true] = ACTIONS(1568),
    [sym_false] = ACTIONS(1568),
    [sym_none] = ACTIONS(1568),
    [sym_comment] = ACTIONS(73),
  },
  [404] = {
    [sym__primary_expression] = STATE(823),
    [sym_binary_operator] = STATE(823),
    [sym_unary_operator] = STATE(823),
    [sym_attribute] = STATE(823),
    [sym_subscript] = STATE(823),
    [sym_call] = STATE(823),
    [sym_list] = STATE(823),
    [sym_list_comprehension] = STATE(823),
    [sym_dictionary] = STATE(823),
    [sym_dictionary_comprehension] = STATE(823),
    [sym_set] = STATE(823),
    [sym_set_comprehension] = STATE(823),
    [sym_parenthesized_expression] = STATE(823),
    [sym_tuple] = STATE(823),
    [sym_generator_expression] = STATE(823),
    [sym_concatenated_string] = STATE(823),
    [sym_string] = STATE(120),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1570),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1572),
    [sym_float] = ACTIONS(1572),
    [sym_identifier] = ACTIONS(1572),
    [sym_true] = ACTIONS(1572),
    [sym_false] = ACTIONS(1572),
    [sym_none] = ACTIONS(1572),
    [sym_comment] = ACTIONS(73),
  },
  [405] = {
    [sym__primary_expression] = STATE(824),
    [sym_binary_operator] = STATE(824),
    [sym_unary_operator] = STATE(824),
    [sym_attribute] = STATE(824),
    [sym_subscript] = STATE(824),
    [sym_call] = STATE(824),
    [sym_list] = STATE(824),
    [sym_list_comprehension] = STATE(824),
    [sym_dictionary] = STATE(824),
    [sym_dictionary_comprehension] = STATE(824),
    [sym_set] = STATE(824),
    [sym_set_comprehension] = STATE(824),
    [sym_parenthesized_expression] = STATE(824),
    [sym_tuple] = STATE(824),
    [sym_generator_expression] = STATE(824),
    [sym_concatenated_string] = STATE(824),
    [sym_string] = STATE(120),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1574),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1576),
    [sym_float] = ACTIONS(1576),
    [sym_identifier] = ACTIONS(1576),
    [sym_true] = ACTIONS(1576),
    [sym_false] = ACTIONS(1576),
    [sym_none] = ACTIONS(1576),
    [sym_comment] = ACTIONS(73),
  },
  [406] = {
    [sym__primary_expression] = STATE(819),
    [sym_binary_operator] = STATE(819),
    [sym_unary_operator] = STATE(819),
    [sym_attribute] = STATE(819),
    [sym_subscript] = STATE(819),
    [sym_call] = STATE(819),
    [sym_list] = STATE(819),
    [sym_list_comprehension] = STATE(819),
    [sym_dictionary] = STATE(819),
    [sym_dictionary_comprehension] = STATE(819),
    [sym_set] = STATE(819),
    [sym_set_comprehension] = STATE(819),
    [sym_parenthesized_expression] = STATE(819),
    [sym_tuple] = STATE(819),
    [sym_generator_expression] = STATE(819),
    [sym_concatenated_string] = STATE(819),
    [sym_string] = STATE(120),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1578),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1556),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1558),
    [sym_float] = ACTIONS(1558),
    [sym_identifier] = ACTIONS(1558),
    [sym_true] = ACTIONS(1558),
    [sym_false] = ACTIONS(1558),
    [sym_none] = ACTIONS(1558),
    [sym_comment] = ACTIONS(73),
  },
  [407] = {
    [aux_sym_comparison_operator_repeat1] = STATE(825),
    [anon_sym_COMMA] = ACTIONS(991),
    [anon_sym_as] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(991),
    [anon_sym_COLON] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(679),
    [anon_sym_not] = ACTIONS(683),
    [anon_sym_and] = ACTIONS(991),
    [anon_sym_or] = ACTIONS(991),
    [anon_sym_LT] = ACTIONS(695),
    [anon_sym_LT_EQ] = ACTIONS(679),
    [anon_sym_EQ_EQ] = ACTIONS(679),
    [anon_sym_BANG_EQ] = ACTIONS(679),
    [anon_sym_GT_EQ] = ACTIONS(679),
    [anon_sym_GT] = ACTIONS(695),
    [anon_sym_LT_GT] = ACTIONS(679),
    [anon_sym_is] = ACTIONS(697),
    [sym_comment] = ACTIONS(73),
  },
  [408] = {
    [sym_string] = STATE(826),
    [aux_sym_concatenated_string_repeat1] = STATE(826),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(995),
    [anon_sym_as] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_COLON] = ACTIONS(995),
    [anon_sym_in] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(995),
    [anon_sym_not] = ACTIONS(995),
    [anon_sym_and] = ACTIONS(995),
    [anon_sym_or] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(995),
    [anon_sym_SLASH_SLASH] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_GT] = ACTIONS(995),
    [anon_sym_is] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(995),
    [sym_comment] = ACTIONS(73),
  },
  [409] = {
    [sym__parameters] = STATE(831),
    [sym_default_parameter] = STATE(832),
    [sym_typed_default_parameter] = STATE(832),
    [sym_list_splat] = STATE(833),
    [sym_dictionary_splat] = STATE(833),
    [sym_typed_parameter] = STATE(832),
    [sym_tuple] = STATE(832),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_RPAREN] = ACTIONS(1580),
    [anon_sym_STAR] = ACTIONS(1582),
    [anon_sym_print] = ACTIONS(1584),
    [anon_sym_exec] = ACTIONS(1584),
    [sym_identifier] = ACTIONS(1586),
    [sym_comment] = ACTIONS(73),
  },
  [410] = {
    [anon_sym_COLON] = ACTIONS(1588),
    [anon_sym_DASH_GT] = ACTIONS(1590),
    [sym_comment] = ACTIONS(73),
  },
  [411] = {
    [sym_identifier] = ACTIONS(1592),
    [sym_comment] = ACTIONS(73),
  },
  [412] = {
    [aux_sym_global_statement_repeat1] = STATE(837),
    [sym__newline] = ACTIONS(1594),
    [anon_sym_COMMA] = ACTIONS(703),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1594),
  },
  [413] = {
    [aux_sym_global_statement_repeat1] = STATE(837),
    [sym__newline] = ACTIONS(1596),
    [anon_sym_COMMA] = ACTIONS(703),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1596),
  },
  [414] = {
    [sym__newline] = ACTIONS(345),
    [anon_sym_in] = ACTIONS(345),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(345),
  },
  [415] = {
    [sym_interpolation] = STATE(207),
    [aux_sym_string_repeat1] = STATE(207),
    [sym__string_content] = ACTIONS(361),
    [sym__string_end] = ACTIONS(1598),
    [anon_sym_LBRACE] = ACTIONS(79),
    [sym_escape_sequence] = ACTIONS(361),
    [sym_comment] = ACTIONS(81),
  },
  [416] = {
    [sym__expression] = STATE(839),
    [sym__primary_expression] = STATE(82),
    [sym_not_operator] = STATE(839),
    [sym_boolean_operator] = STATE(839),
    [sym_binary_operator] = STATE(82),
    [sym_unary_operator] = STATE(82),
    [sym_comparison_operator] = STATE(839),
    [sym_lambda] = STATE(839),
    [sym_attribute] = STATE(82),
    [sym_subscript] = STATE(82),
    [sym_call] = STATE(82),
    [sym_list] = STATE(82),
    [sym_list_comprehension] = STATE(82),
    [sym_dictionary] = STATE(82),
    [sym_dictionary_comprehension] = STATE(82),
    [sym_set] = STATE(82),
    [sym_set_comprehension] = STATE(82),
    [sym_parenthesized_expression] = STATE(82),
    [sym_tuple] = STATE(82),
    [sym_generator_expression] = STATE(82),
    [sym_conditional_expression] = STATE(839),
    [sym_concatenated_string] = STATE(82),
    [sym_string] = STATE(83),
    [sym_await] = STATE(839),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_lambda] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(137),
    [sym_float] = ACTIONS(137),
    [sym_identifier] = ACTIONS(137),
    [sym_true] = ACTIONS(137),
    [sym_false] = ACTIONS(137),
    [sym_none] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
  },
  [417] = {
    [sym_list_splat] = STATE(662),
    [sym_dictionary_splat] = STATE(662),
    [sym__expression] = STATE(840),
    [sym__primary_expression] = STATE(237),
    [sym_not_operator] = STATE(840),
    [sym_boolean_operator] = STATE(840),
    [sym_binary_operator] = STATE(237),
    [sym_unary_operator] = STATE(237),
    [sym_comparison_operator] = STATE(840),
    [sym_lambda] = STATE(840),
    [sym_attribute] = STATE(237),
    [sym_subscript] = STATE(237),
    [sym_call] = STATE(237),
    [sym_keyword_argument] = STATE(662),
    [sym_list] = STATE(237),
    [sym_list_comprehension] = STATE(237),
    [sym_dictionary] = STATE(237),
    [sym_dictionary_comprehension] = STATE(237),
    [sym_set] = STATE(237),
    [sym_set_comprehension] = STATE(237),
    [sym_parenthesized_expression] = STATE(237),
    [sym_tuple] = STATE(237),
    [sym_generator_expression] = STATE(237),
    [sym_conditional_expression] = STATE(840),
    [sym_concatenated_string] = STATE(237),
    [sym_string] = STATE(238),
    [sym_await] = STATE(840),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(1260),
    [anon_sym_COMMA] = ACTIONS(1262),
    [anon_sym_STAR] = ACTIONS(931),
    [anon_sym_print] = ACTIONS(933),
    [anon_sym_exec] = ACTIONS(933),
    [anon_sym_not] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_lambda] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(419),
    [sym_float] = ACTIONS(419),
    [sym_identifier] = ACTIONS(935),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_none] = ACTIONS(419),
    [anon_sym_await] = ACTIONS(421),
    [sym_comment] = ACTIONS(73),
  },
  [418] = {
    [sym__simple_statements] = STATE(841),
    [sym_import_statement] = STATE(34),
    [sym_future_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym__suite] = STATE(841),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(1448),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [419] = {
    [anon_sym_COLON] = ACTIONS(1600),
    [sym_comment] = ACTIONS(73),
  },
  [420] = {
    [aux_sym_dotted_name_repeat1] = STATE(843),
    [sym__newline] = ACTIONS(1159),
    [anon_sym_DOT] = ACTIONS(367),
    [anon_sym_LPAREN] = ACTIONS(1159),
    [sym_comment] = ACTIONS(73),
  },
  [421] = {
    [anon_sym_async] = ACTIONS(1602),
    [anon_sym_def] = ACTIONS(1602),
    [anon_sym_class] = ACTIONS(1602),
    [anon_sym_AT] = ACTIONS(1602),
    [sym_comment] = ACTIONS(73),
  },
  [422] = {
    [sym_list_splat] = STATE(550),
    [sym_dictionary_splat] = STATE(550),
    [sym__expression] = STATE(844),
    [sym__primary_expression] = STATE(237),
    [sym_not_operator] = STATE(844),
    [sym_boolean_operator] = STATE(844),
    [sym_binary_operator] = STATE(237),
    [sym_unary_operator] = STATE(237),
    [sym_comparison_operator] = STATE(844),
    [sym_lambda] = STATE(844),
    [sym_attribute] = STATE(237),
    [sym_subscript] = STATE(237),
    [sym_call] = STATE(237),
    [sym_keyword_argument] = STATE(550),
    [sym_list] = STATE(237),
    [sym_list_comprehension] = STATE(237),
    [sym_dictionary] = STATE(237),
    [sym_dictionary_comprehension] = STATE(237),
    [sym_set] = STATE(237),
    [sym_set_comprehension] = STATE(237),
    [sym_parenthesized_expression] = STATE(237),
    [sym_tuple] = STATE(237),
    [sym_generator_expression] = STATE(237),
    [sym_conditional_expression] = STATE(844),
    [sym_concatenated_string] = STATE(237),
    [sym_string] = STATE(238),
    [sym_await] = STATE(844),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(927),
    [anon_sym_COMMA] = ACTIONS(929),
    [anon_sym_STAR] = ACTIONS(931),
    [anon_sym_print] = ACTIONS(933),
    [anon_sym_exec] = ACTIONS(933),
    [anon_sym_not] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_lambda] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(419),
    [sym_float] = ACTIONS(419),
    [sym_identifier] = ACTIONS(935),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_none] = ACTIONS(419),
    [anon_sym_await] = ACTIONS(421),
    [sym_comment] = ACTIONS(73),
  },
  [423] = {
    [sym__newline] = ACTIONS(1604),
    [sym_comment] = ACTIONS(73),
  },
  [424] = {
    [aux_sym_tuple_repeat1] = STATE(610),
    [anon_sym_RPAREN] = ACTIONS(1182),
    [anon_sym_COMMA] = ACTIONS(1186),
    [anon_sym_if] = ACTIONS(1198),
    [anon_sym_and] = ACTIONS(1200),
    [anon_sym_or] = ACTIONS(1202),
    [sym_comment] = ACTIONS(73),
  },
  [425] = {
    [aux_sym_tuple_repeat1] = STATE(610),
    [anon_sym_RPAREN] = ACTIONS(1182),
    [anon_sym_COMMA] = ACTIONS(1186),
    [sym_comment] = ACTIONS(73),
  },
  [426] = {
    [sym__expression] = STATE(846),
    [sym__primary_expression] = STATE(432),
    [sym_not_operator] = STATE(846),
    [sym_boolean_operator] = STATE(846),
    [sym_binary_operator] = STATE(432),
    [sym_unary_operator] = STATE(432),
    [sym_comparison_operator] = STATE(846),
    [sym_lambda] = STATE(846),
    [sym_attribute] = STATE(432),
    [sym_subscript] = STATE(432),
    [sym_call] = STATE(432),
    [sym_list] = STATE(432),
    [sym_list_comprehension] = STATE(432),
    [sym_dictionary] = STATE(432),
    [sym_dictionary_comprehension] = STATE(432),
    [sym_set] = STATE(432),
    [sym_set_comprehension] = STATE(432),
    [sym_parenthesized_expression] = STATE(432),
    [sym_tuple] = STATE(432),
    [sym_generator_expression] = STATE(432),
    [sym_conditional_expression] = STATE(846),
    [sym_concatenated_string] = STATE(432),
    [sym_string] = STATE(433),
    [sym_await] = STATE(846),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(735),
    [anon_sym_lambda] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(741),
    [sym_float] = ACTIONS(741),
    [sym_identifier] = ACTIONS(741),
    [sym_true] = ACTIONS(741),
    [sym_false] = ACTIONS(741),
    [sym_none] = ACTIONS(741),
    [anon_sym_await] = ACTIONS(743),
    [sym_comment] = ACTIONS(73),
  },
  [427] = {
    [sym__expression] = STATE(847),
    [sym__primary_expression] = STATE(432),
    [sym_not_operator] = STATE(847),
    [sym_boolean_operator] = STATE(847),
    [sym_binary_operator] = STATE(432),
    [sym_unary_operator] = STATE(432),
    [sym_comparison_operator] = STATE(847),
    [sym_lambda] = STATE(847),
    [sym_attribute] = STATE(432),
    [sym_subscript] = STATE(432),
    [sym_call] = STATE(432),
    [sym_list] = STATE(432),
    [sym_list_comprehension] = STATE(432),
    [sym_dictionary] = STATE(432),
    [sym_dictionary_comprehension] = STATE(432),
    [sym_set] = STATE(432),
    [sym_set_comprehension] = STATE(432),
    [sym_parenthesized_expression] = STATE(432),
    [sym_tuple] = STATE(432),
    [sym_generator_expression] = STATE(432),
    [sym_conditional_expression] = STATE(847),
    [sym_concatenated_string] = STATE(432),
    [sym_string] = STATE(433),
    [sym_await] = STATE(847),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(735),
    [anon_sym_lambda] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(741),
    [sym_float] = ACTIONS(741),
    [sym_identifier] = ACTIONS(741),
    [sym_true] = ACTIONS(741),
    [sym_false] = ACTIONS(741),
    [sym_none] = ACTIONS(741),
    [anon_sym_await] = ACTIONS(743),
    [sym_comment] = ACTIONS(73),
  },
  [428] = {
    [sym__primary_expression] = STATE(227),
    [sym_binary_operator] = STATE(227),
    [sym_unary_operator] = STATE(227),
    [sym_attribute] = STATE(227),
    [sym_subscript] = STATE(227),
    [sym_call] = STATE(227),
    [sym_list] = STATE(227),
    [sym_list_comprehension] = STATE(227),
    [sym_dictionary] = STATE(227),
    [sym_dictionary_comprehension] = STATE(227),
    [sym_set] = STATE(227),
    [sym_set_comprehension] = STATE(227),
    [sym_parenthesized_expression] = STATE(227),
    [sym_tuple] = STATE(227),
    [sym_generator_expression] = STATE(227),
    [sym_concatenated_string] = STATE(227),
    [sym_string] = STATE(433),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(403),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(405),
    [sym_float] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_true] = ACTIONS(405),
    [sym_false] = ACTIONS(405),
    [sym_none] = ACTIONS(405),
    [sym_comment] = ACTIONS(73),
  },
  [429] = {
    [sym_lambda_parameters] = STATE(849),
    [sym__parameters] = STATE(138),
    [sym_default_parameter] = STATE(139),
    [sym_typed_default_parameter] = STATE(139),
    [sym_list_splat] = STATE(140),
    [sym_dictionary_splat] = STATE(140),
    [sym_typed_parameter] = STATE(139),
    [sym_tuple] = STATE(139),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(1606),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [430] = {
    [sym__expression] = STATE(249),
    [sym__primary_expression] = STATE(432),
    [sym_not_operator] = STATE(249),
    [sym_boolean_operator] = STATE(249),
    [sym_binary_operator] = STATE(432),
    [sym_unary_operator] = STATE(432),
    [sym_comparison_operator] = STATE(249),
    [sym_lambda] = STATE(249),
    [sym_attribute] = STATE(432),
    [sym_subscript] = STATE(432),
    [sym_call] = STATE(432),
    [sym_list] = STATE(432),
    [sym_list_comprehension] = STATE(432),
    [sym_dictionary] = STATE(432),
    [sym_dictionary_comprehension] = STATE(432),
    [sym_set] = STATE(432),
    [sym_set_comprehension] = STATE(432),
    [sym_parenthesized_expression] = STATE(432),
    [sym_tuple] = STATE(432),
    [sym_generator_expression] = STATE(432),
    [sym_conditional_expression] = STATE(249),
    [sym_concatenated_string] = STATE(432),
    [sym_string] = STATE(433),
    [sym_await] = STATE(249),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(735),
    [anon_sym_lambda] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(741),
    [sym_float] = ACTIONS(741),
    [sym_identifier] = ACTIONS(741),
    [sym_true] = ACTIONS(741),
    [sym_false] = ACTIONS(741),
    [sym_none] = ACTIONS(741),
    [anon_sym_await] = ACTIONS(743),
    [sym_comment] = ACTIONS(73),
  },
  [431] = {
    [anon_sym_COMMA] = ACTIONS(1608),
    [anon_sym_if] = ACTIONS(1610),
    [anon_sym_COLON] = ACTIONS(1608),
    [anon_sym_and] = ACTIONS(1612),
    [anon_sym_or] = ACTIONS(1614),
    [sym_comment] = ACTIONS(73),
  },
  [432] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [aux_sym_comparison_operator_repeat1] = STATE(863),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(1616),
    [anon_sym_GT_GT] = ACTIONS(1618),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(1620),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_not] = ACTIONS(1624),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1626),
    [anon_sym_SLASH] = ACTIONS(1616),
    [anon_sym_PERCENT] = ACTIONS(1622),
    [anon_sym_SLASH_SLASH] = ACTIONS(1622),
    [anon_sym_STAR_STAR] = ACTIONS(1628),
    [anon_sym_PIPE] = ACTIONS(1630),
    [anon_sym_AMP] = ACTIONS(1632),
    [anon_sym_CARET] = ACTIONS(1634),
    [anon_sym_LT_LT] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(1636),
    [anon_sym_LT_EQ] = ACTIONS(1620),
    [anon_sym_EQ_EQ] = ACTIONS(1620),
    [anon_sym_BANG_EQ] = ACTIONS(1620),
    [anon_sym_GT_EQ] = ACTIONS(1620),
    [anon_sym_GT] = ACTIONS(1636),
    [anon_sym_LT_GT] = ACTIONS(1620),
    [anon_sym_is] = ACTIONS(1638),
    [anon_sym_LBRACK] = ACTIONS(473),
    [sym_comment] = ACTIONS(73),
  },
  [433] = {
    [sym_string] = STATE(864),
    [aux_sym_concatenated_string_repeat1] = STATE(864),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_COLON] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [434] = {
    [sym_default_parameter] = STATE(867),
    [sym_typed_default_parameter] = STATE(867),
    [sym_list_splat] = STATE(868),
    [sym_dictionary_splat] = STATE(868),
    [sym_typed_parameter] = STATE(867),
    [sym_tuple] = STATE(867),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(1640),
    [anon_sym_COLON] = ACTIONS(1642),
    [anon_sym_exec] = ACTIONS(1640),
    [sym_identifier] = ACTIONS(1644),
    [sym_comment] = ACTIONS(73),
  },
  [435] = {
    [sym__expression] = STATE(873),
    [sym__primary_expression] = STATE(874),
    [sym_not_operator] = STATE(873),
    [sym_boolean_operator] = STATE(873),
    [sym_binary_operator] = STATE(874),
    [sym_unary_operator] = STATE(874),
    [sym_comparison_operator] = STATE(873),
    [sym_lambda] = STATE(873),
    [sym_attribute] = STATE(874),
    [sym_subscript] = STATE(874),
    [sym_call] = STATE(874),
    [sym_type] = STATE(875),
    [sym_list] = STATE(874),
    [sym_list_comprehension] = STATE(874),
    [sym_dictionary] = STATE(874),
    [sym_dictionary_comprehension] = STATE(874),
    [sym_set] = STATE(874),
    [sym_set_comprehension] = STATE(874),
    [sym_parenthesized_expression] = STATE(874),
    [sym_tuple] = STATE(874),
    [sym_generator_expression] = STATE(874),
    [sym_conditional_expression] = STATE(873),
    [sym_concatenated_string] = STATE(874),
    [sym_string] = STATE(876),
    [sym_await] = STATE(873),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1646),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_DASH] = ACTIONS(1648),
    [anon_sym_TILDE] = ACTIONS(1648),
    [anon_sym_lambda] = ACTIONS(1650),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1652),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1654),
    [sym_float] = ACTIONS(1654),
    [sym_identifier] = ACTIONS(1654),
    [sym_true] = ACTIONS(1654),
    [sym_false] = ACTIONS(1654),
    [sym_none] = ACTIONS(1654),
    [anon_sym_await] = ACTIONS(1656),
    [sym_comment] = ACTIONS(73),
  },
  [436] = {
    [sym__expression] = STATE(877),
    [sym__primary_expression] = STATE(432),
    [sym_not_operator] = STATE(877),
    [sym_boolean_operator] = STATE(877),
    [sym_binary_operator] = STATE(432),
    [sym_unary_operator] = STATE(432),
    [sym_comparison_operator] = STATE(877),
    [sym_lambda] = STATE(877),
    [sym_attribute] = STATE(432),
    [sym_subscript] = STATE(432),
    [sym_call] = STATE(432),
    [sym_list] = STATE(432),
    [sym_list_comprehension] = STATE(432),
    [sym_dictionary] = STATE(432),
    [sym_dictionary_comprehension] = STATE(432),
    [sym_set] = STATE(432),
    [sym_set_comprehension] = STATE(432),
    [sym_parenthesized_expression] = STATE(432),
    [sym_tuple] = STATE(432),
    [sym_generator_expression] = STATE(432),
    [sym_conditional_expression] = STATE(877),
    [sym_concatenated_string] = STATE(432),
    [sym_string] = STATE(433),
    [sym_await] = STATE(877),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(735),
    [anon_sym_lambda] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(741),
    [sym_float] = ACTIONS(741),
    [sym_identifier] = ACTIONS(741),
    [sym_true] = ACTIONS(741),
    [sym_false] = ACTIONS(741),
    [sym_none] = ACTIONS(741),
    [anon_sym_await] = ACTIONS(743),
    [sym_comment] = ACTIONS(73),
  },
  [437] = {
    [aux_sym__parameters_repeat1] = STATE(879),
    [anon_sym_COMMA] = ACTIONS(1658),
    [anon_sym_COLON] = ACTIONS(1642),
    [sym_comment] = ACTIONS(73),
  },
  [438] = {
    [sym__newline] = ACTIONS(1660),
    [anon_sym_COMMA] = ACTIONS(1660),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_COLON] = ACTIONS(1660),
    [anon_sym_EQ] = ACTIONS(1660),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(299),
    [anon_sym_PLUS_EQ] = ACTIONS(1660),
    [anon_sym_DASH_EQ] = ACTIONS(1660),
    [anon_sym_STAR_EQ] = ACTIONS(1660),
    [anon_sym_SLASH_EQ] = ACTIONS(1660),
    [anon_sym_AT_EQ] = ACTIONS(1660),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1660),
    [anon_sym_PERCENT_EQ] = ACTIONS(1660),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1660),
    [anon_sym_GT_GT_EQ] = ACTIONS(1660),
    [anon_sym_LT_LT_EQ] = ACTIONS(1660),
    [anon_sym_AMP_EQ] = ACTIONS(1660),
    [anon_sym_CARET_EQ] = ACTIONS(1660),
    [anon_sym_PIPE_EQ] = ACTIONS(1660),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1660),
  },
  [439] = {
    [sym_default_parameter] = STATE(867),
    [sym_typed_default_parameter] = STATE(867),
    [sym_list_splat] = STATE(868),
    [sym_dictionary_splat] = STATE(868),
    [sym_typed_parameter] = STATE(867),
    [sym_tuple] = STATE(867),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(1640),
    [anon_sym_COLON] = ACTIONS(1662),
    [anon_sym_exec] = ACTIONS(1640),
    [sym_identifier] = ACTIONS(1644),
    [sym_comment] = ACTIONS(73),
  },
  [440] = {
    [sym__expression] = STATE(884),
    [sym__primary_expression] = STATE(885),
    [sym_not_operator] = STATE(884),
    [sym_boolean_operator] = STATE(884),
    [sym_binary_operator] = STATE(885),
    [sym_unary_operator] = STATE(885),
    [sym_comparison_operator] = STATE(884),
    [sym_lambda] = STATE(884),
    [sym_attribute] = STATE(885),
    [sym_subscript] = STATE(885),
    [sym_call] = STATE(885),
    [sym_type] = STATE(886),
    [sym_list] = STATE(885),
    [sym_list_comprehension] = STATE(885),
    [sym_dictionary] = STATE(885),
    [sym_dictionary_comprehension] = STATE(885),
    [sym_set] = STATE(885),
    [sym_set_comprehension] = STATE(885),
    [sym_parenthesized_expression] = STATE(885),
    [sym_tuple] = STATE(885),
    [sym_generator_expression] = STATE(885),
    [sym_conditional_expression] = STATE(884),
    [sym_concatenated_string] = STATE(885),
    [sym_string] = STATE(887),
    [sym_await] = STATE(884),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_PLUS] = ACTIONS(1666),
    [anon_sym_DASH] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [anon_sym_lambda] = ACTIONS(1668),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1670),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1672),
    [sym_float] = ACTIONS(1672),
    [sym_identifier] = ACTIONS(1672),
    [sym_true] = ACTIONS(1672),
    [sym_false] = ACTIONS(1672),
    [sym_none] = ACTIONS(1672),
    [anon_sym_await] = ACTIONS(1674),
    [sym_comment] = ACTIONS(73),
  },
  [441] = {
    [sym__expression] = STATE(888),
    [sym__primary_expression] = STATE(432),
    [sym_not_operator] = STATE(888),
    [sym_boolean_operator] = STATE(888),
    [sym_binary_operator] = STATE(432),
    [sym_unary_operator] = STATE(432),
    [sym_comparison_operator] = STATE(888),
    [sym_lambda] = STATE(888),
    [sym_attribute] = STATE(432),
    [sym_subscript] = STATE(432),
    [sym_call] = STATE(432),
    [sym_list] = STATE(432),
    [sym_list_comprehension] = STATE(432),
    [sym_dictionary] = STATE(432),
    [sym_dictionary_comprehension] = STATE(432),
    [sym_set] = STATE(432),
    [sym_set_comprehension] = STATE(432),
    [sym_parenthesized_expression] = STATE(432),
    [sym_tuple] = STATE(432),
    [sym_generator_expression] = STATE(432),
    [sym_conditional_expression] = STATE(888),
    [sym_concatenated_string] = STATE(432),
    [sym_string] = STATE(433),
    [sym_await] = STATE(888),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(735),
    [anon_sym_lambda] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(741),
    [sym_float] = ACTIONS(741),
    [sym_identifier] = ACTIONS(741),
    [sym_true] = ACTIONS(741),
    [sym_false] = ACTIONS(741),
    [sym_none] = ACTIONS(741),
    [anon_sym_await] = ACTIONS(743),
    [sym_comment] = ACTIONS(73),
  },
  [442] = {
    [aux_sym__parameters_repeat1] = STATE(879),
    [anon_sym_COMMA] = ACTIONS(1676),
    [anon_sym_COLON] = ACTIONS(1662),
    [sym_comment] = ACTIONS(73),
  },
  [443] = {
    [sym__expression] = STATE(890),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(890),
    [sym_boolean_operator] = STATE(890),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(890),
    [sym_lambda] = STATE(890),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(890),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(890),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [444] = {
    [sym__expression] = STATE(891),
    [sym__primary_expression] = STATE(432),
    [sym_not_operator] = STATE(891),
    [sym_boolean_operator] = STATE(891),
    [sym_binary_operator] = STATE(432),
    [sym_unary_operator] = STATE(432),
    [sym_comparison_operator] = STATE(891),
    [sym_lambda] = STATE(891),
    [sym_attribute] = STATE(432),
    [sym_subscript] = STATE(432),
    [sym_call] = STATE(432),
    [sym_type] = STATE(892),
    [sym_list] = STATE(432),
    [sym_list_comprehension] = STATE(432),
    [sym_dictionary] = STATE(432),
    [sym_dictionary_comprehension] = STATE(432),
    [sym_set] = STATE(432),
    [sym_set_comprehension] = STATE(432),
    [sym_parenthesized_expression] = STATE(432),
    [sym_tuple] = STATE(432),
    [sym_generator_expression] = STATE(432),
    [sym_conditional_expression] = STATE(891),
    [sym_concatenated_string] = STATE(432),
    [sym_string] = STATE(433),
    [sym_await] = STATE(891),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(735),
    [anon_sym_lambda] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(741),
    [sym_float] = ACTIONS(741),
    [sym_identifier] = ACTIONS(741),
    [sym_true] = ACTIONS(741),
    [sym_false] = ACTIONS(741),
    [sym_none] = ACTIONS(741),
    [anon_sym_await] = ACTIONS(743),
    [sym_comment] = ACTIONS(73),
  },
  [445] = {
    [sym__newline] = ACTIONS(1678),
    [anon_sym_if] = ACTIONS(1378),
    [anon_sym_and] = ACTIONS(1380),
    [anon_sym_or] = ACTIONS(1382),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1678),
  },
  [446] = {
    [sym__newline] = ACTIONS(1680),
    [anon_sym_DOT] = ACTIONS(1680),
    [anon_sym_LPAREN] = ACTIONS(1680),
    [anon_sym_COMMA] = ACTIONS(1680),
    [anon_sym_STAR] = ACTIONS(1682),
    [anon_sym_GT_GT] = ACTIONS(1682),
    [anon_sym_if] = ACTIONS(1680),
    [anon_sym_COLON] = ACTIONS(1680),
    [anon_sym_in] = ACTIONS(1680),
    [anon_sym_EQ] = ACTIONS(1682),
    [anon_sym_AT] = ACTIONS(1682),
    [anon_sym_not] = ACTIONS(1680),
    [anon_sym_and] = ACTIONS(1680),
    [anon_sym_or] = ACTIONS(1680),
    [anon_sym_PLUS] = ACTIONS(1682),
    [anon_sym_DASH] = ACTIONS(1682),
    [anon_sym_SLASH] = ACTIONS(1682),
    [anon_sym_PERCENT] = ACTIONS(1682),
    [anon_sym_SLASH_SLASH] = ACTIONS(1682),
    [anon_sym_STAR_STAR] = ACTIONS(1682),
    [anon_sym_PIPE] = ACTIONS(1682),
    [anon_sym_AMP] = ACTIONS(1682),
    [anon_sym_CARET] = ACTIONS(1682),
    [anon_sym_LT_LT] = ACTIONS(1682),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_LT_EQ] = ACTIONS(1680),
    [anon_sym_EQ_EQ] = ACTIONS(1680),
    [anon_sym_BANG_EQ] = ACTIONS(1680),
    [anon_sym_GT_EQ] = ACTIONS(1680),
    [anon_sym_GT] = ACTIONS(1682),
    [anon_sym_LT_GT] = ACTIONS(1680),
    [anon_sym_is] = ACTIONS(1680),
    [anon_sym_PLUS_EQ] = ACTIONS(1680),
    [anon_sym_DASH_EQ] = ACTIONS(1680),
    [anon_sym_STAR_EQ] = ACTIONS(1680),
    [anon_sym_SLASH_EQ] = ACTIONS(1680),
    [anon_sym_AT_EQ] = ACTIONS(1680),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1680),
    [anon_sym_PERCENT_EQ] = ACTIONS(1680),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1680),
    [anon_sym_GT_GT_EQ] = ACTIONS(1680),
    [anon_sym_LT_LT_EQ] = ACTIONS(1680),
    [anon_sym_AMP_EQ] = ACTIONS(1680),
    [anon_sym_CARET_EQ] = ACTIONS(1680),
    [anon_sym_PIPE_EQ] = ACTIONS(1680),
    [anon_sym_LBRACK] = ACTIONS(1680),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1680),
  },
  [447] = {
    [sym__expression] = STATE(893),
    [sym__primary_expression] = STATE(452),
    [sym_not_operator] = STATE(893),
    [sym_boolean_operator] = STATE(893),
    [sym_binary_operator] = STATE(452),
    [sym_unary_operator] = STATE(452),
    [sym_comparison_operator] = STATE(893),
    [sym_lambda] = STATE(893),
    [sym_attribute] = STATE(452),
    [sym_subscript] = STATE(452),
    [sym_call] = STATE(452),
    [sym_list] = STATE(452),
    [sym_list_comprehension] = STATE(452),
    [sym_dictionary] = STATE(452),
    [sym_dictionary_comprehension] = STATE(452),
    [sym_set] = STATE(452),
    [sym_set_comprehension] = STATE(452),
    [sym_parenthesized_expression] = STATE(452),
    [sym_tuple] = STATE(452),
    [sym_generator_expression] = STATE(452),
    [sym_conditional_expression] = STATE(893),
    [sym_concatenated_string] = STATE(452),
    [sym_string] = STATE(453),
    [sym_await] = STATE(893),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_lambda] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(773),
    [sym_float] = ACTIONS(773),
    [sym_identifier] = ACTIONS(773),
    [sym_true] = ACTIONS(773),
    [sym_false] = ACTIONS(773),
    [sym_none] = ACTIONS(773),
    [anon_sym_await] = ACTIONS(775),
    [sym_comment] = ACTIONS(73),
  },
  [448] = {
    [sym__primary_expression] = STATE(227),
    [sym_binary_operator] = STATE(227),
    [sym_unary_operator] = STATE(227),
    [sym_attribute] = STATE(227),
    [sym_subscript] = STATE(227),
    [sym_call] = STATE(227),
    [sym_list] = STATE(227),
    [sym_list_comprehension] = STATE(227),
    [sym_dictionary] = STATE(227),
    [sym_dictionary_comprehension] = STATE(227),
    [sym_set] = STATE(227),
    [sym_set_comprehension] = STATE(227),
    [sym_parenthesized_expression] = STATE(227),
    [sym_tuple] = STATE(227),
    [sym_generator_expression] = STATE(227),
    [sym_concatenated_string] = STATE(227),
    [sym_string] = STATE(453),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(403),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(405),
    [sym_float] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_true] = ACTIONS(405),
    [sym_false] = ACTIONS(405),
    [sym_none] = ACTIONS(405),
    [sym_comment] = ACTIONS(73),
  },
  [449] = {
    [sym_lambda_parameters] = STATE(895),
    [sym__parameters] = STATE(138),
    [sym_default_parameter] = STATE(139),
    [sym_typed_default_parameter] = STATE(139),
    [sym_list_splat] = STATE(140),
    [sym_dictionary_splat] = STATE(140),
    [sym_typed_parameter] = STATE(139),
    [sym_tuple] = STATE(139),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(1684),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [450] = {
    [sym__expression] = STATE(249),
    [sym__primary_expression] = STATE(452),
    [sym_not_operator] = STATE(249),
    [sym_boolean_operator] = STATE(249),
    [sym_binary_operator] = STATE(452),
    [sym_unary_operator] = STATE(452),
    [sym_comparison_operator] = STATE(249),
    [sym_lambda] = STATE(249),
    [sym_attribute] = STATE(452),
    [sym_subscript] = STATE(452),
    [sym_call] = STATE(452),
    [sym_list] = STATE(452),
    [sym_list_comprehension] = STATE(452),
    [sym_dictionary] = STATE(452),
    [sym_dictionary_comprehension] = STATE(452),
    [sym_set] = STATE(452),
    [sym_set_comprehension] = STATE(452),
    [sym_parenthesized_expression] = STATE(452),
    [sym_tuple] = STATE(452),
    [sym_generator_expression] = STATE(452),
    [sym_conditional_expression] = STATE(249),
    [sym_concatenated_string] = STATE(452),
    [sym_string] = STATE(453),
    [sym_await] = STATE(249),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_lambda] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(773),
    [sym_float] = ACTIONS(773),
    [sym_identifier] = ACTIONS(773),
    [sym_true] = ACTIONS(773),
    [sym_false] = ACTIONS(773),
    [sym_none] = ACTIONS(773),
    [anon_sym_await] = ACTIONS(775),
    [sym_comment] = ACTIONS(73),
  },
  [451] = {
    [anon_sym_COMMA] = ACTIONS(1608),
    [anon_sym_if] = ACTIONS(1686),
    [anon_sym_and] = ACTIONS(1688),
    [anon_sym_or] = ACTIONS(1690),
    [anon_sym_RBRACK] = ACTIONS(1608),
    [sym_comment] = ACTIONS(73),
  },
  [452] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [aux_sym_comparison_operator_repeat1] = STATE(909),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(1692),
    [anon_sym_GT_GT] = ACTIONS(1694),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(1696),
    [anon_sym_AT] = ACTIONS(1698),
    [anon_sym_not] = ACTIONS(1700),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(1702),
    [anon_sym_DASH] = ACTIONS(1702),
    [anon_sym_SLASH] = ACTIONS(1692),
    [anon_sym_PERCENT] = ACTIONS(1698),
    [anon_sym_SLASH_SLASH] = ACTIONS(1698),
    [anon_sym_STAR_STAR] = ACTIONS(1704),
    [anon_sym_PIPE] = ACTIONS(1706),
    [anon_sym_AMP] = ACTIONS(1708),
    [anon_sym_CARET] = ACTIONS(1710),
    [anon_sym_LT_LT] = ACTIONS(1694),
    [anon_sym_LT] = ACTIONS(1712),
    [anon_sym_LT_EQ] = ACTIONS(1696),
    [anon_sym_EQ_EQ] = ACTIONS(1696),
    [anon_sym_BANG_EQ] = ACTIONS(1696),
    [anon_sym_GT_EQ] = ACTIONS(1696),
    [anon_sym_GT] = ACTIONS(1712),
    [anon_sym_LT_GT] = ACTIONS(1696),
    [anon_sym_is] = ACTIONS(1714),
    [anon_sym_LBRACK] = ACTIONS(473),
    [anon_sym_RBRACK] = ACTIONS(301),
    [sym_comment] = ACTIONS(73),
  },
  [453] = {
    [sym_string] = STATE(910),
    [aux_sym_concatenated_string_repeat1] = STATE(910),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_RBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [454] = {
    [anon_sym_COMMA] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(723),
    [anon_sym_async] = ACTIONS(723),
    [anon_sym_for] = ACTIONS(723),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_or] = ACTIONS(793),
    [anon_sym_RBRACK] = ACTIONS(723),
    [sym_comment] = ACTIONS(73),
  },
  [455] = {
    [sym__expression] = STATE(911),
    [sym__primary_expression] = STATE(152),
    [sym_not_operator] = STATE(911),
    [sym_boolean_operator] = STATE(911),
    [sym_binary_operator] = STATE(152),
    [sym_unary_operator] = STATE(152),
    [sym_comparison_operator] = STATE(911),
    [sym_lambda] = STATE(911),
    [sym_attribute] = STATE(152),
    [sym_subscript] = STATE(152),
    [sym_call] = STATE(152),
    [sym_list] = STATE(152),
    [sym_list_comprehension] = STATE(152),
    [sym_dictionary] = STATE(152),
    [sym_dictionary_comprehension] = STATE(152),
    [sym_set] = STATE(152),
    [sym_set_comprehension] = STATE(152),
    [sym_parenthesized_expression] = STATE(152),
    [sym_tuple] = STATE(152),
    [sym_generator_expression] = STATE(152),
    [sym_conditional_expression] = STATE(911),
    [sym_concatenated_string] = STATE(152),
    [sym_string] = STATE(153),
    [sym_await] = STATE(911),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_lambda] = ACTIONS(249),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(255),
    [sym_float] = ACTIONS(255),
    [sym_identifier] = ACTIONS(255),
    [sym_true] = ACTIONS(255),
    [sym_false] = ACTIONS(255),
    [sym_none] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [sym_comment] = ACTIONS(73),
  },
  [456] = {
    [anon_sym_COLON] = ACTIONS(1716),
    [sym_comment] = ACTIONS(73),
  },
  [457] = {
    [sym_list_splat] = STATE(914),
    [sym__expression] = STATE(915),
    [sym__primary_expression] = STATE(452),
    [sym_not_operator] = STATE(915),
    [sym_boolean_operator] = STATE(915),
    [sym_binary_operator] = STATE(452),
    [sym_unary_operator] = STATE(452),
    [sym_comparison_operator] = STATE(915),
    [sym_lambda] = STATE(915),
    [sym_attribute] = STATE(452),
    [sym_subscript] = STATE(452),
    [sym_call] = STATE(452),
    [sym_list] = STATE(452),
    [sym_list_comprehension] = STATE(452),
    [sym_dictionary] = STATE(452),
    [sym_dictionary_comprehension] = STATE(452),
    [sym_set] = STATE(452),
    [sym_set_comprehension] = STATE(452),
    [sym_parenthesized_expression] = STATE(452),
    [sym_tuple] = STATE(452),
    [sym_generator_expression] = STATE(452),
    [sym_conditional_expression] = STATE(915),
    [sym_concatenated_string] = STATE(452),
    [sym_string] = STATE(453),
    [sym_await] = STATE(915),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(243),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_lambda] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(1718),
    [sym_ellipsis] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(773),
    [sym_float] = ACTIONS(773),
    [sym_identifier] = ACTIONS(773),
    [sym_true] = ACTIONS(773),
    [sym_false] = ACTIONS(773),
    [sym_none] = ACTIONS(773),
    [anon_sym_await] = ACTIONS(775),
    [sym_comment] = ACTIONS(73),
  },
  [458] = {
    [aux_sym_list_repeat1] = STATE(917),
    [anon_sym_COMMA] = ACTIONS(1720),
    [anon_sym_RBRACK] = ACTIONS(1718),
    [sym_comment] = ACTIONS(73),
  },
  [459] = {
    [sym__expression] = STATE(918),
    [sym__primary_expression] = STATE(538),
    [sym_not_operator] = STATE(918),
    [sym_boolean_operator] = STATE(918),
    [sym_binary_operator] = STATE(538),
    [sym_unary_operator] = STATE(538),
    [sym_comparison_operator] = STATE(918),
    [sym_lambda] = STATE(918),
    [sym_attribute] = STATE(538),
    [sym_subscript] = STATE(538),
    [sym_call] = STATE(538),
    [sym_list] = STATE(538),
    [sym_list_comprehension] = STATE(538),
    [sym_dictionary] = STATE(538),
    [sym_dictionary_comprehension] = STATE(538),
    [sym_set] = STATE(538),
    [sym_set_comprehension] = STATE(538),
    [sym_parenthesized_expression] = STATE(538),
    [sym_tuple] = STATE(538),
    [sym_generator_expression] = STATE(538),
    [sym_conditional_expression] = STATE(918),
    [sym_concatenated_string] = STATE(538),
    [sym_string] = STATE(539),
    [sym_await] = STATE(918),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_lambda] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(917),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(919),
    [sym_float] = ACTIONS(919),
    [sym_identifier] = ACTIONS(919),
    [sym_true] = ACTIONS(919),
    [sym_false] = ACTIONS(919),
    [sym_none] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(921),
    [sym_comment] = ACTIONS(73),
  },
  [460] = {
    [anon_sym_for] = ACTIONS(1722),
    [sym_comment] = ACTIONS(73),
  },
  [461] = {
    [sym_variables] = STATE(920),
    [sym__primary_expression] = STATE(109),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(110),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(191),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(193),
    [sym_float] = ACTIONS(193),
    [sym_identifier] = ACTIONS(193),
    [sym_true] = ACTIONS(193),
    [sym_false] = ACTIONS(193),
    [sym_none] = ACTIONS(193),
    [sym_comment] = ACTIONS(73),
  },
  [462] = {
    [sym__expression] = STATE(652),
    [sym__primary_expression] = STATE(152),
    [sym_not_operator] = STATE(652),
    [sym_boolean_operator] = STATE(652),
    [sym_binary_operator] = STATE(152),
    [sym_unary_operator] = STATE(152),
    [sym_comparison_operator] = STATE(652),
    [sym_lambda] = STATE(652),
    [sym_attribute] = STATE(152),
    [sym_subscript] = STATE(152),
    [sym_call] = STATE(152),
    [sym_list] = STATE(152),
    [sym_list_comprehension] = STATE(152),
    [sym_dictionary] = STATE(152),
    [sym_dictionary_comprehension] = STATE(152),
    [sym_set] = STATE(152),
    [sym_set_comprehension] = STATE(152),
    [sym_parenthesized_expression] = STATE(152),
    [sym_tuple] = STATE(152),
    [sym_generator_expression] = STATE(152),
    [sym_conditional_expression] = STATE(652),
    [sym_concatenated_string] = STATE(152),
    [sym_string] = STATE(153),
    [sym_await] = STATE(652),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_lambda] = ACTIONS(249),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(255),
    [sym_float] = ACTIONS(255),
    [sym_identifier] = ACTIONS(255),
    [sym_true] = ACTIONS(255),
    [sym_false] = ACTIONS(255),
    [sym_none] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [sym_comment] = ACTIONS(73),
  },
  [463] = {
    [sym__expression] = STATE(921),
    [sym__primary_expression] = STATE(152),
    [sym_not_operator] = STATE(921),
    [sym_boolean_operator] = STATE(921),
    [sym_binary_operator] = STATE(152),
    [sym_unary_operator] = STATE(152),
    [sym_comparison_operator] = STATE(921),
    [sym_lambda] = STATE(921),
    [sym_attribute] = STATE(152),
    [sym_subscript] = STATE(152),
    [sym_call] = STATE(152),
    [sym_list] = STATE(152),
    [sym_list_comprehension] = STATE(152),
    [sym_dictionary] = STATE(152),
    [sym_dictionary_comprehension] = STATE(152),
    [sym_set] = STATE(152),
    [sym_set_comprehension] = STATE(152),
    [sym_parenthesized_expression] = STATE(152),
    [sym_tuple] = STATE(152),
    [sym_generator_expression] = STATE(152),
    [sym_conditional_expression] = STATE(921),
    [sym_concatenated_string] = STATE(152),
    [sym_string] = STATE(153),
    [sym_await] = STATE(921),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_lambda] = ACTIONS(249),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(255),
    [sym_float] = ACTIONS(255),
    [sym_identifier] = ACTIONS(255),
    [sym_true] = ACTIONS(255),
    [sym_false] = ACTIONS(255),
    [sym_none] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [sym_comment] = ACTIONS(73),
  },
  [464] = {
    [anon_sym_RBRACK] = ACTIONS(1724),
    [sym_comment] = ACTIONS(73),
  },
  [465] = {
    [sym_for_in_clause] = STATE(924),
    [sym_if_clause] = STATE(924),
    [aux_sym__comprehension_body_repeat1] = STATE(924),
    [anon_sym_if] = ACTIONS(1726),
    [anon_sym_async] = ACTIONS(787),
    [anon_sym_for] = ACTIONS(789),
    [anon_sym_RBRACK] = ACTIONS(1252),
    [sym_comment] = ACTIONS(73),
  },
  [466] = {
    [sym__primary_expression] = STATE(925),
    [sym_binary_operator] = STATE(925),
    [sym_unary_operator] = STATE(925),
    [sym_attribute] = STATE(925),
    [sym_subscript] = STATE(925),
    [sym_call] = STATE(925),
    [sym_list] = STATE(925),
    [sym_list_comprehension] = STATE(925),
    [sym_dictionary] = STATE(925),
    [sym_dictionary_comprehension] = STATE(925),
    [sym_set] = STATE(925),
    [sym_set_comprehension] = STATE(925),
    [sym_parenthesized_expression] = STATE(925),
    [sym_tuple] = STATE(925),
    [sym_generator_expression] = STATE(925),
    [sym_concatenated_string] = STATE(925),
    [sym_string] = STATE(153),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1728),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1730),
    [sym_float] = ACTIONS(1730),
    [sym_identifier] = ACTIONS(1730),
    [sym_true] = ACTIONS(1730),
    [sym_false] = ACTIONS(1730),
    [sym_none] = ACTIONS(1730),
    [sym_comment] = ACTIONS(73),
  },
  [467] = {
    [sym__primary_expression] = STATE(926),
    [sym_binary_operator] = STATE(926),
    [sym_unary_operator] = STATE(926),
    [sym_attribute] = STATE(926),
    [sym_subscript] = STATE(926),
    [sym_call] = STATE(926),
    [sym_list] = STATE(926),
    [sym_list_comprehension] = STATE(926),
    [sym_dictionary] = STATE(926),
    [sym_dictionary_comprehension] = STATE(926),
    [sym_set] = STATE(926),
    [sym_set_comprehension] = STATE(926),
    [sym_parenthesized_expression] = STATE(926),
    [sym_tuple] = STATE(926),
    [sym_generator_expression] = STATE(926),
    [sym_concatenated_string] = STATE(926),
    [sym_string] = STATE(153),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1732),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1734),
    [sym_float] = ACTIONS(1734),
    [sym_identifier] = ACTIONS(1734),
    [sym_true] = ACTIONS(1734),
    [sym_false] = ACTIONS(1734),
    [sym_none] = ACTIONS(1734),
    [sym_comment] = ACTIONS(73),
  },
  [468] = {
    [sym__primary_expression] = STATE(927),
    [sym_binary_operator] = STATE(927),
    [sym_unary_operator] = STATE(927),
    [sym_attribute] = STATE(927),
    [sym_subscript] = STATE(927),
    [sym_call] = STATE(927),
    [sym_list] = STATE(927),
    [sym_list_comprehension] = STATE(927),
    [sym_dictionary] = STATE(927),
    [sym_dictionary_comprehension] = STATE(927),
    [sym_set] = STATE(927),
    [sym_set_comprehension] = STATE(927),
    [sym_parenthesized_expression] = STATE(927),
    [sym_tuple] = STATE(927),
    [sym_generator_expression] = STATE(927),
    [sym_concatenated_string] = STATE(927),
    [sym_string] = STATE(153),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1736),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1738),
    [sym_float] = ACTIONS(1738),
    [sym_identifier] = ACTIONS(1738),
    [sym_true] = ACTIONS(1738),
    [sym_false] = ACTIONS(1738),
    [sym_none] = ACTIONS(1738),
    [sym_comment] = ACTIONS(73),
  },
  [469] = {
    [anon_sym_in] = ACTIONS(1740),
    [sym_comment] = ACTIONS(73),
  },
  [470] = {
    [sym__primary_expression] = STATE(929),
    [sym_binary_operator] = STATE(929),
    [sym_unary_operator] = STATE(929),
    [sym_attribute] = STATE(929),
    [sym_subscript] = STATE(929),
    [sym_call] = STATE(929),
    [sym_list] = STATE(929),
    [sym_list_comprehension] = STATE(929),
    [sym_dictionary] = STATE(929),
    [sym_dictionary_comprehension] = STATE(929),
    [sym_set] = STATE(929),
    [sym_set_comprehension] = STATE(929),
    [sym_parenthesized_expression] = STATE(929),
    [sym_tuple] = STATE(929),
    [sym_generator_expression] = STATE(929),
    [sym_concatenated_string] = STATE(929),
    [sym_string] = STATE(153),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1742),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1744),
    [sym_float] = ACTIONS(1744),
    [sym_identifier] = ACTIONS(1744),
    [sym_true] = ACTIONS(1744),
    [sym_false] = ACTIONS(1744),
    [sym_none] = ACTIONS(1744),
    [sym_comment] = ACTIONS(73),
  },
  [471] = {
    [sym__primary_expression] = STATE(669),
    [sym_binary_operator] = STATE(669),
    [sym_unary_operator] = STATE(669),
    [sym_attribute] = STATE(669),
    [sym_subscript] = STATE(669),
    [sym_call] = STATE(669),
    [sym_list] = STATE(669),
    [sym_list_comprehension] = STATE(669),
    [sym_dictionary] = STATE(669),
    [sym_dictionary_comprehension] = STATE(669),
    [sym_set] = STATE(669),
    [sym_set_comprehension] = STATE(669),
    [sym_parenthesized_expression] = STATE(669),
    [sym_tuple] = STATE(669),
    [sym_generator_expression] = STATE(669),
    [sym_concatenated_string] = STATE(669),
    [sym_string] = STATE(153),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1282),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1284),
    [sym_float] = ACTIONS(1284),
    [sym_identifier] = ACTIONS(1284),
    [sym_true] = ACTIONS(1284),
    [sym_false] = ACTIONS(1284),
    [sym_none] = ACTIONS(1284),
    [sym_comment] = ACTIONS(73),
  },
  [472] = {
    [sym__primary_expression] = STATE(930),
    [sym_binary_operator] = STATE(930),
    [sym_unary_operator] = STATE(930),
    [sym_attribute] = STATE(930),
    [sym_subscript] = STATE(930),
    [sym_call] = STATE(930),
    [sym_list] = STATE(930),
    [sym_list_comprehension] = STATE(930),
    [sym_dictionary] = STATE(930),
    [sym_dictionary_comprehension] = STATE(930),
    [sym_set] = STATE(930),
    [sym_set_comprehension] = STATE(930),
    [sym_parenthesized_expression] = STATE(930),
    [sym_tuple] = STATE(930),
    [sym_generator_expression] = STATE(930),
    [sym_concatenated_string] = STATE(930),
    [sym_string] = STATE(153),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1746),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1748),
    [sym_float] = ACTIONS(1748),
    [sym_identifier] = ACTIONS(1748),
    [sym_true] = ACTIONS(1748),
    [sym_false] = ACTIONS(1748),
    [sym_none] = ACTIONS(1748),
    [sym_comment] = ACTIONS(73),
  },
  [473] = {
    [sym__primary_expression] = STATE(931),
    [sym_binary_operator] = STATE(931),
    [sym_unary_operator] = STATE(931),
    [sym_attribute] = STATE(931),
    [sym_subscript] = STATE(931),
    [sym_call] = STATE(931),
    [sym_list] = STATE(931),
    [sym_list_comprehension] = STATE(931),
    [sym_dictionary] = STATE(931),
    [sym_dictionary_comprehension] = STATE(931),
    [sym_set] = STATE(931),
    [sym_set_comprehension] = STATE(931),
    [sym_parenthesized_expression] = STATE(931),
    [sym_tuple] = STATE(931),
    [sym_generator_expression] = STATE(931),
    [sym_concatenated_string] = STATE(931),
    [sym_string] = STATE(153),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1750),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1752),
    [sym_float] = ACTIONS(1752),
    [sym_identifier] = ACTIONS(1752),
    [sym_true] = ACTIONS(1752),
    [sym_false] = ACTIONS(1752),
    [sym_none] = ACTIONS(1752),
    [sym_comment] = ACTIONS(73),
  },
  [474] = {
    [sym__primary_expression] = STATE(932),
    [sym_binary_operator] = STATE(932),
    [sym_unary_operator] = STATE(932),
    [sym_attribute] = STATE(932),
    [sym_subscript] = STATE(932),
    [sym_call] = STATE(932),
    [sym_list] = STATE(932),
    [sym_list_comprehension] = STATE(932),
    [sym_dictionary] = STATE(932),
    [sym_dictionary_comprehension] = STATE(932),
    [sym_set] = STATE(932),
    [sym_set_comprehension] = STATE(932),
    [sym_parenthesized_expression] = STATE(932),
    [sym_tuple] = STATE(932),
    [sym_generator_expression] = STATE(932),
    [sym_concatenated_string] = STATE(932),
    [sym_string] = STATE(153),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1754),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1756),
    [sym_float] = ACTIONS(1756),
    [sym_identifier] = ACTIONS(1756),
    [sym_true] = ACTIONS(1756),
    [sym_false] = ACTIONS(1756),
    [sym_none] = ACTIONS(1756),
    [sym_comment] = ACTIONS(73),
  },
  [475] = {
    [sym__primary_expression] = STATE(927),
    [sym_binary_operator] = STATE(927),
    [sym_unary_operator] = STATE(927),
    [sym_attribute] = STATE(927),
    [sym_subscript] = STATE(927),
    [sym_call] = STATE(927),
    [sym_list] = STATE(927),
    [sym_list_comprehension] = STATE(927),
    [sym_dictionary] = STATE(927),
    [sym_dictionary_comprehension] = STATE(927),
    [sym_set] = STATE(927),
    [sym_set_comprehension] = STATE(927),
    [sym_parenthesized_expression] = STATE(927),
    [sym_tuple] = STATE(927),
    [sym_generator_expression] = STATE(927),
    [sym_concatenated_string] = STATE(927),
    [sym_string] = STATE(153),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1758),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1736),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1738),
    [sym_float] = ACTIONS(1738),
    [sym_identifier] = ACTIONS(1738),
    [sym_true] = ACTIONS(1738),
    [sym_false] = ACTIONS(1738),
    [sym_none] = ACTIONS(1738),
    [sym_comment] = ACTIONS(73),
  },
  [476] = {
    [aux_sym_comparison_operator_repeat1] = STATE(933),
    [anon_sym_COMMA] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(991),
    [anon_sym_async] = ACTIONS(991),
    [anon_sym_for] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(799),
    [anon_sym_not] = ACTIONS(803),
    [anon_sym_and] = ACTIONS(991),
    [anon_sym_or] = ACTIONS(991),
    [anon_sym_LT] = ACTIONS(815),
    [anon_sym_LT_EQ] = ACTIONS(799),
    [anon_sym_EQ_EQ] = ACTIONS(799),
    [anon_sym_BANG_EQ] = ACTIONS(799),
    [anon_sym_GT_EQ] = ACTIONS(799),
    [anon_sym_GT] = ACTIONS(815),
    [anon_sym_LT_GT] = ACTIONS(799),
    [anon_sym_is] = ACTIONS(817),
    [anon_sym_RBRACK] = ACTIONS(991),
    [sym_comment] = ACTIONS(73),
  },
  [477] = {
    [sym_string] = STATE(934),
    [aux_sym_concatenated_string_repeat1] = STATE(934),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_async] = ACTIONS(995),
    [anon_sym_for] = ACTIONS(995),
    [anon_sym_in] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(995),
    [anon_sym_not] = ACTIONS(995),
    [anon_sym_and] = ACTIONS(995),
    [anon_sym_or] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(995),
    [anon_sym_SLASH_SLASH] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_GT] = ACTIONS(995),
    [anon_sym_is] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(995),
    [anon_sym_RBRACK] = ACTIONS(995),
    [sym_comment] = ACTIONS(73),
  },
  [478] = {
    [sym__newline] = ACTIONS(1760),
    [anon_sym_DOT] = ACTIONS(1760),
    [anon_sym_LPAREN] = ACTIONS(1760),
    [anon_sym_COMMA] = ACTIONS(1760),
    [anon_sym_STAR] = ACTIONS(1762),
    [anon_sym_GT_GT] = ACTIONS(1762),
    [anon_sym_if] = ACTIONS(1760),
    [anon_sym_COLON] = ACTIONS(1760),
    [anon_sym_in] = ACTIONS(1760),
    [anon_sym_EQ] = ACTIONS(1762),
    [anon_sym_AT] = ACTIONS(1762),
    [anon_sym_not] = ACTIONS(1760),
    [anon_sym_and] = ACTIONS(1760),
    [anon_sym_or] = ACTIONS(1760),
    [anon_sym_PLUS] = ACTIONS(1762),
    [anon_sym_DASH] = ACTIONS(1762),
    [anon_sym_SLASH] = ACTIONS(1762),
    [anon_sym_PERCENT] = ACTIONS(1762),
    [anon_sym_SLASH_SLASH] = ACTIONS(1762),
    [anon_sym_STAR_STAR] = ACTIONS(1762),
    [anon_sym_PIPE] = ACTIONS(1762),
    [anon_sym_AMP] = ACTIONS(1762),
    [anon_sym_CARET] = ACTIONS(1762),
    [anon_sym_LT_LT] = ACTIONS(1762),
    [anon_sym_LT] = ACTIONS(1762),
    [anon_sym_LT_EQ] = ACTIONS(1760),
    [anon_sym_EQ_EQ] = ACTIONS(1760),
    [anon_sym_BANG_EQ] = ACTIONS(1760),
    [anon_sym_GT_EQ] = ACTIONS(1760),
    [anon_sym_GT] = ACTIONS(1762),
    [anon_sym_LT_GT] = ACTIONS(1760),
    [anon_sym_is] = ACTIONS(1760),
    [anon_sym_PLUS_EQ] = ACTIONS(1760),
    [anon_sym_DASH_EQ] = ACTIONS(1760),
    [anon_sym_STAR_EQ] = ACTIONS(1760),
    [anon_sym_SLASH_EQ] = ACTIONS(1760),
    [anon_sym_AT_EQ] = ACTIONS(1760),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1760),
    [anon_sym_PERCENT_EQ] = ACTIONS(1760),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1760),
    [anon_sym_GT_GT_EQ] = ACTIONS(1760),
    [anon_sym_LT_LT_EQ] = ACTIONS(1760),
    [anon_sym_AMP_EQ] = ACTIONS(1760),
    [anon_sym_CARET_EQ] = ACTIONS(1760),
    [anon_sym_PIPE_EQ] = ACTIONS(1760),
    [anon_sym_LBRACK] = ACTIONS(1760),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1760),
  },
  [479] = {
    [sym__expression] = STATE(935),
    [sym__primary_expression] = STATE(485),
    [sym_not_operator] = STATE(935),
    [sym_boolean_operator] = STATE(935),
    [sym_binary_operator] = STATE(485),
    [sym_unary_operator] = STATE(485),
    [sym_comparison_operator] = STATE(935),
    [sym_lambda] = STATE(935),
    [sym_attribute] = STATE(485),
    [sym_subscript] = STATE(485),
    [sym_call] = STATE(485),
    [sym_list] = STATE(485),
    [sym_list_comprehension] = STATE(485),
    [sym_dictionary] = STATE(485),
    [sym_dictionary_comprehension] = STATE(485),
    [sym_set] = STATE(485),
    [sym_set_comprehension] = STATE(485),
    [sym_parenthesized_expression] = STATE(485),
    [sym_tuple] = STATE(485),
    [sym_generator_expression] = STATE(485),
    [sym_conditional_expression] = STATE(935),
    [sym_concatenated_string] = STATE(485),
    [sym_string] = STATE(486),
    [sym_await] = STATE(935),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(823),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_TILDE] = ACTIONS(825),
    [anon_sym_lambda] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(829),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(831),
    [sym_float] = ACTIONS(831),
    [sym_identifier] = ACTIONS(831),
    [sym_true] = ACTIONS(831),
    [sym_false] = ACTIONS(831),
    [sym_none] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [sym_comment] = ACTIONS(73),
  },
  [480] = {
    [sym__expression] = STATE(936),
    [sym__primary_expression] = STATE(485),
    [sym_not_operator] = STATE(936),
    [sym_boolean_operator] = STATE(936),
    [sym_binary_operator] = STATE(485),
    [sym_unary_operator] = STATE(485),
    [sym_comparison_operator] = STATE(936),
    [sym_lambda] = STATE(936),
    [sym_attribute] = STATE(485),
    [sym_subscript] = STATE(485),
    [sym_call] = STATE(485),
    [sym_list] = STATE(485),
    [sym_list_comprehension] = STATE(485),
    [sym_dictionary] = STATE(485),
    [sym_dictionary_comprehension] = STATE(485),
    [sym_set] = STATE(485),
    [sym_set_comprehension] = STATE(485),
    [sym_parenthesized_expression] = STATE(485),
    [sym_tuple] = STATE(485),
    [sym_generator_expression] = STATE(485),
    [sym_conditional_expression] = STATE(936),
    [sym_concatenated_string] = STATE(485),
    [sym_string] = STATE(486),
    [sym_await] = STATE(936),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(823),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_TILDE] = ACTIONS(825),
    [anon_sym_lambda] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(829),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(831),
    [sym_float] = ACTIONS(831),
    [sym_identifier] = ACTIONS(831),
    [sym_true] = ACTIONS(831),
    [sym_false] = ACTIONS(831),
    [sym_none] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [sym_comment] = ACTIONS(73),
  },
  [481] = {
    [sym__primary_expression] = STATE(227),
    [sym_binary_operator] = STATE(227),
    [sym_unary_operator] = STATE(227),
    [sym_attribute] = STATE(227),
    [sym_subscript] = STATE(227),
    [sym_call] = STATE(227),
    [sym_list] = STATE(227),
    [sym_list_comprehension] = STATE(227),
    [sym_dictionary] = STATE(227),
    [sym_dictionary_comprehension] = STATE(227),
    [sym_set] = STATE(227),
    [sym_set_comprehension] = STATE(227),
    [sym_parenthesized_expression] = STATE(227),
    [sym_tuple] = STATE(227),
    [sym_generator_expression] = STATE(227),
    [sym_concatenated_string] = STATE(227),
    [sym_string] = STATE(486),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_TILDE] = ACTIONS(825),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(403),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(405),
    [sym_float] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_true] = ACTIONS(405),
    [sym_false] = ACTIONS(405),
    [sym_none] = ACTIONS(405),
    [sym_comment] = ACTIONS(73),
  },
  [482] = {
    [sym_lambda_parameters] = STATE(938),
    [sym__parameters] = STATE(138),
    [sym_default_parameter] = STATE(139),
    [sym_typed_default_parameter] = STATE(139),
    [sym_list_splat] = STATE(140),
    [sym_dictionary_splat] = STATE(140),
    [sym_typed_parameter] = STATE(139),
    [sym_tuple] = STATE(139),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(1764),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [483] = {
    [sym__expression] = STATE(249),
    [sym__primary_expression] = STATE(485),
    [sym_not_operator] = STATE(249),
    [sym_boolean_operator] = STATE(249),
    [sym_binary_operator] = STATE(485),
    [sym_unary_operator] = STATE(485),
    [sym_comparison_operator] = STATE(249),
    [sym_lambda] = STATE(249),
    [sym_attribute] = STATE(485),
    [sym_subscript] = STATE(485),
    [sym_call] = STATE(485),
    [sym_list] = STATE(485),
    [sym_list_comprehension] = STATE(485),
    [sym_dictionary] = STATE(485),
    [sym_dictionary_comprehension] = STATE(485),
    [sym_set] = STATE(485),
    [sym_set_comprehension] = STATE(485),
    [sym_parenthesized_expression] = STATE(485),
    [sym_tuple] = STATE(485),
    [sym_generator_expression] = STATE(485),
    [sym_conditional_expression] = STATE(249),
    [sym_concatenated_string] = STATE(485),
    [sym_string] = STATE(486),
    [sym_await] = STATE(249),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(823),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_TILDE] = ACTIONS(825),
    [anon_sym_lambda] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(829),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(831),
    [sym_float] = ACTIONS(831),
    [sym_identifier] = ACTIONS(831),
    [sym_true] = ACTIONS(831),
    [sym_false] = ACTIONS(831),
    [sym_none] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [sym_comment] = ACTIONS(73),
  },
  [484] = {
    [anon_sym_COMMA] = ACTIONS(1608),
    [anon_sym_if] = ACTIONS(1766),
    [anon_sym_and] = ACTIONS(1768),
    [anon_sym_or] = ACTIONS(1770),
    [anon_sym_RBRACE] = ACTIONS(1608),
    [sym_comment] = ACTIONS(73),
  },
  [485] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [aux_sym_comparison_operator_repeat1] = STATE(952),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(1772),
    [anon_sym_GT_GT] = ACTIONS(1774),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(1776),
    [anon_sym_AT] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_SLASH] = ACTIONS(1772),
    [anon_sym_PERCENT] = ACTIONS(1778),
    [anon_sym_SLASH_SLASH] = ACTIONS(1778),
    [anon_sym_STAR_STAR] = ACTIONS(1784),
    [anon_sym_PIPE] = ACTIONS(1786),
    [anon_sym_AMP] = ACTIONS(1788),
    [anon_sym_CARET] = ACTIONS(1790),
    [anon_sym_LT_LT] = ACTIONS(1774),
    [anon_sym_LT] = ACTIONS(1792),
    [anon_sym_LT_EQ] = ACTIONS(1776),
    [anon_sym_EQ_EQ] = ACTIONS(1776),
    [anon_sym_BANG_EQ] = ACTIONS(1776),
    [anon_sym_GT_EQ] = ACTIONS(1776),
    [anon_sym_GT] = ACTIONS(1792),
    [anon_sym_LT_GT] = ACTIONS(1776),
    [anon_sym_is] = ACTIONS(1794),
    [anon_sym_LBRACK] = ACTIONS(473),
    [anon_sym_RBRACE] = ACTIONS(301),
    [sym_comment] = ACTIONS(73),
  },
  [486] = {
    [sym_string] = STATE(953),
    [aux_sym_concatenated_string_repeat1] = STATE(953),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_RBRACE] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [487] = {
    [anon_sym_COMMA] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(723),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_async] = ACTIONS(723),
    [anon_sym_for] = ACTIONS(723),
    [anon_sym_and] = ACTIONS(855),
    [anon_sym_or] = ACTIONS(857),
    [anon_sym_RBRACE] = ACTIONS(723),
    [sym_comment] = ACTIONS(73),
  },
  [488] = {
    [sym__expression] = STATE(954),
    [sym__primary_expression] = STATE(164),
    [sym_not_operator] = STATE(954),
    [sym_boolean_operator] = STATE(954),
    [sym_binary_operator] = STATE(164),
    [sym_unary_operator] = STATE(164),
    [sym_comparison_operator] = STATE(954),
    [sym_lambda] = STATE(954),
    [sym_attribute] = STATE(164),
    [sym_subscript] = STATE(164),
    [sym_call] = STATE(164),
    [sym_list] = STATE(164),
    [sym_list_comprehension] = STATE(164),
    [sym_dictionary] = STATE(164),
    [sym_dictionary_comprehension] = STATE(164),
    [sym_set] = STATE(164),
    [sym_set_comprehension] = STATE(164),
    [sym_parenthesized_expression] = STATE(164),
    [sym_tuple] = STATE(164),
    [sym_generator_expression] = STATE(164),
    [sym_conditional_expression] = STATE(954),
    [sym_concatenated_string] = STATE(164),
    [sym_string] = STATE(166),
    [sym_await] = STATE(954),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_lambda] = ACTIONS(267),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(273),
    [sym_float] = ACTIONS(273),
    [sym_identifier] = ACTIONS(273),
    [sym_true] = ACTIONS(273),
    [sym_false] = ACTIONS(273),
    [sym_none] = ACTIONS(273),
    [anon_sym_await] = ACTIONS(275),
    [sym_comment] = ACTIONS(73),
  },
  [489] = {
    [anon_sym_COLON] = ACTIONS(1796),
    [sym_comment] = ACTIONS(73),
  },
  [490] = {
    [sym_list_splat] = STATE(914),
    [sym__expression] = STATE(958),
    [sym__primary_expression] = STATE(485),
    [sym_not_operator] = STATE(958),
    [sym_boolean_operator] = STATE(958),
    [sym_binary_operator] = STATE(485),
    [sym_unary_operator] = STATE(485),
    [sym_comparison_operator] = STATE(958),
    [sym_lambda] = STATE(958),
    [sym_attribute] = STATE(485),
    [sym_subscript] = STATE(485),
    [sym_call] = STATE(485),
    [sym_list] = STATE(485),
    [sym_list_comprehension] = STATE(485),
    [sym_dictionary] = STATE(485),
    [sym_dictionary_comprehension] = STATE(485),
    [sym_set] = STATE(485),
    [sym_set_comprehension] = STATE(485),
    [sym_parenthesized_expression] = STATE(485),
    [sym_tuple] = STATE(485),
    [sym_generator_expression] = STATE(485),
    [sym_conditional_expression] = STATE(958),
    [sym_concatenated_string] = STATE(485),
    [sym_string] = STATE(486),
    [sym_await] = STATE(958),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(1798),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(823),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_TILDE] = ACTIONS(825),
    [anon_sym_lambda] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(829),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(1800),
    [sym_integer] = ACTIONS(831),
    [sym_float] = ACTIONS(831),
    [sym_identifier] = ACTIONS(831),
    [sym_true] = ACTIONS(831),
    [sym_false] = ACTIONS(831),
    [sym_none] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [sym_comment] = ACTIONS(73),
  },
  [491] = {
    [sym__newline] = ACTIONS(1802),
    [anon_sym_DOT] = ACTIONS(1802),
    [anon_sym_LPAREN] = ACTIONS(1802),
    [anon_sym_COMMA] = ACTIONS(1802),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_GT_GT] = ACTIONS(1804),
    [anon_sym_if] = ACTIONS(1802),
    [anon_sym_COLON] = ACTIONS(1802),
    [anon_sym_in] = ACTIONS(1802),
    [anon_sym_EQ] = ACTIONS(1804),
    [anon_sym_AT] = ACTIONS(1804),
    [anon_sym_not] = ACTIONS(1802),
    [anon_sym_and] = ACTIONS(1802),
    [anon_sym_or] = ACTIONS(1802),
    [anon_sym_PLUS] = ACTIONS(1804),
    [anon_sym_DASH] = ACTIONS(1804),
    [anon_sym_SLASH] = ACTIONS(1804),
    [anon_sym_PERCENT] = ACTIONS(1804),
    [anon_sym_SLASH_SLASH] = ACTIONS(1804),
    [anon_sym_STAR_STAR] = ACTIONS(1804),
    [anon_sym_PIPE] = ACTIONS(1804),
    [anon_sym_AMP] = ACTIONS(1804),
    [anon_sym_CARET] = ACTIONS(1804),
    [anon_sym_LT_LT] = ACTIONS(1804),
    [anon_sym_LT] = ACTIONS(1804),
    [anon_sym_LT_EQ] = ACTIONS(1802),
    [anon_sym_EQ_EQ] = ACTIONS(1802),
    [anon_sym_BANG_EQ] = ACTIONS(1802),
    [anon_sym_GT_EQ] = ACTIONS(1802),
    [anon_sym_GT] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(1802),
    [anon_sym_is] = ACTIONS(1802),
    [anon_sym_PLUS_EQ] = ACTIONS(1802),
    [anon_sym_DASH_EQ] = ACTIONS(1802),
    [anon_sym_STAR_EQ] = ACTIONS(1802),
    [anon_sym_SLASH_EQ] = ACTIONS(1802),
    [anon_sym_AT_EQ] = ACTIONS(1802),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1802),
    [anon_sym_PERCENT_EQ] = ACTIONS(1802),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1802),
    [anon_sym_GT_GT_EQ] = ACTIONS(1802),
    [anon_sym_LT_LT_EQ] = ACTIONS(1802),
    [anon_sym_AMP_EQ] = ACTIONS(1802),
    [anon_sym_CARET_EQ] = ACTIONS(1802),
    [anon_sym_PIPE_EQ] = ACTIONS(1802),
    [anon_sym_LBRACK] = ACTIONS(1802),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1802),
  },
  [492] = {
    [aux_sym_list_repeat1] = STATE(960),
    [anon_sym_COMMA] = ACTIONS(1806),
    [anon_sym_RBRACE] = ACTIONS(1800),
    [sym_comment] = ACTIONS(73),
  },
  [493] = {
    [sym_dictionary_splat] = STATE(963),
    [sym__expression] = STATE(964),
    [sym__primary_expression] = STATE(102),
    [sym_not_operator] = STATE(964),
    [sym_boolean_operator] = STATE(964),
    [sym_binary_operator] = STATE(102),
    [sym_unary_operator] = STATE(102),
    [sym_comparison_operator] = STATE(964),
    [sym_lambda] = STATE(964),
    [sym_attribute] = STATE(102),
    [sym_subscript] = STATE(102),
    [sym_call] = STATE(102),
    [sym_list] = STATE(102),
    [sym_list_comprehension] = STATE(102),
    [sym_dictionary] = STATE(102),
    [sym_dictionary_comprehension] = STATE(102),
    [sym_pair] = STATE(963),
    [sym_set] = STATE(102),
    [sym_set_comprehension] = STATE(102),
    [sym_parenthesized_expression] = STATE(102),
    [sym_tuple] = STATE(102),
    [sym_generator_expression] = STATE(102),
    [sym_conditional_expression] = STATE(964),
    [sym_concatenated_string] = STATE(102),
    [sym_string] = STATE(103),
    [sym_await] = STATE(964),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(1808),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(1810),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [494] = {
    [aux_sym_dictionary_repeat1] = STATE(966),
    [anon_sym_COMMA] = ACTIONS(1812),
    [anon_sym_RBRACE] = ACTIONS(1810),
    [sym_comment] = ACTIONS(73),
  },
  [495] = {
    [sym__expression] = STATE(967),
    [sym__primary_expression] = STATE(538),
    [sym_not_operator] = STATE(967),
    [sym_boolean_operator] = STATE(967),
    [sym_binary_operator] = STATE(538),
    [sym_unary_operator] = STATE(538),
    [sym_comparison_operator] = STATE(967),
    [sym_lambda] = STATE(967),
    [sym_attribute] = STATE(538),
    [sym_subscript] = STATE(538),
    [sym_call] = STATE(538),
    [sym_list] = STATE(538),
    [sym_list_comprehension] = STATE(538),
    [sym_dictionary] = STATE(538),
    [sym_dictionary_comprehension] = STATE(538),
    [sym_set] = STATE(538),
    [sym_set_comprehension] = STATE(538),
    [sym_parenthesized_expression] = STATE(538),
    [sym_tuple] = STATE(538),
    [sym_generator_expression] = STATE(538),
    [sym_conditional_expression] = STATE(967),
    [sym_concatenated_string] = STATE(538),
    [sym_string] = STATE(539),
    [sym_await] = STATE(967),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_lambda] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(917),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(919),
    [sym_float] = ACTIONS(919),
    [sym_identifier] = ACTIONS(919),
    [sym_true] = ACTIONS(919),
    [sym_false] = ACTIONS(919),
    [sym_none] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(921),
    [sym_comment] = ACTIONS(73),
  },
  [496] = {
    [sym__expression] = STATE(972),
    [sym__primary_expression] = STATE(973),
    [sym_not_operator] = STATE(972),
    [sym_boolean_operator] = STATE(972),
    [sym_binary_operator] = STATE(973),
    [sym_unary_operator] = STATE(973),
    [sym_comparison_operator] = STATE(972),
    [sym_lambda] = STATE(972),
    [sym_attribute] = STATE(973),
    [sym_subscript] = STATE(973),
    [sym_call] = STATE(973),
    [sym_list] = STATE(973),
    [sym_list_comprehension] = STATE(973),
    [sym_dictionary] = STATE(973),
    [sym_dictionary_comprehension] = STATE(973),
    [sym_set] = STATE(973),
    [sym_set_comprehension] = STATE(973),
    [sym_parenthesized_expression] = STATE(973),
    [sym_tuple] = STATE(973),
    [sym_generator_expression] = STATE(973),
    [sym_conditional_expression] = STATE(972),
    [sym_concatenated_string] = STATE(973),
    [sym_string] = STATE(974),
    [sym_await] = STATE(972),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1814),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_DASH] = ACTIONS(1816),
    [anon_sym_TILDE] = ACTIONS(1816),
    [anon_sym_lambda] = ACTIONS(1818),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1820),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1822),
    [sym_float] = ACTIONS(1822),
    [sym_identifier] = ACTIONS(1822),
    [sym_true] = ACTIONS(1822),
    [sym_false] = ACTIONS(1822),
    [sym_none] = ACTIONS(1822),
    [anon_sym_await] = ACTIONS(1824),
    [sym_comment] = ACTIONS(73),
  },
  [497] = {
    [anon_sym_for] = ACTIONS(1826),
    [sym_comment] = ACTIONS(73),
  },
  [498] = {
    [sym_variables] = STATE(976),
    [sym__primary_expression] = STATE(109),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(110),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(191),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(193),
    [sym_float] = ACTIONS(193),
    [sym_identifier] = ACTIONS(193),
    [sym_true] = ACTIONS(193),
    [sym_false] = ACTIONS(193),
    [sym_none] = ACTIONS(193),
    [sym_comment] = ACTIONS(73),
  },
  [499] = {
    [sym__expression] = STATE(652),
    [sym__primary_expression] = STATE(164),
    [sym_not_operator] = STATE(652),
    [sym_boolean_operator] = STATE(652),
    [sym_binary_operator] = STATE(164),
    [sym_unary_operator] = STATE(164),
    [sym_comparison_operator] = STATE(652),
    [sym_lambda] = STATE(652),
    [sym_attribute] = STATE(164),
    [sym_subscript] = STATE(164),
    [sym_call] = STATE(164),
    [sym_list] = STATE(164),
    [sym_list_comprehension] = STATE(164),
    [sym_dictionary] = STATE(164),
    [sym_dictionary_comprehension] = STATE(164),
    [sym_set] = STATE(164),
    [sym_set_comprehension] = STATE(164),
    [sym_parenthesized_expression] = STATE(164),
    [sym_tuple] = STATE(164),
    [sym_generator_expression] = STATE(164),
    [sym_conditional_expression] = STATE(652),
    [sym_concatenated_string] = STATE(164),
    [sym_string] = STATE(166),
    [sym_await] = STATE(652),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_lambda] = ACTIONS(267),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(273),
    [sym_float] = ACTIONS(273),
    [sym_identifier] = ACTIONS(273),
    [sym_true] = ACTIONS(273),
    [sym_false] = ACTIONS(273),
    [sym_none] = ACTIONS(273),
    [anon_sym_await] = ACTIONS(275),
    [sym_comment] = ACTIONS(73),
  },
  [500] = {
    [sym__expression] = STATE(977),
    [sym__primary_expression] = STATE(164),
    [sym_not_operator] = STATE(977),
    [sym_boolean_operator] = STATE(977),
    [sym_binary_operator] = STATE(164),
    [sym_unary_operator] = STATE(164),
    [sym_comparison_operator] = STATE(977),
    [sym_lambda] = STATE(977),
    [sym_attribute] = STATE(164),
    [sym_subscript] = STATE(164),
    [sym_call] = STATE(164),
    [sym_list] = STATE(164),
    [sym_list_comprehension] = STATE(164),
    [sym_dictionary] = STATE(164),
    [sym_dictionary_comprehension] = STATE(164),
    [sym_set] = STATE(164),
    [sym_set_comprehension] = STATE(164),
    [sym_parenthesized_expression] = STATE(164),
    [sym_tuple] = STATE(164),
    [sym_generator_expression] = STATE(164),
    [sym_conditional_expression] = STATE(977),
    [sym_concatenated_string] = STATE(164),
    [sym_string] = STATE(166),
    [sym_await] = STATE(977),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_lambda] = ACTIONS(267),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(273),
    [sym_float] = ACTIONS(273),
    [sym_identifier] = ACTIONS(273),
    [sym_true] = ACTIONS(273),
    [sym_false] = ACTIONS(273),
    [sym_none] = ACTIONS(273),
    [anon_sym_await] = ACTIONS(275),
    [sym_comment] = ACTIONS(73),
  },
  [501] = {
    [anon_sym_RBRACE] = ACTIONS(1828),
    [sym_comment] = ACTIONS(73),
  },
  [502] = {
    [sym_for_in_clause] = STATE(980),
    [sym_if_clause] = STATE(980),
    [aux_sym__comprehension_body_repeat1] = STATE(980),
    [anon_sym_if] = ACTIONS(1830),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_RBRACE] = ACTIONS(1252),
    [sym_comment] = ACTIONS(73),
  },
  [503] = {
    [sym__primary_expression] = STATE(981),
    [sym_binary_operator] = STATE(981),
    [sym_unary_operator] = STATE(981),
    [sym_attribute] = STATE(981),
    [sym_subscript] = STATE(981),
    [sym_call] = STATE(981),
    [sym_list] = STATE(981),
    [sym_list_comprehension] = STATE(981),
    [sym_dictionary] = STATE(981),
    [sym_dictionary_comprehension] = STATE(981),
    [sym_set] = STATE(981),
    [sym_set_comprehension] = STATE(981),
    [sym_parenthesized_expression] = STATE(981),
    [sym_tuple] = STATE(981),
    [sym_generator_expression] = STATE(981),
    [sym_concatenated_string] = STATE(981),
    [sym_string] = STATE(166),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1832),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1834),
    [sym_float] = ACTIONS(1834),
    [sym_identifier] = ACTIONS(1834),
    [sym_true] = ACTIONS(1834),
    [sym_false] = ACTIONS(1834),
    [sym_none] = ACTIONS(1834),
    [sym_comment] = ACTIONS(73),
  },
  [504] = {
    [sym__primary_expression] = STATE(982),
    [sym_binary_operator] = STATE(982),
    [sym_unary_operator] = STATE(982),
    [sym_attribute] = STATE(982),
    [sym_subscript] = STATE(982),
    [sym_call] = STATE(982),
    [sym_list] = STATE(982),
    [sym_list_comprehension] = STATE(982),
    [sym_dictionary] = STATE(982),
    [sym_dictionary_comprehension] = STATE(982),
    [sym_set] = STATE(982),
    [sym_set_comprehension] = STATE(982),
    [sym_parenthesized_expression] = STATE(982),
    [sym_tuple] = STATE(982),
    [sym_generator_expression] = STATE(982),
    [sym_concatenated_string] = STATE(982),
    [sym_string] = STATE(166),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1836),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1838),
    [sym_float] = ACTIONS(1838),
    [sym_identifier] = ACTIONS(1838),
    [sym_true] = ACTIONS(1838),
    [sym_false] = ACTIONS(1838),
    [sym_none] = ACTIONS(1838),
    [sym_comment] = ACTIONS(73),
  },
  [505] = {
    [sym__primary_expression] = STATE(983),
    [sym_binary_operator] = STATE(983),
    [sym_unary_operator] = STATE(983),
    [sym_attribute] = STATE(983),
    [sym_subscript] = STATE(983),
    [sym_call] = STATE(983),
    [sym_list] = STATE(983),
    [sym_list_comprehension] = STATE(983),
    [sym_dictionary] = STATE(983),
    [sym_dictionary_comprehension] = STATE(983),
    [sym_set] = STATE(983),
    [sym_set_comprehension] = STATE(983),
    [sym_parenthesized_expression] = STATE(983),
    [sym_tuple] = STATE(983),
    [sym_generator_expression] = STATE(983),
    [sym_concatenated_string] = STATE(983),
    [sym_string] = STATE(166),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1840),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1842),
    [sym_float] = ACTIONS(1842),
    [sym_identifier] = ACTIONS(1842),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [sym_none] = ACTIONS(1842),
    [sym_comment] = ACTIONS(73),
  },
  [506] = {
    [anon_sym_in] = ACTIONS(1844),
    [sym_comment] = ACTIONS(73),
  },
  [507] = {
    [sym__primary_expression] = STATE(985),
    [sym_binary_operator] = STATE(985),
    [sym_unary_operator] = STATE(985),
    [sym_attribute] = STATE(985),
    [sym_subscript] = STATE(985),
    [sym_call] = STATE(985),
    [sym_list] = STATE(985),
    [sym_list_comprehension] = STATE(985),
    [sym_dictionary] = STATE(985),
    [sym_dictionary_comprehension] = STATE(985),
    [sym_set] = STATE(985),
    [sym_set_comprehension] = STATE(985),
    [sym_parenthesized_expression] = STATE(985),
    [sym_tuple] = STATE(985),
    [sym_generator_expression] = STATE(985),
    [sym_concatenated_string] = STATE(985),
    [sym_string] = STATE(166),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1846),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1848),
    [sym_float] = ACTIONS(1848),
    [sym_identifier] = ACTIONS(1848),
    [sym_true] = ACTIONS(1848),
    [sym_false] = ACTIONS(1848),
    [sym_none] = ACTIONS(1848),
    [sym_comment] = ACTIONS(73),
  },
  [508] = {
    [sym__primary_expression] = STATE(669),
    [sym_binary_operator] = STATE(669),
    [sym_unary_operator] = STATE(669),
    [sym_attribute] = STATE(669),
    [sym_subscript] = STATE(669),
    [sym_call] = STATE(669),
    [sym_list] = STATE(669),
    [sym_list_comprehension] = STATE(669),
    [sym_dictionary] = STATE(669),
    [sym_dictionary_comprehension] = STATE(669),
    [sym_set] = STATE(669),
    [sym_set_comprehension] = STATE(669),
    [sym_parenthesized_expression] = STATE(669),
    [sym_tuple] = STATE(669),
    [sym_generator_expression] = STATE(669),
    [sym_concatenated_string] = STATE(669),
    [sym_string] = STATE(166),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1282),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1284),
    [sym_float] = ACTIONS(1284),
    [sym_identifier] = ACTIONS(1284),
    [sym_true] = ACTIONS(1284),
    [sym_false] = ACTIONS(1284),
    [sym_none] = ACTIONS(1284),
    [sym_comment] = ACTIONS(73),
  },
  [509] = {
    [sym__primary_expression] = STATE(986),
    [sym_binary_operator] = STATE(986),
    [sym_unary_operator] = STATE(986),
    [sym_attribute] = STATE(986),
    [sym_subscript] = STATE(986),
    [sym_call] = STATE(986),
    [sym_list] = STATE(986),
    [sym_list_comprehension] = STATE(986),
    [sym_dictionary] = STATE(986),
    [sym_dictionary_comprehension] = STATE(986),
    [sym_set] = STATE(986),
    [sym_set_comprehension] = STATE(986),
    [sym_parenthesized_expression] = STATE(986),
    [sym_tuple] = STATE(986),
    [sym_generator_expression] = STATE(986),
    [sym_concatenated_string] = STATE(986),
    [sym_string] = STATE(166),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1850),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1852),
    [sym_float] = ACTIONS(1852),
    [sym_identifier] = ACTIONS(1852),
    [sym_true] = ACTIONS(1852),
    [sym_false] = ACTIONS(1852),
    [sym_none] = ACTIONS(1852),
    [sym_comment] = ACTIONS(73),
  },
  [510] = {
    [sym__primary_expression] = STATE(987),
    [sym_binary_operator] = STATE(987),
    [sym_unary_operator] = STATE(987),
    [sym_attribute] = STATE(987),
    [sym_subscript] = STATE(987),
    [sym_call] = STATE(987),
    [sym_list] = STATE(987),
    [sym_list_comprehension] = STATE(987),
    [sym_dictionary] = STATE(987),
    [sym_dictionary_comprehension] = STATE(987),
    [sym_set] = STATE(987),
    [sym_set_comprehension] = STATE(987),
    [sym_parenthesized_expression] = STATE(987),
    [sym_tuple] = STATE(987),
    [sym_generator_expression] = STATE(987),
    [sym_concatenated_string] = STATE(987),
    [sym_string] = STATE(166),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1854),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1856),
    [sym_float] = ACTIONS(1856),
    [sym_identifier] = ACTIONS(1856),
    [sym_true] = ACTIONS(1856),
    [sym_false] = ACTIONS(1856),
    [sym_none] = ACTIONS(1856),
    [sym_comment] = ACTIONS(73),
  },
  [511] = {
    [sym__primary_expression] = STATE(988),
    [sym_binary_operator] = STATE(988),
    [sym_unary_operator] = STATE(988),
    [sym_attribute] = STATE(988),
    [sym_subscript] = STATE(988),
    [sym_call] = STATE(988),
    [sym_list] = STATE(988),
    [sym_list_comprehension] = STATE(988),
    [sym_dictionary] = STATE(988),
    [sym_dictionary_comprehension] = STATE(988),
    [sym_set] = STATE(988),
    [sym_set_comprehension] = STATE(988),
    [sym_parenthesized_expression] = STATE(988),
    [sym_tuple] = STATE(988),
    [sym_generator_expression] = STATE(988),
    [sym_concatenated_string] = STATE(988),
    [sym_string] = STATE(166),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1858),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1860),
    [sym_float] = ACTIONS(1860),
    [sym_identifier] = ACTIONS(1860),
    [sym_true] = ACTIONS(1860),
    [sym_false] = ACTIONS(1860),
    [sym_none] = ACTIONS(1860),
    [sym_comment] = ACTIONS(73),
  },
  [512] = {
    [sym__primary_expression] = STATE(983),
    [sym_binary_operator] = STATE(983),
    [sym_unary_operator] = STATE(983),
    [sym_attribute] = STATE(983),
    [sym_subscript] = STATE(983),
    [sym_call] = STATE(983),
    [sym_list] = STATE(983),
    [sym_list_comprehension] = STATE(983),
    [sym_dictionary] = STATE(983),
    [sym_dictionary_comprehension] = STATE(983),
    [sym_set] = STATE(983),
    [sym_set_comprehension] = STATE(983),
    [sym_parenthesized_expression] = STATE(983),
    [sym_tuple] = STATE(983),
    [sym_generator_expression] = STATE(983),
    [sym_concatenated_string] = STATE(983),
    [sym_string] = STATE(166),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1862),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1840),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1842),
    [sym_float] = ACTIONS(1842),
    [sym_identifier] = ACTIONS(1842),
    [sym_true] = ACTIONS(1842),
    [sym_false] = ACTIONS(1842),
    [sym_none] = ACTIONS(1842),
    [sym_comment] = ACTIONS(73),
  },
  [513] = {
    [aux_sym_comparison_operator_repeat1] = STATE(989),
    [anon_sym_COMMA] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(991),
    [anon_sym_COLON] = ACTIONS(991),
    [anon_sym_async] = ACTIONS(991),
    [anon_sym_for] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(863),
    [anon_sym_not] = ACTIONS(867),
    [anon_sym_and] = ACTIONS(991),
    [anon_sym_or] = ACTIONS(991),
    [anon_sym_LT] = ACTIONS(879),
    [anon_sym_LT_EQ] = ACTIONS(863),
    [anon_sym_EQ_EQ] = ACTIONS(863),
    [anon_sym_BANG_EQ] = ACTIONS(863),
    [anon_sym_GT_EQ] = ACTIONS(863),
    [anon_sym_GT] = ACTIONS(879),
    [anon_sym_LT_GT] = ACTIONS(863),
    [anon_sym_is] = ACTIONS(881),
    [anon_sym_RBRACE] = ACTIONS(991),
    [sym_comment] = ACTIONS(73),
  },
  [514] = {
    [anon_sym_RBRACE] = ACTIONS(1864),
    [sym_comment] = ACTIONS(73),
  },
  [515] = {
    [sym_string] = STATE(991),
    [aux_sym_concatenated_string_repeat1] = STATE(991),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_COLON] = ACTIONS(995),
    [anon_sym_async] = ACTIONS(995),
    [anon_sym_for] = ACTIONS(995),
    [anon_sym_in] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(995),
    [anon_sym_not] = ACTIONS(995),
    [anon_sym_and] = ACTIONS(995),
    [anon_sym_or] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(995),
    [anon_sym_SLASH_SLASH] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_GT] = ACTIONS(995),
    [anon_sym_is] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(995),
    [anon_sym_RBRACE] = ACTIONS(995),
    [sym_comment] = ACTIONS(73),
  },
  [516] = {
    [sym__string_start] = ACTIONS(1866),
    [ts_builtin_sym_end] = ACTIONS(1866),
    [anon_sym_import] = ACTIONS(1868),
    [anon_sym_from] = ACTIONS(1868),
    [anon_sym_LPAREN] = ACTIONS(1866),
    [anon_sym_print] = ACTIONS(1868),
    [anon_sym_assert] = ACTIONS(1868),
    [anon_sym_return] = ACTIONS(1868),
    [anon_sym_del] = ACTIONS(1868),
    [anon_sym_raise] = ACTIONS(1868),
    [anon_sym_pass] = ACTIONS(1868),
    [anon_sym_break] = ACTIONS(1868),
    [anon_sym_continue] = ACTIONS(1868),
    [anon_sym_if] = ACTIONS(1868),
    [anon_sym_elif] = ACTIONS(1868),
    [anon_sym_else] = ACTIONS(1868),
    [anon_sym_async] = ACTIONS(1868),
    [anon_sym_for] = ACTIONS(1868),
    [anon_sym_while] = ACTIONS(1868),
    [anon_sym_try] = ACTIONS(1868),
    [anon_sym_except] = ACTIONS(1868),
    [anon_sym_finally] = ACTIONS(1868),
    [anon_sym_with] = ACTIONS(1868),
    [anon_sym_def] = ACTIONS(1868),
    [anon_sym_global] = ACTIONS(1868),
    [anon_sym_nonlocal] = ACTIONS(1868),
    [anon_sym_exec] = ACTIONS(1868),
    [anon_sym_class] = ACTIONS(1868),
    [anon_sym_AT] = ACTIONS(1866),
    [anon_sym_not] = ACTIONS(1868),
    [anon_sym_PLUS] = ACTIONS(1866),
    [anon_sym_DASH] = ACTIONS(1866),
    [anon_sym_TILDE] = ACTIONS(1866),
    [anon_sym_lambda] = ACTIONS(1868),
    [anon_sym_yield] = ACTIONS(1868),
    [anon_sym_LBRACK] = ACTIONS(1866),
    [sym_ellipsis] = ACTIONS(1866),
    [anon_sym_LBRACE] = ACTIONS(1866),
    [sym_integer] = ACTIONS(1868),
    [sym_float] = ACTIONS(1868),
    [sym_identifier] = ACTIONS(1868),
    [sym_true] = ACTIONS(1868),
    [sym_false] = ACTIONS(1868),
    [sym_none] = ACTIONS(1868),
    [anon_sym_await] = ACTIONS(1868),
    [sym_comment] = ACTIONS(73),
  },
  [517] = {
    [sym__newline] = ACTIONS(1870),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1870),
  },
  [518] = {
    [sym_import_statement] = STATE(517),
    [sym_future_import_statement] = STATE(517),
    [sym_import_from_statement] = STATE(517),
    [sym_print_statement] = STATE(517),
    [sym_assert_statement] = STATE(517),
    [sym_expression_statement] = STATE(517),
    [sym_return_statement] = STATE(517),
    [sym_delete_statement] = STATE(517),
    [sym_raise_statement] = STATE(517),
    [sym_pass_statement] = STATE(517),
    [sym_break_statement] = STATE(517),
    [sym_continue_statement] = STATE(517),
    [sym_global_statement] = STATE(517),
    [sym_nonlocal_statement] = STATE(517),
    [sym_exec_statement] = STATE(517),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__newline] = ACTIONS(1872),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [519] = {
    [aux_sym__simple_statements_repeat1] = STATE(519),
    [sym__newline] = ACTIONS(1870),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1874),
  },
  [520] = {
    [sym__expression] = STATE(994),
    [sym__primary_expression] = STATE(525),
    [sym_not_operator] = STATE(994),
    [sym_boolean_operator] = STATE(994),
    [sym_binary_operator] = STATE(525),
    [sym_unary_operator] = STATE(525),
    [sym_comparison_operator] = STATE(994),
    [sym_lambda] = STATE(994),
    [sym_attribute] = STATE(525),
    [sym_subscript] = STATE(525),
    [sym_call] = STATE(525),
    [sym_list] = STATE(525),
    [sym_list_comprehension] = STATE(525),
    [sym_dictionary] = STATE(525),
    [sym_dictionary_comprehension] = STATE(525),
    [sym_set] = STATE(525),
    [sym_set_comprehension] = STATE(525),
    [sym_parenthesized_expression] = STATE(525),
    [sym_tuple] = STATE(525),
    [sym_generator_expression] = STATE(525),
    [sym_conditional_expression] = STATE(994),
    [sym_concatenated_string] = STATE(525),
    [sym_string] = STATE(527),
    [sym_await] = STATE(994),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(893),
    [anon_sym_PLUS] = ACTIONS(895),
    [anon_sym_DASH] = ACTIONS(895),
    [anon_sym_TILDE] = ACTIONS(895),
    [anon_sym_lambda] = ACTIONS(897),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(901),
    [sym_float] = ACTIONS(901),
    [sym_identifier] = ACTIONS(901),
    [sym_true] = ACTIONS(901),
    [sym_false] = ACTIONS(901),
    [sym_none] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(903),
    [sym_comment] = ACTIONS(73),
  },
  [521] = {
    [sym__primary_expression] = STATE(284),
    [sym_binary_operator] = STATE(284),
    [sym_unary_operator] = STATE(284),
    [sym_attribute] = STATE(284),
    [sym_subscript] = STATE(284),
    [sym_call] = STATE(284),
    [sym_list] = STATE(284),
    [sym_list_comprehension] = STATE(284),
    [sym_dictionary] = STATE(284),
    [sym_dictionary_comprehension] = STATE(284),
    [sym_set] = STATE(284),
    [sym_set_comprehension] = STATE(284),
    [sym_parenthesized_expression] = STATE(284),
    [sym_tuple] = STATE(284),
    [sym_generator_expression] = STATE(284),
    [sym_concatenated_string] = STATE(284),
    [sym_string] = STATE(527),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(895),
    [anon_sym_DASH] = ACTIONS(895),
    [anon_sym_TILDE] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(483),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(485),
    [sym_float] = ACTIONS(485),
    [sym_identifier] = ACTIONS(485),
    [sym_true] = ACTIONS(485),
    [sym_false] = ACTIONS(485),
    [sym_none] = ACTIONS(485),
    [sym_comment] = ACTIONS(73),
  },
  [522] = {
    [sym_lambda_parameters] = STATE(996),
    [sym__parameters] = STATE(138),
    [sym_default_parameter] = STATE(139),
    [sym_typed_default_parameter] = STATE(139),
    [sym_list_splat] = STATE(140),
    [sym_dictionary_splat] = STATE(140),
    [sym_typed_parameter] = STATE(139),
    [sym_tuple] = STATE(139),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(1877),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [523] = {
    [sym__expression] = STATE(167),
    [sym__primary_expression] = STATE(525),
    [sym_not_operator] = STATE(167),
    [sym_boolean_operator] = STATE(167),
    [sym_binary_operator] = STATE(525),
    [sym_unary_operator] = STATE(525),
    [sym_comparison_operator] = STATE(167),
    [sym_lambda] = STATE(167),
    [sym_attribute] = STATE(525),
    [sym_subscript] = STATE(525),
    [sym_call] = STATE(525),
    [sym_list] = STATE(525),
    [sym_list_comprehension] = STATE(525),
    [sym_dictionary] = STATE(525),
    [sym_dictionary_comprehension] = STATE(525),
    [sym_set] = STATE(525),
    [sym_set_comprehension] = STATE(525),
    [sym_parenthesized_expression] = STATE(525),
    [sym_tuple] = STATE(525),
    [sym_generator_expression] = STATE(525),
    [sym_conditional_expression] = STATE(167),
    [sym_concatenated_string] = STATE(525),
    [sym_string] = STATE(527),
    [sym_await] = STATE(167),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(893),
    [anon_sym_PLUS] = ACTIONS(895),
    [anon_sym_DASH] = ACTIONS(895),
    [anon_sym_TILDE] = ACTIONS(895),
    [anon_sym_lambda] = ACTIONS(897),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(901),
    [sym_float] = ACTIONS(901),
    [sym_identifier] = ACTIONS(901),
    [sym_true] = ACTIONS(901),
    [sym_false] = ACTIONS(901),
    [sym_none] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(903),
    [sym_comment] = ACTIONS(73),
  },
  [524] = {
    [sym__newline] = ACTIONS(1879),
    [anon_sym_if] = ACTIONS(1881),
    [anon_sym_EQ] = ACTIONS(1879),
    [anon_sym_and] = ACTIONS(1883),
    [anon_sym_or] = ACTIONS(1885),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1879),
  },
  [525] = {
    [sym_argument_list] = STATE(315),
    [sym_generator_expression] = STATE(315),
    [aux_sym_comparison_operator_repeat1] = STATE(1010),
    [sym__newline] = ACTIONS(301),
    [anon_sym_DOT] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_STAR] = ACTIONS(1887),
    [anon_sym_GT_GT] = ACTIONS(1889),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(1891),
    [anon_sym_EQ] = ACTIONS(313),
    [anon_sym_AT] = ACTIONS(1893),
    [anon_sym_not] = ACTIONS(1895),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(1887),
    [anon_sym_PERCENT] = ACTIONS(1893),
    [anon_sym_SLASH_SLASH] = ACTIONS(1893),
    [anon_sym_STAR_STAR] = ACTIONS(1899),
    [anon_sym_PIPE] = ACTIONS(1901),
    [anon_sym_AMP] = ACTIONS(1903),
    [anon_sym_CARET] = ACTIONS(1905),
    [anon_sym_LT_LT] = ACTIONS(1889),
    [anon_sym_LT] = ACTIONS(1907),
    [anon_sym_LT_EQ] = ACTIONS(1891),
    [anon_sym_EQ_EQ] = ACTIONS(1891),
    [anon_sym_BANG_EQ] = ACTIONS(1891),
    [anon_sym_GT_EQ] = ACTIONS(1891),
    [anon_sym_GT] = ACTIONS(1907),
    [anon_sym_LT_GT] = ACTIONS(1891),
    [anon_sym_is] = ACTIONS(1909),
    [anon_sym_LBRACK] = ACTIONS(535),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(301),
  },
  [526] = {
    [sym__newline] = ACTIONS(1911),
    [anon_sym_EQ] = ACTIONS(1913),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1911),
  },
  [527] = {
    [sym_string] = STATE(1012),
    [aux_sym_concatenated_string_repeat1] = STATE(1012),
    [sym__newline] = ACTIONS(333),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_EQ] = ACTIONS(335),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(333),
  },
  [528] = {
    [sym__newline] = ACTIONS(1915),
    [anon_sym_COLON] = ACTIONS(283),
    [anon_sym_EQ] = ACTIONS(285),
    [anon_sym_PLUS_EQ] = ACTIONS(287),
    [anon_sym_DASH_EQ] = ACTIONS(287),
    [anon_sym_STAR_EQ] = ACTIONS(287),
    [anon_sym_SLASH_EQ] = ACTIONS(287),
    [anon_sym_AT_EQ] = ACTIONS(287),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(287),
    [anon_sym_PERCENT_EQ] = ACTIONS(287),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(287),
    [anon_sym_GT_GT_EQ] = ACTIONS(287),
    [anon_sym_LT_LT_EQ] = ACTIONS(287),
    [anon_sym_AMP_EQ] = ACTIONS(287),
    [anon_sym_CARET_EQ] = ACTIONS(287),
    [anon_sym_PIPE_EQ] = ACTIONS(287),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1915),
  },
  [529] = {
    [aux_sym_print_statement_repeat1] = STATE(1014),
    [sym__newline] = ACTIONS(295),
    [anon_sym_COMMA] = ACTIONS(1917),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_COLON] = ACTIONS(295),
    [anon_sym_EQ] = ACTIONS(295),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(299),
    [anon_sym_PLUS_EQ] = ACTIONS(295),
    [anon_sym_DASH_EQ] = ACTIONS(295),
    [anon_sym_STAR_EQ] = ACTIONS(295),
    [anon_sym_SLASH_EQ] = ACTIONS(295),
    [anon_sym_AT_EQ] = ACTIONS(295),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(295),
    [anon_sym_PERCENT_EQ] = ACTIONS(295),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(295),
    [anon_sym_GT_GT_EQ] = ACTIONS(295),
    [anon_sym_LT_LT_EQ] = ACTIONS(295),
    [anon_sym_AMP_EQ] = ACTIONS(295),
    [anon_sym_CARET_EQ] = ACTIONS(295),
    [anon_sym_PIPE_EQ] = ACTIONS(295),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(295),
  },
  [530] = {
    [sym__newline] = ACTIONS(1911),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1911),
  },
  [531] = {
    [sym__newline] = ACTIONS(1919),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1919),
  },
  [532] = {
    [sym__newline] = ACTIONS(1921),
    [anon_sym_COMMA] = ACTIONS(1921),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_COLON] = ACTIONS(1921),
    [anon_sym_EQ] = ACTIONS(1921),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(299),
    [anon_sym_PLUS_EQ] = ACTIONS(1921),
    [anon_sym_DASH_EQ] = ACTIONS(1921),
    [anon_sym_STAR_EQ] = ACTIONS(1921),
    [anon_sym_SLASH_EQ] = ACTIONS(1921),
    [anon_sym_AT_EQ] = ACTIONS(1921),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1921),
    [anon_sym_PERCENT_EQ] = ACTIONS(1921),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1921),
    [anon_sym_GT_GT_EQ] = ACTIONS(1921),
    [anon_sym_LT_LT_EQ] = ACTIONS(1921),
    [anon_sym_AMP_EQ] = ACTIONS(1921),
    [anon_sym_CARET_EQ] = ACTIONS(1921),
    [anon_sym_PIPE_EQ] = ACTIONS(1921),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1921),
  },
  [533] = {
    [sym__expression] = STATE(1015),
    [sym__primary_expression] = STATE(538),
    [sym_not_operator] = STATE(1015),
    [sym_boolean_operator] = STATE(1015),
    [sym_binary_operator] = STATE(538),
    [sym_unary_operator] = STATE(538),
    [sym_comparison_operator] = STATE(1015),
    [sym_lambda] = STATE(1015),
    [sym_attribute] = STATE(538),
    [sym_subscript] = STATE(538),
    [sym_call] = STATE(538),
    [sym_list] = STATE(538),
    [sym_list_comprehension] = STATE(538),
    [sym_dictionary] = STATE(538),
    [sym_dictionary_comprehension] = STATE(538),
    [sym_set] = STATE(538),
    [sym_set_comprehension] = STATE(538),
    [sym_parenthesized_expression] = STATE(538),
    [sym_tuple] = STATE(538),
    [sym_generator_expression] = STATE(538),
    [sym_conditional_expression] = STATE(1015),
    [sym_concatenated_string] = STATE(538),
    [sym_string] = STATE(539),
    [sym_await] = STATE(1015),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_lambda] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(917),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(919),
    [sym_float] = ACTIONS(919),
    [sym_identifier] = ACTIONS(919),
    [sym_true] = ACTIONS(919),
    [sym_false] = ACTIONS(919),
    [sym_none] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(921),
    [sym_comment] = ACTIONS(73),
  },
  [534] = {
    [sym__primary_expression] = STATE(227),
    [sym_binary_operator] = STATE(227),
    [sym_unary_operator] = STATE(227),
    [sym_attribute] = STATE(227),
    [sym_subscript] = STATE(227),
    [sym_call] = STATE(227),
    [sym_list] = STATE(227),
    [sym_list_comprehension] = STATE(227),
    [sym_dictionary] = STATE(227),
    [sym_dictionary_comprehension] = STATE(227),
    [sym_set] = STATE(227),
    [sym_set_comprehension] = STATE(227),
    [sym_parenthesized_expression] = STATE(227),
    [sym_tuple] = STATE(227),
    [sym_generator_expression] = STATE(227),
    [sym_concatenated_string] = STATE(227),
    [sym_string] = STATE(539),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(403),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(405),
    [sym_float] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_true] = ACTIONS(405),
    [sym_false] = ACTIONS(405),
    [sym_none] = ACTIONS(405),
    [sym_comment] = ACTIONS(73),
  },
  [535] = {
    [sym_lambda_parameters] = STATE(1017),
    [sym__parameters] = STATE(138),
    [sym_default_parameter] = STATE(139),
    [sym_typed_default_parameter] = STATE(139),
    [sym_list_splat] = STATE(140),
    [sym_dictionary_splat] = STATE(140),
    [sym_typed_parameter] = STATE(139),
    [sym_tuple] = STATE(139),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(1923),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [536] = {
    [sym__expression] = STATE(249),
    [sym__primary_expression] = STATE(538),
    [sym_not_operator] = STATE(249),
    [sym_boolean_operator] = STATE(249),
    [sym_binary_operator] = STATE(538),
    [sym_unary_operator] = STATE(538),
    [sym_comparison_operator] = STATE(249),
    [sym_lambda] = STATE(249),
    [sym_attribute] = STATE(538),
    [sym_subscript] = STATE(538),
    [sym_call] = STATE(538),
    [sym_list] = STATE(538),
    [sym_list_comprehension] = STATE(538),
    [sym_dictionary] = STATE(538),
    [sym_dictionary_comprehension] = STATE(538),
    [sym_set] = STATE(538),
    [sym_set_comprehension] = STATE(538),
    [sym_parenthesized_expression] = STATE(538),
    [sym_tuple] = STATE(538),
    [sym_generator_expression] = STATE(538),
    [sym_conditional_expression] = STATE(249),
    [sym_concatenated_string] = STATE(538),
    [sym_string] = STATE(539),
    [sym_await] = STATE(249),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_lambda] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(917),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(919),
    [sym_float] = ACTIONS(919),
    [sym_identifier] = ACTIONS(919),
    [sym_true] = ACTIONS(919),
    [sym_false] = ACTIONS(919),
    [sym_none] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(921),
    [sym_comment] = ACTIONS(73),
  },
  [537] = {
    [anon_sym_if] = ACTIONS(1925),
    [anon_sym_else] = ACTIONS(1927),
    [anon_sym_and] = ACTIONS(1929),
    [anon_sym_or] = ACTIONS(1931),
    [sym_comment] = ACTIONS(73),
  },
  [538] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [aux_sym_comparison_operator_repeat1] = STATE(1032),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(1933),
    [anon_sym_GT_GT] = ACTIONS(1935),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_else] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(1937),
    [anon_sym_AT] = ACTIONS(1939),
    [anon_sym_not] = ACTIONS(1941),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1943),
    [anon_sym_SLASH] = ACTIONS(1933),
    [anon_sym_PERCENT] = ACTIONS(1939),
    [anon_sym_SLASH_SLASH] = ACTIONS(1939),
    [anon_sym_STAR_STAR] = ACTIONS(1945),
    [anon_sym_PIPE] = ACTIONS(1947),
    [anon_sym_AMP] = ACTIONS(1949),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_LT_LT] = ACTIONS(1935),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_LT_EQ] = ACTIONS(1937),
    [anon_sym_EQ_EQ] = ACTIONS(1937),
    [anon_sym_BANG_EQ] = ACTIONS(1937),
    [anon_sym_GT_EQ] = ACTIONS(1937),
    [anon_sym_GT] = ACTIONS(1953),
    [anon_sym_LT_GT] = ACTIONS(1937),
    [anon_sym_is] = ACTIONS(1955),
    [anon_sym_LBRACK] = ACTIONS(473),
    [sym_comment] = ACTIONS(73),
  },
  [539] = {
    [sym_string] = STATE(1033),
    [aux_sym_concatenated_string_repeat1] = STATE(1033),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_else] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [540] = {
    [sym__newline] = ACTIONS(1957),
    [anon_sym_from] = ACTIONS(1957),
    [anon_sym_COMMA] = ACTIONS(1957),
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_COLON] = ACTIONS(1957),
    [anon_sym_EQ] = ACTIONS(1957),
    [anon_sym_and] = ACTIONS(1957),
    [anon_sym_or] = ACTIONS(1957),
    [anon_sym_PLUS_EQ] = ACTIONS(1957),
    [anon_sym_DASH_EQ] = ACTIONS(1957),
    [anon_sym_STAR_EQ] = ACTIONS(1957),
    [anon_sym_SLASH_EQ] = ACTIONS(1957),
    [anon_sym_AT_EQ] = ACTIONS(1957),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1957),
    [anon_sym_PERCENT_EQ] = ACTIONS(1957),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1957),
    [anon_sym_GT_GT_EQ] = ACTIONS(1957),
    [anon_sym_LT_LT_EQ] = ACTIONS(1957),
    [anon_sym_AMP_EQ] = ACTIONS(1957),
    [anon_sym_CARET_EQ] = ACTIONS(1957),
    [anon_sym_PIPE_EQ] = ACTIONS(1957),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1957),
  },
  [541] = {
    [sym__newline] = ACTIONS(1957),
    [anon_sym_COMMA] = ACTIONS(1957),
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_COLON] = ACTIONS(1957),
    [anon_sym_EQ] = ACTIONS(1957),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(1957),
    [anon_sym_PLUS_EQ] = ACTIONS(1957),
    [anon_sym_DASH_EQ] = ACTIONS(1957),
    [anon_sym_STAR_EQ] = ACTIONS(1957),
    [anon_sym_SLASH_EQ] = ACTIONS(1957),
    [anon_sym_AT_EQ] = ACTIONS(1957),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1957),
    [anon_sym_PERCENT_EQ] = ACTIONS(1957),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1957),
    [anon_sym_GT_GT_EQ] = ACTIONS(1957),
    [anon_sym_LT_LT_EQ] = ACTIONS(1957),
    [anon_sym_AMP_EQ] = ACTIONS(1957),
    [anon_sym_CARET_EQ] = ACTIONS(1957),
    [anon_sym_PIPE_EQ] = ACTIONS(1957),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1957),
  },
  [542] = {
    [sym__expression] = STATE(532),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(532),
    [sym_boolean_operator] = STATE(532),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(532),
    [sym_lambda] = STATE(532),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(532),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(532),
    [sym__newline] = ACTIONS(1959),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_COLON] = ACTIONS(1961),
    [anon_sym_EQ] = ACTIONS(1961),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_PLUS_EQ] = ACTIONS(1961),
    [anon_sym_DASH_EQ] = ACTIONS(1961),
    [anon_sym_STAR_EQ] = ACTIONS(1961),
    [anon_sym_SLASH_EQ] = ACTIONS(1961),
    [anon_sym_AT_EQ] = ACTIONS(1961),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1961),
    [anon_sym_PERCENT_EQ] = ACTIONS(1961),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1961),
    [anon_sym_GT_GT_EQ] = ACTIONS(1961),
    [anon_sym_LT_LT_EQ] = ACTIONS(1961),
    [anon_sym_AMP_EQ] = ACTIONS(1961),
    [anon_sym_CARET_EQ] = ACTIONS(1961),
    [anon_sym_PIPE_EQ] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1959),
  },
  [543] = {
    [aux_sym_print_statement_repeat1] = STATE(543),
    [sym__newline] = ACTIONS(1921),
    [anon_sym_COMMA] = ACTIONS(1963),
    [anon_sym_COLON] = ACTIONS(1921),
    [anon_sym_EQ] = ACTIONS(1921),
    [anon_sym_PLUS_EQ] = ACTIONS(1921),
    [anon_sym_DASH_EQ] = ACTIONS(1921),
    [anon_sym_STAR_EQ] = ACTIONS(1921),
    [anon_sym_SLASH_EQ] = ACTIONS(1921),
    [anon_sym_AT_EQ] = ACTIONS(1921),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1921),
    [anon_sym_PERCENT_EQ] = ACTIONS(1921),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1921),
    [anon_sym_GT_GT_EQ] = ACTIONS(1921),
    [anon_sym_LT_LT_EQ] = ACTIONS(1921),
    [anon_sym_AMP_EQ] = ACTIONS(1921),
    [anon_sym_CARET_EQ] = ACTIONS(1921),
    [anon_sym_PIPE_EQ] = ACTIONS(1921),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1921),
  },
  [544] = {
    [sym__newline] = ACTIONS(1966),
    [anon_sym_DOT] = ACTIONS(1966),
    [anon_sym_LPAREN] = ACTIONS(1966),
    [anon_sym_COMMA] = ACTIONS(1966),
    [anon_sym_STAR] = ACTIONS(1968),
    [anon_sym_GT_GT] = ACTIONS(1968),
    [anon_sym_if] = ACTIONS(1966),
    [anon_sym_COLON] = ACTIONS(1966),
    [anon_sym_in] = ACTIONS(1966),
    [anon_sym_EQ] = ACTIONS(1968),
    [anon_sym_AT] = ACTIONS(1968),
    [anon_sym_not] = ACTIONS(1966),
    [anon_sym_and] = ACTIONS(1966),
    [anon_sym_or] = ACTIONS(1966),
    [anon_sym_PLUS] = ACTIONS(1968),
    [anon_sym_DASH] = ACTIONS(1968),
    [anon_sym_SLASH] = ACTIONS(1968),
    [anon_sym_PERCENT] = ACTIONS(1968),
    [anon_sym_SLASH_SLASH] = ACTIONS(1968),
    [anon_sym_STAR_STAR] = ACTIONS(1968),
    [anon_sym_PIPE] = ACTIONS(1968),
    [anon_sym_AMP] = ACTIONS(1968),
    [anon_sym_CARET] = ACTIONS(1968),
    [anon_sym_LT_LT] = ACTIONS(1968),
    [anon_sym_LT] = ACTIONS(1968),
    [anon_sym_LT_EQ] = ACTIONS(1966),
    [anon_sym_EQ_EQ] = ACTIONS(1966),
    [anon_sym_BANG_EQ] = ACTIONS(1966),
    [anon_sym_GT_EQ] = ACTIONS(1966),
    [anon_sym_GT] = ACTIONS(1968),
    [anon_sym_LT_GT] = ACTIONS(1966),
    [anon_sym_is] = ACTIONS(1966),
    [anon_sym_PLUS_EQ] = ACTIONS(1966),
    [anon_sym_DASH_EQ] = ACTIONS(1966),
    [anon_sym_STAR_EQ] = ACTIONS(1966),
    [anon_sym_SLASH_EQ] = ACTIONS(1966),
    [anon_sym_AT_EQ] = ACTIONS(1966),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1966),
    [anon_sym_PERCENT_EQ] = ACTIONS(1966),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1966),
    [anon_sym_GT_GT_EQ] = ACTIONS(1966),
    [anon_sym_LT_LT_EQ] = ACTIONS(1966),
    [anon_sym_AMP_EQ] = ACTIONS(1966),
    [anon_sym_CARET_EQ] = ACTIONS(1966),
    [anon_sym_PIPE_EQ] = ACTIONS(1966),
    [anon_sym_LBRACK] = ACTIONS(1966),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1966),
  },
  [545] = {
    [sym__newline] = ACTIONS(1970),
    [anon_sym_DOT] = ACTIONS(1970),
    [anon_sym_LPAREN] = ACTIONS(1970),
    [anon_sym_COMMA] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(1972),
    [anon_sym_GT_GT] = ACTIONS(1972),
    [anon_sym_if] = ACTIONS(1970),
    [anon_sym_COLON] = ACTIONS(1970),
    [anon_sym_in] = ACTIONS(1970),
    [anon_sym_EQ] = ACTIONS(1972),
    [anon_sym_AT] = ACTIONS(1972),
    [anon_sym_not] = ACTIONS(1970),
    [anon_sym_and] = ACTIONS(1970),
    [anon_sym_or] = ACTIONS(1970),
    [anon_sym_PLUS] = ACTIONS(1972),
    [anon_sym_DASH] = ACTIONS(1972),
    [anon_sym_SLASH] = ACTIONS(1972),
    [anon_sym_PERCENT] = ACTIONS(1972),
    [anon_sym_SLASH_SLASH] = ACTIONS(1972),
    [anon_sym_STAR_STAR] = ACTIONS(1972),
    [anon_sym_PIPE] = ACTIONS(1972),
    [anon_sym_AMP] = ACTIONS(1972),
    [anon_sym_CARET] = ACTIONS(1972),
    [anon_sym_LT_LT] = ACTIONS(1972),
    [anon_sym_LT] = ACTIONS(1972),
    [anon_sym_LT_EQ] = ACTIONS(1970),
    [anon_sym_EQ_EQ] = ACTIONS(1970),
    [anon_sym_BANG_EQ] = ACTIONS(1970),
    [anon_sym_GT_EQ] = ACTIONS(1970),
    [anon_sym_GT] = ACTIONS(1972),
    [anon_sym_LT_GT] = ACTIONS(1970),
    [anon_sym_is] = ACTIONS(1970),
    [anon_sym_PLUS_EQ] = ACTIONS(1970),
    [anon_sym_DASH_EQ] = ACTIONS(1970),
    [anon_sym_STAR_EQ] = ACTIONS(1970),
    [anon_sym_SLASH_EQ] = ACTIONS(1970),
    [anon_sym_AT_EQ] = ACTIONS(1970),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1970),
    [anon_sym_PERCENT_EQ] = ACTIONS(1970),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1970),
    [anon_sym_GT_GT_EQ] = ACTIONS(1970),
    [anon_sym_LT_LT_EQ] = ACTIONS(1970),
    [anon_sym_AMP_EQ] = ACTIONS(1970),
    [anon_sym_CARET_EQ] = ACTIONS(1970),
    [anon_sym_PIPE_EQ] = ACTIONS(1970),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1970),
  },
  [546] = {
    [anon_sym_RPAREN] = ACTIONS(1974),
    [sym_comment] = ACTIONS(73),
  },
  [547] = {
    [sym__expression] = STATE(1037),
    [sym__primary_expression] = STATE(237),
    [sym_not_operator] = STATE(1037),
    [sym_boolean_operator] = STATE(1037),
    [sym_binary_operator] = STATE(237),
    [sym_unary_operator] = STATE(237),
    [sym_comparison_operator] = STATE(1037),
    [sym_lambda] = STATE(1037),
    [sym_attribute] = STATE(237),
    [sym_subscript] = STATE(237),
    [sym_call] = STATE(237),
    [sym_list] = STATE(237),
    [sym_list_comprehension] = STATE(237),
    [sym_dictionary] = STATE(237),
    [sym_dictionary_comprehension] = STATE(237),
    [sym_set] = STATE(237),
    [sym_set_comprehension] = STATE(237),
    [sym_parenthesized_expression] = STATE(237),
    [sym_tuple] = STATE(237),
    [sym_generator_expression] = STATE(237),
    [sym_conditional_expression] = STATE(1037),
    [sym_concatenated_string] = STATE(237),
    [sym_string] = STATE(238),
    [sym_await] = STATE(1037),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(729),
    [anon_sym_COMMA] = ACTIONS(729),
    [anon_sym_STAR] = ACTIONS(1976),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_lambda] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(419),
    [sym_float] = ACTIONS(419),
    [sym_identifier] = ACTIONS(419),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_none] = ACTIONS(419),
    [anon_sym_await] = ACTIONS(421),
    [sym_comment] = ACTIONS(73),
  },
  [548] = {
    [anon_sym_DOT] = ACTIONS(119),
    [anon_sym_LPAREN] = ACTIONS(119),
    [anon_sym_RPAREN] = ACTIONS(119),
    [anon_sym_COMMA] = ACTIONS(119),
    [anon_sym_STAR] = ACTIONS(123),
    [anon_sym_GT_GT] = ACTIONS(119),
    [anon_sym_if] = ACTIONS(119),
    [anon_sym_async] = ACTIONS(119),
    [anon_sym_for] = ACTIONS(119),
    [anon_sym_in] = ACTIONS(119),
    [anon_sym_EQ] = ACTIONS(1978),
    [anon_sym_AT] = ACTIONS(119),
    [anon_sym_not] = ACTIONS(119),
    [anon_sym_and] = ACTIONS(119),
    [anon_sym_or] = ACTIONS(119),
    [anon_sym_PLUS] = ACTIONS(119),
    [anon_sym_DASH] = ACTIONS(119),
    [anon_sym_SLASH] = ACTIONS(123),
    [anon_sym_PERCENT] = ACTIONS(119),
    [anon_sym_SLASH_SLASH] = ACTIONS(119),
    [anon_sym_STAR_STAR] = ACTIONS(119),
    [anon_sym_PIPE] = ACTIONS(119),
    [anon_sym_AMP] = ACTIONS(119),
    [anon_sym_CARET] = ACTIONS(119),
    [anon_sym_LT_LT] = ACTIONS(119),
    [anon_sym_LT] = ACTIONS(123),
    [anon_sym_LT_EQ] = ACTIONS(119),
    [anon_sym_EQ_EQ] = ACTIONS(119),
    [anon_sym_BANG_EQ] = ACTIONS(119),
    [anon_sym_GT_EQ] = ACTIONS(119),
    [anon_sym_GT] = ACTIONS(123),
    [anon_sym_LT_GT] = ACTIONS(119),
    [anon_sym_is] = ACTIONS(119),
    [anon_sym_LBRACK] = ACTIONS(119),
    [sym_comment] = ACTIONS(73),
  },
  [549] = {
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_RPAREN] = ACTIONS(333),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_async] = ACTIONS(333),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_EQ] = ACTIONS(1980),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [550] = {
    [aux_sym_argument_list_repeat1] = STATE(1041),
    [anon_sym_RPAREN] = ACTIONS(1974),
    [anon_sym_COMMA] = ACTIONS(1982),
    [sym_comment] = ACTIONS(73),
  },
  [551] = {
    [sym__comprehension_body] = STATE(257),
    [sym_for_in_clause] = STATE(258),
    [aux_sym_argument_list_repeat1] = STATE(1041),
    [anon_sym_RPAREN] = ACTIONS(1974),
    [anon_sym_COMMA] = ACTIONS(1982),
    [anon_sym_if] = ACTIONS(435),
    [anon_sym_async] = ACTIONS(437),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_and] = ACTIONS(441),
    [anon_sym_or] = ACTIONS(443),
    [sym_comment] = ACTIONS(73),
  },
  [552] = {
    [sym_argument_list] = STATE(192),
    [sym_generator_expression] = STATE(192),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_GT_GT] = ACTIONS(1986),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(1986),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1986),
    [anon_sym_DASH] = ACTIONS(1986),
    [anon_sym_SLASH] = ACTIONS(1986),
    [anon_sym_PERCENT] = ACTIONS(1986),
    [anon_sym_SLASH_SLASH] = ACTIONS(1986),
    [anon_sym_STAR_STAR] = ACTIONS(319),
    [anon_sym_PIPE] = ACTIONS(1986),
    [anon_sym_AMP] = ACTIONS(1986),
    [anon_sym_CARET] = ACTIONS(1986),
    [anon_sym_LT_LT] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_PLUS_EQ] = ACTIONS(1984),
    [anon_sym_DASH_EQ] = ACTIONS(1984),
    [anon_sym_STAR_EQ] = ACTIONS(1984),
    [anon_sym_SLASH_EQ] = ACTIONS(1984),
    [anon_sym_AT_EQ] = ACTIONS(1984),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1984),
    [anon_sym_PERCENT_EQ] = ACTIONS(1984),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1984),
    [anon_sym_GT_GT_EQ] = ACTIONS(1984),
    [anon_sym_LT_LT_EQ] = ACTIONS(1984),
    [anon_sym_AMP_EQ] = ACTIONS(1984),
    [anon_sym_CARET_EQ] = ACTIONS(1984),
    [anon_sym_PIPE_EQ] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1984),
  },
  [553] = {
    [sym_argument_list] = STATE(192),
    [sym_generator_expression] = STATE(192),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(307),
    [anon_sym_GT_GT] = ACTIONS(1986),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(307),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(317),
    [anon_sym_SLASH] = ACTIONS(307),
    [anon_sym_PERCENT] = ACTIONS(307),
    [anon_sym_SLASH_SLASH] = ACTIONS(307),
    [anon_sym_STAR_STAR] = ACTIONS(319),
    [anon_sym_PIPE] = ACTIONS(1986),
    [anon_sym_AMP] = ACTIONS(1986),
    [anon_sym_CARET] = ACTIONS(1986),
    [anon_sym_LT_LT] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_PLUS_EQ] = ACTIONS(1984),
    [anon_sym_DASH_EQ] = ACTIONS(1984),
    [anon_sym_STAR_EQ] = ACTIONS(1984),
    [anon_sym_SLASH_EQ] = ACTIONS(1984),
    [anon_sym_AT_EQ] = ACTIONS(1984),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1984),
    [anon_sym_PERCENT_EQ] = ACTIONS(1984),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1984),
    [anon_sym_GT_GT_EQ] = ACTIONS(1984),
    [anon_sym_LT_LT_EQ] = ACTIONS(1984),
    [anon_sym_AMP_EQ] = ACTIONS(1984),
    [anon_sym_CARET_EQ] = ACTIONS(1984),
    [anon_sym_PIPE_EQ] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1984),
  },
  [554] = {
    [sym_argument_list] = STATE(192),
    [sym_generator_expression] = STATE(192),
    [sym__newline] = ACTIONS(1988),
    [anon_sym_DOT] = ACTIONS(303),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_COMMA] = ACTIONS(1988),
    [anon_sym_STAR] = ACTIONS(307),
    [anon_sym_GT_GT] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_COLON] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(1988),
    [anon_sym_EQ] = ACTIONS(1990),
    [anon_sym_AT] = ACTIONS(307),
    [anon_sym_not] = ACTIONS(1988),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_PLUS] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(317),
    [anon_sym_SLASH] = ACTIONS(307),
    [anon_sym_PERCENT] = ACTIONS(307),
    [anon_sym_SLASH_SLASH] = ACTIONS(307),
    [anon_sym_STAR_STAR] = ACTIONS(319),
    [anon_sym_PIPE] = ACTIONS(321),
    [anon_sym_AMP] = ACTIONS(323),
    [anon_sym_CARET] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(1990),
    [anon_sym_LT_EQ] = ACTIONS(1988),
    [anon_sym_EQ_EQ] = ACTIONS(1988),
    [anon_sym_BANG_EQ] = ACTIONS(1988),
    [anon_sym_GT_EQ] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1990),
    [anon_sym_LT_GT] = ACTIONS(1988),
    [anon_sym_is] = ACTIONS(1988),
    [anon_sym_PLUS_EQ] = ACTIONS(1988),
    [anon_sym_DASH_EQ] = ACTIONS(1988),
    [anon_sym_STAR_EQ] = ACTIONS(1988),
    [anon_sym_SLASH_EQ] = ACTIONS(1988),
    [anon_sym_AT_EQ] = ACTIONS(1988),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1988),
    [anon_sym_PERCENT_EQ] = ACTIONS(1988),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1988),
    [anon_sym_GT_GT_EQ] = ACTIONS(1988),
    [anon_sym_LT_LT_EQ] = ACTIONS(1988),
    [anon_sym_AMP_EQ] = ACTIONS(1988),
    [anon_sym_CARET_EQ] = ACTIONS(1988),
    [anon_sym_PIPE_EQ] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(331),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1988),
  },
  [555] = {
    [sym__primary_expression] = STATE(1042),
    [sym_binary_operator] = STATE(1042),
    [sym_unary_operator] = STATE(1042),
    [sym_attribute] = STATE(1042),
    [sym_subscript] = STATE(1042),
    [sym_call] = STATE(1042),
    [sym_list] = STATE(1042),
    [sym_list_comprehension] = STATE(1042),
    [sym_dictionary] = STATE(1042),
    [sym_dictionary_comprehension] = STATE(1042),
    [sym_set] = STATE(1042),
    [sym_set_comprehension] = STATE(1042),
    [sym_parenthesized_expression] = STATE(1042),
    [sym_tuple] = STATE(1042),
    [sym_generator_expression] = STATE(1042),
    [sym_concatenated_string] = STATE(1042),
    [sym_string] = STATE(39),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(1992),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(1994),
    [sym_float] = ACTIONS(1994),
    [sym_identifier] = ACTIONS(1994),
    [sym_true] = ACTIONS(1994),
    [sym_false] = ACTIONS(1994),
    [sym_none] = ACTIONS(1994),
    [sym_comment] = ACTIONS(73),
  },
  [556] = {
    [sym_argument_list] = STATE(192),
    [sym_generator_expression] = STATE(192),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(307),
    [anon_sym_GT_GT] = ACTIONS(1986),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(307),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1986),
    [anon_sym_DASH] = ACTIONS(1986),
    [anon_sym_SLASH] = ACTIONS(307),
    [anon_sym_PERCENT] = ACTIONS(307),
    [anon_sym_SLASH_SLASH] = ACTIONS(307),
    [anon_sym_STAR_STAR] = ACTIONS(319),
    [anon_sym_PIPE] = ACTIONS(1986),
    [anon_sym_AMP] = ACTIONS(1986),
    [anon_sym_CARET] = ACTIONS(1986),
    [anon_sym_LT_LT] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_PLUS_EQ] = ACTIONS(1984),
    [anon_sym_DASH_EQ] = ACTIONS(1984),
    [anon_sym_STAR_EQ] = ACTIONS(1984),
    [anon_sym_SLASH_EQ] = ACTIONS(1984),
    [anon_sym_AT_EQ] = ACTIONS(1984),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1984),
    [anon_sym_PERCENT_EQ] = ACTIONS(1984),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1984),
    [anon_sym_GT_GT_EQ] = ACTIONS(1984),
    [anon_sym_LT_LT_EQ] = ACTIONS(1984),
    [anon_sym_AMP_EQ] = ACTIONS(1984),
    [anon_sym_CARET_EQ] = ACTIONS(1984),
    [anon_sym_PIPE_EQ] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1984),
  },
  [557] = {
    [sym_argument_list] = STATE(192),
    [sym_generator_expression] = STATE(192),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_GT_GT] = ACTIONS(1986),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(1986),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1986),
    [anon_sym_DASH] = ACTIONS(1986),
    [anon_sym_SLASH] = ACTIONS(1986),
    [anon_sym_PERCENT] = ACTIONS(1986),
    [anon_sym_SLASH_SLASH] = ACTIONS(1986),
    [anon_sym_STAR_STAR] = ACTIONS(1986),
    [anon_sym_PIPE] = ACTIONS(1986),
    [anon_sym_AMP] = ACTIONS(1986),
    [anon_sym_CARET] = ACTIONS(1986),
    [anon_sym_LT_LT] = ACTIONS(1986),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_PLUS_EQ] = ACTIONS(1984),
    [anon_sym_DASH_EQ] = ACTIONS(1984),
    [anon_sym_STAR_EQ] = ACTIONS(1984),
    [anon_sym_SLASH_EQ] = ACTIONS(1984),
    [anon_sym_AT_EQ] = ACTIONS(1984),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1984),
    [anon_sym_PERCENT_EQ] = ACTIONS(1984),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1984),
    [anon_sym_GT_GT_EQ] = ACTIONS(1984),
    [anon_sym_LT_LT_EQ] = ACTIONS(1984),
    [anon_sym_AMP_EQ] = ACTIONS(1984),
    [anon_sym_CARET_EQ] = ACTIONS(1984),
    [anon_sym_PIPE_EQ] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1984),
  },
  [558] = {
    [sym_argument_list] = STATE(192),
    [sym_generator_expression] = STATE(192),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(307),
    [anon_sym_GT_GT] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(307),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(317),
    [anon_sym_SLASH] = ACTIONS(307),
    [anon_sym_PERCENT] = ACTIONS(307),
    [anon_sym_SLASH_SLASH] = ACTIONS(307),
    [anon_sym_STAR_STAR] = ACTIONS(319),
    [anon_sym_PIPE] = ACTIONS(1986),
    [anon_sym_AMP] = ACTIONS(323),
    [anon_sym_CARET] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_PLUS_EQ] = ACTIONS(1984),
    [anon_sym_DASH_EQ] = ACTIONS(1984),
    [anon_sym_STAR_EQ] = ACTIONS(1984),
    [anon_sym_SLASH_EQ] = ACTIONS(1984),
    [anon_sym_AT_EQ] = ACTIONS(1984),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1984),
    [anon_sym_PERCENT_EQ] = ACTIONS(1984),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1984),
    [anon_sym_GT_GT_EQ] = ACTIONS(1984),
    [anon_sym_LT_LT_EQ] = ACTIONS(1984),
    [anon_sym_AMP_EQ] = ACTIONS(1984),
    [anon_sym_CARET_EQ] = ACTIONS(1984),
    [anon_sym_PIPE_EQ] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1984),
  },
  [559] = {
    [sym_argument_list] = STATE(192),
    [sym_generator_expression] = STATE(192),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(307),
    [anon_sym_GT_GT] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(307),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(317),
    [anon_sym_SLASH] = ACTIONS(307),
    [anon_sym_PERCENT] = ACTIONS(307),
    [anon_sym_SLASH_SLASH] = ACTIONS(307),
    [anon_sym_STAR_STAR] = ACTIONS(319),
    [anon_sym_PIPE] = ACTIONS(1986),
    [anon_sym_AMP] = ACTIONS(1986),
    [anon_sym_CARET] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_PLUS_EQ] = ACTIONS(1984),
    [anon_sym_DASH_EQ] = ACTIONS(1984),
    [anon_sym_STAR_EQ] = ACTIONS(1984),
    [anon_sym_SLASH_EQ] = ACTIONS(1984),
    [anon_sym_AT_EQ] = ACTIONS(1984),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1984),
    [anon_sym_PERCENT_EQ] = ACTIONS(1984),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1984),
    [anon_sym_GT_GT_EQ] = ACTIONS(1984),
    [anon_sym_LT_LT_EQ] = ACTIONS(1984),
    [anon_sym_AMP_EQ] = ACTIONS(1984),
    [anon_sym_CARET_EQ] = ACTIONS(1984),
    [anon_sym_PIPE_EQ] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1984),
  },
  [560] = {
    [sym_argument_list] = STATE(192),
    [sym_generator_expression] = STATE(192),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(307),
    [anon_sym_GT_GT] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(307),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(317),
    [anon_sym_SLASH] = ACTIONS(307),
    [anon_sym_PERCENT] = ACTIONS(307),
    [anon_sym_SLASH_SLASH] = ACTIONS(307),
    [anon_sym_STAR_STAR] = ACTIONS(319),
    [anon_sym_PIPE] = ACTIONS(1986),
    [anon_sym_AMP] = ACTIONS(1986),
    [anon_sym_CARET] = ACTIONS(1986),
    [anon_sym_LT_LT] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_PLUS_EQ] = ACTIONS(1984),
    [anon_sym_DASH_EQ] = ACTIONS(1984),
    [anon_sym_STAR_EQ] = ACTIONS(1984),
    [anon_sym_SLASH_EQ] = ACTIONS(1984),
    [anon_sym_AT_EQ] = ACTIONS(1984),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1984),
    [anon_sym_PERCENT_EQ] = ACTIONS(1984),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1984),
    [anon_sym_GT_GT_EQ] = ACTIONS(1984),
    [anon_sym_LT_LT_EQ] = ACTIONS(1984),
    [anon_sym_AMP_EQ] = ACTIONS(1984),
    [anon_sym_CARET_EQ] = ACTIONS(1984),
    [anon_sym_PIPE_EQ] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1984),
  },
  [561] = {
    [sym__expression] = STATE(1044),
    [sym__primary_expression] = STATE(567),
    [sym_not_operator] = STATE(1044),
    [sym_boolean_operator] = STATE(1044),
    [sym_binary_operator] = STATE(567),
    [sym_unary_operator] = STATE(567),
    [sym_comparison_operator] = STATE(1044),
    [sym_lambda] = STATE(1044),
    [sym_attribute] = STATE(567),
    [sym_subscript] = STATE(567),
    [sym_call] = STATE(567),
    [sym_list] = STATE(567),
    [sym_list_comprehension] = STATE(567),
    [sym_dictionary] = STATE(567),
    [sym_dictionary_comprehension] = STATE(567),
    [sym_set] = STATE(567),
    [sym_set_comprehension] = STATE(567),
    [sym_parenthesized_expression] = STATE(567),
    [sym_tuple] = STATE(567),
    [sym_generator_expression] = STATE(567),
    [sym_conditional_expression] = STATE(1044),
    [sym_concatenated_string] = STATE(567),
    [sym_string] = STATE(569),
    [sym_await] = STATE(1044),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_COMMA] = ACTIONS(1996),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(1998),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(975),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(977),
    [anon_sym_lambda] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(1996),
    [sym_ellipsis] = ACTIONS(981),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(983),
    [sym_float] = ACTIONS(983),
    [sym_identifier] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_none] = ACTIONS(983),
    [anon_sym_await] = ACTIONS(985),
    [sym_comment] = ACTIONS(73),
  },
  [562] = {
    [sym__expression] = STATE(1045),
    [sym__primary_expression] = STATE(567),
    [sym_not_operator] = STATE(1045),
    [sym_boolean_operator] = STATE(1045),
    [sym_binary_operator] = STATE(567),
    [sym_unary_operator] = STATE(567),
    [sym_comparison_operator] = STATE(1045),
    [sym_lambda] = STATE(1045),
    [sym_attribute] = STATE(567),
    [sym_subscript] = STATE(567),
    [sym_call] = STATE(567),
    [sym_list] = STATE(567),
    [sym_list_comprehension] = STATE(567),
    [sym_dictionary] = STATE(567),
    [sym_dictionary_comprehension] = STATE(567),
    [sym_set] = STATE(567),
    [sym_set_comprehension] = STATE(567),
    [sym_parenthesized_expression] = STATE(567),
    [sym_tuple] = STATE(567),
    [sym_generator_expression] = STATE(567),
    [sym_conditional_expression] = STATE(1045),
    [sym_concatenated_string] = STATE(567),
    [sym_string] = STATE(569),
    [sym_await] = STATE(1045),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(975),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(977),
    [anon_sym_lambda] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(981),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(983),
    [sym_float] = ACTIONS(983),
    [sym_identifier] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_none] = ACTIONS(983),
    [anon_sym_await] = ACTIONS(985),
    [sym_comment] = ACTIONS(73),
  },
  [563] = {
    [sym__primary_expression] = STATE(227),
    [sym_binary_operator] = STATE(227),
    [sym_unary_operator] = STATE(227),
    [sym_attribute] = STATE(227),
    [sym_subscript] = STATE(227),
    [sym_call] = STATE(227),
    [sym_list] = STATE(227),
    [sym_list_comprehension] = STATE(227),
    [sym_dictionary] = STATE(227),
    [sym_dictionary_comprehension] = STATE(227),
    [sym_set] = STATE(227),
    [sym_set_comprehension] = STATE(227),
    [sym_parenthesized_expression] = STATE(227),
    [sym_tuple] = STATE(227),
    [sym_generator_expression] = STATE(227),
    [sym_concatenated_string] = STATE(227),
    [sym_string] = STATE(569),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(977),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(403),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(405),
    [sym_float] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_true] = ACTIONS(405),
    [sym_false] = ACTIONS(405),
    [sym_none] = ACTIONS(405),
    [sym_comment] = ACTIONS(73),
  },
  [564] = {
    [sym_lambda_parameters] = STATE(1047),
    [sym__parameters] = STATE(138),
    [sym_default_parameter] = STATE(139),
    [sym_typed_default_parameter] = STATE(139),
    [sym_list_splat] = STATE(140),
    [sym_dictionary_splat] = STATE(140),
    [sym_typed_parameter] = STATE(139),
    [sym_tuple] = STATE(139),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(2000),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [565] = {
    [sym__expression] = STATE(249),
    [sym__primary_expression] = STATE(567),
    [sym_not_operator] = STATE(249),
    [sym_boolean_operator] = STATE(249),
    [sym_binary_operator] = STATE(567),
    [sym_unary_operator] = STATE(567),
    [sym_comparison_operator] = STATE(249),
    [sym_lambda] = STATE(249),
    [sym_attribute] = STATE(567),
    [sym_subscript] = STATE(567),
    [sym_call] = STATE(567),
    [sym_list] = STATE(567),
    [sym_list_comprehension] = STATE(567),
    [sym_dictionary] = STATE(567),
    [sym_dictionary_comprehension] = STATE(567),
    [sym_set] = STATE(567),
    [sym_set_comprehension] = STATE(567),
    [sym_parenthesized_expression] = STATE(567),
    [sym_tuple] = STATE(567),
    [sym_generator_expression] = STATE(567),
    [sym_conditional_expression] = STATE(249),
    [sym_concatenated_string] = STATE(567),
    [sym_string] = STATE(569),
    [sym_await] = STATE(249),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(975),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(977),
    [anon_sym_lambda] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(981),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(983),
    [sym_float] = ACTIONS(983),
    [sym_identifier] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_none] = ACTIONS(983),
    [anon_sym_await] = ACTIONS(985),
    [sym_comment] = ACTIONS(73),
  },
  [566] = {
    [aux_sym_subscript_repeat1] = STATE(1054),
    [anon_sym_COMMA] = ACTIONS(2002),
    [anon_sym_if] = ACTIONS(2004),
    [anon_sym_COLON] = ACTIONS(2006),
    [anon_sym_and] = ACTIONS(2008),
    [anon_sym_or] = ACTIONS(2010),
    [anon_sym_RBRACK] = ACTIONS(2012),
    [sym_comment] = ACTIONS(73),
  },
  [567] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [aux_sym_comparison_operator_repeat1] = STATE(1065),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(2014),
    [anon_sym_GT_GT] = ACTIONS(2016),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(2018),
    [anon_sym_AT] = ACTIONS(2020),
    [anon_sym_not] = ACTIONS(2022),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(2024),
    [anon_sym_DASH] = ACTIONS(2024),
    [anon_sym_SLASH] = ACTIONS(2014),
    [anon_sym_PERCENT] = ACTIONS(2020),
    [anon_sym_SLASH_SLASH] = ACTIONS(2020),
    [anon_sym_STAR_STAR] = ACTIONS(2026),
    [anon_sym_PIPE] = ACTIONS(2028),
    [anon_sym_AMP] = ACTIONS(2030),
    [anon_sym_CARET] = ACTIONS(2032),
    [anon_sym_LT_LT] = ACTIONS(2016),
    [anon_sym_LT] = ACTIONS(2034),
    [anon_sym_LT_EQ] = ACTIONS(2018),
    [anon_sym_EQ_EQ] = ACTIONS(2018),
    [anon_sym_BANG_EQ] = ACTIONS(2018),
    [anon_sym_GT_EQ] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(2034),
    [anon_sym_LT_GT] = ACTIONS(2018),
    [anon_sym_is] = ACTIONS(2036),
    [anon_sym_LBRACK] = ACTIONS(473),
    [anon_sym_RBRACK] = ACTIONS(301),
    [sym_comment] = ACTIONS(73),
  },
  [568] = {
    [aux_sym_subscript_repeat1] = STATE(1054),
    [anon_sym_COMMA] = ACTIONS(2002),
    [anon_sym_RBRACK] = ACTIONS(2012),
    [sym_comment] = ACTIONS(73),
  },
  [569] = {
    [sym_string] = STATE(1066),
    [aux_sym_concatenated_string_repeat1] = STATE(1066),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_COLON] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_RBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [570] = {
    [aux_sym_comparison_operator_repeat1] = STATE(570),
    [sym__newline] = ACTIONS(1988),
    [anon_sym_COMMA] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_COLON] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(2038),
    [anon_sym_EQ] = ACTIONS(1990),
    [anon_sym_not] = ACTIONS(2041),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(2044),
    [anon_sym_LT_EQ] = ACTIONS(2038),
    [anon_sym_EQ_EQ] = ACTIONS(2038),
    [anon_sym_BANG_EQ] = ACTIONS(2038),
    [anon_sym_GT_EQ] = ACTIONS(2038),
    [anon_sym_GT] = ACTIONS(2044),
    [anon_sym_LT_GT] = ACTIONS(2038),
    [anon_sym_is] = ACTIONS(2047),
    [anon_sym_PLUS_EQ] = ACTIONS(1988),
    [anon_sym_DASH_EQ] = ACTIONS(1988),
    [anon_sym_STAR_EQ] = ACTIONS(1988),
    [anon_sym_SLASH_EQ] = ACTIONS(1988),
    [anon_sym_AT_EQ] = ACTIONS(1988),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1988),
    [anon_sym_PERCENT_EQ] = ACTIONS(1988),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1988),
    [anon_sym_GT_GT_EQ] = ACTIONS(1988),
    [anon_sym_LT_LT_EQ] = ACTIONS(1988),
    [anon_sym_AMP_EQ] = ACTIONS(1988),
    [anon_sym_CARET_EQ] = ACTIONS(1988),
    [anon_sym_PIPE_EQ] = ACTIONS(1988),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1988),
  },
  [571] = {
    [sym_string] = STATE(571),
    [aux_sym_concatenated_string_repeat1] = STATE(571),
    [sym__newline] = ACTIONS(2050),
    [sym__string_start] = ACTIONS(2052),
    [anon_sym_DOT] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(2050),
    [anon_sym_COMMA] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2055),
    [anon_sym_if] = ACTIONS(2050),
    [anon_sym_COLON] = ACTIONS(2050),
    [anon_sym_in] = ACTIONS(2050),
    [anon_sym_EQ] = ACTIONS(2055),
    [anon_sym_AT] = ACTIONS(2055),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_and] = ACTIONS(2050),
    [anon_sym_or] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2055),
    [anon_sym_DASH] = ACTIONS(2055),
    [anon_sym_SLASH] = ACTIONS(2055),
    [anon_sym_PERCENT] = ACTIONS(2055),
    [anon_sym_SLASH_SLASH] = ACTIONS(2055),
    [anon_sym_STAR_STAR] = ACTIONS(2055),
    [anon_sym_PIPE] = ACTIONS(2055),
    [anon_sym_AMP] = ACTIONS(2055),
    [anon_sym_CARET] = ACTIONS(2055),
    [anon_sym_LT_LT] = ACTIONS(2055),
    [anon_sym_LT] = ACTIONS(2055),
    [anon_sym_LT_EQ] = ACTIONS(2050),
    [anon_sym_EQ_EQ] = ACTIONS(2050),
    [anon_sym_BANG_EQ] = ACTIONS(2050),
    [anon_sym_GT_EQ] = ACTIONS(2050),
    [anon_sym_GT] = ACTIONS(2055),
    [anon_sym_LT_GT] = ACTIONS(2050),
    [anon_sym_is] = ACTIONS(2050),
    [anon_sym_PLUS_EQ] = ACTIONS(2050),
    [anon_sym_DASH_EQ] = ACTIONS(2050),
    [anon_sym_STAR_EQ] = ACTIONS(2050),
    [anon_sym_SLASH_EQ] = ACTIONS(2050),
    [anon_sym_AT_EQ] = ACTIONS(2050),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2050),
    [anon_sym_PERCENT_EQ] = ACTIONS(2050),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2050),
    [anon_sym_GT_GT_EQ] = ACTIONS(2050),
    [anon_sym_LT_LT_EQ] = ACTIONS(2050),
    [anon_sym_AMP_EQ] = ACTIONS(2050),
    [anon_sym_CARET_EQ] = ACTIONS(2050),
    [anon_sym_PIPE_EQ] = ACTIONS(2050),
    [anon_sym_LBRACK] = ACTIONS(2050),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2050),
  },
  [572] = {
    [anon_sym_if] = ACTIONS(723),
    [anon_sym_and] = ACTIONS(1113),
    [anon_sym_or] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(723),
    [sym_type_conversion] = ACTIONS(723),
    [sym_comment] = ACTIONS(73),
  },
  [573] = {
    [sym__expression] = STATE(1067),
    [sym__primary_expression] = STATE(204),
    [sym_not_operator] = STATE(1067),
    [sym_boolean_operator] = STATE(1067),
    [sym_binary_operator] = STATE(204),
    [sym_unary_operator] = STATE(204),
    [sym_comparison_operator] = STATE(1067),
    [sym_lambda] = STATE(1067),
    [sym_attribute] = STATE(204),
    [sym_subscript] = STATE(204),
    [sym_call] = STATE(204),
    [sym_list] = STATE(204),
    [sym_list_comprehension] = STATE(204),
    [sym_dictionary] = STATE(204),
    [sym_dictionary_comprehension] = STATE(204),
    [sym_set] = STATE(204),
    [sym_set_comprehension] = STATE(204),
    [sym_parenthesized_expression] = STATE(204),
    [sym_tuple] = STATE(204),
    [sym_generator_expression] = STATE(204),
    [sym_conditional_expression] = STATE(1067),
    [sym_concatenated_string] = STATE(204),
    [sym_string] = STATE(205),
    [sym_await] = STATE(1067),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(349),
    [anon_sym_PLUS] = ACTIONS(351),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_lambda] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_identifier] = ACTIONS(357),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_none] = ACTIONS(357),
    [anon_sym_await] = ACTIONS(359),
    [sym_comment] = ACTIONS(73),
  },
  [574] = {
    [anon_sym_COLON] = ACTIONS(2057),
    [sym_comment] = ACTIONS(73),
  },
  [575] = {
    [sym__expression] = STATE(1069),
    [sym__primary_expression] = STATE(538),
    [sym_not_operator] = STATE(1069),
    [sym_boolean_operator] = STATE(1069),
    [sym_binary_operator] = STATE(538),
    [sym_unary_operator] = STATE(538),
    [sym_comparison_operator] = STATE(1069),
    [sym_lambda] = STATE(1069),
    [sym_attribute] = STATE(538),
    [sym_subscript] = STATE(538),
    [sym_call] = STATE(538),
    [sym_list] = STATE(538),
    [sym_list_comprehension] = STATE(538),
    [sym_dictionary] = STATE(538),
    [sym_dictionary_comprehension] = STATE(538),
    [sym_set] = STATE(538),
    [sym_set_comprehension] = STATE(538),
    [sym_parenthesized_expression] = STATE(538),
    [sym_tuple] = STATE(538),
    [sym_generator_expression] = STATE(538),
    [sym_conditional_expression] = STATE(1069),
    [sym_concatenated_string] = STATE(538),
    [sym_string] = STATE(539),
    [sym_await] = STATE(1069),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_lambda] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(917),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(919),
    [sym_float] = ACTIONS(919),
    [sym_identifier] = ACTIONS(919),
    [sym_true] = ACTIONS(919),
    [sym_false] = ACTIONS(919),
    [sym_none] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(921),
    [sym_comment] = ACTIONS(73),
  },
  [576] = {
    [sym__expression] = STATE(652),
    [sym__primary_expression] = STATE(204),
    [sym_not_operator] = STATE(652),
    [sym_boolean_operator] = STATE(652),
    [sym_binary_operator] = STATE(204),
    [sym_unary_operator] = STATE(204),
    [sym_comparison_operator] = STATE(652),
    [sym_lambda] = STATE(652),
    [sym_attribute] = STATE(204),
    [sym_subscript] = STATE(204),
    [sym_call] = STATE(204),
    [sym_list] = STATE(204),
    [sym_list_comprehension] = STATE(204),
    [sym_dictionary] = STATE(204),
    [sym_dictionary_comprehension] = STATE(204),
    [sym_set] = STATE(204),
    [sym_set_comprehension] = STATE(204),
    [sym_parenthesized_expression] = STATE(204),
    [sym_tuple] = STATE(204),
    [sym_generator_expression] = STATE(204),
    [sym_conditional_expression] = STATE(652),
    [sym_concatenated_string] = STATE(204),
    [sym_string] = STATE(205),
    [sym_await] = STATE(652),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(349),
    [anon_sym_PLUS] = ACTIONS(351),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_lambda] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_identifier] = ACTIONS(357),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_none] = ACTIONS(357),
    [anon_sym_await] = ACTIONS(359),
    [sym_comment] = ACTIONS(73),
  },
  [577] = {
    [sym__expression] = STATE(1070),
    [sym__primary_expression] = STATE(204),
    [sym_not_operator] = STATE(1070),
    [sym_boolean_operator] = STATE(1070),
    [sym_binary_operator] = STATE(204),
    [sym_unary_operator] = STATE(204),
    [sym_comparison_operator] = STATE(1070),
    [sym_lambda] = STATE(1070),
    [sym_attribute] = STATE(204),
    [sym_subscript] = STATE(204),
    [sym_call] = STATE(204),
    [sym_list] = STATE(204),
    [sym_list_comprehension] = STATE(204),
    [sym_dictionary] = STATE(204),
    [sym_dictionary_comprehension] = STATE(204),
    [sym_set] = STATE(204),
    [sym_set_comprehension] = STATE(204),
    [sym_parenthesized_expression] = STATE(204),
    [sym_tuple] = STATE(204),
    [sym_generator_expression] = STATE(204),
    [sym_conditional_expression] = STATE(1070),
    [sym_concatenated_string] = STATE(204),
    [sym_string] = STATE(205),
    [sym_await] = STATE(1070),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(349),
    [anon_sym_PLUS] = ACTIONS(351),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_lambda] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_identifier] = ACTIONS(357),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_none] = ACTIONS(357),
    [anon_sym_await] = ACTIONS(359),
    [sym_comment] = ACTIONS(73),
  },
  [578] = {
    [sym__string_content] = ACTIONS(2059),
    [sym__string_end] = ACTIONS(2059),
    [anon_sym_LBRACE] = ACTIONS(2061),
    [sym_escape_sequence] = ACTIONS(2059),
    [sym_comment] = ACTIONS(81),
  },
  [579] = {
    [anon_sym_RBRACE] = ACTIONS(2063),
    [sym_comment] = ACTIONS(73),
  },
  [580] = {
    [sym__primary_expression] = STATE(1072),
    [sym_binary_operator] = STATE(1072),
    [sym_unary_operator] = STATE(1072),
    [sym_attribute] = STATE(1072),
    [sym_subscript] = STATE(1072),
    [sym_call] = STATE(1072),
    [sym_list] = STATE(1072),
    [sym_list_comprehension] = STATE(1072),
    [sym_dictionary] = STATE(1072),
    [sym_dictionary_comprehension] = STATE(1072),
    [sym_set] = STATE(1072),
    [sym_set_comprehension] = STATE(1072),
    [sym_parenthesized_expression] = STATE(1072),
    [sym_tuple] = STATE(1072),
    [sym_generator_expression] = STATE(1072),
    [sym_concatenated_string] = STATE(1072),
    [sym_string] = STATE(205),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(351),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2065),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2067),
    [sym_float] = ACTIONS(2067),
    [sym_identifier] = ACTIONS(2067),
    [sym_true] = ACTIONS(2067),
    [sym_false] = ACTIONS(2067),
    [sym_none] = ACTIONS(2067),
    [sym_comment] = ACTIONS(73),
  },
  [581] = {
    [sym__primary_expression] = STATE(1073),
    [sym_binary_operator] = STATE(1073),
    [sym_unary_operator] = STATE(1073),
    [sym_attribute] = STATE(1073),
    [sym_subscript] = STATE(1073),
    [sym_call] = STATE(1073),
    [sym_list] = STATE(1073),
    [sym_list_comprehension] = STATE(1073),
    [sym_dictionary] = STATE(1073),
    [sym_dictionary_comprehension] = STATE(1073),
    [sym_set] = STATE(1073),
    [sym_set_comprehension] = STATE(1073),
    [sym_parenthesized_expression] = STATE(1073),
    [sym_tuple] = STATE(1073),
    [sym_generator_expression] = STATE(1073),
    [sym_concatenated_string] = STATE(1073),
    [sym_string] = STATE(205),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(351),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2069),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2071),
    [sym_float] = ACTIONS(2071),
    [sym_identifier] = ACTIONS(2071),
    [sym_true] = ACTIONS(2071),
    [sym_false] = ACTIONS(2071),
    [sym_none] = ACTIONS(2071),
    [sym_comment] = ACTIONS(73),
  },
  [582] = {
    [sym__primary_expression] = STATE(1074),
    [sym_binary_operator] = STATE(1074),
    [sym_unary_operator] = STATE(1074),
    [sym_attribute] = STATE(1074),
    [sym_subscript] = STATE(1074),
    [sym_call] = STATE(1074),
    [sym_list] = STATE(1074),
    [sym_list_comprehension] = STATE(1074),
    [sym_dictionary] = STATE(1074),
    [sym_dictionary_comprehension] = STATE(1074),
    [sym_set] = STATE(1074),
    [sym_set_comprehension] = STATE(1074),
    [sym_parenthesized_expression] = STATE(1074),
    [sym_tuple] = STATE(1074),
    [sym_generator_expression] = STATE(1074),
    [sym_concatenated_string] = STATE(1074),
    [sym_string] = STATE(205),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(351),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2073),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2075),
    [sym_float] = ACTIONS(2075),
    [sym_identifier] = ACTIONS(2075),
    [sym_true] = ACTIONS(2075),
    [sym_false] = ACTIONS(2075),
    [sym_none] = ACTIONS(2075),
    [sym_comment] = ACTIONS(73),
  },
  [583] = {
    [anon_sym_in] = ACTIONS(2077),
    [sym_comment] = ACTIONS(73),
  },
  [584] = {
    [sym__primary_expression] = STATE(1076),
    [sym_binary_operator] = STATE(1076),
    [sym_unary_operator] = STATE(1076),
    [sym_attribute] = STATE(1076),
    [sym_subscript] = STATE(1076),
    [sym_call] = STATE(1076),
    [sym_list] = STATE(1076),
    [sym_list_comprehension] = STATE(1076),
    [sym_dictionary] = STATE(1076),
    [sym_dictionary_comprehension] = STATE(1076),
    [sym_set] = STATE(1076),
    [sym_set_comprehension] = STATE(1076),
    [sym_parenthesized_expression] = STATE(1076),
    [sym_tuple] = STATE(1076),
    [sym_generator_expression] = STATE(1076),
    [sym_concatenated_string] = STATE(1076),
    [sym_string] = STATE(205),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(351),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2079),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2081),
    [sym_float] = ACTIONS(2081),
    [sym_identifier] = ACTIONS(2081),
    [sym_true] = ACTIONS(2081),
    [sym_false] = ACTIONS(2081),
    [sym_none] = ACTIONS(2081),
    [sym_comment] = ACTIONS(73),
  },
  [585] = {
    [sym__primary_expression] = STATE(669),
    [sym_binary_operator] = STATE(669),
    [sym_unary_operator] = STATE(669),
    [sym_attribute] = STATE(669),
    [sym_subscript] = STATE(669),
    [sym_call] = STATE(669),
    [sym_list] = STATE(669),
    [sym_list_comprehension] = STATE(669),
    [sym_dictionary] = STATE(669),
    [sym_dictionary_comprehension] = STATE(669),
    [sym_set] = STATE(669),
    [sym_set_comprehension] = STATE(669),
    [sym_parenthesized_expression] = STATE(669),
    [sym_tuple] = STATE(669),
    [sym_generator_expression] = STATE(669),
    [sym_concatenated_string] = STATE(669),
    [sym_string] = STATE(205),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(351),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1282),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1284),
    [sym_float] = ACTIONS(1284),
    [sym_identifier] = ACTIONS(1284),
    [sym_true] = ACTIONS(1284),
    [sym_false] = ACTIONS(1284),
    [sym_none] = ACTIONS(1284),
    [sym_comment] = ACTIONS(73),
  },
  [586] = {
    [sym__primary_expression] = STATE(1077),
    [sym_binary_operator] = STATE(1077),
    [sym_unary_operator] = STATE(1077),
    [sym_attribute] = STATE(1077),
    [sym_subscript] = STATE(1077),
    [sym_call] = STATE(1077),
    [sym_list] = STATE(1077),
    [sym_list_comprehension] = STATE(1077),
    [sym_dictionary] = STATE(1077),
    [sym_dictionary_comprehension] = STATE(1077),
    [sym_set] = STATE(1077),
    [sym_set_comprehension] = STATE(1077),
    [sym_parenthesized_expression] = STATE(1077),
    [sym_tuple] = STATE(1077),
    [sym_generator_expression] = STATE(1077),
    [sym_concatenated_string] = STATE(1077),
    [sym_string] = STATE(205),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(351),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2083),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2085),
    [sym_float] = ACTIONS(2085),
    [sym_identifier] = ACTIONS(2085),
    [sym_true] = ACTIONS(2085),
    [sym_false] = ACTIONS(2085),
    [sym_none] = ACTIONS(2085),
    [sym_comment] = ACTIONS(73),
  },
  [587] = {
    [sym__primary_expression] = STATE(1078),
    [sym_binary_operator] = STATE(1078),
    [sym_unary_operator] = STATE(1078),
    [sym_attribute] = STATE(1078),
    [sym_subscript] = STATE(1078),
    [sym_call] = STATE(1078),
    [sym_list] = STATE(1078),
    [sym_list_comprehension] = STATE(1078),
    [sym_dictionary] = STATE(1078),
    [sym_dictionary_comprehension] = STATE(1078),
    [sym_set] = STATE(1078),
    [sym_set_comprehension] = STATE(1078),
    [sym_parenthesized_expression] = STATE(1078),
    [sym_tuple] = STATE(1078),
    [sym_generator_expression] = STATE(1078),
    [sym_concatenated_string] = STATE(1078),
    [sym_string] = STATE(205),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(351),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2087),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2089),
    [sym_float] = ACTIONS(2089),
    [sym_identifier] = ACTIONS(2089),
    [sym_true] = ACTIONS(2089),
    [sym_false] = ACTIONS(2089),
    [sym_none] = ACTIONS(2089),
    [sym_comment] = ACTIONS(73),
  },
  [588] = {
    [sym__primary_expression] = STATE(1079),
    [sym_binary_operator] = STATE(1079),
    [sym_unary_operator] = STATE(1079),
    [sym_attribute] = STATE(1079),
    [sym_subscript] = STATE(1079),
    [sym_call] = STATE(1079),
    [sym_list] = STATE(1079),
    [sym_list_comprehension] = STATE(1079),
    [sym_dictionary] = STATE(1079),
    [sym_dictionary_comprehension] = STATE(1079),
    [sym_set] = STATE(1079),
    [sym_set_comprehension] = STATE(1079),
    [sym_parenthesized_expression] = STATE(1079),
    [sym_tuple] = STATE(1079),
    [sym_generator_expression] = STATE(1079),
    [sym_concatenated_string] = STATE(1079),
    [sym_string] = STATE(205),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(351),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2091),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2093),
    [sym_float] = ACTIONS(2093),
    [sym_identifier] = ACTIONS(2093),
    [sym_true] = ACTIONS(2093),
    [sym_false] = ACTIONS(2093),
    [sym_none] = ACTIONS(2093),
    [sym_comment] = ACTIONS(73),
  },
  [589] = {
    [sym__primary_expression] = STATE(1074),
    [sym_binary_operator] = STATE(1074),
    [sym_unary_operator] = STATE(1074),
    [sym_attribute] = STATE(1074),
    [sym_subscript] = STATE(1074),
    [sym_call] = STATE(1074),
    [sym_list] = STATE(1074),
    [sym_list_comprehension] = STATE(1074),
    [sym_dictionary] = STATE(1074),
    [sym_dictionary_comprehension] = STATE(1074),
    [sym_set] = STATE(1074),
    [sym_set_comprehension] = STATE(1074),
    [sym_parenthesized_expression] = STATE(1074),
    [sym_tuple] = STATE(1074),
    [sym_generator_expression] = STATE(1074),
    [sym_concatenated_string] = STATE(1074),
    [sym_string] = STATE(205),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2095),
    [anon_sym_PLUS] = ACTIONS(351),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2073),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2075),
    [sym_float] = ACTIONS(2075),
    [sym_identifier] = ACTIONS(2075),
    [sym_true] = ACTIONS(2075),
    [sym_false] = ACTIONS(2075),
    [sym_none] = ACTIONS(2075),
    [sym_comment] = ACTIONS(73),
  },
  [590] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1080),
    [anon_sym_if] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(1125),
    [anon_sym_not] = ACTIONS(1129),
    [anon_sym_and] = ACTIONS(991),
    [anon_sym_or] = ACTIONS(991),
    [anon_sym_LT] = ACTIONS(1141),
    [anon_sym_LT_EQ] = ACTIONS(1125),
    [anon_sym_EQ_EQ] = ACTIONS(1125),
    [anon_sym_BANG_EQ] = ACTIONS(1125),
    [anon_sym_GT_EQ] = ACTIONS(1125),
    [anon_sym_GT] = ACTIONS(1141),
    [anon_sym_LT_GT] = ACTIONS(1125),
    [anon_sym_is] = ACTIONS(1143),
    [anon_sym_RBRACE] = ACTIONS(991),
    [sym_type_conversion] = ACTIONS(991),
    [sym_comment] = ACTIONS(73),
  },
  [591] = {
    [sym_string] = STATE(1081),
    [aux_sym_concatenated_string_repeat1] = STATE(1081),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_in] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(995),
    [anon_sym_not] = ACTIONS(995),
    [anon_sym_and] = ACTIONS(995),
    [anon_sym_or] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(995),
    [anon_sym_SLASH_SLASH] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_GT] = ACTIONS(995),
    [anon_sym_is] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(995),
    [anon_sym_RBRACE] = ACTIONS(995),
    [sym_type_conversion] = ACTIONS(995),
    [sym_comment] = ACTIONS(73),
  },
  [592] = {
    [sym__newline] = ACTIONS(2097),
    [anon_sym_DOT] = ACTIONS(2097),
    [anon_sym_LPAREN] = ACTIONS(2097),
    [anon_sym_COMMA] = ACTIONS(2097),
    [anon_sym_as] = ACTIONS(2097),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2097),
  },
  [593] = {
    [aux_sym_dotted_name_repeat1] = STATE(593),
    [sym__newline] = ACTIONS(2097),
    [anon_sym_DOT] = ACTIONS(2099),
    [anon_sym_COMMA] = ACTIONS(2097),
    [anon_sym_as] = ACTIONS(2097),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2097),
  },
  [594] = {
    [sym__newline] = ACTIONS(2102),
    [anon_sym_COMMA] = ACTIONS(2102),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2102),
  },
  [595] = {
    [sym__newline] = ACTIONS(2102),
    [anon_sym_COMMA] = ACTIONS(2102),
    [anon_sym_as] = ACTIONS(375),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2102),
  },
  [596] = {
    [sym_aliased_import] = STATE(594),
    [sym_dotted_name] = STATE(595),
    [sym__newline] = ACTIONS(2104),
    [sym_identifier] = ACTIONS(83),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2104),
  },
  [597] = {
    [aux_sym__import_list_repeat1] = STATE(597),
    [sym__newline] = ACTIONS(2102),
    [anon_sym_COMMA] = ACTIONS(2106),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2102),
  },
  [598] = {
    [sym__newline] = ACTIONS(2109),
    [anon_sym_COMMA] = ACTIONS(2109),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2109),
  },
  [599] = {
    [sym__newline] = ACTIONS(2111),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2111),
  },
  [600] = {
    [anon_sym_import] = ACTIONS(2097),
    [anon_sym_DOT] = ACTIONS(2097),
    [anon_sym_RPAREN] = ACTIONS(2097),
    [anon_sym_COMMA] = ACTIONS(2097),
    [anon_sym_as] = ACTIONS(2097),
    [sym_comment] = ACTIONS(73),
  },
  [601] = {
    [aux_sym_dotted_name_repeat1] = STATE(601),
    [anon_sym_import] = ACTIONS(2097),
    [anon_sym_DOT] = ACTIONS(2113),
    [sym_comment] = ACTIONS(73),
  },
  [602] = {
    [sym__import_list] = STATE(1084),
    [sym_aliased_import] = STATE(1085),
    [sym_dotted_name] = STATE(1086),
    [sym_identifier] = ACTIONS(2116),
    [sym_comment] = ACTIONS(73),
  },
  [603] = {
    [sym__newline] = ACTIONS(2118),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2118),
  },
  [604] = {
    [sym__newline] = ACTIONS(2120),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2120),
  },
  [605] = {
    [sym__string_start] = ACTIONS(1145),
    [anon_sym_DOT] = ACTIONS(1145),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [anon_sym_RPAREN] = ACTIONS(1145),
    [anon_sym_COMMA] = ACTIONS(1145),
    [anon_sym_as] = ACTIONS(1147),
    [anon_sym_STAR] = ACTIONS(1147),
    [anon_sym_GT_GT] = ACTIONS(1145),
    [anon_sym_if] = ACTIONS(1145),
    [anon_sym_COLON] = ACTIONS(1145),
    [anon_sym_else] = ACTIONS(1145),
    [anon_sym_async] = ACTIONS(1145),
    [anon_sym_for] = ACTIONS(1145),
    [anon_sym_in] = ACTIONS(1145),
    [anon_sym_EQ] = ACTIONS(1147),
    [anon_sym_AT] = ACTIONS(1145),
    [anon_sym_not] = ACTIONS(1145),
    [anon_sym_and] = ACTIONS(1145),
    [anon_sym_or] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1145),
    [anon_sym_SLASH_SLASH] = ACTIONS(1145),
    [anon_sym_STAR_STAR] = ACTIONS(1145),
    [anon_sym_PIPE] = ACTIONS(1145),
    [anon_sym_AMP] = ACTIONS(1145),
    [anon_sym_CARET] = ACTIONS(1145),
    [anon_sym_LT_LT] = ACTIONS(1145),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_LT_EQ] = ACTIONS(1145),
    [anon_sym_EQ_EQ] = ACTIONS(1145),
    [anon_sym_BANG_EQ] = ACTIONS(1145),
    [anon_sym_GT_EQ] = ACTIONS(1145),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_LT_GT] = ACTIONS(1145),
    [anon_sym_is] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1145),
    [anon_sym_RBRACK] = ACTIONS(1145),
    [anon_sym_RBRACE] = ACTIONS(1145),
    [sym_type_conversion] = ACTIONS(1145),
    [sym_comment] = ACTIONS(73),
  },
  [606] = {
    [anon_sym_DOT] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1188),
    [anon_sym_RPAREN] = ACTIONS(1188),
    [anon_sym_COMMA] = ACTIONS(1188),
    [anon_sym_as] = ACTIONS(1190),
    [anon_sym_STAR] = ACTIONS(1190),
    [anon_sym_GT_GT] = ACTIONS(1188),
    [anon_sym_if] = ACTIONS(1188),
    [anon_sym_COLON] = ACTIONS(1188),
    [anon_sym_else] = ACTIONS(1188),
    [anon_sym_async] = ACTIONS(1188),
    [anon_sym_for] = ACTIONS(1188),
    [anon_sym_in] = ACTIONS(1188),
    [anon_sym_EQ] = ACTIONS(1190),
    [anon_sym_AT] = ACTIONS(1188),
    [anon_sym_not] = ACTIONS(1188),
    [anon_sym_and] = ACTIONS(1188),
    [anon_sym_or] = ACTIONS(1188),
    [anon_sym_PLUS] = ACTIONS(1188),
    [anon_sym_DASH] = ACTIONS(1188),
    [anon_sym_SLASH] = ACTIONS(1190),
    [anon_sym_PERCENT] = ACTIONS(1188),
    [anon_sym_SLASH_SLASH] = ACTIONS(1188),
    [anon_sym_STAR_STAR] = ACTIONS(1188),
    [anon_sym_PIPE] = ACTIONS(1188),
    [anon_sym_AMP] = ACTIONS(1188),
    [anon_sym_CARET] = ACTIONS(1188),
    [anon_sym_LT_LT] = ACTIONS(1188),
    [anon_sym_LT] = ACTIONS(1190),
    [anon_sym_LT_EQ] = ACTIONS(1188),
    [anon_sym_EQ_EQ] = ACTIONS(1188),
    [anon_sym_BANG_EQ] = ACTIONS(1188),
    [anon_sym_GT_EQ] = ACTIONS(1188),
    [anon_sym_GT] = ACTIONS(1190),
    [anon_sym_LT_GT] = ACTIONS(1188),
    [anon_sym_is] = ACTIONS(1188),
    [anon_sym_LBRACK] = ACTIONS(1188),
    [anon_sym_RBRACK] = ACTIONS(1188),
    [anon_sym_RBRACE] = ACTIONS(1188),
    [sym_type_conversion] = ACTIONS(1188),
    [sym_comment] = ACTIONS(73),
  },
  [607] = {
    [anon_sym_DOT] = ACTIONS(1242),
    [anon_sym_LPAREN] = ACTIONS(1242),
    [anon_sym_RPAREN] = ACTIONS(1242),
    [anon_sym_COMMA] = ACTIONS(1242),
    [anon_sym_as] = ACTIONS(1244),
    [anon_sym_STAR] = ACTIONS(1244),
    [anon_sym_GT_GT] = ACTIONS(1242),
    [anon_sym_if] = ACTIONS(1242),
    [anon_sym_COLON] = ACTIONS(1242),
    [anon_sym_else] = ACTIONS(1242),
    [anon_sym_async] = ACTIONS(1242),
    [anon_sym_for] = ACTIONS(1242),
    [anon_sym_in] = ACTIONS(1242),
    [anon_sym_EQ] = ACTIONS(1244),
    [anon_sym_AT] = ACTIONS(1242),
    [anon_sym_not] = ACTIONS(1242),
    [anon_sym_and] = ACTIONS(1242),
    [anon_sym_or] = ACTIONS(1242),
    [anon_sym_PLUS] = ACTIONS(1242),
    [anon_sym_DASH] = ACTIONS(1242),
    [anon_sym_SLASH] = ACTIONS(1244),
    [anon_sym_PERCENT] = ACTIONS(1242),
    [anon_sym_SLASH_SLASH] = ACTIONS(1242),
    [anon_sym_STAR_STAR] = ACTIONS(1242),
    [anon_sym_PIPE] = ACTIONS(1242),
    [anon_sym_AMP] = ACTIONS(1242),
    [anon_sym_CARET] = ACTIONS(1242),
    [anon_sym_LT_LT] = ACTIONS(1242),
    [anon_sym_LT] = ACTIONS(1244),
    [anon_sym_LT_EQ] = ACTIONS(1242),
    [anon_sym_EQ_EQ] = ACTIONS(1242),
    [anon_sym_BANG_EQ] = ACTIONS(1242),
    [anon_sym_GT_EQ] = ACTIONS(1242),
    [anon_sym_GT] = ACTIONS(1244),
    [anon_sym_LT_GT] = ACTIONS(1242),
    [anon_sym_is] = ACTIONS(1242),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [anon_sym_RBRACK] = ACTIONS(1242),
    [anon_sym_RBRACE] = ACTIONS(1242),
    [sym_type_conversion] = ACTIONS(1242),
    [sym_comment] = ACTIONS(73),
  },
  [608] = {
    [sym__expression] = STATE(647),
    [sym__primary_expression] = STATE(237),
    [sym_not_operator] = STATE(647),
    [sym_boolean_operator] = STATE(647),
    [sym_binary_operator] = STATE(237),
    [sym_unary_operator] = STATE(237),
    [sym_comparison_operator] = STATE(647),
    [sym_lambda] = STATE(647),
    [sym_yield] = STATE(648),
    [sym_attribute] = STATE(237),
    [sym_subscript] = STATE(237),
    [sym_call] = STATE(237),
    [sym_list] = STATE(237),
    [sym_list_comprehension] = STATE(237),
    [sym_dictionary] = STATE(237),
    [sym_dictionary_comprehension] = STATE(237),
    [sym_set] = STATE(237),
    [sym_set_comprehension] = STATE(237),
    [sym_parenthesized_expression] = STATE(237),
    [sym_tuple] = STATE(237),
    [sym_generator_expression] = STATE(237),
    [sym_conditional_expression] = STATE(647),
    [sym_concatenated_string] = STATE(237),
    [sym_string] = STATE(238),
    [sym_await] = STATE(647),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(2122),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_lambda] = ACTIONS(415),
    [anon_sym_yield] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(419),
    [sym_float] = ACTIONS(419),
    [sym_identifier] = ACTIONS(419),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_none] = ACTIONS(419),
    [anon_sym_await] = ACTIONS(421),
    [sym_comment] = ACTIONS(73),
  },
  [609] = {
    [anon_sym_RPAREN] = ACTIONS(2124),
    [sym_comment] = ACTIONS(73),
  },
  [610] = {
    [aux_sym_tuple_repeat1] = STATE(658),
    [anon_sym_RPAREN] = ACTIONS(2122),
    [anon_sym_COMMA] = ACTIONS(2126),
    [sym_comment] = ACTIONS(73),
  },
  [611] = {
    [anon_sym_RPAREN] = ACTIONS(1660),
    [anon_sym_COMMA] = ACTIONS(1660),
    [anon_sym_if] = ACTIONS(435),
    [anon_sym_async] = ACTIONS(1660),
    [anon_sym_for] = ACTIONS(1660),
    [anon_sym_and] = ACTIONS(441),
    [anon_sym_or] = ACTIONS(443),
    [sym_comment] = ACTIONS(73),
  },
  [612] = {
    [sym__expression] = STATE(1090),
    [sym__primary_expression] = STATE(67),
    [sym_not_operator] = STATE(1090),
    [sym_boolean_operator] = STATE(1090),
    [sym_binary_operator] = STATE(67),
    [sym_unary_operator] = STATE(67),
    [sym_comparison_operator] = STATE(1090),
    [sym_lambda] = STATE(1090),
    [sym_attribute] = STATE(67),
    [sym_subscript] = STATE(67),
    [sym_call] = STATE(67),
    [sym_list] = STATE(67),
    [sym_list_comprehension] = STATE(67),
    [sym_dictionary] = STATE(67),
    [sym_dictionary_comprehension] = STATE(67),
    [sym_set] = STATE(67),
    [sym_set_comprehension] = STATE(67),
    [sym_parenthesized_expression] = STATE(67),
    [sym_tuple] = STATE(67),
    [sym_generator_expression] = STATE(67),
    [sym_conditional_expression] = STATE(1090),
    [sym_concatenated_string] = STATE(67),
    [sym_string] = STATE(69),
    [sym_await] = STATE(1090),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [613] = {
    [anon_sym_RPAREN] = ACTIONS(1678),
    [anon_sym_COMMA] = ACTIONS(1678),
    [anon_sym_if] = ACTIONS(1198),
    [anon_sym_and] = ACTIONS(1200),
    [anon_sym_or] = ACTIONS(1202),
    [sym_comment] = ACTIONS(73),
  },
  [614] = {
    [anon_sym_RPAREN] = ACTIONS(723),
    [anon_sym_COMMA] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(723),
    [anon_sym_and] = ACTIONS(1200),
    [anon_sym_or] = ACTIONS(1202),
    [sym_comment] = ACTIONS(73),
  },
  [615] = {
    [sym__expression] = STATE(1091),
    [sym__primary_expression] = STATE(237),
    [sym_not_operator] = STATE(1091),
    [sym_boolean_operator] = STATE(1091),
    [sym_binary_operator] = STATE(237),
    [sym_unary_operator] = STATE(237),
    [sym_comparison_operator] = STATE(1091),
    [sym_lambda] = STATE(1091),
    [sym_attribute] = STATE(237),
    [sym_subscript] = STATE(237),
    [sym_call] = STATE(237),
    [sym_list] = STATE(237),
    [sym_list_comprehension] = STATE(237),
    [sym_dictionary] = STATE(237),
    [sym_dictionary_comprehension] = STATE(237),
    [sym_set] = STATE(237),
    [sym_set_comprehension] = STATE(237),
    [sym_parenthesized_expression] = STATE(237),
    [sym_tuple] = STATE(237),
    [sym_generator_expression] = STATE(237),
    [sym_conditional_expression] = STATE(1091),
    [sym_concatenated_string] = STATE(237),
    [sym_string] = STATE(238),
    [sym_await] = STATE(1091),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_lambda] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(419),
    [sym_float] = ACTIONS(419),
    [sym_identifier] = ACTIONS(419),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_none] = ACTIONS(419),
    [anon_sym_await] = ACTIONS(421),
    [sym_comment] = ACTIONS(73),
  },
  [616] = {
    [anon_sym_COLON] = ACTIONS(2128),
    [sym_comment] = ACTIONS(73),
  },
  [617] = {
    [sym__expression] = STATE(1093),
    [sym__primary_expression] = STATE(237),
    [sym_not_operator] = STATE(1093),
    [sym_boolean_operator] = STATE(1093),
    [sym_binary_operator] = STATE(237),
    [sym_unary_operator] = STATE(237),
    [sym_comparison_operator] = STATE(1093),
    [sym_lambda] = STATE(1093),
    [sym_attribute] = STATE(237),
    [sym_subscript] = STATE(237),
    [sym_call] = STATE(237),
    [sym_list] = STATE(237),
    [sym_list_comprehension] = STATE(237),
    [sym_dictionary] = STATE(237),
    [sym_dictionary_comprehension] = STATE(237),
    [sym_set] = STATE(237),
    [sym_set_comprehension] = STATE(237),
    [sym_parenthesized_expression] = STATE(237),
    [sym_tuple] = STATE(237),
    [sym_generator_expression] = STATE(237),
    [sym_conditional_expression] = STATE(1093),
    [sym_concatenated_string] = STATE(237),
    [sym_string] = STATE(238),
    [sym_await] = STATE(1093),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(907),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_lambda] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(419),
    [sym_float] = ACTIONS(419),
    [sym_identifier] = ACTIONS(419),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_none] = ACTIONS(419),
    [anon_sym_await] = ACTIONS(421),
    [sym_comment] = ACTIONS(73),
  },
  [618] = {
    [sym__expression] = STATE(1094),
    [sym__primary_expression] = STATE(538),
    [sym_not_operator] = STATE(1094),
    [sym_boolean_operator] = STATE(1094),
    [sym_binary_operator] = STATE(538),
    [sym_unary_operator] = STATE(538),
    [sym_comparison_operator] = STATE(1094),
    [sym_lambda] = STATE(1094),
    [sym_attribute] = STATE(538),
    [sym_subscript] = STATE(538),
    [sym_call] = STATE(538),
    [sym_list] = STATE(538),
    [sym_list_comprehension] = STATE(538),
    [sym_dictionary] = STATE(538),
    [sym_dictionary_comprehension] = STATE(538),
    [sym_set] = STATE(538),
    [sym_set_comprehension] = STATE(538),
    [sym_parenthesized_expression] = STATE(538),
    [sym_tuple] = STATE(538),
    [sym_generator_expression] = STATE(538),
    [sym_conditional_expression] = STATE(1094),
    [sym_concatenated_string] = STATE(538),
    [sym_string] = STATE(539),
    [sym_await] = STATE(1094),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_lambda] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(917),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(919),
    [sym_float] = ACTIONS(919),
    [sym_identifier] = ACTIONS(919),
    [sym_true] = ACTIONS(919),
    [sym_false] = ACTIONS(919),
    [sym_none] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(921),
    [sym_comment] = ACTIONS(73),
  },
  [619] = {
    [sym__expression] = STATE(652),
    [sym__primary_expression] = STATE(237),
    [sym_not_operator] = STATE(652),
    [sym_boolean_operator] = STATE(652),
    [sym_binary_operator] = STATE(237),
    [sym_unary_operator] = STATE(237),
    [sym_comparison_operator] = STATE(652),
    [sym_lambda] = STATE(652),
    [sym_attribute] = STATE(237),
    [sym_subscript] = STATE(237),
    [sym_call] = STATE(237),
    [sym_list] = STATE(237),
    [sym_list_comprehension] = STATE(237),
    [sym_dictionary] = STATE(237),
    [sym_dictionary_comprehension] = STATE(237),
    [sym_set] = STATE(237),
    [sym_set_comprehension] = STATE(237),
    [sym_parenthesized_expression] = STATE(237),
    [sym_tuple] = STATE(237),
    [sym_generator_expression] = STATE(237),
    [sym_conditional_expression] = STATE(652),
    [sym_concatenated_string] = STATE(237),
    [sym_string] = STATE(238),
    [sym_await] = STATE(652),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_lambda] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(419),
    [sym_float] = ACTIONS(419),
    [sym_identifier] = ACTIONS(419),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_none] = ACTIONS(419),
    [anon_sym_await] = ACTIONS(421),
    [sym_comment] = ACTIONS(73),
  },
  [620] = {
    [sym__expression] = STATE(1095),
    [sym__primary_expression] = STATE(237),
    [sym_not_operator] = STATE(1095),
    [sym_boolean_operator] = STATE(1095),
    [sym_binary_operator] = STATE(237),
    [sym_unary_operator] = STATE(237),
    [sym_comparison_operator] = STATE(1095),
    [sym_lambda] = STATE(1095),
    [sym_attribute] = STATE(237),
    [sym_subscript] = STATE(237),
    [sym_call] = STATE(237),
    [sym_list] = STATE(237),
    [sym_list_comprehension] = STATE(237),
    [sym_dictionary] = STATE(237),
    [sym_dictionary_comprehension] = STATE(237),
    [sym_set] = STATE(237),
    [sym_set_comprehension] = STATE(237),
    [sym_parenthesized_expression] = STATE(237),
    [sym_tuple] = STATE(237),
    [sym_generator_expression] = STATE(237),
    [sym_conditional_expression] = STATE(1095),
    [sym_concatenated_string] = STATE(237),
    [sym_string] = STATE(238),
    [sym_await] = STATE(1095),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_lambda] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(419),
    [sym_float] = ACTIONS(419),
    [sym_identifier] = ACTIONS(419),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_none] = ACTIONS(419),
    [anon_sym_await] = ACTIONS(421),
    [sym_comment] = ACTIONS(73),
  },
  [621] = {
    [aux_sym_print_statement_repeat1] = STATE(1097),
    [anon_sym_RPAREN] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(2130),
    [sym_comment] = ACTIONS(73),
  },
  [622] = {
    [sym__primary_expression] = STATE(1098),
    [sym_binary_operator] = STATE(1098),
    [sym_unary_operator] = STATE(1098),
    [sym_attribute] = STATE(1098),
    [sym_subscript] = STATE(1098),
    [sym_call] = STATE(1098),
    [sym_list] = STATE(1098),
    [sym_list_comprehension] = STATE(1098),
    [sym_dictionary] = STATE(1098),
    [sym_dictionary_comprehension] = STATE(1098),
    [sym_set] = STATE(1098),
    [sym_set_comprehension] = STATE(1098),
    [sym_parenthesized_expression] = STATE(1098),
    [sym_tuple] = STATE(1098),
    [sym_generator_expression] = STATE(1098),
    [sym_concatenated_string] = STATE(1098),
    [sym_string] = STATE(238),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2132),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2134),
    [sym_float] = ACTIONS(2134),
    [sym_identifier] = ACTIONS(2134),
    [sym_true] = ACTIONS(2134),
    [sym_false] = ACTIONS(2134),
    [sym_none] = ACTIONS(2134),
    [sym_comment] = ACTIONS(73),
  },
  [623] = {
    [sym__primary_expression] = STATE(1099),
    [sym_binary_operator] = STATE(1099),
    [sym_unary_operator] = STATE(1099),
    [sym_attribute] = STATE(1099),
    [sym_subscript] = STATE(1099),
    [sym_call] = STATE(1099),
    [sym_list] = STATE(1099),
    [sym_list_comprehension] = STATE(1099),
    [sym_dictionary] = STATE(1099),
    [sym_dictionary_comprehension] = STATE(1099),
    [sym_set] = STATE(1099),
    [sym_set_comprehension] = STATE(1099),
    [sym_parenthesized_expression] = STATE(1099),
    [sym_tuple] = STATE(1099),
    [sym_generator_expression] = STATE(1099),
    [sym_concatenated_string] = STATE(1099),
    [sym_string] = STATE(238),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2136),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2138),
    [sym_float] = ACTIONS(2138),
    [sym_identifier] = ACTIONS(2138),
    [sym_true] = ACTIONS(2138),
    [sym_false] = ACTIONS(2138),
    [sym_none] = ACTIONS(2138),
    [sym_comment] = ACTIONS(73),
  },
  [624] = {
    [sym__primary_expression] = STATE(1100),
    [sym_binary_operator] = STATE(1100),
    [sym_unary_operator] = STATE(1100),
    [sym_attribute] = STATE(1100),
    [sym_subscript] = STATE(1100),
    [sym_call] = STATE(1100),
    [sym_list] = STATE(1100),
    [sym_list_comprehension] = STATE(1100),
    [sym_dictionary] = STATE(1100),
    [sym_dictionary_comprehension] = STATE(1100),
    [sym_set] = STATE(1100),
    [sym_set_comprehension] = STATE(1100),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_tuple] = STATE(1100),
    [sym_generator_expression] = STATE(1100),
    [sym_concatenated_string] = STATE(1100),
    [sym_string] = STATE(238),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2140),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2142),
    [sym_float] = ACTIONS(2142),
    [sym_identifier] = ACTIONS(2142),
    [sym_true] = ACTIONS(2142),
    [sym_false] = ACTIONS(2142),
    [sym_none] = ACTIONS(2142),
    [sym_comment] = ACTIONS(73),
  },
  [625] = {
    [anon_sym_in] = ACTIONS(2144),
    [sym_comment] = ACTIONS(73),
  },
  [626] = {
    [sym__primary_expression] = STATE(1102),
    [sym_binary_operator] = STATE(1102),
    [sym_unary_operator] = STATE(1102),
    [sym_attribute] = STATE(1102),
    [sym_subscript] = STATE(1102),
    [sym_call] = STATE(1102),
    [sym_list] = STATE(1102),
    [sym_list_comprehension] = STATE(1102),
    [sym_dictionary] = STATE(1102),
    [sym_dictionary_comprehension] = STATE(1102),
    [sym_set] = STATE(1102),
    [sym_set_comprehension] = STATE(1102),
    [sym_parenthesized_expression] = STATE(1102),
    [sym_tuple] = STATE(1102),
    [sym_generator_expression] = STATE(1102),
    [sym_concatenated_string] = STATE(1102),
    [sym_string] = STATE(238),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2146),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2148),
    [sym_float] = ACTIONS(2148),
    [sym_identifier] = ACTIONS(2148),
    [sym_true] = ACTIONS(2148),
    [sym_false] = ACTIONS(2148),
    [sym_none] = ACTIONS(2148),
    [sym_comment] = ACTIONS(73),
  },
  [627] = {
    [sym__primary_expression] = STATE(669),
    [sym_binary_operator] = STATE(669),
    [sym_unary_operator] = STATE(669),
    [sym_attribute] = STATE(669),
    [sym_subscript] = STATE(669),
    [sym_call] = STATE(669),
    [sym_list] = STATE(669),
    [sym_list_comprehension] = STATE(669),
    [sym_dictionary] = STATE(669),
    [sym_dictionary_comprehension] = STATE(669),
    [sym_set] = STATE(669),
    [sym_set_comprehension] = STATE(669),
    [sym_parenthesized_expression] = STATE(669),
    [sym_tuple] = STATE(669),
    [sym_generator_expression] = STATE(669),
    [sym_concatenated_string] = STATE(669),
    [sym_string] = STATE(238),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1282),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1284),
    [sym_float] = ACTIONS(1284),
    [sym_identifier] = ACTIONS(1284),
    [sym_true] = ACTIONS(1284),
    [sym_false] = ACTIONS(1284),
    [sym_none] = ACTIONS(1284),
    [sym_comment] = ACTIONS(73),
  },
  [628] = {
    [sym__primary_expression] = STATE(1103),
    [sym_binary_operator] = STATE(1103),
    [sym_unary_operator] = STATE(1103),
    [sym_attribute] = STATE(1103),
    [sym_subscript] = STATE(1103),
    [sym_call] = STATE(1103),
    [sym_list] = STATE(1103),
    [sym_list_comprehension] = STATE(1103),
    [sym_dictionary] = STATE(1103),
    [sym_dictionary_comprehension] = STATE(1103),
    [sym_set] = STATE(1103),
    [sym_set_comprehension] = STATE(1103),
    [sym_parenthesized_expression] = STATE(1103),
    [sym_tuple] = STATE(1103),
    [sym_generator_expression] = STATE(1103),
    [sym_concatenated_string] = STATE(1103),
    [sym_string] = STATE(238),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2150),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2152),
    [sym_float] = ACTIONS(2152),
    [sym_identifier] = ACTIONS(2152),
    [sym_true] = ACTIONS(2152),
    [sym_false] = ACTIONS(2152),
    [sym_none] = ACTIONS(2152),
    [sym_comment] = ACTIONS(73),
  },
  [629] = {
    [sym__primary_expression] = STATE(1104),
    [sym_binary_operator] = STATE(1104),
    [sym_unary_operator] = STATE(1104),
    [sym_attribute] = STATE(1104),
    [sym_subscript] = STATE(1104),
    [sym_call] = STATE(1104),
    [sym_list] = STATE(1104),
    [sym_list_comprehension] = STATE(1104),
    [sym_dictionary] = STATE(1104),
    [sym_dictionary_comprehension] = STATE(1104),
    [sym_set] = STATE(1104),
    [sym_set_comprehension] = STATE(1104),
    [sym_parenthesized_expression] = STATE(1104),
    [sym_tuple] = STATE(1104),
    [sym_generator_expression] = STATE(1104),
    [sym_concatenated_string] = STATE(1104),
    [sym_string] = STATE(238),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2154),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2156),
    [sym_float] = ACTIONS(2156),
    [sym_identifier] = ACTIONS(2156),
    [sym_true] = ACTIONS(2156),
    [sym_false] = ACTIONS(2156),
    [sym_none] = ACTIONS(2156),
    [sym_comment] = ACTIONS(73),
  },
  [630] = {
    [sym__primary_expression] = STATE(1105),
    [sym_binary_operator] = STATE(1105),
    [sym_unary_operator] = STATE(1105),
    [sym_attribute] = STATE(1105),
    [sym_subscript] = STATE(1105),
    [sym_call] = STATE(1105),
    [sym_list] = STATE(1105),
    [sym_list_comprehension] = STATE(1105),
    [sym_dictionary] = STATE(1105),
    [sym_dictionary_comprehension] = STATE(1105),
    [sym_set] = STATE(1105),
    [sym_set_comprehension] = STATE(1105),
    [sym_parenthesized_expression] = STATE(1105),
    [sym_tuple] = STATE(1105),
    [sym_generator_expression] = STATE(1105),
    [sym_concatenated_string] = STATE(1105),
    [sym_string] = STATE(238),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2158),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2160),
    [sym_float] = ACTIONS(2160),
    [sym_identifier] = ACTIONS(2160),
    [sym_true] = ACTIONS(2160),
    [sym_false] = ACTIONS(2160),
    [sym_none] = ACTIONS(2160),
    [sym_comment] = ACTIONS(73),
  },
  [631] = {
    [sym__primary_expression] = STATE(1100),
    [sym_binary_operator] = STATE(1100),
    [sym_unary_operator] = STATE(1100),
    [sym_attribute] = STATE(1100),
    [sym_subscript] = STATE(1100),
    [sym_call] = STATE(1100),
    [sym_list] = STATE(1100),
    [sym_list_comprehension] = STATE(1100),
    [sym_dictionary] = STATE(1100),
    [sym_dictionary_comprehension] = STATE(1100),
    [sym_set] = STATE(1100),
    [sym_set_comprehension] = STATE(1100),
    [sym_parenthesized_expression] = STATE(1100),
    [sym_tuple] = STATE(1100),
    [sym_generator_expression] = STATE(1100),
    [sym_concatenated_string] = STATE(1100),
    [sym_string] = STATE(238),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2162),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2140),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2142),
    [sym_float] = ACTIONS(2142),
    [sym_identifier] = ACTIONS(2142),
    [sym_true] = ACTIONS(2142),
    [sym_false] = ACTIONS(2142),
    [sym_none] = ACTIONS(2142),
    [sym_comment] = ACTIONS(73),
  },
  [632] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1106),
    [anon_sym_RPAREN] = ACTIONS(991),
    [anon_sym_COMMA] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(1208),
    [anon_sym_not] = ACTIONS(1212),
    [anon_sym_and] = ACTIONS(991),
    [anon_sym_or] = ACTIONS(991),
    [anon_sym_LT] = ACTIONS(1224),
    [anon_sym_LT_EQ] = ACTIONS(1208),
    [anon_sym_EQ_EQ] = ACTIONS(1208),
    [anon_sym_BANG_EQ] = ACTIONS(1208),
    [anon_sym_GT_EQ] = ACTIONS(1208),
    [anon_sym_GT] = ACTIONS(1224),
    [anon_sym_LT_GT] = ACTIONS(1208),
    [anon_sym_is] = ACTIONS(1226),
    [sym_comment] = ACTIONS(73),
  },
  [633] = {
    [sym_string] = STATE(1107),
    [aux_sym_concatenated_string_repeat1] = STATE(1107),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_RPAREN] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_in] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(995),
    [anon_sym_not] = ACTIONS(995),
    [anon_sym_and] = ACTIONS(995),
    [anon_sym_or] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(995),
    [anon_sym_SLASH_SLASH] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_GT] = ACTIONS(995),
    [anon_sym_is] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(995),
    [sym_comment] = ACTIONS(73),
  },
  [634] = {
    [anon_sym_DOT] = ACTIONS(1680),
    [anon_sym_LPAREN] = ACTIONS(1680),
    [anon_sym_RPAREN] = ACTIONS(1680),
    [anon_sym_COMMA] = ACTIONS(1680),
    [anon_sym_as] = ACTIONS(1682),
    [anon_sym_STAR] = ACTIONS(1682),
    [anon_sym_GT_GT] = ACTIONS(1680),
    [anon_sym_if] = ACTIONS(1680),
    [anon_sym_COLON] = ACTIONS(1680),
    [anon_sym_else] = ACTIONS(1680),
    [anon_sym_async] = ACTIONS(1680),
    [anon_sym_for] = ACTIONS(1680),
    [anon_sym_in] = ACTIONS(1680),
    [anon_sym_EQ] = ACTIONS(1682),
    [anon_sym_AT] = ACTIONS(1680),
    [anon_sym_not] = ACTIONS(1680),
    [anon_sym_and] = ACTIONS(1680),
    [anon_sym_or] = ACTIONS(1680),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_DASH] = ACTIONS(1680),
    [anon_sym_SLASH] = ACTIONS(1682),
    [anon_sym_PERCENT] = ACTIONS(1680),
    [anon_sym_SLASH_SLASH] = ACTIONS(1680),
    [anon_sym_STAR_STAR] = ACTIONS(1680),
    [anon_sym_PIPE] = ACTIONS(1680),
    [anon_sym_AMP] = ACTIONS(1680),
    [anon_sym_CARET] = ACTIONS(1680),
    [anon_sym_LT_LT] = ACTIONS(1680),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_LT_EQ] = ACTIONS(1680),
    [anon_sym_EQ_EQ] = ACTIONS(1680),
    [anon_sym_BANG_EQ] = ACTIONS(1680),
    [anon_sym_GT_EQ] = ACTIONS(1680),
    [anon_sym_GT] = ACTIONS(1682),
    [anon_sym_LT_GT] = ACTIONS(1680),
    [anon_sym_is] = ACTIONS(1680),
    [anon_sym_LBRACK] = ACTIONS(1680),
    [anon_sym_RBRACK] = ACTIONS(1680),
    [anon_sym_RBRACE] = ACTIONS(1680),
    [sym_type_conversion] = ACTIONS(1680),
    [sym_comment] = ACTIONS(73),
  },
  [635] = {
    [sym_list_splat] = STATE(914),
    [sym__expression] = STATE(915),
    [sym__primary_expression] = STATE(452),
    [sym_not_operator] = STATE(915),
    [sym_boolean_operator] = STATE(915),
    [sym_binary_operator] = STATE(452),
    [sym_unary_operator] = STATE(452),
    [sym_comparison_operator] = STATE(915),
    [sym_lambda] = STATE(915),
    [sym_attribute] = STATE(452),
    [sym_subscript] = STATE(452),
    [sym_call] = STATE(452),
    [sym_list] = STATE(452),
    [sym_list_comprehension] = STATE(452),
    [sym_dictionary] = STATE(452),
    [sym_dictionary_comprehension] = STATE(452),
    [sym_set] = STATE(452),
    [sym_set_comprehension] = STATE(452),
    [sym_parenthesized_expression] = STATE(452),
    [sym_tuple] = STATE(452),
    [sym_generator_expression] = STATE(452),
    [sym_conditional_expression] = STATE(915),
    [sym_concatenated_string] = STATE(452),
    [sym_string] = STATE(453),
    [sym_await] = STATE(915),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(243),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_lambda] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(2164),
    [sym_ellipsis] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(773),
    [sym_float] = ACTIONS(773),
    [sym_identifier] = ACTIONS(773),
    [sym_true] = ACTIONS(773),
    [sym_false] = ACTIONS(773),
    [sym_none] = ACTIONS(773),
    [anon_sym_await] = ACTIONS(775),
    [sym_comment] = ACTIONS(73),
  },
  [636] = {
    [aux_sym_list_repeat1] = STATE(917),
    [anon_sym_COMMA] = ACTIONS(2166),
    [anon_sym_RBRACK] = ACTIONS(2164),
    [sym_comment] = ACTIONS(73),
  },
  [637] = {
    [anon_sym_RBRACK] = ACTIONS(2168),
    [sym_comment] = ACTIONS(73),
  },
  [638] = {
    [anon_sym_DOT] = ACTIONS(1760),
    [anon_sym_LPAREN] = ACTIONS(1760),
    [anon_sym_RPAREN] = ACTIONS(1760),
    [anon_sym_COMMA] = ACTIONS(1760),
    [anon_sym_as] = ACTIONS(1762),
    [anon_sym_STAR] = ACTIONS(1762),
    [anon_sym_GT_GT] = ACTIONS(1760),
    [anon_sym_if] = ACTIONS(1760),
    [anon_sym_COLON] = ACTIONS(1760),
    [anon_sym_else] = ACTIONS(1760),
    [anon_sym_async] = ACTIONS(1760),
    [anon_sym_for] = ACTIONS(1760),
    [anon_sym_in] = ACTIONS(1760),
    [anon_sym_EQ] = ACTIONS(1762),
    [anon_sym_AT] = ACTIONS(1760),
    [anon_sym_not] = ACTIONS(1760),
    [anon_sym_and] = ACTIONS(1760),
    [anon_sym_or] = ACTIONS(1760),
    [anon_sym_PLUS] = ACTIONS(1760),
    [anon_sym_DASH] = ACTIONS(1760),
    [anon_sym_SLASH] = ACTIONS(1762),
    [anon_sym_PERCENT] = ACTIONS(1760),
    [anon_sym_SLASH_SLASH] = ACTIONS(1760),
    [anon_sym_STAR_STAR] = ACTIONS(1760),
    [anon_sym_PIPE] = ACTIONS(1760),
    [anon_sym_AMP] = ACTIONS(1760),
    [anon_sym_CARET] = ACTIONS(1760),
    [anon_sym_LT_LT] = ACTIONS(1760),
    [anon_sym_LT] = ACTIONS(1762),
    [anon_sym_LT_EQ] = ACTIONS(1760),
    [anon_sym_EQ_EQ] = ACTIONS(1760),
    [anon_sym_BANG_EQ] = ACTIONS(1760),
    [anon_sym_GT_EQ] = ACTIONS(1760),
    [anon_sym_GT] = ACTIONS(1762),
    [anon_sym_LT_GT] = ACTIONS(1760),
    [anon_sym_is] = ACTIONS(1760),
    [anon_sym_LBRACK] = ACTIONS(1760),
    [anon_sym_RBRACK] = ACTIONS(1760),
    [anon_sym_RBRACE] = ACTIONS(1760),
    [sym_type_conversion] = ACTIONS(1760),
    [sym_comment] = ACTIONS(73),
  },
  [639] = {
    [sym_list_splat] = STATE(914),
    [sym__expression] = STATE(958),
    [sym__primary_expression] = STATE(485),
    [sym_not_operator] = STATE(958),
    [sym_boolean_operator] = STATE(958),
    [sym_binary_operator] = STATE(485),
    [sym_unary_operator] = STATE(485),
    [sym_comparison_operator] = STATE(958),
    [sym_lambda] = STATE(958),
    [sym_attribute] = STATE(485),
    [sym_subscript] = STATE(485),
    [sym_call] = STATE(485),
    [sym_list] = STATE(485),
    [sym_list_comprehension] = STATE(485),
    [sym_dictionary] = STATE(485),
    [sym_dictionary_comprehension] = STATE(485),
    [sym_set] = STATE(485),
    [sym_set_comprehension] = STATE(485),
    [sym_parenthesized_expression] = STATE(485),
    [sym_tuple] = STATE(485),
    [sym_generator_expression] = STATE(485),
    [sym_conditional_expression] = STATE(958),
    [sym_concatenated_string] = STATE(485),
    [sym_string] = STATE(486),
    [sym_await] = STATE(958),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(1798),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(823),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_TILDE] = ACTIONS(825),
    [anon_sym_lambda] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(829),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(2170),
    [sym_integer] = ACTIONS(831),
    [sym_float] = ACTIONS(831),
    [sym_identifier] = ACTIONS(831),
    [sym_true] = ACTIONS(831),
    [sym_false] = ACTIONS(831),
    [sym_none] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [sym_comment] = ACTIONS(73),
  },
  [640] = {
    [anon_sym_DOT] = ACTIONS(1802),
    [anon_sym_LPAREN] = ACTIONS(1802),
    [anon_sym_RPAREN] = ACTIONS(1802),
    [anon_sym_COMMA] = ACTIONS(1802),
    [anon_sym_as] = ACTIONS(1804),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_GT_GT] = ACTIONS(1802),
    [anon_sym_if] = ACTIONS(1802),
    [anon_sym_COLON] = ACTIONS(1802),
    [anon_sym_else] = ACTIONS(1802),
    [anon_sym_async] = ACTIONS(1802),
    [anon_sym_for] = ACTIONS(1802),
    [anon_sym_in] = ACTIONS(1802),
    [anon_sym_EQ] = ACTIONS(1804),
    [anon_sym_AT] = ACTIONS(1802),
    [anon_sym_not] = ACTIONS(1802),
    [anon_sym_and] = ACTIONS(1802),
    [anon_sym_or] = ACTIONS(1802),
    [anon_sym_PLUS] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(1802),
    [anon_sym_SLASH] = ACTIONS(1804),
    [anon_sym_PERCENT] = ACTIONS(1802),
    [anon_sym_SLASH_SLASH] = ACTIONS(1802),
    [anon_sym_STAR_STAR] = ACTIONS(1802),
    [anon_sym_PIPE] = ACTIONS(1802),
    [anon_sym_AMP] = ACTIONS(1802),
    [anon_sym_CARET] = ACTIONS(1802),
    [anon_sym_LT_LT] = ACTIONS(1802),
    [anon_sym_LT] = ACTIONS(1804),
    [anon_sym_LT_EQ] = ACTIONS(1802),
    [anon_sym_EQ_EQ] = ACTIONS(1802),
    [anon_sym_BANG_EQ] = ACTIONS(1802),
    [anon_sym_GT_EQ] = ACTIONS(1802),
    [anon_sym_GT] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(1802),
    [anon_sym_is] = ACTIONS(1802),
    [anon_sym_LBRACK] = ACTIONS(1802),
    [anon_sym_RBRACK] = ACTIONS(1802),
    [anon_sym_RBRACE] = ACTIONS(1802),
    [sym_type_conversion] = ACTIONS(1802),
    [sym_comment] = ACTIONS(73),
  },
  [641] = {
    [aux_sym_list_repeat1] = STATE(960),
    [anon_sym_COMMA] = ACTIONS(2172),
    [anon_sym_RBRACE] = ACTIONS(2170),
    [sym_comment] = ACTIONS(73),
  },
  [642] = {
    [sym_dictionary_splat] = STATE(963),
    [sym__expression] = STATE(964),
    [sym__primary_expression] = STATE(102),
    [sym_not_operator] = STATE(964),
    [sym_boolean_operator] = STATE(964),
    [sym_binary_operator] = STATE(102),
    [sym_unary_operator] = STATE(102),
    [sym_comparison_operator] = STATE(964),
    [sym_lambda] = STATE(964),
    [sym_attribute] = STATE(102),
    [sym_subscript] = STATE(102),
    [sym_call] = STATE(102),
    [sym_list] = STATE(102),
    [sym_list_comprehension] = STATE(102),
    [sym_dictionary] = STATE(102),
    [sym_dictionary_comprehension] = STATE(102),
    [sym_pair] = STATE(963),
    [sym_set] = STATE(102),
    [sym_set_comprehension] = STATE(102),
    [sym_parenthesized_expression] = STATE(102),
    [sym_tuple] = STATE(102),
    [sym_generator_expression] = STATE(102),
    [sym_conditional_expression] = STATE(964),
    [sym_concatenated_string] = STATE(102),
    [sym_string] = STATE(103),
    [sym_await] = STATE(964),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(1808),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(2174),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [643] = {
    [aux_sym_dictionary_repeat1] = STATE(966),
    [anon_sym_COMMA] = ACTIONS(2176),
    [anon_sym_RBRACE] = ACTIONS(2174),
    [sym_comment] = ACTIONS(73),
  },
  [644] = {
    [anon_sym_RBRACE] = ACTIONS(2178),
    [sym_comment] = ACTIONS(73),
  },
  [645] = {
    [anon_sym_RBRACE] = ACTIONS(2180),
    [sym_comment] = ACTIONS(73),
  },
  [646] = {
    [sym__newline] = ACTIONS(2182),
    [anon_sym_DOT] = ACTIONS(2182),
    [anon_sym_LPAREN] = ACTIONS(2182),
    [anon_sym_COMMA] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(2184),
    [anon_sym_GT_GT] = ACTIONS(2184),
    [anon_sym_if] = ACTIONS(2182),
    [anon_sym_COLON] = ACTIONS(2182),
    [anon_sym_in] = ACTIONS(2182),
    [anon_sym_EQ] = ACTIONS(2184),
    [anon_sym_AT] = ACTIONS(2184),
    [anon_sym_not] = ACTIONS(2182),
    [anon_sym_and] = ACTIONS(2182),
    [anon_sym_or] = ACTIONS(2182),
    [anon_sym_PLUS] = ACTIONS(2184),
    [anon_sym_DASH] = ACTIONS(2184),
    [anon_sym_SLASH] = ACTIONS(2184),
    [anon_sym_PERCENT] = ACTIONS(2184),
    [anon_sym_SLASH_SLASH] = ACTIONS(2184),
    [anon_sym_STAR_STAR] = ACTIONS(2184),
    [anon_sym_PIPE] = ACTIONS(2184),
    [anon_sym_AMP] = ACTIONS(2184),
    [anon_sym_CARET] = ACTIONS(2184),
    [anon_sym_LT_LT] = ACTIONS(2184),
    [anon_sym_LT] = ACTIONS(2184),
    [anon_sym_LT_EQ] = ACTIONS(2182),
    [anon_sym_EQ_EQ] = ACTIONS(2182),
    [anon_sym_BANG_EQ] = ACTIONS(2182),
    [anon_sym_GT_EQ] = ACTIONS(2182),
    [anon_sym_GT] = ACTIONS(2184),
    [anon_sym_LT_GT] = ACTIONS(2182),
    [anon_sym_is] = ACTIONS(2182),
    [anon_sym_PLUS_EQ] = ACTIONS(2182),
    [anon_sym_DASH_EQ] = ACTIONS(2182),
    [anon_sym_STAR_EQ] = ACTIONS(2182),
    [anon_sym_SLASH_EQ] = ACTIONS(2182),
    [anon_sym_AT_EQ] = ACTIONS(2182),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2182),
    [anon_sym_PERCENT_EQ] = ACTIONS(2182),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2182),
    [anon_sym_GT_GT_EQ] = ACTIONS(2182),
    [anon_sym_LT_LT_EQ] = ACTIONS(2182),
    [anon_sym_AMP_EQ] = ACTIONS(2182),
    [anon_sym_CARET_EQ] = ACTIONS(2182),
    [anon_sym_PIPE_EQ] = ACTIONS(2182),
    [anon_sym_LBRACK] = ACTIONS(2182),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2182),
  },
  [647] = {
    [anon_sym_RPAREN] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [anon_sym_if] = ACTIONS(1198),
    [anon_sym_and] = ACTIONS(1200),
    [anon_sym_or] = ACTIONS(1202),
    [sym_comment] = ACTIONS(73),
  },
  [648] = {
    [anon_sym_RPAREN] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2186),
    [sym_comment] = ACTIONS(73),
  },
  [649] = {
    [anon_sym_if] = ACTIONS(1925),
    [anon_sym_else] = ACTIONS(2188),
    [anon_sym_and] = ACTIONS(1929),
    [anon_sym_or] = ACTIONS(1931),
    [sym_comment] = ACTIONS(73),
  },
  [650] = {
    [sym_variables] = STATE(1118),
    [sym__primary_expression] = STATE(109),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(110),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(191),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(193),
    [sym_float] = ACTIONS(193),
    [sym_identifier] = ACTIONS(193),
    [sym_true] = ACTIONS(193),
    [sym_false] = ACTIONS(193),
    [sym_none] = ACTIONS(193),
    [sym_comment] = ACTIONS(73),
  },
  [651] = {
    [anon_sym_in] = ACTIONS(2190),
    [sym_comment] = ACTIONS(73),
  },
  [652] = {
    [anon_sym_RPAREN] = ACTIONS(1957),
    [anon_sym_COMMA] = ACTIONS(1957),
    [anon_sym_as] = ACTIONS(2192),
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_COLON] = ACTIONS(1957),
    [anon_sym_else] = ACTIONS(1957),
    [anon_sym_async] = ACTIONS(1957),
    [anon_sym_for] = ACTIONS(1957),
    [anon_sym_EQ] = ACTIONS(1957),
    [anon_sym_and] = ACTIONS(1957),
    [anon_sym_or] = ACTIONS(1957),
    [anon_sym_RBRACK] = ACTIONS(1957),
    [anon_sym_RBRACE] = ACTIONS(1957),
    [sym_type_conversion] = ACTIONS(1957),
    [sym_comment] = ACTIONS(73),
  },
  [653] = {
    [anon_sym_RPAREN] = ACTIONS(1957),
    [anon_sym_COMMA] = ACTIONS(1957),
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_async] = ACTIONS(1957),
    [anon_sym_for] = ACTIONS(1957),
    [anon_sym_and] = ACTIONS(441),
    [anon_sym_or] = ACTIONS(1957),
    [sym_comment] = ACTIONS(73),
  },
  [654] = {
    [sym__newline] = ACTIONS(2194),
    [anon_sym_DOT] = ACTIONS(2194),
    [anon_sym_LPAREN] = ACTIONS(2194),
    [anon_sym_COMMA] = ACTIONS(2194),
    [anon_sym_STAR] = ACTIONS(2196),
    [anon_sym_GT_GT] = ACTIONS(2196),
    [anon_sym_if] = ACTIONS(2194),
    [anon_sym_COLON] = ACTIONS(2194),
    [anon_sym_in] = ACTIONS(2194),
    [anon_sym_EQ] = ACTIONS(2196),
    [anon_sym_AT] = ACTIONS(2196),
    [anon_sym_not] = ACTIONS(2194),
    [anon_sym_and] = ACTIONS(2194),
    [anon_sym_or] = ACTIONS(2194),
    [anon_sym_PLUS] = ACTIONS(2196),
    [anon_sym_DASH] = ACTIONS(2196),
    [anon_sym_SLASH] = ACTIONS(2196),
    [anon_sym_PERCENT] = ACTIONS(2196),
    [anon_sym_SLASH_SLASH] = ACTIONS(2196),
    [anon_sym_STAR_STAR] = ACTIONS(2196),
    [anon_sym_PIPE] = ACTIONS(2196),
    [anon_sym_AMP] = ACTIONS(2196),
    [anon_sym_CARET] = ACTIONS(2196),
    [anon_sym_LT_LT] = ACTIONS(2196),
    [anon_sym_LT] = ACTIONS(2196),
    [anon_sym_LT_EQ] = ACTIONS(2194),
    [anon_sym_EQ_EQ] = ACTIONS(2194),
    [anon_sym_BANG_EQ] = ACTIONS(2194),
    [anon_sym_GT_EQ] = ACTIONS(2194),
    [anon_sym_GT] = ACTIONS(2196),
    [anon_sym_LT_GT] = ACTIONS(2194),
    [anon_sym_is] = ACTIONS(2194),
    [anon_sym_PLUS_EQ] = ACTIONS(2194),
    [anon_sym_DASH_EQ] = ACTIONS(2194),
    [anon_sym_STAR_EQ] = ACTIONS(2194),
    [anon_sym_SLASH_EQ] = ACTIONS(2194),
    [anon_sym_AT_EQ] = ACTIONS(2194),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2194),
    [anon_sym_PERCENT_EQ] = ACTIONS(2194),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2194),
    [anon_sym_GT_GT_EQ] = ACTIONS(2194),
    [anon_sym_LT_LT_EQ] = ACTIONS(2194),
    [anon_sym_AMP_EQ] = ACTIONS(2194),
    [anon_sym_CARET_EQ] = ACTIONS(2194),
    [anon_sym_PIPE_EQ] = ACTIONS(2194),
    [anon_sym_LBRACK] = ACTIONS(2194),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2194),
  },
  [655] = {
    [sym__expression] = STATE(1124),
    [sym__primary_expression] = STATE(1125),
    [sym_not_operator] = STATE(1124),
    [sym_boolean_operator] = STATE(1124),
    [sym_binary_operator] = STATE(1125),
    [sym_unary_operator] = STATE(1125),
    [sym_comparison_operator] = STATE(1124),
    [sym_lambda] = STATE(1124),
    [sym_attribute] = STATE(1125),
    [sym_subscript] = STATE(1125),
    [sym_call] = STATE(1125),
    [sym_list] = STATE(1125),
    [sym_list_comprehension] = STATE(1125),
    [sym_dictionary] = STATE(1125),
    [sym_dictionary_comprehension] = STATE(1125),
    [sym_set] = STATE(1125),
    [sym_set_comprehension] = STATE(1125),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_tuple] = STATE(1125),
    [sym_generator_expression] = STATE(1125),
    [sym_conditional_expression] = STATE(1124),
    [sym_concatenated_string] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_await] = STATE(1124),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2198),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2200),
    [anon_sym_TILDE] = ACTIONS(2200),
    [anon_sym_lambda] = ACTIONS(2202),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2204),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2206),
    [sym_float] = ACTIONS(2206),
    [sym_identifier] = ACTIONS(2206),
    [sym_true] = ACTIONS(2206),
    [sym_false] = ACTIONS(2206),
    [sym_none] = ACTIONS(2206),
    [anon_sym_await] = ACTIONS(2208),
    [sym_comment] = ACTIONS(73),
  },
  [656] = {
    [sym_for_in_clause] = STATE(1127),
    [sym_if_clause] = STATE(1127),
    [aux_sym__comprehension_body_repeat1] = STATE(1127),
    [anon_sym_RPAREN] = ACTIONS(2210),
    [anon_sym_if] = ACTIONS(1254),
    [anon_sym_async] = ACTIONS(437),
    [anon_sym_for] = ACTIONS(439),
    [sym_comment] = ACTIONS(73),
  },
  [657] = {
    [sym__expression] = STATE(647),
    [sym__primary_expression] = STATE(237),
    [sym_not_operator] = STATE(647),
    [sym_boolean_operator] = STATE(647),
    [sym_binary_operator] = STATE(237),
    [sym_unary_operator] = STATE(237),
    [sym_comparison_operator] = STATE(647),
    [sym_lambda] = STATE(647),
    [sym_yield] = STATE(648),
    [sym_attribute] = STATE(237),
    [sym_subscript] = STATE(237),
    [sym_call] = STATE(237),
    [sym_list] = STATE(237),
    [sym_list_comprehension] = STATE(237),
    [sym_dictionary] = STATE(237),
    [sym_dictionary_comprehension] = STATE(237),
    [sym_set] = STATE(237),
    [sym_set_comprehension] = STATE(237),
    [sym_parenthesized_expression] = STATE(237),
    [sym_tuple] = STATE(237),
    [sym_generator_expression] = STATE(237),
    [sym_conditional_expression] = STATE(647),
    [sym_concatenated_string] = STATE(237),
    [sym_string] = STATE(238),
    [sym_await] = STATE(647),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(2212),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_lambda] = ACTIONS(415),
    [anon_sym_yield] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(419),
    [sym_float] = ACTIONS(419),
    [sym_identifier] = ACTIONS(419),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_none] = ACTIONS(419),
    [anon_sym_await] = ACTIONS(421),
    [sym_comment] = ACTIONS(73),
  },
  [658] = {
    [aux_sym_tuple_repeat1] = STATE(658),
    [anon_sym_RPAREN] = ACTIONS(2186),
    [anon_sym_COMMA] = ACTIONS(2214),
    [sym_comment] = ACTIONS(73),
  },
  [659] = {
    [anon_sym_DOT] = ACTIONS(1966),
    [anon_sym_LPAREN] = ACTIONS(1966),
    [anon_sym_RPAREN] = ACTIONS(1966),
    [anon_sym_COMMA] = ACTIONS(1966),
    [anon_sym_as] = ACTIONS(1968),
    [anon_sym_STAR] = ACTIONS(1968),
    [anon_sym_GT_GT] = ACTIONS(1966),
    [anon_sym_if] = ACTIONS(1966),
    [anon_sym_COLON] = ACTIONS(1966),
    [anon_sym_else] = ACTIONS(1966),
    [anon_sym_async] = ACTIONS(1966),
    [anon_sym_for] = ACTIONS(1966),
    [anon_sym_in] = ACTIONS(1966),
    [anon_sym_EQ] = ACTIONS(1968),
    [anon_sym_AT] = ACTIONS(1966),
    [anon_sym_not] = ACTIONS(1966),
    [anon_sym_and] = ACTIONS(1966),
    [anon_sym_or] = ACTIONS(1966),
    [anon_sym_PLUS] = ACTIONS(1966),
    [anon_sym_DASH] = ACTIONS(1966),
    [anon_sym_SLASH] = ACTIONS(1968),
    [anon_sym_PERCENT] = ACTIONS(1966),
    [anon_sym_SLASH_SLASH] = ACTIONS(1966),
    [anon_sym_STAR_STAR] = ACTIONS(1966),
    [anon_sym_PIPE] = ACTIONS(1966),
    [anon_sym_AMP] = ACTIONS(1966),
    [anon_sym_CARET] = ACTIONS(1966),
    [anon_sym_LT_LT] = ACTIONS(1966),
    [anon_sym_LT] = ACTIONS(1968),
    [anon_sym_LT_EQ] = ACTIONS(1966),
    [anon_sym_EQ_EQ] = ACTIONS(1966),
    [anon_sym_BANG_EQ] = ACTIONS(1966),
    [anon_sym_GT_EQ] = ACTIONS(1966),
    [anon_sym_GT] = ACTIONS(1968),
    [anon_sym_LT_GT] = ACTIONS(1966),
    [anon_sym_is] = ACTIONS(1966),
    [anon_sym_LBRACK] = ACTIONS(1966),
    [anon_sym_RBRACK] = ACTIONS(1966),
    [anon_sym_RBRACE] = ACTIONS(1966),
    [sym_type_conversion] = ACTIONS(1966),
    [sym_comment] = ACTIONS(73),
  },
  [660] = {
    [anon_sym_DOT] = ACTIONS(1970),
    [anon_sym_LPAREN] = ACTIONS(1970),
    [anon_sym_RPAREN] = ACTIONS(1970),
    [anon_sym_COMMA] = ACTIONS(1970),
    [anon_sym_as] = ACTIONS(1972),
    [anon_sym_STAR] = ACTIONS(1972),
    [anon_sym_GT_GT] = ACTIONS(1970),
    [anon_sym_if] = ACTIONS(1970),
    [anon_sym_COLON] = ACTIONS(1970),
    [anon_sym_else] = ACTIONS(1970),
    [anon_sym_async] = ACTIONS(1970),
    [anon_sym_for] = ACTIONS(1970),
    [anon_sym_in] = ACTIONS(1970),
    [anon_sym_EQ] = ACTIONS(1972),
    [anon_sym_AT] = ACTIONS(1970),
    [anon_sym_not] = ACTIONS(1970),
    [anon_sym_and] = ACTIONS(1970),
    [anon_sym_or] = ACTIONS(1970),
    [anon_sym_PLUS] = ACTIONS(1970),
    [anon_sym_DASH] = ACTIONS(1970),
    [anon_sym_SLASH] = ACTIONS(1972),
    [anon_sym_PERCENT] = ACTIONS(1970),
    [anon_sym_SLASH_SLASH] = ACTIONS(1970),
    [anon_sym_STAR_STAR] = ACTIONS(1970),
    [anon_sym_PIPE] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(1970),
    [anon_sym_CARET] = ACTIONS(1970),
    [anon_sym_LT_LT] = ACTIONS(1970),
    [anon_sym_LT] = ACTIONS(1972),
    [anon_sym_LT_EQ] = ACTIONS(1970),
    [anon_sym_EQ_EQ] = ACTIONS(1970),
    [anon_sym_BANG_EQ] = ACTIONS(1970),
    [anon_sym_GT_EQ] = ACTIONS(1970),
    [anon_sym_GT] = ACTIONS(1972),
    [anon_sym_LT_GT] = ACTIONS(1970),
    [anon_sym_is] = ACTIONS(1970),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [anon_sym_RBRACK] = ACTIONS(1970),
    [anon_sym_RBRACE] = ACTIONS(1970),
    [sym_type_conversion] = ACTIONS(1970),
    [sym_comment] = ACTIONS(73),
  },
  [661] = {
    [anon_sym_RPAREN] = ACTIONS(2217),
    [sym_comment] = ACTIONS(73),
  },
  [662] = {
    [aux_sym_argument_list_repeat1] = STATE(1132),
    [anon_sym_RPAREN] = ACTIONS(2217),
    [anon_sym_COMMA] = ACTIONS(2219),
    [sym_comment] = ACTIONS(73),
  },
  [663] = {
    [sym__comprehension_body] = STATE(609),
    [sym_for_in_clause] = STATE(258),
    [aux_sym_argument_list_repeat1] = STATE(1132),
    [anon_sym_RPAREN] = ACTIONS(2217),
    [anon_sym_COMMA] = ACTIONS(2219),
    [anon_sym_if] = ACTIONS(435),
    [anon_sym_async] = ACTIONS(437),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_and] = ACTIONS(441),
    [anon_sym_or] = ACTIONS(443),
    [sym_comment] = ACTIONS(73),
  },
  [664] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1984),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1986),
    [anon_sym_PERCENT] = ACTIONS(1984),
    [anon_sym_SLASH_SLASH] = ACTIONS(1984),
    [anon_sym_STAR_STAR] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [665] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(449),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(455),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_PERCENT] = ACTIONS(455),
    [anon_sym_SLASH_SLASH] = ACTIONS(455),
    [anon_sym_STAR_STAR] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [666] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(1988),
    [anon_sym_COMMA] = ACTIONS(1988),
    [anon_sym_STAR] = ACTIONS(449),
    [anon_sym_GT_GT] = ACTIONS(451),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_async] = ACTIONS(1988),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(1988),
    [anon_sym_AT] = ACTIONS(455),
    [anon_sym_not] = ACTIONS(1988),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_PERCENT] = ACTIONS(455),
    [anon_sym_SLASH_SLASH] = ACTIONS(455),
    [anon_sym_STAR_STAR] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_CARET] = ACTIONS(467),
    [anon_sym_LT_LT] = ACTIONS(451),
    [anon_sym_LT] = ACTIONS(1990),
    [anon_sym_LT_EQ] = ACTIONS(1988),
    [anon_sym_EQ_EQ] = ACTIONS(1988),
    [anon_sym_BANG_EQ] = ACTIONS(1988),
    [anon_sym_GT_EQ] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1990),
    [anon_sym_LT_GT] = ACTIONS(1988),
    [anon_sym_is] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(473),
    [sym_comment] = ACTIONS(73),
  },
  [667] = {
    [sym__primary_expression] = STATE(1133),
    [sym_binary_operator] = STATE(1133),
    [sym_unary_operator] = STATE(1133),
    [sym_attribute] = STATE(1133),
    [sym_subscript] = STATE(1133),
    [sym_call] = STATE(1133),
    [sym_list] = STATE(1133),
    [sym_list_comprehension] = STATE(1133),
    [sym_dictionary] = STATE(1133),
    [sym_dictionary_comprehension] = STATE(1133),
    [sym_set] = STATE(1133),
    [sym_set_comprehension] = STATE(1133),
    [sym_parenthesized_expression] = STATE(1133),
    [sym_tuple] = STATE(1133),
    [sym_generator_expression] = STATE(1133),
    [sym_concatenated_string] = STATE(1133),
    [sym_string] = STATE(69),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2221),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2223),
    [sym_float] = ACTIONS(2223),
    [sym_identifier] = ACTIONS(2223),
    [sym_true] = ACTIONS(2223),
    [sym_false] = ACTIONS(2223),
    [sym_none] = ACTIONS(2223),
    [sym_comment] = ACTIONS(73),
  },
  [668] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(449),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(455),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_PERCENT] = ACTIONS(455),
    [anon_sym_SLASH_SLASH] = ACTIONS(455),
    [anon_sym_STAR_STAR] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [669] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_as] = ACTIONS(1986),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_else] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(1984),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1986),
    [anon_sym_PERCENT] = ACTIONS(1984),
    [anon_sym_SLASH_SLASH] = ACTIONS(1984),
    [anon_sym_STAR_STAR] = ACTIONS(1984),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACK] = ACTIONS(1984),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [sym_type_conversion] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [670] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(449),
    [anon_sym_GT_GT] = ACTIONS(451),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(455),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_PERCENT] = ACTIONS(455),
    [anon_sym_SLASH_SLASH] = ACTIONS(455),
    [anon_sym_STAR_STAR] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_CARET] = ACTIONS(467),
    [anon_sym_LT_LT] = ACTIONS(451),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [671] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(449),
    [anon_sym_GT_GT] = ACTIONS(451),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(455),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_PERCENT] = ACTIONS(455),
    [anon_sym_SLASH_SLASH] = ACTIONS(455),
    [anon_sym_STAR_STAR] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(467),
    [anon_sym_LT_LT] = ACTIONS(451),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [672] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(449),
    [anon_sym_GT_GT] = ACTIONS(451),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(455),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_PERCENT] = ACTIONS(455),
    [anon_sym_SLASH_SLASH] = ACTIONS(455),
    [anon_sym_STAR_STAR] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(451),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [673] = {
    [aux_sym_subscript_repeat1] = STATE(1136),
    [anon_sym_COMMA] = ACTIONS(2225),
    [anon_sym_if] = ACTIONS(2004),
    [anon_sym_COLON] = ACTIONS(2006),
    [anon_sym_and] = ACTIONS(2008),
    [anon_sym_or] = ACTIONS(2010),
    [anon_sym_RBRACK] = ACTIONS(2227),
    [sym_comment] = ACTIONS(73),
  },
  [674] = {
    [aux_sym_subscript_repeat1] = STATE(1136),
    [anon_sym_COMMA] = ACTIONS(2225),
    [anon_sym_RBRACK] = ACTIONS(2227),
    [sym_comment] = ACTIONS(73),
  },
  [675] = {
    [aux_sym_comparison_operator_repeat1] = STATE(675),
    [anon_sym_RPAREN] = ACTIONS(1988),
    [anon_sym_COMMA] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_async] = ACTIONS(1988),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(2229),
    [anon_sym_not] = ACTIONS(2232),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(2235),
    [anon_sym_LT_EQ] = ACTIONS(2229),
    [anon_sym_EQ_EQ] = ACTIONS(2229),
    [anon_sym_BANG_EQ] = ACTIONS(2229),
    [anon_sym_GT_EQ] = ACTIONS(2229),
    [anon_sym_GT] = ACTIONS(2235),
    [anon_sym_LT_GT] = ACTIONS(2229),
    [anon_sym_is] = ACTIONS(2238),
    [sym_comment] = ACTIONS(73),
  },
  [676] = {
    [sym_string] = STATE(676),
    [aux_sym_concatenated_string_repeat1] = STATE(676),
    [sym__string_start] = ACTIONS(2241),
    [anon_sym_DOT] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(2050),
    [anon_sym_RPAREN] = ACTIONS(2050),
    [anon_sym_COMMA] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2050),
    [anon_sym_if] = ACTIONS(2050),
    [anon_sym_async] = ACTIONS(2050),
    [anon_sym_for] = ACTIONS(2050),
    [anon_sym_in] = ACTIONS(2050),
    [anon_sym_AT] = ACTIONS(2050),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_and] = ACTIONS(2050),
    [anon_sym_or] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_SLASH] = ACTIONS(2055),
    [anon_sym_PERCENT] = ACTIONS(2050),
    [anon_sym_SLASH_SLASH] = ACTIONS(2050),
    [anon_sym_STAR_STAR] = ACTIONS(2050),
    [anon_sym_PIPE] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2050),
    [anon_sym_CARET] = ACTIONS(2050),
    [anon_sym_LT_LT] = ACTIONS(2050),
    [anon_sym_LT] = ACTIONS(2055),
    [anon_sym_LT_EQ] = ACTIONS(2050),
    [anon_sym_EQ_EQ] = ACTIONS(2050),
    [anon_sym_BANG_EQ] = ACTIONS(2050),
    [anon_sym_GT_EQ] = ACTIONS(2050),
    [anon_sym_GT] = ACTIONS(2055),
    [anon_sym_LT_GT] = ACTIONS(2050),
    [anon_sym_is] = ACTIONS(2050),
    [anon_sym_LBRACK] = ACTIONS(2050),
    [sym_comment] = ACTIONS(73),
  },
  [677] = {
    [sym__newline] = ACTIONS(1145),
    [sym__string_start] = ACTIONS(1145),
    [anon_sym_DOT] = ACTIONS(1145),
    [anon_sym_from] = ACTIONS(1145),
    [anon_sym_LPAREN] = ACTIONS(1145),
    [anon_sym_COMMA] = ACTIONS(1145),
    [anon_sym_STAR] = ACTIONS(1147),
    [anon_sym_GT_GT] = ACTIONS(1145),
    [anon_sym_if] = ACTIONS(1145),
    [anon_sym_in] = ACTIONS(1145),
    [anon_sym_EQ] = ACTIONS(1147),
    [anon_sym_AT] = ACTIONS(1145),
    [anon_sym_not] = ACTIONS(1145),
    [anon_sym_and] = ACTIONS(1145),
    [anon_sym_or] = ACTIONS(1145),
    [anon_sym_PLUS] = ACTIONS(1145),
    [anon_sym_DASH] = ACTIONS(1145),
    [anon_sym_SLASH] = ACTIONS(1147),
    [anon_sym_PERCENT] = ACTIONS(1145),
    [anon_sym_SLASH_SLASH] = ACTIONS(1145),
    [anon_sym_STAR_STAR] = ACTIONS(1145),
    [anon_sym_PIPE] = ACTIONS(1145),
    [anon_sym_AMP] = ACTIONS(1145),
    [anon_sym_CARET] = ACTIONS(1145),
    [anon_sym_LT_LT] = ACTIONS(1145),
    [anon_sym_LT] = ACTIONS(1147),
    [anon_sym_LT_EQ] = ACTIONS(1145),
    [anon_sym_EQ_EQ] = ACTIONS(1145),
    [anon_sym_BANG_EQ] = ACTIONS(1145),
    [anon_sym_GT_EQ] = ACTIONS(1145),
    [anon_sym_GT] = ACTIONS(1147),
    [anon_sym_LT_GT] = ACTIONS(1145),
    [anon_sym_is] = ACTIONS(1145),
    [anon_sym_LBRACK] = ACTIONS(1145),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1145),
  },
  [678] = {
    [sym__newline] = ACTIONS(1188),
    [anon_sym_DOT] = ACTIONS(1188),
    [anon_sym_from] = ACTIONS(1188),
    [anon_sym_LPAREN] = ACTIONS(1188),
    [anon_sym_COMMA] = ACTIONS(1188),
    [anon_sym_STAR] = ACTIONS(1190),
    [anon_sym_GT_GT] = ACTIONS(1188),
    [anon_sym_if] = ACTIONS(1188),
    [anon_sym_in] = ACTIONS(1188),
    [anon_sym_EQ] = ACTIONS(1190),
    [anon_sym_AT] = ACTIONS(1188),
    [anon_sym_not] = ACTIONS(1188),
    [anon_sym_and] = ACTIONS(1188),
    [anon_sym_or] = ACTIONS(1188),
    [anon_sym_PLUS] = ACTIONS(1188),
    [anon_sym_DASH] = ACTIONS(1188),
    [anon_sym_SLASH] = ACTIONS(1190),
    [anon_sym_PERCENT] = ACTIONS(1188),
    [anon_sym_SLASH_SLASH] = ACTIONS(1188),
    [anon_sym_STAR_STAR] = ACTIONS(1188),
    [anon_sym_PIPE] = ACTIONS(1188),
    [anon_sym_AMP] = ACTIONS(1188),
    [anon_sym_CARET] = ACTIONS(1188),
    [anon_sym_LT_LT] = ACTIONS(1188),
    [anon_sym_LT] = ACTIONS(1190),
    [anon_sym_LT_EQ] = ACTIONS(1188),
    [anon_sym_EQ_EQ] = ACTIONS(1188),
    [anon_sym_BANG_EQ] = ACTIONS(1188),
    [anon_sym_GT_EQ] = ACTIONS(1188),
    [anon_sym_GT] = ACTIONS(1190),
    [anon_sym_LT_GT] = ACTIONS(1188),
    [anon_sym_is] = ACTIONS(1188),
    [anon_sym_LBRACK] = ACTIONS(1188),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1188),
  },
  [679] = {
    [sym__newline] = ACTIONS(1242),
    [anon_sym_DOT] = ACTIONS(1242),
    [anon_sym_from] = ACTIONS(1242),
    [anon_sym_LPAREN] = ACTIONS(1242),
    [anon_sym_COMMA] = ACTIONS(1242),
    [anon_sym_STAR] = ACTIONS(1244),
    [anon_sym_GT_GT] = ACTIONS(1242),
    [anon_sym_if] = ACTIONS(1242),
    [anon_sym_in] = ACTIONS(1242),
    [anon_sym_EQ] = ACTIONS(1244),
    [anon_sym_AT] = ACTIONS(1242),
    [anon_sym_not] = ACTIONS(1242),
    [anon_sym_and] = ACTIONS(1242),
    [anon_sym_or] = ACTIONS(1242),
    [anon_sym_PLUS] = ACTIONS(1242),
    [anon_sym_DASH] = ACTIONS(1242),
    [anon_sym_SLASH] = ACTIONS(1244),
    [anon_sym_PERCENT] = ACTIONS(1242),
    [anon_sym_SLASH_SLASH] = ACTIONS(1242),
    [anon_sym_STAR_STAR] = ACTIONS(1242),
    [anon_sym_PIPE] = ACTIONS(1242),
    [anon_sym_AMP] = ACTIONS(1242),
    [anon_sym_CARET] = ACTIONS(1242),
    [anon_sym_LT_LT] = ACTIONS(1242),
    [anon_sym_LT] = ACTIONS(1244),
    [anon_sym_LT_EQ] = ACTIONS(1242),
    [anon_sym_EQ_EQ] = ACTIONS(1242),
    [anon_sym_BANG_EQ] = ACTIONS(1242),
    [anon_sym_GT_EQ] = ACTIONS(1242),
    [anon_sym_GT] = ACTIONS(1244),
    [anon_sym_LT_GT] = ACTIONS(1242),
    [anon_sym_is] = ACTIONS(1242),
    [anon_sym_LBRACK] = ACTIONS(1242),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1242),
  },
  [680] = {
    [sym__expression] = STATE(647),
    [sym__primary_expression] = STATE(237),
    [sym_not_operator] = STATE(647),
    [sym_boolean_operator] = STATE(647),
    [sym_binary_operator] = STATE(237),
    [sym_unary_operator] = STATE(237),
    [sym_comparison_operator] = STATE(647),
    [sym_lambda] = STATE(647),
    [sym_yield] = STATE(648),
    [sym_attribute] = STATE(237),
    [sym_subscript] = STATE(237),
    [sym_call] = STATE(237),
    [sym_list] = STATE(237),
    [sym_list_comprehension] = STATE(237),
    [sym_dictionary] = STATE(237),
    [sym_dictionary_comprehension] = STATE(237),
    [sym_set] = STATE(237),
    [sym_set_comprehension] = STATE(237),
    [sym_parenthesized_expression] = STATE(237),
    [sym_tuple] = STATE(237),
    [sym_generator_expression] = STATE(237),
    [sym_conditional_expression] = STATE(647),
    [sym_concatenated_string] = STATE(237),
    [sym_string] = STATE(238),
    [sym_await] = STATE(647),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(2244),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_lambda] = ACTIONS(415),
    [anon_sym_yield] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(419),
    [sym_float] = ACTIONS(419),
    [sym_identifier] = ACTIONS(419),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_none] = ACTIONS(419),
    [anon_sym_await] = ACTIONS(421),
    [sym_comment] = ACTIONS(73),
  },
  [681] = {
    [anon_sym_RPAREN] = ACTIONS(2246),
    [sym_comment] = ACTIONS(73),
  },
  [682] = {
    [aux_sym_tuple_repeat1] = STATE(658),
    [anon_sym_RPAREN] = ACTIONS(2244),
    [anon_sym_COMMA] = ACTIONS(2248),
    [sym_comment] = ACTIONS(73),
  },
  [683] = {
    [sym__newline] = ACTIONS(1660),
    [anon_sym_COMMA] = ACTIONS(1660),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_and] = ACTIONS(503),
    [anon_sym_or] = ACTIONS(505),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1660),
  },
  [684] = {
    [sym__expression] = STATE(1140),
    [sym__primary_expression] = STATE(82),
    [sym_not_operator] = STATE(1140),
    [sym_boolean_operator] = STATE(1140),
    [sym_binary_operator] = STATE(82),
    [sym_unary_operator] = STATE(82),
    [sym_comparison_operator] = STATE(1140),
    [sym_lambda] = STATE(1140),
    [sym_attribute] = STATE(82),
    [sym_subscript] = STATE(82),
    [sym_call] = STATE(82),
    [sym_list] = STATE(82),
    [sym_list_comprehension] = STATE(82),
    [sym_dictionary] = STATE(82),
    [sym_dictionary_comprehension] = STATE(82),
    [sym_set] = STATE(82),
    [sym_set_comprehension] = STATE(82),
    [sym_parenthesized_expression] = STATE(82),
    [sym_tuple] = STATE(82),
    [sym_generator_expression] = STATE(82),
    [sym_conditional_expression] = STATE(1140),
    [sym_concatenated_string] = STATE(82),
    [sym_string] = STATE(83),
    [sym_await] = STATE(1140),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_lambda] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(137),
    [sym_float] = ACTIONS(137),
    [sym_identifier] = ACTIONS(137),
    [sym_true] = ACTIONS(137),
    [sym_false] = ACTIONS(137),
    [sym_none] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
  },
  [685] = {
    [sym__newline] = ACTIONS(1680),
    [anon_sym_DOT] = ACTIONS(1680),
    [anon_sym_from] = ACTIONS(1680),
    [anon_sym_LPAREN] = ACTIONS(1680),
    [anon_sym_COMMA] = ACTIONS(1680),
    [anon_sym_STAR] = ACTIONS(1682),
    [anon_sym_GT_GT] = ACTIONS(1680),
    [anon_sym_if] = ACTIONS(1680),
    [anon_sym_in] = ACTIONS(1680),
    [anon_sym_EQ] = ACTIONS(1682),
    [anon_sym_AT] = ACTIONS(1680),
    [anon_sym_not] = ACTIONS(1680),
    [anon_sym_and] = ACTIONS(1680),
    [anon_sym_or] = ACTIONS(1680),
    [anon_sym_PLUS] = ACTIONS(1680),
    [anon_sym_DASH] = ACTIONS(1680),
    [anon_sym_SLASH] = ACTIONS(1682),
    [anon_sym_PERCENT] = ACTIONS(1680),
    [anon_sym_SLASH_SLASH] = ACTIONS(1680),
    [anon_sym_STAR_STAR] = ACTIONS(1680),
    [anon_sym_PIPE] = ACTIONS(1680),
    [anon_sym_AMP] = ACTIONS(1680),
    [anon_sym_CARET] = ACTIONS(1680),
    [anon_sym_LT_LT] = ACTIONS(1680),
    [anon_sym_LT] = ACTIONS(1682),
    [anon_sym_LT_EQ] = ACTIONS(1680),
    [anon_sym_EQ_EQ] = ACTIONS(1680),
    [anon_sym_BANG_EQ] = ACTIONS(1680),
    [anon_sym_GT_EQ] = ACTIONS(1680),
    [anon_sym_GT] = ACTIONS(1682),
    [anon_sym_LT_GT] = ACTIONS(1680),
    [anon_sym_is] = ACTIONS(1680),
    [anon_sym_LBRACK] = ACTIONS(1680),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1680),
  },
  [686] = {
    [sym_list_splat] = STATE(914),
    [sym__expression] = STATE(915),
    [sym__primary_expression] = STATE(452),
    [sym_not_operator] = STATE(915),
    [sym_boolean_operator] = STATE(915),
    [sym_binary_operator] = STATE(452),
    [sym_unary_operator] = STATE(452),
    [sym_comparison_operator] = STATE(915),
    [sym_lambda] = STATE(915),
    [sym_attribute] = STATE(452),
    [sym_subscript] = STATE(452),
    [sym_call] = STATE(452),
    [sym_list] = STATE(452),
    [sym_list_comprehension] = STATE(452),
    [sym_dictionary] = STATE(452),
    [sym_dictionary_comprehension] = STATE(452),
    [sym_set] = STATE(452),
    [sym_set_comprehension] = STATE(452),
    [sym_parenthesized_expression] = STATE(452),
    [sym_tuple] = STATE(452),
    [sym_generator_expression] = STATE(452),
    [sym_conditional_expression] = STATE(915),
    [sym_concatenated_string] = STATE(452),
    [sym_string] = STATE(453),
    [sym_await] = STATE(915),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(243),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_lambda] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(2250),
    [sym_ellipsis] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(773),
    [sym_float] = ACTIONS(773),
    [sym_identifier] = ACTIONS(773),
    [sym_true] = ACTIONS(773),
    [sym_false] = ACTIONS(773),
    [sym_none] = ACTIONS(773),
    [anon_sym_await] = ACTIONS(775),
    [sym_comment] = ACTIONS(73),
  },
  [687] = {
    [aux_sym_list_repeat1] = STATE(917),
    [anon_sym_COMMA] = ACTIONS(2252),
    [anon_sym_RBRACK] = ACTIONS(2250),
    [sym_comment] = ACTIONS(73),
  },
  [688] = {
    [anon_sym_RBRACK] = ACTIONS(2254),
    [sym_comment] = ACTIONS(73),
  },
  [689] = {
    [sym__newline] = ACTIONS(1760),
    [anon_sym_DOT] = ACTIONS(1760),
    [anon_sym_from] = ACTIONS(1760),
    [anon_sym_LPAREN] = ACTIONS(1760),
    [anon_sym_COMMA] = ACTIONS(1760),
    [anon_sym_STAR] = ACTIONS(1762),
    [anon_sym_GT_GT] = ACTIONS(1760),
    [anon_sym_if] = ACTIONS(1760),
    [anon_sym_in] = ACTIONS(1760),
    [anon_sym_EQ] = ACTIONS(1762),
    [anon_sym_AT] = ACTIONS(1760),
    [anon_sym_not] = ACTIONS(1760),
    [anon_sym_and] = ACTIONS(1760),
    [anon_sym_or] = ACTIONS(1760),
    [anon_sym_PLUS] = ACTIONS(1760),
    [anon_sym_DASH] = ACTIONS(1760),
    [anon_sym_SLASH] = ACTIONS(1762),
    [anon_sym_PERCENT] = ACTIONS(1760),
    [anon_sym_SLASH_SLASH] = ACTIONS(1760),
    [anon_sym_STAR_STAR] = ACTIONS(1760),
    [anon_sym_PIPE] = ACTIONS(1760),
    [anon_sym_AMP] = ACTIONS(1760),
    [anon_sym_CARET] = ACTIONS(1760),
    [anon_sym_LT_LT] = ACTIONS(1760),
    [anon_sym_LT] = ACTIONS(1762),
    [anon_sym_LT_EQ] = ACTIONS(1760),
    [anon_sym_EQ_EQ] = ACTIONS(1760),
    [anon_sym_BANG_EQ] = ACTIONS(1760),
    [anon_sym_GT_EQ] = ACTIONS(1760),
    [anon_sym_GT] = ACTIONS(1762),
    [anon_sym_LT_GT] = ACTIONS(1760),
    [anon_sym_is] = ACTIONS(1760),
    [anon_sym_LBRACK] = ACTIONS(1760),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1760),
  },
  [690] = {
    [sym_list_splat] = STATE(914),
    [sym__expression] = STATE(958),
    [sym__primary_expression] = STATE(485),
    [sym_not_operator] = STATE(958),
    [sym_boolean_operator] = STATE(958),
    [sym_binary_operator] = STATE(485),
    [sym_unary_operator] = STATE(485),
    [sym_comparison_operator] = STATE(958),
    [sym_lambda] = STATE(958),
    [sym_attribute] = STATE(485),
    [sym_subscript] = STATE(485),
    [sym_call] = STATE(485),
    [sym_list] = STATE(485),
    [sym_list_comprehension] = STATE(485),
    [sym_dictionary] = STATE(485),
    [sym_dictionary_comprehension] = STATE(485),
    [sym_set] = STATE(485),
    [sym_set_comprehension] = STATE(485),
    [sym_parenthesized_expression] = STATE(485),
    [sym_tuple] = STATE(485),
    [sym_generator_expression] = STATE(485),
    [sym_conditional_expression] = STATE(958),
    [sym_concatenated_string] = STATE(485),
    [sym_string] = STATE(486),
    [sym_await] = STATE(958),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(1798),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(823),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_TILDE] = ACTIONS(825),
    [anon_sym_lambda] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(829),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(2256),
    [sym_integer] = ACTIONS(831),
    [sym_float] = ACTIONS(831),
    [sym_identifier] = ACTIONS(831),
    [sym_true] = ACTIONS(831),
    [sym_false] = ACTIONS(831),
    [sym_none] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [sym_comment] = ACTIONS(73),
  },
  [691] = {
    [sym__newline] = ACTIONS(1802),
    [anon_sym_DOT] = ACTIONS(1802),
    [anon_sym_from] = ACTIONS(1802),
    [anon_sym_LPAREN] = ACTIONS(1802),
    [anon_sym_COMMA] = ACTIONS(1802),
    [anon_sym_STAR] = ACTIONS(1804),
    [anon_sym_GT_GT] = ACTIONS(1802),
    [anon_sym_if] = ACTIONS(1802),
    [anon_sym_in] = ACTIONS(1802),
    [anon_sym_EQ] = ACTIONS(1804),
    [anon_sym_AT] = ACTIONS(1802),
    [anon_sym_not] = ACTIONS(1802),
    [anon_sym_and] = ACTIONS(1802),
    [anon_sym_or] = ACTIONS(1802),
    [anon_sym_PLUS] = ACTIONS(1802),
    [anon_sym_DASH] = ACTIONS(1802),
    [anon_sym_SLASH] = ACTIONS(1804),
    [anon_sym_PERCENT] = ACTIONS(1802),
    [anon_sym_SLASH_SLASH] = ACTIONS(1802),
    [anon_sym_STAR_STAR] = ACTIONS(1802),
    [anon_sym_PIPE] = ACTIONS(1802),
    [anon_sym_AMP] = ACTIONS(1802),
    [anon_sym_CARET] = ACTIONS(1802),
    [anon_sym_LT_LT] = ACTIONS(1802),
    [anon_sym_LT] = ACTIONS(1804),
    [anon_sym_LT_EQ] = ACTIONS(1802),
    [anon_sym_EQ_EQ] = ACTIONS(1802),
    [anon_sym_BANG_EQ] = ACTIONS(1802),
    [anon_sym_GT_EQ] = ACTIONS(1802),
    [anon_sym_GT] = ACTIONS(1804),
    [anon_sym_LT_GT] = ACTIONS(1802),
    [anon_sym_is] = ACTIONS(1802),
    [anon_sym_LBRACK] = ACTIONS(1802),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1802),
  },
  [692] = {
    [aux_sym_list_repeat1] = STATE(960),
    [anon_sym_COMMA] = ACTIONS(2258),
    [anon_sym_RBRACE] = ACTIONS(2256),
    [sym_comment] = ACTIONS(73),
  },
  [693] = {
    [sym_dictionary_splat] = STATE(963),
    [sym__expression] = STATE(964),
    [sym__primary_expression] = STATE(102),
    [sym_not_operator] = STATE(964),
    [sym_boolean_operator] = STATE(964),
    [sym_binary_operator] = STATE(102),
    [sym_unary_operator] = STATE(102),
    [sym_comparison_operator] = STATE(964),
    [sym_lambda] = STATE(964),
    [sym_attribute] = STATE(102),
    [sym_subscript] = STATE(102),
    [sym_call] = STATE(102),
    [sym_list] = STATE(102),
    [sym_list_comprehension] = STATE(102),
    [sym_dictionary] = STATE(102),
    [sym_dictionary_comprehension] = STATE(102),
    [sym_pair] = STATE(963),
    [sym_set] = STATE(102),
    [sym_set_comprehension] = STATE(102),
    [sym_parenthesized_expression] = STATE(102),
    [sym_tuple] = STATE(102),
    [sym_generator_expression] = STATE(102),
    [sym_conditional_expression] = STATE(964),
    [sym_concatenated_string] = STATE(102),
    [sym_string] = STATE(103),
    [sym_await] = STATE(964),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(1808),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(2260),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [694] = {
    [aux_sym_dictionary_repeat1] = STATE(966),
    [anon_sym_COMMA] = ACTIONS(2262),
    [anon_sym_RBRACE] = ACTIONS(2260),
    [sym_comment] = ACTIONS(73),
  },
  [695] = {
    [anon_sym_RBRACE] = ACTIONS(2264),
    [sym_comment] = ACTIONS(73),
  },
  [696] = {
    [anon_sym_RBRACE] = ACTIONS(2266),
    [sym_comment] = ACTIONS(73),
  },
  [697] = {
    [sym__newline] = ACTIONS(1921),
    [anon_sym_COMMA] = ACTIONS(1921),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_and] = ACTIONS(503),
    [anon_sym_or] = ACTIONS(505),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1921),
  },
  [698] = {
    [sym__expression] = STATE(697),
    [sym__primary_expression] = STATE(82),
    [sym_not_operator] = STATE(697),
    [sym_boolean_operator] = STATE(697),
    [sym_binary_operator] = STATE(82),
    [sym_unary_operator] = STATE(82),
    [sym_comparison_operator] = STATE(697),
    [sym_lambda] = STATE(697),
    [sym_attribute] = STATE(82),
    [sym_subscript] = STATE(82),
    [sym_call] = STATE(82),
    [sym_list] = STATE(82),
    [sym_list_comprehension] = STATE(82),
    [sym_dictionary] = STATE(82),
    [sym_dictionary_comprehension] = STATE(82),
    [sym_set] = STATE(82),
    [sym_set_comprehension] = STATE(82),
    [sym_parenthesized_expression] = STATE(82),
    [sym_tuple] = STATE(82),
    [sym_generator_expression] = STATE(82),
    [sym_conditional_expression] = STATE(697),
    [sym_concatenated_string] = STATE(82),
    [sym_string] = STATE(83),
    [sym_await] = STATE(697),
    [sym__newline] = ACTIONS(2268),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_lambda] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(137),
    [sym_float] = ACTIONS(137),
    [sym_identifier] = ACTIONS(137),
    [sym_true] = ACTIONS(137),
    [sym_false] = ACTIONS(137),
    [sym_none] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2268),
  },
  [699] = {
    [aux_sym_print_statement_repeat1] = STATE(699),
    [sym__newline] = ACTIONS(1921),
    [anon_sym_COMMA] = ACTIONS(2270),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1921),
  },
  [700] = {
    [anon_sym_if] = ACTIONS(1925),
    [anon_sym_else] = ACTIONS(2273),
    [anon_sym_and] = ACTIONS(1929),
    [anon_sym_or] = ACTIONS(1931),
    [sym_comment] = ACTIONS(73),
  },
  [701] = {
    [sym__newline] = ACTIONS(1957),
    [anon_sym_COMMA] = ACTIONS(1957),
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_and] = ACTIONS(503),
    [anon_sym_or] = ACTIONS(1957),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1957),
  },
  [702] = {
    [sym__newline] = ACTIONS(1966),
    [anon_sym_DOT] = ACTIONS(1966),
    [anon_sym_from] = ACTIONS(1966),
    [anon_sym_LPAREN] = ACTIONS(1966),
    [anon_sym_COMMA] = ACTIONS(1966),
    [anon_sym_STAR] = ACTIONS(1968),
    [anon_sym_GT_GT] = ACTIONS(1966),
    [anon_sym_if] = ACTIONS(1966),
    [anon_sym_in] = ACTIONS(1966),
    [anon_sym_EQ] = ACTIONS(1968),
    [anon_sym_AT] = ACTIONS(1966),
    [anon_sym_not] = ACTIONS(1966),
    [anon_sym_and] = ACTIONS(1966),
    [anon_sym_or] = ACTIONS(1966),
    [anon_sym_PLUS] = ACTIONS(1966),
    [anon_sym_DASH] = ACTIONS(1966),
    [anon_sym_SLASH] = ACTIONS(1968),
    [anon_sym_PERCENT] = ACTIONS(1966),
    [anon_sym_SLASH_SLASH] = ACTIONS(1966),
    [anon_sym_STAR_STAR] = ACTIONS(1966),
    [anon_sym_PIPE] = ACTIONS(1966),
    [anon_sym_AMP] = ACTIONS(1966),
    [anon_sym_CARET] = ACTIONS(1966),
    [anon_sym_LT_LT] = ACTIONS(1966),
    [anon_sym_LT] = ACTIONS(1968),
    [anon_sym_LT_EQ] = ACTIONS(1966),
    [anon_sym_EQ_EQ] = ACTIONS(1966),
    [anon_sym_BANG_EQ] = ACTIONS(1966),
    [anon_sym_GT_EQ] = ACTIONS(1966),
    [anon_sym_GT] = ACTIONS(1968),
    [anon_sym_LT_GT] = ACTIONS(1966),
    [anon_sym_is] = ACTIONS(1966),
    [anon_sym_LBRACK] = ACTIONS(1966),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1966),
  },
  [703] = {
    [sym__newline] = ACTIONS(1970),
    [anon_sym_DOT] = ACTIONS(1970),
    [anon_sym_from] = ACTIONS(1970),
    [anon_sym_LPAREN] = ACTIONS(1970),
    [anon_sym_COMMA] = ACTIONS(1970),
    [anon_sym_STAR] = ACTIONS(1972),
    [anon_sym_GT_GT] = ACTIONS(1970),
    [anon_sym_if] = ACTIONS(1970),
    [anon_sym_in] = ACTIONS(1970),
    [anon_sym_EQ] = ACTIONS(1972),
    [anon_sym_AT] = ACTIONS(1970),
    [anon_sym_not] = ACTIONS(1970),
    [anon_sym_and] = ACTIONS(1970),
    [anon_sym_or] = ACTIONS(1970),
    [anon_sym_PLUS] = ACTIONS(1970),
    [anon_sym_DASH] = ACTIONS(1970),
    [anon_sym_SLASH] = ACTIONS(1972),
    [anon_sym_PERCENT] = ACTIONS(1970),
    [anon_sym_SLASH_SLASH] = ACTIONS(1970),
    [anon_sym_STAR_STAR] = ACTIONS(1970),
    [anon_sym_PIPE] = ACTIONS(1970),
    [anon_sym_AMP] = ACTIONS(1970),
    [anon_sym_CARET] = ACTIONS(1970),
    [anon_sym_LT_LT] = ACTIONS(1970),
    [anon_sym_LT] = ACTIONS(1972),
    [anon_sym_LT_EQ] = ACTIONS(1970),
    [anon_sym_EQ_EQ] = ACTIONS(1970),
    [anon_sym_BANG_EQ] = ACTIONS(1970),
    [anon_sym_GT_EQ] = ACTIONS(1970),
    [anon_sym_GT] = ACTIONS(1972),
    [anon_sym_LT_GT] = ACTIONS(1970),
    [anon_sym_is] = ACTIONS(1970),
    [anon_sym_LBRACK] = ACTIONS(1970),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1970),
  },
  [704] = {
    [anon_sym_RPAREN] = ACTIONS(2275),
    [sym_comment] = ACTIONS(73),
  },
  [705] = {
    [aux_sym_argument_list_repeat1] = STATE(1153),
    [anon_sym_RPAREN] = ACTIONS(2275),
    [anon_sym_COMMA] = ACTIONS(2277),
    [sym_comment] = ACTIONS(73),
  },
  [706] = {
    [sym__comprehension_body] = STATE(681),
    [sym_for_in_clause] = STATE(258),
    [aux_sym_argument_list_repeat1] = STATE(1153),
    [anon_sym_RPAREN] = ACTIONS(2275),
    [anon_sym_COMMA] = ACTIONS(2277),
    [anon_sym_if] = ACTIONS(435),
    [anon_sym_async] = ACTIONS(437),
    [anon_sym_for] = ACTIONS(439),
    [anon_sym_and] = ACTIONS(441),
    [anon_sym_or] = ACTIONS(443),
    [sym_comment] = ACTIONS(73),
  },
  [707] = {
    [sym_argument_list] = STATE(315),
    [sym_generator_expression] = STATE(315),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1984),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1986),
    [anon_sym_PERCENT] = ACTIONS(1984),
    [anon_sym_SLASH_SLASH] = ACTIONS(1984),
    [anon_sym_STAR_STAR] = ACTIONS(523),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1984),
  },
  [708] = {
    [sym_argument_list] = STATE(315),
    [sym_generator_expression] = STATE(315),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(511),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(517),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(511),
    [anon_sym_PERCENT] = ACTIONS(517),
    [anon_sym_SLASH_SLASH] = ACTIONS(517),
    [anon_sym_STAR_STAR] = ACTIONS(523),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1984),
  },
  [709] = {
    [sym_argument_list] = STATE(315),
    [sym_generator_expression] = STATE(315),
    [sym__newline] = ACTIONS(1988),
    [anon_sym_DOT] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_COMMA] = ACTIONS(1988),
    [anon_sym_STAR] = ACTIONS(511),
    [anon_sym_GT_GT] = ACTIONS(513),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(1988),
    [anon_sym_AT] = ACTIONS(517),
    [anon_sym_not] = ACTIONS(1988),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(511),
    [anon_sym_PERCENT] = ACTIONS(517),
    [anon_sym_SLASH_SLASH] = ACTIONS(517),
    [anon_sym_STAR_STAR] = ACTIONS(523),
    [anon_sym_PIPE] = ACTIONS(525),
    [anon_sym_AMP] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(529),
    [anon_sym_LT_LT] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(1990),
    [anon_sym_LT_EQ] = ACTIONS(1988),
    [anon_sym_EQ_EQ] = ACTIONS(1988),
    [anon_sym_BANG_EQ] = ACTIONS(1988),
    [anon_sym_GT_EQ] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1990),
    [anon_sym_LT_GT] = ACTIONS(1988),
    [anon_sym_is] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(535),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1988),
  },
  [710] = {
    [sym__primary_expression] = STATE(1154),
    [sym_binary_operator] = STATE(1154),
    [sym_unary_operator] = STATE(1154),
    [sym_attribute] = STATE(1154),
    [sym_subscript] = STATE(1154),
    [sym_call] = STATE(1154),
    [sym_list] = STATE(1154),
    [sym_list_comprehension] = STATE(1154),
    [sym_dictionary] = STATE(1154),
    [sym_dictionary_comprehension] = STATE(1154),
    [sym_set] = STATE(1154),
    [sym_set_comprehension] = STATE(1154),
    [sym_parenthesized_expression] = STATE(1154),
    [sym_tuple] = STATE(1154),
    [sym_generator_expression] = STATE(1154),
    [sym_concatenated_string] = STATE(1154),
    [sym_string] = STATE(83),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(2279),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(2281),
    [sym_float] = ACTIONS(2281),
    [sym_identifier] = ACTIONS(2281),
    [sym_true] = ACTIONS(2281),
    [sym_false] = ACTIONS(2281),
    [sym_none] = ACTIONS(2281),
    [sym_comment] = ACTIONS(73),
  },
  [711] = {
    [sym_argument_list] = STATE(315),
    [sym_generator_expression] = STATE(315),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(511),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(517),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(511),
    [anon_sym_PERCENT] = ACTIONS(517),
    [anon_sym_SLASH_SLASH] = ACTIONS(517),
    [anon_sym_STAR_STAR] = ACTIONS(523),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1984),
  },
  [712] = {
    [sym_argument_list] = STATE(315),
    [sym_generator_expression] = STATE(315),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_from] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(1984),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1986),
    [anon_sym_PERCENT] = ACTIONS(1984),
    [anon_sym_SLASH_SLASH] = ACTIONS(1984),
    [anon_sym_STAR_STAR] = ACTIONS(1984),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1984),
  },
  [713] = {
    [sym_argument_list] = STATE(315),
    [sym_generator_expression] = STATE(315),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(511),
    [anon_sym_GT_GT] = ACTIONS(513),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(517),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(511),
    [anon_sym_PERCENT] = ACTIONS(517),
    [anon_sym_SLASH_SLASH] = ACTIONS(517),
    [anon_sym_STAR_STAR] = ACTIONS(523),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(529),
    [anon_sym_LT_LT] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1984),
  },
  [714] = {
    [sym_argument_list] = STATE(315),
    [sym_generator_expression] = STATE(315),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(511),
    [anon_sym_GT_GT] = ACTIONS(513),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(517),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(511),
    [anon_sym_PERCENT] = ACTIONS(517),
    [anon_sym_SLASH_SLASH] = ACTIONS(517),
    [anon_sym_STAR_STAR] = ACTIONS(523),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(529),
    [anon_sym_LT_LT] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1984),
  },
  [715] = {
    [sym_argument_list] = STATE(315),
    [sym_generator_expression] = STATE(315),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(511),
    [anon_sym_GT_GT] = ACTIONS(513),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(517),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(511),
    [anon_sym_PERCENT] = ACTIONS(517),
    [anon_sym_SLASH_SLASH] = ACTIONS(517),
    [anon_sym_STAR_STAR] = ACTIONS(523),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1984),
  },
  [716] = {
    [aux_sym_subscript_repeat1] = STATE(1157),
    [anon_sym_COMMA] = ACTIONS(2283),
    [anon_sym_if] = ACTIONS(2004),
    [anon_sym_COLON] = ACTIONS(2006),
    [anon_sym_and] = ACTIONS(2008),
    [anon_sym_or] = ACTIONS(2010),
    [anon_sym_RBRACK] = ACTIONS(2285),
    [sym_comment] = ACTIONS(73),
  },
  [717] = {
    [aux_sym_subscript_repeat1] = STATE(1157),
    [anon_sym_COMMA] = ACTIONS(2283),
    [anon_sym_RBRACK] = ACTIONS(2285),
    [sym_comment] = ACTIONS(73),
  },
  [718] = {
    [aux_sym_comparison_operator_repeat1] = STATE(718),
    [sym__newline] = ACTIONS(1988),
    [anon_sym_COMMA] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(2287),
    [anon_sym_not] = ACTIONS(2290),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(2293),
    [anon_sym_LT_EQ] = ACTIONS(2287),
    [anon_sym_EQ_EQ] = ACTIONS(2287),
    [anon_sym_BANG_EQ] = ACTIONS(2287),
    [anon_sym_GT_EQ] = ACTIONS(2287),
    [anon_sym_GT] = ACTIONS(2293),
    [anon_sym_LT_GT] = ACTIONS(2287),
    [anon_sym_is] = ACTIONS(2296),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1988),
  },
  [719] = {
    [sym_string] = STATE(719),
    [aux_sym_concatenated_string_repeat1] = STATE(719),
    [sym__newline] = ACTIONS(2050),
    [sym__string_start] = ACTIONS(2299),
    [anon_sym_DOT] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(2050),
    [anon_sym_COMMA] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2050),
    [anon_sym_if] = ACTIONS(2050),
    [anon_sym_in] = ACTIONS(2050),
    [anon_sym_AT] = ACTIONS(2050),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_and] = ACTIONS(2050),
    [anon_sym_or] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_SLASH] = ACTIONS(2055),
    [anon_sym_PERCENT] = ACTIONS(2050),
    [anon_sym_SLASH_SLASH] = ACTIONS(2050),
    [anon_sym_STAR_STAR] = ACTIONS(2050),
    [anon_sym_PIPE] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2050),
    [anon_sym_CARET] = ACTIONS(2050),
    [anon_sym_LT_LT] = ACTIONS(2050),
    [anon_sym_LT] = ACTIONS(2055),
    [anon_sym_LT_EQ] = ACTIONS(2050),
    [anon_sym_EQ_EQ] = ACTIONS(2050),
    [anon_sym_BANG_EQ] = ACTIONS(2050),
    [anon_sym_GT_EQ] = ACTIONS(2050),
    [anon_sym_GT] = ACTIONS(2055),
    [anon_sym_LT_GT] = ACTIONS(2050),
    [anon_sym_is] = ACTIONS(2050),
    [anon_sym_LBRACK] = ACTIONS(2050),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2050),
  },
  [720] = {
    [sym__expression] = STATE(697),
    [sym__primary_expression] = STATE(82),
    [sym_not_operator] = STATE(697),
    [sym_boolean_operator] = STATE(697),
    [sym_binary_operator] = STATE(82),
    [sym_unary_operator] = STATE(82),
    [sym_comparison_operator] = STATE(697),
    [sym_lambda] = STATE(697),
    [sym_attribute] = STATE(82),
    [sym_subscript] = STATE(82),
    [sym_call] = STATE(82),
    [sym_list] = STATE(82),
    [sym_list_comprehension] = STATE(82),
    [sym_dictionary] = STATE(82),
    [sym_dictionary_comprehension] = STATE(82),
    [sym_set] = STATE(82),
    [sym_set_comprehension] = STATE(82),
    [sym_parenthesized_expression] = STATE(82),
    [sym_tuple] = STATE(82),
    [sym_generator_expression] = STATE(82),
    [sym_conditional_expression] = STATE(697),
    [sym_concatenated_string] = STATE(82),
    [sym_string] = STATE(83),
    [sym_await] = STATE(697),
    [sym__newline] = ACTIONS(1961),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_lambda] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(137),
    [sym_float] = ACTIONS(137),
    [sym_identifier] = ACTIONS(137),
    [sym_true] = ACTIONS(137),
    [sym_false] = ACTIONS(137),
    [sym_none] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1961),
  },
  [721] = {
    [sym__newline] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(723),
    [anon_sym_and] = ACTIONS(1380),
    [anon_sym_or] = ACTIONS(1382),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(723),
  },
  [722] = {
    [sym__expression] = STATE(1158),
    [sym__primary_expression] = STATE(327),
    [sym_not_operator] = STATE(1158),
    [sym_boolean_operator] = STATE(1158),
    [sym_binary_operator] = STATE(327),
    [sym_unary_operator] = STATE(327),
    [sym_comparison_operator] = STATE(1158),
    [sym_lambda] = STATE(1158),
    [sym_attribute] = STATE(327),
    [sym_subscript] = STATE(327),
    [sym_call] = STATE(327),
    [sym_list] = STATE(327),
    [sym_list_comprehension] = STATE(327),
    [sym_dictionary] = STATE(327),
    [sym_dictionary_comprehension] = STATE(327),
    [sym_set] = STATE(327),
    [sym_set_comprehension] = STATE(327),
    [sym_parenthesized_expression] = STATE(327),
    [sym_tuple] = STATE(327),
    [sym_generator_expression] = STATE(327),
    [sym_conditional_expression] = STATE(1158),
    [sym_concatenated_string] = STATE(327),
    [sym_string] = STATE(328),
    [sym_await] = STATE(1158),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(547),
    [anon_sym_PLUS] = ACTIONS(549),
    [anon_sym_DASH] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_lambda] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(553),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(555),
    [sym_float] = ACTIONS(555),
    [sym_identifier] = ACTIONS(555),
    [sym_true] = ACTIONS(555),
    [sym_false] = ACTIONS(555),
    [sym_none] = ACTIONS(555),
    [anon_sym_await] = ACTIONS(557),
    [sym_comment] = ACTIONS(73),
  },
  [723] = {
    [anon_sym_COLON] = ACTIONS(2302),
    [sym_comment] = ACTIONS(73),
  },
  [724] = {
    [sym__expression] = STATE(1160),
    [sym__primary_expression] = STATE(538),
    [sym_not_operator] = STATE(1160),
    [sym_boolean_operator] = STATE(1160),
    [sym_binary_operator] = STATE(538),
    [sym_unary_operator] = STATE(538),
    [sym_comparison_operator] = STATE(1160),
    [sym_lambda] = STATE(1160),
    [sym_attribute] = STATE(538),
    [sym_subscript] = STATE(538),
    [sym_call] = STATE(538),
    [sym_list] = STATE(538),
    [sym_list_comprehension] = STATE(538),
    [sym_dictionary] = STATE(538),
    [sym_dictionary_comprehension] = STATE(538),
    [sym_set] = STATE(538),
    [sym_set_comprehension] = STATE(538),
    [sym_parenthesized_expression] = STATE(538),
    [sym_tuple] = STATE(538),
    [sym_generator_expression] = STATE(538),
    [sym_conditional_expression] = STATE(1160),
    [sym_concatenated_string] = STATE(538),
    [sym_string] = STATE(539),
    [sym_await] = STATE(1160),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_lambda] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(917),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(919),
    [sym_float] = ACTIONS(919),
    [sym_identifier] = ACTIONS(919),
    [sym_true] = ACTIONS(919),
    [sym_false] = ACTIONS(919),
    [sym_none] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(921),
    [sym_comment] = ACTIONS(73),
  },
  [725] = {
    [sym__expression] = STATE(540),
    [sym__primary_expression] = STATE(327),
    [sym_not_operator] = STATE(540),
    [sym_boolean_operator] = STATE(540),
    [sym_binary_operator] = STATE(327),
    [sym_unary_operator] = STATE(327),
    [sym_comparison_operator] = STATE(540),
    [sym_lambda] = STATE(540),
    [sym_attribute] = STATE(327),
    [sym_subscript] = STATE(327),
    [sym_call] = STATE(327),
    [sym_list] = STATE(327),
    [sym_list_comprehension] = STATE(327),
    [sym_dictionary] = STATE(327),
    [sym_dictionary_comprehension] = STATE(327),
    [sym_set] = STATE(327),
    [sym_set_comprehension] = STATE(327),
    [sym_parenthesized_expression] = STATE(327),
    [sym_tuple] = STATE(327),
    [sym_generator_expression] = STATE(327),
    [sym_conditional_expression] = STATE(540),
    [sym_concatenated_string] = STATE(327),
    [sym_string] = STATE(328),
    [sym_await] = STATE(540),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(547),
    [anon_sym_PLUS] = ACTIONS(549),
    [anon_sym_DASH] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_lambda] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(553),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(555),
    [sym_float] = ACTIONS(555),
    [sym_identifier] = ACTIONS(555),
    [sym_true] = ACTIONS(555),
    [sym_false] = ACTIONS(555),
    [sym_none] = ACTIONS(555),
    [anon_sym_await] = ACTIONS(557),
    [sym_comment] = ACTIONS(73),
  },
  [726] = {
    [sym__expression] = STATE(1161),
    [sym__primary_expression] = STATE(327),
    [sym_not_operator] = STATE(1161),
    [sym_boolean_operator] = STATE(1161),
    [sym_binary_operator] = STATE(327),
    [sym_unary_operator] = STATE(327),
    [sym_comparison_operator] = STATE(1161),
    [sym_lambda] = STATE(1161),
    [sym_attribute] = STATE(327),
    [sym_subscript] = STATE(327),
    [sym_call] = STATE(327),
    [sym_list] = STATE(327),
    [sym_list_comprehension] = STATE(327),
    [sym_dictionary] = STATE(327),
    [sym_dictionary_comprehension] = STATE(327),
    [sym_set] = STATE(327),
    [sym_set_comprehension] = STATE(327),
    [sym_parenthesized_expression] = STATE(327),
    [sym_tuple] = STATE(327),
    [sym_generator_expression] = STATE(327),
    [sym_conditional_expression] = STATE(1161),
    [sym_concatenated_string] = STATE(327),
    [sym_string] = STATE(328),
    [sym_await] = STATE(1161),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(547),
    [anon_sym_PLUS] = ACTIONS(549),
    [anon_sym_DASH] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_lambda] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(553),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(555),
    [sym_float] = ACTIONS(555),
    [sym_identifier] = ACTIONS(555),
    [sym_true] = ACTIONS(555),
    [sym_false] = ACTIONS(555),
    [sym_none] = ACTIONS(555),
    [anon_sym_await] = ACTIONS(557),
    [sym_comment] = ACTIONS(73),
  },
  [727] = {
    [sym__primary_expression] = STATE(1162),
    [sym_binary_operator] = STATE(1162),
    [sym_unary_operator] = STATE(1162),
    [sym_attribute] = STATE(1162),
    [sym_subscript] = STATE(1162),
    [sym_call] = STATE(1162),
    [sym_list] = STATE(1162),
    [sym_list_comprehension] = STATE(1162),
    [sym_dictionary] = STATE(1162),
    [sym_dictionary_comprehension] = STATE(1162),
    [sym_set] = STATE(1162),
    [sym_set_comprehension] = STATE(1162),
    [sym_parenthesized_expression] = STATE(1162),
    [sym_tuple] = STATE(1162),
    [sym_generator_expression] = STATE(1162),
    [sym_concatenated_string] = STATE(1162),
    [sym_string] = STATE(328),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(549),
    [anon_sym_DASH] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(2304),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(2306),
    [sym_float] = ACTIONS(2306),
    [sym_identifier] = ACTIONS(2306),
    [sym_true] = ACTIONS(2306),
    [sym_false] = ACTIONS(2306),
    [sym_none] = ACTIONS(2306),
    [sym_comment] = ACTIONS(73),
  },
  [728] = {
    [sym__primary_expression] = STATE(1163),
    [sym_binary_operator] = STATE(1163),
    [sym_unary_operator] = STATE(1163),
    [sym_attribute] = STATE(1163),
    [sym_subscript] = STATE(1163),
    [sym_call] = STATE(1163),
    [sym_list] = STATE(1163),
    [sym_list_comprehension] = STATE(1163),
    [sym_dictionary] = STATE(1163),
    [sym_dictionary_comprehension] = STATE(1163),
    [sym_set] = STATE(1163),
    [sym_set_comprehension] = STATE(1163),
    [sym_parenthesized_expression] = STATE(1163),
    [sym_tuple] = STATE(1163),
    [sym_generator_expression] = STATE(1163),
    [sym_concatenated_string] = STATE(1163),
    [sym_string] = STATE(328),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(549),
    [anon_sym_DASH] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(2308),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(2310),
    [sym_float] = ACTIONS(2310),
    [sym_identifier] = ACTIONS(2310),
    [sym_true] = ACTIONS(2310),
    [sym_false] = ACTIONS(2310),
    [sym_none] = ACTIONS(2310),
    [sym_comment] = ACTIONS(73),
  },
  [729] = {
    [sym__primary_expression] = STATE(1164),
    [sym_binary_operator] = STATE(1164),
    [sym_unary_operator] = STATE(1164),
    [sym_attribute] = STATE(1164),
    [sym_subscript] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym_list] = STATE(1164),
    [sym_list_comprehension] = STATE(1164),
    [sym_dictionary] = STATE(1164),
    [sym_dictionary_comprehension] = STATE(1164),
    [sym_set] = STATE(1164),
    [sym_set_comprehension] = STATE(1164),
    [sym_parenthesized_expression] = STATE(1164),
    [sym_tuple] = STATE(1164),
    [sym_generator_expression] = STATE(1164),
    [sym_concatenated_string] = STATE(1164),
    [sym_string] = STATE(328),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(549),
    [anon_sym_DASH] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(2312),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(2314),
    [sym_float] = ACTIONS(2314),
    [sym_identifier] = ACTIONS(2314),
    [sym_true] = ACTIONS(2314),
    [sym_false] = ACTIONS(2314),
    [sym_none] = ACTIONS(2314),
    [sym_comment] = ACTIONS(73),
  },
  [730] = {
    [anon_sym_in] = ACTIONS(2316),
    [sym_comment] = ACTIONS(73),
  },
  [731] = {
    [sym__primary_expression] = STATE(1166),
    [sym_binary_operator] = STATE(1166),
    [sym_unary_operator] = STATE(1166),
    [sym_attribute] = STATE(1166),
    [sym_subscript] = STATE(1166),
    [sym_call] = STATE(1166),
    [sym_list] = STATE(1166),
    [sym_list_comprehension] = STATE(1166),
    [sym_dictionary] = STATE(1166),
    [sym_dictionary_comprehension] = STATE(1166),
    [sym_set] = STATE(1166),
    [sym_set_comprehension] = STATE(1166),
    [sym_parenthesized_expression] = STATE(1166),
    [sym_tuple] = STATE(1166),
    [sym_generator_expression] = STATE(1166),
    [sym_concatenated_string] = STATE(1166),
    [sym_string] = STATE(328),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(549),
    [anon_sym_DASH] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(2318),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(2320),
    [sym_float] = ACTIONS(2320),
    [sym_identifier] = ACTIONS(2320),
    [sym_true] = ACTIONS(2320),
    [sym_false] = ACTIONS(2320),
    [sym_none] = ACTIONS(2320),
    [sym_comment] = ACTIONS(73),
  },
  [732] = {
    [sym__primary_expression] = STATE(712),
    [sym_binary_operator] = STATE(712),
    [sym_unary_operator] = STATE(712),
    [sym_attribute] = STATE(712),
    [sym_subscript] = STATE(712),
    [sym_call] = STATE(712),
    [sym_list] = STATE(712),
    [sym_list_comprehension] = STATE(712),
    [sym_dictionary] = STATE(712),
    [sym_dictionary_comprehension] = STATE(712),
    [sym_set] = STATE(712),
    [sym_set_comprehension] = STATE(712),
    [sym_parenthesized_expression] = STATE(712),
    [sym_tuple] = STATE(712),
    [sym_generator_expression] = STATE(712),
    [sym_concatenated_string] = STATE(712),
    [sym_string] = STATE(328),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(549),
    [anon_sym_DASH] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1354),
    [sym_float] = ACTIONS(1354),
    [sym_identifier] = ACTIONS(1354),
    [sym_true] = ACTIONS(1354),
    [sym_false] = ACTIONS(1354),
    [sym_none] = ACTIONS(1354),
    [sym_comment] = ACTIONS(73),
  },
  [733] = {
    [sym__primary_expression] = STATE(1167),
    [sym_binary_operator] = STATE(1167),
    [sym_unary_operator] = STATE(1167),
    [sym_attribute] = STATE(1167),
    [sym_subscript] = STATE(1167),
    [sym_call] = STATE(1167),
    [sym_list] = STATE(1167),
    [sym_list_comprehension] = STATE(1167),
    [sym_dictionary] = STATE(1167),
    [sym_dictionary_comprehension] = STATE(1167),
    [sym_set] = STATE(1167),
    [sym_set_comprehension] = STATE(1167),
    [sym_parenthesized_expression] = STATE(1167),
    [sym_tuple] = STATE(1167),
    [sym_generator_expression] = STATE(1167),
    [sym_concatenated_string] = STATE(1167),
    [sym_string] = STATE(328),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(549),
    [anon_sym_DASH] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(2322),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(2324),
    [sym_float] = ACTIONS(2324),
    [sym_identifier] = ACTIONS(2324),
    [sym_true] = ACTIONS(2324),
    [sym_false] = ACTIONS(2324),
    [sym_none] = ACTIONS(2324),
    [sym_comment] = ACTIONS(73),
  },
  [734] = {
    [sym__primary_expression] = STATE(1168),
    [sym_binary_operator] = STATE(1168),
    [sym_unary_operator] = STATE(1168),
    [sym_attribute] = STATE(1168),
    [sym_subscript] = STATE(1168),
    [sym_call] = STATE(1168),
    [sym_list] = STATE(1168),
    [sym_list_comprehension] = STATE(1168),
    [sym_dictionary] = STATE(1168),
    [sym_dictionary_comprehension] = STATE(1168),
    [sym_set] = STATE(1168),
    [sym_set_comprehension] = STATE(1168),
    [sym_parenthesized_expression] = STATE(1168),
    [sym_tuple] = STATE(1168),
    [sym_generator_expression] = STATE(1168),
    [sym_concatenated_string] = STATE(1168),
    [sym_string] = STATE(328),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(549),
    [anon_sym_DASH] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(2326),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(2328),
    [sym_float] = ACTIONS(2328),
    [sym_identifier] = ACTIONS(2328),
    [sym_true] = ACTIONS(2328),
    [sym_false] = ACTIONS(2328),
    [sym_none] = ACTIONS(2328),
    [sym_comment] = ACTIONS(73),
  },
  [735] = {
    [sym__primary_expression] = STATE(1169),
    [sym_binary_operator] = STATE(1169),
    [sym_unary_operator] = STATE(1169),
    [sym_attribute] = STATE(1169),
    [sym_subscript] = STATE(1169),
    [sym_call] = STATE(1169),
    [sym_list] = STATE(1169),
    [sym_list_comprehension] = STATE(1169),
    [sym_dictionary] = STATE(1169),
    [sym_dictionary_comprehension] = STATE(1169),
    [sym_set] = STATE(1169),
    [sym_set_comprehension] = STATE(1169),
    [sym_parenthesized_expression] = STATE(1169),
    [sym_tuple] = STATE(1169),
    [sym_generator_expression] = STATE(1169),
    [sym_concatenated_string] = STATE(1169),
    [sym_string] = STATE(328),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(549),
    [anon_sym_DASH] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(2330),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(2332),
    [sym_float] = ACTIONS(2332),
    [sym_identifier] = ACTIONS(2332),
    [sym_true] = ACTIONS(2332),
    [sym_false] = ACTIONS(2332),
    [sym_none] = ACTIONS(2332),
    [sym_comment] = ACTIONS(73),
  },
  [736] = {
    [sym__primary_expression] = STATE(1164),
    [sym_binary_operator] = STATE(1164),
    [sym_unary_operator] = STATE(1164),
    [sym_attribute] = STATE(1164),
    [sym_subscript] = STATE(1164),
    [sym_call] = STATE(1164),
    [sym_list] = STATE(1164),
    [sym_list_comprehension] = STATE(1164),
    [sym_dictionary] = STATE(1164),
    [sym_dictionary_comprehension] = STATE(1164),
    [sym_set] = STATE(1164),
    [sym_set_comprehension] = STATE(1164),
    [sym_parenthesized_expression] = STATE(1164),
    [sym_tuple] = STATE(1164),
    [sym_generator_expression] = STATE(1164),
    [sym_concatenated_string] = STATE(1164),
    [sym_string] = STATE(328),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(2334),
    [anon_sym_PLUS] = ACTIONS(549),
    [anon_sym_DASH] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(2312),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(2314),
    [sym_float] = ACTIONS(2314),
    [sym_identifier] = ACTIONS(2314),
    [sym_true] = ACTIONS(2314),
    [sym_false] = ACTIONS(2314),
    [sym_none] = ACTIONS(2314),
    [sym_comment] = ACTIONS(73),
  },
  [737] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1170),
    [sym__newline] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(1388),
    [anon_sym_not] = ACTIONS(1392),
    [anon_sym_and] = ACTIONS(991),
    [anon_sym_or] = ACTIONS(991),
    [anon_sym_LT] = ACTIONS(1404),
    [anon_sym_LT_EQ] = ACTIONS(1388),
    [anon_sym_EQ_EQ] = ACTIONS(1388),
    [anon_sym_BANG_EQ] = ACTIONS(1388),
    [anon_sym_GT_EQ] = ACTIONS(1388),
    [anon_sym_GT] = ACTIONS(1404),
    [anon_sym_LT_GT] = ACTIONS(1388),
    [anon_sym_is] = ACTIONS(1406),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(991),
  },
  [738] = {
    [sym_string] = STATE(1171),
    [aux_sym_concatenated_string_repeat1] = STATE(1171),
    [sym__newline] = ACTIONS(995),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_in] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(995),
    [anon_sym_not] = ACTIONS(995),
    [anon_sym_and] = ACTIONS(995),
    [anon_sym_or] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(995),
    [anon_sym_SLASH_SLASH] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_GT] = ACTIONS(995),
    [anon_sym_is] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(995),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(995),
  },
  [739] = {
    [sym__newline] = ACTIONS(1660),
    [anon_sym_from] = ACTIONS(1660),
    [anon_sym_COMMA] = ACTIONS(1660),
    [anon_sym_if] = ACTIONS(567),
    [anon_sym_and] = ACTIONS(569),
    [anon_sym_or] = ACTIONS(571),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1660),
  },
  [740] = {
    [sym__expression] = STATE(1172),
    [sym__primary_expression] = STATE(95),
    [sym_not_operator] = STATE(1172),
    [sym_boolean_operator] = STATE(1172),
    [sym_binary_operator] = STATE(95),
    [sym_unary_operator] = STATE(95),
    [sym_comparison_operator] = STATE(1172),
    [sym_lambda] = STATE(1172),
    [sym_attribute] = STATE(95),
    [sym_subscript] = STATE(95),
    [sym_call] = STATE(95),
    [sym_list] = STATE(95),
    [sym_list_comprehension] = STATE(95),
    [sym_dictionary] = STATE(95),
    [sym_dictionary_comprehension] = STATE(95),
    [sym_set] = STATE(95),
    [sym_set_comprehension] = STATE(95),
    [sym_parenthesized_expression] = STATE(95),
    [sym_tuple] = STATE(95),
    [sym_generator_expression] = STATE(95),
    [sym_conditional_expression] = STATE(1172),
    [sym_concatenated_string] = STATE(95),
    [sym_string] = STATE(96),
    [sym_await] = STATE(1172),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_lambda] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(159),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(161),
    [sym_float] = ACTIONS(161),
    [sym_identifier] = ACTIONS(161),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [sym_none] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [sym_comment] = ACTIONS(73),
  },
  [741] = {
    [sym__newline] = ACTIONS(2336),
    [anon_sym_if] = ACTIONS(1378),
    [anon_sym_and] = ACTIONS(1380),
    [anon_sym_or] = ACTIONS(1382),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2336),
  },
  [742] = {
    [sym__newline] = ACTIONS(1921),
    [anon_sym_from] = ACTIONS(1921),
    [anon_sym_COMMA] = ACTIONS(1921),
    [anon_sym_if] = ACTIONS(567),
    [anon_sym_and] = ACTIONS(569),
    [anon_sym_or] = ACTIONS(571),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1921),
  },
  [743] = {
    [anon_sym_if] = ACTIONS(1925),
    [anon_sym_else] = ACTIONS(2338),
    [anon_sym_and] = ACTIONS(1929),
    [anon_sym_or] = ACTIONS(1931),
    [sym_comment] = ACTIONS(73),
  },
  [744] = {
    [sym__newline] = ACTIONS(1957),
    [anon_sym_from] = ACTIONS(1957),
    [anon_sym_COMMA] = ACTIONS(1957),
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_and] = ACTIONS(569),
    [anon_sym_or] = ACTIONS(1957),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1957),
  },
  [745] = {
    [sym__expression] = STATE(742),
    [sym__primary_expression] = STATE(95),
    [sym_not_operator] = STATE(742),
    [sym_boolean_operator] = STATE(742),
    [sym_binary_operator] = STATE(95),
    [sym_unary_operator] = STATE(95),
    [sym_comparison_operator] = STATE(742),
    [sym_lambda] = STATE(742),
    [sym_attribute] = STATE(95),
    [sym_subscript] = STATE(95),
    [sym_call] = STATE(95),
    [sym_list] = STATE(95),
    [sym_list_comprehension] = STATE(95),
    [sym_dictionary] = STATE(95),
    [sym_dictionary_comprehension] = STATE(95),
    [sym_set] = STATE(95),
    [sym_set_comprehension] = STATE(95),
    [sym_parenthesized_expression] = STATE(95),
    [sym_tuple] = STATE(95),
    [sym_generator_expression] = STATE(95),
    [sym_conditional_expression] = STATE(742),
    [sym_concatenated_string] = STATE(95),
    [sym_string] = STATE(96),
    [sym_await] = STATE(742),
    [sym__newline] = ACTIONS(1961),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_from] = ACTIONS(2340),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_lambda] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(159),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(161),
    [sym_float] = ACTIONS(161),
    [sym_identifier] = ACTIONS(161),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [sym_none] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1961),
  },
  [746] = {
    [aux_sym_print_statement_repeat1] = STATE(746),
    [sym__newline] = ACTIONS(1921),
    [anon_sym_from] = ACTIONS(1921),
    [anon_sym_COMMA] = ACTIONS(2342),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1921),
  },
  [747] = {
    [sym_argument_list] = STATE(315),
    [sym_generator_expression] = STATE(315),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_from] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1984),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1986),
    [anon_sym_PERCENT] = ACTIONS(1984),
    [anon_sym_SLASH_SLASH] = ACTIONS(1984),
    [anon_sym_STAR_STAR] = ACTIONS(585),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1984),
  },
  [748] = {
    [sym_argument_list] = STATE(315),
    [sym_generator_expression] = STATE(315),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_from] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(579),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(583),
    [anon_sym_DASH] = ACTIONS(583),
    [anon_sym_SLASH] = ACTIONS(573),
    [anon_sym_PERCENT] = ACTIONS(579),
    [anon_sym_SLASH_SLASH] = ACTIONS(579),
    [anon_sym_STAR_STAR] = ACTIONS(585),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1984),
  },
  [749] = {
    [sym_argument_list] = STATE(315),
    [sym_generator_expression] = STATE(315),
    [sym__newline] = ACTIONS(1988),
    [anon_sym_DOT] = ACTIONS(507),
    [anon_sym_from] = ACTIONS(1988),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_COMMA] = ACTIONS(1988),
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_GT_GT] = ACTIONS(575),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(1988),
    [anon_sym_AT] = ACTIONS(579),
    [anon_sym_not] = ACTIONS(1988),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_PLUS] = ACTIONS(583),
    [anon_sym_DASH] = ACTIONS(583),
    [anon_sym_SLASH] = ACTIONS(573),
    [anon_sym_PERCENT] = ACTIONS(579),
    [anon_sym_SLASH_SLASH] = ACTIONS(579),
    [anon_sym_STAR_STAR] = ACTIONS(585),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_CARET] = ACTIONS(591),
    [anon_sym_LT_LT] = ACTIONS(575),
    [anon_sym_LT] = ACTIONS(1990),
    [anon_sym_LT_EQ] = ACTIONS(1988),
    [anon_sym_EQ_EQ] = ACTIONS(1988),
    [anon_sym_BANG_EQ] = ACTIONS(1988),
    [anon_sym_GT_EQ] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1990),
    [anon_sym_LT_GT] = ACTIONS(1988),
    [anon_sym_is] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(535),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1988),
  },
  [750] = {
    [sym__primary_expression] = STATE(1175),
    [sym_binary_operator] = STATE(1175),
    [sym_unary_operator] = STATE(1175),
    [sym_attribute] = STATE(1175),
    [sym_subscript] = STATE(1175),
    [sym_call] = STATE(1175),
    [sym_list] = STATE(1175),
    [sym_list_comprehension] = STATE(1175),
    [sym_dictionary] = STATE(1175),
    [sym_dictionary_comprehension] = STATE(1175),
    [sym_set] = STATE(1175),
    [sym_set_comprehension] = STATE(1175),
    [sym_parenthesized_expression] = STATE(1175),
    [sym_tuple] = STATE(1175),
    [sym_generator_expression] = STATE(1175),
    [sym_concatenated_string] = STATE(1175),
    [sym_string] = STATE(96),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(2345),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(2347),
    [sym_float] = ACTIONS(2347),
    [sym_identifier] = ACTIONS(2347),
    [sym_true] = ACTIONS(2347),
    [sym_false] = ACTIONS(2347),
    [sym_none] = ACTIONS(2347),
    [sym_comment] = ACTIONS(73),
  },
  [751] = {
    [sym_argument_list] = STATE(315),
    [sym_generator_expression] = STATE(315),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_from] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(579),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(573),
    [anon_sym_PERCENT] = ACTIONS(579),
    [anon_sym_SLASH_SLASH] = ACTIONS(579),
    [anon_sym_STAR_STAR] = ACTIONS(585),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1984),
  },
  [752] = {
    [sym_argument_list] = STATE(315),
    [sym_generator_expression] = STATE(315),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_from] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_GT_GT] = ACTIONS(575),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(579),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(583),
    [anon_sym_DASH] = ACTIONS(583),
    [anon_sym_SLASH] = ACTIONS(573),
    [anon_sym_PERCENT] = ACTIONS(579),
    [anon_sym_SLASH_SLASH] = ACTIONS(579),
    [anon_sym_STAR_STAR] = ACTIONS(585),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_CARET] = ACTIONS(591),
    [anon_sym_LT_LT] = ACTIONS(575),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1984),
  },
  [753] = {
    [sym_argument_list] = STATE(315),
    [sym_generator_expression] = STATE(315),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_from] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_GT_GT] = ACTIONS(575),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(579),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(583),
    [anon_sym_DASH] = ACTIONS(583),
    [anon_sym_SLASH] = ACTIONS(573),
    [anon_sym_PERCENT] = ACTIONS(579),
    [anon_sym_SLASH_SLASH] = ACTIONS(579),
    [anon_sym_STAR_STAR] = ACTIONS(585),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(591),
    [anon_sym_LT_LT] = ACTIONS(575),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1984),
  },
  [754] = {
    [sym_argument_list] = STATE(315),
    [sym_generator_expression] = STATE(315),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_from] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_GT_GT] = ACTIONS(575),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(579),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(583),
    [anon_sym_DASH] = ACTIONS(583),
    [anon_sym_SLASH] = ACTIONS(573),
    [anon_sym_PERCENT] = ACTIONS(579),
    [anon_sym_SLASH_SLASH] = ACTIONS(579),
    [anon_sym_STAR_STAR] = ACTIONS(585),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(575),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1984),
  },
  [755] = {
    [aux_sym_comparison_operator_repeat1] = STATE(755),
    [sym__newline] = ACTIONS(1988),
    [anon_sym_from] = ACTIONS(1988),
    [anon_sym_COMMA] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(2349),
    [anon_sym_not] = ACTIONS(2352),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(2355),
    [anon_sym_LT_EQ] = ACTIONS(2349),
    [anon_sym_EQ_EQ] = ACTIONS(2349),
    [anon_sym_BANG_EQ] = ACTIONS(2349),
    [anon_sym_GT_EQ] = ACTIONS(2349),
    [anon_sym_GT] = ACTIONS(2355),
    [anon_sym_LT_GT] = ACTIONS(2349),
    [anon_sym_is] = ACTIONS(2358),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1988),
  },
  [756] = {
    [sym_string] = STATE(756),
    [aux_sym_concatenated_string_repeat1] = STATE(756),
    [sym__newline] = ACTIONS(2050),
    [sym__string_start] = ACTIONS(2299),
    [anon_sym_DOT] = ACTIONS(2050),
    [anon_sym_from] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(2050),
    [anon_sym_COMMA] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2050),
    [anon_sym_if] = ACTIONS(2050),
    [anon_sym_in] = ACTIONS(2050),
    [anon_sym_AT] = ACTIONS(2050),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_and] = ACTIONS(2050),
    [anon_sym_or] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_SLASH] = ACTIONS(2055),
    [anon_sym_PERCENT] = ACTIONS(2050),
    [anon_sym_SLASH_SLASH] = ACTIONS(2050),
    [anon_sym_STAR_STAR] = ACTIONS(2050),
    [anon_sym_PIPE] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2050),
    [anon_sym_CARET] = ACTIONS(2050),
    [anon_sym_LT_LT] = ACTIONS(2050),
    [anon_sym_LT] = ACTIONS(2055),
    [anon_sym_LT_EQ] = ACTIONS(2050),
    [anon_sym_EQ_EQ] = ACTIONS(2050),
    [anon_sym_BANG_EQ] = ACTIONS(2050),
    [anon_sym_GT_EQ] = ACTIONS(2050),
    [anon_sym_GT] = ACTIONS(2055),
    [anon_sym_LT_GT] = ACTIONS(2050),
    [anon_sym_is] = ACTIONS(2050),
    [anon_sym_LBRACK] = ACTIONS(2050),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2050),
  },
  [757] = {
    [anon_sym_if] = ACTIONS(599),
    [anon_sym_COLON] = ACTIONS(1660),
    [anon_sym_and] = ACTIONS(603),
    [anon_sym_or] = ACTIONS(605),
    [sym_comment] = ACTIONS(73),
  },
  [758] = {
    [sym__expression] = STATE(1176),
    [sym__primary_expression] = STATE(102),
    [sym_not_operator] = STATE(1176),
    [sym_boolean_operator] = STATE(1176),
    [sym_binary_operator] = STATE(102),
    [sym_unary_operator] = STATE(102),
    [sym_comparison_operator] = STATE(1176),
    [sym_lambda] = STATE(1176),
    [sym_attribute] = STATE(102),
    [sym_subscript] = STATE(102),
    [sym_call] = STATE(102),
    [sym_list] = STATE(102),
    [sym_list_comprehension] = STATE(102),
    [sym_dictionary] = STATE(102),
    [sym_dictionary_comprehension] = STATE(102),
    [sym_set] = STATE(102),
    [sym_set_comprehension] = STATE(102),
    [sym_parenthesized_expression] = STATE(102),
    [sym_tuple] = STATE(102),
    [sym_generator_expression] = STATE(102),
    [sym_conditional_expression] = STATE(1176),
    [sym_concatenated_string] = STATE(102),
    [sym_string] = STATE(103),
    [sym_await] = STATE(1176),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [759] = {
    [anon_sym_if] = ACTIONS(1925),
    [anon_sym_else] = ACTIONS(2361),
    [anon_sym_and] = ACTIONS(1929),
    [anon_sym_or] = ACTIONS(1931),
    [sym_comment] = ACTIONS(73),
  },
  [760] = {
    [sym__statement] = STATE(1179),
    [sym__simple_statements] = STATE(1179),
    [sym_import_statement] = STATE(799),
    [sym_future_import_statement] = STATE(799),
    [sym_import_from_statement] = STATE(799),
    [sym_print_statement] = STATE(799),
    [sym_assert_statement] = STATE(799),
    [sym_expression_statement] = STATE(799),
    [sym_return_statement] = STATE(799),
    [sym_delete_statement] = STATE(799),
    [sym_raise_statement] = STATE(799),
    [sym_pass_statement] = STATE(799),
    [sym_break_statement] = STATE(799),
    [sym_continue_statement] = STATE(799),
    [sym_if_statement] = STATE(1179),
    [sym_for_statement] = STATE(1179),
    [sym_while_statement] = STATE(1179),
    [sym_try_statement] = STATE(1179),
    [sym_with_statement] = STATE(1179),
    [sym_function_definition] = STATE(1179),
    [sym_global_statement] = STATE(799),
    [sym_nonlocal_statement] = STATE(799),
    [sym_exec_statement] = STATE(799),
    [sym_class_definition] = STATE(1179),
    [sym_decorated_definition] = STATE(1179),
    [sym_decorator] = STATE(801),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [aux_sym_module_repeat1] = STATE(1179),
    [aux_sym_decorated_definition_repeat1] = STATE(801),
    [sym__dedent] = ACTIONS(2363),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(1522),
    [anon_sym_async] = ACTIONS(1524),
    [anon_sym_for] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1528),
    [anon_sym_try] = ACTIONS(1530),
    [anon_sym_with] = ACTIONS(1532),
    [anon_sym_def] = ACTIONS(1534),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1536),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [761] = {
    [sym_elif_clause] = STATE(1183),
    [sym_else_clause] = STATE(1182),
    [aux_sym_if_statement_repeat1] = STATE(1183),
    [sym__string_start] = ACTIONS(2365),
    [ts_builtin_sym_end] = ACTIONS(2365),
    [anon_sym_import] = ACTIONS(2367),
    [anon_sym_from] = ACTIONS(2367),
    [anon_sym_LPAREN] = ACTIONS(2365),
    [anon_sym_print] = ACTIONS(2367),
    [anon_sym_assert] = ACTIONS(2367),
    [anon_sym_return] = ACTIONS(2367),
    [anon_sym_del] = ACTIONS(2367),
    [anon_sym_raise] = ACTIONS(2367),
    [anon_sym_pass] = ACTIONS(2367),
    [anon_sym_break] = ACTIONS(2367),
    [anon_sym_continue] = ACTIONS(2367),
    [anon_sym_if] = ACTIONS(2367),
    [anon_sym_elif] = ACTIONS(2369),
    [anon_sym_else] = ACTIONS(2371),
    [anon_sym_async] = ACTIONS(2367),
    [anon_sym_for] = ACTIONS(2367),
    [anon_sym_while] = ACTIONS(2367),
    [anon_sym_try] = ACTIONS(2367),
    [anon_sym_with] = ACTIONS(2367),
    [anon_sym_def] = ACTIONS(2367),
    [anon_sym_global] = ACTIONS(2367),
    [anon_sym_nonlocal] = ACTIONS(2367),
    [anon_sym_exec] = ACTIONS(2367),
    [anon_sym_class] = ACTIONS(2367),
    [anon_sym_AT] = ACTIONS(2365),
    [anon_sym_not] = ACTIONS(2367),
    [anon_sym_PLUS] = ACTIONS(2365),
    [anon_sym_DASH] = ACTIONS(2365),
    [anon_sym_TILDE] = ACTIONS(2365),
    [anon_sym_lambda] = ACTIONS(2367),
    [anon_sym_yield] = ACTIONS(2367),
    [anon_sym_LBRACK] = ACTIONS(2365),
    [sym_ellipsis] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2365),
    [sym_integer] = ACTIONS(2367),
    [sym_float] = ACTIONS(2367),
    [sym_identifier] = ACTIONS(2367),
    [sym_true] = ACTIONS(2367),
    [sym_false] = ACTIONS(2367),
    [sym_none] = ACTIONS(2367),
    [anon_sym_await] = ACTIONS(2367),
    [sym_comment] = ACTIONS(73),
  },
  [762] = {
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_COLON] = ACTIONS(1957),
    [anon_sym_and] = ACTIONS(603),
    [anon_sym_or] = ACTIONS(1957),
    [sym_comment] = ACTIONS(73),
  },
  [763] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1984),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1986),
    [anon_sym_PERCENT] = ACTIONS(1984),
    [anon_sym_SLASH_SLASH] = ACTIONS(1984),
    [anon_sym_STAR_STAR] = ACTIONS(619),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [764] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(613),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_SLASH] = ACTIONS(607),
    [anon_sym_PERCENT] = ACTIONS(613),
    [anon_sym_SLASH_SLASH] = ACTIONS(613),
    [anon_sym_STAR_STAR] = ACTIONS(619),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [765] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_GT_GT] = ACTIONS(609),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_COLON] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(1988),
    [anon_sym_AT] = ACTIONS(613),
    [anon_sym_not] = ACTIONS(1988),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_SLASH] = ACTIONS(607),
    [anon_sym_PERCENT] = ACTIONS(613),
    [anon_sym_SLASH_SLASH] = ACTIONS(613),
    [anon_sym_STAR_STAR] = ACTIONS(619),
    [anon_sym_PIPE] = ACTIONS(621),
    [anon_sym_AMP] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(625),
    [anon_sym_LT_LT] = ACTIONS(609),
    [anon_sym_LT] = ACTIONS(1990),
    [anon_sym_LT_EQ] = ACTIONS(1988),
    [anon_sym_EQ_EQ] = ACTIONS(1988),
    [anon_sym_BANG_EQ] = ACTIONS(1988),
    [anon_sym_GT_EQ] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1990),
    [anon_sym_LT_GT] = ACTIONS(1988),
    [anon_sym_is] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(473),
    [sym_comment] = ACTIONS(73),
  },
  [766] = {
    [sym__primary_expression] = STATE(1184),
    [sym_binary_operator] = STATE(1184),
    [sym_unary_operator] = STATE(1184),
    [sym_attribute] = STATE(1184),
    [sym_subscript] = STATE(1184),
    [sym_call] = STATE(1184),
    [sym_list] = STATE(1184),
    [sym_list_comprehension] = STATE(1184),
    [sym_dictionary] = STATE(1184),
    [sym_dictionary_comprehension] = STATE(1184),
    [sym_set] = STATE(1184),
    [sym_set_comprehension] = STATE(1184),
    [sym_parenthesized_expression] = STATE(1184),
    [sym_tuple] = STATE(1184),
    [sym_generator_expression] = STATE(1184),
    [sym_concatenated_string] = STATE(1184),
    [sym_string] = STATE(103),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2373),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2375),
    [sym_float] = ACTIONS(2375),
    [sym_identifier] = ACTIONS(2375),
    [sym_true] = ACTIONS(2375),
    [sym_false] = ACTIONS(2375),
    [sym_none] = ACTIONS(2375),
    [sym_comment] = ACTIONS(73),
  },
  [767] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(613),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(607),
    [anon_sym_PERCENT] = ACTIONS(613),
    [anon_sym_SLASH_SLASH] = ACTIONS(613),
    [anon_sym_STAR_STAR] = ACTIONS(619),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [768] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_GT_GT] = ACTIONS(609),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(613),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_SLASH] = ACTIONS(607),
    [anon_sym_PERCENT] = ACTIONS(613),
    [anon_sym_SLASH_SLASH] = ACTIONS(613),
    [anon_sym_STAR_STAR] = ACTIONS(619),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(625),
    [anon_sym_LT_LT] = ACTIONS(609),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [769] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_GT_GT] = ACTIONS(609),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(613),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_SLASH] = ACTIONS(607),
    [anon_sym_PERCENT] = ACTIONS(613),
    [anon_sym_SLASH_SLASH] = ACTIONS(613),
    [anon_sym_STAR_STAR] = ACTIONS(619),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(625),
    [anon_sym_LT_LT] = ACTIONS(609),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [770] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_GT_GT] = ACTIONS(609),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(613),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_SLASH] = ACTIONS(607),
    [anon_sym_PERCENT] = ACTIONS(613),
    [anon_sym_SLASH_SLASH] = ACTIONS(613),
    [anon_sym_STAR_STAR] = ACTIONS(619),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(609),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [771] = {
    [aux_sym_comparison_operator_repeat1] = STATE(771),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_COLON] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(2377),
    [anon_sym_not] = ACTIONS(2380),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(2383),
    [anon_sym_LT_EQ] = ACTIONS(2377),
    [anon_sym_EQ_EQ] = ACTIONS(2377),
    [anon_sym_BANG_EQ] = ACTIONS(2377),
    [anon_sym_GT_EQ] = ACTIONS(2377),
    [anon_sym_GT] = ACTIONS(2383),
    [anon_sym_LT_GT] = ACTIONS(2377),
    [anon_sym_is] = ACTIONS(2386),
    [sym_comment] = ACTIONS(73),
  },
  [772] = {
    [sym_string] = STATE(772),
    [aux_sym_concatenated_string_repeat1] = STATE(772),
    [sym__string_start] = ACTIONS(2241),
    [anon_sym_DOT] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2050),
    [anon_sym_if] = ACTIONS(2050),
    [anon_sym_COLON] = ACTIONS(2050),
    [anon_sym_in] = ACTIONS(2050),
    [anon_sym_AT] = ACTIONS(2050),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_and] = ACTIONS(2050),
    [anon_sym_or] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_SLASH] = ACTIONS(2055),
    [anon_sym_PERCENT] = ACTIONS(2050),
    [anon_sym_SLASH_SLASH] = ACTIONS(2050),
    [anon_sym_STAR_STAR] = ACTIONS(2050),
    [anon_sym_PIPE] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2050),
    [anon_sym_CARET] = ACTIONS(2050),
    [anon_sym_LT_LT] = ACTIONS(2050),
    [anon_sym_LT] = ACTIONS(2055),
    [anon_sym_LT_EQ] = ACTIONS(2050),
    [anon_sym_EQ_EQ] = ACTIONS(2050),
    [anon_sym_BANG_EQ] = ACTIONS(2050),
    [anon_sym_GT_EQ] = ACTIONS(2050),
    [anon_sym_GT] = ACTIONS(2055),
    [anon_sym_LT_GT] = ACTIONS(2050),
    [anon_sym_is] = ACTIONS(2050),
    [anon_sym_LBRACK] = ACTIONS(2050),
    [sym_comment] = ACTIONS(73),
  },
  [773] = {
    [sym_expression_list] = STATE(1185),
    [sym__expression] = STATE(778),
    [sym__primary_expression] = STATE(432),
    [sym_not_operator] = STATE(778),
    [sym_boolean_operator] = STATE(778),
    [sym_binary_operator] = STATE(432),
    [sym_unary_operator] = STATE(432),
    [sym_comparison_operator] = STATE(778),
    [sym_lambda] = STATE(778),
    [sym_attribute] = STATE(432),
    [sym_subscript] = STATE(432),
    [sym_call] = STATE(432),
    [sym_list] = STATE(432),
    [sym_list_comprehension] = STATE(432),
    [sym_dictionary] = STATE(432),
    [sym_dictionary_comprehension] = STATE(432),
    [sym_set] = STATE(432),
    [sym_set_comprehension] = STATE(432),
    [sym_parenthesized_expression] = STATE(432),
    [sym_tuple] = STATE(432),
    [sym_generator_expression] = STATE(432),
    [sym_conditional_expression] = STATE(778),
    [sym_concatenated_string] = STATE(432),
    [sym_string] = STATE(433),
    [sym_await] = STATE(778),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(735),
    [anon_sym_lambda] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(741),
    [sym_float] = ACTIONS(741),
    [sym_identifier] = ACTIONS(741),
    [sym_true] = ACTIONS(741),
    [sym_false] = ACTIONS(741),
    [sym_none] = ACTIONS(741),
    [anon_sym_await] = ACTIONS(743),
    [sym_comment] = ACTIONS(73),
  },
  [774] = {
    [sym__simple_statements] = STATE(1186),
    [sym_import_statement] = STATE(34),
    [sym_future_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym__suite] = STATE(1186),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(1448),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [775] = {
    [aux_sym_with_statement_repeat1] = STATE(813),
    [anon_sym_COMMA] = ACTIONS(661),
    [anon_sym_COLON] = ACTIONS(2389),
    [sym_comment] = ACTIONS(73),
  },
  [776] = {
    [anon_sym_COLON] = ACTIONS(2391),
    [anon_sym_DASH_GT] = ACTIONS(2393),
    [sym_comment] = ACTIONS(73),
  },
  [777] = {
    [anon_sym_COLON] = ACTIONS(2395),
    [sym_comment] = ACTIONS(73),
  },
  [778] = {
    [aux_sym_print_statement_repeat1] = STATE(1192),
    [anon_sym_COMMA] = ACTIONS(2397),
    [anon_sym_if] = ACTIONS(1610),
    [anon_sym_COLON] = ACTIONS(295),
    [anon_sym_and] = ACTIONS(1612),
    [anon_sym_or] = ACTIONS(1614),
    [sym_comment] = ACTIONS(73),
  },
  [779] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(2399),
    [anon_sym_STAR] = ACTIONS(637),
    [anon_sym_GT_GT] = ACTIONS(639),
    [anon_sym_in] = ACTIONS(2399),
    [anon_sym_AT] = ACTIONS(643),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(645),
    [anon_sym_SLASH] = ACTIONS(637),
    [anon_sym_PERCENT] = ACTIONS(643),
    [anon_sym_SLASH_SLASH] = ACTIONS(643),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(649),
    [anon_sym_AMP] = ACTIONS(651),
    [anon_sym_CARET] = ACTIONS(653),
    [anon_sym_LT_LT] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(473),
    [sym_comment] = ACTIONS(73),
  },
  [780] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1986),
    [anon_sym_PERCENT] = ACTIONS(1984),
    [anon_sym_SLASH_SLASH] = ACTIONS(1984),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [781] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(637),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(643),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(645),
    [anon_sym_SLASH] = ACTIONS(637),
    [anon_sym_PERCENT] = ACTIONS(643),
    [anon_sym_SLASH_SLASH] = ACTIONS(643),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [782] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(637),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(643),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(637),
    [anon_sym_PERCENT] = ACTIONS(643),
    [anon_sym_SLASH_SLASH] = ACTIONS(643),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [783] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(637),
    [anon_sym_GT_GT] = ACTIONS(639),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(643),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(645),
    [anon_sym_SLASH] = ACTIONS(637),
    [anon_sym_PERCENT] = ACTIONS(643),
    [anon_sym_SLASH_SLASH] = ACTIONS(643),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(651),
    [anon_sym_CARET] = ACTIONS(653),
    [anon_sym_LT_LT] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [784] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(637),
    [anon_sym_GT_GT] = ACTIONS(639),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(643),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(645),
    [anon_sym_SLASH] = ACTIONS(637),
    [anon_sym_PERCENT] = ACTIONS(643),
    [anon_sym_SLASH_SLASH] = ACTIONS(643),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(653),
    [anon_sym_LT_LT] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [785] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(637),
    [anon_sym_GT_GT] = ACTIONS(639),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(643),
    [anon_sym_PLUS] = ACTIONS(645),
    [anon_sym_DASH] = ACTIONS(645),
    [anon_sym_SLASH] = ACTIONS(637),
    [anon_sym_PERCENT] = ACTIONS(643),
    [anon_sym_SLASH_SLASH] = ACTIONS(643),
    [anon_sym_STAR_STAR] = ACTIONS(647),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(639),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [786] = {
    [sym__primary_expression] = STATE(779),
    [sym_binary_operator] = STATE(779),
    [sym_unary_operator] = STATE(779),
    [sym_attribute] = STATE(779),
    [sym_subscript] = STATE(779),
    [sym_call] = STATE(779),
    [sym_list] = STATE(779),
    [sym_list_comprehension] = STATE(779),
    [sym_dictionary] = STATE(779),
    [sym_dictionary_comprehension] = STATE(779),
    [sym_set] = STATE(779),
    [sym_set_comprehension] = STATE(779),
    [sym_parenthesized_expression] = STATE(779),
    [sym_tuple] = STATE(779),
    [sym_generator_expression] = STATE(779),
    [sym_concatenated_string] = STATE(779),
    [sym_string] = STATE(110),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_in] = ACTIONS(2401),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1488),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1490),
    [sym_float] = ACTIONS(1490),
    [sym_identifier] = ACTIONS(1490),
    [sym_true] = ACTIONS(1490),
    [sym_false] = ACTIONS(1490),
    [sym_none] = ACTIONS(1490),
    [sym_comment] = ACTIONS(73),
  },
  [787] = {
    [aux_sym_variables_repeat1] = STATE(787),
    [anon_sym_COMMA] = ACTIONS(2403),
    [anon_sym_in] = ACTIONS(2399),
    [sym_comment] = ACTIONS(73),
  },
  [788] = {
    [sym_string] = STATE(788),
    [aux_sym_concatenated_string_repeat1] = STATE(788),
    [sym__string_start] = ACTIONS(2241),
    [anon_sym_DOT] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(2050),
    [anon_sym_COMMA] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2050),
    [anon_sym_in] = ACTIONS(2050),
    [anon_sym_AT] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_SLASH] = ACTIONS(2055),
    [anon_sym_PERCENT] = ACTIONS(2050),
    [anon_sym_SLASH_SLASH] = ACTIONS(2050),
    [anon_sym_STAR_STAR] = ACTIONS(2050),
    [anon_sym_PIPE] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2050),
    [anon_sym_CARET] = ACTIONS(2050),
    [anon_sym_LT_LT] = ACTIONS(2050),
    [anon_sym_LBRACK] = ACTIONS(2050),
    [sym_comment] = ACTIONS(73),
  },
  [789] = {
    [sym_else_clause] = STATE(1194),
    [sym__string_start] = ACTIONS(2406),
    [ts_builtin_sym_end] = ACTIONS(2406),
    [anon_sym_import] = ACTIONS(2408),
    [anon_sym_from] = ACTIONS(2408),
    [anon_sym_LPAREN] = ACTIONS(2406),
    [anon_sym_print] = ACTIONS(2408),
    [anon_sym_assert] = ACTIONS(2408),
    [anon_sym_return] = ACTIONS(2408),
    [anon_sym_del] = ACTIONS(2408),
    [anon_sym_raise] = ACTIONS(2408),
    [anon_sym_pass] = ACTIONS(2408),
    [anon_sym_break] = ACTIONS(2408),
    [anon_sym_continue] = ACTIONS(2408),
    [anon_sym_if] = ACTIONS(2408),
    [anon_sym_else] = ACTIONS(2371),
    [anon_sym_async] = ACTIONS(2408),
    [anon_sym_for] = ACTIONS(2408),
    [anon_sym_while] = ACTIONS(2408),
    [anon_sym_try] = ACTIONS(2408),
    [anon_sym_with] = ACTIONS(2408),
    [anon_sym_def] = ACTIONS(2408),
    [anon_sym_global] = ACTIONS(2408),
    [anon_sym_nonlocal] = ACTIONS(2408),
    [anon_sym_exec] = ACTIONS(2408),
    [anon_sym_class] = ACTIONS(2408),
    [anon_sym_AT] = ACTIONS(2406),
    [anon_sym_not] = ACTIONS(2408),
    [anon_sym_PLUS] = ACTIONS(2406),
    [anon_sym_DASH] = ACTIONS(2406),
    [anon_sym_TILDE] = ACTIONS(2406),
    [anon_sym_lambda] = ACTIONS(2408),
    [anon_sym_yield] = ACTIONS(2408),
    [anon_sym_LBRACK] = ACTIONS(2406),
    [sym_ellipsis] = ACTIONS(2406),
    [anon_sym_LBRACE] = ACTIONS(2406),
    [sym_integer] = ACTIONS(2408),
    [sym_float] = ACTIONS(2408),
    [sym_identifier] = ACTIONS(2408),
    [sym_true] = ACTIONS(2408),
    [sym_false] = ACTIONS(2408),
    [sym_none] = ACTIONS(2408),
    [anon_sym_await] = ACTIONS(2408),
    [sym_comment] = ACTIONS(73),
  },
  [790] = {
    [anon_sym_except] = ACTIONS(2410),
    [anon_sym_finally] = ACTIONS(2410),
    [sym_comment] = ACTIONS(73),
  },
  [791] = {
    [sym__expression] = STATE(1195),
    [sym__primary_expression] = STATE(102),
    [sym_not_operator] = STATE(1195),
    [sym_boolean_operator] = STATE(1195),
    [sym_binary_operator] = STATE(102),
    [sym_unary_operator] = STATE(102),
    [sym_comparison_operator] = STATE(1195),
    [sym_lambda] = STATE(1195),
    [sym_attribute] = STATE(102),
    [sym_subscript] = STATE(102),
    [sym_call] = STATE(102),
    [sym_list] = STATE(102),
    [sym_list_comprehension] = STATE(102),
    [sym_dictionary] = STATE(102),
    [sym_dictionary_comprehension] = STATE(102),
    [sym_set] = STATE(102),
    [sym_set_comprehension] = STATE(102),
    [sym_parenthesized_expression] = STATE(102),
    [sym_tuple] = STATE(102),
    [sym_generator_expression] = STATE(102),
    [sym_conditional_expression] = STATE(1195),
    [sym_concatenated_string] = STATE(102),
    [sym_string] = STATE(103),
    [sym_await] = STATE(1195),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [792] = {
    [anon_sym_for] = ACTIONS(2412),
    [anon_sym_with] = ACTIONS(2414),
    [anon_sym_def] = ACTIONS(2416),
    [sym_comment] = ACTIONS(73),
  },
  [793] = {
    [sym_variables] = STATE(1199),
    [sym__primary_expression] = STATE(109),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(110),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(191),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(193),
    [sym_float] = ACTIONS(193),
    [sym_identifier] = ACTIONS(193),
    [sym_true] = ACTIONS(193),
    [sym_false] = ACTIONS(193),
    [sym_none] = ACTIONS(193),
    [sym_comment] = ACTIONS(73),
  },
  [794] = {
    [sym__expression] = STATE(1200),
    [sym__primary_expression] = STATE(102),
    [sym_not_operator] = STATE(1200),
    [sym_boolean_operator] = STATE(1200),
    [sym_binary_operator] = STATE(102),
    [sym_unary_operator] = STATE(102),
    [sym_comparison_operator] = STATE(1200),
    [sym_lambda] = STATE(1200),
    [sym_attribute] = STATE(102),
    [sym_subscript] = STATE(102),
    [sym_call] = STATE(102),
    [sym_list] = STATE(102),
    [sym_list_comprehension] = STATE(102),
    [sym_dictionary] = STATE(102),
    [sym_dictionary_comprehension] = STATE(102),
    [sym_set] = STATE(102),
    [sym_set_comprehension] = STATE(102),
    [sym_parenthesized_expression] = STATE(102),
    [sym_tuple] = STATE(102),
    [sym_generator_expression] = STATE(102),
    [sym_conditional_expression] = STATE(1200),
    [sym_concatenated_string] = STATE(102),
    [sym_string] = STATE(103),
    [sym_await] = STATE(1200),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [795] = {
    [anon_sym_COLON] = ACTIONS(2418),
    [sym_comment] = ACTIONS(73),
  },
  [796] = {
    [sym_with_item] = STATE(1202),
    [sym__expression] = STATE(118),
    [sym__primary_expression] = STATE(119),
    [sym_not_operator] = STATE(118),
    [sym_boolean_operator] = STATE(118),
    [sym_binary_operator] = STATE(119),
    [sym_unary_operator] = STATE(119),
    [sym_comparison_operator] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym_attribute] = STATE(119),
    [sym_subscript] = STATE(119),
    [sym_call] = STATE(119),
    [sym_list] = STATE(119),
    [sym_list_comprehension] = STATE(119),
    [sym_dictionary] = STATE(119),
    [sym_dictionary_comprehension] = STATE(119),
    [sym_set] = STATE(119),
    [sym_set_comprehension] = STATE(119),
    [sym_parenthesized_expression] = STATE(119),
    [sym_tuple] = STATE(119),
    [sym_generator_expression] = STATE(119),
    [sym_conditional_expression] = STATE(118),
    [sym_concatenated_string] = STATE(119),
    [sym_string] = STATE(120),
    [sym_await] = STATE(118),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(197),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_lambda] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(203),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(205),
    [sym_float] = ACTIONS(205),
    [sym_identifier] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_none] = ACTIONS(205),
    [anon_sym_await] = ACTIONS(207),
    [sym_comment] = ACTIONS(73),
  },
  [797] = {
    [sym_identifier] = ACTIONS(2420),
    [sym_comment] = ACTIONS(73),
  },
  [798] = {
    [sym_identifier] = ACTIONS(2422),
    [sym_comment] = ACTIONS(73),
  },
  [799] = {
    [aux_sym__simple_statements_repeat1] = STATE(1207),
    [sym__newline] = ACTIONS(2424),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2426),
  },
  [800] = {
    [sym__statement] = STATE(1209),
    [sym__simple_statements] = STATE(1209),
    [sym_import_statement] = STATE(799),
    [sym_future_import_statement] = STATE(799),
    [sym_import_from_statement] = STATE(799),
    [sym_print_statement] = STATE(799),
    [sym_assert_statement] = STATE(799),
    [sym_expression_statement] = STATE(799),
    [sym_return_statement] = STATE(799),
    [sym_delete_statement] = STATE(799),
    [sym_raise_statement] = STATE(799),
    [sym_pass_statement] = STATE(799),
    [sym_break_statement] = STATE(799),
    [sym_continue_statement] = STATE(799),
    [sym_if_statement] = STATE(1209),
    [sym_for_statement] = STATE(1209),
    [sym_while_statement] = STATE(1209),
    [sym_try_statement] = STATE(1209),
    [sym_with_statement] = STATE(1209),
    [sym_function_definition] = STATE(1209),
    [sym_global_statement] = STATE(799),
    [sym_nonlocal_statement] = STATE(799),
    [sym_exec_statement] = STATE(799),
    [sym_class_definition] = STATE(1209),
    [sym_decorated_definition] = STATE(1209),
    [sym_decorator] = STATE(801),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [aux_sym_module_repeat1] = STATE(1209),
    [aux_sym_decorated_definition_repeat1] = STATE(801),
    [sym__dedent] = ACTIONS(2428),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(1522),
    [anon_sym_async] = ACTIONS(1524),
    [anon_sym_for] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1528),
    [anon_sym_try] = ACTIONS(1530),
    [anon_sym_with] = ACTIONS(1532),
    [anon_sym_def] = ACTIONS(1534),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1536),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [801] = {
    [sym_function_definition] = STATE(1211),
    [sym_class_definition] = STATE(1211),
    [sym_decorator] = STATE(198),
    [aux_sym_decorated_definition_repeat1] = STATE(198),
    [anon_sym_async] = ACTIONS(2430),
    [anon_sym_def] = ACTIONS(2432),
    [anon_sym_class] = ACTIONS(2434),
    [anon_sym_AT] = ACTIONS(53),
    [sym_comment] = ACTIONS(73),
  },
  [802] = {
    [anon_sym_except] = ACTIONS(885),
    [anon_sym_finally] = ACTIONS(885),
    [sym_comment] = ACTIONS(73),
  },
  [803] = {
    [sym_import_statement] = STATE(517),
    [sym_future_import_statement] = STATE(517),
    [sym_import_from_statement] = STATE(517),
    [sym_print_statement] = STATE(517),
    [sym_assert_statement] = STATE(517),
    [sym_expression_statement] = STATE(517),
    [sym_return_statement] = STATE(517),
    [sym_delete_statement] = STATE(517),
    [sym_raise_statement] = STATE(517),
    [sym_pass_statement] = STATE(517),
    [sym_break_statement] = STATE(517),
    [sym_continue_statement] = STATE(517),
    [sym_global_statement] = STATE(517),
    [sym_nonlocal_statement] = STATE(517),
    [sym_exec_statement] = STATE(517),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__newline] = ACTIONS(2436),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [804] = {
    [aux_sym__simple_statements_repeat1] = STATE(519),
    [sym__newline] = ACTIONS(2436),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2438),
  },
  [805] = {
    [sym__expression] = STATE(1215),
    [sym__primary_expression] = STATE(119),
    [sym_not_operator] = STATE(1215),
    [sym_boolean_operator] = STATE(1215),
    [sym_binary_operator] = STATE(119),
    [sym_unary_operator] = STATE(119),
    [sym_comparison_operator] = STATE(1215),
    [sym_lambda] = STATE(1215),
    [sym_attribute] = STATE(119),
    [sym_subscript] = STATE(119),
    [sym_call] = STATE(119),
    [sym_list] = STATE(119),
    [sym_list_comprehension] = STATE(119),
    [sym_dictionary] = STATE(119),
    [sym_dictionary_comprehension] = STATE(119),
    [sym_set] = STATE(119),
    [sym_set_comprehension] = STATE(119),
    [sym_parenthesized_expression] = STATE(119),
    [sym_tuple] = STATE(119),
    [sym_generator_expression] = STATE(119),
    [sym_conditional_expression] = STATE(1215),
    [sym_concatenated_string] = STATE(119),
    [sym_string] = STATE(120),
    [sym_await] = STATE(1215),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(2440),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(197),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_lambda] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(203),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(205),
    [sym_float] = ACTIONS(205),
    [sym_identifier] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_none] = ACTIONS(205),
    [anon_sym_await] = ACTIONS(207),
    [sym_comment] = ACTIONS(73),
  },
  [806] = {
    [anon_sym_COLON] = ACTIONS(2442),
    [sym_comment] = ACTIONS(73),
  },
  [807] = {
    [sym__string_start] = ACTIONS(2444),
    [ts_builtin_sym_end] = ACTIONS(2444),
    [anon_sym_import] = ACTIONS(2446),
    [anon_sym_from] = ACTIONS(2446),
    [anon_sym_LPAREN] = ACTIONS(2444),
    [anon_sym_print] = ACTIONS(2446),
    [anon_sym_assert] = ACTIONS(2446),
    [anon_sym_return] = ACTIONS(2446),
    [anon_sym_del] = ACTIONS(2446),
    [anon_sym_raise] = ACTIONS(2446),
    [anon_sym_pass] = ACTIONS(2446),
    [anon_sym_break] = ACTIONS(2446),
    [anon_sym_continue] = ACTIONS(2446),
    [anon_sym_if] = ACTIONS(2446),
    [anon_sym_async] = ACTIONS(2446),
    [anon_sym_for] = ACTIONS(2446),
    [anon_sym_while] = ACTIONS(2446),
    [anon_sym_try] = ACTIONS(2446),
    [anon_sym_with] = ACTIONS(2446),
    [anon_sym_def] = ACTIONS(2446),
    [anon_sym_global] = ACTIONS(2446),
    [anon_sym_nonlocal] = ACTIONS(2446),
    [anon_sym_exec] = ACTIONS(2446),
    [anon_sym_class] = ACTIONS(2446),
    [anon_sym_AT] = ACTIONS(2444),
    [anon_sym_not] = ACTIONS(2446),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_TILDE] = ACTIONS(2444),
    [anon_sym_lambda] = ACTIONS(2446),
    [anon_sym_yield] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(2444),
    [sym_ellipsis] = ACTIONS(2444),
    [anon_sym_LBRACE] = ACTIONS(2444),
    [sym_integer] = ACTIONS(2446),
    [sym_float] = ACTIONS(2446),
    [sym_identifier] = ACTIONS(2446),
    [sym_true] = ACTIONS(2446),
    [sym_false] = ACTIONS(2446),
    [sym_none] = ACTIONS(2446),
    [anon_sym_await] = ACTIONS(2446),
    [sym_comment] = ACTIONS(73),
  },
  [808] = {
    [sym_else_clause] = STATE(1217),
    [sym_except_clause] = STATE(1219),
    [sym_finally_clause] = STATE(1218),
    [aux_sym_try_statement_repeat1] = STATE(1219),
    [sym__string_start] = ACTIONS(2444),
    [ts_builtin_sym_end] = ACTIONS(2444),
    [anon_sym_import] = ACTIONS(2446),
    [anon_sym_from] = ACTIONS(2446),
    [anon_sym_LPAREN] = ACTIONS(2444),
    [anon_sym_print] = ACTIONS(2446),
    [anon_sym_assert] = ACTIONS(2446),
    [anon_sym_return] = ACTIONS(2446),
    [anon_sym_del] = ACTIONS(2446),
    [anon_sym_raise] = ACTIONS(2446),
    [anon_sym_pass] = ACTIONS(2446),
    [anon_sym_break] = ACTIONS(2446),
    [anon_sym_continue] = ACTIONS(2446),
    [anon_sym_if] = ACTIONS(2446),
    [anon_sym_else] = ACTIONS(2371),
    [anon_sym_async] = ACTIONS(2446),
    [anon_sym_for] = ACTIONS(2446),
    [anon_sym_while] = ACTIONS(2446),
    [anon_sym_try] = ACTIONS(2446),
    [anon_sym_except] = ACTIONS(2448),
    [anon_sym_finally] = ACTIONS(2450),
    [anon_sym_with] = ACTIONS(2446),
    [anon_sym_def] = ACTIONS(2446),
    [anon_sym_global] = ACTIONS(2446),
    [anon_sym_nonlocal] = ACTIONS(2446),
    [anon_sym_exec] = ACTIONS(2446),
    [anon_sym_class] = ACTIONS(2446),
    [anon_sym_AT] = ACTIONS(2444),
    [anon_sym_not] = ACTIONS(2446),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_TILDE] = ACTIONS(2444),
    [anon_sym_lambda] = ACTIONS(2446),
    [anon_sym_yield] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(2444),
    [sym_ellipsis] = ACTIONS(2444),
    [anon_sym_LBRACE] = ACTIONS(2444),
    [sym_integer] = ACTIONS(2446),
    [sym_float] = ACTIONS(2446),
    [sym_identifier] = ACTIONS(2446),
    [sym_true] = ACTIONS(2446),
    [sym_false] = ACTIONS(2446),
    [sym_none] = ACTIONS(2446),
    [anon_sym_await] = ACTIONS(2446),
    [sym_comment] = ACTIONS(73),
  },
  [809] = {
    [anon_sym_COMMA] = ACTIONS(1660),
    [anon_sym_as] = ACTIONS(1660),
    [anon_sym_if] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(1660),
    [anon_sym_and] = ACTIONS(671),
    [anon_sym_or] = ACTIONS(673),
    [sym_comment] = ACTIONS(73),
  },
  [810] = {
    [sym__expression] = STATE(1220),
    [sym__primary_expression] = STATE(119),
    [sym_not_operator] = STATE(1220),
    [sym_boolean_operator] = STATE(1220),
    [sym_binary_operator] = STATE(119),
    [sym_unary_operator] = STATE(119),
    [sym_comparison_operator] = STATE(1220),
    [sym_lambda] = STATE(1220),
    [sym_attribute] = STATE(119),
    [sym_subscript] = STATE(119),
    [sym_call] = STATE(119),
    [sym_list] = STATE(119),
    [sym_list_comprehension] = STATE(119),
    [sym_dictionary] = STATE(119),
    [sym_dictionary_comprehension] = STATE(119),
    [sym_set] = STATE(119),
    [sym_set_comprehension] = STATE(119),
    [sym_parenthesized_expression] = STATE(119),
    [sym_tuple] = STATE(119),
    [sym_generator_expression] = STATE(119),
    [sym_conditional_expression] = STATE(1220),
    [sym_concatenated_string] = STATE(119),
    [sym_string] = STATE(120),
    [sym_await] = STATE(1220),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(197),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_lambda] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(203),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(205),
    [sym_float] = ACTIONS(205),
    [sym_identifier] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_none] = ACTIONS(205),
    [anon_sym_await] = ACTIONS(207),
    [sym_comment] = ACTIONS(73),
  },
  [811] = {
    [anon_sym_COMMA] = ACTIONS(2452),
    [anon_sym_COLON] = ACTIONS(2452),
    [sym_comment] = ACTIONS(73),
  },
  [812] = {
    [sym__string_start] = ACTIONS(2454),
    [ts_builtin_sym_end] = ACTIONS(2454),
    [anon_sym_import] = ACTIONS(2456),
    [anon_sym_from] = ACTIONS(2456),
    [anon_sym_LPAREN] = ACTIONS(2454),
    [anon_sym_print] = ACTIONS(2456),
    [anon_sym_assert] = ACTIONS(2456),
    [anon_sym_return] = ACTIONS(2456),
    [anon_sym_del] = ACTIONS(2456),
    [anon_sym_raise] = ACTIONS(2456),
    [anon_sym_pass] = ACTIONS(2456),
    [anon_sym_break] = ACTIONS(2456),
    [anon_sym_continue] = ACTIONS(2456),
    [anon_sym_if] = ACTIONS(2456),
    [anon_sym_async] = ACTIONS(2456),
    [anon_sym_for] = ACTIONS(2456),
    [anon_sym_while] = ACTIONS(2456),
    [anon_sym_try] = ACTIONS(2456),
    [anon_sym_with] = ACTIONS(2456),
    [anon_sym_def] = ACTIONS(2456),
    [anon_sym_global] = ACTIONS(2456),
    [anon_sym_nonlocal] = ACTIONS(2456),
    [anon_sym_exec] = ACTIONS(2456),
    [anon_sym_class] = ACTIONS(2456),
    [anon_sym_AT] = ACTIONS(2454),
    [anon_sym_not] = ACTIONS(2456),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_TILDE] = ACTIONS(2454),
    [anon_sym_lambda] = ACTIONS(2456),
    [anon_sym_yield] = ACTIONS(2456),
    [anon_sym_LBRACK] = ACTIONS(2454),
    [sym_ellipsis] = ACTIONS(2454),
    [anon_sym_LBRACE] = ACTIONS(2454),
    [sym_integer] = ACTIONS(2456),
    [sym_float] = ACTIONS(2456),
    [sym_identifier] = ACTIONS(2456),
    [sym_true] = ACTIONS(2456),
    [sym_false] = ACTIONS(2456),
    [sym_none] = ACTIONS(2456),
    [anon_sym_await] = ACTIONS(2456),
    [sym_comment] = ACTIONS(73),
  },
  [813] = {
    [aux_sym_with_statement_repeat1] = STATE(813),
    [anon_sym_COMMA] = ACTIONS(2458),
    [anon_sym_COLON] = ACTIONS(2452),
    [sym_comment] = ACTIONS(73),
  },
  [814] = {
    [anon_sym_COMMA] = ACTIONS(2461),
    [anon_sym_if] = ACTIONS(1610),
    [anon_sym_COLON] = ACTIONS(2461),
    [anon_sym_and] = ACTIONS(1612),
    [anon_sym_or] = ACTIONS(1614),
    [sym_comment] = ACTIONS(73),
  },
  [815] = {
    [anon_sym_if] = ACTIONS(1925),
    [anon_sym_else] = ACTIONS(2463),
    [anon_sym_and] = ACTIONS(1929),
    [anon_sym_or] = ACTIONS(1931),
    [sym_comment] = ACTIONS(73),
  },
  [816] = {
    [anon_sym_COMMA] = ACTIONS(1957),
    [anon_sym_as] = ACTIONS(1957),
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_COLON] = ACTIONS(1957),
    [anon_sym_and] = ACTIONS(671),
    [anon_sym_or] = ACTIONS(1957),
    [sym_comment] = ACTIONS(73),
  },
  [817] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_as] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1984),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1986),
    [anon_sym_PERCENT] = ACTIONS(1984),
    [anon_sym_SLASH_SLASH] = ACTIONS(1984),
    [anon_sym_STAR_STAR] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [818] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_as] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(675),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(681),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_DASH] = ACTIONS(685),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_PERCENT] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(681),
    [anon_sym_STAR_STAR] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [819] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1988),
    [anon_sym_as] = ACTIONS(1988),
    [anon_sym_STAR] = ACTIONS(675),
    [anon_sym_GT_GT] = ACTIONS(677),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_COLON] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(1988),
    [anon_sym_AT] = ACTIONS(681),
    [anon_sym_not] = ACTIONS(1988),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_DASH] = ACTIONS(685),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_PERCENT] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(681),
    [anon_sym_STAR_STAR] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(689),
    [anon_sym_AMP] = ACTIONS(691),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_LT_LT] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(1990),
    [anon_sym_LT_EQ] = ACTIONS(1988),
    [anon_sym_EQ_EQ] = ACTIONS(1988),
    [anon_sym_BANG_EQ] = ACTIONS(1988),
    [anon_sym_GT_EQ] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1990),
    [anon_sym_LT_GT] = ACTIONS(1988),
    [anon_sym_is] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(473),
    [sym_comment] = ACTIONS(73),
  },
  [820] = {
    [sym__primary_expression] = STATE(1222),
    [sym_binary_operator] = STATE(1222),
    [sym_unary_operator] = STATE(1222),
    [sym_attribute] = STATE(1222),
    [sym_subscript] = STATE(1222),
    [sym_call] = STATE(1222),
    [sym_list] = STATE(1222),
    [sym_list_comprehension] = STATE(1222),
    [sym_dictionary] = STATE(1222),
    [sym_dictionary_comprehension] = STATE(1222),
    [sym_set] = STATE(1222),
    [sym_set_comprehension] = STATE(1222),
    [sym_parenthesized_expression] = STATE(1222),
    [sym_tuple] = STATE(1222),
    [sym_generator_expression] = STATE(1222),
    [sym_concatenated_string] = STATE(1222),
    [sym_string] = STATE(120),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2465),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2467),
    [sym_float] = ACTIONS(2467),
    [sym_identifier] = ACTIONS(2467),
    [sym_true] = ACTIONS(2467),
    [sym_false] = ACTIONS(2467),
    [sym_none] = ACTIONS(2467),
    [sym_comment] = ACTIONS(73),
  },
  [821] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_as] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(675),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(681),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_PERCENT] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(681),
    [anon_sym_STAR_STAR] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [822] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_as] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(675),
    [anon_sym_GT_GT] = ACTIONS(677),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(681),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_DASH] = ACTIONS(685),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_PERCENT] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(681),
    [anon_sym_STAR_STAR] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(691),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_LT_LT] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [823] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_as] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(675),
    [anon_sym_GT_GT] = ACTIONS(677),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(681),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_DASH] = ACTIONS(685),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_PERCENT] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(681),
    [anon_sym_STAR_STAR] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_LT_LT] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [824] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_as] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(675),
    [anon_sym_GT_GT] = ACTIONS(677),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(681),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_DASH] = ACTIONS(685),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_PERCENT] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(681),
    [anon_sym_STAR_STAR] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [825] = {
    [aux_sym_comparison_operator_repeat1] = STATE(825),
    [anon_sym_COMMA] = ACTIONS(1988),
    [anon_sym_as] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_COLON] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(2469),
    [anon_sym_not] = ACTIONS(2472),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(2475),
    [anon_sym_LT_EQ] = ACTIONS(2469),
    [anon_sym_EQ_EQ] = ACTIONS(2469),
    [anon_sym_BANG_EQ] = ACTIONS(2469),
    [anon_sym_GT_EQ] = ACTIONS(2469),
    [anon_sym_GT] = ACTIONS(2475),
    [anon_sym_LT_GT] = ACTIONS(2469),
    [anon_sym_is] = ACTIONS(2478),
    [sym_comment] = ACTIONS(73),
  },
  [826] = {
    [sym_string] = STATE(826),
    [aux_sym_concatenated_string_repeat1] = STATE(826),
    [sym__string_start] = ACTIONS(2241),
    [anon_sym_DOT] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(2050),
    [anon_sym_COMMA] = ACTIONS(2050),
    [anon_sym_as] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2050),
    [anon_sym_if] = ACTIONS(2050),
    [anon_sym_COLON] = ACTIONS(2050),
    [anon_sym_in] = ACTIONS(2050),
    [anon_sym_AT] = ACTIONS(2050),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_and] = ACTIONS(2050),
    [anon_sym_or] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_SLASH] = ACTIONS(2055),
    [anon_sym_PERCENT] = ACTIONS(2050),
    [anon_sym_SLASH_SLASH] = ACTIONS(2050),
    [anon_sym_STAR_STAR] = ACTIONS(2050),
    [anon_sym_PIPE] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2050),
    [anon_sym_CARET] = ACTIONS(2050),
    [anon_sym_LT_LT] = ACTIONS(2050),
    [anon_sym_LT] = ACTIONS(2055),
    [anon_sym_LT_EQ] = ACTIONS(2050),
    [anon_sym_EQ_EQ] = ACTIONS(2050),
    [anon_sym_BANG_EQ] = ACTIONS(2050),
    [anon_sym_GT_EQ] = ACTIONS(2050),
    [anon_sym_GT] = ACTIONS(2055),
    [anon_sym_LT_GT] = ACTIONS(2050),
    [anon_sym_is] = ACTIONS(2050),
    [anon_sym_LBRACK] = ACTIONS(2050),
    [sym_comment] = ACTIONS(73),
  },
  [827] = {
    [anon_sym_COLON] = ACTIONS(2481),
    [anon_sym_DASH_GT] = ACTIONS(2481),
    [sym_comment] = ACTIONS(73),
  },
  [828] = {
    [sym__expression] = STATE(1228),
    [sym__primary_expression] = STATE(1229),
    [sym_not_operator] = STATE(1228),
    [sym_boolean_operator] = STATE(1228),
    [sym_binary_operator] = STATE(1229),
    [sym_unary_operator] = STATE(1229),
    [sym_comparison_operator] = STATE(1228),
    [sym_lambda] = STATE(1228),
    [sym_attribute] = STATE(1229),
    [sym_subscript] = STATE(1229),
    [sym_call] = STATE(1229),
    [sym_list] = STATE(1229),
    [sym_list_comprehension] = STATE(1229),
    [sym_dictionary] = STATE(1229),
    [sym_dictionary_comprehension] = STATE(1229),
    [sym_set] = STATE(1229),
    [sym_set_comprehension] = STATE(1229),
    [sym_parenthesized_expression] = STATE(1229),
    [sym_tuple] = STATE(1229),
    [sym_generator_expression] = STATE(1229),
    [sym_conditional_expression] = STATE(1228),
    [sym_concatenated_string] = STATE(1229),
    [sym_string] = STATE(1230),
    [sym_await] = STATE(1228),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(729),
    [anon_sym_COMMA] = ACTIONS(729),
    [anon_sym_STAR] = ACTIONS(2483),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(729),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2485),
    [anon_sym_PLUS] = ACTIONS(2487),
    [anon_sym_DASH] = ACTIONS(2487),
    [anon_sym_TILDE] = ACTIONS(2487),
    [anon_sym_lambda] = ACTIONS(2489),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2491),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2493),
    [sym_float] = ACTIONS(2493),
    [sym_identifier] = ACTIONS(2493),
    [sym_true] = ACTIONS(2493),
    [sym_false] = ACTIONS(2493),
    [sym_none] = ACTIONS(2493),
    [anon_sym_await] = ACTIONS(2495),
    [sym_comment] = ACTIONS(73),
  },
  [829] = {
    [aux_sym__parameters_repeat1] = STATE(1234),
    [anon_sym_RPAREN] = ACTIONS(747),
    [anon_sym_COMMA] = ACTIONS(2497),
    [anon_sym_COLON] = ACTIONS(2499),
    [anon_sym_EQ] = ACTIONS(2501),
    [sym_comment] = ACTIONS(73),
  },
  [830] = {
    [aux_sym__parameters_repeat1] = STATE(1238),
    [anon_sym_RPAREN] = ACTIONS(753),
    [anon_sym_COMMA] = ACTIONS(2503),
    [anon_sym_COLON] = ACTIONS(2505),
    [anon_sym_EQ] = ACTIONS(2507),
    [sym_comment] = ACTIONS(73),
  },
  [831] = {
    [anon_sym_RPAREN] = ACTIONS(2509),
    [sym_comment] = ACTIONS(73),
  },
  [832] = {
    [aux_sym__parameters_repeat1] = STATE(1238),
    [anon_sym_RPAREN] = ACTIONS(753),
    [anon_sym_COMMA] = ACTIONS(2503),
    [sym_comment] = ACTIONS(73),
  },
  [833] = {
    [aux_sym__parameters_repeat1] = STATE(1238),
    [anon_sym_RPAREN] = ACTIONS(753),
    [anon_sym_COMMA] = ACTIONS(2503),
    [anon_sym_COLON] = ACTIONS(2511),
    [sym_comment] = ACTIONS(73),
  },
  [834] = {
    [sym__simple_statements] = STATE(1241),
    [sym_import_statement] = STATE(34),
    [sym_future_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym__suite] = STATE(1241),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(1448),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [835] = {
    [sym__expression] = STATE(1242),
    [sym__primary_expression] = STATE(102),
    [sym_not_operator] = STATE(1242),
    [sym_boolean_operator] = STATE(1242),
    [sym_binary_operator] = STATE(102),
    [sym_unary_operator] = STATE(102),
    [sym_comparison_operator] = STATE(1242),
    [sym_lambda] = STATE(1242),
    [sym_attribute] = STATE(102),
    [sym_subscript] = STATE(102),
    [sym_call] = STATE(102),
    [sym_type] = STATE(1243),
    [sym_list] = STATE(102),
    [sym_list_comprehension] = STATE(102),
    [sym_dictionary] = STATE(102),
    [sym_dictionary_comprehension] = STATE(102),
    [sym_set] = STATE(102),
    [sym_set_comprehension] = STATE(102),
    [sym_parenthesized_expression] = STATE(102),
    [sym_tuple] = STATE(102),
    [sym_generator_expression] = STATE(102),
    [sym_conditional_expression] = STATE(1242),
    [sym_concatenated_string] = STATE(102),
    [sym_string] = STATE(103),
    [sym_await] = STATE(1242),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [836] = {
    [sym__newline] = ACTIONS(2513),
    [anon_sym_COMMA] = ACTIONS(2513),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2513),
  },
  [837] = {
    [aux_sym_global_statement_repeat1] = STATE(837),
    [sym__newline] = ACTIONS(2513),
    [anon_sym_COMMA] = ACTIONS(2515),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2513),
  },
  [838] = {
    [sym__newline] = ACTIONS(1145),
    [anon_sym_in] = ACTIONS(1145),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1145),
  },
  [839] = {
    [aux_sym_print_statement_repeat1] = STATE(1244),
    [sym__newline] = ACTIONS(2518),
    [anon_sym_COMMA] = ACTIONS(539),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_and] = ACTIONS(503),
    [anon_sym_or] = ACTIONS(505),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2518),
  },
  [840] = {
    [aux_sym_argument_list_repeat1] = STATE(1132),
    [anon_sym_RPAREN] = ACTIONS(2217),
    [anon_sym_COMMA] = ACTIONS(2219),
    [anon_sym_if] = ACTIONS(1198),
    [anon_sym_and] = ACTIONS(1200),
    [anon_sym_or] = ACTIONS(1202),
    [sym_comment] = ACTIONS(73),
  },
  [841] = {
    [sym__string_start] = ACTIONS(2520),
    [ts_builtin_sym_end] = ACTIONS(2520),
    [anon_sym_import] = ACTIONS(2522),
    [anon_sym_from] = ACTIONS(2522),
    [anon_sym_LPAREN] = ACTIONS(2520),
    [anon_sym_print] = ACTIONS(2522),
    [anon_sym_assert] = ACTIONS(2522),
    [anon_sym_return] = ACTIONS(2522),
    [anon_sym_del] = ACTIONS(2522),
    [anon_sym_raise] = ACTIONS(2522),
    [anon_sym_pass] = ACTIONS(2522),
    [anon_sym_break] = ACTIONS(2522),
    [anon_sym_continue] = ACTIONS(2522),
    [anon_sym_if] = ACTIONS(2522),
    [anon_sym_async] = ACTIONS(2522),
    [anon_sym_for] = ACTIONS(2522),
    [anon_sym_while] = ACTIONS(2522),
    [anon_sym_try] = ACTIONS(2522),
    [anon_sym_with] = ACTIONS(2522),
    [anon_sym_def] = ACTIONS(2522),
    [anon_sym_global] = ACTIONS(2522),
    [anon_sym_nonlocal] = ACTIONS(2522),
    [anon_sym_exec] = ACTIONS(2522),
    [anon_sym_class] = ACTIONS(2522),
    [anon_sym_AT] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2522),
    [anon_sym_PLUS] = ACTIONS(2520),
    [anon_sym_DASH] = ACTIONS(2520),
    [anon_sym_TILDE] = ACTIONS(2520),
    [anon_sym_lambda] = ACTIONS(2522),
    [anon_sym_yield] = ACTIONS(2522),
    [anon_sym_LBRACK] = ACTIONS(2520),
    [sym_ellipsis] = ACTIONS(2520),
    [anon_sym_LBRACE] = ACTIONS(2520),
    [sym_integer] = ACTIONS(2522),
    [sym_float] = ACTIONS(2522),
    [sym_identifier] = ACTIONS(2522),
    [sym_true] = ACTIONS(2522),
    [sym_false] = ACTIONS(2522),
    [sym_none] = ACTIONS(2522),
    [anon_sym_await] = ACTIONS(2522),
    [sym_comment] = ACTIONS(73),
  },
  [842] = {
    [sym__simple_statements] = STATE(1245),
    [sym_import_statement] = STATE(34),
    [sym_future_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym__suite] = STATE(1245),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(1448),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [843] = {
    [aux_sym_dotted_name_repeat1] = STATE(843),
    [sym__newline] = ACTIONS(2097),
    [anon_sym_DOT] = ACTIONS(2099),
    [anon_sym_LPAREN] = ACTIONS(2097),
    [sym_comment] = ACTIONS(73),
  },
  [844] = {
    [aux_sym_argument_list_repeat1] = STATE(1041),
    [anon_sym_RPAREN] = ACTIONS(1974),
    [anon_sym_COMMA] = ACTIONS(1982),
    [anon_sym_if] = ACTIONS(1198),
    [anon_sym_and] = ACTIONS(1200),
    [anon_sym_or] = ACTIONS(1202),
    [sym_comment] = ACTIONS(73),
  },
  [845] = {
    [anon_sym_async] = ACTIONS(2524),
    [anon_sym_def] = ACTIONS(2524),
    [anon_sym_class] = ACTIONS(2524),
    [anon_sym_AT] = ACTIONS(2524),
    [sym_comment] = ACTIONS(73),
  },
  [846] = {
    [anon_sym_COMMA] = ACTIONS(2526),
    [anon_sym_if] = ACTIONS(1610),
    [anon_sym_COLON] = ACTIONS(2526),
    [anon_sym_and] = ACTIONS(1612),
    [anon_sym_or] = ACTIONS(1614),
    [sym_comment] = ACTIONS(73),
  },
  [847] = {
    [anon_sym_COMMA] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(723),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_and] = ACTIONS(1612),
    [anon_sym_or] = ACTIONS(1614),
    [sym_comment] = ACTIONS(73),
  },
  [848] = {
    [sym__expression] = STATE(1246),
    [sym__primary_expression] = STATE(432),
    [sym_not_operator] = STATE(1246),
    [sym_boolean_operator] = STATE(1246),
    [sym_binary_operator] = STATE(432),
    [sym_unary_operator] = STATE(432),
    [sym_comparison_operator] = STATE(1246),
    [sym_lambda] = STATE(1246),
    [sym_attribute] = STATE(432),
    [sym_subscript] = STATE(432),
    [sym_call] = STATE(432),
    [sym_list] = STATE(432),
    [sym_list_comprehension] = STATE(432),
    [sym_dictionary] = STATE(432),
    [sym_dictionary_comprehension] = STATE(432),
    [sym_set] = STATE(432),
    [sym_set_comprehension] = STATE(432),
    [sym_parenthesized_expression] = STATE(432),
    [sym_tuple] = STATE(432),
    [sym_generator_expression] = STATE(432),
    [sym_conditional_expression] = STATE(1246),
    [sym_concatenated_string] = STATE(432),
    [sym_string] = STATE(433),
    [sym_await] = STATE(1246),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(735),
    [anon_sym_lambda] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(741),
    [sym_float] = ACTIONS(741),
    [sym_identifier] = ACTIONS(741),
    [sym_true] = ACTIONS(741),
    [sym_false] = ACTIONS(741),
    [sym_none] = ACTIONS(741),
    [anon_sym_await] = ACTIONS(743),
    [sym_comment] = ACTIONS(73),
  },
  [849] = {
    [anon_sym_COLON] = ACTIONS(2528),
    [sym_comment] = ACTIONS(73),
  },
  [850] = {
    [sym__expression] = STATE(1248),
    [sym__primary_expression] = STATE(538),
    [sym_not_operator] = STATE(1248),
    [sym_boolean_operator] = STATE(1248),
    [sym_binary_operator] = STATE(538),
    [sym_unary_operator] = STATE(538),
    [sym_comparison_operator] = STATE(1248),
    [sym_lambda] = STATE(1248),
    [sym_attribute] = STATE(538),
    [sym_subscript] = STATE(538),
    [sym_call] = STATE(538),
    [sym_list] = STATE(538),
    [sym_list_comprehension] = STATE(538),
    [sym_dictionary] = STATE(538),
    [sym_dictionary_comprehension] = STATE(538),
    [sym_set] = STATE(538),
    [sym_set_comprehension] = STATE(538),
    [sym_parenthesized_expression] = STATE(538),
    [sym_tuple] = STATE(538),
    [sym_generator_expression] = STATE(538),
    [sym_conditional_expression] = STATE(1248),
    [sym_concatenated_string] = STATE(538),
    [sym_string] = STATE(539),
    [sym_await] = STATE(1248),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_lambda] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(917),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(919),
    [sym_float] = ACTIONS(919),
    [sym_identifier] = ACTIONS(919),
    [sym_true] = ACTIONS(919),
    [sym_false] = ACTIONS(919),
    [sym_none] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(921),
    [sym_comment] = ACTIONS(73),
  },
  [851] = {
    [sym__expression] = STATE(652),
    [sym__primary_expression] = STATE(432),
    [sym_not_operator] = STATE(652),
    [sym_boolean_operator] = STATE(652),
    [sym_binary_operator] = STATE(432),
    [sym_unary_operator] = STATE(432),
    [sym_comparison_operator] = STATE(652),
    [sym_lambda] = STATE(652),
    [sym_attribute] = STATE(432),
    [sym_subscript] = STATE(432),
    [sym_call] = STATE(432),
    [sym_list] = STATE(432),
    [sym_list_comprehension] = STATE(432),
    [sym_dictionary] = STATE(432),
    [sym_dictionary_comprehension] = STATE(432),
    [sym_set] = STATE(432),
    [sym_set_comprehension] = STATE(432),
    [sym_parenthesized_expression] = STATE(432),
    [sym_tuple] = STATE(432),
    [sym_generator_expression] = STATE(432),
    [sym_conditional_expression] = STATE(652),
    [sym_concatenated_string] = STATE(432),
    [sym_string] = STATE(433),
    [sym_await] = STATE(652),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(735),
    [anon_sym_lambda] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(741),
    [sym_float] = ACTIONS(741),
    [sym_identifier] = ACTIONS(741),
    [sym_true] = ACTIONS(741),
    [sym_false] = ACTIONS(741),
    [sym_none] = ACTIONS(741),
    [anon_sym_await] = ACTIONS(743),
    [sym_comment] = ACTIONS(73),
  },
  [852] = {
    [sym__expression] = STATE(1249),
    [sym__primary_expression] = STATE(432),
    [sym_not_operator] = STATE(1249),
    [sym_boolean_operator] = STATE(1249),
    [sym_binary_operator] = STATE(432),
    [sym_unary_operator] = STATE(432),
    [sym_comparison_operator] = STATE(1249),
    [sym_lambda] = STATE(1249),
    [sym_attribute] = STATE(432),
    [sym_subscript] = STATE(432),
    [sym_call] = STATE(432),
    [sym_list] = STATE(432),
    [sym_list_comprehension] = STATE(432),
    [sym_dictionary] = STATE(432),
    [sym_dictionary_comprehension] = STATE(432),
    [sym_set] = STATE(432),
    [sym_set_comprehension] = STATE(432),
    [sym_parenthesized_expression] = STATE(432),
    [sym_tuple] = STATE(432),
    [sym_generator_expression] = STATE(432),
    [sym_conditional_expression] = STATE(1249),
    [sym_concatenated_string] = STATE(432),
    [sym_string] = STATE(433),
    [sym_await] = STATE(1249),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(735),
    [anon_sym_lambda] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(741),
    [sym_float] = ACTIONS(741),
    [sym_identifier] = ACTIONS(741),
    [sym_true] = ACTIONS(741),
    [sym_false] = ACTIONS(741),
    [sym_none] = ACTIONS(741),
    [anon_sym_await] = ACTIONS(743),
    [sym_comment] = ACTIONS(73),
  },
  [853] = {
    [sym__primary_expression] = STATE(1250),
    [sym_binary_operator] = STATE(1250),
    [sym_unary_operator] = STATE(1250),
    [sym_attribute] = STATE(1250),
    [sym_subscript] = STATE(1250),
    [sym_call] = STATE(1250),
    [sym_list] = STATE(1250),
    [sym_list_comprehension] = STATE(1250),
    [sym_dictionary] = STATE(1250),
    [sym_dictionary_comprehension] = STATE(1250),
    [sym_set] = STATE(1250),
    [sym_set_comprehension] = STATE(1250),
    [sym_parenthesized_expression] = STATE(1250),
    [sym_tuple] = STATE(1250),
    [sym_generator_expression] = STATE(1250),
    [sym_concatenated_string] = STATE(1250),
    [sym_string] = STATE(433),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2530),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2532),
    [sym_float] = ACTIONS(2532),
    [sym_identifier] = ACTIONS(2532),
    [sym_true] = ACTIONS(2532),
    [sym_false] = ACTIONS(2532),
    [sym_none] = ACTIONS(2532),
    [sym_comment] = ACTIONS(73),
  },
  [854] = {
    [sym__primary_expression] = STATE(1251),
    [sym_binary_operator] = STATE(1251),
    [sym_unary_operator] = STATE(1251),
    [sym_attribute] = STATE(1251),
    [sym_subscript] = STATE(1251),
    [sym_call] = STATE(1251),
    [sym_list] = STATE(1251),
    [sym_list_comprehension] = STATE(1251),
    [sym_dictionary] = STATE(1251),
    [sym_dictionary_comprehension] = STATE(1251),
    [sym_set] = STATE(1251),
    [sym_set_comprehension] = STATE(1251),
    [sym_parenthesized_expression] = STATE(1251),
    [sym_tuple] = STATE(1251),
    [sym_generator_expression] = STATE(1251),
    [sym_concatenated_string] = STATE(1251),
    [sym_string] = STATE(433),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2534),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2536),
    [sym_float] = ACTIONS(2536),
    [sym_identifier] = ACTIONS(2536),
    [sym_true] = ACTIONS(2536),
    [sym_false] = ACTIONS(2536),
    [sym_none] = ACTIONS(2536),
    [sym_comment] = ACTIONS(73),
  },
  [855] = {
    [sym__primary_expression] = STATE(1252),
    [sym_binary_operator] = STATE(1252),
    [sym_unary_operator] = STATE(1252),
    [sym_attribute] = STATE(1252),
    [sym_subscript] = STATE(1252),
    [sym_call] = STATE(1252),
    [sym_list] = STATE(1252),
    [sym_list_comprehension] = STATE(1252),
    [sym_dictionary] = STATE(1252),
    [sym_dictionary_comprehension] = STATE(1252),
    [sym_set] = STATE(1252),
    [sym_set_comprehension] = STATE(1252),
    [sym_parenthesized_expression] = STATE(1252),
    [sym_tuple] = STATE(1252),
    [sym_generator_expression] = STATE(1252),
    [sym_concatenated_string] = STATE(1252),
    [sym_string] = STATE(433),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2538),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2540),
    [sym_float] = ACTIONS(2540),
    [sym_identifier] = ACTIONS(2540),
    [sym_true] = ACTIONS(2540),
    [sym_false] = ACTIONS(2540),
    [sym_none] = ACTIONS(2540),
    [sym_comment] = ACTIONS(73),
  },
  [856] = {
    [anon_sym_in] = ACTIONS(2542),
    [sym_comment] = ACTIONS(73),
  },
  [857] = {
    [sym__primary_expression] = STATE(1254),
    [sym_binary_operator] = STATE(1254),
    [sym_unary_operator] = STATE(1254),
    [sym_attribute] = STATE(1254),
    [sym_subscript] = STATE(1254),
    [sym_call] = STATE(1254),
    [sym_list] = STATE(1254),
    [sym_list_comprehension] = STATE(1254),
    [sym_dictionary] = STATE(1254),
    [sym_dictionary_comprehension] = STATE(1254),
    [sym_set] = STATE(1254),
    [sym_set_comprehension] = STATE(1254),
    [sym_parenthesized_expression] = STATE(1254),
    [sym_tuple] = STATE(1254),
    [sym_generator_expression] = STATE(1254),
    [sym_concatenated_string] = STATE(1254),
    [sym_string] = STATE(433),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2544),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2546),
    [sym_float] = ACTIONS(2546),
    [sym_identifier] = ACTIONS(2546),
    [sym_true] = ACTIONS(2546),
    [sym_false] = ACTIONS(2546),
    [sym_none] = ACTIONS(2546),
    [sym_comment] = ACTIONS(73),
  },
  [858] = {
    [sym__primary_expression] = STATE(669),
    [sym_binary_operator] = STATE(669),
    [sym_unary_operator] = STATE(669),
    [sym_attribute] = STATE(669),
    [sym_subscript] = STATE(669),
    [sym_call] = STATE(669),
    [sym_list] = STATE(669),
    [sym_list_comprehension] = STATE(669),
    [sym_dictionary] = STATE(669),
    [sym_dictionary_comprehension] = STATE(669),
    [sym_set] = STATE(669),
    [sym_set_comprehension] = STATE(669),
    [sym_parenthesized_expression] = STATE(669),
    [sym_tuple] = STATE(669),
    [sym_generator_expression] = STATE(669),
    [sym_concatenated_string] = STATE(669),
    [sym_string] = STATE(433),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1282),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1284),
    [sym_float] = ACTIONS(1284),
    [sym_identifier] = ACTIONS(1284),
    [sym_true] = ACTIONS(1284),
    [sym_false] = ACTIONS(1284),
    [sym_none] = ACTIONS(1284),
    [sym_comment] = ACTIONS(73),
  },
  [859] = {
    [sym__primary_expression] = STATE(1255),
    [sym_binary_operator] = STATE(1255),
    [sym_unary_operator] = STATE(1255),
    [sym_attribute] = STATE(1255),
    [sym_subscript] = STATE(1255),
    [sym_call] = STATE(1255),
    [sym_list] = STATE(1255),
    [sym_list_comprehension] = STATE(1255),
    [sym_dictionary] = STATE(1255),
    [sym_dictionary_comprehension] = STATE(1255),
    [sym_set] = STATE(1255),
    [sym_set_comprehension] = STATE(1255),
    [sym_parenthesized_expression] = STATE(1255),
    [sym_tuple] = STATE(1255),
    [sym_generator_expression] = STATE(1255),
    [sym_concatenated_string] = STATE(1255),
    [sym_string] = STATE(433),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2548),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2550),
    [sym_float] = ACTIONS(2550),
    [sym_identifier] = ACTIONS(2550),
    [sym_true] = ACTIONS(2550),
    [sym_false] = ACTIONS(2550),
    [sym_none] = ACTIONS(2550),
    [sym_comment] = ACTIONS(73),
  },
  [860] = {
    [sym__primary_expression] = STATE(1256),
    [sym_binary_operator] = STATE(1256),
    [sym_unary_operator] = STATE(1256),
    [sym_attribute] = STATE(1256),
    [sym_subscript] = STATE(1256),
    [sym_call] = STATE(1256),
    [sym_list] = STATE(1256),
    [sym_list_comprehension] = STATE(1256),
    [sym_dictionary] = STATE(1256),
    [sym_dictionary_comprehension] = STATE(1256),
    [sym_set] = STATE(1256),
    [sym_set_comprehension] = STATE(1256),
    [sym_parenthesized_expression] = STATE(1256),
    [sym_tuple] = STATE(1256),
    [sym_generator_expression] = STATE(1256),
    [sym_concatenated_string] = STATE(1256),
    [sym_string] = STATE(433),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2552),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2554),
    [sym_float] = ACTIONS(2554),
    [sym_identifier] = ACTIONS(2554),
    [sym_true] = ACTIONS(2554),
    [sym_false] = ACTIONS(2554),
    [sym_none] = ACTIONS(2554),
    [sym_comment] = ACTIONS(73),
  },
  [861] = {
    [sym__primary_expression] = STATE(1257),
    [sym_binary_operator] = STATE(1257),
    [sym_unary_operator] = STATE(1257),
    [sym_attribute] = STATE(1257),
    [sym_subscript] = STATE(1257),
    [sym_call] = STATE(1257),
    [sym_list] = STATE(1257),
    [sym_list_comprehension] = STATE(1257),
    [sym_dictionary] = STATE(1257),
    [sym_dictionary_comprehension] = STATE(1257),
    [sym_set] = STATE(1257),
    [sym_set_comprehension] = STATE(1257),
    [sym_parenthesized_expression] = STATE(1257),
    [sym_tuple] = STATE(1257),
    [sym_generator_expression] = STATE(1257),
    [sym_concatenated_string] = STATE(1257),
    [sym_string] = STATE(433),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2556),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2558),
    [sym_float] = ACTIONS(2558),
    [sym_identifier] = ACTIONS(2558),
    [sym_true] = ACTIONS(2558),
    [sym_false] = ACTIONS(2558),
    [sym_none] = ACTIONS(2558),
    [sym_comment] = ACTIONS(73),
  },
  [862] = {
    [sym__primary_expression] = STATE(1252),
    [sym_binary_operator] = STATE(1252),
    [sym_unary_operator] = STATE(1252),
    [sym_attribute] = STATE(1252),
    [sym_subscript] = STATE(1252),
    [sym_call] = STATE(1252),
    [sym_list] = STATE(1252),
    [sym_list_comprehension] = STATE(1252),
    [sym_dictionary] = STATE(1252),
    [sym_dictionary_comprehension] = STATE(1252),
    [sym_set] = STATE(1252),
    [sym_set_comprehension] = STATE(1252),
    [sym_parenthesized_expression] = STATE(1252),
    [sym_tuple] = STATE(1252),
    [sym_generator_expression] = STATE(1252),
    [sym_concatenated_string] = STATE(1252),
    [sym_string] = STATE(433),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2560),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2538),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2540),
    [sym_float] = ACTIONS(2540),
    [sym_identifier] = ACTIONS(2540),
    [sym_true] = ACTIONS(2540),
    [sym_false] = ACTIONS(2540),
    [sym_none] = ACTIONS(2540),
    [sym_comment] = ACTIONS(73),
  },
  [863] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1258),
    [anon_sym_COMMA] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(991),
    [anon_sym_COLON] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(1620),
    [anon_sym_not] = ACTIONS(1624),
    [anon_sym_and] = ACTIONS(991),
    [anon_sym_or] = ACTIONS(991),
    [anon_sym_LT] = ACTIONS(1636),
    [anon_sym_LT_EQ] = ACTIONS(1620),
    [anon_sym_EQ_EQ] = ACTIONS(1620),
    [anon_sym_BANG_EQ] = ACTIONS(1620),
    [anon_sym_GT_EQ] = ACTIONS(1620),
    [anon_sym_GT] = ACTIONS(1636),
    [anon_sym_LT_GT] = ACTIONS(1620),
    [anon_sym_is] = ACTIONS(1638),
    [sym_comment] = ACTIONS(73),
  },
  [864] = {
    [sym_string] = STATE(1259),
    [aux_sym_concatenated_string_repeat1] = STATE(1259),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_COLON] = ACTIONS(995),
    [anon_sym_in] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(995),
    [anon_sym_not] = ACTIONS(995),
    [anon_sym_and] = ACTIONS(995),
    [anon_sym_or] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(995),
    [anon_sym_SLASH_SLASH] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_GT] = ACTIONS(995),
    [anon_sym_is] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(995),
    [sym_comment] = ACTIONS(73),
  },
  [865] = {
    [anon_sym_COMMA] = ACTIONS(2562),
    [anon_sym_COLON] = ACTIONS(2562),
    [anon_sym_EQ] = ACTIONS(749),
    [sym_comment] = ACTIONS(73),
  },
  [866] = {
    [anon_sym_COMMA] = ACTIONS(2564),
    [anon_sym_COLON] = ACTIONS(2564),
    [anon_sym_EQ] = ACTIONS(755),
    [sym_comment] = ACTIONS(73),
  },
  [867] = {
    [anon_sym_RPAREN] = ACTIONS(2564),
    [anon_sym_COMMA] = ACTIONS(2564),
    [anon_sym_COLON] = ACTIONS(2564),
    [sym_comment] = ACTIONS(73),
  },
  [868] = {
    [anon_sym_COMMA] = ACTIONS(2564),
    [anon_sym_COLON] = ACTIONS(2564),
    [sym_comment] = ACTIONS(73),
  },
  [869] = {
    [sym__expression] = STATE(1260),
    [sym__primary_expression] = STATE(874),
    [sym_not_operator] = STATE(1260),
    [sym_boolean_operator] = STATE(1260),
    [sym_binary_operator] = STATE(874),
    [sym_unary_operator] = STATE(874),
    [sym_comparison_operator] = STATE(1260),
    [sym_lambda] = STATE(1260),
    [sym_attribute] = STATE(874),
    [sym_subscript] = STATE(874),
    [sym_call] = STATE(874),
    [sym_list] = STATE(874),
    [sym_list_comprehension] = STATE(874),
    [sym_dictionary] = STATE(874),
    [sym_dictionary_comprehension] = STATE(874),
    [sym_set] = STATE(874),
    [sym_set_comprehension] = STATE(874),
    [sym_parenthesized_expression] = STATE(874),
    [sym_tuple] = STATE(874),
    [sym_generator_expression] = STATE(874),
    [sym_conditional_expression] = STATE(1260),
    [sym_concatenated_string] = STATE(874),
    [sym_string] = STATE(876),
    [sym_await] = STATE(1260),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1646),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_DASH] = ACTIONS(1648),
    [anon_sym_TILDE] = ACTIONS(1648),
    [anon_sym_lambda] = ACTIONS(1650),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1652),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1654),
    [sym_float] = ACTIONS(1654),
    [sym_identifier] = ACTIONS(1654),
    [sym_true] = ACTIONS(1654),
    [sym_false] = ACTIONS(1654),
    [sym_none] = ACTIONS(1654),
    [anon_sym_await] = ACTIONS(1656),
    [sym_comment] = ACTIONS(73),
  },
  [870] = {
    [sym__primary_expression] = STATE(227),
    [sym_binary_operator] = STATE(227),
    [sym_unary_operator] = STATE(227),
    [sym_attribute] = STATE(227),
    [sym_subscript] = STATE(227),
    [sym_call] = STATE(227),
    [sym_list] = STATE(227),
    [sym_list_comprehension] = STATE(227),
    [sym_dictionary] = STATE(227),
    [sym_dictionary_comprehension] = STATE(227),
    [sym_set] = STATE(227),
    [sym_set_comprehension] = STATE(227),
    [sym_parenthesized_expression] = STATE(227),
    [sym_tuple] = STATE(227),
    [sym_generator_expression] = STATE(227),
    [sym_concatenated_string] = STATE(227),
    [sym_string] = STATE(876),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_DASH] = ACTIONS(1648),
    [anon_sym_TILDE] = ACTIONS(1648),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(403),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(405),
    [sym_float] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_true] = ACTIONS(405),
    [sym_false] = ACTIONS(405),
    [sym_none] = ACTIONS(405),
    [sym_comment] = ACTIONS(73),
  },
  [871] = {
    [sym_lambda_parameters] = STATE(1262),
    [sym__parameters] = STATE(138),
    [sym_default_parameter] = STATE(139),
    [sym_typed_default_parameter] = STATE(139),
    [sym_list_splat] = STATE(140),
    [sym_dictionary_splat] = STATE(140),
    [sym_typed_parameter] = STATE(139),
    [sym_tuple] = STATE(139),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(2566),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [872] = {
    [sym__expression] = STATE(249),
    [sym__primary_expression] = STATE(874),
    [sym_not_operator] = STATE(249),
    [sym_boolean_operator] = STATE(249),
    [sym_binary_operator] = STATE(874),
    [sym_unary_operator] = STATE(874),
    [sym_comparison_operator] = STATE(249),
    [sym_lambda] = STATE(249),
    [sym_attribute] = STATE(874),
    [sym_subscript] = STATE(874),
    [sym_call] = STATE(874),
    [sym_list] = STATE(874),
    [sym_list_comprehension] = STATE(874),
    [sym_dictionary] = STATE(874),
    [sym_dictionary_comprehension] = STATE(874),
    [sym_set] = STATE(874),
    [sym_set_comprehension] = STATE(874),
    [sym_parenthesized_expression] = STATE(874),
    [sym_tuple] = STATE(874),
    [sym_generator_expression] = STATE(874),
    [sym_conditional_expression] = STATE(249),
    [sym_concatenated_string] = STATE(874),
    [sym_string] = STATE(876),
    [sym_await] = STATE(249),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1646),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_DASH] = ACTIONS(1648),
    [anon_sym_TILDE] = ACTIONS(1648),
    [anon_sym_lambda] = ACTIONS(1650),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1652),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1654),
    [sym_float] = ACTIONS(1654),
    [sym_identifier] = ACTIONS(1654),
    [sym_true] = ACTIONS(1654),
    [sym_false] = ACTIONS(1654),
    [sym_none] = ACTIONS(1654),
    [anon_sym_await] = ACTIONS(1656),
    [sym_comment] = ACTIONS(73),
  },
  [873] = {
    [anon_sym_if] = ACTIONS(2568),
    [anon_sym_EQ] = ACTIONS(1879),
    [anon_sym_and] = ACTIONS(2570),
    [anon_sym_or] = ACTIONS(2572),
    [sym_comment] = ACTIONS(73),
  },
  [874] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [aux_sym_comparison_operator_repeat1] = STATE(1276),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(2574),
    [anon_sym_GT_GT] = ACTIONS(2576),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(2578),
    [anon_sym_EQ] = ACTIONS(313),
    [anon_sym_AT] = ACTIONS(2580),
    [anon_sym_not] = ACTIONS(2582),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(2584),
    [anon_sym_DASH] = ACTIONS(2584),
    [anon_sym_SLASH] = ACTIONS(2574),
    [anon_sym_PERCENT] = ACTIONS(2580),
    [anon_sym_SLASH_SLASH] = ACTIONS(2580),
    [anon_sym_STAR_STAR] = ACTIONS(2586),
    [anon_sym_PIPE] = ACTIONS(2588),
    [anon_sym_AMP] = ACTIONS(2590),
    [anon_sym_CARET] = ACTIONS(2592),
    [anon_sym_LT_LT] = ACTIONS(2576),
    [anon_sym_LT] = ACTIONS(2594),
    [anon_sym_LT_EQ] = ACTIONS(2578),
    [anon_sym_EQ_EQ] = ACTIONS(2578),
    [anon_sym_BANG_EQ] = ACTIONS(2578),
    [anon_sym_GT_EQ] = ACTIONS(2578),
    [anon_sym_GT] = ACTIONS(2594),
    [anon_sym_LT_GT] = ACTIONS(2578),
    [anon_sym_is] = ACTIONS(2596),
    [anon_sym_LBRACK] = ACTIONS(473),
    [sym_comment] = ACTIONS(73),
  },
  [875] = {
    [anon_sym_EQ] = ACTIONS(2598),
    [sym_comment] = ACTIONS(73),
  },
  [876] = {
    [sym_string] = STATE(1278),
    [aux_sym_concatenated_string_repeat1] = STATE(1278),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_EQ] = ACTIONS(335),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [877] = {
    [anon_sym_COMMA] = ACTIONS(2600),
    [anon_sym_if] = ACTIONS(1610),
    [anon_sym_COLON] = ACTIONS(2600),
    [anon_sym_and] = ACTIONS(1612),
    [anon_sym_or] = ACTIONS(1614),
    [sym_comment] = ACTIONS(73),
  },
  [878] = {
    [sym_default_parameter] = STATE(867),
    [sym_typed_default_parameter] = STATE(867),
    [sym_list_splat] = STATE(868),
    [sym_dictionary_splat] = STATE(868),
    [sym_typed_parameter] = STATE(867),
    [sym_tuple] = STATE(867),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(1640),
    [anon_sym_COLON] = ACTIONS(2602),
    [anon_sym_exec] = ACTIONS(1640),
    [sym_identifier] = ACTIONS(1644),
    [sym_comment] = ACTIONS(73),
  },
  [879] = {
    [aux_sym__parameters_repeat1] = STATE(879),
    [anon_sym_COMMA] = ACTIONS(2604),
    [anon_sym_COLON] = ACTIONS(2564),
    [sym_comment] = ACTIONS(73),
  },
  [880] = {
    [sym__expression] = STATE(1280),
    [sym__primary_expression] = STATE(885),
    [sym_not_operator] = STATE(1280),
    [sym_boolean_operator] = STATE(1280),
    [sym_binary_operator] = STATE(885),
    [sym_unary_operator] = STATE(885),
    [sym_comparison_operator] = STATE(1280),
    [sym_lambda] = STATE(1280),
    [sym_attribute] = STATE(885),
    [sym_subscript] = STATE(885),
    [sym_call] = STATE(885),
    [sym_list] = STATE(885),
    [sym_list_comprehension] = STATE(885),
    [sym_dictionary] = STATE(885),
    [sym_dictionary_comprehension] = STATE(885),
    [sym_set] = STATE(885),
    [sym_set_comprehension] = STATE(885),
    [sym_parenthesized_expression] = STATE(885),
    [sym_tuple] = STATE(885),
    [sym_generator_expression] = STATE(885),
    [sym_conditional_expression] = STATE(1280),
    [sym_concatenated_string] = STATE(885),
    [sym_string] = STATE(887),
    [sym_await] = STATE(1280),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_PLUS] = ACTIONS(1666),
    [anon_sym_DASH] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [anon_sym_lambda] = ACTIONS(1668),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1670),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1672),
    [sym_float] = ACTIONS(1672),
    [sym_identifier] = ACTIONS(1672),
    [sym_true] = ACTIONS(1672),
    [sym_false] = ACTIONS(1672),
    [sym_none] = ACTIONS(1672),
    [anon_sym_await] = ACTIONS(1674),
    [sym_comment] = ACTIONS(73),
  },
  [881] = {
    [sym__primary_expression] = STATE(227),
    [sym_binary_operator] = STATE(227),
    [sym_unary_operator] = STATE(227),
    [sym_attribute] = STATE(227),
    [sym_subscript] = STATE(227),
    [sym_call] = STATE(227),
    [sym_list] = STATE(227),
    [sym_list_comprehension] = STATE(227),
    [sym_dictionary] = STATE(227),
    [sym_dictionary_comprehension] = STATE(227),
    [sym_set] = STATE(227),
    [sym_set_comprehension] = STATE(227),
    [sym_parenthesized_expression] = STATE(227),
    [sym_tuple] = STATE(227),
    [sym_generator_expression] = STATE(227),
    [sym_concatenated_string] = STATE(227),
    [sym_string] = STATE(887),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1666),
    [anon_sym_DASH] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(403),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(405),
    [sym_float] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_true] = ACTIONS(405),
    [sym_false] = ACTIONS(405),
    [sym_none] = ACTIONS(405),
    [sym_comment] = ACTIONS(73),
  },
  [882] = {
    [sym_lambda_parameters] = STATE(1282),
    [sym__parameters] = STATE(138),
    [sym_default_parameter] = STATE(139),
    [sym_typed_default_parameter] = STATE(139),
    [sym_list_splat] = STATE(140),
    [sym_dictionary_splat] = STATE(140),
    [sym_typed_parameter] = STATE(139),
    [sym_tuple] = STATE(139),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(2607),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [883] = {
    [sym__expression] = STATE(249),
    [sym__primary_expression] = STATE(885),
    [sym_not_operator] = STATE(249),
    [sym_boolean_operator] = STATE(249),
    [sym_binary_operator] = STATE(885),
    [sym_unary_operator] = STATE(885),
    [sym_comparison_operator] = STATE(249),
    [sym_lambda] = STATE(249),
    [sym_attribute] = STATE(885),
    [sym_subscript] = STATE(885),
    [sym_call] = STATE(885),
    [sym_list] = STATE(885),
    [sym_list_comprehension] = STATE(885),
    [sym_dictionary] = STATE(885),
    [sym_dictionary_comprehension] = STATE(885),
    [sym_set] = STATE(885),
    [sym_set_comprehension] = STATE(885),
    [sym_parenthesized_expression] = STATE(885),
    [sym_tuple] = STATE(885),
    [sym_generator_expression] = STATE(885),
    [sym_conditional_expression] = STATE(249),
    [sym_concatenated_string] = STATE(885),
    [sym_string] = STATE(887),
    [sym_await] = STATE(249),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_PLUS] = ACTIONS(1666),
    [anon_sym_DASH] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [anon_sym_lambda] = ACTIONS(1668),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1670),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1672),
    [sym_float] = ACTIONS(1672),
    [sym_identifier] = ACTIONS(1672),
    [sym_true] = ACTIONS(1672),
    [sym_false] = ACTIONS(1672),
    [sym_none] = ACTIONS(1672),
    [anon_sym_await] = ACTIONS(1674),
    [sym_comment] = ACTIONS(73),
  },
  [884] = {
    [anon_sym_COMMA] = ACTIONS(1879),
    [anon_sym_if] = ACTIONS(2609),
    [anon_sym_COLON] = ACTIONS(1879),
    [anon_sym_EQ] = ACTIONS(1879),
    [anon_sym_and] = ACTIONS(2611),
    [anon_sym_or] = ACTIONS(2613),
    [sym_comment] = ACTIONS(73),
  },
  [885] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [aux_sym_comparison_operator_repeat1] = STATE(1296),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(2615),
    [anon_sym_GT_GT] = ACTIONS(2617),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(2619),
    [anon_sym_EQ] = ACTIONS(313),
    [anon_sym_AT] = ACTIONS(2621),
    [anon_sym_not] = ACTIONS(2623),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(2625),
    [anon_sym_DASH] = ACTIONS(2625),
    [anon_sym_SLASH] = ACTIONS(2615),
    [anon_sym_PERCENT] = ACTIONS(2621),
    [anon_sym_SLASH_SLASH] = ACTIONS(2621),
    [anon_sym_STAR_STAR] = ACTIONS(2627),
    [anon_sym_PIPE] = ACTIONS(2629),
    [anon_sym_AMP] = ACTIONS(2631),
    [anon_sym_CARET] = ACTIONS(2633),
    [anon_sym_LT_LT] = ACTIONS(2617),
    [anon_sym_LT] = ACTIONS(2635),
    [anon_sym_LT_EQ] = ACTIONS(2619),
    [anon_sym_EQ_EQ] = ACTIONS(2619),
    [anon_sym_BANG_EQ] = ACTIONS(2619),
    [anon_sym_GT_EQ] = ACTIONS(2619),
    [anon_sym_GT] = ACTIONS(2635),
    [anon_sym_LT_GT] = ACTIONS(2619),
    [anon_sym_is] = ACTIONS(2637),
    [anon_sym_LBRACK] = ACTIONS(473),
    [sym_comment] = ACTIONS(73),
  },
  [886] = {
    [anon_sym_COMMA] = ACTIONS(2639),
    [anon_sym_COLON] = ACTIONS(2639),
    [anon_sym_EQ] = ACTIONS(2641),
    [sym_comment] = ACTIONS(73),
  },
  [887] = {
    [sym_string] = STATE(1298),
    [aux_sym_concatenated_string_repeat1] = STATE(1298),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_COLON] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_EQ] = ACTIONS(335),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [888] = {
    [anon_sym_COMMA] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(1610),
    [anon_sym_COLON] = ACTIONS(2643),
    [anon_sym_and] = ACTIONS(1612),
    [anon_sym_or] = ACTIONS(1614),
    [sym_comment] = ACTIONS(73),
  },
  [889] = {
    [sym_default_parameter] = STATE(867),
    [sym_typed_default_parameter] = STATE(867),
    [sym_list_splat] = STATE(868),
    [sym_dictionary_splat] = STATE(868),
    [sym_typed_parameter] = STATE(867),
    [sym_tuple] = STATE(867),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(1640),
    [anon_sym_COLON] = ACTIONS(2645),
    [anon_sym_exec] = ACTIONS(1640),
    [sym_identifier] = ACTIONS(1644),
    [sym_comment] = ACTIONS(73),
  },
  [890] = {
    [sym__newline] = ACTIONS(2647),
    [anon_sym_COMMA] = ACTIONS(2647),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_COLON] = ACTIONS(2647),
    [anon_sym_EQ] = ACTIONS(2647),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(299),
    [anon_sym_PLUS_EQ] = ACTIONS(2647),
    [anon_sym_DASH_EQ] = ACTIONS(2647),
    [anon_sym_STAR_EQ] = ACTIONS(2647),
    [anon_sym_SLASH_EQ] = ACTIONS(2647),
    [anon_sym_AT_EQ] = ACTIONS(2647),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2647),
    [anon_sym_PERCENT_EQ] = ACTIONS(2647),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2647),
    [anon_sym_GT_GT_EQ] = ACTIONS(2647),
    [anon_sym_LT_LT_EQ] = ACTIONS(2647),
    [anon_sym_AMP_EQ] = ACTIONS(2647),
    [anon_sym_CARET_EQ] = ACTIONS(2647),
    [anon_sym_PIPE_EQ] = ACTIONS(2647),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2647),
  },
  [891] = {
    [anon_sym_COMMA] = ACTIONS(1879),
    [anon_sym_if] = ACTIONS(1610),
    [anon_sym_COLON] = ACTIONS(1879),
    [anon_sym_and] = ACTIONS(1612),
    [anon_sym_or] = ACTIONS(1614),
    [sym_comment] = ACTIONS(73),
  },
  [892] = {
    [anon_sym_RPAREN] = ACTIONS(2639),
    [anon_sym_COMMA] = ACTIONS(2639),
    [anon_sym_COLON] = ACTIONS(2639),
    [sym_comment] = ACTIONS(73),
  },
  [893] = {
    [anon_sym_COMMA] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(723),
    [anon_sym_and] = ACTIONS(1688),
    [anon_sym_or] = ACTIONS(1690),
    [anon_sym_RBRACK] = ACTIONS(723),
    [sym_comment] = ACTIONS(73),
  },
  [894] = {
    [sym__expression] = STATE(1299),
    [sym__primary_expression] = STATE(452),
    [sym_not_operator] = STATE(1299),
    [sym_boolean_operator] = STATE(1299),
    [sym_binary_operator] = STATE(452),
    [sym_unary_operator] = STATE(452),
    [sym_comparison_operator] = STATE(1299),
    [sym_lambda] = STATE(1299),
    [sym_attribute] = STATE(452),
    [sym_subscript] = STATE(452),
    [sym_call] = STATE(452),
    [sym_list] = STATE(452),
    [sym_list_comprehension] = STATE(452),
    [sym_dictionary] = STATE(452),
    [sym_dictionary_comprehension] = STATE(452),
    [sym_set] = STATE(452),
    [sym_set_comprehension] = STATE(452),
    [sym_parenthesized_expression] = STATE(452),
    [sym_tuple] = STATE(452),
    [sym_generator_expression] = STATE(452),
    [sym_conditional_expression] = STATE(1299),
    [sym_concatenated_string] = STATE(452),
    [sym_string] = STATE(453),
    [sym_await] = STATE(1299),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_lambda] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(773),
    [sym_float] = ACTIONS(773),
    [sym_identifier] = ACTIONS(773),
    [sym_true] = ACTIONS(773),
    [sym_false] = ACTIONS(773),
    [sym_none] = ACTIONS(773),
    [anon_sym_await] = ACTIONS(775),
    [sym_comment] = ACTIONS(73),
  },
  [895] = {
    [anon_sym_COLON] = ACTIONS(2649),
    [sym_comment] = ACTIONS(73),
  },
  [896] = {
    [sym__expression] = STATE(1301),
    [sym__primary_expression] = STATE(538),
    [sym_not_operator] = STATE(1301),
    [sym_boolean_operator] = STATE(1301),
    [sym_binary_operator] = STATE(538),
    [sym_unary_operator] = STATE(538),
    [sym_comparison_operator] = STATE(1301),
    [sym_lambda] = STATE(1301),
    [sym_attribute] = STATE(538),
    [sym_subscript] = STATE(538),
    [sym_call] = STATE(538),
    [sym_list] = STATE(538),
    [sym_list_comprehension] = STATE(538),
    [sym_dictionary] = STATE(538),
    [sym_dictionary_comprehension] = STATE(538),
    [sym_set] = STATE(538),
    [sym_set_comprehension] = STATE(538),
    [sym_parenthesized_expression] = STATE(538),
    [sym_tuple] = STATE(538),
    [sym_generator_expression] = STATE(538),
    [sym_conditional_expression] = STATE(1301),
    [sym_concatenated_string] = STATE(538),
    [sym_string] = STATE(539),
    [sym_await] = STATE(1301),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_lambda] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(917),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(919),
    [sym_float] = ACTIONS(919),
    [sym_identifier] = ACTIONS(919),
    [sym_true] = ACTIONS(919),
    [sym_false] = ACTIONS(919),
    [sym_none] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(921),
    [sym_comment] = ACTIONS(73),
  },
  [897] = {
    [sym__expression] = STATE(652),
    [sym__primary_expression] = STATE(452),
    [sym_not_operator] = STATE(652),
    [sym_boolean_operator] = STATE(652),
    [sym_binary_operator] = STATE(452),
    [sym_unary_operator] = STATE(452),
    [sym_comparison_operator] = STATE(652),
    [sym_lambda] = STATE(652),
    [sym_attribute] = STATE(452),
    [sym_subscript] = STATE(452),
    [sym_call] = STATE(452),
    [sym_list] = STATE(452),
    [sym_list_comprehension] = STATE(452),
    [sym_dictionary] = STATE(452),
    [sym_dictionary_comprehension] = STATE(452),
    [sym_set] = STATE(452),
    [sym_set_comprehension] = STATE(452),
    [sym_parenthesized_expression] = STATE(452),
    [sym_tuple] = STATE(452),
    [sym_generator_expression] = STATE(452),
    [sym_conditional_expression] = STATE(652),
    [sym_concatenated_string] = STATE(452),
    [sym_string] = STATE(453),
    [sym_await] = STATE(652),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_lambda] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(773),
    [sym_float] = ACTIONS(773),
    [sym_identifier] = ACTIONS(773),
    [sym_true] = ACTIONS(773),
    [sym_false] = ACTIONS(773),
    [sym_none] = ACTIONS(773),
    [anon_sym_await] = ACTIONS(775),
    [sym_comment] = ACTIONS(73),
  },
  [898] = {
    [sym__expression] = STATE(1302),
    [sym__primary_expression] = STATE(452),
    [sym_not_operator] = STATE(1302),
    [sym_boolean_operator] = STATE(1302),
    [sym_binary_operator] = STATE(452),
    [sym_unary_operator] = STATE(452),
    [sym_comparison_operator] = STATE(1302),
    [sym_lambda] = STATE(1302),
    [sym_attribute] = STATE(452),
    [sym_subscript] = STATE(452),
    [sym_call] = STATE(452),
    [sym_list] = STATE(452),
    [sym_list_comprehension] = STATE(452),
    [sym_dictionary] = STATE(452),
    [sym_dictionary_comprehension] = STATE(452),
    [sym_set] = STATE(452),
    [sym_set_comprehension] = STATE(452),
    [sym_parenthesized_expression] = STATE(452),
    [sym_tuple] = STATE(452),
    [sym_generator_expression] = STATE(452),
    [sym_conditional_expression] = STATE(1302),
    [sym_concatenated_string] = STATE(452),
    [sym_string] = STATE(453),
    [sym_await] = STATE(1302),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_lambda] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(773),
    [sym_float] = ACTIONS(773),
    [sym_identifier] = ACTIONS(773),
    [sym_true] = ACTIONS(773),
    [sym_false] = ACTIONS(773),
    [sym_none] = ACTIONS(773),
    [anon_sym_await] = ACTIONS(775),
    [sym_comment] = ACTIONS(73),
  },
  [899] = {
    [sym__primary_expression] = STATE(1303),
    [sym_binary_operator] = STATE(1303),
    [sym_unary_operator] = STATE(1303),
    [sym_attribute] = STATE(1303),
    [sym_subscript] = STATE(1303),
    [sym_call] = STATE(1303),
    [sym_list] = STATE(1303),
    [sym_list_comprehension] = STATE(1303),
    [sym_dictionary] = STATE(1303),
    [sym_dictionary_comprehension] = STATE(1303),
    [sym_set] = STATE(1303),
    [sym_set_comprehension] = STATE(1303),
    [sym_parenthesized_expression] = STATE(1303),
    [sym_tuple] = STATE(1303),
    [sym_generator_expression] = STATE(1303),
    [sym_concatenated_string] = STATE(1303),
    [sym_string] = STATE(453),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2651),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2653),
    [sym_float] = ACTIONS(2653),
    [sym_identifier] = ACTIONS(2653),
    [sym_true] = ACTIONS(2653),
    [sym_false] = ACTIONS(2653),
    [sym_none] = ACTIONS(2653),
    [sym_comment] = ACTIONS(73),
  },
  [900] = {
    [sym__primary_expression] = STATE(1304),
    [sym_binary_operator] = STATE(1304),
    [sym_unary_operator] = STATE(1304),
    [sym_attribute] = STATE(1304),
    [sym_subscript] = STATE(1304),
    [sym_call] = STATE(1304),
    [sym_list] = STATE(1304),
    [sym_list_comprehension] = STATE(1304),
    [sym_dictionary] = STATE(1304),
    [sym_dictionary_comprehension] = STATE(1304),
    [sym_set] = STATE(1304),
    [sym_set_comprehension] = STATE(1304),
    [sym_parenthesized_expression] = STATE(1304),
    [sym_tuple] = STATE(1304),
    [sym_generator_expression] = STATE(1304),
    [sym_concatenated_string] = STATE(1304),
    [sym_string] = STATE(453),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2655),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2657),
    [sym_float] = ACTIONS(2657),
    [sym_identifier] = ACTIONS(2657),
    [sym_true] = ACTIONS(2657),
    [sym_false] = ACTIONS(2657),
    [sym_none] = ACTIONS(2657),
    [sym_comment] = ACTIONS(73),
  },
  [901] = {
    [sym__primary_expression] = STATE(1305),
    [sym_binary_operator] = STATE(1305),
    [sym_unary_operator] = STATE(1305),
    [sym_attribute] = STATE(1305),
    [sym_subscript] = STATE(1305),
    [sym_call] = STATE(1305),
    [sym_list] = STATE(1305),
    [sym_list_comprehension] = STATE(1305),
    [sym_dictionary] = STATE(1305),
    [sym_dictionary_comprehension] = STATE(1305),
    [sym_set] = STATE(1305),
    [sym_set_comprehension] = STATE(1305),
    [sym_parenthesized_expression] = STATE(1305),
    [sym_tuple] = STATE(1305),
    [sym_generator_expression] = STATE(1305),
    [sym_concatenated_string] = STATE(1305),
    [sym_string] = STATE(453),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2659),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2661),
    [sym_float] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_true] = ACTIONS(2661),
    [sym_false] = ACTIONS(2661),
    [sym_none] = ACTIONS(2661),
    [sym_comment] = ACTIONS(73),
  },
  [902] = {
    [anon_sym_in] = ACTIONS(2663),
    [sym_comment] = ACTIONS(73),
  },
  [903] = {
    [sym__primary_expression] = STATE(1307),
    [sym_binary_operator] = STATE(1307),
    [sym_unary_operator] = STATE(1307),
    [sym_attribute] = STATE(1307),
    [sym_subscript] = STATE(1307),
    [sym_call] = STATE(1307),
    [sym_list] = STATE(1307),
    [sym_list_comprehension] = STATE(1307),
    [sym_dictionary] = STATE(1307),
    [sym_dictionary_comprehension] = STATE(1307),
    [sym_set] = STATE(1307),
    [sym_set_comprehension] = STATE(1307),
    [sym_parenthesized_expression] = STATE(1307),
    [sym_tuple] = STATE(1307),
    [sym_generator_expression] = STATE(1307),
    [sym_concatenated_string] = STATE(1307),
    [sym_string] = STATE(453),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2665),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2667),
    [sym_float] = ACTIONS(2667),
    [sym_identifier] = ACTIONS(2667),
    [sym_true] = ACTIONS(2667),
    [sym_false] = ACTIONS(2667),
    [sym_none] = ACTIONS(2667),
    [sym_comment] = ACTIONS(73),
  },
  [904] = {
    [sym__primary_expression] = STATE(669),
    [sym_binary_operator] = STATE(669),
    [sym_unary_operator] = STATE(669),
    [sym_attribute] = STATE(669),
    [sym_subscript] = STATE(669),
    [sym_call] = STATE(669),
    [sym_list] = STATE(669),
    [sym_list_comprehension] = STATE(669),
    [sym_dictionary] = STATE(669),
    [sym_dictionary_comprehension] = STATE(669),
    [sym_set] = STATE(669),
    [sym_set_comprehension] = STATE(669),
    [sym_parenthesized_expression] = STATE(669),
    [sym_tuple] = STATE(669),
    [sym_generator_expression] = STATE(669),
    [sym_concatenated_string] = STATE(669),
    [sym_string] = STATE(453),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1282),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1284),
    [sym_float] = ACTIONS(1284),
    [sym_identifier] = ACTIONS(1284),
    [sym_true] = ACTIONS(1284),
    [sym_false] = ACTIONS(1284),
    [sym_none] = ACTIONS(1284),
    [sym_comment] = ACTIONS(73),
  },
  [905] = {
    [sym__primary_expression] = STATE(1308),
    [sym_binary_operator] = STATE(1308),
    [sym_unary_operator] = STATE(1308),
    [sym_attribute] = STATE(1308),
    [sym_subscript] = STATE(1308),
    [sym_call] = STATE(1308),
    [sym_list] = STATE(1308),
    [sym_list_comprehension] = STATE(1308),
    [sym_dictionary] = STATE(1308),
    [sym_dictionary_comprehension] = STATE(1308),
    [sym_set] = STATE(1308),
    [sym_set_comprehension] = STATE(1308),
    [sym_parenthesized_expression] = STATE(1308),
    [sym_tuple] = STATE(1308),
    [sym_generator_expression] = STATE(1308),
    [sym_concatenated_string] = STATE(1308),
    [sym_string] = STATE(453),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2669),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2671),
    [sym_float] = ACTIONS(2671),
    [sym_identifier] = ACTIONS(2671),
    [sym_true] = ACTIONS(2671),
    [sym_false] = ACTIONS(2671),
    [sym_none] = ACTIONS(2671),
    [sym_comment] = ACTIONS(73),
  },
  [906] = {
    [sym__primary_expression] = STATE(1309),
    [sym_binary_operator] = STATE(1309),
    [sym_unary_operator] = STATE(1309),
    [sym_attribute] = STATE(1309),
    [sym_subscript] = STATE(1309),
    [sym_call] = STATE(1309),
    [sym_list] = STATE(1309),
    [sym_list_comprehension] = STATE(1309),
    [sym_dictionary] = STATE(1309),
    [sym_dictionary_comprehension] = STATE(1309),
    [sym_set] = STATE(1309),
    [sym_set_comprehension] = STATE(1309),
    [sym_parenthesized_expression] = STATE(1309),
    [sym_tuple] = STATE(1309),
    [sym_generator_expression] = STATE(1309),
    [sym_concatenated_string] = STATE(1309),
    [sym_string] = STATE(453),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2673),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2675),
    [sym_float] = ACTIONS(2675),
    [sym_identifier] = ACTIONS(2675),
    [sym_true] = ACTIONS(2675),
    [sym_false] = ACTIONS(2675),
    [sym_none] = ACTIONS(2675),
    [sym_comment] = ACTIONS(73),
  },
  [907] = {
    [sym__primary_expression] = STATE(1310),
    [sym_binary_operator] = STATE(1310),
    [sym_unary_operator] = STATE(1310),
    [sym_attribute] = STATE(1310),
    [sym_subscript] = STATE(1310),
    [sym_call] = STATE(1310),
    [sym_list] = STATE(1310),
    [sym_list_comprehension] = STATE(1310),
    [sym_dictionary] = STATE(1310),
    [sym_dictionary_comprehension] = STATE(1310),
    [sym_set] = STATE(1310),
    [sym_set_comprehension] = STATE(1310),
    [sym_parenthesized_expression] = STATE(1310),
    [sym_tuple] = STATE(1310),
    [sym_generator_expression] = STATE(1310),
    [sym_concatenated_string] = STATE(1310),
    [sym_string] = STATE(453),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2677),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2679),
    [sym_float] = ACTIONS(2679),
    [sym_identifier] = ACTIONS(2679),
    [sym_true] = ACTIONS(2679),
    [sym_false] = ACTIONS(2679),
    [sym_none] = ACTIONS(2679),
    [sym_comment] = ACTIONS(73),
  },
  [908] = {
    [sym__primary_expression] = STATE(1305),
    [sym_binary_operator] = STATE(1305),
    [sym_unary_operator] = STATE(1305),
    [sym_attribute] = STATE(1305),
    [sym_subscript] = STATE(1305),
    [sym_call] = STATE(1305),
    [sym_list] = STATE(1305),
    [sym_list_comprehension] = STATE(1305),
    [sym_dictionary] = STATE(1305),
    [sym_dictionary_comprehension] = STATE(1305),
    [sym_set] = STATE(1305),
    [sym_set_comprehension] = STATE(1305),
    [sym_parenthesized_expression] = STATE(1305),
    [sym_tuple] = STATE(1305),
    [sym_generator_expression] = STATE(1305),
    [sym_concatenated_string] = STATE(1305),
    [sym_string] = STATE(453),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2681),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2659),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2661),
    [sym_float] = ACTIONS(2661),
    [sym_identifier] = ACTIONS(2661),
    [sym_true] = ACTIONS(2661),
    [sym_false] = ACTIONS(2661),
    [sym_none] = ACTIONS(2661),
    [sym_comment] = ACTIONS(73),
  },
  [909] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1311),
    [anon_sym_COMMA] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(1696),
    [anon_sym_not] = ACTIONS(1700),
    [anon_sym_and] = ACTIONS(991),
    [anon_sym_or] = ACTIONS(991),
    [anon_sym_LT] = ACTIONS(1712),
    [anon_sym_LT_EQ] = ACTIONS(1696),
    [anon_sym_EQ_EQ] = ACTIONS(1696),
    [anon_sym_BANG_EQ] = ACTIONS(1696),
    [anon_sym_GT_EQ] = ACTIONS(1696),
    [anon_sym_GT] = ACTIONS(1712),
    [anon_sym_LT_GT] = ACTIONS(1696),
    [anon_sym_is] = ACTIONS(1714),
    [anon_sym_RBRACK] = ACTIONS(991),
    [sym_comment] = ACTIONS(73),
  },
  [910] = {
    [sym_string] = STATE(1312),
    [aux_sym_concatenated_string_repeat1] = STATE(1312),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_in] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(995),
    [anon_sym_not] = ACTIONS(995),
    [anon_sym_and] = ACTIONS(995),
    [anon_sym_or] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(995),
    [anon_sym_SLASH_SLASH] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_GT] = ACTIONS(995),
    [anon_sym_is] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(995),
    [anon_sym_RBRACK] = ACTIONS(995),
    [sym_comment] = ACTIONS(73),
  },
  [911] = {
    [anon_sym_COMMA] = ACTIONS(1660),
    [anon_sym_if] = ACTIONS(785),
    [anon_sym_async] = ACTIONS(1660),
    [anon_sym_for] = ACTIONS(1660),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_or] = ACTIONS(793),
    [anon_sym_RBRACK] = ACTIONS(1660),
    [sym_comment] = ACTIONS(73),
  },
  [912] = {
    [sym__expression] = STATE(1313),
    [sym__primary_expression] = STATE(152),
    [sym_not_operator] = STATE(1313),
    [sym_boolean_operator] = STATE(1313),
    [sym_binary_operator] = STATE(152),
    [sym_unary_operator] = STATE(152),
    [sym_comparison_operator] = STATE(1313),
    [sym_lambda] = STATE(1313),
    [sym_attribute] = STATE(152),
    [sym_subscript] = STATE(152),
    [sym_call] = STATE(152),
    [sym_list] = STATE(152),
    [sym_list_comprehension] = STATE(152),
    [sym_dictionary] = STATE(152),
    [sym_dictionary_comprehension] = STATE(152),
    [sym_set] = STATE(152),
    [sym_set_comprehension] = STATE(152),
    [sym_parenthesized_expression] = STATE(152),
    [sym_tuple] = STATE(152),
    [sym_generator_expression] = STATE(152),
    [sym_conditional_expression] = STATE(1313),
    [sym_concatenated_string] = STATE(152),
    [sym_string] = STATE(153),
    [sym_await] = STATE(1313),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_lambda] = ACTIONS(249),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(255),
    [sym_float] = ACTIONS(255),
    [sym_identifier] = ACTIONS(255),
    [sym_true] = ACTIONS(255),
    [sym_false] = ACTIONS(255),
    [sym_none] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [sym_comment] = ACTIONS(73),
  },
  [913] = {
    [sym__newline] = ACTIONS(2683),
    [anon_sym_DOT] = ACTIONS(2683),
    [anon_sym_LPAREN] = ACTIONS(2683),
    [anon_sym_COMMA] = ACTIONS(2683),
    [anon_sym_STAR] = ACTIONS(2685),
    [anon_sym_GT_GT] = ACTIONS(2685),
    [anon_sym_if] = ACTIONS(2683),
    [anon_sym_COLON] = ACTIONS(2683),
    [anon_sym_in] = ACTIONS(2683),
    [anon_sym_EQ] = ACTIONS(2685),
    [anon_sym_AT] = ACTIONS(2685),
    [anon_sym_not] = ACTIONS(2683),
    [anon_sym_and] = ACTIONS(2683),
    [anon_sym_or] = ACTIONS(2683),
    [anon_sym_PLUS] = ACTIONS(2685),
    [anon_sym_DASH] = ACTIONS(2685),
    [anon_sym_SLASH] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2685),
    [anon_sym_SLASH_SLASH] = ACTIONS(2685),
    [anon_sym_STAR_STAR] = ACTIONS(2685),
    [anon_sym_PIPE] = ACTIONS(2685),
    [anon_sym_AMP] = ACTIONS(2685),
    [anon_sym_CARET] = ACTIONS(2685),
    [anon_sym_LT_LT] = ACTIONS(2685),
    [anon_sym_LT] = ACTIONS(2685),
    [anon_sym_LT_EQ] = ACTIONS(2683),
    [anon_sym_EQ_EQ] = ACTIONS(2683),
    [anon_sym_BANG_EQ] = ACTIONS(2683),
    [anon_sym_GT_EQ] = ACTIONS(2683),
    [anon_sym_GT] = ACTIONS(2685),
    [anon_sym_LT_GT] = ACTIONS(2683),
    [anon_sym_is] = ACTIONS(2683),
    [anon_sym_PLUS_EQ] = ACTIONS(2683),
    [anon_sym_DASH_EQ] = ACTIONS(2683),
    [anon_sym_STAR_EQ] = ACTIONS(2683),
    [anon_sym_SLASH_EQ] = ACTIONS(2683),
    [anon_sym_AT_EQ] = ACTIONS(2683),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2683),
    [anon_sym_PERCENT_EQ] = ACTIONS(2683),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2683),
    [anon_sym_GT_GT_EQ] = ACTIONS(2683),
    [anon_sym_LT_LT_EQ] = ACTIONS(2683),
    [anon_sym_AMP_EQ] = ACTIONS(2683),
    [anon_sym_CARET_EQ] = ACTIONS(2683),
    [anon_sym_PIPE_EQ] = ACTIONS(2683),
    [anon_sym_LBRACK] = ACTIONS(2683),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2683),
  },
  [914] = {
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_RBRACK] = ACTIONS(2687),
    [anon_sym_RBRACE] = ACTIONS(2687),
    [sym_comment] = ACTIONS(73),
  },
  [915] = {
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_if] = ACTIONS(1686),
    [anon_sym_and] = ACTIONS(1688),
    [anon_sym_or] = ACTIONS(1690),
    [anon_sym_RBRACK] = ACTIONS(2687),
    [sym_comment] = ACTIONS(73),
  },
  [916] = {
    [sym_list_splat] = STATE(914),
    [sym__expression] = STATE(915),
    [sym__primary_expression] = STATE(452),
    [sym_not_operator] = STATE(915),
    [sym_boolean_operator] = STATE(915),
    [sym_binary_operator] = STATE(452),
    [sym_unary_operator] = STATE(452),
    [sym_comparison_operator] = STATE(915),
    [sym_lambda] = STATE(915),
    [sym_attribute] = STATE(452),
    [sym_subscript] = STATE(452),
    [sym_call] = STATE(452),
    [sym_list] = STATE(452),
    [sym_list_comprehension] = STATE(452),
    [sym_dictionary] = STATE(452),
    [sym_dictionary_comprehension] = STATE(452),
    [sym_set] = STATE(452),
    [sym_set_comprehension] = STATE(452),
    [sym_parenthesized_expression] = STATE(452),
    [sym_tuple] = STATE(452),
    [sym_generator_expression] = STATE(452),
    [sym_conditional_expression] = STATE(915),
    [sym_concatenated_string] = STATE(452),
    [sym_string] = STATE(453),
    [sym_await] = STATE(915),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(243),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_lambda] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(2689),
    [sym_ellipsis] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(773),
    [sym_float] = ACTIONS(773),
    [sym_identifier] = ACTIONS(773),
    [sym_true] = ACTIONS(773),
    [sym_false] = ACTIONS(773),
    [sym_none] = ACTIONS(773),
    [anon_sym_await] = ACTIONS(775),
    [sym_comment] = ACTIONS(73),
  },
  [917] = {
    [aux_sym_list_repeat1] = STATE(917),
    [anon_sym_COMMA] = ACTIONS(2691),
    [anon_sym_RBRACK] = ACTIONS(2687),
    [sym_comment] = ACTIONS(73),
  },
  [918] = {
    [anon_sym_if] = ACTIONS(1925),
    [anon_sym_else] = ACTIONS(2694),
    [anon_sym_and] = ACTIONS(1929),
    [anon_sym_or] = ACTIONS(1931),
    [sym_comment] = ACTIONS(73),
  },
  [919] = {
    [sym_variables] = STATE(1317),
    [sym__primary_expression] = STATE(109),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(110),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(191),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(193),
    [sym_float] = ACTIONS(193),
    [sym_identifier] = ACTIONS(193),
    [sym_true] = ACTIONS(193),
    [sym_false] = ACTIONS(193),
    [sym_none] = ACTIONS(193),
    [sym_comment] = ACTIONS(73),
  },
  [920] = {
    [anon_sym_in] = ACTIONS(2696),
    [sym_comment] = ACTIONS(73),
  },
  [921] = {
    [anon_sym_COMMA] = ACTIONS(1957),
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_async] = ACTIONS(1957),
    [anon_sym_for] = ACTIONS(1957),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_or] = ACTIONS(1957),
    [anon_sym_RBRACK] = ACTIONS(1957),
    [sym_comment] = ACTIONS(73),
  },
  [922] = {
    [sym__newline] = ACTIONS(2698),
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_LPAREN] = ACTIONS(2698),
    [anon_sym_COMMA] = ACTIONS(2698),
    [anon_sym_STAR] = ACTIONS(2700),
    [anon_sym_GT_GT] = ACTIONS(2700),
    [anon_sym_if] = ACTIONS(2698),
    [anon_sym_COLON] = ACTIONS(2698),
    [anon_sym_in] = ACTIONS(2698),
    [anon_sym_EQ] = ACTIONS(2700),
    [anon_sym_AT] = ACTIONS(2700),
    [anon_sym_not] = ACTIONS(2698),
    [anon_sym_and] = ACTIONS(2698),
    [anon_sym_or] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2700),
    [anon_sym_DASH] = ACTIONS(2700),
    [anon_sym_SLASH] = ACTIONS(2700),
    [anon_sym_PERCENT] = ACTIONS(2700),
    [anon_sym_SLASH_SLASH] = ACTIONS(2700),
    [anon_sym_STAR_STAR] = ACTIONS(2700),
    [anon_sym_PIPE] = ACTIONS(2700),
    [anon_sym_AMP] = ACTIONS(2700),
    [anon_sym_CARET] = ACTIONS(2700),
    [anon_sym_LT_LT] = ACTIONS(2700),
    [anon_sym_LT] = ACTIONS(2700),
    [anon_sym_LT_EQ] = ACTIONS(2698),
    [anon_sym_EQ_EQ] = ACTIONS(2698),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_GT_EQ] = ACTIONS(2698),
    [anon_sym_GT] = ACTIONS(2700),
    [anon_sym_LT_GT] = ACTIONS(2698),
    [anon_sym_is] = ACTIONS(2698),
    [anon_sym_PLUS_EQ] = ACTIONS(2698),
    [anon_sym_DASH_EQ] = ACTIONS(2698),
    [anon_sym_STAR_EQ] = ACTIONS(2698),
    [anon_sym_SLASH_EQ] = ACTIONS(2698),
    [anon_sym_AT_EQ] = ACTIONS(2698),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2698),
    [anon_sym_PERCENT_EQ] = ACTIONS(2698),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2698),
    [anon_sym_GT_GT_EQ] = ACTIONS(2698),
    [anon_sym_LT_LT_EQ] = ACTIONS(2698),
    [anon_sym_AMP_EQ] = ACTIONS(2698),
    [anon_sym_CARET_EQ] = ACTIONS(2698),
    [anon_sym_PIPE_EQ] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(2698),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2698),
  },
  [923] = {
    [sym__expression] = STATE(1323),
    [sym__primary_expression] = STATE(1324),
    [sym_not_operator] = STATE(1323),
    [sym_boolean_operator] = STATE(1323),
    [sym_binary_operator] = STATE(1324),
    [sym_unary_operator] = STATE(1324),
    [sym_comparison_operator] = STATE(1323),
    [sym_lambda] = STATE(1323),
    [sym_attribute] = STATE(1324),
    [sym_subscript] = STATE(1324),
    [sym_call] = STATE(1324),
    [sym_list] = STATE(1324),
    [sym_list_comprehension] = STATE(1324),
    [sym_dictionary] = STATE(1324),
    [sym_dictionary_comprehension] = STATE(1324),
    [sym_set] = STATE(1324),
    [sym_set_comprehension] = STATE(1324),
    [sym_parenthesized_expression] = STATE(1324),
    [sym_tuple] = STATE(1324),
    [sym_generator_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(1323),
    [sym_concatenated_string] = STATE(1324),
    [sym_string] = STATE(1325),
    [sym_await] = STATE(1323),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2702),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_lambda] = ACTIONS(2706),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2708),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2710),
    [sym_float] = ACTIONS(2710),
    [sym_identifier] = ACTIONS(2710),
    [sym_true] = ACTIONS(2710),
    [sym_false] = ACTIONS(2710),
    [sym_none] = ACTIONS(2710),
    [anon_sym_await] = ACTIONS(2712),
    [sym_comment] = ACTIONS(73),
  },
  [924] = {
    [sym_for_in_clause] = STATE(1326),
    [sym_if_clause] = STATE(1326),
    [aux_sym__comprehension_body_repeat1] = STATE(1326),
    [anon_sym_if] = ACTIONS(1726),
    [anon_sym_async] = ACTIONS(787),
    [anon_sym_for] = ACTIONS(789),
    [anon_sym_RBRACK] = ACTIONS(2210),
    [sym_comment] = ACTIONS(73),
  },
  [925] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1984),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1986),
    [anon_sym_PERCENT] = ACTIONS(1984),
    [anon_sym_SLASH_SLASH] = ACTIONS(1984),
    [anon_sym_STAR_STAR] = ACTIONS(807),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [926] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(795),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(805),
    [anon_sym_DASH] = ACTIONS(805),
    [anon_sym_SLASH] = ACTIONS(795),
    [anon_sym_PERCENT] = ACTIONS(801),
    [anon_sym_SLASH_SLASH] = ACTIONS(801),
    [anon_sym_STAR_STAR] = ACTIONS(807),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [927] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1988),
    [anon_sym_STAR] = ACTIONS(795),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_async] = ACTIONS(1988),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(1988),
    [anon_sym_AT] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(1988),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_PLUS] = ACTIONS(805),
    [anon_sym_DASH] = ACTIONS(805),
    [anon_sym_SLASH] = ACTIONS(795),
    [anon_sym_PERCENT] = ACTIONS(801),
    [anon_sym_SLASH_SLASH] = ACTIONS(801),
    [anon_sym_STAR_STAR] = ACTIONS(807),
    [anon_sym_PIPE] = ACTIONS(809),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(1990),
    [anon_sym_LT_EQ] = ACTIONS(1988),
    [anon_sym_EQ_EQ] = ACTIONS(1988),
    [anon_sym_BANG_EQ] = ACTIONS(1988),
    [anon_sym_GT_EQ] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1990),
    [anon_sym_LT_GT] = ACTIONS(1988),
    [anon_sym_is] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(473),
    [anon_sym_RBRACK] = ACTIONS(1988),
    [sym_comment] = ACTIONS(73),
  },
  [928] = {
    [sym__primary_expression] = STATE(1327),
    [sym_binary_operator] = STATE(1327),
    [sym_unary_operator] = STATE(1327),
    [sym_attribute] = STATE(1327),
    [sym_subscript] = STATE(1327),
    [sym_call] = STATE(1327),
    [sym_list] = STATE(1327),
    [sym_list_comprehension] = STATE(1327),
    [sym_dictionary] = STATE(1327),
    [sym_dictionary_comprehension] = STATE(1327),
    [sym_set] = STATE(1327),
    [sym_set_comprehension] = STATE(1327),
    [sym_parenthesized_expression] = STATE(1327),
    [sym_tuple] = STATE(1327),
    [sym_generator_expression] = STATE(1327),
    [sym_concatenated_string] = STATE(1327),
    [sym_string] = STATE(153),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2714),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2716),
    [sym_float] = ACTIONS(2716),
    [sym_identifier] = ACTIONS(2716),
    [sym_true] = ACTIONS(2716),
    [sym_false] = ACTIONS(2716),
    [sym_none] = ACTIONS(2716),
    [sym_comment] = ACTIONS(73),
  },
  [929] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(795),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(795),
    [anon_sym_PERCENT] = ACTIONS(801),
    [anon_sym_SLASH_SLASH] = ACTIONS(801),
    [anon_sym_STAR_STAR] = ACTIONS(807),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [930] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(795),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(805),
    [anon_sym_DASH] = ACTIONS(805),
    [anon_sym_SLASH] = ACTIONS(795),
    [anon_sym_PERCENT] = ACTIONS(801),
    [anon_sym_SLASH_SLASH] = ACTIONS(801),
    [anon_sym_STAR_STAR] = ACTIONS(807),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [931] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(795),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(805),
    [anon_sym_DASH] = ACTIONS(805),
    [anon_sym_SLASH] = ACTIONS(795),
    [anon_sym_PERCENT] = ACTIONS(801),
    [anon_sym_SLASH_SLASH] = ACTIONS(801),
    [anon_sym_STAR_STAR] = ACTIONS(807),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [932] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(795),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(805),
    [anon_sym_DASH] = ACTIONS(805),
    [anon_sym_SLASH] = ACTIONS(795),
    [anon_sym_PERCENT] = ACTIONS(801),
    [anon_sym_SLASH_SLASH] = ACTIONS(801),
    [anon_sym_STAR_STAR] = ACTIONS(807),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [933] = {
    [aux_sym_comparison_operator_repeat1] = STATE(933),
    [anon_sym_COMMA] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_async] = ACTIONS(1988),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(2718),
    [anon_sym_not] = ACTIONS(2721),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(2724),
    [anon_sym_LT_EQ] = ACTIONS(2718),
    [anon_sym_EQ_EQ] = ACTIONS(2718),
    [anon_sym_BANG_EQ] = ACTIONS(2718),
    [anon_sym_GT_EQ] = ACTIONS(2718),
    [anon_sym_GT] = ACTIONS(2724),
    [anon_sym_LT_GT] = ACTIONS(2718),
    [anon_sym_is] = ACTIONS(2727),
    [anon_sym_RBRACK] = ACTIONS(1988),
    [sym_comment] = ACTIONS(73),
  },
  [934] = {
    [sym_string] = STATE(934),
    [aux_sym_concatenated_string_repeat1] = STATE(934),
    [sym__string_start] = ACTIONS(2241),
    [anon_sym_DOT] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(2050),
    [anon_sym_COMMA] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2050),
    [anon_sym_if] = ACTIONS(2050),
    [anon_sym_async] = ACTIONS(2050),
    [anon_sym_for] = ACTIONS(2050),
    [anon_sym_in] = ACTIONS(2050),
    [anon_sym_AT] = ACTIONS(2050),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_and] = ACTIONS(2050),
    [anon_sym_or] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_SLASH] = ACTIONS(2055),
    [anon_sym_PERCENT] = ACTIONS(2050),
    [anon_sym_SLASH_SLASH] = ACTIONS(2050),
    [anon_sym_STAR_STAR] = ACTIONS(2050),
    [anon_sym_PIPE] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2050),
    [anon_sym_CARET] = ACTIONS(2050),
    [anon_sym_LT_LT] = ACTIONS(2050),
    [anon_sym_LT] = ACTIONS(2055),
    [anon_sym_LT_EQ] = ACTIONS(2050),
    [anon_sym_EQ_EQ] = ACTIONS(2050),
    [anon_sym_BANG_EQ] = ACTIONS(2050),
    [anon_sym_GT_EQ] = ACTIONS(2050),
    [anon_sym_GT] = ACTIONS(2055),
    [anon_sym_LT_GT] = ACTIONS(2050),
    [anon_sym_is] = ACTIONS(2050),
    [anon_sym_LBRACK] = ACTIONS(2050),
    [anon_sym_RBRACK] = ACTIONS(2050),
    [sym_comment] = ACTIONS(73),
  },
  [935] = {
    [anon_sym_COMMA] = ACTIONS(2526),
    [anon_sym_if] = ACTIONS(1766),
    [anon_sym_and] = ACTIONS(1768),
    [anon_sym_or] = ACTIONS(1770),
    [anon_sym_RBRACE] = ACTIONS(2526),
    [sym_comment] = ACTIONS(73),
  },
  [936] = {
    [anon_sym_COMMA] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(723),
    [anon_sym_and] = ACTIONS(1768),
    [anon_sym_or] = ACTIONS(1770),
    [anon_sym_RBRACE] = ACTIONS(723),
    [sym_comment] = ACTIONS(73),
  },
  [937] = {
    [sym__expression] = STATE(1328),
    [sym__primary_expression] = STATE(485),
    [sym_not_operator] = STATE(1328),
    [sym_boolean_operator] = STATE(1328),
    [sym_binary_operator] = STATE(485),
    [sym_unary_operator] = STATE(485),
    [sym_comparison_operator] = STATE(1328),
    [sym_lambda] = STATE(1328),
    [sym_attribute] = STATE(485),
    [sym_subscript] = STATE(485),
    [sym_call] = STATE(485),
    [sym_list] = STATE(485),
    [sym_list_comprehension] = STATE(485),
    [sym_dictionary] = STATE(485),
    [sym_dictionary_comprehension] = STATE(485),
    [sym_set] = STATE(485),
    [sym_set_comprehension] = STATE(485),
    [sym_parenthesized_expression] = STATE(485),
    [sym_tuple] = STATE(485),
    [sym_generator_expression] = STATE(485),
    [sym_conditional_expression] = STATE(1328),
    [sym_concatenated_string] = STATE(485),
    [sym_string] = STATE(486),
    [sym_await] = STATE(1328),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(823),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_TILDE] = ACTIONS(825),
    [anon_sym_lambda] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(829),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(831),
    [sym_float] = ACTIONS(831),
    [sym_identifier] = ACTIONS(831),
    [sym_true] = ACTIONS(831),
    [sym_false] = ACTIONS(831),
    [sym_none] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [sym_comment] = ACTIONS(73),
  },
  [938] = {
    [anon_sym_COLON] = ACTIONS(2730),
    [sym_comment] = ACTIONS(73),
  },
  [939] = {
    [sym__expression] = STATE(1330),
    [sym__primary_expression] = STATE(538),
    [sym_not_operator] = STATE(1330),
    [sym_boolean_operator] = STATE(1330),
    [sym_binary_operator] = STATE(538),
    [sym_unary_operator] = STATE(538),
    [sym_comparison_operator] = STATE(1330),
    [sym_lambda] = STATE(1330),
    [sym_attribute] = STATE(538),
    [sym_subscript] = STATE(538),
    [sym_call] = STATE(538),
    [sym_list] = STATE(538),
    [sym_list_comprehension] = STATE(538),
    [sym_dictionary] = STATE(538),
    [sym_dictionary_comprehension] = STATE(538),
    [sym_set] = STATE(538),
    [sym_set_comprehension] = STATE(538),
    [sym_parenthesized_expression] = STATE(538),
    [sym_tuple] = STATE(538),
    [sym_generator_expression] = STATE(538),
    [sym_conditional_expression] = STATE(1330),
    [sym_concatenated_string] = STATE(538),
    [sym_string] = STATE(539),
    [sym_await] = STATE(1330),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_lambda] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(917),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(919),
    [sym_float] = ACTIONS(919),
    [sym_identifier] = ACTIONS(919),
    [sym_true] = ACTIONS(919),
    [sym_false] = ACTIONS(919),
    [sym_none] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(921),
    [sym_comment] = ACTIONS(73),
  },
  [940] = {
    [sym__expression] = STATE(652),
    [sym__primary_expression] = STATE(485),
    [sym_not_operator] = STATE(652),
    [sym_boolean_operator] = STATE(652),
    [sym_binary_operator] = STATE(485),
    [sym_unary_operator] = STATE(485),
    [sym_comparison_operator] = STATE(652),
    [sym_lambda] = STATE(652),
    [sym_attribute] = STATE(485),
    [sym_subscript] = STATE(485),
    [sym_call] = STATE(485),
    [sym_list] = STATE(485),
    [sym_list_comprehension] = STATE(485),
    [sym_dictionary] = STATE(485),
    [sym_dictionary_comprehension] = STATE(485),
    [sym_set] = STATE(485),
    [sym_set_comprehension] = STATE(485),
    [sym_parenthesized_expression] = STATE(485),
    [sym_tuple] = STATE(485),
    [sym_generator_expression] = STATE(485),
    [sym_conditional_expression] = STATE(652),
    [sym_concatenated_string] = STATE(485),
    [sym_string] = STATE(486),
    [sym_await] = STATE(652),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(823),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_TILDE] = ACTIONS(825),
    [anon_sym_lambda] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(829),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(831),
    [sym_float] = ACTIONS(831),
    [sym_identifier] = ACTIONS(831),
    [sym_true] = ACTIONS(831),
    [sym_false] = ACTIONS(831),
    [sym_none] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [sym_comment] = ACTIONS(73),
  },
  [941] = {
    [sym__expression] = STATE(1331),
    [sym__primary_expression] = STATE(485),
    [sym_not_operator] = STATE(1331),
    [sym_boolean_operator] = STATE(1331),
    [sym_binary_operator] = STATE(485),
    [sym_unary_operator] = STATE(485),
    [sym_comparison_operator] = STATE(1331),
    [sym_lambda] = STATE(1331),
    [sym_attribute] = STATE(485),
    [sym_subscript] = STATE(485),
    [sym_call] = STATE(485),
    [sym_list] = STATE(485),
    [sym_list_comprehension] = STATE(485),
    [sym_dictionary] = STATE(485),
    [sym_dictionary_comprehension] = STATE(485),
    [sym_set] = STATE(485),
    [sym_set_comprehension] = STATE(485),
    [sym_parenthesized_expression] = STATE(485),
    [sym_tuple] = STATE(485),
    [sym_generator_expression] = STATE(485),
    [sym_conditional_expression] = STATE(1331),
    [sym_concatenated_string] = STATE(485),
    [sym_string] = STATE(486),
    [sym_await] = STATE(1331),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(823),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_TILDE] = ACTIONS(825),
    [anon_sym_lambda] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(829),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(831),
    [sym_float] = ACTIONS(831),
    [sym_identifier] = ACTIONS(831),
    [sym_true] = ACTIONS(831),
    [sym_false] = ACTIONS(831),
    [sym_none] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [sym_comment] = ACTIONS(73),
  },
  [942] = {
    [sym__primary_expression] = STATE(1332),
    [sym_binary_operator] = STATE(1332),
    [sym_unary_operator] = STATE(1332),
    [sym_attribute] = STATE(1332),
    [sym_subscript] = STATE(1332),
    [sym_call] = STATE(1332),
    [sym_list] = STATE(1332),
    [sym_list_comprehension] = STATE(1332),
    [sym_dictionary] = STATE(1332),
    [sym_dictionary_comprehension] = STATE(1332),
    [sym_set] = STATE(1332),
    [sym_set_comprehension] = STATE(1332),
    [sym_parenthesized_expression] = STATE(1332),
    [sym_tuple] = STATE(1332),
    [sym_generator_expression] = STATE(1332),
    [sym_concatenated_string] = STATE(1332),
    [sym_string] = STATE(486),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_TILDE] = ACTIONS(825),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2732),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2734),
    [sym_float] = ACTIONS(2734),
    [sym_identifier] = ACTIONS(2734),
    [sym_true] = ACTIONS(2734),
    [sym_false] = ACTIONS(2734),
    [sym_none] = ACTIONS(2734),
    [sym_comment] = ACTIONS(73),
  },
  [943] = {
    [sym__primary_expression] = STATE(1333),
    [sym_binary_operator] = STATE(1333),
    [sym_unary_operator] = STATE(1333),
    [sym_attribute] = STATE(1333),
    [sym_subscript] = STATE(1333),
    [sym_call] = STATE(1333),
    [sym_list] = STATE(1333),
    [sym_list_comprehension] = STATE(1333),
    [sym_dictionary] = STATE(1333),
    [sym_dictionary_comprehension] = STATE(1333),
    [sym_set] = STATE(1333),
    [sym_set_comprehension] = STATE(1333),
    [sym_parenthesized_expression] = STATE(1333),
    [sym_tuple] = STATE(1333),
    [sym_generator_expression] = STATE(1333),
    [sym_concatenated_string] = STATE(1333),
    [sym_string] = STATE(486),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_TILDE] = ACTIONS(825),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2736),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2738),
    [sym_float] = ACTIONS(2738),
    [sym_identifier] = ACTIONS(2738),
    [sym_true] = ACTIONS(2738),
    [sym_false] = ACTIONS(2738),
    [sym_none] = ACTIONS(2738),
    [sym_comment] = ACTIONS(73),
  },
  [944] = {
    [sym__primary_expression] = STATE(1334),
    [sym_binary_operator] = STATE(1334),
    [sym_unary_operator] = STATE(1334),
    [sym_attribute] = STATE(1334),
    [sym_subscript] = STATE(1334),
    [sym_call] = STATE(1334),
    [sym_list] = STATE(1334),
    [sym_list_comprehension] = STATE(1334),
    [sym_dictionary] = STATE(1334),
    [sym_dictionary_comprehension] = STATE(1334),
    [sym_set] = STATE(1334),
    [sym_set_comprehension] = STATE(1334),
    [sym_parenthesized_expression] = STATE(1334),
    [sym_tuple] = STATE(1334),
    [sym_generator_expression] = STATE(1334),
    [sym_concatenated_string] = STATE(1334),
    [sym_string] = STATE(486),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_TILDE] = ACTIONS(825),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2740),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2742),
    [sym_float] = ACTIONS(2742),
    [sym_identifier] = ACTIONS(2742),
    [sym_true] = ACTIONS(2742),
    [sym_false] = ACTIONS(2742),
    [sym_none] = ACTIONS(2742),
    [sym_comment] = ACTIONS(73),
  },
  [945] = {
    [anon_sym_in] = ACTIONS(2744),
    [sym_comment] = ACTIONS(73),
  },
  [946] = {
    [sym__primary_expression] = STATE(1336),
    [sym_binary_operator] = STATE(1336),
    [sym_unary_operator] = STATE(1336),
    [sym_attribute] = STATE(1336),
    [sym_subscript] = STATE(1336),
    [sym_call] = STATE(1336),
    [sym_list] = STATE(1336),
    [sym_list_comprehension] = STATE(1336),
    [sym_dictionary] = STATE(1336),
    [sym_dictionary_comprehension] = STATE(1336),
    [sym_set] = STATE(1336),
    [sym_set_comprehension] = STATE(1336),
    [sym_parenthesized_expression] = STATE(1336),
    [sym_tuple] = STATE(1336),
    [sym_generator_expression] = STATE(1336),
    [sym_concatenated_string] = STATE(1336),
    [sym_string] = STATE(486),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_TILDE] = ACTIONS(825),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2746),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2748),
    [sym_float] = ACTIONS(2748),
    [sym_identifier] = ACTIONS(2748),
    [sym_true] = ACTIONS(2748),
    [sym_false] = ACTIONS(2748),
    [sym_none] = ACTIONS(2748),
    [sym_comment] = ACTIONS(73),
  },
  [947] = {
    [sym__primary_expression] = STATE(669),
    [sym_binary_operator] = STATE(669),
    [sym_unary_operator] = STATE(669),
    [sym_attribute] = STATE(669),
    [sym_subscript] = STATE(669),
    [sym_call] = STATE(669),
    [sym_list] = STATE(669),
    [sym_list_comprehension] = STATE(669),
    [sym_dictionary] = STATE(669),
    [sym_dictionary_comprehension] = STATE(669),
    [sym_set] = STATE(669),
    [sym_set_comprehension] = STATE(669),
    [sym_parenthesized_expression] = STATE(669),
    [sym_tuple] = STATE(669),
    [sym_generator_expression] = STATE(669),
    [sym_concatenated_string] = STATE(669),
    [sym_string] = STATE(486),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_TILDE] = ACTIONS(825),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1282),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1284),
    [sym_float] = ACTIONS(1284),
    [sym_identifier] = ACTIONS(1284),
    [sym_true] = ACTIONS(1284),
    [sym_false] = ACTIONS(1284),
    [sym_none] = ACTIONS(1284),
    [sym_comment] = ACTIONS(73),
  },
  [948] = {
    [sym__primary_expression] = STATE(1337),
    [sym_binary_operator] = STATE(1337),
    [sym_unary_operator] = STATE(1337),
    [sym_attribute] = STATE(1337),
    [sym_subscript] = STATE(1337),
    [sym_call] = STATE(1337),
    [sym_list] = STATE(1337),
    [sym_list_comprehension] = STATE(1337),
    [sym_dictionary] = STATE(1337),
    [sym_dictionary_comprehension] = STATE(1337),
    [sym_set] = STATE(1337),
    [sym_set_comprehension] = STATE(1337),
    [sym_parenthesized_expression] = STATE(1337),
    [sym_tuple] = STATE(1337),
    [sym_generator_expression] = STATE(1337),
    [sym_concatenated_string] = STATE(1337),
    [sym_string] = STATE(486),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_TILDE] = ACTIONS(825),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2750),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2752),
    [sym_float] = ACTIONS(2752),
    [sym_identifier] = ACTIONS(2752),
    [sym_true] = ACTIONS(2752),
    [sym_false] = ACTIONS(2752),
    [sym_none] = ACTIONS(2752),
    [sym_comment] = ACTIONS(73),
  },
  [949] = {
    [sym__primary_expression] = STATE(1338),
    [sym_binary_operator] = STATE(1338),
    [sym_unary_operator] = STATE(1338),
    [sym_attribute] = STATE(1338),
    [sym_subscript] = STATE(1338),
    [sym_call] = STATE(1338),
    [sym_list] = STATE(1338),
    [sym_list_comprehension] = STATE(1338),
    [sym_dictionary] = STATE(1338),
    [sym_dictionary_comprehension] = STATE(1338),
    [sym_set] = STATE(1338),
    [sym_set_comprehension] = STATE(1338),
    [sym_parenthesized_expression] = STATE(1338),
    [sym_tuple] = STATE(1338),
    [sym_generator_expression] = STATE(1338),
    [sym_concatenated_string] = STATE(1338),
    [sym_string] = STATE(486),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_TILDE] = ACTIONS(825),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2754),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2756),
    [sym_float] = ACTIONS(2756),
    [sym_identifier] = ACTIONS(2756),
    [sym_true] = ACTIONS(2756),
    [sym_false] = ACTIONS(2756),
    [sym_none] = ACTIONS(2756),
    [sym_comment] = ACTIONS(73),
  },
  [950] = {
    [sym__primary_expression] = STATE(1339),
    [sym_binary_operator] = STATE(1339),
    [sym_unary_operator] = STATE(1339),
    [sym_attribute] = STATE(1339),
    [sym_subscript] = STATE(1339),
    [sym_call] = STATE(1339),
    [sym_list] = STATE(1339),
    [sym_list_comprehension] = STATE(1339),
    [sym_dictionary] = STATE(1339),
    [sym_dictionary_comprehension] = STATE(1339),
    [sym_set] = STATE(1339),
    [sym_set_comprehension] = STATE(1339),
    [sym_parenthesized_expression] = STATE(1339),
    [sym_tuple] = STATE(1339),
    [sym_generator_expression] = STATE(1339),
    [sym_concatenated_string] = STATE(1339),
    [sym_string] = STATE(486),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_TILDE] = ACTIONS(825),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2758),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2760),
    [sym_float] = ACTIONS(2760),
    [sym_identifier] = ACTIONS(2760),
    [sym_true] = ACTIONS(2760),
    [sym_false] = ACTIONS(2760),
    [sym_none] = ACTIONS(2760),
    [sym_comment] = ACTIONS(73),
  },
  [951] = {
    [sym__primary_expression] = STATE(1334),
    [sym_binary_operator] = STATE(1334),
    [sym_unary_operator] = STATE(1334),
    [sym_attribute] = STATE(1334),
    [sym_subscript] = STATE(1334),
    [sym_call] = STATE(1334),
    [sym_list] = STATE(1334),
    [sym_list_comprehension] = STATE(1334),
    [sym_dictionary] = STATE(1334),
    [sym_dictionary_comprehension] = STATE(1334),
    [sym_set] = STATE(1334),
    [sym_set_comprehension] = STATE(1334),
    [sym_parenthesized_expression] = STATE(1334),
    [sym_tuple] = STATE(1334),
    [sym_generator_expression] = STATE(1334),
    [sym_concatenated_string] = STATE(1334),
    [sym_string] = STATE(486),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2762),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_TILDE] = ACTIONS(825),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2740),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2742),
    [sym_float] = ACTIONS(2742),
    [sym_identifier] = ACTIONS(2742),
    [sym_true] = ACTIONS(2742),
    [sym_false] = ACTIONS(2742),
    [sym_none] = ACTIONS(2742),
    [sym_comment] = ACTIONS(73),
  },
  [952] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1340),
    [anon_sym_COMMA] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(1776),
    [anon_sym_not] = ACTIONS(1780),
    [anon_sym_and] = ACTIONS(991),
    [anon_sym_or] = ACTIONS(991),
    [anon_sym_LT] = ACTIONS(1792),
    [anon_sym_LT_EQ] = ACTIONS(1776),
    [anon_sym_EQ_EQ] = ACTIONS(1776),
    [anon_sym_BANG_EQ] = ACTIONS(1776),
    [anon_sym_GT_EQ] = ACTIONS(1776),
    [anon_sym_GT] = ACTIONS(1792),
    [anon_sym_LT_GT] = ACTIONS(1776),
    [anon_sym_is] = ACTIONS(1794),
    [anon_sym_RBRACE] = ACTIONS(991),
    [sym_comment] = ACTIONS(73),
  },
  [953] = {
    [sym_string] = STATE(1341),
    [aux_sym_concatenated_string_repeat1] = STATE(1341),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_in] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(995),
    [anon_sym_not] = ACTIONS(995),
    [anon_sym_and] = ACTIONS(995),
    [anon_sym_or] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(995),
    [anon_sym_SLASH_SLASH] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_GT] = ACTIONS(995),
    [anon_sym_is] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(995),
    [anon_sym_RBRACE] = ACTIONS(995),
    [sym_comment] = ACTIONS(73),
  },
  [954] = {
    [anon_sym_COMMA] = ACTIONS(1660),
    [anon_sym_if] = ACTIONS(847),
    [anon_sym_COLON] = ACTIONS(1660),
    [anon_sym_async] = ACTIONS(1660),
    [anon_sym_for] = ACTIONS(1660),
    [anon_sym_and] = ACTIONS(855),
    [anon_sym_or] = ACTIONS(857),
    [anon_sym_RBRACE] = ACTIONS(1660),
    [sym_comment] = ACTIONS(73),
  },
  [955] = {
    [sym__expression] = STATE(1342),
    [sym__primary_expression] = STATE(164),
    [sym_not_operator] = STATE(1342),
    [sym_boolean_operator] = STATE(1342),
    [sym_binary_operator] = STATE(164),
    [sym_unary_operator] = STATE(164),
    [sym_comparison_operator] = STATE(1342),
    [sym_lambda] = STATE(1342),
    [sym_attribute] = STATE(164),
    [sym_subscript] = STATE(164),
    [sym_call] = STATE(164),
    [sym_list] = STATE(164),
    [sym_list_comprehension] = STATE(164),
    [sym_dictionary] = STATE(164),
    [sym_dictionary_comprehension] = STATE(164),
    [sym_set] = STATE(164),
    [sym_set_comprehension] = STATE(164),
    [sym_parenthesized_expression] = STATE(164),
    [sym_tuple] = STATE(164),
    [sym_generator_expression] = STATE(164),
    [sym_conditional_expression] = STATE(1342),
    [sym_concatenated_string] = STATE(164),
    [sym_string] = STATE(166),
    [sym_await] = STATE(1342),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_lambda] = ACTIONS(267),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(273),
    [sym_float] = ACTIONS(273),
    [sym_identifier] = ACTIONS(273),
    [sym_true] = ACTIONS(273),
    [sym_false] = ACTIONS(273),
    [sym_none] = ACTIONS(273),
    [anon_sym_await] = ACTIONS(275),
    [sym_comment] = ACTIONS(73),
  },
  [956] = {
    [sym__expression] = STATE(484),
    [sym__primary_expression] = STATE(485),
    [sym_not_operator] = STATE(484),
    [sym_boolean_operator] = STATE(484),
    [sym_binary_operator] = STATE(485),
    [sym_unary_operator] = STATE(485),
    [sym_comparison_operator] = STATE(484),
    [sym_lambda] = STATE(484),
    [sym_attribute] = STATE(485),
    [sym_subscript] = STATE(485),
    [sym_call] = STATE(485),
    [sym_list] = STATE(485),
    [sym_list_comprehension] = STATE(485),
    [sym_dictionary] = STATE(485),
    [sym_dictionary_comprehension] = STATE(485),
    [sym_set] = STATE(485),
    [sym_set_comprehension] = STATE(485),
    [sym_parenthesized_expression] = STATE(485),
    [sym_tuple] = STATE(485),
    [sym_generator_expression] = STATE(485),
    [sym_conditional_expression] = STATE(484),
    [sym_concatenated_string] = STATE(485),
    [sym_string] = STATE(486),
    [sym_await] = STATE(484),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_COMMA] = ACTIONS(729),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(823),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_TILDE] = ACTIONS(825),
    [anon_sym_lambda] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(829),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(729),
    [sym_integer] = ACTIONS(831),
    [sym_float] = ACTIONS(831),
    [sym_identifier] = ACTIONS(831),
    [sym_true] = ACTIONS(831),
    [sym_false] = ACTIONS(831),
    [sym_none] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [sym_comment] = ACTIONS(73),
  },
  [957] = {
    [sym__newline] = ACTIONS(2764),
    [anon_sym_DOT] = ACTIONS(2764),
    [anon_sym_LPAREN] = ACTIONS(2764),
    [anon_sym_COMMA] = ACTIONS(2764),
    [anon_sym_STAR] = ACTIONS(2766),
    [anon_sym_GT_GT] = ACTIONS(2766),
    [anon_sym_if] = ACTIONS(2764),
    [anon_sym_COLON] = ACTIONS(2764),
    [anon_sym_in] = ACTIONS(2764),
    [anon_sym_EQ] = ACTIONS(2766),
    [anon_sym_AT] = ACTIONS(2766),
    [anon_sym_not] = ACTIONS(2764),
    [anon_sym_and] = ACTIONS(2764),
    [anon_sym_or] = ACTIONS(2764),
    [anon_sym_PLUS] = ACTIONS(2766),
    [anon_sym_DASH] = ACTIONS(2766),
    [anon_sym_SLASH] = ACTIONS(2766),
    [anon_sym_PERCENT] = ACTIONS(2766),
    [anon_sym_SLASH_SLASH] = ACTIONS(2766),
    [anon_sym_STAR_STAR] = ACTIONS(2766),
    [anon_sym_PIPE] = ACTIONS(2766),
    [anon_sym_AMP] = ACTIONS(2766),
    [anon_sym_CARET] = ACTIONS(2766),
    [anon_sym_LT_LT] = ACTIONS(2766),
    [anon_sym_LT] = ACTIONS(2766),
    [anon_sym_LT_EQ] = ACTIONS(2764),
    [anon_sym_EQ_EQ] = ACTIONS(2764),
    [anon_sym_BANG_EQ] = ACTIONS(2764),
    [anon_sym_GT_EQ] = ACTIONS(2764),
    [anon_sym_GT] = ACTIONS(2766),
    [anon_sym_LT_GT] = ACTIONS(2764),
    [anon_sym_is] = ACTIONS(2764),
    [anon_sym_PLUS_EQ] = ACTIONS(2764),
    [anon_sym_DASH_EQ] = ACTIONS(2764),
    [anon_sym_STAR_EQ] = ACTIONS(2764),
    [anon_sym_SLASH_EQ] = ACTIONS(2764),
    [anon_sym_AT_EQ] = ACTIONS(2764),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2764),
    [anon_sym_PERCENT_EQ] = ACTIONS(2764),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2764),
    [anon_sym_GT_GT_EQ] = ACTIONS(2764),
    [anon_sym_LT_LT_EQ] = ACTIONS(2764),
    [anon_sym_AMP_EQ] = ACTIONS(2764),
    [anon_sym_CARET_EQ] = ACTIONS(2764),
    [anon_sym_PIPE_EQ] = ACTIONS(2764),
    [anon_sym_LBRACK] = ACTIONS(2764),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2764),
  },
  [958] = {
    [anon_sym_COMMA] = ACTIONS(2687),
    [anon_sym_if] = ACTIONS(1766),
    [anon_sym_and] = ACTIONS(1768),
    [anon_sym_or] = ACTIONS(1770),
    [anon_sym_RBRACE] = ACTIONS(2687),
    [sym_comment] = ACTIONS(73),
  },
  [959] = {
    [sym_list_splat] = STATE(914),
    [sym__expression] = STATE(958),
    [sym__primary_expression] = STATE(485),
    [sym_not_operator] = STATE(958),
    [sym_boolean_operator] = STATE(958),
    [sym_binary_operator] = STATE(485),
    [sym_unary_operator] = STATE(485),
    [sym_comparison_operator] = STATE(958),
    [sym_lambda] = STATE(958),
    [sym_attribute] = STATE(485),
    [sym_subscript] = STATE(485),
    [sym_call] = STATE(485),
    [sym_list] = STATE(485),
    [sym_list_comprehension] = STATE(485),
    [sym_dictionary] = STATE(485),
    [sym_dictionary_comprehension] = STATE(485),
    [sym_set] = STATE(485),
    [sym_set_comprehension] = STATE(485),
    [sym_parenthesized_expression] = STATE(485),
    [sym_tuple] = STATE(485),
    [sym_generator_expression] = STATE(485),
    [sym_conditional_expression] = STATE(958),
    [sym_concatenated_string] = STATE(485),
    [sym_string] = STATE(486),
    [sym_await] = STATE(958),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(1798),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(823),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_TILDE] = ACTIONS(825),
    [anon_sym_lambda] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(829),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(2768),
    [sym_integer] = ACTIONS(831),
    [sym_float] = ACTIONS(831),
    [sym_identifier] = ACTIONS(831),
    [sym_true] = ACTIONS(831),
    [sym_false] = ACTIONS(831),
    [sym_none] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [sym_comment] = ACTIONS(73),
  },
  [960] = {
    [aux_sym_list_repeat1] = STATE(960),
    [anon_sym_COMMA] = ACTIONS(2770),
    [anon_sym_RBRACE] = ACTIONS(2687),
    [sym_comment] = ACTIONS(73),
  },
  [961] = {
    [anon_sym_STAR] = ACTIONS(821),
    [sym_comment] = ACTIONS(73),
  },
  [962] = {
    [sym__newline] = ACTIONS(2773),
    [anon_sym_DOT] = ACTIONS(2773),
    [anon_sym_LPAREN] = ACTIONS(2773),
    [anon_sym_COMMA] = ACTIONS(2773),
    [anon_sym_STAR] = ACTIONS(2775),
    [anon_sym_GT_GT] = ACTIONS(2775),
    [anon_sym_if] = ACTIONS(2773),
    [anon_sym_COLON] = ACTIONS(2773),
    [anon_sym_in] = ACTIONS(2773),
    [anon_sym_EQ] = ACTIONS(2775),
    [anon_sym_AT] = ACTIONS(2775),
    [anon_sym_not] = ACTIONS(2773),
    [anon_sym_and] = ACTIONS(2773),
    [anon_sym_or] = ACTIONS(2773),
    [anon_sym_PLUS] = ACTIONS(2775),
    [anon_sym_DASH] = ACTIONS(2775),
    [anon_sym_SLASH] = ACTIONS(2775),
    [anon_sym_PERCENT] = ACTIONS(2775),
    [anon_sym_SLASH_SLASH] = ACTIONS(2775),
    [anon_sym_STAR_STAR] = ACTIONS(2775),
    [anon_sym_PIPE] = ACTIONS(2775),
    [anon_sym_AMP] = ACTIONS(2775),
    [anon_sym_CARET] = ACTIONS(2775),
    [anon_sym_LT_LT] = ACTIONS(2775),
    [anon_sym_LT] = ACTIONS(2775),
    [anon_sym_LT_EQ] = ACTIONS(2773),
    [anon_sym_EQ_EQ] = ACTIONS(2773),
    [anon_sym_BANG_EQ] = ACTIONS(2773),
    [anon_sym_GT_EQ] = ACTIONS(2773),
    [anon_sym_GT] = ACTIONS(2775),
    [anon_sym_LT_GT] = ACTIONS(2773),
    [anon_sym_is] = ACTIONS(2773),
    [anon_sym_PLUS_EQ] = ACTIONS(2773),
    [anon_sym_DASH_EQ] = ACTIONS(2773),
    [anon_sym_STAR_EQ] = ACTIONS(2773),
    [anon_sym_SLASH_EQ] = ACTIONS(2773),
    [anon_sym_AT_EQ] = ACTIONS(2773),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2773),
    [anon_sym_PERCENT_EQ] = ACTIONS(2773),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2773),
    [anon_sym_GT_GT_EQ] = ACTIONS(2773),
    [anon_sym_LT_LT_EQ] = ACTIONS(2773),
    [anon_sym_AMP_EQ] = ACTIONS(2773),
    [anon_sym_CARET_EQ] = ACTIONS(2773),
    [anon_sym_PIPE_EQ] = ACTIONS(2773),
    [anon_sym_LBRACK] = ACTIONS(2773),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2773),
  },
  [963] = {
    [anon_sym_COMMA] = ACTIONS(2777),
    [anon_sym_RBRACE] = ACTIONS(2777),
    [sym_comment] = ACTIONS(73),
  },
  [964] = {
    [anon_sym_if] = ACTIONS(599),
    [anon_sym_COLON] = ACTIONS(2779),
    [anon_sym_and] = ACTIONS(603),
    [anon_sym_or] = ACTIONS(605),
    [sym_comment] = ACTIONS(73),
  },
  [965] = {
    [sym_dictionary_splat] = STATE(963),
    [sym__expression] = STATE(964),
    [sym__primary_expression] = STATE(102),
    [sym_not_operator] = STATE(964),
    [sym_boolean_operator] = STATE(964),
    [sym_binary_operator] = STATE(102),
    [sym_unary_operator] = STATE(102),
    [sym_comparison_operator] = STATE(964),
    [sym_lambda] = STATE(964),
    [sym_attribute] = STATE(102),
    [sym_subscript] = STATE(102),
    [sym_call] = STATE(102),
    [sym_list] = STATE(102),
    [sym_list_comprehension] = STATE(102),
    [sym_dictionary] = STATE(102),
    [sym_dictionary_comprehension] = STATE(102),
    [sym_pair] = STATE(963),
    [sym_set] = STATE(102),
    [sym_set_comprehension] = STATE(102),
    [sym_parenthesized_expression] = STATE(102),
    [sym_tuple] = STATE(102),
    [sym_generator_expression] = STATE(102),
    [sym_conditional_expression] = STATE(964),
    [sym_concatenated_string] = STATE(102),
    [sym_string] = STATE(103),
    [sym_await] = STATE(964),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(1808),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(2781),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [966] = {
    [aux_sym_dictionary_repeat1] = STATE(966),
    [anon_sym_COMMA] = ACTIONS(2783),
    [anon_sym_RBRACE] = ACTIONS(2777),
    [sym_comment] = ACTIONS(73),
  },
  [967] = {
    [anon_sym_if] = ACTIONS(1925),
    [anon_sym_else] = ACTIONS(2786),
    [anon_sym_and] = ACTIONS(1929),
    [anon_sym_or] = ACTIONS(1931),
    [sym_comment] = ACTIONS(73),
  },
  [968] = {
    [sym__expression] = STATE(1349),
    [sym__primary_expression] = STATE(973),
    [sym_not_operator] = STATE(1349),
    [sym_boolean_operator] = STATE(1349),
    [sym_binary_operator] = STATE(973),
    [sym_unary_operator] = STATE(973),
    [sym_comparison_operator] = STATE(1349),
    [sym_lambda] = STATE(1349),
    [sym_attribute] = STATE(973),
    [sym_subscript] = STATE(973),
    [sym_call] = STATE(973),
    [sym_list] = STATE(973),
    [sym_list_comprehension] = STATE(973),
    [sym_dictionary] = STATE(973),
    [sym_dictionary_comprehension] = STATE(973),
    [sym_set] = STATE(973),
    [sym_set_comprehension] = STATE(973),
    [sym_parenthesized_expression] = STATE(973),
    [sym_tuple] = STATE(973),
    [sym_generator_expression] = STATE(973),
    [sym_conditional_expression] = STATE(1349),
    [sym_concatenated_string] = STATE(973),
    [sym_string] = STATE(974),
    [sym_await] = STATE(1349),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1814),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_DASH] = ACTIONS(1816),
    [anon_sym_TILDE] = ACTIONS(1816),
    [anon_sym_lambda] = ACTIONS(1818),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1820),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1822),
    [sym_float] = ACTIONS(1822),
    [sym_identifier] = ACTIONS(1822),
    [sym_true] = ACTIONS(1822),
    [sym_false] = ACTIONS(1822),
    [sym_none] = ACTIONS(1822),
    [anon_sym_await] = ACTIONS(1824),
    [sym_comment] = ACTIONS(73),
  },
  [969] = {
    [sym__primary_expression] = STATE(227),
    [sym_binary_operator] = STATE(227),
    [sym_unary_operator] = STATE(227),
    [sym_attribute] = STATE(227),
    [sym_subscript] = STATE(227),
    [sym_call] = STATE(227),
    [sym_list] = STATE(227),
    [sym_list_comprehension] = STATE(227),
    [sym_dictionary] = STATE(227),
    [sym_dictionary_comprehension] = STATE(227),
    [sym_set] = STATE(227),
    [sym_set_comprehension] = STATE(227),
    [sym_parenthesized_expression] = STATE(227),
    [sym_tuple] = STATE(227),
    [sym_generator_expression] = STATE(227),
    [sym_concatenated_string] = STATE(227),
    [sym_string] = STATE(974),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_DASH] = ACTIONS(1816),
    [anon_sym_TILDE] = ACTIONS(1816),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(403),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(405),
    [sym_float] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_true] = ACTIONS(405),
    [sym_false] = ACTIONS(405),
    [sym_none] = ACTIONS(405),
    [sym_comment] = ACTIONS(73),
  },
  [970] = {
    [sym_lambda_parameters] = STATE(1351),
    [sym__parameters] = STATE(138),
    [sym_default_parameter] = STATE(139),
    [sym_typed_default_parameter] = STATE(139),
    [sym_list_splat] = STATE(140),
    [sym_dictionary_splat] = STATE(140),
    [sym_typed_parameter] = STATE(139),
    [sym_tuple] = STATE(139),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(2788),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [971] = {
    [sym__expression] = STATE(249),
    [sym__primary_expression] = STATE(973),
    [sym_not_operator] = STATE(249),
    [sym_boolean_operator] = STATE(249),
    [sym_binary_operator] = STATE(973),
    [sym_unary_operator] = STATE(973),
    [sym_comparison_operator] = STATE(249),
    [sym_lambda] = STATE(249),
    [sym_attribute] = STATE(973),
    [sym_subscript] = STATE(973),
    [sym_call] = STATE(973),
    [sym_list] = STATE(973),
    [sym_list_comprehension] = STATE(973),
    [sym_dictionary] = STATE(973),
    [sym_dictionary_comprehension] = STATE(973),
    [sym_set] = STATE(973),
    [sym_set_comprehension] = STATE(973),
    [sym_parenthesized_expression] = STATE(973),
    [sym_tuple] = STATE(973),
    [sym_generator_expression] = STATE(973),
    [sym_conditional_expression] = STATE(249),
    [sym_concatenated_string] = STATE(973),
    [sym_string] = STATE(974),
    [sym_await] = STATE(249),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1814),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_DASH] = ACTIONS(1816),
    [anon_sym_TILDE] = ACTIONS(1816),
    [anon_sym_lambda] = ACTIONS(1818),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1820),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1822),
    [sym_float] = ACTIONS(1822),
    [sym_identifier] = ACTIONS(1822),
    [sym_true] = ACTIONS(1822),
    [sym_false] = ACTIONS(1822),
    [sym_none] = ACTIONS(1822),
    [anon_sym_await] = ACTIONS(1824),
    [sym_comment] = ACTIONS(73),
  },
  [972] = {
    [anon_sym_COMMA] = ACTIONS(2790),
    [anon_sym_if] = ACTIONS(2792),
    [anon_sym_async] = ACTIONS(2790),
    [anon_sym_for] = ACTIONS(2790),
    [anon_sym_and] = ACTIONS(2794),
    [anon_sym_or] = ACTIONS(2796),
    [anon_sym_RBRACE] = ACTIONS(2790),
    [sym_comment] = ACTIONS(73),
  },
  [973] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [aux_sym_comparison_operator_repeat1] = STATE(1365),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(2798),
    [anon_sym_GT_GT] = ACTIONS(2800),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(2802),
    [anon_sym_AT] = ACTIONS(2804),
    [anon_sym_not] = ACTIONS(2806),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(2808),
    [anon_sym_DASH] = ACTIONS(2808),
    [anon_sym_SLASH] = ACTIONS(2798),
    [anon_sym_PERCENT] = ACTIONS(2804),
    [anon_sym_SLASH_SLASH] = ACTIONS(2804),
    [anon_sym_STAR_STAR] = ACTIONS(2810),
    [anon_sym_PIPE] = ACTIONS(2812),
    [anon_sym_AMP] = ACTIONS(2814),
    [anon_sym_CARET] = ACTIONS(2816),
    [anon_sym_LT_LT] = ACTIONS(2800),
    [anon_sym_LT] = ACTIONS(2818),
    [anon_sym_LT_EQ] = ACTIONS(2802),
    [anon_sym_EQ_EQ] = ACTIONS(2802),
    [anon_sym_BANG_EQ] = ACTIONS(2802),
    [anon_sym_GT_EQ] = ACTIONS(2802),
    [anon_sym_GT] = ACTIONS(2818),
    [anon_sym_LT_GT] = ACTIONS(2802),
    [anon_sym_is] = ACTIONS(2820),
    [anon_sym_LBRACK] = ACTIONS(473),
    [anon_sym_RBRACE] = ACTIONS(301),
    [sym_comment] = ACTIONS(73),
  },
  [974] = {
    [sym_string] = STATE(1366),
    [aux_sym_concatenated_string_repeat1] = STATE(1366),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_async] = ACTIONS(333),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_RBRACE] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [975] = {
    [sym_variables] = STATE(1367),
    [sym__primary_expression] = STATE(109),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(110),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(191),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(193),
    [sym_float] = ACTIONS(193),
    [sym_identifier] = ACTIONS(193),
    [sym_true] = ACTIONS(193),
    [sym_false] = ACTIONS(193),
    [sym_none] = ACTIONS(193),
    [sym_comment] = ACTIONS(73),
  },
  [976] = {
    [anon_sym_in] = ACTIONS(2822),
    [sym_comment] = ACTIONS(73),
  },
  [977] = {
    [anon_sym_COMMA] = ACTIONS(1957),
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_COLON] = ACTIONS(1957),
    [anon_sym_async] = ACTIONS(1957),
    [anon_sym_for] = ACTIONS(1957),
    [anon_sym_and] = ACTIONS(855),
    [anon_sym_or] = ACTIONS(1957),
    [anon_sym_RBRACE] = ACTIONS(1957),
    [sym_comment] = ACTIONS(73),
  },
  [978] = {
    [sym__newline] = ACTIONS(2824),
    [anon_sym_DOT] = ACTIONS(2824),
    [anon_sym_LPAREN] = ACTIONS(2824),
    [anon_sym_COMMA] = ACTIONS(2824),
    [anon_sym_STAR] = ACTIONS(2826),
    [anon_sym_GT_GT] = ACTIONS(2826),
    [anon_sym_if] = ACTIONS(2824),
    [anon_sym_COLON] = ACTIONS(2824),
    [anon_sym_in] = ACTIONS(2824),
    [anon_sym_EQ] = ACTIONS(2826),
    [anon_sym_AT] = ACTIONS(2826),
    [anon_sym_not] = ACTIONS(2824),
    [anon_sym_and] = ACTIONS(2824),
    [anon_sym_or] = ACTIONS(2824),
    [anon_sym_PLUS] = ACTIONS(2826),
    [anon_sym_DASH] = ACTIONS(2826),
    [anon_sym_SLASH] = ACTIONS(2826),
    [anon_sym_PERCENT] = ACTIONS(2826),
    [anon_sym_SLASH_SLASH] = ACTIONS(2826),
    [anon_sym_STAR_STAR] = ACTIONS(2826),
    [anon_sym_PIPE] = ACTIONS(2826),
    [anon_sym_AMP] = ACTIONS(2826),
    [anon_sym_CARET] = ACTIONS(2826),
    [anon_sym_LT_LT] = ACTIONS(2826),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_LT_EQ] = ACTIONS(2824),
    [anon_sym_EQ_EQ] = ACTIONS(2824),
    [anon_sym_BANG_EQ] = ACTIONS(2824),
    [anon_sym_GT_EQ] = ACTIONS(2824),
    [anon_sym_GT] = ACTIONS(2826),
    [anon_sym_LT_GT] = ACTIONS(2824),
    [anon_sym_is] = ACTIONS(2824),
    [anon_sym_PLUS_EQ] = ACTIONS(2824),
    [anon_sym_DASH_EQ] = ACTIONS(2824),
    [anon_sym_STAR_EQ] = ACTIONS(2824),
    [anon_sym_SLASH_EQ] = ACTIONS(2824),
    [anon_sym_AT_EQ] = ACTIONS(2824),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2824),
    [anon_sym_PERCENT_EQ] = ACTIONS(2824),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2824),
    [anon_sym_GT_GT_EQ] = ACTIONS(2824),
    [anon_sym_LT_LT_EQ] = ACTIONS(2824),
    [anon_sym_AMP_EQ] = ACTIONS(2824),
    [anon_sym_CARET_EQ] = ACTIONS(2824),
    [anon_sym_PIPE_EQ] = ACTIONS(2824),
    [anon_sym_LBRACK] = ACTIONS(2824),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2824),
  },
  [979] = {
    [sym__expression] = STATE(1373),
    [sym__primary_expression] = STATE(1374),
    [sym_not_operator] = STATE(1373),
    [sym_boolean_operator] = STATE(1373),
    [sym_binary_operator] = STATE(1374),
    [sym_unary_operator] = STATE(1374),
    [sym_comparison_operator] = STATE(1373),
    [sym_lambda] = STATE(1373),
    [sym_attribute] = STATE(1374),
    [sym_subscript] = STATE(1374),
    [sym_call] = STATE(1374),
    [sym_list] = STATE(1374),
    [sym_list_comprehension] = STATE(1374),
    [sym_dictionary] = STATE(1374),
    [sym_dictionary_comprehension] = STATE(1374),
    [sym_set] = STATE(1374),
    [sym_set_comprehension] = STATE(1374),
    [sym_parenthesized_expression] = STATE(1374),
    [sym_tuple] = STATE(1374),
    [sym_generator_expression] = STATE(1374),
    [sym_conditional_expression] = STATE(1373),
    [sym_concatenated_string] = STATE(1374),
    [sym_string] = STATE(1375),
    [sym_await] = STATE(1373),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2828),
    [anon_sym_PLUS] = ACTIONS(2830),
    [anon_sym_DASH] = ACTIONS(2830),
    [anon_sym_TILDE] = ACTIONS(2830),
    [anon_sym_lambda] = ACTIONS(2832),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2834),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2836),
    [sym_float] = ACTIONS(2836),
    [sym_identifier] = ACTIONS(2836),
    [sym_true] = ACTIONS(2836),
    [sym_false] = ACTIONS(2836),
    [sym_none] = ACTIONS(2836),
    [anon_sym_await] = ACTIONS(2838),
    [sym_comment] = ACTIONS(73),
  },
  [980] = {
    [sym_for_in_clause] = STATE(1376),
    [sym_if_clause] = STATE(1376),
    [aux_sym__comprehension_body_repeat1] = STATE(1376),
    [anon_sym_if] = ACTIONS(1830),
    [anon_sym_async] = ACTIONS(851),
    [anon_sym_for] = ACTIONS(853),
    [anon_sym_RBRACE] = ACTIONS(2210),
    [sym_comment] = ACTIONS(73),
  },
  [981] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1984),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1986),
    [anon_sym_PERCENT] = ACTIONS(1984),
    [anon_sym_SLASH_SLASH] = ACTIONS(1984),
    [anon_sym_STAR_STAR] = ACTIONS(871),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [982] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(865),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(869),
    [anon_sym_DASH] = ACTIONS(869),
    [anon_sym_SLASH] = ACTIONS(859),
    [anon_sym_PERCENT] = ACTIONS(865),
    [anon_sym_SLASH_SLASH] = ACTIONS(865),
    [anon_sym_STAR_STAR] = ACTIONS(871),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [983] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1988),
    [anon_sym_STAR] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_COLON] = ACTIONS(1988),
    [anon_sym_async] = ACTIONS(1988),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(1988),
    [anon_sym_AT] = ACTIONS(865),
    [anon_sym_not] = ACTIONS(1988),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_PLUS] = ACTIONS(869),
    [anon_sym_DASH] = ACTIONS(869),
    [anon_sym_SLASH] = ACTIONS(859),
    [anon_sym_PERCENT] = ACTIONS(865),
    [anon_sym_SLASH_SLASH] = ACTIONS(865),
    [anon_sym_STAR_STAR] = ACTIONS(871),
    [anon_sym_PIPE] = ACTIONS(873),
    [anon_sym_AMP] = ACTIONS(875),
    [anon_sym_CARET] = ACTIONS(877),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(1990),
    [anon_sym_LT_EQ] = ACTIONS(1988),
    [anon_sym_EQ_EQ] = ACTIONS(1988),
    [anon_sym_BANG_EQ] = ACTIONS(1988),
    [anon_sym_GT_EQ] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1990),
    [anon_sym_LT_GT] = ACTIONS(1988),
    [anon_sym_is] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(473),
    [anon_sym_RBRACE] = ACTIONS(1988),
    [sym_comment] = ACTIONS(73),
  },
  [984] = {
    [sym__primary_expression] = STATE(1377),
    [sym_binary_operator] = STATE(1377),
    [sym_unary_operator] = STATE(1377),
    [sym_attribute] = STATE(1377),
    [sym_subscript] = STATE(1377),
    [sym_call] = STATE(1377),
    [sym_list] = STATE(1377),
    [sym_list_comprehension] = STATE(1377),
    [sym_dictionary] = STATE(1377),
    [sym_dictionary_comprehension] = STATE(1377),
    [sym_set] = STATE(1377),
    [sym_set_comprehension] = STATE(1377),
    [sym_parenthesized_expression] = STATE(1377),
    [sym_tuple] = STATE(1377),
    [sym_generator_expression] = STATE(1377),
    [sym_concatenated_string] = STATE(1377),
    [sym_string] = STATE(166),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2840),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2842),
    [sym_float] = ACTIONS(2842),
    [sym_identifier] = ACTIONS(2842),
    [sym_true] = ACTIONS(2842),
    [sym_false] = ACTIONS(2842),
    [sym_none] = ACTIONS(2842),
    [sym_comment] = ACTIONS(73),
  },
  [985] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(865),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(859),
    [anon_sym_PERCENT] = ACTIONS(865),
    [anon_sym_SLASH_SLASH] = ACTIONS(865),
    [anon_sym_STAR_STAR] = ACTIONS(871),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [986] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(865),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(869),
    [anon_sym_DASH] = ACTIONS(869),
    [anon_sym_SLASH] = ACTIONS(859),
    [anon_sym_PERCENT] = ACTIONS(865),
    [anon_sym_SLASH_SLASH] = ACTIONS(865),
    [anon_sym_STAR_STAR] = ACTIONS(871),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(875),
    [anon_sym_CARET] = ACTIONS(877),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [987] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(865),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(869),
    [anon_sym_DASH] = ACTIONS(869),
    [anon_sym_SLASH] = ACTIONS(859),
    [anon_sym_PERCENT] = ACTIONS(865),
    [anon_sym_SLASH_SLASH] = ACTIONS(865),
    [anon_sym_STAR_STAR] = ACTIONS(871),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(877),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [988] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(865),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(869),
    [anon_sym_DASH] = ACTIONS(869),
    [anon_sym_SLASH] = ACTIONS(859),
    [anon_sym_PERCENT] = ACTIONS(865),
    [anon_sym_SLASH_SLASH] = ACTIONS(865),
    [anon_sym_STAR_STAR] = ACTIONS(871),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [989] = {
    [aux_sym_comparison_operator_repeat1] = STATE(989),
    [anon_sym_COMMA] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_COLON] = ACTIONS(1988),
    [anon_sym_async] = ACTIONS(1988),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(2844),
    [anon_sym_not] = ACTIONS(2847),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(2850),
    [anon_sym_LT_EQ] = ACTIONS(2844),
    [anon_sym_EQ_EQ] = ACTIONS(2844),
    [anon_sym_BANG_EQ] = ACTIONS(2844),
    [anon_sym_GT_EQ] = ACTIONS(2844),
    [anon_sym_GT] = ACTIONS(2850),
    [anon_sym_LT_GT] = ACTIONS(2844),
    [anon_sym_is] = ACTIONS(2853),
    [anon_sym_RBRACE] = ACTIONS(1988),
    [sym_comment] = ACTIONS(73),
  },
  [990] = {
    [sym__newline] = ACTIONS(2856),
    [anon_sym_DOT] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(2856),
    [anon_sym_STAR] = ACTIONS(2858),
    [anon_sym_GT_GT] = ACTIONS(2858),
    [anon_sym_if] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2856),
    [anon_sym_in] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(2858),
    [anon_sym_AT] = ACTIONS(2858),
    [anon_sym_not] = ACTIONS(2856),
    [anon_sym_and] = ACTIONS(2856),
    [anon_sym_or] = ACTIONS(2856),
    [anon_sym_PLUS] = ACTIONS(2858),
    [anon_sym_DASH] = ACTIONS(2858),
    [anon_sym_SLASH] = ACTIONS(2858),
    [anon_sym_PERCENT] = ACTIONS(2858),
    [anon_sym_SLASH_SLASH] = ACTIONS(2858),
    [anon_sym_STAR_STAR] = ACTIONS(2858),
    [anon_sym_PIPE] = ACTIONS(2858),
    [anon_sym_AMP] = ACTIONS(2858),
    [anon_sym_CARET] = ACTIONS(2858),
    [anon_sym_LT_LT] = ACTIONS(2858),
    [anon_sym_LT] = ACTIONS(2858),
    [anon_sym_LT_EQ] = ACTIONS(2856),
    [anon_sym_EQ_EQ] = ACTIONS(2856),
    [anon_sym_BANG_EQ] = ACTIONS(2856),
    [anon_sym_GT_EQ] = ACTIONS(2856),
    [anon_sym_GT] = ACTIONS(2858),
    [anon_sym_LT_GT] = ACTIONS(2856),
    [anon_sym_is] = ACTIONS(2856),
    [anon_sym_PLUS_EQ] = ACTIONS(2856),
    [anon_sym_DASH_EQ] = ACTIONS(2856),
    [anon_sym_STAR_EQ] = ACTIONS(2856),
    [anon_sym_SLASH_EQ] = ACTIONS(2856),
    [anon_sym_AT_EQ] = ACTIONS(2856),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2856),
    [anon_sym_PERCENT_EQ] = ACTIONS(2856),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2856),
    [anon_sym_GT_GT_EQ] = ACTIONS(2856),
    [anon_sym_LT_LT_EQ] = ACTIONS(2856),
    [anon_sym_AMP_EQ] = ACTIONS(2856),
    [anon_sym_CARET_EQ] = ACTIONS(2856),
    [anon_sym_PIPE_EQ] = ACTIONS(2856),
    [anon_sym_LBRACK] = ACTIONS(2856),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2856),
  },
  [991] = {
    [sym_string] = STATE(991),
    [aux_sym_concatenated_string_repeat1] = STATE(991),
    [sym__string_start] = ACTIONS(2241),
    [anon_sym_DOT] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(2050),
    [anon_sym_COMMA] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2050),
    [anon_sym_if] = ACTIONS(2050),
    [anon_sym_COLON] = ACTIONS(2050),
    [anon_sym_async] = ACTIONS(2050),
    [anon_sym_for] = ACTIONS(2050),
    [anon_sym_in] = ACTIONS(2050),
    [anon_sym_AT] = ACTIONS(2050),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_and] = ACTIONS(2050),
    [anon_sym_or] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_SLASH] = ACTIONS(2055),
    [anon_sym_PERCENT] = ACTIONS(2050),
    [anon_sym_SLASH_SLASH] = ACTIONS(2050),
    [anon_sym_STAR_STAR] = ACTIONS(2050),
    [anon_sym_PIPE] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2050),
    [anon_sym_CARET] = ACTIONS(2050),
    [anon_sym_LT_LT] = ACTIONS(2050),
    [anon_sym_LT] = ACTIONS(2055),
    [anon_sym_LT_EQ] = ACTIONS(2050),
    [anon_sym_EQ_EQ] = ACTIONS(2050),
    [anon_sym_BANG_EQ] = ACTIONS(2050),
    [anon_sym_GT_EQ] = ACTIONS(2050),
    [anon_sym_GT] = ACTIONS(2055),
    [anon_sym_LT_GT] = ACTIONS(2050),
    [anon_sym_is] = ACTIONS(2050),
    [anon_sym_LBRACK] = ACTIONS(2050),
    [anon_sym_RBRACE] = ACTIONS(2050),
    [sym_comment] = ACTIONS(73),
  },
  [992] = {
    [sym__string_start] = ACTIONS(2860),
    [ts_builtin_sym_end] = ACTIONS(2860),
    [anon_sym_import] = ACTIONS(2862),
    [anon_sym_from] = ACTIONS(2862),
    [anon_sym_LPAREN] = ACTIONS(2860),
    [anon_sym_print] = ACTIONS(2862),
    [anon_sym_assert] = ACTIONS(2862),
    [anon_sym_return] = ACTIONS(2862),
    [anon_sym_del] = ACTIONS(2862),
    [anon_sym_raise] = ACTIONS(2862),
    [anon_sym_pass] = ACTIONS(2862),
    [anon_sym_break] = ACTIONS(2862),
    [anon_sym_continue] = ACTIONS(2862),
    [anon_sym_if] = ACTIONS(2862),
    [anon_sym_elif] = ACTIONS(2862),
    [anon_sym_else] = ACTIONS(2862),
    [anon_sym_async] = ACTIONS(2862),
    [anon_sym_for] = ACTIONS(2862),
    [anon_sym_while] = ACTIONS(2862),
    [anon_sym_try] = ACTIONS(2862),
    [anon_sym_except] = ACTIONS(2862),
    [anon_sym_finally] = ACTIONS(2862),
    [anon_sym_with] = ACTIONS(2862),
    [anon_sym_def] = ACTIONS(2862),
    [anon_sym_global] = ACTIONS(2862),
    [anon_sym_nonlocal] = ACTIONS(2862),
    [anon_sym_exec] = ACTIONS(2862),
    [anon_sym_class] = ACTIONS(2862),
    [anon_sym_AT] = ACTIONS(2860),
    [anon_sym_not] = ACTIONS(2862),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_TILDE] = ACTIONS(2860),
    [anon_sym_lambda] = ACTIONS(2862),
    [anon_sym_yield] = ACTIONS(2862),
    [anon_sym_LBRACK] = ACTIONS(2860),
    [sym_ellipsis] = ACTIONS(2860),
    [anon_sym_LBRACE] = ACTIONS(2860),
    [sym_integer] = ACTIONS(2862),
    [sym_float] = ACTIONS(2862),
    [sym_identifier] = ACTIONS(2862),
    [sym_true] = ACTIONS(2862),
    [sym_false] = ACTIONS(2862),
    [sym_none] = ACTIONS(2862),
    [anon_sym_await] = ACTIONS(2862),
    [sym_comment] = ACTIONS(73),
  },
  [993] = {
    [sym_import_statement] = STATE(517),
    [sym_future_import_statement] = STATE(517),
    [sym_import_from_statement] = STATE(517),
    [sym_print_statement] = STATE(517),
    [sym_assert_statement] = STATE(517),
    [sym_expression_statement] = STATE(517),
    [sym_return_statement] = STATE(517),
    [sym_delete_statement] = STATE(517),
    [sym_raise_statement] = STATE(517),
    [sym_pass_statement] = STATE(517),
    [sym_break_statement] = STATE(517),
    [sym_continue_statement] = STATE(517),
    [sym_global_statement] = STATE(517),
    [sym_nonlocal_statement] = STATE(517),
    [sym_exec_statement] = STATE(517),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [994] = {
    [sym__newline] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(723),
    [anon_sym_EQ] = ACTIONS(723),
    [anon_sym_and] = ACTIONS(1883),
    [anon_sym_or] = ACTIONS(1885),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(723),
  },
  [995] = {
    [sym__expression] = STATE(1378),
    [sym__primary_expression] = STATE(525),
    [sym_not_operator] = STATE(1378),
    [sym_boolean_operator] = STATE(1378),
    [sym_binary_operator] = STATE(525),
    [sym_unary_operator] = STATE(525),
    [sym_comparison_operator] = STATE(1378),
    [sym_lambda] = STATE(1378),
    [sym_attribute] = STATE(525),
    [sym_subscript] = STATE(525),
    [sym_call] = STATE(525),
    [sym_list] = STATE(525),
    [sym_list_comprehension] = STATE(525),
    [sym_dictionary] = STATE(525),
    [sym_dictionary_comprehension] = STATE(525),
    [sym_set] = STATE(525),
    [sym_set_comprehension] = STATE(525),
    [sym_parenthesized_expression] = STATE(525),
    [sym_tuple] = STATE(525),
    [sym_generator_expression] = STATE(525),
    [sym_conditional_expression] = STATE(1378),
    [sym_concatenated_string] = STATE(525),
    [sym_string] = STATE(527),
    [sym_await] = STATE(1378),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(893),
    [anon_sym_PLUS] = ACTIONS(895),
    [anon_sym_DASH] = ACTIONS(895),
    [anon_sym_TILDE] = ACTIONS(895),
    [anon_sym_lambda] = ACTIONS(897),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(901),
    [sym_float] = ACTIONS(901),
    [sym_identifier] = ACTIONS(901),
    [sym_true] = ACTIONS(901),
    [sym_false] = ACTIONS(901),
    [sym_none] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(903),
    [sym_comment] = ACTIONS(73),
  },
  [996] = {
    [anon_sym_COLON] = ACTIONS(2864),
    [sym_comment] = ACTIONS(73),
  },
  [997] = {
    [sym__expression] = STATE(1380),
    [sym__primary_expression] = STATE(538),
    [sym_not_operator] = STATE(1380),
    [sym_boolean_operator] = STATE(1380),
    [sym_binary_operator] = STATE(538),
    [sym_unary_operator] = STATE(538),
    [sym_comparison_operator] = STATE(1380),
    [sym_lambda] = STATE(1380),
    [sym_attribute] = STATE(538),
    [sym_subscript] = STATE(538),
    [sym_call] = STATE(538),
    [sym_list] = STATE(538),
    [sym_list_comprehension] = STATE(538),
    [sym_dictionary] = STATE(538),
    [sym_dictionary_comprehension] = STATE(538),
    [sym_set] = STATE(538),
    [sym_set_comprehension] = STATE(538),
    [sym_parenthesized_expression] = STATE(538),
    [sym_tuple] = STATE(538),
    [sym_generator_expression] = STATE(538),
    [sym_conditional_expression] = STATE(1380),
    [sym_concatenated_string] = STATE(538),
    [sym_string] = STATE(539),
    [sym_await] = STATE(1380),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_lambda] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(917),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(919),
    [sym_float] = ACTIONS(919),
    [sym_identifier] = ACTIONS(919),
    [sym_true] = ACTIONS(919),
    [sym_false] = ACTIONS(919),
    [sym_none] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(921),
    [sym_comment] = ACTIONS(73),
  },
  [998] = {
    [sym__expression] = STATE(540),
    [sym__primary_expression] = STATE(525),
    [sym_not_operator] = STATE(540),
    [sym_boolean_operator] = STATE(540),
    [sym_binary_operator] = STATE(525),
    [sym_unary_operator] = STATE(525),
    [sym_comparison_operator] = STATE(540),
    [sym_lambda] = STATE(540),
    [sym_attribute] = STATE(525),
    [sym_subscript] = STATE(525),
    [sym_call] = STATE(525),
    [sym_list] = STATE(525),
    [sym_list_comprehension] = STATE(525),
    [sym_dictionary] = STATE(525),
    [sym_dictionary_comprehension] = STATE(525),
    [sym_set] = STATE(525),
    [sym_set_comprehension] = STATE(525),
    [sym_parenthesized_expression] = STATE(525),
    [sym_tuple] = STATE(525),
    [sym_generator_expression] = STATE(525),
    [sym_conditional_expression] = STATE(540),
    [sym_concatenated_string] = STATE(525),
    [sym_string] = STATE(527),
    [sym_await] = STATE(540),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(893),
    [anon_sym_PLUS] = ACTIONS(895),
    [anon_sym_DASH] = ACTIONS(895),
    [anon_sym_TILDE] = ACTIONS(895),
    [anon_sym_lambda] = ACTIONS(897),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(901),
    [sym_float] = ACTIONS(901),
    [sym_identifier] = ACTIONS(901),
    [sym_true] = ACTIONS(901),
    [sym_false] = ACTIONS(901),
    [sym_none] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(903),
    [sym_comment] = ACTIONS(73),
  },
  [999] = {
    [sym__expression] = STATE(1381),
    [sym__primary_expression] = STATE(525),
    [sym_not_operator] = STATE(1381),
    [sym_boolean_operator] = STATE(1381),
    [sym_binary_operator] = STATE(525),
    [sym_unary_operator] = STATE(525),
    [sym_comparison_operator] = STATE(1381),
    [sym_lambda] = STATE(1381),
    [sym_attribute] = STATE(525),
    [sym_subscript] = STATE(525),
    [sym_call] = STATE(525),
    [sym_list] = STATE(525),
    [sym_list_comprehension] = STATE(525),
    [sym_dictionary] = STATE(525),
    [sym_dictionary_comprehension] = STATE(525),
    [sym_set] = STATE(525),
    [sym_set_comprehension] = STATE(525),
    [sym_parenthesized_expression] = STATE(525),
    [sym_tuple] = STATE(525),
    [sym_generator_expression] = STATE(525),
    [sym_conditional_expression] = STATE(1381),
    [sym_concatenated_string] = STATE(525),
    [sym_string] = STATE(527),
    [sym_await] = STATE(1381),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(893),
    [anon_sym_PLUS] = ACTIONS(895),
    [anon_sym_DASH] = ACTIONS(895),
    [anon_sym_TILDE] = ACTIONS(895),
    [anon_sym_lambda] = ACTIONS(897),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(901),
    [sym_float] = ACTIONS(901),
    [sym_identifier] = ACTIONS(901),
    [sym_true] = ACTIONS(901),
    [sym_false] = ACTIONS(901),
    [sym_none] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(903),
    [sym_comment] = ACTIONS(73),
  },
  [1000] = {
    [sym__primary_expression] = STATE(1382),
    [sym_binary_operator] = STATE(1382),
    [sym_unary_operator] = STATE(1382),
    [sym_attribute] = STATE(1382),
    [sym_subscript] = STATE(1382),
    [sym_call] = STATE(1382),
    [sym_list] = STATE(1382),
    [sym_list_comprehension] = STATE(1382),
    [sym_dictionary] = STATE(1382),
    [sym_dictionary_comprehension] = STATE(1382),
    [sym_set] = STATE(1382),
    [sym_set_comprehension] = STATE(1382),
    [sym_parenthesized_expression] = STATE(1382),
    [sym_tuple] = STATE(1382),
    [sym_generator_expression] = STATE(1382),
    [sym_concatenated_string] = STATE(1382),
    [sym_string] = STATE(527),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(895),
    [anon_sym_DASH] = ACTIONS(895),
    [anon_sym_TILDE] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(2866),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(2868),
    [sym_float] = ACTIONS(2868),
    [sym_identifier] = ACTIONS(2868),
    [sym_true] = ACTIONS(2868),
    [sym_false] = ACTIONS(2868),
    [sym_none] = ACTIONS(2868),
    [sym_comment] = ACTIONS(73),
  },
  [1001] = {
    [sym__primary_expression] = STATE(1383),
    [sym_binary_operator] = STATE(1383),
    [sym_unary_operator] = STATE(1383),
    [sym_attribute] = STATE(1383),
    [sym_subscript] = STATE(1383),
    [sym_call] = STATE(1383),
    [sym_list] = STATE(1383),
    [sym_list_comprehension] = STATE(1383),
    [sym_dictionary] = STATE(1383),
    [sym_dictionary_comprehension] = STATE(1383),
    [sym_set] = STATE(1383),
    [sym_set_comprehension] = STATE(1383),
    [sym_parenthesized_expression] = STATE(1383),
    [sym_tuple] = STATE(1383),
    [sym_generator_expression] = STATE(1383),
    [sym_concatenated_string] = STATE(1383),
    [sym_string] = STATE(527),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(895),
    [anon_sym_DASH] = ACTIONS(895),
    [anon_sym_TILDE] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(2870),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(2872),
    [sym_float] = ACTIONS(2872),
    [sym_identifier] = ACTIONS(2872),
    [sym_true] = ACTIONS(2872),
    [sym_false] = ACTIONS(2872),
    [sym_none] = ACTIONS(2872),
    [sym_comment] = ACTIONS(73),
  },
  [1002] = {
    [sym__primary_expression] = STATE(1384),
    [sym_binary_operator] = STATE(1384),
    [sym_unary_operator] = STATE(1384),
    [sym_attribute] = STATE(1384),
    [sym_subscript] = STATE(1384),
    [sym_call] = STATE(1384),
    [sym_list] = STATE(1384),
    [sym_list_comprehension] = STATE(1384),
    [sym_dictionary] = STATE(1384),
    [sym_dictionary_comprehension] = STATE(1384),
    [sym_set] = STATE(1384),
    [sym_set_comprehension] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple] = STATE(1384),
    [sym_generator_expression] = STATE(1384),
    [sym_concatenated_string] = STATE(1384),
    [sym_string] = STATE(527),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(895),
    [anon_sym_DASH] = ACTIONS(895),
    [anon_sym_TILDE] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(2874),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2876),
    [sym_identifier] = ACTIONS(2876),
    [sym_true] = ACTIONS(2876),
    [sym_false] = ACTIONS(2876),
    [sym_none] = ACTIONS(2876),
    [sym_comment] = ACTIONS(73),
  },
  [1003] = {
    [anon_sym_in] = ACTIONS(2878),
    [sym_comment] = ACTIONS(73),
  },
  [1004] = {
    [sym__primary_expression] = STATE(1386),
    [sym_binary_operator] = STATE(1386),
    [sym_unary_operator] = STATE(1386),
    [sym_attribute] = STATE(1386),
    [sym_subscript] = STATE(1386),
    [sym_call] = STATE(1386),
    [sym_list] = STATE(1386),
    [sym_list_comprehension] = STATE(1386),
    [sym_dictionary] = STATE(1386),
    [sym_dictionary_comprehension] = STATE(1386),
    [sym_set] = STATE(1386),
    [sym_set_comprehension] = STATE(1386),
    [sym_parenthesized_expression] = STATE(1386),
    [sym_tuple] = STATE(1386),
    [sym_generator_expression] = STATE(1386),
    [sym_concatenated_string] = STATE(1386),
    [sym_string] = STATE(527),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(895),
    [anon_sym_DASH] = ACTIONS(895),
    [anon_sym_TILDE] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(2880),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(2882),
    [sym_float] = ACTIONS(2882),
    [sym_identifier] = ACTIONS(2882),
    [sym_true] = ACTIONS(2882),
    [sym_false] = ACTIONS(2882),
    [sym_none] = ACTIONS(2882),
    [sym_comment] = ACTIONS(73),
  },
  [1005] = {
    [sym__primary_expression] = STATE(712),
    [sym_binary_operator] = STATE(712),
    [sym_unary_operator] = STATE(712),
    [sym_attribute] = STATE(712),
    [sym_subscript] = STATE(712),
    [sym_call] = STATE(712),
    [sym_list] = STATE(712),
    [sym_list_comprehension] = STATE(712),
    [sym_dictionary] = STATE(712),
    [sym_dictionary_comprehension] = STATE(712),
    [sym_set] = STATE(712),
    [sym_set_comprehension] = STATE(712),
    [sym_parenthesized_expression] = STATE(712),
    [sym_tuple] = STATE(712),
    [sym_generator_expression] = STATE(712),
    [sym_concatenated_string] = STATE(712),
    [sym_string] = STATE(527),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(895),
    [anon_sym_DASH] = ACTIONS(895),
    [anon_sym_TILDE] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(1352),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(1354),
    [sym_float] = ACTIONS(1354),
    [sym_identifier] = ACTIONS(1354),
    [sym_true] = ACTIONS(1354),
    [sym_false] = ACTIONS(1354),
    [sym_none] = ACTIONS(1354),
    [sym_comment] = ACTIONS(73),
  },
  [1006] = {
    [sym__primary_expression] = STATE(1387),
    [sym_binary_operator] = STATE(1387),
    [sym_unary_operator] = STATE(1387),
    [sym_attribute] = STATE(1387),
    [sym_subscript] = STATE(1387),
    [sym_call] = STATE(1387),
    [sym_list] = STATE(1387),
    [sym_list_comprehension] = STATE(1387),
    [sym_dictionary] = STATE(1387),
    [sym_dictionary_comprehension] = STATE(1387),
    [sym_set] = STATE(1387),
    [sym_set_comprehension] = STATE(1387),
    [sym_parenthesized_expression] = STATE(1387),
    [sym_tuple] = STATE(1387),
    [sym_generator_expression] = STATE(1387),
    [sym_concatenated_string] = STATE(1387),
    [sym_string] = STATE(527),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(895),
    [anon_sym_DASH] = ACTIONS(895),
    [anon_sym_TILDE] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(2884),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(2886),
    [sym_float] = ACTIONS(2886),
    [sym_identifier] = ACTIONS(2886),
    [sym_true] = ACTIONS(2886),
    [sym_false] = ACTIONS(2886),
    [sym_none] = ACTIONS(2886),
    [sym_comment] = ACTIONS(73),
  },
  [1007] = {
    [sym__primary_expression] = STATE(1388),
    [sym_binary_operator] = STATE(1388),
    [sym_unary_operator] = STATE(1388),
    [sym_attribute] = STATE(1388),
    [sym_subscript] = STATE(1388),
    [sym_call] = STATE(1388),
    [sym_list] = STATE(1388),
    [sym_list_comprehension] = STATE(1388),
    [sym_dictionary] = STATE(1388),
    [sym_dictionary_comprehension] = STATE(1388),
    [sym_set] = STATE(1388),
    [sym_set_comprehension] = STATE(1388),
    [sym_parenthesized_expression] = STATE(1388),
    [sym_tuple] = STATE(1388),
    [sym_generator_expression] = STATE(1388),
    [sym_concatenated_string] = STATE(1388),
    [sym_string] = STATE(527),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(895),
    [anon_sym_DASH] = ACTIONS(895),
    [anon_sym_TILDE] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(2888),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(2890),
    [sym_float] = ACTIONS(2890),
    [sym_identifier] = ACTIONS(2890),
    [sym_true] = ACTIONS(2890),
    [sym_false] = ACTIONS(2890),
    [sym_none] = ACTIONS(2890),
    [sym_comment] = ACTIONS(73),
  },
  [1008] = {
    [sym__primary_expression] = STATE(1389),
    [sym_binary_operator] = STATE(1389),
    [sym_unary_operator] = STATE(1389),
    [sym_attribute] = STATE(1389),
    [sym_subscript] = STATE(1389),
    [sym_call] = STATE(1389),
    [sym_list] = STATE(1389),
    [sym_list_comprehension] = STATE(1389),
    [sym_dictionary] = STATE(1389),
    [sym_dictionary_comprehension] = STATE(1389),
    [sym_set] = STATE(1389),
    [sym_set_comprehension] = STATE(1389),
    [sym_parenthesized_expression] = STATE(1389),
    [sym_tuple] = STATE(1389),
    [sym_generator_expression] = STATE(1389),
    [sym_concatenated_string] = STATE(1389),
    [sym_string] = STATE(527),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(895),
    [anon_sym_DASH] = ACTIONS(895),
    [anon_sym_TILDE] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(2892),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(2894),
    [sym_float] = ACTIONS(2894),
    [sym_identifier] = ACTIONS(2894),
    [sym_true] = ACTIONS(2894),
    [sym_false] = ACTIONS(2894),
    [sym_none] = ACTIONS(2894),
    [sym_comment] = ACTIONS(73),
  },
  [1009] = {
    [sym__primary_expression] = STATE(1384),
    [sym_binary_operator] = STATE(1384),
    [sym_unary_operator] = STATE(1384),
    [sym_attribute] = STATE(1384),
    [sym_subscript] = STATE(1384),
    [sym_call] = STATE(1384),
    [sym_list] = STATE(1384),
    [sym_list_comprehension] = STATE(1384),
    [sym_dictionary] = STATE(1384),
    [sym_dictionary_comprehension] = STATE(1384),
    [sym_set] = STATE(1384),
    [sym_set_comprehension] = STATE(1384),
    [sym_parenthesized_expression] = STATE(1384),
    [sym_tuple] = STATE(1384),
    [sym_generator_expression] = STATE(1384),
    [sym_concatenated_string] = STATE(1384),
    [sym_string] = STATE(527),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(2896),
    [anon_sym_PLUS] = ACTIONS(895),
    [anon_sym_DASH] = ACTIONS(895),
    [anon_sym_TILDE] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(2874),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(2876),
    [sym_float] = ACTIONS(2876),
    [sym_identifier] = ACTIONS(2876),
    [sym_true] = ACTIONS(2876),
    [sym_false] = ACTIONS(2876),
    [sym_none] = ACTIONS(2876),
    [sym_comment] = ACTIONS(73),
  },
  [1010] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1390),
    [sym__newline] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(1891),
    [anon_sym_EQ] = ACTIONS(993),
    [anon_sym_not] = ACTIONS(1895),
    [anon_sym_and] = ACTIONS(991),
    [anon_sym_or] = ACTIONS(991),
    [anon_sym_LT] = ACTIONS(1907),
    [anon_sym_LT_EQ] = ACTIONS(1891),
    [anon_sym_EQ_EQ] = ACTIONS(1891),
    [anon_sym_BANG_EQ] = ACTIONS(1891),
    [anon_sym_GT_EQ] = ACTIONS(1891),
    [anon_sym_GT] = ACTIONS(1907),
    [anon_sym_LT_GT] = ACTIONS(1891),
    [anon_sym_is] = ACTIONS(1909),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(991),
  },
  [1011] = {
    [sym_expression_list] = STATE(528),
    [sym__expression] = STATE(529),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(529),
    [sym_boolean_operator] = STATE(529),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(529),
    [sym_lambda] = STATE(529),
    [sym_assignment] = STATE(1391),
    [sym_augmented_assignment] = STATE(1391),
    [sym__right_hand_side] = STATE(1391),
    [sym_yield] = STATE(1391),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(529),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(529),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1012] = {
    [sym_string] = STATE(1392),
    [aux_sym_concatenated_string_repeat1] = STATE(1392),
    [sym__newline] = ACTIONS(995),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_in] = ACTIONS(995),
    [anon_sym_EQ] = ACTIONS(997),
    [anon_sym_AT] = ACTIONS(995),
    [anon_sym_not] = ACTIONS(995),
    [anon_sym_and] = ACTIONS(995),
    [anon_sym_or] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(995),
    [anon_sym_SLASH_SLASH] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_GT] = ACTIONS(995),
    [anon_sym_is] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(995),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(995),
  },
  [1013] = {
    [sym__expression] = STATE(532),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(532),
    [sym_boolean_operator] = STATE(532),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(532),
    [sym_lambda] = STATE(532),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(532),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(532),
    [sym__newline] = ACTIONS(907),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_COLON] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(907),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_PLUS_EQ] = ACTIONS(907),
    [anon_sym_DASH_EQ] = ACTIONS(907),
    [anon_sym_STAR_EQ] = ACTIONS(907),
    [anon_sym_SLASH_EQ] = ACTIONS(907),
    [anon_sym_AT_EQ] = ACTIONS(907),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(907),
    [anon_sym_PERCENT_EQ] = ACTIONS(907),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(907),
    [anon_sym_GT_GT_EQ] = ACTIONS(907),
    [anon_sym_LT_LT_EQ] = ACTIONS(907),
    [anon_sym_AMP_EQ] = ACTIONS(907),
    [anon_sym_CARET_EQ] = ACTIONS(907),
    [anon_sym_PIPE_EQ] = ACTIONS(907),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(907),
  },
  [1014] = {
    [aux_sym_print_statement_repeat1] = STATE(543),
    [sym__newline] = ACTIONS(907),
    [anon_sym_COMMA] = ACTIONS(2898),
    [anon_sym_COLON] = ACTIONS(907),
    [anon_sym_EQ] = ACTIONS(907),
    [anon_sym_PLUS_EQ] = ACTIONS(907),
    [anon_sym_DASH_EQ] = ACTIONS(907),
    [anon_sym_STAR_EQ] = ACTIONS(907),
    [anon_sym_SLASH_EQ] = ACTIONS(907),
    [anon_sym_AT_EQ] = ACTIONS(907),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(907),
    [anon_sym_PERCENT_EQ] = ACTIONS(907),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(907),
    [anon_sym_GT_GT_EQ] = ACTIONS(907),
    [anon_sym_LT_LT_EQ] = ACTIONS(907),
    [anon_sym_AMP_EQ] = ACTIONS(907),
    [anon_sym_CARET_EQ] = ACTIONS(907),
    [anon_sym_PIPE_EQ] = ACTIONS(907),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(907),
  },
  [1015] = {
    [anon_sym_if] = ACTIONS(723),
    [anon_sym_else] = ACTIONS(723),
    [anon_sym_and] = ACTIONS(1929),
    [anon_sym_or] = ACTIONS(1931),
    [sym_comment] = ACTIONS(73),
  },
  [1016] = {
    [sym__expression] = STATE(1394),
    [sym__primary_expression] = STATE(538),
    [sym_not_operator] = STATE(1394),
    [sym_boolean_operator] = STATE(1394),
    [sym_binary_operator] = STATE(538),
    [sym_unary_operator] = STATE(538),
    [sym_comparison_operator] = STATE(1394),
    [sym_lambda] = STATE(1394),
    [sym_attribute] = STATE(538),
    [sym_subscript] = STATE(538),
    [sym_call] = STATE(538),
    [sym_list] = STATE(538),
    [sym_list_comprehension] = STATE(538),
    [sym_dictionary] = STATE(538),
    [sym_dictionary_comprehension] = STATE(538),
    [sym_set] = STATE(538),
    [sym_set_comprehension] = STATE(538),
    [sym_parenthesized_expression] = STATE(538),
    [sym_tuple] = STATE(538),
    [sym_generator_expression] = STATE(538),
    [sym_conditional_expression] = STATE(1394),
    [sym_concatenated_string] = STATE(538),
    [sym_string] = STATE(539),
    [sym_await] = STATE(1394),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_lambda] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(917),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(919),
    [sym_float] = ACTIONS(919),
    [sym_identifier] = ACTIONS(919),
    [sym_true] = ACTIONS(919),
    [sym_false] = ACTIONS(919),
    [sym_none] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(921),
    [sym_comment] = ACTIONS(73),
  },
  [1017] = {
    [anon_sym_COLON] = ACTIONS(2900),
    [sym_comment] = ACTIONS(73),
  },
  [1018] = {
    [sym__expression] = STATE(1396),
    [sym__primary_expression] = STATE(538),
    [sym_not_operator] = STATE(1396),
    [sym_boolean_operator] = STATE(1396),
    [sym_binary_operator] = STATE(538),
    [sym_unary_operator] = STATE(538),
    [sym_comparison_operator] = STATE(1396),
    [sym_lambda] = STATE(1396),
    [sym_attribute] = STATE(538),
    [sym_subscript] = STATE(538),
    [sym_call] = STATE(538),
    [sym_list] = STATE(538),
    [sym_list_comprehension] = STATE(538),
    [sym_dictionary] = STATE(538),
    [sym_dictionary_comprehension] = STATE(538),
    [sym_set] = STATE(538),
    [sym_set_comprehension] = STATE(538),
    [sym_parenthesized_expression] = STATE(538),
    [sym_tuple] = STATE(538),
    [sym_generator_expression] = STATE(538),
    [sym_conditional_expression] = STATE(1396),
    [sym_concatenated_string] = STATE(538),
    [sym_string] = STATE(539),
    [sym_await] = STATE(1396),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_lambda] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(917),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(919),
    [sym_float] = ACTIONS(919),
    [sym_identifier] = ACTIONS(919),
    [sym_true] = ACTIONS(919),
    [sym_false] = ACTIONS(919),
    [sym_none] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(921),
    [sym_comment] = ACTIONS(73),
  },
  [1019] = {
    [sym__expression] = STATE(1397),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(1397),
    [sym_boolean_operator] = STATE(1397),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(1397),
    [sym_lambda] = STATE(1397),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(1397),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(1397),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1020] = {
    [sym__expression] = STATE(652),
    [sym__primary_expression] = STATE(538),
    [sym_not_operator] = STATE(652),
    [sym_boolean_operator] = STATE(652),
    [sym_binary_operator] = STATE(538),
    [sym_unary_operator] = STATE(538),
    [sym_comparison_operator] = STATE(652),
    [sym_lambda] = STATE(652),
    [sym_attribute] = STATE(538),
    [sym_subscript] = STATE(538),
    [sym_call] = STATE(538),
    [sym_list] = STATE(538),
    [sym_list_comprehension] = STATE(538),
    [sym_dictionary] = STATE(538),
    [sym_dictionary_comprehension] = STATE(538),
    [sym_set] = STATE(538),
    [sym_set_comprehension] = STATE(538),
    [sym_parenthesized_expression] = STATE(538),
    [sym_tuple] = STATE(538),
    [sym_generator_expression] = STATE(538),
    [sym_conditional_expression] = STATE(652),
    [sym_concatenated_string] = STATE(538),
    [sym_string] = STATE(539),
    [sym_await] = STATE(652),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_lambda] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(917),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(919),
    [sym_float] = ACTIONS(919),
    [sym_identifier] = ACTIONS(919),
    [sym_true] = ACTIONS(919),
    [sym_false] = ACTIONS(919),
    [sym_none] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(921),
    [sym_comment] = ACTIONS(73),
  },
  [1021] = {
    [sym__expression] = STATE(1398),
    [sym__primary_expression] = STATE(538),
    [sym_not_operator] = STATE(1398),
    [sym_boolean_operator] = STATE(1398),
    [sym_binary_operator] = STATE(538),
    [sym_unary_operator] = STATE(538),
    [sym_comparison_operator] = STATE(1398),
    [sym_lambda] = STATE(1398),
    [sym_attribute] = STATE(538),
    [sym_subscript] = STATE(538),
    [sym_call] = STATE(538),
    [sym_list] = STATE(538),
    [sym_list_comprehension] = STATE(538),
    [sym_dictionary] = STATE(538),
    [sym_dictionary_comprehension] = STATE(538),
    [sym_set] = STATE(538),
    [sym_set_comprehension] = STATE(538),
    [sym_parenthesized_expression] = STATE(538),
    [sym_tuple] = STATE(538),
    [sym_generator_expression] = STATE(538),
    [sym_conditional_expression] = STATE(1398),
    [sym_concatenated_string] = STATE(538),
    [sym_string] = STATE(539),
    [sym_await] = STATE(1398),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_lambda] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(917),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(919),
    [sym_float] = ACTIONS(919),
    [sym_identifier] = ACTIONS(919),
    [sym_true] = ACTIONS(919),
    [sym_false] = ACTIONS(919),
    [sym_none] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(921),
    [sym_comment] = ACTIONS(73),
  },
  [1022] = {
    [sym__primary_expression] = STATE(1399),
    [sym_binary_operator] = STATE(1399),
    [sym_unary_operator] = STATE(1399),
    [sym_attribute] = STATE(1399),
    [sym_subscript] = STATE(1399),
    [sym_call] = STATE(1399),
    [sym_list] = STATE(1399),
    [sym_list_comprehension] = STATE(1399),
    [sym_dictionary] = STATE(1399),
    [sym_dictionary_comprehension] = STATE(1399),
    [sym_set] = STATE(1399),
    [sym_set_comprehension] = STATE(1399),
    [sym_parenthesized_expression] = STATE(1399),
    [sym_tuple] = STATE(1399),
    [sym_generator_expression] = STATE(1399),
    [sym_concatenated_string] = STATE(1399),
    [sym_string] = STATE(539),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2902),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2904),
    [sym_float] = ACTIONS(2904),
    [sym_identifier] = ACTIONS(2904),
    [sym_true] = ACTIONS(2904),
    [sym_false] = ACTIONS(2904),
    [sym_none] = ACTIONS(2904),
    [sym_comment] = ACTIONS(73),
  },
  [1023] = {
    [sym__primary_expression] = STATE(1400),
    [sym_binary_operator] = STATE(1400),
    [sym_unary_operator] = STATE(1400),
    [sym_attribute] = STATE(1400),
    [sym_subscript] = STATE(1400),
    [sym_call] = STATE(1400),
    [sym_list] = STATE(1400),
    [sym_list_comprehension] = STATE(1400),
    [sym_dictionary] = STATE(1400),
    [sym_dictionary_comprehension] = STATE(1400),
    [sym_set] = STATE(1400),
    [sym_set_comprehension] = STATE(1400),
    [sym_parenthesized_expression] = STATE(1400),
    [sym_tuple] = STATE(1400),
    [sym_generator_expression] = STATE(1400),
    [sym_concatenated_string] = STATE(1400),
    [sym_string] = STATE(539),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2906),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2908),
    [sym_float] = ACTIONS(2908),
    [sym_identifier] = ACTIONS(2908),
    [sym_true] = ACTIONS(2908),
    [sym_false] = ACTIONS(2908),
    [sym_none] = ACTIONS(2908),
    [sym_comment] = ACTIONS(73),
  },
  [1024] = {
    [sym__primary_expression] = STATE(1401),
    [sym_binary_operator] = STATE(1401),
    [sym_unary_operator] = STATE(1401),
    [sym_attribute] = STATE(1401),
    [sym_subscript] = STATE(1401),
    [sym_call] = STATE(1401),
    [sym_list] = STATE(1401),
    [sym_list_comprehension] = STATE(1401),
    [sym_dictionary] = STATE(1401),
    [sym_dictionary_comprehension] = STATE(1401),
    [sym_set] = STATE(1401),
    [sym_set_comprehension] = STATE(1401),
    [sym_parenthesized_expression] = STATE(1401),
    [sym_tuple] = STATE(1401),
    [sym_generator_expression] = STATE(1401),
    [sym_concatenated_string] = STATE(1401),
    [sym_string] = STATE(539),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2910),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2912),
    [sym_float] = ACTIONS(2912),
    [sym_identifier] = ACTIONS(2912),
    [sym_true] = ACTIONS(2912),
    [sym_false] = ACTIONS(2912),
    [sym_none] = ACTIONS(2912),
    [sym_comment] = ACTIONS(73),
  },
  [1025] = {
    [anon_sym_in] = ACTIONS(2914),
    [sym_comment] = ACTIONS(73),
  },
  [1026] = {
    [sym__primary_expression] = STATE(1403),
    [sym_binary_operator] = STATE(1403),
    [sym_unary_operator] = STATE(1403),
    [sym_attribute] = STATE(1403),
    [sym_subscript] = STATE(1403),
    [sym_call] = STATE(1403),
    [sym_list] = STATE(1403),
    [sym_list_comprehension] = STATE(1403),
    [sym_dictionary] = STATE(1403),
    [sym_dictionary_comprehension] = STATE(1403),
    [sym_set] = STATE(1403),
    [sym_set_comprehension] = STATE(1403),
    [sym_parenthesized_expression] = STATE(1403),
    [sym_tuple] = STATE(1403),
    [sym_generator_expression] = STATE(1403),
    [sym_concatenated_string] = STATE(1403),
    [sym_string] = STATE(539),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2916),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2918),
    [sym_float] = ACTIONS(2918),
    [sym_identifier] = ACTIONS(2918),
    [sym_true] = ACTIONS(2918),
    [sym_false] = ACTIONS(2918),
    [sym_none] = ACTIONS(2918),
    [sym_comment] = ACTIONS(73),
  },
  [1027] = {
    [sym__primary_expression] = STATE(669),
    [sym_binary_operator] = STATE(669),
    [sym_unary_operator] = STATE(669),
    [sym_attribute] = STATE(669),
    [sym_subscript] = STATE(669),
    [sym_call] = STATE(669),
    [sym_list] = STATE(669),
    [sym_list_comprehension] = STATE(669),
    [sym_dictionary] = STATE(669),
    [sym_dictionary_comprehension] = STATE(669),
    [sym_set] = STATE(669),
    [sym_set_comprehension] = STATE(669),
    [sym_parenthesized_expression] = STATE(669),
    [sym_tuple] = STATE(669),
    [sym_generator_expression] = STATE(669),
    [sym_concatenated_string] = STATE(669),
    [sym_string] = STATE(539),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1282),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1284),
    [sym_float] = ACTIONS(1284),
    [sym_identifier] = ACTIONS(1284),
    [sym_true] = ACTIONS(1284),
    [sym_false] = ACTIONS(1284),
    [sym_none] = ACTIONS(1284),
    [sym_comment] = ACTIONS(73),
  },
  [1028] = {
    [sym__primary_expression] = STATE(1404),
    [sym_binary_operator] = STATE(1404),
    [sym_unary_operator] = STATE(1404),
    [sym_attribute] = STATE(1404),
    [sym_subscript] = STATE(1404),
    [sym_call] = STATE(1404),
    [sym_list] = STATE(1404),
    [sym_list_comprehension] = STATE(1404),
    [sym_dictionary] = STATE(1404),
    [sym_dictionary_comprehension] = STATE(1404),
    [sym_set] = STATE(1404),
    [sym_set_comprehension] = STATE(1404),
    [sym_parenthesized_expression] = STATE(1404),
    [sym_tuple] = STATE(1404),
    [sym_generator_expression] = STATE(1404),
    [sym_concatenated_string] = STATE(1404),
    [sym_string] = STATE(539),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2920),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2922),
    [sym_float] = ACTIONS(2922),
    [sym_identifier] = ACTIONS(2922),
    [sym_true] = ACTIONS(2922),
    [sym_false] = ACTIONS(2922),
    [sym_none] = ACTIONS(2922),
    [sym_comment] = ACTIONS(73),
  },
  [1029] = {
    [sym__primary_expression] = STATE(1405),
    [sym_binary_operator] = STATE(1405),
    [sym_unary_operator] = STATE(1405),
    [sym_attribute] = STATE(1405),
    [sym_subscript] = STATE(1405),
    [sym_call] = STATE(1405),
    [sym_list] = STATE(1405),
    [sym_list_comprehension] = STATE(1405),
    [sym_dictionary] = STATE(1405),
    [sym_dictionary_comprehension] = STATE(1405),
    [sym_set] = STATE(1405),
    [sym_set_comprehension] = STATE(1405),
    [sym_parenthesized_expression] = STATE(1405),
    [sym_tuple] = STATE(1405),
    [sym_generator_expression] = STATE(1405),
    [sym_concatenated_string] = STATE(1405),
    [sym_string] = STATE(539),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2924),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2926),
    [sym_float] = ACTIONS(2926),
    [sym_identifier] = ACTIONS(2926),
    [sym_true] = ACTIONS(2926),
    [sym_false] = ACTIONS(2926),
    [sym_none] = ACTIONS(2926),
    [sym_comment] = ACTIONS(73),
  },
  [1030] = {
    [sym__primary_expression] = STATE(1406),
    [sym_binary_operator] = STATE(1406),
    [sym_unary_operator] = STATE(1406),
    [sym_attribute] = STATE(1406),
    [sym_subscript] = STATE(1406),
    [sym_call] = STATE(1406),
    [sym_list] = STATE(1406),
    [sym_list_comprehension] = STATE(1406),
    [sym_dictionary] = STATE(1406),
    [sym_dictionary_comprehension] = STATE(1406),
    [sym_set] = STATE(1406),
    [sym_set_comprehension] = STATE(1406),
    [sym_parenthesized_expression] = STATE(1406),
    [sym_tuple] = STATE(1406),
    [sym_generator_expression] = STATE(1406),
    [sym_concatenated_string] = STATE(1406),
    [sym_string] = STATE(539),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2928),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2930),
    [sym_float] = ACTIONS(2930),
    [sym_identifier] = ACTIONS(2930),
    [sym_true] = ACTIONS(2930),
    [sym_false] = ACTIONS(2930),
    [sym_none] = ACTIONS(2930),
    [sym_comment] = ACTIONS(73),
  },
  [1031] = {
    [sym__primary_expression] = STATE(1401),
    [sym_binary_operator] = STATE(1401),
    [sym_unary_operator] = STATE(1401),
    [sym_attribute] = STATE(1401),
    [sym_subscript] = STATE(1401),
    [sym_call] = STATE(1401),
    [sym_list] = STATE(1401),
    [sym_list_comprehension] = STATE(1401),
    [sym_dictionary] = STATE(1401),
    [sym_dictionary_comprehension] = STATE(1401),
    [sym_set] = STATE(1401),
    [sym_set_comprehension] = STATE(1401),
    [sym_parenthesized_expression] = STATE(1401),
    [sym_tuple] = STATE(1401),
    [sym_generator_expression] = STATE(1401),
    [sym_concatenated_string] = STATE(1401),
    [sym_string] = STATE(539),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2932),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2910),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2912),
    [sym_float] = ACTIONS(2912),
    [sym_identifier] = ACTIONS(2912),
    [sym_true] = ACTIONS(2912),
    [sym_false] = ACTIONS(2912),
    [sym_none] = ACTIONS(2912),
    [sym_comment] = ACTIONS(73),
  },
  [1032] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1407),
    [anon_sym_if] = ACTIONS(991),
    [anon_sym_else] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(1937),
    [anon_sym_not] = ACTIONS(1941),
    [anon_sym_and] = ACTIONS(991),
    [anon_sym_or] = ACTIONS(991),
    [anon_sym_LT] = ACTIONS(1953),
    [anon_sym_LT_EQ] = ACTIONS(1937),
    [anon_sym_EQ_EQ] = ACTIONS(1937),
    [anon_sym_BANG_EQ] = ACTIONS(1937),
    [anon_sym_GT_EQ] = ACTIONS(1937),
    [anon_sym_GT] = ACTIONS(1953),
    [anon_sym_LT_GT] = ACTIONS(1937),
    [anon_sym_is] = ACTIONS(1955),
    [sym_comment] = ACTIONS(73),
  },
  [1033] = {
    [sym_string] = STATE(1408),
    [aux_sym_concatenated_string_repeat1] = STATE(1408),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_else] = ACTIONS(995),
    [anon_sym_in] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(995),
    [anon_sym_not] = ACTIONS(995),
    [anon_sym_and] = ACTIONS(995),
    [anon_sym_or] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(995),
    [anon_sym_SLASH_SLASH] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_GT] = ACTIONS(995),
    [anon_sym_is] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(995),
    [sym_comment] = ACTIONS(73),
  },
  [1034] = {
    [sym__expression] = STATE(532),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(532),
    [sym_boolean_operator] = STATE(532),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(532),
    [sym_lambda] = STATE(532),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(532),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(532),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1035] = {
    [sym__newline] = ACTIONS(2934),
    [anon_sym_DOT] = ACTIONS(2934),
    [anon_sym_LPAREN] = ACTIONS(2934),
    [anon_sym_COMMA] = ACTIONS(2934),
    [anon_sym_STAR] = ACTIONS(2936),
    [anon_sym_GT_GT] = ACTIONS(2936),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_COLON] = ACTIONS(2934),
    [anon_sym_in] = ACTIONS(2934),
    [anon_sym_EQ] = ACTIONS(2936),
    [anon_sym_AT] = ACTIONS(2936),
    [anon_sym_not] = ACTIONS(2934),
    [anon_sym_and] = ACTIONS(2934),
    [anon_sym_or] = ACTIONS(2934),
    [anon_sym_PLUS] = ACTIONS(2936),
    [anon_sym_DASH] = ACTIONS(2936),
    [anon_sym_SLASH] = ACTIONS(2936),
    [anon_sym_PERCENT] = ACTIONS(2936),
    [anon_sym_SLASH_SLASH] = ACTIONS(2936),
    [anon_sym_STAR_STAR] = ACTIONS(2936),
    [anon_sym_PIPE] = ACTIONS(2936),
    [anon_sym_AMP] = ACTIONS(2936),
    [anon_sym_CARET] = ACTIONS(2936),
    [anon_sym_LT_LT] = ACTIONS(2936),
    [anon_sym_LT] = ACTIONS(2936),
    [anon_sym_LT_EQ] = ACTIONS(2934),
    [anon_sym_EQ_EQ] = ACTIONS(2934),
    [anon_sym_BANG_EQ] = ACTIONS(2934),
    [anon_sym_GT_EQ] = ACTIONS(2934),
    [anon_sym_GT] = ACTIONS(2936),
    [anon_sym_LT_GT] = ACTIONS(2934),
    [anon_sym_is] = ACTIONS(2934),
    [anon_sym_PLUS_EQ] = ACTIONS(2934),
    [anon_sym_DASH_EQ] = ACTIONS(2934),
    [anon_sym_STAR_EQ] = ACTIONS(2934),
    [anon_sym_SLASH_EQ] = ACTIONS(2934),
    [anon_sym_AT_EQ] = ACTIONS(2934),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2934),
    [anon_sym_PERCENT_EQ] = ACTIONS(2934),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2934),
    [anon_sym_GT_GT_EQ] = ACTIONS(2934),
    [anon_sym_LT_LT_EQ] = ACTIONS(2934),
    [anon_sym_AMP_EQ] = ACTIONS(2934),
    [anon_sym_CARET_EQ] = ACTIONS(2934),
    [anon_sym_PIPE_EQ] = ACTIONS(2934),
    [anon_sym_LBRACK] = ACTIONS(2934),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2934),
  },
  [1036] = {
    [sym__expression] = STATE(1409),
    [sym__primary_expression] = STATE(237),
    [sym_not_operator] = STATE(1409),
    [sym_boolean_operator] = STATE(1409),
    [sym_binary_operator] = STATE(237),
    [sym_unary_operator] = STATE(237),
    [sym_comparison_operator] = STATE(1409),
    [sym_lambda] = STATE(1409),
    [sym_attribute] = STATE(237),
    [sym_subscript] = STATE(237),
    [sym_call] = STATE(237),
    [sym_list] = STATE(237),
    [sym_list_comprehension] = STATE(237),
    [sym_dictionary] = STATE(237),
    [sym_dictionary_comprehension] = STATE(237),
    [sym_set] = STATE(237),
    [sym_set_comprehension] = STATE(237),
    [sym_parenthesized_expression] = STATE(237),
    [sym_tuple] = STATE(237),
    [sym_generator_expression] = STATE(237),
    [sym_conditional_expression] = STATE(1409),
    [sym_concatenated_string] = STATE(237),
    [sym_string] = STATE(238),
    [sym_await] = STATE(1409),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_lambda] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(419),
    [sym_float] = ACTIONS(419),
    [sym_identifier] = ACTIONS(419),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_none] = ACTIONS(419),
    [anon_sym_await] = ACTIONS(421),
    [sym_comment] = ACTIONS(73),
  },
  [1037] = {
    [anon_sym_RPAREN] = ACTIONS(1608),
    [anon_sym_COMMA] = ACTIONS(1608),
    [anon_sym_if] = ACTIONS(1198),
    [anon_sym_and] = ACTIONS(1200),
    [anon_sym_or] = ACTIONS(1202),
    [sym_comment] = ACTIONS(73),
  },
  [1038] = {
    [sym__expression] = STATE(1410),
    [sym__primary_expression] = STATE(237),
    [sym_not_operator] = STATE(1410),
    [sym_boolean_operator] = STATE(1410),
    [sym_binary_operator] = STATE(237),
    [sym_unary_operator] = STATE(237),
    [sym_comparison_operator] = STATE(1410),
    [sym_lambda] = STATE(1410),
    [sym_attribute] = STATE(237),
    [sym_subscript] = STATE(237),
    [sym_call] = STATE(237),
    [sym_list] = STATE(237),
    [sym_list_comprehension] = STATE(237),
    [sym_dictionary] = STATE(237),
    [sym_dictionary_comprehension] = STATE(237),
    [sym_set] = STATE(237),
    [sym_set_comprehension] = STATE(237),
    [sym_parenthesized_expression] = STATE(237),
    [sym_tuple] = STATE(237),
    [sym_generator_expression] = STATE(237),
    [sym_conditional_expression] = STATE(1410),
    [sym_concatenated_string] = STATE(237),
    [sym_string] = STATE(238),
    [sym_await] = STATE(1410),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_lambda] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(419),
    [sym_float] = ACTIONS(419),
    [sym_identifier] = ACTIONS(419),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_none] = ACTIONS(419),
    [anon_sym_await] = ACTIONS(421),
    [sym_comment] = ACTIONS(73),
  },
  [1039] = {
    [sym__expression] = STATE(1411),
    [sym__primary_expression] = STATE(237),
    [sym_not_operator] = STATE(1411),
    [sym_boolean_operator] = STATE(1411),
    [sym_binary_operator] = STATE(237),
    [sym_unary_operator] = STATE(237),
    [sym_comparison_operator] = STATE(1411),
    [sym_lambda] = STATE(1411),
    [sym_attribute] = STATE(237),
    [sym_subscript] = STATE(237),
    [sym_call] = STATE(237),
    [sym_list] = STATE(237),
    [sym_list_comprehension] = STATE(237),
    [sym_dictionary] = STATE(237),
    [sym_dictionary_comprehension] = STATE(237),
    [sym_set] = STATE(237),
    [sym_set_comprehension] = STATE(237),
    [sym_parenthesized_expression] = STATE(237),
    [sym_tuple] = STATE(237),
    [sym_generator_expression] = STATE(237),
    [sym_conditional_expression] = STATE(1411),
    [sym_concatenated_string] = STATE(237),
    [sym_string] = STATE(238),
    [sym_await] = STATE(1411),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_lambda] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(419),
    [sym_float] = ACTIONS(419),
    [sym_identifier] = ACTIONS(419),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_none] = ACTIONS(419),
    [anon_sym_await] = ACTIONS(421),
    [sym_comment] = ACTIONS(73),
  },
  [1040] = {
    [sym_list_splat] = STATE(1413),
    [sym_dictionary_splat] = STATE(1413),
    [sym__expression] = STATE(1414),
    [sym__primary_expression] = STATE(237),
    [sym_not_operator] = STATE(1414),
    [sym_boolean_operator] = STATE(1414),
    [sym_binary_operator] = STATE(237),
    [sym_unary_operator] = STATE(237),
    [sym_comparison_operator] = STATE(1414),
    [sym_lambda] = STATE(1414),
    [sym_attribute] = STATE(237),
    [sym_subscript] = STATE(237),
    [sym_call] = STATE(237),
    [sym_keyword_argument] = STATE(1413),
    [sym_list] = STATE(237),
    [sym_list_comprehension] = STATE(237),
    [sym_dictionary] = STATE(237),
    [sym_dictionary_comprehension] = STATE(237),
    [sym_set] = STATE(237),
    [sym_set_comprehension] = STATE(237),
    [sym_parenthesized_expression] = STATE(237),
    [sym_tuple] = STATE(237),
    [sym_generator_expression] = STATE(237),
    [sym_conditional_expression] = STATE(1414),
    [sym_concatenated_string] = STATE(237),
    [sym_string] = STATE(238),
    [sym_await] = STATE(1414),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(2938),
    [anon_sym_STAR] = ACTIONS(931),
    [anon_sym_print] = ACTIONS(933),
    [anon_sym_exec] = ACTIONS(933),
    [anon_sym_not] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_lambda] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(419),
    [sym_float] = ACTIONS(419),
    [sym_identifier] = ACTIONS(935),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_none] = ACTIONS(419),
    [anon_sym_await] = ACTIONS(421),
    [sym_comment] = ACTIONS(73),
  },
  [1041] = {
    [aux_sym_argument_list_repeat1] = STATE(1416),
    [anon_sym_RPAREN] = ACTIONS(2938),
    [anon_sym_COMMA] = ACTIONS(2940),
    [sym_comment] = ACTIONS(73),
  },
  [1042] = {
    [sym_argument_list] = STATE(192),
    [sym_generator_expression] = STATE(192),
    [sym__newline] = ACTIONS(2942),
    [anon_sym_DOT] = ACTIONS(303),
    [anon_sym_LPAREN] = ACTIONS(305),
    [anon_sym_COMMA] = ACTIONS(2942),
    [anon_sym_STAR] = ACTIONS(307),
    [anon_sym_GT_GT] = ACTIONS(309),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_COLON] = ACTIONS(2942),
    [anon_sym_in] = ACTIONS(2942),
    [anon_sym_EQ] = ACTIONS(2944),
    [anon_sym_AT] = ACTIONS(307),
    [anon_sym_not] = ACTIONS(2942),
    [anon_sym_and] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(317),
    [anon_sym_DASH] = ACTIONS(317),
    [anon_sym_SLASH] = ACTIONS(307),
    [anon_sym_PERCENT] = ACTIONS(307),
    [anon_sym_SLASH_SLASH] = ACTIONS(307),
    [anon_sym_STAR_STAR] = ACTIONS(319),
    [anon_sym_PIPE] = ACTIONS(321),
    [anon_sym_AMP] = ACTIONS(323),
    [anon_sym_CARET] = ACTIONS(325),
    [anon_sym_LT_LT] = ACTIONS(309),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_LT_EQ] = ACTIONS(2942),
    [anon_sym_EQ_EQ] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_GT_EQ] = ACTIONS(2942),
    [anon_sym_GT] = ACTIONS(2944),
    [anon_sym_LT_GT] = ACTIONS(2942),
    [anon_sym_is] = ACTIONS(2942),
    [anon_sym_PLUS_EQ] = ACTIONS(2942),
    [anon_sym_DASH_EQ] = ACTIONS(2942),
    [anon_sym_STAR_EQ] = ACTIONS(2942),
    [anon_sym_SLASH_EQ] = ACTIONS(2942),
    [anon_sym_AT_EQ] = ACTIONS(2942),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2942),
    [anon_sym_PERCENT_EQ] = ACTIONS(2942),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2942),
    [anon_sym_GT_GT_EQ] = ACTIONS(2942),
    [anon_sym_LT_LT_EQ] = ACTIONS(2942),
    [anon_sym_AMP_EQ] = ACTIONS(2942),
    [anon_sym_CARET_EQ] = ACTIONS(2942),
    [anon_sym_PIPE_EQ] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(331),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2942),
  },
  [1043] = {
    [sym__expression] = STATE(1417),
    [sym__primary_expression] = STATE(452),
    [sym_not_operator] = STATE(1417),
    [sym_boolean_operator] = STATE(1417),
    [sym_binary_operator] = STATE(452),
    [sym_unary_operator] = STATE(452),
    [sym_comparison_operator] = STATE(1417),
    [sym_lambda] = STATE(1417),
    [sym_attribute] = STATE(452),
    [sym_subscript] = STATE(452),
    [sym_call] = STATE(452),
    [sym_list] = STATE(452),
    [sym_list_comprehension] = STATE(452),
    [sym_dictionary] = STATE(452),
    [sym_dictionary_comprehension] = STATE(452),
    [sym_set] = STATE(452),
    [sym_set_comprehension] = STATE(452),
    [sym_parenthesized_expression] = STATE(452),
    [sym_tuple] = STATE(452),
    [sym_generator_expression] = STATE(452),
    [sym_conditional_expression] = STATE(1417),
    [sym_concatenated_string] = STATE(452),
    [sym_string] = STATE(453),
    [sym_await] = STATE(1417),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_COMMA] = ACTIONS(2946),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_lambda] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(2946),
    [sym_ellipsis] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(773),
    [sym_float] = ACTIONS(773),
    [sym_identifier] = ACTIONS(773),
    [sym_true] = ACTIONS(773),
    [sym_false] = ACTIONS(773),
    [sym_none] = ACTIONS(773),
    [anon_sym_await] = ACTIONS(775),
    [sym_comment] = ACTIONS(73),
  },
  [1044] = {
    [anon_sym_COMMA] = ACTIONS(2946),
    [anon_sym_if] = ACTIONS(2004),
    [anon_sym_COLON] = ACTIONS(2948),
    [anon_sym_and] = ACTIONS(2008),
    [anon_sym_or] = ACTIONS(2010),
    [anon_sym_RBRACK] = ACTIONS(2946),
    [sym_comment] = ACTIONS(73),
  },
  [1045] = {
    [anon_sym_COMMA] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(723),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_and] = ACTIONS(2008),
    [anon_sym_or] = ACTIONS(2010),
    [anon_sym_RBRACK] = ACTIONS(723),
    [sym_comment] = ACTIONS(73),
  },
  [1046] = {
    [sym__expression] = STATE(1419),
    [sym__primary_expression] = STATE(567),
    [sym_not_operator] = STATE(1419),
    [sym_boolean_operator] = STATE(1419),
    [sym_binary_operator] = STATE(567),
    [sym_unary_operator] = STATE(567),
    [sym_comparison_operator] = STATE(1419),
    [sym_lambda] = STATE(1419),
    [sym_attribute] = STATE(567),
    [sym_subscript] = STATE(567),
    [sym_call] = STATE(567),
    [sym_list] = STATE(567),
    [sym_list_comprehension] = STATE(567),
    [sym_dictionary] = STATE(567),
    [sym_dictionary_comprehension] = STATE(567),
    [sym_set] = STATE(567),
    [sym_set_comprehension] = STATE(567),
    [sym_parenthesized_expression] = STATE(567),
    [sym_tuple] = STATE(567),
    [sym_generator_expression] = STATE(567),
    [sym_conditional_expression] = STATE(1419),
    [sym_concatenated_string] = STATE(567),
    [sym_string] = STATE(569),
    [sym_await] = STATE(1419),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(975),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(977),
    [anon_sym_lambda] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(981),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(983),
    [sym_float] = ACTIONS(983),
    [sym_identifier] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_none] = ACTIONS(983),
    [anon_sym_await] = ACTIONS(985),
    [sym_comment] = ACTIONS(73),
  },
  [1047] = {
    [anon_sym_COLON] = ACTIONS(2950),
    [sym_comment] = ACTIONS(73),
  },
  [1048] = {
    [sym__expression] = STATE(1422),
    [sym__primary_expression] = STATE(567),
    [sym_not_operator] = STATE(1422),
    [sym_boolean_operator] = STATE(1422),
    [sym_binary_operator] = STATE(567),
    [sym_unary_operator] = STATE(567),
    [sym_comparison_operator] = STATE(1422),
    [sym_lambda] = STATE(1422),
    [sym_attribute] = STATE(567),
    [sym_subscript] = STATE(567),
    [sym_slice] = STATE(1423),
    [sym_call] = STATE(567),
    [sym_list] = STATE(567),
    [sym_list_comprehension] = STATE(567),
    [sym_dictionary] = STATE(567),
    [sym_dictionary_comprehension] = STATE(567),
    [sym_set] = STATE(567),
    [sym_set_comprehension] = STATE(567),
    [sym_parenthesized_expression] = STATE(567),
    [sym_tuple] = STATE(567),
    [sym_generator_expression] = STATE(567),
    [sym_conditional_expression] = STATE(1422),
    [sym_concatenated_string] = STATE(567),
    [sym_string] = STATE(569),
    [sym_await] = STATE(1422),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(973),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(975),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(977),
    [anon_sym_lambda] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(2952),
    [sym_ellipsis] = ACTIONS(981),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(983),
    [sym_float] = ACTIONS(983),
    [sym_identifier] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_none] = ACTIONS(983),
    [anon_sym_await] = ACTIONS(985),
    [sym_comment] = ACTIONS(73),
  },
  [1049] = {
    [sym__expression] = STATE(1424),
    [sym__primary_expression] = STATE(538),
    [sym_not_operator] = STATE(1424),
    [sym_boolean_operator] = STATE(1424),
    [sym_binary_operator] = STATE(538),
    [sym_unary_operator] = STATE(538),
    [sym_comparison_operator] = STATE(1424),
    [sym_lambda] = STATE(1424),
    [sym_attribute] = STATE(538),
    [sym_subscript] = STATE(538),
    [sym_call] = STATE(538),
    [sym_list] = STATE(538),
    [sym_list_comprehension] = STATE(538),
    [sym_dictionary] = STATE(538),
    [sym_dictionary_comprehension] = STATE(538),
    [sym_set] = STATE(538),
    [sym_set_comprehension] = STATE(538),
    [sym_parenthesized_expression] = STATE(538),
    [sym_tuple] = STATE(538),
    [sym_generator_expression] = STATE(538),
    [sym_conditional_expression] = STATE(1424),
    [sym_concatenated_string] = STATE(538),
    [sym_string] = STATE(539),
    [sym_await] = STATE(1424),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_lambda] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(917),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(919),
    [sym_float] = ACTIONS(919),
    [sym_identifier] = ACTIONS(919),
    [sym_true] = ACTIONS(919),
    [sym_false] = ACTIONS(919),
    [sym_none] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(921),
    [sym_comment] = ACTIONS(73),
  },
  [1050] = {
    [sym__expression] = STATE(1425),
    [sym__primary_expression] = STATE(567),
    [sym_not_operator] = STATE(1425),
    [sym_boolean_operator] = STATE(1425),
    [sym_binary_operator] = STATE(567),
    [sym_unary_operator] = STATE(567),
    [sym_comparison_operator] = STATE(1425),
    [sym_lambda] = STATE(1425),
    [sym_attribute] = STATE(567),
    [sym_subscript] = STATE(567),
    [sym_call] = STATE(567),
    [sym_list] = STATE(567),
    [sym_list_comprehension] = STATE(567),
    [sym_dictionary] = STATE(567),
    [sym_dictionary_comprehension] = STATE(567),
    [sym_set] = STATE(567),
    [sym_set_comprehension] = STATE(567),
    [sym_parenthesized_expression] = STATE(567),
    [sym_tuple] = STATE(567),
    [sym_generator_expression] = STATE(567),
    [sym_conditional_expression] = STATE(1425),
    [sym_concatenated_string] = STATE(567),
    [sym_string] = STATE(569),
    [sym_await] = STATE(1425),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_COMMA] = ACTIONS(2946),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(2948),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(975),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(977),
    [anon_sym_lambda] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(2946),
    [sym_ellipsis] = ACTIONS(981),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(983),
    [sym_float] = ACTIONS(983),
    [sym_identifier] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_none] = ACTIONS(983),
    [anon_sym_await] = ACTIONS(985),
    [sym_comment] = ACTIONS(73),
  },
  [1051] = {
    [sym__expression] = STATE(652),
    [sym__primary_expression] = STATE(567),
    [sym_not_operator] = STATE(652),
    [sym_boolean_operator] = STATE(652),
    [sym_binary_operator] = STATE(567),
    [sym_unary_operator] = STATE(567),
    [sym_comparison_operator] = STATE(652),
    [sym_lambda] = STATE(652),
    [sym_attribute] = STATE(567),
    [sym_subscript] = STATE(567),
    [sym_call] = STATE(567),
    [sym_list] = STATE(567),
    [sym_list_comprehension] = STATE(567),
    [sym_dictionary] = STATE(567),
    [sym_dictionary_comprehension] = STATE(567),
    [sym_set] = STATE(567),
    [sym_set_comprehension] = STATE(567),
    [sym_parenthesized_expression] = STATE(567),
    [sym_tuple] = STATE(567),
    [sym_generator_expression] = STATE(567),
    [sym_conditional_expression] = STATE(652),
    [sym_concatenated_string] = STATE(567),
    [sym_string] = STATE(569),
    [sym_await] = STATE(652),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(975),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(977),
    [anon_sym_lambda] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(981),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(983),
    [sym_float] = ACTIONS(983),
    [sym_identifier] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_none] = ACTIONS(983),
    [anon_sym_await] = ACTIONS(985),
    [sym_comment] = ACTIONS(73),
  },
  [1052] = {
    [sym__expression] = STATE(1426),
    [sym__primary_expression] = STATE(567),
    [sym_not_operator] = STATE(1426),
    [sym_boolean_operator] = STATE(1426),
    [sym_binary_operator] = STATE(567),
    [sym_unary_operator] = STATE(567),
    [sym_comparison_operator] = STATE(1426),
    [sym_lambda] = STATE(1426),
    [sym_attribute] = STATE(567),
    [sym_subscript] = STATE(567),
    [sym_call] = STATE(567),
    [sym_list] = STATE(567),
    [sym_list_comprehension] = STATE(567),
    [sym_dictionary] = STATE(567),
    [sym_dictionary_comprehension] = STATE(567),
    [sym_set] = STATE(567),
    [sym_set_comprehension] = STATE(567),
    [sym_parenthesized_expression] = STATE(567),
    [sym_tuple] = STATE(567),
    [sym_generator_expression] = STATE(567),
    [sym_conditional_expression] = STATE(1426),
    [sym_concatenated_string] = STATE(567),
    [sym_string] = STATE(569),
    [sym_await] = STATE(1426),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(975),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(977),
    [anon_sym_lambda] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(981),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(983),
    [sym_float] = ACTIONS(983),
    [sym_identifier] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_none] = ACTIONS(983),
    [anon_sym_await] = ACTIONS(985),
    [sym_comment] = ACTIONS(73),
  },
  [1053] = {
    [sym__newline] = ACTIONS(2954),
    [anon_sym_DOT] = ACTIONS(2954),
    [anon_sym_LPAREN] = ACTIONS(2954),
    [anon_sym_COMMA] = ACTIONS(2954),
    [anon_sym_STAR] = ACTIONS(2956),
    [anon_sym_GT_GT] = ACTIONS(2956),
    [anon_sym_if] = ACTIONS(2954),
    [anon_sym_COLON] = ACTIONS(2954),
    [anon_sym_in] = ACTIONS(2954),
    [anon_sym_EQ] = ACTIONS(2956),
    [anon_sym_AT] = ACTIONS(2956),
    [anon_sym_not] = ACTIONS(2954),
    [anon_sym_and] = ACTIONS(2954),
    [anon_sym_or] = ACTIONS(2954),
    [anon_sym_PLUS] = ACTIONS(2956),
    [anon_sym_DASH] = ACTIONS(2956),
    [anon_sym_SLASH] = ACTIONS(2956),
    [anon_sym_PERCENT] = ACTIONS(2956),
    [anon_sym_SLASH_SLASH] = ACTIONS(2956),
    [anon_sym_STAR_STAR] = ACTIONS(2956),
    [anon_sym_PIPE] = ACTIONS(2956),
    [anon_sym_AMP] = ACTIONS(2956),
    [anon_sym_CARET] = ACTIONS(2956),
    [anon_sym_LT_LT] = ACTIONS(2956),
    [anon_sym_LT] = ACTIONS(2956),
    [anon_sym_LT_EQ] = ACTIONS(2954),
    [anon_sym_EQ_EQ] = ACTIONS(2954),
    [anon_sym_BANG_EQ] = ACTIONS(2954),
    [anon_sym_GT_EQ] = ACTIONS(2954),
    [anon_sym_GT] = ACTIONS(2956),
    [anon_sym_LT_GT] = ACTIONS(2954),
    [anon_sym_is] = ACTIONS(2954),
    [anon_sym_PLUS_EQ] = ACTIONS(2954),
    [anon_sym_DASH_EQ] = ACTIONS(2954),
    [anon_sym_STAR_EQ] = ACTIONS(2954),
    [anon_sym_SLASH_EQ] = ACTIONS(2954),
    [anon_sym_AT_EQ] = ACTIONS(2954),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(2954),
    [anon_sym_PERCENT_EQ] = ACTIONS(2954),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(2954),
    [anon_sym_GT_GT_EQ] = ACTIONS(2954),
    [anon_sym_LT_LT_EQ] = ACTIONS(2954),
    [anon_sym_AMP_EQ] = ACTIONS(2954),
    [anon_sym_CARET_EQ] = ACTIONS(2954),
    [anon_sym_PIPE_EQ] = ACTIONS(2954),
    [anon_sym_LBRACK] = ACTIONS(2954),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2954),
  },
  [1054] = {
    [aux_sym_subscript_repeat1] = STATE(1428),
    [anon_sym_COMMA] = ACTIONS(2958),
    [anon_sym_RBRACK] = ACTIONS(2952),
    [sym_comment] = ACTIONS(73),
  },
  [1055] = {
    [sym__primary_expression] = STATE(1429),
    [sym_binary_operator] = STATE(1429),
    [sym_unary_operator] = STATE(1429),
    [sym_attribute] = STATE(1429),
    [sym_subscript] = STATE(1429),
    [sym_call] = STATE(1429),
    [sym_list] = STATE(1429),
    [sym_list_comprehension] = STATE(1429),
    [sym_dictionary] = STATE(1429),
    [sym_dictionary_comprehension] = STATE(1429),
    [sym_set] = STATE(1429),
    [sym_set_comprehension] = STATE(1429),
    [sym_parenthesized_expression] = STATE(1429),
    [sym_tuple] = STATE(1429),
    [sym_generator_expression] = STATE(1429),
    [sym_concatenated_string] = STATE(1429),
    [sym_string] = STATE(569),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(977),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2960),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2962),
    [sym_float] = ACTIONS(2962),
    [sym_identifier] = ACTIONS(2962),
    [sym_true] = ACTIONS(2962),
    [sym_false] = ACTIONS(2962),
    [sym_none] = ACTIONS(2962),
    [sym_comment] = ACTIONS(73),
  },
  [1056] = {
    [sym__primary_expression] = STATE(1430),
    [sym_binary_operator] = STATE(1430),
    [sym_unary_operator] = STATE(1430),
    [sym_attribute] = STATE(1430),
    [sym_subscript] = STATE(1430),
    [sym_call] = STATE(1430),
    [sym_list] = STATE(1430),
    [sym_list_comprehension] = STATE(1430),
    [sym_dictionary] = STATE(1430),
    [sym_dictionary_comprehension] = STATE(1430),
    [sym_set] = STATE(1430),
    [sym_set_comprehension] = STATE(1430),
    [sym_parenthesized_expression] = STATE(1430),
    [sym_tuple] = STATE(1430),
    [sym_generator_expression] = STATE(1430),
    [sym_concatenated_string] = STATE(1430),
    [sym_string] = STATE(569),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(977),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2964),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2966),
    [sym_float] = ACTIONS(2966),
    [sym_identifier] = ACTIONS(2966),
    [sym_true] = ACTIONS(2966),
    [sym_false] = ACTIONS(2966),
    [sym_none] = ACTIONS(2966),
    [sym_comment] = ACTIONS(73),
  },
  [1057] = {
    [sym__primary_expression] = STATE(1431),
    [sym_binary_operator] = STATE(1431),
    [sym_unary_operator] = STATE(1431),
    [sym_attribute] = STATE(1431),
    [sym_subscript] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_list] = STATE(1431),
    [sym_list_comprehension] = STATE(1431),
    [sym_dictionary] = STATE(1431),
    [sym_dictionary_comprehension] = STATE(1431),
    [sym_set] = STATE(1431),
    [sym_set_comprehension] = STATE(1431),
    [sym_parenthesized_expression] = STATE(1431),
    [sym_tuple] = STATE(1431),
    [sym_generator_expression] = STATE(1431),
    [sym_concatenated_string] = STATE(1431),
    [sym_string] = STATE(569),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(977),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2968),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2970),
    [sym_float] = ACTIONS(2970),
    [sym_identifier] = ACTIONS(2970),
    [sym_true] = ACTIONS(2970),
    [sym_false] = ACTIONS(2970),
    [sym_none] = ACTIONS(2970),
    [sym_comment] = ACTIONS(73),
  },
  [1058] = {
    [anon_sym_in] = ACTIONS(2972),
    [sym_comment] = ACTIONS(73),
  },
  [1059] = {
    [sym__primary_expression] = STATE(1433),
    [sym_binary_operator] = STATE(1433),
    [sym_unary_operator] = STATE(1433),
    [sym_attribute] = STATE(1433),
    [sym_subscript] = STATE(1433),
    [sym_call] = STATE(1433),
    [sym_list] = STATE(1433),
    [sym_list_comprehension] = STATE(1433),
    [sym_dictionary] = STATE(1433),
    [sym_dictionary_comprehension] = STATE(1433),
    [sym_set] = STATE(1433),
    [sym_set_comprehension] = STATE(1433),
    [sym_parenthesized_expression] = STATE(1433),
    [sym_tuple] = STATE(1433),
    [sym_generator_expression] = STATE(1433),
    [sym_concatenated_string] = STATE(1433),
    [sym_string] = STATE(569),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(977),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2974),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2976),
    [sym_float] = ACTIONS(2976),
    [sym_identifier] = ACTIONS(2976),
    [sym_true] = ACTIONS(2976),
    [sym_false] = ACTIONS(2976),
    [sym_none] = ACTIONS(2976),
    [sym_comment] = ACTIONS(73),
  },
  [1060] = {
    [sym__primary_expression] = STATE(669),
    [sym_binary_operator] = STATE(669),
    [sym_unary_operator] = STATE(669),
    [sym_attribute] = STATE(669),
    [sym_subscript] = STATE(669),
    [sym_call] = STATE(669),
    [sym_list] = STATE(669),
    [sym_list_comprehension] = STATE(669),
    [sym_dictionary] = STATE(669),
    [sym_dictionary_comprehension] = STATE(669),
    [sym_set] = STATE(669),
    [sym_set_comprehension] = STATE(669),
    [sym_parenthesized_expression] = STATE(669),
    [sym_tuple] = STATE(669),
    [sym_generator_expression] = STATE(669),
    [sym_concatenated_string] = STATE(669),
    [sym_string] = STATE(569),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(977),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1282),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1284),
    [sym_float] = ACTIONS(1284),
    [sym_identifier] = ACTIONS(1284),
    [sym_true] = ACTIONS(1284),
    [sym_false] = ACTIONS(1284),
    [sym_none] = ACTIONS(1284),
    [sym_comment] = ACTIONS(73),
  },
  [1061] = {
    [sym__primary_expression] = STATE(1434),
    [sym_binary_operator] = STATE(1434),
    [sym_unary_operator] = STATE(1434),
    [sym_attribute] = STATE(1434),
    [sym_subscript] = STATE(1434),
    [sym_call] = STATE(1434),
    [sym_list] = STATE(1434),
    [sym_list_comprehension] = STATE(1434),
    [sym_dictionary] = STATE(1434),
    [sym_dictionary_comprehension] = STATE(1434),
    [sym_set] = STATE(1434),
    [sym_set_comprehension] = STATE(1434),
    [sym_parenthesized_expression] = STATE(1434),
    [sym_tuple] = STATE(1434),
    [sym_generator_expression] = STATE(1434),
    [sym_concatenated_string] = STATE(1434),
    [sym_string] = STATE(569),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(977),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2978),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2980),
    [sym_float] = ACTIONS(2980),
    [sym_identifier] = ACTIONS(2980),
    [sym_true] = ACTIONS(2980),
    [sym_false] = ACTIONS(2980),
    [sym_none] = ACTIONS(2980),
    [sym_comment] = ACTIONS(73),
  },
  [1062] = {
    [sym__primary_expression] = STATE(1435),
    [sym_binary_operator] = STATE(1435),
    [sym_unary_operator] = STATE(1435),
    [sym_attribute] = STATE(1435),
    [sym_subscript] = STATE(1435),
    [sym_call] = STATE(1435),
    [sym_list] = STATE(1435),
    [sym_list_comprehension] = STATE(1435),
    [sym_dictionary] = STATE(1435),
    [sym_dictionary_comprehension] = STATE(1435),
    [sym_set] = STATE(1435),
    [sym_set_comprehension] = STATE(1435),
    [sym_parenthesized_expression] = STATE(1435),
    [sym_tuple] = STATE(1435),
    [sym_generator_expression] = STATE(1435),
    [sym_concatenated_string] = STATE(1435),
    [sym_string] = STATE(569),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(977),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2982),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2984),
    [sym_float] = ACTIONS(2984),
    [sym_identifier] = ACTIONS(2984),
    [sym_true] = ACTIONS(2984),
    [sym_false] = ACTIONS(2984),
    [sym_none] = ACTIONS(2984),
    [sym_comment] = ACTIONS(73),
  },
  [1063] = {
    [sym__primary_expression] = STATE(1436),
    [sym_binary_operator] = STATE(1436),
    [sym_unary_operator] = STATE(1436),
    [sym_attribute] = STATE(1436),
    [sym_subscript] = STATE(1436),
    [sym_call] = STATE(1436),
    [sym_list] = STATE(1436),
    [sym_list_comprehension] = STATE(1436),
    [sym_dictionary] = STATE(1436),
    [sym_dictionary_comprehension] = STATE(1436),
    [sym_set] = STATE(1436),
    [sym_set_comprehension] = STATE(1436),
    [sym_parenthesized_expression] = STATE(1436),
    [sym_tuple] = STATE(1436),
    [sym_generator_expression] = STATE(1436),
    [sym_concatenated_string] = STATE(1436),
    [sym_string] = STATE(569),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(977),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2986),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2988),
    [sym_float] = ACTIONS(2988),
    [sym_identifier] = ACTIONS(2988),
    [sym_true] = ACTIONS(2988),
    [sym_false] = ACTIONS(2988),
    [sym_none] = ACTIONS(2988),
    [sym_comment] = ACTIONS(73),
  },
  [1064] = {
    [sym__primary_expression] = STATE(1431),
    [sym_binary_operator] = STATE(1431),
    [sym_unary_operator] = STATE(1431),
    [sym_attribute] = STATE(1431),
    [sym_subscript] = STATE(1431),
    [sym_call] = STATE(1431),
    [sym_list] = STATE(1431),
    [sym_list_comprehension] = STATE(1431),
    [sym_dictionary] = STATE(1431),
    [sym_dictionary_comprehension] = STATE(1431),
    [sym_set] = STATE(1431),
    [sym_set_comprehension] = STATE(1431),
    [sym_parenthesized_expression] = STATE(1431),
    [sym_tuple] = STATE(1431),
    [sym_generator_expression] = STATE(1431),
    [sym_concatenated_string] = STATE(1431),
    [sym_string] = STATE(569),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2990),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(977),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2968),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2970),
    [sym_float] = ACTIONS(2970),
    [sym_identifier] = ACTIONS(2970),
    [sym_true] = ACTIONS(2970),
    [sym_false] = ACTIONS(2970),
    [sym_none] = ACTIONS(2970),
    [sym_comment] = ACTIONS(73),
  },
  [1065] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1437),
    [anon_sym_COMMA] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(991),
    [anon_sym_COLON] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2018),
    [anon_sym_not] = ACTIONS(2022),
    [anon_sym_and] = ACTIONS(991),
    [anon_sym_or] = ACTIONS(991),
    [anon_sym_LT] = ACTIONS(2034),
    [anon_sym_LT_EQ] = ACTIONS(2018),
    [anon_sym_EQ_EQ] = ACTIONS(2018),
    [anon_sym_BANG_EQ] = ACTIONS(2018),
    [anon_sym_GT_EQ] = ACTIONS(2018),
    [anon_sym_GT] = ACTIONS(2034),
    [anon_sym_LT_GT] = ACTIONS(2018),
    [anon_sym_is] = ACTIONS(2036),
    [anon_sym_RBRACK] = ACTIONS(991),
    [sym_comment] = ACTIONS(73),
  },
  [1066] = {
    [sym_string] = STATE(1438),
    [aux_sym_concatenated_string_repeat1] = STATE(1438),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_COLON] = ACTIONS(995),
    [anon_sym_in] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(995),
    [anon_sym_not] = ACTIONS(995),
    [anon_sym_and] = ACTIONS(995),
    [anon_sym_or] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(995),
    [anon_sym_SLASH_SLASH] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_GT] = ACTIONS(995),
    [anon_sym_is] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(995),
    [anon_sym_RBRACK] = ACTIONS(995),
    [sym_comment] = ACTIONS(73),
  },
  [1067] = {
    [anon_sym_if] = ACTIONS(1111),
    [anon_sym_and] = ACTIONS(1113),
    [anon_sym_or] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(1660),
    [sym_type_conversion] = ACTIONS(1660),
    [sym_comment] = ACTIONS(73),
  },
  [1068] = {
    [sym__expression] = STATE(1439),
    [sym__primary_expression] = STATE(204),
    [sym_not_operator] = STATE(1439),
    [sym_boolean_operator] = STATE(1439),
    [sym_binary_operator] = STATE(204),
    [sym_unary_operator] = STATE(204),
    [sym_comparison_operator] = STATE(1439),
    [sym_lambda] = STATE(1439),
    [sym_attribute] = STATE(204),
    [sym_subscript] = STATE(204),
    [sym_call] = STATE(204),
    [sym_list] = STATE(204),
    [sym_list_comprehension] = STATE(204),
    [sym_dictionary] = STATE(204),
    [sym_dictionary_comprehension] = STATE(204),
    [sym_set] = STATE(204),
    [sym_set_comprehension] = STATE(204),
    [sym_parenthesized_expression] = STATE(204),
    [sym_tuple] = STATE(204),
    [sym_generator_expression] = STATE(204),
    [sym_conditional_expression] = STATE(1439),
    [sym_concatenated_string] = STATE(204),
    [sym_string] = STATE(205),
    [sym_await] = STATE(1439),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(349),
    [anon_sym_PLUS] = ACTIONS(351),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_lambda] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_identifier] = ACTIONS(357),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_none] = ACTIONS(357),
    [anon_sym_await] = ACTIONS(359),
    [sym_comment] = ACTIONS(73),
  },
  [1069] = {
    [anon_sym_if] = ACTIONS(1925),
    [anon_sym_else] = ACTIONS(2992),
    [anon_sym_and] = ACTIONS(1929),
    [anon_sym_or] = ACTIONS(1931),
    [sym_comment] = ACTIONS(73),
  },
  [1070] = {
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_and] = ACTIONS(1113),
    [anon_sym_or] = ACTIONS(1957),
    [anon_sym_RBRACE] = ACTIONS(1957),
    [sym_type_conversion] = ACTIONS(1957),
    [sym_comment] = ACTIONS(73),
  },
  [1071] = {
    [sym__string_content] = ACTIONS(2994),
    [sym__string_end] = ACTIONS(2994),
    [anon_sym_LBRACE] = ACTIONS(2996),
    [sym_escape_sequence] = ACTIONS(2994),
    [sym_comment] = ACTIONS(81),
  },
  [1072] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1984),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1986),
    [anon_sym_PERCENT] = ACTIONS(1984),
    [anon_sym_SLASH_SLASH] = ACTIONS(1984),
    [anon_sym_STAR_STAR] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [sym_type_conversion] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1073] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1127),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1127),
    [anon_sym_SLASH_SLASH] = ACTIONS(1127),
    [anon_sym_STAR_STAR] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [sym_type_conversion] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1074] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_GT_GT] = ACTIONS(1123),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(1988),
    [anon_sym_AT] = ACTIONS(1127),
    [anon_sym_not] = ACTIONS(1988),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1127),
    [anon_sym_SLASH_SLASH] = ACTIONS(1127),
    [anon_sym_STAR_STAR] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1137),
    [anon_sym_CARET] = ACTIONS(1139),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1990),
    [anon_sym_LT_EQ] = ACTIONS(1988),
    [anon_sym_EQ_EQ] = ACTIONS(1988),
    [anon_sym_BANG_EQ] = ACTIONS(1988),
    [anon_sym_GT_EQ] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1990),
    [anon_sym_LT_GT] = ACTIONS(1988),
    [anon_sym_is] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(473),
    [anon_sym_RBRACE] = ACTIONS(1988),
    [sym_type_conversion] = ACTIONS(1988),
    [sym_comment] = ACTIONS(73),
  },
  [1075] = {
    [sym__primary_expression] = STATE(1441),
    [sym_binary_operator] = STATE(1441),
    [sym_unary_operator] = STATE(1441),
    [sym_attribute] = STATE(1441),
    [sym_subscript] = STATE(1441),
    [sym_call] = STATE(1441),
    [sym_list] = STATE(1441),
    [sym_list_comprehension] = STATE(1441),
    [sym_dictionary] = STATE(1441),
    [sym_dictionary_comprehension] = STATE(1441),
    [sym_set] = STATE(1441),
    [sym_set_comprehension] = STATE(1441),
    [sym_parenthesized_expression] = STATE(1441),
    [sym_tuple] = STATE(1441),
    [sym_generator_expression] = STATE(1441),
    [sym_concatenated_string] = STATE(1441),
    [sym_string] = STATE(205),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(351),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2998),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3000),
    [sym_float] = ACTIONS(3000),
    [sym_identifier] = ACTIONS(3000),
    [sym_true] = ACTIONS(3000),
    [sym_false] = ACTIONS(3000),
    [sym_none] = ACTIONS(3000),
    [sym_comment] = ACTIONS(73),
  },
  [1076] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1127),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1127),
    [anon_sym_SLASH_SLASH] = ACTIONS(1127),
    [anon_sym_STAR_STAR] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [sym_type_conversion] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1077] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_GT_GT] = ACTIONS(1123),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1127),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1127),
    [anon_sym_SLASH_SLASH] = ACTIONS(1127),
    [anon_sym_STAR_STAR] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1137),
    [anon_sym_CARET] = ACTIONS(1139),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [sym_type_conversion] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1078] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_GT_GT] = ACTIONS(1123),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1127),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1127),
    [anon_sym_SLASH_SLASH] = ACTIONS(1127),
    [anon_sym_STAR_STAR] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1139),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [sym_type_conversion] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1079] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_GT_GT] = ACTIONS(1123),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1127),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1127),
    [anon_sym_SLASH_SLASH] = ACTIONS(1127),
    [anon_sym_STAR_STAR] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [sym_type_conversion] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1080] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1080),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(3002),
    [anon_sym_not] = ACTIONS(3005),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(3008),
    [anon_sym_LT_EQ] = ACTIONS(3002),
    [anon_sym_EQ_EQ] = ACTIONS(3002),
    [anon_sym_BANG_EQ] = ACTIONS(3002),
    [anon_sym_GT_EQ] = ACTIONS(3002),
    [anon_sym_GT] = ACTIONS(3008),
    [anon_sym_LT_GT] = ACTIONS(3002),
    [anon_sym_is] = ACTIONS(3011),
    [anon_sym_RBRACE] = ACTIONS(1988),
    [sym_type_conversion] = ACTIONS(1988),
    [sym_comment] = ACTIONS(73),
  },
  [1081] = {
    [sym_string] = STATE(1081),
    [aux_sym_concatenated_string_repeat1] = STATE(1081),
    [sym__string_start] = ACTIONS(2241),
    [anon_sym_DOT] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2050),
    [anon_sym_if] = ACTIONS(2050),
    [anon_sym_in] = ACTIONS(2050),
    [anon_sym_AT] = ACTIONS(2050),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_and] = ACTIONS(2050),
    [anon_sym_or] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_SLASH] = ACTIONS(2055),
    [anon_sym_PERCENT] = ACTIONS(2050),
    [anon_sym_SLASH_SLASH] = ACTIONS(2050),
    [anon_sym_STAR_STAR] = ACTIONS(2050),
    [anon_sym_PIPE] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2050),
    [anon_sym_CARET] = ACTIONS(2050),
    [anon_sym_LT_LT] = ACTIONS(2050),
    [anon_sym_LT] = ACTIONS(2055),
    [anon_sym_LT_EQ] = ACTIONS(2050),
    [anon_sym_EQ_EQ] = ACTIONS(2050),
    [anon_sym_BANG_EQ] = ACTIONS(2050),
    [anon_sym_GT_EQ] = ACTIONS(2050),
    [anon_sym_GT] = ACTIONS(2055),
    [anon_sym_LT_GT] = ACTIONS(2050),
    [anon_sym_is] = ACTIONS(2050),
    [anon_sym_LBRACK] = ACTIONS(2050),
    [anon_sym_RBRACE] = ACTIONS(2050),
    [sym_type_conversion] = ACTIONS(2050),
    [sym_comment] = ACTIONS(73),
  },
  [1082] = {
    [sym_aliased_import] = STATE(594),
    [sym_dotted_name] = STATE(595),
    [sym_identifier] = ACTIONS(83),
    [sym_comment] = ACTIONS(73),
  },
  [1083] = {
    [aux_sym_dotted_name_repeat1] = STATE(1442),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym_RPAREN] = ACTIONS(365),
    [anon_sym_COMMA] = ACTIONS(365),
    [anon_sym_as] = ACTIONS(365),
    [sym_comment] = ACTIONS(73),
  },
  [1084] = {
    [anon_sym_RPAREN] = ACTIONS(3014),
    [sym_comment] = ACTIONS(73),
  },
  [1085] = {
    [aux_sym__import_list_repeat1] = STATE(1445),
    [anon_sym_RPAREN] = ACTIONS(371),
    [anon_sym_COMMA] = ACTIONS(3016),
    [sym_comment] = ACTIONS(73),
  },
  [1086] = {
    [aux_sym__import_list_repeat1] = STATE(1445),
    [anon_sym_RPAREN] = ACTIONS(371),
    [anon_sym_COMMA] = ACTIONS(3016),
    [anon_sym_as] = ACTIONS(3018),
    [sym_comment] = ACTIONS(73),
  },
  [1087] = {
    [anon_sym_DOT] = ACTIONS(2182),
    [anon_sym_LPAREN] = ACTIONS(2182),
    [anon_sym_RPAREN] = ACTIONS(2182),
    [anon_sym_COMMA] = ACTIONS(2182),
    [anon_sym_as] = ACTIONS(2184),
    [anon_sym_STAR] = ACTIONS(2184),
    [anon_sym_GT_GT] = ACTIONS(2182),
    [anon_sym_if] = ACTIONS(2182),
    [anon_sym_COLON] = ACTIONS(2182),
    [anon_sym_else] = ACTIONS(2182),
    [anon_sym_async] = ACTIONS(2182),
    [anon_sym_for] = ACTIONS(2182),
    [anon_sym_in] = ACTIONS(2182),
    [anon_sym_EQ] = ACTIONS(2184),
    [anon_sym_AT] = ACTIONS(2182),
    [anon_sym_not] = ACTIONS(2182),
    [anon_sym_and] = ACTIONS(2182),
    [anon_sym_or] = ACTIONS(2182),
    [anon_sym_PLUS] = ACTIONS(2182),
    [anon_sym_DASH] = ACTIONS(2182),
    [anon_sym_SLASH] = ACTIONS(2184),
    [anon_sym_PERCENT] = ACTIONS(2182),
    [anon_sym_SLASH_SLASH] = ACTIONS(2182),
    [anon_sym_STAR_STAR] = ACTIONS(2182),
    [anon_sym_PIPE] = ACTIONS(2182),
    [anon_sym_AMP] = ACTIONS(2182),
    [anon_sym_CARET] = ACTIONS(2182),
    [anon_sym_LT_LT] = ACTIONS(2182),
    [anon_sym_LT] = ACTIONS(2184),
    [anon_sym_LT_EQ] = ACTIONS(2182),
    [anon_sym_EQ_EQ] = ACTIONS(2182),
    [anon_sym_BANG_EQ] = ACTIONS(2182),
    [anon_sym_GT_EQ] = ACTIONS(2182),
    [anon_sym_GT] = ACTIONS(2184),
    [anon_sym_LT_GT] = ACTIONS(2182),
    [anon_sym_is] = ACTIONS(2182),
    [anon_sym_LBRACK] = ACTIONS(2182),
    [anon_sym_RBRACK] = ACTIONS(2182),
    [anon_sym_RBRACE] = ACTIONS(2182),
    [sym_type_conversion] = ACTIONS(2182),
    [sym_comment] = ACTIONS(73),
  },
  [1088] = {
    [anon_sym_DOT] = ACTIONS(2194),
    [anon_sym_LPAREN] = ACTIONS(2194),
    [anon_sym_RPAREN] = ACTIONS(2194),
    [anon_sym_COMMA] = ACTIONS(2194),
    [anon_sym_as] = ACTIONS(2196),
    [anon_sym_STAR] = ACTIONS(2196),
    [anon_sym_GT_GT] = ACTIONS(2194),
    [anon_sym_if] = ACTIONS(2194),
    [anon_sym_COLON] = ACTIONS(2194),
    [anon_sym_else] = ACTIONS(2194),
    [anon_sym_async] = ACTIONS(2194),
    [anon_sym_for] = ACTIONS(2194),
    [anon_sym_in] = ACTIONS(2194),
    [anon_sym_EQ] = ACTIONS(2196),
    [anon_sym_AT] = ACTIONS(2194),
    [anon_sym_not] = ACTIONS(2194),
    [anon_sym_and] = ACTIONS(2194),
    [anon_sym_or] = ACTIONS(2194),
    [anon_sym_PLUS] = ACTIONS(2194),
    [anon_sym_DASH] = ACTIONS(2194),
    [anon_sym_SLASH] = ACTIONS(2196),
    [anon_sym_PERCENT] = ACTIONS(2194),
    [anon_sym_SLASH_SLASH] = ACTIONS(2194),
    [anon_sym_STAR_STAR] = ACTIONS(2194),
    [anon_sym_PIPE] = ACTIONS(2194),
    [anon_sym_AMP] = ACTIONS(2194),
    [anon_sym_CARET] = ACTIONS(2194),
    [anon_sym_LT_LT] = ACTIONS(2194),
    [anon_sym_LT] = ACTIONS(2196),
    [anon_sym_LT_EQ] = ACTIONS(2194),
    [anon_sym_EQ_EQ] = ACTIONS(2194),
    [anon_sym_BANG_EQ] = ACTIONS(2194),
    [anon_sym_GT_EQ] = ACTIONS(2194),
    [anon_sym_GT] = ACTIONS(2196),
    [anon_sym_LT_GT] = ACTIONS(2194),
    [anon_sym_is] = ACTIONS(2194),
    [anon_sym_LBRACK] = ACTIONS(2194),
    [anon_sym_RBRACK] = ACTIONS(2194),
    [anon_sym_RBRACE] = ACTIONS(2194),
    [sym_type_conversion] = ACTIONS(2194),
    [sym_comment] = ACTIONS(73),
  },
  [1089] = {
    [sym__expression] = STATE(647),
    [sym__primary_expression] = STATE(237),
    [sym_not_operator] = STATE(647),
    [sym_boolean_operator] = STATE(647),
    [sym_binary_operator] = STATE(237),
    [sym_unary_operator] = STATE(237),
    [sym_comparison_operator] = STATE(647),
    [sym_lambda] = STATE(647),
    [sym_yield] = STATE(648),
    [sym_attribute] = STATE(237),
    [sym_subscript] = STATE(237),
    [sym_call] = STATE(237),
    [sym_list] = STATE(237),
    [sym_list_comprehension] = STATE(237),
    [sym_dictionary] = STATE(237),
    [sym_dictionary_comprehension] = STATE(237),
    [sym_set] = STATE(237),
    [sym_set_comprehension] = STATE(237),
    [sym_parenthesized_expression] = STATE(237),
    [sym_tuple] = STATE(237),
    [sym_generator_expression] = STATE(237),
    [sym_conditional_expression] = STATE(647),
    [sym_concatenated_string] = STATE(237),
    [sym_string] = STATE(238),
    [sym_await] = STATE(647),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3020),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_lambda] = ACTIONS(415),
    [anon_sym_yield] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(419),
    [sym_float] = ACTIONS(419),
    [sym_identifier] = ACTIONS(419),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_none] = ACTIONS(419),
    [anon_sym_await] = ACTIONS(421),
    [sym_comment] = ACTIONS(73),
  },
  [1090] = {
    [anon_sym_RPAREN] = ACTIONS(2647),
    [anon_sym_COMMA] = ACTIONS(2647),
    [anon_sym_if] = ACTIONS(435),
    [anon_sym_async] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2647),
    [anon_sym_and] = ACTIONS(441),
    [anon_sym_or] = ACTIONS(443),
    [sym_comment] = ACTIONS(73),
  },
  [1091] = {
    [anon_sym_RPAREN] = ACTIONS(1660),
    [anon_sym_COMMA] = ACTIONS(1660),
    [anon_sym_if] = ACTIONS(1198),
    [anon_sym_and] = ACTIONS(1200),
    [anon_sym_or] = ACTIONS(1202),
    [sym_comment] = ACTIONS(73),
  },
  [1092] = {
    [sym__expression] = STATE(1448),
    [sym__primary_expression] = STATE(237),
    [sym_not_operator] = STATE(1448),
    [sym_boolean_operator] = STATE(1448),
    [sym_binary_operator] = STATE(237),
    [sym_unary_operator] = STATE(237),
    [sym_comparison_operator] = STATE(1448),
    [sym_lambda] = STATE(1448),
    [sym_attribute] = STATE(237),
    [sym_subscript] = STATE(237),
    [sym_call] = STATE(237),
    [sym_list] = STATE(237),
    [sym_list_comprehension] = STATE(237),
    [sym_dictionary] = STATE(237),
    [sym_dictionary_comprehension] = STATE(237),
    [sym_set] = STATE(237),
    [sym_set_comprehension] = STATE(237),
    [sym_parenthesized_expression] = STATE(237),
    [sym_tuple] = STATE(237),
    [sym_generator_expression] = STATE(237),
    [sym_conditional_expression] = STATE(1448),
    [sym_concatenated_string] = STATE(237),
    [sym_string] = STATE(238),
    [sym_await] = STATE(1448),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_lambda] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(419),
    [sym_float] = ACTIONS(419),
    [sym_identifier] = ACTIONS(419),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_none] = ACTIONS(419),
    [anon_sym_await] = ACTIONS(421),
    [sym_comment] = ACTIONS(73),
  },
  [1093] = {
    [anon_sym_RPAREN] = ACTIONS(1921),
    [anon_sym_COMMA] = ACTIONS(1921),
    [anon_sym_if] = ACTIONS(1198),
    [anon_sym_and] = ACTIONS(1200),
    [anon_sym_or] = ACTIONS(1202),
    [sym_comment] = ACTIONS(73),
  },
  [1094] = {
    [anon_sym_if] = ACTIONS(1925),
    [anon_sym_else] = ACTIONS(3022),
    [anon_sym_and] = ACTIONS(1929),
    [anon_sym_or] = ACTIONS(1931),
    [sym_comment] = ACTIONS(73),
  },
  [1095] = {
    [anon_sym_RPAREN] = ACTIONS(1957),
    [anon_sym_COMMA] = ACTIONS(1957),
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_and] = ACTIONS(1200),
    [anon_sym_or] = ACTIONS(1957),
    [sym_comment] = ACTIONS(73),
  },
  [1096] = {
    [sym__expression] = STATE(1093),
    [sym__primary_expression] = STATE(237),
    [sym_not_operator] = STATE(1093),
    [sym_boolean_operator] = STATE(1093),
    [sym_binary_operator] = STATE(237),
    [sym_unary_operator] = STATE(237),
    [sym_comparison_operator] = STATE(1093),
    [sym_lambda] = STATE(1093),
    [sym_attribute] = STATE(237),
    [sym_subscript] = STATE(237),
    [sym_call] = STATE(237),
    [sym_list] = STATE(237),
    [sym_list_comprehension] = STATE(237),
    [sym_dictionary] = STATE(237),
    [sym_dictionary_comprehension] = STATE(237),
    [sym_set] = STATE(237),
    [sym_set_comprehension] = STATE(237),
    [sym_parenthesized_expression] = STATE(237),
    [sym_tuple] = STATE(237),
    [sym_generator_expression] = STATE(237),
    [sym_conditional_expression] = STATE(1093),
    [sym_concatenated_string] = STATE(237),
    [sym_string] = STATE(238),
    [sym_await] = STATE(1093),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(1961),
    [anon_sym_COMMA] = ACTIONS(1961),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_lambda] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(419),
    [sym_float] = ACTIONS(419),
    [sym_identifier] = ACTIONS(419),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_none] = ACTIONS(419),
    [anon_sym_await] = ACTIONS(421),
    [sym_comment] = ACTIONS(73),
  },
  [1097] = {
    [aux_sym_print_statement_repeat1] = STATE(1097),
    [anon_sym_RPAREN] = ACTIONS(1921),
    [anon_sym_COMMA] = ACTIONS(3024),
    [sym_comment] = ACTIONS(73),
  },
  [1098] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1984),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1986),
    [anon_sym_PERCENT] = ACTIONS(1984),
    [anon_sym_SLASH_SLASH] = ACTIONS(1984),
    [anon_sym_STAR_STAR] = ACTIONS(1216),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1099] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1204),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1210),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1214),
    [anon_sym_DASH] = ACTIONS(1214),
    [anon_sym_SLASH] = ACTIONS(1204),
    [anon_sym_PERCENT] = ACTIONS(1210),
    [anon_sym_SLASH_SLASH] = ACTIONS(1210),
    [anon_sym_STAR_STAR] = ACTIONS(1216),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1100] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(1988),
    [anon_sym_COMMA] = ACTIONS(1988),
    [anon_sym_STAR] = ACTIONS(1204),
    [anon_sym_GT_GT] = ACTIONS(1206),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(1988),
    [anon_sym_AT] = ACTIONS(1210),
    [anon_sym_not] = ACTIONS(1988),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_PLUS] = ACTIONS(1214),
    [anon_sym_DASH] = ACTIONS(1214),
    [anon_sym_SLASH] = ACTIONS(1204),
    [anon_sym_PERCENT] = ACTIONS(1210),
    [anon_sym_SLASH_SLASH] = ACTIONS(1210),
    [anon_sym_STAR_STAR] = ACTIONS(1216),
    [anon_sym_PIPE] = ACTIONS(1218),
    [anon_sym_AMP] = ACTIONS(1220),
    [anon_sym_CARET] = ACTIONS(1222),
    [anon_sym_LT_LT] = ACTIONS(1206),
    [anon_sym_LT] = ACTIONS(1990),
    [anon_sym_LT_EQ] = ACTIONS(1988),
    [anon_sym_EQ_EQ] = ACTIONS(1988),
    [anon_sym_BANG_EQ] = ACTIONS(1988),
    [anon_sym_GT_EQ] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1990),
    [anon_sym_LT_GT] = ACTIONS(1988),
    [anon_sym_is] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(473),
    [sym_comment] = ACTIONS(73),
  },
  [1101] = {
    [sym__primary_expression] = STATE(1451),
    [sym_binary_operator] = STATE(1451),
    [sym_unary_operator] = STATE(1451),
    [sym_attribute] = STATE(1451),
    [sym_subscript] = STATE(1451),
    [sym_call] = STATE(1451),
    [sym_list] = STATE(1451),
    [sym_list_comprehension] = STATE(1451),
    [sym_dictionary] = STATE(1451),
    [sym_dictionary_comprehension] = STATE(1451),
    [sym_set] = STATE(1451),
    [sym_set_comprehension] = STATE(1451),
    [sym_parenthesized_expression] = STATE(1451),
    [sym_tuple] = STATE(1451),
    [sym_generator_expression] = STATE(1451),
    [sym_concatenated_string] = STATE(1451),
    [sym_string] = STATE(238),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3027),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3029),
    [sym_float] = ACTIONS(3029),
    [sym_identifier] = ACTIONS(3029),
    [sym_true] = ACTIONS(3029),
    [sym_false] = ACTIONS(3029),
    [sym_none] = ACTIONS(3029),
    [sym_comment] = ACTIONS(73),
  },
  [1102] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1204),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1210),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1204),
    [anon_sym_PERCENT] = ACTIONS(1210),
    [anon_sym_SLASH_SLASH] = ACTIONS(1210),
    [anon_sym_STAR_STAR] = ACTIONS(1216),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1103] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1204),
    [anon_sym_GT_GT] = ACTIONS(1206),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1210),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1214),
    [anon_sym_DASH] = ACTIONS(1214),
    [anon_sym_SLASH] = ACTIONS(1204),
    [anon_sym_PERCENT] = ACTIONS(1210),
    [anon_sym_SLASH_SLASH] = ACTIONS(1210),
    [anon_sym_STAR_STAR] = ACTIONS(1216),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1220),
    [anon_sym_CARET] = ACTIONS(1222),
    [anon_sym_LT_LT] = ACTIONS(1206),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1104] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1204),
    [anon_sym_GT_GT] = ACTIONS(1206),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1210),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1214),
    [anon_sym_DASH] = ACTIONS(1214),
    [anon_sym_SLASH] = ACTIONS(1204),
    [anon_sym_PERCENT] = ACTIONS(1210),
    [anon_sym_SLASH_SLASH] = ACTIONS(1210),
    [anon_sym_STAR_STAR] = ACTIONS(1216),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1222),
    [anon_sym_LT_LT] = ACTIONS(1206),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1105] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1204),
    [anon_sym_GT_GT] = ACTIONS(1206),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1210),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1214),
    [anon_sym_DASH] = ACTIONS(1214),
    [anon_sym_SLASH] = ACTIONS(1204),
    [anon_sym_PERCENT] = ACTIONS(1210),
    [anon_sym_SLASH_SLASH] = ACTIONS(1210),
    [anon_sym_STAR_STAR] = ACTIONS(1216),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1206),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1106] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1106),
    [anon_sym_RPAREN] = ACTIONS(1988),
    [anon_sym_COMMA] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(3031),
    [anon_sym_not] = ACTIONS(3034),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(3037),
    [anon_sym_LT_EQ] = ACTIONS(3031),
    [anon_sym_EQ_EQ] = ACTIONS(3031),
    [anon_sym_BANG_EQ] = ACTIONS(3031),
    [anon_sym_GT_EQ] = ACTIONS(3031),
    [anon_sym_GT] = ACTIONS(3037),
    [anon_sym_LT_GT] = ACTIONS(3031),
    [anon_sym_is] = ACTIONS(3040),
    [sym_comment] = ACTIONS(73),
  },
  [1107] = {
    [sym_string] = STATE(1107),
    [aux_sym_concatenated_string_repeat1] = STATE(1107),
    [sym__string_start] = ACTIONS(2241),
    [anon_sym_DOT] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(2050),
    [anon_sym_RPAREN] = ACTIONS(2050),
    [anon_sym_COMMA] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2050),
    [anon_sym_if] = ACTIONS(2050),
    [anon_sym_in] = ACTIONS(2050),
    [anon_sym_AT] = ACTIONS(2050),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_and] = ACTIONS(2050),
    [anon_sym_or] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_SLASH] = ACTIONS(2055),
    [anon_sym_PERCENT] = ACTIONS(2050),
    [anon_sym_SLASH_SLASH] = ACTIONS(2050),
    [anon_sym_STAR_STAR] = ACTIONS(2050),
    [anon_sym_PIPE] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2050),
    [anon_sym_CARET] = ACTIONS(2050),
    [anon_sym_LT_LT] = ACTIONS(2050),
    [anon_sym_LT] = ACTIONS(2055),
    [anon_sym_LT_EQ] = ACTIONS(2050),
    [anon_sym_EQ_EQ] = ACTIONS(2050),
    [anon_sym_BANG_EQ] = ACTIONS(2050),
    [anon_sym_GT_EQ] = ACTIONS(2050),
    [anon_sym_GT] = ACTIONS(2055),
    [anon_sym_LT_GT] = ACTIONS(2050),
    [anon_sym_is] = ACTIONS(2050),
    [anon_sym_LBRACK] = ACTIONS(2050),
    [sym_comment] = ACTIONS(73),
  },
  [1108] = {
    [anon_sym_DOT] = ACTIONS(2683),
    [anon_sym_LPAREN] = ACTIONS(2683),
    [anon_sym_RPAREN] = ACTIONS(2683),
    [anon_sym_COMMA] = ACTIONS(2683),
    [anon_sym_as] = ACTIONS(2685),
    [anon_sym_STAR] = ACTIONS(2685),
    [anon_sym_GT_GT] = ACTIONS(2683),
    [anon_sym_if] = ACTIONS(2683),
    [anon_sym_COLON] = ACTIONS(2683),
    [anon_sym_else] = ACTIONS(2683),
    [anon_sym_async] = ACTIONS(2683),
    [anon_sym_for] = ACTIONS(2683),
    [anon_sym_in] = ACTIONS(2683),
    [anon_sym_EQ] = ACTIONS(2685),
    [anon_sym_AT] = ACTIONS(2683),
    [anon_sym_not] = ACTIONS(2683),
    [anon_sym_and] = ACTIONS(2683),
    [anon_sym_or] = ACTIONS(2683),
    [anon_sym_PLUS] = ACTIONS(2683),
    [anon_sym_DASH] = ACTIONS(2683),
    [anon_sym_SLASH] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2683),
    [anon_sym_SLASH_SLASH] = ACTIONS(2683),
    [anon_sym_STAR_STAR] = ACTIONS(2683),
    [anon_sym_PIPE] = ACTIONS(2683),
    [anon_sym_AMP] = ACTIONS(2683),
    [anon_sym_CARET] = ACTIONS(2683),
    [anon_sym_LT_LT] = ACTIONS(2683),
    [anon_sym_LT] = ACTIONS(2685),
    [anon_sym_LT_EQ] = ACTIONS(2683),
    [anon_sym_EQ_EQ] = ACTIONS(2683),
    [anon_sym_BANG_EQ] = ACTIONS(2683),
    [anon_sym_GT_EQ] = ACTIONS(2683),
    [anon_sym_GT] = ACTIONS(2685),
    [anon_sym_LT_GT] = ACTIONS(2683),
    [anon_sym_is] = ACTIONS(2683),
    [anon_sym_LBRACK] = ACTIONS(2683),
    [anon_sym_RBRACK] = ACTIONS(2683),
    [anon_sym_RBRACE] = ACTIONS(2683),
    [sym_type_conversion] = ACTIONS(2683),
    [sym_comment] = ACTIONS(73),
  },
  [1109] = {
    [sym_list_splat] = STATE(914),
    [sym__expression] = STATE(915),
    [sym__primary_expression] = STATE(452),
    [sym_not_operator] = STATE(915),
    [sym_boolean_operator] = STATE(915),
    [sym_binary_operator] = STATE(452),
    [sym_unary_operator] = STATE(452),
    [sym_comparison_operator] = STATE(915),
    [sym_lambda] = STATE(915),
    [sym_attribute] = STATE(452),
    [sym_subscript] = STATE(452),
    [sym_call] = STATE(452),
    [sym_list] = STATE(452),
    [sym_list_comprehension] = STATE(452),
    [sym_dictionary] = STATE(452),
    [sym_dictionary_comprehension] = STATE(452),
    [sym_set] = STATE(452),
    [sym_set_comprehension] = STATE(452),
    [sym_parenthesized_expression] = STATE(452),
    [sym_tuple] = STATE(452),
    [sym_generator_expression] = STATE(452),
    [sym_conditional_expression] = STATE(915),
    [sym_concatenated_string] = STATE(452),
    [sym_string] = STATE(453),
    [sym_await] = STATE(915),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(243),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_lambda] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(3043),
    [sym_ellipsis] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(773),
    [sym_float] = ACTIONS(773),
    [sym_identifier] = ACTIONS(773),
    [sym_true] = ACTIONS(773),
    [sym_false] = ACTIONS(773),
    [sym_none] = ACTIONS(773),
    [anon_sym_await] = ACTIONS(775),
    [sym_comment] = ACTIONS(73),
  },
  [1110] = {
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_LPAREN] = ACTIONS(2698),
    [anon_sym_RPAREN] = ACTIONS(2698),
    [anon_sym_COMMA] = ACTIONS(2698),
    [anon_sym_as] = ACTIONS(2700),
    [anon_sym_STAR] = ACTIONS(2700),
    [anon_sym_GT_GT] = ACTIONS(2698),
    [anon_sym_if] = ACTIONS(2698),
    [anon_sym_COLON] = ACTIONS(2698),
    [anon_sym_else] = ACTIONS(2698),
    [anon_sym_async] = ACTIONS(2698),
    [anon_sym_for] = ACTIONS(2698),
    [anon_sym_in] = ACTIONS(2698),
    [anon_sym_EQ] = ACTIONS(2700),
    [anon_sym_AT] = ACTIONS(2698),
    [anon_sym_not] = ACTIONS(2698),
    [anon_sym_and] = ACTIONS(2698),
    [anon_sym_or] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_DASH] = ACTIONS(2698),
    [anon_sym_SLASH] = ACTIONS(2700),
    [anon_sym_PERCENT] = ACTIONS(2698),
    [anon_sym_SLASH_SLASH] = ACTIONS(2698),
    [anon_sym_STAR_STAR] = ACTIONS(2698),
    [anon_sym_PIPE] = ACTIONS(2698),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_CARET] = ACTIONS(2698),
    [anon_sym_LT_LT] = ACTIONS(2698),
    [anon_sym_LT] = ACTIONS(2700),
    [anon_sym_LT_EQ] = ACTIONS(2698),
    [anon_sym_EQ_EQ] = ACTIONS(2698),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_GT_EQ] = ACTIONS(2698),
    [anon_sym_GT] = ACTIONS(2700),
    [anon_sym_LT_GT] = ACTIONS(2698),
    [anon_sym_is] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(2698),
    [anon_sym_RBRACK] = ACTIONS(2698),
    [anon_sym_RBRACE] = ACTIONS(2698),
    [sym_type_conversion] = ACTIONS(2698),
    [sym_comment] = ACTIONS(73),
  },
  [1111] = {
    [anon_sym_DOT] = ACTIONS(2764),
    [anon_sym_LPAREN] = ACTIONS(2764),
    [anon_sym_RPAREN] = ACTIONS(2764),
    [anon_sym_COMMA] = ACTIONS(2764),
    [anon_sym_as] = ACTIONS(2766),
    [anon_sym_STAR] = ACTIONS(2766),
    [anon_sym_GT_GT] = ACTIONS(2764),
    [anon_sym_if] = ACTIONS(2764),
    [anon_sym_COLON] = ACTIONS(2764),
    [anon_sym_else] = ACTIONS(2764),
    [anon_sym_async] = ACTIONS(2764),
    [anon_sym_for] = ACTIONS(2764),
    [anon_sym_in] = ACTIONS(2764),
    [anon_sym_EQ] = ACTIONS(2766),
    [anon_sym_AT] = ACTIONS(2764),
    [anon_sym_not] = ACTIONS(2764),
    [anon_sym_and] = ACTIONS(2764),
    [anon_sym_or] = ACTIONS(2764),
    [anon_sym_PLUS] = ACTIONS(2764),
    [anon_sym_DASH] = ACTIONS(2764),
    [anon_sym_SLASH] = ACTIONS(2766),
    [anon_sym_PERCENT] = ACTIONS(2764),
    [anon_sym_SLASH_SLASH] = ACTIONS(2764),
    [anon_sym_STAR_STAR] = ACTIONS(2764),
    [anon_sym_PIPE] = ACTIONS(2764),
    [anon_sym_AMP] = ACTIONS(2764),
    [anon_sym_CARET] = ACTIONS(2764),
    [anon_sym_LT_LT] = ACTIONS(2764),
    [anon_sym_LT] = ACTIONS(2766),
    [anon_sym_LT_EQ] = ACTIONS(2764),
    [anon_sym_EQ_EQ] = ACTIONS(2764),
    [anon_sym_BANG_EQ] = ACTIONS(2764),
    [anon_sym_GT_EQ] = ACTIONS(2764),
    [anon_sym_GT] = ACTIONS(2766),
    [anon_sym_LT_GT] = ACTIONS(2764),
    [anon_sym_is] = ACTIONS(2764),
    [anon_sym_LBRACK] = ACTIONS(2764),
    [anon_sym_RBRACK] = ACTIONS(2764),
    [anon_sym_RBRACE] = ACTIONS(2764),
    [sym_type_conversion] = ACTIONS(2764),
    [sym_comment] = ACTIONS(73),
  },
  [1112] = {
    [sym_list_splat] = STATE(914),
    [sym__expression] = STATE(958),
    [sym__primary_expression] = STATE(485),
    [sym_not_operator] = STATE(958),
    [sym_boolean_operator] = STATE(958),
    [sym_binary_operator] = STATE(485),
    [sym_unary_operator] = STATE(485),
    [sym_comparison_operator] = STATE(958),
    [sym_lambda] = STATE(958),
    [sym_attribute] = STATE(485),
    [sym_subscript] = STATE(485),
    [sym_call] = STATE(485),
    [sym_list] = STATE(485),
    [sym_list_comprehension] = STATE(485),
    [sym_dictionary] = STATE(485),
    [sym_dictionary_comprehension] = STATE(485),
    [sym_set] = STATE(485),
    [sym_set_comprehension] = STATE(485),
    [sym_parenthesized_expression] = STATE(485),
    [sym_tuple] = STATE(485),
    [sym_generator_expression] = STATE(485),
    [sym_conditional_expression] = STATE(958),
    [sym_concatenated_string] = STATE(485),
    [sym_string] = STATE(486),
    [sym_await] = STATE(958),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(1798),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(823),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_TILDE] = ACTIONS(825),
    [anon_sym_lambda] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(829),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(3045),
    [sym_integer] = ACTIONS(831),
    [sym_float] = ACTIONS(831),
    [sym_identifier] = ACTIONS(831),
    [sym_true] = ACTIONS(831),
    [sym_false] = ACTIONS(831),
    [sym_none] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [sym_comment] = ACTIONS(73),
  },
  [1113] = {
    [anon_sym_DOT] = ACTIONS(2773),
    [anon_sym_LPAREN] = ACTIONS(2773),
    [anon_sym_RPAREN] = ACTIONS(2773),
    [anon_sym_COMMA] = ACTIONS(2773),
    [anon_sym_as] = ACTIONS(2775),
    [anon_sym_STAR] = ACTIONS(2775),
    [anon_sym_GT_GT] = ACTIONS(2773),
    [anon_sym_if] = ACTIONS(2773),
    [anon_sym_COLON] = ACTIONS(2773),
    [anon_sym_else] = ACTIONS(2773),
    [anon_sym_async] = ACTIONS(2773),
    [anon_sym_for] = ACTIONS(2773),
    [anon_sym_in] = ACTIONS(2773),
    [anon_sym_EQ] = ACTIONS(2775),
    [anon_sym_AT] = ACTIONS(2773),
    [anon_sym_not] = ACTIONS(2773),
    [anon_sym_and] = ACTIONS(2773),
    [anon_sym_or] = ACTIONS(2773),
    [anon_sym_PLUS] = ACTIONS(2773),
    [anon_sym_DASH] = ACTIONS(2773),
    [anon_sym_SLASH] = ACTIONS(2775),
    [anon_sym_PERCENT] = ACTIONS(2773),
    [anon_sym_SLASH_SLASH] = ACTIONS(2773),
    [anon_sym_STAR_STAR] = ACTIONS(2773),
    [anon_sym_PIPE] = ACTIONS(2773),
    [anon_sym_AMP] = ACTIONS(2773),
    [anon_sym_CARET] = ACTIONS(2773),
    [anon_sym_LT_LT] = ACTIONS(2773),
    [anon_sym_LT] = ACTIONS(2775),
    [anon_sym_LT_EQ] = ACTIONS(2773),
    [anon_sym_EQ_EQ] = ACTIONS(2773),
    [anon_sym_BANG_EQ] = ACTIONS(2773),
    [anon_sym_GT_EQ] = ACTIONS(2773),
    [anon_sym_GT] = ACTIONS(2775),
    [anon_sym_LT_GT] = ACTIONS(2773),
    [anon_sym_is] = ACTIONS(2773),
    [anon_sym_LBRACK] = ACTIONS(2773),
    [anon_sym_RBRACK] = ACTIONS(2773),
    [anon_sym_RBRACE] = ACTIONS(2773),
    [sym_type_conversion] = ACTIONS(2773),
    [sym_comment] = ACTIONS(73),
  },
  [1114] = {
    [sym_dictionary_splat] = STATE(963),
    [sym__expression] = STATE(964),
    [sym__primary_expression] = STATE(102),
    [sym_not_operator] = STATE(964),
    [sym_boolean_operator] = STATE(964),
    [sym_binary_operator] = STATE(102),
    [sym_unary_operator] = STATE(102),
    [sym_comparison_operator] = STATE(964),
    [sym_lambda] = STATE(964),
    [sym_attribute] = STATE(102),
    [sym_subscript] = STATE(102),
    [sym_call] = STATE(102),
    [sym_list] = STATE(102),
    [sym_list_comprehension] = STATE(102),
    [sym_dictionary] = STATE(102),
    [sym_dictionary_comprehension] = STATE(102),
    [sym_pair] = STATE(963),
    [sym_set] = STATE(102),
    [sym_set_comprehension] = STATE(102),
    [sym_parenthesized_expression] = STATE(102),
    [sym_tuple] = STATE(102),
    [sym_generator_expression] = STATE(102),
    [sym_conditional_expression] = STATE(964),
    [sym_concatenated_string] = STATE(102),
    [sym_string] = STATE(103),
    [sym_await] = STATE(964),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(1808),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(3047),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [1115] = {
    [anon_sym_DOT] = ACTIONS(2824),
    [anon_sym_LPAREN] = ACTIONS(2824),
    [anon_sym_RPAREN] = ACTIONS(2824),
    [anon_sym_COMMA] = ACTIONS(2824),
    [anon_sym_as] = ACTIONS(2826),
    [anon_sym_STAR] = ACTIONS(2826),
    [anon_sym_GT_GT] = ACTIONS(2824),
    [anon_sym_if] = ACTIONS(2824),
    [anon_sym_COLON] = ACTIONS(2824),
    [anon_sym_else] = ACTIONS(2824),
    [anon_sym_async] = ACTIONS(2824),
    [anon_sym_for] = ACTIONS(2824),
    [anon_sym_in] = ACTIONS(2824),
    [anon_sym_EQ] = ACTIONS(2826),
    [anon_sym_AT] = ACTIONS(2824),
    [anon_sym_not] = ACTIONS(2824),
    [anon_sym_and] = ACTIONS(2824),
    [anon_sym_or] = ACTIONS(2824),
    [anon_sym_PLUS] = ACTIONS(2824),
    [anon_sym_DASH] = ACTIONS(2824),
    [anon_sym_SLASH] = ACTIONS(2826),
    [anon_sym_PERCENT] = ACTIONS(2824),
    [anon_sym_SLASH_SLASH] = ACTIONS(2824),
    [anon_sym_STAR_STAR] = ACTIONS(2824),
    [anon_sym_PIPE] = ACTIONS(2824),
    [anon_sym_AMP] = ACTIONS(2824),
    [anon_sym_CARET] = ACTIONS(2824),
    [anon_sym_LT_LT] = ACTIONS(2824),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_LT_EQ] = ACTIONS(2824),
    [anon_sym_EQ_EQ] = ACTIONS(2824),
    [anon_sym_BANG_EQ] = ACTIONS(2824),
    [anon_sym_GT_EQ] = ACTIONS(2824),
    [anon_sym_GT] = ACTIONS(2826),
    [anon_sym_LT_GT] = ACTIONS(2824),
    [anon_sym_is] = ACTIONS(2824),
    [anon_sym_LBRACK] = ACTIONS(2824),
    [anon_sym_RBRACK] = ACTIONS(2824),
    [anon_sym_RBRACE] = ACTIONS(2824),
    [sym_type_conversion] = ACTIONS(2824),
    [sym_comment] = ACTIONS(73),
  },
  [1116] = {
    [anon_sym_DOT] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [anon_sym_RPAREN] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(2856),
    [anon_sym_as] = ACTIONS(2858),
    [anon_sym_STAR] = ACTIONS(2858),
    [anon_sym_GT_GT] = ACTIONS(2856),
    [anon_sym_if] = ACTIONS(2856),
    [anon_sym_COLON] = ACTIONS(2856),
    [anon_sym_else] = ACTIONS(2856),
    [anon_sym_async] = ACTIONS(2856),
    [anon_sym_for] = ACTIONS(2856),
    [anon_sym_in] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(2858),
    [anon_sym_AT] = ACTIONS(2856),
    [anon_sym_not] = ACTIONS(2856),
    [anon_sym_and] = ACTIONS(2856),
    [anon_sym_or] = ACTIONS(2856),
    [anon_sym_PLUS] = ACTIONS(2856),
    [anon_sym_DASH] = ACTIONS(2856),
    [anon_sym_SLASH] = ACTIONS(2858),
    [anon_sym_PERCENT] = ACTIONS(2856),
    [anon_sym_SLASH_SLASH] = ACTIONS(2856),
    [anon_sym_STAR_STAR] = ACTIONS(2856),
    [anon_sym_PIPE] = ACTIONS(2856),
    [anon_sym_AMP] = ACTIONS(2856),
    [anon_sym_CARET] = ACTIONS(2856),
    [anon_sym_LT_LT] = ACTIONS(2856),
    [anon_sym_LT] = ACTIONS(2858),
    [anon_sym_LT_EQ] = ACTIONS(2856),
    [anon_sym_EQ_EQ] = ACTIONS(2856),
    [anon_sym_BANG_EQ] = ACTIONS(2856),
    [anon_sym_GT_EQ] = ACTIONS(2856),
    [anon_sym_GT] = ACTIONS(2858),
    [anon_sym_LT_GT] = ACTIONS(2856),
    [anon_sym_is] = ACTIONS(2856),
    [anon_sym_LBRACK] = ACTIONS(2856),
    [anon_sym_RBRACK] = ACTIONS(2856),
    [anon_sym_RBRACE] = ACTIONS(2856),
    [sym_type_conversion] = ACTIONS(2856),
    [sym_comment] = ACTIONS(73),
  },
  [1117] = {
    [sym__expression] = STATE(1455),
    [sym__primary_expression] = STATE(67),
    [sym_not_operator] = STATE(1455),
    [sym_boolean_operator] = STATE(1455),
    [sym_binary_operator] = STATE(67),
    [sym_unary_operator] = STATE(67),
    [sym_comparison_operator] = STATE(1455),
    [sym_lambda] = STATE(1455),
    [sym_attribute] = STATE(67),
    [sym_subscript] = STATE(67),
    [sym_call] = STATE(67),
    [sym_list] = STATE(67),
    [sym_list_comprehension] = STATE(67),
    [sym_dictionary] = STATE(67),
    [sym_dictionary_comprehension] = STATE(67),
    [sym_set] = STATE(67),
    [sym_set_comprehension] = STATE(67),
    [sym_parenthesized_expression] = STATE(67),
    [sym_tuple] = STATE(67),
    [sym_generator_expression] = STATE(67),
    [sym_conditional_expression] = STATE(1455),
    [sym_concatenated_string] = STATE(67),
    [sym_string] = STATE(69),
    [sym_await] = STATE(1455),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [1118] = {
    [anon_sym_in] = ACTIONS(3049),
    [sym_comment] = ACTIONS(73),
  },
  [1119] = {
    [sym__expression_within_for_in_clause] = STATE(1458),
    [sym__expression] = STATE(1459),
    [sym__primary_expression] = STATE(67),
    [sym_not_operator] = STATE(1459),
    [sym_boolean_operator] = STATE(1459),
    [sym_binary_operator] = STATE(67),
    [sym_unary_operator] = STATE(67),
    [sym_comparison_operator] = STATE(1459),
    [sym_lambda] = STATE(1459),
    [sym_lambda_within_for_in_clause] = STATE(1458),
    [sym_attribute] = STATE(67),
    [sym_subscript] = STATE(67),
    [sym_call] = STATE(67),
    [sym_list] = STATE(67),
    [sym_list_comprehension] = STATE(67),
    [sym_dictionary] = STATE(67),
    [sym_dictionary_comprehension] = STATE(67),
    [sym_set] = STATE(67),
    [sym_set_comprehension] = STATE(67),
    [sym_parenthesized_expression] = STATE(67),
    [sym_tuple] = STATE(67),
    [sym_generator_expression] = STATE(67),
    [sym_conditional_expression] = STATE(1459),
    [sym_concatenated_string] = STATE(67),
    [sym_string] = STATE(69),
    [sym_await] = STATE(1459),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(3051),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [1120] = {
    [sym__expression] = STATE(1460),
    [sym__primary_expression] = STATE(1125),
    [sym_not_operator] = STATE(1460),
    [sym_boolean_operator] = STATE(1460),
    [sym_binary_operator] = STATE(1125),
    [sym_unary_operator] = STATE(1125),
    [sym_comparison_operator] = STATE(1460),
    [sym_lambda] = STATE(1460),
    [sym_attribute] = STATE(1125),
    [sym_subscript] = STATE(1125),
    [sym_call] = STATE(1125),
    [sym_list] = STATE(1125),
    [sym_list_comprehension] = STATE(1125),
    [sym_dictionary] = STATE(1125),
    [sym_dictionary_comprehension] = STATE(1125),
    [sym_set] = STATE(1125),
    [sym_set_comprehension] = STATE(1125),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_tuple] = STATE(1125),
    [sym_generator_expression] = STATE(1125),
    [sym_conditional_expression] = STATE(1460),
    [sym_concatenated_string] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_await] = STATE(1460),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2198),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2200),
    [anon_sym_TILDE] = ACTIONS(2200),
    [anon_sym_lambda] = ACTIONS(2202),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2204),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2206),
    [sym_float] = ACTIONS(2206),
    [sym_identifier] = ACTIONS(2206),
    [sym_true] = ACTIONS(2206),
    [sym_false] = ACTIONS(2206),
    [sym_none] = ACTIONS(2206),
    [anon_sym_await] = ACTIONS(2208),
    [sym_comment] = ACTIONS(73),
  },
  [1121] = {
    [sym__primary_expression] = STATE(227),
    [sym_binary_operator] = STATE(227),
    [sym_unary_operator] = STATE(227),
    [sym_attribute] = STATE(227),
    [sym_subscript] = STATE(227),
    [sym_call] = STATE(227),
    [sym_list] = STATE(227),
    [sym_list_comprehension] = STATE(227),
    [sym_dictionary] = STATE(227),
    [sym_dictionary_comprehension] = STATE(227),
    [sym_set] = STATE(227),
    [sym_set_comprehension] = STATE(227),
    [sym_parenthesized_expression] = STATE(227),
    [sym_tuple] = STATE(227),
    [sym_generator_expression] = STATE(227),
    [sym_concatenated_string] = STATE(227),
    [sym_string] = STATE(1126),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2200),
    [anon_sym_TILDE] = ACTIONS(2200),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(403),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(405),
    [sym_float] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_true] = ACTIONS(405),
    [sym_false] = ACTIONS(405),
    [sym_none] = ACTIONS(405),
    [sym_comment] = ACTIONS(73),
  },
  [1122] = {
    [sym_lambda_parameters] = STATE(1462),
    [sym__parameters] = STATE(138),
    [sym_default_parameter] = STATE(139),
    [sym_typed_default_parameter] = STATE(139),
    [sym_list_splat] = STATE(140),
    [sym_dictionary_splat] = STATE(140),
    [sym_typed_parameter] = STATE(139),
    [sym_tuple] = STATE(139),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(3053),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [1123] = {
    [sym__expression] = STATE(249),
    [sym__primary_expression] = STATE(1125),
    [sym_not_operator] = STATE(249),
    [sym_boolean_operator] = STATE(249),
    [sym_binary_operator] = STATE(1125),
    [sym_unary_operator] = STATE(1125),
    [sym_comparison_operator] = STATE(249),
    [sym_lambda] = STATE(249),
    [sym_attribute] = STATE(1125),
    [sym_subscript] = STATE(1125),
    [sym_call] = STATE(1125),
    [sym_list] = STATE(1125),
    [sym_list_comprehension] = STATE(1125),
    [sym_dictionary] = STATE(1125),
    [sym_dictionary_comprehension] = STATE(1125),
    [sym_set] = STATE(1125),
    [sym_set_comprehension] = STATE(1125),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_tuple] = STATE(1125),
    [sym_generator_expression] = STATE(1125),
    [sym_conditional_expression] = STATE(249),
    [sym_concatenated_string] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_await] = STATE(249),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2198),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2200),
    [anon_sym_TILDE] = ACTIONS(2200),
    [anon_sym_lambda] = ACTIONS(2202),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2204),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2206),
    [sym_float] = ACTIONS(2206),
    [sym_identifier] = ACTIONS(2206),
    [sym_true] = ACTIONS(2206),
    [sym_false] = ACTIONS(2206),
    [sym_none] = ACTIONS(2206),
    [anon_sym_await] = ACTIONS(2208),
    [sym_comment] = ACTIONS(73),
  },
  [1124] = {
    [anon_sym_RPAREN] = ACTIONS(3055),
    [anon_sym_if] = ACTIONS(3055),
    [anon_sym_async] = ACTIONS(3055),
    [anon_sym_for] = ACTIONS(3055),
    [anon_sym_and] = ACTIONS(3057),
    [anon_sym_or] = ACTIONS(3059),
    [sym_comment] = ACTIONS(73),
  },
  [1125] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [aux_sym_comparison_operator_repeat1] = STATE(1476),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(3061),
    [anon_sym_GT_GT] = ACTIONS(3063),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(3065),
    [anon_sym_AT] = ACTIONS(3067),
    [anon_sym_not] = ACTIONS(3069),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_SLASH] = ACTIONS(3061),
    [anon_sym_PERCENT] = ACTIONS(3067),
    [anon_sym_SLASH_SLASH] = ACTIONS(3067),
    [anon_sym_STAR_STAR] = ACTIONS(3073),
    [anon_sym_PIPE] = ACTIONS(3075),
    [anon_sym_AMP] = ACTIONS(3077),
    [anon_sym_CARET] = ACTIONS(3079),
    [anon_sym_LT_LT] = ACTIONS(3063),
    [anon_sym_LT] = ACTIONS(3081),
    [anon_sym_LT_EQ] = ACTIONS(3065),
    [anon_sym_EQ_EQ] = ACTIONS(3065),
    [anon_sym_BANG_EQ] = ACTIONS(3065),
    [anon_sym_GT_EQ] = ACTIONS(3065),
    [anon_sym_GT] = ACTIONS(3081),
    [anon_sym_LT_GT] = ACTIONS(3065),
    [anon_sym_is] = ACTIONS(3083),
    [anon_sym_LBRACK] = ACTIONS(473),
    [sym_comment] = ACTIONS(73),
  },
  [1126] = {
    [sym_string] = STATE(1477),
    [aux_sym_concatenated_string_repeat1] = STATE(1477),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_RPAREN] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_async] = ACTIONS(333),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [1127] = {
    [sym_for_in_clause] = STATE(1127),
    [sym_if_clause] = STATE(1127),
    [aux_sym__comprehension_body_repeat1] = STATE(1127),
    [anon_sym_RPAREN] = ACTIONS(3085),
    [anon_sym_if] = ACTIONS(3087),
    [anon_sym_async] = ACTIONS(3090),
    [anon_sym_for] = ACTIONS(3093),
    [sym_comment] = ACTIONS(73),
  },
  [1128] = {
    [sym__newline] = ACTIONS(3096),
    [anon_sym_DOT] = ACTIONS(3096),
    [anon_sym_LPAREN] = ACTIONS(3096),
    [anon_sym_COMMA] = ACTIONS(3096),
    [anon_sym_STAR] = ACTIONS(3098),
    [anon_sym_GT_GT] = ACTIONS(3098),
    [anon_sym_if] = ACTIONS(3096),
    [anon_sym_COLON] = ACTIONS(3096),
    [anon_sym_in] = ACTIONS(3096),
    [anon_sym_EQ] = ACTIONS(3098),
    [anon_sym_AT] = ACTIONS(3098),
    [anon_sym_not] = ACTIONS(3096),
    [anon_sym_and] = ACTIONS(3096),
    [anon_sym_or] = ACTIONS(3096),
    [anon_sym_PLUS] = ACTIONS(3098),
    [anon_sym_DASH] = ACTIONS(3098),
    [anon_sym_SLASH] = ACTIONS(3098),
    [anon_sym_PERCENT] = ACTIONS(3098),
    [anon_sym_SLASH_SLASH] = ACTIONS(3098),
    [anon_sym_STAR_STAR] = ACTIONS(3098),
    [anon_sym_PIPE] = ACTIONS(3098),
    [anon_sym_AMP] = ACTIONS(3098),
    [anon_sym_CARET] = ACTIONS(3098),
    [anon_sym_LT_LT] = ACTIONS(3098),
    [anon_sym_LT] = ACTIONS(3098),
    [anon_sym_LT_EQ] = ACTIONS(3096),
    [anon_sym_EQ_EQ] = ACTIONS(3096),
    [anon_sym_BANG_EQ] = ACTIONS(3096),
    [anon_sym_GT_EQ] = ACTIONS(3096),
    [anon_sym_GT] = ACTIONS(3098),
    [anon_sym_LT_GT] = ACTIONS(3096),
    [anon_sym_is] = ACTIONS(3096),
    [anon_sym_PLUS_EQ] = ACTIONS(3096),
    [anon_sym_DASH_EQ] = ACTIONS(3096),
    [anon_sym_STAR_EQ] = ACTIONS(3096),
    [anon_sym_SLASH_EQ] = ACTIONS(3096),
    [anon_sym_AT_EQ] = ACTIONS(3096),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3096),
    [anon_sym_PERCENT_EQ] = ACTIONS(3096),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3096),
    [anon_sym_GT_GT_EQ] = ACTIONS(3096),
    [anon_sym_LT_LT_EQ] = ACTIONS(3096),
    [anon_sym_AMP_EQ] = ACTIONS(3096),
    [anon_sym_CARET_EQ] = ACTIONS(3096),
    [anon_sym_PIPE_EQ] = ACTIONS(3096),
    [anon_sym_LBRACK] = ACTIONS(3096),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3096),
  },
  [1129] = {
    [sym__expression] = STATE(647),
    [sym__primary_expression] = STATE(237),
    [sym_not_operator] = STATE(647),
    [sym_boolean_operator] = STATE(647),
    [sym_binary_operator] = STATE(237),
    [sym_unary_operator] = STATE(237),
    [sym_comparison_operator] = STATE(647),
    [sym_lambda] = STATE(647),
    [sym_yield] = STATE(648),
    [sym_attribute] = STATE(237),
    [sym_subscript] = STATE(237),
    [sym_call] = STATE(237),
    [sym_list] = STATE(237),
    [sym_list_comprehension] = STATE(237),
    [sym_dictionary] = STATE(237),
    [sym_dictionary_comprehension] = STATE(237),
    [sym_set] = STATE(237),
    [sym_set_comprehension] = STATE(237),
    [sym_parenthesized_expression] = STATE(237),
    [sym_tuple] = STATE(237),
    [sym_generator_expression] = STATE(237),
    [sym_conditional_expression] = STATE(647),
    [sym_concatenated_string] = STATE(237),
    [sym_string] = STATE(238),
    [sym_await] = STATE(647),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_lambda] = ACTIONS(415),
    [anon_sym_yield] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(419),
    [sym_float] = ACTIONS(419),
    [sym_identifier] = ACTIONS(419),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_none] = ACTIONS(419),
    [anon_sym_await] = ACTIONS(421),
    [sym_comment] = ACTIONS(73),
  },
  [1130] = {
    [anon_sym_DOT] = ACTIONS(2934),
    [anon_sym_LPAREN] = ACTIONS(2934),
    [anon_sym_RPAREN] = ACTIONS(2934),
    [anon_sym_COMMA] = ACTIONS(2934),
    [anon_sym_as] = ACTIONS(2936),
    [anon_sym_STAR] = ACTIONS(2936),
    [anon_sym_GT_GT] = ACTIONS(2934),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_COLON] = ACTIONS(2934),
    [anon_sym_else] = ACTIONS(2934),
    [anon_sym_async] = ACTIONS(2934),
    [anon_sym_for] = ACTIONS(2934),
    [anon_sym_in] = ACTIONS(2934),
    [anon_sym_EQ] = ACTIONS(2936),
    [anon_sym_AT] = ACTIONS(2934),
    [anon_sym_not] = ACTIONS(2934),
    [anon_sym_and] = ACTIONS(2934),
    [anon_sym_or] = ACTIONS(2934),
    [anon_sym_PLUS] = ACTIONS(2934),
    [anon_sym_DASH] = ACTIONS(2934),
    [anon_sym_SLASH] = ACTIONS(2936),
    [anon_sym_PERCENT] = ACTIONS(2934),
    [anon_sym_SLASH_SLASH] = ACTIONS(2934),
    [anon_sym_STAR_STAR] = ACTIONS(2934),
    [anon_sym_PIPE] = ACTIONS(2934),
    [anon_sym_AMP] = ACTIONS(2934),
    [anon_sym_CARET] = ACTIONS(2934),
    [anon_sym_LT_LT] = ACTIONS(2934),
    [anon_sym_LT] = ACTIONS(2936),
    [anon_sym_LT_EQ] = ACTIONS(2934),
    [anon_sym_EQ_EQ] = ACTIONS(2934),
    [anon_sym_BANG_EQ] = ACTIONS(2934),
    [anon_sym_GT_EQ] = ACTIONS(2934),
    [anon_sym_GT] = ACTIONS(2936),
    [anon_sym_LT_GT] = ACTIONS(2934),
    [anon_sym_is] = ACTIONS(2934),
    [anon_sym_LBRACK] = ACTIONS(2934),
    [anon_sym_RBRACK] = ACTIONS(2934),
    [anon_sym_RBRACE] = ACTIONS(2934),
    [sym_type_conversion] = ACTIONS(2934),
    [sym_comment] = ACTIONS(73),
  },
  [1131] = {
    [sym_list_splat] = STATE(1413),
    [sym_dictionary_splat] = STATE(1413),
    [sym__expression] = STATE(1414),
    [sym__primary_expression] = STATE(237),
    [sym_not_operator] = STATE(1414),
    [sym_boolean_operator] = STATE(1414),
    [sym_binary_operator] = STATE(237),
    [sym_unary_operator] = STATE(237),
    [sym_comparison_operator] = STATE(1414),
    [sym_lambda] = STATE(1414),
    [sym_attribute] = STATE(237),
    [sym_subscript] = STATE(237),
    [sym_call] = STATE(237),
    [sym_keyword_argument] = STATE(1413),
    [sym_list] = STATE(237),
    [sym_list_comprehension] = STATE(237),
    [sym_dictionary] = STATE(237),
    [sym_dictionary_comprehension] = STATE(237),
    [sym_set] = STATE(237),
    [sym_set_comprehension] = STATE(237),
    [sym_parenthesized_expression] = STATE(237),
    [sym_tuple] = STATE(237),
    [sym_generator_expression] = STATE(237),
    [sym_conditional_expression] = STATE(1414),
    [sym_concatenated_string] = STATE(237),
    [sym_string] = STATE(238),
    [sym_await] = STATE(1414),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3100),
    [anon_sym_STAR] = ACTIONS(931),
    [anon_sym_print] = ACTIONS(933),
    [anon_sym_exec] = ACTIONS(933),
    [anon_sym_not] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_lambda] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(419),
    [sym_float] = ACTIONS(419),
    [sym_identifier] = ACTIONS(935),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_none] = ACTIONS(419),
    [anon_sym_await] = ACTIONS(421),
    [sym_comment] = ACTIONS(73),
  },
  [1132] = {
    [aux_sym_argument_list_repeat1] = STATE(1416),
    [anon_sym_RPAREN] = ACTIONS(3100),
    [anon_sym_COMMA] = ACTIONS(3102),
    [sym_comment] = ACTIONS(73),
  },
  [1133] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(2942),
    [anon_sym_COMMA] = ACTIONS(2942),
    [anon_sym_STAR] = ACTIONS(449),
    [anon_sym_GT_GT] = ACTIONS(451),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_async] = ACTIONS(2942),
    [anon_sym_for] = ACTIONS(2942),
    [anon_sym_in] = ACTIONS(2942),
    [anon_sym_AT] = ACTIONS(455),
    [anon_sym_not] = ACTIONS(2942),
    [anon_sym_and] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(459),
    [anon_sym_DASH] = ACTIONS(459),
    [anon_sym_SLASH] = ACTIONS(449),
    [anon_sym_PERCENT] = ACTIONS(455),
    [anon_sym_SLASH_SLASH] = ACTIONS(455),
    [anon_sym_STAR_STAR] = ACTIONS(461),
    [anon_sym_PIPE] = ACTIONS(463),
    [anon_sym_AMP] = ACTIONS(465),
    [anon_sym_CARET] = ACTIONS(467),
    [anon_sym_LT_LT] = ACTIONS(451),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_LT_EQ] = ACTIONS(2942),
    [anon_sym_EQ_EQ] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_GT_EQ] = ACTIONS(2942),
    [anon_sym_GT] = ACTIONS(2944),
    [anon_sym_LT_GT] = ACTIONS(2942),
    [anon_sym_is] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(473),
    [sym_comment] = ACTIONS(73),
  },
  [1134] = {
    [sym__expression] = STATE(1422),
    [sym__primary_expression] = STATE(567),
    [sym_not_operator] = STATE(1422),
    [sym_boolean_operator] = STATE(1422),
    [sym_binary_operator] = STATE(567),
    [sym_unary_operator] = STATE(567),
    [sym_comparison_operator] = STATE(1422),
    [sym_lambda] = STATE(1422),
    [sym_attribute] = STATE(567),
    [sym_subscript] = STATE(567),
    [sym_slice] = STATE(1423),
    [sym_call] = STATE(567),
    [sym_list] = STATE(567),
    [sym_list_comprehension] = STATE(567),
    [sym_dictionary] = STATE(567),
    [sym_dictionary_comprehension] = STATE(567),
    [sym_set] = STATE(567),
    [sym_set_comprehension] = STATE(567),
    [sym_parenthesized_expression] = STATE(567),
    [sym_tuple] = STATE(567),
    [sym_generator_expression] = STATE(567),
    [sym_conditional_expression] = STATE(1422),
    [sym_concatenated_string] = STATE(567),
    [sym_string] = STATE(569),
    [sym_await] = STATE(1422),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(973),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(975),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(977),
    [anon_sym_lambda] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(3104),
    [sym_ellipsis] = ACTIONS(981),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(983),
    [sym_float] = ACTIONS(983),
    [sym_identifier] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_none] = ACTIONS(983),
    [anon_sym_await] = ACTIONS(985),
    [sym_comment] = ACTIONS(73),
  },
  [1135] = {
    [anon_sym_DOT] = ACTIONS(2954),
    [anon_sym_LPAREN] = ACTIONS(2954),
    [anon_sym_RPAREN] = ACTIONS(2954),
    [anon_sym_COMMA] = ACTIONS(2954),
    [anon_sym_as] = ACTIONS(2956),
    [anon_sym_STAR] = ACTIONS(2956),
    [anon_sym_GT_GT] = ACTIONS(2954),
    [anon_sym_if] = ACTIONS(2954),
    [anon_sym_COLON] = ACTIONS(2954),
    [anon_sym_else] = ACTIONS(2954),
    [anon_sym_async] = ACTIONS(2954),
    [anon_sym_for] = ACTIONS(2954),
    [anon_sym_in] = ACTIONS(2954),
    [anon_sym_EQ] = ACTIONS(2956),
    [anon_sym_AT] = ACTIONS(2954),
    [anon_sym_not] = ACTIONS(2954),
    [anon_sym_and] = ACTIONS(2954),
    [anon_sym_or] = ACTIONS(2954),
    [anon_sym_PLUS] = ACTIONS(2954),
    [anon_sym_DASH] = ACTIONS(2954),
    [anon_sym_SLASH] = ACTIONS(2956),
    [anon_sym_PERCENT] = ACTIONS(2954),
    [anon_sym_SLASH_SLASH] = ACTIONS(2954),
    [anon_sym_STAR_STAR] = ACTIONS(2954),
    [anon_sym_PIPE] = ACTIONS(2954),
    [anon_sym_AMP] = ACTIONS(2954),
    [anon_sym_CARET] = ACTIONS(2954),
    [anon_sym_LT_LT] = ACTIONS(2954),
    [anon_sym_LT] = ACTIONS(2956),
    [anon_sym_LT_EQ] = ACTIONS(2954),
    [anon_sym_EQ_EQ] = ACTIONS(2954),
    [anon_sym_BANG_EQ] = ACTIONS(2954),
    [anon_sym_GT_EQ] = ACTIONS(2954),
    [anon_sym_GT] = ACTIONS(2956),
    [anon_sym_LT_GT] = ACTIONS(2954),
    [anon_sym_is] = ACTIONS(2954),
    [anon_sym_LBRACK] = ACTIONS(2954),
    [anon_sym_RBRACK] = ACTIONS(2954),
    [anon_sym_RBRACE] = ACTIONS(2954),
    [sym_type_conversion] = ACTIONS(2954),
    [sym_comment] = ACTIONS(73),
  },
  [1136] = {
    [aux_sym_subscript_repeat1] = STATE(1428),
    [anon_sym_COMMA] = ACTIONS(3106),
    [anon_sym_RBRACK] = ACTIONS(3104),
    [sym_comment] = ACTIONS(73),
  },
  [1137] = {
    [sym__newline] = ACTIONS(2182),
    [anon_sym_DOT] = ACTIONS(2182),
    [anon_sym_from] = ACTIONS(2182),
    [anon_sym_LPAREN] = ACTIONS(2182),
    [anon_sym_COMMA] = ACTIONS(2182),
    [anon_sym_STAR] = ACTIONS(2184),
    [anon_sym_GT_GT] = ACTIONS(2182),
    [anon_sym_if] = ACTIONS(2182),
    [anon_sym_in] = ACTIONS(2182),
    [anon_sym_EQ] = ACTIONS(2184),
    [anon_sym_AT] = ACTIONS(2182),
    [anon_sym_not] = ACTIONS(2182),
    [anon_sym_and] = ACTIONS(2182),
    [anon_sym_or] = ACTIONS(2182),
    [anon_sym_PLUS] = ACTIONS(2182),
    [anon_sym_DASH] = ACTIONS(2182),
    [anon_sym_SLASH] = ACTIONS(2184),
    [anon_sym_PERCENT] = ACTIONS(2182),
    [anon_sym_SLASH_SLASH] = ACTIONS(2182),
    [anon_sym_STAR_STAR] = ACTIONS(2182),
    [anon_sym_PIPE] = ACTIONS(2182),
    [anon_sym_AMP] = ACTIONS(2182),
    [anon_sym_CARET] = ACTIONS(2182),
    [anon_sym_LT_LT] = ACTIONS(2182),
    [anon_sym_LT] = ACTIONS(2184),
    [anon_sym_LT_EQ] = ACTIONS(2182),
    [anon_sym_EQ_EQ] = ACTIONS(2182),
    [anon_sym_BANG_EQ] = ACTIONS(2182),
    [anon_sym_GT_EQ] = ACTIONS(2182),
    [anon_sym_GT] = ACTIONS(2184),
    [anon_sym_LT_GT] = ACTIONS(2182),
    [anon_sym_is] = ACTIONS(2182),
    [anon_sym_LBRACK] = ACTIONS(2182),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2182),
  },
  [1138] = {
    [sym__newline] = ACTIONS(2194),
    [anon_sym_DOT] = ACTIONS(2194),
    [anon_sym_from] = ACTIONS(2194),
    [anon_sym_LPAREN] = ACTIONS(2194),
    [anon_sym_COMMA] = ACTIONS(2194),
    [anon_sym_STAR] = ACTIONS(2196),
    [anon_sym_GT_GT] = ACTIONS(2194),
    [anon_sym_if] = ACTIONS(2194),
    [anon_sym_in] = ACTIONS(2194),
    [anon_sym_EQ] = ACTIONS(2196),
    [anon_sym_AT] = ACTIONS(2194),
    [anon_sym_not] = ACTIONS(2194),
    [anon_sym_and] = ACTIONS(2194),
    [anon_sym_or] = ACTIONS(2194),
    [anon_sym_PLUS] = ACTIONS(2194),
    [anon_sym_DASH] = ACTIONS(2194),
    [anon_sym_SLASH] = ACTIONS(2196),
    [anon_sym_PERCENT] = ACTIONS(2194),
    [anon_sym_SLASH_SLASH] = ACTIONS(2194),
    [anon_sym_STAR_STAR] = ACTIONS(2194),
    [anon_sym_PIPE] = ACTIONS(2194),
    [anon_sym_AMP] = ACTIONS(2194),
    [anon_sym_CARET] = ACTIONS(2194),
    [anon_sym_LT_LT] = ACTIONS(2194),
    [anon_sym_LT] = ACTIONS(2196),
    [anon_sym_LT_EQ] = ACTIONS(2194),
    [anon_sym_EQ_EQ] = ACTIONS(2194),
    [anon_sym_BANG_EQ] = ACTIONS(2194),
    [anon_sym_GT_EQ] = ACTIONS(2194),
    [anon_sym_GT] = ACTIONS(2196),
    [anon_sym_LT_GT] = ACTIONS(2194),
    [anon_sym_is] = ACTIONS(2194),
    [anon_sym_LBRACK] = ACTIONS(2194),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2194),
  },
  [1139] = {
    [sym__expression] = STATE(647),
    [sym__primary_expression] = STATE(237),
    [sym_not_operator] = STATE(647),
    [sym_boolean_operator] = STATE(647),
    [sym_binary_operator] = STATE(237),
    [sym_unary_operator] = STATE(237),
    [sym_comparison_operator] = STATE(647),
    [sym_lambda] = STATE(647),
    [sym_yield] = STATE(648),
    [sym_attribute] = STATE(237),
    [sym_subscript] = STATE(237),
    [sym_call] = STATE(237),
    [sym_list] = STATE(237),
    [sym_list_comprehension] = STATE(237),
    [sym_dictionary] = STATE(237),
    [sym_dictionary_comprehension] = STATE(237),
    [sym_set] = STATE(237),
    [sym_set_comprehension] = STATE(237),
    [sym_parenthesized_expression] = STATE(237),
    [sym_tuple] = STATE(237),
    [sym_generator_expression] = STATE(237),
    [sym_conditional_expression] = STATE(647),
    [sym_concatenated_string] = STATE(237),
    [sym_string] = STATE(238),
    [sym_await] = STATE(647),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3108),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_lambda] = ACTIONS(415),
    [anon_sym_yield] = ACTIONS(107),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(419),
    [sym_float] = ACTIONS(419),
    [sym_identifier] = ACTIONS(419),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_none] = ACTIONS(419),
    [anon_sym_await] = ACTIONS(421),
    [sym_comment] = ACTIONS(73),
  },
  [1140] = {
    [sym__newline] = ACTIONS(2647),
    [anon_sym_COMMA] = ACTIONS(2647),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_and] = ACTIONS(503),
    [anon_sym_or] = ACTIONS(505),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2647),
  },
  [1141] = {
    [sym__newline] = ACTIONS(2683),
    [anon_sym_DOT] = ACTIONS(2683),
    [anon_sym_from] = ACTIONS(2683),
    [anon_sym_LPAREN] = ACTIONS(2683),
    [anon_sym_COMMA] = ACTIONS(2683),
    [anon_sym_STAR] = ACTIONS(2685),
    [anon_sym_GT_GT] = ACTIONS(2683),
    [anon_sym_if] = ACTIONS(2683),
    [anon_sym_in] = ACTIONS(2683),
    [anon_sym_EQ] = ACTIONS(2685),
    [anon_sym_AT] = ACTIONS(2683),
    [anon_sym_not] = ACTIONS(2683),
    [anon_sym_and] = ACTIONS(2683),
    [anon_sym_or] = ACTIONS(2683),
    [anon_sym_PLUS] = ACTIONS(2683),
    [anon_sym_DASH] = ACTIONS(2683),
    [anon_sym_SLASH] = ACTIONS(2685),
    [anon_sym_PERCENT] = ACTIONS(2683),
    [anon_sym_SLASH_SLASH] = ACTIONS(2683),
    [anon_sym_STAR_STAR] = ACTIONS(2683),
    [anon_sym_PIPE] = ACTIONS(2683),
    [anon_sym_AMP] = ACTIONS(2683),
    [anon_sym_CARET] = ACTIONS(2683),
    [anon_sym_LT_LT] = ACTIONS(2683),
    [anon_sym_LT] = ACTIONS(2685),
    [anon_sym_LT_EQ] = ACTIONS(2683),
    [anon_sym_EQ_EQ] = ACTIONS(2683),
    [anon_sym_BANG_EQ] = ACTIONS(2683),
    [anon_sym_GT_EQ] = ACTIONS(2683),
    [anon_sym_GT] = ACTIONS(2685),
    [anon_sym_LT_GT] = ACTIONS(2683),
    [anon_sym_is] = ACTIONS(2683),
    [anon_sym_LBRACK] = ACTIONS(2683),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2683),
  },
  [1142] = {
    [sym_list_splat] = STATE(914),
    [sym__expression] = STATE(915),
    [sym__primary_expression] = STATE(452),
    [sym_not_operator] = STATE(915),
    [sym_boolean_operator] = STATE(915),
    [sym_binary_operator] = STATE(452),
    [sym_unary_operator] = STATE(452),
    [sym_comparison_operator] = STATE(915),
    [sym_lambda] = STATE(915),
    [sym_attribute] = STATE(452),
    [sym_subscript] = STATE(452),
    [sym_call] = STATE(452),
    [sym_list] = STATE(452),
    [sym_list_comprehension] = STATE(452),
    [sym_dictionary] = STATE(452),
    [sym_dictionary_comprehension] = STATE(452),
    [sym_set] = STATE(452),
    [sym_set_comprehension] = STATE(452),
    [sym_parenthesized_expression] = STATE(452),
    [sym_tuple] = STATE(452),
    [sym_generator_expression] = STATE(452),
    [sym_conditional_expression] = STATE(915),
    [sym_concatenated_string] = STATE(452),
    [sym_string] = STATE(453),
    [sym_await] = STATE(915),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(243),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_lambda] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(3110),
    [sym_ellipsis] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(773),
    [sym_float] = ACTIONS(773),
    [sym_identifier] = ACTIONS(773),
    [sym_true] = ACTIONS(773),
    [sym_false] = ACTIONS(773),
    [sym_none] = ACTIONS(773),
    [anon_sym_await] = ACTIONS(775),
    [sym_comment] = ACTIONS(73),
  },
  [1143] = {
    [sym__newline] = ACTIONS(2698),
    [anon_sym_DOT] = ACTIONS(2698),
    [anon_sym_from] = ACTIONS(2698),
    [anon_sym_LPAREN] = ACTIONS(2698),
    [anon_sym_COMMA] = ACTIONS(2698),
    [anon_sym_STAR] = ACTIONS(2700),
    [anon_sym_GT_GT] = ACTIONS(2698),
    [anon_sym_if] = ACTIONS(2698),
    [anon_sym_in] = ACTIONS(2698),
    [anon_sym_EQ] = ACTIONS(2700),
    [anon_sym_AT] = ACTIONS(2698),
    [anon_sym_not] = ACTIONS(2698),
    [anon_sym_and] = ACTIONS(2698),
    [anon_sym_or] = ACTIONS(2698),
    [anon_sym_PLUS] = ACTIONS(2698),
    [anon_sym_DASH] = ACTIONS(2698),
    [anon_sym_SLASH] = ACTIONS(2700),
    [anon_sym_PERCENT] = ACTIONS(2698),
    [anon_sym_SLASH_SLASH] = ACTIONS(2698),
    [anon_sym_STAR_STAR] = ACTIONS(2698),
    [anon_sym_PIPE] = ACTIONS(2698),
    [anon_sym_AMP] = ACTIONS(2698),
    [anon_sym_CARET] = ACTIONS(2698),
    [anon_sym_LT_LT] = ACTIONS(2698),
    [anon_sym_LT] = ACTIONS(2700),
    [anon_sym_LT_EQ] = ACTIONS(2698),
    [anon_sym_EQ_EQ] = ACTIONS(2698),
    [anon_sym_BANG_EQ] = ACTIONS(2698),
    [anon_sym_GT_EQ] = ACTIONS(2698),
    [anon_sym_GT] = ACTIONS(2700),
    [anon_sym_LT_GT] = ACTIONS(2698),
    [anon_sym_is] = ACTIONS(2698),
    [anon_sym_LBRACK] = ACTIONS(2698),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2698),
  },
  [1144] = {
    [sym__newline] = ACTIONS(2764),
    [anon_sym_DOT] = ACTIONS(2764),
    [anon_sym_from] = ACTIONS(2764),
    [anon_sym_LPAREN] = ACTIONS(2764),
    [anon_sym_COMMA] = ACTIONS(2764),
    [anon_sym_STAR] = ACTIONS(2766),
    [anon_sym_GT_GT] = ACTIONS(2764),
    [anon_sym_if] = ACTIONS(2764),
    [anon_sym_in] = ACTIONS(2764),
    [anon_sym_EQ] = ACTIONS(2766),
    [anon_sym_AT] = ACTIONS(2764),
    [anon_sym_not] = ACTIONS(2764),
    [anon_sym_and] = ACTIONS(2764),
    [anon_sym_or] = ACTIONS(2764),
    [anon_sym_PLUS] = ACTIONS(2764),
    [anon_sym_DASH] = ACTIONS(2764),
    [anon_sym_SLASH] = ACTIONS(2766),
    [anon_sym_PERCENT] = ACTIONS(2764),
    [anon_sym_SLASH_SLASH] = ACTIONS(2764),
    [anon_sym_STAR_STAR] = ACTIONS(2764),
    [anon_sym_PIPE] = ACTIONS(2764),
    [anon_sym_AMP] = ACTIONS(2764),
    [anon_sym_CARET] = ACTIONS(2764),
    [anon_sym_LT_LT] = ACTIONS(2764),
    [anon_sym_LT] = ACTIONS(2766),
    [anon_sym_LT_EQ] = ACTIONS(2764),
    [anon_sym_EQ_EQ] = ACTIONS(2764),
    [anon_sym_BANG_EQ] = ACTIONS(2764),
    [anon_sym_GT_EQ] = ACTIONS(2764),
    [anon_sym_GT] = ACTIONS(2766),
    [anon_sym_LT_GT] = ACTIONS(2764),
    [anon_sym_is] = ACTIONS(2764),
    [anon_sym_LBRACK] = ACTIONS(2764),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2764),
  },
  [1145] = {
    [sym_list_splat] = STATE(914),
    [sym__expression] = STATE(958),
    [sym__primary_expression] = STATE(485),
    [sym_not_operator] = STATE(958),
    [sym_boolean_operator] = STATE(958),
    [sym_binary_operator] = STATE(485),
    [sym_unary_operator] = STATE(485),
    [sym_comparison_operator] = STATE(958),
    [sym_lambda] = STATE(958),
    [sym_attribute] = STATE(485),
    [sym_subscript] = STATE(485),
    [sym_call] = STATE(485),
    [sym_list] = STATE(485),
    [sym_list_comprehension] = STATE(485),
    [sym_dictionary] = STATE(485),
    [sym_dictionary_comprehension] = STATE(485),
    [sym_set] = STATE(485),
    [sym_set_comprehension] = STATE(485),
    [sym_parenthesized_expression] = STATE(485),
    [sym_tuple] = STATE(485),
    [sym_generator_expression] = STATE(485),
    [sym_conditional_expression] = STATE(958),
    [sym_concatenated_string] = STATE(485),
    [sym_string] = STATE(486),
    [sym_await] = STATE(958),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(1798),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(823),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_TILDE] = ACTIONS(825),
    [anon_sym_lambda] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(829),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(3112),
    [sym_integer] = ACTIONS(831),
    [sym_float] = ACTIONS(831),
    [sym_identifier] = ACTIONS(831),
    [sym_true] = ACTIONS(831),
    [sym_false] = ACTIONS(831),
    [sym_none] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [sym_comment] = ACTIONS(73),
  },
  [1146] = {
    [sym__newline] = ACTIONS(2773),
    [anon_sym_DOT] = ACTIONS(2773),
    [anon_sym_from] = ACTIONS(2773),
    [anon_sym_LPAREN] = ACTIONS(2773),
    [anon_sym_COMMA] = ACTIONS(2773),
    [anon_sym_STAR] = ACTIONS(2775),
    [anon_sym_GT_GT] = ACTIONS(2773),
    [anon_sym_if] = ACTIONS(2773),
    [anon_sym_in] = ACTIONS(2773),
    [anon_sym_EQ] = ACTIONS(2775),
    [anon_sym_AT] = ACTIONS(2773),
    [anon_sym_not] = ACTIONS(2773),
    [anon_sym_and] = ACTIONS(2773),
    [anon_sym_or] = ACTIONS(2773),
    [anon_sym_PLUS] = ACTIONS(2773),
    [anon_sym_DASH] = ACTIONS(2773),
    [anon_sym_SLASH] = ACTIONS(2775),
    [anon_sym_PERCENT] = ACTIONS(2773),
    [anon_sym_SLASH_SLASH] = ACTIONS(2773),
    [anon_sym_STAR_STAR] = ACTIONS(2773),
    [anon_sym_PIPE] = ACTIONS(2773),
    [anon_sym_AMP] = ACTIONS(2773),
    [anon_sym_CARET] = ACTIONS(2773),
    [anon_sym_LT_LT] = ACTIONS(2773),
    [anon_sym_LT] = ACTIONS(2775),
    [anon_sym_LT_EQ] = ACTIONS(2773),
    [anon_sym_EQ_EQ] = ACTIONS(2773),
    [anon_sym_BANG_EQ] = ACTIONS(2773),
    [anon_sym_GT_EQ] = ACTIONS(2773),
    [anon_sym_GT] = ACTIONS(2775),
    [anon_sym_LT_GT] = ACTIONS(2773),
    [anon_sym_is] = ACTIONS(2773),
    [anon_sym_LBRACK] = ACTIONS(2773),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2773),
  },
  [1147] = {
    [sym_dictionary_splat] = STATE(963),
    [sym__expression] = STATE(964),
    [sym__primary_expression] = STATE(102),
    [sym_not_operator] = STATE(964),
    [sym_boolean_operator] = STATE(964),
    [sym_binary_operator] = STATE(102),
    [sym_unary_operator] = STATE(102),
    [sym_comparison_operator] = STATE(964),
    [sym_lambda] = STATE(964),
    [sym_attribute] = STATE(102),
    [sym_subscript] = STATE(102),
    [sym_call] = STATE(102),
    [sym_list] = STATE(102),
    [sym_list_comprehension] = STATE(102),
    [sym_dictionary] = STATE(102),
    [sym_dictionary_comprehension] = STATE(102),
    [sym_pair] = STATE(963),
    [sym_set] = STATE(102),
    [sym_set_comprehension] = STATE(102),
    [sym_parenthesized_expression] = STATE(102),
    [sym_tuple] = STATE(102),
    [sym_generator_expression] = STATE(102),
    [sym_conditional_expression] = STATE(964),
    [sym_concatenated_string] = STATE(102),
    [sym_string] = STATE(103),
    [sym_await] = STATE(964),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(1808),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(3114),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [1148] = {
    [sym__newline] = ACTIONS(2824),
    [anon_sym_DOT] = ACTIONS(2824),
    [anon_sym_from] = ACTIONS(2824),
    [anon_sym_LPAREN] = ACTIONS(2824),
    [anon_sym_COMMA] = ACTIONS(2824),
    [anon_sym_STAR] = ACTIONS(2826),
    [anon_sym_GT_GT] = ACTIONS(2824),
    [anon_sym_if] = ACTIONS(2824),
    [anon_sym_in] = ACTIONS(2824),
    [anon_sym_EQ] = ACTIONS(2826),
    [anon_sym_AT] = ACTIONS(2824),
    [anon_sym_not] = ACTIONS(2824),
    [anon_sym_and] = ACTIONS(2824),
    [anon_sym_or] = ACTIONS(2824),
    [anon_sym_PLUS] = ACTIONS(2824),
    [anon_sym_DASH] = ACTIONS(2824),
    [anon_sym_SLASH] = ACTIONS(2826),
    [anon_sym_PERCENT] = ACTIONS(2824),
    [anon_sym_SLASH_SLASH] = ACTIONS(2824),
    [anon_sym_STAR_STAR] = ACTIONS(2824),
    [anon_sym_PIPE] = ACTIONS(2824),
    [anon_sym_AMP] = ACTIONS(2824),
    [anon_sym_CARET] = ACTIONS(2824),
    [anon_sym_LT_LT] = ACTIONS(2824),
    [anon_sym_LT] = ACTIONS(2826),
    [anon_sym_LT_EQ] = ACTIONS(2824),
    [anon_sym_EQ_EQ] = ACTIONS(2824),
    [anon_sym_BANG_EQ] = ACTIONS(2824),
    [anon_sym_GT_EQ] = ACTIONS(2824),
    [anon_sym_GT] = ACTIONS(2826),
    [anon_sym_LT_GT] = ACTIONS(2824),
    [anon_sym_is] = ACTIONS(2824),
    [anon_sym_LBRACK] = ACTIONS(2824),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2824),
  },
  [1149] = {
    [sym__newline] = ACTIONS(2856),
    [anon_sym_DOT] = ACTIONS(2856),
    [anon_sym_from] = ACTIONS(2856),
    [anon_sym_LPAREN] = ACTIONS(2856),
    [anon_sym_COMMA] = ACTIONS(2856),
    [anon_sym_STAR] = ACTIONS(2858),
    [anon_sym_GT_GT] = ACTIONS(2856),
    [anon_sym_if] = ACTIONS(2856),
    [anon_sym_in] = ACTIONS(2856),
    [anon_sym_EQ] = ACTIONS(2858),
    [anon_sym_AT] = ACTIONS(2856),
    [anon_sym_not] = ACTIONS(2856),
    [anon_sym_and] = ACTIONS(2856),
    [anon_sym_or] = ACTIONS(2856),
    [anon_sym_PLUS] = ACTIONS(2856),
    [anon_sym_DASH] = ACTIONS(2856),
    [anon_sym_SLASH] = ACTIONS(2858),
    [anon_sym_PERCENT] = ACTIONS(2856),
    [anon_sym_SLASH_SLASH] = ACTIONS(2856),
    [anon_sym_STAR_STAR] = ACTIONS(2856),
    [anon_sym_PIPE] = ACTIONS(2856),
    [anon_sym_AMP] = ACTIONS(2856),
    [anon_sym_CARET] = ACTIONS(2856),
    [anon_sym_LT_LT] = ACTIONS(2856),
    [anon_sym_LT] = ACTIONS(2858),
    [anon_sym_LT_EQ] = ACTIONS(2856),
    [anon_sym_EQ_EQ] = ACTIONS(2856),
    [anon_sym_BANG_EQ] = ACTIONS(2856),
    [anon_sym_GT_EQ] = ACTIONS(2856),
    [anon_sym_GT] = ACTIONS(2858),
    [anon_sym_LT_GT] = ACTIONS(2856),
    [anon_sym_is] = ACTIONS(2856),
    [anon_sym_LBRACK] = ACTIONS(2856),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2856),
  },
  [1150] = {
    [sym__expression] = STATE(1486),
    [sym__primary_expression] = STATE(82),
    [sym_not_operator] = STATE(1486),
    [sym_boolean_operator] = STATE(1486),
    [sym_binary_operator] = STATE(82),
    [sym_unary_operator] = STATE(82),
    [sym_comparison_operator] = STATE(1486),
    [sym_lambda] = STATE(1486),
    [sym_attribute] = STATE(82),
    [sym_subscript] = STATE(82),
    [sym_call] = STATE(82),
    [sym_list] = STATE(82),
    [sym_list_comprehension] = STATE(82),
    [sym_dictionary] = STATE(82),
    [sym_dictionary_comprehension] = STATE(82),
    [sym_set] = STATE(82),
    [sym_set_comprehension] = STATE(82),
    [sym_parenthesized_expression] = STATE(82),
    [sym_tuple] = STATE(82),
    [sym_generator_expression] = STATE(82),
    [sym_conditional_expression] = STATE(1486),
    [sym_concatenated_string] = STATE(82),
    [sym_string] = STATE(83),
    [sym_await] = STATE(1486),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(143),
    [anon_sym_PLUS] = ACTIONS(129),
    [anon_sym_DASH] = ACTIONS(129),
    [anon_sym_TILDE] = ACTIONS(129),
    [anon_sym_lambda] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(133),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(137),
    [sym_float] = ACTIONS(137),
    [sym_identifier] = ACTIONS(137),
    [sym_true] = ACTIONS(137),
    [sym_false] = ACTIONS(137),
    [sym_none] = ACTIONS(137),
    [anon_sym_await] = ACTIONS(139),
    [sym_comment] = ACTIONS(73),
  },
  [1151] = {
    [sym__newline] = ACTIONS(2934),
    [anon_sym_DOT] = ACTIONS(2934),
    [anon_sym_from] = ACTIONS(2934),
    [anon_sym_LPAREN] = ACTIONS(2934),
    [anon_sym_COMMA] = ACTIONS(2934),
    [anon_sym_STAR] = ACTIONS(2936),
    [anon_sym_GT_GT] = ACTIONS(2934),
    [anon_sym_if] = ACTIONS(2934),
    [anon_sym_in] = ACTIONS(2934),
    [anon_sym_EQ] = ACTIONS(2936),
    [anon_sym_AT] = ACTIONS(2934),
    [anon_sym_not] = ACTIONS(2934),
    [anon_sym_and] = ACTIONS(2934),
    [anon_sym_or] = ACTIONS(2934),
    [anon_sym_PLUS] = ACTIONS(2934),
    [anon_sym_DASH] = ACTIONS(2934),
    [anon_sym_SLASH] = ACTIONS(2936),
    [anon_sym_PERCENT] = ACTIONS(2934),
    [anon_sym_SLASH_SLASH] = ACTIONS(2934),
    [anon_sym_STAR_STAR] = ACTIONS(2934),
    [anon_sym_PIPE] = ACTIONS(2934),
    [anon_sym_AMP] = ACTIONS(2934),
    [anon_sym_CARET] = ACTIONS(2934),
    [anon_sym_LT_LT] = ACTIONS(2934),
    [anon_sym_LT] = ACTIONS(2936),
    [anon_sym_LT_EQ] = ACTIONS(2934),
    [anon_sym_EQ_EQ] = ACTIONS(2934),
    [anon_sym_BANG_EQ] = ACTIONS(2934),
    [anon_sym_GT_EQ] = ACTIONS(2934),
    [anon_sym_GT] = ACTIONS(2936),
    [anon_sym_LT_GT] = ACTIONS(2934),
    [anon_sym_is] = ACTIONS(2934),
    [anon_sym_LBRACK] = ACTIONS(2934),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2934),
  },
  [1152] = {
    [sym_list_splat] = STATE(1413),
    [sym_dictionary_splat] = STATE(1413),
    [sym__expression] = STATE(1414),
    [sym__primary_expression] = STATE(237),
    [sym_not_operator] = STATE(1414),
    [sym_boolean_operator] = STATE(1414),
    [sym_binary_operator] = STATE(237),
    [sym_unary_operator] = STATE(237),
    [sym_comparison_operator] = STATE(1414),
    [sym_lambda] = STATE(1414),
    [sym_attribute] = STATE(237),
    [sym_subscript] = STATE(237),
    [sym_call] = STATE(237),
    [sym_keyword_argument] = STATE(1413),
    [sym_list] = STATE(237),
    [sym_list_comprehension] = STATE(237),
    [sym_dictionary] = STATE(237),
    [sym_dictionary_comprehension] = STATE(237),
    [sym_set] = STATE(237),
    [sym_set_comprehension] = STATE(237),
    [sym_parenthesized_expression] = STATE(237),
    [sym_tuple] = STATE(237),
    [sym_generator_expression] = STATE(237),
    [sym_conditional_expression] = STATE(1414),
    [sym_concatenated_string] = STATE(237),
    [sym_string] = STATE(238),
    [sym_await] = STATE(1414),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3116),
    [anon_sym_STAR] = ACTIONS(931),
    [anon_sym_print] = ACTIONS(933),
    [anon_sym_exec] = ACTIONS(933),
    [anon_sym_not] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_lambda] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(419),
    [sym_float] = ACTIONS(419),
    [sym_identifier] = ACTIONS(935),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_none] = ACTIONS(419),
    [anon_sym_await] = ACTIONS(421),
    [sym_comment] = ACTIONS(73),
  },
  [1153] = {
    [aux_sym_argument_list_repeat1] = STATE(1416),
    [anon_sym_RPAREN] = ACTIONS(3116),
    [anon_sym_COMMA] = ACTIONS(3118),
    [sym_comment] = ACTIONS(73),
  },
  [1154] = {
    [sym_argument_list] = STATE(315),
    [sym_generator_expression] = STATE(315),
    [sym__newline] = ACTIONS(2942),
    [anon_sym_DOT] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_COMMA] = ACTIONS(2942),
    [anon_sym_STAR] = ACTIONS(511),
    [anon_sym_GT_GT] = ACTIONS(513),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_in] = ACTIONS(2942),
    [anon_sym_AT] = ACTIONS(517),
    [anon_sym_not] = ACTIONS(2942),
    [anon_sym_and] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(521),
    [anon_sym_DASH] = ACTIONS(521),
    [anon_sym_SLASH] = ACTIONS(511),
    [anon_sym_PERCENT] = ACTIONS(517),
    [anon_sym_SLASH_SLASH] = ACTIONS(517),
    [anon_sym_STAR_STAR] = ACTIONS(523),
    [anon_sym_PIPE] = ACTIONS(525),
    [anon_sym_AMP] = ACTIONS(527),
    [anon_sym_CARET] = ACTIONS(529),
    [anon_sym_LT_LT] = ACTIONS(513),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_LT_EQ] = ACTIONS(2942),
    [anon_sym_EQ_EQ] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_GT_EQ] = ACTIONS(2942),
    [anon_sym_GT] = ACTIONS(2944),
    [anon_sym_LT_GT] = ACTIONS(2942),
    [anon_sym_is] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(535),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2942),
  },
  [1155] = {
    [sym__expression] = STATE(1422),
    [sym__primary_expression] = STATE(567),
    [sym_not_operator] = STATE(1422),
    [sym_boolean_operator] = STATE(1422),
    [sym_binary_operator] = STATE(567),
    [sym_unary_operator] = STATE(567),
    [sym_comparison_operator] = STATE(1422),
    [sym_lambda] = STATE(1422),
    [sym_attribute] = STATE(567),
    [sym_subscript] = STATE(567),
    [sym_slice] = STATE(1423),
    [sym_call] = STATE(567),
    [sym_list] = STATE(567),
    [sym_list_comprehension] = STATE(567),
    [sym_dictionary] = STATE(567),
    [sym_dictionary_comprehension] = STATE(567),
    [sym_set] = STATE(567),
    [sym_set_comprehension] = STATE(567),
    [sym_parenthesized_expression] = STATE(567),
    [sym_tuple] = STATE(567),
    [sym_generator_expression] = STATE(567),
    [sym_conditional_expression] = STATE(1422),
    [sym_concatenated_string] = STATE(567),
    [sym_string] = STATE(569),
    [sym_await] = STATE(1422),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(973),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(975),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(977),
    [anon_sym_lambda] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(3120),
    [sym_ellipsis] = ACTIONS(981),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(983),
    [sym_float] = ACTIONS(983),
    [sym_identifier] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_none] = ACTIONS(983),
    [anon_sym_await] = ACTIONS(985),
    [sym_comment] = ACTIONS(73),
  },
  [1156] = {
    [sym__newline] = ACTIONS(2954),
    [anon_sym_DOT] = ACTIONS(2954),
    [anon_sym_from] = ACTIONS(2954),
    [anon_sym_LPAREN] = ACTIONS(2954),
    [anon_sym_COMMA] = ACTIONS(2954),
    [anon_sym_STAR] = ACTIONS(2956),
    [anon_sym_GT_GT] = ACTIONS(2954),
    [anon_sym_if] = ACTIONS(2954),
    [anon_sym_in] = ACTIONS(2954),
    [anon_sym_EQ] = ACTIONS(2956),
    [anon_sym_AT] = ACTIONS(2954),
    [anon_sym_not] = ACTIONS(2954),
    [anon_sym_and] = ACTIONS(2954),
    [anon_sym_or] = ACTIONS(2954),
    [anon_sym_PLUS] = ACTIONS(2954),
    [anon_sym_DASH] = ACTIONS(2954),
    [anon_sym_SLASH] = ACTIONS(2956),
    [anon_sym_PERCENT] = ACTIONS(2954),
    [anon_sym_SLASH_SLASH] = ACTIONS(2954),
    [anon_sym_STAR_STAR] = ACTIONS(2954),
    [anon_sym_PIPE] = ACTIONS(2954),
    [anon_sym_AMP] = ACTIONS(2954),
    [anon_sym_CARET] = ACTIONS(2954),
    [anon_sym_LT_LT] = ACTIONS(2954),
    [anon_sym_LT] = ACTIONS(2956),
    [anon_sym_LT_EQ] = ACTIONS(2954),
    [anon_sym_EQ_EQ] = ACTIONS(2954),
    [anon_sym_BANG_EQ] = ACTIONS(2954),
    [anon_sym_GT_EQ] = ACTIONS(2954),
    [anon_sym_GT] = ACTIONS(2956),
    [anon_sym_LT_GT] = ACTIONS(2954),
    [anon_sym_is] = ACTIONS(2954),
    [anon_sym_LBRACK] = ACTIONS(2954),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2954),
  },
  [1157] = {
    [aux_sym_subscript_repeat1] = STATE(1428),
    [anon_sym_COMMA] = ACTIONS(3122),
    [anon_sym_RBRACK] = ACTIONS(3120),
    [sym_comment] = ACTIONS(73),
  },
  [1158] = {
    [sym__newline] = ACTIONS(1660),
    [anon_sym_if] = ACTIONS(1378),
    [anon_sym_and] = ACTIONS(1380),
    [anon_sym_or] = ACTIONS(1382),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1660),
  },
  [1159] = {
    [sym__expression] = STATE(1491),
    [sym__primary_expression] = STATE(327),
    [sym_not_operator] = STATE(1491),
    [sym_boolean_operator] = STATE(1491),
    [sym_binary_operator] = STATE(327),
    [sym_unary_operator] = STATE(327),
    [sym_comparison_operator] = STATE(1491),
    [sym_lambda] = STATE(1491),
    [sym_attribute] = STATE(327),
    [sym_subscript] = STATE(327),
    [sym_call] = STATE(327),
    [sym_list] = STATE(327),
    [sym_list_comprehension] = STATE(327),
    [sym_dictionary] = STATE(327),
    [sym_dictionary_comprehension] = STATE(327),
    [sym_set] = STATE(327),
    [sym_set_comprehension] = STATE(327),
    [sym_parenthesized_expression] = STATE(327),
    [sym_tuple] = STATE(327),
    [sym_generator_expression] = STATE(327),
    [sym_conditional_expression] = STATE(1491),
    [sym_concatenated_string] = STATE(327),
    [sym_string] = STATE(328),
    [sym_await] = STATE(1491),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(547),
    [anon_sym_PLUS] = ACTIONS(549),
    [anon_sym_DASH] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_lambda] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(553),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(555),
    [sym_float] = ACTIONS(555),
    [sym_identifier] = ACTIONS(555),
    [sym_true] = ACTIONS(555),
    [sym_false] = ACTIONS(555),
    [sym_none] = ACTIONS(555),
    [anon_sym_await] = ACTIONS(557),
    [sym_comment] = ACTIONS(73),
  },
  [1160] = {
    [anon_sym_if] = ACTIONS(1925),
    [anon_sym_else] = ACTIONS(3124),
    [anon_sym_and] = ACTIONS(1929),
    [anon_sym_or] = ACTIONS(1931),
    [sym_comment] = ACTIONS(73),
  },
  [1161] = {
    [sym__newline] = ACTIONS(1957),
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_and] = ACTIONS(1380),
    [anon_sym_or] = ACTIONS(1957),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1957),
  },
  [1162] = {
    [sym_argument_list] = STATE(315),
    [sym_generator_expression] = STATE(315),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1984),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1986),
    [anon_sym_PERCENT] = ACTIONS(1984),
    [anon_sym_SLASH_SLASH] = ACTIONS(1984),
    [anon_sym_STAR_STAR] = ACTIONS(1396),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1984),
  },
  [1163] = {
    [sym_argument_list] = STATE(315),
    [sym_generator_expression] = STATE(315),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_STAR] = ACTIONS(1384),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1390),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1394),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_SLASH] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH] = ACTIONS(1390),
    [anon_sym_STAR_STAR] = ACTIONS(1396),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1984),
  },
  [1164] = {
    [sym_argument_list] = STATE(315),
    [sym_generator_expression] = STATE(315),
    [sym__newline] = ACTIONS(1988),
    [anon_sym_DOT] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_STAR] = ACTIONS(1384),
    [anon_sym_GT_GT] = ACTIONS(1386),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(1988),
    [anon_sym_AT] = ACTIONS(1390),
    [anon_sym_not] = ACTIONS(1988),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_PLUS] = ACTIONS(1394),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_SLASH] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH] = ACTIONS(1390),
    [anon_sym_STAR_STAR] = ACTIONS(1396),
    [anon_sym_PIPE] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
    [anon_sym_CARET] = ACTIONS(1402),
    [anon_sym_LT_LT] = ACTIONS(1386),
    [anon_sym_LT] = ACTIONS(1990),
    [anon_sym_LT_EQ] = ACTIONS(1988),
    [anon_sym_EQ_EQ] = ACTIONS(1988),
    [anon_sym_BANG_EQ] = ACTIONS(1988),
    [anon_sym_GT_EQ] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1990),
    [anon_sym_LT_GT] = ACTIONS(1988),
    [anon_sym_is] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(535),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1988),
  },
  [1165] = {
    [sym__primary_expression] = STATE(1493),
    [sym_binary_operator] = STATE(1493),
    [sym_unary_operator] = STATE(1493),
    [sym_attribute] = STATE(1493),
    [sym_subscript] = STATE(1493),
    [sym_call] = STATE(1493),
    [sym_list] = STATE(1493),
    [sym_list_comprehension] = STATE(1493),
    [sym_dictionary] = STATE(1493),
    [sym_dictionary_comprehension] = STATE(1493),
    [sym_set] = STATE(1493),
    [sym_set_comprehension] = STATE(1493),
    [sym_parenthesized_expression] = STATE(1493),
    [sym_tuple] = STATE(1493),
    [sym_generator_expression] = STATE(1493),
    [sym_concatenated_string] = STATE(1493),
    [sym_string] = STATE(328),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(549),
    [anon_sym_DASH] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(3126),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(3128),
    [sym_float] = ACTIONS(3128),
    [sym_identifier] = ACTIONS(3128),
    [sym_true] = ACTIONS(3128),
    [sym_false] = ACTIONS(3128),
    [sym_none] = ACTIONS(3128),
    [sym_comment] = ACTIONS(73),
  },
  [1166] = {
    [sym_argument_list] = STATE(315),
    [sym_generator_expression] = STATE(315),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_STAR] = ACTIONS(1384),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1390),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH] = ACTIONS(1390),
    [anon_sym_STAR_STAR] = ACTIONS(1396),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1984),
  },
  [1167] = {
    [sym_argument_list] = STATE(315),
    [sym_generator_expression] = STATE(315),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_STAR] = ACTIONS(1384),
    [anon_sym_GT_GT] = ACTIONS(1386),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1390),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1394),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_SLASH] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH] = ACTIONS(1390),
    [anon_sym_STAR_STAR] = ACTIONS(1396),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1400),
    [anon_sym_CARET] = ACTIONS(1402),
    [anon_sym_LT_LT] = ACTIONS(1386),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1984),
  },
  [1168] = {
    [sym_argument_list] = STATE(315),
    [sym_generator_expression] = STATE(315),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_STAR] = ACTIONS(1384),
    [anon_sym_GT_GT] = ACTIONS(1386),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1390),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1394),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_SLASH] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH] = ACTIONS(1390),
    [anon_sym_STAR_STAR] = ACTIONS(1396),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1402),
    [anon_sym_LT_LT] = ACTIONS(1386),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1984),
  },
  [1169] = {
    [sym_argument_list] = STATE(315),
    [sym_generator_expression] = STATE(315),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_STAR] = ACTIONS(1384),
    [anon_sym_GT_GT] = ACTIONS(1386),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1390),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1394),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_SLASH] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH] = ACTIONS(1390),
    [anon_sym_STAR_STAR] = ACTIONS(1396),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1386),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1984),
  },
  [1170] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1170),
    [sym__newline] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(3130),
    [anon_sym_not] = ACTIONS(3133),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(3136),
    [anon_sym_LT_EQ] = ACTIONS(3130),
    [anon_sym_EQ_EQ] = ACTIONS(3130),
    [anon_sym_BANG_EQ] = ACTIONS(3130),
    [anon_sym_GT_EQ] = ACTIONS(3130),
    [anon_sym_GT] = ACTIONS(3136),
    [anon_sym_LT_GT] = ACTIONS(3130),
    [anon_sym_is] = ACTIONS(3139),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1988),
  },
  [1171] = {
    [sym_string] = STATE(1171),
    [aux_sym_concatenated_string_repeat1] = STATE(1171),
    [sym__newline] = ACTIONS(2050),
    [sym__string_start] = ACTIONS(2299),
    [anon_sym_DOT] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2050),
    [anon_sym_if] = ACTIONS(2050),
    [anon_sym_in] = ACTIONS(2050),
    [anon_sym_AT] = ACTIONS(2050),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_and] = ACTIONS(2050),
    [anon_sym_or] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_SLASH] = ACTIONS(2055),
    [anon_sym_PERCENT] = ACTIONS(2050),
    [anon_sym_SLASH_SLASH] = ACTIONS(2050),
    [anon_sym_STAR_STAR] = ACTIONS(2050),
    [anon_sym_PIPE] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2050),
    [anon_sym_CARET] = ACTIONS(2050),
    [anon_sym_LT_LT] = ACTIONS(2050),
    [anon_sym_LT] = ACTIONS(2055),
    [anon_sym_LT_EQ] = ACTIONS(2050),
    [anon_sym_EQ_EQ] = ACTIONS(2050),
    [anon_sym_BANG_EQ] = ACTIONS(2050),
    [anon_sym_GT_EQ] = ACTIONS(2050),
    [anon_sym_GT] = ACTIONS(2055),
    [anon_sym_LT_GT] = ACTIONS(2050),
    [anon_sym_is] = ACTIONS(2050),
    [anon_sym_LBRACK] = ACTIONS(2050),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2050),
  },
  [1172] = {
    [sym__newline] = ACTIONS(2647),
    [anon_sym_from] = ACTIONS(2647),
    [anon_sym_COMMA] = ACTIONS(2647),
    [anon_sym_if] = ACTIONS(567),
    [anon_sym_and] = ACTIONS(569),
    [anon_sym_or] = ACTIONS(571),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2647),
  },
  [1173] = {
    [sym__expression] = STATE(1494),
    [sym__primary_expression] = STATE(95),
    [sym_not_operator] = STATE(1494),
    [sym_boolean_operator] = STATE(1494),
    [sym_binary_operator] = STATE(95),
    [sym_unary_operator] = STATE(95),
    [sym_comparison_operator] = STATE(1494),
    [sym_lambda] = STATE(1494),
    [sym_attribute] = STATE(95),
    [sym_subscript] = STATE(95),
    [sym_call] = STATE(95),
    [sym_list] = STATE(95),
    [sym_list_comprehension] = STATE(95),
    [sym_dictionary] = STATE(95),
    [sym_dictionary_comprehension] = STATE(95),
    [sym_set] = STATE(95),
    [sym_set_comprehension] = STATE(95),
    [sym_parenthesized_expression] = STATE(95),
    [sym_tuple] = STATE(95),
    [sym_generator_expression] = STATE(95),
    [sym_conditional_expression] = STATE(1494),
    [sym_concatenated_string] = STATE(95),
    [sym_string] = STATE(96),
    [sym_await] = STATE(1494),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_lambda] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(159),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(161),
    [sym_float] = ACTIONS(161),
    [sym_identifier] = ACTIONS(161),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [sym_none] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [sym_comment] = ACTIONS(73),
  },
  [1174] = {
    [sym__expression] = STATE(742),
    [sym__primary_expression] = STATE(95),
    [sym_not_operator] = STATE(742),
    [sym_boolean_operator] = STATE(742),
    [sym_binary_operator] = STATE(95),
    [sym_unary_operator] = STATE(95),
    [sym_comparison_operator] = STATE(742),
    [sym_lambda] = STATE(742),
    [sym_attribute] = STATE(95),
    [sym_subscript] = STATE(95),
    [sym_call] = STATE(95),
    [sym_list] = STATE(95),
    [sym_list_comprehension] = STATE(95),
    [sym_dictionary] = STATE(95),
    [sym_dictionary_comprehension] = STATE(95),
    [sym_set] = STATE(95),
    [sym_set_comprehension] = STATE(95),
    [sym_parenthesized_expression] = STATE(95),
    [sym_tuple] = STATE(95),
    [sym_generator_expression] = STATE(95),
    [sym_conditional_expression] = STATE(742),
    [sym_concatenated_string] = STATE(95),
    [sym_string] = STATE(96),
    [sym_await] = STATE(742),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(153),
    [anon_sym_PLUS] = ACTIONS(155),
    [anon_sym_DASH] = ACTIONS(155),
    [anon_sym_TILDE] = ACTIONS(155),
    [anon_sym_lambda] = ACTIONS(157),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(159),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(161),
    [sym_float] = ACTIONS(161),
    [sym_identifier] = ACTIONS(161),
    [sym_true] = ACTIONS(161),
    [sym_false] = ACTIONS(161),
    [sym_none] = ACTIONS(161),
    [anon_sym_await] = ACTIONS(163),
    [sym_comment] = ACTIONS(73),
  },
  [1175] = {
    [sym_argument_list] = STATE(315),
    [sym_generator_expression] = STATE(315),
    [sym__newline] = ACTIONS(2942),
    [anon_sym_DOT] = ACTIONS(507),
    [anon_sym_from] = ACTIONS(2942),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_COMMA] = ACTIONS(2942),
    [anon_sym_STAR] = ACTIONS(573),
    [anon_sym_GT_GT] = ACTIONS(575),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_in] = ACTIONS(2942),
    [anon_sym_AT] = ACTIONS(579),
    [anon_sym_not] = ACTIONS(2942),
    [anon_sym_and] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(583),
    [anon_sym_DASH] = ACTIONS(583),
    [anon_sym_SLASH] = ACTIONS(573),
    [anon_sym_PERCENT] = ACTIONS(579),
    [anon_sym_SLASH_SLASH] = ACTIONS(579),
    [anon_sym_STAR_STAR] = ACTIONS(585),
    [anon_sym_PIPE] = ACTIONS(587),
    [anon_sym_AMP] = ACTIONS(589),
    [anon_sym_CARET] = ACTIONS(591),
    [anon_sym_LT_LT] = ACTIONS(575),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_LT_EQ] = ACTIONS(2942),
    [anon_sym_EQ_EQ] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_GT_EQ] = ACTIONS(2942),
    [anon_sym_GT] = ACTIONS(2944),
    [anon_sym_LT_GT] = ACTIONS(2942),
    [anon_sym_is] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(535),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2942),
  },
  [1176] = {
    [anon_sym_if] = ACTIONS(599),
    [anon_sym_COLON] = ACTIONS(2647),
    [anon_sym_and] = ACTIONS(603),
    [anon_sym_or] = ACTIONS(605),
    [sym_comment] = ACTIONS(73),
  },
  [1177] = {
    [sym__expression] = STATE(1495),
    [sym__primary_expression] = STATE(102),
    [sym_not_operator] = STATE(1495),
    [sym_boolean_operator] = STATE(1495),
    [sym_binary_operator] = STATE(102),
    [sym_unary_operator] = STATE(102),
    [sym_comparison_operator] = STATE(1495),
    [sym_lambda] = STATE(1495),
    [sym_attribute] = STATE(102),
    [sym_subscript] = STATE(102),
    [sym_call] = STATE(102),
    [sym_list] = STATE(102),
    [sym_list_comprehension] = STATE(102),
    [sym_dictionary] = STATE(102),
    [sym_dictionary_comprehension] = STATE(102),
    [sym_set] = STATE(102),
    [sym_set_comprehension] = STATE(102),
    [sym_parenthesized_expression] = STATE(102),
    [sym_tuple] = STATE(102),
    [sym_generator_expression] = STATE(102),
    [sym_conditional_expression] = STATE(1495),
    [sym_concatenated_string] = STATE(102),
    [sym_string] = STATE(103),
    [sym_await] = STATE(1495),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [1178] = {
    [sym__string_start] = ACTIONS(2410),
    [ts_builtin_sym_end] = ACTIONS(2410),
    [anon_sym_import] = ACTIONS(3142),
    [anon_sym_from] = ACTIONS(3142),
    [anon_sym_LPAREN] = ACTIONS(2410),
    [anon_sym_print] = ACTIONS(3142),
    [anon_sym_assert] = ACTIONS(3142),
    [anon_sym_return] = ACTIONS(3142),
    [anon_sym_del] = ACTIONS(3142),
    [anon_sym_raise] = ACTIONS(3142),
    [anon_sym_pass] = ACTIONS(3142),
    [anon_sym_break] = ACTIONS(3142),
    [anon_sym_continue] = ACTIONS(3142),
    [anon_sym_if] = ACTIONS(3142),
    [anon_sym_elif] = ACTIONS(3142),
    [anon_sym_else] = ACTIONS(3142),
    [anon_sym_async] = ACTIONS(3142),
    [anon_sym_for] = ACTIONS(3142),
    [anon_sym_while] = ACTIONS(3142),
    [anon_sym_try] = ACTIONS(3142),
    [anon_sym_except] = ACTIONS(3142),
    [anon_sym_finally] = ACTIONS(3142),
    [anon_sym_with] = ACTIONS(3142),
    [anon_sym_def] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3142),
    [anon_sym_nonlocal] = ACTIONS(3142),
    [anon_sym_exec] = ACTIONS(3142),
    [anon_sym_class] = ACTIONS(3142),
    [anon_sym_AT] = ACTIONS(2410),
    [anon_sym_not] = ACTIONS(3142),
    [anon_sym_PLUS] = ACTIONS(2410),
    [anon_sym_DASH] = ACTIONS(2410),
    [anon_sym_TILDE] = ACTIONS(2410),
    [anon_sym_lambda] = ACTIONS(3142),
    [anon_sym_yield] = ACTIONS(3142),
    [anon_sym_LBRACK] = ACTIONS(2410),
    [sym_ellipsis] = ACTIONS(2410),
    [anon_sym_LBRACE] = ACTIONS(2410),
    [sym_integer] = ACTIONS(3142),
    [sym_float] = ACTIONS(3142),
    [sym_identifier] = ACTIONS(3142),
    [sym_true] = ACTIONS(3142),
    [sym_false] = ACTIONS(3142),
    [sym_none] = ACTIONS(3142),
    [anon_sym_await] = ACTIONS(3142),
    [sym_comment] = ACTIONS(73),
  },
  [1179] = {
    [sym__statement] = STATE(1209),
    [sym__simple_statements] = STATE(1209),
    [sym_import_statement] = STATE(799),
    [sym_future_import_statement] = STATE(799),
    [sym_import_from_statement] = STATE(799),
    [sym_print_statement] = STATE(799),
    [sym_assert_statement] = STATE(799),
    [sym_expression_statement] = STATE(799),
    [sym_return_statement] = STATE(799),
    [sym_delete_statement] = STATE(799),
    [sym_raise_statement] = STATE(799),
    [sym_pass_statement] = STATE(799),
    [sym_break_statement] = STATE(799),
    [sym_continue_statement] = STATE(799),
    [sym_if_statement] = STATE(1209),
    [sym_for_statement] = STATE(1209),
    [sym_while_statement] = STATE(1209),
    [sym_try_statement] = STATE(1209),
    [sym_with_statement] = STATE(1209),
    [sym_function_definition] = STATE(1209),
    [sym_global_statement] = STATE(799),
    [sym_nonlocal_statement] = STATE(799),
    [sym_exec_statement] = STATE(799),
    [sym_class_definition] = STATE(1209),
    [sym_decorated_definition] = STATE(1209),
    [sym_decorator] = STATE(801),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [aux_sym_module_repeat1] = STATE(1209),
    [aux_sym_decorated_definition_repeat1] = STATE(801),
    [sym__dedent] = ACTIONS(3144),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(1522),
    [anon_sym_async] = ACTIONS(1524),
    [anon_sym_for] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1528),
    [anon_sym_try] = ACTIONS(1530),
    [anon_sym_with] = ACTIONS(1532),
    [anon_sym_def] = ACTIONS(1534),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1536),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1180] = {
    [sym__expression] = STATE(1497),
    [sym__primary_expression] = STATE(102),
    [sym_not_operator] = STATE(1497),
    [sym_boolean_operator] = STATE(1497),
    [sym_binary_operator] = STATE(102),
    [sym_unary_operator] = STATE(102),
    [sym_comparison_operator] = STATE(1497),
    [sym_lambda] = STATE(1497),
    [sym_attribute] = STATE(102),
    [sym_subscript] = STATE(102),
    [sym_call] = STATE(102),
    [sym_list] = STATE(102),
    [sym_list_comprehension] = STATE(102),
    [sym_dictionary] = STATE(102),
    [sym_dictionary_comprehension] = STATE(102),
    [sym_set] = STATE(102),
    [sym_set_comprehension] = STATE(102),
    [sym_parenthesized_expression] = STATE(102),
    [sym_tuple] = STATE(102),
    [sym_generator_expression] = STATE(102),
    [sym_conditional_expression] = STATE(1497),
    [sym_concatenated_string] = STATE(102),
    [sym_string] = STATE(103),
    [sym_await] = STATE(1497),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [1181] = {
    [anon_sym_COLON] = ACTIONS(3146),
    [sym_comment] = ACTIONS(73),
  },
  [1182] = {
    [sym__string_start] = ACTIONS(3148),
    [ts_builtin_sym_end] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_from] = ACTIONS(3150),
    [anon_sym_LPAREN] = ACTIONS(3148),
    [anon_sym_print] = ACTIONS(3150),
    [anon_sym_assert] = ACTIONS(3150),
    [anon_sym_return] = ACTIONS(3150),
    [anon_sym_del] = ACTIONS(3150),
    [anon_sym_raise] = ACTIONS(3150),
    [anon_sym_pass] = ACTIONS(3150),
    [anon_sym_break] = ACTIONS(3150),
    [anon_sym_continue] = ACTIONS(3150),
    [anon_sym_if] = ACTIONS(3150),
    [anon_sym_async] = ACTIONS(3150),
    [anon_sym_for] = ACTIONS(3150),
    [anon_sym_while] = ACTIONS(3150),
    [anon_sym_try] = ACTIONS(3150),
    [anon_sym_with] = ACTIONS(3150),
    [anon_sym_def] = ACTIONS(3150),
    [anon_sym_global] = ACTIONS(3150),
    [anon_sym_nonlocal] = ACTIONS(3150),
    [anon_sym_exec] = ACTIONS(3150),
    [anon_sym_class] = ACTIONS(3150),
    [anon_sym_AT] = ACTIONS(3148),
    [anon_sym_not] = ACTIONS(3150),
    [anon_sym_PLUS] = ACTIONS(3148),
    [anon_sym_DASH] = ACTIONS(3148),
    [anon_sym_TILDE] = ACTIONS(3148),
    [anon_sym_lambda] = ACTIONS(3150),
    [anon_sym_yield] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [sym_ellipsis] = ACTIONS(3148),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [sym_integer] = ACTIONS(3150),
    [sym_float] = ACTIONS(3150),
    [sym_identifier] = ACTIONS(3150),
    [sym_true] = ACTIONS(3150),
    [sym_false] = ACTIONS(3150),
    [sym_none] = ACTIONS(3150),
    [anon_sym_await] = ACTIONS(3150),
    [sym_comment] = ACTIONS(73),
  },
  [1183] = {
    [sym_elif_clause] = STATE(1500),
    [sym_else_clause] = STATE(1499),
    [aux_sym_if_statement_repeat1] = STATE(1500),
    [sym__string_start] = ACTIONS(3148),
    [ts_builtin_sym_end] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_from] = ACTIONS(3150),
    [anon_sym_LPAREN] = ACTIONS(3148),
    [anon_sym_print] = ACTIONS(3150),
    [anon_sym_assert] = ACTIONS(3150),
    [anon_sym_return] = ACTIONS(3150),
    [anon_sym_del] = ACTIONS(3150),
    [anon_sym_raise] = ACTIONS(3150),
    [anon_sym_pass] = ACTIONS(3150),
    [anon_sym_break] = ACTIONS(3150),
    [anon_sym_continue] = ACTIONS(3150),
    [anon_sym_if] = ACTIONS(3150),
    [anon_sym_elif] = ACTIONS(2369),
    [anon_sym_else] = ACTIONS(2371),
    [anon_sym_async] = ACTIONS(3150),
    [anon_sym_for] = ACTIONS(3150),
    [anon_sym_while] = ACTIONS(3150),
    [anon_sym_try] = ACTIONS(3150),
    [anon_sym_with] = ACTIONS(3150),
    [anon_sym_def] = ACTIONS(3150),
    [anon_sym_global] = ACTIONS(3150),
    [anon_sym_nonlocal] = ACTIONS(3150),
    [anon_sym_exec] = ACTIONS(3150),
    [anon_sym_class] = ACTIONS(3150),
    [anon_sym_AT] = ACTIONS(3148),
    [anon_sym_not] = ACTIONS(3150),
    [anon_sym_PLUS] = ACTIONS(3148),
    [anon_sym_DASH] = ACTIONS(3148),
    [anon_sym_TILDE] = ACTIONS(3148),
    [anon_sym_lambda] = ACTIONS(3150),
    [anon_sym_yield] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [sym_ellipsis] = ACTIONS(3148),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [sym_integer] = ACTIONS(3150),
    [sym_float] = ACTIONS(3150),
    [sym_identifier] = ACTIONS(3150),
    [sym_true] = ACTIONS(3150),
    [sym_false] = ACTIONS(3150),
    [sym_none] = ACTIONS(3150),
    [anon_sym_await] = ACTIONS(3150),
    [sym_comment] = ACTIONS(73),
  },
  [1184] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(607),
    [anon_sym_GT_GT] = ACTIONS(609),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_COLON] = ACTIONS(2942),
    [anon_sym_in] = ACTIONS(2942),
    [anon_sym_AT] = ACTIONS(613),
    [anon_sym_not] = ACTIONS(2942),
    [anon_sym_and] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(617),
    [anon_sym_DASH] = ACTIONS(617),
    [anon_sym_SLASH] = ACTIONS(607),
    [anon_sym_PERCENT] = ACTIONS(613),
    [anon_sym_SLASH_SLASH] = ACTIONS(613),
    [anon_sym_STAR_STAR] = ACTIONS(619),
    [anon_sym_PIPE] = ACTIONS(621),
    [anon_sym_AMP] = ACTIONS(623),
    [anon_sym_CARET] = ACTIONS(625),
    [anon_sym_LT_LT] = ACTIONS(609),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_LT_EQ] = ACTIONS(2942),
    [anon_sym_EQ_EQ] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_GT_EQ] = ACTIONS(2942),
    [anon_sym_GT] = ACTIONS(2944),
    [anon_sym_LT_GT] = ACTIONS(2942),
    [anon_sym_is] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(473),
    [sym_comment] = ACTIONS(73),
  },
  [1185] = {
    [anon_sym_COLON] = ACTIONS(3152),
    [sym_comment] = ACTIONS(73),
  },
  [1186] = {
    [sym__string_start] = ACTIONS(3154),
    [ts_builtin_sym_end] = ACTIONS(3154),
    [anon_sym_import] = ACTIONS(3156),
    [anon_sym_from] = ACTIONS(3156),
    [anon_sym_LPAREN] = ACTIONS(3154),
    [anon_sym_print] = ACTIONS(3156),
    [anon_sym_assert] = ACTIONS(3156),
    [anon_sym_return] = ACTIONS(3156),
    [anon_sym_del] = ACTIONS(3156),
    [anon_sym_raise] = ACTIONS(3156),
    [anon_sym_pass] = ACTIONS(3156),
    [anon_sym_break] = ACTIONS(3156),
    [anon_sym_continue] = ACTIONS(3156),
    [anon_sym_if] = ACTIONS(3156),
    [anon_sym_async] = ACTIONS(3156),
    [anon_sym_for] = ACTIONS(3156),
    [anon_sym_while] = ACTIONS(3156),
    [anon_sym_try] = ACTIONS(3156),
    [anon_sym_with] = ACTIONS(3156),
    [anon_sym_def] = ACTIONS(3156),
    [anon_sym_global] = ACTIONS(3156),
    [anon_sym_nonlocal] = ACTIONS(3156),
    [anon_sym_exec] = ACTIONS(3156),
    [anon_sym_class] = ACTIONS(3156),
    [anon_sym_AT] = ACTIONS(3154),
    [anon_sym_not] = ACTIONS(3156),
    [anon_sym_PLUS] = ACTIONS(3154),
    [anon_sym_DASH] = ACTIONS(3154),
    [anon_sym_TILDE] = ACTIONS(3154),
    [anon_sym_lambda] = ACTIONS(3156),
    [anon_sym_yield] = ACTIONS(3156),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [sym_ellipsis] = ACTIONS(3154),
    [anon_sym_LBRACE] = ACTIONS(3154),
    [sym_integer] = ACTIONS(3156),
    [sym_float] = ACTIONS(3156),
    [sym_identifier] = ACTIONS(3156),
    [sym_true] = ACTIONS(3156),
    [sym_false] = ACTIONS(3156),
    [sym_none] = ACTIONS(3156),
    [anon_sym_await] = ACTIONS(3156),
    [sym_comment] = ACTIONS(73),
  },
  [1187] = {
    [sym__simple_statements] = STATE(1502),
    [sym_import_statement] = STATE(34),
    [sym_future_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym__suite] = STATE(1502),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(1448),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1188] = {
    [sym__simple_statements] = STATE(1503),
    [sym_import_statement] = STATE(34),
    [sym_future_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym__suite] = STATE(1503),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(1448),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1189] = {
    [sym__expression] = STATE(1242),
    [sym__primary_expression] = STATE(102),
    [sym_not_operator] = STATE(1242),
    [sym_boolean_operator] = STATE(1242),
    [sym_binary_operator] = STATE(102),
    [sym_unary_operator] = STATE(102),
    [sym_comparison_operator] = STATE(1242),
    [sym_lambda] = STATE(1242),
    [sym_attribute] = STATE(102),
    [sym_subscript] = STATE(102),
    [sym_call] = STATE(102),
    [sym_type] = STATE(1504),
    [sym_list] = STATE(102),
    [sym_list_comprehension] = STATE(102),
    [sym_dictionary] = STATE(102),
    [sym_dictionary_comprehension] = STATE(102),
    [sym_set] = STATE(102),
    [sym_set_comprehension] = STATE(102),
    [sym_parenthesized_expression] = STATE(102),
    [sym_tuple] = STATE(102),
    [sym_generator_expression] = STATE(102),
    [sym_conditional_expression] = STATE(1242),
    [sym_concatenated_string] = STATE(102),
    [sym_string] = STATE(103),
    [sym_await] = STATE(1242),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [1190] = {
    [sym__simple_statements] = STATE(1505),
    [sym_import_statement] = STATE(34),
    [sym_future_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym__suite] = STATE(1505),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(1448),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1191] = {
    [sym__expression] = STATE(1506),
    [sym__primary_expression] = STATE(432),
    [sym_not_operator] = STATE(1506),
    [sym_boolean_operator] = STATE(1506),
    [sym_binary_operator] = STATE(432),
    [sym_unary_operator] = STATE(432),
    [sym_comparison_operator] = STATE(1506),
    [sym_lambda] = STATE(1506),
    [sym_attribute] = STATE(432),
    [sym_subscript] = STATE(432),
    [sym_call] = STATE(432),
    [sym_list] = STATE(432),
    [sym_list_comprehension] = STATE(432),
    [sym_dictionary] = STATE(432),
    [sym_dictionary_comprehension] = STATE(432),
    [sym_set] = STATE(432),
    [sym_set_comprehension] = STATE(432),
    [sym_parenthesized_expression] = STATE(432),
    [sym_tuple] = STATE(432),
    [sym_generator_expression] = STATE(432),
    [sym_conditional_expression] = STATE(1506),
    [sym_concatenated_string] = STATE(432),
    [sym_string] = STATE(433),
    [sym_await] = STATE(1506),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(907),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(735),
    [anon_sym_lambda] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(741),
    [sym_float] = ACTIONS(741),
    [sym_identifier] = ACTIONS(741),
    [sym_true] = ACTIONS(741),
    [sym_false] = ACTIONS(741),
    [sym_none] = ACTIONS(741),
    [anon_sym_await] = ACTIONS(743),
    [sym_comment] = ACTIONS(73),
  },
  [1192] = {
    [aux_sym_print_statement_repeat1] = STATE(1508),
    [anon_sym_COMMA] = ACTIONS(3158),
    [anon_sym_COLON] = ACTIONS(907),
    [sym_comment] = ACTIONS(73),
  },
  [1193] = {
    [sym__primary_expression] = STATE(779),
    [sym_binary_operator] = STATE(779),
    [sym_unary_operator] = STATE(779),
    [sym_attribute] = STATE(779),
    [sym_subscript] = STATE(779),
    [sym_call] = STATE(779),
    [sym_list] = STATE(779),
    [sym_list_comprehension] = STATE(779),
    [sym_dictionary] = STATE(779),
    [sym_dictionary_comprehension] = STATE(779),
    [sym_set] = STATE(779),
    [sym_set_comprehension] = STATE(779),
    [sym_parenthesized_expression] = STATE(779),
    [sym_tuple] = STATE(779),
    [sym_generator_expression] = STATE(779),
    [sym_concatenated_string] = STATE(779),
    [sym_string] = STATE(110),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1488),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1490),
    [sym_float] = ACTIONS(1490),
    [sym_identifier] = ACTIONS(1490),
    [sym_true] = ACTIONS(1490),
    [sym_false] = ACTIONS(1490),
    [sym_none] = ACTIONS(1490),
    [sym_comment] = ACTIONS(73),
  },
  [1194] = {
    [sym__string_start] = ACTIONS(3160),
    [ts_builtin_sym_end] = ACTIONS(3160),
    [anon_sym_import] = ACTIONS(3162),
    [anon_sym_from] = ACTIONS(3162),
    [anon_sym_LPAREN] = ACTIONS(3160),
    [anon_sym_print] = ACTIONS(3162),
    [anon_sym_assert] = ACTIONS(3162),
    [anon_sym_return] = ACTIONS(3162),
    [anon_sym_del] = ACTIONS(3162),
    [anon_sym_raise] = ACTIONS(3162),
    [anon_sym_pass] = ACTIONS(3162),
    [anon_sym_break] = ACTIONS(3162),
    [anon_sym_continue] = ACTIONS(3162),
    [anon_sym_if] = ACTIONS(3162),
    [anon_sym_async] = ACTIONS(3162),
    [anon_sym_for] = ACTIONS(3162),
    [anon_sym_while] = ACTIONS(3162),
    [anon_sym_try] = ACTIONS(3162),
    [anon_sym_with] = ACTIONS(3162),
    [anon_sym_def] = ACTIONS(3162),
    [anon_sym_global] = ACTIONS(3162),
    [anon_sym_nonlocal] = ACTIONS(3162),
    [anon_sym_exec] = ACTIONS(3162),
    [anon_sym_class] = ACTIONS(3162),
    [anon_sym_AT] = ACTIONS(3160),
    [anon_sym_not] = ACTIONS(3162),
    [anon_sym_PLUS] = ACTIONS(3160),
    [anon_sym_DASH] = ACTIONS(3160),
    [anon_sym_TILDE] = ACTIONS(3160),
    [anon_sym_lambda] = ACTIONS(3162),
    [anon_sym_yield] = ACTIONS(3162),
    [anon_sym_LBRACK] = ACTIONS(3160),
    [sym_ellipsis] = ACTIONS(3160),
    [anon_sym_LBRACE] = ACTIONS(3160),
    [sym_integer] = ACTIONS(3162),
    [sym_float] = ACTIONS(3162),
    [sym_identifier] = ACTIONS(3162),
    [sym_true] = ACTIONS(3162),
    [sym_false] = ACTIONS(3162),
    [sym_none] = ACTIONS(3162),
    [anon_sym_await] = ACTIONS(3162),
    [sym_comment] = ACTIONS(73),
  },
  [1195] = {
    [anon_sym_if] = ACTIONS(599),
    [anon_sym_COLON] = ACTIONS(3164),
    [anon_sym_and] = ACTIONS(603),
    [anon_sym_or] = ACTIONS(605),
    [sym_comment] = ACTIONS(73),
  },
  [1196] = {
    [sym_variables] = STATE(1510),
    [sym__primary_expression] = STATE(109),
    [sym_binary_operator] = STATE(109),
    [sym_unary_operator] = STATE(109),
    [sym_attribute] = STATE(109),
    [sym_subscript] = STATE(109),
    [sym_call] = STATE(109),
    [sym_list] = STATE(109),
    [sym_list_comprehension] = STATE(109),
    [sym_dictionary] = STATE(109),
    [sym_dictionary_comprehension] = STATE(109),
    [sym_set] = STATE(109),
    [sym_set_comprehension] = STATE(109),
    [sym_parenthesized_expression] = STATE(109),
    [sym_tuple] = STATE(109),
    [sym_generator_expression] = STATE(109),
    [sym_concatenated_string] = STATE(109),
    [sym_string] = STATE(110),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(189),
    [anon_sym_DASH] = ACTIONS(189),
    [anon_sym_TILDE] = ACTIONS(189),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(191),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(193),
    [sym_float] = ACTIONS(193),
    [sym_identifier] = ACTIONS(193),
    [sym_true] = ACTIONS(193),
    [sym_false] = ACTIONS(193),
    [sym_none] = ACTIONS(193),
    [sym_comment] = ACTIONS(73),
  },
  [1197] = {
    [sym_with_item] = STATE(1511),
    [sym__expression] = STATE(118),
    [sym__primary_expression] = STATE(119),
    [sym_not_operator] = STATE(118),
    [sym_boolean_operator] = STATE(118),
    [sym_binary_operator] = STATE(119),
    [sym_unary_operator] = STATE(119),
    [sym_comparison_operator] = STATE(118),
    [sym_lambda] = STATE(118),
    [sym_attribute] = STATE(119),
    [sym_subscript] = STATE(119),
    [sym_call] = STATE(119),
    [sym_list] = STATE(119),
    [sym_list_comprehension] = STATE(119),
    [sym_dictionary] = STATE(119),
    [sym_dictionary_comprehension] = STATE(119),
    [sym_set] = STATE(119),
    [sym_set_comprehension] = STATE(119),
    [sym_parenthesized_expression] = STATE(119),
    [sym_tuple] = STATE(119),
    [sym_generator_expression] = STATE(119),
    [sym_conditional_expression] = STATE(118),
    [sym_concatenated_string] = STATE(119),
    [sym_string] = STATE(120),
    [sym_await] = STATE(118),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(197),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_lambda] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(203),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(205),
    [sym_float] = ACTIONS(205),
    [sym_identifier] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_none] = ACTIONS(205),
    [anon_sym_await] = ACTIONS(207),
    [sym_comment] = ACTIONS(73),
  },
  [1198] = {
    [sym_identifier] = ACTIONS(3166),
    [sym_comment] = ACTIONS(73),
  },
  [1199] = {
    [anon_sym_in] = ACTIONS(3168),
    [sym_comment] = ACTIONS(73),
  },
  [1200] = {
    [anon_sym_if] = ACTIONS(599),
    [anon_sym_COLON] = ACTIONS(3170),
    [anon_sym_and] = ACTIONS(603),
    [anon_sym_or] = ACTIONS(605),
    [sym_comment] = ACTIONS(73),
  },
  [1201] = {
    [sym__simple_statements] = STATE(1515),
    [sym_import_statement] = STATE(385),
    [sym_future_import_statement] = STATE(385),
    [sym_import_from_statement] = STATE(385),
    [sym_print_statement] = STATE(385),
    [sym_assert_statement] = STATE(385),
    [sym_expression_statement] = STATE(385),
    [sym_return_statement] = STATE(385),
    [sym_delete_statement] = STATE(385),
    [sym_raise_statement] = STATE(385),
    [sym_pass_statement] = STATE(385),
    [sym_break_statement] = STATE(385),
    [sym_continue_statement] = STATE(385),
    [sym_global_statement] = STATE(385),
    [sym_nonlocal_statement] = STATE(385),
    [sym_exec_statement] = STATE(385),
    [sym__suite] = STATE(1515),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(657),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1202] = {
    [aux_sym_with_statement_repeat1] = STATE(1517),
    [anon_sym_COMMA] = ACTIONS(661),
    [anon_sym_COLON] = ACTIONS(3172),
    [sym_comment] = ACTIONS(73),
  },
  [1203] = {
    [sym_parameters] = STATE(1518),
    [anon_sym_LPAREN] = ACTIONS(699),
    [sym_comment] = ACTIONS(73),
  },
  [1204] = {
    [sym_argument_list] = STATE(1520),
    [anon_sym_LPAREN] = ACTIONS(715),
    [anon_sym_COLON] = ACTIONS(3174),
    [sym_comment] = ACTIONS(73),
  },
  [1205] = {
    [sym__dedent] = ACTIONS(885),
    [sym__string_start] = ACTIONS(885),
    [anon_sym_import] = ACTIONS(887),
    [anon_sym_from] = ACTIONS(887),
    [anon_sym_LPAREN] = ACTIONS(885),
    [anon_sym_print] = ACTIONS(887),
    [anon_sym_assert] = ACTIONS(887),
    [anon_sym_return] = ACTIONS(887),
    [anon_sym_del] = ACTIONS(887),
    [anon_sym_raise] = ACTIONS(887),
    [anon_sym_pass] = ACTIONS(887),
    [anon_sym_break] = ACTIONS(887),
    [anon_sym_continue] = ACTIONS(887),
    [anon_sym_if] = ACTIONS(887),
    [anon_sym_elif] = ACTIONS(887),
    [anon_sym_else] = ACTIONS(887),
    [anon_sym_async] = ACTIONS(887),
    [anon_sym_for] = ACTIONS(887),
    [anon_sym_while] = ACTIONS(887),
    [anon_sym_try] = ACTIONS(887),
    [anon_sym_except] = ACTIONS(887),
    [anon_sym_finally] = ACTIONS(887),
    [anon_sym_with] = ACTIONS(887),
    [anon_sym_def] = ACTIONS(887),
    [anon_sym_global] = ACTIONS(887),
    [anon_sym_nonlocal] = ACTIONS(887),
    [anon_sym_exec] = ACTIONS(887),
    [anon_sym_class] = ACTIONS(887),
    [anon_sym_AT] = ACTIONS(885),
    [anon_sym_not] = ACTIONS(887),
    [anon_sym_PLUS] = ACTIONS(885),
    [anon_sym_DASH] = ACTIONS(885),
    [anon_sym_TILDE] = ACTIONS(885),
    [anon_sym_lambda] = ACTIONS(887),
    [anon_sym_yield] = ACTIONS(887),
    [anon_sym_LBRACK] = ACTIONS(885),
    [sym_ellipsis] = ACTIONS(885),
    [anon_sym_LBRACE] = ACTIONS(885),
    [sym_integer] = ACTIONS(887),
    [sym_float] = ACTIONS(887),
    [sym_identifier] = ACTIONS(887),
    [sym_true] = ACTIONS(887),
    [sym_false] = ACTIONS(887),
    [sym_none] = ACTIONS(887),
    [anon_sym_await] = ACTIONS(887),
    [sym_comment] = ACTIONS(73),
  },
  [1206] = {
    [sym_import_statement] = STATE(517),
    [sym_future_import_statement] = STATE(517),
    [sym_import_from_statement] = STATE(517),
    [sym_print_statement] = STATE(517),
    [sym_assert_statement] = STATE(517),
    [sym_expression_statement] = STATE(517),
    [sym_return_statement] = STATE(517),
    [sym_delete_statement] = STATE(517),
    [sym_raise_statement] = STATE(517),
    [sym_pass_statement] = STATE(517),
    [sym_break_statement] = STATE(517),
    [sym_continue_statement] = STATE(517),
    [sym_global_statement] = STATE(517),
    [sym_nonlocal_statement] = STATE(517),
    [sym_exec_statement] = STATE(517),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__newline] = ACTIONS(3176),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1207] = {
    [aux_sym__simple_statements_repeat1] = STATE(519),
    [sym__newline] = ACTIONS(3176),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3178),
  },
  [1208] = {
    [anon_sym_except] = ACTIONS(3180),
    [anon_sym_finally] = ACTIONS(3180),
    [sym_comment] = ACTIONS(73),
  },
  [1209] = {
    [sym__statement] = STATE(1209),
    [sym__simple_statements] = STATE(1209),
    [sym_import_statement] = STATE(799),
    [sym_future_import_statement] = STATE(799),
    [sym_import_from_statement] = STATE(799),
    [sym_print_statement] = STATE(799),
    [sym_assert_statement] = STATE(799),
    [sym_expression_statement] = STATE(799),
    [sym_return_statement] = STATE(799),
    [sym_delete_statement] = STATE(799),
    [sym_raise_statement] = STATE(799),
    [sym_pass_statement] = STATE(799),
    [sym_break_statement] = STATE(799),
    [sym_continue_statement] = STATE(799),
    [sym_if_statement] = STATE(1209),
    [sym_for_statement] = STATE(1209),
    [sym_while_statement] = STATE(1209),
    [sym_try_statement] = STATE(1209),
    [sym_with_statement] = STATE(1209),
    [sym_function_definition] = STATE(1209),
    [sym_global_statement] = STATE(799),
    [sym_nonlocal_statement] = STATE(799),
    [sym_exec_statement] = STATE(799),
    [sym_class_definition] = STATE(1209),
    [sym_decorated_definition] = STATE(1209),
    [sym_decorator] = STATE(801),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [aux_sym_module_repeat1] = STATE(1209),
    [aux_sym_decorated_definition_repeat1] = STATE(801),
    [sym__dedent] = ACTIONS(1002),
    [sym__string_start] = ACTIONS(999),
    [anon_sym_import] = ACTIONS(1004),
    [anon_sym_from] = ACTIONS(1007),
    [anon_sym_LPAREN] = ACTIONS(1010),
    [anon_sym_print] = ACTIONS(1013),
    [anon_sym_assert] = ACTIONS(1016),
    [anon_sym_return] = ACTIONS(1019),
    [anon_sym_del] = ACTIONS(1022),
    [anon_sym_raise] = ACTIONS(1025),
    [anon_sym_pass] = ACTIONS(1028),
    [anon_sym_break] = ACTIONS(1031),
    [anon_sym_continue] = ACTIONS(1034),
    [anon_sym_if] = ACTIONS(3182),
    [anon_sym_async] = ACTIONS(3185),
    [anon_sym_for] = ACTIONS(3188),
    [anon_sym_while] = ACTIONS(3191),
    [anon_sym_try] = ACTIONS(3194),
    [anon_sym_with] = ACTIONS(3197),
    [anon_sym_def] = ACTIONS(3200),
    [anon_sym_global] = ACTIONS(1058),
    [anon_sym_nonlocal] = ACTIONS(1061),
    [anon_sym_exec] = ACTIONS(1064),
    [anon_sym_class] = ACTIONS(3203),
    [anon_sym_AT] = ACTIONS(1070),
    [anon_sym_not] = ACTIONS(1073),
    [anon_sym_PLUS] = ACTIONS(1076),
    [anon_sym_DASH] = ACTIONS(1076),
    [anon_sym_TILDE] = ACTIONS(1076),
    [anon_sym_lambda] = ACTIONS(1079),
    [anon_sym_yield] = ACTIONS(1082),
    [anon_sym_LBRACK] = ACTIONS(1085),
    [sym_ellipsis] = ACTIONS(1088),
    [anon_sym_LBRACE] = ACTIONS(1091),
    [sym_integer] = ACTIONS(1094),
    [sym_float] = ACTIONS(1094),
    [sym_identifier] = ACTIONS(1094),
    [sym_true] = ACTIONS(1094),
    [sym_false] = ACTIONS(1094),
    [sym_none] = ACTIONS(1094),
    [anon_sym_await] = ACTIONS(1097),
    [sym_comment] = ACTIONS(73),
  },
  [1210] = {
    [anon_sym_def] = ACTIONS(2416),
    [sym_comment] = ACTIONS(73),
  },
  [1211] = {
    [sym__dedent] = ACTIONS(1100),
    [sym__string_start] = ACTIONS(1100),
    [anon_sym_import] = ACTIONS(1102),
    [anon_sym_from] = ACTIONS(1102),
    [anon_sym_LPAREN] = ACTIONS(1100),
    [anon_sym_print] = ACTIONS(1102),
    [anon_sym_assert] = ACTIONS(1102),
    [anon_sym_return] = ACTIONS(1102),
    [anon_sym_del] = ACTIONS(1102),
    [anon_sym_raise] = ACTIONS(1102),
    [anon_sym_pass] = ACTIONS(1102),
    [anon_sym_break] = ACTIONS(1102),
    [anon_sym_continue] = ACTIONS(1102),
    [anon_sym_if] = ACTIONS(1102),
    [anon_sym_async] = ACTIONS(1102),
    [anon_sym_for] = ACTIONS(1102),
    [anon_sym_while] = ACTIONS(1102),
    [anon_sym_try] = ACTIONS(1102),
    [anon_sym_with] = ACTIONS(1102),
    [anon_sym_def] = ACTIONS(1102),
    [anon_sym_global] = ACTIONS(1102),
    [anon_sym_nonlocal] = ACTIONS(1102),
    [anon_sym_exec] = ACTIONS(1102),
    [anon_sym_class] = ACTIONS(1102),
    [anon_sym_AT] = ACTIONS(1100),
    [anon_sym_not] = ACTIONS(1102),
    [anon_sym_PLUS] = ACTIONS(1100),
    [anon_sym_DASH] = ACTIONS(1100),
    [anon_sym_TILDE] = ACTIONS(1100),
    [anon_sym_lambda] = ACTIONS(1102),
    [anon_sym_yield] = ACTIONS(1102),
    [anon_sym_LBRACK] = ACTIONS(1100),
    [sym_ellipsis] = ACTIONS(1100),
    [anon_sym_LBRACE] = ACTIONS(1100),
    [sym_integer] = ACTIONS(1102),
    [sym_float] = ACTIONS(1102),
    [sym_identifier] = ACTIONS(1102),
    [sym_true] = ACTIONS(1102),
    [sym_false] = ACTIONS(1102),
    [sym_none] = ACTIONS(1102),
    [anon_sym_await] = ACTIONS(1102),
    [sym_comment] = ACTIONS(73),
  },
  [1212] = {
    [anon_sym_except] = ACTIONS(1866),
    [anon_sym_finally] = ACTIONS(1866),
    [sym_comment] = ACTIONS(73),
  },
  [1213] = {
    [sym_import_statement] = STATE(517),
    [sym_future_import_statement] = STATE(517),
    [sym_import_from_statement] = STATE(517),
    [sym_print_statement] = STATE(517),
    [sym_assert_statement] = STATE(517),
    [sym_expression_statement] = STATE(517),
    [sym_return_statement] = STATE(517),
    [sym_delete_statement] = STATE(517),
    [sym_raise_statement] = STATE(517),
    [sym_pass_statement] = STATE(517),
    [sym_break_statement] = STATE(517),
    [sym_continue_statement] = STATE(517),
    [sym_global_statement] = STATE(517),
    [sym_nonlocal_statement] = STATE(517),
    [sym_exec_statement] = STATE(517),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__newline] = ACTIONS(3206),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1214] = {
    [sym__simple_statements] = STATE(1524),
    [sym_import_statement] = STATE(34),
    [sym_future_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym__suite] = STATE(1524),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(1448),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1215] = {
    [anon_sym_COMMA] = ACTIONS(3208),
    [anon_sym_as] = ACTIONS(3208),
    [anon_sym_if] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(3210),
    [anon_sym_and] = ACTIONS(671),
    [anon_sym_or] = ACTIONS(673),
    [sym_comment] = ACTIONS(73),
  },
  [1216] = {
    [sym__simple_statements] = STATE(1527),
    [sym_import_statement] = STATE(34),
    [sym_future_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym__suite] = STATE(1527),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(1448),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1217] = {
    [sym_finally_clause] = STATE(1528),
    [sym__string_start] = ACTIONS(3212),
    [ts_builtin_sym_end] = ACTIONS(3212),
    [anon_sym_import] = ACTIONS(3214),
    [anon_sym_from] = ACTIONS(3214),
    [anon_sym_LPAREN] = ACTIONS(3212),
    [anon_sym_print] = ACTIONS(3214),
    [anon_sym_assert] = ACTIONS(3214),
    [anon_sym_return] = ACTIONS(3214),
    [anon_sym_del] = ACTIONS(3214),
    [anon_sym_raise] = ACTIONS(3214),
    [anon_sym_pass] = ACTIONS(3214),
    [anon_sym_break] = ACTIONS(3214),
    [anon_sym_continue] = ACTIONS(3214),
    [anon_sym_if] = ACTIONS(3214),
    [anon_sym_async] = ACTIONS(3214),
    [anon_sym_for] = ACTIONS(3214),
    [anon_sym_while] = ACTIONS(3214),
    [anon_sym_try] = ACTIONS(3214),
    [anon_sym_finally] = ACTIONS(2450),
    [anon_sym_with] = ACTIONS(3214),
    [anon_sym_def] = ACTIONS(3214),
    [anon_sym_global] = ACTIONS(3214),
    [anon_sym_nonlocal] = ACTIONS(3214),
    [anon_sym_exec] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3214),
    [anon_sym_AT] = ACTIONS(3212),
    [anon_sym_not] = ACTIONS(3214),
    [anon_sym_PLUS] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [anon_sym_lambda] = ACTIONS(3214),
    [anon_sym_yield] = ACTIONS(3214),
    [anon_sym_LBRACK] = ACTIONS(3212),
    [sym_ellipsis] = ACTIONS(3212),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [sym_integer] = ACTIONS(3214),
    [sym_float] = ACTIONS(3214),
    [sym_identifier] = ACTIONS(3214),
    [sym_true] = ACTIONS(3214),
    [sym_false] = ACTIONS(3214),
    [sym_none] = ACTIONS(3214),
    [anon_sym_await] = ACTIONS(3214),
    [sym_comment] = ACTIONS(73),
  },
  [1218] = {
    [sym__string_start] = ACTIONS(3212),
    [ts_builtin_sym_end] = ACTIONS(3212),
    [anon_sym_import] = ACTIONS(3214),
    [anon_sym_from] = ACTIONS(3214),
    [anon_sym_LPAREN] = ACTIONS(3212),
    [anon_sym_print] = ACTIONS(3214),
    [anon_sym_assert] = ACTIONS(3214),
    [anon_sym_return] = ACTIONS(3214),
    [anon_sym_del] = ACTIONS(3214),
    [anon_sym_raise] = ACTIONS(3214),
    [anon_sym_pass] = ACTIONS(3214),
    [anon_sym_break] = ACTIONS(3214),
    [anon_sym_continue] = ACTIONS(3214),
    [anon_sym_if] = ACTIONS(3214),
    [anon_sym_async] = ACTIONS(3214),
    [anon_sym_for] = ACTIONS(3214),
    [anon_sym_while] = ACTIONS(3214),
    [anon_sym_try] = ACTIONS(3214),
    [anon_sym_with] = ACTIONS(3214),
    [anon_sym_def] = ACTIONS(3214),
    [anon_sym_global] = ACTIONS(3214),
    [anon_sym_nonlocal] = ACTIONS(3214),
    [anon_sym_exec] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3214),
    [anon_sym_AT] = ACTIONS(3212),
    [anon_sym_not] = ACTIONS(3214),
    [anon_sym_PLUS] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [anon_sym_lambda] = ACTIONS(3214),
    [anon_sym_yield] = ACTIONS(3214),
    [anon_sym_LBRACK] = ACTIONS(3212),
    [sym_ellipsis] = ACTIONS(3212),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [sym_integer] = ACTIONS(3214),
    [sym_float] = ACTIONS(3214),
    [sym_identifier] = ACTIONS(3214),
    [sym_true] = ACTIONS(3214),
    [sym_false] = ACTIONS(3214),
    [sym_none] = ACTIONS(3214),
    [anon_sym_await] = ACTIONS(3214),
    [sym_comment] = ACTIONS(73),
  },
  [1219] = {
    [sym_except_clause] = STATE(1219),
    [aux_sym_try_statement_repeat1] = STATE(1219),
    [sym__string_start] = ACTIONS(3216),
    [ts_builtin_sym_end] = ACTIONS(3216),
    [anon_sym_import] = ACTIONS(3218),
    [anon_sym_from] = ACTIONS(3218),
    [anon_sym_LPAREN] = ACTIONS(3216),
    [anon_sym_print] = ACTIONS(3218),
    [anon_sym_assert] = ACTIONS(3218),
    [anon_sym_return] = ACTIONS(3218),
    [anon_sym_del] = ACTIONS(3218),
    [anon_sym_raise] = ACTIONS(3218),
    [anon_sym_pass] = ACTIONS(3218),
    [anon_sym_break] = ACTIONS(3218),
    [anon_sym_continue] = ACTIONS(3218),
    [anon_sym_if] = ACTIONS(3218),
    [anon_sym_else] = ACTIONS(3218),
    [anon_sym_async] = ACTIONS(3218),
    [anon_sym_for] = ACTIONS(3218),
    [anon_sym_while] = ACTIONS(3218),
    [anon_sym_try] = ACTIONS(3218),
    [anon_sym_except] = ACTIONS(3220),
    [anon_sym_finally] = ACTIONS(3218),
    [anon_sym_with] = ACTIONS(3218),
    [anon_sym_def] = ACTIONS(3218),
    [anon_sym_global] = ACTIONS(3218),
    [anon_sym_nonlocal] = ACTIONS(3218),
    [anon_sym_exec] = ACTIONS(3218),
    [anon_sym_class] = ACTIONS(3218),
    [anon_sym_AT] = ACTIONS(3216),
    [anon_sym_not] = ACTIONS(3218),
    [anon_sym_PLUS] = ACTIONS(3216),
    [anon_sym_DASH] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_lambda] = ACTIONS(3218),
    [anon_sym_yield] = ACTIONS(3218),
    [anon_sym_LBRACK] = ACTIONS(3216),
    [sym_ellipsis] = ACTIONS(3216),
    [anon_sym_LBRACE] = ACTIONS(3216),
    [sym_integer] = ACTIONS(3218),
    [sym_float] = ACTIONS(3218),
    [sym_identifier] = ACTIONS(3218),
    [sym_true] = ACTIONS(3218),
    [sym_false] = ACTIONS(3218),
    [sym_none] = ACTIONS(3218),
    [anon_sym_await] = ACTIONS(3218),
    [sym_comment] = ACTIONS(73),
  },
  [1220] = {
    [anon_sym_COMMA] = ACTIONS(2647),
    [anon_sym_as] = ACTIONS(2647),
    [anon_sym_if] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(2647),
    [anon_sym_and] = ACTIONS(671),
    [anon_sym_or] = ACTIONS(673),
    [sym_comment] = ACTIONS(73),
  },
  [1221] = {
    [sym__expression] = STATE(1529),
    [sym__primary_expression] = STATE(119),
    [sym_not_operator] = STATE(1529),
    [sym_boolean_operator] = STATE(1529),
    [sym_binary_operator] = STATE(119),
    [sym_unary_operator] = STATE(119),
    [sym_comparison_operator] = STATE(1529),
    [sym_lambda] = STATE(1529),
    [sym_attribute] = STATE(119),
    [sym_subscript] = STATE(119),
    [sym_call] = STATE(119),
    [sym_list] = STATE(119),
    [sym_list_comprehension] = STATE(119),
    [sym_dictionary] = STATE(119),
    [sym_dictionary_comprehension] = STATE(119),
    [sym_set] = STATE(119),
    [sym_set_comprehension] = STATE(119),
    [sym_parenthesized_expression] = STATE(119),
    [sym_tuple] = STATE(119),
    [sym_generator_expression] = STATE(119),
    [sym_conditional_expression] = STATE(1529),
    [sym_concatenated_string] = STATE(119),
    [sym_string] = STATE(120),
    [sym_await] = STATE(1529),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(197),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_lambda] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(203),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(205),
    [sym_float] = ACTIONS(205),
    [sym_identifier] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_none] = ACTIONS(205),
    [anon_sym_await] = ACTIONS(207),
    [sym_comment] = ACTIONS(73),
  },
  [1222] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(2942),
    [anon_sym_as] = ACTIONS(2942),
    [anon_sym_STAR] = ACTIONS(675),
    [anon_sym_GT_GT] = ACTIONS(677),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_COLON] = ACTIONS(2942),
    [anon_sym_in] = ACTIONS(2942),
    [anon_sym_AT] = ACTIONS(681),
    [anon_sym_not] = ACTIONS(2942),
    [anon_sym_and] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(685),
    [anon_sym_DASH] = ACTIONS(685),
    [anon_sym_SLASH] = ACTIONS(675),
    [anon_sym_PERCENT] = ACTIONS(681),
    [anon_sym_SLASH_SLASH] = ACTIONS(681),
    [anon_sym_STAR_STAR] = ACTIONS(687),
    [anon_sym_PIPE] = ACTIONS(689),
    [anon_sym_AMP] = ACTIONS(691),
    [anon_sym_CARET] = ACTIONS(693),
    [anon_sym_LT_LT] = ACTIONS(677),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_LT_EQ] = ACTIONS(2942),
    [anon_sym_EQ_EQ] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_GT_EQ] = ACTIONS(2942),
    [anon_sym_GT] = ACTIONS(2944),
    [anon_sym_LT_GT] = ACTIONS(2942),
    [anon_sym_is] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(473),
    [sym_comment] = ACTIONS(73),
  },
  [1223] = {
    [sym__expression] = STATE(1530),
    [sym__primary_expression] = STATE(1229),
    [sym_not_operator] = STATE(1530),
    [sym_boolean_operator] = STATE(1530),
    [sym_binary_operator] = STATE(1229),
    [sym_unary_operator] = STATE(1229),
    [sym_comparison_operator] = STATE(1530),
    [sym_lambda] = STATE(1530),
    [sym_attribute] = STATE(1229),
    [sym_subscript] = STATE(1229),
    [sym_call] = STATE(1229),
    [sym_list] = STATE(1229),
    [sym_list_comprehension] = STATE(1229),
    [sym_dictionary] = STATE(1229),
    [sym_dictionary_comprehension] = STATE(1229),
    [sym_set] = STATE(1229),
    [sym_set_comprehension] = STATE(1229),
    [sym_parenthesized_expression] = STATE(1229),
    [sym_tuple] = STATE(1229),
    [sym_generator_expression] = STATE(1229),
    [sym_conditional_expression] = STATE(1530),
    [sym_concatenated_string] = STATE(1229),
    [sym_string] = STATE(1230),
    [sym_await] = STATE(1530),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2485),
    [anon_sym_PLUS] = ACTIONS(2487),
    [anon_sym_DASH] = ACTIONS(2487),
    [anon_sym_TILDE] = ACTIONS(2487),
    [anon_sym_lambda] = ACTIONS(2489),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2491),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2493),
    [sym_float] = ACTIONS(2493),
    [sym_identifier] = ACTIONS(2493),
    [sym_true] = ACTIONS(2493),
    [sym_false] = ACTIONS(2493),
    [sym_none] = ACTIONS(2493),
    [anon_sym_await] = ACTIONS(2495),
    [sym_comment] = ACTIONS(73),
  },
  [1224] = {
    [sym__expression] = STATE(1531),
    [sym__primary_expression] = STATE(1229),
    [sym_not_operator] = STATE(1531),
    [sym_boolean_operator] = STATE(1531),
    [sym_binary_operator] = STATE(1229),
    [sym_unary_operator] = STATE(1229),
    [sym_comparison_operator] = STATE(1531),
    [sym_lambda] = STATE(1531),
    [sym_attribute] = STATE(1229),
    [sym_subscript] = STATE(1229),
    [sym_call] = STATE(1229),
    [sym_list] = STATE(1229),
    [sym_list_comprehension] = STATE(1229),
    [sym_dictionary] = STATE(1229),
    [sym_dictionary_comprehension] = STATE(1229),
    [sym_set] = STATE(1229),
    [sym_set_comprehension] = STATE(1229),
    [sym_parenthesized_expression] = STATE(1229),
    [sym_tuple] = STATE(1229),
    [sym_generator_expression] = STATE(1229),
    [sym_conditional_expression] = STATE(1531),
    [sym_concatenated_string] = STATE(1229),
    [sym_string] = STATE(1230),
    [sym_await] = STATE(1531),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2485),
    [anon_sym_PLUS] = ACTIONS(2487),
    [anon_sym_DASH] = ACTIONS(2487),
    [anon_sym_TILDE] = ACTIONS(2487),
    [anon_sym_lambda] = ACTIONS(2489),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2491),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2493),
    [sym_float] = ACTIONS(2493),
    [sym_identifier] = ACTIONS(2493),
    [sym_true] = ACTIONS(2493),
    [sym_false] = ACTIONS(2493),
    [sym_none] = ACTIONS(2493),
    [anon_sym_await] = ACTIONS(2495),
    [sym_comment] = ACTIONS(73),
  },
  [1225] = {
    [sym__primary_expression] = STATE(227),
    [sym_binary_operator] = STATE(227),
    [sym_unary_operator] = STATE(227),
    [sym_attribute] = STATE(227),
    [sym_subscript] = STATE(227),
    [sym_call] = STATE(227),
    [sym_list] = STATE(227),
    [sym_list_comprehension] = STATE(227),
    [sym_dictionary] = STATE(227),
    [sym_dictionary_comprehension] = STATE(227),
    [sym_set] = STATE(227),
    [sym_set_comprehension] = STATE(227),
    [sym_parenthesized_expression] = STATE(227),
    [sym_tuple] = STATE(227),
    [sym_generator_expression] = STATE(227),
    [sym_concatenated_string] = STATE(227),
    [sym_string] = STATE(1230),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2487),
    [anon_sym_DASH] = ACTIONS(2487),
    [anon_sym_TILDE] = ACTIONS(2487),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(403),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(405),
    [sym_float] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_true] = ACTIONS(405),
    [sym_false] = ACTIONS(405),
    [sym_none] = ACTIONS(405),
    [sym_comment] = ACTIONS(73),
  },
  [1226] = {
    [sym_lambda_parameters] = STATE(1533),
    [sym__parameters] = STATE(138),
    [sym_default_parameter] = STATE(139),
    [sym_typed_default_parameter] = STATE(139),
    [sym_list_splat] = STATE(140),
    [sym_dictionary_splat] = STATE(140),
    [sym_typed_parameter] = STATE(139),
    [sym_tuple] = STATE(139),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(3223),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [1227] = {
    [sym__expression] = STATE(249),
    [sym__primary_expression] = STATE(1229),
    [sym_not_operator] = STATE(249),
    [sym_boolean_operator] = STATE(249),
    [sym_binary_operator] = STATE(1229),
    [sym_unary_operator] = STATE(1229),
    [sym_comparison_operator] = STATE(249),
    [sym_lambda] = STATE(249),
    [sym_attribute] = STATE(1229),
    [sym_subscript] = STATE(1229),
    [sym_call] = STATE(1229),
    [sym_list] = STATE(1229),
    [sym_list_comprehension] = STATE(1229),
    [sym_dictionary] = STATE(1229),
    [sym_dictionary_comprehension] = STATE(1229),
    [sym_set] = STATE(1229),
    [sym_set_comprehension] = STATE(1229),
    [sym_parenthesized_expression] = STATE(1229),
    [sym_tuple] = STATE(1229),
    [sym_generator_expression] = STATE(1229),
    [sym_conditional_expression] = STATE(249),
    [sym_concatenated_string] = STATE(1229),
    [sym_string] = STATE(1230),
    [sym_await] = STATE(249),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2485),
    [anon_sym_PLUS] = ACTIONS(2487),
    [anon_sym_DASH] = ACTIONS(2487),
    [anon_sym_TILDE] = ACTIONS(2487),
    [anon_sym_lambda] = ACTIONS(2489),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2491),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2493),
    [sym_float] = ACTIONS(2493),
    [sym_identifier] = ACTIONS(2493),
    [sym_true] = ACTIONS(2493),
    [sym_false] = ACTIONS(2493),
    [sym_none] = ACTIONS(2493),
    [anon_sym_await] = ACTIONS(2495),
    [sym_comment] = ACTIONS(73),
  },
  [1228] = {
    [anon_sym_RPAREN] = ACTIONS(1608),
    [anon_sym_COMMA] = ACTIONS(1608),
    [anon_sym_if] = ACTIONS(3225),
    [anon_sym_COLON] = ACTIONS(1608),
    [anon_sym_and] = ACTIONS(3227),
    [anon_sym_or] = ACTIONS(3229),
    [sym_comment] = ACTIONS(73),
  },
  [1229] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [aux_sym_comparison_operator_repeat1] = STATE(1547),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(301),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(3231),
    [anon_sym_GT_GT] = ACTIONS(3233),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_COLON] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(3235),
    [anon_sym_AT] = ACTIONS(3237),
    [anon_sym_not] = ACTIONS(3239),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(3241),
    [anon_sym_DASH] = ACTIONS(3241),
    [anon_sym_SLASH] = ACTIONS(3231),
    [anon_sym_PERCENT] = ACTIONS(3237),
    [anon_sym_SLASH_SLASH] = ACTIONS(3237),
    [anon_sym_STAR_STAR] = ACTIONS(3243),
    [anon_sym_PIPE] = ACTIONS(3245),
    [anon_sym_AMP] = ACTIONS(3247),
    [anon_sym_CARET] = ACTIONS(3249),
    [anon_sym_LT_LT] = ACTIONS(3233),
    [anon_sym_LT] = ACTIONS(3251),
    [anon_sym_LT_EQ] = ACTIONS(3235),
    [anon_sym_EQ_EQ] = ACTIONS(3235),
    [anon_sym_BANG_EQ] = ACTIONS(3235),
    [anon_sym_GT_EQ] = ACTIONS(3235),
    [anon_sym_GT] = ACTIONS(3251),
    [anon_sym_LT_GT] = ACTIONS(3235),
    [anon_sym_is] = ACTIONS(3253),
    [anon_sym_LBRACK] = ACTIONS(473),
    [sym_comment] = ACTIONS(73),
  },
  [1230] = {
    [sym_string] = STATE(1548),
    [aux_sym_concatenated_string_repeat1] = STATE(1548),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_RPAREN] = ACTIONS(333),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_COLON] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [1231] = {
    [sym_default_parameter] = STATE(867),
    [sym_typed_default_parameter] = STATE(867),
    [sym_list_splat] = STATE(1551),
    [sym_dictionary_splat] = STATE(1551),
    [sym_typed_parameter] = STATE(867),
    [sym_tuple] = STATE(867),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_RPAREN] = ACTIONS(1642),
    [anon_sym_STAR] = ACTIONS(1582),
    [anon_sym_print] = ACTIONS(3255),
    [anon_sym_exec] = ACTIONS(3255),
    [sym_identifier] = ACTIONS(3257),
    [sym_comment] = ACTIONS(73),
  },
  [1232] = {
    [sym__expression] = STATE(873),
    [sym__primary_expression] = STATE(874),
    [sym_not_operator] = STATE(873),
    [sym_boolean_operator] = STATE(873),
    [sym_binary_operator] = STATE(874),
    [sym_unary_operator] = STATE(874),
    [sym_comparison_operator] = STATE(873),
    [sym_lambda] = STATE(873),
    [sym_attribute] = STATE(874),
    [sym_subscript] = STATE(874),
    [sym_call] = STATE(874),
    [sym_type] = STATE(1552),
    [sym_list] = STATE(874),
    [sym_list_comprehension] = STATE(874),
    [sym_dictionary] = STATE(874),
    [sym_dictionary_comprehension] = STATE(874),
    [sym_set] = STATE(874),
    [sym_set_comprehension] = STATE(874),
    [sym_parenthesized_expression] = STATE(874),
    [sym_tuple] = STATE(874),
    [sym_generator_expression] = STATE(874),
    [sym_conditional_expression] = STATE(873),
    [sym_concatenated_string] = STATE(874),
    [sym_string] = STATE(876),
    [sym_await] = STATE(873),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1646),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_DASH] = ACTIONS(1648),
    [anon_sym_TILDE] = ACTIONS(1648),
    [anon_sym_lambda] = ACTIONS(1650),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1652),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1654),
    [sym_float] = ACTIONS(1654),
    [sym_identifier] = ACTIONS(1654),
    [sym_true] = ACTIONS(1654),
    [sym_false] = ACTIONS(1654),
    [sym_none] = ACTIONS(1654),
    [anon_sym_await] = ACTIONS(1656),
    [sym_comment] = ACTIONS(73),
  },
  [1233] = {
    [sym__expression] = STATE(1553),
    [sym__primary_expression] = STATE(237),
    [sym_not_operator] = STATE(1553),
    [sym_boolean_operator] = STATE(1553),
    [sym_binary_operator] = STATE(237),
    [sym_unary_operator] = STATE(237),
    [sym_comparison_operator] = STATE(1553),
    [sym_lambda] = STATE(1553),
    [sym_attribute] = STATE(237),
    [sym_subscript] = STATE(237),
    [sym_call] = STATE(237),
    [sym_list] = STATE(237),
    [sym_list_comprehension] = STATE(237),
    [sym_dictionary] = STATE(237),
    [sym_dictionary_comprehension] = STATE(237),
    [sym_set] = STATE(237),
    [sym_set_comprehension] = STATE(237),
    [sym_parenthesized_expression] = STATE(237),
    [sym_tuple] = STATE(237),
    [sym_generator_expression] = STATE(237),
    [sym_conditional_expression] = STATE(1553),
    [sym_concatenated_string] = STATE(237),
    [sym_string] = STATE(238),
    [sym_await] = STATE(1553),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_lambda] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(419),
    [sym_float] = ACTIONS(419),
    [sym_identifier] = ACTIONS(419),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_none] = ACTIONS(419),
    [anon_sym_await] = ACTIONS(421),
    [sym_comment] = ACTIONS(73),
  },
  [1234] = {
    [aux_sym__parameters_repeat1] = STATE(1555),
    [anon_sym_RPAREN] = ACTIONS(1642),
    [anon_sym_COMMA] = ACTIONS(3259),
    [sym_comment] = ACTIONS(73),
  },
  [1235] = {
    [sym_default_parameter] = STATE(867),
    [sym_typed_default_parameter] = STATE(867),
    [sym_list_splat] = STATE(1551),
    [sym_dictionary_splat] = STATE(1551),
    [sym_typed_parameter] = STATE(867),
    [sym_tuple] = STATE(867),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_RPAREN] = ACTIONS(1662),
    [anon_sym_STAR] = ACTIONS(1582),
    [anon_sym_print] = ACTIONS(3255),
    [anon_sym_exec] = ACTIONS(3255),
    [sym_identifier] = ACTIONS(3257),
    [sym_comment] = ACTIONS(73),
  },
  [1236] = {
    [sym__expression] = STATE(1560),
    [sym__primary_expression] = STATE(1561),
    [sym_not_operator] = STATE(1560),
    [sym_boolean_operator] = STATE(1560),
    [sym_binary_operator] = STATE(1561),
    [sym_unary_operator] = STATE(1561),
    [sym_comparison_operator] = STATE(1560),
    [sym_lambda] = STATE(1560),
    [sym_attribute] = STATE(1561),
    [sym_subscript] = STATE(1561),
    [sym_call] = STATE(1561),
    [sym_type] = STATE(1562),
    [sym_list] = STATE(1561),
    [sym_list_comprehension] = STATE(1561),
    [sym_dictionary] = STATE(1561),
    [sym_dictionary_comprehension] = STATE(1561),
    [sym_set] = STATE(1561),
    [sym_set_comprehension] = STATE(1561),
    [sym_parenthesized_expression] = STATE(1561),
    [sym_tuple] = STATE(1561),
    [sym_generator_expression] = STATE(1561),
    [sym_conditional_expression] = STATE(1560),
    [sym_concatenated_string] = STATE(1561),
    [sym_string] = STATE(1563),
    [sym_await] = STATE(1560),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3263),
    [anon_sym_DASH] = ACTIONS(3263),
    [anon_sym_TILDE] = ACTIONS(3263),
    [anon_sym_lambda] = ACTIONS(3265),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3267),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3269),
    [sym_float] = ACTIONS(3269),
    [sym_identifier] = ACTIONS(3269),
    [sym_true] = ACTIONS(3269),
    [sym_false] = ACTIONS(3269),
    [sym_none] = ACTIONS(3269),
    [anon_sym_await] = ACTIONS(3271),
    [sym_comment] = ACTIONS(73),
  },
  [1237] = {
    [sym__expression] = STATE(1564),
    [sym__primary_expression] = STATE(237),
    [sym_not_operator] = STATE(1564),
    [sym_boolean_operator] = STATE(1564),
    [sym_binary_operator] = STATE(237),
    [sym_unary_operator] = STATE(237),
    [sym_comparison_operator] = STATE(1564),
    [sym_lambda] = STATE(1564),
    [sym_attribute] = STATE(237),
    [sym_subscript] = STATE(237),
    [sym_call] = STATE(237),
    [sym_list] = STATE(237),
    [sym_list_comprehension] = STATE(237),
    [sym_dictionary] = STATE(237),
    [sym_dictionary_comprehension] = STATE(237),
    [sym_set] = STATE(237),
    [sym_set_comprehension] = STATE(237),
    [sym_parenthesized_expression] = STATE(237),
    [sym_tuple] = STATE(237),
    [sym_generator_expression] = STATE(237),
    [sym_conditional_expression] = STATE(1564),
    [sym_concatenated_string] = STATE(237),
    [sym_string] = STATE(238),
    [sym_await] = STATE(1564),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_lambda] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(419),
    [sym_float] = ACTIONS(419),
    [sym_identifier] = ACTIONS(419),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_none] = ACTIONS(419),
    [anon_sym_await] = ACTIONS(421),
    [sym_comment] = ACTIONS(73),
  },
  [1238] = {
    [aux_sym__parameters_repeat1] = STATE(1555),
    [anon_sym_RPAREN] = ACTIONS(1662),
    [anon_sym_COMMA] = ACTIONS(3273),
    [sym_comment] = ACTIONS(73),
  },
  [1239] = {
    [anon_sym_COLON] = ACTIONS(3275),
    [anon_sym_DASH_GT] = ACTIONS(3275),
    [sym_comment] = ACTIONS(73),
  },
  [1240] = {
    [sym__expression] = STATE(1566),
    [sym__primary_expression] = STATE(237),
    [sym_not_operator] = STATE(1566),
    [sym_boolean_operator] = STATE(1566),
    [sym_binary_operator] = STATE(237),
    [sym_unary_operator] = STATE(237),
    [sym_comparison_operator] = STATE(1566),
    [sym_lambda] = STATE(1566),
    [sym_attribute] = STATE(237),
    [sym_subscript] = STATE(237),
    [sym_call] = STATE(237),
    [sym_type] = STATE(892),
    [sym_list] = STATE(237),
    [sym_list_comprehension] = STATE(237),
    [sym_dictionary] = STATE(237),
    [sym_dictionary_comprehension] = STATE(237),
    [sym_set] = STATE(237),
    [sym_set_comprehension] = STATE(237),
    [sym_parenthesized_expression] = STATE(237),
    [sym_tuple] = STATE(237),
    [sym_generator_expression] = STATE(237),
    [sym_conditional_expression] = STATE(1566),
    [sym_concatenated_string] = STATE(237),
    [sym_string] = STATE(238),
    [sym_await] = STATE(1566),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_lambda] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(419),
    [sym_float] = ACTIONS(419),
    [sym_identifier] = ACTIONS(419),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_none] = ACTIONS(419),
    [anon_sym_await] = ACTIONS(421),
    [sym_comment] = ACTIONS(73),
  },
  [1241] = {
    [sym__string_start] = ACTIONS(3277),
    [ts_builtin_sym_end] = ACTIONS(3277),
    [anon_sym_import] = ACTIONS(3279),
    [anon_sym_from] = ACTIONS(3279),
    [anon_sym_LPAREN] = ACTIONS(3277),
    [anon_sym_print] = ACTIONS(3279),
    [anon_sym_assert] = ACTIONS(3279),
    [anon_sym_return] = ACTIONS(3279),
    [anon_sym_del] = ACTIONS(3279),
    [anon_sym_raise] = ACTIONS(3279),
    [anon_sym_pass] = ACTIONS(3279),
    [anon_sym_break] = ACTIONS(3279),
    [anon_sym_continue] = ACTIONS(3279),
    [anon_sym_if] = ACTIONS(3279),
    [anon_sym_async] = ACTIONS(3279),
    [anon_sym_for] = ACTIONS(3279),
    [anon_sym_while] = ACTIONS(3279),
    [anon_sym_try] = ACTIONS(3279),
    [anon_sym_with] = ACTIONS(3279),
    [anon_sym_def] = ACTIONS(3279),
    [anon_sym_global] = ACTIONS(3279),
    [anon_sym_nonlocal] = ACTIONS(3279),
    [anon_sym_exec] = ACTIONS(3279),
    [anon_sym_class] = ACTIONS(3279),
    [anon_sym_AT] = ACTIONS(3277),
    [anon_sym_not] = ACTIONS(3279),
    [anon_sym_PLUS] = ACTIONS(3277),
    [anon_sym_DASH] = ACTIONS(3277),
    [anon_sym_TILDE] = ACTIONS(3277),
    [anon_sym_lambda] = ACTIONS(3279),
    [anon_sym_yield] = ACTIONS(3279),
    [anon_sym_LBRACK] = ACTIONS(3277),
    [sym_ellipsis] = ACTIONS(3277),
    [anon_sym_LBRACE] = ACTIONS(3277),
    [sym_integer] = ACTIONS(3279),
    [sym_float] = ACTIONS(3279),
    [sym_identifier] = ACTIONS(3279),
    [sym_true] = ACTIONS(3279),
    [sym_false] = ACTIONS(3279),
    [sym_none] = ACTIONS(3279),
    [anon_sym_await] = ACTIONS(3279),
    [sym_comment] = ACTIONS(73),
  },
  [1242] = {
    [anon_sym_if] = ACTIONS(599),
    [anon_sym_COLON] = ACTIONS(1879),
    [anon_sym_and] = ACTIONS(603),
    [anon_sym_or] = ACTIONS(605),
    [sym_comment] = ACTIONS(73),
  },
  [1243] = {
    [anon_sym_COLON] = ACTIONS(3281),
    [sym_comment] = ACTIONS(73),
  },
  [1244] = {
    [aux_sym_print_statement_repeat1] = STATE(699),
    [sym__newline] = ACTIONS(3283),
    [anon_sym_COMMA] = ACTIONS(539),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3283),
  },
  [1245] = {
    [sym__string_start] = ACTIONS(3285),
    [ts_builtin_sym_end] = ACTIONS(3285),
    [anon_sym_import] = ACTIONS(3287),
    [anon_sym_from] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_print] = ACTIONS(3287),
    [anon_sym_assert] = ACTIONS(3287),
    [anon_sym_return] = ACTIONS(3287),
    [anon_sym_del] = ACTIONS(3287),
    [anon_sym_raise] = ACTIONS(3287),
    [anon_sym_pass] = ACTIONS(3287),
    [anon_sym_break] = ACTIONS(3287),
    [anon_sym_continue] = ACTIONS(3287),
    [anon_sym_if] = ACTIONS(3287),
    [anon_sym_async] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3287),
    [anon_sym_while] = ACTIONS(3287),
    [anon_sym_try] = ACTIONS(3287),
    [anon_sym_with] = ACTIONS(3287),
    [anon_sym_def] = ACTIONS(3287),
    [anon_sym_global] = ACTIONS(3287),
    [anon_sym_nonlocal] = ACTIONS(3287),
    [anon_sym_exec] = ACTIONS(3287),
    [anon_sym_class] = ACTIONS(3287),
    [anon_sym_AT] = ACTIONS(3285),
    [anon_sym_not] = ACTIONS(3287),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_lambda] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3287),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [sym_ellipsis] = ACTIONS(3285),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [sym_integer] = ACTIONS(3287),
    [sym_float] = ACTIONS(3287),
    [sym_identifier] = ACTIONS(3287),
    [sym_true] = ACTIONS(3287),
    [sym_false] = ACTIONS(3287),
    [sym_none] = ACTIONS(3287),
    [anon_sym_await] = ACTIONS(3287),
    [sym_comment] = ACTIONS(73),
  },
  [1246] = {
    [anon_sym_COMMA] = ACTIONS(1660),
    [anon_sym_if] = ACTIONS(1610),
    [anon_sym_COLON] = ACTIONS(1660),
    [anon_sym_and] = ACTIONS(1612),
    [anon_sym_or] = ACTIONS(1614),
    [sym_comment] = ACTIONS(73),
  },
  [1247] = {
    [sym__expression] = STATE(1568),
    [sym__primary_expression] = STATE(432),
    [sym_not_operator] = STATE(1568),
    [sym_boolean_operator] = STATE(1568),
    [sym_binary_operator] = STATE(432),
    [sym_unary_operator] = STATE(432),
    [sym_comparison_operator] = STATE(1568),
    [sym_lambda] = STATE(1568),
    [sym_attribute] = STATE(432),
    [sym_subscript] = STATE(432),
    [sym_call] = STATE(432),
    [sym_list] = STATE(432),
    [sym_list_comprehension] = STATE(432),
    [sym_dictionary] = STATE(432),
    [sym_dictionary_comprehension] = STATE(432),
    [sym_set] = STATE(432),
    [sym_set_comprehension] = STATE(432),
    [sym_parenthesized_expression] = STATE(432),
    [sym_tuple] = STATE(432),
    [sym_generator_expression] = STATE(432),
    [sym_conditional_expression] = STATE(1568),
    [sym_concatenated_string] = STATE(432),
    [sym_string] = STATE(433),
    [sym_await] = STATE(1568),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(735),
    [anon_sym_lambda] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(741),
    [sym_float] = ACTIONS(741),
    [sym_identifier] = ACTIONS(741),
    [sym_true] = ACTIONS(741),
    [sym_false] = ACTIONS(741),
    [sym_none] = ACTIONS(741),
    [anon_sym_await] = ACTIONS(743),
    [sym_comment] = ACTIONS(73),
  },
  [1248] = {
    [anon_sym_if] = ACTIONS(1925),
    [anon_sym_else] = ACTIONS(3289),
    [anon_sym_and] = ACTIONS(1929),
    [anon_sym_or] = ACTIONS(1931),
    [sym_comment] = ACTIONS(73),
  },
  [1249] = {
    [anon_sym_COMMA] = ACTIONS(1957),
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_COLON] = ACTIONS(1957),
    [anon_sym_and] = ACTIONS(1612),
    [anon_sym_or] = ACTIONS(1957),
    [sym_comment] = ACTIONS(73),
  },
  [1250] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1984),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1986),
    [anon_sym_PERCENT] = ACTIONS(1984),
    [anon_sym_SLASH_SLASH] = ACTIONS(1984),
    [anon_sym_STAR_STAR] = ACTIONS(1628),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1251] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1616),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1626),
    [anon_sym_SLASH] = ACTIONS(1616),
    [anon_sym_PERCENT] = ACTIONS(1622),
    [anon_sym_SLASH_SLASH] = ACTIONS(1622),
    [anon_sym_STAR_STAR] = ACTIONS(1628),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1252] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1988),
    [anon_sym_STAR] = ACTIONS(1616),
    [anon_sym_GT_GT] = ACTIONS(1618),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_COLON] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(1988),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_not] = ACTIONS(1988),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_PLUS] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1626),
    [anon_sym_SLASH] = ACTIONS(1616),
    [anon_sym_PERCENT] = ACTIONS(1622),
    [anon_sym_SLASH_SLASH] = ACTIONS(1622),
    [anon_sym_STAR_STAR] = ACTIONS(1628),
    [anon_sym_PIPE] = ACTIONS(1630),
    [anon_sym_AMP] = ACTIONS(1632),
    [anon_sym_CARET] = ACTIONS(1634),
    [anon_sym_LT_LT] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(1990),
    [anon_sym_LT_EQ] = ACTIONS(1988),
    [anon_sym_EQ_EQ] = ACTIONS(1988),
    [anon_sym_BANG_EQ] = ACTIONS(1988),
    [anon_sym_GT_EQ] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1990),
    [anon_sym_LT_GT] = ACTIONS(1988),
    [anon_sym_is] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(473),
    [sym_comment] = ACTIONS(73),
  },
  [1253] = {
    [sym__primary_expression] = STATE(1570),
    [sym_binary_operator] = STATE(1570),
    [sym_unary_operator] = STATE(1570),
    [sym_attribute] = STATE(1570),
    [sym_subscript] = STATE(1570),
    [sym_call] = STATE(1570),
    [sym_list] = STATE(1570),
    [sym_list_comprehension] = STATE(1570),
    [sym_dictionary] = STATE(1570),
    [sym_dictionary_comprehension] = STATE(1570),
    [sym_set] = STATE(1570),
    [sym_set_comprehension] = STATE(1570),
    [sym_parenthesized_expression] = STATE(1570),
    [sym_tuple] = STATE(1570),
    [sym_generator_expression] = STATE(1570),
    [sym_concatenated_string] = STATE(1570),
    [sym_string] = STATE(433),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(735),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3291),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3293),
    [sym_float] = ACTIONS(3293),
    [sym_identifier] = ACTIONS(3293),
    [sym_true] = ACTIONS(3293),
    [sym_false] = ACTIONS(3293),
    [sym_none] = ACTIONS(3293),
    [sym_comment] = ACTIONS(73),
  },
  [1254] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1616),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1616),
    [anon_sym_PERCENT] = ACTIONS(1622),
    [anon_sym_SLASH_SLASH] = ACTIONS(1622),
    [anon_sym_STAR_STAR] = ACTIONS(1628),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1255] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1616),
    [anon_sym_GT_GT] = ACTIONS(1618),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1626),
    [anon_sym_SLASH] = ACTIONS(1616),
    [anon_sym_PERCENT] = ACTIONS(1622),
    [anon_sym_SLASH_SLASH] = ACTIONS(1622),
    [anon_sym_STAR_STAR] = ACTIONS(1628),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1632),
    [anon_sym_CARET] = ACTIONS(1634),
    [anon_sym_LT_LT] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1256] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1616),
    [anon_sym_GT_GT] = ACTIONS(1618),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1626),
    [anon_sym_SLASH] = ACTIONS(1616),
    [anon_sym_PERCENT] = ACTIONS(1622),
    [anon_sym_SLASH_SLASH] = ACTIONS(1622),
    [anon_sym_STAR_STAR] = ACTIONS(1628),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1634),
    [anon_sym_LT_LT] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1257] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1616),
    [anon_sym_GT_GT] = ACTIONS(1618),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1626),
    [anon_sym_SLASH] = ACTIONS(1616),
    [anon_sym_PERCENT] = ACTIONS(1622),
    [anon_sym_SLASH_SLASH] = ACTIONS(1622),
    [anon_sym_STAR_STAR] = ACTIONS(1628),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1258] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1258),
    [anon_sym_COMMA] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_COLON] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(3295),
    [anon_sym_not] = ACTIONS(3298),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(3301),
    [anon_sym_LT_EQ] = ACTIONS(3295),
    [anon_sym_EQ_EQ] = ACTIONS(3295),
    [anon_sym_BANG_EQ] = ACTIONS(3295),
    [anon_sym_GT_EQ] = ACTIONS(3295),
    [anon_sym_GT] = ACTIONS(3301),
    [anon_sym_LT_GT] = ACTIONS(3295),
    [anon_sym_is] = ACTIONS(3304),
    [sym_comment] = ACTIONS(73),
  },
  [1259] = {
    [sym_string] = STATE(1259),
    [aux_sym_concatenated_string_repeat1] = STATE(1259),
    [sym__string_start] = ACTIONS(2241),
    [anon_sym_DOT] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(2050),
    [anon_sym_COMMA] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2050),
    [anon_sym_if] = ACTIONS(2050),
    [anon_sym_COLON] = ACTIONS(2050),
    [anon_sym_in] = ACTIONS(2050),
    [anon_sym_AT] = ACTIONS(2050),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_and] = ACTIONS(2050),
    [anon_sym_or] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_SLASH] = ACTIONS(2055),
    [anon_sym_PERCENT] = ACTIONS(2050),
    [anon_sym_SLASH_SLASH] = ACTIONS(2050),
    [anon_sym_STAR_STAR] = ACTIONS(2050),
    [anon_sym_PIPE] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2050),
    [anon_sym_CARET] = ACTIONS(2050),
    [anon_sym_LT_LT] = ACTIONS(2050),
    [anon_sym_LT] = ACTIONS(2055),
    [anon_sym_LT_EQ] = ACTIONS(2050),
    [anon_sym_EQ_EQ] = ACTIONS(2050),
    [anon_sym_BANG_EQ] = ACTIONS(2050),
    [anon_sym_GT_EQ] = ACTIONS(2050),
    [anon_sym_GT] = ACTIONS(2055),
    [anon_sym_LT_GT] = ACTIONS(2050),
    [anon_sym_is] = ACTIONS(2050),
    [anon_sym_LBRACK] = ACTIONS(2050),
    [sym_comment] = ACTIONS(73),
  },
  [1260] = {
    [anon_sym_if] = ACTIONS(723),
    [anon_sym_EQ] = ACTIONS(723),
    [anon_sym_and] = ACTIONS(2570),
    [anon_sym_or] = ACTIONS(2572),
    [sym_comment] = ACTIONS(73),
  },
  [1261] = {
    [sym__expression] = STATE(1571),
    [sym__primary_expression] = STATE(874),
    [sym_not_operator] = STATE(1571),
    [sym_boolean_operator] = STATE(1571),
    [sym_binary_operator] = STATE(874),
    [sym_unary_operator] = STATE(874),
    [sym_comparison_operator] = STATE(1571),
    [sym_lambda] = STATE(1571),
    [sym_attribute] = STATE(874),
    [sym_subscript] = STATE(874),
    [sym_call] = STATE(874),
    [sym_list] = STATE(874),
    [sym_list_comprehension] = STATE(874),
    [sym_dictionary] = STATE(874),
    [sym_dictionary_comprehension] = STATE(874),
    [sym_set] = STATE(874),
    [sym_set_comprehension] = STATE(874),
    [sym_parenthesized_expression] = STATE(874),
    [sym_tuple] = STATE(874),
    [sym_generator_expression] = STATE(874),
    [sym_conditional_expression] = STATE(1571),
    [sym_concatenated_string] = STATE(874),
    [sym_string] = STATE(876),
    [sym_await] = STATE(1571),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1646),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_DASH] = ACTIONS(1648),
    [anon_sym_TILDE] = ACTIONS(1648),
    [anon_sym_lambda] = ACTIONS(1650),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1652),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1654),
    [sym_float] = ACTIONS(1654),
    [sym_identifier] = ACTIONS(1654),
    [sym_true] = ACTIONS(1654),
    [sym_false] = ACTIONS(1654),
    [sym_none] = ACTIONS(1654),
    [anon_sym_await] = ACTIONS(1656),
    [sym_comment] = ACTIONS(73),
  },
  [1262] = {
    [anon_sym_COLON] = ACTIONS(3307),
    [sym_comment] = ACTIONS(73),
  },
  [1263] = {
    [sym__expression] = STATE(1573),
    [sym__primary_expression] = STATE(538),
    [sym_not_operator] = STATE(1573),
    [sym_boolean_operator] = STATE(1573),
    [sym_binary_operator] = STATE(538),
    [sym_unary_operator] = STATE(538),
    [sym_comparison_operator] = STATE(1573),
    [sym_lambda] = STATE(1573),
    [sym_attribute] = STATE(538),
    [sym_subscript] = STATE(538),
    [sym_call] = STATE(538),
    [sym_list] = STATE(538),
    [sym_list_comprehension] = STATE(538),
    [sym_dictionary] = STATE(538),
    [sym_dictionary_comprehension] = STATE(538),
    [sym_set] = STATE(538),
    [sym_set_comprehension] = STATE(538),
    [sym_parenthesized_expression] = STATE(538),
    [sym_tuple] = STATE(538),
    [sym_generator_expression] = STATE(538),
    [sym_conditional_expression] = STATE(1573),
    [sym_concatenated_string] = STATE(538),
    [sym_string] = STATE(539),
    [sym_await] = STATE(1573),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_lambda] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(917),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(919),
    [sym_float] = ACTIONS(919),
    [sym_identifier] = ACTIONS(919),
    [sym_true] = ACTIONS(919),
    [sym_false] = ACTIONS(919),
    [sym_none] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(921),
    [sym_comment] = ACTIONS(73),
  },
  [1264] = {
    [sym__expression] = STATE(652),
    [sym__primary_expression] = STATE(874),
    [sym_not_operator] = STATE(652),
    [sym_boolean_operator] = STATE(652),
    [sym_binary_operator] = STATE(874),
    [sym_unary_operator] = STATE(874),
    [sym_comparison_operator] = STATE(652),
    [sym_lambda] = STATE(652),
    [sym_attribute] = STATE(874),
    [sym_subscript] = STATE(874),
    [sym_call] = STATE(874),
    [sym_list] = STATE(874),
    [sym_list_comprehension] = STATE(874),
    [sym_dictionary] = STATE(874),
    [sym_dictionary_comprehension] = STATE(874),
    [sym_set] = STATE(874),
    [sym_set_comprehension] = STATE(874),
    [sym_parenthesized_expression] = STATE(874),
    [sym_tuple] = STATE(874),
    [sym_generator_expression] = STATE(874),
    [sym_conditional_expression] = STATE(652),
    [sym_concatenated_string] = STATE(874),
    [sym_string] = STATE(876),
    [sym_await] = STATE(652),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1646),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_DASH] = ACTIONS(1648),
    [anon_sym_TILDE] = ACTIONS(1648),
    [anon_sym_lambda] = ACTIONS(1650),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1652),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1654),
    [sym_float] = ACTIONS(1654),
    [sym_identifier] = ACTIONS(1654),
    [sym_true] = ACTIONS(1654),
    [sym_false] = ACTIONS(1654),
    [sym_none] = ACTIONS(1654),
    [anon_sym_await] = ACTIONS(1656),
    [sym_comment] = ACTIONS(73),
  },
  [1265] = {
    [sym__expression] = STATE(1574),
    [sym__primary_expression] = STATE(874),
    [sym_not_operator] = STATE(1574),
    [sym_boolean_operator] = STATE(1574),
    [sym_binary_operator] = STATE(874),
    [sym_unary_operator] = STATE(874),
    [sym_comparison_operator] = STATE(1574),
    [sym_lambda] = STATE(1574),
    [sym_attribute] = STATE(874),
    [sym_subscript] = STATE(874),
    [sym_call] = STATE(874),
    [sym_list] = STATE(874),
    [sym_list_comprehension] = STATE(874),
    [sym_dictionary] = STATE(874),
    [sym_dictionary_comprehension] = STATE(874),
    [sym_set] = STATE(874),
    [sym_set_comprehension] = STATE(874),
    [sym_parenthesized_expression] = STATE(874),
    [sym_tuple] = STATE(874),
    [sym_generator_expression] = STATE(874),
    [sym_conditional_expression] = STATE(1574),
    [sym_concatenated_string] = STATE(874),
    [sym_string] = STATE(876),
    [sym_await] = STATE(1574),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1646),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_DASH] = ACTIONS(1648),
    [anon_sym_TILDE] = ACTIONS(1648),
    [anon_sym_lambda] = ACTIONS(1650),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1652),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1654),
    [sym_float] = ACTIONS(1654),
    [sym_identifier] = ACTIONS(1654),
    [sym_true] = ACTIONS(1654),
    [sym_false] = ACTIONS(1654),
    [sym_none] = ACTIONS(1654),
    [anon_sym_await] = ACTIONS(1656),
    [sym_comment] = ACTIONS(73),
  },
  [1266] = {
    [sym__primary_expression] = STATE(1575),
    [sym_binary_operator] = STATE(1575),
    [sym_unary_operator] = STATE(1575),
    [sym_attribute] = STATE(1575),
    [sym_subscript] = STATE(1575),
    [sym_call] = STATE(1575),
    [sym_list] = STATE(1575),
    [sym_list_comprehension] = STATE(1575),
    [sym_dictionary] = STATE(1575),
    [sym_dictionary_comprehension] = STATE(1575),
    [sym_set] = STATE(1575),
    [sym_set_comprehension] = STATE(1575),
    [sym_parenthesized_expression] = STATE(1575),
    [sym_tuple] = STATE(1575),
    [sym_generator_expression] = STATE(1575),
    [sym_concatenated_string] = STATE(1575),
    [sym_string] = STATE(876),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_DASH] = ACTIONS(1648),
    [anon_sym_TILDE] = ACTIONS(1648),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3309),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3311),
    [sym_float] = ACTIONS(3311),
    [sym_identifier] = ACTIONS(3311),
    [sym_true] = ACTIONS(3311),
    [sym_false] = ACTIONS(3311),
    [sym_none] = ACTIONS(3311),
    [sym_comment] = ACTIONS(73),
  },
  [1267] = {
    [sym__primary_expression] = STATE(1576),
    [sym_binary_operator] = STATE(1576),
    [sym_unary_operator] = STATE(1576),
    [sym_attribute] = STATE(1576),
    [sym_subscript] = STATE(1576),
    [sym_call] = STATE(1576),
    [sym_list] = STATE(1576),
    [sym_list_comprehension] = STATE(1576),
    [sym_dictionary] = STATE(1576),
    [sym_dictionary_comprehension] = STATE(1576),
    [sym_set] = STATE(1576),
    [sym_set_comprehension] = STATE(1576),
    [sym_parenthesized_expression] = STATE(1576),
    [sym_tuple] = STATE(1576),
    [sym_generator_expression] = STATE(1576),
    [sym_concatenated_string] = STATE(1576),
    [sym_string] = STATE(876),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_DASH] = ACTIONS(1648),
    [anon_sym_TILDE] = ACTIONS(1648),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3313),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3315),
    [sym_float] = ACTIONS(3315),
    [sym_identifier] = ACTIONS(3315),
    [sym_true] = ACTIONS(3315),
    [sym_false] = ACTIONS(3315),
    [sym_none] = ACTIONS(3315),
    [sym_comment] = ACTIONS(73),
  },
  [1268] = {
    [sym__primary_expression] = STATE(1577),
    [sym_binary_operator] = STATE(1577),
    [sym_unary_operator] = STATE(1577),
    [sym_attribute] = STATE(1577),
    [sym_subscript] = STATE(1577),
    [sym_call] = STATE(1577),
    [sym_list] = STATE(1577),
    [sym_list_comprehension] = STATE(1577),
    [sym_dictionary] = STATE(1577),
    [sym_dictionary_comprehension] = STATE(1577),
    [sym_set] = STATE(1577),
    [sym_set_comprehension] = STATE(1577),
    [sym_parenthesized_expression] = STATE(1577),
    [sym_tuple] = STATE(1577),
    [sym_generator_expression] = STATE(1577),
    [sym_concatenated_string] = STATE(1577),
    [sym_string] = STATE(876),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_DASH] = ACTIONS(1648),
    [anon_sym_TILDE] = ACTIONS(1648),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3317),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3319),
    [sym_float] = ACTIONS(3319),
    [sym_identifier] = ACTIONS(3319),
    [sym_true] = ACTIONS(3319),
    [sym_false] = ACTIONS(3319),
    [sym_none] = ACTIONS(3319),
    [sym_comment] = ACTIONS(73),
  },
  [1269] = {
    [anon_sym_in] = ACTIONS(3321),
    [sym_comment] = ACTIONS(73),
  },
  [1270] = {
    [sym__primary_expression] = STATE(1579),
    [sym_binary_operator] = STATE(1579),
    [sym_unary_operator] = STATE(1579),
    [sym_attribute] = STATE(1579),
    [sym_subscript] = STATE(1579),
    [sym_call] = STATE(1579),
    [sym_list] = STATE(1579),
    [sym_list_comprehension] = STATE(1579),
    [sym_dictionary] = STATE(1579),
    [sym_dictionary_comprehension] = STATE(1579),
    [sym_set] = STATE(1579),
    [sym_set_comprehension] = STATE(1579),
    [sym_parenthesized_expression] = STATE(1579),
    [sym_tuple] = STATE(1579),
    [sym_generator_expression] = STATE(1579),
    [sym_concatenated_string] = STATE(1579),
    [sym_string] = STATE(876),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_DASH] = ACTIONS(1648),
    [anon_sym_TILDE] = ACTIONS(1648),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3323),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3325),
    [sym_float] = ACTIONS(3325),
    [sym_identifier] = ACTIONS(3325),
    [sym_true] = ACTIONS(3325),
    [sym_false] = ACTIONS(3325),
    [sym_none] = ACTIONS(3325),
    [sym_comment] = ACTIONS(73),
  },
  [1271] = {
    [sym__primary_expression] = STATE(669),
    [sym_binary_operator] = STATE(669),
    [sym_unary_operator] = STATE(669),
    [sym_attribute] = STATE(669),
    [sym_subscript] = STATE(669),
    [sym_call] = STATE(669),
    [sym_list] = STATE(669),
    [sym_list_comprehension] = STATE(669),
    [sym_dictionary] = STATE(669),
    [sym_dictionary_comprehension] = STATE(669),
    [sym_set] = STATE(669),
    [sym_set_comprehension] = STATE(669),
    [sym_parenthesized_expression] = STATE(669),
    [sym_tuple] = STATE(669),
    [sym_generator_expression] = STATE(669),
    [sym_concatenated_string] = STATE(669),
    [sym_string] = STATE(876),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_DASH] = ACTIONS(1648),
    [anon_sym_TILDE] = ACTIONS(1648),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1282),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1284),
    [sym_float] = ACTIONS(1284),
    [sym_identifier] = ACTIONS(1284),
    [sym_true] = ACTIONS(1284),
    [sym_false] = ACTIONS(1284),
    [sym_none] = ACTIONS(1284),
    [sym_comment] = ACTIONS(73),
  },
  [1272] = {
    [sym__primary_expression] = STATE(1580),
    [sym_binary_operator] = STATE(1580),
    [sym_unary_operator] = STATE(1580),
    [sym_attribute] = STATE(1580),
    [sym_subscript] = STATE(1580),
    [sym_call] = STATE(1580),
    [sym_list] = STATE(1580),
    [sym_list_comprehension] = STATE(1580),
    [sym_dictionary] = STATE(1580),
    [sym_dictionary_comprehension] = STATE(1580),
    [sym_set] = STATE(1580),
    [sym_set_comprehension] = STATE(1580),
    [sym_parenthesized_expression] = STATE(1580),
    [sym_tuple] = STATE(1580),
    [sym_generator_expression] = STATE(1580),
    [sym_concatenated_string] = STATE(1580),
    [sym_string] = STATE(876),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_DASH] = ACTIONS(1648),
    [anon_sym_TILDE] = ACTIONS(1648),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3327),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3329),
    [sym_float] = ACTIONS(3329),
    [sym_identifier] = ACTIONS(3329),
    [sym_true] = ACTIONS(3329),
    [sym_false] = ACTIONS(3329),
    [sym_none] = ACTIONS(3329),
    [sym_comment] = ACTIONS(73),
  },
  [1273] = {
    [sym__primary_expression] = STATE(1581),
    [sym_binary_operator] = STATE(1581),
    [sym_unary_operator] = STATE(1581),
    [sym_attribute] = STATE(1581),
    [sym_subscript] = STATE(1581),
    [sym_call] = STATE(1581),
    [sym_list] = STATE(1581),
    [sym_list_comprehension] = STATE(1581),
    [sym_dictionary] = STATE(1581),
    [sym_dictionary_comprehension] = STATE(1581),
    [sym_set] = STATE(1581),
    [sym_set_comprehension] = STATE(1581),
    [sym_parenthesized_expression] = STATE(1581),
    [sym_tuple] = STATE(1581),
    [sym_generator_expression] = STATE(1581),
    [sym_concatenated_string] = STATE(1581),
    [sym_string] = STATE(876),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_DASH] = ACTIONS(1648),
    [anon_sym_TILDE] = ACTIONS(1648),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3331),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3333),
    [sym_float] = ACTIONS(3333),
    [sym_identifier] = ACTIONS(3333),
    [sym_true] = ACTIONS(3333),
    [sym_false] = ACTIONS(3333),
    [sym_none] = ACTIONS(3333),
    [sym_comment] = ACTIONS(73),
  },
  [1274] = {
    [sym__primary_expression] = STATE(1582),
    [sym_binary_operator] = STATE(1582),
    [sym_unary_operator] = STATE(1582),
    [sym_attribute] = STATE(1582),
    [sym_subscript] = STATE(1582),
    [sym_call] = STATE(1582),
    [sym_list] = STATE(1582),
    [sym_list_comprehension] = STATE(1582),
    [sym_dictionary] = STATE(1582),
    [sym_dictionary_comprehension] = STATE(1582),
    [sym_set] = STATE(1582),
    [sym_set_comprehension] = STATE(1582),
    [sym_parenthesized_expression] = STATE(1582),
    [sym_tuple] = STATE(1582),
    [sym_generator_expression] = STATE(1582),
    [sym_concatenated_string] = STATE(1582),
    [sym_string] = STATE(876),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_DASH] = ACTIONS(1648),
    [anon_sym_TILDE] = ACTIONS(1648),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3335),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3337),
    [sym_float] = ACTIONS(3337),
    [sym_identifier] = ACTIONS(3337),
    [sym_true] = ACTIONS(3337),
    [sym_false] = ACTIONS(3337),
    [sym_none] = ACTIONS(3337),
    [sym_comment] = ACTIONS(73),
  },
  [1275] = {
    [sym__primary_expression] = STATE(1577),
    [sym_binary_operator] = STATE(1577),
    [sym_unary_operator] = STATE(1577),
    [sym_attribute] = STATE(1577),
    [sym_subscript] = STATE(1577),
    [sym_call] = STATE(1577),
    [sym_list] = STATE(1577),
    [sym_list_comprehension] = STATE(1577),
    [sym_dictionary] = STATE(1577),
    [sym_dictionary_comprehension] = STATE(1577),
    [sym_set] = STATE(1577),
    [sym_set_comprehension] = STATE(1577),
    [sym_parenthesized_expression] = STATE(1577),
    [sym_tuple] = STATE(1577),
    [sym_generator_expression] = STATE(1577),
    [sym_concatenated_string] = STATE(1577),
    [sym_string] = STATE(876),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(3339),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_DASH] = ACTIONS(1648),
    [anon_sym_TILDE] = ACTIONS(1648),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3317),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3319),
    [sym_float] = ACTIONS(3319),
    [sym_identifier] = ACTIONS(3319),
    [sym_true] = ACTIONS(3319),
    [sym_false] = ACTIONS(3319),
    [sym_none] = ACTIONS(3319),
    [sym_comment] = ACTIONS(73),
  },
  [1276] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1583),
    [anon_sym_if] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2578),
    [anon_sym_EQ] = ACTIONS(993),
    [anon_sym_not] = ACTIONS(2582),
    [anon_sym_and] = ACTIONS(991),
    [anon_sym_or] = ACTIONS(991),
    [anon_sym_LT] = ACTIONS(2594),
    [anon_sym_LT_EQ] = ACTIONS(2578),
    [anon_sym_EQ_EQ] = ACTIONS(2578),
    [anon_sym_BANG_EQ] = ACTIONS(2578),
    [anon_sym_GT_EQ] = ACTIONS(2578),
    [anon_sym_GT] = ACTIONS(2594),
    [anon_sym_LT_GT] = ACTIONS(2578),
    [anon_sym_is] = ACTIONS(2596),
    [sym_comment] = ACTIONS(73),
  },
  [1277] = {
    [sym__expression] = STATE(1584),
    [sym__primary_expression] = STATE(432),
    [sym_not_operator] = STATE(1584),
    [sym_boolean_operator] = STATE(1584),
    [sym_binary_operator] = STATE(432),
    [sym_unary_operator] = STATE(432),
    [sym_comparison_operator] = STATE(1584),
    [sym_lambda] = STATE(1584),
    [sym_attribute] = STATE(432),
    [sym_subscript] = STATE(432),
    [sym_call] = STATE(432),
    [sym_list] = STATE(432),
    [sym_list_comprehension] = STATE(432),
    [sym_dictionary] = STATE(432),
    [sym_dictionary_comprehension] = STATE(432),
    [sym_set] = STATE(432),
    [sym_set_comprehension] = STATE(432),
    [sym_parenthesized_expression] = STATE(432),
    [sym_tuple] = STATE(432),
    [sym_generator_expression] = STATE(432),
    [sym_conditional_expression] = STATE(1584),
    [sym_concatenated_string] = STATE(432),
    [sym_string] = STATE(433),
    [sym_await] = STATE(1584),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(735),
    [anon_sym_lambda] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(741),
    [sym_float] = ACTIONS(741),
    [sym_identifier] = ACTIONS(741),
    [sym_true] = ACTIONS(741),
    [sym_false] = ACTIONS(741),
    [sym_none] = ACTIONS(741),
    [anon_sym_await] = ACTIONS(743),
    [sym_comment] = ACTIONS(73),
  },
  [1278] = {
    [sym_string] = STATE(1585),
    [aux_sym_concatenated_string_repeat1] = STATE(1585),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_in] = ACTIONS(995),
    [anon_sym_EQ] = ACTIONS(997),
    [anon_sym_AT] = ACTIONS(995),
    [anon_sym_not] = ACTIONS(995),
    [anon_sym_and] = ACTIONS(995),
    [anon_sym_or] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(995),
    [anon_sym_SLASH_SLASH] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_GT] = ACTIONS(995),
    [anon_sym_is] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(995),
    [sym_comment] = ACTIONS(73),
  },
  [1279] = {
    [sym_default_parameter] = STATE(867),
    [sym_typed_default_parameter] = STATE(867),
    [sym_list_splat] = STATE(868),
    [sym_dictionary_splat] = STATE(868),
    [sym_typed_parameter] = STATE(867),
    [sym_tuple] = STATE(867),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(1640),
    [anon_sym_exec] = ACTIONS(1640),
    [sym_identifier] = ACTIONS(1644),
    [sym_comment] = ACTIONS(73),
  },
  [1280] = {
    [anon_sym_COMMA] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(723),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_EQ] = ACTIONS(723),
    [anon_sym_and] = ACTIONS(2611),
    [anon_sym_or] = ACTIONS(2613),
    [sym_comment] = ACTIONS(73),
  },
  [1281] = {
    [sym__expression] = STATE(1586),
    [sym__primary_expression] = STATE(885),
    [sym_not_operator] = STATE(1586),
    [sym_boolean_operator] = STATE(1586),
    [sym_binary_operator] = STATE(885),
    [sym_unary_operator] = STATE(885),
    [sym_comparison_operator] = STATE(1586),
    [sym_lambda] = STATE(1586),
    [sym_attribute] = STATE(885),
    [sym_subscript] = STATE(885),
    [sym_call] = STATE(885),
    [sym_list] = STATE(885),
    [sym_list_comprehension] = STATE(885),
    [sym_dictionary] = STATE(885),
    [sym_dictionary_comprehension] = STATE(885),
    [sym_set] = STATE(885),
    [sym_set_comprehension] = STATE(885),
    [sym_parenthesized_expression] = STATE(885),
    [sym_tuple] = STATE(885),
    [sym_generator_expression] = STATE(885),
    [sym_conditional_expression] = STATE(1586),
    [sym_concatenated_string] = STATE(885),
    [sym_string] = STATE(887),
    [sym_await] = STATE(1586),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_PLUS] = ACTIONS(1666),
    [anon_sym_DASH] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [anon_sym_lambda] = ACTIONS(1668),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1670),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1672),
    [sym_float] = ACTIONS(1672),
    [sym_identifier] = ACTIONS(1672),
    [sym_true] = ACTIONS(1672),
    [sym_false] = ACTIONS(1672),
    [sym_none] = ACTIONS(1672),
    [anon_sym_await] = ACTIONS(1674),
    [sym_comment] = ACTIONS(73),
  },
  [1282] = {
    [anon_sym_COLON] = ACTIONS(3341),
    [sym_comment] = ACTIONS(73),
  },
  [1283] = {
    [sym__expression] = STATE(1588),
    [sym__primary_expression] = STATE(538),
    [sym_not_operator] = STATE(1588),
    [sym_boolean_operator] = STATE(1588),
    [sym_binary_operator] = STATE(538),
    [sym_unary_operator] = STATE(538),
    [sym_comparison_operator] = STATE(1588),
    [sym_lambda] = STATE(1588),
    [sym_attribute] = STATE(538),
    [sym_subscript] = STATE(538),
    [sym_call] = STATE(538),
    [sym_list] = STATE(538),
    [sym_list_comprehension] = STATE(538),
    [sym_dictionary] = STATE(538),
    [sym_dictionary_comprehension] = STATE(538),
    [sym_set] = STATE(538),
    [sym_set_comprehension] = STATE(538),
    [sym_parenthesized_expression] = STATE(538),
    [sym_tuple] = STATE(538),
    [sym_generator_expression] = STATE(538),
    [sym_conditional_expression] = STATE(1588),
    [sym_concatenated_string] = STATE(538),
    [sym_string] = STATE(539),
    [sym_await] = STATE(1588),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_lambda] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(917),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(919),
    [sym_float] = ACTIONS(919),
    [sym_identifier] = ACTIONS(919),
    [sym_true] = ACTIONS(919),
    [sym_false] = ACTIONS(919),
    [sym_none] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(921),
    [sym_comment] = ACTIONS(73),
  },
  [1284] = {
    [sym__expression] = STATE(652),
    [sym__primary_expression] = STATE(885),
    [sym_not_operator] = STATE(652),
    [sym_boolean_operator] = STATE(652),
    [sym_binary_operator] = STATE(885),
    [sym_unary_operator] = STATE(885),
    [sym_comparison_operator] = STATE(652),
    [sym_lambda] = STATE(652),
    [sym_attribute] = STATE(885),
    [sym_subscript] = STATE(885),
    [sym_call] = STATE(885),
    [sym_list] = STATE(885),
    [sym_list_comprehension] = STATE(885),
    [sym_dictionary] = STATE(885),
    [sym_dictionary_comprehension] = STATE(885),
    [sym_set] = STATE(885),
    [sym_set_comprehension] = STATE(885),
    [sym_parenthesized_expression] = STATE(885),
    [sym_tuple] = STATE(885),
    [sym_generator_expression] = STATE(885),
    [sym_conditional_expression] = STATE(652),
    [sym_concatenated_string] = STATE(885),
    [sym_string] = STATE(887),
    [sym_await] = STATE(652),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_PLUS] = ACTIONS(1666),
    [anon_sym_DASH] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [anon_sym_lambda] = ACTIONS(1668),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1670),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1672),
    [sym_float] = ACTIONS(1672),
    [sym_identifier] = ACTIONS(1672),
    [sym_true] = ACTIONS(1672),
    [sym_false] = ACTIONS(1672),
    [sym_none] = ACTIONS(1672),
    [anon_sym_await] = ACTIONS(1674),
    [sym_comment] = ACTIONS(73),
  },
  [1285] = {
    [sym__expression] = STATE(1589),
    [sym__primary_expression] = STATE(885),
    [sym_not_operator] = STATE(1589),
    [sym_boolean_operator] = STATE(1589),
    [sym_binary_operator] = STATE(885),
    [sym_unary_operator] = STATE(885),
    [sym_comparison_operator] = STATE(1589),
    [sym_lambda] = STATE(1589),
    [sym_attribute] = STATE(885),
    [sym_subscript] = STATE(885),
    [sym_call] = STATE(885),
    [sym_list] = STATE(885),
    [sym_list_comprehension] = STATE(885),
    [sym_dictionary] = STATE(885),
    [sym_dictionary_comprehension] = STATE(885),
    [sym_set] = STATE(885),
    [sym_set_comprehension] = STATE(885),
    [sym_parenthesized_expression] = STATE(885),
    [sym_tuple] = STATE(885),
    [sym_generator_expression] = STATE(885),
    [sym_conditional_expression] = STATE(1589),
    [sym_concatenated_string] = STATE(885),
    [sym_string] = STATE(887),
    [sym_await] = STATE(1589),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_PLUS] = ACTIONS(1666),
    [anon_sym_DASH] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [anon_sym_lambda] = ACTIONS(1668),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1670),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1672),
    [sym_float] = ACTIONS(1672),
    [sym_identifier] = ACTIONS(1672),
    [sym_true] = ACTIONS(1672),
    [sym_false] = ACTIONS(1672),
    [sym_none] = ACTIONS(1672),
    [anon_sym_await] = ACTIONS(1674),
    [sym_comment] = ACTIONS(73),
  },
  [1286] = {
    [sym__primary_expression] = STATE(1590),
    [sym_binary_operator] = STATE(1590),
    [sym_unary_operator] = STATE(1590),
    [sym_attribute] = STATE(1590),
    [sym_subscript] = STATE(1590),
    [sym_call] = STATE(1590),
    [sym_list] = STATE(1590),
    [sym_list_comprehension] = STATE(1590),
    [sym_dictionary] = STATE(1590),
    [sym_dictionary_comprehension] = STATE(1590),
    [sym_set] = STATE(1590),
    [sym_set_comprehension] = STATE(1590),
    [sym_parenthesized_expression] = STATE(1590),
    [sym_tuple] = STATE(1590),
    [sym_generator_expression] = STATE(1590),
    [sym_concatenated_string] = STATE(1590),
    [sym_string] = STATE(887),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1666),
    [anon_sym_DASH] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3343),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3345),
    [sym_float] = ACTIONS(3345),
    [sym_identifier] = ACTIONS(3345),
    [sym_true] = ACTIONS(3345),
    [sym_false] = ACTIONS(3345),
    [sym_none] = ACTIONS(3345),
    [sym_comment] = ACTIONS(73),
  },
  [1287] = {
    [sym__primary_expression] = STATE(1591),
    [sym_binary_operator] = STATE(1591),
    [sym_unary_operator] = STATE(1591),
    [sym_attribute] = STATE(1591),
    [sym_subscript] = STATE(1591),
    [sym_call] = STATE(1591),
    [sym_list] = STATE(1591),
    [sym_list_comprehension] = STATE(1591),
    [sym_dictionary] = STATE(1591),
    [sym_dictionary_comprehension] = STATE(1591),
    [sym_set] = STATE(1591),
    [sym_set_comprehension] = STATE(1591),
    [sym_parenthesized_expression] = STATE(1591),
    [sym_tuple] = STATE(1591),
    [sym_generator_expression] = STATE(1591),
    [sym_concatenated_string] = STATE(1591),
    [sym_string] = STATE(887),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1666),
    [anon_sym_DASH] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3347),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3349),
    [sym_float] = ACTIONS(3349),
    [sym_identifier] = ACTIONS(3349),
    [sym_true] = ACTIONS(3349),
    [sym_false] = ACTIONS(3349),
    [sym_none] = ACTIONS(3349),
    [sym_comment] = ACTIONS(73),
  },
  [1288] = {
    [sym__primary_expression] = STATE(1592),
    [sym_binary_operator] = STATE(1592),
    [sym_unary_operator] = STATE(1592),
    [sym_attribute] = STATE(1592),
    [sym_subscript] = STATE(1592),
    [sym_call] = STATE(1592),
    [sym_list] = STATE(1592),
    [sym_list_comprehension] = STATE(1592),
    [sym_dictionary] = STATE(1592),
    [sym_dictionary_comprehension] = STATE(1592),
    [sym_set] = STATE(1592),
    [sym_set_comprehension] = STATE(1592),
    [sym_parenthesized_expression] = STATE(1592),
    [sym_tuple] = STATE(1592),
    [sym_generator_expression] = STATE(1592),
    [sym_concatenated_string] = STATE(1592),
    [sym_string] = STATE(887),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1666),
    [anon_sym_DASH] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3351),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3353),
    [sym_float] = ACTIONS(3353),
    [sym_identifier] = ACTIONS(3353),
    [sym_true] = ACTIONS(3353),
    [sym_false] = ACTIONS(3353),
    [sym_none] = ACTIONS(3353),
    [sym_comment] = ACTIONS(73),
  },
  [1289] = {
    [anon_sym_in] = ACTIONS(3355),
    [sym_comment] = ACTIONS(73),
  },
  [1290] = {
    [sym__primary_expression] = STATE(1594),
    [sym_binary_operator] = STATE(1594),
    [sym_unary_operator] = STATE(1594),
    [sym_attribute] = STATE(1594),
    [sym_subscript] = STATE(1594),
    [sym_call] = STATE(1594),
    [sym_list] = STATE(1594),
    [sym_list_comprehension] = STATE(1594),
    [sym_dictionary] = STATE(1594),
    [sym_dictionary_comprehension] = STATE(1594),
    [sym_set] = STATE(1594),
    [sym_set_comprehension] = STATE(1594),
    [sym_parenthesized_expression] = STATE(1594),
    [sym_tuple] = STATE(1594),
    [sym_generator_expression] = STATE(1594),
    [sym_concatenated_string] = STATE(1594),
    [sym_string] = STATE(887),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1666),
    [anon_sym_DASH] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3357),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3359),
    [sym_float] = ACTIONS(3359),
    [sym_identifier] = ACTIONS(3359),
    [sym_true] = ACTIONS(3359),
    [sym_false] = ACTIONS(3359),
    [sym_none] = ACTIONS(3359),
    [sym_comment] = ACTIONS(73),
  },
  [1291] = {
    [sym__primary_expression] = STATE(669),
    [sym_binary_operator] = STATE(669),
    [sym_unary_operator] = STATE(669),
    [sym_attribute] = STATE(669),
    [sym_subscript] = STATE(669),
    [sym_call] = STATE(669),
    [sym_list] = STATE(669),
    [sym_list_comprehension] = STATE(669),
    [sym_dictionary] = STATE(669),
    [sym_dictionary_comprehension] = STATE(669),
    [sym_set] = STATE(669),
    [sym_set_comprehension] = STATE(669),
    [sym_parenthesized_expression] = STATE(669),
    [sym_tuple] = STATE(669),
    [sym_generator_expression] = STATE(669),
    [sym_concatenated_string] = STATE(669),
    [sym_string] = STATE(887),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1666),
    [anon_sym_DASH] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1282),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1284),
    [sym_float] = ACTIONS(1284),
    [sym_identifier] = ACTIONS(1284),
    [sym_true] = ACTIONS(1284),
    [sym_false] = ACTIONS(1284),
    [sym_none] = ACTIONS(1284),
    [sym_comment] = ACTIONS(73),
  },
  [1292] = {
    [sym__primary_expression] = STATE(1595),
    [sym_binary_operator] = STATE(1595),
    [sym_unary_operator] = STATE(1595),
    [sym_attribute] = STATE(1595),
    [sym_subscript] = STATE(1595),
    [sym_call] = STATE(1595),
    [sym_list] = STATE(1595),
    [sym_list_comprehension] = STATE(1595),
    [sym_dictionary] = STATE(1595),
    [sym_dictionary_comprehension] = STATE(1595),
    [sym_set] = STATE(1595),
    [sym_set_comprehension] = STATE(1595),
    [sym_parenthesized_expression] = STATE(1595),
    [sym_tuple] = STATE(1595),
    [sym_generator_expression] = STATE(1595),
    [sym_concatenated_string] = STATE(1595),
    [sym_string] = STATE(887),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1666),
    [anon_sym_DASH] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3361),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3363),
    [sym_float] = ACTIONS(3363),
    [sym_identifier] = ACTIONS(3363),
    [sym_true] = ACTIONS(3363),
    [sym_false] = ACTIONS(3363),
    [sym_none] = ACTIONS(3363),
    [sym_comment] = ACTIONS(73),
  },
  [1293] = {
    [sym__primary_expression] = STATE(1596),
    [sym_binary_operator] = STATE(1596),
    [sym_unary_operator] = STATE(1596),
    [sym_attribute] = STATE(1596),
    [sym_subscript] = STATE(1596),
    [sym_call] = STATE(1596),
    [sym_list] = STATE(1596),
    [sym_list_comprehension] = STATE(1596),
    [sym_dictionary] = STATE(1596),
    [sym_dictionary_comprehension] = STATE(1596),
    [sym_set] = STATE(1596),
    [sym_set_comprehension] = STATE(1596),
    [sym_parenthesized_expression] = STATE(1596),
    [sym_tuple] = STATE(1596),
    [sym_generator_expression] = STATE(1596),
    [sym_concatenated_string] = STATE(1596),
    [sym_string] = STATE(887),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1666),
    [anon_sym_DASH] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3365),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3367),
    [sym_float] = ACTIONS(3367),
    [sym_identifier] = ACTIONS(3367),
    [sym_true] = ACTIONS(3367),
    [sym_false] = ACTIONS(3367),
    [sym_none] = ACTIONS(3367),
    [sym_comment] = ACTIONS(73),
  },
  [1294] = {
    [sym__primary_expression] = STATE(1597),
    [sym_binary_operator] = STATE(1597),
    [sym_unary_operator] = STATE(1597),
    [sym_attribute] = STATE(1597),
    [sym_subscript] = STATE(1597),
    [sym_call] = STATE(1597),
    [sym_list] = STATE(1597),
    [sym_list_comprehension] = STATE(1597),
    [sym_dictionary] = STATE(1597),
    [sym_dictionary_comprehension] = STATE(1597),
    [sym_set] = STATE(1597),
    [sym_set_comprehension] = STATE(1597),
    [sym_parenthesized_expression] = STATE(1597),
    [sym_tuple] = STATE(1597),
    [sym_generator_expression] = STATE(1597),
    [sym_concatenated_string] = STATE(1597),
    [sym_string] = STATE(887),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1666),
    [anon_sym_DASH] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3369),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3371),
    [sym_float] = ACTIONS(3371),
    [sym_identifier] = ACTIONS(3371),
    [sym_true] = ACTIONS(3371),
    [sym_false] = ACTIONS(3371),
    [sym_none] = ACTIONS(3371),
    [sym_comment] = ACTIONS(73),
  },
  [1295] = {
    [sym__primary_expression] = STATE(1592),
    [sym_binary_operator] = STATE(1592),
    [sym_unary_operator] = STATE(1592),
    [sym_attribute] = STATE(1592),
    [sym_subscript] = STATE(1592),
    [sym_call] = STATE(1592),
    [sym_list] = STATE(1592),
    [sym_list_comprehension] = STATE(1592),
    [sym_dictionary] = STATE(1592),
    [sym_dictionary_comprehension] = STATE(1592),
    [sym_set] = STATE(1592),
    [sym_set_comprehension] = STATE(1592),
    [sym_parenthesized_expression] = STATE(1592),
    [sym_tuple] = STATE(1592),
    [sym_generator_expression] = STATE(1592),
    [sym_concatenated_string] = STATE(1592),
    [sym_string] = STATE(887),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(3373),
    [anon_sym_PLUS] = ACTIONS(1666),
    [anon_sym_DASH] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3351),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3353),
    [sym_float] = ACTIONS(3353),
    [sym_identifier] = ACTIONS(3353),
    [sym_true] = ACTIONS(3353),
    [sym_false] = ACTIONS(3353),
    [sym_none] = ACTIONS(3353),
    [sym_comment] = ACTIONS(73),
  },
  [1296] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1598),
    [anon_sym_COMMA] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(991),
    [anon_sym_COLON] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2619),
    [anon_sym_EQ] = ACTIONS(993),
    [anon_sym_not] = ACTIONS(2623),
    [anon_sym_and] = ACTIONS(991),
    [anon_sym_or] = ACTIONS(991),
    [anon_sym_LT] = ACTIONS(2635),
    [anon_sym_LT_EQ] = ACTIONS(2619),
    [anon_sym_EQ_EQ] = ACTIONS(2619),
    [anon_sym_BANG_EQ] = ACTIONS(2619),
    [anon_sym_GT_EQ] = ACTIONS(2619),
    [anon_sym_GT] = ACTIONS(2635),
    [anon_sym_LT_GT] = ACTIONS(2619),
    [anon_sym_is] = ACTIONS(2637),
    [sym_comment] = ACTIONS(73),
  },
  [1297] = {
    [sym__expression] = STATE(1599),
    [sym__primary_expression] = STATE(432),
    [sym_not_operator] = STATE(1599),
    [sym_boolean_operator] = STATE(1599),
    [sym_binary_operator] = STATE(432),
    [sym_unary_operator] = STATE(432),
    [sym_comparison_operator] = STATE(1599),
    [sym_lambda] = STATE(1599),
    [sym_attribute] = STATE(432),
    [sym_subscript] = STATE(432),
    [sym_call] = STATE(432),
    [sym_list] = STATE(432),
    [sym_list_comprehension] = STATE(432),
    [sym_dictionary] = STATE(432),
    [sym_dictionary_comprehension] = STATE(432),
    [sym_set] = STATE(432),
    [sym_set_comprehension] = STATE(432),
    [sym_parenthesized_expression] = STATE(432),
    [sym_tuple] = STATE(432),
    [sym_generator_expression] = STATE(432),
    [sym_conditional_expression] = STATE(1599),
    [sym_concatenated_string] = STATE(432),
    [sym_string] = STATE(433),
    [sym_await] = STATE(1599),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(735),
    [anon_sym_lambda] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(741),
    [sym_float] = ACTIONS(741),
    [sym_identifier] = ACTIONS(741),
    [sym_true] = ACTIONS(741),
    [sym_false] = ACTIONS(741),
    [sym_none] = ACTIONS(741),
    [anon_sym_await] = ACTIONS(743),
    [sym_comment] = ACTIONS(73),
  },
  [1298] = {
    [sym_string] = STATE(1600),
    [aux_sym_concatenated_string_repeat1] = STATE(1600),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_COLON] = ACTIONS(995),
    [anon_sym_in] = ACTIONS(995),
    [anon_sym_EQ] = ACTIONS(997),
    [anon_sym_AT] = ACTIONS(995),
    [anon_sym_not] = ACTIONS(995),
    [anon_sym_and] = ACTIONS(995),
    [anon_sym_or] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(995),
    [anon_sym_SLASH_SLASH] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_GT] = ACTIONS(995),
    [anon_sym_is] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(995),
    [sym_comment] = ACTIONS(73),
  },
  [1299] = {
    [anon_sym_COMMA] = ACTIONS(1660),
    [anon_sym_if] = ACTIONS(1686),
    [anon_sym_and] = ACTIONS(1688),
    [anon_sym_or] = ACTIONS(1690),
    [anon_sym_RBRACK] = ACTIONS(1660),
    [sym_comment] = ACTIONS(73),
  },
  [1300] = {
    [sym__expression] = STATE(1601),
    [sym__primary_expression] = STATE(452),
    [sym_not_operator] = STATE(1601),
    [sym_boolean_operator] = STATE(1601),
    [sym_binary_operator] = STATE(452),
    [sym_unary_operator] = STATE(452),
    [sym_comparison_operator] = STATE(1601),
    [sym_lambda] = STATE(1601),
    [sym_attribute] = STATE(452),
    [sym_subscript] = STATE(452),
    [sym_call] = STATE(452),
    [sym_list] = STATE(452),
    [sym_list_comprehension] = STATE(452),
    [sym_dictionary] = STATE(452),
    [sym_dictionary_comprehension] = STATE(452),
    [sym_set] = STATE(452),
    [sym_set_comprehension] = STATE(452),
    [sym_parenthesized_expression] = STATE(452),
    [sym_tuple] = STATE(452),
    [sym_generator_expression] = STATE(452),
    [sym_conditional_expression] = STATE(1601),
    [sym_concatenated_string] = STATE(452),
    [sym_string] = STATE(453),
    [sym_await] = STATE(1601),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_lambda] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(773),
    [sym_float] = ACTIONS(773),
    [sym_identifier] = ACTIONS(773),
    [sym_true] = ACTIONS(773),
    [sym_false] = ACTIONS(773),
    [sym_none] = ACTIONS(773),
    [anon_sym_await] = ACTIONS(775),
    [sym_comment] = ACTIONS(73),
  },
  [1301] = {
    [anon_sym_if] = ACTIONS(1925),
    [anon_sym_else] = ACTIONS(3375),
    [anon_sym_and] = ACTIONS(1929),
    [anon_sym_or] = ACTIONS(1931),
    [sym_comment] = ACTIONS(73),
  },
  [1302] = {
    [anon_sym_COMMA] = ACTIONS(1957),
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_and] = ACTIONS(1688),
    [anon_sym_or] = ACTIONS(1957),
    [anon_sym_RBRACK] = ACTIONS(1957),
    [sym_comment] = ACTIONS(73),
  },
  [1303] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1984),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1986),
    [anon_sym_PERCENT] = ACTIONS(1984),
    [anon_sym_SLASH_SLASH] = ACTIONS(1984),
    [anon_sym_STAR_STAR] = ACTIONS(1704),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1304] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1692),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1698),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1702),
    [anon_sym_DASH] = ACTIONS(1702),
    [anon_sym_SLASH] = ACTIONS(1692),
    [anon_sym_PERCENT] = ACTIONS(1698),
    [anon_sym_SLASH_SLASH] = ACTIONS(1698),
    [anon_sym_STAR_STAR] = ACTIONS(1704),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1305] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1988),
    [anon_sym_STAR] = ACTIONS(1692),
    [anon_sym_GT_GT] = ACTIONS(1694),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(1988),
    [anon_sym_AT] = ACTIONS(1698),
    [anon_sym_not] = ACTIONS(1988),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_PLUS] = ACTIONS(1702),
    [anon_sym_DASH] = ACTIONS(1702),
    [anon_sym_SLASH] = ACTIONS(1692),
    [anon_sym_PERCENT] = ACTIONS(1698),
    [anon_sym_SLASH_SLASH] = ACTIONS(1698),
    [anon_sym_STAR_STAR] = ACTIONS(1704),
    [anon_sym_PIPE] = ACTIONS(1706),
    [anon_sym_AMP] = ACTIONS(1708),
    [anon_sym_CARET] = ACTIONS(1710),
    [anon_sym_LT_LT] = ACTIONS(1694),
    [anon_sym_LT] = ACTIONS(1990),
    [anon_sym_LT_EQ] = ACTIONS(1988),
    [anon_sym_EQ_EQ] = ACTIONS(1988),
    [anon_sym_BANG_EQ] = ACTIONS(1988),
    [anon_sym_GT_EQ] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1990),
    [anon_sym_LT_GT] = ACTIONS(1988),
    [anon_sym_is] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(473),
    [anon_sym_RBRACK] = ACTIONS(1988),
    [sym_comment] = ACTIONS(73),
  },
  [1306] = {
    [sym__primary_expression] = STATE(1603),
    [sym_binary_operator] = STATE(1603),
    [sym_unary_operator] = STATE(1603),
    [sym_attribute] = STATE(1603),
    [sym_subscript] = STATE(1603),
    [sym_call] = STATE(1603),
    [sym_list] = STATE(1603),
    [sym_list_comprehension] = STATE(1603),
    [sym_dictionary] = STATE(1603),
    [sym_dictionary_comprehension] = STATE(1603),
    [sym_set] = STATE(1603),
    [sym_set_comprehension] = STATE(1603),
    [sym_parenthesized_expression] = STATE(1603),
    [sym_tuple] = STATE(1603),
    [sym_generator_expression] = STATE(1603),
    [sym_concatenated_string] = STATE(1603),
    [sym_string] = STATE(453),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3377),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3379),
    [sym_float] = ACTIONS(3379),
    [sym_identifier] = ACTIONS(3379),
    [sym_true] = ACTIONS(3379),
    [sym_false] = ACTIONS(3379),
    [sym_none] = ACTIONS(3379),
    [sym_comment] = ACTIONS(73),
  },
  [1307] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1692),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1698),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1692),
    [anon_sym_PERCENT] = ACTIONS(1698),
    [anon_sym_SLASH_SLASH] = ACTIONS(1698),
    [anon_sym_STAR_STAR] = ACTIONS(1704),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1308] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1692),
    [anon_sym_GT_GT] = ACTIONS(1694),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1698),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1702),
    [anon_sym_DASH] = ACTIONS(1702),
    [anon_sym_SLASH] = ACTIONS(1692),
    [anon_sym_PERCENT] = ACTIONS(1698),
    [anon_sym_SLASH_SLASH] = ACTIONS(1698),
    [anon_sym_STAR_STAR] = ACTIONS(1704),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1708),
    [anon_sym_CARET] = ACTIONS(1710),
    [anon_sym_LT_LT] = ACTIONS(1694),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1309] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1692),
    [anon_sym_GT_GT] = ACTIONS(1694),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1698),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1702),
    [anon_sym_DASH] = ACTIONS(1702),
    [anon_sym_SLASH] = ACTIONS(1692),
    [anon_sym_PERCENT] = ACTIONS(1698),
    [anon_sym_SLASH_SLASH] = ACTIONS(1698),
    [anon_sym_STAR_STAR] = ACTIONS(1704),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1710),
    [anon_sym_LT_LT] = ACTIONS(1694),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1310] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1692),
    [anon_sym_GT_GT] = ACTIONS(1694),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1698),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1702),
    [anon_sym_DASH] = ACTIONS(1702),
    [anon_sym_SLASH] = ACTIONS(1692),
    [anon_sym_PERCENT] = ACTIONS(1698),
    [anon_sym_SLASH_SLASH] = ACTIONS(1698),
    [anon_sym_STAR_STAR] = ACTIONS(1704),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1694),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1311] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1311),
    [anon_sym_COMMA] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(3381),
    [anon_sym_not] = ACTIONS(3384),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(3387),
    [anon_sym_LT_EQ] = ACTIONS(3381),
    [anon_sym_EQ_EQ] = ACTIONS(3381),
    [anon_sym_BANG_EQ] = ACTIONS(3381),
    [anon_sym_GT_EQ] = ACTIONS(3381),
    [anon_sym_GT] = ACTIONS(3387),
    [anon_sym_LT_GT] = ACTIONS(3381),
    [anon_sym_is] = ACTIONS(3390),
    [anon_sym_RBRACK] = ACTIONS(1988),
    [sym_comment] = ACTIONS(73),
  },
  [1312] = {
    [sym_string] = STATE(1312),
    [aux_sym_concatenated_string_repeat1] = STATE(1312),
    [sym__string_start] = ACTIONS(2241),
    [anon_sym_DOT] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(2050),
    [anon_sym_COMMA] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2050),
    [anon_sym_if] = ACTIONS(2050),
    [anon_sym_in] = ACTIONS(2050),
    [anon_sym_AT] = ACTIONS(2050),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_and] = ACTIONS(2050),
    [anon_sym_or] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_SLASH] = ACTIONS(2055),
    [anon_sym_PERCENT] = ACTIONS(2050),
    [anon_sym_SLASH_SLASH] = ACTIONS(2050),
    [anon_sym_STAR_STAR] = ACTIONS(2050),
    [anon_sym_PIPE] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2050),
    [anon_sym_CARET] = ACTIONS(2050),
    [anon_sym_LT_LT] = ACTIONS(2050),
    [anon_sym_LT] = ACTIONS(2055),
    [anon_sym_LT_EQ] = ACTIONS(2050),
    [anon_sym_EQ_EQ] = ACTIONS(2050),
    [anon_sym_BANG_EQ] = ACTIONS(2050),
    [anon_sym_GT_EQ] = ACTIONS(2050),
    [anon_sym_GT] = ACTIONS(2055),
    [anon_sym_LT_GT] = ACTIONS(2050),
    [anon_sym_is] = ACTIONS(2050),
    [anon_sym_LBRACK] = ACTIONS(2050),
    [anon_sym_RBRACK] = ACTIONS(2050),
    [sym_comment] = ACTIONS(73),
  },
  [1313] = {
    [anon_sym_COMMA] = ACTIONS(2647),
    [anon_sym_if] = ACTIONS(785),
    [anon_sym_async] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2647),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_or] = ACTIONS(793),
    [anon_sym_RBRACK] = ACTIONS(2647),
    [sym_comment] = ACTIONS(73),
  },
  [1314] = {
    [sym__newline] = ACTIONS(3393),
    [anon_sym_DOT] = ACTIONS(3393),
    [anon_sym_LPAREN] = ACTIONS(3393),
    [anon_sym_COMMA] = ACTIONS(3393),
    [anon_sym_STAR] = ACTIONS(3395),
    [anon_sym_GT_GT] = ACTIONS(3395),
    [anon_sym_if] = ACTIONS(3393),
    [anon_sym_COLON] = ACTIONS(3393),
    [anon_sym_in] = ACTIONS(3393),
    [anon_sym_EQ] = ACTIONS(3395),
    [anon_sym_AT] = ACTIONS(3395),
    [anon_sym_not] = ACTIONS(3393),
    [anon_sym_and] = ACTIONS(3393),
    [anon_sym_or] = ACTIONS(3393),
    [anon_sym_PLUS] = ACTIONS(3395),
    [anon_sym_DASH] = ACTIONS(3395),
    [anon_sym_SLASH] = ACTIONS(3395),
    [anon_sym_PERCENT] = ACTIONS(3395),
    [anon_sym_SLASH_SLASH] = ACTIONS(3395),
    [anon_sym_STAR_STAR] = ACTIONS(3395),
    [anon_sym_PIPE] = ACTIONS(3395),
    [anon_sym_AMP] = ACTIONS(3395),
    [anon_sym_CARET] = ACTIONS(3395),
    [anon_sym_LT_LT] = ACTIONS(3395),
    [anon_sym_LT] = ACTIONS(3395),
    [anon_sym_LT_EQ] = ACTIONS(3393),
    [anon_sym_EQ_EQ] = ACTIONS(3393),
    [anon_sym_BANG_EQ] = ACTIONS(3393),
    [anon_sym_GT_EQ] = ACTIONS(3393),
    [anon_sym_GT] = ACTIONS(3395),
    [anon_sym_LT_GT] = ACTIONS(3393),
    [anon_sym_is] = ACTIONS(3393),
    [anon_sym_PLUS_EQ] = ACTIONS(3393),
    [anon_sym_DASH_EQ] = ACTIONS(3393),
    [anon_sym_STAR_EQ] = ACTIONS(3393),
    [anon_sym_SLASH_EQ] = ACTIONS(3393),
    [anon_sym_AT_EQ] = ACTIONS(3393),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3393),
    [anon_sym_PERCENT_EQ] = ACTIONS(3393),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3393),
    [anon_sym_GT_GT_EQ] = ACTIONS(3393),
    [anon_sym_LT_LT_EQ] = ACTIONS(3393),
    [anon_sym_AMP_EQ] = ACTIONS(3393),
    [anon_sym_CARET_EQ] = ACTIONS(3393),
    [anon_sym_PIPE_EQ] = ACTIONS(3393),
    [anon_sym_LBRACK] = ACTIONS(3393),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3393),
  },
  [1315] = {
    [sym_list_splat] = STATE(914),
    [sym__expression] = STATE(915),
    [sym__primary_expression] = STATE(452),
    [sym_not_operator] = STATE(915),
    [sym_boolean_operator] = STATE(915),
    [sym_binary_operator] = STATE(452),
    [sym_unary_operator] = STATE(452),
    [sym_comparison_operator] = STATE(915),
    [sym_lambda] = STATE(915),
    [sym_attribute] = STATE(452),
    [sym_subscript] = STATE(452),
    [sym_call] = STATE(452),
    [sym_list] = STATE(452),
    [sym_list_comprehension] = STATE(452),
    [sym_dictionary] = STATE(452),
    [sym_dictionary_comprehension] = STATE(452),
    [sym_set] = STATE(452),
    [sym_set_comprehension] = STATE(452),
    [sym_parenthesized_expression] = STATE(452),
    [sym_tuple] = STATE(452),
    [sym_generator_expression] = STATE(452),
    [sym_conditional_expression] = STATE(915),
    [sym_concatenated_string] = STATE(452),
    [sym_string] = STATE(453),
    [sym_await] = STATE(915),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(243),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_lambda] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(773),
    [sym_float] = ACTIONS(773),
    [sym_identifier] = ACTIONS(773),
    [sym_true] = ACTIONS(773),
    [sym_false] = ACTIONS(773),
    [sym_none] = ACTIONS(773),
    [anon_sym_await] = ACTIONS(775),
    [sym_comment] = ACTIONS(73),
  },
  [1316] = {
    [sym__expression] = STATE(1604),
    [sym__primary_expression] = STATE(152),
    [sym_not_operator] = STATE(1604),
    [sym_boolean_operator] = STATE(1604),
    [sym_binary_operator] = STATE(152),
    [sym_unary_operator] = STATE(152),
    [sym_comparison_operator] = STATE(1604),
    [sym_lambda] = STATE(1604),
    [sym_attribute] = STATE(152),
    [sym_subscript] = STATE(152),
    [sym_call] = STATE(152),
    [sym_list] = STATE(152),
    [sym_list_comprehension] = STATE(152),
    [sym_dictionary] = STATE(152),
    [sym_dictionary_comprehension] = STATE(152),
    [sym_set] = STATE(152),
    [sym_set_comprehension] = STATE(152),
    [sym_parenthesized_expression] = STATE(152),
    [sym_tuple] = STATE(152),
    [sym_generator_expression] = STATE(152),
    [sym_conditional_expression] = STATE(1604),
    [sym_concatenated_string] = STATE(152),
    [sym_string] = STATE(153),
    [sym_await] = STATE(1604),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_lambda] = ACTIONS(249),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(255),
    [sym_float] = ACTIONS(255),
    [sym_identifier] = ACTIONS(255),
    [sym_true] = ACTIONS(255),
    [sym_false] = ACTIONS(255),
    [sym_none] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [sym_comment] = ACTIONS(73),
  },
  [1317] = {
    [anon_sym_in] = ACTIONS(3397),
    [sym_comment] = ACTIONS(73),
  },
  [1318] = {
    [sym__expression_within_for_in_clause] = STATE(1607),
    [sym__expression] = STATE(1608),
    [sym__primary_expression] = STATE(152),
    [sym_not_operator] = STATE(1608),
    [sym_boolean_operator] = STATE(1608),
    [sym_binary_operator] = STATE(152),
    [sym_unary_operator] = STATE(152),
    [sym_comparison_operator] = STATE(1608),
    [sym_lambda] = STATE(1608),
    [sym_lambda_within_for_in_clause] = STATE(1607),
    [sym_attribute] = STATE(152),
    [sym_subscript] = STATE(152),
    [sym_call] = STATE(152),
    [sym_list] = STATE(152),
    [sym_list_comprehension] = STATE(152),
    [sym_dictionary] = STATE(152),
    [sym_dictionary_comprehension] = STATE(152),
    [sym_set] = STATE(152),
    [sym_set_comprehension] = STATE(152),
    [sym_parenthesized_expression] = STATE(152),
    [sym_tuple] = STATE(152),
    [sym_generator_expression] = STATE(152),
    [sym_conditional_expression] = STATE(1608),
    [sym_concatenated_string] = STATE(152),
    [sym_string] = STATE(153),
    [sym_await] = STATE(1608),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_lambda] = ACTIONS(3399),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(255),
    [sym_float] = ACTIONS(255),
    [sym_identifier] = ACTIONS(255),
    [sym_true] = ACTIONS(255),
    [sym_false] = ACTIONS(255),
    [sym_none] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [sym_comment] = ACTIONS(73),
  },
  [1319] = {
    [sym__expression] = STATE(1609),
    [sym__primary_expression] = STATE(1324),
    [sym_not_operator] = STATE(1609),
    [sym_boolean_operator] = STATE(1609),
    [sym_binary_operator] = STATE(1324),
    [sym_unary_operator] = STATE(1324),
    [sym_comparison_operator] = STATE(1609),
    [sym_lambda] = STATE(1609),
    [sym_attribute] = STATE(1324),
    [sym_subscript] = STATE(1324),
    [sym_call] = STATE(1324),
    [sym_list] = STATE(1324),
    [sym_list_comprehension] = STATE(1324),
    [sym_dictionary] = STATE(1324),
    [sym_dictionary_comprehension] = STATE(1324),
    [sym_set] = STATE(1324),
    [sym_set_comprehension] = STATE(1324),
    [sym_parenthesized_expression] = STATE(1324),
    [sym_tuple] = STATE(1324),
    [sym_generator_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(1609),
    [sym_concatenated_string] = STATE(1324),
    [sym_string] = STATE(1325),
    [sym_await] = STATE(1609),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2702),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_lambda] = ACTIONS(2706),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2708),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2710),
    [sym_float] = ACTIONS(2710),
    [sym_identifier] = ACTIONS(2710),
    [sym_true] = ACTIONS(2710),
    [sym_false] = ACTIONS(2710),
    [sym_none] = ACTIONS(2710),
    [anon_sym_await] = ACTIONS(2712),
    [sym_comment] = ACTIONS(73),
  },
  [1320] = {
    [sym__primary_expression] = STATE(227),
    [sym_binary_operator] = STATE(227),
    [sym_unary_operator] = STATE(227),
    [sym_attribute] = STATE(227),
    [sym_subscript] = STATE(227),
    [sym_call] = STATE(227),
    [sym_list] = STATE(227),
    [sym_list_comprehension] = STATE(227),
    [sym_dictionary] = STATE(227),
    [sym_dictionary_comprehension] = STATE(227),
    [sym_set] = STATE(227),
    [sym_set_comprehension] = STATE(227),
    [sym_parenthesized_expression] = STATE(227),
    [sym_tuple] = STATE(227),
    [sym_generator_expression] = STATE(227),
    [sym_concatenated_string] = STATE(227),
    [sym_string] = STATE(1325),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(403),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(405),
    [sym_float] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_true] = ACTIONS(405),
    [sym_false] = ACTIONS(405),
    [sym_none] = ACTIONS(405),
    [sym_comment] = ACTIONS(73),
  },
  [1321] = {
    [sym_lambda_parameters] = STATE(1611),
    [sym__parameters] = STATE(138),
    [sym_default_parameter] = STATE(139),
    [sym_typed_default_parameter] = STATE(139),
    [sym_list_splat] = STATE(140),
    [sym_dictionary_splat] = STATE(140),
    [sym_typed_parameter] = STATE(139),
    [sym_tuple] = STATE(139),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(3401),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [1322] = {
    [sym__expression] = STATE(249),
    [sym__primary_expression] = STATE(1324),
    [sym_not_operator] = STATE(249),
    [sym_boolean_operator] = STATE(249),
    [sym_binary_operator] = STATE(1324),
    [sym_unary_operator] = STATE(1324),
    [sym_comparison_operator] = STATE(249),
    [sym_lambda] = STATE(249),
    [sym_attribute] = STATE(1324),
    [sym_subscript] = STATE(1324),
    [sym_call] = STATE(1324),
    [sym_list] = STATE(1324),
    [sym_list_comprehension] = STATE(1324),
    [sym_dictionary] = STATE(1324),
    [sym_dictionary_comprehension] = STATE(1324),
    [sym_set] = STATE(1324),
    [sym_set_comprehension] = STATE(1324),
    [sym_parenthesized_expression] = STATE(1324),
    [sym_tuple] = STATE(1324),
    [sym_generator_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(249),
    [sym_concatenated_string] = STATE(1324),
    [sym_string] = STATE(1325),
    [sym_await] = STATE(249),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2702),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_lambda] = ACTIONS(2706),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2708),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2710),
    [sym_float] = ACTIONS(2710),
    [sym_identifier] = ACTIONS(2710),
    [sym_true] = ACTIONS(2710),
    [sym_false] = ACTIONS(2710),
    [sym_none] = ACTIONS(2710),
    [anon_sym_await] = ACTIONS(2712),
    [sym_comment] = ACTIONS(73),
  },
  [1323] = {
    [anon_sym_if] = ACTIONS(3055),
    [anon_sym_async] = ACTIONS(3055),
    [anon_sym_for] = ACTIONS(3055),
    [anon_sym_and] = ACTIONS(3403),
    [anon_sym_or] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(3055),
    [sym_comment] = ACTIONS(73),
  },
  [1324] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [aux_sym_comparison_operator_repeat1] = STATE(1625),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(3407),
    [anon_sym_GT_GT] = ACTIONS(3409),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(3411),
    [anon_sym_AT] = ACTIONS(3413),
    [anon_sym_not] = ACTIONS(3415),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_SLASH] = ACTIONS(3407),
    [anon_sym_PERCENT] = ACTIONS(3413),
    [anon_sym_SLASH_SLASH] = ACTIONS(3413),
    [anon_sym_STAR_STAR] = ACTIONS(3419),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3423),
    [anon_sym_CARET] = ACTIONS(3425),
    [anon_sym_LT_LT] = ACTIONS(3409),
    [anon_sym_LT] = ACTIONS(3427),
    [anon_sym_LT_EQ] = ACTIONS(3411),
    [anon_sym_EQ_EQ] = ACTIONS(3411),
    [anon_sym_BANG_EQ] = ACTIONS(3411),
    [anon_sym_GT_EQ] = ACTIONS(3411),
    [anon_sym_GT] = ACTIONS(3427),
    [anon_sym_LT_GT] = ACTIONS(3411),
    [anon_sym_is] = ACTIONS(3429),
    [anon_sym_LBRACK] = ACTIONS(473),
    [anon_sym_RBRACK] = ACTIONS(301),
    [sym_comment] = ACTIONS(73),
  },
  [1325] = {
    [sym_string] = STATE(1626),
    [aux_sym_concatenated_string_repeat1] = STATE(1626),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_async] = ACTIONS(333),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_RBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [1326] = {
    [sym_for_in_clause] = STATE(1326),
    [sym_if_clause] = STATE(1326),
    [aux_sym__comprehension_body_repeat1] = STATE(1326),
    [anon_sym_if] = ACTIONS(3431),
    [anon_sym_async] = ACTIONS(3434),
    [anon_sym_for] = ACTIONS(3437),
    [anon_sym_RBRACK] = ACTIONS(3085),
    [sym_comment] = ACTIONS(73),
  },
  [1327] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(2942),
    [anon_sym_STAR] = ACTIONS(795),
    [anon_sym_GT_GT] = ACTIONS(797),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_async] = ACTIONS(2942),
    [anon_sym_for] = ACTIONS(2942),
    [anon_sym_in] = ACTIONS(2942),
    [anon_sym_AT] = ACTIONS(801),
    [anon_sym_not] = ACTIONS(2942),
    [anon_sym_and] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(805),
    [anon_sym_DASH] = ACTIONS(805),
    [anon_sym_SLASH] = ACTIONS(795),
    [anon_sym_PERCENT] = ACTIONS(801),
    [anon_sym_SLASH_SLASH] = ACTIONS(801),
    [anon_sym_STAR_STAR] = ACTIONS(807),
    [anon_sym_PIPE] = ACTIONS(809),
    [anon_sym_AMP] = ACTIONS(811),
    [anon_sym_CARET] = ACTIONS(813),
    [anon_sym_LT_LT] = ACTIONS(797),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_LT_EQ] = ACTIONS(2942),
    [anon_sym_EQ_EQ] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_GT_EQ] = ACTIONS(2942),
    [anon_sym_GT] = ACTIONS(2944),
    [anon_sym_LT_GT] = ACTIONS(2942),
    [anon_sym_is] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(473),
    [anon_sym_RBRACK] = ACTIONS(2942),
    [sym_comment] = ACTIONS(73),
  },
  [1328] = {
    [anon_sym_COMMA] = ACTIONS(1660),
    [anon_sym_if] = ACTIONS(1766),
    [anon_sym_and] = ACTIONS(1768),
    [anon_sym_or] = ACTIONS(1770),
    [anon_sym_RBRACE] = ACTIONS(1660),
    [sym_comment] = ACTIONS(73),
  },
  [1329] = {
    [sym__expression] = STATE(1627),
    [sym__primary_expression] = STATE(485),
    [sym_not_operator] = STATE(1627),
    [sym_boolean_operator] = STATE(1627),
    [sym_binary_operator] = STATE(485),
    [sym_unary_operator] = STATE(485),
    [sym_comparison_operator] = STATE(1627),
    [sym_lambda] = STATE(1627),
    [sym_attribute] = STATE(485),
    [sym_subscript] = STATE(485),
    [sym_call] = STATE(485),
    [sym_list] = STATE(485),
    [sym_list_comprehension] = STATE(485),
    [sym_dictionary] = STATE(485),
    [sym_dictionary_comprehension] = STATE(485),
    [sym_set] = STATE(485),
    [sym_set_comprehension] = STATE(485),
    [sym_parenthesized_expression] = STATE(485),
    [sym_tuple] = STATE(485),
    [sym_generator_expression] = STATE(485),
    [sym_conditional_expression] = STATE(1627),
    [sym_concatenated_string] = STATE(485),
    [sym_string] = STATE(486),
    [sym_await] = STATE(1627),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(823),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_TILDE] = ACTIONS(825),
    [anon_sym_lambda] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(829),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(831),
    [sym_float] = ACTIONS(831),
    [sym_identifier] = ACTIONS(831),
    [sym_true] = ACTIONS(831),
    [sym_false] = ACTIONS(831),
    [sym_none] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [sym_comment] = ACTIONS(73),
  },
  [1330] = {
    [anon_sym_if] = ACTIONS(1925),
    [anon_sym_else] = ACTIONS(3440),
    [anon_sym_and] = ACTIONS(1929),
    [anon_sym_or] = ACTIONS(1931),
    [sym_comment] = ACTIONS(73),
  },
  [1331] = {
    [anon_sym_COMMA] = ACTIONS(1957),
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_and] = ACTIONS(1768),
    [anon_sym_or] = ACTIONS(1957),
    [anon_sym_RBRACE] = ACTIONS(1957),
    [sym_comment] = ACTIONS(73),
  },
  [1332] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1984),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1986),
    [anon_sym_PERCENT] = ACTIONS(1984),
    [anon_sym_SLASH_SLASH] = ACTIONS(1984),
    [anon_sym_STAR_STAR] = ACTIONS(1784),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1333] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1772),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_SLASH] = ACTIONS(1772),
    [anon_sym_PERCENT] = ACTIONS(1778),
    [anon_sym_SLASH_SLASH] = ACTIONS(1778),
    [anon_sym_STAR_STAR] = ACTIONS(1784),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1334] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1988),
    [anon_sym_STAR] = ACTIONS(1772),
    [anon_sym_GT_GT] = ACTIONS(1774),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(1988),
    [anon_sym_AT] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1988),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_PLUS] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_SLASH] = ACTIONS(1772),
    [anon_sym_PERCENT] = ACTIONS(1778),
    [anon_sym_SLASH_SLASH] = ACTIONS(1778),
    [anon_sym_STAR_STAR] = ACTIONS(1784),
    [anon_sym_PIPE] = ACTIONS(1786),
    [anon_sym_AMP] = ACTIONS(1788),
    [anon_sym_CARET] = ACTIONS(1790),
    [anon_sym_LT_LT] = ACTIONS(1774),
    [anon_sym_LT] = ACTIONS(1990),
    [anon_sym_LT_EQ] = ACTIONS(1988),
    [anon_sym_EQ_EQ] = ACTIONS(1988),
    [anon_sym_BANG_EQ] = ACTIONS(1988),
    [anon_sym_GT_EQ] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1990),
    [anon_sym_LT_GT] = ACTIONS(1988),
    [anon_sym_is] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(473),
    [anon_sym_RBRACE] = ACTIONS(1988),
    [sym_comment] = ACTIONS(73),
  },
  [1335] = {
    [sym__primary_expression] = STATE(1629),
    [sym_binary_operator] = STATE(1629),
    [sym_unary_operator] = STATE(1629),
    [sym_attribute] = STATE(1629),
    [sym_subscript] = STATE(1629),
    [sym_call] = STATE(1629),
    [sym_list] = STATE(1629),
    [sym_list_comprehension] = STATE(1629),
    [sym_dictionary] = STATE(1629),
    [sym_dictionary_comprehension] = STATE(1629),
    [sym_set] = STATE(1629),
    [sym_set_comprehension] = STATE(1629),
    [sym_parenthesized_expression] = STATE(1629),
    [sym_tuple] = STATE(1629),
    [sym_generator_expression] = STATE(1629),
    [sym_concatenated_string] = STATE(1629),
    [sym_string] = STATE(486),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_TILDE] = ACTIONS(825),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3442),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3444),
    [sym_float] = ACTIONS(3444),
    [sym_identifier] = ACTIONS(3444),
    [sym_true] = ACTIONS(3444),
    [sym_false] = ACTIONS(3444),
    [sym_none] = ACTIONS(3444),
    [sym_comment] = ACTIONS(73),
  },
  [1336] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1772),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1772),
    [anon_sym_PERCENT] = ACTIONS(1778),
    [anon_sym_SLASH_SLASH] = ACTIONS(1778),
    [anon_sym_STAR_STAR] = ACTIONS(1784),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1337] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1772),
    [anon_sym_GT_GT] = ACTIONS(1774),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_SLASH] = ACTIONS(1772),
    [anon_sym_PERCENT] = ACTIONS(1778),
    [anon_sym_SLASH_SLASH] = ACTIONS(1778),
    [anon_sym_STAR_STAR] = ACTIONS(1784),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1788),
    [anon_sym_CARET] = ACTIONS(1790),
    [anon_sym_LT_LT] = ACTIONS(1774),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1338] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1772),
    [anon_sym_GT_GT] = ACTIONS(1774),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_SLASH] = ACTIONS(1772),
    [anon_sym_PERCENT] = ACTIONS(1778),
    [anon_sym_SLASH_SLASH] = ACTIONS(1778),
    [anon_sym_STAR_STAR] = ACTIONS(1784),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1790),
    [anon_sym_LT_LT] = ACTIONS(1774),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1339] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1772),
    [anon_sym_GT_GT] = ACTIONS(1774),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_SLASH] = ACTIONS(1772),
    [anon_sym_PERCENT] = ACTIONS(1778),
    [anon_sym_SLASH_SLASH] = ACTIONS(1778),
    [anon_sym_STAR_STAR] = ACTIONS(1784),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1774),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1340] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1340),
    [anon_sym_COMMA] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(3446),
    [anon_sym_not] = ACTIONS(3449),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(3452),
    [anon_sym_LT_EQ] = ACTIONS(3446),
    [anon_sym_EQ_EQ] = ACTIONS(3446),
    [anon_sym_BANG_EQ] = ACTIONS(3446),
    [anon_sym_GT_EQ] = ACTIONS(3446),
    [anon_sym_GT] = ACTIONS(3452),
    [anon_sym_LT_GT] = ACTIONS(3446),
    [anon_sym_is] = ACTIONS(3455),
    [anon_sym_RBRACE] = ACTIONS(1988),
    [sym_comment] = ACTIONS(73),
  },
  [1341] = {
    [sym_string] = STATE(1341),
    [aux_sym_concatenated_string_repeat1] = STATE(1341),
    [sym__string_start] = ACTIONS(2241),
    [anon_sym_DOT] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(2050),
    [anon_sym_COMMA] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2050),
    [anon_sym_if] = ACTIONS(2050),
    [anon_sym_in] = ACTIONS(2050),
    [anon_sym_AT] = ACTIONS(2050),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_and] = ACTIONS(2050),
    [anon_sym_or] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_SLASH] = ACTIONS(2055),
    [anon_sym_PERCENT] = ACTIONS(2050),
    [anon_sym_SLASH_SLASH] = ACTIONS(2050),
    [anon_sym_STAR_STAR] = ACTIONS(2050),
    [anon_sym_PIPE] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2050),
    [anon_sym_CARET] = ACTIONS(2050),
    [anon_sym_LT_LT] = ACTIONS(2050),
    [anon_sym_LT] = ACTIONS(2055),
    [anon_sym_LT_EQ] = ACTIONS(2050),
    [anon_sym_EQ_EQ] = ACTIONS(2050),
    [anon_sym_BANG_EQ] = ACTIONS(2050),
    [anon_sym_GT_EQ] = ACTIONS(2050),
    [anon_sym_GT] = ACTIONS(2055),
    [anon_sym_LT_GT] = ACTIONS(2050),
    [anon_sym_is] = ACTIONS(2050),
    [anon_sym_LBRACK] = ACTIONS(2050),
    [anon_sym_RBRACE] = ACTIONS(2050),
    [sym_comment] = ACTIONS(73),
  },
  [1342] = {
    [anon_sym_COMMA] = ACTIONS(2647),
    [anon_sym_if] = ACTIONS(847),
    [anon_sym_COLON] = ACTIONS(2647),
    [anon_sym_async] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2647),
    [anon_sym_and] = ACTIONS(855),
    [anon_sym_or] = ACTIONS(857),
    [anon_sym_RBRACE] = ACTIONS(2647),
    [sym_comment] = ACTIONS(73),
  },
  [1343] = {
    [sym__newline] = ACTIONS(3458),
    [anon_sym_DOT] = ACTIONS(3458),
    [anon_sym_LPAREN] = ACTIONS(3458),
    [anon_sym_COMMA] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_GT_GT] = ACTIONS(3460),
    [anon_sym_if] = ACTIONS(3458),
    [anon_sym_COLON] = ACTIONS(3458),
    [anon_sym_in] = ACTIONS(3458),
    [anon_sym_EQ] = ACTIONS(3460),
    [anon_sym_AT] = ACTIONS(3460),
    [anon_sym_not] = ACTIONS(3458),
    [anon_sym_and] = ACTIONS(3458),
    [anon_sym_or] = ACTIONS(3458),
    [anon_sym_PLUS] = ACTIONS(3460),
    [anon_sym_DASH] = ACTIONS(3460),
    [anon_sym_SLASH] = ACTIONS(3460),
    [anon_sym_PERCENT] = ACTIONS(3460),
    [anon_sym_SLASH_SLASH] = ACTIONS(3460),
    [anon_sym_STAR_STAR] = ACTIONS(3460),
    [anon_sym_PIPE] = ACTIONS(3460),
    [anon_sym_AMP] = ACTIONS(3460),
    [anon_sym_CARET] = ACTIONS(3460),
    [anon_sym_LT_LT] = ACTIONS(3460),
    [anon_sym_LT] = ACTIONS(3460),
    [anon_sym_LT_EQ] = ACTIONS(3458),
    [anon_sym_EQ_EQ] = ACTIONS(3458),
    [anon_sym_BANG_EQ] = ACTIONS(3458),
    [anon_sym_GT_EQ] = ACTIONS(3458),
    [anon_sym_GT] = ACTIONS(3460),
    [anon_sym_LT_GT] = ACTIONS(3458),
    [anon_sym_is] = ACTIONS(3458),
    [anon_sym_PLUS_EQ] = ACTIONS(3458),
    [anon_sym_DASH_EQ] = ACTIONS(3458),
    [anon_sym_STAR_EQ] = ACTIONS(3458),
    [anon_sym_SLASH_EQ] = ACTIONS(3458),
    [anon_sym_AT_EQ] = ACTIONS(3458),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3458),
    [anon_sym_PERCENT_EQ] = ACTIONS(3458),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3458),
    [anon_sym_GT_GT_EQ] = ACTIONS(3458),
    [anon_sym_LT_LT_EQ] = ACTIONS(3458),
    [anon_sym_AMP_EQ] = ACTIONS(3458),
    [anon_sym_CARET_EQ] = ACTIONS(3458),
    [anon_sym_PIPE_EQ] = ACTIONS(3458),
    [anon_sym_LBRACK] = ACTIONS(3458),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3458),
  },
  [1344] = {
    [sym_list_splat] = STATE(914),
    [sym__expression] = STATE(958),
    [sym__primary_expression] = STATE(485),
    [sym_not_operator] = STATE(958),
    [sym_boolean_operator] = STATE(958),
    [sym_binary_operator] = STATE(485),
    [sym_unary_operator] = STATE(485),
    [sym_comparison_operator] = STATE(958),
    [sym_lambda] = STATE(958),
    [sym_attribute] = STATE(485),
    [sym_subscript] = STATE(485),
    [sym_call] = STATE(485),
    [sym_list] = STATE(485),
    [sym_list_comprehension] = STATE(485),
    [sym_dictionary] = STATE(485),
    [sym_dictionary_comprehension] = STATE(485),
    [sym_set] = STATE(485),
    [sym_set_comprehension] = STATE(485),
    [sym_parenthesized_expression] = STATE(485),
    [sym_tuple] = STATE(485),
    [sym_generator_expression] = STATE(485),
    [sym_conditional_expression] = STATE(958),
    [sym_concatenated_string] = STATE(485),
    [sym_string] = STATE(486),
    [sym_await] = STATE(958),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(1798),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(823),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_TILDE] = ACTIONS(825),
    [anon_sym_lambda] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(829),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(831),
    [sym_float] = ACTIONS(831),
    [sym_identifier] = ACTIONS(831),
    [sym_true] = ACTIONS(831),
    [sym_false] = ACTIONS(831),
    [sym_none] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [sym_comment] = ACTIONS(73),
  },
  [1345] = {
    [sym__expression] = STATE(1630),
    [sym__primary_expression] = STATE(485),
    [sym_not_operator] = STATE(1630),
    [sym_boolean_operator] = STATE(1630),
    [sym_binary_operator] = STATE(485),
    [sym_unary_operator] = STATE(485),
    [sym_comparison_operator] = STATE(1630),
    [sym_lambda] = STATE(1630),
    [sym_attribute] = STATE(485),
    [sym_subscript] = STATE(485),
    [sym_call] = STATE(485),
    [sym_list] = STATE(485),
    [sym_list_comprehension] = STATE(485),
    [sym_dictionary] = STATE(485),
    [sym_dictionary_comprehension] = STATE(485),
    [sym_set] = STATE(485),
    [sym_set_comprehension] = STATE(485),
    [sym_parenthesized_expression] = STATE(485),
    [sym_tuple] = STATE(485),
    [sym_generator_expression] = STATE(485),
    [sym_conditional_expression] = STATE(1630),
    [sym_concatenated_string] = STATE(485),
    [sym_string] = STATE(486),
    [sym_await] = STATE(1630),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(823),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_TILDE] = ACTIONS(825),
    [anon_sym_lambda] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(829),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(831),
    [sym_float] = ACTIONS(831),
    [sym_identifier] = ACTIONS(831),
    [sym_true] = ACTIONS(831),
    [sym_false] = ACTIONS(831),
    [sym_none] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [sym_comment] = ACTIONS(73),
  },
  [1346] = {
    [sym__newline] = ACTIONS(3462),
    [anon_sym_DOT] = ACTIONS(3462),
    [anon_sym_LPAREN] = ACTIONS(3462),
    [anon_sym_COMMA] = ACTIONS(3462),
    [anon_sym_STAR] = ACTIONS(3464),
    [anon_sym_GT_GT] = ACTIONS(3464),
    [anon_sym_if] = ACTIONS(3462),
    [anon_sym_COLON] = ACTIONS(3462),
    [anon_sym_in] = ACTIONS(3462),
    [anon_sym_EQ] = ACTIONS(3464),
    [anon_sym_AT] = ACTIONS(3464),
    [anon_sym_not] = ACTIONS(3462),
    [anon_sym_and] = ACTIONS(3462),
    [anon_sym_or] = ACTIONS(3462),
    [anon_sym_PLUS] = ACTIONS(3464),
    [anon_sym_DASH] = ACTIONS(3464),
    [anon_sym_SLASH] = ACTIONS(3464),
    [anon_sym_PERCENT] = ACTIONS(3464),
    [anon_sym_SLASH_SLASH] = ACTIONS(3464),
    [anon_sym_STAR_STAR] = ACTIONS(3464),
    [anon_sym_PIPE] = ACTIONS(3464),
    [anon_sym_AMP] = ACTIONS(3464),
    [anon_sym_CARET] = ACTIONS(3464),
    [anon_sym_LT_LT] = ACTIONS(3464),
    [anon_sym_LT] = ACTIONS(3464),
    [anon_sym_LT_EQ] = ACTIONS(3462),
    [anon_sym_EQ_EQ] = ACTIONS(3462),
    [anon_sym_BANG_EQ] = ACTIONS(3462),
    [anon_sym_GT_EQ] = ACTIONS(3462),
    [anon_sym_GT] = ACTIONS(3464),
    [anon_sym_LT_GT] = ACTIONS(3462),
    [anon_sym_is] = ACTIONS(3462),
    [anon_sym_PLUS_EQ] = ACTIONS(3462),
    [anon_sym_DASH_EQ] = ACTIONS(3462),
    [anon_sym_STAR_EQ] = ACTIONS(3462),
    [anon_sym_SLASH_EQ] = ACTIONS(3462),
    [anon_sym_AT_EQ] = ACTIONS(3462),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3462),
    [anon_sym_PERCENT_EQ] = ACTIONS(3462),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3462),
    [anon_sym_GT_GT_EQ] = ACTIONS(3462),
    [anon_sym_LT_LT_EQ] = ACTIONS(3462),
    [anon_sym_AMP_EQ] = ACTIONS(3462),
    [anon_sym_CARET_EQ] = ACTIONS(3462),
    [anon_sym_PIPE_EQ] = ACTIONS(3462),
    [anon_sym_LBRACK] = ACTIONS(3462),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3462),
  },
  [1347] = {
    [sym_dictionary_splat] = STATE(963),
    [sym__expression] = STATE(964),
    [sym__primary_expression] = STATE(102),
    [sym_not_operator] = STATE(964),
    [sym_boolean_operator] = STATE(964),
    [sym_binary_operator] = STATE(102),
    [sym_unary_operator] = STATE(102),
    [sym_comparison_operator] = STATE(964),
    [sym_lambda] = STATE(964),
    [sym_attribute] = STATE(102),
    [sym_subscript] = STATE(102),
    [sym_call] = STATE(102),
    [sym_list] = STATE(102),
    [sym_list_comprehension] = STATE(102),
    [sym_dictionary] = STATE(102),
    [sym_dictionary_comprehension] = STATE(102),
    [sym_pair] = STATE(963),
    [sym_set] = STATE(102),
    [sym_set_comprehension] = STATE(102),
    [sym_parenthesized_expression] = STATE(102),
    [sym_tuple] = STATE(102),
    [sym_generator_expression] = STATE(102),
    [sym_conditional_expression] = STATE(964),
    [sym_concatenated_string] = STATE(102),
    [sym_string] = STATE(103),
    [sym_await] = STATE(964),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(1808),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [1348] = {
    [sym__expression] = STATE(1631),
    [sym__primary_expression] = STATE(164),
    [sym_not_operator] = STATE(1631),
    [sym_boolean_operator] = STATE(1631),
    [sym_binary_operator] = STATE(164),
    [sym_unary_operator] = STATE(164),
    [sym_comparison_operator] = STATE(1631),
    [sym_lambda] = STATE(1631),
    [sym_attribute] = STATE(164),
    [sym_subscript] = STATE(164),
    [sym_call] = STATE(164),
    [sym_list] = STATE(164),
    [sym_list_comprehension] = STATE(164),
    [sym_dictionary] = STATE(164),
    [sym_dictionary_comprehension] = STATE(164),
    [sym_set] = STATE(164),
    [sym_set_comprehension] = STATE(164),
    [sym_parenthesized_expression] = STATE(164),
    [sym_tuple] = STATE(164),
    [sym_generator_expression] = STATE(164),
    [sym_conditional_expression] = STATE(1631),
    [sym_concatenated_string] = STATE(164),
    [sym_string] = STATE(166),
    [sym_await] = STATE(1631),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(263),
    [anon_sym_PLUS] = ACTIONS(265),
    [anon_sym_DASH] = ACTIONS(265),
    [anon_sym_TILDE] = ACTIONS(265),
    [anon_sym_lambda] = ACTIONS(267),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(269),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(273),
    [sym_float] = ACTIONS(273),
    [sym_identifier] = ACTIONS(273),
    [sym_true] = ACTIONS(273),
    [sym_false] = ACTIONS(273),
    [sym_none] = ACTIONS(273),
    [anon_sym_await] = ACTIONS(275),
    [sym_comment] = ACTIONS(73),
  },
  [1349] = {
    [anon_sym_COMMA] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(723),
    [anon_sym_async] = ACTIONS(723),
    [anon_sym_for] = ACTIONS(723),
    [anon_sym_and] = ACTIONS(2794),
    [anon_sym_or] = ACTIONS(2796),
    [anon_sym_RBRACE] = ACTIONS(723),
    [sym_comment] = ACTIONS(73),
  },
  [1350] = {
    [sym__expression] = STATE(1632),
    [sym__primary_expression] = STATE(973),
    [sym_not_operator] = STATE(1632),
    [sym_boolean_operator] = STATE(1632),
    [sym_binary_operator] = STATE(973),
    [sym_unary_operator] = STATE(973),
    [sym_comparison_operator] = STATE(1632),
    [sym_lambda] = STATE(1632),
    [sym_attribute] = STATE(973),
    [sym_subscript] = STATE(973),
    [sym_call] = STATE(973),
    [sym_list] = STATE(973),
    [sym_list_comprehension] = STATE(973),
    [sym_dictionary] = STATE(973),
    [sym_dictionary_comprehension] = STATE(973),
    [sym_set] = STATE(973),
    [sym_set_comprehension] = STATE(973),
    [sym_parenthesized_expression] = STATE(973),
    [sym_tuple] = STATE(973),
    [sym_generator_expression] = STATE(973),
    [sym_conditional_expression] = STATE(1632),
    [sym_concatenated_string] = STATE(973),
    [sym_string] = STATE(974),
    [sym_await] = STATE(1632),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1814),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_DASH] = ACTIONS(1816),
    [anon_sym_TILDE] = ACTIONS(1816),
    [anon_sym_lambda] = ACTIONS(1818),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1820),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1822),
    [sym_float] = ACTIONS(1822),
    [sym_identifier] = ACTIONS(1822),
    [sym_true] = ACTIONS(1822),
    [sym_false] = ACTIONS(1822),
    [sym_none] = ACTIONS(1822),
    [anon_sym_await] = ACTIONS(1824),
    [sym_comment] = ACTIONS(73),
  },
  [1351] = {
    [anon_sym_COLON] = ACTIONS(3466),
    [sym_comment] = ACTIONS(73),
  },
  [1352] = {
    [sym__expression] = STATE(1634),
    [sym__primary_expression] = STATE(538),
    [sym_not_operator] = STATE(1634),
    [sym_boolean_operator] = STATE(1634),
    [sym_binary_operator] = STATE(538),
    [sym_unary_operator] = STATE(538),
    [sym_comparison_operator] = STATE(1634),
    [sym_lambda] = STATE(1634),
    [sym_attribute] = STATE(538),
    [sym_subscript] = STATE(538),
    [sym_call] = STATE(538),
    [sym_list] = STATE(538),
    [sym_list_comprehension] = STATE(538),
    [sym_dictionary] = STATE(538),
    [sym_dictionary_comprehension] = STATE(538),
    [sym_set] = STATE(538),
    [sym_set_comprehension] = STATE(538),
    [sym_parenthesized_expression] = STATE(538),
    [sym_tuple] = STATE(538),
    [sym_generator_expression] = STATE(538),
    [sym_conditional_expression] = STATE(1634),
    [sym_concatenated_string] = STATE(538),
    [sym_string] = STATE(539),
    [sym_await] = STATE(1634),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_lambda] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(917),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(919),
    [sym_float] = ACTIONS(919),
    [sym_identifier] = ACTIONS(919),
    [sym_true] = ACTIONS(919),
    [sym_false] = ACTIONS(919),
    [sym_none] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(921),
    [sym_comment] = ACTIONS(73),
  },
  [1353] = {
    [sym__expression] = STATE(652),
    [sym__primary_expression] = STATE(973),
    [sym_not_operator] = STATE(652),
    [sym_boolean_operator] = STATE(652),
    [sym_binary_operator] = STATE(973),
    [sym_unary_operator] = STATE(973),
    [sym_comparison_operator] = STATE(652),
    [sym_lambda] = STATE(652),
    [sym_attribute] = STATE(973),
    [sym_subscript] = STATE(973),
    [sym_call] = STATE(973),
    [sym_list] = STATE(973),
    [sym_list_comprehension] = STATE(973),
    [sym_dictionary] = STATE(973),
    [sym_dictionary_comprehension] = STATE(973),
    [sym_set] = STATE(973),
    [sym_set_comprehension] = STATE(973),
    [sym_parenthesized_expression] = STATE(973),
    [sym_tuple] = STATE(973),
    [sym_generator_expression] = STATE(973),
    [sym_conditional_expression] = STATE(652),
    [sym_concatenated_string] = STATE(973),
    [sym_string] = STATE(974),
    [sym_await] = STATE(652),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1814),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_DASH] = ACTIONS(1816),
    [anon_sym_TILDE] = ACTIONS(1816),
    [anon_sym_lambda] = ACTIONS(1818),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1820),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1822),
    [sym_float] = ACTIONS(1822),
    [sym_identifier] = ACTIONS(1822),
    [sym_true] = ACTIONS(1822),
    [sym_false] = ACTIONS(1822),
    [sym_none] = ACTIONS(1822),
    [anon_sym_await] = ACTIONS(1824),
    [sym_comment] = ACTIONS(73),
  },
  [1354] = {
    [sym__expression] = STATE(1635),
    [sym__primary_expression] = STATE(973),
    [sym_not_operator] = STATE(1635),
    [sym_boolean_operator] = STATE(1635),
    [sym_binary_operator] = STATE(973),
    [sym_unary_operator] = STATE(973),
    [sym_comparison_operator] = STATE(1635),
    [sym_lambda] = STATE(1635),
    [sym_attribute] = STATE(973),
    [sym_subscript] = STATE(973),
    [sym_call] = STATE(973),
    [sym_list] = STATE(973),
    [sym_list_comprehension] = STATE(973),
    [sym_dictionary] = STATE(973),
    [sym_dictionary_comprehension] = STATE(973),
    [sym_set] = STATE(973),
    [sym_set_comprehension] = STATE(973),
    [sym_parenthesized_expression] = STATE(973),
    [sym_tuple] = STATE(973),
    [sym_generator_expression] = STATE(973),
    [sym_conditional_expression] = STATE(1635),
    [sym_concatenated_string] = STATE(973),
    [sym_string] = STATE(974),
    [sym_await] = STATE(1635),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1814),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_DASH] = ACTIONS(1816),
    [anon_sym_TILDE] = ACTIONS(1816),
    [anon_sym_lambda] = ACTIONS(1818),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1820),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1822),
    [sym_float] = ACTIONS(1822),
    [sym_identifier] = ACTIONS(1822),
    [sym_true] = ACTIONS(1822),
    [sym_false] = ACTIONS(1822),
    [sym_none] = ACTIONS(1822),
    [anon_sym_await] = ACTIONS(1824),
    [sym_comment] = ACTIONS(73),
  },
  [1355] = {
    [sym__primary_expression] = STATE(1636),
    [sym_binary_operator] = STATE(1636),
    [sym_unary_operator] = STATE(1636),
    [sym_attribute] = STATE(1636),
    [sym_subscript] = STATE(1636),
    [sym_call] = STATE(1636),
    [sym_list] = STATE(1636),
    [sym_list_comprehension] = STATE(1636),
    [sym_dictionary] = STATE(1636),
    [sym_dictionary_comprehension] = STATE(1636),
    [sym_set] = STATE(1636),
    [sym_set_comprehension] = STATE(1636),
    [sym_parenthesized_expression] = STATE(1636),
    [sym_tuple] = STATE(1636),
    [sym_generator_expression] = STATE(1636),
    [sym_concatenated_string] = STATE(1636),
    [sym_string] = STATE(974),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_DASH] = ACTIONS(1816),
    [anon_sym_TILDE] = ACTIONS(1816),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3468),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3470),
    [sym_float] = ACTIONS(3470),
    [sym_identifier] = ACTIONS(3470),
    [sym_true] = ACTIONS(3470),
    [sym_false] = ACTIONS(3470),
    [sym_none] = ACTIONS(3470),
    [sym_comment] = ACTIONS(73),
  },
  [1356] = {
    [sym__primary_expression] = STATE(1637),
    [sym_binary_operator] = STATE(1637),
    [sym_unary_operator] = STATE(1637),
    [sym_attribute] = STATE(1637),
    [sym_subscript] = STATE(1637),
    [sym_call] = STATE(1637),
    [sym_list] = STATE(1637),
    [sym_list_comprehension] = STATE(1637),
    [sym_dictionary] = STATE(1637),
    [sym_dictionary_comprehension] = STATE(1637),
    [sym_set] = STATE(1637),
    [sym_set_comprehension] = STATE(1637),
    [sym_parenthesized_expression] = STATE(1637),
    [sym_tuple] = STATE(1637),
    [sym_generator_expression] = STATE(1637),
    [sym_concatenated_string] = STATE(1637),
    [sym_string] = STATE(974),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_DASH] = ACTIONS(1816),
    [anon_sym_TILDE] = ACTIONS(1816),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3472),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3474),
    [sym_float] = ACTIONS(3474),
    [sym_identifier] = ACTIONS(3474),
    [sym_true] = ACTIONS(3474),
    [sym_false] = ACTIONS(3474),
    [sym_none] = ACTIONS(3474),
    [sym_comment] = ACTIONS(73),
  },
  [1357] = {
    [sym__primary_expression] = STATE(1638),
    [sym_binary_operator] = STATE(1638),
    [sym_unary_operator] = STATE(1638),
    [sym_attribute] = STATE(1638),
    [sym_subscript] = STATE(1638),
    [sym_call] = STATE(1638),
    [sym_list] = STATE(1638),
    [sym_list_comprehension] = STATE(1638),
    [sym_dictionary] = STATE(1638),
    [sym_dictionary_comprehension] = STATE(1638),
    [sym_set] = STATE(1638),
    [sym_set_comprehension] = STATE(1638),
    [sym_parenthesized_expression] = STATE(1638),
    [sym_tuple] = STATE(1638),
    [sym_generator_expression] = STATE(1638),
    [sym_concatenated_string] = STATE(1638),
    [sym_string] = STATE(974),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_DASH] = ACTIONS(1816),
    [anon_sym_TILDE] = ACTIONS(1816),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3476),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3478),
    [sym_float] = ACTIONS(3478),
    [sym_identifier] = ACTIONS(3478),
    [sym_true] = ACTIONS(3478),
    [sym_false] = ACTIONS(3478),
    [sym_none] = ACTIONS(3478),
    [sym_comment] = ACTIONS(73),
  },
  [1358] = {
    [anon_sym_in] = ACTIONS(3480),
    [sym_comment] = ACTIONS(73),
  },
  [1359] = {
    [sym__primary_expression] = STATE(1640),
    [sym_binary_operator] = STATE(1640),
    [sym_unary_operator] = STATE(1640),
    [sym_attribute] = STATE(1640),
    [sym_subscript] = STATE(1640),
    [sym_call] = STATE(1640),
    [sym_list] = STATE(1640),
    [sym_list_comprehension] = STATE(1640),
    [sym_dictionary] = STATE(1640),
    [sym_dictionary_comprehension] = STATE(1640),
    [sym_set] = STATE(1640),
    [sym_set_comprehension] = STATE(1640),
    [sym_parenthesized_expression] = STATE(1640),
    [sym_tuple] = STATE(1640),
    [sym_generator_expression] = STATE(1640),
    [sym_concatenated_string] = STATE(1640),
    [sym_string] = STATE(974),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_DASH] = ACTIONS(1816),
    [anon_sym_TILDE] = ACTIONS(1816),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3482),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3484),
    [sym_float] = ACTIONS(3484),
    [sym_identifier] = ACTIONS(3484),
    [sym_true] = ACTIONS(3484),
    [sym_false] = ACTIONS(3484),
    [sym_none] = ACTIONS(3484),
    [sym_comment] = ACTIONS(73),
  },
  [1360] = {
    [sym__primary_expression] = STATE(669),
    [sym_binary_operator] = STATE(669),
    [sym_unary_operator] = STATE(669),
    [sym_attribute] = STATE(669),
    [sym_subscript] = STATE(669),
    [sym_call] = STATE(669),
    [sym_list] = STATE(669),
    [sym_list_comprehension] = STATE(669),
    [sym_dictionary] = STATE(669),
    [sym_dictionary_comprehension] = STATE(669),
    [sym_set] = STATE(669),
    [sym_set_comprehension] = STATE(669),
    [sym_parenthesized_expression] = STATE(669),
    [sym_tuple] = STATE(669),
    [sym_generator_expression] = STATE(669),
    [sym_concatenated_string] = STATE(669),
    [sym_string] = STATE(974),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_DASH] = ACTIONS(1816),
    [anon_sym_TILDE] = ACTIONS(1816),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1282),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1284),
    [sym_float] = ACTIONS(1284),
    [sym_identifier] = ACTIONS(1284),
    [sym_true] = ACTIONS(1284),
    [sym_false] = ACTIONS(1284),
    [sym_none] = ACTIONS(1284),
    [sym_comment] = ACTIONS(73),
  },
  [1361] = {
    [sym__primary_expression] = STATE(1641),
    [sym_binary_operator] = STATE(1641),
    [sym_unary_operator] = STATE(1641),
    [sym_attribute] = STATE(1641),
    [sym_subscript] = STATE(1641),
    [sym_call] = STATE(1641),
    [sym_list] = STATE(1641),
    [sym_list_comprehension] = STATE(1641),
    [sym_dictionary] = STATE(1641),
    [sym_dictionary_comprehension] = STATE(1641),
    [sym_set] = STATE(1641),
    [sym_set_comprehension] = STATE(1641),
    [sym_parenthesized_expression] = STATE(1641),
    [sym_tuple] = STATE(1641),
    [sym_generator_expression] = STATE(1641),
    [sym_concatenated_string] = STATE(1641),
    [sym_string] = STATE(974),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_DASH] = ACTIONS(1816),
    [anon_sym_TILDE] = ACTIONS(1816),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3486),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3488),
    [sym_float] = ACTIONS(3488),
    [sym_identifier] = ACTIONS(3488),
    [sym_true] = ACTIONS(3488),
    [sym_false] = ACTIONS(3488),
    [sym_none] = ACTIONS(3488),
    [sym_comment] = ACTIONS(73),
  },
  [1362] = {
    [sym__primary_expression] = STATE(1642),
    [sym_binary_operator] = STATE(1642),
    [sym_unary_operator] = STATE(1642),
    [sym_attribute] = STATE(1642),
    [sym_subscript] = STATE(1642),
    [sym_call] = STATE(1642),
    [sym_list] = STATE(1642),
    [sym_list_comprehension] = STATE(1642),
    [sym_dictionary] = STATE(1642),
    [sym_dictionary_comprehension] = STATE(1642),
    [sym_set] = STATE(1642),
    [sym_set_comprehension] = STATE(1642),
    [sym_parenthesized_expression] = STATE(1642),
    [sym_tuple] = STATE(1642),
    [sym_generator_expression] = STATE(1642),
    [sym_concatenated_string] = STATE(1642),
    [sym_string] = STATE(974),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_DASH] = ACTIONS(1816),
    [anon_sym_TILDE] = ACTIONS(1816),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3490),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3492),
    [sym_float] = ACTIONS(3492),
    [sym_identifier] = ACTIONS(3492),
    [sym_true] = ACTIONS(3492),
    [sym_false] = ACTIONS(3492),
    [sym_none] = ACTIONS(3492),
    [sym_comment] = ACTIONS(73),
  },
  [1363] = {
    [sym__primary_expression] = STATE(1643),
    [sym_binary_operator] = STATE(1643),
    [sym_unary_operator] = STATE(1643),
    [sym_attribute] = STATE(1643),
    [sym_subscript] = STATE(1643),
    [sym_call] = STATE(1643),
    [sym_list] = STATE(1643),
    [sym_list_comprehension] = STATE(1643),
    [sym_dictionary] = STATE(1643),
    [sym_dictionary_comprehension] = STATE(1643),
    [sym_set] = STATE(1643),
    [sym_set_comprehension] = STATE(1643),
    [sym_parenthesized_expression] = STATE(1643),
    [sym_tuple] = STATE(1643),
    [sym_generator_expression] = STATE(1643),
    [sym_concatenated_string] = STATE(1643),
    [sym_string] = STATE(974),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_DASH] = ACTIONS(1816),
    [anon_sym_TILDE] = ACTIONS(1816),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3494),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3496),
    [sym_float] = ACTIONS(3496),
    [sym_identifier] = ACTIONS(3496),
    [sym_true] = ACTIONS(3496),
    [sym_false] = ACTIONS(3496),
    [sym_none] = ACTIONS(3496),
    [sym_comment] = ACTIONS(73),
  },
  [1364] = {
    [sym__primary_expression] = STATE(1638),
    [sym_binary_operator] = STATE(1638),
    [sym_unary_operator] = STATE(1638),
    [sym_attribute] = STATE(1638),
    [sym_subscript] = STATE(1638),
    [sym_call] = STATE(1638),
    [sym_list] = STATE(1638),
    [sym_list_comprehension] = STATE(1638),
    [sym_dictionary] = STATE(1638),
    [sym_dictionary_comprehension] = STATE(1638),
    [sym_set] = STATE(1638),
    [sym_set_comprehension] = STATE(1638),
    [sym_parenthesized_expression] = STATE(1638),
    [sym_tuple] = STATE(1638),
    [sym_generator_expression] = STATE(1638),
    [sym_concatenated_string] = STATE(1638),
    [sym_string] = STATE(974),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(3498),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_DASH] = ACTIONS(1816),
    [anon_sym_TILDE] = ACTIONS(1816),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3476),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3478),
    [sym_float] = ACTIONS(3478),
    [sym_identifier] = ACTIONS(3478),
    [sym_true] = ACTIONS(3478),
    [sym_false] = ACTIONS(3478),
    [sym_none] = ACTIONS(3478),
    [sym_comment] = ACTIONS(73),
  },
  [1365] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1644),
    [anon_sym_COMMA] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(991),
    [anon_sym_async] = ACTIONS(991),
    [anon_sym_for] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(2802),
    [anon_sym_not] = ACTIONS(2806),
    [anon_sym_and] = ACTIONS(991),
    [anon_sym_or] = ACTIONS(991),
    [anon_sym_LT] = ACTIONS(2818),
    [anon_sym_LT_EQ] = ACTIONS(2802),
    [anon_sym_EQ_EQ] = ACTIONS(2802),
    [anon_sym_BANG_EQ] = ACTIONS(2802),
    [anon_sym_GT_EQ] = ACTIONS(2802),
    [anon_sym_GT] = ACTIONS(2818),
    [anon_sym_LT_GT] = ACTIONS(2802),
    [anon_sym_is] = ACTIONS(2820),
    [anon_sym_RBRACE] = ACTIONS(991),
    [sym_comment] = ACTIONS(73),
  },
  [1366] = {
    [sym_string] = STATE(1645),
    [aux_sym_concatenated_string_repeat1] = STATE(1645),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_async] = ACTIONS(995),
    [anon_sym_for] = ACTIONS(995),
    [anon_sym_in] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(995),
    [anon_sym_not] = ACTIONS(995),
    [anon_sym_and] = ACTIONS(995),
    [anon_sym_or] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(995),
    [anon_sym_SLASH_SLASH] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_GT] = ACTIONS(995),
    [anon_sym_is] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(995),
    [anon_sym_RBRACE] = ACTIONS(995),
    [sym_comment] = ACTIONS(73),
  },
  [1367] = {
    [anon_sym_in] = ACTIONS(3500),
    [sym_comment] = ACTIONS(73),
  },
  [1368] = {
    [sym__expression_within_for_in_clause] = STATE(1648),
    [sym__expression] = STATE(1649),
    [sym__primary_expression] = STATE(973),
    [sym_not_operator] = STATE(1649),
    [sym_boolean_operator] = STATE(1649),
    [sym_binary_operator] = STATE(973),
    [sym_unary_operator] = STATE(973),
    [sym_comparison_operator] = STATE(1649),
    [sym_lambda] = STATE(1649),
    [sym_lambda_within_for_in_clause] = STATE(1648),
    [sym_attribute] = STATE(973),
    [sym_subscript] = STATE(973),
    [sym_call] = STATE(973),
    [sym_list] = STATE(973),
    [sym_list_comprehension] = STATE(973),
    [sym_dictionary] = STATE(973),
    [sym_dictionary_comprehension] = STATE(973),
    [sym_set] = STATE(973),
    [sym_set_comprehension] = STATE(973),
    [sym_parenthesized_expression] = STATE(973),
    [sym_tuple] = STATE(973),
    [sym_generator_expression] = STATE(973),
    [sym_conditional_expression] = STATE(1649),
    [sym_concatenated_string] = STATE(973),
    [sym_string] = STATE(974),
    [sym_await] = STATE(1649),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1814),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_DASH] = ACTIONS(1816),
    [anon_sym_TILDE] = ACTIONS(1816),
    [anon_sym_lambda] = ACTIONS(3502),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1820),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1822),
    [sym_float] = ACTIONS(1822),
    [sym_identifier] = ACTIONS(1822),
    [sym_true] = ACTIONS(1822),
    [sym_false] = ACTIONS(1822),
    [sym_none] = ACTIONS(1822),
    [anon_sym_await] = ACTIONS(1824),
    [sym_comment] = ACTIONS(73),
  },
  [1369] = {
    [sym__expression] = STATE(1650),
    [sym__primary_expression] = STATE(1374),
    [sym_not_operator] = STATE(1650),
    [sym_boolean_operator] = STATE(1650),
    [sym_binary_operator] = STATE(1374),
    [sym_unary_operator] = STATE(1374),
    [sym_comparison_operator] = STATE(1650),
    [sym_lambda] = STATE(1650),
    [sym_attribute] = STATE(1374),
    [sym_subscript] = STATE(1374),
    [sym_call] = STATE(1374),
    [sym_list] = STATE(1374),
    [sym_list_comprehension] = STATE(1374),
    [sym_dictionary] = STATE(1374),
    [sym_dictionary_comprehension] = STATE(1374),
    [sym_set] = STATE(1374),
    [sym_set_comprehension] = STATE(1374),
    [sym_parenthesized_expression] = STATE(1374),
    [sym_tuple] = STATE(1374),
    [sym_generator_expression] = STATE(1374),
    [sym_conditional_expression] = STATE(1650),
    [sym_concatenated_string] = STATE(1374),
    [sym_string] = STATE(1375),
    [sym_await] = STATE(1650),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2828),
    [anon_sym_PLUS] = ACTIONS(2830),
    [anon_sym_DASH] = ACTIONS(2830),
    [anon_sym_TILDE] = ACTIONS(2830),
    [anon_sym_lambda] = ACTIONS(2832),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2834),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2836),
    [sym_float] = ACTIONS(2836),
    [sym_identifier] = ACTIONS(2836),
    [sym_true] = ACTIONS(2836),
    [sym_false] = ACTIONS(2836),
    [sym_none] = ACTIONS(2836),
    [anon_sym_await] = ACTIONS(2838),
    [sym_comment] = ACTIONS(73),
  },
  [1370] = {
    [sym__primary_expression] = STATE(227),
    [sym_binary_operator] = STATE(227),
    [sym_unary_operator] = STATE(227),
    [sym_attribute] = STATE(227),
    [sym_subscript] = STATE(227),
    [sym_call] = STATE(227),
    [sym_list] = STATE(227),
    [sym_list_comprehension] = STATE(227),
    [sym_dictionary] = STATE(227),
    [sym_dictionary_comprehension] = STATE(227),
    [sym_set] = STATE(227),
    [sym_set_comprehension] = STATE(227),
    [sym_parenthesized_expression] = STATE(227),
    [sym_tuple] = STATE(227),
    [sym_generator_expression] = STATE(227),
    [sym_concatenated_string] = STATE(227),
    [sym_string] = STATE(1375),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2830),
    [anon_sym_DASH] = ACTIONS(2830),
    [anon_sym_TILDE] = ACTIONS(2830),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(403),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(405),
    [sym_float] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_true] = ACTIONS(405),
    [sym_false] = ACTIONS(405),
    [sym_none] = ACTIONS(405),
    [sym_comment] = ACTIONS(73),
  },
  [1371] = {
    [sym_lambda_parameters] = STATE(1652),
    [sym__parameters] = STATE(138),
    [sym_default_parameter] = STATE(139),
    [sym_typed_default_parameter] = STATE(139),
    [sym_list_splat] = STATE(140),
    [sym_dictionary_splat] = STATE(140),
    [sym_typed_parameter] = STATE(139),
    [sym_tuple] = STATE(139),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(3504),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [1372] = {
    [sym__expression] = STATE(249),
    [sym__primary_expression] = STATE(1374),
    [sym_not_operator] = STATE(249),
    [sym_boolean_operator] = STATE(249),
    [sym_binary_operator] = STATE(1374),
    [sym_unary_operator] = STATE(1374),
    [sym_comparison_operator] = STATE(249),
    [sym_lambda] = STATE(249),
    [sym_attribute] = STATE(1374),
    [sym_subscript] = STATE(1374),
    [sym_call] = STATE(1374),
    [sym_list] = STATE(1374),
    [sym_list_comprehension] = STATE(1374),
    [sym_dictionary] = STATE(1374),
    [sym_dictionary_comprehension] = STATE(1374),
    [sym_set] = STATE(1374),
    [sym_set_comprehension] = STATE(1374),
    [sym_parenthesized_expression] = STATE(1374),
    [sym_tuple] = STATE(1374),
    [sym_generator_expression] = STATE(1374),
    [sym_conditional_expression] = STATE(249),
    [sym_concatenated_string] = STATE(1374),
    [sym_string] = STATE(1375),
    [sym_await] = STATE(249),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2828),
    [anon_sym_PLUS] = ACTIONS(2830),
    [anon_sym_DASH] = ACTIONS(2830),
    [anon_sym_TILDE] = ACTIONS(2830),
    [anon_sym_lambda] = ACTIONS(2832),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2834),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2836),
    [sym_float] = ACTIONS(2836),
    [sym_identifier] = ACTIONS(2836),
    [sym_true] = ACTIONS(2836),
    [sym_false] = ACTIONS(2836),
    [sym_none] = ACTIONS(2836),
    [anon_sym_await] = ACTIONS(2838),
    [sym_comment] = ACTIONS(73),
  },
  [1373] = {
    [anon_sym_if] = ACTIONS(3055),
    [anon_sym_async] = ACTIONS(3055),
    [anon_sym_for] = ACTIONS(3055),
    [anon_sym_and] = ACTIONS(3506),
    [anon_sym_or] = ACTIONS(3508),
    [anon_sym_RBRACE] = ACTIONS(3055),
    [sym_comment] = ACTIONS(73),
  },
  [1374] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [aux_sym_comparison_operator_repeat1] = STATE(1666),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(3510),
    [anon_sym_GT_GT] = ACTIONS(3512),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_async] = ACTIONS(301),
    [anon_sym_for] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(3514),
    [anon_sym_AT] = ACTIONS(3516),
    [anon_sym_not] = ACTIONS(3518),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(3520),
    [anon_sym_DASH] = ACTIONS(3520),
    [anon_sym_SLASH] = ACTIONS(3510),
    [anon_sym_PERCENT] = ACTIONS(3516),
    [anon_sym_SLASH_SLASH] = ACTIONS(3516),
    [anon_sym_STAR_STAR] = ACTIONS(3522),
    [anon_sym_PIPE] = ACTIONS(3524),
    [anon_sym_AMP] = ACTIONS(3526),
    [anon_sym_CARET] = ACTIONS(3528),
    [anon_sym_LT_LT] = ACTIONS(3512),
    [anon_sym_LT] = ACTIONS(3530),
    [anon_sym_LT_EQ] = ACTIONS(3514),
    [anon_sym_EQ_EQ] = ACTIONS(3514),
    [anon_sym_BANG_EQ] = ACTIONS(3514),
    [anon_sym_GT_EQ] = ACTIONS(3514),
    [anon_sym_GT] = ACTIONS(3530),
    [anon_sym_LT_GT] = ACTIONS(3514),
    [anon_sym_is] = ACTIONS(3532),
    [anon_sym_LBRACK] = ACTIONS(473),
    [anon_sym_RBRACE] = ACTIONS(301),
    [sym_comment] = ACTIONS(73),
  },
  [1375] = {
    [sym_string] = STATE(1667),
    [aux_sym_concatenated_string_repeat1] = STATE(1667),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_async] = ACTIONS(333),
    [anon_sym_for] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [anon_sym_RBRACE] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [1376] = {
    [sym_for_in_clause] = STATE(1376),
    [sym_if_clause] = STATE(1376),
    [aux_sym__comprehension_body_repeat1] = STATE(1376),
    [anon_sym_if] = ACTIONS(3534),
    [anon_sym_async] = ACTIONS(3537),
    [anon_sym_for] = ACTIONS(3540),
    [anon_sym_RBRACE] = ACTIONS(3085),
    [sym_comment] = ACTIONS(73),
  },
  [1377] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(2942),
    [anon_sym_STAR] = ACTIONS(859),
    [anon_sym_GT_GT] = ACTIONS(861),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_COLON] = ACTIONS(2942),
    [anon_sym_async] = ACTIONS(2942),
    [anon_sym_for] = ACTIONS(2942),
    [anon_sym_in] = ACTIONS(2942),
    [anon_sym_AT] = ACTIONS(865),
    [anon_sym_not] = ACTIONS(2942),
    [anon_sym_and] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(869),
    [anon_sym_DASH] = ACTIONS(869),
    [anon_sym_SLASH] = ACTIONS(859),
    [anon_sym_PERCENT] = ACTIONS(865),
    [anon_sym_SLASH_SLASH] = ACTIONS(865),
    [anon_sym_STAR_STAR] = ACTIONS(871),
    [anon_sym_PIPE] = ACTIONS(873),
    [anon_sym_AMP] = ACTIONS(875),
    [anon_sym_CARET] = ACTIONS(877),
    [anon_sym_LT_LT] = ACTIONS(861),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_LT_EQ] = ACTIONS(2942),
    [anon_sym_EQ_EQ] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_GT_EQ] = ACTIONS(2942),
    [anon_sym_GT] = ACTIONS(2944),
    [anon_sym_LT_GT] = ACTIONS(2942),
    [anon_sym_is] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(473),
    [anon_sym_RBRACE] = ACTIONS(2942),
    [sym_comment] = ACTIONS(73),
  },
  [1378] = {
    [sym__newline] = ACTIONS(1660),
    [anon_sym_if] = ACTIONS(1881),
    [anon_sym_EQ] = ACTIONS(1660),
    [anon_sym_and] = ACTIONS(1883),
    [anon_sym_or] = ACTIONS(1885),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1660),
  },
  [1379] = {
    [sym__expression] = STATE(1668),
    [sym__primary_expression] = STATE(525),
    [sym_not_operator] = STATE(1668),
    [sym_boolean_operator] = STATE(1668),
    [sym_binary_operator] = STATE(525),
    [sym_unary_operator] = STATE(525),
    [sym_comparison_operator] = STATE(1668),
    [sym_lambda] = STATE(1668),
    [sym_attribute] = STATE(525),
    [sym_subscript] = STATE(525),
    [sym_call] = STATE(525),
    [sym_list] = STATE(525),
    [sym_list_comprehension] = STATE(525),
    [sym_dictionary] = STATE(525),
    [sym_dictionary_comprehension] = STATE(525),
    [sym_set] = STATE(525),
    [sym_set_comprehension] = STATE(525),
    [sym_parenthesized_expression] = STATE(525),
    [sym_tuple] = STATE(525),
    [sym_generator_expression] = STATE(525),
    [sym_conditional_expression] = STATE(1668),
    [sym_concatenated_string] = STATE(525),
    [sym_string] = STATE(527),
    [sym_await] = STATE(1668),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(893),
    [anon_sym_PLUS] = ACTIONS(895),
    [anon_sym_DASH] = ACTIONS(895),
    [anon_sym_TILDE] = ACTIONS(895),
    [anon_sym_lambda] = ACTIONS(897),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(901),
    [sym_float] = ACTIONS(901),
    [sym_identifier] = ACTIONS(901),
    [sym_true] = ACTIONS(901),
    [sym_false] = ACTIONS(901),
    [sym_none] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(903),
    [sym_comment] = ACTIONS(73),
  },
  [1380] = {
    [anon_sym_if] = ACTIONS(1925),
    [anon_sym_else] = ACTIONS(3543),
    [anon_sym_and] = ACTIONS(1929),
    [anon_sym_or] = ACTIONS(1931),
    [sym_comment] = ACTIONS(73),
  },
  [1381] = {
    [sym__newline] = ACTIONS(1957),
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_EQ] = ACTIONS(1957),
    [anon_sym_and] = ACTIONS(1883),
    [anon_sym_or] = ACTIONS(1957),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1957),
  },
  [1382] = {
    [sym_argument_list] = STATE(315),
    [sym_generator_expression] = STATE(315),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(1984),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1986),
    [anon_sym_PERCENT] = ACTIONS(1984),
    [anon_sym_SLASH_SLASH] = ACTIONS(1984),
    [anon_sym_STAR_STAR] = ACTIONS(1899),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1984),
  },
  [1383] = {
    [sym_argument_list] = STATE(315),
    [sym_generator_expression] = STATE(315),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_STAR] = ACTIONS(1887),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(1893),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(1887),
    [anon_sym_PERCENT] = ACTIONS(1893),
    [anon_sym_SLASH_SLASH] = ACTIONS(1893),
    [anon_sym_STAR_STAR] = ACTIONS(1899),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1984),
  },
  [1384] = {
    [sym_argument_list] = STATE(315),
    [sym_generator_expression] = STATE(315),
    [sym__newline] = ACTIONS(1988),
    [anon_sym_DOT] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_STAR] = ACTIONS(1887),
    [anon_sym_GT_GT] = ACTIONS(1889),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(1988),
    [anon_sym_EQ] = ACTIONS(1990),
    [anon_sym_AT] = ACTIONS(1893),
    [anon_sym_not] = ACTIONS(1988),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(1887),
    [anon_sym_PERCENT] = ACTIONS(1893),
    [anon_sym_SLASH_SLASH] = ACTIONS(1893),
    [anon_sym_STAR_STAR] = ACTIONS(1899),
    [anon_sym_PIPE] = ACTIONS(1901),
    [anon_sym_AMP] = ACTIONS(1903),
    [anon_sym_CARET] = ACTIONS(1905),
    [anon_sym_LT_LT] = ACTIONS(1889),
    [anon_sym_LT] = ACTIONS(1990),
    [anon_sym_LT_EQ] = ACTIONS(1988),
    [anon_sym_EQ_EQ] = ACTIONS(1988),
    [anon_sym_BANG_EQ] = ACTIONS(1988),
    [anon_sym_GT_EQ] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1990),
    [anon_sym_LT_GT] = ACTIONS(1988),
    [anon_sym_is] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(535),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1988),
  },
  [1385] = {
    [sym__primary_expression] = STATE(1670),
    [sym_binary_operator] = STATE(1670),
    [sym_unary_operator] = STATE(1670),
    [sym_attribute] = STATE(1670),
    [sym_subscript] = STATE(1670),
    [sym_call] = STATE(1670),
    [sym_list] = STATE(1670),
    [sym_list_comprehension] = STATE(1670),
    [sym_dictionary] = STATE(1670),
    [sym_dictionary_comprehension] = STATE(1670),
    [sym_set] = STATE(1670),
    [sym_set_comprehension] = STATE(1670),
    [sym_parenthesized_expression] = STATE(1670),
    [sym_tuple] = STATE(1670),
    [sym_generator_expression] = STATE(1670),
    [sym_concatenated_string] = STATE(1670),
    [sym_string] = STATE(527),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_PLUS] = ACTIONS(895),
    [anon_sym_DASH] = ACTIONS(895),
    [anon_sym_TILDE] = ACTIONS(895),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(3545),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(3547),
    [sym_float] = ACTIONS(3547),
    [sym_identifier] = ACTIONS(3547),
    [sym_true] = ACTIONS(3547),
    [sym_false] = ACTIONS(3547),
    [sym_none] = ACTIONS(3547),
    [sym_comment] = ACTIONS(73),
  },
  [1386] = {
    [sym_argument_list] = STATE(315),
    [sym_generator_expression] = STATE(315),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_STAR] = ACTIONS(1887),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(1893),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1887),
    [anon_sym_PERCENT] = ACTIONS(1893),
    [anon_sym_SLASH_SLASH] = ACTIONS(1893),
    [anon_sym_STAR_STAR] = ACTIONS(1899),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1984),
  },
  [1387] = {
    [sym_argument_list] = STATE(315),
    [sym_generator_expression] = STATE(315),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_STAR] = ACTIONS(1887),
    [anon_sym_GT_GT] = ACTIONS(1889),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(1893),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(1887),
    [anon_sym_PERCENT] = ACTIONS(1893),
    [anon_sym_SLASH_SLASH] = ACTIONS(1893),
    [anon_sym_STAR_STAR] = ACTIONS(1899),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1903),
    [anon_sym_CARET] = ACTIONS(1905),
    [anon_sym_LT_LT] = ACTIONS(1889),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1984),
  },
  [1388] = {
    [sym_argument_list] = STATE(315),
    [sym_generator_expression] = STATE(315),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_STAR] = ACTIONS(1887),
    [anon_sym_GT_GT] = ACTIONS(1889),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(1893),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(1887),
    [anon_sym_PERCENT] = ACTIONS(1893),
    [anon_sym_SLASH_SLASH] = ACTIONS(1893),
    [anon_sym_STAR_STAR] = ACTIONS(1899),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1905),
    [anon_sym_LT_LT] = ACTIONS(1889),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1984),
  },
  [1389] = {
    [sym_argument_list] = STATE(315),
    [sym_generator_expression] = STATE(315),
    [sym__newline] = ACTIONS(1984),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_STAR] = ACTIONS(1887),
    [anon_sym_GT_GT] = ACTIONS(1889),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(1893),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(1887),
    [anon_sym_PERCENT] = ACTIONS(1893),
    [anon_sym_SLASH_SLASH] = ACTIONS(1893),
    [anon_sym_STAR_STAR] = ACTIONS(1899),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1889),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1984),
  },
  [1390] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1390),
    [sym__newline] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(3549),
    [anon_sym_EQ] = ACTIONS(1990),
    [anon_sym_not] = ACTIONS(3552),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(3555),
    [anon_sym_LT_EQ] = ACTIONS(3549),
    [anon_sym_EQ_EQ] = ACTIONS(3549),
    [anon_sym_BANG_EQ] = ACTIONS(3549),
    [anon_sym_GT_EQ] = ACTIONS(3549),
    [anon_sym_GT] = ACTIONS(3555),
    [anon_sym_LT_GT] = ACTIONS(3549),
    [anon_sym_is] = ACTIONS(3558),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1988),
  },
  [1391] = {
    [sym__newline] = ACTIONS(3561),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3561),
  },
  [1392] = {
    [sym_string] = STATE(1392),
    [aux_sym_concatenated_string_repeat1] = STATE(1392),
    [sym__newline] = ACTIONS(2050),
    [sym__string_start] = ACTIONS(2299),
    [anon_sym_DOT] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2050),
    [anon_sym_if] = ACTIONS(2050),
    [anon_sym_in] = ACTIONS(2050),
    [anon_sym_EQ] = ACTIONS(2055),
    [anon_sym_AT] = ACTIONS(2050),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_and] = ACTIONS(2050),
    [anon_sym_or] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_SLASH] = ACTIONS(2055),
    [anon_sym_PERCENT] = ACTIONS(2050),
    [anon_sym_SLASH_SLASH] = ACTIONS(2050),
    [anon_sym_STAR_STAR] = ACTIONS(2050),
    [anon_sym_PIPE] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2050),
    [anon_sym_CARET] = ACTIONS(2050),
    [anon_sym_LT_LT] = ACTIONS(2050),
    [anon_sym_LT] = ACTIONS(2055),
    [anon_sym_LT_EQ] = ACTIONS(2050),
    [anon_sym_EQ_EQ] = ACTIONS(2050),
    [anon_sym_BANG_EQ] = ACTIONS(2050),
    [anon_sym_GT_EQ] = ACTIONS(2050),
    [anon_sym_GT] = ACTIONS(2055),
    [anon_sym_LT_GT] = ACTIONS(2050),
    [anon_sym_is] = ACTIONS(2050),
    [anon_sym_LBRACK] = ACTIONS(2050),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2050),
  },
  [1393] = {
    [sym__expression] = STATE(532),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(532),
    [sym_boolean_operator] = STATE(532),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(532),
    [sym_lambda] = STATE(532),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(532),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(532),
    [sym__newline] = ACTIONS(1961),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(221),
    [anon_sym_COLON] = ACTIONS(1961),
    [anon_sym_EQ] = ACTIONS(1961),
    [anon_sym_exec] = ACTIONS(221),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(909),
    [anon_sym_DASH] = ACTIONS(909),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_PLUS_EQ] = ACTIONS(1961),
    [anon_sym_DASH_EQ] = ACTIONS(1961),
    [anon_sym_STAR_EQ] = ACTIONS(1961),
    [anon_sym_SLASH_EQ] = ACTIONS(1961),
    [anon_sym_AT_EQ] = ACTIONS(1961),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(1961),
    [anon_sym_PERCENT_EQ] = ACTIONS(1961),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(1961),
    [anon_sym_GT_GT_EQ] = ACTIONS(1961),
    [anon_sym_LT_LT_EQ] = ACTIONS(1961),
    [anon_sym_AMP_EQ] = ACTIONS(1961),
    [anon_sym_CARET_EQ] = ACTIONS(1961),
    [anon_sym_PIPE_EQ] = ACTIONS(1961),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(1961),
  },
  [1394] = {
    [anon_sym_if] = ACTIONS(1925),
    [anon_sym_else] = ACTIONS(1660),
    [anon_sym_and] = ACTIONS(1929),
    [anon_sym_or] = ACTIONS(1931),
    [sym_comment] = ACTIONS(73),
  },
  [1395] = {
    [sym__expression] = STATE(1671),
    [sym__primary_expression] = STATE(538),
    [sym_not_operator] = STATE(1671),
    [sym_boolean_operator] = STATE(1671),
    [sym_binary_operator] = STATE(538),
    [sym_unary_operator] = STATE(538),
    [sym_comparison_operator] = STATE(1671),
    [sym_lambda] = STATE(1671),
    [sym_attribute] = STATE(538),
    [sym_subscript] = STATE(538),
    [sym_call] = STATE(538),
    [sym_list] = STATE(538),
    [sym_list_comprehension] = STATE(538),
    [sym_dictionary] = STATE(538),
    [sym_dictionary_comprehension] = STATE(538),
    [sym_set] = STATE(538),
    [sym_set_comprehension] = STATE(538),
    [sym_parenthesized_expression] = STATE(538),
    [sym_tuple] = STATE(538),
    [sym_generator_expression] = STATE(538),
    [sym_conditional_expression] = STATE(1671),
    [sym_concatenated_string] = STATE(538),
    [sym_string] = STATE(539),
    [sym_await] = STATE(1671),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_lambda] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(917),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(919),
    [sym_float] = ACTIONS(919),
    [sym_identifier] = ACTIONS(919),
    [sym_true] = ACTIONS(919),
    [sym_false] = ACTIONS(919),
    [sym_none] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(921),
    [sym_comment] = ACTIONS(73),
  },
  [1396] = {
    [anon_sym_if] = ACTIONS(1925),
    [anon_sym_else] = ACTIONS(3563),
    [anon_sym_and] = ACTIONS(1929),
    [anon_sym_or] = ACTIONS(1931),
    [sym_comment] = ACTIONS(73),
  },
  [1397] = {
    [sym__newline] = ACTIONS(3565),
    [anon_sym_COMMA] = ACTIONS(3565),
    [anon_sym_if] = ACTIONS(293),
    [anon_sym_COLON] = ACTIONS(3565),
    [anon_sym_EQ] = ACTIONS(3565),
    [anon_sym_and] = ACTIONS(297),
    [anon_sym_or] = ACTIONS(299),
    [anon_sym_PLUS_EQ] = ACTIONS(3565),
    [anon_sym_DASH_EQ] = ACTIONS(3565),
    [anon_sym_STAR_EQ] = ACTIONS(3565),
    [anon_sym_SLASH_EQ] = ACTIONS(3565),
    [anon_sym_AT_EQ] = ACTIONS(3565),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3565),
    [anon_sym_PERCENT_EQ] = ACTIONS(3565),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3565),
    [anon_sym_GT_GT_EQ] = ACTIONS(3565),
    [anon_sym_LT_LT_EQ] = ACTIONS(3565),
    [anon_sym_AMP_EQ] = ACTIONS(3565),
    [anon_sym_CARET_EQ] = ACTIONS(3565),
    [anon_sym_PIPE_EQ] = ACTIONS(3565),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3565),
  },
  [1398] = {
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_else] = ACTIONS(1957),
    [anon_sym_and] = ACTIONS(1929),
    [anon_sym_or] = ACTIONS(1957),
    [sym_comment] = ACTIONS(73),
  },
  [1399] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_else] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1984),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1986),
    [anon_sym_PERCENT] = ACTIONS(1984),
    [anon_sym_SLASH_SLASH] = ACTIONS(1984),
    [anon_sym_STAR_STAR] = ACTIONS(1945),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1400] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(1933),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_else] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1939),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1943),
    [anon_sym_SLASH] = ACTIONS(1933),
    [anon_sym_PERCENT] = ACTIONS(1939),
    [anon_sym_SLASH_SLASH] = ACTIONS(1939),
    [anon_sym_STAR_STAR] = ACTIONS(1945),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1401] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(1933),
    [anon_sym_GT_GT] = ACTIONS(1935),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_else] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(1988),
    [anon_sym_AT] = ACTIONS(1939),
    [anon_sym_not] = ACTIONS(1988),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_PLUS] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1943),
    [anon_sym_SLASH] = ACTIONS(1933),
    [anon_sym_PERCENT] = ACTIONS(1939),
    [anon_sym_SLASH_SLASH] = ACTIONS(1939),
    [anon_sym_STAR_STAR] = ACTIONS(1945),
    [anon_sym_PIPE] = ACTIONS(1947),
    [anon_sym_AMP] = ACTIONS(1949),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_LT_LT] = ACTIONS(1935),
    [anon_sym_LT] = ACTIONS(1990),
    [anon_sym_LT_EQ] = ACTIONS(1988),
    [anon_sym_EQ_EQ] = ACTIONS(1988),
    [anon_sym_BANG_EQ] = ACTIONS(1988),
    [anon_sym_GT_EQ] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1990),
    [anon_sym_LT_GT] = ACTIONS(1988),
    [anon_sym_is] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(473),
    [sym_comment] = ACTIONS(73),
  },
  [1402] = {
    [sym__primary_expression] = STATE(1673),
    [sym_binary_operator] = STATE(1673),
    [sym_unary_operator] = STATE(1673),
    [sym_attribute] = STATE(1673),
    [sym_subscript] = STATE(1673),
    [sym_call] = STATE(1673),
    [sym_list] = STATE(1673),
    [sym_list_comprehension] = STATE(1673),
    [sym_dictionary] = STATE(1673),
    [sym_dictionary_comprehension] = STATE(1673),
    [sym_set] = STATE(1673),
    [sym_set_comprehension] = STATE(1673),
    [sym_parenthesized_expression] = STATE(1673),
    [sym_tuple] = STATE(1673),
    [sym_generator_expression] = STATE(1673),
    [sym_concatenated_string] = STATE(1673),
    [sym_string] = STATE(539),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3567),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3569),
    [sym_float] = ACTIONS(3569),
    [sym_identifier] = ACTIONS(3569),
    [sym_true] = ACTIONS(3569),
    [sym_false] = ACTIONS(3569),
    [sym_none] = ACTIONS(3569),
    [sym_comment] = ACTIONS(73),
  },
  [1403] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(1933),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_else] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1939),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1933),
    [anon_sym_PERCENT] = ACTIONS(1939),
    [anon_sym_SLASH_SLASH] = ACTIONS(1939),
    [anon_sym_STAR_STAR] = ACTIONS(1945),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1404] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(1933),
    [anon_sym_GT_GT] = ACTIONS(1935),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_else] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1939),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1943),
    [anon_sym_SLASH] = ACTIONS(1933),
    [anon_sym_PERCENT] = ACTIONS(1939),
    [anon_sym_SLASH_SLASH] = ACTIONS(1939),
    [anon_sym_STAR_STAR] = ACTIONS(1945),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1949),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_LT_LT] = ACTIONS(1935),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1405] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(1933),
    [anon_sym_GT_GT] = ACTIONS(1935),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_else] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1939),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1943),
    [anon_sym_SLASH] = ACTIONS(1933),
    [anon_sym_PERCENT] = ACTIONS(1939),
    [anon_sym_SLASH_SLASH] = ACTIONS(1939),
    [anon_sym_STAR_STAR] = ACTIONS(1945),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_LT_LT] = ACTIONS(1935),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1406] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(1933),
    [anon_sym_GT_GT] = ACTIONS(1935),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_else] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1939),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1943),
    [anon_sym_SLASH] = ACTIONS(1933),
    [anon_sym_PERCENT] = ACTIONS(1939),
    [anon_sym_SLASH_SLASH] = ACTIONS(1939),
    [anon_sym_STAR_STAR] = ACTIONS(1945),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1935),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1407] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1407),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_else] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(3571),
    [anon_sym_not] = ACTIONS(3574),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(3577),
    [anon_sym_LT_EQ] = ACTIONS(3571),
    [anon_sym_EQ_EQ] = ACTIONS(3571),
    [anon_sym_BANG_EQ] = ACTIONS(3571),
    [anon_sym_GT_EQ] = ACTIONS(3571),
    [anon_sym_GT] = ACTIONS(3577),
    [anon_sym_LT_GT] = ACTIONS(3571),
    [anon_sym_is] = ACTIONS(3580),
    [sym_comment] = ACTIONS(73),
  },
  [1408] = {
    [sym_string] = STATE(1408),
    [aux_sym_concatenated_string_repeat1] = STATE(1408),
    [sym__string_start] = ACTIONS(2241),
    [anon_sym_DOT] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2050),
    [anon_sym_if] = ACTIONS(2050),
    [anon_sym_else] = ACTIONS(2050),
    [anon_sym_in] = ACTIONS(2050),
    [anon_sym_AT] = ACTIONS(2050),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_and] = ACTIONS(2050),
    [anon_sym_or] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_SLASH] = ACTIONS(2055),
    [anon_sym_PERCENT] = ACTIONS(2050),
    [anon_sym_SLASH_SLASH] = ACTIONS(2050),
    [anon_sym_STAR_STAR] = ACTIONS(2050),
    [anon_sym_PIPE] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2050),
    [anon_sym_CARET] = ACTIONS(2050),
    [anon_sym_LT_LT] = ACTIONS(2050),
    [anon_sym_LT] = ACTIONS(2055),
    [anon_sym_LT_EQ] = ACTIONS(2050),
    [anon_sym_EQ_EQ] = ACTIONS(2050),
    [anon_sym_BANG_EQ] = ACTIONS(2050),
    [anon_sym_GT_EQ] = ACTIONS(2050),
    [anon_sym_GT] = ACTIONS(2055),
    [anon_sym_LT_GT] = ACTIONS(2050),
    [anon_sym_is] = ACTIONS(2050),
    [anon_sym_LBRACK] = ACTIONS(2050),
    [sym_comment] = ACTIONS(73),
  },
  [1409] = {
    [anon_sym_RPAREN] = ACTIONS(2526),
    [anon_sym_COMMA] = ACTIONS(2526),
    [anon_sym_if] = ACTIONS(1198),
    [anon_sym_and] = ACTIONS(1200),
    [anon_sym_or] = ACTIONS(1202),
    [sym_comment] = ACTIONS(73),
  },
  [1410] = {
    [anon_sym_RPAREN] = ACTIONS(3583),
    [anon_sym_COMMA] = ACTIONS(3583),
    [anon_sym_if] = ACTIONS(1198),
    [anon_sym_and] = ACTIONS(1200),
    [anon_sym_or] = ACTIONS(1202),
    [sym_comment] = ACTIONS(73),
  },
  [1411] = {
    [anon_sym_RPAREN] = ACTIONS(3585),
    [anon_sym_COMMA] = ACTIONS(3585),
    [anon_sym_if] = ACTIONS(1198),
    [anon_sym_and] = ACTIONS(1200),
    [anon_sym_or] = ACTIONS(1202),
    [sym_comment] = ACTIONS(73),
  },
  [1412] = {
    [sym__newline] = ACTIONS(3587),
    [anon_sym_DOT] = ACTIONS(3587),
    [anon_sym_LPAREN] = ACTIONS(3587),
    [anon_sym_COMMA] = ACTIONS(3587),
    [anon_sym_STAR] = ACTIONS(3589),
    [anon_sym_GT_GT] = ACTIONS(3589),
    [anon_sym_if] = ACTIONS(3587),
    [anon_sym_COLON] = ACTIONS(3587),
    [anon_sym_in] = ACTIONS(3587),
    [anon_sym_EQ] = ACTIONS(3589),
    [anon_sym_AT] = ACTIONS(3589),
    [anon_sym_not] = ACTIONS(3587),
    [anon_sym_and] = ACTIONS(3587),
    [anon_sym_or] = ACTIONS(3587),
    [anon_sym_PLUS] = ACTIONS(3589),
    [anon_sym_DASH] = ACTIONS(3589),
    [anon_sym_SLASH] = ACTIONS(3589),
    [anon_sym_PERCENT] = ACTIONS(3589),
    [anon_sym_SLASH_SLASH] = ACTIONS(3589),
    [anon_sym_STAR_STAR] = ACTIONS(3589),
    [anon_sym_PIPE] = ACTIONS(3589),
    [anon_sym_AMP] = ACTIONS(3589),
    [anon_sym_CARET] = ACTIONS(3589),
    [anon_sym_LT_LT] = ACTIONS(3589),
    [anon_sym_LT] = ACTIONS(3589),
    [anon_sym_LT_EQ] = ACTIONS(3587),
    [anon_sym_EQ_EQ] = ACTIONS(3587),
    [anon_sym_BANG_EQ] = ACTIONS(3587),
    [anon_sym_GT_EQ] = ACTIONS(3587),
    [anon_sym_GT] = ACTIONS(3589),
    [anon_sym_LT_GT] = ACTIONS(3587),
    [anon_sym_is] = ACTIONS(3587),
    [anon_sym_PLUS_EQ] = ACTIONS(3587),
    [anon_sym_DASH_EQ] = ACTIONS(3587),
    [anon_sym_STAR_EQ] = ACTIONS(3587),
    [anon_sym_SLASH_EQ] = ACTIONS(3587),
    [anon_sym_AT_EQ] = ACTIONS(3587),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3587),
    [anon_sym_PERCENT_EQ] = ACTIONS(3587),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3587),
    [anon_sym_GT_GT_EQ] = ACTIONS(3587),
    [anon_sym_LT_LT_EQ] = ACTIONS(3587),
    [anon_sym_AMP_EQ] = ACTIONS(3587),
    [anon_sym_CARET_EQ] = ACTIONS(3587),
    [anon_sym_PIPE_EQ] = ACTIONS(3587),
    [anon_sym_LBRACK] = ACTIONS(3587),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3587),
  },
  [1413] = {
    [anon_sym_RPAREN] = ACTIONS(3591),
    [anon_sym_COMMA] = ACTIONS(3591),
    [sym_comment] = ACTIONS(73),
  },
  [1414] = {
    [anon_sym_RPAREN] = ACTIONS(3591),
    [anon_sym_COMMA] = ACTIONS(3591),
    [anon_sym_if] = ACTIONS(1198),
    [anon_sym_and] = ACTIONS(1200),
    [anon_sym_or] = ACTIONS(1202),
    [sym_comment] = ACTIONS(73),
  },
  [1415] = {
    [sym_list_splat] = STATE(1413),
    [sym_dictionary_splat] = STATE(1413),
    [sym__expression] = STATE(1414),
    [sym__primary_expression] = STATE(237),
    [sym_not_operator] = STATE(1414),
    [sym_boolean_operator] = STATE(1414),
    [sym_binary_operator] = STATE(237),
    [sym_unary_operator] = STATE(237),
    [sym_comparison_operator] = STATE(1414),
    [sym_lambda] = STATE(1414),
    [sym_attribute] = STATE(237),
    [sym_subscript] = STATE(237),
    [sym_call] = STATE(237),
    [sym_keyword_argument] = STATE(1413),
    [sym_list] = STATE(237),
    [sym_list_comprehension] = STATE(237),
    [sym_dictionary] = STATE(237),
    [sym_dictionary_comprehension] = STATE(237),
    [sym_set] = STATE(237),
    [sym_set_comprehension] = STATE(237),
    [sym_parenthesized_expression] = STATE(237),
    [sym_tuple] = STATE(237),
    [sym_generator_expression] = STATE(237),
    [sym_conditional_expression] = STATE(1414),
    [sym_concatenated_string] = STATE(237),
    [sym_string] = STATE(238),
    [sym_await] = STATE(1414),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3593),
    [anon_sym_STAR] = ACTIONS(931),
    [anon_sym_print] = ACTIONS(933),
    [anon_sym_exec] = ACTIONS(933),
    [anon_sym_not] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_lambda] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(419),
    [sym_float] = ACTIONS(419),
    [sym_identifier] = ACTIONS(935),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_none] = ACTIONS(419),
    [anon_sym_await] = ACTIONS(421),
    [sym_comment] = ACTIONS(73),
  },
  [1416] = {
    [aux_sym_argument_list_repeat1] = STATE(1416),
    [anon_sym_RPAREN] = ACTIONS(3591),
    [anon_sym_COMMA] = ACTIONS(3595),
    [sym_comment] = ACTIONS(73),
  },
  [1417] = {
    [anon_sym_COMMA] = ACTIONS(3598),
    [anon_sym_if] = ACTIONS(1686),
    [anon_sym_and] = ACTIONS(1688),
    [anon_sym_or] = ACTIONS(1690),
    [anon_sym_RBRACK] = ACTIONS(3598),
    [sym_comment] = ACTIONS(73),
  },
  [1418] = {
    [sym__expression] = STATE(1676),
    [sym__primary_expression] = STATE(452),
    [sym_not_operator] = STATE(1676),
    [sym_boolean_operator] = STATE(1676),
    [sym_binary_operator] = STATE(452),
    [sym_unary_operator] = STATE(452),
    [sym_comparison_operator] = STATE(1676),
    [sym_lambda] = STATE(1676),
    [sym_attribute] = STATE(452),
    [sym_subscript] = STATE(452),
    [sym_call] = STATE(452),
    [sym_list] = STATE(452),
    [sym_list_comprehension] = STATE(452),
    [sym_dictionary] = STATE(452),
    [sym_dictionary_comprehension] = STATE(452),
    [sym_set] = STATE(452),
    [sym_set_comprehension] = STATE(452),
    [sym_parenthesized_expression] = STATE(452),
    [sym_tuple] = STATE(452),
    [sym_generator_expression] = STATE(452),
    [sym_conditional_expression] = STATE(1676),
    [sym_concatenated_string] = STATE(452),
    [sym_string] = STATE(453),
    [sym_await] = STATE(1676),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_COMMA] = ACTIONS(3598),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_lambda] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(3598),
    [sym_ellipsis] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(773),
    [sym_float] = ACTIONS(773),
    [sym_identifier] = ACTIONS(773),
    [sym_true] = ACTIONS(773),
    [sym_false] = ACTIONS(773),
    [sym_none] = ACTIONS(773),
    [anon_sym_await] = ACTIONS(775),
    [sym_comment] = ACTIONS(73),
  },
  [1419] = {
    [anon_sym_COMMA] = ACTIONS(1660),
    [anon_sym_if] = ACTIONS(2004),
    [anon_sym_COLON] = ACTIONS(1660),
    [anon_sym_and] = ACTIONS(2008),
    [anon_sym_or] = ACTIONS(2010),
    [anon_sym_RBRACK] = ACTIONS(1660),
    [sym_comment] = ACTIONS(73),
  },
  [1420] = {
    [sym__expression] = STATE(1677),
    [sym__primary_expression] = STATE(567),
    [sym_not_operator] = STATE(1677),
    [sym_boolean_operator] = STATE(1677),
    [sym_binary_operator] = STATE(567),
    [sym_unary_operator] = STATE(567),
    [sym_comparison_operator] = STATE(1677),
    [sym_lambda] = STATE(1677),
    [sym_attribute] = STATE(567),
    [sym_subscript] = STATE(567),
    [sym_call] = STATE(567),
    [sym_list] = STATE(567),
    [sym_list_comprehension] = STATE(567),
    [sym_dictionary] = STATE(567),
    [sym_dictionary_comprehension] = STATE(567),
    [sym_set] = STATE(567),
    [sym_set_comprehension] = STATE(567),
    [sym_parenthesized_expression] = STATE(567),
    [sym_tuple] = STATE(567),
    [sym_generator_expression] = STATE(567),
    [sym_conditional_expression] = STATE(1677),
    [sym_concatenated_string] = STATE(567),
    [sym_string] = STATE(569),
    [sym_await] = STATE(1677),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(975),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(977),
    [anon_sym_lambda] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(981),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(983),
    [sym_float] = ACTIONS(983),
    [sym_identifier] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_none] = ACTIONS(983),
    [anon_sym_await] = ACTIONS(985),
    [sym_comment] = ACTIONS(73),
  },
  [1421] = {
    [sym__newline] = ACTIONS(3600),
    [anon_sym_DOT] = ACTIONS(3600),
    [anon_sym_LPAREN] = ACTIONS(3600),
    [anon_sym_COMMA] = ACTIONS(3600),
    [anon_sym_STAR] = ACTIONS(3602),
    [anon_sym_GT_GT] = ACTIONS(3602),
    [anon_sym_if] = ACTIONS(3600),
    [anon_sym_COLON] = ACTIONS(3600),
    [anon_sym_in] = ACTIONS(3600),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_AT] = ACTIONS(3602),
    [anon_sym_not] = ACTIONS(3600),
    [anon_sym_and] = ACTIONS(3600),
    [anon_sym_or] = ACTIONS(3600),
    [anon_sym_PLUS] = ACTIONS(3602),
    [anon_sym_DASH] = ACTIONS(3602),
    [anon_sym_SLASH] = ACTIONS(3602),
    [anon_sym_PERCENT] = ACTIONS(3602),
    [anon_sym_SLASH_SLASH] = ACTIONS(3602),
    [anon_sym_STAR_STAR] = ACTIONS(3602),
    [anon_sym_PIPE] = ACTIONS(3602),
    [anon_sym_AMP] = ACTIONS(3602),
    [anon_sym_CARET] = ACTIONS(3602),
    [anon_sym_LT_LT] = ACTIONS(3602),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_LT_EQ] = ACTIONS(3600),
    [anon_sym_EQ_EQ] = ACTIONS(3600),
    [anon_sym_BANG_EQ] = ACTIONS(3600),
    [anon_sym_GT_EQ] = ACTIONS(3600),
    [anon_sym_GT] = ACTIONS(3602),
    [anon_sym_LT_GT] = ACTIONS(3600),
    [anon_sym_is] = ACTIONS(3600),
    [anon_sym_PLUS_EQ] = ACTIONS(3600),
    [anon_sym_DASH_EQ] = ACTIONS(3600),
    [anon_sym_STAR_EQ] = ACTIONS(3600),
    [anon_sym_SLASH_EQ] = ACTIONS(3600),
    [anon_sym_AT_EQ] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3600),
    [anon_sym_PERCENT_EQ] = ACTIONS(3600),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3600),
    [anon_sym_GT_GT_EQ] = ACTIONS(3600),
    [anon_sym_LT_LT_EQ] = ACTIONS(3600),
    [anon_sym_AMP_EQ] = ACTIONS(3600),
    [anon_sym_CARET_EQ] = ACTIONS(3600),
    [anon_sym_PIPE_EQ] = ACTIONS(3600),
    [anon_sym_LBRACK] = ACTIONS(3600),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3600),
  },
  [1422] = {
    [anon_sym_COMMA] = ACTIONS(3604),
    [anon_sym_if] = ACTIONS(2004),
    [anon_sym_COLON] = ACTIONS(2006),
    [anon_sym_and] = ACTIONS(2008),
    [anon_sym_or] = ACTIONS(2010),
    [anon_sym_RBRACK] = ACTIONS(3604),
    [sym_comment] = ACTIONS(73),
  },
  [1423] = {
    [anon_sym_COMMA] = ACTIONS(3604),
    [anon_sym_RBRACK] = ACTIONS(3604),
    [sym_comment] = ACTIONS(73),
  },
  [1424] = {
    [anon_sym_if] = ACTIONS(1925),
    [anon_sym_else] = ACTIONS(3606),
    [anon_sym_and] = ACTIONS(1929),
    [anon_sym_or] = ACTIONS(1931),
    [sym_comment] = ACTIONS(73),
  },
  [1425] = {
    [anon_sym_COMMA] = ACTIONS(3598),
    [anon_sym_if] = ACTIONS(2004),
    [anon_sym_COLON] = ACTIONS(3608),
    [anon_sym_and] = ACTIONS(2008),
    [anon_sym_or] = ACTIONS(2010),
    [anon_sym_RBRACK] = ACTIONS(3598),
    [sym_comment] = ACTIONS(73),
  },
  [1426] = {
    [anon_sym_COMMA] = ACTIONS(1957),
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_COLON] = ACTIONS(1957),
    [anon_sym_and] = ACTIONS(2008),
    [anon_sym_or] = ACTIONS(1957),
    [anon_sym_RBRACK] = ACTIONS(1957),
    [sym_comment] = ACTIONS(73),
  },
  [1427] = {
    [sym__expression] = STATE(1422),
    [sym__primary_expression] = STATE(567),
    [sym_not_operator] = STATE(1422),
    [sym_boolean_operator] = STATE(1422),
    [sym_binary_operator] = STATE(567),
    [sym_unary_operator] = STATE(567),
    [sym_comparison_operator] = STATE(1422),
    [sym_lambda] = STATE(1422),
    [sym_attribute] = STATE(567),
    [sym_subscript] = STATE(567),
    [sym_slice] = STATE(1423),
    [sym_call] = STATE(567),
    [sym_list] = STATE(567),
    [sym_list_comprehension] = STATE(567),
    [sym_dictionary] = STATE(567),
    [sym_dictionary_comprehension] = STATE(567),
    [sym_set] = STATE(567),
    [sym_set_comprehension] = STATE(567),
    [sym_parenthesized_expression] = STATE(567),
    [sym_tuple] = STATE(567),
    [sym_generator_expression] = STATE(567),
    [sym_conditional_expression] = STATE(1422),
    [sym_concatenated_string] = STATE(567),
    [sym_string] = STATE(569),
    [sym_await] = STATE(1422),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(973),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(975),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(977),
    [anon_sym_lambda] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(3610),
    [sym_ellipsis] = ACTIONS(981),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(983),
    [sym_float] = ACTIONS(983),
    [sym_identifier] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_none] = ACTIONS(983),
    [anon_sym_await] = ACTIONS(985),
    [sym_comment] = ACTIONS(73),
  },
  [1428] = {
    [aux_sym_subscript_repeat1] = STATE(1428),
    [anon_sym_COMMA] = ACTIONS(3612),
    [anon_sym_RBRACK] = ACTIONS(3604),
    [sym_comment] = ACTIONS(73),
  },
  [1429] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1984),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1986),
    [anon_sym_PERCENT] = ACTIONS(1984),
    [anon_sym_SLASH_SLASH] = ACTIONS(1984),
    [anon_sym_STAR_STAR] = ACTIONS(2026),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1430] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(2014),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(2020),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(2024),
    [anon_sym_DASH] = ACTIONS(2024),
    [anon_sym_SLASH] = ACTIONS(2014),
    [anon_sym_PERCENT] = ACTIONS(2020),
    [anon_sym_SLASH_SLASH] = ACTIONS(2020),
    [anon_sym_STAR_STAR] = ACTIONS(2026),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1431] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1988),
    [anon_sym_STAR] = ACTIONS(2014),
    [anon_sym_GT_GT] = ACTIONS(2016),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_COLON] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(1988),
    [anon_sym_AT] = ACTIONS(2020),
    [anon_sym_not] = ACTIONS(1988),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_PLUS] = ACTIONS(2024),
    [anon_sym_DASH] = ACTIONS(2024),
    [anon_sym_SLASH] = ACTIONS(2014),
    [anon_sym_PERCENT] = ACTIONS(2020),
    [anon_sym_SLASH_SLASH] = ACTIONS(2020),
    [anon_sym_STAR_STAR] = ACTIONS(2026),
    [anon_sym_PIPE] = ACTIONS(2028),
    [anon_sym_AMP] = ACTIONS(2030),
    [anon_sym_CARET] = ACTIONS(2032),
    [anon_sym_LT_LT] = ACTIONS(2016),
    [anon_sym_LT] = ACTIONS(1990),
    [anon_sym_LT_EQ] = ACTIONS(1988),
    [anon_sym_EQ_EQ] = ACTIONS(1988),
    [anon_sym_BANG_EQ] = ACTIONS(1988),
    [anon_sym_GT_EQ] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1990),
    [anon_sym_LT_GT] = ACTIONS(1988),
    [anon_sym_is] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(473),
    [anon_sym_RBRACK] = ACTIONS(1988),
    [sym_comment] = ACTIONS(73),
  },
  [1432] = {
    [sym__primary_expression] = STATE(1682),
    [sym_binary_operator] = STATE(1682),
    [sym_unary_operator] = STATE(1682),
    [sym_attribute] = STATE(1682),
    [sym_subscript] = STATE(1682),
    [sym_call] = STATE(1682),
    [sym_list] = STATE(1682),
    [sym_list_comprehension] = STATE(1682),
    [sym_dictionary] = STATE(1682),
    [sym_dictionary_comprehension] = STATE(1682),
    [sym_set] = STATE(1682),
    [sym_set_comprehension] = STATE(1682),
    [sym_parenthesized_expression] = STATE(1682),
    [sym_tuple] = STATE(1682),
    [sym_generator_expression] = STATE(1682),
    [sym_concatenated_string] = STATE(1682),
    [sym_string] = STATE(569),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(977),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3615),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3617),
    [sym_float] = ACTIONS(3617),
    [sym_identifier] = ACTIONS(3617),
    [sym_true] = ACTIONS(3617),
    [sym_false] = ACTIONS(3617),
    [sym_none] = ACTIONS(3617),
    [sym_comment] = ACTIONS(73),
  },
  [1433] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(2014),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(2020),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(2014),
    [anon_sym_PERCENT] = ACTIONS(2020),
    [anon_sym_SLASH_SLASH] = ACTIONS(2020),
    [anon_sym_STAR_STAR] = ACTIONS(2026),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1434] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(2014),
    [anon_sym_GT_GT] = ACTIONS(2016),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(2020),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(2024),
    [anon_sym_DASH] = ACTIONS(2024),
    [anon_sym_SLASH] = ACTIONS(2014),
    [anon_sym_PERCENT] = ACTIONS(2020),
    [anon_sym_SLASH_SLASH] = ACTIONS(2020),
    [anon_sym_STAR_STAR] = ACTIONS(2026),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(2030),
    [anon_sym_CARET] = ACTIONS(2032),
    [anon_sym_LT_LT] = ACTIONS(2016),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1435] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(2014),
    [anon_sym_GT_GT] = ACTIONS(2016),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(2020),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(2024),
    [anon_sym_DASH] = ACTIONS(2024),
    [anon_sym_SLASH] = ACTIONS(2014),
    [anon_sym_PERCENT] = ACTIONS(2020),
    [anon_sym_SLASH_SLASH] = ACTIONS(2020),
    [anon_sym_STAR_STAR] = ACTIONS(2026),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(2032),
    [anon_sym_LT_LT] = ACTIONS(2016),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1436] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(2014),
    [anon_sym_GT_GT] = ACTIONS(2016),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(2020),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(2024),
    [anon_sym_DASH] = ACTIONS(2024),
    [anon_sym_SLASH] = ACTIONS(2014),
    [anon_sym_PERCENT] = ACTIONS(2020),
    [anon_sym_SLASH_SLASH] = ACTIONS(2020),
    [anon_sym_STAR_STAR] = ACTIONS(2026),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(2016),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1437] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1437),
    [anon_sym_COMMA] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_COLON] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(3619),
    [anon_sym_not] = ACTIONS(3622),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(3625),
    [anon_sym_LT_EQ] = ACTIONS(3619),
    [anon_sym_EQ_EQ] = ACTIONS(3619),
    [anon_sym_BANG_EQ] = ACTIONS(3619),
    [anon_sym_GT_EQ] = ACTIONS(3619),
    [anon_sym_GT] = ACTIONS(3625),
    [anon_sym_LT_GT] = ACTIONS(3619),
    [anon_sym_is] = ACTIONS(3628),
    [anon_sym_RBRACK] = ACTIONS(1988),
    [sym_comment] = ACTIONS(73),
  },
  [1438] = {
    [sym_string] = STATE(1438),
    [aux_sym_concatenated_string_repeat1] = STATE(1438),
    [sym__string_start] = ACTIONS(2241),
    [anon_sym_DOT] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(2050),
    [anon_sym_COMMA] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2050),
    [anon_sym_if] = ACTIONS(2050),
    [anon_sym_COLON] = ACTIONS(2050),
    [anon_sym_in] = ACTIONS(2050),
    [anon_sym_AT] = ACTIONS(2050),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_and] = ACTIONS(2050),
    [anon_sym_or] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_SLASH] = ACTIONS(2055),
    [anon_sym_PERCENT] = ACTIONS(2050),
    [anon_sym_SLASH_SLASH] = ACTIONS(2050),
    [anon_sym_STAR_STAR] = ACTIONS(2050),
    [anon_sym_PIPE] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2050),
    [anon_sym_CARET] = ACTIONS(2050),
    [anon_sym_LT_LT] = ACTIONS(2050),
    [anon_sym_LT] = ACTIONS(2055),
    [anon_sym_LT_EQ] = ACTIONS(2050),
    [anon_sym_EQ_EQ] = ACTIONS(2050),
    [anon_sym_BANG_EQ] = ACTIONS(2050),
    [anon_sym_GT_EQ] = ACTIONS(2050),
    [anon_sym_GT] = ACTIONS(2055),
    [anon_sym_LT_GT] = ACTIONS(2050),
    [anon_sym_is] = ACTIONS(2050),
    [anon_sym_LBRACK] = ACTIONS(2050),
    [anon_sym_RBRACK] = ACTIONS(2050),
    [sym_comment] = ACTIONS(73),
  },
  [1439] = {
    [anon_sym_if] = ACTIONS(1111),
    [anon_sym_and] = ACTIONS(1113),
    [anon_sym_or] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(2647),
    [sym_type_conversion] = ACTIONS(2647),
    [sym_comment] = ACTIONS(73),
  },
  [1440] = {
    [sym__expression] = STATE(1683),
    [sym__primary_expression] = STATE(204),
    [sym_not_operator] = STATE(1683),
    [sym_boolean_operator] = STATE(1683),
    [sym_binary_operator] = STATE(204),
    [sym_unary_operator] = STATE(204),
    [sym_comparison_operator] = STATE(1683),
    [sym_lambda] = STATE(1683),
    [sym_attribute] = STATE(204),
    [sym_subscript] = STATE(204),
    [sym_call] = STATE(204),
    [sym_list] = STATE(204),
    [sym_list_comprehension] = STATE(204),
    [sym_dictionary] = STATE(204),
    [sym_dictionary_comprehension] = STATE(204),
    [sym_set] = STATE(204),
    [sym_set_comprehension] = STATE(204),
    [sym_parenthesized_expression] = STATE(204),
    [sym_tuple] = STATE(204),
    [sym_generator_expression] = STATE(204),
    [sym_conditional_expression] = STATE(1683),
    [sym_concatenated_string] = STATE(204),
    [sym_string] = STATE(205),
    [sym_await] = STATE(1683),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(349),
    [anon_sym_PLUS] = ACTIONS(351),
    [anon_sym_DASH] = ACTIONS(351),
    [anon_sym_TILDE] = ACTIONS(351),
    [anon_sym_lambda] = ACTIONS(353),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(355),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(357),
    [sym_float] = ACTIONS(357),
    [sym_identifier] = ACTIONS(357),
    [sym_true] = ACTIONS(357),
    [sym_false] = ACTIONS(357),
    [sym_none] = ACTIONS(357),
    [anon_sym_await] = ACTIONS(359),
    [sym_comment] = ACTIONS(73),
  },
  [1441] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(1121),
    [anon_sym_GT_GT] = ACTIONS(1123),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_in] = ACTIONS(2942),
    [anon_sym_AT] = ACTIONS(1127),
    [anon_sym_not] = ACTIONS(2942),
    [anon_sym_and] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(1131),
    [anon_sym_DASH] = ACTIONS(1131),
    [anon_sym_SLASH] = ACTIONS(1121),
    [anon_sym_PERCENT] = ACTIONS(1127),
    [anon_sym_SLASH_SLASH] = ACTIONS(1127),
    [anon_sym_STAR_STAR] = ACTIONS(1133),
    [anon_sym_PIPE] = ACTIONS(1135),
    [anon_sym_AMP] = ACTIONS(1137),
    [anon_sym_CARET] = ACTIONS(1139),
    [anon_sym_LT_LT] = ACTIONS(1123),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_LT_EQ] = ACTIONS(2942),
    [anon_sym_EQ_EQ] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_GT_EQ] = ACTIONS(2942),
    [anon_sym_GT] = ACTIONS(2944),
    [anon_sym_LT_GT] = ACTIONS(2942),
    [anon_sym_is] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(473),
    [anon_sym_RBRACE] = ACTIONS(2942),
    [sym_type_conversion] = ACTIONS(2942),
    [sym_comment] = ACTIONS(73),
  },
  [1442] = {
    [aux_sym_dotted_name_repeat1] = STATE(1684),
    [anon_sym_DOT] = ACTIONS(379),
    [anon_sym_RPAREN] = ACTIONS(1159),
    [anon_sym_COMMA] = ACTIONS(1159),
    [anon_sym_as] = ACTIONS(1159),
    [sym_comment] = ACTIONS(73),
  },
  [1443] = {
    [sym__newline] = ACTIONS(3631),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3631),
  },
  [1444] = {
    [sym_aliased_import] = STATE(1685),
    [sym_dotted_name] = STATE(1686),
    [anon_sym_RPAREN] = ACTIONS(1161),
    [sym_identifier] = ACTIONS(2116),
    [sym_comment] = ACTIONS(73),
  },
  [1445] = {
    [aux_sym__import_list_repeat1] = STATE(1688),
    [anon_sym_RPAREN] = ACTIONS(1161),
    [anon_sym_COMMA] = ACTIONS(3633),
    [sym_comment] = ACTIONS(73),
  },
  [1446] = {
    [sym_identifier] = ACTIONS(3635),
    [sym_comment] = ACTIONS(73),
  },
  [1447] = {
    [anon_sym_DOT] = ACTIONS(3096),
    [anon_sym_LPAREN] = ACTIONS(3096),
    [anon_sym_RPAREN] = ACTIONS(3096),
    [anon_sym_COMMA] = ACTIONS(3096),
    [anon_sym_as] = ACTIONS(3098),
    [anon_sym_STAR] = ACTIONS(3098),
    [anon_sym_GT_GT] = ACTIONS(3096),
    [anon_sym_if] = ACTIONS(3096),
    [anon_sym_COLON] = ACTIONS(3096),
    [anon_sym_else] = ACTIONS(3096),
    [anon_sym_async] = ACTIONS(3096),
    [anon_sym_for] = ACTIONS(3096),
    [anon_sym_in] = ACTIONS(3096),
    [anon_sym_EQ] = ACTIONS(3098),
    [anon_sym_AT] = ACTIONS(3096),
    [anon_sym_not] = ACTIONS(3096),
    [anon_sym_and] = ACTIONS(3096),
    [anon_sym_or] = ACTIONS(3096),
    [anon_sym_PLUS] = ACTIONS(3096),
    [anon_sym_DASH] = ACTIONS(3096),
    [anon_sym_SLASH] = ACTIONS(3098),
    [anon_sym_PERCENT] = ACTIONS(3096),
    [anon_sym_SLASH_SLASH] = ACTIONS(3096),
    [anon_sym_STAR_STAR] = ACTIONS(3096),
    [anon_sym_PIPE] = ACTIONS(3096),
    [anon_sym_AMP] = ACTIONS(3096),
    [anon_sym_CARET] = ACTIONS(3096),
    [anon_sym_LT_LT] = ACTIONS(3096),
    [anon_sym_LT] = ACTIONS(3098),
    [anon_sym_LT_EQ] = ACTIONS(3096),
    [anon_sym_EQ_EQ] = ACTIONS(3096),
    [anon_sym_BANG_EQ] = ACTIONS(3096),
    [anon_sym_GT_EQ] = ACTIONS(3096),
    [anon_sym_GT] = ACTIONS(3098),
    [anon_sym_LT_GT] = ACTIONS(3096),
    [anon_sym_is] = ACTIONS(3096),
    [anon_sym_LBRACK] = ACTIONS(3096),
    [anon_sym_RBRACK] = ACTIONS(3096),
    [anon_sym_RBRACE] = ACTIONS(3096),
    [sym_type_conversion] = ACTIONS(3096),
    [sym_comment] = ACTIONS(73),
  },
  [1448] = {
    [anon_sym_RPAREN] = ACTIONS(2647),
    [anon_sym_COMMA] = ACTIONS(2647),
    [anon_sym_if] = ACTIONS(1198),
    [anon_sym_and] = ACTIONS(1200),
    [anon_sym_or] = ACTIONS(1202),
    [sym_comment] = ACTIONS(73),
  },
  [1449] = {
    [sym__expression] = STATE(1690),
    [sym__primary_expression] = STATE(237),
    [sym_not_operator] = STATE(1690),
    [sym_boolean_operator] = STATE(1690),
    [sym_binary_operator] = STATE(237),
    [sym_unary_operator] = STATE(237),
    [sym_comparison_operator] = STATE(1690),
    [sym_lambda] = STATE(1690),
    [sym_attribute] = STATE(237),
    [sym_subscript] = STATE(237),
    [sym_call] = STATE(237),
    [sym_list] = STATE(237),
    [sym_list_comprehension] = STATE(237),
    [sym_dictionary] = STATE(237),
    [sym_dictionary_comprehension] = STATE(237),
    [sym_set] = STATE(237),
    [sym_set_comprehension] = STATE(237),
    [sym_parenthesized_expression] = STATE(237),
    [sym_tuple] = STATE(237),
    [sym_generator_expression] = STATE(237),
    [sym_conditional_expression] = STATE(1690),
    [sym_concatenated_string] = STATE(237),
    [sym_string] = STATE(238),
    [sym_await] = STATE(1690),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_lambda] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(419),
    [sym_float] = ACTIONS(419),
    [sym_identifier] = ACTIONS(419),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_none] = ACTIONS(419),
    [anon_sym_await] = ACTIONS(421),
    [sym_comment] = ACTIONS(73),
  },
  [1450] = {
    [sym__expression] = STATE(1093),
    [sym__primary_expression] = STATE(237),
    [sym_not_operator] = STATE(1093),
    [sym_boolean_operator] = STATE(1093),
    [sym_binary_operator] = STATE(237),
    [sym_unary_operator] = STATE(237),
    [sym_comparison_operator] = STATE(1093),
    [sym_lambda] = STATE(1093),
    [sym_attribute] = STATE(237),
    [sym_subscript] = STATE(237),
    [sym_call] = STATE(237),
    [sym_list] = STATE(237),
    [sym_list_comprehension] = STATE(237),
    [sym_dictionary] = STATE(237),
    [sym_dictionary_comprehension] = STATE(237),
    [sym_set] = STATE(237),
    [sym_set_comprehension] = STATE(237),
    [sym_parenthesized_expression] = STATE(237),
    [sym_tuple] = STATE(237),
    [sym_generator_expression] = STATE(237),
    [sym_conditional_expression] = STATE(1093),
    [sym_concatenated_string] = STATE(237),
    [sym_string] = STATE(238),
    [sym_await] = STATE(1093),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_lambda] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(419),
    [sym_float] = ACTIONS(419),
    [sym_identifier] = ACTIONS(419),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_none] = ACTIONS(419),
    [anon_sym_await] = ACTIONS(421),
    [sym_comment] = ACTIONS(73),
  },
  [1451] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(2942),
    [anon_sym_COMMA] = ACTIONS(2942),
    [anon_sym_STAR] = ACTIONS(1204),
    [anon_sym_GT_GT] = ACTIONS(1206),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_in] = ACTIONS(2942),
    [anon_sym_AT] = ACTIONS(1210),
    [anon_sym_not] = ACTIONS(2942),
    [anon_sym_and] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(1214),
    [anon_sym_DASH] = ACTIONS(1214),
    [anon_sym_SLASH] = ACTIONS(1204),
    [anon_sym_PERCENT] = ACTIONS(1210),
    [anon_sym_SLASH_SLASH] = ACTIONS(1210),
    [anon_sym_STAR_STAR] = ACTIONS(1216),
    [anon_sym_PIPE] = ACTIONS(1218),
    [anon_sym_AMP] = ACTIONS(1220),
    [anon_sym_CARET] = ACTIONS(1222),
    [anon_sym_LT_LT] = ACTIONS(1206),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_LT_EQ] = ACTIONS(2942),
    [anon_sym_EQ_EQ] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_GT_EQ] = ACTIONS(2942),
    [anon_sym_GT] = ACTIONS(2944),
    [anon_sym_LT_GT] = ACTIONS(2942),
    [anon_sym_is] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(473),
    [sym_comment] = ACTIONS(73),
  },
  [1452] = {
    [anon_sym_DOT] = ACTIONS(3393),
    [anon_sym_LPAREN] = ACTIONS(3393),
    [anon_sym_RPAREN] = ACTIONS(3393),
    [anon_sym_COMMA] = ACTIONS(3393),
    [anon_sym_as] = ACTIONS(3395),
    [anon_sym_STAR] = ACTIONS(3395),
    [anon_sym_GT_GT] = ACTIONS(3393),
    [anon_sym_if] = ACTIONS(3393),
    [anon_sym_COLON] = ACTIONS(3393),
    [anon_sym_else] = ACTIONS(3393),
    [anon_sym_async] = ACTIONS(3393),
    [anon_sym_for] = ACTIONS(3393),
    [anon_sym_in] = ACTIONS(3393),
    [anon_sym_EQ] = ACTIONS(3395),
    [anon_sym_AT] = ACTIONS(3393),
    [anon_sym_not] = ACTIONS(3393),
    [anon_sym_and] = ACTIONS(3393),
    [anon_sym_or] = ACTIONS(3393),
    [anon_sym_PLUS] = ACTIONS(3393),
    [anon_sym_DASH] = ACTIONS(3393),
    [anon_sym_SLASH] = ACTIONS(3395),
    [anon_sym_PERCENT] = ACTIONS(3393),
    [anon_sym_SLASH_SLASH] = ACTIONS(3393),
    [anon_sym_STAR_STAR] = ACTIONS(3393),
    [anon_sym_PIPE] = ACTIONS(3393),
    [anon_sym_AMP] = ACTIONS(3393),
    [anon_sym_CARET] = ACTIONS(3393),
    [anon_sym_LT_LT] = ACTIONS(3393),
    [anon_sym_LT] = ACTIONS(3395),
    [anon_sym_LT_EQ] = ACTIONS(3393),
    [anon_sym_EQ_EQ] = ACTIONS(3393),
    [anon_sym_BANG_EQ] = ACTIONS(3393),
    [anon_sym_GT_EQ] = ACTIONS(3393),
    [anon_sym_GT] = ACTIONS(3395),
    [anon_sym_LT_GT] = ACTIONS(3393),
    [anon_sym_is] = ACTIONS(3393),
    [anon_sym_LBRACK] = ACTIONS(3393),
    [anon_sym_RBRACK] = ACTIONS(3393),
    [anon_sym_RBRACE] = ACTIONS(3393),
    [sym_type_conversion] = ACTIONS(3393),
    [sym_comment] = ACTIONS(73),
  },
  [1453] = {
    [anon_sym_DOT] = ACTIONS(3458),
    [anon_sym_LPAREN] = ACTIONS(3458),
    [anon_sym_RPAREN] = ACTIONS(3458),
    [anon_sym_COMMA] = ACTIONS(3458),
    [anon_sym_as] = ACTIONS(3460),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_GT_GT] = ACTIONS(3458),
    [anon_sym_if] = ACTIONS(3458),
    [anon_sym_COLON] = ACTIONS(3458),
    [anon_sym_else] = ACTIONS(3458),
    [anon_sym_async] = ACTIONS(3458),
    [anon_sym_for] = ACTIONS(3458),
    [anon_sym_in] = ACTIONS(3458),
    [anon_sym_EQ] = ACTIONS(3460),
    [anon_sym_AT] = ACTIONS(3458),
    [anon_sym_not] = ACTIONS(3458),
    [anon_sym_and] = ACTIONS(3458),
    [anon_sym_or] = ACTIONS(3458),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_SLASH] = ACTIONS(3460),
    [anon_sym_PERCENT] = ACTIONS(3458),
    [anon_sym_SLASH_SLASH] = ACTIONS(3458),
    [anon_sym_STAR_STAR] = ACTIONS(3458),
    [anon_sym_PIPE] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_LT_LT] = ACTIONS(3458),
    [anon_sym_LT] = ACTIONS(3460),
    [anon_sym_LT_EQ] = ACTIONS(3458),
    [anon_sym_EQ_EQ] = ACTIONS(3458),
    [anon_sym_BANG_EQ] = ACTIONS(3458),
    [anon_sym_GT_EQ] = ACTIONS(3458),
    [anon_sym_GT] = ACTIONS(3460),
    [anon_sym_LT_GT] = ACTIONS(3458),
    [anon_sym_is] = ACTIONS(3458),
    [anon_sym_LBRACK] = ACTIONS(3458),
    [anon_sym_RBRACK] = ACTIONS(3458),
    [anon_sym_RBRACE] = ACTIONS(3458),
    [sym_type_conversion] = ACTIONS(3458),
    [sym_comment] = ACTIONS(73),
  },
  [1454] = {
    [anon_sym_DOT] = ACTIONS(3462),
    [anon_sym_LPAREN] = ACTIONS(3462),
    [anon_sym_RPAREN] = ACTIONS(3462),
    [anon_sym_COMMA] = ACTIONS(3462),
    [anon_sym_as] = ACTIONS(3464),
    [anon_sym_STAR] = ACTIONS(3464),
    [anon_sym_GT_GT] = ACTIONS(3462),
    [anon_sym_if] = ACTIONS(3462),
    [anon_sym_COLON] = ACTIONS(3462),
    [anon_sym_else] = ACTIONS(3462),
    [anon_sym_async] = ACTIONS(3462),
    [anon_sym_for] = ACTIONS(3462),
    [anon_sym_in] = ACTIONS(3462),
    [anon_sym_EQ] = ACTIONS(3464),
    [anon_sym_AT] = ACTIONS(3462),
    [anon_sym_not] = ACTIONS(3462),
    [anon_sym_and] = ACTIONS(3462),
    [anon_sym_or] = ACTIONS(3462),
    [anon_sym_PLUS] = ACTIONS(3462),
    [anon_sym_DASH] = ACTIONS(3462),
    [anon_sym_SLASH] = ACTIONS(3464),
    [anon_sym_PERCENT] = ACTIONS(3462),
    [anon_sym_SLASH_SLASH] = ACTIONS(3462),
    [anon_sym_STAR_STAR] = ACTIONS(3462),
    [anon_sym_PIPE] = ACTIONS(3462),
    [anon_sym_AMP] = ACTIONS(3462),
    [anon_sym_CARET] = ACTIONS(3462),
    [anon_sym_LT_LT] = ACTIONS(3462),
    [anon_sym_LT] = ACTIONS(3464),
    [anon_sym_LT_EQ] = ACTIONS(3462),
    [anon_sym_EQ_EQ] = ACTIONS(3462),
    [anon_sym_BANG_EQ] = ACTIONS(3462),
    [anon_sym_GT_EQ] = ACTIONS(3462),
    [anon_sym_GT] = ACTIONS(3464),
    [anon_sym_LT_GT] = ACTIONS(3462),
    [anon_sym_is] = ACTIONS(3462),
    [anon_sym_LBRACK] = ACTIONS(3462),
    [anon_sym_RBRACK] = ACTIONS(3462),
    [anon_sym_RBRACE] = ACTIONS(3462),
    [sym_type_conversion] = ACTIONS(3462),
    [sym_comment] = ACTIONS(73),
  },
  [1455] = {
    [anon_sym_RPAREN] = ACTIONS(3565),
    [anon_sym_COMMA] = ACTIONS(3565),
    [anon_sym_if] = ACTIONS(435),
    [anon_sym_async] = ACTIONS(3565),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_and] = ACTIONS(441),
    [anon_sym_or] = ACTIONS(443),
    [sym_comment] = ACTIONS(73),
  },
  [1456] = {
    [sym__expression_within_for_in_clause] = STATE(1691),
    [sym__expression] = STATE(1459),
    [sym__primary_expression] = STATE(67),
    [sym_not_operator] = STATE(1459),
    [sym_boolean_operator] = STATE(1459),
    [sym_binary_operator] = STATE(67),
    [sym_unary_operator] = STATE(67),
    [sym_comparison_operator] = STATE(1459),
    [sym_lambda] = STATE(1459),
    [sym_lambda_within_for_in_clause] = STATE(1691),
    [sym_attribute] = STATE(67),
    [sym_subscript] = STATE(67),
    [sym_call] = STATE(67),
    [sym_list] = STATE(67),
    [sym_list_comprehension] = STATE(67),
    [sym_dictionary] = STATE(67),
    [sym_dictionary_comprehension] = STATE(67),
    [sym_set] = STATE(67),
    [sym_set_comprehension] = STATE(67),
    [sym_parenthesized_expression] = STATE(67),
    [sym_tuple] = STATE(67),
    [sym_generator_expression] = STATE(67),
    [sym_conditional_expression] = STATE(1459),
    [sym_concatenated_string] = STATE(67),
    [sym_string] = STATE(69),
    [sym_await] = STATE(1459),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(3051),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [1457] = {
    [sym_lambda_parameters] = STATE(1693),
    [sym__parameters] = STATE(138),
    [sym_default_parameter] = STATE(139),
    [sym_typed_default_parameter] = STATE(139),
    [sym_list_splat] = STATE(140),
    [sym_dictionary_splat] = STATE(140),
    [sym_typed_parameter] = STATE(139),
    [sym_tuple] = STATE(139),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(3637),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [1458] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1695),
    [anon_sym_RPAREN] = ACTIONS(3639),
    [anon_sym_COMMA] = ACTIONS(3641),
    [anon_sym_if] = ACTIONS(3639),
    [anon_sym_async] = ACTIONS(3639),
    [anon_sym_for] = ACTIONS(3639),
    [sym_comment] = ACTIONS(73),
  },
  [1459] = {
    [anon_sym_RPAREN] = ACTIONS(3643),
    [anon_sym_COMMA] = ACTIONS(3643),
    [anon_sym_if] = ACTIONS(3643),
    [anon_sym_async] = ACTIONS(3643),
    [anon_sym_for] = ACTIONS(3643),
    [anon_sym_and] = ACTIONS(441),
    [anon_sym_or] = ACTIONS(443),
    [sym_comment] = ACTIONS(73),
  },
  [1460] = {
    [anon_sym_RPAREN] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(723),
    [anon_sym_async] = ACTIONS(723),
    [anon_sym_for] = ACTIONS(723),
    [anon_sym_and] = ACTIONS(3057),
    [anon_sym_or] = ACTIONS(3059),
    [sym_comment] = ACTIONS(73),
  },
  [1461] = {
    [sym__expression] = STATE(1696),
    [sym__primary_expression] = STATE(1125),
    [sym_not_operator] = STATE(1696),
    [sym_boolean_operator] = STATE(1696),
    [sym_binary_operator] = STATE(1125),
    [sym_unary_operator] = STATE(1125),
    [sym_comparison_operator] = STATE(1696),
    [sym_lambda] = STATE(1696),
    [sym_attribute] = STATE(1125),
    [sym_subscript] = STATE(1125),
    [sym_call] = STATE(1125),
    [sym_list] = STATE(1125),
    [sym_list_comprehension] = STATE(1125),
    [sym_dictionary] = STATE(1125),
    [sym_dictionary_comprehension] = STATE(1125),
    [sym_set] = STATE(1125),
    [sym_set_comprehension] = STATE(1125),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_tuple] = STATE(1125),
    [sym_generator_expression] = STATE(1125),
    [sym_conditional_expression] = STATE(1696),
    [sym_concatenated_string] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_await] = STATE(1696),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2198),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2200),
    [anon_sym_TILDE] = ACTIONS(2200),
    [anon_sym_lambda] = ACTIONS(2202),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2204),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2206),
    [sym_float] = ACTIONS(2206),
    [sym_identifier] = ACTIONS(2206),
    [sym_true] = ACTIONS(2206),
    [sym_false] = ACTIONS(2206),
    [sym_none] = ACTIONS(2206),
    [anon_sym_await] = ACTIONS(2208),
    [sym_comment] = ACTIONS(73),
  },
  [1462] = {
    [anon_sym_COLON] = ACTIONS(3645),
    [sym_comment] = ACTIONS(73),
  },
  [1463] = {
    [sym__expression] = STATE(1698),
    [sym__primary_expression] = STATE(538),
    [sym_not_operator] = STATE(1698),
    [sym_boolean_operator] = STATE(1698),
    [sym_binary_operator] = STATE(538),
    [sym_unary_operator] = STATE(538),
    [sym_comparison_operator] = STATE(1698),
    [sym_lambda] = STATE(1698),
    [sym_attribute] = STATE(538),
    [sym_subscript] = STATE(538),
    [sym_call] = STATE(538),
    [sym_list] = STATE(538),
    [sym_list_comprehension] = STATE(538),
    [sym_dictionary] = STATE(538),
    [sym_dictionary_comprehension] = STATE(538),
    [sym_set] = STATE(538),
    [sym_set_comprehension] = STATE(538),
    [sym_parenthesized_expression] = STATE(538),
    [sym_tuple] = STATE(538),
    [sym_generator_expression] = STATE(538),
    [sym_conditional_expression] = STATE(1698),
    [sym_concatenated_string] = STATE(538),
    [sym_string] = STATE(539),
    [sym_await] = STATE(1698),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_lambda] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(917),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(919),
    [sym_float] = ACTIONS(919),
    [sym_identifier] = ACTIONS(919),
    [sym_true] = ACTIONS(919),
    [sym_false] = ACTIONS(919),
    [sym_none] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(921),
    [sym_comment] = ACTIONS(73),
  },
  [1464] = {
    [sym__expression] = STATE(652),
    [sym__primary_expression] = STATE(1125),
    [sym_not_operator] = STATE(652),
    [sym_boolean_operator] = STATE(652),
    [sym_binary_operator] = STATE(1125),
    [sym_unary_operator] = STATE(1125),
    [sym_comparison_operator] = STATE(652),
    [sym_lambda] = STATE(652),
    [sym_attribute] = STATE(1125),
    [sym_subscript] = STATE(1125),
    [sym_call] = STATE(1125),
    [sym_list] = STATE(1125),
    [sym_list_comprehension] = STATE(1125),
    [sym_dictionary] = STATE(1125),
    [sym_dictionary_comprehension] = STATE(1125),
    [sym_set] = STATE(1125),
    [sym_set_comprehension] = STATE(1125),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_tuple] = STATE(1125),
    [sym_generator_expression] = STATE(1125),
    [sym_conditional_expression] = STATE(652),
    [sym_concatenated_string] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_await] = STATE(652),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2198),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2200),
    [anon_sym_TILDE] = ACTIONS(2200),
    [anon_sym_lambda] = ACTIONS(2202),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2204),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2206),
    [sym_float] = ACTIONS(2206),
    [sym_identifier] = ACTIONS(2206),
    [sym_true] = ACTIONS(2206),
    [sym_false] = ACTIONS(2206),
    [sym_none] = ACTIONS(2206),
    [anon_sym_await] = ACTIONS(2208),
    [sym_comment] = ACTIONS(73),
  },
  [1465] = {
    [sym__expression] = STATE(1699),
    [sym__primary_expression] = STATE(1125),
    [sym_not_operator] = STATE(1699),
    [sym_boolean_operator] = STATE(1699),
    [sym_binary_operator] = STATE(1125),
    [sym_unary_operator] = STATE(1125),
    [sym_comparison_operator] = STATE(1699),
    [sym_lambda] = STATE(1699),
    [sym_attribute] = STATE(1125),
    [sym_subscript] = STATE(1125),
    [sym_call] = STATE(1125),
    [sym_list] = STATE(1125),
    [sym_list_comprehension] = STATE(1125),
    [sym_dictionary] = STATE(1125),
    [sym_dictionary_comprehension] = STATE(1125),
    [sym_set] = STATE(1125),
    [sym_set_comprehension] = STATE(1125),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_tuple] = STATE(1125),
    [sym_generator_expression] = STATE(1125),
    [sym_conditional_expression] = STATE(1699),
    [sym_concatenated_string] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_await] = STATE(1699),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2198),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2200),
    [anon_sym_TILDE] = ACTIONS(2200),
    [anon_sym_lambda] = ACTIONS(2202),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2204),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2206),
    [sym_float] = ACTIONS(2206),
    [sym_identifier] = ACTIONS(2206),
    [sym_true] = ACTIONS(2206),
    [sym_false] = ACTIONS(2206),
    [sym_none] = ACTIONS(2206),
    [anon_sym_await] = ACTIONS(2208),
    [sym_comment] = ACTIONS(73),
  },
  [1466] = {
    [sym__primary_expression] = STATE(1700),
    [sym_binary_operator] = STATE(1700),
    [sym_unary_operator] = STATE(1700),
    [sym_attribute] = STATE(1700),
    [sym_subscript] = STATE(1700),
    [sym_call] = STATE(1700),
    [sym_list] = STATE(1700),
    [sym_list_comprehension] = STATE(1700),
    [sym_dictionary] = STATE(1700),
    [sym_dictionary_comprehension] = STATE(1700),
    [sym_set] = STATE(1700),
    [sym_set_comprehension] = STATE(1700),
    [sym_parenthesized_expression] = STATE(1700),
    [sym_tuple] = STATE(1700),
    [sym_generator_expression] = STATE(1700),
    [sym_concatenated_string] = STATE(1700),
    [sym_string] = STATE(1126),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2200),
    [anon_sym_TILDE] = ACTIONS(2200),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3647),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3649),
    [sym_float] = ACTIONS(3649),
    [sym_identifier] = ACTIONS(3649),
    [sym_true] = ACTIONS(3649),
    [sym_false] = ACTIONS(3649),
    [sym_none] = ACTIONS(3649),
    [sym_comment] = ACTIONS(73),
  },
  [1467] = {
    [sym__primary_expression] = STATE(1701),
    [sym_binary_operator] = STATE(1701),
    [sym_unary_operator] = STATE(1701),
    [sym_attribute] = STATE(1701),
    [sym_subscript] = STATE(1701),
    [sym_call] = STATE(1701),
    [sym_list] = STATE(1701),
    [sym_list_comprehension] = STATE(1701),
    [sym_dictionary] = STATE(1701),
    [sym_dictionary_comprehension] = STATE(1701),
    [sym_set] = STATE(1701),
    [sym_set_comprehension] = STATE(1701),
    [sym_parenthesized_expression] = STATE(1701),
    [sym_tuple] = STATE(1701),
    [sym_generator_expression] = STATE(1701),
    [sym_concatenated_string] = STATE(1701),
    [sym_string] = STATE(1126),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2200),
    [anon_sym_TILDE] = ACTIONS(2200),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3651),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3653),
    [sym_float] = ACTIONS(3653),
    [sym_identifier] = ACTIONS(3653),
    [sym_true] = ACTIONS(3653),
    [sym_false] = ACTIONS(3653),
    [sym_none] = ACTIONS(3653),
    [sym_comment] = ACTIONS(73),
  },
  [1468] = {
    [sym__primary_expression] = STATE(1702),
    [sym_binary_operator] = STATE(1702),
    [sym_unary_operator] = STATE(1702),
    [sym_attribute] = STATE(1702),
    [sym_subscript] = STATE(1702),
    [sym_call] = STATE(1702),
    [sym_list] = STATE(1702),
    [sym_list_comprehension] = STATE(1702),
    [sym_dictionary] = STATE(1702),
    [sym_dictionary_comprehension] = STATE(1702),
    [sym_set] = STATE(1702),
    [sym_set_comprehension] = STATE(1702),
    [sym_parenthesized_expression] = STATE(1702),
    [sym_tuple] = STATE(1702),
    [sym_generator_expression] = STATE(1702),
    [sym_concatenated_string] = STATE(1702),
    [sym_string] = STATE(1126),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2200),
    [anon_sym_TILDE] = ACTIONS(2200),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3655),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3657),
    [sym_float] = ACTIONS(3657),
    [sym_identifier] = ACTIONS(3657),
    [sym_true] = ACTIONS(3657),
    [sym_false] = ACTIONS(3657),
    [sym_none] = ACTIONS(3657),
    [sym_comment] = ACTIONS(73),
  },
  [1469] = {
    [anon_sym_in] = ACTIONS(3659),
    [sym_comment] = ACTIONS(73),
  },
  [1470] = {
    [sym__primary_expression] = STATE(1704),
    [sym_binary_operator] = STATE(1704),
    [sym_unary_operator] = STATE(1704),
    [sym_attribute] = STATE(1704),
    [sym_subscript] = STATE(1704),
    [sym_call] = STATE(1704),
    [sym_list] = STATE(1704),
    [sym_list_comprehension] = STATE(1704),
    [sym_dictionary] = STATE(1704),
    [sym_dictionary_comprehension] = STATE(1704),
    [sym_set] = STATE(1704),
    [sym_set_comprehension] = STATE(1704),
    [sym_parenthesized_expression] = STATE(1704),
    [sym_tuple] = STATE(1704),
    [sym_generator_expression] = STATE(1704),
    [sym_concatenated_string] = STATE(1704),
    [sym_string] = STATE(1126),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2200),
    [anon_sym_TILDE] = ACTIONS(2200),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3661),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3663),
    [sym_float] = ACTIONS(3663),
    [sym_identifier] = ACTIONS(3663),
    [sym_true] = ACTIONS(3663),
    [sym_false] = ACTIONS(3663),
    [sym_none] = ACTIONS(3663),
    [sym_comment] = ACTIONS(73),
  },
  [1471] = {
    [sym__primary_expression] = STATE(669),
    [sym_binary_operator] = STATE(669),
    [sym_unary_operator] = STATE(669),
    [sym_attribute] = STATE(669),
    [sym_subscript] = STATE(669),
    [sym_call] = STATE(669),
    [sym_list] = STATE(669),
    [sym_list_comprehension] = STATE(669),
    [sym_dictionary] = STATE(669),
    [sym_dictionary_comprehension] = STATE(669),
    [sym_set] = STATE(669),
    [sym_set_comprehension] = STATE(669),
    [sym_parenthesized_expression] = STATE(669),
    [sym_tuple] = STATE(669),
    [sym_generator_expression] = STATE(669),
    [sym_concatenated_string] = STATE(669),
    [sym_string] = STATE(1126),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2200),
    [anon_sym_TILDE] = ACTIONS(2200),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1282),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1284),
    [sym_float] = ACTIONS(1284),
    [sym_identifier] = ACTIONS(1284),
    [sym_true] = ACTIONS(1284),
    [sym_false] = ACTIONS(1284),
    [sym_none] = ACTIONS(1284),
    [sym_comment] = ACTIONS(73),
  },
  [1472] = {
    [sym__primary_expression] = STATE(1705),
    [sym_binary_operator] = STATE(1705),
    [sym_unary_operator] = STATE(1705),
    [sym_attribute] = STATE(1705),
    [sym_subscript] = STATE(1705),
    [sym_call] = STATE(1705),
    [sym_list] = STATE(1705),
    [sym_list_comprehension] = STATE(1705),
    [sym_dictionary] = STATE(1705),
    [sym_dictionary_comprehension] = STATE(1705),
    [sym_set] = STATE(1705),
    [sym_set_comprehension] = STATE(1705),
    [sym_parenthesized_expression] = STATE(1705),
    [sym_tuple] = STATE(1705),
    [sym_generator_expression] = STATE(1705),
    [sym_concatenated_string] = STATE(1705),
    [sym_string] = STATE(1126),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2200),
    [anon_sym_TILDE] = ACTIONS(2200),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3665),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3667),
    [sym_float] = ACTIONS(3667),
    [sym_identifier] = ACTIONS(3667),
    [sym_true] = ACTIONS(3667),
    [sym_false] = ACTIONS(3667),
    [sym_none] = ACTIONS(3667),
    [sym_comment] = ACTIONS(73),
  },
  [1473] = {
    [sym__primary_expression] = STATE(1706),
    [sym_binary_operator] = STATE(1706),
    [sym_unary_operator] = STATE(1706),
    [sym_attribute] = STATE(1706),
    [sym_subscript] = STATE(1706),
    [sym_call] = STATE(1706),
    [sym_list] = STATE(1706),
    [sym_list_comprehension] = STATE(1706),
    [sym_dictionary] = STATE(1706),
    [sym_dictionary_comprehension] = STATE(1706),
    [sym_set] = STATE(1706),
    [sym_set_comprehension] = STATE(1706),
    [sym_parenthesized_expression] = STATE(1706),
    [sym_tuple] = STATE(1706),
    [sym_generator_expression] = STATE(1706),
    [sym_concatenated_string] = STATE(1706),
    [sym_string] = STATE(1126),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2200),
    [anon_sym_TILDE] = ACTIONS(2200),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3669),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3671),
    [sym_float] = ACTIONS(3671),
    [sym_identifier] = ACTIONS(3671),
    [sym_true] = ACTIONS(3671),
    [sym_false] = ACTIONS(3671),
    [sym_none] = ACTIONS(3671),
    [sym_comment] = ACTIONS(73),
  },
  [1474] = {
    [sym__primary_expression] = STATE(1707),
    [sym_binary_operator] = STATE(1707),
    [sym_unary_operator] = STATE(1707),
    [sym_attribute] = STATE(1707),
    [sym_subscript] = STATE(1707),
    [sym_call] = STATE(1707),
    [sym_list] = STATE(1707),
    [sym_list_comprehension] = STATE(1707),
    [sym_dictionary] = STATE(1707),
    [sym_dictionary_comprehension] = STATE(1707),
    [sym_set] = STATE(1707),
    [sym_set_comprehension] = STATE(1707),
    [sym_parenthesized_expression] = STATE(1707),
    [sym_tuple] = STATE(1707),
    [sym_generator_expression] = STATE(1707),
    [sym_concatenated_string] = STATE(1707),
    [sym_string] = STATE(1126),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2200),
    [anon_sym_TILDE] = ACTIONS(2200),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3673),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3675),
    [sym_float] = ACTIONS(3675),
    [sym_identifier] = ACTIONS(3675),
    [sym_true] = ACTIONS(3675),
    [sym_false] = ACTIONS(3675),
    [sym_none] = ACTIONS(3675),
    [sym_comment] = ACTIONS(73),
  },
  [1475] = {
    [sym__primary_expression] = STATE(1702),
    [sym_binary_operator] = STATE(1702),
    [sym_unary_operator] = STATE(1702),
    [sym_attribute] = STATE(1702),
    [sym_subscript] = STATE(1702),
    [sym_call] = STATE(1702),
    [sym_list] = STATE(1702),
    [sym_list_comprehension] = STATE(1702),
    [sym_dictionary] = STATE(1702),
    [sym_dictionary_comprehension] = STATE(1702),
    [sym_set] = STATE(1702),
    [sym_set_comprehension] = STATE(1702),
    [sym_parenthesized_expression] = STATE(1702),
    [sym_tuple] = STATE(1702),
    [sym_generator_expression] = STATE(1702),
    [sym_concatenated_string] = STATE(1702),
    [sym_string] = STATE(1126),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(3677),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2200),
    [anon_sym_TILDE] = ACTIONS(2200),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3655),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3657),
    [sym_float] = ACTIONS(3657),
    [sym_identifier] = ACTIONS(3657),
    [sym_true] = ACTIONS(3657),
    [sym_false] = ACTIONS(3657),
    [sym_none] = ACTIONS(3657),
    [sym_comment] = ACTIONS(73),
  },
  [1476] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1708),
    [anon_sym_RPAREN] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(991),
    [anon_sym_async] = ACTIONS(991),
    [anon_sym_for] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(3065),
    [anon_sym_not] = ACTIONS(3069),
    [anon_sym_and] = ACTIONS(991),
    [anon_sym_or] = ACTIONS(991),
    [anon_sym_LT] = ACTIONS(3081),
    [anon_sym_LT_EQ] = ACTIONS(3065),
    [anon_sym_EQ_EQ] = ACTIONS(3065),
    [anon_sym_BANG_EQ] = ACTIONS(3065),
    [anon_sym_GT_EQ] = ACTIONS(3065),
    [anon_sym_GT] = ACTIONS(3081),
    [anon_sym_LT_GT] = ACTIONS(3065),
    [anon_sym_is] = ACTIONS(3083),
    [sym_comment] = ACTIONS(73),
  },
  [1477] = {
    [sym_string] = STATE(1709),
    [aux_sym_concatenated_string_repeat1] = STATE(1709),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_RPAREN] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_async] = ACTIONS(995),
    [anon_sym_for] = ACTIONS(995),
    [anon_sym_in] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(995),
    [anon_sym_not] = ACTIONS(995),
    [anon_sym_and] = ACTIONS(995),
    [anon_sym_or] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(995),
    [anon_sym_SLASH_SLASH] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_GT] = ACTIONS(995),
    [anon_sym_is] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(995),
    [sym_comment] = ACTIONS(73),
  },
  [1478] = {
    [anon_sym_DOT] = ACTIONS(3587),
    [anon_sym_LPAREN] = ACTIONS(3587),
    [anon_sym_RPAREN] = ACTIONS(3587),
    [anon_sym_COMMA] = ACTIONS(3587),
    [anon_sym_as] = ACTIONS(3589),
    [anon_sym_STAR] = ACTIONS(3589),
    [anon_sym_GT_GT] = ACTIONS(3587),
    [anon_sym_if] = ACTIONS(3587),
    [anon_sym_COLON] = ACTIONS(3587),
    [anon_sym_else] = ACTIONS(3587),
    [anon_sym_async] = ACTIONS(3587),
    [anon_sym_for] = ACTIONS(3587),
    [anon_sym_in] = ACTIONS(3587),
    [anon_sym_EQ] = ACTIONS(3589),
    [anon_sym_AT] = ACTIONS(3587),
    [anon_sym_not] = ACTIONS(3587),
    [anon_sym_and] = ACTIONS(3587),
    [anon_sym_or] = ACTIONS(3587),
    [anon_sym_PLUS] = ACTIONS(3587),
    [anon_sym_DASH] = ACTIONS(3587),
    [anon_sym_SLASH] = ACTIONS(3589),
    [anon_sym_PERCENT] = ACTIONS(3587),
    [anon_sym_SLASH_SLASH] = ACTIONS(3587),
    [anon_sym_STAR_STAR] = ACTIONS(3587),
    [anon_sym_PIPE] = ACTIONS(3587),
    [anon_sym_AMP] = ACTIONS(3587),
    [anon_sym_CARET] = ACTIONS(3587),
    [anon_sym_LT_LT] = ACTIONS(3587),
    [anon_sym_LT] = ACTIONS(3589),
    [anon_sym_LT_EQ] = ACTIONS(3587),
    [anon_sym_EQ_EQ] = ACTIONS(3587),
    [anon_sym_BANG_EQ] = ACTIONS(3587),
    [anon_sym_GT_EQ] = ACTIONS(3587),
    [anon_sym_GT] = ACTIONS(3589),
    [anon_sym_LT_GT] = ACTIONS(3587),
    [anon_sym_is] = ACTIONS(3587),
    [anon_sym_LBRACK] = ACTIONS(3587),
    [anon_sym_RBRACK] = ACTIONS(3587),
    [anon_sym_RBRACE] = ACTIONS(3587),
    [sym_type_conversion] = ACTIONS(3587),
    [sym_comment] = ACTIONS(73),
  },
  [1479] = {
    [sym_list_splat] = STATE(1413),
    [sym_dictionary_splat] = STATE(1413),
    [sym__expression] = STATE(1414),
    [sym__primary_expression] = STATE(237),
    [sym_not_operator] = STATE(1414),
    [sym_boolean_operator] = STATE(1414),
    [sym_binary_operator] = STATE(237),
    [sym_unary_operator] = STATE(237),
    [sym_comparison_operator] = STATE(1414),
    [sym_lambda] = STATE(1414),
    [sym_attribute] = STATE(237),
    [sym_subscript] = STATE(237),
    [sym_call] = STATE(237),
    [sym_keyword_argument] = STATE(1413),
    [sym_list] = STATE(237),
    [sym_list_comprehension] = STATE(237),
    [sym_dictionary] = STATE(237),
    [sym_dictionary_comprehension] = STATE(237),
    [sym_set] = STATE(237),
    [sym_set_comprehension] = STATE(237),
    [sym_parenthesized_expression] = STATE(237),
    [sym_tuple] = STATE(237),
    [sym_generator_expression] = STATE(237),
    [sym_conditional_expression] = STATE(1414),
    [sym_concatenated_string] = STATE(237),
    [sym_string] = STATE(238),
    [sym_await] = STATE(1414),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3679),
    [anon_sym_STAR] = ACTIONS(931),
    [anon_sym_print] = ACTIONS(933),
    [anon_sym_exec] = ACTIONS(933),
    [anon_sym_not] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_lambda] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(419),
    [sym_float] = ACTIONS(419),
    [sym_identifier] = ACTIONS(935),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_none] = ACTIONS(419),
    [anon_sym_await] = ACTIONS(421),
    [sym_comment] = ACTIONS(73),
  },
  [1480] = {
    [anon_sym_DOT] = ACTIONS(3600),
    [anon_sym_LPAREN] = ACTIONS(3600),
    [anon_sym_RPAREN] = ACTIONS(3600),
    [anon_sym_COMMA] = ACTIONS(3600),
    [anon_sym_as] = ACTIONS(3602),
    [anon_sym_STAR] = ACTIONS(3602),
    [anon_sym_GT_GT] = ACTIONS(3600),
    [anon_sym_if] = ACTIONS(3600),
    [anon_sym_COLON] = ACTIONS(3600),
    [anon_sym_else] = ACTIONS(3600),
    [anon_sym_async] = ACTIONS(3600),
    [anon_sym_for] = ACTIONS(3600),
    [anon_sym_in] = ACTIONS(3600),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_AT] = ACTIONS(3600),
    [anon_sym_not] = ACTIONS(3600),
    [anon_sym_and] = ACTIONS(3600),
    [anon_sym_or] = ACTIONS(3600),
    [anon_sym_PLUS] = ACTIONS(3600),
    [anon_sym_DASH] = ACTIONS(3600),
    [anon_sym_SLASH] = ACTIONS(3602),
    [anon_sym_PERCENT] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH] = ACTIONS(3600),
    [anon_sym_STAR_STAR] = ACTIONS(3600),
    [anon_sym_PIPE] = ACTIONS(3600),
    [anon_sym_AMP] = ACTIONS(3600),
    [anon_sym_CARET] = ACTIONS(3600),
    [anon_sym_LT_LT] = ACTIONS(3600),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_LT_EQ] = ACTIONS(3600),
    [anon_sym_EQ_EQ] = ACTIONS(3600),
    [anon_sym_BANG_EQ] = ACTIONS(3600),
    [anon_sym_GT_EQ] = ACTIONS(3600),
    [anon_sym_GT] = ACTIONS(3602),
    [anon_sym_LT_GT] = ACTIONS(3600),
    [anon_sym_is] = ACTIONS(3600),
    [anon_sym_LBRACK] = ACTIONS(3600),
    [anon_sym_RBRACK] = ACTIONS(3600),
    [anon_sym_RBRACE] = ACTIONS(3600),
    [sym_type_conversion] = ACTIONS(3600),
    [sym_comment] = ACTIONS(73),
  },
  [1481] = {
    [sym__expression] = STATE(1422),
    [sym__primary_expression] = STATE(567),
    [sym_not_operator] = STATE(1422),
    [sym_boolean_operator] = STATE(1422),
    [sym_binary_operator] = STATE(567),
    [sym_unary_operator] = STATE(567),
    [sym_comparison_operator] = STATE(1422),
    [sym_lambda] = STATE(1422),
    [sym_attribute] = STATE(567),
    [sym_subscript] = STATE(567),
    [sym_slice] = STATE(1423),
    [sym_call] = STATE(567),
    [sym_list] = STATE(567),
    [sym_list_comprehension] = STATE(567),
    [sym_dictionary] = STATE(567),
    [sym_dictionary_comprehension] = STATE(567),
    [sym_set] = STATE(567),
    [sym_set_comprehension] = STATE(567),
    [sym_parenthesized_expression] = STATE(567),
    [sym_tuple] = STATE(567),
    [sym_generator_expression] = STATE(567),
    [sym_conditional_expression] = STATE(1422),
    [sym_concatenated_string] = STATE(567),
    [sym_string] = STATE(569),
    [sym_await] = STATE(1422),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(973),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(975),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(977),
    [anon_sym_lambda] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(3681),
    [sym_ellipsis] = ACTIONS(981),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(983),
    [sym_float] = ACTIONS(983),
    [sym_identifier] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_none] = ACTIONS(983),
    [anon_sym_await] = ACTIONS(985),
    [sym_comment] = ACTIONS(73),
  },
  [1482] = {
    [sym__newline] = ACTIONS(3096),
    [anon_sym_DOT] = ACTIONS(3096),
    [anon_sym_from] = ACTIONS(3096),
    [anon_sym_LPAREN] = ACTIONS(3096),
    [anon_sym_COMMA] = ACTIONS(3096),
    [anon_sym_STAR] = ACTIONS(3098),
    [anon_sym_GT_GT] = ACTIONS(3096),
    [anon_sym_if] = ACTIONS(3096),
    [anon_sym_in] = ACTIONS(3096),
    [anon_sym_EQ] = ACTIONS(3098),
    [anon_sym_AT] = ACTIONS(3096),
    [anon_sym_not] = ACTIONS(3096),
    [anon_sym_and] = ACTIONS(3096),
    [anon_sym_or] = ACTIONS(3096),
    [anon_sym_PLUS] = ACTIONS(3096),
    [anon_sym_DASH] = ACTIONS(3096),
    [anon_sym_SLASH] = ACTIONS(3098),
    [anon_sym_PERCENT] = ACTIONS(3096),
    [anon_sym_SLASH_SLASH] = ACTIONS(3096),
    [anon_sym_STAR_STAR] = ACTIONS(3096),
    [anon_sym_PIPE] = ACTIONS(3096),
    [anon_sym_AMP] = ACTIONS(3096),
    [anon_sym_CARET] = ACTIONS(3096),
    [anon_sym_LT_LT] = ACTIONS(3096),
    [anon_sym_LT] = ACTIONS(3098),
    [anon_sym_LT_EQ] = ACTIONS(3096),
    [anon_sym_EQ_EQ] = ACTIONS(3096),
    [anon_sym_BANG_EQ] = ACTIONS(3096),
    [anon_sym_GT_EQ] = ACTIONS(3096),
    [anon_sym_GT] = ACTIONS(3098),
    [anon_sym_LT_GT] = ACTIONS(3096),
    [anon_sym_is] = ACTIONS(3096),
    [anon_sym_LBRACK] = ACTIONS(3096),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3096),
  },
  [1483] = {
    [sym__newline] = ACTIONS(3393),
    [anon_sym_DOT] = ACTIONS(3393),
    [anon_sym_from] = ACTIONS(3393),
    [anon_sym_LPAREN] = ACTIONS(3393),
    [anon_sym_COMMA] = ACTIONS(3393),
    [anon_sym_STAR] = ACTIONS(3395),
    [anon_sym_GT_GT] = ACTIONS(3393),
    [anon_sym_if] = ACTIONS(3393),
    [anon_sym_in] = ACTIONS(3393),
    [anon_sym_EQ] = ACTIONS(3395),
    [anon_sym_AT] = ACTIONS(3393),
    [anon_sym_not] = ACTIONS(3393),
    [anon_sym_and] = ACTIONS(3393),
    [anon_sym_or] = ACTIONS(3393),
    [anon_sym_PLUS] = ACTIONS(3393),
    [anon_sym_DASH] = ACTIONS(3393),
    [anon_sym_SLASH] = ACTIONS(3395),
    [anon_sym_PERCENT] = ACTIONS(3393),
    [anon_sym_SLASH_SLASH] = ACTIONS(3393),
    [anon_sym_STAR_STAR] = ACTIONS(3393),
    [anon_sym_PIPE] = ACTIONS(3393),
    [anon_sym_AMP] = ACTIONS(3393),
    [anon_sym_CARET] = ACTIONS(3393),
    [anon_sym_LT_LT] = ACTIONS(3393),
    [anon_sym_LT] = ACTIONS(3395),
    [anon_sym_LT_EQ] = ACTIONS(3393),
    [anon_sym_EQ_EQ] = ACTIONS(3393),
    [anon_sym_BANG_EQ] = ACTIONS(3393),
    [anon_sym_GT_EQ] = ACTIONS(3393),
    [anon_sym_GT] = ACTIONS(3395),
    [anon_sym_LT_GT] = ACTIONS(3393),
    [anon_sym_is] = ACTIONS(3393),
    [anon_sym_LBRACK] = ACTIONS(3393),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3393),
  },
  [1484] = {
    [sym__newline] = ACTIONS(3458),
    [anon_sym_DOT] = ACTIONS(3458),
    [anon_sym_from] = ACTIONS(3458),
    [anon_sym_LPAREN] = ACTIONS(3458),
    [anon_sym_COMMA] = ACTIONS(3458),
    [anon_sym_STAR] = ACTIONS(3460),
    [anon_sym_GT_GT] = ACTIONS(3458),
    [anon_sym_if] = ACTIONS(3458),
    [anon_sym_in] = ACTIONS(3458),
    [anon_sym_EQ] = ACTIONS(3460),
    [anon_sym_AT] = ACTIONS(3458),
    [anon_sym_not] = ACTIONS(3458),
    [anon_sym_and] = ACTIONS(3458),
    [anon_sym_or] = ACTIONS(3458),
    [anon_sym_PLUS] = ACTIONS(3458),
    [anon_sym_DASH] = ACTIONS(3458),
    [anon_sym_SLASH] = ACTIONS(3460),
    [anon_sym_PERCENT] = ACTIONS(3458),
    [anon_sym_SLASH_SLASH] = ACTIONS(3458),
    [anon_sym_STAR_STAR] = ACTIONS(3458),
    [anon_sym_PIPE] = ACTIONS(3458),
    [anon_sym_AMP] = ACTIONS(3458),
    [anon_sym_CARET] = ACTIONS(3458),
    [anon_sym_LT_LT] = ACTIONS(3458),
    [anon_sym_LT] = ACTIONS(3460),
    [anon_sym_LT_EQ] = ACTIONS(3458),
    [anon_sym_EQ_EQ] = ACTIONS(3458),
    [anon_sym_BANG_EQ] = ACTIONS(3458),
    [anon_sym_GT_EQ] = ACTIONS(3458),
    [anon_sym_GT] = ACTIONS(3460),
    [anon_sym_LT_GT] = ACTIONS(3458),
    [anon_sym_is] = ACTIONS(3458),
    [anon_sym_LBRACK] = ACTIONS(3458),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3458),
  },
  [1485] = {
    [sym__newline] = ACTIONS(3462),
    [anon_sym_DOT] = ACTIONS(3462),
    [anon_sym_from] = ACTIONS(3462),
    [anon_sym_LPAREN] = ACTIONS(3462),
    [anon_sym_COMMA] = ACTIONS(3462),
    [anon_sym_STAR] = ACTIONS(3464),
    [anon_sym_GT_GT] = ACTIONS(3462),
    [anon_sym_if] = ACTIONS(3462),
    [anon_sym_in] = ACTIONS(3462),
    [anon_sym_EQ] = ACTIONS(3464),
    [anon_sym_AT] = ACTIONS(3462),
    [anon_sym_not] = ACTIONS(3462),
    [anon_sym_and] = ACTIONS(3462),
    [anon_sym_or] = ACTIONS(3462),
    [anon_sym_PLUS] = ACTIONS(3462),
    [anon_sym_DASH] = ACTIONS(3462),
    [anon_sym_SLASH] = ACTIONS(3464),
    [anon_sym_PERCENT] = ACTIONS(3462),
    [anon_sym_SLASH_SLASH] = ACTIONS(3462),
    [anon_sym_STAR_STAR] = ACTIONS(3462),
    [anon_sym_PIPE] = ACTIONS(3462),
    [anon_sym_AMP] = ACTIONS(3462),
    [anon_sym_CARET] = ACTIONS(3462),
    [anon_sym_LT_LT] = ACTIONS(3462),
    [anon_sym_LT] = ACTIONS(3464),
    [anon_sym_LT_EQ] = ACTIONS(3462),
    [anon_sym_EQ_EQ] = ACTIONS(3462),
    [anon_sym_BANG_EQ] = ACTIONS(3462),
    [anon_sym_GT_EQ] = ACTIONS(3462),
    [anon_sym_GT] = ACTIONS(3464),
    [anon_sym_LT_GT] = ACTIONS(3462),
    [anon_sym_is] = ACTIONS(3462),
    [anon_sym_LBRACK] = ACTIONS(3462),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3462),
  },
  [1486] = {
    [sym__newline] = ACTIONS(3565),
    [anon_sym_COMMA] = ACTIONS(3565),
    [anon_sym_if] = ACTIONS(501),
    [anon_sym_and] = ACTIONS(503),
    [anon_sym_or] = ACTIONS(505),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3565),
  },
  [1487] = {
    [sym__newline] = ACTIONS(3587),
    [anon_sym_DOT] = ACTIONS(3587),
    [anon_sym_from] = ACTIONS(3587),
    [anon_sym_LPAREN] = ACTIONS(3587),
    [anon_sym_COMMA] = ACTIONS(3587),
    [anon_sym_STAR] = ACTIONS(3589),
    [anon_sym_GT_GT] = ACTIONS(3587),
    [anon_sym_if] = ACTIONS(3587),
    [anon_sym_in] = ACTIONS(3587),
    [anon_sym_EQ] = ACTIONS(3589),
    [anon_sym_AT] = ACTIONS(3587),
    [anon_sym_not] = ACTIONS(3587),
    [anon_sym_and] = ACTIONS(3587),
    [anon_sym_or] = ACTIONS(3587),
    [anon_sym_PLUS] = ACTIONS(3587),
    [anon_sym_DASH] = ACTIONS(3587),
    [anon_sym_SLASH] = ACTIONS(3589),
    [anon_sym_PERCENT] = ACTIONS(3587),
    [anon_sym_SLASH_SLASH] = ACTIONS(3587),
    [anon_sym_STAR_STAR] = ACTIONS(3587),
    [anon_sym_PIPE] = ACTIONS(3587),
    [anon_sym_AMP] = ACTIONS(3587),
    [anon_sym_CARET] = ACTIONS(3587),
    [anon_sym_LT_LT] = ACTIONS(3587),
    [anon_sym_LT] = ACTIONS(3589),
    [anon_sym_LT_EQ] = ACTIONS(3587),
    [anon_sym_EQ_EQ] = ACTIONS(3587),
    [anon_sym_BANG_EQ] = ACTIONS(3587),
    [anon_sym_GT_EQ] = ACTIONS(3587),
    [anon_sym_GT] = ACTIONS(3589),
    [anon_sym_LT_GT] = ACTIONS(3587),
    [anon_sym_is] = ACTIONS(3587),
    [anon_sym_LBRACK] = ACTIONS(3587),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3587),
  },
  [1488] = {
    [sym_list_splat] = STATE(1413),
    [sym_dictionary_splat] = STATE(1413),
    [sym__expression] = STATE(1414),
    [sym__primary_expression] = STATE(237),
    [sym_not_operator] = STATE(1414),
    [sym_boolean_operator] = STATE(1414),
    [sym_binary_operator] = STATE(237),
    [sym_unary_operator] = STATE(237),
    [sym_comparison_operator] = STATE(1414),
    [sym_lambda] = STATE(1414),
    [sym_attribute] = STATE(237),
    [sym_subscript] = STATE(237),
    [sym_call] = STATE(237),
    [sym_keyword_argument] = STATE(1413),
    [sym_list] = STATE(237),
    [sym_list_comprehension] = STATE(237),
    [sym_dictionary] = STATE(237),
    [sym_dictionary_comprehension] = STATE(237),
    [sym_set] = STATE(237),
    [sym_set_comprehension] = STATE(237),
    [sym_parenthesized_expression] = STATE(237),
    [sym_tuple] = STATE(237),
    [sym_generator_expression] = STATE(237),
    [sym_conditional_expression] = STATE(1414),
    [sym_concatenated_string] = STATE(237),
    [sym_string] = STATE(238),
    [sym_await] = STATE(1414),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3683),
    [anon_sym_STAR] = ACTIONS(931),
    [anon_sym_print] = ACTIONS(933),
    [anon_sym_exec] = ACTIONS(933),
    [anon_sym_not] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_lambda] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(419),
    [sym_float] = ACTIONS(419),
    [sym_identifier] = ACTIONS(935),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_none] = ACTIONS(419),
    [anon_sym_await] = ACTIONS(421),
    [sym_comment] = ACTIONS(73),
  },
  [1489] = {
    [sym__newline] = ACTIONS(3600),
    [anon_sym_DOT] = ACTIONS(3600),
    [anon_sym_from] = ACTIONS(3600),
    [anon_sym_LPAREN] = ACTIONS(3600),
    [anon_sym_COMMA] = ACTIONS(3600),
    [anon_sym_STAR] = ACTIONS(3602),
    [anon_sym_GT_GT] = ACTIONS(3600),
    [anon_sym_if] = ACTIONS(3600),
    [anon_sym_in] = ACTIONS(3600),
    [anon_sym_EQ] = ACTIONS(3602),
    [anon_sym_AT] = ACTIONS(3600),
    [anon_sym_not] = ACTIONS(3600),
    [anon_sym_and] = ACTIONS(3600),
    [anon_sym_or] = ACTIONS(3600),
    [anon_sym_PLUS] = ACTIONS(3600),
    [anon_sym_DASH] = ACTIONS(3600),
    [anon_sym_SLASH] = ACTIONS(3602),
    [anon_sym_PERCENT] = ACTIONS(3600),
    [anon_sym_SLASH_SLASH] = ACTIONS(3600),
    [anon_sym_STAR_STAR] = ACTIONS(3600),
    [anon_sym_PIPE] = ACTIONS(3600),
    [anon_sym_AMP] = ACTIONS(3600),
    [anon_sym_CARET] = ACTIONS(3600),
    [anon_sym_LT_LT] = ACTIONS(3600),
    [anon_sym_LT] = ACTIONS(3602),
    [anon_sym_LT_EQ] = ACTIONS(3600),
    [anon_sym_EQ_EQ] = ACTIONS(3600),
    [anon_sym_BANG_EQ] = ACTIONS(3600),
    [anon_sym_GT_EQ] = ACTIONS(3600),
    [anon_sym_GT] = ACTIONS(3602),
    [anon_sym_LT_GT] = ACTIONS(3600),
    [anon_sym_is] = ACTIONS(3600),
    [anon_sym_LBRACK] = ACTIONS(3600),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3600),
  },
  [1490] = {
    [sym__expression] = STATE(1422),
    [sym__primary_expression] = STATE(567),
    [sym_not_operator] = STATE(1422),
    [sym_boolean_operator] = STATE(1422),
    [sym_binary_operator] = STATE(567),
    [sym_unary_operator] = STATE(567),
    [sym_comparison_operator] = STATE(1422),
    [sym_lambda] = STATE(1422),
    [sym_attribute] = STATE(567),
    [sym_subscript] = STATE(567),
    [sym_slice] = STATE(1423),
    [sym_call] = STATE(567),
    [sym_list] = STATE(567),
    [sym_list_comprehension] = STATE(567),
    [sym_dictionary] = STATE(567),
    [sym_dictionary_comprehension] = STATE(567),
    [sym_set] = STATE(567),
    [sym_set_comprehension] = STATE(567),
    [sym_parenthesized_expression] = STATE(567),
    [sym_tuple] = STATE(567),
    [sym_generator_expression] = STATE(567),
    [sym_conditional_expression] = STATE(1422),
    [sym_concatenated_string] = STATE(567),
    [sym_string] = STATE(569),
    [sym_await] = STATE(1422),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(973),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(975),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(977),
    [anon_sym_lambda] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(3685),
    [sym_ellipsis] = ACTIONS(981),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(983),
    [sym_float] = ACTIONS(983),
    [sym_identifier] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_none] = ACTIONS(983),
    [anon_sym_await] = ACTIONS(985),
    [sym_comment] = ACTIONS(73),
  },
  [1491] = {
    [sym__newline] = ACTIONS(2647),
    [anon_sym_if] = ACTIONS(1378),
    [anon_sym_and] = ACTIONS(1380),
    [anon_sym_or] = ACTIONS(1382),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2647),
  },
  [1492] = {
    [sym__expression] = STATE(1714),
    [sym__primary_expression] = STATE(327),
    [sym_not_operator] = STATE(1714),
    [sym_boolean_operator] = STATE(1714),
    [sym_binary_operator] = STATE(327),
    [sym_unary_operator] = STATE(327),
    [sym_comparison_operator] = STATE(1714),
    [sym_lambda] = STATE(1714),
    [sym_attribute] = STATE(327),
    [sym_subscript] = STATE(327),
    [sym_call] = STATE(327),
    [sym_list] = STATE(327),
    [sym_list_comprehension] = STATE(327),
    [sym_dictionary] = STATE(327),
    [sym_dictionary_comprehension] = STATE(327),
    [sym_set] = STATE(327),
    [sym_set_comprehension] = STATE(327),
    [sym_parenthesized_expression] = STATE(327),
    [sym_tuple] = STATE(327),
    [sym_generator_expression] = STATE(327),
    [sym_conditional_expression] = STATE(1714),
    [sym_concatenated_string] = STATE(327),
    [sym_string] = STATE(328),
    [sym_await] = STATE(1714),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(547),
    [anon_sym_PLUS] = ACTIONS(549),
    [anon_sym_DASH] = ACTIONS(549),
    [anon_sym_TILDE] = ACTIONS(549),
    [anon_sym_lambda] = ACTIONS(551),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(553),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(555),
    [sym_float] = ACTIONS(555),
    [sym_identifier] = ACTIONS(555),
    [sym_true] = ACTIONS(555),
    [sym_false] = ACTIONS(555),
    [sym_none] = ACTIONS(555),
    [anon_sym_await] = ACTIONS(557),
    [sym_comment] = ACTIONS(73),
  },
  [1493] = {
    [sym_argument_list] = STATE(315),
    [sym_generator_expression] = STATE(315),
    [sym__newline] = ACTIONS(2942),
    [anon_sym_DOT] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_STAR] = ACTIONS(1384),
    [anon_sym_GT_GT] = ACTIONS(1386),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_in] = ACTIONS(2942),
    [anon_sym_AT] = ACTIONS(1390),
    [anon_sym_not] = ACTIONS(2942),
    [anon_sym_and] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(1394),
    [anon_sym_DASH] = ACTIONS(1394),
    [anon_sym_SLASH] = ACTIONS(1384),
    [anon_sym_PERCENT] = ACTIONS(1390),
    [anon_sym_SLASH_SLASH] = ACTIONS(1390),
    [anon_sym_STAR_STAR] = ACTIONS(1396),
    [anon_sym_PIPE] = ACTIONS(1398),
    [anon_sym_AMP] = ACTIONS(1400),
    [anon_sym_CARET] = ACTIONS(1402),
    [anon_sym_LT_LT] = ACTIONS(1386),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_LT_EQ] = ACTIONS(2942),
    [anon_sym_EQ_EQ] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_GT_EQ] = ACTIONS(2942),
    [anon_sym_GT] = ACTIONS(2944),
    [anon_sym_LT_GT] = ACTIONS(2942),
    [anon_sym_is] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(535),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2942),
  },
  [1494] = {
    [sym__newline] = ACTIONS(3565),
    [anon_sym_from] = ACTIONS(3565),
    [anon_sym_COMMA] = ACTIONS(3565),
    [anon_sym_if] = ACTIONS(567),
    [anon_sym_and] = ACTIONS(569),
    [anon_sym_or] = ACTIONS(571),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3565),
  },
  [1495] = {
    [anon_sym_if] = ACTIONS(599),
    [anon_sym_COLON] = ACTIONS(3565),
    [anon_sym_and] = ACTIONS(603),
    [anon_sym_or] = ACTIONS(605),
    [sym_comment] = ACTIONS(73),
  },
  [1496] = {
    [sym__string_start] = ACTIONS(3180),
    [ts_builtin_sym_end] = ACTIONS(3180),
    [anon_sym_import] = ACTIONS(3687),
    [anon_sym_from] = ACTIONS(3687),
    [anon_sym_LPAREN] = ACTIONS(3180),
    [anon_sym_print] = ACTIONS(3687),
    [anon_sym_assert] = ACTIONS(3687),
    [anon_sym_return] = ACTIONS(3687),
    [anon_sym_del] = ACTIONS(3687),
    [anon_sym_raise] = ACTIONS(3687),
    [anon_sym_pass] = ACTIONS(3687),
    [anon_sym_break] = ACTIONS(3687),
    [anon_sym_continue] = ACTIONS(3687),
    [anon_sym_if] = ACTIONS(3687),
    [anon_sym_elif] = ACTIONS(3687),
    [anon_sym_else] = ACTIONS(3687),
    [anon_sym_async] = ACTIONS(3687),
    [anon_sym_for] = ACTIONS(3687),
    [anon_sym_while] = ACTIONS(3687),
    [anon_sym_try] = ACTIONS(3687),
    [anon_sym_except] = ACTIONS(3687),
    [anon_sym_finally] = ACTIONS(3687),
    [anon_sym_with] = ACTIONS(3687),
    [anon_sym_def] = ACTIONS(3687),
    [anon_sym_global] = ACTIONS(3687),
    [anon_sym_nonlocal] = ACTIONS(3687),
    [anon_sym_exec] = ACTIONS(3687),
    [anon_sym_class] = ACTIONS(3687),
    [anon_sym_AT] = ACTIONS(3180),
    [anon_sym_not] = ACTIONS(3687),
    [anon_sym_PLUS] = ACTIONS(3180),
    [anon_sym_DASH] = ACTIONS(3180),
    [anon_sym_TILDE] = ACTIONS(3180),
    [anon_sym_lambda] = ACTIONS(3687),
    [anon_sym_yield] = ACTIONS(3687),
    [anon_sym_LBRACK] = ACTIONS(3180),
    [sym_ellipsis] = ACTIONS(3180),
    [anon_sym_LBRACE] = ACTIONS(3180),
    [sym_integer] = ACTIONS(3687),
    [sym_float] = ACTIONS(3687),
    [sym_identifier] = ACTIONS(3687),
    [sym_true] = ACTIONS(3687),
    [sym_false] = ACTIONS(3687),
    [sym_none] = ACTIONS(3687),
    [anon_sym_await] = ACTIONS(3687),
    [sym_comment] = ACTIONS(73),
  },
  [1497] = {
    [anon_sym_if] = ACTIONS(599),
    [anon_sym_COLON] = ACTIONS(3689),
    [anon_sym_and] = ACTIONS(603),
    [anon_sym_or] = ACTIONS(605),
    [sym_comment] = ACTIONS(73),
  },
  [1498] = {
    [sym__simple_statements] = STATE(1716),
    [sym_import_statement] = STATE(34),
    [sym_future_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym__suite] = STATE(1716),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(1448),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1499] = {
    [sym__string_start] = ACTIONS(3691),
    [ts_builtin_sym_end] = ACTIONS(3691),
    [anon_sym_import] = ACTIONS(3693),
    [anon_sym_from] = ACTIONS(3693),
    [anon_sym_LPAREN] = ACTIONS(3691),
    [anon_sym_print] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_del] = ACTIONS(3693),
    [anon_sym_raise] = ACTIONS(3693),
    [anon_sym_pass] = ACTIONS(3693),
    [anon_sym_break] = ACTIONS(3693),
    [anon_sym_continue] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_async] = ACTIONS(3693),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_with] = ACTIONS(3693),
    [anon_sym_def] = ACTIONS(3693),
    [anon_sym_global] = ACTIONS(3693),
    [anon_sym_nonlocal] = ACTIONS(3693),
    [anon_sym_exec] = ACTIONS(3693),
    [anon_sym_class] = ACTIONS(3693),
    [anon_sym_AT] = ACTIONS(3691),
    [anon_sym_not] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3691),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_TILDE] = ACTIONS(3691),
    [anon_sym_lambda] = ACTIONS(3693),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3691),
    [sym_ellipsis] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3691),
    [sym_integer] = ACTIONS(3693),
    [sym_float] = ACTIONS(3693),
    [sym_identifier] = ACTIONS(3693),
    [sym_true] = ACTIONS(3693),
    [sym_false] = ACTIONS(3693),
    [sym_none] = ACTIONS(3693),
    [anon_sym_await] = ACTIONS(3693),
    [sym_comment] = ACTIONS(73),
  },
  [1500] = {
    [sym_elif_clause] = STATE(1500),
    [aux_sym_if_statement_repeat1] = STATE(1500),
    [sym__string_start] = ACTIONS(3695),
    [ts_builtin_sym_end] = ACTIONS(3695),
    [anon_sym_import] = ACTIONS(3697),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_LPAREN] = ACTIONS(3695),
    [anon_sym_print] = ACTIONS(3697),
    [anon_sym_assert] = ACTIONS(3697),
    [anon_sym_return] = ACTIONS(3697),
    [anon_sym_del] = ACTIONS(3697),
    [anon_sym_raise] = ACTIONS(3697),
    [anon_sym_pass] = ACTIONS(3697),
    [anon_sym_break] = ACTIONS(3697),
    [anon_sym_continue] = ACTIONS(3697),
    [anon_sym_if] = ACTIONS(3697),
    [anon_sym_elif] = ACTIONS(3699),
    [anon_sym_else] = ACTIONS(3697),
    [anon_sym_async] = ACTIONS(3697),
    [anon_sym_for] = ACTIONS(3697),
    [anon_sym_while] = ACTIONS(3697),
    [anon_sym_try] = ACTIONS(3697),
    [anon_sym_with] = ACTIONS(3697),
    [anon_sym_def] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_nonlocal] = ACTIONS(3697),
    [anon_sym_exec] = ACTIONS(3697),
    [anon_sym_class] = ACTIONS(3697),
    [anon_sym_AT] = ACTIONS(3695),
    [anon_sym_not] = ACTIONS(3697),
    [anon_sym_PLUS] = ACTIONS(3695),
    [anon_sym_DASH] = ACTIONS(3695),
    [anon_sym_TILDE] = ACTIONS(3695),
    [anon_sym_lambda] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_LBRACK] = ACTIONS(3695),
    [sym_ellipsis] = ACTIONS(3695),
    [anon_sym_LBRACE] = ACTIONS(3695),
    [sym_integer] = ACTIONS(3697),
    [sym_float] = ACTIONS(3697),
    [sym_identifier] = ACTIONS(3697),
    [sym_true] = ACTIONS(3697),
    [sym_false] = ACTIONS(3697),
    [sym_none] = ACTIONS(3697),
    [anon_sym_await] = ACTIONS(3697),
    [sym_comment] = ACTIONS(73),
  },
  [1501] = {
    [sym__simple_statements] = STATE(1717),
    [sym_import_statement] = STATE(34),
    [sym_future_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym__suite] = STATE(1717),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(1448),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1502] = {
    [sym__string_start] = ACTIONS(3702),
    [ts_builtin_sym_end] = ACTIONS(3702),
    [anon_sym_import] = ACTIONS(3704),
    [anon_sym_from] = ACTIONS(3704),
    [anon_sym_LPAREN] = ACTIONS(3702),
    [anon_sym_print] = ACTIONS(3704),
    [anon_sym_assert] = ACTIONS(3704),
    [anon_sym_return] = ACTIONS(3704),
    [anon_sym_del] = ACTIONS(3704),
    [anon_sym_raise] = ACTIONS(3704),
    [anon_sym_pass] = ACTIONS(3704),
    [anon_sym_break] = ACTIONS(3704),
    [anon_sym_continue] = ACTIONS(3704),
    [anon_sym_if] = ACTIONS(3704),
    [anon_sym_async] = ACTIONS(3704),
    [anon_sym_for] = ACTIONS(3704),
    [anon_sym_while] = ACTIONS(3704),
    [anon_sym_try] = ACTIONS(3704),
    [anon_sym_with] = ACTIONS(3704),
    [anon_sym_def] = ACTIONS(3704),
    [anon_sym_global] = ACTIONS(3704),
    [anon_sym_nonlocal] = ACTIONS(3704),
    [anon_sym_exec] = ACTIONS(3704),
    [anon_sym_class] = ACTIONS(3704),
    [anon_sym_AT] = ACTIONS(3702),
    [anon_sym_not] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3702),
    [anon_sym_DASH] = ACTIONS(3702),
    [anon_sym_TILDE] = ACTIONS(3702),
    [anon_sym_lambda] = ACTIONS(3704),
    [anon_sym_yield] = ACTIONS(3704),
    [anon_sym_LBRACK] = ACTIONS(3702),
    [sym_ellipsis] = ACTIONS(3702),
    [anon_sym_LBRACE] = ACTIONS(3702),
    [sym_integer] = ACTIONS(3704),
    [sym_float] = ACTIONS(3704),
    [sym_identifier] = ACTIONS(3704),
    [sym_true] = ACTIONS(3704),
    [sym_false] = ACTIONS(3704),
    [sym_none] = ACTIONS(3704),
    [anon_sym_await] = ACTIONS(3704),
    [sym_comment] = ACTIONS(73),
  },
  [1503] = {
    [sym__string_start] = ACTIONS(3706),
    [ts_builtin_sym_end] = ACTIONS(3706),
    [anon_sym_import] = ACTIONS(3708),
    [anon_sym_from] = ACTIONS(3708),
    [anon_sym_LPAREN] = ACTIONS(3706),
    [anon_sym_print] = ACTIONS(3708),
    [anon_sym_assert] = ACTIONS(3708),
    [anon_sym_return] = ACTIONS(3708),
    [anon_sym_del] = ACTIONS(3708),
    [anon_sym_raise] = ACTIONS(3708),
    [anon_sym_pass] = ACTIONS(3708),
    [anon_sym_break] = ACTIONS(3708),
    [anon_sym_continue] = ACTIONS(3708),
    [anon_sym_if] = ACTIONS(3708),
    [anon_sym_async] = ACTIONS(3708),
    [anon_sym_for] = ACTIONS(3708),
    [anon_sym_while] = ACTIONS(3708),
    [anon_sym_try] = ACTIONS(3708),
    [anon_sym_with] = ACTIONS(3708),
    [anon_sym_def] = ACTIONS(3708),
    [anon_sym_global] = ACTIONS(3708),
    [anon_sym_nonlocal] = ACTIONS(3708),
    [anon_sym_exec] = ACTIONS(3708),
    [anon_sym_class] = ACTIONS(3708),
    [anon_sym_AT] = ACTIONS(3706),
    [anon_sym_not] = ACTIONS(3708),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_TILDE] = ACTIONS(3706),
    [anon_sym_lambda] = ACTIONS(3708),
    [anon_sym_yield] = ACTIONS(3708),
    [anon_sym_LBRACK] = ACTIONS(3706),
    [sym_ellipsis] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3706),
    [sym_integer] = ACTIONS(3708),
    [sym_float] = ACTIONS(3708),
    [sym_identifier] = ACTIONS(3708),
    [sym_true] = ACTIONS(3708),
    [sym_false] = ACTIONS(3708),
    [sym_none] = ACTIONS(3708),
    [anon_sym_await] = ACTIONS(3708),
    [sym_comment] = ACTIONS(73),
  },
  [1504] = {
    [anon_sym_COLON] = ACTIONS(3710),
    [sym_comment] = ACTIONS(73),
  },
  [1505] = {
    [sym_else_clause] = STATE(1719),
    [sym__string_start] = ACTIONS(3712),
    [ts_builtin_sym_end] = ACTIONS(3712),
    [anon_sym_import] = ACTIONS(3714),
    [anon_sym_from] = ACTIONS(3714),
    [anon_sym_LPAREN] = ACTIONS(3712),
    [anon_sym_print] = ACTIONS(3714),
    [anon_sym_assert] = ACTIONS(3714),
    [anon_sym_return] = ACTIONS(3714),
    [anon_sym_del] = ACTIONS(3714),
    [anon_sym_raise] = ACTIONS(3714),
    [anon_sym_pass] = ACTIONS(3714),
    [anon_sym_break] = ACTIONS(3714),
    [anon_sym_continue] = ACTIONS(3714),
    [anon_sym_if] = ACTIONS(3714),
    [anon_sym_else] = ACTIONS(2371),
    [anon_sym_async] = ACTIONS(3714),
    [anon_sym_for] = ACTIONS(3714),
    [anon_sym_while] = ACTIONS(3714),
    [anon_sym_try] = ACTIONS(3714),
    [anon_sym_with] = ACTIONS(3714),
    [anon_sym_def] = ACTIONS(3714),
    [anon_sym_global] = ACTIONS(3714),
    [anon_sym_nonlocal] = ACTIONS(3714),
    [anon_sym_exec] = ACTIONS(3714),
    [anon_sym_class] = ACTIONS(3714),
    [anon_sym_AT] = ACTIONS(3712),
    [anon_sym_not] = ACTIONS(3714),
    [anon_sym_PLUS] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_lambda] = ACTIONS(3714),
    [anon_sym_yield] = ACTIONS(3714),
    [anon_sym_LBRACK] = ACTIONS(3712),
    [sym_ellipsis] = ACTIONS(3712),
    [anon_sym_LBRACE] = ACTIONS(3712),
    [sym_integer] = ACTIONS(3714),
    [sym_float] = ACTIONS(3714),
    [sym_identifier] = ACTIONS(3714),
    [sym_true] = ACTIONS(3714),
    [sym_false] = ACTIONS(3714),
    [sym_none] = ACTIONS(3714),
    [anon_sym_await] = ACTIONS(3714),
    [sym_comment] = ACTIONS(73),
  },
  [1506] = {
    [anon_sym_COMMA] = ACTIONS(1921),
    [anon_sym_if] = ACTIONS(1610),
    [anon_sym_COLON] = ACTIONS(1921),
    [anon_sym_and] = ACTIONS(1612),
    [anon_sym_or] = ACTIONS(1614),
    [sym_comment] = ACTIONS(73),
  },
  [1507] = {
    [sym__expression] = STATE(1506),
    [sym__primary_expression] = STATE(432),
    [sym_not_operator] = STATE(1506),
    [sym_boolean_operator] = STATE(1506),
    [sym_binary_operator] = STATE(432),
    [sym_unary_operator] = STATE(432),
    [sym_comparison_operator] = STATE(1506),
    [sym_lambda] = STATE(1506),
    [sym_attribute] = STATE(432),
    [sym_subscript] = STATE(432),
    [sym_call] = STATE(432),
    [sym_list] = STATE(432),
    [sym_list_comprehension] = STATE(432),
    [sym_dictionary] = STATE(432),
    [sym_dictionary_comprehension] = STATE(432),
    [sym_set] = STATE(432),
    [sym_set_comprehension] = STATE(432),
    [sym_parenthesized_expression] = STATE(432),
    [sym_tuple] = STATE(432),
    [sym_generator_expression] = STATE(432),
    [sym_conditional_expression] = STATE(1506),
    [sym_concatenated_string] = STATE(432),
    [sym_string] = STATE(433),
    [sym_await] = STATE(1506),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(1961),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(735),
    [anon_sym_lambda] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(741),
    [sym_float] = ACTIONS(741),
    [sym_identifier] = ACTIONS(741),
    [sym_true] = ACTIONS(741),
    [sym_false] = ACTIONS(741),
    [sym_none] = ACTIONS(741),
    [anon_sym_await] = ACTIONS(743),
    [sym_comment] = ACTIONS(73),
  },
  [1508] = {
    [aux_sym_print_statement_repeat1] = STATE(1508),
    [anon_sym_COMMA] = ACTIONS(3716),
    [anon_sym_COLON] = ACTIONS(1921),
    [sym_comment] = ACTIONS(73),
  },
  [1509] = {
    [sym__simple_statements] = STATE(1722),
    [sym_import_statement] = STATE(799),
    [sym_future_import_statement] = STATE(799),
    [sym_import_from_statement] = STATE(799),
    [sym_print_statement] = STATE(799),
    [sym_assert_statement] = STATE(799),
    [sym_expression_statement] = STATE(799),
    [sym_return_statement] = STATE(799),
    [sym_delete_statement] = STATE(799),
    [sym_raise_statement] = STATE(799),
    [sym_pass_statement] = STATE(799),
    [sym_break_statement] = STATE(799),
    [sym_continue_statement] = STATE(799),
    [sym_global_statement] = STATE(799),
    [sym_nonlocal_statement] = STATE(799),
    [sym_exec_statement] = STATE(799),
    [sym__suite] = STATE(1722),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(3719),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1510] = {
    [anon_sym_in] = ACTIONS(3721),
    [sym_comment] = ACTIONS(73),
  },
  [1511] = {
    [aux_sym_with_statement_repeat1] = STATE(1725),
    [anon_sym_COMMA] = ACTIONS(661),
    [anon_sym_COLON] = ACTIONS(3723),
    [sym_comment] = ACTIONS(73),
  },
  [1512] = {
    [sym_parameters] = STATE(1726),
    [anon_sym_LPAREN] = ACTIONS(699),
    [sym_comment] = ACTIONS(73),
  },
  [1513] = {
    [sym_expression_list] = STATE(1727),
    [sym__expression] = STATE(778),
    [sym__primary_expression] = STATE(432),
    [sym_not_operator] = STATE(778),
    [sym_boolean_operator] = STATE(778),
    [sym_binary_operator] = STATE(432),
    [sym_unary_operator] = STATE(432),
    [sym_comparison_operator] = STATE(778),
    [sym_lambda] = STATE(778),
    [sym_attribute] = STATE(432),
    [sym_subscript] = STATE(432),
    [sym_call] = STATE(432),
    [sym_list] = STATE(432),
    [sym_list_comprehension] = STATE(432),
    [sym_dictionary] = STATE(432),
    [sym_dictionary_comprehension] = STATE(432),
    [sym_set] = STATE(432),
    [sym_set_comprehension] = STATE(432),
    [sym_parenthesized_expression] = STATE(432),
    [sym_tuple] = STATE(432),
    [sym_generator_expression] = STATE(432),
    [sym_conditional_expression] = STATE(778),
    [sym_concatenated_string] = STATE(432),
    [sym_string] = STATE(433),
    [sym_await] = STATE(778),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(735),
    [anon_sym_lambda] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(741),
    [sym_float] = ACTIONS(741),
    [sym_identifier] = ACTIONS(741),
    [sym_true] = ACTIONS(741),
    [sym_false] = ACTIONS(741),
    [sym_none] = ACTIONS(741),
    [anon_sym_await] = ACTIONS(743),
    [sym_comment] = ACTIONS(73),
  },
  [1514] = {
    [sym__simple_statements] = STATE(1728),
    [sym_import_statement] = STATE(799),
    [sym_future_import_statement] = STATE(799),
    [sym_import_from_statement] = STATE(799),
    [sym_print_statement] = STATE(799),
    [sym_assert_statement] = STATE(799),
    [sym_expression_statement] = STATE(799),
    [sym_return_statement] = STATE(799),
    [sym_delete_statement] = STATE(799),
    [sym_raise_statement] = STATE(799),
    [sym_pass_statement] = STATE(799),
    [sym_break_statement] = STATE(799),
    [sym_continue_statement] = STATE(799),
    [sym_global_statement] = STATE(799),
    [sym_nonlocal_statement] = STATE(799),
    [sym_exec_statement] = STATE(799),
    [sym__suite] = STATE(1728),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(3719),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1515] = {
    [sym_except_clause] = STATE(1732),
    [sym_finally_clause] = STATE(1731),
    [aux_sym_try_statement_repeat1] = STATE(1732),
    [anon_sym_except] = ACTIONS(3725),
    [anon_sym_finally] = ACTIONS(3727),
    [sym_comment] = ACTIONS(73),
  },
  [1516] = {
    [sym__simple_statements] = STATE(1733),
    [sym_import_statement] = STATE(799),
    [sym_future_import_statement] = STATE(799),
    [sym_import_from_statement] = STATE(799),
    [sym_print_statement] = STATE(799),
    [sym_assert_statement] = STATE(799),
    [sym_expression_statement] = STATE(799),
    [sym_return_statement] = STATE(799),
    [sym_delete_statement] = STATE(799),
    [sym_raise_statement] = STATE(799),
    [sym_pass_statement] = STATE(799),
    [sym_break_statement] = STATE(799),
    [sym_continue_statement] = STATE(799),
    [sym_global_statement] = STATE(799),
    [sym_nonlocal_statement] = STATE(799),
    [sym_exec_statement] = STATE(799),
    [sym__suite] = STATE(1733),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(3719),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1517] = {
    [aux_sym_with_statement_repeat1] = STATE(813),
    [anon_sym_COMMA] = ACTIONS(661),
    [anon_sym_COLON] = ACTIONS(3723),
    [sym_comment] = ACTIONS(73),
  },
  [1518] = {
    [anon_sym_COLON] = ACTIONS(3729),
    [anon_sym_DASH_GT] = ACTIONS(3731),
    [sym_comment] = ACTIONS(73),
  },
  [1519] = {
    [sym__simple_statements] = STATE(1736),
    [sym_import_statement] = STATE(799),
    [sym_future_import_statement] = STATE(799),
    [sym_import_from_statement] = STATE(799),
    [sym_print_statement] = STATE(799),
    [sym_assert_statement] = STATE(799),
    [sym_expression_statement] = STATE(799),
    [sym_return_statement] = STATE(799),
    [sym_delete_statement] = STATE(799),
    [sym_raise_statement] = STATE(799),
    [sym_pass_statement] = STATE(799),
    [sym_break_statement] = STATE(799),
    [sym_continue_statement] = STATE(799),
    [sym_global_statement] = STATE(799),
    [sym_nonlocal_statement] = STATE(799),
    [sym_exec_statement] = STATE(799),
    [sym__suite] = STATE(1736),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(3719),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1520] = {
    [anon_sym_COLON] = ACTIONS(3733),
    [sym_comment] = ACTIONS(73),
  },
  [1521] = {
    [sym__dedent] = ACTIONS(1866),
    [sym__string_start] = ACTIONS(1866),
    [anon_sym_import] = ACTIONS(1868),
    [anon_sym_from] = ACTIONS(1868),
    [anon_sym_LPAREN] = ACTIONS(1866),
    [anon_sym_print] = ACTIONS(1868),
    [anon_sym_assert] = ACTIONS(1868),
    [anon_sym_return] = ACTIONS(1868),
    [anon_sym_del] = ACTIONS(1868),
    [anon_sym_raise] = ACTIONS(1868),
    [anon_sym_pass] = ACTIONS(1868),
    [anon_sym_break] = ACTIONS(1868),
    [anon_sym_continue] = ACTIONS(1868),
    [anon_sym_if] = ACTIONS(1868),
    [anon_sym_elif] = ACTIONS(1868),
    [anon_sym_else] = ACTIONS(1868),
    [anon_sym_async] = ACTIONS(1868),
    [anon_sym_for] = ACTIONS(1868),
    [anon_sym_while] = ACTIONS(1868),
    [anon_sym_try] = ACTIONS(1868),
    [anon_sym_except] = ACTIONS(1868),
    [anon_sym_finally] = ACTIONS(1868),
    [anon_sym_with] = ACTIONS(1868),
    [anon_sym_def] = ACTIONS(1868),
    [anon_sym_global] = ACTIONS(1868),
    [anon_sym_nonlocal] = ACTIONS(1868),
    [anon_sym_exec] = ACTIONS(1868),
    [anon_sym_class] = ACTIONS(1868),
    [anon_sym_AT] = ACTIONS(1866),
    [anon_sym_not] = ACTIONS(1868),
    [anon_sym_PLUS] = ACTIONS(1866),
    [anon_sym_DASH] = ACTIONS(1866),
    [anon_sym_TILDE] = ACTIONS(1866),
    [anon_sym_lambda] = ACTIONS(1868),
    [anon_sym_yield] = ACTIONS(1868),
    [anon_sym_LBRACK] = ACTIONS(1866),
    [sym_ellipsis] = ACTIONS(1866),
    [anon_sym_LBRACE] = ACTIONS(1866),
    [sym_integer] = ACTIONS(1868),
    [sym_float] = ACTIONS(1868),
    [sym_identifier] = ACTIONS(1868),
    [sym_true] = ACTIONS(1868),
    [sym_false] = ACTIONS(1868),
    [sym_none] = ACTIONS(1868),
    [anon_sym_await] = ACTIONS(1868),
    [sym_comment] = ACTIONS(73),
  },
  [1522] = {
    [sym_import_statement] = STATE(517),
    [sym_future_import_statement] = STATE(517),
    [sym_import_from_statement] = STATE(517),
    [sym_print_statement] = STATE(517),
    [sym_assert_statement] = STATE(517),
    [sym_expression_statement] = STATE(517),
    [sym_return_statement] = STATE(517),
    [sym_delete_statement] = STATE(517),
    [sym_raise_statement] = STATE(517),
    [sym_pass_statement] = STATE(517),
    [sym_break_statement] = STATE(517),
    [sym_continue_statement] = STATE(517),
    [sym_global_statement] = STATE(517),
    [sym_nonlocal_statement] = STATE(517),
    [sym_exec_statement] = STATE(517),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__newline] = ACTIONS(3735),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1523] = {
    [anon_sym_except] = ACTIONS(2860),
    [anon_sym_finally] = ACTIONS(2860),
    [sym_comment] = ACTIONS(73),
  },
  [1524] = {
    [sym__string_start] = ACTIONS(3737),
    [ts_builtin_sym_end] = ACTIONS(3737),
    [anon_sym_import] = ACTIONS(3739),
    [anon_sym_from] = ACTIONS(3739),
    [anon_sym_LPAREN] = ACTIONS(3737),
    [anon_sym_print] = ACTIONS(3739),
    [anon_sym_assert] = ACTIONS(3739),
    [anon_sym_return] = ACTIONS(3739),
    [anon_sym_del] = ACTIONS(3739),
    [anon_sym_raise] = ACTIONS(3739),
    [anon_sym_pass] = ACTIONS(3739),
    [anon_sym_break] = ACTIONS(3739),
    [anon_sym_continue] = ACTIONS(3739),
    [anon_sym_if] = ACTIONS(3739),
    [anon_sym_else] = ACTIONS(3739),
    [anon_sym_async] = ACTIONS(3739),
    [anon_sym_for] = ACTIONS(3739),
    [anon_sym_while] = ACTIONS(3739),
    [anon_sym_try] = ACTIONS(3739),
    [anon_sym_except] = ACTIONS(3739),
    [anon_sym_finally] = ACTIONS(3739),
    [anon_sym_with] = ACTIONS(3739),
    [anon_sym_def] = ACTIONS(3739),
    [anon_sym_global] = ACTIONS(3739),
    [anon_sym_nonlocal] = ACTIONS(3739),
    [anon_sym_exec] = ACTIONS(3739),
    [anon_sym_class] = ACTIONS(3739),
    [anon_sym_AT] = ACTIONS(3737),
    [anon_sym_not] = ACTIONS(3739),
    [anon_sym_PLUS] = ACTIONS(3737),
    [anon_sym_DASH] = ACTIONS(3737),
    [anon_sym_TILDE] = ACTIONS(3737),
    [anon_sym_lambda] = ACTIONS(3739),
    [anon_sym_yield] = ACTIONS(3739),
    [anon_sym_LBRACK] = ACTIONS(3737),
    [sym_ellipsis] = ACTIONS(3737),
    [anon_sym_LBRACE] = ACTIONS(3737),
    [sym_integer] = ACTIONS(3739),
    [sym_float] = ACTIONS(3739),
    [sym_identifier] = ACTIONS(3739),
    [sym_true] = ACTIONS(3739),
    [sym_false] = ACTIONS(3739),
    [sym_none] = ACTIONS(3739),
    [anon_sym_await] = ACTIONS(3739),
    [sym_comment] = ACTIONS(73),
  },
  [1525] = {
    [sym__expression] = STATE(1739),
    [sym__primary_expression] = STATE(102),
    [sym_not_operator] = STATE(1739),
    [sym_boolean_operator] = STATE(1739),
    [sym_binary_operator] = STATE(102),
    [sym_unary_operator] = STATE(102),
    [sym_comparison_operator] = STATE(1739),
    [sym_lambda] = STATE(1739),
    [sym_attribute] = STATE(102),
    [sym_subscript] = STATE(102),
    [sym_call] = STATE(102),
    [sym_list] = STATE(102),
    [sym_list_comprehension] = STATE(102),
    [sym_dictionary] = STATE(102),
    [sym_dictionary_comprehension] = STATE(102),
    [sym_set] = STATE(102),
    [sym_set_comprehension] = STATE(102),
    [sym_parenthesized_expression] = STATE(102),
    [sym_tuple] = STATE(102),
    [sym_generator_expression] = STATE(102),
    [sym_conditional_expression] = STATE(1739),
    [sym_concatenated_string] = STATE(102),
    [sym_string] = STATE(103),
    [sym_await] = STATE(1739),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [1526] = {
    [sym__simple_statements] = STATE(1740),
    [sym_import_statement] = STATE(34),
    [sym_future_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym__suite] = STATE(1740),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(1448),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1527] = {
    [sym__string_start] = ACTIONS(3741),
    [ts_builtin_sym_end] = ACTIONS(3741),
    [anon_sym_import] = ACTIONS(3743),
    [anon_sym_from] = ACTIONS(3743),
    [anon_sym_LPAREN] = ACTIONS(3741),
    [anon_sym_print] = ACTIONS(3743),
    [anon_sym_assert] = ACTIONS(3743),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_del] = ACTIONS(3743),
    [anon_sym_raise] = ACTIONS(3743),
    [anon_sym_pass] = ACTIONS(3743),
    [anon_sym_break] = ACTIONS(3743),
    [anon_sym_continue] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_async] = ACTIONS(3743),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_with] = ACTIONS(3743),
    [anon_sym_def] = ACTIONS(3743),
    [anon_sym_global] = ACTIONS(3743),
    [anon_sym_nonlocal] = ACTIONS(3743),
    [anon_sym_exec] = ACTIONS(3743),
    [anon_sym_class] = ACTIONS(3743),
    [anon_sym_AT] = ACTIONS(3741),
    [anon_sym_not] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3741),
    [anon_sym_DASH] = ACTIONS(3741),
    [anon_sym_TILDE] = ACTIONS(3741),
    [anon_sym_lambda] = ACTIONS(3743),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3741),
    [sym_ellipsis] = ACTIONS(3741),
    [anon_sym_LBRACE] = ACTIONS(3741),
    [sym_integer] = ACTIONS(3743),
    [sym_float] = ACTIONS(3743),
    [sym_identifier] = ACTIONS(3743),
    [sym_true] = ACTIONS(3743),
    [sym_false] = ACTIONS(3743),
    [sym_none] = ACTIONS(3743),
    [anon_sym_await] = ACTIONS(3743),
    [sym_comment] = ACTIONS(73),
  },
  [1528] = {
    [sym__string_start] = ACTIONS(3745),
    [ts_builtin_sym_end] = ACTIONS(3745),
    [anon_sym_import] = ACTIONS(3747),
    [anon_sym_from] = ACTIONS(3747),
    [anon_sym_LPAREN] = ACTIONS(3745),
    [anon_sym_print] = ACTIONS(3747),
    [anon_sym_assert] = ACTIONS(3747),
    [anon_sym_return] = ACTIONS(3747),
    [anon_sym_del] = ACTIONS(3747),
    [anon_sym_raise] = ACTIONS(3747),
    [anon_sym_pass] = ACTIONS(3747),
    [anon_sym_break] = ACTIONS(3747),
    [anon_sym_continue] = ACTIONS(3747),
    [anon_sym_if] = ACTIONS(3747),
    [anon_sym_async] = ACTIONS(3747),
    [anon_sym_for] = ACTIONS(3747),
    [anon_sym_while] = ACTIONS(3747),
    [anon_sym_try] = ACTIONS(3747),
    [anon_sym_with] = ACTIONS(3747),
    [anon_sym_def] = ACTIONS(3747),
    [anon_sym_global] = ACTIONS(3747),
    [anon_sym_nonlocal] = ACTIONS(3747),
    [anon_sym_exec] = ACTIONS(3747),
    [anon_sym_class] = ACTIONS(3747),
    [anon_sym_AT] = ACTIONS(3745),
    [anon_sym_not] = ACTIONS(3747),
    [anon_sym_PLUS] = ACTIONS(3745),
    [anon_sym_DASH] = ACTIONS(3745),
    [anon_sym_TILDE] = ACTIONS(3745),
    [anon_sym_lambda] = ACTIONS(3747),
    [anon_sym_yield] = ACTIONS(3747),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [sym_ellipsis] = ACTIONS(3745),
    [anon_sym_LBRACE] = ACTIONS(3745),
    [sym_integer] = ACTIONS(3747),
    [sym_float] = ACTIONS(3747),
    [sym_identifier] = ACTIONS(3747),
    [sym_true] = ACTIONS(3747),
    [sym_false] = ACTIONS(3747),
    [sym_none] = ACTIONS(3747),
    [anon_sym_await] = ACTIONS(3747),
    [sym_comment] = ACTIONS(73),
  },
  [1529] = {
    [anon_sym_COMMA] = ACTIONS(3565),
    [anon_sym_as] = ACTIONS(3565),
    [anon_sym_if] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(3565),
    [anon_sym_and] = ACTIONS(671),
    [anon_sym_or] = ACTIONS(673),
    [sym_comment] = ACTIONS(73),
  },
  [1530] = {
    [anon_sym_RPAREN] = ACTIONS(2526),
    [anon_sym_COMMA] = ACTIONS(2526),
    [anon_sym_if] = ACTIONS(3225),
    [anon_sym_COLON] = ACTIONS(2526),
    [anon_sym_and] = ACTIONS(3227),
    [anon_sym_or] = ACTIONS(3229),
    [sym_comment] = ACTIONS(73),
  },
  [1531] = {
    [anon_sym_RPAREN] = ACTIONS(723),
    [anon_sym_COMMA] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(723),
    [anon_sym_COLON] = ACTIONS(723),
    [anon_sym_and] = ACTIONS(3227),
    [anon_sym_or] = ACTIONS(3229),
    [sym_comment] = ACTIONS(73),
  },
  [1532] = {
    [sym__expression] = STATE(1741),
    [sym__primary_expression] = STATE(1229),
    [sym_not_operator] = STATE(1741),
    [sym_boolean_operator] = STATE(1741),
    [sym_binary_operator] = STATE(1229),
    [sym_unary_operator] = STATE(1229),
    [sym_comparison_operator] = STATE(1741),
    [sym_lambda] = STATE(1741),
    [sym_attribute] = STATE(1229),
    [sym_subscript] = STATE(1229),
    [sym_call] = STATE(1229),
    [sym_list] = STATE(1229),
    [sym_list_comprehension] = STATE(1229),
    [sym_dictionary] = STATE(1229),
    [sym_dictionary_comprehension] = STATE(1229),
    [sym_set] = STATE(1229),
    [sym_set_comprehension] = STATE(1229),
    [sym_parenthesized_expression] = STATE(1229),
    [sym_tuple] = STATE(1229),
    [sym_generator_expression] = STATE(1229),
    [sym_conditional_expression] = STATE(1741),
    [sym_concatenated_string] = STATE(1229),
    [sym_string] = STATE(1230),
    [sym_await] = STATE(1741),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2485),
    [anon_sym_PLUS] = ACTIONS(2487),
    [anon_sym_DASH] = ACTIONS(2487),
    [anon_sym_TILDE] = ACTIONS(2487),
    [anon_sym_lambda] = ACTIONS(2489),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2491),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2493),
    [sym_float] = ACTIONS(2493),
    [sym_identifier] = ACTIONS(2493),
    [sym_true] = ACTIONS(2493),
    [sym_false] = ACTIONS(2493),
    [sym_none] = ACTIONS(2493),
    [anon_sym_await] = ACTIONS(2495),
    [sym_comment] = ACTIONS(73),
  },
  [1533] = {
    [anon_sym_COLON] = ACTIONS(3749),
    [sym_comment] = ACTIONS(73),
  },
  [1534] = {
    [sym__expression] = STATE(1743),
    [sym__primary_expression] = STATE(538),
    [sym_not_operator] = STATE(1743),
    [sym_boolean_operator] = STATE(1743),
    [sym_binary_operator] = STATE(538),
    [sym_unary_operator] = STATE(538),
    [sym_comparison_operator] = STATE(1743),
    [sym_lambda] = STATE(1743),
    [sym_attribute] = STATE(538),
    [sym_subscript] = STATE(538),
    [sym_call] = STATE(538),
    [sym_list] = STATE(538),
    [sym_list_comprehension] = STATE(538),
    [sym_dictionary] = STATE(538),
    [sym_dictionary_comprehension] = STATE(538),
    [sym_set] = STATE(538),
    [sym_set_comprehension] = STATE(538),
    [sym_parenthesized_expression] = STATE(538),
    [sym_tuple] = STATE(538),
    [sym_generator_expression] = STATE(538),
    [sym_conditional_expression] = STATE(1743),
    [sym_concatenated_string] = STATE(538),
    [sym_string] = STATE(539),
    [sym_await] = STATE(1743),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_lambda] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(917),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(919),
    [sym_float] = ACTIONS(919),
    [sym_identifier] = ACTIONS(919),
    [sym_true] = ACTIONS(919),
    [sym_false] = ACTIONS(919),
    [sym_none] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(921),
    [sym_comment] = ACTIONS(73),
  },
  [1535] = {
    [sym__expression] = STATE(652),
    [sym__primary_expression] = STATE(1229),
    [sym_not_operator] = STATE(652),
    [sym_boolean_operator] = STATE(652),
    [sym_binary_operator] = STATE(1229),
    [sym_unary_operator] = STATE(1229),
    [sym_comparison_operator] = STATE(652),
    [sym_lambda] = STATE(652),
    [sym_attribute] = STATE(1229),
    [sym_subscript] = STATE(1229),
    [sym_call] = STATE(1229),
    [sym_list] = STATE(1229),
    [sym_list_comprehension] = STATE(1229),
    [sym_dictionary] = STATE(1229),
    [sym_dictionary_comprehension] = STATE(1229),
    [sym_set] = STATE(1229),
    [sym_set_comprehension] = STATE(1229),
    [sym_parenthesized_expression] = STATE(1229),
    [sym_tuple] = STATE(1229),
    [sym_generator_expression] = STATE(1229),
    [sym_conditional_expression] = STATE(652),
    [sym_concatenated_string] = STATE(1229),
    [sym_string] = STATE(1230),
    [sym_await] = STATE(652),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2485),
    [anon_sym_PLUS] = ACTIONS(2487),
    [anon_sym_DASH] = ACTIONS(2487),
    [anon_sym_TILDE] = ACTIONS(2487),
    [anon_sym_lambda] = ACTIONS(2489),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2491),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2493),
    [sym_float] = ACTIONS(2493),
    [sym_identifier] = ACTIONS(2493),
    [sym_true] = ACTIONS(2493),
    [sym_false] = ACTIONS(2493),
    [sym_none] = ACTIONS(2493),
    [anon_sym_await] = ACTIONS(2495),
    [sym_comment] = ACTIONS(73),
  },
  [1536] = {
    [sym__expression] = STATE(1744),
    [sym__primary_expression] = STATE(1229),
    [sym_not_operator] = STATE(1744),
    [sym_boolean_operator] = STATE(1744),
    [sym_binary_operator] = STATE(1229),
    [sym_unary_operator] = STATE(1229),
    [sym_comparison_operator] = STATE(1744),
    [sym_lambda] = STATE(1744),
    [sym_attribute] = STATE(1229),
    [sym_subscript] = STATE(1229),
    [sym_call] = STATE(1229),
    [sym_list] = STATE(1229),
    [sym_list_comprehension] = STATE(1229),
    [sym_dictionary] = STATE(1229),
    [sym_dictionary_comprehension] = STATE(1229),
    [sym_set] = STATE(1229),
    [sym_set_comprehension] = STATE(1229),
    [sym_parenthesized_expression] = STATE(1229),
    [sym_tuple] = STATE(1229),
    [sym_generator_expression] = STATE(1229),
    [sym_conditional_expression] = STATE(1744),
    [sym_concatenated_string] = STATE(1229),
    [sym_string] = STATE(1230),
    [sym_await] = STATE(1744),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2485),
    [anon_sym_PLUS] = ACTIONS(2487),
    [anon_sym_DASH] = ACTIONS(2487),
    [anon_sym_TILDE] = ACTIONS(2487),
    [anon_sym_lambda] = ACTIONS(2489),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2491),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2493),
    [sym_float] = ACTIONS(2493),
    [sym_identifier] = ACTIONS(2493),
    [sym_true] = ACTIONS(2493),
    [sym_false] = ACTIONS(2493),
    [sym_none] = ACTIONS(2493),
    [anon_sym_await] = ACTIONS(2495),
    [sym_comment] = ACTIONS(73),
  },
  [1537] = {
    [sym__primary_expression] = STATE(1745),
    [sym_binary_operator] = STATE(1745),
    [sym_unary_operator] = STATE(1745),
    [sym_attribute] = STATE(1745),
    [sym_subscript] = STATE(1745),
    [sym_call] = STATE(1745),
    [sym_list] = STATE(1745),
    [sym_list_comprehension] = STATE(1745),
    [sym_dictionary] = STATE(1745),
    [sym_dictionary_comprehension] = STATE(1745),
    [sym_set] = STATE(1745),
    [sym_set_comprehension] = STATE(1745),
    [sym_parenthesized_expression] = STATE(1745),
    [sym_tuple] = STATE(1745),
    [sym_generator_expression] = STATE(1745),
    [sym_concatenated_string] = STATE(1745),
    [sym_string] = STATE(1230),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2487),
    [anon_sym_DASH] = ACTIONS(2487),
    [anon_sym_TILDE] = ACTIONS(2487),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3751),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3753),
    [sym_float] = ACTIONS(3753),
    [sym_identifier] = ACTIONS(3753),
    [sym_true] = ACTIONS(3753),
    [sym_false] = ACTIONS(3753),
    [sym_none] = ACTIONS(3753),
    [sym_comment] = ACTIONS(73),
  },
  [1538] = {
    [sym__primary_expression] = STATE(1746),
    [sym_binary_operator] = STATE(1746),
    [sym_unary_operator] = STATE(1746),
    [sym_attribute] = STATE(1746),
    [sym_subscript] = STATE(1746),
    [sym_call] = STATE(1746),
    [sym_list] = STATE(1746),
    [sym_list_comprehension] = STATE(1746),
    [sym_dictionary] = STATE(1746),
    [sym_dictionary_comprehension] = STATE(1746),
    [sym_set] = STATE(1746),
    [sym_set_comprehension] = STATE(1746),
    [sym_parenthesized_expression] = STATE(1746),
    [sym_tuple] = STATE(1746),
    [sym_generator_expression] = STATE(1746),
    [sym_concatenated_string] = STATE(1746),
    [sym_string] = STATE(1230),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2487),
    [anon_sym_DASH] = ACTIONS(2487),
    [anon_sym_TILDE] = ACTIONS(2487),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3755),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3757),
    [sym_float] = ACTIONS(3757),
    [sym_identifier] = ACTIONS(3757),
    [sym_true] = ACTIONS(3757),
    [sym_false] = ACTIONS(3757),
    [sym_none] = ACTIONS(3757),
    [sym_comment] = ACTIONS(73),
  },
  [1539] = {
    [sym__primary_expression] = STATE(1747),
    [sym_binary_operator] = STATE(1747),
    [sym_unary_operator] = STATE(1747),
    [sym_attribute] = STATE(1747),
    [sym_subscript] = STATE(1747),
    [sym_call] = STATE(1747),
    [sym_list] = STATE(1747),
    [sym_list_comprehension] = STATE(1747),
    [sym_dictionary] = STATE(1747),
    [sym_dictionary_comprehension] = STATE(1747),
    [sym_set] = STATE(1747),
    [sym_set_comprehension] = STATE(1747),
    [sym_parenthesized_expression] = STATE(1747),
    [sym_tuple] = STATE(1747),
    [sym_generator_expression] = STATE(1747),
    [sym_concatenated_string] = STATE(1747),
    [sym_string] = STATE(1230),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2487),
    [anon_sym_DASH] = ACTIONS(2487),
    [anon_sym_TILDE] = ACTIONS(2487),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3759),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3761),
    [sym_float] = ACTIONS(3761),
    [sym_identifier] = ACTIONS(3761),
    [sym_true] = ACTIONS(3761),
    [sym_false] = ACTIONS(3761),
    [sym_none] = ACTIONS(3761),
    [sym_comment] = ACTIONS(73),
  },
  [1540] = {
    [anon_sym_in] = ACTIONS(3763),
    [sym_comment] = ACTIONS(73),
  },
  [1541] = {
    [sym__primary_expression] = STATE(1749),
    [sym_binary_operator] = STATE(1749),
    [sym_unary_operator] = STATE(1749),
    [sym_attribute] = STATE(1749),
    [sym_subscript] = STATE(1749),
    [sym_call] = STATE(1749),
    [sym_list] = STATE(1749),
    [sym_list_comprehension] = STATE(1749),
    [sym_dictionary] = STATE(1749),
    [sym_dictionary_comprehension] = STATE(1749),
    [sym_set] = STATE(1749),
    [sym_set_comprehension] = STATE(1749),
    [sym_parenthesized_expression] = STATE(1749),
    [sym_tuple] = STATE(1749),
    [sym_generator_expression] = STATE(1749),
    [sym_concatenated_string] = STATE(1749),
    [sym_string] = STATE(1230),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2487),
    [anon_sym_DASH] = ACTIONS(2487),
    [anon_sym_TILDE] = ACTIONS(2487),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3765),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3767),
    [sym_float] = ACTIONS(3767),
    [sym_identifier] = ACTIONS(3767),
    [sym_true] = ACTIONS(3767),
    [sym_false] = ACTIONS(3767),
    [sym_none] = ACTIONS(3767),
    [sym_comment] = ACTIONS(73),
  },
  [1542] = {
    [sym__primary_expression] = STATE(669),
    [sym_binary_operator] = STATE(669),
    [sym_unary_operator] = STATE(669),
    [sym_attribute] = STATE(669),
    [sym_subscript] = STATE(669),
    [sym_call] = STATE(669),
    [sym_list] = STATE(669),
    [sym_list_comprehension] = STATE(669),
    [sym_dictionary] = STATE(669),
    [sym_dictionary_comprehension] = STATE(669),
    [sym_set] = STATE(669),
    [sym_set_comprehension] = STATE(669),
    [sym_parenthesized_expression] = STATE(669),
    [sym_tuple] = STATE(669),
    [sym_generator_expression] = STATE(669),
    [sym_concatenated_string] = STATE(669),
    [sym_string] = STATE(1230),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2487),
    [anon_sym_DASH] = ACTIONS(2487),
    [anon_sym_TILDE] = ACTIONS(2487),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1282),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1284),
    [sym_float] = ACTIONS(1284),
    [sym_identifier] = ACTIONS(1284),
    [sym_true] = ACTIONS(1284),
    [sym_false] = ACTIONS(1284),
    [sym_none] = ACTIONS(1284),
    [sym_comment] = ACTIONS(73),
  },
  [1543] = {
    [sym__primary_expression] = STATE(1750),
    [sym_binary_operator] = STATE(1750),
    [sym_unary_operator] = STATE(1750),
    [sym_attribute] = STATE(1750),
    [sym_subscript] = STATE(1750),
    [sym_call] = STATE(1750),
    [sym_list] = STATE(1750),
    [sym_list_comprehension] = STATE(1750),
    [sym_dictionary] = STATE(1750),
    [sym_dictionary_comprehension] = STATE(1750),
    [sym_set] = STATE(1750),
    [sym_set_comprehension] = STATE(1750),
    [sym_parenthesized_expression] = STATE(1750),
    [sym_tuple] = STATE(1750),
    [sym_generator_expression] = STATE(1750),
    [sym_concatenated_string] = STATE(1750),
    [sym_string] = STATE(1230),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2487),
    [anon_sym_DASH] = ACTIONS(2487),
    [anon_sym_TILDE] = ACTIONS(2487),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3769),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3771),
    [sym_float] = ACTIONS(3771),
    [sym_identifier] = ACTIONS(3771),
    [sym_true] = ACTIONS(3771),
    [sym_false] = ACTIONS(3771),
    [sym_none] = ACTIONS(3771),
    [sym_comment] = ACTIONS(73),
  },
  [1544] = {
    [sym__primary_expression] = STATE(1751),
    [sym_binary_operator] = STATE(1751),
    [sym_unary_operator] = STATE(1751),
    [sym_attribute] = STATE(1751),
    [sym_subscript] = STATE(1751),
    [sym_call] = STATE(1751),
    [sym_list] = STATE(1751),
    [sym_list_comprehension] = STATE(1751),
    [sym_dictionary] = STATE(1751),
    [sym_dictionary_comprehension] = STATE(1751),
    [sym_set] = STATE(1751),
    [sym_set_comprehension] = STATE(1751),
    [sym_parenthesized_expression] = STATE(1751),
    [sym_tuple] = STATE(1751),
    [sym_generator_expression] = STATE(1751),
    [sym_concatenated_string] = STATE(1751),
    [sym_string] = STATE(1230),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2487),
    [anon_sym_DASH] = ACTIONS(2487),
    [anon_sym_TILDE] = ACTIONS(2487),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3773),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3775),
    [sym_float] = ACTIONS(3775),
    [sym_identifier] = ACTIONS(3775),
    [sym_true] = ACTIONS(3775),
    [sym_false] = ACTIONS(3775),
    [sym_none] = ACTIONS(3775),
    [sym_comment] = ACTIONS(73),
  },
  [1545] = {
    [sym__primary_expression] = STATE(1752),
    [sym_binary_operator] = STATE(1752),
    [sym_unary_operator] = STATE(1752),
    [sym_attribute] = STATE(1752),
    [sym_subscript] = STATE(1752),
    [sym_call] = STATE(1752),
    [sym_list] = STATE(1752),
    [sym_list_comprehension] = STATE(1752),
    [sym_dictionary] = STATE(1752),
    [sym_dictionary_comprehension] = STATE(1752),
    [sym_set] = STATE(1752),
    [sym_set_comprehension] = STATE(1752),
    [sym_parenthesized_expression] = STATE(1752),
    [sym_tuple] = STATE(1752),
    [sym_generator_expression] = STATE(1752),
    [sym_concatenated_string] = STATE(1752),
    [sym_string] = STATE(1230),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2487),
    [anon_sym_DASH] = ACTIONS(2487),
    [anon_sym_TILDE] = ACTIONS(2487),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3777),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3779),
    [sym_float] = ACTIONS(3779),
    [sym_identifier] = ACTIONS(3779),
    [sym_true] = ACTIONS(3779),
    [sym_false] = ACTIONS(3779),
    [sym_none] = ACTIONS(3779),
    [sym_comment] = ACTIONS(73),
  },
  [1546] = {
    [sym__primary_expression] = STATE(1747),
    [sym_binary_operator] = STATE(1747),
    [sym_unary_operator] = STATE(1747),
    [sym_attribute] = STATE(1747),
    [sym_subscript] = STATE(1747),
    [sym_call] = STATE(1747),
    [sym_list] = STATE(1747),
    [sym_list_comprehension] = STATE(1747),
    [sym_dictionary] = STATE(1747),
    [sym_dictionary_comprehension] = STATE(1747),
    [sym_set] = STATE(1747),
    [sym_set_comprehension] = STATE(1747),
    [sym_parenthesized_expression] = STATE(1747),
    [sym_tuple] = STATE(1747),
    [sym_generator_expression] = STATE(1747),
    [sym_concatenated_string] = STATE(1747),
    [sym_string] = STATE(1230),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(3781),
    [anon_sym_PLUS] = ACTIONS(2487),
    [anon_sym_DASH] = ACTIONS(2487),
    [anon_sym_TILDE] = ACTIONS(2487),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3759),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3761),
    [sym_float] = ACTIONS(3761),
    [sym_identifier] = ACTIONS(3761),
    [sym_true] = ACTIONS(3761),
    [sym_false] = ACTIONS(3761),
    [sym_none] = ACTIONS(3761),
    [sym_comment] = ACTIONS(73),
  },
  [1547] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1753),
    [anon_sym_RPAREN] = ACTIONS(991),
    [anon_sym_COMMA] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(991),
    [anon_sym_COLON] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(3235),
    [anon_sym_not] = ACTIONS(3239),
    [anon_sym_and] = ACTIONS(991),
    [anon_sym_or] = ACTIONS(991),
    [anon_sym_LT] = ACTIONS(3251),
    [anon_sym_LT_EQ] = ACTIONS(3235),
    [anon_sym_EQ_EQ] = ACTIONS(3235),
    [anon_sym_BANG_EQ] = ACTIONS(3235),
    [anon_sym_GT_EQ] = ACTIONS(3235),
    [anon_sym_GT] = ACTIONS(3251),
    [anon_sym_LT_GT] = ACTIONS(3235),
    [anon_sym_is] = ACTIONS(3253),
    [sym_comment] = ACTIONS(73),
  },
  [1548] = {
    [sym_string] = STATE(1754),
    [aux_sym_concatenated_string_repeat1] = STATE(1754),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_RPAREN] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_COLON] = ACTIONS(995),
    [anon_sym_in] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(995),
    [anon_sym_not] = ACTIONS(995),
    [anon_sym_and] = ACTIONS(995),
    [anon_sym_or] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(995),
    [anon_sym_SLASH_SLASH] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_GT] = ACTIONS(995),
    [anon_sym_is] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(995),
    [sym_comment] = ACTIONS(73),
  },
  [1549] = {
    [anon_sym_RPAREN] = ACTIONS(2562),
    [anon_sym_COMMA] = ACTIONS(2562),
    [anon_sym_COLON] = ACTIONS(2499),
    [anon_sym_EQ] = ACTIONS(2501),
    [sym_comment] = ACTIONS(73),
  },
  [1550] = {
    [anon_sym_RPAREN] = ACTIONS(2564),
    [anon_sym_COMMA] = ACTIONS(2564),
    [anon_sym_COLON] = ACTIONS(2505),
    [anon_sym_EQ] = ACTIONS(2507),
    [sym_comment] = ACTIONS(73),
  },
  [1551] = {
    [anon_sym_RPAREN] = ACTIONS(2564),
    [anon_sym_COMMA] = ACTIONS(2564),
    [anon_sym_COLON] = ACTIONS(2511),
    [sym_comment] = ACTIONS(73),
  },
  [1552] = {
    [anon_sym_EQ] = ACTIONS(3783),
    [sym_comment] = ACTIONS(73),
  },
  [1553] = {
    [anon_sym_RPAREN] = ACTIONS(2600),
    [anon_sym_COMMA] = ACTIONS(2600),
    [anon_sym_if] = ACTIONS(1198),
    [anon_sym_and] = ACTIONS(1200),
    [anon_sym_or] = ACTIONS(1202),
    [sym_comment] = ACTIONS(73),
  },
  [1554] = {
    [sym_default_parameter] = STATE(867),
    [sym_typed_default_parameter] = STATE(867),
    [sym_list_splat] = STATE(1551),
    [sym_dictionary_splat] = STATE(1551),
    [sym_typed_parameter] = STATE(867),
    [sym_tuple] = STATE(867),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_RPAREN] = ACTIONS(2602),
    [anon_sym_STAR] = ACTIONS(1582),
    [anon_sym_print] = ACTIONS(3255),
    [anon_sym_exec] = ACTIONS(3255),
    [sym_identifier] = ACTIONS(3257),
    [sym_comment] = ACTIONS(73),
  },
  [1555] = {
    [aux_sym__parameters_repeat1] = STATE(1555),
    [anon_sym_RPAREN] = ACTIONS(2564),
    [anon_sym_COMMA] = ACTIONS(3785),
    [sym_comment] = ACTIONS(73),
  },
  [1556] = {
    [sym__expression] = STATE(1757),
    [sym__primary_expression] = STATE(1561),
    [sym_not_operator] = STATE(1757),
    [sym_boolean_operator] = STATE(1757),
    [sym_binary_operator] = STATE(1561),
    [sym_unary_operator] = STATE(1561),
    [sym_comparison_operator] = STATE(1757),
    [sym_lambda] = STATE(1757),
    [sym_attribute] = STATE(1561),
    [sym_subscript] = STATE(1561),
    [sym_call] = STATE(1561),
    [sym_list] = STATE(1561),
    [sym_list_comprehension] = STATE(1561),
    [sym_dictionary] = STATE(1561),
    [sym_dictionary_comprehension] = STATE(1561),
    [sym_set] = STATE(1561),
    [sym_set_comprehension] = STATE(1561),
    [sym_parenthesized_expression] = STATE(1561),
    [sym_tuple] = STATE(1561),
    [sym_generator_expression] = STATE(1561),
    [sym_conditional_expression] = STATE(1757),
    [sym_concatenated_string] = STATE(1561),
    [sym_string] = STATE(1563),
    [sym_await] = STATE(1757),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3263),
    [anon_sym_DASH] = ACTIONS(3263),
    [anon_sym_TILDE] = ACTIONS(3263),
    [anon_sym_lambda] = ACTIONS(3265),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3267),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3269),
    [sym_float] = ACTIONS(3269),
    [sym_identifier] = ACTIONS(3269),
    [sym_true] = ACTIONS(3269),
    [sym_false] = ACTIONS(3269),
    [sym_none] = ACTIONS(3269),
    [anon_sym_await] = ACTIONS(3271),
    [sym_comment] = ACTIONS(73),
  },
  [1557] = {
    [sym__primary_expression] = STATE(227),
    [sym_binary_operator] = STATE(227),
    [sym_unary_operator] = STATE(227),
    [sym_attribute] = STATE(227),
    [sym_subscript] = STATE(227),
    [sym_call] = STATE(227),
    [sym_list] = STATE(227),
    [sym_list_comprehension] = STATE(227),
    [sym_dictionary] = STATE(227),
    [sym_dictionary_comprehension] = STATE(227),
    [sym_set] = STATE(227),
    [sym_set_comprehension] = STATE(227),
    [sym_parenthesized_expression] = STATE(227),
    [sym_tuple] = STATE(227),
    [sym_generator_expression] = STATE(227),
    [sym_concatenated_string] = STATE(227),
    [sym_string] = STATE(1563),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(3263),
    [anon_sym_DASH] = ACTIONS(3263),
    [anon_sym_TILDE] = ACTIONS(3263),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(403),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(405),
    [sym_float] = ACTIONS(405),
    [sym_identifier] = ACTIONS(405),
    [sym_true] = ACTIONS(405),
    [sym_false] = ACTIONS(405),
    [sym_none] = ACTIONS(405),
    [sym_comment] = ACTIONS(73),
  },
  [1558] = {
    [sym_lambda_parameters] = STATE(1759),
    [sym__parameters] = STATE(138),
    [sym_default_parameter] = STATE(139),
    [sym_typed_default_parameter] = STATE(139),
    [sym_list_splat] = STATE(140),
    [sym_dictionary_splat] = STATE(140),
    [sym_typed_parameter] = STATE(139),
    [sym_tuple] = STATE(139),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(3788),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [1559] = {
    [sym__expression] = STATE(249),
    [sym__primary_expression] = STATE(1561),
    [sym_not_operator] = STATE(249),
    [sym_boolean_operator] = STATE(249),
    [sym_binary_operator] = STATE(1561),
    [sym_unary_operator] = STATE(1561),
    [sym_comparison_operator] = STATE(249),
    [sym_lambda] = STATE(249),
    [sym_attribute] = STATE(1561),
    [sym_subscript] = STATE(1561),
    [sym_call] = STATE(1561),
    [sym_list] = STATE(1561),
    [sym_list_comprehension] = STATE(1561),
    [sym_dictionary] = STATE(1561),
    [sym_dictionary_comprehension] = STATE(1561),
    [sym_set] = STATE(1561),
    [sym_set_comprehension] = STATE(1561),
    [sym_parenthesized_expression] = STATE(1561),
    [sym_tuple] = STATE(1561),
    [sym_generator_expression] = STATE(1561),
    [sym_conditional_expression] = STATE(249),
    [sym_concatenated_string] = STATE(1561),
    [sym_string] = STATE(1563),
    [sym_await] = STATE(249),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3263),
    [anon_sym_DASH] = ACTIONS(3263),
    [anon_sym_TILDE] = ACTIONS(3263),
    [anon_sym_lambda] = ACTIONS(3265),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3267),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3269),
    [sym_float] = ACTIONS(3269),
    [sym_identifier] = ACTIONS(3269),
    [sym_true] = ACTIONS(3269),
    [sym_false] = ACTIONS(3269),
    [sym_none] = ACTIONS(3269),
    [anon_sym_await] = ACTIONS(3271),
    [sym_comment] = ACTIONS(73),
  },
  [1560] = {
    [anon_sym_RPAREN] = ACTIONS(1879),
    [anon_sym_COMMA] = ACTIONS(1879),
    [anon_sym_if] = ACTIONS(3790),
    [anon_sym_EQ] = ACTIONS(1879),
    [anon_sym_and] = ACTIONS(3792),
    [anon_sym_or] = ACTIONS(3794),
    [sym_comment] = ACTIONS(73),
  },
  [1561] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [aux_sym_comparison_operator_repeat1] = STATE(1773),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(301),
    [anon_sym_COMMA] = ACTIONS(301),
    [anon_sym_STAR] = ACTIONS(3796),
    [anon_sym_GT_GT] = ACTIONS(3798),
    [anon_sym_if] = ACTIONS(301),
    [anon_sym_in] = ACTIONS(3800),
    [anon_sym_EQ] = ACTIONS(313),
    [anon_sym_AT] = ACTIONS(3802),
    [anon_sym_not] = ACTIONS(3804),
    [anon_sym_and] = ACTIONS(301),
    [anon_sym_or] = ACTIONS(301),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3806),
    [anon_sym_SLASH] = ACTIONS(3796),
    [anon_sym_PERCENT] = ACTIONS(3802),
    [anon_sym_SLASH_SLASH] = ACTIONS(3802),
    [anon_sym_STAR_STAR] = ACTIONS(3808),
    [anon_sym_PIPE] = ACTIONS(3810),
    [anon_sym_AMP] = ACTIONS(3812),
    [anon_sym_CARET] = ACTIONS(3814),
    [anon_sym_LT_LT] = ACTIONS(3798),
    [anon_sym_LT] = ACTIONS(3816),
    [anon_sym_LT_EQ] = ACTIONS(3800),
    [anon_sym_EQ_EQ] = ACTIONS(3800),
    [anon_sym_BANG_EQ] = ACTIONS(3800),
    [anon_sym_GT_EQ] = ACTIONS(3800),
    [anon_sym_GT] = ACTIONS(3816),
    [anon_sym_LT_GT] = ACTIONS(3800),
    [anon_sym_is] = ACTIONS(3818),
    [anon_sym_LBRACK] = ACTIONS(473),
    [sym_comment] = ACTIONS(73),
  },
  [1562] = {
    [anon_sym_RPAREN] = ACTIONS(2639),
    [anon_sym_COMMA] = ACTIONS(2639),
    [anon_sym_EQ] = ACTIONS(3820),
    [sym_comment] = ACTIONS(73),
  },
  [1563] = {
    [sym_string] = STATE(1775),
    [aux_sym_concatenated_string_repeat1] = STATE(1775),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(333),
    [anon_sym_LPAREN] = ACTIONS(333),
    [anon_sym_RPAREN] = ACTIONS(333),
    [anon_sym_COMMA] = ACTIONS(333),
    [anon_sym_STAR] = ACTIONS(335),
    [anon_sym_GT_GT] = ACTIONS(333),
    [anon_sym_if] = ACTIONS(333),
    [anon_sym_in] = ACTIONS(333),
    [anon_sym_EQ] = ACTIONS(335),
    [anon_sym_AT] = ACTIONS(333),
    [anon_sym_not] = ACTIONS(333),
    [anon_sym_and] = ACTIONS(333),
    [anon_sym_or] = ACTIONS(333),
    [anon_sym_PLUS] = ACTIONS(333),
    [anon_sym_DASH] = ACTIONS(333),
    [anon_sym_SLASH] = ACTIONS(335),
    [anon_sym_PERCENT] = ACTIONS(333),
    [anon_sym_SLASH_SLASH] = ACTIONS(333),
    [anon_sym_STAR_STAR] = ACTIONS(333),
    [anon_sym_PIPE] = ACTIONS(333),
    [anon_sym_AMP] = ACTIONS(333),
    [anon_sym_CARET] = ACTIONS(333),
    [anon_sym_LT_LT] = ACTIONS(333),
    [anon_sym_LT] = ACTIONS(335),
    [anon_sym_LT_EQ] = ACTIONS(333),
    [anon_sym_EQ_EQ] = ACTIONS(333),
    [anon_sym_BANG_EQ] = ACTIONS(333),
    [anon_sym_GT_EQ] = ACTIONS(333),
    [anon_sym_GT] = ACTIONS(335),
    [anon_sym_LT_GT] = ACTIONS(333),
    [anon_sym_is] = ACTIONS(333),
    [anon_sym_LBRACK] = ACTIONS(333),
    [sym_comment] = ACTIONS(73),
  },
  [1564] = {
    [anon_sym_RPAREN] = ACTIONS(2643),
    [anon_sym_COMMA] = ACTIONS(2643),
    [anon_sym_if] = ACTIONS(1198),
    [anon_sym_and] = ACTIONS(1200),
    [anon_sym_or] = ACTIONS(1202),
    [sym_comment] = ACTIONS(73),
  },
  [1565] = {
    [sym_default_parameter] = STATE(867),
    [sym_typed_default_parameter] = STATE(867),
    [sym_list_splat] = STATE(1551),
    [sym_dictionary_splat] = STATE(1551),
    [sym_typed_parameter] = STATE(867),
    [sym_tuple] = STATE(867),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_RPAREN] = ACTIONS(2645),
    [anon_sym_STAR] = ACTIONS(1582),
    [anon_sym_print] = ACTIONS(3255),
    [anon_sym_exec] = ACTIONS(3255),
    [sym_identifier] = ACTIONS(3257),
    [sym_comment] = ACTIONS(73),
  },
  [1566] = {
    [anon_sym_RPAREN] = ACTIONS(1879),
    [anon_sym_COMMA] = ACTIONS(1879),
    [anon_sym_if] = ACTIONS(1198),
    [anon_sym_and] = ACTIONS(1200),
    [anon_sym_or] = ACTIONS(1202),
    [sym_comment] = ACTIONS(73),
  },
  [1567] = {
    [sym__simple_statements] = STATE(1776),
    [sym_import_statement] = STATE(34),
    [sym_future_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym__suite] = STATE(1776),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(1448),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1568] = {
    [anon_sym_COMMA] = ACTIONS(2647),
    [anon_sym_if] = ACTIONS(1610),
    [anon_sym_COLON] = ACTIONS(2647),
    [anon_sym_and] = ACTIONS(1612),
    [anon_sym_or] = ACTIONS(1614),
    [sym_comment] = ACTIONS(73),
  },
  [1569] = {
    [sym__expression] = STATE(1777),
    [sym__primary_expression] = STATE(432),
    [sym_not_operator] = STATE(1777),
    [sym_boolean_operator] = STATE(1777),
    [sym_binary_operator] = STATE(432),
    [sym_unary_operator] = STATE(432),
    [sym_comparison_operator] = STATE(1777),
    [sym_lambda] = STATE(1777),
    [sym_attribute] = STATE(432),
    [sym_subscript] = STATE(432),
    [sym_call] = STATE(432),
    [sym_list] = STATE(432),
    [sym_list_comprehension] = STATE(432),
    [sym_dictionary] = STATE(432),
    [sym_dictionary_comprehension] = STATE(432),
    [sym_set] = STATE(432),
    [sym_set_comprehension] = STATE(432),
    [sym_parenthesized_expression] = STATE(432),
    [sym_tuple] = STATE(432),
    [sym_generator_expression] = STATE(432),
    [sym_conditional_expression] = STATE(1777),
    [sym_concatenated_string] = STATE(432),
    [sym_string] = STATE(433),
    [sym_await] = STATE(1777),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(735),
    [anon_sym_lambda] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(741),
    [sym_float] = ACTIONS(741),
    [sym_identifier] = ACTIONS(741),
    [sym_true] = ACTIONS(741),
    [sym_false] = ACTIONS(741),
    [sym_none] = ACTIONS(741),
    [anon_sym_await] = ACTIONS(743),
    [sym_comment] = ACTIONS(73),
  },
  [1570] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(2942),
    [anon_sym_STAR] = ACTIONS(1616),
    [anon_sym_GT_GT] = ACTIONS(1618),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_COLON] = ACTIONS(2942),
    [anon_sym_in] = ACTIONS(2942),
    [anon_sym_AT] = ACTIONS(1622),
    [anon_sym_not] = ACTIONS(2942),
    [anon_sym_and] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(1626),
    [anon_sym_DASH] = ACTIONS(1626),
    [anon_sym_SLASH] = ACTIONS(1616),
    [anon_sym_PERCENT] = ACTIONS(1622),
    [anon_sym_SLASH_SLASH] = ACTIONS(1622),
    [anon_sym_STAR_STAR] = ACTIONS(1628),
    [anon_sym_PIPE] = ACTIONS(1630),
    [anon_sym_AMP] = ACTIONS(1632),
    [anon_sym_CARET] = ACTIONS(1634),
    [anon_sym_LT_LT] = ACTIONS(1618),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_LT_EQ] = ACTIONS(2942),
    [anon_sym_EQ_EQ] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_GT_EQ] = ACTIONS(2942),
    [anon_sym_GT] = ACTIONS(2944),
    [anon_sym_LT_GT] = ACTIONS(2942),
    [anon_sym_is] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(473),
    [sym_comment] = ACTIONS(73),
  },
  [1571] = {
    [anon_sym_if] = ACTIONS(2568),
    [anon_sym_EQ] = ACTIONS(1660),
    [anon_sym_and] = ACTIONS(2570),
    [anon_sym_or] = ACTIONS(2572),
    [sym_comment] = ACTIONS(73),
  },
  [1572] = {
    [sym__expression] = STATE(1778),
    [sym__primary_expression] = STATE(874),
    [sym_not_operator] = STATE(1778),
    [sym_boolean_operator] = STATE(1778),
    [sym_binary_operator] = STATE(874),
    [sym_unary_operator] = STATE(874),
    [sym_comparison_operator] = STATE(1778),
    [sym_lambda] = STATE(1778),
    [sym_attribute] = STATE(874),
    [sym_subscript] = STATE(874),
    [sym_call] = STATE(874),
    [sym_list] = STATE(874),
    [sym_list_comprehension] = STATE(874),
    [sym_dictionary] = STATE(874),
    [sym_dictionary_comprehension] = STATE(874),
    [sym_set] = STATE(874),
    [sym_set_comprehension] = STATE(874),
    [sym_parenthesized_expression] = STATE(874),
    [sym_tuple] = STATE(874),
    [sym_generator_expression] = STATE(874),
    [sym_conditional_expression] = STATE(1778),
    [sym_concatenated_string] = STATE(874),
    [sym_string] = STATE(876),
    [sym_await] = STATE(1778),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1646),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_DASH] = ACTIONS(1648),
    [anon_sym_TILDE] = ACTIONS(1648),
    [anon_sym_lambda] = ACTIONS(1650),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1652),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1654),
    [sym_float] = ACTIONS(1654),
    [sym_identifier] = ACTIONS(1654),
    [sym_true] = ACTIONS(1654),
    [sym_false] = ACTIONS(1654),
    [sym_none] = ACTIONS(1654),
    [anon_sym_await] = ACTIONS(1656),
    [sym_comment] = ACTIONS(73),
  },
  [1573] = {
    [anon_sym_if] = ACTIONS(1925),
    [anon_sym_else] = ACTIONS(3822),
    [anon_sym_and] = ACTIONS(1929),
    [anon_sym_or] = ACTIONS(1931),
    [sym_comment] = ACTIONS(73),
  },
  [1574] = {
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_EQ] = ACTIONS(1957),
    [anon_sym_and] = ACTIONS(2570),
    [anon_sym_or] = ACTIONS(1957),
    [sym_comment] = ACTIONS(73),
  },
  [1575] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(1984),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1986),
    [anon_sym_PERCENT] = ACTIONS(1984),
    [anon_sym_SLASH_SLASH] = ACTIONS(1984),
    [anon_sym_STAR_STAR] = ACTIONS(2586),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1576] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(2574),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(2580),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(2584),
    [anon_sym_DASH] = ACTIONS(2584),
    [anon_sym_SLASH] = ACTIONS(2574),
    [anon_sym_PERCENT] = ACTIONS(2580),
    [anon_sym_SLASH_SLASH] = ACTIONS(2580),
    [anon_sym_STAR_STAR] = ACTIONS(2586),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1577] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(2574),
    [anon_sym_GT_GT] = ACTIONS(2576),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(1988),
    [anon_sym_EQ] = ACTIONS(1990),
    [anon_sym_AT] = ACTIONS(2580),
    [anon_sym_not] = ACTIONS(1988),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_PLUS] = ACTIONS(2584),
    [anon_sym_DASH] = ACTIONS(2584),
    [anon_sym_SLASH] = ACTIONS(2574),
    [anon_sym_PERCENT] = ACTIONS(2580),
    [anon_sym_SLASH_SLASH] = ACTIONS(2580),
    [anon_sym_STAR_STAR] = ACTIONS(2586),
    [anon_sym_PIPE] = ACTIONS(2588),
    [anon_sym_AMP] = ACTIONS(2590),
    [anon_sym_CARET] = ACTIONS(2592),
    [anon_sym_LT_LT] = ACTIONS(2576),
    [anon_sym_LT] = ACTIONS(1990),
    [anon_sym_LT_EQ] = ACTIONS(1988),
    [anon_sym_EQ_EQ] = ACTIONS(1988),
    [anon_sym_BANG_EQ] = ACTIONS(1988),
    [anon_sym_GT_EQ] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1990),
    [anon_sym_LT_GT] = ACTIONS(1988),
    [anon_sym_is] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(473),
    [sym_comment] = ACTIONS(73),
  },
  [1578] = {
    [sym__primary_expression] = STATE(1780),
    [sym_binary_operator] = STATE(1780),
    [sym_unary_operator] = STATE(1780),
    [sym_attribute] = STATE(1780),
    [sym_subscript] = STATE(1780),
    [sym_call] = STATE(1780),
    [sym_list] = STATE(1780),
    [sym_list_comprehension] = STATE(1780),
    [sym_dictionary] = STATE(1780),
    [sym_dictionary_comprehension] = STATE(1780),
    [sym_set] = STATE(1780),
    [sym_set_comprehension] = STATE(1780),
    [sym_parenthesized_expression] = STATE(1780),
    [sym_tuple] = STATE(1780),
    [sym_generator_expression] = STATE(1780),
    [sym_concatenated_string] = STATE(1780),
    [sym_string] = STATE(876),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_DASH] = ACTIONS(1648),
    [anon_sym_TILDE] = ACTIONS(1648),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3824),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3826),
    [sym_float] = ACTIONS(3826),
    [sym_identifier] = ACTIONS(3826),
    [sym_true] = ACTIONS(3826),
    [sym_false] = ACTIONS(3826),
    [sym_none] = ACTIONS(3826),
    [sym_comment] = ACTIONS(73),
  },
  [1579] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(2574),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(2580),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(2574),
    [anon_sym_PERCENT] = ACTIONS(2580),
    [anon_sym_SLASH_SLASH] = ACTIONS(2580),
    [anon_sym_STAR_STAR] = ACTIONS(2586),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1580] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(2574),
    [anon_sym_GT_GT] = ACTIONS(2576),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(2580),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(2584),
    [anon_sym_DASH] = ACTIONS(2584),
    [anon_sym_SLASH] = ACTIONS(2574),
    [anon_sym_PERCENT] = ACTIONS(2580),
    [anon_sym_SLASH_SLASH] = ACTIONS(2580),
    [anon_sym_STAR_STAR] = ACTIONS(2586),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(2590),
    [anon_sym_CARET] = ACTIONS(2592),
    [anon_sym_LT_LT] = ACTIONS(2576),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1581] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(2574),
    [anon_sym_GT_GT] = ACTIONS(2576),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(2580),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(2584),
    [anon_sym_DASH] = ACTIONS(2584),
    [anon_sym_SLASH] = ACTIONS(2574),
    [anon_sym_PERCENT] = ACTIONS(2580),
    [anon_sym_SLASH_SLASH] = ACTIONS(2580),
    [anon_sym_STAR_STAR] = ACTIONS(2586),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(2592),
    [anon_sym_LT_LT] = ACTIONS(2576),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1582] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(2574),
    [anon_sym_GT_GT] = ACTIONS(2576),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(2580),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(2584),
    [anon_sym_DASH] = ACTIONS(2584),
    [anon_sym_SLASH] = ACTIONS(2574),
    [anon_sym_PERCENT] = ACTIONS(2580),
    [anon_sym_SLASH_SLASH] = ACTIONS(2580),
    [anon_sym_STAR_STAR] = ACTIONS(2586),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(2576),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1583] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1583),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(3828),
    [anon_sym_EQ] = ACTIONS(1990),
    [anon_sym_not] = ACTIONS(3831),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(3834),
    [anon_sym_LT_EQ] = ACTIONS(3828),
    [anon_sym_EQ_EQ] = ACTIONS(3828),
    [anon_sym_BANG_EQ] = ACTIONS(3828),
    [anon_sym_GT_EQ] = ACTIONS(3828),
    [anon_sym_GT] = ACTIONS(3834),
    [anon_sym_LT_GT] = ACTIONS(3828),
    [anon_sym_is] = ACTIONS(3837),
    [sym_comment] = ACTIONS(73),
  },
  [1584] = {
    [anon_sym_COMMA] = ACTIONS(3840),
    [anon_sym_if] = ACTIONS(1610),
    [anon_sym_COLON] = ACTIONS(3840),
    [anon_sym_and] = ACTIONS(1612),
    [anon_sym_or] = ACTIONS(1614),
    [sym_comment] = ACTIONS(73),
  },
  [1585] = {
    [sym_string] = STATE(1585),
    [aux_sym_concatenated_string_repeat1] = STATE(1585),
    [sym__string_start] = ACTIONS(2241),
    [anon_sym_DOT] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2050),
    [anon_sym_if] = ACTIONS(2050),
    [anon_sym_in] = ACTIONS(2050),
    [anon_sym_EQ] = ACTIONS(2055),
    [anon_sym_AT] = ACTIONS(2050),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_and] = ACTIONS(2050),
    [anon_sym_or] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_SLASH] = ACTIONS(2055),
    [anon_sym_PERCENT] = ACTIONS(2050),
    [anon_sym_SLASH_SLASH] = ACTIONS(2050),
    [anon_sym_STAR_STAR] = ACTIONS(2050),
    [anon_sym_PIPE] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2050),
    [anon_sym_CARET] = ACTIONS(2050),
    [anon_sym_LT_LT] = ACTIONS(2050),
    [anon_sym_LT] = ACTIONS(2055),
    [anon_sym_LT_EQ] = ACTIONS(2050),
    [anon_sym_EQ_EQ] = ACTIONS(2050),
    [anon_sym_BANG_EQ] = ACTIONS(2050),
    [anon_sym_GT_EQ] = ACTIONS(2050),
    [anon_sym_GT] = ACTIONS(2055),
    [anon_sym_LT_GT] = ACTIONS(2050),
    [anon_sym_is] = ACTIONS(2050),
    [anon_sym_LBRACK] = ACTIONS(2050),
    [sym_comment] = ACTIONS(73),
  },
  [1586] = {
    [anon_sym_COMMA] = ACTIONS(1660),
    [anon_sym_if] = ACTIONS(2609),
    [anon_sym_COLON] = ACTIONS(1660),
    [anon_sym_EQ] = ACTIONS(1660),
    [anon_sym_and] = ACTIONS(2611),
    [anon_sym_or] = ACTIONS(2613),
    [sym_comment] = ACTIONS(73),
  },
  [1587] = {
    [sym__expression] = STATE(1781),
    [sym__primary_expression] = STATE(885),
    [sym_not_operator] = STATE(1781),
    [sym_boolean_operator] = STATE(1781),
    [sym_binary_operator] = STATE(885),
    [sym_unary_operator] = STATE(885),
    [sym_comparison_operator] = STATE(1781),
    [sym_lambda] = STATE(1781),
    [sym_attribute] = STATE(885),
    [sym_subscript] = STATE(885),
    [sym_call] = STATE(885),
    [sym_list] = STATE(885),
    [sym_list_comprehension] = STATE(885),
    [sym_dictionary] = STATE(885),
    [sym_dictionary_comprehension] = STATE(885),
    [sym_set] = STATE(885),
    [sym_set_comprehension] = STATE(885),
    [sym_parenthesized_expression] = STATE(885),
    [sym_tuple] = STATE(885),
    [sym_generator_expression] = STATE(885),
    [sym_conditional_expression] = STATE(1781),
    [sym_concatenated_string] = STATE(885),
    [sym_string] = STATE(887),
    [sym_await] = STATE(1781),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_PLUS] = ACTIONS(1666),
    [anon_sym_DASH] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [anon_sym_lambda] = ACTIONS(1668),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1670),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1672),
    [sym_float] = ACTIONS(1672),
    [sym_identifier] = ACTIONS(1672),
    [sym_true] = ACTIONS(1672),
    [sym_false] = ACTIONS(1672),
    [sym_none] = ACTIONS(1672),
    [anon_sym_await] = ACTIONS(1674),
    [sym_comment] = ACTIONS(73),
  },
  [1588] = {
    [anon_sym_if] = ACTIONS(1925),
    [anon_sym_else] = ACTIONS(3842),
    [anon_sym_and] = ACTIONS(1929),
    [anon_sym_or] = ACTIONS(1931),
    [sym_comment] = ACTIONS(73),
  },
  [1589] = {
    [anon_sym_COMMA] = ACTIONS(1957),
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_COLON] = ACTIONS(1957),
    [anon_sym_EQ] = ACTIONS(1957),
    [anon_sym_and] = ACTIONS(2611),
    [anon_sym_or] = ACTIONS(1957),
    [sym_comment] = ACTIONS(73),
  },
  [1590] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(1984),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1986),
    [anon_sym_PERCENT] = ACTIONS(1984),
    [anon_sym_SLASH_SLASH] = ACTIONS(1984),
    [anon_sym_STAR_STAR] = ACTIONS(2627),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1591] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(2615),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(2621),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(2625),
    [anon_sym_DASH] = ACTIONS(2625),
    [anon_sym_SLASH] = ACTIONS(2615),
    [anon_sym_PERCENT] = ACTIONS(2621),
    [anon_sym_SLASH_SLASH] = ACTIONS(2621),
    [anon_sym_STAR_STAR] = ACTIONS(2627),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1592] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1988),
    [anon_sym_STAR] = ACTIONS(2615),
    [anon_sym_GT_GT] = ACTIONS(2617),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_COLON] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(1988),
    [anon_sym_EQ] = ACTIONS(1990),
    [anon_sym_AT] = ACTIONS(2621),
    [anon_sym_not] = ACTIONS(1988),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_PLUS] = ACTIONS(2625),
    [anon_sym_DASH] = ACTIONS(2625),
    [anon_sym_SLASH] = ACTIONS(2615),
    [anon_sym_PERCENT] = ACTIONS(2621),
    [anon_sym_SLASH_SLASH] = ACTIONS(2621),
    [anon_sym_STAR_STAR] = ACTIONS(2627),
    [anon_sym_PIPE] = ACTIONS(2629),
    [anon_sym_AMP] = ACTIONS(2631),
    [anon_sym_CARET] = ACTIONS(2633),
    [anon_sym_LT_LT] = ACTIONS(2617),
    [anon_sym_LT] = ACTIONS(1990),
    [anon_sym_LT_EQ] = ACTIONS(1988),
    [anon_sym_EQ_EQ] = ACTIONS(1988),
    [anon_sym_BANG_EQ] = ACTIONS(1988),
    [anon_sym_GT_EQ] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1990),
    [anon_sym_LT_GT] = ACTIONS(1988),
    [anon_sym_is] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(473),
    [sym_comment] = ACTIONS(73),
  },
  [1593] = {
    [sym__primary_expression] = STATE(1783),
    [sym_binary_operator] = STATE(1783),
    [sym_unary_operator] = STATE(1783),
    [sym_attribute] = STATE(1783),
    [sym_subscript] = STATE(1783),
    [sym_call] = STATE(1783),
    [sym_list] = STATE(1783),
    [sym_list_comprehension] = STATE(1783),
    [sym_dictionary] = STATE(1783),
    [sym_dictionary_comprehension] = STATE(1783),
    [sym_set] = STATE(1783),
    [sym_set_comprehension] = STATE(1783),
    [sym_parenthesized_expression] = STATE(1783),
    [sym_tuple] = STATE(1783),
    [sym_generator_expression] = STATE(1783),
    [sym_concatenated_string] = STATE(1783),
    [sym_string] = STATE(887),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1666),
    [anon_sym_DASH] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3844),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3846),
    [sym_float] = ACTIONS(3846),
    [sym_identifier] = ACTIONS(3846),
    [sym_true] = ACTIONS(3846),
    [sym_false] = ACTIONS(3846),
    [sym_none] = ACTIONS(3846),
    [sym_comment] = ACTIONS(73),
  },
  [1594] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(2615),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(2621),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(2615),
    [anon_sym_PERCENT] = ACTIONS(2621),
    [anon_sym_SLASH_SLASH] = ACTIONS(2621),
    [anon_sym_STAR_STAR] = ACTIONS(2627),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1595] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(2615),
    [anon_sym_GT_GT] = ACTIONS(2617),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(2621),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(2625),
    [anon_sym_DASH] = ACTIONS(2625),
    [anon_sym_SLASH] = ACTIONS(2615),
    [anon_sym_PERCENT] = ACTIONS(2621),
    [anon_sym_SLASH_SLASH] = ACTIONS(2621),
    [anon_sym_STAR_STAR] = ACTIONS(2627),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(2631),
    [anon_sym_CARET] = ACTIONS(2633),
    [anon_sym_LT_LT] = ACTIONS(2617),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1596] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(2615),
    [anon_sym_GT_GT] = ACTIONS(2617),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(2621),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(2625),
    [anon_sym_DASH] = ACTIONS(2625),
    [anon_sym_SLASH] = ACTIONS(2615),
    [anon_sym_PERCENT] = ACTIONS(2621),
    [anon_sym_SLASH_SLASH] = ACTIONS(2621),
    [anon_sym_STAR_STAR] = ACTIONS(2627),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(2633),
    [anon_sym_LT_LT] = ACTIONS(2617),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1597] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(2615),
    [anon_sym_GT_GT] = ACTIONS(2617),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(2621),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(2625),
    [anon_sym_DASH] = ACTIONS(2625),
    [anon_sym_SLASH] = ACTIONS(2615),
    [anon_sym_PERCENT] = ACTIONS(2621),
    [anon_sym_SLASH_SLASH] = ACTIONS(2621),
    [anon_sym_STAR_STAR] = ACTIONS(2627),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(2617),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1598] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1598),
    [anon_sym_COMMA] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_COLON] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(3848),
    [anon_sym_EQ] = ACTIONS(1990),
    [anon_sym_not] = ACTIONS(3851),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(3854),
    [anon_sym_LT_EQ] = ACTIONS(3848),
    [anon_sym_EQ_EQ] = ACTIONS(3848),
    [anon_sym_BANG_EQ] = ACTIONS(3848),
    [anon_sym_GT_EQ] = ACTIONS(3848),
    [anon_sym_GT] = ACTIONS(3854),
    [anon_sym_LT_GT] = ACTIONS(3848),
    [anon_sym_is] = ACTIONS(3857),
    [sym_comment] = ACTIONS(73),
  },
  [1599] = {
    [anon_sym_COMMA] = ACTIONS(3860),
    [anon_sym_if] = ACTIONS(1610),
    [anon_sym_COLON] = ACTIONS(3860),
    [anon_sym_and] = ACTIONS(1612),
    [anon_sym_or] = ACTIONS(1614),
    [sym_comment] = ACTIONS(73),
  },
  [1600] = {
    [sym_string] = STATE(1600),
    [aux_sym_concatenated_string_repeat1] = STATE(1600),
    [sym__string_start] = ACTIONS(2241),
    [anon_sym_DOT] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(2050),
    [anon_sym_COMMA] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2050),
    [anon_sym_if] = ACTIONS(2050),
    [anon_sym_COLON] = ACTIONS(2050),
    [anon_sym_in] = ACTIONS(2050),
    [anon_sym_EQ] = ACTIONS(2055),
    [anon_sym_AT] = ACTIONS(2050),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_and] = ACTIONS(2050),
    [anon_sym_or] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_SLASH] = ACTIONS(2055),
    [anon_sym_PERCENT] = ACTIONS(2050),
    [anon_sym_SLASH_SLASH] = ACTIONS(2050),
    [anon_sym_STAR_STAR] = ACTIONS(2050),
    [anon_sym_PIPE] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2050),
    [anon_sym_CARET] = ACTIONS(2050),
    [anon_sym_LT_LT] = ACTIONS(2050),
    [anon_sym_LT] = ACTIONS(2055),
    [anon_sym_LT_EQ] = ACTIONS(2050),
    [anon_sym_EQ_EQ] = ACTIONS(2050),
    [anon_sym_BANG_EQ] = ACTIONS(2050),
    [anon_sym_GT_EQ] = ACTIONS(2050),
    [anon_sym_GT] = ACTIONS(2055),
    [anon_sym_LT_GT] = ACTIONS(2050),
    [anon_sym_is] = ACTIONS(2050),
    [anon_sym_LBRACK] = ACTIONS(2050),
    [sym_comment] = ACTIONS(73),
  },
  [1601] = {
    [anon_sym_COMMA] = ACTIONS(2647),
    [anon_sym_if] = ACTIONS(1686),
    [anon_sym_and] = ACTIONS(1688),
    [anon_sym_or] = ACTIONS(1690),
    [anon_sym_RBRACK] = ACTIONS(2647),
    [sym_comment] = ACTIONS(73),
  },
  [1602] = {
    [sym__expression] = STATE(1784),
    [sym__primary_expression] = STATE(452),
    [sym_not_operator] = STATE(1784),
    [sym_boolean_operator] = STATE(1784),
    [sym_binary_operator] = STATE(452),
    [sym_unary_operator] = STATE(452),
    [sym_comparison_operator] = STATE(1784),
    [sym_lambda] = STATE(1784),
    [sym_attribute] = STATE(452),
    [sym_subscript] = STATE(452),
    [sym_call] = STATE(452),
    [sym_list] = STATE(452),
    [sym_list_comprehension] = STATE(452),
    [sym_dictionary] = STATE(452),
    [sym_dictionary_comprehension] = STATE(452),
    [sym_set] = STATE(452),
    [sym_set_comprehension] = STATE(452),
    [sym_parenthesized_expression] = STATE(452),
    [sym_tuple] = STATE(452),
    [sym_generator_expression] = STATE(452),
    [sym_conditional_expression] = STATE(1784),
    [sym_concatenated_string] = STATE(452),
    [sym_string] = STATE(453),
    [sym_await] = STATE(1784),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_lambda] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(773),
    [sym_float] = ACTIONS(773),
    [sym_identifier] = ACTIONS(773),
    [sym_true] = ACTIONS(773),
    [sym_false] = ACTIONS(773),
    [sym_none] = ACTIONS(773),
    [anon_sym_await] = ACTIONS(775),
    [sym_comment] = ACTIONS(73),
  },
  [1603] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(2942),
    [anon_sym_STAR] = ACTIONS(1692),
    [anon_sym_GT_GT] = ACTIONS(1694),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_in] = ACTIONS(2942),
    [anon_sym_AT] = ACTIONS(1698),
    [anon_sym_not] = ACTIONS(2942),
    [anon_sym_and] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(1702),
    [anon_sym_DASH] = ACTIONS(1702),
    [anon_sym_SLASH] = ACTIONS(1692),
    [anon_sym_PERCENT] = ACTIONS(1698),
    [anon_sym_SLASH_SLASH] = ACTIONS(1698),
    [anon_sym_STAR_STAR] = ACTIONS(1704),
    [anon_sym_PIPE] = ACTIONS(1706),
    [anon_sym_AMP] = ACTIONS(1708),
    [anon_sym_CARET] = ACTIONS(1710),
    [anon_sym_LT_LT] = ACTIONS(1694),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_LT_EQ] = ACTIONS(2942),
    [anon_sym_EQ_EQ] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_GT_EQ] = ACTIONS(2942),
    [anon_sym_GT] = ACTIONS(2944),
    [anon_sym_LT_GT] = ACTIONS(2942),
    [anon_sym_is] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(473),
    [anon_sym_RBRACK] = ACTIONS(2942),
    [sym_comment] = ACTIONS(73),
  },
  [1604] = {
    [anon_sym_COMMA] = ACTIONS(3565),
    [anon_sym_if] = ACTIONS(785),
    [anon_sym_async] = ACTIONS(3565),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_or] = ACTIONS(793),
    [anon_sym_RBRACK] = ACTIONS(3565),
    [sym_comment] = ACTIONS(73),
  },
  [1605] = {
    [sym__expression_within_for_in_clause] = STATE(1785),
    [sym__expression] = STATE(1608),
    [sym__primary_expression] = STATE(152),
    [sym_not_operator] = STATE(1608),
    [sym_boolean_operator] = STATE(1608),
    [sym_binary_operator] = STATE(152),
    [sym_unary_operator] = STATE(152),
    [sym_comparison_operator] = STATE(1608),
    [sym_lambda] = STATE(1608),
    [sym_lambda_within_for_in_clause] = STATE(1785),
    [sym_attribute] = STATE(152),
    [sym_subscript] = STATE(152),
    [sym_call] = STATE(152),
    [sym_list] = STATE(152),
    [sym_list_comprehension] = STATE(152),
    [sym_dictionary] = STATE(152),
    [sym_dictionary_comprehension] = STATE(152),
    [sym_set] = STATE(152),
    [sym_set_comprehension] = STATE(152),
    [sym_parenthesized_expression] = STATE(152),
    [sym_tuple] = STATE(152),
    [sym_generator_expression] = STATE(152),
    [sym_conditional_expression] = STATE(1608),
    [sym_concatenated_string] = STATE(152),
    [sym_string] = STATE(153),
    [sym_await] = STATE(1608),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_lambda] = ACTIONS(3399),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(255),
    [sym_float] = ACTIONS(255),
    [sym_identifier] = ACTIONS(255),
    [sym_true] = ACTIONS(255),
    [sym_false] = ACTIONS(255),
    [sym_none] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [sym_comment] = ACTIONS(73),
  },
  [1606] = {
    [sym_lambda_parameters] = STATE(1787),
    [sym__parameters] = STATE(138),
    [sym_default_parameter] = STATE(139),
    [sym_typed_default_parameter] = STATE(139),
    [sym_list_splat] = STATE(140),
    [sym_dictionary_splat] = STATE(140),
    [sym_typed_parameter] = STATE(139),
    [sym_tuple] = STATE(139),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(3862),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [1607] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1789),
    [anon_sym_COMMA] = ACTIONS(3864),
    [anon_sym_if] = ACTIONS(3639),
    [anon_sym_async] = ACTIONS(3639),
    [anon_sym_for] = ACTIONS(3639),
    [anon_sym_RBRACK] = ACTIONS(3639),
    [sym_comment] = ACTIONS(73),
  },
  [1608] = {
    [anon_sym_COMMA] = ACTIONS(3643),
    [anon_sym_if] = ACTIONS(3643),
    [anon_sym_async] = ACTIONS(3643),
    [anon_sym_for] = ACTIONS(3643),
    [anon_sym_and] = ACTIONS(791),
    [anon_sym_or] = ACTIONS(793),
    [anon_sym_RBRACK] = ACTIONS(3643),
    [sym_comment] = ACTIONS(73),
  },
  [1609] = {
    [anon_sym_if] = ACTIONS(723),
    [anon_sym_async] = ACTIONS(723),
    [anon_sym_for] = ACTIONS(723),
    [anon_sym_and] = ACTIONS(3403),
    [anon_sym_or] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(723),
    [sym_comment] = ACTIONS(73),
  },
  [1610] = {
    [sym__expression] = STATE(1790),
    [sym__primary_expression] = STATE(1324),
    [sym_not_operator] = STATE(1790),
    [sym_boolean_operator] = STATE(1790),
    [sym_binary_operator] = STATE(1324),
    [sym_unary_operator] = STATE(1324),
    [sym_comparison_operator] = STATE(1790),
    [sym_lambda] = STATE(1790),
    [sym_attribute] = STATE(1324),
    [sym_subscript] = STATE(1324),
    [sym_call] = STATE(1324),
    [sym_list] = STATE(1324),
    [sym_list_comprehension] = STATE(1324),
    [sym_dictionary] = STATE(1324),
    [sym_dictionary_comprehension] = STATE(1324),
    [sym_set] = STATE(1324),
    [sym_set_comprehension] = STATE(1324),
    [sym_parenthesized_expression] = STATE(1324),
    [sym_tuple] = STATE(1324),
    [sym_generator_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(1790),
    [sym_concatenated_string] = STATE(1324),
    [sym_string] = STATE(1325),
    [sym_await] = STATE(1790),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2702),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_lambda] = ACTIONS(2706),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2708),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2710),
    [sym_float] = ACTIONS(2710),
    [sym_identifier] = ACTIONS(2710),
    [sym_true] = ACTIONS(2710),
    [sym_false] = ACTIONS(2710),
    [sym_none] = ACTIONS(2710),
    [anon_sym_await] = ACTIONS(2712),
    [sym_comment] = ACTIONS(73),
  },
  [1611] = {
    [anon_sym_COLON] = ACTIONS(3866),
    [sym_comment] = ACTIONS(73),
  },
  [1612] = {
    [sym__expression] = STATE(1792),
    [sym__primary_expression] = STATE(538),
    [sym_not_operator] = STATE(1792),
    [sym_boolean_operator] = STATE(1792),
    [sym_binary_operator] = STATE(538),
    [sym_unary_operator] = STATE(538),
    [sym_comparison_operator] = STATE(1792),
    [sym_lambda] = STATE(1792),
    [sym_attribute] = STATE(538),
    [sym_subscript] = STATE(538),
    [sym_call] = STATE(538),
    [sym_list] = STATE(538),
    [sym_list_comprehension] = STATE(538),
    [sym_dictionary] = STATE(538),
    [sym_dictionary_comprehension] = STATE(538),
    [sym_set] = STATE(538),
    [sym_set_comprehension] = STATE(538),
    [sym_parenthesized_expression] = STATE(538),
    [sym_tuple] = STATE(538),
    [sym_generator_expression] = STATE(538),
    [sym_conditional_expression] = STATE(1792),
    [sym_concatenated_string] = STATE(538),
    [sym_string] = STATE(539),
    [sym_await] = STATE(1792),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_lambda] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(917),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(919),
    [sym_float] = ACTIONS(919),
    [sym_identifier] = ACTIONS(919),
    [sym_true] = ACTIONS(919),
    [sym_false] = ACTIONS(919),
    [sym_none] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(921),
    [sym_comment] = ACTIONS(73),
  },
  [1613] = {
    [sym__expression] = STATE(652),
    [sym__primary_expression] = STATE(1324),
    [sym_not_operator] = STATE(652),
    [sym_boolean_operator] = STATE(652),
    [sym_binary_operator] = STATE(1324),
    [sym_unary_operator] = STATE(1324),
    [sym_comparison_operator] = STATE(652),
    [sym_lambda] = STATE(652),
    [sym_attribute] = STATE(1324),
    [sym_subscript] = STATE(1324),
    [sym_call] = STATE(1324),
    [sym_list] = STATE(1324),
    [sym_list_comprehension] = STATE(1324),
    [sym_dictionary] = STATE(1324),
    [sym_dictionary_comprehension] = STATE(1324),
    [sym_set] = STATE(1324),
    [sym_set_comprehension] = STATE(1324),
    [sym_parenthesized_expression] = STATE(1324),
    [sym_tuple] = STATE(1324),
    [sym_generator_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(652),
    [sym_concatenated_string] = STATE(1324),
    [sym_string] = STATE(1325),
    [sym_await] = STATE(652),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2702),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_lambda] = ACTIONS(2706),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2708),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2710),
    [sym_float] = ACTIONS(2710),
    [sym_identifier] = ACTIONS(2710),
    [sym_true] = ACTIONS(2710),
    [sym_false] = ACTIONS(2710),
    [sym_none] = ACTIONS(2710),
    [anon_sym_await] = ACTIONS(2712),
    [sym_comment] = ACTIONS(73),
  },
  [1614] = {
    [sym__expression] = STATE(1793),
    [sym__primary_expression] = STATE(1324),
    [sym_not_operator] = STATE(1793),
    [sym_boolean_operator] = STATE(1793),
    [sym_binary_operator] = STATE(1324),
    [sym_unary_operator] = STATE(1324),
    [sym_comparison_operator] = STATE(1793),
    [sym_lambda] = STATE(1793),
    [sym_attribute] = STATE(1324),
    [sym_subscript] = STATE(1324),
    [sym_call] = STATE(1324),
    [sym_list] = STATE(1324),
    [sym_list_comprehension] = STATE(1324),
    [sym_dictionary] = STATE(1324),
    [sym_dictionary_comprehension] = STATE(1324),
    [sym_set] = STATE(1324),
    [sym_set_comprehension] = STATE(1324),
    [sym_parenthesized_expression] = STATE(1324),
    [sym_tuple] = STATE(1324),
    [sym_generator_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(1793),
    [sym_concatenated_string] = STATE(1324),
    [sym_string] = STATE(1325),
    [sym_await] = STATE(1793),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2702),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_lambda] = ACTIONS(2706),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2708),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2710),
    [sym_float] = ACTIONS(2710),
    [sym_identifier] = ACTIONS(2710),
    [sym_true] = ACTIONS(2710),
    [sym_false] = ACTIONS(2710),
    [sym_none] = ACTIONS(2710),
    [anon_sym_await] = ACTIONS(2712),
    [sym_comment] = ACTIONS(73),
  },
  [1615] = {
    [sym__primary_expression] = STATE(1794),
    [sym_binary_operator] = STATE(1794),
    [sym_unary_operator] = STATE(1794),
    [sym_attribute] = STATE(1794),
    [sym_subscript] = STATE(1794),
    [sym_call] = STATE(1794),
    [sym_list] = STATE(1794),
    [sym_list_comprehension] = STATE(1794),
    [sym_dictionary] = STATE(1794),
    [sym_dictionary_comprehension] = STATE(1794),
    [sym_set] = STATE(1794),
    [sym_set_comprehension] = STATE(1794),
    [sym_parenthesized_expression] = STATE(1794),
    [sym_tuple] = STATE(1794),
    [sym_generator_expression] = STATE(1794),
    [sym_concatenated_string] = STATE(1794),
    [sym_string] = STATE(1325),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3868),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3870),
    [sym_float] = ACTIONS(3870),
    [sym_identifier] = ACTIONS(3870),
    [sym_true] = ACTIONS(3870),
    [sym_false] = ACTIONS(3870),
    [sym_none] = ACTIONS(3870),
    [sym_comment] = ACTIONS(73),
  },
  [1616] = {
    [sym__primary_expression] = STATE(1795),
    [sym_binary_operator] = STATE(1795),
    [sym_unary_operator] = STATE(1795),
    [sym_attribute] = STATE(1795),
    [sym_subscript] = STATE(1795),
    [sym_call] = STATE(1795),
    [sym_list] = STATE(1795),
    [sym_list_comprehension] = STATE(1795),
    [sym_dictionary] = STATE(1795),
    [sym_dictionary_comprehension] = STATE(1795),
    [sym_set] = STATE(1795),
    [sym_set_comprehension] = STATE(1795),
    [sym_parenthesized_expression] = STATE(1795),
    [sym_tuple] = STATE(1795),
    [sym_generator_expression] = STATE(1795),
    [sym_concatenated_string] = STATE(1795),
    [sym_string] = STATE(1325),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3872),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3874),
    [sym_float] = ACTIONS(3874),
    [sym_identifier] = ACTIONS(3874),
    [sym_true] = ACTIONS(3874),
    [sym_false] = ACTIONS(3874),
    [sym_none] = ACTIONS(3874),
    [sym_comment] = ACTIONS(73),
  },
  [1617] = {
    [sym__primary_expression] = STATE(1796),
    [sym_binary_operator] = STATE(1796),
    [sym_unary_operator] = STATE(1796),
    [sym_attribute] = STATE(1796),
    [sym_subscript] = STATE(1796),
    [sym_call] = STATE(1796),
    [sym_list] = STATE(1796),
    [sym_list_comprehension] = STATE(1796),
    [sym_dictionary] = STATE(1796),
    [sym_dictionary_comprehension] = STATE(1796),
    [sym_set] = STATE(1796),
    [sym_set_comprehension] = STATE(1796),
    [sym_parenthesized_expression] = STATE(1796),
    [sym_tuple] = STATE(1796),
    [sym_generator_expression] = STATE(1796),
    [sym_concatenated_string] = STATE(1796),
    [sym_string] = STATE(1325),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3876),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3878),
    [sym_float] = ACTIONS(3878),
    [sym_identifier] = ACTIONS(3878),
    [sym_true] = ACTIONS(3878),
    [sym_false] = ACTIONS(3878),
    [sym_none] = ACTIONS(3878),
    [sym_comment] = ACTIONS(73),
  },
  [1618] = {
    [anon_sym_in] = ACTIONS(3880),
    [sym_comment] = ACTIONS(73),
  },
  [1619] = {
    [sym__primary_expression] = STATE(1798),
    [sym_binary_operator] = STATE(1798),
    [sym_unary_operator] = STATE(1798),
    [sym_attribute] = STATE(1798),
    [sym_subscript] = STATE(1798),
    [sym_call] = STATE(1798),
    [sym_list] = STATE(1798),
    [sym_list_comprehension] = STATE(1798),
    [sym_dictionary] = STATE(1798),
    [sym_dictionary_comprehension] = STATE(1798),
    [sym_set] = STATE(1798),
    [sym_set_comprehension] = STATE(1798),
    [sym_parenthesized_expression] = STATE(1798),
    [sym_tuple] = STATE(1798),
    [sym_generator_expression] = STATE(1798),
    [sym_concatenated_string] = STATE(1798),
    [sym_string] = STATE(1325),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3882),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3884),
    [sym_float] = ACTIONS(3884),
    [sym_identifier] = ACTIONS(3884),
    [sym_true] = ACTIONS(3884),
    [sym_false] = ACTIONS(3884),
    [sym_none] = ACTIONS(3884),
    [sym_comment] = ACTIONS(73),
  },
  [1620] = {
    [sym__primary_expression] = STATE(669),
    [sym_binary_operator] = STATE(669),
    [sym_unary_operator] = STATE(669),
    [sym_attribute] = STATE(669),
    [sym_subscript] = STATE(669),
    [sym_call] = STATE(669),
    [sym_list] = STATE(669),
    [sym_list_comprehension] = STATE(669),
    [sym_dictionary] = STATE(669),
    [sym_dictionary_comprehension] = STATE(669),
    [sym_set] = STATE(669),
    [sym_set_comprehension] = STATE(669),
    [sym_parenthesized_expression] = STATE(669),
    [sym_tuple] = STATE(669),
    [sym_generator_expression] = STATE(669),
    [sym_concatenated_string] = STATE(669),
    [sym_string] = STATE(1325),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1282),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1284),
    [sym_float] = ACTIONS(1284),
    [sym_identifier] = ACTIONS(1284),
    [sym_true] = ACTIONS(1284),
    [sym_false] = ACTIONS(1284),
    [sym_none] = ACTIONS(1284),
    [sym_comment] = ACTIONS(73),
  },
  [1621] = {
    [sym__primary_expression] = STATE(1799),
    [sym_binary_operator] = STATE(1799),
    [sym_unary_operator] = STATE(1799),
    [sym_attribute] = STATE(1799),
    [sym_subscript] = STATE(1799),
    [sym_call] = STATE(1799),
    [sym_list] = STATE(1799),
    [sym_list_comprehension] = STATE(1799),
    [sym_dictionary] = STATE(1799),
    [sym_dictionary_comprehension] = STATE(1799),
    [sym_set] = STATE(1799),
    [sym_set_comprehension] = STATE(1799),
    [sym_parenthesized_expression] = STATE(1799),
    [sym_tuple] = STATE(1799),
    [sym_generator_expression] = STATE(1799),
    [sym_concatenated_string] = STATE(1799),
    [sym_string] = STATE(1325),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3886),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3888),
    [sym_float] = ACTIONS(3888),
    [sym_identifier] = ACTIONS(3888),
    [sym_true] = ACTIONS(3888),
    [sym_false] = ACTIONS(3888),
    [sym_none] = ACTIONS(3888),
    [sym_comment] = ACTIONS(73),
  },
  [1622] = {
    [sym__primary_expression] = STATE(1800),
    [sym_binary_operator] = STATE(1800),
    [sym_unary_operator] = STATE(1800),
    [sym_attribute] = STATE(1800),
    [sym_subscript] = STATE(1800),
    [sym_call] = STATE(1800),
    [sym_list] = STATE(1800),
    [sym_list_comprehension] = STATE(1800),
    [sym_dictionary] = STATE(1800),
    [sym_dictionary_comprehension] = STATE(1800),
    [sym_set] = STATE(1800),
    [sym_set_comprehension] = STATE(1800),
    [sym_parenthesized_expression] = STATE(1800),
    [sym_tuple] = STATE(1800),
    [sym_generator_expression] = STATE(1800),
    [sym_concatenated_string] = STATE(1800),
    [sym_string] = STATE(1325),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3890),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3892),
    [sym_float] = ACTIONS(3892),
    [sym_identifier] = ACTIONS(3892),
    [sym_true] = ACTIONS(3892),
    [sym_false] = ACTIONS(3892),
    [sym_none] = ACTIONS(3892),
    [sym_comment] = ACTIONS(73),
  },
  [1623] = {
    [sym__primary_expression] = STATE(1801),
    [sym_binary_operator] = STATE(1801),
    [sym_unary_operator] = STATE(1801),
    [sym_attribute] = STATE(1801),
    [sym_subscript] = STATE(1801),
    [sym_call] = STATE(1801),
    [sym_list] = STATE(1801),
    [sym_list_comprehension] = STATE(1801),
    [sym_dictionary] = STATE(1801),
    [sym_dictionary_comprehension] = STATE(1801),
    [sym_set] = STATE(1801),
    [sym_set_comprehension] = STATE(1801),
    [sym_parenthesized_expression] = STATE(1801),
    [sym_tuple] = STATE(1801),
    [sym_generator_expression] = STATE(1801),
    [sym_concatenated_string] = STATE(1801),
    [sym_string] = STATE(1325),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3894),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3896),
    [sym_float] = ACTIONS(3896),
    [sym_identifier] = ACTIONS(3896),
    [sym_true] = ACTIONS(3896),
    [sym_false] = ACTIONS(3896),
    [sym_none] = ACTIONS(3896),
    [sym_comment] = ACTIONS(73),
  },
  [1624] = {
    [sym__primary_expression] = STATE(1796),
    [sym_binary_operator] = STATE(1796),
    [sym_unary_operator] = STATE(1796),
    [sym_attribute] = STATE(1796),
    [sym_subscript] = STATE(1796),
    [sym_call] = STATE(1796),
    [sym_list] = STATE(1796),
    [sym_list_comprehension] = STATE(1796),
    [sym_dictionary] = STATE(1796),
    [sym_dictionary_comprehension] = STATE(1796),
    [sym_set] = STATE(1796),
    [sym_set_comprehension] = STATE(1796),
    [sym_parenthesized_expression] = STATE(1796),
    [sym_tuple] = STATE(1796),
    [sym_generator_expression] = STATE(1796),
    [sym_concatenated_string] = STATE(1796),
    [sym_string] = STATE(1325),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(3898),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3876),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3878),
    [sym_float] = ACTIONS(3878),
    [sym_identifier] = ACTIONS(3878),
    [sym_true] = ACTIONS(3878),
    [sym_false] = ACTIONS(3878),
    [sym_none] = ACTIONS(3878),
    [sym_comment] = ACTIONS(73),
  },
  [1625] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1802),
    [anon_sym_if] = ACTIONS(991),
    [anon_sym_async] = ACTIONS(991),
    [anon_sym_for] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(3411),
    [anon_sym_not] = ACTIONS(3415),
    [anon_sym_and] = ACTIONS(991),
    [anon_sym_or] = ACTIONS(991),
    [anon_sym_LT] = ACTIONS(3427),
    [anon_sym_LT_EQ] = ACTIONS(3411),
    [anon_sym_EQ_EQ] = ACTIONS(3411),
    [anon_sym_BANG_EQ] = ACTIONS(3411),
    [anon_sym_GT_EQ] = ACTIONS(3411),
    [anon_sym_GT] = ACTIONS(3427),
    [anon_sym_LT_GT] = ACTIONS(3411),
    [anon_sym_is] = ACTIONS(3429),
    [anon_sym_RBRACK] = ACTIONS(991),
    [sym_comment] = ACTIONS(73),
  },
  [1626] = {
    [sym_string] = STATE(1803),
    [aux_sym_concatenated_string_repeat1] = STATE(1803),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_async] = ACTIONS(995),
    [anon_sym_for] = ACTIONS(995),
    [anon_sym_in] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(995),
    [anon_sym_not] = ACTIONS(995),
    [anon_sym_and] = ACTIONS(995),
    [anon_sym_or] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(995),
    [anon_sym_SLASH_SLASH] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_GT] = ACTIONS(995),
    [anon_sym_is] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(995),
    [anon_sym_RBRACK] = ACTIONS(995),
    [sym_comment] = ACTIONS(73),
  },
  [1627] = {
    [anon_sym_COMMA] = ACTIONS(2647),
    [anon_sym_if] = ACTIONS(1766),
    [anon_sym_and] = ACTIONS(1768),
    [anon_sym_or] = ACTIONS(1770),
    [anon_sym_RBRACE] = ACTIONS(2647),
    [sym_comment] = ACTIONS(73),
  },
  [1628] = {
    [sym__expression] = STATE(1804),
    [sym__primary_expression] = STATE(485),
    [sym_not_operator] = STATE(1804),
    [sym_boolean_operator] = STATE(1804),
    [sym_binary_operator] = STATE(485),
    [sym_unary_operator] = STATE(485),
    [sym_comparison_operator] = STATE(1804),
    [sym_lambda] = STATE(1804),
    [sym_attribute] = STATE(485),
    [sym_subscript] = STATE(485),
    [sym_call] = STATE(485),
    [sym_list] = STATE(485),
    [sym_list_comprehension] = STATE(485),
    [sym_dictionary] = STATE(485),
    [sym_dictionary_comprehension] = STATE(485),
    [sym_set] = STATE(485),
    [sym_set_comprehension] = STATE(485),
    [sym_parenthesized_expression] = STATE(485),
    [sym_tuple] = STATE(485),
    [sym_generator_expression] = STATE(485),
    [sym_conditional_expression] = STATE(1804),
    [sym_concatenated_string] = STATE(485),
    [sym_string] = STATE(486),
    [sym_await] = STATE(1804),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(823),
    [anon_sym_PLUS] = ACTIONS(825),
    [anon_sym_DASH] = ACTIONS(825),
    [anon_sym_TILDE] = ACTIONS(825),
    [anon_sym_lambda] = ACTIONS(827),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(829),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(831),
    [sym_float] = ACTIONS(831),
    [sym_identifier] = ACTIONS(831),
    [sym_true] = ACTIONS(831),
    [sym_false] = ACTIONS(831),
    [sym_none] = ACTIONS(831),
    [anon_sym_await] = ACTIONS(833),
    [sym_comment] = ACTIONS(73),
  },
  [1629] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(2942),
    [anon_sym_STAR] = ACTIONS(1772),
    [anon_sym_GT_GT] = ACTIONS(1774),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_in] = ACTIONS(2942),
    [anon_sym_AT] = ACTIONS(1778),
    [anon_sym_not] = ACTIONS(2942),
    [anon_sym_and] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(1782),
    [anon_sym_DASH] = ACTIONS(1782),
    [anon_sym_SLASH] = ACTIONS(1772),
    [anon_sym_PERCENT] = ACTIONS(1778),
    [anon_sym_SLASH_SLASH] = ACTIONS(1778),
    [anon_sym_STAR_STAR] = ACTIONS(1784),
    [anon_sym_PIPE] = ACTIONS(1786),
    [anon_sym_AMP] = ACTIONS(1788),
    [anon_sym_CARET] = ACTIONS(1790),
    [anon_sym_LT_LT] = ACTIONS(1774),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_LT_EQ] = ACTIONS(2942),
    [anon_sym_EQ_EQ] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_GT_EQ] = ACTIONS(2942),
    [anon_sym_GT] = ACTIONS(2944),
    [anon_sym_LT_GT] = ACTIONS(2942),
    [anon_sym_is] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(473),
    [anon_sym_RBRACE] = ACTIONS(2942),
    [sym_comment] = ACTIONS(73),
  },
  [1630] = {
    [anon_sym_COMMA] = ACTIONS(2790),
    [anon_sym_if] = ACTIONS(1766),
    [anon_sym_and] = ACTIONS(1768),
    [anon_sym_or] = ACTIONS(1770),
    [anon_sym_RBRACE] = ACTIONS(2790),
    [sym_comment] = ACTIONS(73),
  },
  [1631] = {
    [anon_sym_COMMA] = ACTIONS(3565),
    [anon_sym_if] = ACTIONS(847),
    [anon_sym_COLON] = ACTIONS(3565),
    [anon_sym_async] = ACTIONS(3565),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_and] = ACTIONS(855),
    [anon_sym_or] = ACTIONS(857),
    [anon_sym_RBRACE] = ACTIONS(3565),
    [sym_comment] = ACTIONS(73),
  },
  [1632] = {
    [anon_sym_COMMA] = ACTIONS(1660),
    [anon_sym_if] = ACTIONS(2792),
    [anon_sym_async] = ACTIONS(1660),
    [anon_sym_for] = ACTIONS(1660),
    [anon_sym_and] = ACTIONS(2794),
    [anon_sym_or] = ACTIONS(2796),
    [anon_sym_RBRACE] = ACTIONS(1660),
    [sym_comment] = ACTIONS(73),
  },
  [1633] = {
    [sym__expression] = STATE(1805),
    [sym__primary_expression] = STATE(973),
    [sym_not_operator] = STATE(1805),
    [sym_boolean_operator] = STATE(1805),
    [sym_binary_operator] = STATE(973),
    [sym_unary_operator] = STATE(973),
    [sym_comparison_operator] = STATE(1805),
    [sym_lambda] = STATE(1805),
    [sym_attribute] = STATE(973),
    [sym_subscript] = STATE(973),
    [sym_call] = STATE(973),
    [sym_list] = STATE(973),
    [sym_list_comprehension] = STATE(973),
    [sym_dictionary] = STATE(973),
    [sym_dictionary_comprehension] = STATE(973),
    [sym_set] = STATE(973),
    [sym_set_comprehension] = STATE(973),
    [sym_parenthesized_expression] = STATE(973),
    [sym_tuple] = STATE(973),
    [sym_generator_expression] = STATE(973),
    [sym_conditional_expression] = STATE(1805),
    [sym_concatenated_string] = STATE(973),
    [sym_string] = STATE(974),
    [sym_await] = STATE(1805),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1814),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_DASH] = ACTIONS(1816),
    [anon_sym_TILDE] = ACTIONS(1816),
    [anon_sym_lambda] = ACTIONS(1818),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1820),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1822),
    [sym_float] = ACTIONS(1822),
    [sym_identifier] = ACTIONS(1822),
    [sym_true] = ACTIONS(1822),
    [sym_false] = ACTIONS(1822),
    [sym_none] = ACTIONS(1822),
    [anon_sym_await] = ACTIONS(1824),
    [sym_comment] = ACTIONS(73),
  },
  [1634] = {
    [anon_sym_if] = ACTIONS(1925),
    [anon_sym_else] = ACTIONS(3900),
    [anon_sym_and] = ACTIONS(1929),
    [anon_sym_or] = ACTIONS(1931),
    [sym_comment] = ACTIONS(73),
  },
  [1635] = {
    [anon_sym_COMMA] = ACTIONS(1957),
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_async] = ACTIONS(1957),
    [anon_sym_for] = ACTIONS(1957),
    [anon_sym_and] = ACTIONS(2794),
    [anon_sym_or] = ACTIONS(1957),
    [anon_sym_RBRACE] = ACTIONS(1957),
    [sym_comment] = ACTIONS(73),
  },
  [1636] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1984),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1986),
    [anon_sym_PERCENT] = ACTIONS(1984),
    [anon_sym_SLASH_SLASH] = ACTIONS(1984),
    [anon_sym_STAR_STAR] = ACTIONS(2810),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1637] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(2798),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(2804),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(2808),
    [anon_sym_DASH] = ACTIONS(2808),
    [anon_sym_SLASH] = ACTIONS(2798),
    [anon_sym_PERCENT] = ACTIONS(2804),
    [anon_sym_SLASH_SLASH] = ACTIONS(2804),
    [anon_sym_STAR_STAR] = ACTIONS(2810),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1638] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1988),
    [anon_sym_STAR] = ACTIONS(2798),
    [anon_sym_GT_GT] = ACTIONS(2800),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_async] = ACTIONS(1988),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(1988),
    [anon_sym_AT] = ACTIONS(2804),
    [anon_sym_not] = ACTIONS(1988),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_PLUS] = ACTIONS(2808),
    [anon_sym_DASH] = ACTIONS(2808),
    [anon_sym_SLASH] = ACTIONS(2798),
    [anon_sym_PERCENT] = ACTIONS(2804),
    [anon_sym_SLASH_SLASH] = ACTIONS(2804),
    [anon_sym_STAR_STAR] = ACTIONS(2810),
    [anon_sym_PIPE] = ACTIONS(2812),
    [anon_sym_AMP] = ACTIONS(2814),
    [anon_sym_CARET] = ACTIONS(2816),
    [anon_sym_LT_LT] = ACTIONS(2800),
    [anon_sym_LT] = ACTIONS(1990),
    [anon_sym_LT_EQ] = ACTIONS(1988),
    [anon_sym_EQ_EQ] = ACTIONS(1988),
    [anon_sym_BANG_EQ] = ACTIONS(1988),
    [anon_sym_GT_EQ] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1990),
    [anon_sym_LT_GT] = ACTIONS(1988),
    [anon_sym_is] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(473),
    [anon_sym_RBRACE] = ACTIONS(1988),
    [sym_comment] = ACTIONS(73),
  },
  [1639] = {
    [sym__primary_expression] = STATE(1807),
    [sym_binary_operator] = STATE(1807),
    [sym_unary_operator] = STATE(1807),
    [sym_attribute] = STATE(1807),
    [sym_subscript] = STATE(1807),
    [sym_call] = STATE(1807),
    [sym_list] = STATE(1807),
    [sym_list_comprehension] = STATE(1807),
    [sym_dictionary] = STATE(1807),
    [sym_dictionary_comprehension] = STATE(1807),
    [sym_set] = STATE(1807),
    [sym_set_comprehension] = STATE(1807),
    [sym_parenthesized_expression] = STATE(1807),
    [sym_tuple] = STATE(1807),
    [sym_generator_expression] = STATE(1807),
    [sym_concatenated_string] = STATE(1807),
    [sym_string] = STATE(974),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_DASH] = ACTIONS(1816),
    [anon_sym_TILDE] = ACTIONS(1816),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3902),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3904),
    [sym_float] = ACTIONS(3904),
    [sym_identifier] = ACTIONS(3904),
    [sym_true] = ACTIONS(3904),
    [sym_false] = ACTIONS(3904),
    [sym_none] = ACTIONS(3904),
    [sym_comment] = ACTIONS(73),
  },
  [1640] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(2798),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(2804),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(2798),
    [anon_sym_PERCENT] = ACTIONS(2804),
    [anon_sym_SLASH_SLASH] = ACTIONS(2804),
    [anon_sym_STAR_STAR] = ACTIONS(2810),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1641] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(2798),
    [anon_sym_GT_GT] = ACTIONS(2800),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(2804),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(2808),
    [anon_sym_DASH] = ACTIONS(2808),
    [anon_sym_SLASH] = ACTIONS(2798),
    [anon_sym_PERCENT] = ACTIONS(2804),
    [anon_sym_SLASH_SLASH] = ACTIONS(2804),
    [anon_sym_STAR_STAR] = ACTIONS(2810),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(2814),
    [anon_sym_CARET] = ACTIONS(2816),
    [anon_sym_LT_LT] = ACTIONS(2800),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1642] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(2798),
    [anon_sym_GT_GT] = ACTIONS(2800),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(2804),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(2808),
    [anon_sym_DASH] = ACTIONS(2808),
    [anon_sym_SLASH] = ACTIONS(2798),
    [anon_sym_PERCENT] = ACTIONS(2804),
    [anon_sym_SLASH_SLASH] = ACTIONS(2804),
    [anon_sym_STAR_STAR] = ACTIONS(2810),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(2816),
    [anon_sym_LT_LT] = ACTIONS(2800),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1643] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(2798),
    [anon_sym_GT_GT] = ACTIONS(2800),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(2804),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(2808),
    [anon_sym_DASH] = ACTIONS(2808),
    [anon_sym_SLASH] = ACTIONS(2798),
    [anon_sym_PERCENT] = ACTIONS(2804),
    [anon_sym_SLASH_SLASH] = ACTIONS(2804),
    [anon_sym_STAR_STAR] = ACTIONS(2810),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(2800),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1644] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1644),
    [anon_sym_COMMA] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_async] = ACTIONS(1988),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(3906),
    [anon_sym_not] = ACTIONS(3909),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(3912),
    [anon_sym_LT_EQ] = ACTIONS(3906),
    [anon_sym_EQ_EQ] = ACTIONS(3906),
    [anon_sym_BANG_EQ] = ACTIONS(3906),
    [anon_sym_GT_EQ] = ACTIONS(3906),
    [anon_sym_GT] = ACTIONS(3912),
    [anon_sym_LT_GT] = ACTIONS(3906),
    [anon_sym_is] = ACTIONS(3915),
    [anon_sym_RBRACE] = ACTIONS(1988),
    [sym_comment] = ACTIONS(73),
  },
  [1645] = {
    [sym_string] = STATE(1645),
    [aux_sym_concatenated_string_repeat1] = STATE(1645),
    [sym__string_start] = ACTIONS(2241),
    [anon_sym_DOT] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(2050),
    [anon_sym_COMMA] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2050),
    [anon_sym_if] = ACTIONS(2050),
    [anon_sym_async] = ACTIONS(2050),
    [anon_sym_for] = ACTIONS(2050),
    [anon_sym_in] = ACTIONS(2050),
    [anon_sym_AT] = ACTIONS(2050),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_and] = ACTIONS(2050),
    [anon_sym_or] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_SLASH] = ACTIONS(2055),
    [anon_sym_PERCENT] = ACTIONS(2050),
    [anon_sym_SLASH_SLASH] = ACTIONS(2050),
    [anon_sym_STAR_STAR] = ACTIONS(2050),
    [anon_sym_PIPE] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2050),
    [anon_sym_CARET] = ACTIONS(2050),
    [anon_sym_LT_LT] = ACTIONS(2050),
    [anon_sym_LT] = ACTIONS(2055),
    [anon_sym_LT_EQ] = ACTIONS(2050),
    [anon_sym_EQ_EQ] = ACTIONS(2050),
    [anon_sym_BANG_EQ] = ACTIONS(2050),
    [anon_sym_GT_EQ] = ACTIONS(2050),
    [anon_sym_GT] = ACTIONS(2055),
    [anon_sym_LT_GT] = ACTIONS(2050),
    [anon_sym_is] = ACTIONS(2050),
    [anon_sym_LBRACK] = ACTIONS(2050),
    [anon_sym_RBRACE] = ACTIONS(2050),
    [sym_comment] = ACTIONS(73),
  },
  [1646] = {
    [sym__expression_within_for_in_clause] = STATE(1808),
    [sym__expression] = STATE(1649),
    [sym__primary_expression] = STATE(973),
    [sym_not_operator] = STATE(1649),
    [sym_boolean_operator] = STATE(1649),
    [sym_binary_operator] = STATE(973),
    [sym_unary_operator] = STATE(973),
    [sym_comparison_operator] = STATE(1649),
    [sym_lambda] = STATE(1649),
    [sym_lambda_within_for_in_clause] = STATE(1808),
    [sym_attribute] = STATE(973),
    [sym_subscript] = STATE(973),
    [sym_call] = STATE(973),
    [sym_list] = STATE(973),
    [sym_list_comprehension] = STATE(973),
    [sym_dictionary] = STATE(973),
    [sym_dictionary_comprehension] = STATE(973),
    [sym_set] = STATE(973),
    [sym_set_comprehension] = STATE(973),
    [sym_parenthesized_expression] = STATE(973),
    [sym_tuple] = STATE(973),
    [sym_generator_expression] = STATE(973),
    [sym_conditional_expression] = STATE(1649),
    [sym_concatenated_string] = STATE(973),
    [sym_string] = STATE(974),
    [sym_await] = STATE(1649),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1814),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_DASH] = ACTIONS(1816),
    [anon_sym_TILDE] = ACTIONS(1816),
    [anon_sym_lambda] = ACTIONS(3502),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1820),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1822),
    [sym_float] = ACTIONS(1822),
    [sym_identifier] = ACTIONS(1822),
    [sym_true] = ACTIONS(1822),
    [sym_false] = ACTIONS(1822),
    [sym_none] = ACTIONS(1822),
    [anon_sym_await] = ACTIONS(1824),
    [sym_comment] = ACTIONS(73),
  },
  [1647] = {
    [sym_lambda_parameters] = STATE(1810),
    [sym__parameters] = STATE(138),
    [sym_default_parameter] = STATE(139),
    [sym_typed_default_parameter] = STATE(139),
    [sym_list_splat] = STATE(140),
    [sym_dictionary_splat] = STATE(140),
    [sym_typed_parameter] = STATE(139),
    [sym_tuple] = STATE(139),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(229),
    [anon_sym_print] = ACTIONS(231),
    [anon_sym_COLON] = ACTIONS(3918),
    [anon_sym_exec] = ACTIONS(231),
    [sym_identifier] = ACTIONS(235),
    [sym_comment] = ACTIONS(73),
  },
  [1648] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1812),
    [anon_sym_COMMA] = ACTIONS(3920),
    [anon_sym_if] = ACTIONS(3639),
    [anon_sym_async] = ACTIONS(3639),
    [anon_sym_for] = ACTIONS(3639),
    [anon_sym_RBRACE] = ACTIONS(3639),
    [sym_comment] = ACTIONS(73),
  },
  [1649] = {
    [anon_sym_COMMA] = ACTIONS(3643),
    [anon_sym_if] = ACTIONS(3643),
    [anon_sym_async] = ACTIONS(3643),
    [anon_sym_for] = ACTIONS(3643),
    [anon_sym_and] = ACTIONS(2794),
    [anon_sym_or] = ACTIONS(2796),
    [anon_sym_RBRACE] = ACTIONS(3643),
    [sym_comment] = ACTIONS(73),
  },
  [1650] = {
    [anon_sym_if] = ACTIONS(723),
    [anon_sym_async] = ACTIONS(723),
    [anon_sym_for] = ACTIONS(723),
    [anon_sym_and] = ACTIONS(3506),
    [anon_sym_or] = ACTIONS(3508),
    [anon_sym_RBRACE] = ACTIONS(723),
    [sym_comment] = ACTIONS(73),
  },
  [1651] = {
    [sym__expression] = STATE(1813),
    [sym__primary_expression] = STATE(1374),
    [sym_not_operator] = STATE(1813),
    [sym_boolean_operator] = STATE(1813),
    [sym_binary_operator] = STATE(1374),
    [sym_unary_operator] = STATE(1374),
    [sym_comparison_operator] = STATE(1813),
    [sym_lambda] = STATE(1813),
    [sym_attribute] = STATE(1374),
    [sym_subscript] = STATE(1374),
    [sym_call] = STATE(1374),
    [sym_list] = STATE(1374),
    [sym_list_comprehension] = STATE(1374),
    [sym_dictionary] = STATE(1374),
    [sym_dictionary_comprehension] = STATE(1374),
    [sym_set] = STATE(1374),
    [sym_set_comprehension] = STATE(1374),
    [sym_parenthesized_expression] = STATE(1374),
    [sym_tuple] = STATE(1374),
    [sym_generator_expression] = STATE(1374),
    [sym_conditional_expression] = STATE(1813),
    [sym_concatenated_string] = STATE(1374),
    [sym_string] = STATE(1375),
    [sym_await] = STATE(1813),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2828),
    [anon_sym_PLUS] = ACTIONS(2830),
    [anon_sym_DASH] = ACTIONS(2830),
    [anon_sym_TILDE] = ACTIONS(2830),
    [anon_sym_lambda] = ACTIONS(2832),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2834),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2836),
    [sym_float] = ACTIONS(2836),
    [sym_identifier] = ACTIONS(2836),
    [sym_true] = ACTIONS(2836),
    [sym_false] = ACTIONS(2836),
    [sym_none] = ACTIONS(2836),
    [anon_sym_await] = ACTIONS(2838),
    [sym_comment] = ACTIONS(73),
  },
  [1652] = {
    [anon_sym_COLON] = ACTIONS(3922),
    [sym_comment] = ACTIONS(73),
  },
  [1653] = {
    [sym__expression] = STATE(1815),
    [sym__primary_expression] = STATE(538),
    [sym_not_operator] = STATE(1815),
    [sym_boolean_operator] = STATE(1815),
    [sym_binary_operator] = STATE(538),
    [sym_unary_operator] = STATE(538),
    [sym_comparison_operator] = STATE(1815),
    [sym_lambda] = STATE(1815),
    [sym_attribute] = STATE(538),
    [sym_subscript] = STATE(538),
    [sym_call] = STATE(538),
    [sym_list] = STATE(538),
    [sym_list_comprehension] = STATE(538),
    [sym_dictionary] = STATE(538),
    [sym_dictionary_comprehension] = STATE(538),
    [sym_set] = STATE(538),
    [sym_set_comprehension] = STATE(538),
    [sym_parenthesized_expression] = STATE(538),
    [sym_tuple] = STATE(538),
    [sym_generator_expression] = STATE(538),
    [sym_conditional_expression] = STATE(1815),
    [sym_concatenated_string] = STATE(538),
    [sym_string] = STATE(539),
    [sym_await] = STATE(1815),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_lambda] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(917),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(919),
    [sym_float] = ACTIONS(919),
    [sym_identifier] = ACTIONS(919),
    [sym_true] = ACTIONS(919),
    [sym_false] = ACTIONS(919),
    [sym_none] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(921),
    [sym_comment] = ACTIONS(73),
  },
  [1654] = {
    [sym__expression] = STATE(652),
    [sym__primary_expression] = STATE(1374),
    [sym_not_operator] = STATE(652),
    [sym_boolean_operator] = STATE(652),
    [sym_binary_operator] = STATE(1374),
    [sym_unary_operator] = STATE(1374),
    [sym_comparison_operator] = STATE(652),
    [sym_lambda] = STATE(652),
    [sym_attribute] = STATE(1374),
    [sym_subscript] = STATE(1374),
    [sym_call] = STATE(1374),
    [sym_list] = STATE(1374),
    [sym_list_comprehension] = STATE(1374),
    [sym_dictionary] = STATE(1374),
    [sym_dictionary_comprehension] = STATE(1374),
    [sym_set] = STATE(1374),
    [sym_set_comprehension] = STATE(1374),
    [sym_parenthesized_expression] = STATE(1374),
    [sym_tuple] = STATE(1374),
    [sym_generator_expression] = STATE(1374),
    [sym_conditional_expression] = STATE(652),
    [sym_concatenated_string] = STATE(1374),
    [sym_string] = STATE(1375),
    [sym_await] = STATE(652),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2828),
    [anon_sym_PLUS] = ACTIONS(2830),
    [anon_sym_DASH] = ACTIONS(2830),
    [anon_sym_TILDE] = ACTIONS(2830),
    [anon_sym_lambda] = ACTIONS(2832),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2834),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2836),
    [sym_float] = ACTIONS(2836),
    [sym_identifier] = ACTIONS(2836),
    [sym_true] = ACTIONS(2836),
    [sym_false] = ACTIONS(2836),
    [sym_none] = ACTIONS(2836),
    [anon_sym_await] = ACTIONS(2838),
    [sym_comment] = ACTIONS(73),
  },
  [1655] = {
    [sym__expression] = STATE(1816),
    [sym__primary_expression] = STATE(1374),
    [sym_not_operator] = STATE(1816),
    [sym_boolean_operator] = STATE(1816),
    [sym_binary_operator] = STATE(1374),
    [sym_unary_operator] = STATE(1374),
    [sym_comparison_operator] = STATE(1816),
    [sym_lambda] = STATE(1816),
    [sym_attribute] = STATE(1374),
    [sym_subscript] = STATE(1374),
    [sym_call] = STATE(1374),
    [sym_list] = STATE(1374),
    [sym_list_comprehension] = STATE(1374),
    [sym_dictionary] = STATE(1374),
    [sym_dictionary_comprehension] = STATE(1374),
    [sym_set] = STATE(1374),
    [sym_set_comprehension] = STATE(1374),
    [sym_parenthesized_expression] = STATE(1374),
    [sym_tuple] = STATE(1374),
    [sym_generator_expression] = STATE(1374),
    [sym_conditional_expression] = STATE(1816),
    [sym_concatenated_string] = STATE(1374),
    [sym_string] = STATE(1375),
    [sym_await] = STATE(1816),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2828),
    [anon_sym_PLUS] = ACTIONS(2830),
    [anon_sym_DASH] = ACTIONS(2830),
    [anon_sym_TILDE] = ACTIONS(2830),
    [anon_sym_lambda] = ACTIONS(2832),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2834),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2836),
    [sym_float] = ACTIONS(2836),
    [sym_identifier] = ACTIONS(2836),
    [sym_true] = ACTIONS(2836),
    [sym_false] = ACTIONS(2836),
    [sym_none] = ACTIONS(2836),
    [anon_sym_await] = ACTIONS(2838),
    [sym_comment] = ACTIONS(73),
  },
  [1656] = {
    [sym__primary_expression] = STATE(1817),
    [sym_binary_operator] = STATE(1817),
    [sym_unary_operator] = STATE(1817),
    [sym_attribute] = STATE(1817),
    [sym_subscript] = STATE(1817),
    [sym_call] = STATE(1817),
    [sym_list] = STATE(1817),
    [sym_list_comprehension] = STATE(1817),
    [sym_dictionary] = STATE(1817),
    [sym_dictionary_comprehension] = STATE(1817),
    [sym_set] = STATE(1817),
    [sym_set_comprehension] = STATE(1817),
    [sym_parenthesized_expression] = STATE(1817),
    [sym_tuple] = STATE(1817),
    [sym_generator_expression] = STATE(1817),
    [sym_concatenated_string] = STATE(1817),
    [sym_string] = STATE(1375),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2830),
    [anon_sym_DASH] = ACTIONS(2830),
    [anon_sym_TILDE] = ACTIONS(2830),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3924),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3926),
    [sym_float] = ACTIONS(3926),
    [sym_identifier] = ACTIONS(3926),
    [sym_true] = ACTIONS(3926),
    [sym_false] = ACTIONS(3926),
    [sym_none] = ACTIONS(3926),
    [sym_comment] = ACTIONS(73),
  },
  [1657] = {
    [sym__primary_expression] = STATE(1818),
    [sym_binary_operator] = STATE(1818),
    [sym_unary_operator] = STATE(1818),
    [sym_attribute] = STATE(1818),
    [sym_subscript] = STATE(1818),
    [sym_call] = STATE(1818),
    [sym_list] = STATE(1818),
    [sym_list_comprehension] = STATE(1818),
    [sym_dictionary] = STATE(1818),
    [sym_dictionary_comprehension] = STATE(1818),
    [sym_set] = STATE(1818),
    [sym_set_comprehension] = STATE(1818),
    [sym_parenthesized_expression] = STATE(1818),
    [sym_tuple] = STATE(1818),
    [sym_generator_expression] = STATE(1818),
    [sym_concatenated_string] = STATE(1818),
    [sym_string] = STATE(1375),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2830),
    [anon_sym_DASH] = ACTIONS(2830),
    [anon_sym_TILDE] = ACTIONS(2830),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3928),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3930),
    [sym_float] = ACTIONS(3930),
    [sym_identifier] = ACTIONS(3930),
    [sym_true] = ACTIONS(3930),
    [sym_false] = ACTIONS(3930),
    [sym_none] = ACTIONS(3930),
    [sym_comment] = ACTIONS(73),
  },
  [1658] = {
    [sym__primary_expression] = STATE(1819),
    [sym_binary_operator] = STATE(1819),
    [sym_unary_operator] = STATE(1819),
    [sym_attribute] = STATE(1819),
    [sym_subscript] = STATE(1819),
    [sym_call] = STATE(1819),
    [sym_list] = STATE(1819),
    [sym_list_comprehension] = STATE(1819),
    [sym_dictionary] = STATE(1819),
    [sym_dictionary_comprehension] = STATE(1819),
    [sym_set] = STATE(1819),
    [sym_set_comprehension] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1819),
    [sym_tuple] = STATE(1819),
    [sym_generator_expression] = STATE(1819),
    [sym_concatenated_string] = STATE(1819),
    [sym_string] = STATE(1375),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2830),
    [anon_sym_DASH] = ACTIONS(2830),
    [anon_sym_TILDE] = ACTIONS(2830),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3932),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3934),
    [sym_float] = ACTIONS(3934),
    [sym_identifier] = ACTIONS(3934),
    [sym_true] = ACTIONS(3934),
    [sym_false] = ACTIONS(3934),
    [sym_none] = ACTIONS(3934),
    [sym_comment] = ACTIONS(73),
  },
  [1659] = {
    [anon_sym_in] = ACTIONS(3936),
    [sym_comment] = ACTIONS(73),
  },
  [1660] = {
    [sym__primary_expression] = STATE(1821),
    [sym_binary_operator] = STATE(1821),
    [sym_unary_operator] = STATE(1821),
    [sym_attribute] = STATE(1821),
    [sym_subscript] = STATE(1821),
    [sym_call] = STATE(1821),
    [sym_list] = STATE(1821),
    [sym_list_comprehension] = STATE(1821),
    [sym_dictionary] = STATE(1821),
    [sym_dictionary_comprehension] = STATE(1821),
    [sym_set] = STATE(1821),
    [sym_set_comprehension] = STATE(1821),
    [sym_parenthesized_expression] = STATE(1821),
    [sym_tuple] = STATE(1821),
    [sym_generator_expression] = STATE(1821),
    [sym_concatenated_string] = STATE(1821),
    [sym_string] = STATE(1375),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2830),
    [anon_sym_DASH] = ACTIONS(2830),
    [anon_sym_TILDE] = ACTIONS(2830),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3938),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3940),
    [sym_float] = ACTIONS(3940),
    [sym_identifier] = ACTIONS(3940),
    [sym_true] = ACTIONS(3940),
    [sym_false] = ACTIONS(3940),
    [sym_none] = ACTIONS(3940),
    [sym_comment] = ACTIONS(73),
  },
  [1661] = {
    [sym__primary_expression] = STATE(669),
    [sym_binary_operator] = STATE(669),
    [sym_unary_operator] = STATE(669),
    [sym_attribute] = STATE(669),
    [sym_subscript] = STATE(669),
    [sym_call] = STATE(669),
    [sym_list] = STATE(669),
    [sym_list_comprehension] = STATE(669),
    [sym_dictionary] = STATE(669),
    [sym_dictionary_comprehension] = STATE(669),
    [sym_set] = STATE(669),
    [sym_set_comprehension] = STATE(669),
    [sym_parenthesized_expression] = STATE(669),
    [sym_tuple] = STATE(669),
    [sym_generator_expression] = STATE(669),
    [sym_concatenated_string] = STATE(669),
    [sym_string] = STATE(1375),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2830),
    [anon_sym_DASH] = ACTIONS(2830),
    [anon_sym_TILDE] = ACTIONS(2830),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1282),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1284),
    [sym_float] = ACTIONS(1284),
    [sym_identifier] = ACTIONS(1284),
    [sym_true] = ACTIONS(1284),
    [sym_false] = ACTIONS(1284),
    [sym_none] = ACTIONS(1284),
    [sym_comment] = ACTIONS(73),
  },
  [1662] = {
    [sym__primary_expression] = STATE(1822),
    [sym_binary_operator] = STATE(1822),
    [sym_unary_operator] = STATE(1822),
    [sym_attribute] = STATE(1822),
    [sym_subscript] = STATE(1822),
    [sym_call] = STATE(1822),
    [sym_list] = STATE(1822),
    [sym_list_comprehension] = STATE(1822),
    [sym_dictionary] = STATE(1822),
    [sym_dictionary_comprehension] = STATE(1822),
    [sym_set] = STATE(1822),
    [sym_set_comprehension] = STATE(1822),
    [sym_parenthesized_expression] = STATE(1822),
    [sym_tuple] = STATE(1822),
    [sym_generator_expression] = STATE(1822),
    [sym_concatenated_string] = STATE(1822),
    [sym_string] = STATE(1375),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2830),
    [anon_sym_DASH] = ACTIONS(2830),
    [anon_sym_TILDE] = ACTIONS(2830),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3942),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3944),
    [sym_float] = ACTIONS(3944),
    [sym_identifier] = ACTIONS(3944),
    [sym_true] = ACTIONS(3944),
    [sym_false] = ACTIONS(3944),
    [sym_none] = ACTIONS(3944),
    [sym_comment] = ACTIONS(73),
  },
  [1663] = {
    [sym__primary_expression] = STATE(1823),
    [sym_binary_operator] = STATE(1823),
    [sym_unary_operator] = STATE(1823),
    [sym_attribute] = STATE(1823),
    [sym_subscript] = STATE(1823),
    [sym_call] = STATE(1823),
    [sym_list] = STATE(1823),
    [sym_list_comprehension] = STATE(1823),
    [sym_dictionary] = STATE(1823),
    [sym_dictionary_comprehension] = STATE(1823),
    [sym_set] = STATE(1823),
    [sym_set_comprehension] = STATE(1823),
    [sym_parenthesized_expression] = STATE(1823),
    [sym_tuple] = STATE(1823),
    [sym_generator_expression] = STATE(1823),
    [sym_concatenated_string] = STATE(1823),
    [sym_string] = STATE(1375),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2830),
    [anon_sym_DASH] = ACTIONS(2830),
    [anon_sym_TILDE] = ACTIONS(2830),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3946),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3948),
    [sym_float] = ACTIONS(3948),
    [sym_identifier] = ACTIONS(3948),
    [sym_true] = ACTIONS(3948),
    [sym_false] = ACTIONS(3948),
    [sym_none] = ACTIONS(3948),
    [sym_comment] = ACTIONS(73),
  },
  [1664] = {
    [sym__primary_expression] = STATE(1824),
    [sym_binary_operator] = STATE(1824),
    [sym_unary_operator] = STATE(1824),
    [sym_attribute] = STATE(1824),
    [sym_subscript] = STATE(1824),
    [sym_call] = STATE(1824),
    [sym_list] = STATE(1824),
    [sym_list_comprehension] = STATE(1824),
    [sym_dictionary] = STATE(1824),
    [sym_dictionary_comprehension] = STATE(1824),
    [sym_set] = STATE(1824),
    [sym_set_comprehension] = STATE(1824),
    [sym_parenthesized_expression] = STATE(1824),
    [sym_tuple] = STATE(1824),
    [sym_generator_expression] = STATE(1824),
    [sym_concatenated_string] = STATE(1824),
    [sym_string] = STATE(1375),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2830),
    [anon_sym_DASH] = ACTIONS(2830),
    [anon_sym_TILDE] = ACTIONS(2830),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3950),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3952),
    [sym_float] = ACTIONS(3952),
    [sym_identifier] = ACTIONS(3952),
    [sym_true] = ACTIONS(3952),
    [sym_false] = ACTIONS(3952),
    [sym_none] = ACTIONS(3952),
    [sym_comment] = ACTIONS(73),
  },
  [1665] = {
    [sym__primary_expression] = STATE(1819),
    [sym_binary_operator] = STATE(1819),
    [sym_unary_operator] = STATE(1819),
    [sym_attribute] = STATE(1819),
    [sym_subscript] = STATE(1819),
    [sym_call] = STATE(1819),
    [sym_list] = STATE(1819),
    [sym_list_comprehension] = STATE(1819),
    [sym_dictionary] = STATE(1819),
    [sym_dictionary_comprehension] = STATE(1819),
    [sym_set] = STATE(1819),
    [sym_set_comprehension] = STATE(1819),
    [sym_parenthesized_expression] = STATE(1819),
    [sym_tuple] = STATE(1819),
    [sym_generator_expression] = STATE(1819),
    [sym_concatenated_string] = STATE(1819),
    [sym_string] = STATE(1375),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(3954),
    [anon_sym_PLUS] = ACTIONS(2830),
    [anon_sym_DASH] = ACTIONS(2830),
    [anon_sym_TILDE] = ACTIONS(2830),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3932),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3934),
    [sym_float] = ACTIONS(3934),
    [sym_identifier] = ACTIONS(3934),
    [sym_true] = ACTIONS(3934),
    [sym_false] = ACTIONS(3934),
    [sym_none] = ACTIONS(3934),
    [sym_comment] = ACTIONS(73),
  },
  [1666] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1825),
    [anon_sym_if] = ACTIONS(991),
    [anon_sym_async] = ACTIONS(991),
    [anon_sym_for] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(3514),
    [anon_sym_not] = ACTIONS(3518),
    [anon_sym_and] = ACTIONS(991),
    [anon_sym_or] = ACTIONS(991),
    [anon_sym_LT] = ACTIONS(3530),
    [anon_sym_LT_EQ] = ACTIONS(3514),
    [anon_sym_EQ_EQ] = ACTIONS(3514),
    [anon_sym_BANG_EQ] = ACTIONS(3514),
    [anon_sym_GT_EQ] = ACTIONS(3514),
    [anon_sym_GT] = ACTIONS(3530),
    [anon_sym_LT_GT] = ACTIONS(3514),
    [anon_sym_is] = ACTIONS(3532),
    [anon_sym_RBRACE] = ACTIONS(991),
    [sym_comment] = ACTIONS(73),
  },
  [1667] = {
    [sym_string] = STATE(1826),
    [aux_sym_concatenated_string_repeat1] = STATE(1826),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_async] = ACTIONS(995),
    [anon_sym_for] = ACTIONS(995),
    [anon_sym_in] = ACTIONS(995),
    [anon_sym_AT] = ACTIONS(995),
    [anon_sym_not] = ACTIONS(995),
    [anon_sym_and] = ACTIONS(995),
    [anon_sym_or] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(995),
    [anon_sym_SLASH_SLASH] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_GT] = ACTIONS(995),
    [anon_sym_is] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(995),
    [anon_sym_RBRACE] = ACTIONS(995),
    [sym_comment] = ACTIONS(73),
  },
  [1668] = {
    [sym__newline] = ACTIONS(2647),
    [anon_sym_if] = ACTIONS(1881),
    [anon_sym_EQ] = ACTIONS(2647),
    [anon_sym_and] = ACTIONS(1883),
    [anon_sym_or] = ACTIONS(1885),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2647),
  },
  [1669] = {
    [sym__expression] = STATE(1827),
    [sym__primary_expression] = STATE(525),
    [sym_not_operator] = STATE(1827),
    [sym_boolean_operator] = STATE(1827),
    [sym_binary_operator] = STATE(525),
    [sym_unary_operator] = STATE(525),
    [sym_comparison_operator] = STATE(1827),
    [sym_lambda] = STATE(1827),
    [sym_attribute] = STATE(525),
    [sym_subscript] = STATE(525),
    [sym_call] = STATE(525),
    [sym_list] = STATE(525),
    [sym_list_comprehension] = STATE(525),
    [sym_dictionary] = STATE(525),
    [sym_dictionary_comprehension] = STATE(525),
    [sym_set] = STATE(525),
    [sym_set_comprehension] = STATE(525),
    [sym_parenthesized_expression] = STATE(525),
    [sym_tuple] = STATE(525),
    [sym_generator_expression] = STATE(525),
    [sym_conditional_expression] = STATE(1827),
    [sym_concatenated_string] = STATE(525),
    [sym_string] = STATE(527),
    [sym_await] = STATE(1827),
    [sym__string_start] = ACTIONS(121),
    [anon_sym_LPAREN] = ACTIONS(141),
    [anon_sym_print] = ACTIONS(125),
    [anon_sym_exec] = ACTIONS(125),
    [anon_sym_not] = ACTIONS(893),
    [anon_sym_PLUS] = ACTIONS(895),
    [anon_sym_DASH] = ACTIONS(895),
    [anon_sym_TILDE] = ACTIONS(895),
    [anon_sym_lambda] = ACTIONS(897),
    [anon_sym_LBRACK] = ACTIONS(145),
    [sym_ellipsis] = ACTIONS(899),
    [anon_sym_LBRACE] = ACTIONS(135),
    [sym_integer] = ACTIONS(901),
    [sym_float] = ACTIONS(901),
    [sym_identifier] = ACTIONS(901),
    [sym_true] = ACTIONS(901),
    [sym_false] = ACTIONS(901),
    [sym_none] = ACTIONS(901),
    [anon_sym_await] = ACTIONS(903),
    [sym_comment] = ACTIONS(73),
  },
  [1670] = {
    [sym_argument_list] = STATE(315),
    [sym_generator_expression] = STATE(315),
    [sym__newline] = ACTIONS(2942),
    [anon_sym_DOT] = ACTIONS(507),
    [anon_sym_LPAREN] = ACTIONS(509),
    [anon_sym_STAR] = ACTIONS(1887),
    [anon_sym_GT_GT] = ACTIONS(1889),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_in] = ACTIONS(2942),
    [anon_sym_EQ] = ACTIONS(2944),
    [anon_sym_AT] = ACTIONS(1893),
    [anon_sym_not] = ACTIONS(2942),
    [anon_sym_and] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(1897),
    [anon_sym_DASH] = ACTIONS(1897),
    [anon_sym_SLASH] = ACTIONS(1887),
    [anon_sym_PERCENT] = ACTIONS(1893),
    [anon_sym_SLASH_SLASH] = ACTIONS(1893),
    [anon_sym_STAR_STAR] = ACTIONS(1899),
    [anon_sym_PIPE] = ACTIONS(1901),
    [anon_sym_AMP] = ACTIONS(1903),
    [anon_sym_CARET] = ACTIONS(1905),
    [anon_sym_LT_LT] = ACTIONS(1889),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_LT_EQ] = ACTIONS(2942),
    [anon_sym_EQ_EQ] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_GT_EQ] = ACTIONS(2942),
    [anon_sym_GT] = ACTIONS(2944),
    [anon_sym_LT_GT] = ACTIONS(2942),
    [anon_sym_is] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(535),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(2942),
  },
  [1671] = {
    [anon_sym_if] = ACTIONS(1925),
    [anon_sym_else] = ACTIONS(2647),
    [anon_sym_and] = ACTIONS(1929),
    [anon_sym_or] = ACTIONS(1931),
    [sym_comment] = ACTIONS(73),
  },
  [1672] = {
    [sym__expression] = STATE(1828),
    [sym__primary_expression] = STATE(538),
    [sym_not_operator] = STATE(1828),
    [sym_boolean_operator] = STATE(1828),
    [sym_binary_operator] = STATE(538),
    [sym_unary_operator] = STATE(538),
    [sym_comparison_operator] = STATE(1828),
    [sym_lambda] = STATE(1828),
    [sym_attribute] = STATE(538),
    [sym_subscript] = STATE(538),
    [sym_call] = STATE(538),
    [sym_list] = STATE(538),
    [sym_list_comprehension] = STATE(538),
    [sym_dictionary] = STATE(538),
    [sym_dictionary_comprehension] = STATE(538),
    [sym_set] = STATE(538),
    [sym_set_comprehension] = STATE(538),
    [sym_parenthesized_expression] = STATE(538),
    [sym_tuple] = STATE(538),
    [sym_generator_expression] = STATE(538),
    [sym_conditional_expression] = STATE(1828),
    [sym_concatenated_string] = STATE(538),
    [sym_string] = STATE(539),
    [sym_await] = STATE(1828),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_lambda] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(917),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(919),
    [sym_float] = ACTIONS(919),
    [sym_identifier] = ACTIONS(919),
    [sym_true] = ACTIONS(919),
    [sym_false] = ACTIONS(919),
    [sym_none] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(921),
    [sym_comment] = ACTIONS(73),
  },
  [1673] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(1933),
    [anon_sym_GT_GT] = ACTIONS(1935),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_else] = ACTIONS(2942),
    [anon_sym_in] = ACTIONS(2942),
    [anon_sym_AT] = ACTIONS(1939),
    [anon_sym_not] = ACTIONS(2942),
    [anon_sym_and] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(1943),
    [anon_sym_DASH] = ACTIONS(1943),
    [anon_sym_SLASH] = ACTIONS(1933),
    [anon_sym_PERCENT] = ACTIONS(1939),
    [anon_sym_SLASH_SLASH] = ACTIONS(1939),
    [anon_sym_STAR_STAR] = ACTIONS(1945),
    [anon_sym_PIPE] = ACTIONS(1947),
    [anon_sym_AMP] = ACTIONS(1949),
    [anon_sym_CARET] = ACTIONS(1951),
    [anon_sym_LT_LT] = ACTIONS(1935),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_LT_EQ] = ACTIONS(2942),
    [anon_sym_EQ_EQ] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_GT_EQ] = ACTIONS(2942),
    [anon_sym_GT] = ACTIONS(2944),
    [anon_sym_LT_GT] = ACTIONS(2942),
    [anon_sym_is] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(473),
    [sym_comment] = ACTIONS(73),
  },
  [1674] = {
    [sym__newline] = ACTIONS(3956),
    [anon_sym_DOT] = ACTIONS(3956),
    [anon_sym_LPAREN] = ACTIONS(3956),
    [anon_sym_COMMA] = ACTIONS(3956),
    [anon_sym_STAR] = ACTIONS(3958),
    [anon_sym_GT_GT] = ACTIONS(3958),
    [anon_sym_if] = ACTIONS(3956),
    [anon_sym_COLON] = ACTIONS(3956),
    [anon_sym_in] = ACTIONS(3956),
    [anon_sym_EQ] = ACTIONS(3958),
    [anon_sym_AT] = ACTIONS(3958),
    [anon_sym_not] = ACTIONS(3956),
    [anon_sym_and] = ACTIONS(3956),
    [anon_sym_or] = ACTIONS(3956),
    [anon_sym_PLUS] = ACTIONS(3958),
    [anon_sym_DASH] = ACTIONS(3958),
    [anon_sym_SLASH] = ACTIONS(3958),
    [anon_sym_PERCENT] = ACTIONS(3958),
    [anon_sym_SLASH_SLASH] = ACTIONS(3958),
    [anon_sym_STAR_STAR] = ACTIONS(3958),
    [anon_sym_PIPE] = ACTIONS(3958),
    [anon_sym_AMP] = ACTIONS(3958),
    [anon_sym_CARET] = ACTIONS(3958),
    [anon_sym_LT_LT] = ACTIONS(3958),
    [anon_sym_LT] = ACTIONS(3958),
    [anon_sym_LT_EQ] = ACTIONS(3956),
    [anon_sym_EQ_EQ] = ACTIONS(3956),
    [anon_sym_BANG_EQ] = ACTIONS(3956),
    [anon_sym_GT_EQ] = ACTIONS(3956),
    [anon_sym_GT] = ACTIONS(3958),
    [anon_sym_LT_GT] = ACTIONS(3956),
    [anon_sym_is] = ACTIONS(3956),
    [anon_sym_PLUS_EQ] = ACTIONS(3956),
    [anon_sym_DASH_EQ] = ACTIONS(3956),
    [anon_sym_STAR_EQ] = ACTIONS(3956),
    [anon_sym_SLASH_EQ] = ACTIONS(3956),
    [anon_sym_AT_EQ] = ACTIONS(3956),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3956),
    [anon_sym_PERCENT_EQ] = ACTIONS(3956),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3956),
    [anon_sym_GT_GT_EQ] = ACTIONS(3956),
    [anon_sym_LT_LT_EQ] = ACTIONS(3956),
    [anon_sym_AMP_EQ] = ACTIONS(3956),
    [anon_sym_CARET_EQ] = ACTIONS(3956),
    [anon_sym_PIPE_EQ] = ACTIONS(3956),
    [anon_sym_LBRACK] = ACTIONS(3956),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3956),
  },
  [1675] = {
    [sym_list_splat] = STATE(1413),
    [sym_dictionary_splat] = STATE(1413),
    [sym__expression] = STATE(1414),
    [sym__primary_expression] = STATE(237),
    [sym_not_operator] = STATE(1414),
    [sym_boolean_operator] = STATE(1414),
    [sym_binary_operator] = STATE(237),
    [sym_unary_operator] = STATE(237),
    [sym_comparison_operator] = STATE(1414),
    [sym_lambda] = STATE(1414),
    [sym_attribute] = STATE(237),
    [sym_subscript] = STATE(237),
    [sym_call] = STATE(237),
    [sym_keyword_argument] = STATE(1413),
    [sym_list] = STATE(237),
    [sym_list_comprehension] = STATE(237),
    [sym_dictionary] = STATE(237),
    [sym_dictionary_comprehension] = STATE(237),
    [sym_set] = STATE(237),
    [sym_set_comprehension] = STATE(237),
    [sym_parenthesized_expression] = STATE(237),
    [sym_tuple] = STATE(237),
    [sym_generator_expression] = STATE(237),
    [sym_conditional_expression] = STATE(1414),
    [sym_concatenated_string] = STATE(237),
    [sym_string] = STATE(238),
    [sym_await] = STATE(1414),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_STAR] = ACTIONS(931),
    [anon_sym_print] = ACTIONS(933),
    [anon_sym_exec] = ACTIONS(933),
    [anon_sym_not] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_lambda] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(419),
    [sym_float] = ACTIONS(419),
    [sym_identifier] = ACTIONS(935),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_none] = ACTIONS(419),
    [anon_sym_await] = ACTIONS(421),
    [sym_comment] = ACTIONS(73),
  },
  [1676] = {
    [anon_sym_COMMA] = ACTIONS(3960),
    [anon_sym_if] = ACTIONS(1686),
    [anon_sym_and] = ACTIONS(1688),
    [anon_sym_or] = ACTIONS(1690),
    [anon_sym_RBRACK] = ACTIONS(3960),
    [sym_comment] = ACTIONS(73),
  },
  [1677] = {
    [anon_sym_COMMA] = ACTIONS(2647),
    [anon_sym_if] = ACTIONS(2004),
    [anon_sym_COLON] = ACTIONS(2647),
    [anon_sym_and] = ACTIONS(2008),
    [anon_sym_or] = ACTIONS(2010),
    [anon_sym_RBRACK] = ACTIONS(2647),
    [sym_comment] = ACTIONS(73),
  },
  [1678] = {
    [sym__expression] = STATE(1829),
    [sym__primary_expression] = STATE(567),
    [sym_not_operator] = STATE(1829),
    [sym_boolean_operator] = STATE(1829),
    [sym_binary_operator] = STATE(567),
    [sym_unary_operator] = STATE(567),
    [sym_comparison_operator] = STATE(1829),
    [sym_lambda] = STATE(1829),
    [sym_attribute] = STATE(567),
    [sym_subscript] = STATE(567),
    [sym_call] = STATE(567),
    [sym_list] = STATE(567),
    [sym_list_comprehension] = STATE(567),
    [sym_dictionary] = STATE(567),
    [sym_dictionary_comprehension] = STATE(567),
    [sym_set] = STATE(567),
    [sym_set_comprehension] = STATE(567),
    [sym_parenthesized_expression] = STATE(567),
    [sym_tuple] = STATE(567),
    [sym_generator_expression] = STATE(567),
    [sym_conditional_expression] = STATE(1829),
    [sym_concatenated_string] = STATE(567),
    [sym_string] = STATE(569),
    [sym_await] = STATE(1829),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(975),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(977),
    [anon_sym_lambda] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(981),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(983),
    [sym_float] = ACTIONS(983),
    [sym_identifier] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_none] = ACTIONS(983),
    [anon_sym_await] = ACTIONS(985),
    [sym_comment] = ACTIONS(73),
  },
  [1679] = {
    [sym__expression] = STATE(1830),
    [sym__primary_expression] = STATE(452),
    [sym_not_operator] = STATE(1830),
    [sym_boolean_operator] = STATE(1830),
    [sym_binary_operator] = STATE(452),
    [sym_unary_operator] = STATE(452),
    [sym_comparison_operator] = STATE(1830),
    [sym_lambda] = STATE(1830),
    [sym_attribute] = STATE(452),
    [sym_subscript] = STATE(452),
    [sym_call] = STATE(452),
    [sym_list] = STATE(452),
    [sym_list_comprehension] = STATE(452),
    [sym_dictionary] = STATE(452),
    [sym_dictionary_comprehension] = STATE(452),
    [sym_set] = STATE(452),
    [sym_set_comprehension] = STATE(452),
    [sym_parenthesized_expression] = STATE(452),
    [sym_tuple] = STATE(452),
    [sym_generator_expression] = STATE(452),
    [sym_conditional_expression] = STATE(1830),
    [sym_concatenated_string] = STATE(452),
    [sym_string] = STATE(453),
    [sym_await] = STATE(1830),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_COMMA] = ACTIONS(3960),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(765),
    [anon_sym_PLUS] = ACTIONS(767),
    [anon_sym_DASH] = ACTIONS(767),
    [anon_sym_TILDE] = ACTIONS(767),
    [anon_sym_lambda] = ACTIONS(769),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(3960),
    [sym_ellipsis] = ACTIONS(771),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(773),
    [sym_float] = ACTIONS(773),
    [sym_identifier] = ACTIONS(773),
    [sym_true] = ACTIONS(773),
    [sym_false] = ACTIONS(773),
    [sym_none] = ACTIONS(773),
    [anon_sym_await] = ACTIONS(775),
    [sym_comment] = ACTIONS(73),
  },
  [1680] = {
    [sym__newline] = ACTIONS(3962),
    [anon_sym_DOT] = ACTIONS(3962),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_COMMA] = ACTIONS(3962),
    [anon_sym_STAR] = ACTIONS(3964),
    [anon_sym_GT_GT] = ACTIONS(3964),
    [anon_sym_if] = ACTIONS(3962),
    [anon_sym_COLON] = ACTIONS(3962),
    [anon_sym_in] = ACTIONS(3962),
    [anon_sym_EQ] = ACTIONS(3964),
    [anon_sym_AT] = ACTIONS(3964),
    [anon_sym_not] = ACTIONS(3962),
    [anon_sym_and] = ACTIONS(3962),
    [anon_sym_or] = ACTIONS(3962),
    [anon_sym_PLUS] = ACTIONS(3964),
    [anon_sym_DASH] = ACTIONS(3964),
    [anon_sym_SLASH] = ACTIONS(3964),
    [anon_sym_PERCENT] = ACTIONS(3964),
    [anon_sym_SLASH_SLASH] = ACTIONS(3964),
    [anon_sym_STAR_STAR] = ACTIONS(3964),
    [anon_sym_PIPE] = ACTIONS(3964),
    [anon_sym_AMP] = ACTIONS(3964),
    [anon_sym_CARET] = ACTIONS(3964),
    [anon_sym_LT_LT] = ACTIONS(3964),
    [anon_sym_LT] = ACTIONS(3964),
    [anon_sym_LT_EQ] = ACTIONS(3962),
    [anon_sym_EQ_EQ] = ACTIONS(3962),
    [anon_sym_BANG_EQ] = ACTIONS(3962),
    [anon_sym_GT_EQ] = ACTIONS(3962),
    [anon_sym_GT] = ACTIONS(3964),
    [anon_sym_LT_GT] = ACTIONS(3962),
    [anon_sym_is] = ACTIONS(3962),
    [anon_sym_PLUS_EQ] = ACTIONS(3962),
    [anon_sym_DASH_EQ] = ACTIONS(3962),
    [anon_sym_STAR_EQ] = ACTIONS(3962),
    [anon_sym_SLASH_EQ] = ACTIONS(3962),
    [anon_sym_AT_EQ] = ACTIONS(3962),
    [anon_sym_SLASH_SLASH_EQ] = ACTIONS(3962),
    [anon_sym_PERCENT_EQ] = ACTIONS(3962),
    [anon_sym_STAR_STAR_EQ] = ACTIONS(3962),
    [anon_sym_GT_GT_EQ] = ACTIONS(3962),
    [anon_sym_LT_LT_EQ] = ACTIONS(3962),
    [anon_sym_AMP_EQ] = ACTIONS(3962),
    [anon_sym_CARET_EQ] = ACTIONS(3962),
    [anon_sym_PIPE_EQ] = ACTIONS(3962),
    [anon_sym_LBRACK] = ACTIONS(3962),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3962),
  },
  [1681] = {
    [sym__expression] = STATE(1422),
    [sym__primary_expression] = STATE(567),
    [sym_not_operator] = STATE(1422),
    [sym_boolean_operator] = STATE(1422),
    [sym_binary_operator] = STATE(567),
    [sym_unary_operator] = STATE(567),
    [sym_comparison_operator] = STATE(1422),
    [sym_lambda] = STATE(1422),
    [sym_attribute] = STATE(567),
    [sym_subscript] = STATE(567),
    [sym_slice] = STATE(1423),
    [sym_call] = STATE(567),
    [sym_list] = STATE(567),
    [sym_list_comprehension] = STATE(567),
    [sym_dictionary] = STATE(567),
    [sym_dictionary_comprehension] = STATE(567),
    [sym_set] = STATE(567),
    [sym_set_comprehension] = STATE(567),
    [sym_parenthesized_expression] = STATE(567),
    [sym_tuple] = STATE(567),
    [sym_generator_expression] = STATE(567),
    [sym_conditional_expression] = STATE(1422),
    [sym_concatenated_string] = STATE(567),
    [sym_string] = STATE(569),
    [sym_await] = STATE(1422),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(973),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(975),
    [anon_sym_PLUS] = ACTIONS(977),
    [anon_sym_DASH] = ACTIONS(977),
    [anon_sym_TILDE] = ACTIONS(977),
    [anon_sym_lambda] = ACTIONS(979),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(981),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(983),
    [sym_float] = ACTIONS(983),
    [sym_identifier] = ACTIONS(983),
    [sym_true] = ACTIONS(983),
    [sym_false] = ACTIONS(983),
    [sym_none] = ACTIONS(983),
    [anon_sym_await] = ACTIONS(985),
    [sym_comment] = ACTIONS(73),
  },
  [1682] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(2942),
    [anon_sym_STAR] = ACTIONS(2014),
    [anon_sym_GT_GT] = ACTIONS(2016),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_COLON] = ACTIONS(2942),
    [anon_sym_in] = ACTIONS(2942),
    [anon_sym_AT] = ACTIONS(2020),
    [anon_sym_not] = ACTIONS(2942),
    [anon_sym_and] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(2024),
    [anon_sym_DASH] = ACTIONS(2024),
    [anon_sym_SLASH] = ACTIONS(2014),
    [anon_sym_PERCENT] = ACTIONS(2020),
    [anon_sym_SLASH_SLASH] = ACTIONS(2020),
    [anon_sym_STAR_STAR] = ACTIONS(2026),
    [anon_sym_PIPE] = ACTIONS(2028),
    [anon_sym_AMP] = ACTIONS(2030),
    [anon_sym_CARET] = ACTIONS(2032),
    [anon_sym_LT_LT] = ACTIONS(2016),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_LT_EQ] = ACTIONS(2942),
    [anon_sym_EQ_EQ] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_GT_EQ] = ACTIONS(2942),
    [anon_sym_GT] = ACTIONS(2944),
    [anon_sym_LT_GT] = ACTIONS(2942),
    [anon_sym_is] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(473),
    [anon_sym_RBRACK] = ACTIONS(2942),
    [sym_comment] = ACTIONS(73),
  },
  [1683] = {
    [anon_sym_if] = ACTIONS(1111),
    [anon_sym_and] = ACTIONS(1113),
    [anon_sym_or] = ACTIONS(1115),
    [anon_sym_RBRACE] = ACTIONS(3565),
    [sym_type_conversion] = ACTIONS(3565),
    [sym_comment] = ACTIONS(73),
  },
  [1684] = {
    [aux_sym_dotted_name_repeat1] = STATE(1684),
    [anon_sym_DOT] = ACTIONS(2113),
    [anon_sym_RPAREN] = ACTIONS(2097),
    [anon_sym_COMMA] = ACTIONS(2097),
    [anon_sym_as] = ACTIONS(2097),
    [sym_comment] = ACTIONS(73),
  },
  [1685] = {
    [anon_sym_RPAREN] = ACTIONS(2102),
    [anon_sym_COMMA] = ACTIONS(2102),
    [sym_comment] = ACTIONS(73),
  },
  [1686] = {
    [anon_sym_RPAREN] = ACTIONS(2102),
    [anon_sym_COMMA] = ACTIONS(2102),
    [anon_sym_as] = ACTIONS(3018),
    [sym_comment] = ACTIONS(73),
  },
  [1687] = {
    [sym_aliased_import] = STATE(1685),
    [sym_dotted_name] = STATE(1686),
    [anon_sym_RPAREN] = ACTIONS(2104),
    [sym_identifier] = ACTIONS(2116),
    [sym_comment] = ACTIONS(73),
  },
  [1688] = {
    [aux_sym__import_list_repeat1] = STATE(1688),
    [anon_sym_RPAREN] = ACTIONS(2102),
    [anon_sym_COMMA] = ACTIONS(3966),
    [sym_comment] = ACTIONS(73),
  },
  [1689] = {
    [anon_sym_RPAREN] = ACTIONS(2109),
    [anon_sym_COMMA] = ACTIONS(2109),
    [sym_comment] = ACTIONS(73),
  },
  [1690] = {
    [anon_sym_RPAREN] = ACTIONS(3565),
    [anon_sym_COMMA] = ACTIONS(3565),
    [anon_sym_if] = ACTIONS(1198),
    [anon_sym_and] = ACTIONS(1200),
    [anon_sym_or] = ACTIONS(1202),
    [sym_comment] = ACTIONS(73),
  },
  [1691] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1833),
    [anon_sym_RPAREN] = ACTIONS(3969),
    [anon_sym_COMMA] = ACTIONS(3971),
    [anon_sym_if] = ACTIONS(3969),
    [anon_sym_async] = ACTIONS(3969),
    [anon_sym_for] = ACTIONS(3969),
    [sym_comment] = ACTIONS(73),
  },
  [1692] = {
    [sym__expression_within_for_in_clause] = STATE(1834),
    [sym__expression] = STATE(1459),
    [sym__primary_expression] = STATE(67),
    [sym_not_operator] = STATE(1459),
    [sym_boolean_operator] = STATE(1459),
    [sym_binary_operator] = STATE(67),
    [sym_unary_operator] = STATE(67),
    [sym_comparison_operator] = STATE(1459),
    [sym_lambda] = STATE(1459),
    [sym_lambda_within_for_in_clause] = STATE(1834),
    [sym_attribute] = STATE(67),
    [sym_subscript] = STATE(67),
    [sym_call] = STATE(67),
    [sym_list] = STATE(67),
    [sym_list_comprehension] = STATE(67),
    [sym_dictionary] = STATE(67),
    [sym_dictionary_comprehension] = STATE(67),
    [sym_set] = STATE(67),
    [sym_set_comprehension] = STATE(67),
    [sym_parenthesized_expression] = STATE(67),
    [sym_tuple] = STATE(67),
    [sym_generator_expression] = STATE(67),
    [sym_conditional_expression] = STATE(1459),
    [sym_concatenated_string] = STATE(67),
    [sym_string] = STATE(69),
    [sym_await] = STATE(1459),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(3051),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [1693] = {
    [anon_sym_COLON] = ACTIONS(3973),
    [sym_comment] = ACTIONS(73),
  },
  [1694] = {
    [sym__expression_within_for_in_clause] = STATE(1836),
    [sym__expression] = STATE(1459),
    [sym__primary_expression] = STATE(67),
    [sym_not_operator] = STATE(1459),
    [sym_boolean_operator] = STATE(1459),
    [sym_binary_operator] = STATE(67),
    [sym_unary_operator] = STATE(67),
    [sym_comparison_operator] = STATE(1459),
    [sym_lambda] = STATE(1459),
    [sym_lambda_within_for_in_clause] = STATE(1836),
    [sym_attribute] = STATE(67),
    [sym_subscript] = STATE(67),
    [sym_call] = STATE(67),
    [sym_list] = STATE(67),
    [sym_list_comprehension] = STATE(67),
    [sym_dictionary] = STATE(67),
    [sym_dictionary_comprehension] = STATE(67),
    [sym_set] = STATE(67),
    [sym_set_comprehension] = STATE(67),
    [sym_parenthesized_expression] = STATE(67),
    [sym_tuple] = STATE(67),
    [sym_generator_expression] = STATE(67),
    [sym_conditional_expression] = STATE(1459),
    [sym_concatenated_string] = STATE(67),
    [sym_string] = STATE(69),
    [sym_await] = STATE(1459),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(3969),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(3975),
    [anon_sym_async] = ACTIONS(3975),
    [anon_sym_for] = ACTIONS(3975),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(3051),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [1695] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1837),
    [anon_sym_RPAREN] = ACTIONS(3969),
    [anon_sym_COMMA] = ACTIONS(3971),
    [anon_sym_if] = ACTIONS(3969),
    [anon_sym_async] = ACTIONS(3969),
    [anon_sym_for] = ACTIONS(3969),
    [sym_comment] = ACTIONS(73),
  },
  [1696] = {
    [anon_sym_RPAREN] = ACTIONS(1660),
    [anon_sym_if] = ACTIONS(3977),
    [anon_sym_async] = ACTIONS(1660),
    [anon_sym_for] = ACTIONS(1660),
    [anon_sym_and] = ACTIONS(3057),
    [anon_sym_or] = ACTIONS(3059),
    [sym_comment] = ACTIONS(73),
  },
  [1697] = {
    [sym__expression] = STATE(1838),
    [sym__primary_expression] = STATE(1125),
    [sym_not_operator] = STATE(1838),
    [sym_boolean_operator] = STATE(1838),
    [sym_binary_operator] = STATE(1125),
    [sym_unary_operator] = STATE(1125),
    [sym_comparison_operator] = STATE(1838),
    [sym_lambda] = STATE(1838),
    [sym_attribute] = STATE(1125),
    [sym_subscript] = STATE(1125),
    [sym_call] = STATE(1125),
    [sym_list] = STATE(1125),
    [sym_list_comprehension] = STATE(1125),
    [sym_dictionary] = STATE(1125),
    [sym_dictionary_comprehension] = STATE(1125),
    [sym_set] = STATE(1125),
    [sym_set_comprehension] = STATE(1125),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_tuple] = STATE(1125),
    [sym_generator_expression] = STATE(1125),
    [sym_conditional_expression] = STATE(1838),
    [sym_concatenated_string] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_await] = STATE(1838),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2198),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2200),
    [anon_sym_TILDE] = ACTIONS(2200),
    [anon_sym_lambda] = ACTIONS(2202),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2204),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2206),
    [sym_float] = ACTIONS(2206),
    [sym_identifier] = ACTIONS(2206),
    [sym_true] = ACTIONS(2206),
    [sym_false] = ACTIONS(2206),
    [sym_none] = ACTIONS(2206),
    [anon_sym_await] = ACTIONS(2208),
    [sym_comment] = ACTIONS(73),
  },
  [1698] = {
    [anon_sym_if] = ACTIONS(1925),
    [anon_sym_else] = ACTIONS(3979),
    [anon_sym_and] = ACTIONS(1929),
    [anon_sym_or] = ACTIONS(1931),
    [sym_comment] = ACTIONS(73),
  },
  [1699] = {
    [anon_sym_RPAREN] = ACTIONS(1957),
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_async] = ACTIONS(1957),
    [anon_sym_for] = ACTIONS(1957),
    [anon_sym_and] = ACTIONS(3057),
    [anon_sym_or] = ACTIONS(1957),
    [sym_comment] = ACTIONS(73),
  },
  [1700] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1984),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1986),
    [anon_sym_PERCENT] = ACTIONS(1984),
    [anon_sym_SLASH_SLASH] = ACTIONS(1984),
    [anon_sym_STAR_STAR] = ACTIONS(3073),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1701] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(3061),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(3067),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_SLASH] = ACTIONS(3061),
    [anon_sym_PERCENT] = ACTIONS(3067),
    [anon_sym_SLASH_SLASH] = ACTIONS(3067),
    [anon_sym_STAR_STAR] = ACTIONS(3073),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1702] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(1988),
    [anon_sym_STAR] = ACTIONS(3061),
    [anon_sym_GT_GT] = ACTIONS(3063),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_async] = ACTIONS(1988),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(1988),
    [anon_sym_AT] = ACTIONS(3067),
    [anon_sym_not] = ACTIONS(1988),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_SLASH] = ACTIONS(3061),
    [anon_sym_PERCENT] = ACTIONS(3067),
    [anon_sym_SLASH_SLASH] = ACTIONS(3067),
    [anon_sym_STAR_STAR] = ACTIONS(3073),
    [anon_sym_PIPE] = ACTIONS(3075),
    [anon_sym_AMP] = ACTIONS(3077),
    [anon_sym_CARET] = ACTIONS(3079),
    [anon_sym_LT_LT] = ACTIONS(3063),
    [anon_sym_LT] = ACTIONS(1990),
    [anon_sym_LT_EQ] = ACTIONS(1988),
    [anon_sym_EQ_EQ] = ACTIONS(1988),
    [anon_sym_BANG_EQ] = ACTIONS(1988),
    [anon_sym_GT_EQ] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1990),
    [anon_sym_LT_GT] = ACTIONS(1988),
    [anon_sym_is] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(473),
    [sym_comment] = ACTIONS(73),
  },
  [1703] = {
    [sym__primary_expression] = STATE(1840),
    [sym_binary_operator] = STATE(1840),
    [sym_unary_operator] = STATE(1840),
    [sym_attribute] = STATE(1840),
    [sym_subscript] = STATE(1840),
    [sym_call] = STATE(1840),
    [sym_list] = STATE(1840),
    [sym_list_comprehension] = STATE(1840),
    [sym_dictionary] = STATE(1840),
    [sym_dictionary_comprehension] = STATE(1840),
    [sym_set] = STATE(1840),
    [sym_set_comprehension] = STATE(1840),
    [sym_parenthesized_expression] = STATE(1840),
    [sym_tuple] = STATE(1840),
    [sym_generator_expression] = STATE(1840),
    [sym_concatenated_string] = STATE(1840),
    [sym_string] = STATE(1126),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2200),
    [anon_sym_TILDE] = ACTIONS(2200),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3981),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3983),
    [sym_float] = ACTIONS(3983),
    [sym_identifier] = ACTIONS(3983),
    [sym_true] = ACTIONS(3983),
    [sym_false] = ACTIONS(3983),
    [sym_none] = ACTIONS(3983),
    [sym_comment] = ACTIONS(73),
  },
  [1704] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(3061),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(3067),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(3061),
    [anon_sym_PERCENT] = ACTIONS(3067),
    [anon_sym_SLASH_SLASH] = ACTIONS(3067),
    [anon_sym_STAR_STAR] = ACTIONS(3073),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1705] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(3061),
    [anon_sym_GT_GT] = ACTIONS(3063),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(3067),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_SLASH] = ACTIONS(3061),
    [anon_sym_PERCENT] = ACTIONS(3067),
    [anon_sym_SLASH_SLASH] = ACTIONS(3067),
    [anon_sym_STAR_STAR] = ACTIONS(3073),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(3077),
    [anon_sym_CARET] = ACTIONS(3079),
    [anon_sym_LT_LT] = ACTIONS(3063),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1706] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(3061),
    [anon_sym_GT_GT] = ACTIONS(3063),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(3067),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_SLASH] = ACTIONS(3061),
    [anon_sym_PERCENT] = ACTIONS(3067),
    [anon_sym_SLASH_SLASH] = ACTIONS(3067),
    [anon_sym_STAR_STAR] = ACTIONS(3073),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(3079),
    [anon_sym_LT_LT] = ACTIONS(3063),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1707] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(3061),
    [anon_sym_GT_GT] = ACTIONS(3063),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(3067),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_SLASH] = ACTIONS(3061),
    [anon_sym_PERCENT] = ACTIONS(3067),
    [anon_sym_SLASH_SLASH] = ACTIONS(3067),
    [anon_sym_STAR_STAR] = ACTIONS(3073),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(3063),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1708] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1708),
    [anon_sym_RPAREN] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_async] = ACTIONS(1988),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(3985),
    [anon_sym_not] = ACTIONS(3988),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(3991),
    [anon_sym_LT_EQ] = ACTIONS(3985),
    [anon_sym_EQ_EQ] = ACTIONS(3985),
    [anon_sym_BANG_EQ] = ACTIONS(3985),
    [anon_sym_GT_EQ] = ACTIONS(3985),
    [anon_sym_GT] = ACTIONS(3991),
    [anon_sym_LT_GT] = ACTIONS(3985),
    [anon_sym_is] = ACTIONS(3994),
    [sym_comment] = ACTIONS(73),
  },
  [1709] = {
    [sym_string] = STATE(1709),
    [aux_sym_concatenated_string_repeat1] = STATE(1709),
    [sym__string_start] = ACTIONS(2241),
    [anon_sym_DOT] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(2050),
    [anon_sym_RPAREN] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2050),
    [anon_sym_if] = ACTIONS(2050),
    [anon_sym_async] = ACTIONS(2050),
    [anon_sym_for] = ACTIONS(2050),
    [anon_sym_in] = ACTIONS(2050),
    [anon_sym_AT] = ACTIONS(2050),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_and] = ACTIONS(2050),
    [anon_sym_or] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_SLASH] = ACTIONS(2055),
    [anon_sym_PERCENT] = ACTIONS(2050),
    [anon_sym_SLASH_SLASH] = ACTIONS(2050),
    [anon_sym_STAR_STAR] = ACTIONS(2050),
    [anon_sym_PIPE] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2050),
    [anon_sym_CARET] = ACTIONS(2050),
    [anon_sym_LT_LT] = ACTIONS(2050),
    [anon_sym_LT] = ACTIONS(2055),
    [anon_sym_LT_EQ] = ACTIONS(2050),
    [anon_sym_EQ_EQ] = ACTIONS(2050),
    [anon_sym_BANG_EQ] = ACTIONS(2050),
    [anon_sym_GT_EQ] = ACTIONS(2050),
    [anon_sym_GT] = ACTIONS(2055),
    [anon_sym_LT_GT] = ACTIONS(2050),
    [anon_sym_is] = ACTIONS(2050),
    [anon_sym_LBRACK] = ACTIONS(2050),
    [sym_comment] = ACTIONS(73),
  },
  [1710] = {
    [anon_sym_DOT] = ACTIONS(3956),
    [anon_sym_LPAREN] = ACTIONS(3956),
    [anon_sym_RPAREN] = ACTIONS(3956),
    [anon_sym_COMMA] = ACTIONS(3956),
    [anon_sym_as] = ACTIONS(3958),
    [anon_sym_STAR] = ACTIONS(3958),
    [anon_sym_GT_GT] = ACTIONS(3956),
    [anon_sym_if] = ACTIONS(3956),
    [anon_sym_COLON] = ACTIONS(3956),
    [anon_sym_else] = ACTIONS(3956),
    [anon_sym_async] = ACTIONS(3956),
    [anon_sym_for] = ACTIONS(3956),
    [anon_sym_in] = ACTIONS(3956),
    [anon_sym_EQ] = ACTIONS(3958),
    [anon_sym_AT] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(3956),
    [anon_sym_and] = ACTIONS(3956),
    [anon_sym_or] = ACTIONS(3956),
    [anon_sym_PLUS] = ACTIONS(3956),
    [anon_sym_DASH] = ACTIONS(3956),
    [anon_sym_SLASH] = ACTIONS(3958),
    [anon_sym_PERCENT] = ACTIONS(3956),
    [anon_sym_SLASH_SLASH] = ACTIONS(3956),
    [anon_sym_STAR_STAR] = ACTIONS(3956),
    [anon_sym_PIPE] = ACTIONS(3956),
    [anon_sym_AMP] = ACTIONS(3956),
    [anon_sym_CARET] = ACTIONS(3956),
    [anon_sym_LT_LT] = ACTIONS(3956),
    [anon_sym_LT] = ACTIONS(3958),
    [anon_sym_LT_EQ] = ACTIONS(3956),
    [anon_sym_EQ_EQ] = ACTIONS(3956),
    [anon_sym_BANG_EQ] = ACTIONS(3956),
    [anon_sym_GT_EQ] = ACTIONS(3956),
    [anon_sym_GT] = ACTIONS(3958),
    [anon_sym_LT_GT] = ACTIONS(3956),
    [anon_sym_is] = ACTIONS(3956),
    [anon_sym_LBRACK] = ACTIONS(3956),
    [anon_sym_RBRACK] = ACTIONS(3956),
    [anon_sym_RBRACE] = ACTIONS(3956),
    [sym_type_conversion] = ACTIONS(3956),
    [sym_comment] = ACTIONS(73),
  },
  [1711] = {
    [anon_sym_DOT] = ACTIONS(3962),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_RPAREN] = ACTIONS(3962),
    [anon_sym_COMMA] = ACTIONS(3962),
    [anon_sym_as] = ACTIONS(3964),
    [anon_sym_STAR] = ACTIONS(3964),
    [anon_sym_GT_GT] = ACTIONS(3962),
    [anon_sym_if] = ACTIONS(3962),
    [anon_sym_COLON] = ACTIONS(3962),
    [anon_sym_else] = ACTIONS(3962),
    [anon_sym_async] = ACTIONS(3962),
    [anon_sym_for] = ACTIONS(3962),
    [anon_sym_in] = ACTIONS(3962),
    [anon_sym_EQ] = ACTIONS(3964),
    [anon_sym_AT] = ACTIONS(3962),
    [anon_sym_not] = ACTIONS(3962),
    [anon_sym_and] = ACTIONS(3962),
    [anon_sym_or] = ACTIONS(3962),
    [anon_sym_PLUS] = ACTIONS(3962),
    [anon_sym_DASH] = ACTIONS(3962),
    [anon_sym_SLASH] = ACTIONS(3964),
    [anon_sym_PERCENT] = ACTIONS(3962),
    [anon_sym_SLASH_SLASH] = ACTIONS(3962),
    [anon_sym_STAR_STAR] = ACTIONS(3962),
    [anon_sym_PIPE] = ACTIONS(3962),
    [anon_sym_AMP] = ACTIONS(3962),
    [anon_sym_CARET] = ACTIONS(3962),
    [anon_sym_LT_LT] = ACTIONS(3962),
    [anon_sym_LT] = ACTIONS(3964),
    [anon_sym_LT_EQ] = ACTIONS(3962),
    [anon_sym_EQ_EQ] = ACTIONS(3962),
    [anon_sym_BANG_EQ] = ACTIONS(3962),
    [anon_sym_GT_EQ] = ACTIONS(3962),
    [anon_sym_GT] = ACTIONS(3964),
    [anon_sym_LT_GT] = ACTIONS(3962),
    [anon_sym_is] = ACTIONS(3962),
    [anon_sym_LBRACK] = ACTIONS(3962),
    [anon_sym_RBRACK] = ACTIONS(3962),
    [anon_sym_RBRACE] = ACTIONS(3962),
    [sym_type_conversion] = ACTIONS(3962),
    [sym_comment] = ACTIONS(73),
  },
  [1712] = {
    [sym__newline] = ACTIONS(3956),
    [anon_sym_DOT] = ACTIONS(3956),
    [anon_sym_from] = ACTIONS(3956),
    [anon_sym_LPAREN] = ACTIONS(3956),
    [anon_sym_COMMA] = ACTIONS(3956),
    [anon_sym_STAR] = ACTIONS(3958),
    [anon_sym_GT_GT] = ACTIONS(3956),
    [anon_sym_if] = ACTIONS(3956),
    [anon_sym_in] = ACTIONS(3956),
    [anon_sym_EQ] = ACTIONS(3958),
    [anon_sym_AT] = ACTIONS(3956),
    [anon_sym_not] = ACTIONS(3956),
    [anon_sym_and] = ACTIONS(3956),
    [anon_sym_or] = ACTIONS(3956),
    [anon_sym_PLUS] = ACTIONS(3956),
    [anon_sym_DASH] = ACTIONS(3956),
    [anon_sym_SLASH] = ACTIONS(3958),
    [anon_sym_PERCENT] = ACTIONS(3956),
    [anon_sym_SLASH_SLASH] = ACTIONS(3956),
    [anon_sym_STAR_STAR] = ACTIONS(3956),
    [anon_sym_PIPE] = ACTIONS(3956),
    [anon_sym_AMP] = ACTIONS(3956),
    [anon_sym_CARET] = ACTIONS(3956),
    [anon_sym_LT_LT] = ACTIONS(3956),
    [anon_sym_LT] = ACTIONS(3958),
    [anon_sym_LT_EQ] = ACTIONS(3956),
    [anon_sym_EQ_EQ] = ACTIONS(3956),
    [anon_sym_BANG_EQ] = ACTIONS(3956),
    [anon_sym_GT_EQ] = ACTIONS(3956),
    [anon_sym_GT] = ACTIONS(3958),
    [anon_sym_LT_GT] = ACTIONS(3956),
    [anon_sym_is] = ACTIONS(3956),
    [anon_sym_LBRACK] = ACTIONS(3956),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3956),
  },
  [1713] = {
    [sym__newline] = ACTIONS(3962),
    [anon_sym_DOT] = ACTIONS(3962),
    [anon_sym_from] = ACTIONS(3962),
    [anon_sym_LPAREN] = ACTIONS(3962),
    [anon_sym_COMMA] = ACTIONS(3962),
    [anon_sym_STAR] = ACTIONS(3964),
    [anon_sym_GT_GT] = ACTIONS(3962),
    [anon_sym_if] = ACTIONS(3962),
    [anon_sym_in] = ACTIONS(3962),
    [anon_sym_EQ] = ACTIONS(3964),
    [anon_sym_AT] = ACTIONS(3962),
    [anon_sym_not] = ACTIONS(3962),
    [anon_sym_and] = ACTIONS(3962),
    [anon_sym_or] = ACTIONS(3962),
    [anon_sym_PLUS] = ACTIONS(3962),
    [anon_sym_DASH] = ACTIONS(3962),
    [anon_sym_SLASH] = ACTIONS(3964),
    [anon_sym_PERCENT] = ACTIONS(3962),
    [anon_sym_SLASH_SLASH] = ACTIONS(3962),
    [anon_sym_STAR_STAR] = ACTIONS(3962),
    [anon_sym_PIPE] = ACTIONS(3962),
    [anon_sym_AMP] = ACTIONS(3962),
    [anon_sym_CARET] = ACTIONS(3962),
    [anon_sym_LT_LT] = ACTIONS(3962),
    [anon_sym_LT] = ACTIONS(3964),
    [anon_sym_LT_EQ] = ACTIONS(3962),
    [anon_sym_EQ_EQ] = ACTIONS(3962),
    [anon_sym_BANG_EQ] = ACTIONS(3962),
    [anon_sym_GT_EQ] = ACTIONS(3962),
    [anon_sym_GT] = ACTIONS(3964),
    [anon_sym_LT_GT] = ACTIONS(3962),
    [anon_sym_is] = ACTIONS(3962),
    [anon_sym_LBRACK] = ACTIONS(3962),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3962),
  },
  [1714] = {
    [sym__newline] = ACTIONS(3565),
    [anon_sym_if] = ACTIONS(1378),
    [anon_sym_and] = ACTIONS(1380),
    [anon_sym_or] = ACTIONS(1382),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3565),
  },
  [1715] = {
    [sym__simple_statements] = STATE(1841),
    [sym_import_statement] = STATE(34),
    [sym_future_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym__suite] = STATE(1841),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(1448),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1716] = {
    [sym__string_start] = ACTIONS(3997),
    [ts_builtin_sym_end] = ACTIONS(3997),
    [anon_sym_import] = ACTIONS(3999),
    [anon_sym_from] = ACTIONS(3999),
    [anon_sym_LPAREN] = ACTIONS(3997),
    [anon_sym_print] = ACTIONS(3999),
    [anon_sym_assert] = ACTIONS(3999),
    [anon_sym_return] = ACTIONS(3999),
    [anon_sym_del] = ACTIONS(3999),
    [anon_sym_raise] = ACTIONS(3999),
    [anon_sym_pass] = ACTIONS(3999),
    [anon_sym_break] = ACTIONS(3999),
    [anon_sym_continue] = ACTIONS(3999),
    [anon_sym_if] = ACTIONS(3999),
    [anon_sym_async] = ACTIONS(3999),
    [anon_sym_for] = ACTIONS(3999),
    [anon_sym_while] = ACTIONS(3999),
    [anon_sym_try] = ACTIONS(3999),
    [anon_sym_finally] = ACTIONS(3999),
    [anon_sym_with] = ACTIONS(3999),
    [anon_sym_def] = ACTIONS(3999),
    [anon_sym_global] = ACTIONS(3999),
    [anon_sym_nonlocal] = ACTIONS(3999),
    [anon_sym_exec] = ACTIONS(3999),
    [anon_sym_class] = ACTIONS(3999),
    [anon_sym_AT] = ACTIONS(3997),
    [anon_sym_not] = ACTIONS(3999),
    [anon_sym_PLUS] = ACTIONS(3997),
    [anon_sym_DASH] = ACTIONS(3997),
    [anon_sym_TILDE] = ACTIONS(3997),
    [anon_sym_lambda] = ACTIONS(3999),
    [anon_sym_yield] = ACTIONS(3999),
    [anon_sym_LBRACK] = ACTIONS(3997),
    [sym_ellipsis] = ACTIONS(3997),
    [anon_sym_LBRACE] = ACTIONS(3997),
    [sym_integer] = ACTIONS(3999),
    [sym_float] = ACTIONS(3999),
    [sym_identifier] = ACTIONS(3999),
    [sym_true] = ACTIONS(3999),
    [sym_false] = ACTIONS(3999),
    [sym_none] = ACTIONS(3999),
    [anon_sym_await] = ACTIONS(3999),
    [sym_comment] = ACTIONS(73),
  },
  [1717] = {
    [sym_else_clause] = STATE(1842),
    [sym__string_start] = ACTIONS(4001),
    [ts_builtin_sym_end] = ACTIONS(4001),
    [anon_sym_import] = ACTIONS(4003),
    [anon_sym_from] = ACTIONS(4003),
    [anon_sym_LPAREN] = ACTIONS(4001),
    [anon_sym_print] = ACTIONS(4003),
    [anon_sym_assert] = ACTIONS(4003),
    [anon_sym_return] = ACTIONS(4003),
    [anon_sym_del] = ACTIONS(4003),
    [anon_sym_raise] = ACTIONS(4003),
    [anon_sym_pass] = ACTIONS(4003),
    [anon_sym_break] = ACTIONS(4003),
    [anon_sym_continue] = ACTIONS(4003),
    [anon_sym_if] = ACTIONS(4003),
    [anon_sym_else] = ACTIONS(2371),
    [anon_sym_async] = ACTIONS(4003),
    [anon_sym_for] = ACTIONS(4003),
    [anon_sym_while] = ACTIONS(4003),
    [anon_sym_try] = ACTIONS(4003),
    [anon_sym_with] = ACTIONS(4003),
    [anon_sym_def] = ACTIONS(4003),
    [anon_sym_global] = ACTIONS(4003),
    [anon_sym_nonlocal] = ACTIONS(4003),
    [anon_sym_exec] = ACTIONS(4003),
    [anon_sym_class] = ACTIONS(4003),
    [anon_sym_AT] = ACTIONS(4001),
    [anon_sym_not] = ACTIONS(4003),
    [anon_sym_PLUS] = ACTIONS(4001),
    [anon_sym_DASH] = ACTIONS(4001),
    [anon_sym_TILDE] = ACTIONS(4001),
    [anon_sym_lambda] = ACTIONS(4003),
    [anon_sym_yield] = ACTIONS(4003),
    [anon_sym_LBRACK] = ACTIONS(4001),
    [sym_ellipsis] = ACTIONS(4001),
    [anon_sym_LBRACE] = ACTIONS(4001),
    [sym_integer] = ACTIONS(4003),
    [sym_float] = ACTIONS(4003),
    [sym_identifier] = ACTIONS(4003),
    [sym_true] = ACTIONS(4003),
    [sym_false] = ACTIONS(4003),
    [sym_none] = ACTIONS(4003),
    [anon_sym_await] = ACTIONS(4003),
    [sym_comment] = ACTIONS(73),
  },
  [1718] = {
    [sym__simple_statements] = STATE(1843),
    [sym_import_statement] = STATE(34),
    [sym_future_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym__suite] = STATE(1843),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(1448),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1719] = {
    [sym__string_start] = ACTIONS(4001),
    [ts_builtin_sym_end] = ACTIONS(4001),
    [anon_sym_import] = ACTIONS(4003),
    [anon_sym_from] = ACTIONS(4003),
    [anon_sym_LPAREN] = ACTIONS(4001),
    [anon_sym_print] = ACTIONS(4003),
    [anon_sym_assert] = ACTIONS(4003),
    [anon_sym_return] = ACTIONS(4003),
    [anon_sym_del] = ACTIONS(4003),
    [anon_sym_raise] = ACTIONS(4003),
    [anon_sym_pass] = ACTIONS(4003),
    [anon_sym_break] = ACTIONS(4003),
    [anon_sym_continue] = ACTIONS(4003),
    [anon_sym_if] = ACTIONS(4003),
    [anon_sym_async] = ACTIONS(4003),
    [anon_sym_for] = ACTIONS(4003),
    [anon_sym_while] = ACTIONS(4003),
    [anon_sym_try] = ACTIONS(4003),
    [anon_sym_with] = ACTIONS(4003),
    [anon_sym_def] = ACTIONS(4003),
    [anon_sym_global] = ACTIONS(4003),
    [anon_sym_nonlocal] = ACTIONS(4003),
    [anon_sym_exec] = ACTIONS(4003),
    [anon_sym_class] = ACTIONS(4003),
    [anon_sym_AT] = ACTIONS(4001),
    [anon_sym_not] = ACTIONS(4003),
    [anon_sym_PLUS] = ACTIONS(4001),
    [anon_sym_DASH] = ACTIONS(4001),
    [anon_sym_TILDE] = ACTIONS(4001),
    [anon_sym_lambda] = ACTIONS(4003),
    [anon_sym_yield] = ACTIONS(4003),
    [anon_sym_LBRACK] = ACTIONS(4001),
    [sym_ellipsis] = ACTIONS(4001),
    [anon_sym_LBRACE] = ACTIONS(4001),
    [sym_integer] = ACTIONS(4003),
    [sym_float] = ACTIONS(4003),
    [sym_identifier] = ACTIONS(4003),
    [sym_true] = ACTIONS(4003),
    [sym_false] = ACTIONS(4003),
    [sym_none] = ACTIONS(4003),
    [anon_sym_await] = ACTIONS(4003),
    [sym_comment] = ACTIONS(73),
  },
  [1720] = {
    [sym__expression] = STATE(1506),
    [sym__primary_expression] = STATE(432),
    [sym_not_operator] = STATE(1506),
    [sym_boolean_operator] = STATE(1506),
    [sym_binary_operator] = STATE(432),
    [sym_unary_operator] = STATE(432),
    [sym_comparison_operator] = STATE(1506),
    [sym_lambda] = STATE(1506),
    [sym_attribute] = STATE(432),
    [sym_subscript] = STATE(432),
    [sym_call] = STATE(432),
    [sym_list] = STATE(432),
    [sym_list_comprehension] = STATE(432),
    [sym_dictionary] = STATE(432),
    [sym_dictionary_comprehension] = STATE(432),
    [sym_set] = STATE(432),
    [sym_set_comprehension] = STATE(432),
    [sym_parenthesized_expression] = STATE(432),
    [sym_tuple] = STATE(432),
    [sym_generator_expression] = STATE(432),
    [sym_conditional_expression] = STATE(1506),
    [sym_concatenated_string] = STATE(432),
    [sym_string] = STATE(433),
    [sym_await] = STATE(1506),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(735),
    [anon_sym_lambda] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(741),
    [sym_float] = ACTIONS(741),
    [sym_identifier] = ACTIONS(741),
    [sym_true] = ACTIONS(741),
    [sym_false] = ACTIONS(741),
    [sym_none] = ACTIONS(741),
    [anon_sym_await] = ACTIONS(743),
    [sym_comment] = ACTIONS(73),
  },
  [1721] = {
    [sym__statement] = STATE(1845),
    [sym__simple_statements] = STATE(1845),
    [sym_import_statement] = STATE(799),
    [sym_future_import_statement] = STATE(799),
    [sym_import_from_statement] = STATE(799),
    [sym_print_statement] = STATE(799),
    [sym_assert_statement] = STATE(799),
    [sym_expression_statement] = STATE(799),
    [sym_return_statement] = STATE(799),
    [sym_delete_statement] = STATE(799),
    [sym_raise_statement] = STATE(799),
    [sym_pass_statement] = STATE(799),
    [sym_break_statement] = STATE(799),
    [sym_continue_statement] = STATE(799),
    [sym_if_statement] = STATE(1845),
    [sym_for_statement] = STATE(1845),
    [sym_while_statement] = STATE(1845),
    [sym_try_statement] = STATE(1845),
    [sym_with_statement] = STATE(1845),
    [sym_function_definition] = STATE(1845),
    [sym_global_statement] = STATE(799),
    [sym_nonlocal_statement] = STATE(799),
    [sym_exec_statement] = STATE(799),
    [sym_class_definition] = STATE(1845),
    [sym_decorated_definition] = STATE(1845),
    [sym_decorator] = STATE(801),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [aux_sym_module_repeat1] = STATE(1845),
    [aux_sym_decorated_definition_repeat1] = STATE(801),
    [sym__dedent] = ACTIONS(4005),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(1522),
    [anon_sym_async] = ACTIONS(1524),
    [anon_sym_for] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1528),
    [anon_sym_try] = ACTIONS(1530),
    [anon_sym_with] = ACTIONS(1532),
    [anon_sym_def] = ACTIONS(1534),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1536),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1722] = {
    [sym_elif_clause] = STATE(1849),
    [sym_else_clause] = STATE(1848),
    [aux_sym_if_statement_repeat1] = STATE(1849),
    [sym__dedent] = ACTIONS(2365),
    [sym__string_start] = ACTIONS(2365),
    [anon_sym_import] = ACTIONS(2367),
    [anon_sym_from] = ACTIONS(2367),
    [anon_sym_LPAREN] = ACTIONS(2365),
    [anon_sym_print] = ACTIONS(2367),
    [anon_sym_assert] = ACTIONS(2367),
    [anon_sym_return] = ACTIONS(2367),
    [anon_sym_del] = ACTIONS(2367),
    [anon_sym_raise] = ACTIONS(2367),
    [anon_sym_pass] = ACTIONS(2367),
    [anon_sym_break] = ACTIONS(2367),
    [anon_sym_continue] = ACTIONS(2367),
    [anon_sym_if] = ACTIONS(2367),
    [anon_sym_elif] = ACTIONS(4007),
    [anon_sym_else] = ACTIONS(4009),
    [anon_sym_async] = ACTIONS(2367),
    [anon_sym_for] = ACTIONS(2367),
    [anon_sym_while] = ACTIONS(2367),
    [anon_sym_try] = ACTIONS(2367),
    [anon_sym_with] = ACTIONS(2367),
    [anon_sym_def] = ACTIONS(2367),
    [anon_sym_global] = ACTIONS(2367),
    [anon_sym_nonlocal] = ACTIONS(2367),
    [anon_sym_exec] = ACTIONS(2367),
    [anon_sym_class] = ACTIONS(2367),
    [anon_sym_AT] = ACTIONS(2365),
    [anon_sym_not] = ACTIONS(2367),
    [anon_sym_PLUS] = ACTIONS(2365),
    [anon_sym_DASH] = ACTIONS(2365),
    [anon_sym_TILDE] = ACTIONS(2365),
    [anon_sym_lambda] = ACTIONS(2367),
    [anon_sym_yield] = ACTIONS(2367),
    [anon_sym_LBRACK] = ACTIONS(2365),
    [sym_ellipsis] = ACTIONS(2365),
    [anon_sym_LBRACE] = ACTIONS(2365),
    [sym_integer] = ACTIONS(2367),
    [sym_float] = ACTIONS(2367),
    [sym_identifier] = ACTIONS(2367),
    [sym_true] = ACTIONS(2367),
    [sym_false] = ACTIONS(2367),
    [sym_none] = ACTIONS(2367),
    [anon_sym_await] = ACTIONS(2367),
    [sym_comment] = ACTIONS(73),
  },
  [1723] = {
    [sym_expression_list] = STATE(1850),
    [sym__expression] = STATE(778),
    [sym__primary_expression] = STATE(432),
    [sym_not_operator] = STATE(778),
    [sym_boolean_operator] = STATE(778),
    [sym_binary_operator] = STATE(432),
    [sym_unary_operator] = STATE(432),
    [sym_comparison_operator] = STATE(778),
    [sym_lambda] = STATE(778),
    [sym_attribute] = STATE(432),
    [sym_subscript] = STATE(432),
    [sym_call] = STATE(432),
    [sym_list] = STATE(432),
    [sym_list_comprehension] = STATE(432),
    [sym_dictionary] = STATE(432),
    [sym_dictionary_comprehension] = STATE(432),
    [sym_set] = STATE(432),
    [sym_set_comprehension] = STATE(432),
    [sym_parenthesized_expression] = STATE(432),
    [sym_tuple] = STATE(432),
    [sym_generator_expression] = STATE(432),
    [sym_conditional_expression] = STATE(778),
    [sym_concatenated_string] = STATE(432),
    [sym_string] = STATE(433),
    [sym_await] = STATE(778),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(733),
    [anon_sym_PLUS] = ACTIONS(735),
    [anon_sym_DASH] = ACTIONS(735),
    [anon_sym_TILDE] = ACTIONS(735),
    [anon_sym_lambda] = ACTIONS(737),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(739),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(741),
    [sym_float] = ACTIONS(741),
    [sym_identifier] = ACTIONS(741),
    [sym_true] = ACTIONS(741),
    [sym_false] = ACTIONS(741),
    [sym_none] = ACTIONS(741),
    [anon_sym_await] = ACTIONS(743),
    [sym_comment] = ACTIONS(73),
  },
  [1724] = {
    [sym__simple_statements] = STATE(1851),
    [sym_import_statement] = STATE(799),
    [sym_future_import_statement] = STATE(799),
    [sym_import_from_statement] = STATE(799),
    [sym_print_statement] = STATE(799),
    [sym_assert_statement] = STATE(799),
    [sym_expression_statement] = STATE(799),
    [sym_return_statement] = STATE(799),
    [sym_delete_statement] = STATE(799),
    [sym_raise_statement] = STATE(799),
    [sym_pass_statement] = STATE(799),
    [sym_break_statement] = STATE(799),
    [sym_continue_statement] = STATE(799),
    [sym_global_statement] = STATE(799),
    [sym_nonlocal_statement] = STATE(799),
    [sym_exec_statement] = STATE(799),
    [sym__suite] = STATE(1851),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(3719),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1725] = {
    [aux_sym_with_statement_repeat1] = STATE(813),
    [anon_sym_COMMA] = ACTIONS(661),
    [anon_sym_COLON] = ACTIONS(4011),
    [sym_comment] = ACTIONS(73),
  },
  [1726] = {
    [anon_sym_COLON] = ACTIONS(4013),
    [anon_sym_DASH_GT] = ACTIONS(4015),
    [sym_comment] = ACTIONS(73),
  },
  [1727] = {
    [anon_sym_COLON] = ACTIONS(4017),
    [sym_comment] = ACTIONS(73),
  },
  [1728] = {
    [sym_else_clause] = STATE(1856),
    [sym__dedent] = ACTIONS(2406),
    [sym__string_start] = ACTIONS(2406),
    [anon_sym_import] = ACTIONS(2408),
    [anon_sym_from] = ACTIONS(2408),
    [anon_sym_LPAREN] = ACTIONS(2406),
    [anon_sym_print] = ACTIONS(2408),
    [anon_sym_assert] = ACTIONS(2408),
    [anon_sym_return] = ACTIONS(2408),
    [anon_sym_del] = ACTIONS(2408),
    [anon_sym_raise] = ACTIONS(2408),
    [anon_sym_pass] = ACTIONS(2408),
    [anon_sym_break] = ACTIONS(2408),
    [anon_sym_continue] = ACTIONS(2408),
    [anon_sym_if] = ACTIONS(2408),
    [anon_sym_else] = ACTIONS(4009),
    [anon_sym_async] = ACTIONS(2408),
    [anon_sym_for] = ACTIONS(2408),
    [anon_sym_while] = ACTIONS(2408),
    [anon_sym_try] = ACTIONS(2408),
    [anon_sym_with] = ACTIONS(2408),
    [anon_sym_def] = ACTIONS(2408),
    [anon_sym_global] = ACTIONS(2408),
    [anon_sym_nonlocal] = ACTIONS(2408),
    [anon_sym_exec] = ACTIONS(2408),
    [anon_sym_class] = ACTIONS(2408),
    [anon_sym_AT] = ACTIONS(2406),
    [anon_sym_not] = ACTIONS(2408),
    [anon_sym_PLUS] = ACTIONS(2406),
    [anon_sym_DASH] = ACTIONS(2406),
    [anon_sym_TILDE] = ACTIONS(2406),
    [anon_sym_lambda] = ACTIONS(2408),
    [anon_sym_yield] = ACTIONS(2408),
    [anon_sym_LBRACK] = ACTIONS(2406),
    [sym_ellipsis] = ACTIONS(2406),
    [anon_sym_LBRACE] = ACTIONS(2406),
    [sym_integer] = ACTIONS(2408),
    [sym_float] = ACTIONS(2408),
    [sym_identifier] = ACTIONS(2408),
    [sym_true] = ACTIONS(2408),
    [sym_false] = ACTIONS(2408),
    [sym_none] = ACTIONS(2408),
    [anon_sym_await] = ACTIONS(2408),
    [sym_comment] = ACTIONS(73),
  },
  [1729] = {
    [sym__expression] = STATE(1858),
    [sym__primary_expression] = STATE(119),
    [sym_not_operator] = STATE(1858),
    [sym_boolean_operator] = STATE(1858),
    [sym_binary_operator] = STATE(119),
    [sym_unary_operator] = STATE(119),
    [sym_comparison_operator] = STATE(1858),
    [sym_lambda] = STATE(1858),
    [sym_attribute] = STATE(119),
    [sym_subscript] = STATE(119),
    [sym_call] = STATE(119),
    [sym_list] = STATE(119),
    [sym_list_comprehension] = STATE(119),
    [sym_dictionary] = STATE(119),
    [sym_dictionary_comprehension] = STATE(119),
    [sym_set] = STATE(119),
    [sym_set_comprehension] = STATE(119),
    [sym_parenthesized_expression] = STATE(119),
    [sym_tuple] = STATE(119),
    [sym_generator_expression] = STATE(119),
    [sym_conditional_expression] = STATE(1858),
    [sym_concatenated_string] = STATE(119),
    [sym_string] = STATE(120),
    [sym_await] = STATE(1858),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_COLON] = ACTIONS(4019),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(197),
    [anon_sym_PLUS] = ACTIONS(199),
    [anon_sym_DASH] = ACTIONS(199),
    [anon_sym_TILDE] = ACTIONS(199),
    [anon_sym_lambda] = ACTIONS(201),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(203),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(205),
    [sym_float] = ACTIONS(205),
    [sym_identifier] = ACTIONS(205),
    [sym_true] = ACTIONS(205),
    [sym_false] = ACTIONS(205),
    [sym_none] = ACTIONS(205),
    [anon_sym_await] = ACTIONS(207),
    [sym_comment] = ACTIONS(73),
  },
  [1730] = {
    [anon_sym_COLON] = ACTIONS(4021),
    [sym_comment] = ACTIONS(73),
  },
  [1731] = {
    [sym__dedent] = ACTIONS(2444),
    [sym__string_start] = ACTIONS(2444),
    [anon_sym_import] = ACTIONS(2446),
    [anon_sym_from] = ACTIONS(2446),
    [anon_sym_LPAREN] = ACTIONS(2444),
    [anon_sym_print] = ACTIONS(2446),
    [anon_sym_assert] = ACTIONS(2446),
    [anon_sym_return] = ACTIONS(2446),
    [anon_sym_del] = ACTIONS(2446),
    [anon_sym_raise] = ACTIONS(2446),
    [anon_sym_pass] = ACTIONS(2446),
    [anon_sym_break] = ACTIONS(2446),
    [anon_sym_continue] = ACTIONS(2446),
    [anon_sym_if] = ACTIONS(2446),
    [anon_sym_async] = ACTIONS(2446),
    [anon_sym_for] = ACTIONS(2446),
    [anon_sym_while] = ACTIONS(2446),
    [anon_sym_try] = ACTIONS(2446),
    [anon_sym_with] = ACTIONS(2446),
    [anon_sym_def] = ACTIONS(2446),
    [anon_sym_global] = ACTIONS(2446),
    [anon_sym_nonlocal] = ACTIONS(2446),
    [anon_sym_exec] = ACTIONS(2446),
    [anon_sym_class] = ACTIONS(2446),
    [anon_sym_AT] = ACTIONS(2444),
    [anon_sym_not] = ACTIONS(2446),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_TILDE] = ACTIONS(2444),
    [anon_sym_lambda] = ACTIONS(2446),
    [anon_sym_yield] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(2444),
    [sym_ellipsis] = ACTIONS(2444),
    [anon_sym_LBRACE] = ACTIONS(2444),
    [sym_integer] = ACTIONS(2446),
    [sym_float] = ACTIONS(2446),
    [sym_identifier] = ACTIONS(2446),
    [sym_true] = ACTIONS(2446),
    [sym_false] = ACTIONS(2446),
    [sym_none] = ACTIONS(2446),
    [anon_sym_await] = ACTIONS(2446),
    [sym_comment] = ACTIONS(73),
  },
  [1732] = {
    [sym_else_clause] = STATE(1860),
    [sym_except_clause] = STATE(1862),
    [sym_finally_clause] = STATE(1861),
    [aux_sym_try_statement_repeat1] = STATE(1862),
    [sym__dedent] = ACTIONS(2444),
    [sym__string_start] = ACTIONS(2444),
    [anon_sym_import] = ACTIONS(2446),
    [anon_sym_from] = ACTIONS(2446),
    [anon_sym_LPAREN] = ACTIONS(2444),
    [anon_sym_print] = ACTIONS(2446),
    [anon_sym_assert] = ACTIONS(2446),
    [anon_sym_return] = ACTIONS(2446),
    [anon_sym_del] = ACTIONS(2446),
    [anon_sym_raise] = ACTIONS(2446),
    [anon_sym_pass] = ACTIONS(2446),
    [anon_sym_break] = ACTIONS(2446),
    [anon_sym_continue] = ACTIONS(2446),
    [anon_sym_if] = ACTIONS(2446),
    [anon_sym_else] = ACTIONS(4009),
    [anon_sym_async] = ACTIONS(2446),
    [anon_sym_for] = ACTIONS(2446),
    [anon_sym_while] = ACTIONS(2446),
    [anon_sym_try] = ACTIONS(2446),
    [anon_sym_except] = ACTIONS(4023),
    [anon_sym_finally] = ACTIONS(4025),
    [anon_sym_with] = ACTIONS(2446),
    [anon_sym_def] = ACTIONS(2446),
    [anon_sym_global] = ACTIONS(2446),
    [anon_sym_nonlocal] = ACTIONS(2446),
    [anon_sym_exec] = ACTIONS(2446),
    [anon_sym_class] = ACTIONS(2446),
    [anon_sym_AT] = ACTIONS(2444),
    [anon_sym_not] = ACTIONS(2446),
    [anon_sym_PLUS] = ACTIONS(2444),
    [anon_sym_DASH] = ACTIONS(2444),
    [anon_sym_TILDE] = ACTIONS(2444),
    [anon_sym_lambda] = ACTIONS(2446),
    [anon_sym_yield] = ACTIONS(2446),
    [anon_sym_LBRACK] = ACTIONS(2444),
    [sym_ellipsis] = ACTIONS(2444),
    [anon_sym_LBRACE] = ACTIONS(2444),
    [sym_integer] = ACTIONS(2446),
    [sym_float] = ACTIONS(2446),
    [sym_identifier] = ACTIONS(2446),
    [sym_true] = ACTIONS(2446),
    [sym_false] = ACTIONS(2446),
    [sym_none] = ACTIONS(2446),
    [anon_sym_await] = ACTIONS(2446),
    [sym_comment] = ACTIONS(73),
  },
  [1733] = {
    [sym__dedent] = ACTIONS(2454),
    [sym__string_start] = ACTIONS(2454),
    [anon_sym_import] = ACTIONS(2456),
    [anon_sym_from] = ACTIONS(2456),
    [anon_sym_LPAREN] = ACTIONS(2454),
    [anon_sym_print] = ACTIONS(2456),
    [anon_sym_assert] = ACTIONS(2456),
    [anon_sym_return] = ACTIONS(2456),
    [anon_sym_del] = ACTIONS(2456),
    [anon_sym_raise] = ACTIONS(2456),
    [anon_sym_pass] = ACTIONS(2456),
    [anon_sym_break] = ACTIONS(2456),
    [anon_sym_continue] = ACTIONS(2456),
    [anon_sym_if] = ACTIONS(2456),
    [anon_sym_async] = ACTIONS(2456),
    [anon_sym_for] = ACTIONS(2456),
    [anon_sym_while] = ACTIONS(2456),
    [anon_sym_try] = ACTIONS(2456),
    [anon_sym_with] = ACTIONS(2456),
    [anon_sym_def] = ACTIONS(2456),
    [anon_sym_global] = ACTIONS(2456),
    [anon_sym_nonlocal] = ACTIONS(2456),
    [anon_sym_exec] = ACTIONS(2456),
    [anon_sym_class] = ACTIONS(2456),
    [anon_sym_AT] = ACTIONS(2454),
    [anon_sym_not] = ACTIONS(2456),
    [anon_sym_PLUS] = ACTIONS(2454),
    [anon_sym_DASH] = ACTIONS(2454),
    [anon_sym_TILDE] = ACTIONS(2454),
    [anon_sym_lambda] = ACTIONS(2456),
    [anon_sym_yield] = ACTIONS(2456),
    [anon_sym_LBRACK] = ACTIONS(2454),
    [sym_ellipsis] = ACTIONS(2454),
    [anon_sym_LBRACE] = ACTIONS(2454),
    [sym_integer] = ACTIONS(2456),
    [sym_float] = ACTIONS(2456),
    [sym_identifier] = ACTIONS(2456),
    [sym_true] = ACTIONS(2456),
    [sym_false] = ACTIONS(2456),
    [sym_none] = ACTIONS(2456),
    [anon_sym_await] = ACTIONS(2456),
    [sym_comment] = ACTIONS(73),
  },
  [1734] = {
    [sym__simple_statements] = STATE(1863),
    [sym_import_statement] = STATE(799),
    [sym_future_import_statement] = STATE(799),
    [sym_import_from_statement] = STATE(799),
    [sym_print_statement] = STATE(799),
    [sym_assert_statement] = STATE(799),
    [sym_expression_statement] = STATE(799),
    [sym_return_statement] = STATE(799),
    [sym_delete_statement] = STATE(799),
    [sym_raise_statement] = STATE(799),
    [sym_pass_statement] = STATE(799),
    [sym_break_statement] = STATE(799),
    [sym_continue_statement] = STATE(799),
    [sym_global_statement] = STATE(799),
    [sym_nonlocal_statement] = STATE(799),
    [sym_exec_statement] = STATE(799),
    [sym__suite] = STATE(1863),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(3719),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1735] = {
    [sym__expression] = STATE(1242),
    [sym__primary_expression] = STATE(102),
    [sym_not_operator] = STATE(1242),
    [sym_boolean_operator] = STATE(1242),
    [sym_binary_operator] = STATE(102),
    [sym_unary_operator] = STATE(102),
    [sym_comparison_operator] = STATE(1242),
    [sym_lambda] = STATE(1242),
    [sym_attribute] = STATE(102),
    [sym_subscript] = STATE(102),
    [sym_call] = STATE(102),
    [sym_type] = STATE(1864),
    [sym_list] = STATE(102),
    [sym_list_comprehension] = STATE(102),
    [sym_dictionary] = STATE(102),
    [sym_dictionary_comprehension] = STATE(102),
    [sym_set] = STATE(102),
    [sym_set_comprehension] = STATE(102),
    [sym_parenthesized_expression] = STATE(102),
    [sym_tuple] = STATE(102),
    [sym_generator_expression] = STATE(102),
    [sym_conditional_expression] = STATE(1242),
    [sym_concatenated_string] = STATE(102),
    [sym_string] = STATE(103),
    [sym_await] = STATE(1242),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [1736] = {
    [sym__dedent] = ACTIONS(2520),
    [sym__string_start] = ACTIONS(2520),
    [anon_sym_import] = ACTIONS(2522),
    [anon_sym_from] = ACTIONS(2522),
    [anon_sym_LPAREN] = ACTIONS(2520),
    [anon_sym_print] = ACTIONS(2522),
    [anon_sym_assert] = ACTIONS(2522),
    [anon_sym_return] = ACTIONS(2522),
    [anon_sym_del] = ACTIONS(2522),
    [anon_sym_raise] = ACTIONS(2522),
    [anon_sym_pass] = ACTIONS(2522),
    [anon_sym_break] = ACTIONS(2522),
    [anon_sym_continue] = ACTIONS(2522),
    [anon_sym_if] = ACTIONS(2522),
    [anon_sym_async] = ACTIONS(2522),
    [anon_sym_for] = ACTIONS(2522),
    [anon_sym_while] = ACTIONS(2522),
    [anon_sym_try] = ACTIONS(2522),
    [anon_sym_with] = ACTIONS(2522),
    [anon_sym_def] = ACTIONS(2522),
    [anon_sym_global] = ACTIONS(2522),
    [anon_sym_nonlocal] = ACTIONS(2522),
    [anon_sym_exec] = ACTIONS(2522),
    [anon_sym_class] = ACTIONS(2522),
    [anon_sym_AT] = ACTIONS(2520),
    [anon_sym_not] = ACTIONS(2522),
    [anon_sym_PLUS] = ACTIONS(2520),
    [anon_sym_DASH] = ACTIONS(2520),
    [anon_sym_TILDE] = ACTIONS(2520),
    [anon_sym_lambda] = ACTIONS(2522),
    [anon_sym_yield] = ACTIONS(2522),
    [anon_sym_LBRACK] = ACTIONS(2520),
    [sym_ellipsis] = ACTIONS(2520),
    [anon_sym_LBRACE] = ACTIONS(2520),
    [sym_integer] = ACTIONS(2522),
    [sym_float] = ACTIONS(2522),
    [sym_identifier] = ACTIONS(2522),
    [sym_true] = ACTIONS(2522),
    [sym_false] = ACTIONS(2522),
    [sym_none] = ACTIONS(2522),
    [anon_sym_await] = ACTIONS(2522),
    [sym_comment] = ACTIONS(73),
  },
  [1737] = {
    [sym__simple_statements] = STATE(1865),
    [sym_import_statement] = STATE(799),
    [sym_future_import_statement] = STATE(799),
    [sym_import_from_statement] = STATE(799),
    [sym_print_statement] = STATE(799),
    [sym_assert_statement] = STATE(799),
    [sym_expression_statement] = STATE(799),
    [sym_return_statement] = STATE(799),
    [sym_delete_statement] = STATE(799),
    [sym_raise_statement] = STATE(799),
    [sym_pass_statement] = STATE(799),
    [sym_break_statement] = STATE(799),
    [sym_continue_statement] = STATE(799),
    [sym_global_statement] = STATE(799),
    [sym_nonlocal_statement] = STATE(799),
    [sym_exec_statement] = STATE(799),
    [sym__suite] = STATE(1865),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(3719),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1738] = {
    [sym__dedent] = ACTIONS(2860),
    [sym__string_start] = ACTIONS(2860),
    [anon_sym_import] = ACTIONS(2862),
    [anon_sym_from] = ACTIONS(2862),
    [anon_sym_LPAREN] = ACTIONS(2860),
    [anon_sym_print] = ACTIONS(2862),
    [anon_sym_assert] = ACTIONS(2862),
    [anon_sym_return] = ACTIONS(2862),
    [anon_sym_del] = ACTIONS(2862),
    [anon_sym_raise] = ACTIONS(2862),
    [anon_sym_pass] = ACTIONS(2862),
    [anon_sym_break] = ACTIONS(2862),
    [anon_sym_continue] = ACTIONS(2862),
    [anon_sym_if] = ACTIONS(2862),
    [anon_sym_elif] = ACTIONS(2862),
    [anon_sym_else] = ACTIONS(2862),
    [anon_sym_async] = ACTIONS(2862),
    [anon_sym_for] = ACTIONS(2862),
    [anon_sym_while] = ACTIONS(2862),
    [anon_sym_try] = ACTIONS(2862),
    [anon_sym_except] = ACTIONS(2862),
    [anon_sym_finally] = ACTIONS(2862),
    [anon_sym_with] = ACTIONS(2862),
    [anon_sym_def] = ACTIONS(2862),
    [anon_sym_global] = ACTIONS(2862),
    [anon_sym_nonlocal] = ACTIONS(2862),
    [anon_sym_exec] = ACTIONS(2862),
    [anon_sym_class] = ACTIONS(2862),
    [anon_sym_AT] = ACTIONS(2860),
    [anon_sym_not] = ACTIONS(2862),
    [anon_sym_PLUS] = ACTIONS(2860),
    [anon_sym_DASH] = ACTIONS(2860),
    [anon_sym_TILDE] = ACTIONS(2860),
    [anon_sym_lambda] = ACTIONS(2862),
    [anon_sym_yield] = ACTIONS(2862),
    [anon_sym_LBRACK] = ACTIONS(2860),
    [sym_ellipsis] = ACTIONS(2860),
    [anon_sym_LBRACE] = ACTIONS(2860),
    [sym_integer] = ACTIONS(2862),
    [sym_float] = ACTIONS(2862),
    [sym_identifier] = ACTIONS(2862),
    [sym_true] = ACTIONS(2862),
    [sym_false] = ACTIONS(2862),
    [sym_none] = ACTIONS(2862),
    [anon_sym_await] = ACTIONS(2862),
    [sym_comment] = ACTIONS(73),
  },
  [1739] = {
    [anon_sym_if] = ACTIONS(599),
    [anon_sym_COLON] = ACTIONS(4027),
    [anon_sym_and] = ACTIONS(603),
    [anon_sym_or] = ACTIONS(605),
    [sym_comment] = ACTIONS(73),
  },
  [1740] = {
    [sym__string_start] = ACTIONS(4029),
    [ts_builtin_sym_end] = ACTIONS(4029),
    [anon_sym_import] = ACTIONS(4031),
    [anon_sym_from] = ACTIONS(4031),
    [anon_sym_LPAREN] = ACTIONS(4029),
    [anon_sym_print] = ACTIONS(4031),
    [anon_sym_assert] = ACTIONS(4031),
    [anon_sym_return] = ACTIONS(4031),
    [anon_sym_del] = ACTIONS(4031),
    [anon_sym_raise] = ACTIONS(4031),
    [anon_sym_pass] = ACTIONS(4031),
    [anon_sym_break] = ACTIONS(4031),
    [anon_sym_continue] = ACTIONS(4031),
    [anon_sym_if] = ACTIONS(4031),
    [anon_sym_else] = ACTIONS(4031),
    [anon_sym_async] = ACTIONS(4031),
    [anon_sym_for] = ACTIONS(4031),
    [anon_sym_while] = ACTIONS(4031),
    [anon_sym_try] = ACTIONS(4031),
    [anon_sym_except] = ACTIONS(4031),
    [anon_sym_finally] = ACTIONS(4031),
    [anon_sym_with] = ACTIONS(4031),
    [anon_sym_def] = ACTIONS(4031),
    [anon_sym_global] = ACTIONS(4031),
    [anon_sym_nonlocal] = ACTIONS(4031),
    [anon_sym_exec] = ACTIONS(4031),
    [anon_sym_class] = ACTIONS(4031),
    [anon_sym_AT] = ACTIONS(4029),
    [anon_sym_not] = ACTIONS(4031),
    [anon_sym_PLUS] = ACTIONS(4029),
    [anon_sym_DASH] = ACTIONS(4029),
    [anon_sym_TILDE] = ACTIONS(4029),
    [anon_sym_lambda] = ACTIONS(4031),
    [anon_sym_yield] = ACTIONS(4031),
    [anon_sym_LBRACK] = ACTIONS(4029),
    [sym_ellipsis] = ACTIONS(4029),
    [anon_sym_LBRACE] = ACTIONS(4029),
    [sym_integer] = ACTIONS(4031),
    [sym_float] = ACTIONS(4031),
    [sym_identifier] = ACTIONS(4031),
    [sym_true] = ACTIONS(4031),
    [sym_false] = ACTIONS(4031),
    [sym_none] = ACTIONS(4031),
    [anon_sym_await] = ACTIONS(4031),
    [sym_comment] = ACTIONS(73),
  },
  [1741] = {
    [anon_sym_RPAREN] = ACTIONS(1660),
    [anon_sym_COMMA] = ACTIONS(1660),
    [anon_sym_if] = ACTIONS(3225),
    [anon_sym_COLON] = ACTIONS(1660),
    [anon_sym_and] = ACTIONS(3227),
    [anon_sym_or] = ACTIONS(3229),
    [sym_comment] = ACTIONS(73),
  },
  [1742] = {
    [sym__expression] = STATE(1867),
    [sym__primary_expression] = STATE(1229),
    [sym_not_operator] = STATE(1867),
    [sym_boolean_operator] = STATE(1867),
    [sym_binary_operator] = STATE(1229),
    [sym_unary_operator] = STATE(1229),
    [sym_comparison_operator] = STATE(1867),
    [sym_lambda] = STATE(1867),
    [sym_attribute] = STATE(1229),
    [sym_subscript] = STATE(1229),
    [sym_call] = STATE(1229),
    [sym_list] = STATE(1229),
    [sym_list_comprehension] = STATE(1229),
    [sym_dictionary] = STATE(1229),
    [sym_dictionary_comprehension] = STATE(1229),
    [sym_set] = STATE(1229),
    [sym_set_comprehension] = STATE(1229),
    [sym_parenthesized_expression] = STATE(1229),
    [sym_tuple] = STATE(1229),
    [sym_generator_expression] = STATE(1229),
    [sym_conditional_expression] = STATE(1867),
    [sym_concatenated_string] = STATE(1229),
    [sym_string] = STATE(1230),
    [sym_await] = STATE(1867),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2485),
    [anon_sym_PLUS] = ACTIONS(2487),
    [anon_sym_DASH] = ACTIONS(2487),
    [anon_sym_TILDE] = ACTIONS(2487),
    [anon_sym_lambda] = ACTIONS(2489),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2491),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2493),
    [sym_float] = ACTIONS(2493),
    [sym_identifier] = ACTIONS(2493),
    [sym_true] = ACTIONS(2493),
    [sym_false] = ACTIONS(2493),
    [sym_none] = ACTIONS(2493),
    [anon_sym_await] = ACTIONS(2495),
    [sym_comment] = ACTIONS(73),
  },
  [1743] = {
    [anon_sym_if] = ACTIONS(1925),
    [anon_sym_else] = ACTIONS(4033),
    [anon_sym_and] = ACTIONS(1929),
    [anon_sym_or] = ACTIONS(1931),
    [sym_comment] = ACTIONS(73),
  },
  [1744] = {
    [anon_sym_RPAREN] = ACTIONS(1957),
    [anon_sym_COMMA] = ACTIONS(1957),
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_COLON] = ACTIONS(1957),
    [anon_sym_and] = ACTIONS(3227),
    [anon_sym_or] = ACTIONS(1957),
    [sym_comment] = ACTIONS(73),
  },
  [1745] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1984),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1986),
    [anon_sym_PERCENT] = ACTIONS(1984),
    [anon_sym_SLASH_SLASH] = ACTIONS(1984),
    [anon_sym_STAR_STAR] = ACTIONS(3243),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1746] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(3231),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(3237),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(3241),
    [anon_sym_DASH] = ACTIONS(3241),
    [anon_sym_SLASH] = ACTIONS(3231),
    [anon_sym_PERCENT] = ACTIONS(3237),
    [anon_sym_SLASH_SLASH] = ACTIONS(3237),
    [anon_sym_STAR_STAR] = ACTIONS(3243),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1747] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(1988),
    [anon_sym_COMMA] = ACTIONS(1988),
    [anon_sym_STAR] = ACTIONS(3231),
    [anon_sym_GT_GT] = ACTIONS(3233),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_COLON] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(1988),
    [anon_sym_AT] = ACTIONS(3237),
    [anon_sym_not] = ACTIONS(1988),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_PLUS] = ACTIONS(3241),
    [anon_sym_DASH] = ACTIONS(3241),
    [anon_sym_SLASH] = ACTIONS(3231),
    [anon_sym_PERCENT] = ACTIONS(3237),
    [anon_sym_SLASH_SLASH] = ACTIONS(3237),
    [anon_sym_STAR_STAR] = ACTIONS(3243),
    [anon_sym_PIPE] = ACTIONS(3245),
    [anon_sym_AMP] = ACTIONS(3247),
    [anon_sym_CARET] = ACTIONS(3249),
    [anon_sym_LT_LT] = ACTIONS(3233),
    [anon_sym_LT] = ACTIONS(1990),
    [anon_sym_LT_EQ] = ACTIONS(1988),
    [anon_sym_EQ_EQ] = ACTIONS(1988),
    [anon_sym_BANG_EQ] = ACTIONS(1988),
    [anon_sym_GT_EQ] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1990),
    [anon_sym_LT_GT] = ACTIONS(1988),
    [anon_sym_is] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(473),
    [sym_comment] = ACTIONS(73),
  },
  [1748] = {
    [sym__primary_expression] = STATE(1869),
    [sym_binary_operator] = STATE(1869),
    [sym_unary_operator] = STATE(1869),
    [sym_attribute] = STATE(1869),
    [sym_subscript] = STATE(1869),
    [sym_call] = STATE(1869),
    [sym_list] = STATE(1869),
    [sym_list_comprehension] = STATE(1869),
    [sym_dictionary] = STATE(1869),
    [sym_dictionary_comprehension] = STATE(1869),
    [sym_set] = STATE(1869),
    [sym_set_comprehension] = STATE(1869),
    [sym_parenthesized_expression] = STATE(1869),
    [sym_tuple] = STATE(1869),
    [sym_generator_expression] = STATE(1869),
    [sym_concatenated_string] = STATE(1869),
    [sym_string] = STATE(1230),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2487),
    [anon_sym_DASH] = ACTIONS(2487),
    [anon_sym_TILDE] = ACTIONS(2487),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(4035),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(4037),
    [sym_float] = ACTIONS(4037),
    [sym_identifier] = ACTIONS(4037),
    [sym_true] = ACTIONS(4037),
    [sym_false] = ACTIONS(4037),
    [sym_none] = ACTIONS(4037),
    [sym_comment] = ACTIONS(73),
  },
  [1749] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(3231),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(3237),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(3231),
    [anon_sym_PERCENT] = ACTIONS(3237),
    [anon_sym_SLASH_SLASH] = ACTIONS(3237),
    [anon_sym_STAR_STAR] = ACTIONS(3243),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1750] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(3231),
    [anon_sym_GT_GT] = ACTIONS(3233),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(3237),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(3241),
    [anon_sym_DASH] = ACTIONS(3241),
    [anon_sym_SLASH] = ACTIONS(3231),
    [anon_sym_PERCENT] = ACTIONS(3237),
    [anon_sym_SLASH_SLASH] = ACTIONS(3237),
    [anon_sym_STAR_STAR] = ACTIONS(3243),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(3247),
    [anon_sym_CARET] = ACTIONS(3249),
    [anon_sym_LT_LT] = ACTIONS(3233),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1751] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(3231),
    [anon_sym_GT_GT] = ACTIONS(3233),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(3237),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(3241),
    [anon_sym_DASH] = ACTIONS(3241),
    [anon_sym_SLASH] = ACTIONS(3231),
    [anon_sym_PERCENT] = ACTIONS(3237),
    [anon_sym_SLASH_SLASH] = ACTIONS(3237),
    [anon_sym_STAR_STAR] = ACTIONS(3243),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(3249),
    [anon_sym_LT_LT] = ACTIONS(3233),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1752] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(3231),
    [anon_sym_GT_GT] = ACTIONS(3233),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_COLON] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(3237),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(3241),
    [anon_sym_DASH] = ACTIONS(3241),
    [anon_sym_SLASH] = ACTIONS(3231),
    [anon_sym_PERCENT] = ACTIONS(3237),
    [anon_sym_SLASH_SLASH] = ACTIONS(3237),
    [anon_sym_STAR_STAR] = ACTIONS(3243),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(3233),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1753] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1753),
    [anon_sym_RPAREN] = ACTIONS(1988),
    [anon_sym_COMMA] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_COLON] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(4039),
    [anon_sym_not] = ACTIONS(4042),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(4045),
    [anon_sym_LT_EQ] = ACTIONS(4039),
    [anon_sym_EQ_EQ] = ACTIONS(4039),
    [anon_sym_BANG_EQ] = ACTIONS(4039),
    [anon_sym_GT_EQ] = ACTIONS(4039),
    [anon_sym_GT] = ACTIONS(4045),
    [anon_sym_LT_GT] = ACTIONS(4039),
    [anon_sym_is] = ACTIONS(4048),
    [sym_comment] = ACTIONS(73),
  },
  [1754] = {
    [sym_string] = STATE(1754),
    [aux_sym_concatenated_string_repeat1] = STATE(1754),
    [sym__string_start] = ACTIONS(2241),
    [anon_sym_DOT] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(2050),
    [anon_sym_RPAREN] = ACTIONS(2050),
    [anon_sym_COMMA] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2050),
    [anon_sym_if] = ACTIONS(2050),
    [anon_sym_COLON] = ACTIONS(2050),
    [anon_sym_in] = ACTIONS(2050),
    [anon_sym_AT] = ACTIONS(2050),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_and] = ACTIONS(2050),
    [anon_sym_or] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_SLASH] = ACTIONS(2055),
    [anon_sym_PERCENT] = ACTIONS(2050),
    [anon_sym_SLASH_SLASH] = ACTIONS(2050),
    [anon_sym_STAR_STAR] = ACTIONS(2050),
    [anon_sym_PIPE] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2050),
    [anon_sym_CARET] = ACTIONS(2050),
    [anon_sym_LT_LT] = ACTIONS(2050),
    [anon_sym_LT] = ACTIONS(2055),
    [anon_sym_LT_EQ] = ACTIONS(2050),
    [anon_sym_EQ_EQ] = ACTIONS(2050),
    [anon_sym_BANG_EQ] = ACTIONS(2050),
    [anon_sym_GT_EQ] = ACTIONS(2050),
    [anon_sym_GT] = ACTIONS(2055),
    [anon_sym_LT_GT] = ACTIONS(2050),
    [anon_sym_is] = ACTIONS(2050),
    [anon_sym_LBRACK] = ACTIONS(2050),
    [sym_comment] = ACTIONS(73),
  },
  [1755] = {
    [sym__expression] = STATE(1870),
    [sym__primary_expression] = STATE(237),
    [sym_not_operator] = STATE(1870),
    [sym_boolean_operator] = STATE(1870),
    [sym_binary_operator] = STATE(237),
    [sym_unary_operator] = STATE(237),
    [sym_comparison_operator] = STATE(1870),
    [sym_lambda] = STATE(1870),
    [sym_attribute] = STATE(237),
    [sym_subscript] = STATE(237),
    [sym_call] = STATE(237),
    [sym_list] = STATE(237),
    [sym_list_comprehension] = STATE(237),
    [sym_dictionary] = STATE(237),
    [sym_dictionary_comprehension] = STATE(237),
    [sym_set] = STATE(237),
    [sym_set_comprehension] = STATE(237),
    [sym_parenthesized_expression] = STATE(237),
    [sym_tuple] = STATE(237),
    [sym_generator_expression] = STATE(237),
    [sym_conditional_expression] = STATE(1870),
    [sym_concatenated_string] = STATE(237),
    [sym_string] = STATE(238),
    [sym_await] = STATE(1870),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_lambda] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(419),
    [sym_float] = ACTIONS(419),
    [sym_identifier] = ACTIONS(419),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_none] = ACTIONS(419),
    [anon_sym_await] = ACTIONS(421),
    [sym_comment] = ACTIONS(73),
  },
  [1756] = {
    [sym_default_parameter] = STATE(867),
    [sym_typed_default_parameter] = STATE(867),
    [sym_list_splat] = STATE(1551),
    [sym_dictionary_splat] = STATE(1551),
    [sym_typed_parameter] = STATE(867),
    [sym_tuple] = STATE(867),
    [anon_sym_LPAREN] = ACTIONS(227),
    [anon_sym_STAR] = ACTIONS(1582),
    [anon_sym_print] = ACTIONS(3255),
    [anon_sym_exec] = ACTIONS(3255),
    [sym_identifier] = ACTIONS(3257),
    [sym_comment] = ACTIONS(73),
  },
  [1757] = {
    [anon_sym_RPAREN] = ACTIONS(723),
    [anon_sym_COMMA] = ACTIONS(723),
    [anon_sym_if] = ACTIONS(723),
    [anon_sym_EQ] = ACTIONS(723),
    [anon_sym_and] = ACTIONS(3792),
    [anon_sym_or] = ACTIONS(3794),
    [sym_comment] = ACTIONS(73),
  },
  [1758] = {
    [sym__expression] = STATE(1871),
    [sym__primary_expression] = STATE(1561),
    [sym_not_operator] = STATE(1871),
    [sym_boolean_operator] = STATE(1871),
    [sym_binary_operator] = STATE(1561),
    [sym_unary_operator] = STATE(1561),
    [sym_comparison_operator] = STATE(1871),
    [sym_lambda] = STATE(1871),
    [sym_attribute] = STATE(1561),
    [sym_subscript] = STATE(1561),
    [sym_call] = STATE(1561),
    [sym_list] = STATE(1561),
    [sym_list_comprehension] = STATE(1561),
    [sym_dictionary] = STATE(1561),
    [sym_dictionary_comprehension] = STATE(1561),
    [sym_set] = STATE(1561),
    [sym_set_comprehension] = STATE(1561),
    [sym_parenthesized_expression] = STATE(1561),
    [sym_tuple] = STATE(1561),
    [sym_generator_expression] = STATE(1561),
    [sym_conditional_expression] = STATE(1871),
    [sym_concatenated_string] = STATE(1561),
    [sym_string] = STATE(1563),
    [sym_await] = STATE(1871),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3263),
    [anon_sym_DASH] = ACTIONS(3263),
    [anon_sym_TILDE] = ACTIONS(3263),
    [anon_sym_lambda] = ACTIONS(3265),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3267),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3269),
    [sym_float] = ACTIONS(3269),
    [sym_identifier] = ACTIONS(3269),
    [sym_true] = ACTIONS(3269),
    [sym_false] = ACTIONS(3269),
    [sym_none] = ACTIONS(3269),
    [anon_sym_await] = ACTIONS(3271),
    [sym_comment] = ACTIONS(73),
  },
  [1759] = {
    [anon_sym_COLON] = ACTIONS(4051),
    [sym_comment] = ACTIONS(73),
  },
  [1760] = {
    [sym__expression] = STATE(1873),
    [sym__primary_expression] = STATE(538),
    [sym_not_operator] = STATE(1873),
    [sym_boolean_operator] = STATE(1873),
    [sym_binary_operator] = STATE(538),
    [sym_unary_operator] = STATE(538),
    [sym_comparison_operator] = STATE(1873),
    [sym_lambda] = STATE(1873),
    [sym_attribute] = STATE(538),
    [sym_subscript] = STATE(538),
    [sym_call] = STATE(538),
    [sym_list] = STATE(538),
    [sym_list_comprehension] = STATE(538),
    [sym_dictionary] = STATE(538),
    [sym_dictionary_comprehension] = STATE(538),
    [sym_set] = STATE(538),
    [sym_set_comprehension] = STATE(538),
    [sym_parenthesized_expression] = STATE(538),
    [sym_tuple] = STATE(538),
    [sym_generator_expression] = STATE(538),
    [sym_conditional_expression] = STATE(1873),
    [sym_concatenated_string] = STATE(538),
    [sym_string] = STATE(539),
    [sym_await] = STATE(1873),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(911),
    [anon_sym_PLUS] = ACTIONS(913),
    [anon_sym_DASH] = ACTIONS(913),
    [anon_sym_TILDE] = ACTIONS(913),
    [anon_sym_lambda] = ACTIONS(915),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(917),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(919),
    [sym_float] = ACTIONS(919),
    [sym_identifier] = ACTIONS(919),
    [sym_true] = ACTIONS(919),
    [sym_false] = ACTIONS(919),
    [sym_none] = ACTIONS(919),
    [anon_sym_await] = ACTIONS(921),
    [sym_comment] = ACTIONS(73),
  },
  [1761] = {
    [sym__expression] = STATE(652),
    [sym__primary_expression] = STATE(1561),
    [sym_not_operator] = STATE(652),
    [sym_boolean_operator] = STATE(652),
    [sym_binary_operator] = STATE(1561),
    [sym_unary_operator] = STATE(1561),
    [sym_comparison_operator] = STATE(652),
    [sym_lambda] = STATE(652),
    [sym_attribute] = STATE(1561),
    [sym_subscript] = STATE(1561),
    [sym_call] = STATE(1561),
    [sym_list] = STATE(1561),
    [sym_list_comprehension] = STATE(1561),
    [sym_dictionary] = STATE(1561),
    [sym_dictionary_comprehension] = STATE(1561),
    [sym_set] = STATE(1561),
    [sym_set_comprehension] = STATE(1561),
    [sym_parenthesized_expression] = STATE(1561),
    [sym_tuple] = STATE(1561),
    [sym_generator_expression] = STATE(1561),
    [sym_conditional_expression] = STATE(652),
    [sym_concatenated_string] = STATE(1561),
    [sym_string] = STATE(1563),
    [sym_await] = STATE(652),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3263),
    [anon_sym_DASH] = ACTIONS(3263),
    [anon_sym_TILDE] = ACTIONS(3263),
    [anon_sym_lambda] = ACTIONS(3265),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3267),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3269),
    [sym_float] = ACTIONS(3269),
    [sym_identifier] = ACTIONS(3269),
    [sym_true] = ACTIONS(3269),
    [sym_false] = ACTIONS(3269),
    [sym_none] = ACTIONS(3269),
    [anon_sym_await] = ACTIONS(3271),
    [sym_comment] = ACTIONS(73),
  },
  [1762] = {
    [sym__expression] = STATE(1874),
    [sym__primary_expression] = STATE(1561),
    [sym_not_operator] = STATE(1874),
    [sym_boolean_operator] = STATE(1874),
    [sym_binary_operator] = STATE(1561),
    [sym_unary_operator] = STATE(1561),
    [sym_comparison_operator] = STATE(1874),
    [sym_lambda] = STATE(1874),
    [sym_attribute] = STATE(1561),
    [sym_subscript] = STATE(1561),
    [sym_call] = STATE(1561),
    [sym_list] = STATE(1561),
    [sym_list_comprehension] = STATE(1561),
    [sym_dictionary] = STATE(1561),
    [sym_dictionary_comprehension] = STATE(1561),
    [sym_set] = STATE(1561),
    [sym_set_comprehension] = STATE(1561),
    [sym_parenthesized_expression] = STATE(1561),
    [sym_tuple] = STATE(1561),
    [sym_generator_expression] = STATE(1561),
    [sym_conditional_expression] = STATE(1874),
    [sym_concatenated_string] = STATE(1561),
    [sym_string] = STATE(1563),
    [sym_await] = STATE(1874),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3263),
    [anon_sym_DASH] = ACTIONS(3263),
    [anon_sym_TILDE] = ACTIONS(3263),
    [anon_sym_lambda] = ACTIONS(3265),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3267),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3269),
    [sym_float] = ACTIONS(3269),
    [sym_identifier] = ACTIONS(3269),
    [sym_true] = ACTIONS(3269),
    [sym_false] = ACTIONS(3269),
    [sym_none] = ACTIONS(3269),
    [anon_sym_await] = ACTIONS(3271),
    [sym_comment] = ACTIONS(73),
  },
  [1763] = {
    [sym__primary_expression] = STATE(1875),
    [sym_binary_operator] = STATE(1875),
    [sym_unary_operator] = STATE(1875),
    [sym_attribute] = STATE(1875),
    [sym_subscript] = STATE(1875),
    [sym_call] = STATE(1875),
    [sym_list] = STATE(1875),
    [sym_list_comprehension] = STATE(1875),
    [sym_dictionary] = STATE(1875),
    [sym_dictionary_comprehension] = STATE(1875),
    [sym_set] = STATE(1875),
    [sym_set_comprehension] = STATE(1875),
    [sym_parenthesized_expression] = STATE(1875),
    [sym_tuple] = STATE(1875),
    [sym_generator_expression] = STATE(1875),
    [sym_concatenated_string] = STATE(1875),
    [sym_string] = STATE(1563),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(3263),
    [anon_sym_DASH] = ACTIONS(3263),
    [anon_sym_TILDE] = ACTIONS(3263),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(4053),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(4055),
    [sym_float] = ACTIONS(4055),
    [sym_identifier] = ACTIONS(4055),
    [sym_true] = ACTIONS(4055),
    [sym_false] = ACTIONS(4055),
    [sym_none] = ACTIONS(4055),
    [sym_comment] = ACTIONS(73),
  },
  [1764] = {
    [sym__primary_expression] = STATE(1876),
    [sym_binary_operator] = STATE(1876),
    [sym_unary_operator] = STATE(1876),
    [sym_attribute] = STATE(1876),
    [sym_subscript] = STATE(1876),
    [sym_call] = STATE(1876),
    [sym_list] = STATE(1876),
    [sym_list_comprehension] = STATE(1876),
    [sym_dictionary] = STATE(1876),
    [sym_dictionary_comprehension] = STATE(1876),
    [sym_set] = STATE(1876),
    [sym_set_comprehension] = STATE(1876),
    [sym_parenthesized_expression] = STATE(1876),
    [sym_tuple] = STATE(1876),
    [sym_generator_expression] = STATE(1876),
    [sym_concatenated_string] = STATE(1876),
    [sym_string] = STATE(1563),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(3263),
    [anon_sym_DASH] = ACTIONS(3263),
    [anon_sym_TILDE] = ACTIONS(3263),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(4057),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(4059),
    [sym_float] = ACTIONS(4059),
    [sym_identifier] = ACTIONS(4059),
    [sym_true] = ACTIONS(4059),
    [sym_false] = ACTIONS(4059),
    [sym_none] = ACTIONS(4059),
    [sym_comment] = ACTIONS(73),
  },
  [1765] = {
    [sym__primary_expression] = STATE(1877),
    [sym_binary_operator] = STATE(1877),
    [sym_unary_operator] = STATE(1877),
    [sym_attribute] = STATE(1877),
    [sym_subscript] = STATE(1877),
    [sym_call] = STATE(1877),
    [sym_list] = STATE(1877),
    [sym_list_comprehension] = STATE(1877),
    [sym_dictionary] = STATE(1877),
    [sym_dictionary_comprehension] = STATE(1877),
    [sym_set] = STATE(1877),
    [sym_set_comprehension] = STATE(1877),
    [sym_parenthesized_expression] = STATE(1877),
    [sym_tuple] = STATE(1877),
    [sym_generator_expression] = STATE(1877),
    [sym_concatenated_string] = STATE(1877),
    [sym_string] = STATE(1563),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(3263),
    [anon_sym_DASH] = ACTIONS(3263),
    [anon_sym_TILDE] = ACTIONS(3263),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(4061),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(4063),
    [sym_float] = ACTIONS(4063),
    [sym_identifier] = ACTIONS(4063),
    [sym_true] = ACTIONS(4063),
    [sym_false] = ACTIONS(4063),
    [sym_none] = ACTIONS(4063),
    [sym_comment] = ACTIONS(73),
  },
  [1766] = {
    [anon_sym_in] = ACTIONS(4065),
    [sym_comment] = ACTIONS(73),
  },
  [1767] = {
    [sym__primary_expression] = STATE(1879),
    [sym_binary_operator] = STATE(1879),
    [sym_unary_operator] = STATE(1879),
    [sym_attribute] = STATE(1879),
    [sym_subscript] = STATE(1879),
    [sym_call] = STATE(1879),
    [sym_list] = STATE(1879),
    [sym_list_comprehension] = STATE(1879),
    [sym_dictionary] = STATE(1879),
    [sym_dictionary_comprehension] = STATE(1879),
    [sym_set] = STATE(1879),
    [sym_set_comprehension] = STATE(1879),
    [sym_parenthesized_expression] = STATE(1879),
    [sym_tuple] = STATE(1879),
    [sym_generator_expression] = STATE(1879),
    [sym_concatenated_string] = STATE(1879),
    [sym_string] = STATE(1563),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(3263),
    [anon_sym_DASH] = ACTIONS(3263),
    [anon_sym_TILDE] = ACTIONS(3263),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(4067),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(4069),
    [sym_float] = ACTIONS(4069),
    [sym_identifier] = ACTIONS(4069),
    [sym_true] = ACTIONS(4069),
    [sym_false] = ACTIONS(4069),
    [sym_none] = ACTIONS(4069),
    [sym_comment] = ACTIONS(73),
  },
  [1768] = {
    [sym__primary_expression] = STATE(669),
    [sym_binary_operator] = STATE(669),
    [sym_unary_operator] = STATE(669),
    [sym_attribute] = STATE(669),
    [sym_subscript] = STATE(669),
    [sym_call] = STATE(669),
    [sym_list] = STATE(669),
    [sym_list_comprehension] = STATE(669),
    [sym_dictionary] = STATE(669),
    [sym_dictionary_comprehension] = STATE(669),
    [sym_set] = STATE(669),
    [sym_set_comprehension] = STATE(669),
    [sym_parenthesized_expression] = STATE(669),
    [sym_tuple] = STATE(669),
    [sym_generator_expression] = STATE(669),
    [sym_concatenated_string] = STATE(669),
    [sym_string] = STATE(1563),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(3263),
    [anon_sym_DASH] = ACTIONS(3263),
    [anon_sym_TILDE] = ACTIONS(3263),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1282),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1284),
    [sym_float] = ACTIONS(1284),
    [sym_identifier] = ACTIONS(1284),
    [sym_true] = ACTIONS(1284),
    [sym_false] = ACTIONS(1284),
    [sym_none] = ACTIONS(1284),
    [sym_comment] = ACTIONS(73),
  },
  [1769] = {
    [sym__primary_expression] = STATE(1880),
    [sym_binary_operator] = STATE(1880),
    [sym_unary_operator] = STATE(1880),
    [sym_attribute] = STATE(1880),
    [sym_subscript] = STATE(1880),
    [sym_call] = STATE(1880),
    [sym_list] = STATE(1880),
    [sym_list_comprehension] = STATE(1880),
    [sym_dictionary] = STATE(1880),
    [sym_dictionary_comprehension] = STATE(1880),
    [sym_set] = STATE(1880),
    [sym_set_comprehension] = STATE(1880),
    [sym_parenthesized_expression] = STATE(1880),
    [sym_tuple] = STATE(1880),
    [sym_generator_expression] = STATE(1880),
    [sym_concatenated_string] = STATE(1880),
    [sym_string] = STATE(1563),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(3263),
    [anon_sym_DASH] = ACTIONS(3263),
    [anon_sym_TILDE] = ACTIONS(3263),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(4071),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(4073),
    [sym_float] = ACTIONS(4073),
    [sym_identifier] = ACTIONS(4073),
    [sym_true] = ACTIONS(4073),
    [sym_false] = ACTIONS(4073),
    [sym_none] = ACTIONS(4073),
    [sym_comment] = ACTIONS(73),
  },
  [1770] = {
    [sym__primary_expression] = STATE(1881),
    [sym_binary_operator] = STATE(1881),
    [sym_unary_operator] = STATE(1881),
    [sym_attribute] = STATE(1881),
    [sym_subscript] = STATE(1881),
    [sym_call] = STATE(1881),
    [sym_list] = STATE(1881),
    [sym_list_comprehension] = STATE(1881),
    [sym_dictionary] = STATE(1881),
    [sym_dictionary_comprehension] = STATE(1881),
    [sym_set] = STATE(1881),
    [sym_set_comprehension] = STATE(1881),
    [sym_parenthesized_expression] = STATE(1881),
    [sym_tuple] = STATE(1881),
    [sym_generator_expression] = STATE(1881),
    [sym_concatenated_string] = STATE(1881),
    [sym_string] = STATE(1563),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(3263),
    [anon_sym_DASH] = ACTIONS(3263),
    [anon_sym_TILDE] = ACTIONS(3263),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(4075),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(4077),
    [sym_float] = ACTIONS(4077),
    [sym_identifier] = ACTIONS(4077),
    [sym_true] = ACTIONS(4077),
    [sym_false] = ACTIONS(4077),
    [sym_none] = ACTIONS(4077),
    [sym_comment] = ACTIONS(73),
  },
  [1771] = {
    [sym__primary_expression] = STATE(1882),
    [sym_binary_operator] = STATE(1882),
    [sym_unary_operator] = STATE(1882),
    [sym_attribute] = STATE(1882),
    [sym_subscript] = STATE(1882),
    [sym_call] = STATE(1882),
    [sym_list] = STATE(1882),
    [sym_list_comprehension] = STATE(1882),
    [sym_dictionary] = STATE(1882),
    [sym_dictionary_comprehension] = STATE(1882),
    [sym_set] = STATE(1882),
    [sym_set_comprehension] = STATE(1882),
    [sym_parenthesized_expression] = STATE(1882),
    [sym_tuple] = STATE(1882),
    [sym_generator_expression] = STATE(1882),
    [sym_concatenated_string] = STATE(1882),
    [sym_string] = STATE(1563),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(3263),
    [anon_sym_DASH] = ACTIONS(3263),
    [anon_sym_TILDE] = ACTIONS(3263),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(4079),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(4081),
    [sym_float] = ACTIONS(4081),
    [sym_identifier] = ACTIONS(4081),
    [sym_true] = ACTIONS(4081),
    [sym_false] = ACTIONS(4081),
    [sym_none] = ACTIONS(4081),
    [sym_comment] = ACTIONS(73),
  },
  [1772] = {
    [sym__primary_expression] = STATE(1877),
    [sym_binary_operator] = STATE(1877),
    [sym_unary_operator] = STATE(1877),
    [sym_attribute] = STATE(1877),
    [sym_subscript] = STATE(1877),
    [sym_call] = STATE(1877),
    [sym_list] = STATE(1877),
    [sym_list_comprehension] = STATE(1877),
    [sym_dictionary] = STATE(1877),
    [sym_dictionary_comprehension] = STATE(1877),
    [sym_set] = STATE(1877),
    [sym_set_comprehension] = STATE(1877),
    [sym_parenthesized_expression] = STATE(1877),
    [sym_tuple] = STATE(1877),
    [sym_generator_expression] = STATE(1877),
    [sym_concatenated_string] = STATE(1877),
    [sym_string] = STATE(1563),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(4083),
    [anon_sym_PLUS] = ACTIONS(3263),
    [anon_sym_DASH] = ACTIONS(3263),
    [anon_sym_TILDE] = ACTIONS(3263),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(4061),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(4063),
    [sym_float] = ACTIONS(4063),
    [sym_identifier] = ACTIONS(4063),
    [sym_true] = ACTIONS(4063),
    [sym_false] = ACTIONS(4063),
    [sym_none] = ACTIONS(4063),
    [sym_comment] = ACTIONS(73),
  },
  [1773] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1883),
    [anon_sym_RPAREN] = ACTIONS(991),
    [anon_sym_COMMA] = ACTIONS(991),
    [anon_sym_if] = ACTIONS(991),
    [anon_sym_in] = ACTIONS(3800),
    [anon_sym_EQ] = ACTIONS(993),
    [anon_sym_not] = ACTIONS(3804),
    [anon_sym_and] = ACTIONS(991),
    [anon_sym_or] = ACTIONS(991),
    [anon_sym_LT] = ACTIONS(3816),
    [anon_sym_LT_EQ] = ACTIONS(3800),
    [anon_sym_EQ_EQ] = ACTIONS(3800),
    [anon_sym_BANG_EQ] = ACTIONS(3800),
    [anon_sym_GT_EQ] = ACTIONS(3800),
    [anon_sym_GT] = ACTIONS(3816),
    [anon_sym_LT_GT] = ACTIONS(3800),
    [anon_sym_is] = ACTIONS(3818),
    [sym_comment] = ACTIONS(73),
  },
  [1774] = {
    [sym__expression] = STATE(1884),
    [sym__primary_expression] = STATE(237),
    [sym_not_operator] = STATE(1884),
    [sym_boolean_operator] = STATE(1884),
    [sym_binary_operator] = STATE(237),
    [sym_unary_operator] = STATE(237),
    [sym_comparison_operator] = STATE(1884),
    [sym_lambda] = STATE(1884),
    [sym_attribute] = STATE(237),
    [sym_subscript] = STATE(237),
    [sym_call] = STATE(237),
    [sym_list] = STATE(237),
    [sym_list_comprehension] = STATE(237),
    [sym_dictionary] = STATE(237),
    [sym_dictionary_comprehension] = STATE(237),
    [sym_set] = STATE(237),
    [sym_set_comprehension] = STATE(237),
    [sym_parenthesized_expression] = STATE(237),
    [sym_tuple] = STATE(237),
    [sym_generator_expression] = STATE(237),
    [sym_conditional_expression] = STATE(1884),
    [sym_concatenated_string] = STATE(237),
    [sym_string] = STATE(238),
    [sym_await] = STATE(1884),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(411),
    [anon_sym_PLUS] = ACTIONS(413),
    [anon_sym_DASH] = ACTIONS(413),
    [anon_sym_TILDE] = ACTIONS(413),
    [anon_sym_lambda] = ACTIONS(415),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(417),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(419),
    [sym_float] = ACTIONS(419),
    [sym_identifier] = ACTIONS(419),
    [sym_true] = ACTIONS(419),
    [sym_false] = ACTIONS(419),
    [sym_none] = ACTIONS(419),
    [anon_sym_await] = ACTIONS(421),
    [sym_comment] = ACTIONS(73),
  },
  [1775] = {
    [sym_string] = STATE(1885),
    [aux_sym_concatenated_string_repeat1] = STATE(1885),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_DOT] = ACTIONS(995),
    [anon_sym_LPAREN] = ACTIONS(995),
    [anon_sym_RPAREN] = ACTIONS(995),
    [anon_sym_COMMA] = ACTIONS(995),
    [anon_sym_STAR] = ACTIONS(997),
    [anon_sym_GT_GT] = ACTIONS(995),
    [anon_sym_if] = ACTIONS(995),
    [anon_sym_in] = ACTIONS(995),
    [anon_sym_EQ] = ACTIONS(997),
    [anon_sym_AT] = ACTIONS(995),
    [anon_sym_not] = ACTIONS(995),
    [anon_sym_and] = ACTIONS(995),
    [anon_sym_or] = ACTIONS(995),
    [anon_sym_PLUS] = ACTIONS(995),
    [anon_sym_DASH] = ACTIONS(995),
    [anon_sym_SLASH] = ACTIONS(997),
    [anon_sym_PERCENT] = ACTIONS(995),
    [anon_sym_SLASH_SLASH] = ACTIONS(995),
    [anon_sym_STAR_STAR] = ACTIONS(995),
    [anon_sym_PIPE] = ACTIONS(995),
    [anon_sym_AMP] = ACTIONS(995),
    [anon_sym_CARET] = ACTIONS(995),
    [anon_sym_LT_LT] = ACTIONS(995),
    [anon_sym_LT] = ACTIONS(997),
    [anon_sym_LT_EQ] = ACTIONS(995),
    [anon_sym_EQ_EQ] = ACTIONS(995),
    [anon_sym_BANG_EQ] = ACTIONS(995),
    [anon_sym_GT_EQ] = ACTIONS(995),
    [anon_sym_GT] = ACTIONS(997),
    [anon_sym_LT_GT] = ACTIONS(995),
    [anon_sym_is] = ACTIONS(995),
    [anon_sym_LBRACK] = ACTIONS(995),
    [sym_comment] = ACTIONS(73),
  },
  [1776] = {
    [sym__string_start] = ACTIONS(4085),
    [ts_builtin_sym_end] = ACTIONS(4085),
    [anon_sym_import] = ACTIONS(4087),
    [anon_sym_from] = ACTIONS(4087),
    [anon_sym_LPAREN] = ACTIONS(4085),
    [anon_sym_print] = ACTIONS(4087),
    [anon_sym_assert] = ACTIONS(4087),
    [anon_sym_return] = ACTIONS(4087),
    [anon_sym_del] = ACTIONS(4087),
    [anon_sym_raise] = ACTIONS(4087),
    [anon_sym_pass] = ACTIONS(4087),
    [anon_sym_break] = ACTIONS(4087),
    [anon_sym_continue] = ACTIONS(4087),
    [anon_sym_if] = ACTIONS(4087),
    [anon_sym_async] = ACTIONS(4087),
    [anon_sym_for] = ACTIONS(4087),
    [anon_sym_while] = ACTIONS(4087),
    [anon_sym_try] = ACTIONS(4087),
    [anon_sym_with] = ACTIONS(4087),
    [anon_sym_def] = ACTIONS(4087),
    [anon_sym_global] = ACTIONS(4087),
    [anon_sym_nonlocal] = ACTIONS(4087),
    [anon_sym_exec] = ACTIONS(4087),
    [anon_sym_class] = ACTIONS(4087),
    [anon_sym_AT] = ACTIONS(4085),
    [anon_sym_not] = ACTIONS(4087),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_TILDE] = ACTIONS(4085),
    [anon_sym_lambda] = ACTIONS(4087),
    [anon_sym_yield] = ACTIONS(4087),
    [anon_sym_LBRACK] = ACTIONS(4085),
    [sym_ellipsis] = ACTIONS(4085),
    [anon_sym_LBRACE] = ACTIONS(4085),
    [sym_integer] = ACTIONS(4087),
    [sym_float] = ACTIONS(4087),
    [sym_identifier] = ACTIONS(4087),
    [sym_true] = ACTIONS(4087),
    [sym_false] = ACTIONS(4087),
    [sym_none] = ACTIONS(4087),
    [anon_sym_await] = ACTIONS(4087),
    [sym_comment] = ACTIONS(73),
  },
  [1777] = {
    [anon_sym_COMMA] = ACTIONS(3565),
    [anon_sym_if] = ACTIONS(1610),
    [anon_sym_COLON] = ACTIONS(3565),
    [anon_sym_and] = ACTIONS(1612),
    [anon_sym_or] = ACTIONS(1614),
    [sym_comment] = ACTIONS(73),
  },
  [1778] = {
    [anon_sym_if] = ACTIONS(2568),
    [anon_sym_EQ] = ACTIONS(2647),
    [anon_sym_and] = ACTIONS(2570),
    [anon_sym_or] = ACTIONS(2572),
    [sym_comment] = ACTIONS(73),
  },
  [1779] = {
    [sym__expression] = STATE(1886),
    [sym__primary_expression] = STATE(874),
    [sym_not_operator] = STATE(1886),
    [sym_boolean_operator] = STATE(1886),
    [sym_binary_operator] = STATE(874),
    [sym_unary_operator] = STATE(874),
    [sym_comparison_operator] = STATE(1886),
    [sym_lambda] = STATE(1886),
    [sym_attribute] = STATE(874),
    [sym_subscript] = STATE(874),
    [sym_call] = STATE(874),
    [sym_list] = STATE(874),
    [sym_list_comprehension] = STATE(874),
    [sym_dictionary] = STATE(874),
    [sym_dictionary_comprehension] = STATE(874),
    [sym_set] = STATE(874),
    [sym_set_comprehension] = STATE(874),
    [sym_parenthesized_expression] = STATE(874),
    [sym_tuple] = STATE(874),
    [sym_generator_expression] = STATE(874),
    [sym_conditional_expression] = STATE(1886),
    [sym_concatenated_string] = STATE(874),
    [sym_string] = STATE(876),
    [sym_await] = STATE(1886),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1646),
    [anon_sym_PLUS] = ACTIONS(1648),
    [anon_sym_DASH] = ACTIONS(1648),
    [anon_sym_TILDE] = ACTIONS(1648),
    [anon_sym_lambda] = ACTIONS(1650),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1652),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1654),
    [sym_float] = ACTIONS(1654),
    [sym_identifier] = ACTIONS(1654),
    [sym_true] = ACTIONS(1654),
    [sym_false] = ACTIONS(1654),
    [sym_none] = ACTIONS(1654),
    [anon_sym_await] = ACTIONS(1656),
    [sym_comment] = ACTIONS(73),
  },
  [1780] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(2574),
    [anon_sym_GT_GT] = ACTIONS(2576),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_in] = ACTIONS(2942),
    [anon_sym_EQ] = ACTIONS(2944),
    [anon_sym_AT] = ACTIONS(2580),
    [anon_sym_not] = ACTIONS(2942),
    [anon_sym_and] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(2584),
    [anon_sym_DASH] = ACTIONS(2584),
    [anon_sym_SLASH] = ACTIONS(2574),
    [anon_sym_PERCENT] = ACTIONS(2580),
    [anon_sym_SLASH_SLASH] = ACTIONS(2580),
    [anon_sym_STAR_STAR] = ACTIONS(2586),
    [anon_sym_PIPE] = ACTIONS(2588),
    [anon_sym_AMP] = ACTIONS(2590),
    [anon_sym_CARET] = ACTIONS(2592),
    [anon_sym_LT_LT] = ACTIONS(2576),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_LT_EQ] = ACTIONS(2942),
    [anon_sym_EQ_EQ] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_GT_EQ] = ACTIONS(2942),
    [anon_sym_GT] = ACTIONS(2944),
    [anon_sym_LT_GT] = ACTIONS(2942),
    [anon_sym_is] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(473),
    [sym_comment] = ACTIONS(73),
  },
  [1781] = {
    [anon_sym_COMMA] = ACTIONS(2647),
    [anon_sym_if] = ACTIONS(2609),
    [anon_sym_COLON] = ACTIONS(2647),
    [anon_sym_EQ] = ACTIONS(2647),
    [anon_sym_and] = ACTIONS(2611),
    [anon_sym_or] = ACTIONS(2613),
    [sym_comment] = ACTIONS(73),
  },
  [1782] = {
    [sym__expression] = STATE(1887),
    [sym__primary_expression] = STATE(885),
    [sym_not_operator] = STATE(1887),
    [sym_boolean_operator] = STATE(1887),
    [sym_binary_operator] = STATE(885),
    [sym_unary_operator] = STATE(885),
    [sym_comparison_operator] = STATE(1887),
    [sym_lambda] = STATE(1887),
    [sym_attribute] = STATE(885),
    [sym_subscript] = STATE(885),
    [sym_call] = STATE(885),
    [sym_list] = STATE(885),
    [sym_list_comprehension] = STATE(885),
    [sym_dictionary] = STATE(885),
    [sym_dictionary_comprehension] = STATE(885),
    [sym_set] = STATE(885),
    [sym_set_comprehension] = STATE(885),
    [sym_parenthesized_expression] = STATE(885),
    [sym_tuple] = STATE(885),
    [sym_generator_expression] = STATE(885),
    [sym_conditional_expression] = STATE(1887),
    [sym_concatenated_string] = STATE(885),
    [sym_string] = STATE(887),
    [sym_await] = STATE(1887),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1664),
    [anon_sym_PLUS] = ACTIONS(1666),
    [anon_sym_DASH] = ACTIONS(1666),
    [anon_sym_TILDE] = ACTIONS(1666),
    [anon_sym_lambda] = ACTIONS(1668),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1670),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1672),
    [sym_float] = ACTIONS(1672),
    [sym_identifier] = ACTIONS(1672),
    [sym_true] = ACTIONS(1672),
    [sym_false] = ACTIONS(1672),
    [sym_none] = ACTIONS(1672),
    [anon_sym_await] = ACTIONS(1674),
    [sym_comment] = ACTIONS(73),
  },
  [1783] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(2942),
    [anon_sym_STAR] = ACTIONS(2615),
    [anon_sym_GT_GT] = ACTIONS(2617),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_COLON] = ACTIONS(2942),
    [anon_sym_in] = ACTIONS(2942),
    [anon_sym_EQ] = ACTIONS(2944),
    [anon_sym_AT] = ACTIONS(2621),
    [anon_sym_not] = ACTIONS(2942),
    [anon_sym_and] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(2625),
    [anon_sym_DASH] = ACTIONS(2625),
    [anon_sym_SLASH] = ACTIONS(2615),
    [anon_sym_PERCENT] = ACTIONS(2621),
    [anon_sym_SLASH_SLASH] = ACTIONS(2621),
    [anon_sym_STAR_STAR] = ACTIONS(2627),
    [anon_sym_PIPE] = ACTIONS(2629),
    [anon_sym_AMP] = ACTIONS(2631),
    [anon_sym_CARET] = ACTIONS(2633),
    [anon_sym_LT_LT] = ACTIONS(2617),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_LT_EQ] = ACTIONS(2942),
    [anon_sym_EQ_EQ] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_GT_EQ] = ACTIONS(2942),
    [anon_sym_GT] = ACTIONS(2944),
    [anon_sym_LT_GT] = ACTIONS(2942),
    [anon_sym_is] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(473),
    [sym_comment] = ACTIONS(73),
  },
  [1784] = {
    [anon_sym_COMMA] = ACTIONS(3565),
    [anon_sym_if] = ACTIONS(1686),
    [anon_sym_and] = ACTIONS(1688),
    [anon_sym_or] = ACTIONS(1690),
    [anon_sym_RBRACK] = ACTIONS(3565),
    [sym_comment] = ACTIONS(73),
  },
  [1785] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1889),
    [anon_sym_COMMA] = ACTIONS(4089),
    [anon_sym_if] = ACTIONS(3969),
    [anon_sym_async] = ACTIONS(3969),
    [anon_sym_for] = ACTIONS(3969),
    [anon_sym_RBRACK] = ACTIONS(3969),
    [sym_comment] = ACTIONS(73),
  },
  [1786] = {
    [sym__expression_within_for_in_clause] = STATE(1834),
    [sym__expression] = STATE(1608),
    [sym__primary_expression] = STATE(152),
    [sym_not_operator] = STATE(1608),
    [sym_boolean_operator] = STATE(1608),
    [sym_binary_operator] = STATE(152),
    [sym_unary_operator] = STATE(152),
    [sym_comparison_operator] = STATE(1608),
    [sym_lambda] = STATE(1608),
    [sym_lambda_within_for_in_clause] = STATE(1834),
    [sym_attribute] = STATE(152),
    [sym_subscript] = STATE(152),
    [sym_call] = STATE(152),
    [sym_list] = STATE(152),
    [sym_list_comprehension] = STATE(152),
    [sym_dictionary] = STATE(152),
    [sym_dictionary_comprehension] = STATE(152),
    [sym_set] = STATE(152),
    [sym_set_comprehension] = STATE(152),
    [sym_parenthesized_expression] = STATE(152),
    [sym_tuple] = STATE(152),
    [sym_generator_expression] = STATE(152),
    [sym_conditional_expression] = STATE(1608),
    [sym_concatenated_string] = STATE(152),
    [sym_string] = STATE(153),
    [sym_await] = STATE(1608),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_lambda] = ACTIONS(3399),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(255),
    [sym_float] = ACTIONS(255),
    [sym_identifier] = ACTIONS(255),
    [sym_true] = ACTIONS(255),
    [sym_false] = ACTIONS(255),
    [sym_none] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [sym_comment] = ACTIONS(73),
  },
  [1787] = {
    [anon_sym_COLON] = ACTIONS(4091),
    [sym_comment] = ACTIONS(73),
  },
  [1788] = {
    [sym__expression_within_for_in_clause] = STATE(1836),
    [sym__expression] = STATE(1608),
    [sym__primary_expression] = STATE(152),
    [sym_not_operator] = STATE(1608),
    [sym_boolean_operator] = STATE(1608),
    [sym_binary_operator] = STATE(152),
    [sym_unary_operator] = STATE(152),
    [sym_comparison_operator] = STATE(1608),
    [sym_lambda] = STATE(1608),
    [sym_lambda_within_for_in_clause] = STATE(1836),
    [sym_attribute] = STATE(152),
    [sym_subscript] = STATE(152),
    [sym_call] = STATE(152),
    [sym_list] = STATE(152),
    [sym_list_comprehension] = STATE(152),
    [sym_dictionary] = STATE(152),
    [sym_dictionary_comprehension] = STATE(152),
    [sym_set] = STATE(152),
    [sym_set_comprehension] = STATE(152),
    [sym_parenthesized_expression] = STATE(152),
    [sym_tuple] = STATE(152),
    [sym_generator_expression] = STATE(152),
    [sym_conditional_expression] = STATE(1608),
    [sym_concatenated_string] = STATE(152),
    [sym_string] = STATE(153),
    [sym_await] = STATE(1608),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(3975),
    [anon_sym_async] = ACTIONS(3975),
    [anon_sym_for] = ACTIONS(3975),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_lambda] = ACTIONS(3399),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(3969),
    [sym_ellipsis] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(255),
    [sym_float] = ACTIONS(255),
    [sym_identifier] = ACTIONS(255),
    [sym_true] = ACTIONS(255),
    [sym_false] = ACTIONS(255),
    [sym_none] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [sym_comment] = ACTIONS(73),
  },
  [1789] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1891),
    [anon_sym_COMMA] = ACTIONS(4089),
    [anon_sym_if] = ACTIONS(3969),
    [anon_sym_async] = ACTIONS(3969),
    [anon_sym_for] = ACTIONS(3969),
    [anon_sym_RBRACK] = ACTIONS(3969),
    [sym_comment] = ACTIONS(73),
  },
  [1790] = {
    [anon_sym_if] = ACTIONS(4093),
    [anon_sym_async] = ACTIONS(1660),
    [anon_sym_for] = ACTIONS(1660),
    [anon_sym_and] = ACTIONS(3403),
    [anon_sym_or] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(1660),
    [sym_comment] = ACTIONS(73),
  },
  [1791] = {
    [sym__expression] = STATE(1892),
    [sym__primary_expression] = STATE(1324),
    [sym_not_operator] = STATE(1892),
    [sym_boolean_operator] = STATE(1892),
    [sym_binary_operator] = STATE(1324),
    [sym_unary_operator] = STATE(1324),
    [sym_comparison_operator] = STATE(1892),
    [sym_lambda] = STATE(1892),
    [sym_attribute] = STATE(1324),
    [sym_subscript] = STATE(1324),
    [sym_call] = STATE(1324),
    [sym_list] = STATE(1324),
    [sym_list_comprehension] = STATE(1324),
    [sym_dictionary] = STATE(1324),
    [sym_dictionary_comprehension] = STATE(1324),
    [sym_set] = STATE(1324),
    [sym_set_comprehension] = STATE(1324),
    [sym_parenthesized_expression] = STATE(1324),
    [sym_tuple] = STATE(1324),
    [sym_generator_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(1892),
    [sym_concatenated_string] = STATE(1324),
    [sym_string] = STATE(1325),
    [sym_await] = STATE(1892),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2702),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_lambda] = ACTIONS(2706),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2708),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2710),
    [sym_float] = ACTIONS(2710),
    [sym_identifier] = ACTIONS(2710),
    [sym_true] = ACTIONS(2710),
    [sym_false] = ACTIONS(2710),
    [sym_none] = ACTIONS(2710),
    [anon_sym_await] = ACTIONS(2712),
    [sym_comment] = ACTIONS(73),
  },
  [1792] = {
    [anon_sym_if] = ACTIONS(1925),
    [anon_sym_else] = ACTIONS(4095),
    [anon_sym_and] = ACTIONS(1929),
    [anon_sym_or] = ACTIONS(1931),
    [sym_comment] = ACTIONS(73),
  },
  [1793] = {
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_async] = ACTIONS(1957),
    [anon_sym_for] = ACTIONS(1957),
    [anon_sym_and] = ACTIONS(3403),
    [anon_sym_or] = ACTIONS(1957),
    [anon_sym_RBRACK] = ACTIONS(1957),
    [sym_comment] = ACTIONS(73),
  },
  [1794] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1984),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1986),
    [anon_sym_PERCENT] = ACTIONS(1984),
    [anon_sym_SLASH_SLASH] = ACTIONS(1984),
    [anon_sym_STAR_STAR] = ACTIONS(3419),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1795] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(3407),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(3413),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_SLASH] = ACTIONS(3407),
    [anon_sym_PERCENT] = ACTIONS(3413),
    [anon_sym_SLASH_SLASH] = ACTIONS(3413),
    [anon_sym_STAR_STAR] = ACTIONS(3419),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1796] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(3407),
    [anon_sym_GT_GT] = ACTIONS(3409),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_async] = ACTIONS(1988),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(1988),
    [anon_sym_AT] = ACTIONS(3413),
    [anon_sym_not] = ACTIONS(1988),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_SLASH] = ACTIONS(3407),
    [anon_sym_PERCENT] = ACTIONS(3413),
    [anon_sym_SLASH_SLASH] = ACTIONS(3413),
    [anon_sym_STAR_STAR] = ACTIONS(3419),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3423),
    [anon_sym_CARET] = ACTIONS(3425),
    [anon_sym_LT_LT] = ACTIONS(3409),
    [anon_sym_LT] = ACTIONS(1990),
    [anon_sym_LT_EQ] = ACTIONS(1988),
    [anon_sym_EQ_EQ] = ACTIONS(1988),
    [anon_sym_BANG_EQ] = ACTIONS(1988),
    [anon_sym_GT_EQ] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1990),
    [anon_sym_LT_GT] = ACTIONS(1988),
    [anon_sym_is] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(473),
    [anon_sym_RBRACK] = ACTIONS(1988),
    [sym_comment] = ACTIONS(73),
  },
  [1797] = {
    [sym__primary_expression] = STATE(1894),
    [sym_binary_operator] = STATE(1894),
    [sym_unary_operator] = STATE(1894),
    [sym_attribute] = STATE(1894),
    [sym_subscript] = STATE(1894),
    [sym_call] = STATE(1894),
    [sym_list] = STATE(1894),
    [sym_list_comprehension] = STATE(1894),
    [sym_dictionary] = STATE(1894),
    [sym_dictionary_comprehension] = STATE(1894),
    [sym_set] = STATE(1894),
    [sym_set_comprehension] = STATE(1894),
    [sym_parenthesized_expression] = STATE(1894),
    [sym_tuple] = STATE(1894),
    [sym_generator_expression] = STATE(1894),
    [sym_concatenated_string] = STATE(1894),
    [sym_string] = STATE(1325),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(4097),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(4099),
    [sym_float] = ACTIONS(4099),
    [sym_identifier] = ACTIONS(4099),
    [sym_true] = ACTIONS(4099),
    [sym_false] = ACTIONS(4099),
    [sym_none] = ACTIONS(4099),
    [sym_comment] = ACTIONS(73),
  },
  [1798] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(3407),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(3413),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(3407),
    [anon_sym_PERCENT] = ACTIONS(3413),
    [anon_sym_SLASH_SLASH] = ACTIONS(3413),
    [anon_sym_STAR_STAR] = ACTIONS(3419),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1799] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(3407),
    [anon_sym_GT_GT] = ACTIONS(3409),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(3413),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_SLASH] = ACTIONS(3407),
    [anon_sym_PERCENT] = ACTIONS(3413),
    [anon_sym_SLASH_SLASH] = ACTIONS(3413),
    [anon_sym_STAR_STAR] = ACTIONS(3419),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(3423),
    [anon_sym_CARET] = ACTIONS(3425),
    [anon_sym_LT_LT] = ACTIONS(3409),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1800] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(3407),
    [anon_sym_GT_GT] = ACTIONS(3409),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(3413),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_SLASH] = ACTIONS(3407),
    [anon_sym_PERCENT] = ACTIONS(3413),
    [anon_sym_SLASH_SLASH] = ACTIONS(3413),
    [anon_sym_STAR_STAR] = ACTIONS(3419),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(3425),
    [anon_sym_LT_LT] = ACTIONS(3409),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1801] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(3407),
    [anon_sym_GT_GT] = ACTIONS(3409),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(3413),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_SLASH] = ACTIONS(3407),
    [anon_sym_PERCENT] = ACTIONS(3413),
    [anon_sym_SLASH_SLASH] = ACTIONS(3413),
    [anon_sym_STAR_STAR] = ACTIONS(3419),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(3409),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1802] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1802),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_async] = ACTIONS(1988),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(4101),
    [anon_sym_not] = ACTIONS(4104),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(4107),
    [anon_sym_LT_EQ] = ACTIONS(4101),
    [anon_sym_EQ_EQ] = ACTIONS(4101),
    [anon_sym_BANG_EQ] = ACTIONS(4101),
    [anon_sym_GT_EQ] = ACTIONS(4101),
    [anon_sym_GT] = ACTIONS(4107),
    [anon_sym_LT_GT] = ACTIONS(4101),
    [anon_sym_is] = ACTIONS(4110),
    [anon_sym_RBRACK] = ACTIONS(1988),
    [sym_comment] = ACTIONS(73),
  },
  [1803] = {
    [sym_string] = STATE(1803),
    [aux_sym_concatenated_string_repeat1] = STATE(1803),
    [sym__string_start] = ACTIONS(2241),
    [anon_sym_DOT] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2050),
    [anon_sym_if] = ACTIONS(2050),
    [anon_sym_async] = ACTIONS(2050),
    [anon_sym_for] = ACTIONS(2050),
    [anon_sym_in] = ACTIONS(2050),
    [anon_sym_AT] = ACTIONS(2050),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_and] = ACTIONS(2050),
    [anon_sym_or] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_SLASH] = ACTIONS(2055),
    [anon_sym_PERCENT] = ACTIONS(2050),
    [anon_sym_SLASH_SLASH] = ACTIONS(2050),
    [anon_sym_STAR_STAR] = ACTIONS(2050),
    [anon_sym_PIPE] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2050),
    [anon_sym_CARET] = ACTIONS(2050),
    [anon_sym_LT_LT] = ACTIONS(2050),
    [anon_sym_LT] = ACTIONS(2055),
    [anon_sym_LT_EQ] = ACTIONS(2050),
    [anon_sym_EQ_EQ] = ACTIONS(2050),
    [anon_sym_BANG_EQ] = ACTIONS(2050),
    [anon_sym_GT_EQ] = ACTIONS(2050),
    [anon_sym_GT] = ACTIONS(2055),
    [anon_sym_LT_GT] = ACTIONS(2050),
    [anon_sym_is] = ACTIONS(2050),
    [anon_sym_LBRACK] = ACTIONS(2050),
    [anon_sym_RBRACK] = ACTIONS(2050),
    [sym_comment] = ACTIONS(73),
  },
  [1804] = {
    [anon_sym_COMMA] = ACTIONS(3565),
    [anon_sym_if] = ACTIONS(1766),
    [anon_sym_and] = ACTIONS(1768),
    [anon_sym_or] = ACTIONS(1770),
    [anon_sym_RBRACE] = ACTIONS(3565),
    [sym_comment] = ACTIONS(73),
  },
  [1805] = {
    [anon_sym_COMMA] = ACTIONS(2647),
    [anon_sym_if] = ACTIONS(2792),
    [anon_sym_async] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2647),
    [anon_sym_and] = ACTIONS(2794),
    [anon_sym_or] = ACTIONS(2796),
    [anon_sym_RBRACE] = ACTIONS(2647),
    [sym_comment] = ACTIONS(73),
  },
  [1806] = {
    [sym__expression] = STATE(1895),
    [sym__primary_expression] = STATE(973),
    [sym_not_operator] = STATE(1895),
    [sym_boolean_operator] = STATE(1895),
    [sym_binary_operator] = STATE(973),
    [sym_unary_operator] = STATE(973),
    [sym_comparison_operator] = STATE(1895),
    [sym_lambda] = STATE(1895),
    [sym_attribute] = STATE(973),
    [sym_subscript] = STATE(973),
    [sym_call] = STATE(973),
    [sym_list] = STATE(973),
    [sym_list_comprehension] = STATE(973),
    [sym_dictionary] = STATE(973),
    [sym_dictionary_comprehension] = STATE(973),
    [sym_set] = STATE(973),
    [sym_set_comprehension] = STATE(973),
    [sym_parenthesized_expression] = STATE(973),
    [sym_tuple] = STATE(973),
    [sym_generator_expression] = STATE(973),
    [sym_conditional_expression] = STATE(1895),
    [sym_concatenated_string] = STATE(973),
    [sym_string] = STATE(974),
    [sym_await] = STATE(1895),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1814),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_DASH] = ACTIONS(1816),
    [anon_sym_TILDE] = ACTIONS(1816),
    [anon_sym_lambda] = ACTIONS(1818),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1820),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1822),
    [sym_float] = ACTIONS(1822),
    [sym_identifier] = ACTIONS(1822),
    [sym_true] = ACTIONS(1822),
    [sym_false] = ACTIONS(1822),
    [sym_none] = ACTIONS(1822),
    [anon_sym_await] = ACTIONS(1824),
    [sym_comment] = ACTIONS(73),
  },
  [1807] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_COMMA] = ACTIONS(2942),
    [anon_sym_STAR] = ACTIONS(2798),
    [anon_sym_GT_GT] = ACTIONS(2800),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_async] = ACTIONS(2942),
    [anon_sym_for] = ACTIONS(2942),
    [anon_sym_in] = ACTIONS(2942),
    [anon_sym_AT] = ACTIONS(2804),
    [anon_sym_not] = ACTIONS(2942),
    [anon_sym_and] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(2808),
    [anon_sym_DASH] = ACTIONS(2808),
    [anon_sym_SLASH] = ACTIONS(2798),
    [anon_sym_PERCENT] = ACTIONS(2804),
    [anon_sym_SLASH_SLASH] = ACTIONS(2804),
    [anon_sym_STAR_STAR] = ACTIONS(2810),
    [anon_sym_PIPE] = ACTIONS(2812),
    [anon_sym_AMP] = ACTIONS(2814),
    [anon_sym_CARET] = ACTIONS(2816),
    [anon_sym_LT_LT] = ACTIONS(2800),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_LT_EQ] = ACTIONS(2942),
    [anon_sym_EQ_EQ] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_GT_EQ] = ACTIONS(2942),
    [anon_sym_GT] = ACTIONS(2944),
    [anon_sym_LT_GT] = ACTIONS(2942),
    [anon_sym_is] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(473),
    [anon_sym_RBRACE] = ACTIONS(2942),
    [sym_comment] = ACTIONS(73),
  },
  [1808] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1897),
    [anon_sym_COMMA] = ACTIONS(4113),
    [anon_sym_if] = ACTIONS(3969),
    [anon_sym_async] = ACTIONS(3969),
    [anon_sym_for] = ACTIONS(3969),
    [anon_sym_RBRACE] = ACTIONS(3969),
    [sym_comment] = ACTIONS(73),
  },
  [1809] = {
    [sym__expression_within_for_in_clause] = STATE(1834),
    [sym__expression] = STATE(1649),
    [sym__primary_expression] = STATE(973),
    [sym_not_operator] = STATE(1649),
    [sym_boolean_operator] = STATE(1649),
    [sym_binary_operator] = STATE(973),
    [sym_unary_operator] = STATE(973),
    [sym_comparison_operator] = STATE(1649),
    [sym_lambda] = STATE(1649),
    [sym_lambda_within_for_in_clause] = STATE(1834),
    [sym_attribute] = STATE(973),
    [sym_subscript] = STATE(973),
    [sym_call] = STATE(973),
    [sym_list] = STATE(973),
    [sym_list_comprehension] = STATE(973),
    [sym_dictionary] = STATE(973),
    [sym_dictionary_comprehension] = STATE(973),
    [sym_set] = STATE(973),
    [sym_set_comprehension] = STATE(973),
    [sym_parenthesized_expression] = STATE(973),
    [sym_tuple] = STATE(973),
    [sym_generator_expression] = STATE(973),
    [sym_conditional_expression] = STATE(1649),
    [sym_concatenated_string] = STATE(973),
    [sym_string] = STATE(974),
    [sym_await] = STATE(1649),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1814),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_DASH] = ACTIONS(1816),
    [anon_sym_TILDE] = ACTIONS(1816),
    [anon_sym_lambda] = ACTIONS(3502),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1820),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1822),
    [sym_float] = ACTIONS(1822),
    [sym_identifier] = ACTIONS(1822),
    [sym_true] = ACTIONS(1822),
    [sym_false] = ACTIONS(1822),
    [sym_none] = ACTIONS(1822),
    [anon_sym_await] = ACTIONS(1824),
    [sym_comment] = ACTIONS(73),
  },
  [1810] = {
    [anon_sym_COLON] = ACTIONS(4115),
    [sym_comment] = ACTIONS(73),
  },
  [1811] = {
    [sym__expression_within_for_in_clause] = STATE(1836),
    [sym__expression] = STATE(1649),
    [sym__primary_expression] = STATE(973),
    [sym_not_operator] = STATE(1649),
    [sym_boolean_operator] = STATE(1649),
    [sym_binary_operator] = STATE(973),
    [sym_unary_operator] = STATE(973),
    [sym_comparison_operator] = STATE(1649),
    [sym_lambda] = STATE(1649),
    [sym_lambda_within_for_in_clause] = STATE(1836),
    [sym_attribute] = STATE(973),
    [sym_subscript] = STATE(973),
    [sym_call] = STATE(973),
    [sym_list] = STATE(973),
    [sym_list_comprehension] = STATE(973),
    [sym_dictionary] = STATE(973),
    [sym_dictionary_comprehension] = STATE(973),
    [sym_set] = STATE(973),
    [sym_set_comprehension] = STATE(973),
    [sym_parenthesized_expression] = STATE(973),
    [sym_tuple] = STATE(973),
    [sym_generator_expression] = STATE(973),
    [sym_conditional_expression] = STATE(1649),
    [sym_concatenated_string] = STATE(973),
    [sym_string] = STATE(974),
    [sym_await] = STATE(1649),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(3975),
    [anon_sym_async] = ACTIONS(3975),
    [anon_sym_for] = ACTIONS(3975),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1814),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_DASH] = ACTIONS(1816),
    [anon_sym_TILDE] = ACTIONS(1816),
    [anon_sym_lambda] = ACTIONS(3502),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1820),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(3969),
    [sym_integer] = ACTIONS(1822),
    [sym_float] = ACTIONS(1822),
    [sym_identifier] = ACTIONS(1822),
    [sym_true] = ACTIONS(1822),
    [sym_false] = ACTIONS(1822),
    [sym_none] = ACTIONS(1822),
    [anon_sym_await] = ACTIONS(1824),
    [sym_comment] = ACTIONS(73),
  },
  [1812] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1899),
    [anon_sym_COMMA] = ACTIONS(4113),
    [anon_sym_if] = ACTIONS(3969),
    [anon_sym_async] = ACTIONS(3969),
    [anon_sym_for] = ACTIONS(3969),
    [anon_sym_RBRACE] = ACTIONS(3969),
    [sym_comment] = ACTIONS(73),
  },
  [1813] = {
    [anon_sym_if] = ACTIONS(4117),
    [anon_sym_async] = ACTIONS(1660),
    [anon_sym_for] = ACTIONS(1660),
    [anon_sym_and] = ACTIONS(3506),
    [anon_sym_or] = ACTIONS(3508),
    [anon_sym_RBRACE] = ACTIONS(1660),
    [sym_comment] = ACTIONS(73),
  },
  [1814] = {
    [sym__expression] = STATE(1900),
    [sym__primary_expression] = STATE(1374),
    [sym_not_operator] = STATE(1900),
    [sym_boolean_operator] = STATE(1900),
    [sym_binary_operator] = STATE(1374),
    [sym_unary_operator] = STATE(1374),
    [sym_comparison_operator] = STATE(1900),
    [sym_lambda] = STATE(1900),
    [sym_attribute] = STATE(1374),
    [sym_subscript] = STATE(1374),
    [sym_call] = STATE(1374),
    [sym_list] = STATE(1374),
    [sym_list_comprehension] = STATE(1374),
    [sym_dictionary] = STATE(1374),
    [sym_dictionary_comprehension] = STATE(1374),
    [sym_set] = STATE(1374),
    [sym_set_comprehension] = STATE(1374),
    [sym_parenthesized_expression] = STATE(1374),
    [sym_tuple] = STATE(1374),
    [sym_generator_expression] = STATE(1374),
    [sym_conditional_expression] = STATE(1900),
    [sym_concatenated_string] = STATE(1374),
    [sym_string] = STATE(1375),
    [sym_await] = STATE(1900),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2828),
    [anon_sym_PLUS] = ACTIONS(2830),
    [anon_sym_DASH] = ACTIONS(2830),
    [anon_sym_TILDE] = ACTIONS(2830),
    [anon_sym_lambda] = ACTIONS(2832),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2834),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2836),
    [sym_float] = ACTIONS(2836),
    [sym_identifier] = ACTIONS(2836),
    [sym_true] = ACTIONS(2836),
    [sym_false] = ACTIONS(2836),
    [sym_none] = ACTIONS(2836),
    [anon_sym_await] = ACTIONS(2838),
    [sym_comment] = ACTIONS(73),
  },
  [1815] = {
    [anon_sym_if] = ACTIONS(1925),
    [anon_sym_else] = ACTIONS(4119),
    [anon_sym_and] = ACTIONS(1929),
    [anon_sym_or] = ACTIONS(1931),
    [sym_comment] = ACTIONS(73),
  },
  [1816] = {
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_async] = ACTIONS(1957),
    [anon_sym_for] = ACTIONS(1957),
    [anon_sym_and] = ACTIONS(3506),
    [anon_sym_or] = ACTIONS(1957),
    [anon_sym_RBRACE] = ACTIONS(1957),
    [sym_comment] = ACTIONS(73),
  },
  [1817] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(1984),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1986),
    [anon_sym_PERCENT] = ACTIONS(1984),
    [anon_sym_SLASH_SLASH] = ACTIONS(1984),
    [anon_sym_STAR_STAR] = ACTIONS(3522),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1818] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(3510),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(3516),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(3520),
    [anon_sym_DASH] = ACTIONS(3520),
    [anon_sym_SLASH] = ACTIONS(3510),
    [anon_sym_PERCENT] = ACTIONS(3516),
    [anon_sym_SLASH_SLASH] = ACTIONS(3516),
    [anon_sym_STAR_STAR] = ACTIONS(3522),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1819] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(3510),
    [anon_sym_GT_GT] = ACTIONS(3512),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_async] = ACTIONS(1988),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(1988),
    [anon_sym_AT] = ACTIONS(3516),
    [anon_sym_not] = ACTIONS(1988),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_PLUS] = ACTIONS(3520),
    [anon_sym_DASH] = ACTIONS(3520),
    [anon_sym_SLASH] = ACTIONS(3510),
    [anon_sym_PERCENT] = ACTIONS(3516),
    [anon_sym_SLASH_SLASH] = ACTIONS(3516),
    [anon_sym_STAR_STAR] = ACTIONS(3522),
    [anon_sym_PIPE] = ACTIONS(3524),
    [anon_sym_AMP] = ACTIONS(3526),
    [anon_sym_CARET] = ACTIONS(3528),
    [anon_sym_LT_LT] = ACTIONS(3512),
    [anon_sym_LT] = ACTIONS(1990),
    [anon_sym_LT_EQ] = ACTIONS(1988),
    [anon_sym_EQ_EQ] = ACTIONS(1988),
    [anon_sym_BANG_EQ] = ACTIONS(1988),
    [anon_sym_GT_EQ] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1990),
    [anon_sym_LT_GT] = ACTIONS(1988),
    [anon_sym_is] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(473),
    [anon_sym_RBRACE] = ACTIONS(1988),
    [sym_comment] = ACTIONS(73),
  },
  [1820] = {
    [sym__primary_expression] = STATE(1902),
    [sym_binary_operator] = STATE(1902),
    [sym_unary_operator] = STATE(1902),
    [sym_attribute] = STATE(1902),
    [sym_subscript] = STATE(1902),
    [sym_call] = STATE(1902),
    [sym_list] = STATE(1902),
    [sym_list_comprehension] = STATE(1902),
    [sym_dictionary] = STATE(1902),
    [sym_dictionary_comprehension] = STATE(1902),
    [sym_set] = STATE(1902),
    [sym_set_comprehension] = STATE(1902),
    [sym_parenthesized_expression] = STATE(1902),
    [sym_tuple] = STATE(1902),
    [sym_generator_expression] = STATE(1902),
    [sym_concatenated_string] = STATE(1902),
    [sym_string] = STATE(1375),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(2830),
    [anon_sym_DASH] = ACTIONS(2830),
    [anon_sym_TILDE] = ACTIONS(2830),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(4121),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(4123),
    [sym_float] = ACTIONS(4123),
    [sym_identifier] = ACTIONS(4123),
    [sym_true] = ACTIONS(4123),
    [sym_false] = ACTIONS(4123),
    [sym_none] = ACTIONS(4123),
    [sym_comment] = ACTIONS(73),
  },
  [1821] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(3510),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(3516),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(3510),
    [anon_sym_PERCENT] = ACTIONS(3516),
    [anon_sym_SLASH_SLASH] = ACTIONS(3516),
    [anon_sym_STAR_STAR] = ACTIONS(3522),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1822] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(3510),
    [anon_sym_GT_GT] = ACTIONS(3512),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(3516),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(3520),
    [anon_sym_DASH] = ACTIONS(3520),
    [anon_sym_SLASH] = ACTIONS(3510),
    [anon_sym_PERCENT] = ACTIONS(3516),
    [anon_sym_SLASH_SLASH] = ACTIONS(3516),
    [anon_sym_STAR_STAR] = ACTIONS(3522),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(3526),
    [anon_sym_CARET] = ACTIONS(3528),
    [anon_sym_LT_LT] = ACTIONS(3512),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1823] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(3510),
    [anon_sym_GT_GT] = ACTIONS(3512),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(3516),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(3520),
    [anon_sym_DASH] = ACTIONS(3520),
    [anon_sym_SLASH] = ACTIONS(3510),
    [anon_sym_PERCENT] = ACTIONS(3516),
    [anon_sym_SLASH_SLASH] = ACTIONS(3516),
    [anon_sym_STAR_STAR] = ACTIONS(3522),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(3528),
    [anon_sym_LT_LT] = ACTIONS(3512),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1824] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(3510),
    [anon_sym_GT_GT] = ACTIONS(3512),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_async] = ACTIONS(1984),
    [anon_sym_for] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_AT] = ACTIONS(3516),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(3520),
    [anon_sym_DASH] = ACTIONS(3520),
    [anon_sym_SLASH] = ACTIONS(3510),
    [anon_sym_PERCENT] = ACTIONS(3516),
    [anon_sym_SLASH_SLASH] = ACTIONS(3516),
    [anon_sym_STAR_STAR] = ACTIONS(3522),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(3512),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [anon_sym_RBRACE] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1825] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1825),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_async] = ACTIONS(1988),
    [anon_sym_for] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(4125),
    [anon_sym_not] = ACTIONS(4128),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(4131),
    [anon_sym_LT_EQ] = ACTIONS(4125),
    [anon_sym_EQ_EQ] = ACTIONS(4125),
    [anon_sym_BANG_EQ] = ACTIONS(4125),
    [anon_sym_GT_EQ] = ACTIONS(4125),
    [anon_sym_GT] = ACTIONS(4131),
    [anon_sym_LT_GT] = ACTIONS(4125),
    [anon_sym_is] = ACTIONS(4134),
    [anon_sym_RBRACE] = ACTIONS(1988),
    [sym_comment] = ACTIONS(73),
  },
  [1826] = {
    [sym_string] = STATE(1826),
    [aux_sym_concatenated_string_repeat1] = STATE(1826),
    [sym__string_start] = ACTIONS(2241),
    [anon_sym_DOT] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2050),
    [anon_sym_if] = ACTIONS(2050),
    [anon_sym_async] = ACTIONS(2050),
    [anon_sym_for] = ACTIONS(2050),
    [anon_sym_in] = ACTIONS(2050),
    [anon_sym_AT] = ACTIONS(2050),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_and] = ACTIONS(2050),
    [anon_sym_or] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_SLASH] = ACTIONS(2055),
    [anon_sym_PERCENT] = ACTIONS(2050),
    [anon_sym_SLASH_SLASH] = ACTIONS(2050),
    [anon_sym_STAR_STAR] = ACTIONS(2050),
    [anon_sym_PIPE] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2050),
    [anon_sym_CARET] = ACTIONS(2050),
    [anon_sym_LT_LT] = ACTIONS(2050),
    [anon_sym_LT] = ACTIONS(2055),
    [anon_sym_LT_EQ] = ACTIONS(2050),
    [anon_sym_EQ_EQ] = ACTIONS(2050),
    [anon_sym_BANG_EQ] = ACTIONS(2050),
    [anon_sym_GT_EQ] = ACTIONS(2050),
    [anon_sym_GT] = ACTIONS(2055),
    [anon_sym_LT_GT] = ACTIONS(2050),
    [anon_sym_is] = ACTIONS(2050),
    [anon_sym_LBRACK] = ACTIONS(2050),
    [anon_sym_RBRACE] = ACTIONS(2050),
    [sym_comment] = ACTIONS(73),
  },
  [1827] = {
    [sym__newline] = ACTIONS(3565),
    [anon_sym_if] = ACTIONS(1881),
    [anon_sym_EQ] = ACTIONS(3565),
    [anon_sym_and] = ACTIONS(1883),
    [anon_sym_or] = ACTIONS(1885),
    [sym_comment] = ACTIONS(73),
    [sym__semicolon] = ACTIONS(3565),
  },
  [1828] = {
    [anon_sym_if] = ACTIONS(1925),
    [anon_sym_else] = ACTIONS(3565),
    [anon_sym_and] = ACTIONS(1929),
    [anon_sym_or] = ACTIONS(1931),
    [sym_comment] = ACTIONS(73),
  },
  [1829] = {
    [anon_sym_COMMA] = ACTIONS(3565),
    [anon_sym_if] = ACTIONS(2004),
    [anon_sym_COLON] = ACTIONS(3565),
    [anon_sym_and] = ACTIONS(2008),
    [anon_sym_or] = ACTIONS(2010),
    [anon_sym_RBRACK] = ACTIONS(3565),
    [sym_comment] = ACTIONS(73),
  },
  [1830] = {
    [anon_sym_COMMA] = ACTIONS(4137),
    [anon_sym_if] = ACTIONS(1686),
    [anon_sym_and] = ACTIONS(1688),
    [anon_sym_or] = ACTIONS(1690),
    [anon_sym_RBRACK] = ACTIONS(4137),
    [sym_comment] = ACTIONS(73),
  },
  [1831] = {
    [sym_aliased_import] = STATE(1685),
    [sym_dotted_name] = STATE(1686),
    [sym_identifier] = ACTIONS(2116),
    [sym_comment] = ACTIONS(73),
  },
  [1832] = {
    [sym__expression_within_for_in_clause] = STATE(1836),
    [sym__expression] = STATE(1459),
    [sym__primary_expression] = STATE(67),
    [sym_not_operator] = STATE(1459),
    [sym_boolean_operator] = STATE(1459),
    [sym_binary_operator] = STATE(67),
    [sym_unary_operator] = STATE(67),
    [sym_comparison_operator] = STATE(1459),
    [sym_lambda] = STATE(1459),
    [sym_lambda_within_for_in_clause] = STATE(1836),
    [sym_attribute] = STATE(67),
    [sym_subscript] = STATE(67),
    [sym_call] = STATE(67),
    [sym_list] = STATE(67),
    [sym_list_comprehension] = STATE(67),
    [sym_dictionary] = STATE(67),
    [sym_dictionary_comprehension] = STATE(67),
    [sym_set] = STATE(67),
    [sym_set_comprehension] = STATE(67),
    [sym_parenthesized_expression] = STATE(67),
    [sym_tuple] = STATE(67),
    [sym_generator_expression] = STATE(67),
    [sym_conditional_expression] = STATE(1459),
    [sym_concatenated_string] = STATE(67),
    [sym_string] = STATE(69),
    [sym_await] = STATE(1459),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(4139),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(4141),
    [anon_sym_async] = ACTIONS(4141),
    [anon_sym_for] = ACTIONS(4141),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(3051),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [1833] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1837),
    [anon_sym_RPAREN] = ACTIONS(4139),
    [anon_sym_COMMA] = ACTIONS(4143),
    [anon_sym_if] = ACTIONS(4139),
    [anon_sym_async] = ACTIONS(4139),
    [anon_sym_for] = ACTIONS(4139),
    [sym_comment] = ACTIONS(73),
  },
  [1834] = {
    [anon_sym_RPAREN] = ACTIONS(4145),
    [anon_sym_COMMA] = ACTIONS(4145),
    [anon_sym_if] = ACTIONS(4145),
    [anon_sym_async] = ACTIONS(4145),
    [anon_sym_for] = ACTIONS(4145),
    [anon_sym_RBRACK] = ACTIONS(4145),
    [anon_sym_RBRACE] = ACTIONS(4145),
    [sym_comment] = ACTIONS(73),
  },
  [1835] = {
    [sym__expression_within_for_in_clause] = STATE(1904),
    [sym__expression] = STATE(1459),
    [sym__primary_expression] = STATE(67),
    [sym_not_operator] = STATE(1459),
    [sym_boolean_operator] = STATE(1459),
    [sym_binary_operator] = STATE(67),
    [sym_unary_operator] = STATE(67),
    [sym_comparison_operator] = STATE(1459),
    [sym_lambda] = STATE(1459),
    [sym_lambda_within_for_in_clause] = STATE(1904),
    [sym_attribute] = STATE(67),
    [sym_subscript] = STATE(67),
    [sym_call] = STATE(67),
    [sym_list] = STATE(67),
    [sym_list_comprehension] = STATE(67),
    [sym_dictionary] = STATE(67),
    [sym_dictionary_comprehension] = STATE(67),
    [sym_set] = STATE(67),
    [sym_set_comprehension] = STATE(67),
    [sym_parenthesized_expression] = STATE(67),
    [sym_tuple] = STATE(67),
    [sym_generator_expression] = STATE(67),
    [sym_conditional_expression] = STATE(1459),
    [sym_concatenated_string] = STATE(67),
    [sym_string] = STATE(69),
    [sym_await] = STATE(1459),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(3051),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [1836] = {
    [anon_sym_RPAREN] = ACTIONS(4147),
    [anon_sym_COMMA] = ACTIONS(4147),
    [anon_sym_if] = ACTIONS(4147),
    [anon_sym_async] = ACTIONS(4147),
    [anon_sym_for] = ACTIONS(4147),
    [anon_sym_RBRACK] = ACTIONS(4147),
    [anon_sym_RBRACE] = ACTIONS(4147),
    [sym_comment] = ACTIONS(73),
  },
  [1837] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1837),
    [anon_sym_RPAREN] = ACTIONS(4147),
    [anon_sym_COMMA] = ACTIONS(4149),
    [anon_sym_if] = ACTIONS(4147),
    [anon_sym_async] = ACTIONS(4147),
    [anon_sym_for] = ACTIONS(4147),
    [sym_comment] = ACTIONS(73),
  },
  [1838] = {
    [anon_sym_RPAREN] = ACTIONS(2647),
    [anon_sym_if] = ACTIONS(3977),
    [anon_sym_async] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2647),
    [anon_sym_and] = ACTIONS(3057),
    [anon_sym_or] = ACTIONS(3059),
    [sym_comment] = ACTIONS(73),
  },
  [1839] = {
    [sym__expression] = STATE(1906),
    [sym__primary_expression] = STATE(1125),
    [sym_not_operator] = STATE(1906),
    [sym_boolean_operator] = STATE(1906),
    [sym_binary_operator] = STATE(1125),
    [sym_unary_operator] = STATE(1125),
    [sym_comparison_operator] = STATE(1906),
    [sym_lambda] = STATE(1906),
    [sym_attribute] = STATE(1125),
    [sym_subscript] = STATE(1125),
    [sym_call] = STATE(1125),
    [sym_list] = STATE(1125),
    [sym_list_comprehension] = STATE(1125),
    [sym_dictionary] = STATE(1125),
    [sym_dictionary_comprehension] = STATE(1125),
    [sym_set] = STATE(1125),
    [sym_set_comprehension] = STATE(1125),
    [sym_parenthesized_expression] = STATE(1125),
    [sym_tuple] = STATE(1125),
    [sym_generator_expression] = STATE(1125),
    [sym_conditional_expression] = STATE(1906),
    [sym_concatenated_string] = STATE(1125),
    [sym_string] = STATE(1126),
    [sym_await] = STATE(1906),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2198),
    [anon_sym_PLUS] = ACTIONS(2200),
    [anon_sym_DASH] = ACTIONS(2200),
    [anon_sym_TILDE] = ACTIONS(2200),
    [anon_sym_lambda] = ACTIONS(2202),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2204),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2206),
    [sym_float] = ACTIONS(2206),
    [sym_identifier] = ACTIONS(2206),
    [sym_true] = ACTIONS(2206),
    [sym_false] = ACTIONS(2206),
    [sym_none] = ACTIONS(2206),
    [anon_sym_await] = ACTIONS(2208),
    [sym_comment] = ACTIONS(73),
  },
  [1840] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(2942),
    [anon_sym_STAR] = ACTIONS(3061),
    [anon_sym_GT_GT] = ACTIONS(3063),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_async] = ACTIONS(2942),
    [anon_sym_for] = ACTIONS(2942),
    [anon_sym_in] = ACTIONS(2942),
    [anon_sym_AT] = ACTIONS(3067),
    [anon_sym_not] = ACTIONS(2942),
    [anon_sym_and] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(3071),
    [anon_sym_DASH] = ACTIONS(3071),
    [anon_sym_SLASH] = ACTIONS(3061),
    [anon_sym_PERCENT] = ACTIONS(3067),
    [anon_sym_SLASH_SLASH] = ACTIONS(3067),
    [anon_sym_STAR_STAR] = ACTIONS(3073),
    [anon_sym_PIPE] = ACTIONS(3075),
    [anon_sym_AMP] = ACTIONS(3077),
    [anon_sym_CARET] = ACTIONS(3079),
    [anon_sym_LT_LT] = ACTIONS(3063),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_LT_EQ] = ACTIONS(2942),
    [anon_sym_EQ_EQ] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_GT_EQ] = ACTIONS(2942),
    [anon_sym_GT] = ACTIONS(2944),
    [anon_sym_LT_GT] = ACTIONS(2942),
    [anon_sym_is] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(473),
    [sym_comment] = ACTIONS(73),
  },
  [1841] = {
    [sym__string_start] = ACTIONS(4152),
    [ts_builtin_sym_end] = ACTIONS(4152),
    [anon_sym_import] = ACTIONS(4154),
    [anon_sym_from] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(4152),
    [anon_sym_print] = ACTIONS(4154),
    [anon_sym_assert] = ACTIONS(4154),
    [anon_sym_return] = ACTIONS(4154),
    [anon_sym_del] = ACTIONS(4154),
    [anon_sym_raise] = ACTIONS(4154),
    [anon_sym_pass] = ACTIONS(4154),
    [anon_sym_break] = ACTIONS(4154),
    [anon_sym_continue] = ACTIONS(4154),
    [anon_sym_if] = ACTIONS(4154),
    [anon_sym_elif] = ACTIONS(4154),
    [anon_sym_else] = ACTIONS(4154),
    [anon_sym_async] = ACTIONS(4154),
    [anon_sym_for] = ACTIONS(4154),
    [anon_sym_while] = ACTIONS(4154),
    [anon_sym_try] = ACTIONS(4154),
    [anon_sym_with] = ACTIONS(4154),
    [anon_sym_def] = ACTIONS(4154),
    [anon_sym_global] = ACTIONS(4154),
    [anon_sym_nonlocal] = ACTIONS(4154),
    [anon_sym_exec] = ACTIONS(4154),
    [anon_sym_class] = ACTIONS(4154),
    [anon_sym_AT] = ACTIONS(4152),
    [anon_sym_not] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4152),
    [anon_sym_DASH] = ACTIONS(4152),
    [anon_sym_TILDE] = ACTIONS(4152),
    [anon_sym_lambda] = ACTIONS(4154),
    [anon_sym_yield] = ACTIONS(4154),
    [anon_sym_LBRACK] = ACTIONS(4152),
    [sym_ellipsis] = ACTIONS(4152),
    [anon_sym_LBRACE] = ACTIONS(4152),
    [sym_integer] = ACTIONS(4154),
    [sym_float] = ACTIONS(4154),
    [sym_identifier] = ACTIONS(4154),
    [sym_true] = ACTIONS(4154),
    [sym_false] = ACTIONS(4154),
    [sym_none] = ACTIONS(4154),
    [anon_sym_await] = ACTIONS(4154),
    [sym_comment] = ACTIONS(73),
  },
  [1842] = {
    [sym__string_start] = ACTIONS(4156),
    [ts_builtin_sym_end] = ACTIONS(4156),
    [anon_sym_import] = ACTIONS(4158),
    [anon_sym_from] = ACTIONS(4158),
    [anon_sym_LPAREN] = ACTIONS(4156),
    [anon_sym_print] = ACTIONS(4158),
    [anon_sym_assert] = ACTIONS(4158),
    [anon_sym_return] = ACTIONS(4158),
    [anon_sym_del] = ACTIONS(4158),
    [anon_sym_raise] = ACTIONS(4158),
    [anon_sym_pass] = ACTIONS(4158),
    [anon_sym_break] = ACTIONS(4158),
    [anon_sym_continue] = ACTIONS(4158),
    [anon_sym_if] = ACTIONS(4158),
    [anon_sym_async] = ACTIONS(4158),
    [anon_sym_for] = ACTIONS(4158),
    [anon_sym_while] = ACTIONS(4158),
    [anon_sym_try] = ACTIONS(4158),
    [anon_sym_with] = ACTIONS(4158),
    [anon_sym_def] = ACTIONS(4158),
    [anon_sym_global] = ACTIONS(4158),
    [anon_sym_nonlocal] = ACTIONS(4158),
    [anon_sym_exec] = ACTIONS(4158),
    [anon_sym_class] = ACTIONS(4158),
    [anon_sym_AT] = ACTIONS(4156),
    [anon_sym_not] = ACTIONS(4158),
    [anon_sym_PLUS] = ACTIONS(4156),
    [anon_sym_DASH] = ACTIONS(4156),
    [anon_sym_TILDE] = ACTIONS(4156),
    [anon_sym_lambda] = ACTIONS(4158),
    [anon_sym_yield] = ACTIONS(4158),
    [anon_sym_LBRACK] = ACTIONS(4156),
    [sym_ellipsis] = ACTIONS(4156),
    [anon_sym_LBRACE] = ACTIONS(4156),
    [sym_integer] = ACTIONS(4158),
    [sym_float] = ACTIONS(4158),
    [sym_identifier] = ACTIONS(4158),
    [sym_true] = ACTIONS(4158),
    [sym_false] = ACTIONS(4158),
    [sym_none] = ACTIONS(4158),
    [anon_sym_await] = ACTIONS(4158),
    [sym_comment] = ACTIONS(73),
  },
  [1843] = {
    [sym__string_start] = ACTIONS(4160),
    [ts_builtin_sym_end] = ACTIONS(4160),
    [anon_sym_import] = ACTIONS(4162),
    [anon_sym_from] = ACTIONS(4162),
    [anon_sym_LPAREN] = ACTIONS(4160),
    [anon_sym_print] = ACTIONS(4162),
    [anon_sym_assert] = ACTIONS(4162),
    [anon_sym_return] = ACTIONS(4162),
    [anon_sym_del] = ACTIONS(4162),
    [anon_sym_raise] = ACTIONS(4162),
    [anon_sym_pass] = ACTIONS(4162),
    [anon_sym_break] = ACTIONS(4162),
    [anon_sym_continue] = ACTIONS(4162),
    [anon_sym_if] = ACTIONS(4162),
    [anon_sym_async] = ACTIONS(4162),
    [anon_sym_for] = ACTIONS(4162),
    [anon_sym_while] = ACTIONS(4162),
    [anon_sym_try] = ACTIONS(4162),
    [anon_sym_with] = ACTIONS(4162),
    [anon_sym_def] = ACTIONS(4162),
    [anon_sym_global] = ACTIONS(4162),
    [anon_sym_nonlocal] = ACTIONS(4162),
    [anon_sym_exec] = ACTIONS(4162),
    [anon_sym_class] = ACTIONS(4162),
    [anon_sym_AT] = ACTIONS(4160),
    [anon_sym_not] = ACTIONS(4162),
    [anon_sym_PLUS] = ACTIONS(4160),
    [anon_sym_DASH] = ACTIONS(4160),
    [anon_sym_TILDE] = ACTIONS(4160),
    [anon_sym_lambda] = ACTIONS(4162),
    [anon_sym_yield] = ACTIONS(4162),
    [anon_sym_LBRACK] = ACTIONS(4160),
    [sym_ellipsis] = ACTIONS(4160),
    [anon_sym_LBRACE] = ACTIONS(4160),
    [sym_integer] = ACTIONS(4162),
    [sym_float] = ACTIONS(4162),
    [sym_identifier] = ACTIONS(4162),
    [sym_true] = ACTIONS(4162),
    [sym_false] = ACTIONS(4162),
    [sym_none] = ACTIONS(4162),
    [anon_sym_await] = ACTIONS(4162),
    [sym_comment] = ACTIONS(73),
  },
  [1844] = {
    [sym__dedent] = ACTIONS(2410),
    [sym__string_start] = ACTIONS(2410),
    [anon_sym_import] = ACTIONS(3142),
    [anon_sym_from] = ACTIONS(3142),
    [anon_sym_LPAREN] = ACTIONS(2410),
    [anon_sym_print] = ACTIONS(3142),
    [anon_sym_assert] = ACTIONS(3142),
    [anon_sym_return] = ACTIONS(3142),
    [anon_sym_del] = ACTIONS(3142),
    [anon_sym_raise] = ACTIONS(3142),
    [anon_sym_pass] = ACTIONS(3142),
    [anon_sym_break] = ACTIONS(3142),
    [anon_sym_continue] = ACTIONS(3142),
    [anon_sym_if] = ACTIONS(3142),
    [anon_sym_elif] = ACTIONS(3142),
    [anon_sym_else] = ACTIONS(3142),
    [anon_sym_async] = ACTIONS(3142),
    [anon_sym_for] = ACTIONS(3142),
    [anon_sym_while] = ACTIONS(3142),
    [anon_sym_try] = ACTIONS(3142),
    [anon_sym_except] = ACTIONS(3142),
    [anon_sym_finally] = ACTIONS(3142),
    [anon_sym_with] = ACTIONS(3142),
    [anon_sym_def] = ACTIONS(3142),
    [anon_sym_global] = ACTIONS(3142),
    [anon_sym_nonlocal] = ACTIONS(3142),
    [anon_sym_exec] = ACTIONS(3142),
    [anon_sym_class] = ACTIONS(3142),
    [anon_sym_AT] = ACTIONS(2410),
    [anon_sym_not] = ACTIONS(3142),
    [anon_sym_PLUS] = ACTIONS(2410),
    [anon_sym_DASH] = ACTIONS(2410),
    [anon_sym_TILDE] = ACTIONS(2410),
    [anon_sym_lambda] = ACTIONS(3142),
    [anon_sym_yield] = ACTIONS(3142),
    [anon_sym_LBRACK] = ACTIONS(2410),
    [sym_ellipsis] = ACTIONS(2410),
    [anon_sym_LBRACE] = ACTIONS(2410),
    [sym_integer] = ACTIONS(3142),
    [sym_float] = ACTIONS(3142),
    [sym_identifier] = ACTIONS(3142),
    [sym_true] = ACTIONS(3142),
    [sym_false] = ACTIONS(3142),
    [sym_none] = ACTIONS(3142),
    [anon_sym_await] = ACTIONS(3142),
    [sym_comment] = ACTIONS(73),
  },
  [1845] = {
    [sym__statement] = STATE(1209),
    [sym__simple_statements] = STATE(1209),
    [sym_import_statement] = STATE(799),
    [sym_future_import_statement] = STATE(799),
    [sym_import_from_statement] = STATE(799),
    [sym_print_statement] = STATE(799),
    [sym_assert_statement] = STATE(799),
    [sym_expression_statement] = STATE(799),
    [sym_return_statement] = STATE(799),
    [sym_delete_statement] = STATE(799),
    [sym_raise_statement] = STATE(799),
    [sym_pass_statement] = STATE(799),
    [sym_break_statement] = STATE(799),
    [sym_continue_statement] = STATE(799),
    [sym_if_statement] = STATE(1209),
    [sym_for_statement] = STATE(1209),
    [sym_while_statement] = STATE(1209),
    [sym_try_statement] = STATE(1209),
    [sym_with_statement] = STATE(1209),
    [sym_function_definition] = STATE(1209),
    [sym_global_statement] = STATE(799),
    [sym_nonlocal_statement] = STATE(799),
    [sym_exec_statement] = STATE(799),
    [sym_class_definition] = STATE(1209),
    [sym_decorated_definition] = STATE(1209),
    [sym_decorator] = STATE(801),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [aux_sym_module_repeat1] = STATE(1209),
    [aux_sym_decorated_definition_repeat1] = STATE(801),
    [sym__dedent] = ACTIONS(4164),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_if] = ACTIONS(1522),
    [anon_sym_async] = ACTIONS(1524),
    [anon_sym_for] = ACTIONS(1526),
    [anon_sym_while] = ACTIONS(1528),
    [anon_sym_try] = ACTIONS(1530),
    [anon_sym_with] = ACTIONS(1532),
    [anon_sym_def] = ACTIONS(1534),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_class] = ACTIONS(1536),
    [anon_sym_AT] = ACTIONS(53),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1846] = {
    [sym__expression] = STATE(1908),
    [sym__primary_expression] = STATE(102),
    [sym_not_operator] = STATE(1908),
    [sym_boolean_operator] = STATE(1908),
    [sym_binary_operator] = STATE(102),
    [sym_unary_operator] = STATE(102),
    [sym_comparison_operator] = STATE(1908),
    [sym_lambda] = STATE(1908),
    [sym_attribute] = STATE(102),
    [sym_subscript] = STATE(102),
    [sym_call] = STATE(102),
    [sym_list] = STATE(102),
    [sym_list_comprehension] = STATE(102),
    [sym_dictionary] = STATE(102),
    [sym_dictionary_comprehension] = STATE(102),
    [sym_set] = STATE(102),
    [sym_set_comprehension] = STATE(102),
    [sym_parenthesized_expression] = STATE(102),
    [sym_tuple] = STATE(102),
    [sym_generator_expression] = STATE(102),
    [sym_conditional_expression] = STATE(1908),
    [sym_concatenated_string] = STATE(102),
    [sym_string] = STATE(103),
    [sym_await] = STATE(1908),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [1847] = {
    [anon_sym_COLON] = ACTIONS(4166),
    [sym_comment] = ACTIONS(73),
  },
  [1848] = {
    [sym__dedent] = ACTIONS(3148),
    [sym__string_start] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_from] = ACTIONS(3150),
    [anon_sym_LPAREN] = ACTIONS(3148),
    [anon_sym_print] = ACTIONS(3150),
    [anon_sym_assert] = ACTIONS(3150),
    [anon_sym_return] = ACTIONS(3150),
    [anon_sym_del] = ACTIONS(3150),
    [anon_sym_raise] = ACTIONS(3150),
    [anon_sym_pass] = ACTIONS(3150),
    [anon_sym_break] = ACTIONS(3150),
    [anon_sym_continue] = ACTIONS(3150),
    [anon_sym_if] = ACTIONS(3150),
    [anon_sym_async] = ACTIONS(3150),
    [anon_sym_for] = ACTIONS(3150),
    [anon_sym_while] = ACTIONS(3150),
    [anon_sym_try] = ACTIONS(3150),
    [anon_sym_with] = ACTIONS(3150),
    [anon_sym_def] = ACTIONS(3150),
    [anon_sym_global] = ACTIONS(3150),
    [anon_sym_nonlocal] = ACTIONS(3150),
    [anon_sym_exec] = ACTIONS(3150),
    [anon_sym_class] = ACTIONS(3150),
    [anon_sym_AT] = ACTIONS(3148),
    [anon_sym_not] = ACTIONS(3150),
    [anon_sym_PLUS] = ACTIONS(3148),
    [anon_sym_DASH] = ACTIONS(3148),
    [anon_sym_TILDE] = ACTIONS(3148),
    [anon_sym_lambda] = ACTIONS(3150),
    [anon_sym_yield] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [sym_ellipsis] = ACTIONS(3148),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [sym_integer] = ACTIONS(3150),
    [sym_float] = ACTIONS(3150),
    [sym_identifier] = ACTIONS(3150),
    [sym_true] = ACTIONS(3150),
    [sym_false] = ACTIONS(3150),
    [sym_none] = ACTIONS(3150),
    [anon_sym_await] = ACTIONS(3150),
    [sym_comment] = ACTIONS(73),
  },
  [1849] = {
    [sym_elif_clause] = STATE(1911),
    [sym_else_clause] = STATE(1910),
    [aux_sym_if_statement_repeat1] = STATE(1911),
    [sym__dedent] = ACTIONS(3148),
    [sym__string_start] = ACTIONS(3148),
    [anon_sym_import] = ACTIONS(3150),
    [anon_sym_from] = ACTIONS(3150),
    [anon_sym_LPAREN] = ACTIONS(3148),
    [anon_sym_print] = ACTIONS(3150),
    [anon_sym_assert] = ACTIONS(3150),
    [anon_sym_return] = ACTIONS(3150),
    [anon_sym_del] = ACTIONS(3150),
    [anon_sym_raise] = ACTIONS(3150),
    [anon_sym_pass] = ACTIONS(3150),
    [anon_sym_break] = ACTIONS(3150),
    [anon_sym_continue] = ACTIONS(3150),
    [anon_sym_if] = ACTIONS(3150),
    [anon_sym_elif] = ACTIONS(4007),
    [anon_sym_else] = ACTIONS(4009),
    [anon_sym_async] = ACTIONS(3150),
    [anon_sym_for] = ACTIONS(3150),
    [anon_sym_while] = ACTIONS(3150),
    [anon_sym_try] = ACTIONS(3150),
    [anon_sym_with] = ACTIONS(3150),
    [anon_sym_def] = ACTIONS(3150),
    [anon_sym_global] = ACTIONS(3150),
    [anon_sym_nonlocal] = ACTIONS(3150),
    [anon_sym_exec] = ACTIONS(3150),
    [anon_sym_class] = ACTIONS(3150),
    [anon_sym_AT] = ACTIONS(3148),
    [anon_sym_not] = ACTIONS(3150),
    [anon_sym_PLUS] = ACTIONS(3148),
    [anon_sym_DASH] = ACTIONS(3148),
    [anon_sym_TILDE] = ACTIONS(3148),
    [anon_sym_lambda] = ACTIONS(3150),
    [anon_sym_yield] = ACTIONS(3150),
    [anon_sym_LBRACK] = ACTIONS(3148),
    [sym_ellipsis] = ACTIONS(3148),
    [anon_sym_LBRACE] = ACTIONS(3148),
    [sym_integer] = ACTIONS(3150),
    [sym_float] = ACTIONS(3150),
    [sym_identifier] = ACTIONS(3150),
    [sym_true] = ACTIONS(3150),
    [sym_false] = ACTIONS(3150),
    [sym_none] = ACTIONS(3150),
    [anon_sym_await] = ACTIONS(3150),
    [sym_comment] = ACTIONS(73),
  },
  [1850] = {
    [anon_sym_COLON] = ACTIONS(4168),
    [sym_comment] = ACTIONS(73),
  },
  [1851] = {
    [sym__dedent] = ACTIONS(3154),
    [sym__string_start] = ACTIONS(3154),
    [anon_sym_import] = ACTIONS(3156),
    [anon_sym_from] = ACTIONS(3156),
    [anon_sym_LPAREN] = ACTIONS(3154),
    [anon_sym_print] = ACTIONS(3156),
    [anon_sym_assert] = ACTIONS(3156),
    [anon_sym_return] = ACTIONS(3156),
    [anon_sym_del] = ACTIONS(3156),
    [anon_sym_raise] = ACTIONS(3156),
    [anon_sym_pass] = ACTIONS(3156),
    [anon_sym_break] = ACTIONS(3156),
    [anon_sym_continue] = ACTIONS(3156),
    [anon_sym_if] = ACTIONS(3156),
    [anon_sym_async] = ACTIONS(3156),
    [anon_sym_for] = ACTIONS(3156),
    [anon_sym_while] = ACTIONS(3156),
    [anon_sym_try] = ACTIONS(3156),
    [anon_sym_with] = ACTIONS(3156),
    [anon_sym_def] = ACTIONS(3156),
    [anon_sym_global] = ACTIONS(3156),
    [anon_sym_nonlocal] = ACTIONS(3156),
    [anon_sym_exec] = ACTIONS(3156),
    [anon_sym_class] = ACTIONS(3156),
    [anon_sym_AT] = ACTIONS(3154),
    [anon_sym_not] = ACTIONS(3156),
    [anon_sym_PLUS] = ACTIONS(3154),
    [anon_sym_DASH] = ACTIONS(3154),
    [anon_sym_TILDE] = ACTIONS(3154),
    [anon_sym_lambda] = ACTIONS(3156),
    [anon_sym_yield] = ACTIONS(3156),
    [anon_sym_LBRACK] = ACTIONS(3154),
    [sym_ellipsis] = ACTIONS(3154),
    [anon_sym_LBRACE] = ACTIONS(3154),
    [sym_integer] = ACTIONS(3156),
    [sym_float] = ACTIONS(3156),
    [sym_identifier] = ACTIONS(3156),
    [sym_true] = ACTIONS(3156),
    [sym_false] = ACTIONS(3156),
    [sym_none] = ACTIONS(3156),
    [anon_sym_await] = ACTIONS(3156),
    [sym_comment] = ACTIONS(73),
  },
  [1852] = {
    [sym__simple_statements] = STATE(1913),
    [sym_import_statement] = STATE(799),
    [sym_future_import_statement] = STATE(799),
    [sym_import_from_statement] = STATE(799),
    [sym_print_statement] = STATE(799),
    [sym_assert_statement] = STATE(799),
    [sym_expression_statement] = STATE(799),
    [sym_return_statement] = STATE(799),
    [sym_delete_statement] = STATE(799),
    [sym_raise_statement] = STATE(799),
    [sym_pass_statement] = STATE(799),
    [sym_break_statement] = STATE(799),
    [sym_continue_statement] = STATE(799),
    [sym_global_statement] = STATE(799),
    [sym_nonlocal_statement] = STATE(799),
    [sym_exec_statement] = STATE(799),
    [sym__suite] = STATE(1913),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(3719),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1853] = {
    [sym__simple_statements] = STATE(1914),
    [sym_import_statement] = STATE(799),
    [sym_future_import_statement] = STATE(799),
    [sym_import_from_statement] = STATE(799),
    [sym_print_statement] = STATE(799),
    [sym_assert_statement] = STATE(799),
    [sym_expression_statement] = STATE(799),
    [sym_return_statement] = STATE(799),
    [sym_delete_statement] = STATE(799),
    [sym_raise_statement] = STATE(799),
    [sym_pass_statement] = STATE(799),
    [sym_break_statement] = STATE(799),
    [sym_continue_statement] = STATE(799),
    [sym_global_statement] = STATE(799),
    [sym_nonlocal_statement] = STATE(799),
    [sym_exec_statement] = STATE(799),
    [sym__suite] = STATE(1914),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(3719),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1854] = {
    [sym__expression] = STATE(1242),
    [sym__primary_expression] = STATE(102),
    [sym_not_operator] = STATE(1242),
    [sym_boolean_operator] = STATE(1242),
    [sym_binary_operator] = STATE(102),
    [sym_unary_operator] = STATE(102),
    [sym_comparison_operator] = STATE(1242),
    [sym_lambda] = STATE(1242),
    [sym_attribute] = STATE(102),
    [sym_subscript] = STATE(102),
    [sym_call] = STATE(102),
    [sym_type] = STATE(1915),
    [sym_list] = STATE(102),
    [sym_list_comprehension] = STATE(102),
    [sym_dictionary] = STATE(102),
    [sym_dictionary_comprehension] = STATE(102),
    [sym_set] = STATE(102),
    [sym_set_comprehension] = STATE(102),
    [sym_parenthesized_expression] = STATE(102),
    [sym_tuple] = STATE(102),
    [sym_generator_expression] = STATE(102),
    [sym_conditional_expression] = STATE(1242),
    [sym_concatenated_string] = STATE(102),
    [sym_string] = STATE(103),
    [sym_await] = STATE(1242),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [1855] = {
    [sym__simple_statements] = STATE(1916),
    [sym_import_statement] = STATE(799),
    [sym_future_import_statement] = STATE(799),
    [sym_import_from_statement] = STATE(799),
    [sym_print_statement] = STATE(799),
    [sym_assert_statement] = STATE(799),
    [sym_expression_statement] = STATE(799),
    [sym_return_statement] = STATE(799),
    [sym_delete_statement] = STATE(799),
    [sym_raise_statement] = STATE(799),
    [sym_pass_statement] = STATE(799),
    [sym_break_statement] = STATE(799),
    [sym_continue_statement] = STATE(799),
    [sym_global_statement] = STATE(799),
    [sym_nonlocal_statement] = STATE(799),
    [sym_exec_statement] = STATE(799),
    [sym__suite] = STATE(1916),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(3719),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1856] = {
    [sym__dedent] = ACTIONS(3160),
    [sym__string_start] = ACTIONS(3160),
    [anon_sym_import] = ACTIONS(3162),
    [anon_sym_from] = ACTIONS(3162),
    [anon_sym_LPAREN] = ACTIONS(3160),
    [anon_sym_print] = ACTIONS(3162),
    [anon_sym_assert] = ACTIONS(3162),
    [anon_sym_return] = ACTIONS(3162),
    [anon_sym_del] = ACTIONS(3162),
    [anon_sym_raise] = ACTIONS(3162),
    [anon_sym_pass] = ACTIONS(3162),
    [anon_sym_break] = ACTIONS(3162),
    [anon_sym_continue] = ACTIONS(3162),
    [anon_sym_if] = ACTIONS(3162),
    [anon_sym_async] = ACTIONS(3162),
    [anon_sym_for] = ACTIONS(3162),
    [anon_sym_while] = ACTIONS(3162),
    [anon_sym_try] = ACTIONS(3162),
    [anon_sym_with] = ACTIONS(3162),
    [anon_sym_def] = ACTIONS(3162),
    [anon_sym_global] = ACTIONS(3162),
    [anon_sym_nonlocal] = ACTIONS(3162),
    [anon_sym_exec] = ACTIONS(3162),
    [anon_sym_class] = ACTIONS(3162),
    [anon_sym_AT] = ACTIONS(3160),
    [anon_sym_not] = ACTIONS(3162),
    [anon_sym_PLUS] = ACTIONS(3160),
    [anon_sym_DASH] = ACTIONS(3160),
    [anon_sym_TILDE] = ACTIONS(3160),
    [anon_sym_lambda] = ACTIONS(3162),
    [anon_sym_yield] = ACTIONS(3162),
    [anon_sym_LBRACK] = ACTIONS(3160),
    [sym_ellipsis] = ACTIONS(3160),
    [anon_sym_LBRACE] = ACTIONS(3160),
    [sym_integer] = ACTIONS(3162),
    [sym_float] = ACTIONS(3162),
    [sym_identifier] = ACTIONS(3162),
    [sym_true] = ACTIONS(3162),
    [sym_false] = ACTIONS(3162),
    [sym_none] = ACTIONS(3162),
    [anon_sym_await] = ACTIONS(3162),
    [sym_comment] = ACTIONS(73),
  },
  [1857] = {
    [sym__simple_statements] = STATE(1917),
    [sym_import_statement] = STATE(799),
    [sym_future_import_statement] = STATE(799),
    [sym_import_from_statement] = STATE(799),
    [sym_print_statement] = STATE(799),
    [sym_assert_statement] = STATE(799),
    [sym_expression_statement] = STATE(799),
    [sym_return_statement] = STATE(799),
    [sym_delete_statement] = STATE(799),
    [sym_raise_statement] = STATE(799),
    [sym_pass_statement] = STATE(799),
    [sym_break_statement] = STATE(799),
    [sym_continue_statement] = STATE(799),
    [sym_global_statement] = STATE(799),
    [sym_nonlocal_statement] = STATE(799),
    [sym_exec_statement] = STATE(799),
    [sym__suite] = STATE(1917),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(3719),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1858] = {
    [anon_sym_COMMA] = ACTIONS(4170),
    [anon_sym_as] = ACTIONS(4170),
    [anon_sym_if] = ACTIONS(669),
    [anon_sym_COLON] = ACTIONS(4172),
    [anon_sym_and] = ACTIONS(671),
    [anon_sym_or] = ACTIONS(673),
    [sym_comment] = ACTIONS(73),
  },
  [1859] = {
    [sym__simple_statements] = STATE(1920),
    [sym_import_statement] = STATE(799),
    [sym_future_import_statement] = STATE(799),
    [sym_import_from_statement] = STATE(799),
    [sym_print_statement] = STATE(799),
    [sym_assert_statement] = STATE(799),
    [sym_expression_statement] = STATE(799),
    [sym_return_statement] = STATE(799),
    [sym_delete_statement] = STATE(799),
    [sym_raise_statement] = STATE(799),
    [sym_pass_statement] = STATE(799),
    [sym_break_statement] = STATE(799),
    [sym_continue_statement] = STATE(799),
    [sym_global_statement] = STATE(799),
    [sym_nonlocal_statement] = STATE(799),
    [sym_exec_statement] = STATE(799),
    [sym__suite] = STATE(1920),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(3719),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1860] = {
    [sym_finally_clause] = STATE(1921),
    [sym__dedent] = ACTIONS(3212),
    [sym__string_start] = ACTIONS(3212),
    [anon_sym_import] = ACTIONS(3214),
    [anon_sym_from] = ACTIONS(3214),
    [anon_sym_LPAREN] = ACTIONS(3212),
    [anon_sym_print] = ACTIONS(3214),
    [anon_sym_assert] = ACTIONS(3214),
    [anon_sym_return] = ACTIONS(3214),
    [anon_sym_del] = ACTIONS(3214),
    [anon_sym_raise] = ACTIONS(3214),
    [anon_sym_pass] = ACTIONS(3214),
    [anon_sym_break] = ACTIONS(3214),
    [anon_sym_continue] = ACTIONS(3214),
    [anon_sym_if] = ACTIONS(3214),
    [anon_sym_async] = ACTIONS(3214),
    [anon_sym_for] = ACTIONS(3214),
    [anon_sym_while] = ACTIONS(3214),
    [anon_sym_try] = ACTIONS(3214),
    [anon_sym_finally] = ACTIONS(4025),
    [anon_sym_with] = ACTIONS(3214),
    [anon_sym_def] = ACTIONS(3214),
    [anon_sym_global] = ACTIONS(3214),
    [anon_sym_nonlocal] = ACTIONS(3214),
    [anon_sym_exec] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3214),
    [anon_sym_AT] = ACTIONS(3212),
    [anon_sym_not] = ACTIONS(3214),
    [anon_sym_PLUS] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [anon_sym_lambda] = ACTIONS(3214),
    [anon_sym_yield] = ACTIONS(3214),
    [anon_sym_LBRACK] = ACTIONS(3212),
    [sym_ellipsis] = ACTIONS(3212),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [sym_integer] = ACTIONS(3214),
    [sym_float] = ACTIONS(3214),
    [sym_identifier] = ACTIONS(3214),
    [sym_true] = ACTIONS(3214),
    [sym_false] = ACTIONS(3214),
    [sym_none] = ACTIONS(3214),
    [anon_sym_await] = ACTIONS(3214),
    [sym_comment] = ACTIONS(73),
  },
  [1861] = {
    [sym__dedent] = ACTIONS(3212),
    [sym__string_start] = ACTIONS(3212),
    [anon_sym_import] = ACTIONS(3214),
    [anon_sym_from] = ACTIONS(3214),
    [anon_sym_LPAREN] = ACTIONS(3212),
    [anon_sym_print] = ACTIONS(3214),
    [anon_sym_assert] = ACTIONS(3214),
    [anon_sym_return] = ACTIONS(3214),
    [anon_sym_del] = ACTIONS(3214),
    [anon_sym_raise] = ACTIONS(3214),
    [anon_sym_pass] = ACTIONS(3214),
    [anon_sym_break] = ACTIONS(3214),
    [anon_sym_continue] = ACTIONS(3214),
    [anon_sym_if] = ACTIONS(3214),
    [anon_sym_async] = ACTIONS(3214),
    [anon_sym_for] = ACTIONS(3214),
    [anon_sym_while] = ACTIONS(3214),
    [anon_sym_try] = ACTIONS(3214),
    [anon_sym_with] = ACTIONS(3214),
    [anon_sym_def] = ACTIONS(3214),
    [anon_sym_global] = ACTIONS(3214),
    [anon_sym_nonlocal] = ACTIONS(3214),
    [anon_sym_exec] = ACTIONS(3214),
    [anon_sym_class] = ACTIONS(3214),
    [anon_sym_AT] = ACTIONS(3212),
    [anon_sym_not] = ACTIONS(3214),
    [anon_sym_PLUS] = ACTIONS(3212),
    [anon_sym_DASH] = ACTIONS(3212),
    [anon_sym_TILDE] = ACTIONS(3212),
    [anon_sym_lambda] = ACTIONS(3214),
    [anon_sym_yield] = ACTIONS(3214),
    [anon_sym_LBRACK] = ACTIONS(3212),
    [sym_ellipsis] = ACTIONS(3212),
    [anon_sym_LBRACE] = ACTIONS(3212),
    [sym_integer] = ACTIONS(3214),
    [sym_float] = ACTIONS(3214),
    [sym_identifier] = ACTIONS(3214),
    [sym_true] = ACTIONS(3214),
    [sym_false] = ACTIONS(3214),
    [sym_none] = ACTIONS(3214),
    [anon_sym_await] = ACTIONS(3214),
    [sym_comment] = ACTIONS(73),
  },
  [1862] = {
    [sym_except_clause] = STATE(1862),
    [aux_sym_try_statement_repeat1] = STATE(1862),
    [sym__dedent] = ACTIONS(3216),
    [sym__string_start] = ACTIONS(3216),
    [anon_sym_import] = ACTIONS(3218),
    [anon_sym_from] = ACTIONS(3218),
    [anon_sym_LPAREN] = ACTIONS(3216),
    [anon_sym_print] = ACTIONS(3218),
    [anon_sym_assert] = ACTIONS(3218),
    [anon_sym_return] = ACTIONS(3218),
    [anon_sym_del] = ACTIONS(3218),
    [anon_sym_raise] = ACTIONS(3218),
    [anon_sym_pass] = ACTIONS(3218),
    [anon_sym_break] = ACTIONS(3218),
    [anon_sym_continue] = ACTIONS(3218),
    [anon_sym_if] = ACTIONS(3218),
    [anon_sym_else] = ACTIONS(3218),
    [anon_sym_async] = ACTIONS(3218),
    [anon_sym_for] = ACTIONS(3218),
    [anon_sym_while] = ACTIONS(3218),
    [anon_sym_try] = ACTIONS(3218),
    [anon_sym_except] = ACTIONS(4174),
    [anon_sym_finally] = ACTIONS(3218),
    [anon_sym_with] = ACTIONS(3218),
    [anon_sym_def] = ACTIONS(3218),
    [anon_sym_global] = ACTIONS(3218),
    [anon_sym_nonlocal] = ACTIONS(3218),
    [anon_sym_exec] = ACTIONS(3218),
    [anon_sym_class] = ACTIONS(3218),
    [anon_sym_AT] = ACTIONS(3216),
    [anon_sym_not] = ACTIONS(3218),
    [anon_sym_PLUS] = ACTIONS(3216),
    [anon_sym_DASH] = ACTIONS(3216),
    [anon_sym_TILDE] = ACTIONS(3216),
    [anon_sym_lambda] = ACTIONS(3218),
    [anon_sym_yield] = ACTIONS(3218),
    [anon_sym_LBRACK] = ACTIONS(3216),
    [sym_ellipsis] = ACTIONS(3216),
    [anon_sym_LBRACE] = ACTIONS(3216),
    [sym_integer] = ACTIONS(3218),
    [sym_float] = ACTIONS(3218),
    [sym_identifier] = ACTIONS(3218),
    [sym_true] = ACTIONS(3218),
    [sym_false] = ACTIONS(3218),
    [sym_none] = ACTIONS(3218),
    [anon_sym_await] = ACTIONS(3218),
    [sym_comment] = ACTIONS(73),
  },
  [1863] = {
    [sym__dedent] = ACTIONS(3277),
    [sym__string_start] = ACTIONS(3277),
    [anon_sym_import] = ACTIONS(3279),
    [anon_sym_from] = ACTIONS(3279),
    [anon_sym_LPAREN] = ACTIONS(3277),
    [anon_sym_print] = ACTIONS(3279),
    [anon_sym_assert] = ACTIONS(3279),
    [anon_sym_return] = ACTIONS(3279),
    [anon_sym_del] = ACTIONS(3279),
    [anon_sym_raise] = ACTIONS(3279),
    [anon_sym_pass] = ACTIONS(3279),
    [anon_sym_break] = ACTIONS(3279),
    [anon_sym_continue] = ACTIONS(3279),
    [anon_sym_if] = ACTIONS(3279),
    [anon_sym_async] = ACTIONS(3279),
    [anon_sym_for] = ACTIONS(3279),
    [anon_sym_while] = ACTIONS(3279),
    [anon_sym_try] = ACTIONS(3279),
    [anon_sym_with] = ACTIONS(3279),
    [anon_sym_def] = ACTIONS(3279),
    [anon_sym_global] = ACTIONS(3279),
    [anon_sym_nonlocal] = ACTIONS(3279),
    [anon_sym_exec] = ACTIONS(3279),
    [anon_sym_class] = ACTIONS(3279),
    [anon_sym_AT] = ACTIONS(3277),
    [anon_sym_not] = ACTIONS(3279),
    [anon_sym_PLUS] = ACTIONS(3277),
    [anon_sym_DASH] = ACTIONS(3277),
    [anon_sym_TILDE] = ACTIONS(3277),
    [anon_sym_lambda] = ACTIONS(3279),
    [anon_sym_yield] = ACTIONS(3279),
    [anon_sym_LBRACK] = ACTIONS(3277),
    [sym_ellipsis] = ACTIONS(3277),
    [anon_sym_LBRACE] = ACTIONS(3277),
    [sym_integer] = ACTIONS(3279),
    [sym_float] = ACTIONS(3279),
    [sym_identifier] = ACTIONS(3279),
    [sym_true] = ACTIONS(3279),
    [sym_false] = ACTIONS(3279),
    [sym_none] = ACTIONS(3279),
    [anon_sym_await] = ACTIONS(3279),
    [sym_comment] = ACTIONS(73),
  },
  [1864] = {
    [anon_sym_COLON] = ACTIONS(4177),
    [sym_comment] = ACTIONS(73),
  },
  [1865] = {
    [sym__dedent] = ACTIONS(3285),
    [sym__string_start] = ACTIONS(3285),
    [anon_sym_import] = ACTIONS(3287),
    [anon_sym_from] = ACTIONS(3287),
    [anon_sym_LPAREN] = ACTIONS(3285),
    [anon_sym_print] = ACTIONS(3287),
    [anon_sym_assert] = ACTIONS(3287),
    [anon_sym_return] = ACTIONS(3287),
    [anon_sym_del] = ACTIONS(3287),
    [anon_sym_raise] = ACTIONS(3287),
    [anon_sym_pass] = ACTIONS(3287),
    [anon_sym_break] = ACTIONS(3287),
    [anon_sym_continue] = ACTIONS(3287),
    [anon_sym_if] = ACTIONS(3287),
    [anon_sym_async] = ACTIONS(3287),
    [anon_sym_for] = ACTIONS(3287),
    [anon_sym_while] = ACTIONS(3287),
    [anon_sym_try] = ACTIONS(3287),
    [anon_sym_with] = ACTIONS(3287),
    [anon_sym_def] = ACTIONS(3287),
    [anon_sym_global] = ACTIONS(3287),
    [anon_sym_nonlocal] = ACTIONS(3287),
    [anon_sym_exec] = ACTIONS(3287),
    [anon_sym_class] = ACTIONS(3287),
    [anon_sym_AT] = ACTIONS(3285),
    [anon_sym_not] = ACTIONS(3287),
    [anon_sym_PLUS] = ACTIONS(3285),
    [anon_sym_DASH] = ACTIONS(3285),
    [anon_sym_TILDE] = ACTIONS(3285),
    [anon_sym_lambda] = ACTIONS(3287),
    [anon_sym_yield] = ACTIONS(3287),
    [anon_sym_LBRACK] = ACTIONS(3285),
    [sym_ellipsis] = ACTIONS(3285),
    [anon_sym_LBRACE] = ACTIONS(3285),
    [sym_integer] = ACTIONS(3287),
    [sym_float] = ACTIONS(3287),
    [sym_identifier] = ACTIONS(3287),
    [sym_true] = ACTIONS(3287),
    [sym_false] = ACTIONS(3287),
    [sym_none] = ACTIONS(3287),
    [anon_sym_await] = ACTIONS(3287),
    [sym_comment] = ACTIONS(73),
  },
  [1866] = {
    [sym__simple_statements] = STATE(1923),
    [sym_import_statement] = STATE(34),
    [sym_future_import_statement] = STATE(34),
    [sym_import_from_statement] = STATE(34),
    [sym_print_statement] = STATE(34),
    [sym_assert_statement] = STATE(34),
    [sym_expression_statement] = STATE(34),
    [sym_return_statement] = STATE(34),
    [sym_delete_statement] = STATE(34),
    [sym_raise_statement] = STATE(34),
    [sym_pass_statement] = STATE(34),
    [sym_break_statement] = STATE(34),
    [sym_continue_statement] = STATE(34),
    [sym_global_statement] = STATE(34),
    [sym_nonlocal_statement] = STATE(34),
    [sym_exec_statement] = STATE(34),
    [sym__suite] = STATE(1923),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(1448),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1867] = {
    [anon_sym_RPAREN] = ACTIONS(2647),
    [anon_sym_COMMA] = ACTIONS(2647),
    [anon_sym_if] = ACTIONS(3225),
    [anon_sym_COLON] = ACTIONS(2647),
    [anon_sym_and] = ACTIONS(3227),
    [anon_sym_or] = ACTIONS(3229),
    [sym_comment] = ACTIONS(73),
  },
  [1868] = {
    [sym__expression] = STATE(1924),
    [sym__primary_expression] = STATE(1229),
    [sym_not_operator] = STATE(1924),
    [sym_boolean_operator] = STATE(1924),
    [sym_binary_operator] = STATE(1229),
    [sym_unary_operator] = STATE(1229),
    [sym_comparison_operator] = STATE(1924),
    [sym_lambda] = STATE(1924),
    [sym_attribute] = STATE(1229),
    [sym_subscript] = STATE(1229),
    [sym_call] = STATE(1229),
    [sym_list] = STATE(1229),
    [sym_list_comprehension] = STATE(1229),
    [sym_dictionary] = STATE(1229),
    [sym_dictionary_comprehension] = STATE(1229),
    [sym_set] = STATE(1229),
    [sym_set_comprehension] = STATE(1229),
    [sym_parenthesized_expression] = STATE(1229),
    [sym_tuple] = STATE(1229),
    [sym_generator_expression] = STATE(1229),
    [sym_conditional_expression] = STATE(1924),
    [sym_concatenated_string] = STATE(1229),
    [sym_string] = STATE(1230),
    [sym_await] = STATE(1924),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2485),
    [anon_sym_PLUS] = ACTIONS(2487),
    [anon_sym_DASH] = ACTIONS(2487),
    [anon_sym_TILDE] = ACTIONS(2487),
    [anon_sym_lambda] = ACTIONS(2489),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2491),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2493),
    [sym_float] = ACTIONS(2493),
    [sym_identifier] = ACTIONS(2493),
    [sym_true] = ACTIONS(2493),
    [sym_false] = ACTIONS(2493),
    [sym_none] = ACTIONS(2493),
    [anon_sym_await] = ACTIONS(2495),
    [sym_comment] = ACTIONS(73),
  },
  [1869] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(2942),
    [anon_sym_COMMA] = ACTIONS(2942),
    [anon_sym_STAR] = ACTIONS(3231),
    [anon_sym_GT_GT] = ACTIONS(3233),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_COLON] = ACTIONS(2942),
    [anon_sym_in] = ACTIONS(2942),
    [anon_sym_AT] = ACTIONS(3237),
    [anon_sym_not] = ACTIONS(2942),
    [anon_sym_and] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(3241),
    [anon_sym_DASH] = ACTIONS(3241),
    [anon_sym_SLASH] = ACTIONS(3231),
    [anon_sym_PERCENT] = ACTIONS(3237),
    [anon_sym_SLASH_SLASH] = ACTIONS(3237),
    [anon_sym_STAR_STAR] = ACTIONS(3243),
    [anon_sym_PIPE] = ACTIONS(3245),
    [anon_sym_AMP] = ACTIONS(3247),
    [anon_sym_CARET] = ACTIONS(3249),
    [anon_sym_LT_LT] = ACTIONS(3233),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_LT_EQ] = ACTIONS(2942),
    [anon_sym_EQ_EQ] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_GT_EQ] = ACTIONS(2942),
    [anon_sym_GT] = ACTIONS(2944),
    [anon_sym_LT_GT] = ACTIONS(2942),
    [anon_sym_is] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(473),
    [sym_comment] = ACTIONS(73),
  },
  [1870] = {
    [anon_sym_RPAREN] = ACTIONS(3840),
    [anon_sym_COMMA] = ACTIONS(3840),
    [anon_sym_if] = ACTIONS(1198),
    [anon_sym_and] = ACTIONS(1200),
    [anon_sym_or] = ACTIONS(1202),
    [sym_comment] = ACTIONS(73),
  },
  [1871] = {
    [anon_sym_RPAREN] = ACTIONS(1660),
    [anon_sym_COMMA] = ACTIONS(1660),
    [anon_sym_if] = ACTIONS(3790),
    [anon_sym_EQ] = ACTIONS(1660),
    [anon_sym_and] = ACTIONS(3792),
    [anon_sym_or] = ACTIONS(3794),
    [sym_comment] = ACTIONS(73),
  },
  [1872] = {
    [sym__expression] = STATE(1925),
    [sym__primary_expression] = STATE(1561),
    [sym_not_operator] = STATE(1925),
    [sym_boolean_operator] = STATE(1925),
    [sym_binary_operator] = STATE(1561),
    [sym_unary_operator] = STATE(1561),
    [sym_comparison_operator] = STATE(1925),
    [sym_lambda] = STATE(1925),
    [sym_attribute] = STATE(1561),
    [sym_subscript] = STATE(1561),
    [sym_call] = STATE(1561),
    [sym_list] = STATE(1561),
    [sym_list_comprehension] = STATE(1561),
    [sym_dictionary] = STATE(1561),
    [sym_dictionary_comprehension] = STATE(1561),
    [sym_set] = STATE(1561),
    [sym_set_comprehension] = STATE(1561),
    [sym_parenthesized_expression] = STATE(1561),
    [sym_tuple] = STATE(1561),
    [sym_generator_expression] = STATE(1561),
    [sym_conditional_expression] = STATE(1925),
    [sym_concatenated_string] = STATE(1561),
    [sym_string] = STATE(1563),
    [sym_await] = STATE(1925),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3263),
    [anon_sym_DASH] = ACTIONS(3263),
    [anon_sym_TILDE] = ACTIONS(3263),
    [anon_sym_lambda] = ACTIONS(3265),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3267),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3269),
    [sym_float] = ACTIONS(3269),
    [sym_identifier] = ACTIONS(3269),
    [sym_true] = ACTIONS(3269),
    [sym_false] = ACTIONS(3269),
    [sym_none] = ACTIONS(3269),
    [anon_sym_await] = ACTIONS(3271),
    [sym_comment] = ACTIONS(73),
  },
  [1873] = {
    [anon_sym_if] = ACTIONS(1925),
    [anon_sym_else] = ACTIONS(4179),
    [anon_sym_and] = ACTIONS(1929),
    [anon_sym_or] = ACTIONS(1931),
    [sym_comment] = ACTIONS(73),
  },
  [1874] = {
    [anon_sym_RPAREN] = ACTIONS(1957),
    [anon_sym_COMMA] = ACTIONS(1957),
    [anon_sym_if] = ACTIONS(1957),
    [anon_sym_EQ] = ACTIONS(1957),
    [anon_sym_and] = ACTIONS(3792),
    [anon_sym_or] = ACTIONS(1957),
    [sym_comment] = ACTIONS(73),
  },
  [1875] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(1986),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(1984),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(1986),
    [anon_sym_PERCENT] = ACTIONS(1984),
    [anon_sym_SLASH_SLASH] = ACTIONS(1984),
    [anon_sym_STAR_STAR] = ACTIONS(3808),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1876] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(3796),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(3802),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3806),
    [anon_sym_SLASH] = ACTIONS(3796),
    [anon_sym_PERCENT] = ACTIONS(3802),
    [anon_sym_SLASH_SLASH] = ACTIONS(3802),
    [anon_sym_STAR_STAR] = ACTIONS(3808),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1877] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(1988),
    [anon_sym_COMMA] = ACTIONS(1988),
    [anon_sym_STAR] = ACTIONS(3796),
    [anon_sym_GT_GT] = ACTIONS(3798),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(1988),
    [anon_sym_EQ] = ACTIONS(1990),
    [anon_sym_AT] = ACTIONS(3802),
    [anon_sym_not] = ACTIONS(1988),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3806),
    [anon_sym_SLASH] = ACTIONS(3796),
    [anon_sym_PERCENT] = ACTIONS(3802),
    [anon_sym_SLASH_SLASH] = ACTIONS(3802),
    [anon_sym_STAR_STAR] = ACTIONS(3808),
    [anon_sym_PIPE] = ACTIONS(3810),
    [anon_sym_AMP] = ACTIONS(3812),
    [anon_sym_CARET] = ACTIONS(3814),
    [anon_sym_LT_LT] = ACTIONS(3798),
    [anon_sym_LT] = ACTIONS(1990),
    [anon_sym_LT_EQ] = ACTIONS(1988),
    [anon_sym_EQ_EQ] = ACTIONS(1988),
    [anon_sym_BANG_EQ] = ACTIONS(1988),
    [anon_sym_GT_EQ] = ACTIONS(1988),
    [anon_sym_GT] = ACTIONS(1990),
    [anon_sym_LT_GT] = ACTIONS(1988),
    [anon_sym_is] = ACTIONS(1988),
    [anon_sym_LBRACK] = ACTIONS(473),
    [sym_comment] = ACTIONS(73),
  },
  [1878] = {
    [sym__primary_expression] = STATE(1927),
    [sym_binary_operator] = STATE(1927),
    [sym_unary_operator] = STATE(1927),
    [sym_attribute] = STATE(1927),
    [sym_subscript] = STATE(1927),
    [sym_call] = STATE(1927),
    [sym_list] = STATE(1927),
    [sym_list_comprehension] = STATE(1927),
    [sym_dictionary] = STATE(1927),
    [sym_dictionary_comprehension] = STATE(1927),
    [sym_set] = STATE(1927),
    [sym_set_comprehension] = STATE(1927),
    [sym_parenthesized_expression] = STATE(1927),
    [sym_tuple] = STATE(1927),
    [sym_generator_expression] = STATE(1927),
    [sym_concatenated_string] = STATE(1927),
    [sym_string] = STATE(1563),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_PLUS] = ACTIONS(3263),
    [anon_sym_DASH] = ACTIONS(3263),
    [anon_sym_TILDE] = ACTIONS(3263),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(4181),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(4183),
    [sym_float] = ACTIONS(4183),
    [sym_identifier] = ACTIONS(4183),
    [sym_true] = ACTIONS(4183),
    [sym_false] = ACTIONS(4183),
    [sym_none] = ACTIONS(4183),
    [sym_comment] = ACTIONS(73),
  },
  [1879] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(3796),
    [anon_sym_GT_GT] = ACTIONS(1984),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(3802),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(1984),
    [anon_sym_DASH] = ACTIONS(1984),
    [anon_sym_SLASH] = ACTIONS(3796),
    [anon_sym_PERCENT] = ACTIONS(3802),
    [anon_sym_SLASH_SLASH] = ACTIONS(3802),
    [anon_sym_STAR_STAR] = ACTIONS(3808),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(1984),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1880] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(3796),
    [anon_sym_GT_GT] = ACTIONS(3798),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(3802),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3806),
    [anon_sym_SLASH] = ACTIONS(3796),
    [anon_sym_PERCENT] = ACTIONS(3802),
    [anon_sym_SLASH_SLASH] = ACTIONS(3802),
    [anon_sym_STAR_STAR] = ACTIONS(3808),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(3812),
    [anon_sym_CARET] = ACTIONS(3814),
    [anon_sym_LT_LT] = ACTIONS(3798),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1881] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(3796),
    [anon_sym_GT_GT] = ACTIONS(3798),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(3802),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3806),
    [anon_sym_SLASH] = ACTIONS(3796),
    [anon_sym_PERCENT] = ACTIONS(3802),
    [anon_sym_SLASH_SLASH] = ACTIONS(3802),
    [anon_sym_STAR_STAR] = ACTIONS(3808),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(3814),
    [anon_sym_LT_LT] = ACTIONS(3798),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1882] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(1984),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(1984),
    [anon_sym_COMMA] = ACTIONS(1984),
    [anon_sym_STAR] = ACTIONS(3796),
    [anon_sym_GT_GT] = ACTIONS(3798),
    [anon_sym_if] = ACTIONS(1984),
    [anon_sym_in] = ACTIONS(1984),
    [anon_sym_EQ] = ACTIONS(1986),
    [anon_sym_AT] = ACTIONS(3802),
    [anon_sym_not] = ACTIONS(1984),
    [anon_sym_and] = ACTIONS(1984),
    [anon_sym_or] = ACTIONS(1984),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3806),
    [anon_sym_SLASH] = ACTIONS(3796),
    [anon_sym_PERCENT] = ACTIONS(3802),
    [anon_sym_SLASH_SLASH] = ACTIONS(3802),
    [anon_sym_STAR_STAR] = ACTIONS(3808),
    [anon_sym_PIPE] = ACTIONS(1984),
    [anon_sym_AMP] = ACTIONS(1984),
    [anon_sym_CARET] = ACTIONS(1984),
    [anon_sym_LT_LT] = ACTIONS(3798),
    [anon_sym_LT] = ACTIONS(1986),
    [anon_sym_LT_EQ] = ACTIONS(1984),
    [anon_sym_EQ_EQ] = ACTIONS(1984),
    [anon_sym_BANG_EQ] = ACTIONS(1984),
    [anon_sym_GT_EQ] = ACTIONS(1984),
    [anon_sym_GT] = ACTIONS(1986),
    [anon_sym_LT_GT] = ACTIONS(1984),
    [anon_sym_is] = ACTIONS(1984),
    [anon_sym_LBRACK] = ACTIONS(1984),
    [sym_comment] = ACTIONS(73),
  },
  [1883] = {
    [aux_sym_comparison_operator_repeat1] = STATE(1883),
    [anon_sym_RPAREN] = ACTIONS(1988),
    [anon_sym_COMMA] = ACTIONS(1988),
    [anon_sym_if] = ACTIONS(1988),
    [anon_sym_in] = ACTIONS(4185),
    [anon_sym_EQ] = ACTIONS(1990),
    [anon_sym_not] = ACTIONS(4188),
    [anon_sym_and] = ACTIONS(1988),
    [anon_sym_or] = ACTIONS(1988),
    [anon_sym_LT] = ACTIONS(4191),
    [anon_sym_LT_EQ] = ACTIONS(4185),
    [anon_sym_EQ_EQ] = ACTIONS(4185),
    [anon_sym_BANG_EQ] = ACTIONS(4185),
    [anon_sym_GT_EQ] = ACTIONS(4185),
    [anon_sym_GT] = ACTIONS(4191),
    [anon_sym_LT_GT] = ACTIONS(4185),
    [anon_sym_is] = ACTIONS(4194),
    [sym_comment] = ACTIONS(73),
  },
  [1884] = {
    [anon_sym_RPAREN] = ACTIONS(3860),
    [anon_sym_COMMA] = ACTIONS(3860),
    [anon_sym_if] = ACTIONS(1198),
    [anon_sym_and] = ACTIONS(1200),
    [anon_sym_or] = ACTIONS(1202),
    [sym_comment] = ACTIONS(73),
  },
  [1885] = {
    [sym_string] = STATE(1885),
    [aux_sym_concatenated_string_repeat1] = STATE(1885),
    [sym__string_start] = ACTIONS(2241),
    [anon_sym_DOT] = ACTIONS(2050),
    [anon_sym_LPAREN] = ACTIONS(2050),
    [anon_sym_RPAREN] = ACTIONS(2050),
    [anon_sym_COMMA] = ACTIONS(2050),
    [anon_sym_STAR] = ACTIONS(2055),
    [anon_sym_GT_GT] = ACTIONS(2050),
    [anon_sym_if] = ACTIONS(2050),
    [anon_sym_in] = ACTIONS(2050),
    [anon_sym_EQ] = ACTIONS(2055),
    [anon_sym_AT] = ACTIONS(2050),
    [anon_sym_not] = ACTIONS(2050),
    [anon_sym_and] = ACTIONS(2050),
    [anon_sym_or] = ACTIONS(2050),
    [anon_sym_PLUS] = ACTIONS(2050),
    [anon_sym_DASH] = ACTIONS(2050),
    [anon_sym_SLASH] = ACTIONS(2055),
    [anon_sym_PERCENT] = ACTIONS(2050),
    [anon_sym_SLASH_SLASH] = ACTIONS(2050),
    [anon_sym_STAR_STAR] = ACTIONS(2050),
    [anon_sym_PIPE] = ACTIONS(2050),
    [anon_sym_AMP] = ACTIONS(2050),
    [anon_sym_CARET] = ACTIONS(2050),
    [anon_sym_LT_LT] = ACTIONS(2050),
    [anon_sym_LT] = ACTIONS(2055),
    [anon_sym_LT_EQ] = ACTIONS(2050),
    [anon_sym_EQ_EQ] = ACTIONS(2050),
    [anon_sym_BANG_EQ] = ACTIONS(2050),
    [anon_sym_GT_EQ] = ACTIONS(2050),
    [anon_sym_GT] = ACTIONS(2055),
    [anon_sym_LT_GT] = ACTIONS(2050),
    [anon_sym_is] = ACTIONS(2050),
    [anon_sym_LBRACK] = ACTIONS(2050),
    [sym_comment] = ACTIONS(73),
  },
  [1886] = {
    [anon_sym_if] = ACTIONS(2568),
    [anon_sym_EQ] = ACTIONS(3565),
    [anon_sym_and] = ACTIONS(2570),
    [anon_sym_or] = ACTIONS(2572),
    [sym_comment] = ACTIONS(73),
  },
  [1887] = {
    [anon_sym_COMMA] = ACTIONS(3565),
    [anon_sym_if] = ACTIONS(2609),
    [anon_sym_COLON] = ACTIONS(3565),
    [anon_sym_EQ] = ACTIONS(3565),
    [anon_sym_and] = ACTIONS(2611),
    [anon_sym_or] = ACTIONS(2613),
    [sym_comment] = ACTIONS(73),
  },
  [1888] = {
    [sym__expression_within_for_in_clause] = STATE(1836),
    [sym__expression] = STATE(1608),
    [sym__primary_expression] = STATE(152),
    [sym_not_operator] = STATE(1608),
    [sym_boolean_operator] = STATE(1608),
    [sym_binary_operator] = STATE(152),
    [sym_unary_operator] = STATE(152),
    [sym_comparison_operator] = STATE(1608),
    [sym_lambda] = STATE(1608),
    [sym_lambda_within_for_in_clause] = STATE(1836),
    [sym_attribute] = STATE(152),
    [sym_subscript] = STATE(152),
    [sym_call] = STATE(152),
    [sym_list] = STATE(152),
    [sym_list_comprehension] = STATE(152),
    [sym_dictionary] = STATE(152),
    [sym_dictionary_comprehension] = STATE(152),
    [sym_set] = STATE(152),
    [sym_set_comprehension] = STATE(152),
    [sym_parenthesized_expression] = STATE(152),
    [sym_tuple] = STATE(152),
    [sym_generator_expression] = STATE(152),
    [sym_conditional_expression] = STATE(1608),
    [sym_concatenated_string] = STATE(152),
    [sym_string] = STATE(153),
    [sym_await] = STATE(1608),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(4141),
    [anon_sym_async] = ACTIONS(4141),
    [anon_sym_for] = ACTIONS(4141),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_lambda] = ACTIONS(3399),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(4139),
    [sym_ellipsis] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(255),
    [sym_float] = ACTIONS(255),
    [sym_identifier] = ACTIONS(255),
    [sym_true] = ACTIONS(255),
    [sym_false] = ACTIONS(255),
    [sym_none] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [sym_comment] = ACTIONS(73),
  },
  [1889] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1891),
    [anon_sym_COMMA] = ACTIONS(4197),
    [anon_sym_if] = ACTIONS(4139),
    [anon_sym_async] = ACTIONS(4139),
    [anon_sym_for] = ACTIONS(4139),
    [anon_sym_RBRACK] = ACTIONS(4139),
    [sym_comment] = ACTIONS(73),
  },
  [1890] = {
    [sym__expression_within_for_in_clause] = STATE(1904),
    [sym__expression] = STATE(1608),
    [sym__primary_expression] = STATE(152),
    [sym_not_operator] = STATE(1608),
    [sym_boolean_operator] = STATE(1608),
    [sym_binary_operator] = STATE(152),
    [sym_unary_operator] = STATE(152),
    [sym_comparison_operator] = STATE(1608),
    [sym_lambda] = STATE(1608),
    [sym_lambda_within_for_in_clause] = STATE(1904),
    [sym_attribute] = STATE(152),
    [sym_subscript] = STATE(152),
    [sym_call] = STATE(152),
    [sym_list] = STATE(152),
    [sym_list_comprehension] = STATE(152),
    [sym_dictionary] = STATE(152),
    [sym_dictionary_comprehension] = STATE(152),
    [sym_set] = STATE(152),
    [sym_set_comprehension] = STATE(152),
    [sym_parenthesized_expression] = STATE(152),
    [sym_tuple] = STATE(152),
    [sym_generator_expression] = STATE(152),
    [sym_conditional_expression] = STATE(1608),
    [sym_concatenated_string] = STATE(152),
    [sym_string] = STATE(153),
    [sym_await] = STATE(1608),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_lambda] = ACTIONS(3399),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(255),
    [sym_float] = ACTIONS(255),
    [sym_identifier] = ACTIONS(255),
    [sym_true] = ACTIONS(255),
    [sym_false] = ACTIONS(255),
    [sym_none] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [sym_comment] = ACTIONS(73),
  },
  [1891] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1891),
    [anon_sym_COMMA] = ACTIONS(4199),
    [anon_sym_if] = ACTIONS(4147),
    [anon_sym_async] = ACTIONS(4147),
    [anon_sym_for] = ACTIONS(4147),
    [anon_sym_RBRACK] = ACTIONS(4147),
    [sym_comment] = ACTIONS(73),
  },
  [1892] = {
    [anon_sym_if] = ACTIONS(4093),
    [anon_sym_async] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2647),
    [anon_sym_and] = ACTIONS(3403),
    [anon_sym_or] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(2647),
    [sym_comment] = ACTIONS(73),
  },
  [1893] = {
    [sym__expression] = STATE(1930),
    [sym__primary_expression] = STATE(1324),
    [sym_not_operator] = STATE(1930),
    [sym_boolean_operator] = STATE(1930),
    [sym_binary_operator] = STATE(1324),
    [sym_unary_operator] = STATE(1324),
    [sym_comparison_operator] = STATE(1930),
    [sym_lambda] = STATE(1930),
    [sym_attribute] = STATE(1324),
    [sym_subscript] = STATE(1324),
    [sym_call] = STATE(1324),
    [sym_list] = STATE(1324),
    [sym_list_comprehension] = STATE(1324),
    [sym_dictionary] = STATE(1324),
    [sym_dictionary_comprehension] = STATE(1324),
    [sym_set] = STATE(1324),
    [sym_set_comprehension] = STATE(1324),
    [sym_parenthesized_expression] = STATE(1324),
    [sym_tuple] = STATE(1324),
    [sym_generator_expression] = STATE(1324),
    [sym_conditional_expression] = STATE(1930),
    [sym_concatenated_string] = STATE(1324),
    [sym_string] = STATE(1325),
    [sym_await] = STATE(1930),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2702),
    [anon_sym_PLUS] = ACTIONS(2704),
    [anon_sym_DASH] = ACTIONS(2704),
    [anon_sym_TILDE] = ACTIONS(2704),
    [anon_sym_lambda] = ACTIONS(2706),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2708),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2710),
    [sym_float] = ACTIONS(2710),
    [sym_identifier] = ACTIONS(2710),
    [sym_true] = ACTIONS(2710),
    [sym_false] = ACTIONS(2710),
    [sym_none] = ACTIONS(2710),
    [anon_sym_await] = ACTIONS(2712),
    [sym_comment] = ACTIONS(73),
  },
  [1894] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(3407),
    [anon_sym_GT_GT] = ACTIONS(3409),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_async] = ACTIONS(2942),
    [anon_sym_for] = ACTIONS(2942),
    [anon_sym_in] = ACTIONS(2942),
    [anon_sym_AT] = ACTIONS(3413),
    [anon_sym_not] = ACTIONS(2942),
    [anon_sym_and] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(3417),
    [anon_sym_DASH] = ACTIONS(3417),
    [anon_sym_SLASH] = ACTIONS(3407),
    [anon_sym_PERCENT] = ACTIONS(3413),
    [anon_sym_SLASH_SLASH] = ACTIONS(3413),
    [anon_sym_STAR_STAR] = ACTIONS(3419),
    [anon_sym_PIPE] = ACTIONS(3421),
    [anon_sym_AMP] = ACTIONS(3423),
    [anon_sym_CARET] = ACTIONS(3425),
    [anon_sym_LT_LT] = ACTIONS(3409),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_LT_EQ] = ACTIONS(2942),
    [anon_sym_EQ_EQ] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_GT_EQ] = ACTIONS(2942),
    [anon_sym_GT] = ACTIONS(2944),
    [anon_sym_LT_GT] = ACTIONS(2942),
    [anon_sym_is] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(473),
    [anon_sym_RBRACK] = ACTIONS(2942),
    [sym_comment] = ACTIONS(73),
  },
  [1895] = {
    [anon_sym_COMMA] = ACTIONS(3565),
    [anon_sym_if] = ACTIONS(2792),
    [anon_sym_async] = ACTIONS(3565),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_and] = ACTIONS(2794),
    [anon_sym_or] = ACTIONS(2796),
    [anon_sym_RBRACE] = ACTIONS(3565),
    [sym_comment] = ACTIONS(73),
  },
  [1896] = {
    [sym__expression_within_for_in_clause] = STATE(1836),
    [sym__expression] = STATE(1649),
    [sym__primary_expression] = STATE(973),
    [sym_not_operator] = STATE(1649),
    [sym_boolean_operator] = STATE(1649),
    [sym_binary_operator] = STATE(973),
    [sym_unary_operator] = STATE(973),
    [sym_comparison_operator] = STATE(1649),
    [sym_lambda] = STATE(1649),
    [sym_lambda_within_for_in_clause] = STATE(1836),
    [sym_attribute] = STATE(973),
    [sym_subscript] = STATE(973),
    [sym_call] = STATE(973),
    [sym_list] = STATE(973),
    [sym_list_comprehension] = STATE(973),
    [sym_dictionary] = STATE(973),
    [sym_dictionary_comprehension] = STATE(973),
    [sym_set] = STATE(973),
    [sym_set_comprehension] = STATE(973),
    [sym_parenthesized_expression] = STATE(973),
    [sym_tuple] = STATE(973),
    [sym_generator_expression] = STATE(973),
    [sym_conditional_expression] = STATE(1649),
    [sym_concatenated_string] = STATE(973),
    [sym_string] = STATE(974),
    [sym_await] = STATE(1649),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(4141),
    [anon_sym_async] = ACTIONS(4141),
    [anon_sym_for] = ACTIONS(4141),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1814),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_DASH] = ACTIONS(1816),
    [anon_sym_TILDE] = ACTIONS(1816),
    [anon_sym_lambda] = ACTIONS(3502),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1820),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(4139),
    [sym_integer] = ACTIONS(1822),
    [sym_float] = ACTIONS(1822),
    [sym_identifier] = ACTIONS(1822),
    [sym_true] = ACTIONS(1822),
    [sym_false] = ACTIONS(1822),
    [sym_none] = ACTIONS(1822),
    [anon_sym_await] = ACTIONS(1824),
    [sym_comment] = ACTIONS(73),
  },
  [1897] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1899),
    [anon_sym_COMMA] = ACTIONS(4202),
    [anon_sym_if] = ACTIONS(4139),
    [anon_sym_async] = ACTIONS(4139),
    [anon_sym_for] = ACTIONS(4139),
    [anon_sym_RBRACE] = ACTIONS(4139),
    [sym_comment] = ACTIONS(73),
  },
  [1898] = {
    [sym__expression_within_for_in_clause] = STATE(1904),
    [sym__expression] = STATE(1649),
    [sym__primary_expression] = STATE(973),
    [sym_not_operator] = STATE(1649),
    [sym_boolean_operator] = STATE(1649),
    [sym_binary_operator] = STATE(973),
    [sym_unary_operator] = STATE(973),
    [sym_comparison_operator] = STATE(1649),
    [sym_lambda] = STATE(1649),
    [sym_lambda_within_for_in_clause] = STATE(1904),
    [sym_attribute] = STATE(973),
    [sym_subscript] = STATE(973),
    [sym_call] = STATE(973),
    [sym_list] = STATE(973),
    [sym_list_comprehension] = STATE(973),
    [sym_dictionary] = STATE(973),
    [sym_dictionary_comprehension] = STATE(973),
    [sym_set] = STATE(973),
    [sym_set_comprehension] = STATE(973),
    [sym_parenthesized_expression] = STATE(973),
    [sym_tuple] = STATE(973),
    [sym_generator_expression] = STATE(973),
    [sym_conditional_expression] = STATE(1649),
    [sym_concatenated_string] = STATE(973),
    [sym_string] = STATE(974),
    [sym_await] = STATE(1649),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1814),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_DASH] = ACTIONS(1816),
    [anon_sym_TILDE] = ACTIONS(1816),
    [anon_sym_lambda] = ACTIONS(3502),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1820),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1822),
    [sym_float] = ACTIONS(1822),
    [sym_identifier] = ACTIONS(1822),
    [sym_true] = ACTIONS(1822),
    [sym_false] = ACTIONS(1822),
    [sym_none] = ACTIONS(1822),
    [anon_sym_await] = ACTIONS(1824),
    [sym_comment] = ACTIONS(73),
  },
  [1899] = {
    [aux_sym_for_in_clause_repeat1] = STATE(1899),
    [anon_sym_COMMA] = ACTIONS(4204),
    [anon_sym_if] = ACTIONS(4147),
    [anon_sym_async] = ACTIONS(4147),
    [anon_sym_for] = ACTIONS(4147),
    [anon_sym_RBRACE] = ACTIONS(4147),
    [sym_comment] = ACTIONS(73),
  },
  [1900] = {
    [anon_sym_if] = ACTIONS(4117),
    [anon_sym_async] = ACTIONS(2647),
    [anon_sym_for] = ACTIONS(2647),
    [anon_sym_and] = ACTIONS(3506),
    [anon_sym_or] = ACTIONS(3508),
    [anon_sym_RBRACE] = ACTIONS(2647),
    [sym_comment] = ACTIONS(73),
  },
  [1901] = {
    [sym__expression] = STATE(1933),
    [sym__primary_expression] = STATE(1374),
    [sym_not_operator] = STATE(1933),
    [sym_boolean_operator] = STATE(1933),
    [sym_binary_operator] = STATE(1374),
    [sym_unary_operator] = STATE(1374),
    [sym_comparison_operator] = STATE(1933),
    [sym_lambda] = STATE(1933),
    [sym_attribute] = STATE(1374),
    [sym_subscript] = STATE(1374),
    [sym_call] = STATE(1374),
    [sym_list] = STATE(1374),
    [sym_list_comprehension] = STATE(1374),
    [sym_dictionary] = STATE(1374),
    [sym_dictionary_comprehension] = STATE(1374),
    [sym_set] = STATE(1374),
    [sym_set_comprehension] = STATE(1374),
    [sym_parenthesized_expression] = STATE(1374),
    [sym_tuple] = STATE(1374),
    [sym_generator_expression] = STATE(1374),
    [sym_conditional_expression] = STATE(1933),
    [sym_concatenated_string] = STATE(1374),
    [sym_string] = STATE(1375),
    [sym_await] = STATE(1933),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(2828),
    [anon_sym_PLUS] = ACTIONS(2830),
    [anon_sym_DASH] = ACTIONS(2830),
    [anon_sym_TILDE] = ACTIONS(2830),
    [anon_sym_lambda] = ACTIONS(2832),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(2834),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(2836),
    [sym_float] = ACTIONS(2836),
    [sym_identifier] = ACTIONS(2836),
    [sym_true] = ACTIONS(2836),
    [sym_false] = ACTIONS(2836),
    [sym_none] = ACTIONS(2836),
    [anon_sym_await] = ACTIONS(2838),
    [sym_comment] = ACTIONS(73),
  },
  [1902] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_STAR] = ACTIONS(3510),
    [anon_sym_GT_GT] = ACTIONS(3512),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_async] = ACTIONS(2942),
    [anon_sym_for] = ACTIONS(2942),
    [anon_sym_in] = ACTIONS(2942),
    [anon_sym_AT] = ACTIONS(3516),
    [anon_sym_not] = ACTIONS(2942),
    [anon_sym_and] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(3520),
    [anon_sym_DASH] = ACTIONS(3520),
    [anon_sym_SLASH] = ACTIONS(3510),
    [anon_sym_PERCENT] = ACTIONS(3516),
    [anon_sym_SLASH_SLASH] = ACTIONS(3516),
    [anon_sym_STAR_STAR] = ACTIONS(3522),
    [anon_sym_PIPE] = ACTIONS(3524),
    [anon_sym_AMP] = ACTIONS(3526),
    [anon_sym_CARET] = ACTIONS(3528),
    [anon_sym_LT_LT] = ACTIONS(3512),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_LT_EQ] = ACTIONS(2942),
    [anon_sym_EQ_EQ] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_GT_EQ] = ACTIONS(2942),
    [anon_sym_GT] = ACTIONS(2944),
    [anon_sym_LT_GT] = ACTIONS(2942),
    [anon_sym_is] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(473),
    [anon_sym_RBRACE] = ACTIONS(2942),
    [sym_comment] = ACTIONS(73),
  },
  [1903] = {
    [sym__expression_within_for_in_clause] = STATE(1836),
    [sym__expression] = STATE(1459),
    [sym__primary_expression] = STATE(67),
    [sym_not_operator] = STATE(1459),
    [sym_boolean_operator] = STATE(1459),
    [sym_binary_operator] = STATE(67),
    [sym_unary_operator] = STATE(67),
    [sym_comparison_operator] = STATE(1459),
    [sym_lambda] = STATE(1459),
    [sym_lambda_within_for_in_clause] = STATE(1836),
    [sym_attribute] = STATE(67),
    [sym_subscript] = STATE(67),
    [sym_call] = STATE(67),
    [sym_list] = STATE(67),
    [sym_list_comprehension] = STATE(67),
    [sym_dictionary] = STATE(67),
    [sym_dictionary_comprehension] = STATE(67),
    [sym_set] = STATE(67),
    [sym_set_comprehension] = STATE(67),
    [sym_parenthesized_expression] = STATE(67),
    [sym_tuple] = STATE(67),
    [sym_generator_expression] = STATE(67),
    [sym_conditional_expression] = STATE(1459),
    [sym_concatenated_string] = STATE(67),
    [sym_string] = STATE(69),
    [sym_await] = STATE(1459),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_RPAREN] = ACTIONS(4207),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(4209),
    [anon_sym_async] = ACTIONS(4209),
    [anon_sym_for] = ACTIONS(4209),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(3051),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [1904] = {
    [anon_sym_RPAREN] = ACTIONS(4211),
    [anon_sym_COMMA] = ACTIONS(4211),
    [anon_sym_if] = ACTIONS(4211),
    [anon_sym_async] = ACTIONS(4211),
    [anon_sym_for] = ACTIONS(4211),
    [anon_sym_RBRACK] = ACTIONS(4211),
    [anon_sym_RBRACE] = ACTIONS(4211),
    [sym_comment] = ACTIONS(73),
  },
  [1905] = {
    [sym__expression_within_for_in_clause] = STATE(1836),
    [sym__expression] = STATE(1459),
    [sym__primary_expression] = STATE(67),
    [sym_not_operator] = STATE(1459),
    [sym_boolean_operator] = STATE(1459),
    [sym_binary_operator] = STATE(67),
    [sym_unary_operator] = STATE(67),
    [sym_comparison_operator] = STATE(1459),
    [sym_lambda] = STATE(1459),
    [sym_lambda_within_for_in_clause] = STATE(1836),
    [sym_attribute] = STATE(67),
    [sym_subscript] = STATE(67),
    [sym_call] = STATE(67),
    [sym_list] = STATE(67),
    [sym_list_comprehension] = STATE(67),
    [sym_dictionary] = STATE(67),
    [sym_dictionary_comprehension] = STATE(67),
    [sym_set] = STATE(67),
    [sym_set_comprehension] = STATE(67),
    [sym_parenthesized_expression] = STATE(67),
    [sym_tuple] = STATE(67),
    [sym_generator_expression] = STATE(67),
    [sym_conditional_expression] = STATE(1459),
    [sym_concatenated_string] = STATE(67),
    [sym_string] = STATE(69),
    [sym_await] = STATE(1459),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(101),
    [anon_sym_PLUS] = ACTIONS(103),
    [anon_sym_DASH] = ACTIONS(103),
    [anon_sym_TILDE] = ACTIONS(103),
    [anon_sym_lambda] = ACTIONS(3051),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(111),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(115),
    [sym_float] = ACTIONS(115),
    [sym_identifier] = ACTIONS(115),
    [sym_true] = ACTIONS(115),
    [sym_false] = ACTIONS(115),
    [sym_none] = ACTIONS(115),
    [anon_sym_await] = ACTIONS(117),
    [sym_comment] = ACTIONS(73),
  },
  [1906] = {
    [anon_sym_RPAREN] = ACTIONS(3565),
    [anon_sym_if] = ACTIONS(3977),
    [anon_sym_async] = ACTIONS(3565),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_and] = ACTIONS(3057),
    [anon_sym_or] = ACTIONS(3059),
    [sym_comment] = ACTIONS(73),
  },
  [1907] = {
    [sym__dedent] = ACTIONS(3180),
    [sym__string_start] = ACTIONS(3180),
    [anon_sym_import] = ACTIONS(3687),
    [anon_sym_from] = ACTIONS(3687),
    [anon_sym_LPAREN] = ACTIONS(3180),
    [anon_sym_print] = ACTIONS(3687),
    [anon_sym_assert] = ACTIONS(3687),
    [anon_sym_return] = ACTIONS(3687),
    [anon_sym_del] = ACTIONS(3687),
    [anon_sym_raise] = ACTIONS(3687),
    [anon_sym_pass] = ACTIONS(3687),
    [anon_sym_break] = ACTIONS(3687),
    [anon_sym_continue] = ACTIONS(3687),
    [anon_sym_if] = ACTIONS(3687),
    [anon_sym_elif] = ACTIONS(3687),
    [anon_sym_else] = ACTIONS(3687),
    [anon_sym_async] = ACTIONS(3687),
    [anon_sym_for] = ACTIONS(3687),
    [anon_sym_while] = ACTIONS(3687),
    [anon_sym_try] = ACTIONS(3687),
    [anon_sym_except] = ACTIONS(3687),
    [anon_sym_finally] = ACTIONS(3687),
    [anon_sym_with] = ACTIONS(3687),
    [anon_sym_def] = ACTIONS(3687),
    [anon_sym_global] = ACTIONS(3687),
    [anon_sym_nonlocal] = ACTIONS(3687),
    [anon_sym_exec] = ACTIONS(3687),
    [anon_sym_class] = ACTIONS(3687),
    [anon_sym_AT] = ACTIONS(3180),
    [anon_sym_not] = ACTIONS(3687),
    [anon_sym_PLUS] = ACTIONS(3180),
    [anon_sym_DASH] = ACTIONS(3180),
    [anon_sym_TILDE] = ACTIONS(3180),
    [anon_sym_lambda] = ACTIONS(3687),
    [anon_sym_yield] = ACTIONS(3687),
    [anon_sym_LBRACK] = ACTIONS(3180),
    [sym_ellipsis] = ACTIONS(3180),
    [anon_sym_LBRACE] = ACTIONS(3180),
    [sym_integer] = ACTIONS(3687),
    [sym_float] = ACTIONS(3687),
    [sym_identifier] = ACTIONS(3687),
    [sym_true] = ACTIONS(3687),
    [sym_false] = ACTIONS(3687),
    [sym_none] = ACTIONS(3687),
    [anon_sym_await] = ACTIONS(3687),
    [sym_comment] = ACTIONS(73),
  },
  [1908] = {
    [anon_sym_if] = ACTIONS(599),
    [anon_sym_COLON] = ACTIONS(4213),
    [anon_sym_and] = ACTIONS(603),
    [anon_sym_or] = ACTIONS(605),
    [sym_comment] = ACTIONS(73),
  },
  [1909] = {
    [sym__simple_statements] = STATE(1935),
    [sym_import_statement] = STATE(799),
    [sym_future_import_statement] = STATE(799),
    [sym_import_from_statement] = STATE(799),
    [sym_print_statement] = STATE(799),
    [sym_assert_statement] = STATE(799),
    [sym_expression_statement] = STATE(799),
    [sym_return_statement] = STATE(799),
    [sym_delete_statement] = STATE(799),
    [sym_raise_statement] = STATE(799),
    [sym_pass_statement] = STATE(799),
    [sym_break_statement] = STATE(799),
    [sym_continue_statement] = STATE(799),
    [sym_global_statement] = STATE(799),
    [sym_nonlocal_statement] = STATE(799),
    [sym_exec_statement] = STATE(799),
    [sym__suite] = STATE(1935),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(3719),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1910] = {
    [sym__dedent] = ACTIONS(3691),
    [sym__string_start] = ACTIONS(3691),
    [anon_sym_import] = ACTIONS(3693),
    [anon_sym_from] = ACTIONS(3693),
    [anon_sym_LPAREN] = ACTIONS(3691),
    [anon_sym_print] = ACTIONS(3693),
    [anon_sym_assert] = ACTIONS(3693),
    [anon_sym_return] = ACTIONS(3693),
    [anon_sym_del] = ACTIONS(3693),
    [anon_sym_raise] = ACTIONS(3693),
    [anon_sym_pass] = ACTIONS(3693),
    [anon_sym_break] = ACTIONS(3693),
    [anon_sym_continue] = ACTIONS(3693),
    [anon_sym_if] = ACTIONS(3693),
    [anon_sym_async] = ACTIONS(3693),
    [anon_sym_for] = ACTIONS(3693),
    [anon_sym_while] = ACTIONS(3693),
    [anon_sym_try] = ACTIONS(3693),
    [anon_sym_with] = ACTIONS(3693),
    [anon_sym_def] = ACTIONS(3693),
    [anon_sym_global] = ACTIONS(3693),
    [anon_sym_nonlocal] = ACTIONS(3693),
    [anon_sym_exec] = ACTIONS(3693),
    [anon_sym_class] = ACTIONS(3693),
    [anon_sym_AT] = ACTIONS(3691),
    [anon_sym_not] = ACTIONS(3693),
    [anon_sym_PLUS] = ACTIONS(3691),
    [anon_sym_DASH] = ACTIONS(3691),
    [anon_sym_TILDE] = ACTIONS(3691),
    [anon_sym_lambda] = ACTIONS(3693),
    [anon_sym_yield] = ACTIONS(3693),
    [anon_sym_LBRACK] = ACTIONS(3691),
    [sym_ellipsis] = ACTIONS(3691),
    [anon_sym_LBRACE] = ACTIONS(3691),
    [sym_integer] = ACTIONS(3693),
    [sym_float] = ACTIONS(3693),
    [sym_identifier] = ACTIONS(3693),
    [sym_true] = ACTIONS(3693),
    [sym_false] = ACTIONS(3693),
    [sym_none] = ACTIONS(3693),
    [anon_sym_await] = ACTIONS(3693),
    [sym_comment] = ACTIONS(73),
  },
  [1911] = {
    [sym_elif_clause] = STATE(1911),
    [aux_sym_if_statement_repeat1] = STATE(1911),
    [sym__dedent] = ACTIONS(3695),
    [sym__string_start] = ACTIONS(3695),
    [anon_sym_import] = ACTIONS(3697),
    [anon_sym_from] = ACTIONS(3697),
    [anon_sym_LPAREN] = ACTIONS(3695),
    [anon_sym_print] = ACTIONS(3697),
    [anon_sym_assert] = ACTIONS(3697),
    [anon_sym_return] = ACTIONS(3697),
    [anon_sym_del] = ACTIONS(3697),
    [anon_sym_raise] = ACTIONS(3697),
    [anon_sym_pass] = ACTIONS(3697),
    [anon_sym_break] = ACTIONS(3697),
    [anon_sym_continue] = ACTIONS(3697),
    [anon_sym_if] = ACTIONS(3697),
    [anon_sym_elif] = ACTIONS(4215),
    [anon_sym_else] = ACTIONS(3697),
    [anon_sym_async] = ACTIONS(3697),
    [anon_sym_for] = ACTIONS(3697),
    [anon_sym_while] = ACTIONS(3697),
    [anon_sym_try] = ACTIONS(3697),
    [anon_sym_with] = ACTIONS(3697),
    [anon_sym_def] = ACTIONS(3697),
    [anon_sym_global] = ACTIONS(3697),
    [anon_sym_nonlocal] = ACTIONS(3697),
    [anon_sym_exec] = ACTIONS(3697),
    [anon_sym_class] = ACTIONS(3697),
    [anon_sym_AT] = ACTIONS(3695),
    [anon_sym_not] = ACTIONS(3697),
    [anon_sym_PLUS] = ACTIONS(3695),
    [anon_sym_DASH] = ACTIONS(3695),
    [anon_sym_TILDE] = ACTIONS(3695),
    [anon_sym_lambda] = ACTIONS(3697),
    [anon_sym_yield] = ACTIONS(3697),
    [anon_sym_LBRACK] = ACTIONS(3695),
    [sym_ellipsis] = ACTIONS(3695),
    [anon_sym_LBRACE] = ACTIONS(3695),
    [sym_integer] = ACTIONS(3697),
    [sym_float] = ACTIONS(3697),
    [sym_identifier] = ACTIONS(3697),
    [sym_true] = ACTIONS(3697),
    [sym_false] = ACTIONS(3697),
    [sym_none] = ACTIONS(3697),
    [anon_sym_await] = ACTIONS(3697),
    [sym_comment] = ACTIONS(73),
  },
  [1912] = {
    [sym__simple_statements] = STATE(1936),
    [sym_import_statement] = STATE(799),
    [sym_future_import_statement] = STATE(799),
    [sym_import_from_statement] = STATE(799),
    [sym_print_statement] = STATE(799),
    [sym_assert_statement] = STATE(799),
    [sym_expression_statement] = STATE(799),
    [sym_return_statement] = STATE(799),
    [sym_delete_statement] = STATE(799),
    [sym_raise_statement] = STATE(799),
    [sym_pass_statement] = STATE(799),
    [sym_break_statement] = STATE(799),
    [sym_continue_statement] = STATE(799),
    [sym_global_statement] = STATE(799),
    [sym_nonlocal_statement] = STATE(799),
    [sym_exec_statement] = STATE(799),
    [sym__suite] = STATE(1936),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(3719),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1913] = {
    [sym__dedent] = ACTIONS(3702),
    [sym__string_start] = ACTIONS(3702),
    [anon_sym_import] = ACTIONS(3704),
    [anon_sym_from] = ACTIONS(3704),
    [anon_sym_LPAREN] = ACTIONS(3702),
    [anon_sym_print] = ACTIONS(3704),
    [anon_sym_assert] = ACTIONS(3704),
    [anon_sym_return] = ACTIONS(3704),
    [anon_sym_del] = ACTIONS(3704),
    [anon_sym_raise] = ACTIONS(3704),
    [anon_sym_pass] = ACTIONS(3704),
    [anon_sym_break] = ACTIONS(3704),
    [anon_sym_continue] = ACTIONS(3704),
    [anon_sym_if] = ACTIONS(3704),
    [anon_sym_async] = ACTIONS(3704),
    [anon_sym_for] = ACTIONS(3704),
    [anon_sym_while] = ACTIONS(3704),
    [anon_sym_try] = ACTIONS(3704),
    [anon_sym_with] = ACTIONS(3704),
    [anon_sym_def] = ACTIONS(3704),
    [anon_sym_global] = ACTIONS(3704),
    [anon_sym_nonlocal] = ACTIONS(3704),
    [anon_sym_exec] = ACTIONS(3704),
    [anon_sym_class] = ACTIONS(3704),
    [anon_sym_AT] = ACTIONS(3702),
    [anon_sym_not] = ACTIONS(3704),
    [anon_sym_PLUS] = ACTIONS(3702),
    [anon_sym_DASH] = ACTIONS(3702),
    [anon_sym_TILDE] = ACTIONS(3702),
    [anon_sym_lambda] = ACTIONS(3704),
    [anon_sym_yield] = ACTIONS(3704),
    [anon_sym_LBRACK] = ACTIONS(3702),
    [sym_ellipsis] = ACTIONS(3702),
    [anon_sym_LBRACE] = ACTIONS(3702),
    [sym_integer] = ACTIONS(3704),
    [sym_float] = ACTIONS(3704),
    [sym_identifier] = ACTIONS(3704),
    [sym_true] = ACTIONS(3704),
    [sym_false] = ACTIONS(3704),
    [sym_none] = ACTIONS(3704),
    [anon_sym_await] = ACTIONS(3704),
    [sym_comment] = ACTIONS(73),
  },
  [1914] = {
    [sym__dedent] = ACTIONS(3706),
    [sym__string_start] = ACTIONS(3706),
    [anon_sym_import] = ACTIONS(3708),
    [anon_sym_from] = ACTIONS(3708),
    [anon_sym_LPAREN] = ACTIONS(3706),
    [anon_sym_print] = ACTIONS(3708),
    [anon_sym_assert] = ACTIONS(3708),
    [anon_sym_return] = ACTIONS(3708),
    [anon_sym_del] = ACTIONS(3708),
    [anon_sym_raise] = ACTIONS(3708),
    [anon_sym_pass] = ACTIONS(3708),
    [anon_sym_break] = ACTIONS(3708),
    [anon_sym_continue] = ACTIONS(3708),
    [anon_sym_if] = ACTIONS(3708),
    [anon_sym_async] = ACTIONS(3708),
    [anon_sym_for] = ACTIONS(3708),
    [anon_sym_while] = ACTIONS(3708),
    [anon_sym_try] = ACTIONS(3708),
    [anon_sym_with] = ACTIONS(3708),
    [anon_sym_def] = ACTIONS(3708),
    [anon_sym_global] = ACTIONS(3708),
    [anon_sym_nonlocal] = ACTIONS(3708),
    [anon_sym_exec] = ACTIONS(3708),
    [anon_sym_class] = ACTIONS(3708),
    [anon_sym_AT] = ACTIONS(3706),
    [anon_sym_not] = ACTIONS(3708),
    [anon_sym_PLUS] = ACTIONS(3706),
    [anon_sym_DASH] = ACTIONS(3706),
    [anon_sym_TILDE] = ACTIONS(3706),
    [anon_sym_lambda] = ACTIONS(3708),
    [anon_sym_yield] = ACTIONS(3708),
    [anon_sym_LBRACK] = ACTIONS(3706),
    [sym_ellipsis] = ACTIONS(3706),
    [anon_sym_LBRACE] = ACTIONS(3706),
    [sym_integer] = ACTIONS(3708),
    [sym_float] = ACTIONS(3708),
    [sym_identifier] = ACTIONS(3708),
    [sym_true] = ACTIONS(3708),
    [sym_false] = ACTIONS(3708),
    [sym_none] = ACTIONS(3708),
    [anon_sym_await] = ACTIONS(3708),
    [sym_comment] = ACTIONS(73),
  },
  [1915] = {
    [anon_sym_COLON] = ACTIONS(4218),
    [sym_comment] = ACTIONS(73),
  },
  [1916] = {
    [sym_else_clause] = STATE(1938),
    [sym__dedent] = ACTIONS(3712),
    [sym__string_start] = ACTIONS(3712),
    [anon_sym_import] = ACTIONS(3714),
    [anon_sym_from] = ACTIONS(3714),
    [anon_sym_LPAREN] = ACTIONS(3712),
    [anon_sym_print] = ACTIONS(3714),
    [anon_sym_assert] = ACTIONS(3714),
    [anon_sym_return] = ACTIONS(3714),
    [anon_sym_del] = ACTIONS(3714),
    [anon_sym_raise] = ACTIONS(3714),
    [anon_sym_pass] = ACTIONS(3714),
    [anon_sym_break] = ACTIONS(3714),
    [anon_sym_continue] = ACTIONS(3714),
    [anon_sym_if] = ACTIONS(3714),
    [anon_sym_else] = ACTIONS(4009),
    [anon_sym_async] = ACTIONS(3714),
    [anon_sym_for] = ACTIONS(3714),
    [anon_sym_while] = ACTIONS(3714),
    [anon_sym_try] = ACTIONS(3714),
    [anon_sym_with] = ACTIONS(3714),
    [anon_sym_def] = ACTIONS(3714),
    [anon_sym_global] = ACTIONS(3714),
    [anon_sym_nonlocal] = ACTIONS(3714),
    [anon_sym_exec] = ACTIONS(3714),
    [anon_sym_class] = ACTIONS(3714),
    [anon_sym_AT] = ACTIONS(3712),
    [anon_sym_not] = ACTIONS(3714),
    [anon_sym_PLUS] = ACTIONS(3712),
    [anon_sym_DASH] = ACTIONS(3712),
    [anon_sym_TILDE] = ACTIONS(3712),
    [anon_sym_lambda] = ACTIONS(3714),
    [anon_sym_yield] = ACTIONS(3714),
    [anon_sym_LBRACK] = ACTIONS(3712),
    [sym_ellipsis] = ACTIONS(3712),
    [anon_sym_LBRACE] = ACTIONS(3712),
    [sym_integer] = ACTIONS(3714),
    [sym_float] = ACTIONS(3714),
    [sym_identifier] = ACTIONS(3714),
    [sym_true] = ACTIONS(3714),
    [sym_false] = ACTIONS(3714),
    [sym_none] = ACTIONS(3714),
    [anon_sym_await] = ACTIONS(3714),
    [sym_comment] = ACTIONS(73),
  },
  [1917] = {
    [sym__dedent] = ACTIONS(3737),
    [sym__string_start] = ACTIONS(3737),
    [anon_sym_import] = ACTIONS(3739),
    [anon_sym_from] = ACTIONS(3739),
    [anon_sym_LPAREN] = ACTIONS(3737),
    [anon_sym_print] = ACTIONS(3739),
    [anon_sym_assert] = ACTIONS(3739),
    [anon_sym_return] = ACTIONS(3739),
    [anon_sym_del] = ACTIONS(3739),
    [anon_sym_raise] = ACTIONS(3739),
    [anon_sym_pass] = ACTIONS(3739),
    [anon_sym_break] = ACTIONS(3739),
    [anon_sym_continue] = ACTIONS(3739),
    [anon_sym_if] = ACTIONS(3739),
    [anon_sym_else] = ACTIONS(3739),
    [anon_sym_async] = ACTIONS(3739),
    [anon_sym_for] = ACTIONS(3739),
    [anon_sym_while] = ACTIONS(3739),
    [anon_sym_try] = ACTIONS(3739),
    [anon_sym_except] = ACTIONS(3739),
    [anon_sym_finally] = ACTIONS(3739),
    [anon_sym_with] = ACTIONS(3739),
    [anon_sym_def] = ACTIONS(3739),
    [anon_sym_global] = ACTIONS(3739),
    [anon_sym_nonlocal] = ACTIONS(3739),
    [anon_sym_exec] = ACTIONS(3739),
    [anon_sym_class] = ACTIONS(3739),
    [anon_sym_AT] = ACTIONS(3737),
    [anon_sym_not] = ACTIONS(3739),
    [anon_sym_PLUS] = ACTIONS(3737),
    [anon_sym_DASH] = ACTIONS(3737),
    [anon_sym_TILDE] = ACTIONS(3737),
    [anon_sym_lambda] = ACTIONS(3739),
    [anon_sym_yield] = ACTIONS(3739),
    [anon_sym_LBRACK] = ACTIONS(3737),
    [sym_ellipsis] = ACTIONS(3737),
    [anon_sym_LBRACE] = ACTIONS(3737),
    [sym_integer] = ACTIONS(3739),
    [sym_float] = ACTIONS(3739),
    [sym_identifier] = ACTIONS(3739),
    [sym_true] = ACTIONS(3739),
    [sym_false] = ACTIONS(3739),
    [sym_none] = ACTIONS(3739),
    [anon_sym_await] = ACTIONS(3739),
    [sym_comment] = ACTIONS(73),
  },
  [1918] = {
    [sym__expression] = STATE(1939),
    [sym__primary_expression] = STATE(102),
    [sym_not_operator] = STATE(1939),
    [sym_boolean_operator] = STATE(1939),
    [sym_binary_operator] = STATE(102),
    [sym_unary_operator] = STATE(102),
    [sym_comparison_operator] = STATE(1939),
    [sym_lambda] = STATE(1939),
    [sym_attribute] = STATE(102),
    [sym_subscript] = STATE(102),
    [sym_call] = STATE(102),
    [sym_list] = STATE(102),
    [sym_list_comprehension] = STATE(102),
    [sym_dictionary] = STATE(102),
    [sym_dictionary_comprehension] = STATE(102),
    [sym_set] = STATE(102),
    [sym_set_comprehension] = STATE(102),
    [sym_parenthesized_expression] = STATE(102),
    [sym_tuple] = STATE(102),
    [sym_generator_expression] = STATE(102),
    [sym_conditional_expression] = STATE(1939),
    [sym_concatenated_string] = STATE(102),
    [sym_string] = STATE(103),
    [sym_await] = STATE(1939),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(171),
    [anon_sym_PLUS] = ACTIONS(173),
    [anon_sym_DASH] = ACTIONS(173),
    [anon_sym_TILDE] = ACTIONS(173),
    [anon_sym_lambda] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(177),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(179),
    [sym_float] = ACTIONS(179),
    [sym_identifier] = ACTIONS(179),
    [sym_true] = ACTIONS(179),
    [sym_false] = ACTIONS(179),
    [sym_none] = ACTIONS(179),
    [anon_sym_await] = ACTIONS(181),
    [sym_comment] = ACTIONS(73),
  },
  [1919] = {
    [sym__simple_statements] = STATE(1940),
    [sym_import_statement] = STATE(799),
    [sym_future_import_statement] = STATE(799),
    [sym_import_from_statement] = STATE(799),
    [sym_print_statement] = STATE(799),
    [sym_assert_statement] = STATE(799),
    [sym_expression_statement] = STATE(799),
    [sym_return_statement] = STATE(799),
    [sym_delete_statement] = STATE(799),
    [sym_raise_statement] = STATE(799),
    [sym_pass_statement] = STATE(799),
    [sym_break_statement] = STATE(799),
    [sym_continue_statement] = STATE(799),
    [sym_global_statement] = STATE(799),
    [sym_nonlocal_statement] = STATE(799),
    [sym_exec_statement] = STATE(799),
    [sym__suite] = STATE(1940),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(3719),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1920] = {
    [sym__dedent] = ACTIONS(3741),
    [sym__string_start] = ACTIONS(3741),
    [anon_sym_import] = ACTIONS(3743),
    [anon_sym_from] = ACTIONS(3743),
    [anon_sym_LPAREN] = ACTIONS(3741),
    [anon_sym_print] = ACTIONS(3743),
    [anon_sym_assert] = ACTIONS(3743),
    [anon_sym_return] = ACTIONS(3743),
    [anon_sym_del] = ACTIONS(3743),
    [anon_sym_raise] = ACTIONS(3743),
    [anon_sym_pass] = ACTIONS(3743),
    [anon_sym_break] = ACTIONS(3743),
    [anon_sym_continue] = ACTIONS(3743),
    [anon_sym_if] = ACTIONS(3743),
    [anon_sym_async] = ACTIONS(3743),
    [anon_sym_for] = ACTIONS(3743),
    [anon_sym_while] = ACTIONS(3743),
    [anon_sym_try] = ACTIONS(3743),
    [anon_sym_with] = ACTIONS(3743),
    [anon_sym_def] = ACTIONS(3743),
    [anon_sym_global] = ACTIONS(3743),
    [anon_sym_nonlocal] = ACTIONS(3743),
    [anon_sym_exec] = ACTIONS(3743),
    [anon_sym_class] = ACTIONS(3743),
    [anon_sym_AT] = ACTIONS(3741),
    [anon_sym_not] = ACTIONS(3743),
    [anon_sym_PLUS] = ACTIONS(3741),
    [anon_sym_DASH] = ACTIONS(3741),
    [anon_sym_TILDE] = ACTIONS(3741),
    [anon_sym_lambda] = ACTIONS(3743),
    [anon_sym_yield] = ACTIONS(3743),
    [anon_sym_LBRACK] = ACTIONS(3741),
    [sym_ellipsis] = ACTIONS(3741),
    [anon_sym_LBRACE] = ACTIONS(3741),
    [sym_integer] = ACTIONS(3743),
    [sym_float] = ACTIONS(3743),
    [sym_identifier] = ACTIONS(3743),
    [sym_true] = ACTIONS(3743),
    [sym_false] = ACTIONS(3743),
    [sym_none] = ACTIONS(3743),
    [anon_sym_await] = ACTIONS(3743),
    [sym_comment] = ACTIONS(73),
  },
  [1921] = {
    [sym__dedent] = ACTIONS(3745),
    [sym__string_start] = ACTIONS(3745),
    [anon_sym_import] = ACTIONS(3747),
    [anon_sym_from] = ACTIONS(3747),
    [anon_sym_LPAREN] = ACTIONS(3745),
    [anon_sym_print] = ACTIONS(3747),
    [anon_sym_assert] = ACTIONS(3747),
    [anon_sym_return] = ACTIONS(3747),
    [anon_sym_del] = ACTIONS(3747),
    [anon_sym_raise] = ACTIONS(3747),
    [anon_sym_pass] = ACTIONS(3747),
    [anon_sym_break] = ACTIONS(3747),
    [anon_sym_continue] = ACTIONS(3747),
    [anon_sym_if] = ACTIONS(3747),
    [anon_sym_async] = ACTIONS(3747),
    [anon_sym_for] = ACTIONS(3747),
    [anon_sym_while] = ACTIONS(3747),
    [anon_sym_try] = ACTIONS(3747),
    [anon_sym_with] = ACTIONS(3747),
    [anon_sym_def] = ACTIONS(3747),
    [anon_sym_global] = ACTIONS(3747),
    [anon_sym_nonlocal] = ACTIONS(3747),
    [anon_sym_exec] = ACTIONS(3747),
    [anon_sym_class] = ACTIONS(3747),
    [anon_sym_AT] = ACTIONS(3745),
    [anon_sym_not] = ACTIONS(3747),
    [anon_sym_PLUS] = ACTIONS(3745),
    [anon_sym_DASH] = ACTIONS(3745),
    [anon_sym_TILDE] = ACTIONS(3745),
    [anon_sym_lambda] = ACTIONS(3747),
    [anon_sym_yield] = ACTIONS(3747),
    [anon_sym_LBRACK] = ACTIONS(3745),
    [sym_ellipsis] = ACTIONS(3745),
    [anon_sym_LBRACE] = ACTIONS(3745),
    [sym_integer] = ACTIONS(3747),
    [sym_float] = ACTIONS(3747),
    [sym_identifier] = ACTIONS(3747),
    [sym_true] = ACTIONS(3747),
    [sym_false] = ACTIONS(3747),
    [sym_none] = ACTIONS(3747),
    [anon_sym_await] = ACTIONS(3747),
    [sym_comment] = ACTIONS(73),
  },
  [1922] = {
    [sym__simple_statements] = STATE(1941),
    [sym_import_statement] = STATE(799),
    [sym_future_import_statement] = STATE(799),
    [sym_import_from_statement] = STATE(799),
    [sym_print_statement] = STATE(799),
    [sym_assert_statement] = STATE(799),
    [sym_expression_statement] = STATE(799),
    [sym_return_statement] = STATE(799),
    [sym_delete_statement] = STATE(799),
    [sym_raise_statement] = STATE(799),
    [sym_pass_statement] = STATE(799),
    [sym_break_statement] = STATE(799),
    [sym_continue_statement] = STATE(799),
    [sym_global_statement] = STATE(799),
    [sym_nonlocal_statement] = STATE(799),
    [sym_exec_statement] = STATE(799),
    [sym__suite] = STATE(1941),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(3719),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1923] = {
    [sym__string_start] = ACTIONS(4220),
    [ts_builtin_sym_end] = ACTIONS(4220),
    [anon_sym_import] = ACTIONS(4222),
    [anon_sym_from] = ACTIONS(4222),
    [anon_sym_LPAREN] = ACTIONS(4220),
    [anon_sym_print] = ACTIONS(4222),
    [anon_sym_assert] = ACTIONS(4222),
    [anon_sym_return] = ACTIONS(4222),
    [anon_sym_del] = ACTIONS(4222),
    [anon_sym_raise] = ACTIONS(4222),
    [anon_sym_pass] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4222),
    [anon_sym_continue] = ACTIONS(4222),
    [anon_sym_if] = ACTIONS(4222),
    [anon_sym_else] = ACTIONS(4222),
    [anon_sym_async] = ACTIONS(4222),
    [anon_sym_for] = ACTIONS(4222),
    [anon_sym_while] = ACTIONS(4222),
    [anon_sym_try] = ACTIONS(4222),
    [anon_sym_except] = ACTIONS(4222),
    [anon_sym_finally] = ACTIONS(4222),
    [anon_sym_with] = ACTIONS(4222),
    [anon_sym_def] = ACTIONS(4222),
    [anon_sym_global] = ACTIONS(4222),
    [anon_sym_nonlocal] = ACTIONS(4222),
    [anon_sym_exec] = ACTIONS(4222),
    [anon_sym_class] = ACTIONS(4222),
    [anon_sym_AT] = ACTIONS(4220),
    [anon_sym_not] = ACTIONS(4222),
    [anon_sym_PLUS] = ACTIONS(4220),
    [anon_sym_DASH] = ACTIONS(4220),
    [anon_sym_TILDE] = ACTIONS(4220),
    [anon_sym_lambda] = ACTIONS(4222),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_LBRACK] = ACTIONS(4220),
    [sym_ellipsis] = ACTIONS(4220),
    [anon_sym_LBRACE] = ACTIONS(4220),
    [sym_integer] = ACTIONS(4222),
    [sym_float] = ACTIONS(4222),
    [sym_identifier] = ACTIONS(4222),
    [sym_true] = ACTIONS(4222),
    [sym_false] = ACTIONS(4222),
    [sym_none] = ACTIONS(4222),
    [anon_sym_await] = ACTIONS(4222),
    [sym_comment] = ACTIONS(73),
  },
  [1924] = {
    [anon_sym_RPAREN] = ACTIONS(3565),
    [anon_sym_COMMA] = ACTIONS(3565),
    [anon_sym_if] = ACTIONS(3225),
    [anon_sym_COLON] = ACTIONS(3565),
    [anon_sym_and] = ACTIONS(3227),
    [anon_sym_or] = ACTIONS(3229),
    [sym_comment] = ACTIONS(73),
  },
  [1925] = {
    [anon_sym_RPAREN] = ACTIONS(2647),
    [anon_sym_COMMA] = ACTIONS(2647),
    [anon_sym_if] = ACTIONS(3790),
    [anon_sym_EQ] = ACTIONS(2647),
    [anon_sym_and] = ACTIONS(3792),
    [anon_sym_or] = ACTIONS(3794),
    [sym_comment] = ACTIONS(73),
  },
  [1926] = {
    [sym__expression] = STATE(1942),
    [sym__primary_expression] = STATE(1561),
    [sym_not_operator] = STATE(1942),
    [sym_boolean_operator] = STATE(1942),
    [sym_binary_operator] = STATE(1561),
    [sym_unary_operator] = STATE(1561),
    [sym_comparison_operator] = STATE(1942),
    [sym_lambda] = STATE(1942),
    [sym_attribute] = STATE(1561),
    [sym_subscript] = STATE(1561),
    [sym_call] = STATE(1561),
    [sym_list] = STATE(1561),
    [sym_list_comprehension] = STATE(1561),
    [sym_dictionary] = STATE(1561),
    [sym_dictionary_comprehension] = STATE(1561),
    [sym_set] = STATE(1561),
    [sym_set_comprehension] = STATE(1561),
    [sym_parenthesized_expression] = STATE(1561),
    [sym_tuple] = STATE(1561),
    [sym_generator_expression] = STATE(1561),
    [sym_conditional_expression] = STATE(1942),
    [sym_concatenated_string] = STATE(1561),
    [sym_string] = STATE(1563),
    [sym_await] = STATE(1942),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(3261),
    [anon_sym_PLUS] = ACTIONS(3263),
    [anon_sym_DASH] = ACTIONS(3263),
    [anon_sym_TILDE] = ACTIONS(3263),
    [anon_sym_lambda] = ACTIONS(3265),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(3267),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(3269),
    [sym_float] = ACTIONS(3269),
    [sym_identifier] = ACTIONS(3269),
    [sym_true] = ACTIONS(3269),
    [sym_false] = ACTIONS(3269),
    [sym_none] = ACTIONS(3269),
    [anon_sym_await] = ACTIONS(3271),
    [sym_comment] = ACTIONS(73),
  },
  [1927] = {
    [sym_argument_list] = STATE(273),
    [sym_generator_expression] = STATE(273),
    [anon_sym_DOT] = ACTIONS(445),
    [anon_sym_LPAREN] = ACTIONS(447),
    [anon_sym_RPAREN] = ACTIONS(2942),
    [anon_sym_COMMA] = ACTIONS(2942),
    [anon_sym_STAR] = ACTIONS(3796),
    [anon_sym_GT_GT] = ACTIONS(3798),
    [anon_sym_if] = ACTIONS(2942),
    [anon_sym_in] = ACTIONS(2942),
    [anon_sym_EQ] = ACTIONS(2944),
    [anon_sym_AT] = ACTIONS(3802),
    [anon_sym_not] = ACTIONS(2942),
    [anon_sym_and] = ACTIONS(2942),
    [anon_sym_or] = ACTIONS(2942),
    [anon_sym_PLUS] = ACTIONS(3806),
    [anon_sym_DASH] = ACTIONS(3806),
    [anon_sym_SLASH] = ACTIONS(3796),
    [anon_sym_PERCENT] = ACTIONS(3802),
    [anon_sym_SLASH_SLASH] = ACTIONS(3802),
    [anon_sym_STAR_STAR] = ACTIONS(3808),
    [anon_sym_PIPE] = ACTIONS(3810),
    [anon_sym_AMP] = ACTIONS(3812),
    [anon_sym_CARET] = ACTIONS(3814),
    [anon_sym_LT_LT] = ACTIONS(3798),
    [anon_sym_LT] = ACTIONS(2944),
    [anon_sym_LT_EQ] = ACTIONS(2942),
    [anon_sym_EQ_EQ] = ACTIONS(2942),
    [anon_sym_BANG_EQ] = ACTIONS(2942),
    [anon_sym_GT_EQ] = ACTIONS(2942),
    [anon_sym_GT] = ACTIONS(2944),
    [anon_sym_LT_GT] = ACTIONS(2942),
    [anon_sym_is] = ACTIONS(2942),
    [anon_sym_LBRACK] = ACTIONS(473),
    [sym_comment] = ACTIONS(73),
  },
  [1928] = {
    [sym__expression_within_for_in_clause] = STATE(1836),
    [sym__expression] = STATE(1608),
    [sym__primary_expression] = STATE(152),
    [sym_not_operator] = STATE(1608),
    [sym_boolean_operator] = STATE(1608),
    [sym_binary_operator] = STATE(152),
    [sym_unary_operator] = STATE(152),
    [sym_comparison_operator] = STATE(1608),
    [sym_lambda] = STATE(1608),
    [sym_lambda_within_for_in_clause] = STATE(1836),
    [sym_attribute] = STATE(152),
    [sym_subscript] = STATE(152),
    [sym_call] = STATE(152),
    [sym_list] = STATE(152),
    [sym_list_comprehension] = STATE(152),
    [sym_dictionary] = STATE(152),
    [sym_dictionary_comprehension] = STATE(152),
    [sym_set] = STATE(152),
    [sym_set_comprehension] = STATE(152),
    [sym_parenthesized_expression] = STATE(152),
    [sym_tuple] = STATE(152),
    [sym_generator_expression] = STATE(152),
    [sym_conditional_expression] = STATE(1608),
    [sym_concatenated_string] = STATE(152),
    [sym_string] = STATE(153),
    [sym_await] = STATE(1608),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(4209),
    [anon_sym_async] = ACTIONS(4209),
    [anon_sym_for] = ACTIONS(4209),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_lambda] = ACTIONS(3399),
    [anon_sym_LBRACK] = ACTIONS(109),
    [anon_sym_RBRACK] = ACTIONS(4207),
    [sym_ellipsis] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(255),
    [sym_float] = ACTIONS(255),
    [sym_identifier] = ACTIONS(255),
    [sym_true] = ACTIONS(255),
    [sym_false] = ACTIONS(255),
    [sym_none] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [sym_comment] = ACTIONS(73),
  },
  [1929] = {
    [sym__expression_within_for_in_clause] = STATE(1836),
    [sym__expression] = STATE(1608),
    [sym__primary_expression] = STATE(152),
    [sym_not_operator] = STATE(1608),
    [sym_boolean_operator] = STATE(1608),
    [sym_binary_operator] = STATE(152),
    [sym_unary_operator] = STATE(152),
    [sym_comparison_operator] = STATE(1608),
    [sym_lambda] = STATE(1608),
    [sym_lambda_within_for_in_clause] = STATE(1836),
    [sym_attribute] = STATE(152),
    [sym_subscript] = STATE(152),
    [sym_call] = STATE(152),
    [sym_list] = STATE(152),
    [sym_list_comprehension] = STATE(152),
    [sym_dictionary] = STATE(152),
    [sym_dictionary_comprehension] = STATE(152),
    [sym_set] = STATE(152),
    [sym_set_comprehension] = STATE(152),
    [sym_parenthesized_expression] = STATE(152),
    [sym_tuple] = STATE(152),
    [sym_generator_expression] = STATE(152),
    [sym_conditional_expression] = STATE(1608),
    [sym_concatenated_string] = STATE(152),
    [sym_string] = STATE(153),
    [sym_await] = STATE(1608),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(245),
    [anon_sym_PLUS] = ACTIONS(247),
    [anon_sym_DASH] = ACTIONS(247),
    [anon_sym_TILDE] = ACTIONS(247),
    [anon_sym_lambda] = ACTIONS(3399),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(253),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(255),
    [sym_float] = ACTIONS(255),
    [sym_identifier] = ACTIONS(255),
    [sym_true] = ACTIONS(255),
    [sym_false] = ACTIONS(255),
    [sym_none] = ACTIONS(255),
    [anon_sym_await] = ACTIONS(257),
    [sym_comment] = ACTIONS(73),
  },
  [1930] = {
    [anon_sym_if] = ACTIONS(4093),
    [anon_sym_async] = ACTIONS(3565),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_and] = ACTIONS(3403),
    [anon_sym_or] = ACTIONS(3405),
    [anon_sym_RBRACK] = ACTIONS(3565),
    [sym_comment] = ACTIONS(73),
  },
  [1931] = {
    [sym__expression_within_for_in_clause] = STATE(1836),
    [sym__expression] = STATE(1649),
    [sym__primary_expression] = STATE(973),
    [sym_not_operator] = STATE(1649),
    [sym_boolean_operator] = STATE(1649),
    [sym_binary_operator] = STATE(973),
    [sym_unary_operator] = STATE(973),
    [sym_comparison_operator] = STATE(1649),
    [sym_lambda] = STATE(1649),
    [sym_lambda_within_for_in_clause] = STATE(1836),
    [sym_attribute] = STATE(973),
    [sym_subscript] = STATE(973),
    [sym_call] = STATE(973),
    [sym_list] = STATE(973),
    [sym_list_comprehension] = STATE(973),
    [sym_dictionary] = STATE(973),
    [sym_dictionary_comprehension] = STATE(973),
    [sym_set] = STATE(973),
    [sym_set_comprehension] = STATE(973),
    [sym_parenthesized_expression] = STATE(973),
    [sym_tuple] = STATE(973),
    [sym_generator_expression] = STATE(973),
    [sym_conditional_expression] = STATE(1649),
    [sym_concatenated_string] = STATE(973),
    [sym_string] = STATE(974),
    [sym_await] = STATE(1649),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_if] = ACTIONS(4209),
    [anon_sym_async] = ACTIONS(4209),
    [anon_sym_for] = ACTIONS(4209),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1814),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_DASH] = ACTIONS(1816),
    [anon_sym_TILDE] = ACTIONS(1816),
    [anon_sym_lambda] = ACTIONS(3502),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1820),
    [anon_sym_LBRACE] = ACTIONS(113),
    [anon_sym_RBRACE] = ACTIONS(4207),
    [sym_integer] = ACTIONS(1822),
    [sym_float] = ACTIONS(1822),
    [sym_identifier] = ACTIONS(1822),
    [sym_true] = ACTIONS(1822),
    [sym_false] = ACTIONS(1822),
    [sym_none] = ACTIONS(1822),
    [anon_sym_await] = ACTIONS(1824),
    [sym_comment] = ACTIONS(73),
  },
  [1932] = {
    [sym__expression_within_for_in_clause] = STATE(1836),
    [sym__expression] = STATE(1649),
    [sym__primary_expression] = STATE(973),
    [sym_not_operator] = STATE(1649),
    [sym_boolean_operator] = STATE(1649),
    [sym_binary_operator] = STATE(973),
    [sym_unary_operator] = STATE(973),
    [sym_comparison_operator] = STATE(1649),
    [sym_lambda] = STATE(1649),
    [sym_lambda_within_for_in_clause] = STATE(1836),
    [sym_attribute] = STATE(973),
    [sym_subscript] = STATE(973),
    [sym_call] = STATE(973),
    [sym_list] = STATE(973),
    [sym_list_comprehension] = STATE(973),
    [sym_dictionary] = STATE(973),
    [sym_dictionary_comprehension] = STATE(973),
    [sym_set] = STATE(973),
    [sym_set_comprehension] = STATE(973),
    [sym_parenthesized_expression] = STATE(973),
    [sym_tuple] = STATE(973),
    [sym_generator_expression] = STATE(973),
    [sym_conditional_expression] = STATE(1649),
    [sym_concatenated_string] = STATE(973),
    [sym_string] = STATE(974),
    [sym_await] = STATE(1649),
    [sym__string_start] = ACTIONS(91),
    [anon_sym_LPAREN] = ACTIONS(93),
    [anon_sym_print] = ACTIONS(99),
    [anon_sym_exec] = ACTIONS(99),
    [anon_sym_not] = ACTIONS(1814),
    [anon_sym_PLUS] = ACTIONS(1816),
    [anon_sym_DASH] = ACTIONS(1816),
    [anon_sym_TILDE] = ACTIONS(1816),
    [anon_sym_lambda] = ACTIONS(3502),
    [anon_sym_LBRACK] = ACTIONS(109),
    [sym_ellipsis] = ACTIONS(1820),
    [anon_sym_LBRACE] = ACTIONS(113),
    [sym_integer] = ACTIONS(1822),
    [sym_float] = ACTIONS(1822),
    [sym_identifier] = ACTIONS(1822),
    [sym_true] = ACTIONS(1822),
    [sym_false] = ACTIONS(1822),
    [sym_none] = ACTIONS(1822),
    [anon_sym_await] = ACTIONS(1824),
    [sym_comment] = ACTIONS(73),
  },
  [1933] = {
    [anon_sym_if] = ACTIONS(4117),
    [anon_sym_async] = ACTIONS(3565),
    [anon_sym_for] = ACTIONS(3565),
    [anon_sym_and] = ACTIONS(3506),
    [anon_sym_or] = ACTIONS(3508),
    [anon_sym_RBRACE] = ACTIONS(3565),
    [sym_comment] = ACTIONS(73),
  },
  [1934] = {
    [sym__simple_statements] = STATE(1943),
    [sym_import_statement] = STATE(799),
    [sym_future_import_statement] = STATE(799),
    [sym_import_from_statement] = STATE(799),
    [sym_print_statement] = STATE(799),
    [sym_assert_statement] = STATE(799),
    [sym_expression_statement] = STATE(799),
    [sym_return_statement] = STATE(799),
    [sym_delete_statement] = STATE(799),
    [sym_raise_statement] = STATE(799),
    [sym_pass_statement] = STATE(799),
    [sym_break_statement] = STATE(799),
    [sym_continue_statement] = STATE(799),
    [sym_global_statement] = STATE(799),
    [sym_nonlocal_statement] = STATE(799),
    [sym_exec_statement] = STATE(799),
    [sym__suite] = STATE(1943),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(3719),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1935] = {
    [sym__dedent] = ACTIONS(3997),
    [sym__string_start] = ACTIONS(3997),
    [anon_sym_import] = ACTIONS(3999),
    [anon_sym_from] = ACTIONS(3999),
    [anon_sym_LPAREN] = ACTIONS(3997),
    [anon_sym_print] = ACTIONS(3999),
    [anon_sym_assert] = ACTIONS(3999),
    [anon_sym_return] = ACTIONS(3999),
    [anon_sym_del] = ACTIONS(3999),
    [anon_sym_raise] = ACTIONS(3999),
    [anon_sym_pass] = ACTIONS(3999),
    [anon_sym_break] = ACTIONS(3999),
    [anon_sym_continue] = ACTIONS(3999),
    [anon_sym_if] = ACTIONS(3999),
    [anon_sym_async] = ACTIONS(3999),
    [anon_sym_for] = ACTIONS(3999),
    [anon_sym_while] = ACTIONS(3999),
    [anon_sym_try] = ACTIONS(3999),
    [anon_sym_finally] = ACTIONS(3999),
    [anon_sym_with] = ACTIONS(3999),
    [anon_sym_def] = ACTIONS(3999),
    [anon_sym_global] = ACTIONS(3999),
    [anon_sym_nonlocal] = ACTIONS(3999),
    [anon_sym_exec] = ACTIONS(3999),
    [anon_sym_class] = ACTIONS(3999),
    [anon_sym_AT] = ACTIONS(3997),
    [anon_sym_not] = ACTIONS(3999),
    [anon_sym_PLUS] = ACTIONS(3997),
    [anon_sym_DASH] = ACTIONS(3997),
    [anon_sym_TILDE] = ACTIONS(3997),
    [anon_sym_lambda] = ACTIONS(3999),
    [anon_sym_yield] = ACTIONS(3999),
    [anon_sym_LBRACK] = ACTIONS(3997),
    [sym_ellipsis] = ACTIONS(3997),
    [anon_sym_LBRACE] = ACTIONS(3997),
    [sym_integer] = ACTIONS(3999),
    [sym_float] = ACTIONS(3999),
    [sym_identifier] = ACTIONS(3999),
    [sym_true] = ACTIONS(3999),
    [sym_false] = ACTIONS(3999),
    [sym_none] = ACTIONS(3999),
    [anon_sym_await] = ACTIONS(3999),
    [sym_comment] = ACTIONS(73),
  },
  [1936] = {
    [sym_else_clause] = STATE(1944),
    [sym__dedent] = ACTIONS(4001),
    [sym__string_start] = ACTIONS(4001),
    [anon_sym_import] = ACTIONS(4003),
    [anon_sym_from] = ACTIONS(4003),
    [anon_sym_LPAREN] = ACTIONS(4001),
    [anon_sym_print] = ACTIONS(4003),
    [anon_sym_assert] = ACTIONS(4003),
    [anon_sym_return] = ACTIONS(4003),
    [anon_sym_del] = ACTIONS(4003),
    [anon_sym_raise] = ACTIONS(4003),
    [anon_sym_pass] = ACTIONS(4003),
    [anon_sym_break] = ACTIONS(4003),
    [anon_sym_continue] = ACTIONS(4003),
    [anon_sym_if] = ACTIONS(4003),
    [anon_sym_else] = ACTIONS(4009),
    [anon_sym_async] = ACTIONS(4003),
    [anon_sym_for] = ACTIONS(4003),
    [anon_sym_while] = ACTIONS(4003),
    [anon_sym_try] = ACTIONS(4003),
    [anon_sym_with] = ACTIONS(4003),
    [anon_sym_def] = ACTIONS(4003),
    [anon_sym_global] = ACTIONS(4003),
    [anon_sym_nonlocal] = ACTIONS(4003),
    [anon_sym_exec] = ACTIONS(4003),
    [anon_sym_class] = ACTIONS(4003),
    [anon_sym_AT] = ACTIONS(4001),
    [anon_sym_not] = ACTIONS(4003),
    [anon_sym_PLUS] = ACTIONS(4001),
    [anon_sym_DASH] = ACTIONS(4001),
    [anon_sym_TILDE] = ACTIONS(4001),
    [anon_sym_lambda] = ACTIONS(4003),
    [anon_sym_yield] = ACTIONS(4003),
    [anon_sym_LBRACK] = ACTIONS(4001),
    [sym_ellipsis] = ACTIONS(4001),
    [anon_sym_LBRACE] = ACTIONS(4001),
    [sym_integer] = ACTIONS(4003),
    [sym_float] = ACTIONS(4003),
    [sym_identifier] = ACTIONS(4003),
    [sym_true] = ACTIONS(4003),
    [sym_false] = ACTIONS(4003),
    [sym_none] = ACTIONS(4003),
    [anon_sym_await] = ACTIONS(4003),
    [sym_comment] = ACTIONS(73),
  },
  [1937] = {
    [sym__simple_statements] = STATE(1945),
    [sym_import_statement] = STATE(799),
    [sym_future_import_statement] = STATE(799),
    [sym_import_from_statement] = STATE(799),
    [sym_print_statement] = STATE(799),
    [sym_assert_statement] = STATE(799),
    [sym_expression_statement] = STATE(799),
    [sym_return_statement] = STATE(799),
    [sym_delete_statement] = STATE(799),
    [sym_raise_statement] = STATE(799),
    [sym_pass_statement] = STATE(799),
    [sym_break_statement] = STATE(799),
    [sym_continue_statement] = STATE(799),
    [sym_global_statement] = STATE(799),
    [sym_nonlocal_statement] = STATE(799),
    [sym_exec_statement] = STATE(799),
    [sym__suite] = STATE(1945),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(3719),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1938] = {
    [sym__dedent] = ACTIONS(4001),
    [sym__string_start] = ACTIONS(4001),
    [anon_sym_import] = ACTIONS(4003),
    [anon_sym_from] = ACTIONS(4003),
    [anon_sym_LPAREN] = ACTIONS(4001),
    [anon_sym_print] = ACTIONS(4003),
    [anon_sym_assert] = ACTIONS(4003),
    [anon_sym_return] = ACTIONS(4003),
    [anon_sym_del] = ACTIONS(4003),
    [anon_sym_raise] = ACTIONS(4003),
    [anon_sym_pass] = ACTIONS(4003),
    [anon_sym_break] = ACTIONS(4003),
    [anon_sym_continue] = ACTIONS(4003),
    [anon_sym_if] = ACTIONS(4003),
    [anon_sym_async] = ACTIONS(4003),
    [anon_sym_for] = ACTIONS(4003),
    [anon_sym_while] = ACTIONS(4003),
    [anon_sym_try] = ACTIONS(4003),
    [anon_sym_with] = ACTIONS(4003),
    [anon_sym_def] = ACTIONS(4003),
    [anon_sym_global] = ACTIONS(4003),
    [anon_sym_nonlocal] = ACTIONS(4003),
    [anon_sym_exec] = ACTIONS(4003),
    [anon_sym_class] = ACTIONS(4003),
    [anon_sym_AT] = ACTIONS(4001),
    [anon_sym_not] = ACTIONS(4003),
    [anon_sym_PLUS] = ACTIONS(4001),
    [anon_sym_DASH] = ACTIONS(4001),
    [anon_sym_TILDE] = ACTIONS(4001),
    [anon_sym_lambda] = ACTIONS(4003),
    [anon_sym_yield] = ACTIONS(4003),
    [anon_sym_LBRACK] = ACTIONS(4001),
    [sym_ellipsis] = ACTIONS(4001),
    [anon_sym_LBRACE] = ACTIONS(4001),
    [sym_integer] = ACTIONS(4003),
    [sym_float] = ACTIONS(4003),
    [sym_identifier] = ACTIONS(4003),
    [sym_true] = ACTIONS(4003),
    [sym_false] = ACTIONS(4003),
    [sym_none] = ACTIONS(4003),
    [anon_sym_await] = ACTIONS(4003),
    [sym_comment] = ACTIONS(73),
  },
  [1939] = {
    [anon_sym_if] = ACTIONS(599),
    [anon_sym_COLON] = ACTIONS(4224),
    [anon_sym_and] = ACTIONS(603),
    [anon_sym_or] = ACTIONS(605),
    [sym_comment] = ACTIONS(73),
  },
  [1940] = {
    [sym__dedent] = ACTIONS(4029),
    [sym__string_start] = ACTIONS(4029),
    [anon_sym_import] = ACTIONS(4031),
    [anon_sym_from] = ACTIONS(4031),
    [anon_sym_LPAREN] = ACTIONS(4029),
    [anon_sym_print] = ACTIONS(4031),
    [anon_sym_assert] = ACTIONS(4031),
    [anon_sym_return] = ACTIONS(4031),
    [anon_sym_del] = ACTIONS(4031),
    [anon_sym_raise] = ACTIONS(4031),
    [anon_sym_pass] = ACTIONS(4031),
    [anon_sym_break] = ACTIONS(4031),
    [anon_sym_continue] = ACTIONS(4031),
    [anon_sym_if] = ACTIONS(4031),
    [anon_sym_else] = ACTIONS(4031),
    [anon_sym_async] = ACTIONS(4031),
    [anon_sym_for] = ACTIONS(4031),
    [anon_sym_while] = ACTIONS(4031),
    [anon_sym_try] = ACTIONS(4031),
    [anon_sym_except] = ACTIONS(4031),
    [anon_sym_finally] = ACTIONS(4031),
    [anon_sym_with] = ACTIONS(4031),
    [anon_sym_def] = ACTIONS(4031),
    [anon_sym_global] = ACTIONS(4031),
    [anon_sym_nonlocal] = ACTIONS(4031),
    [anon_sym_exec] = ACTIONS(4031),
    [anon_sym_class] = ACTIONS(4031),
    [anon_sym_AT] = ACTIONS(4029),
    [anon_sym_not] = ACTIONS(4031),
    [anon_sym_PLUS] = ACTIONS(4029),
    [anon_sym_DASH] = ACTIONS(4029),
    [anon_sym_TILDE] = ACTIONS(4029),
    [anon_sym_lambda] = ACTIONS(4031),
    [anon_sym_yield] = ACTIONS(4031),
    [anon_sym_LBRACK] = ACTIONS(4029),
    [sym_ellipsis] = ACTIONS(4029),
    [anon_sym_LBRACE] = ACTIONS(4029),
    [sym_integer] = ACTIONS(4031),
    [sym_float] = ACTIONS(4031),
    [sym_identifier] = ACTIONS(4031),
    [sym_true] = ACTIONS(4031),
    [sym_false] = ACTIONS(4031),
    [sym_none] = ACTIONS(4031),
    [anon_sym_await] = ACTIONS(4031),
    [sym_comment] = ACTIONS(73),
  },
  [1941] = {
    [sym__dedent] = ACTIONS(4085),
    [sym__string_start] = ACTIONS(4085),
    [anon_sym_import] = ACTIONS(4087),
    [anon_sym_from] = ACTIONS(4087),
    [anon_sym_LPAREN] = ACTIONS(4085),
    [anon_sym_print] = ACTIONS(4087),
    [anon_sym_assert] = ACTIONS(4087),
    [anon_sym_return] = ACTIONS(4087),
    [anon_sym_del] = ACTIONS(4087),
    [anon_sym_raise] = ACTIONS(4087),
    [anon_sym_pass] = ACTIONS(4087),
    [anon_sym_break] = ACTIONS(4087),
    [anon_sym_continue] = ACTIONS(4087),
    [anon_sym_if] = ACTIONS(4087),
    [anon_sym_async] = ACTIONS(4087),
    [anon_sym_for] = ACTIONS(4087),
    [anon_sym_while] = ACTIONS(4087),
    [anon_sym_try] = ACTIONS(4087),
    [anon_sym_with] = ACTIONS(4087),
    [anon_sym_def] = ACTIONS(4087),
    [anon_sym_global] = ACTIONS(4087),
    [anon_sym_nonlocal] = ACTIONS(4087),
    [anon_sym_exec] = ACTIONS(4087),
    [anon_sym_class] = ACTIONS(4087),
    [anon_sym_AT] = ACTIONS(4085),
    [anon_sym_not] = ACTIONS(4087),
    [anon_sym_PLUS] = ACTIONS(4085),
    [anon_sym_DASH] = ACTIONS(4085),
    [anon_sym_TILDE] = ACTIONS(4085),
    [anon_sym_lambda] = ACTIONS(4087),
    [anon_sym_yield] = ACTIONS(4087),
    [anon_sym_LBRACK] = ACTIONS(4085),
    [sym_ellipsis] = ACTIONS(4085),
    [anon_sym_LBRACE] = ACTIONS(4085),
    [sym_integer] = ACTIONS(4087),
    [sym_float] = ACTIONS(4087),
    [sym_identifier] = ACTIONS(4087),
    [sym_true] = ACTIONS(4087),
    [sym_false] = ACTIONS(4087),
    [sym_none] = ACTIONS(4087),
    [anon_sym_await] = ACTIONS(4087),
    [sym_comment] = ACTIONS(73),
  },
  [1942] = {
    [anon_sym_RPAREN] = ACTIONS(3565),
    [anon_sym_COMMA] = ACTIONS(3565),
    [anon_sym_if] = ACTIONS(3790),
    [anon_sym_EQ] = ACTIONS(3565),
    [anon_sym_and] = ACTIONS(3792),
    [anon_sym_or] = ACTIONS(3794),
    [sym_comment] = ACTIONS(73),
  },
  [1943] = {
    [sym__dedent] = ACTIONS(4152),
    [sym__string_start] = ACTIONS(4152),
    [anon_sym_import] = ACTIONS(4154),
    [anon_sym_from] = ACTIONS(4154),
    [anon_sym_LPAREN] = ACTIONS(4152),
    [anon_sym_print] = ACTIONS(4154),
    [anon_sym_assert] = ACTIONS(4154),
    [anon_sym_return] = ACTIONS(4154),
    [anon_sym_del] = ACTIONS(4154),
    [anon_sym_raise] = ACTIONS(4154),
    [anon_sym_pass] = ACTIONS(4154),
    [anon_sym_break] = ACTIONS(4154),
    [anon_sym_continue] = ACTIONS(4154),
    [anon_sym_if] = ACTIONS(4154),
    [anon_sym_elif] = ACTIONS(4154),
    [anon_sym_else] = ACTIONS(4154),
    [anon_sym_async] = ACTIONS(4154),
    [anon_sym_for] = ACTIONS(4154),
    [anon_sym_while] = ACTIONS(4154),
    [anon_sym_try] = ACTIONS(4154),
    [anon_sym_with] = ACTIONS(4154),
    [anon_sym_def] = ACTIONS(4154),
    [anon_sym_global] = ACTIONS(4154),
    [anon_sym_nonlocal] = ACTIONS(4154),
    [anon_sym_exec] = ACTIONS(4154),
    [anon_sym_class] = ACTIONS(4154),
    [anon_sym_AT] = ACTIONS(4152),
    [anon_sym_not] = ACTIONS(4154),
    [anon_sym_PLUS] = ACTIONS(4152),
    [anon_sym_DASH] = ACTIONS(4152),
    [anon_sym_TILDE] = ACTIONS(4152),
    [anon_sym_lambda] = ACTIONS(4154),
    [anon_sym_yield] = ACTIONS(4154),
    [anon_sym_LBRACK] = ACTIONS(4152),
    [sym_ellipsis] = ACTIONS(4152),
    [anon_sym_LBRACE] = ACTIONS(4152),
    [sym_integer] = ACTIONS(4154),
    [sym_float] = ACTIONS(4154),
    [sym_identifier] = ACTIONS(4154),
    [sym_true] = ACTIONS(4154),
    [sym_false] = ACTIONS(4154),
    [sym_none] = ACTIONS(4154),
    [anon_sym_await] = ACTIONS(4154),
    [sym_comment] = ACTIONS(73),
  },
  [1944] = {
    [sym__dedent] = ACTIONS(4156),
    [sym__string_start] = ACTIONS(4156),
    [anon_sym_import] = ACTIONS(4158),
    [anon_sym_from] = ACTIONS(4158),
    [anon_sym_LPAREN] = ACTIONS(4156),
    [anon_sym_print] = ACTIONS(4158),
    [anon_sym_assert] = ACTIONS(4158),
    [anon_sym_return] = ACTIONS(4158),
    [anon_sym_del] = ACTIONS(4158),
    [anon_sym_raise] = ACTIONS(4158),
    [anon_sym_pass] = ACTIONS(4158),
    [anon_sym_break] = ACTIONS(4158),
    [anon_sym_continue] = ACTIONS(4158),
    [anon_sym_if] = ACTIONS(4158),
    [anon_sym_async] = ACTIONS(4158),
    [anon_sym_for] = ACTIONS(4158),
    [anon_sym_while] = ACTIONS(4158),
    [anon_sym_try] = ACTIONS(4158),
    [anon_sym_with] = ACTIONS(4158),
    [anon_sym_def] = ACTIONS(4158),
    [anon_sym_global] = ACTIONS(4158),
    [anon_sym_nonlocal] = ACTIONS(4158),
    [anon_sym_exec] = ACTIONS(4158),
    [anon_sym_class] = ACTIONS(4158),
    [anon_sym_AT] = ACTIONS(4156),
    [anon_sym_not] = ACTIONS(4158),
    [anon_sym_PLUS] = ACTIONS(4156),
    [anon_sym_DASH] = ACTIONS(4156),
    [anon_sym_TILDE] = ACTIONS(4156),
    [anon_sym_lambda] = ACTIONS(4158),
    [anon_sym_yield] = ACTIONS(4158),
    [anon_sym_LBRACK] = ACTIONS(4156),
    [sym_ellipsis] = ACTIONS(4156),
    [anon_sym_LBRACE] = ACTIONS(4156),
    [sym_integer] = ACTIONS(4158),
    [sym_float] = ACTIONS(4158),
    [sym_identifier] = ACTIONS(4158),
    [sym_true] = ACTIONS(4158),
    [sym_false] = ACTIONS(4158),
    [sym_none] = ACTIONS(4158),
    [anon_sym_await] = ACTIONS(4158),
    [sym_comment] = ACTIONS(73),
  },
  [1945] = {
    [sym__dedent] = ACTIONS(4160),
    [sym__string_start] = ACTIONS(4160),
    [anon_sym_import] = ACTIONS(4162),
    [anon_sym_from] = ACTIONS(4162),
    [anon_sym_LPAREN] = ACTIONS(4160),
    [anon_sym_print] = ACTIONS(4162),
    [anon_sym_assert] = ACTIONS(4162),
    [anon_sym_return] = ACTIONS(4162),
    [anon_sym_del] = ACTIONS(4162),
    [anon_sym_raise] = ACTIONS(4162),
    [anon_sym_pass] = ACTIONS(4162),
    [anon_sym_break] = ACTIONS(4162),
    [anon_sym_continue] = ACTIONS(4162),
    [anon_sym_if] = ACTIONS(4162),
    [anon_sym_async] = ACTIONS(4162),
    [anon_sym_for] = ACTIONS(4162),
    [anon_sym_while] = ACTIONS(4162),
    [anon_sym_try] = ACTIONS(4162),
    [anon_sym_with] = ACTIONS(4162),
    [anon_sym_def] = ACTIONS(4162),
    [anon_sym_global] = ACTIONS(4162),
    [anon_sym_nonlocal] = ACTIONS(4162),
    [anon_sym_exec] = ACTIONS(4162),
    [anon_sym_class] = ACTIONS(4162),
    [anon_sym_AT] = ACTIONS(4160),
    [anon_sym_not] = ACTIONS(4162),
    [anon_sym_PLUS] = ACTIONS(4160),
    [anon_sym_DASH] = ACTIONS(4160),
    [anon_sym_TILDE] = ACTIONS(4160),
    [anon_sym_lambda] = ACTIONS(4162),
    [anon_sym_yield] = ACTIONS(4162),
    [anon_sym_LBRACK] = ACTIONS(4160),
    [sym_ellipsis] = ACTIONS(4160),
    [anon_sym_LBRACE] = ACTIONS(4160),
    [sym_integer] = ACTIONS(4162),
    [sym_float] = ACTIONS(4162),
    [sym_identifier] = ACTIONS(4162),
    [sym_true] = ACTIONS(4162),
    [sym_false] = ACTIONS(4162),
    [sym_none] = ACTIONS(4162),
    [anon_sym_await] = ACTIONS(4162),
    [sym_comment] = ACTIONS(73),
  },
  [1946] = {
    [sym__simple_statements] = STATE(1947),
    [sym_import_statement] = STATE(799),
    [sym_future_import_statement] = STATE(799),
    [sym_import_from_statement] = STATE(799),
    [sym_print_statement] = STATE(799),
    [sym_assert_statement] = STATE(799),
    [sym_expression_statement] = STATE(799),
    [sym_return_statement] = STATE(799),
    [sym_delete_statement] = STATE(799),
    [sym_raise_statement] = STATE(799),
    [sym_pass_statement] = STATE(799),
    [sym_break_statement] = STATE(799),
    [sym_continue_statement] = STATE(799),
    [sym_global_statement] = STATE(799),
    [sym_nonlocal_statement] = STATE(799),
    [sym_exec_statement] = STATE(799),
    [sym__suite] = STATE(1947),
    [sym_expression_list] = STATE(35),
    [sym__expression] = STATE(36),
    [sym__primary_expression] = STATE(37),
    [sym_not_operator] = STATE(36),
    [sym_boolean_operator] = STATE(36),
    [sym_binary_operator] = STATE(37),
    [sym_unary_operator] = STATE(37),
    [sym_comparison_operator] = STATE(36),
    [sym_lambda] = STATE(36),
    [sym_assignment] = STATE(38),
    [sym_augmented_assignment] = STATE(38),
    [sym_yield] = STATE(38),
    [sym_attribute] = STATE(37),
    [sym_subscript] = STATE(37),
    [sym_call] = STATE(37),
    [sym_list] = STATE(37),
    [sym_list_comprehension] = STATE(37),
    [sym_dictionary] = STATE(37),
    [sym_dictionary_comprehension] = STATE(37),
    [sym_set] = STATE(37),
    [sym_set_comprehension] = STATE(37),
    [sym_parenthesized_expression] = STATE(37),
    [sym_tuple] = STATE(37),
    [sym_generator_expression] = STATE(37),
    [sym_conditional_expression] = STATE(36),
    [sym_concatenated_string] = STATE(37),
    [sym_string] = STATE(39),
    [sym_await] = STATE(36),
    [sym__indent] = ACTIONS(3719),
    [sym__string_start] = ACTIONS(5),
    [anon_sym_import] = ACTIONS(9),
    [anon_sym_from] = ACTIONS(11),
    [anon_sym_LPAREN] = ACTIONS(13),
    [anon_sym_print] = ACTIONS(15),
    [anon_sym_assert] = ACTIONS(17),
    [anon_sym_return] = ACTIONS(19),
    [anon_sym_del] = ACTIONS(21),
    [anon_sym_raise] = ACTIONS(23),
    [anon_sym_pass] = ACTIONS(25),
    [anon_sym_break] = ACTIONS(27),
    [anon_sym_continue] = ACTIONS(29),
    [anon_sym_global] = ACTIONS(45),
    [anon_sym_nonlocal] = ACTIONS(47),
    [anon_sym_exec] = ACTIONS(49),
    [anon_sym_not] = ACTIONS(55),
    [anon_sym_PLUS] = ACTIONS(57),
    [anon_sym_DASH] = ACTIONS(57),
    [anon_sym_TILDE] = ACTIONS(57),
    [anon_sym_lambda] = ACTIONS(59),
    [anon_sym_yield] = ACTIONS(61),
    [anon_sym_LBRACK] = ACTIONS(63),
    [sym_ellipsis] = ACTIONS(65),
    [anon_sym_LBRACE] = ACTIONS(67),
    [sym_integer] = ACTIONS(69),
    [sym_float] = ACTIONS(69),
    [sym_identifier] = ACTIONS(69),
    [sym_true] = ACTIONS(69),
    [sym_false] = ACTIONS(69),
    [sym_none] = ACTIONS(69),
    [anon_sym_await] = ACTIONS(71),
    [sym_comment] = ACTIONS(73),
  },
  [1947] = {
    [sym__dedent] = ACTIONS(4220),
    [sym__string_start] = ACTIONS(4220),
    [anon_sym_import] = ACTIONS(4222),
    [anon_sym_from] = ACTIONS(4222),
    [anon_sym_LPAREN] = ACTIONS(4220),
    [anon_sym_print] = ACTIONS(4222),
    [anon_sym_assert] = ACTIONS(4222),
    [anon_sym_return] = ACTIONS(4222),
    [anon_sym_del] = ACTIONS(4222),
    [anon_sym_raise] = ACTIONS(4222),
    [anon_sym_pass] = ACTIONS(4222),
    [anon_sym_break] = ACTIONS(4222),
    [anon_sym_continue] = ACTIONS(4222),
    [anon_sym_if] = ACTIONS(4222),
    [anon_sym_else] = ACTIONS(4222),
    [anon_sym_async] = ACTIONS(4222),
    [anon_sym_for] = ACTIONS(4222),
    [anon_sym_while] = ACTIONS(4222),
    [anon_sym_try] = ACTIONS(4222),
    [anon_sym_except] = ACTIONS(4222),
    [anon_sym_finally] = ACTIONS(4222),
    [anon_sym_with] = ACTIONS(4222),
    [anon_sym_def] = ACTIONS(4222),
    [anon_sym_global] = ACTIONS(4222),
    [anon_sym_nonlocal] = ACTIONS(4222),
    [anon_sym_exec] = ACTIONS(4222),
    [anon_sym_class] = ACTIONS(4222),
    [anon_sym_AT] = ACTIONS(4220),
    [anon_sym_not] = ACTIONS(4222),
    [anon_sym_PLUS] = ACTIONS(4220),
    [anon_sym_DASH] = ACTIONS(4220),
    [anon_sym_TILDE] = ACTIONS(4220),
    [anon_sym_lambda] = ACTIONS(4222),
    [anon_sym_yield] = ACTIONS(4222),
    [anon_sym_LBRACK] = ACTIONS(4220),
    [sym_ellipsis] = ACTIONS(4220),
    [anon_sym_LBRACE] = ACTIONS(4220),
    [sym_integer] = ACTIONS(4222),
    [sym_float] = ACTIONS(4222),
    [sym_identifier] = ACTIONS(4222),
    [sym_true] = ACTIONS(4222),
    [sym_false] = ACTIONS(4222),
    [sym_none] = ACTIONS(4222),
    [anon_sym_await] = ACTIONS(4222),
    [sym_comment] = ACTIONS(73),
  },
};

static TSParseActionEntry ts_parse_actions[] = {
  [0] = {.count = 0, .reusable = false},
  [1] = {.count = 1, .reusable = true}, RECOVER(),
  [3] = {.count = 1, .reusable = false}, RECOVER(),
  [5] = {.count = 1, .reusable = true}, SHIFT(2),
  [7] = {.count = 1, .reusable = true}, REDUCE(sym_module, 0),
  [9] = {.count = 1, .reusable = false}, SHIFT(3),
  [11] = {.count = 1, .reusable = false}, SHIFT(4),
  [13] = {.count = 1, .reusable = true}, SHIFT(5),
  [15] = {.count = 1, .reusable = false}, SHIFT(6),
  [17] = {.count = 1, .reusable = false}, SHIFT(7),
  [19] = {.count = 1, .reusable = false}, SHIFT(8),
  [21] = {.count = 1, .reusable = false}, SHIFT(9),
  [23] = {.count = 1, .reusable = false}, SHIFT(10),
  [25] = {.count = 1, .reusable = false}, SHIFT(11),
  [27] = {.count = 1, .reusable = false}, SHIFT(12),
  [29] = {.count = 1, .reusable = false}, SHIFT(13),
  [31] = {.count = 1, .reusable = false}, SHIFT(14),
  [33] = {.count = 1, .reusable = false}, SHIFT(15),
  [35] = {.count = 1, .reusable = false}, SHIFT(16),
  [37] = {.count = 1, .reusable = false}, SHIFT(17),
  [39] = {.count = 1, .reusable = false}, SHIFT(18),
  [41] = {.count = 1, .reusable = false}, SHIFT(19),
  [43] = {.count = 1, .reusable = false}, SHIFT(20),
  [45] = {.count = 1, .reusable = false}, SHIFT(21),
  [47] = {.count = 1, .reusable = false}, SHIFT(22),
  [49] = {.count = 1, .reusable = false}, SHIFT(23),
  [51] = {.count = 1, .reusable = false}, SHIFT(24),
  [53] = {.count = 1, .reusable = true}, SHIFT(25),
  [55] = {.count = 1, .reusable = false}, SHIFT(26),
  [57] = {.count = 1, .reusable = true}, SHIFT(27),
  [59] = {.count = 1, .reusable = false}, SHIFT(28),
  [61] = {.count = 1, .reusable = false}, SHIFT(29),
  [63] = {.count = 1, .reusable = true}, SHIFT(30),
  [65] = {.count = 1, .reusable = true}, SHIFT(37),
  [67] = {.count = 1, .reusable = true}, SHIFT(31),
  [69] = {.count = 1, .reusable = false}, SHIFT(37),
  [71] = {.count = 1, .reusable = false}, SHIFT(32),
  [73] = {.count = 1, .reusable = true}, SHIFT_EXTRA(),
  [75] = {.count = 1, .reusable = true}, SHIFT(44),
  [77] = {.count = 1, .reusable = true}, SHIFT(42),
  [79] = {.count = 1, .reusable = false}, SHIFT(43),
  [81] = {.count = 1, .reusable = false}, SHIFT_EXTRA(),
  [83] = {.count = 1, .reusable = true}, SHIFT(45),
  [85] = {.count = 1, .reusable = true}, SHIFT(53),
  [87] = {.count = 1, .reusable = false}, SHIFT(49),
  [89] = {.count = 1, .reusable = false}, SHIFT(50),
  [91] = {.count = 1, .reusable = true}, SHIFT(54),
  [93] = {.count = 1, .reusable = true}, SHIFT(55),
  [95] = {.count = 1, .reusable = true}, SHIFT(56),
  [97] = {.count = 1, .reusable = true}, SHIFT(57),
  [99] = {.count = 1, .reusable = false}, SHIFT(58),
  [101] = {.count = 1, .reusable = false}, SHIFT(59),
  [103] = {.count = 1, .reusable = true}, SHIFT(60),
  [105] = {.count = 1, .reusable = false}, SHIFT(61),
  [107] = {.count = 1, .reusable = false}, SHIFT(62),
  [109] = {.count = 1, .reusable = true}, SHIFT(63),
  [111] = {.count = 1, .reusable = true}, SHIFT(67),
  [113] = {.count = 1, .reusable = true}, SHIFT(64),
  [115] = {.count = 1, .reusable = false}, SHIFT(67),
  [117] = {.count = 1, .reusable = false}, SHIFT(65),
  [119] = {.count = 1, .reusable = true}, REDUCE(sym__primary_expression, 1, .alias_sequence_id = 1),
  [121] = {.count = 1, .reusable = true}, SHIFT(70),
  [123] = {.count = 1, .reusable = false}, REDUCE(sym__primary_expression, 1, .alias_sequence_id = 1),
  [125] = {.count = 1, .reusable = false}, SHIFT(72),
  [127] = {.count = 1, .reusable = false}, SHIFT(73),
  [129] = {.count = 1, .reusable = true}, SHIFT(75),
  [131] = {.count = 1, .reusable = false}, SHIFT(76),
  [133] = {.count = 1, .reusable = true}, SHIFT(82),
  [135] = {.count = 1, .reusable = true}, SHIFT(78),
  [137] = {.count = 1, .reusable = false}, SHIFT(82),
  [139] = {.count = 1, .reusable = false}, SHIFT(79),
  [141] = {.count = 1, .reusable = true}, SHIFT(71),
  [143] = {.count = 1, .reusable = false}, SHIFT(74),
  [145] = {.count = 1, .reusable = true}, SHIFT(77),
  [147] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 1),
  [149] = {.count = 1, .reusable = true}, REDUCE(sym_raise_statement, 1),
  [151] = {.count = 1, .reusable = false}, SHIFT(88),
  [153] = {.count = 1, .reusable = false}, SHIFT(89),
  [155] = {.count = 1, .reusable = true}, SHIFT(90),
  [157] = {.count = 1, .reusable = false}, SHIFT(91),
  [159] = {.count = 1, .reusable = true}, SHIFT(95),
  [161] = {.count = 1, .reusable = false}, SHIFT(95),
  [163] = {.count = 1, .reusable = false}, SHIFT(92),
  [165] = {.count = 1, .reusable = true}, REDUCE(sym_pass_statement, 1),
  [167] = {.count = 1, .reusable = true}, REDUCE(sym_break_statement, 1),
  [169] = {.count = 1, .reusable = true}, REDUCE(sym_continue_statement, 1),
  [171] = {.count = 1, .reusable = false}, SHIFT(97),
  [173] = {.count = 1, .reusable = true}, SHIFT(98),
  [175] = {.count = 1, .reusable = false}, SHIFT(99),
  [177] = {.count = 1, .reusable = true}, SHIFT(102),
  [179] = {.count = 1, .reusable = false}, SHIFT(102),
  [181] = {.count = 1, .reusable = false}, SHIFT(100),
  [183] = {.count = 1, .reusable = true}, SHIFT(104),
  [185] = {.count = 1, .reusable = true}, SHIFT(105),
  [187] = {.count = 1, .reusable = true}, SHIFT(106),
  [189] = {.count = 1, .reusable = true}, SHIFT(107),
  [191] = {.count = 1, .reusable = true}, SHIFT(109),
  [193] = {.count = 1, .reusable = false}, SHIFT(109),
  [195] = {.count = 1, .reusable = true}, SHIFT(112),
  [197] = {.count = 1, .reusable = false}, SHIFT(113),
  [199] = {.count = 1, .reusable = true}, SHIFT(114),
  [201] = {.count = 1, .reusable = false}, SHIFT(115),
  [203] = {.count = 1, .reusable = true}, SHIFT(119),
  [205] = {.count = 1, .reusable = false}, SHIFT(119),
  [207] = {.count = 1, .reusable = false}, SHIFT(116),
  [209] = {.count = 1, .reusable = true}, SHIFT(121),
  [211] = {.count = 1, .reusable = true}, SHIFT(122),
  [213] = {.count = 1, .reusable = true}, SHIFT(123),
  [215] = {.count = 1, .reusable = true}, SHIFT(124),
  [217] = {.count = 1, .reusable = true}, SHIFT(126),
  [219] = {.count = 1, .reusable = true}, SHIFT(127),
  [221] = {.count = 1, .reusable = false}, SHIFT(129),
  [223] = {.count = 1, .reusable = true}, SHIFT(131),
  [225] = {.count = 1, .reusable = false}, SHIFT(131),
  [227] = {.count = 1, .reusable = true}, SHIFT(132),
  [229] = {.count = 1, .reusable = true}, SHIFT(133),
  [231] = {.count = 1, .reusable = false}, SHIFT(134),
  [233] = {.count = 1, .reusable = true}, SHIFT(135),
  [235] = {.count = 1, .reusable = false}, SHIFT(136),
  [237] = {.count = 1, .reusable = true}, REDUCE(sym_yield, 1),
  [239] = {.count = 1, .reusable = false}, SHIFT(141),
  [241] = {.count = 1, .reusable = true}, SHIFT(143),
  [243] = {.count = 1, .reusable = true}, SHIFT(144),
  [245] = {.count = 1, .reusable = false}, SHIFT(145),
  [247] = {.count = 1, .reusable = true}, SHIFT(146),
  [249] = {.count = 1, .reusable = false}, SHIFT(147),
  [251] = {.count = 1, .reusable = true}, SHIFT(148),
  [253] = {.count = 1, .reusable = true}, SHIFT(152),
  [255] = {.count = 1, .reusable = false}, SHIFT(152),
  [257] = {.count = 1, .reusable = false}, SHIFT(149),
  [259] = {.count = 1, .reusable = true}, SHIFT(154),
  [261] = {.count = 1, .reusable = true}, SHIFT(155),
  [263] = {.count = 1, .reusable = false}, SHIFT(156),
  [265] = {.count = 1, .reusable = true}, SHIFT(157),
  [267] = {.count = 1, .reusable = false}, SHIFT(158),
  [269] = {.count = 1, .reusable = true}, SHIFT(164),
  [271] = {.count = 1, .reusable = true}, SHIFT(159),
  [273] = {.count = 1, .reusable = false}, SHIFT(164),
  [275] = {.count = 1, .reusable = false}, SHIFT(160),
  [277] = {.count = 1, .reusable = true}, ACCEPT_INPUT(),
  [279] = {.count = 1, .reusable = true}, SHIFT(168),
  [281] = {.count = 1, .reusable = true}, SHIFT(169),
  [283] = {.count = 1, .reusable = true}, SHIFT(171),
  [285] = {.count = 1, .reusable = true}, SHIFT(172),
  [287] = {.count = 1, .reusable = true}, SHIFT(173),
  [289] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 1),
  [291] = {.count = 1, .reusable = true}, SHIFT(174),
  [293] = {.count = 1, .reusable = true}, SHIFT(175),
  [295] = {.count = 1, .reusable = true}, REDUCE(sym_expression_list, 1),
  [297] = {.count = 1, .reusable = true}, SHIFT(176),
  [299] = {.count = 1, .reusable = true}, SHIFT(177),
  [301] = {.count = 1, .reusable = true}, REDUCE(sym__expression, 1),
  [303] = {.count = 1, .reusable = true}, SHIFT(179),
  [305] = {.count = 1, .reusable = true}, SHIFT(180),
  [307] = {.count = 1, .reusable = false}, SHIFT(181),
  [309] = {.count = 1, .reusable = false}, SHIFT(182),
  [311] = {.count = 1, .reusable = true}, SHIFT(183),
  [313] = {.count = 1, .reusable = false}, REDUCE(sym__expression, 1),
  [315] = {.count = 1, .reusable = true}, SHIFT(184),
  [317] = {.count = 1, .reusable = false}, SHIFT(185),
  [319] = {.count = 1, .reusable = false}, SHIFT(186),
  [321] = {.count = 1, .reusable = false}, SHIFT(187),
  [323] = {.count = 1, .reusable = false}, SHIFT(188),
  [325] = {.count = 1, .reusable = false}, SHIFT(189),
  [327] = {.count = 1, .reusable = false}, SHIFT(183),
  [329] = {.count = 1, .reusable = true}, SHIFT(190),
  [331] = {.count = 1, .reusable = true}, SHIFT(191),
  [333] = {.count = 1, .reusable = true}, REDUCE(sym__primary_expression, 1),
  [335] = {.count = 1, .reusable = false}, REDUCE(sym__primary_expression, 1),
  [337] = {.count = 1, .reusable = true}, REDUCE(sym_module, 1),
  [339] = {.count = 1, .reusable = true}, SHIFT(196),
  [341] = {.count = 1, .reusable = true}, SHIFT(20),
  [343] = {.count = 1, .reusable = true}, SHIFT(24),
  [345] = {.count = 1, .reusable = true}, REDUCE(sym_string, 2),
  [347] = {.count = 1, .reusable = false}, REDUCE(sym_string, 2),
  [349] = {.count = 1, .reusable = false}, SHIFT(199),
  [351] = {.count = 1, .reusable = true}, SHIFT(200),
  [353] = {.count = 1, .reusable = false}, SHIFT(201),
  [355] = {.count = 1, .reusable = true}, SHIFT(204),
  [357] = {.count = 1, .reusable = false}, SHIFT(204),
  [359] = {.count = 1, .reusable = false}, SHIFT(202),
  [361] = {.count = 1, .reusable = true}, SHIFT(207),
  [363] = {.count = 1, .reusable = true}, SHIFT(206),
  [365] = {.count = 1, .reusable = true}, REDUCE(sym_dotted_name, 1),
  [367] = {.count = 1, .reusable = true}, SHIFT(208),
  [369] = {.count = 1, .reusable = true}, REDUCE(sym_import_statement, 2),
  [371] = {.count = 1, .reusable = true}, REDUCE(sym__import_list, 1),
  [373] = {.count = 1, .reusable = true}, SHIFT(210),
  [375] = {.count = 1, .reusable = true}, SHIFT(212),
  [377] = {.count = 1, .reusable = true}, SHIFT(213),
  [379] = {.count = 1, .reusable = true}, SHIFT(214),
  [381] = {.count = 1, .reusable = false}, REDUCE(sym_relative_import, 1),
  [383] = {.count = 1, .reusable = true}, SHIFT(217),
  [385] = {.count = 1, .reusable = false}, REDUCE(sym_import_prefix, 1),
  [387] = {.count = 1, .reusable = true}, SHIFT(218),
  [389] = {.count = 1, .reusable = true}, SHIFT(220),
  [391] = {.count = 1, .reusable = true}, SHIFT(219),
  [393] = {.count = 1, .reusable = true}, SHIFT(221),
  [395] = {.count = 1, .reusable = true}, SHIFT(222),
  [397] = {.count = 1, .reusable = true}, REDUCE(sym_tuple, 2),
  [399] = {.count = 1, .reusable = false}, REDUCE(sym_tuple, 2),
  [401] = {.count = 1, .reusable = true}, SHIFT(225),
  [403] = {.count = 1, .reusable = true}, SHIFT(227),
  [405] = {.count = 1, .reusable = false}, SHIFT(227),
  [407] = {.count = 1, .reusable = true}, SHIFT(228),
  [409] = {.count = 1, .reusable = false}, SHIFT(230),
  [411] = {.count = 1, .reusable = false}, SHIFT(231),
  [413] = {.count = 1, .reusable = true}, SHIFT(232),
  [415] = {.count = 1, .reusable = false}, SHIFT(233),
  [417] = {.count = 1, .reusable = true}, SHIFT(237),
  [419] = {.count = 1, .reusable = false}, SHIFT(237),
  [421] = {.count = 1, .reusable = false}, SHIFT(234),
  [423] = {.count = 1, .reusable = true}, SHIFT(239),
  [425] = {.count = 1, .reusable = true}, SHIFT(240),
  [427] = {.count = 1, .reusable = true}, SHIFT(243),
  [429] = {.count = 1, .reusable = true}, SHIFT(244),
  [431] = {.count = 1, .reusable = true}, SHIFT(250),
  [433] = {.count = 1, .reusable = true}, SHIFT(251),
  [435] = {.count = 1, .reusable = true}, SHIFT(252),
  [437] = {.count = 1, .reusable = true}, SHIFT(253),
  [439] = {.count = 1, .reusable = true}, SHIFT(254),
  [441] = {.count = 1, .reusable = true}, SHIFT(255),
  [443] = {.count = 1, .reusable = true}, SHIFT(256),
  [445] = {.count = 1, .reusable = true}, SHIFT(260),
  [447] = {.count = 1, .reusable = true}, SHIFT(261),
  [449] = {.count = 1, .reusable = false}, SHIFT(262),
  [451] = {.count = 1, .reusable = true}, SHIFT(263),
  [453] = {.count = 1, .reusable = true}, SHIFT(264),
  [455] = {.count = 1, .reusable = true}, SHIFT(262),
  [457] = {.count = 1, .reusable = true}, SHIFT(265),
  [459] = {.count = 1, .reusable = true}, SHIFT(266),
  [461] = {.count = 1, .reusable = true}, SHIFT(267),
  [463] = {.count = 1, .reusable = true}, SHIFT(268),
  [465] = {.count = 1, .reusable = true}, SHIFT(269),
  [467] = {.count = 1, .reusable = true}, SHIFT(270),
  [469] = {.count = 1, .reusable = false}, SHIFT(264),
  [471] = {.count = 1, .reusable = true}, SHIFT(271),
  [473] = {.count = 1, .reusable = true}, SHIFT(272),
  [475] = {.count = 1, .reusable = true}, SHIFT(277),
  [477] = {.count = 1, .reusable = true}, SHIFT(276),
  [479] = {.count = 1, .reusable = true}, SHIFT(278),
  [481] = {.count = 1, .reusable = true}, SHIFT(279),
  [483] = {.count = 1, .reusable = true}, SHIFT(284),
  [485] = {.count = 1, .reusable = false}, SHIFT(284),
  [487] = {.count = 1, .reusable = true}, SHIFT(285),
  [489] = {.count = 1, .reusable = true}, SHIFT(287),
  [491] = {.count = 1, .reusable = true}, SHIFT(288),
  [493] = {.count = 1, .reusable = true}, SHIFT(291),
  [495] = {.count = 1, .reusable = true}, SHIFT(292),
  [497] = {.count = 1, .reusable = true}, REDUCE(sym_print_statement, 2),
  [499] = {.count = 1, .reusable = true}, SHIFT(297),
  [501] = {.count = 1, .reusable = true}, SHIFT(299),
  [503] = {.count = 1, .reusable = true}, SHIFT(300),
  [505] = {.count = 1, .reusable = true}, SHIFT(301),
  [507] = {.count = 1, .reusable = true}, SHIFT(302),
  [509] = {.count = 1, .reusable = true}, SHIFT(303),
  [511] = {.count = 1, .reusable = false}, SHIFT(304),
  [513] = {.count = 1, .reusable = true}, SHIFT(305),
  [515] = {.count = 1, .reusable = true}, SHIFT(306),
  [517] = {.count = 1, .reusable = true}, SHIFT(304),
  [519] = {.count = 1, .reusable = true}, SHIFT(307),
  [521] = {.count = 1, .reusable = true}, SHIFT(308),
  [523] = {.count = 1, .reusable = true}, SHIFT(309),
  [525] = {.count = 1, .reusable = true}, SHIFT(310),
  [527] = {.count = 1, .reusable = true}, SHIFT(311),
  [529] = {.count = 1, .reusable = true}, SHIFT(312),
  [531] = {.count = 1, .reusable = false}, SHIFT(306),
  [533] = {.count = 1, .reusable = true}, SHIFT(313),
  [535] = {.count = 1, .reusable = true}, SHIFT(314),
  [537] = {.count = 1, .reusable = true}, REDUCE(sym_assert_statement, 2),
  [539] = {.count = 1, .reusable = true}, SHIFT(318),
  [541] = {.count = 1, .reusable = true}, REDUCE(sym_return_statement, 2),
  [543] = {.count = 1, .reusable = true}, SHIFT(320),
  [545] = {.count = 1, .reusable = true}, REDUCE(sym_delete_statement, 2),
  [547] = {.count = 1, .reusable = false}, SHIFT(322),
  [549] = {.count = 1, .reusable = true}, SHIFT(323),
  [551] = {.count = 1, .reusable = false}, SHIFT(324),
  [553] = {.count = 1, .reusable = true}, SHIFT(327),
  [555] = {.count = 1, .reusable = false}, SHIFT(327),
  [557] = {.count = 1, .reusable = false}, SHIFT(325),
  [559] = {.count = 1, .reusable = true}, SHIFT(330),
  [561] = {.count = 1, .reusable = true}, REDUCE(sym_raise_statement, 2),
  [563] = {.count = 1, .reusable = true}, SHIFT(332),
  [565] = {.count = 1, .reusable = true}, SHIFT(333),
  [567] = {.count = 1, .reusable = true}, SHIFT(334),
  [569] = {.count = 1, .reusable = true}, SHIFT(335),
  [571] = {.count = 1, .reusable = true}, SHIFT(336),
  [573] = {.count = 1, .reusable = false}, SHIFT(338),
  [575] = {.count = 1, .reusable = true}, SHIFT(339),
  [577] = {.count = 1, .reusable = true}, SHIFT(340),
  [579] = {.count = 1, .reusable = true}, SHIFT(338),
  [581] = {.count = 1, .reusable = true}, SHIFT(341),
  [583] = {.count = 1, .reusable = true}, SHIFT(342),
  [585] = {.count = 1, .reusable = true}, SHIFT(343),
  [587] = {.count = 1, .reusable = true}, SHIFT(344),
  [589] = {.count = 1, .reusable = true}, SHIFT(345),
  [591] = {.count = 1, .reusable = true}, SHIFT(346),
  [593] = {.count = 1, .reusable = false}, SHIFT(340),
  [595] = {.count = 1, .reusable = true}, SHIFT(347),
  [597] = {.count = 1, .reusable = true}, SHIFT(351),
  [599] = {.count = 1, .reusable = true}, SHIFT(353),
  [601] = {.count = 1, .reusable = true}, SHIFT(354),
  [603] = {.count = 1, .reusable = true}, SHIFT(355),
  [605] = {.count = 1, .reusable = true}, SHIFT(356),
  [607] = {.count = 1, .reusable = false}, SHIFT(357),
  [609] = {.count = 1, .reusable = true}, SHIFT(358),
  [611] = {.count = 1, .reusable = true}, SHIFT(359),
  [613] = {.count = 1, .reusable = true}, SHIFT(357),
  [615] = {.count = 1, .reusable = true}, SHIFT(360),
  [617] = {.count = 1, .reusable = true}, SHIFT(361),
  [619] = {.count = 1, .reusable = true}, SHIFT(362),
  [621] = {.count = 1, .reusable = true}, SHIFT(363),
  [623] = {.count = 1, .reusable = true}, SHIFT(364),
  [625] = {.count = 1, .reusable = true}, SHIFT(365),
  [627] = {.count = 1, .reusable = false}, SHIFT(359),
  [629] = {.count = 1, .reusable = true}, SHIFT(366),
  [631] = {.count = 1, .reusable = true}, SHIFT(371),
  [633] = {.count = 1, .reusable = true}, SHIFT(372),
  [635] = {.count = 1, .reusable = true}, SHIFT(373),
  [637] = {.count = 1, .reusable = false}, SHIFT(374),
  [639] = {.count = 1, .reusable = true}, SHIFT(375),
  [641] = {.count = 1, .reusable = true}, REDUCE(sym_variables, 1),
  [643] = {.count = 1, .reusable = true}, SHIFT(374),
  [645] = {.count = 1, .reusable = true}, SHIFT(376),
  [647] = {.count = 1, .reusable = true}, SHIFT(377),
  [649] = {.count = 1, .reusable = true}, SHIFT(378),
  [651] = {.count = 1, .reusable = true}, SHIFT(379),
  [653] = {.count = 1, .reusable = true}, SHIFT(380),
  [655] = {.count = 1, .reusable = true}, SHIFT(383),
  [657] = {.count = 1, .reusable = true}, SHIFT(384),
  [659] = {.count = 1, .reusable = true}, SHIFT(388),
  [661] = {.count = 1, .reusable = true}, SHIFT(390),
  [663] = {.count = 1, .reusable = true}, SHIFT(391),
  [665] = {.count = 1, .reusable = true}, REDUCE(sym_with_item, 1),
  [667] = {.count = 1, .reusable = true}, SHIFT(393),
  [669] = {.count = 1, .reusable = true}, SHIFT(394),
  [671] = {.count = 1, .reusable = true}, SHIFT(395),
  [673] = {.count = 1, .reusable = true}, SHIFT(396),
  [675] = {.count = 1, .reusable = false}, SHIFT(397),
  [677] = {.count = 1, .reusable = true}, SHIFT(398),
  [679] = {.count = 1, .reusable = true}, SHIFT(399),
  [681] = {.count = 1, .reusable = true}, SHIFT(397),
  [683] = {.count = 1, .reusable = true}, SHIFT(400),
  [685] = {.count = 1, .reusable = true}, SHIFT(401),
  [687] = {.count = 1, .reusable = true}, SHIFT(402),
  [689] = {.count = 1, .reusable = true}, SHIFT(403),
  [691] = {.count = 1, .reusable = true}, SHIFT(404),
  [693] = {.count = 1, .reusable = true}, SHIFT(405),
  [695] = {.count = 1, .reusable = false}, SHIFT(399),
  [697] = {.count = 1, .reusable = true}, SHIFT(406),
  [699] = {.count = 1, .reusable = true}, SHIFT(409),
  [701] = {.count = 1, .reusable = true}, REDUCE(sym_global_statement, 2),
  [703] = {.count = 1, .reusable = true}, SHIFT(411),
  [705] = {.count = 1, .reusable = true}, REDUCE(sym_nonlocal_statement, 2),
  [707] = {.count = 1, .reusable = true}, SHIFT(415),
  [709] = {.count = 1, .reusable = true}, SHIFT(414),
  [711] = {.count = 1, .reusable = true}, REDUCE(sym_exec_statement, 2),
  [713] = {.count = 1, .reusable = true}, SHIFT(416),
  [715] = {.count = 1, .reusable = true}, SHIFT(417),
  [717] = {.count = 1, .reusable = true}, SHIFT(418),
  [719] = {.count = 1, .reusable = true}, SHIFT(421),
  [721] = {.count = 1, .reusable = true}, SHIFT(422),
  [723] = {.count = 1, .reusable = true}, REDUCE(sym_not_operator, 2),
  [725] = {.count = 1, .reusable = true}, REDUCE(sym_unary_operator, 2),
  [727] = {.count = 1, .reusable = false}, REDUCE(sym_unary_operator, 2),
  [729] = {.count = 1, .reusable = true}, REDUCE(sym_list_splat, 1),
  [731] = {.count = 1, .reusable = true}, SHIFT(426),
  [733] = {.count = 1, .reusable = false}, SHIFT(427),
  [735] = {.count = 1, .reusable = true}, SHIFT(428),
  [737] = {.count = 1, .reusable = false}, SHIFT(429),
  [739] = {.count = 1, .reusable = true}, SHIFT(432),
  [741] = {.count = 1, .reusable = false}, SHIFT(432),
  [743] = {.count = 1, .reusable = false}, SHIFT(430),
  [745] = {.count = 1, .reusable = true}, SHIFT(434),
  [747] = {.count = 1, .reusable = true}, REDUCE(sym__parameters, 1, .alias_sequence_id = 1),
  [749] = {.count = 1, .reusable = true}, SHIFT(436),
  [751] = {.count = 1, .reusable = true}, SHIFT(439),
  [753] = {.count = 1, .reusable = true}, REDUCE(sym__parameters, 1),
  [755] = {.count = 1, .reusable = true}, SHIFT(441),
  [757] = {.count = 1, .reusable = true}, SHIFT(443),
  [759] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_parameters, 1),
  [761] = {.count = 1, .reusable = true}, REDUCE(sym_yield, 2),
  [763] = {.count = 1, .reusable = true}, SHIFT(446),
  [765] = {.count = 1, .reusable = false}, SHIFT(447),
  [767] = {.count = 1, .reusable = true}, SHIFT(448),
  [769] = {.count = 1, .reusable = false}, SHIFT(449),
  [771] = {.count = 1, .reusable = true}, SHIFT(452),
  [773] = {.count = 1, .reusable = false}, SHIFT(452),
  [775] = {.count = 1, .reusable = false}, SHIFT(450),
  [777] = {.count = 1, .reusable = true}, SHIFT(455),
  [779] = {.count = 1, .reusable = true}, REDUCE(sym_list, 2),
  [781] = {.count = 1, .reusable = false}, REDUCE(sym_list, 2),
  [783] = {.count = 1, .reusable = true}, SHIFT(457),
  [785] = {.count = 1, .reusable = true}, SHIFT(459),
  [787] = {.count = 1, .reusable = true}, SHIFT(460),
  [789] = {.count = 1, .reusable = true}, SHIFT(461),
  [791] = {.count = 1, .reusable = true}, SHIFT(462),
  [793] = {.count = 1, .reusable = true}, SHIFT(463),
  [795] = {.count = 1, .reusable = false}, SHIFT(466),
  [797] = {.count = 1, .reusable = true}, SHIFT(467),
  [799] = {.count = 1, .reusable = true}, SHIFT(468),
  [801] = {.count = 1, .reusable = true}, SHIFT(466),
  [803] = {.count = 1, .reusable = true}, SHIFT(469),
  [805] = {.count = 1, .reusable = true}, SHIFT(470),
  [807] = {.count = 1, .reusable = true}, SHIFT(471),
  [809] = {.count = 1, .reusable = true}, SHIFT(472),
  [811] = {.count = 1, .reusable = true}, SHIFT(473),
  [813] = {.count = 1, .reusable = true}, SHIFT(474),
  [815] = {.count = 1, .reusable = false}, SHIFT(468),
  [817] = {.count = 1, .reusable = true}, SHIFT(475),
  [819] = {.count = 1, .reusable = true}, SHIFT(478),
  [821] = {.count = 1, .reusable = true}, SHIFT(479),
  [823] = {.count = 1, .reusable = false}, SHIFT(480),
  [825] = {.count = 1, .reusable = true}, SHIFT(481),
  [827] = {.count = 1, .reusable = false}, SHIFT(482),
  [829] = {.count = 1, .reusable = true}, SHIFT(485),
  [831] = {.count = 1, .reusable = false}, SHIFT(485),
  [833] = {.count = 1, .reusable = false}, SHIFT(483),
  [835] = {.count = 1, .reusable = true}, SHIFT(488),
  [837] = {.count = 1, .reusable = true}, REDUCE(sym_dictionary, 2),
  [839] = {.count = 1, .reusable = false}, REDUCE(sym_dictionary, 2),
  [841] = {.count = 1, .reusable = true}, SHIFT(490),
  [843] = {.count = 1, .reusable = true}, SHIFT(491),
  [845] = {.count = 1, .reusable = true}, SHIFT(493),
  [847] = {.count = 1, .reusable = true}, SHIFT(495),
  [849] = {.count = 1, .reusable = true}, SHIFT(496),
  [851] = {.count = 1, .reusable = true}, SHIFT(497),
  [853] = {.count = 1, .reusable = true}, SHIFT(498),
  [855] = {.count = 1, .reusable = true}, SHIFT(499),
  [857] = {.count = 1, .reusable = true}, SHIFT(500),
  [859] = {.count = 1, .reusable = false}, SHIFT(503),
  [861] = {.count = 1, .reusable = true}, SHIFT(504),
  [863] = {.count = 1, .reusable = true}, SHIFT(505),
  [865] = {.count = 1, .reusable = true}, SHIFT(503),
  [867] = {.count = 1, .reusable = true}, SHIFT(506),
  [869] = {.count = 1, .reusable = true}, SHIFT(507),
  [871] = {.count = 1, .reusable = true}, SHIFT(508),
  [873] = {.count = 1, .reusable = true}, SHIFT(509),
  [875] = {.count = 1, .reusable = true}, SHIFT(510),
  [877] = {.count = 1, .reusable = true}, SHIFT(511),
  [879] = {.count = 1, .reusable = false}, SHIFT(505),
  [881] = {.count = 1, .reusable = true}, SHIFT(512),
  [883] = {.count = 1, .reusable = true}, REDUCE(sym_await, 2),
  [885] = {.count = 1, .reusable = true}, REDUCE(sym__simple_statements, 2),
  [887] = {.count = 1, .reusable = false}, REDUCE(sym__simple_statements, 2),
  [889] = {.count = 1, .reusable = true}, SHIFT(516),
  [891] = {.count = 1, .reusable = true}, SHIFT(518),
  [893] = {.count = 1, .reusable = false}, SHIFT(520),
  [895] = {.count = 1, .reusable = true}, SHIFT(521),
  [897] = {.count = 1, .reusable = false}, SHIFT(522),
  [899] = {.count = 1, .reusable = true}, SHIFT(525),
  [901] = {.count = 1, .reusable = false}, SHIFT(525),
  [903] = {.count = 1, .reusable = false}, SHIFT(523),
  [905] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 2),
  [907] = {.count = 1, .reusable = true}, REDUCE(sym_expression_list, 2),
  [909] = {.count = 1, .reusable = false}, SHIFT(27),
  [911] = {.count = 1, .reusable = false}, SHIFT(533),
  [913] = {.count = 1, .reusable = true}, SHIFT(534),
  [915] = {.count = 1, .reusable = false}, SHIFT(535),
  [917] = {.count = 1, .reusable = true}, SHIFT(538),
  [919] = {.count = 1, .reusable = false}, SHIFT(538),
  [921] = {.count = 1, .reusable = false}, SHIFT(536),
  [923] = {.count = 1, .reusable = true}, SHIFT(542),
  [925] = {.count = 1, .reusable = true}, SHIFT(544),
  [927] = {.count = 1, .reusable = true}, SHIFT(545),
  [929] = {.count = 1, .reusable = true}, SHIFT(546),
  [931] = {.count = 1, .reusable = true}, SHIFT(547),
  [933] = {.count = 1, .reusable = false}, SHIFT(548),
  [935] = {.count = 1, .reusable = false}, SHIFT(549),
  [937] = {.count = 1, .reusable = true}, SHIFT(552),
  [939] = {.count = 1, .reusable = false}, SHIFT(552),
  [941] = {.count = 1, .reusable = true}, SHIFT(553),
  [943] = {.count = 1, .reusable = false}, SHIFT(553),
  [945] = {.count = 1, .reusable = true}, SHIFT(554),
  [947] = {.count = 1, .reusable = false}, SHIFT(554),
  [949] = {.count = 1, .reusable = true}, SHIFT(555),
  [951] = {.count = 1, .reusable = true}, SHIFT(556),
  [953] = {.count = 1, .reusable = false}, SHIFT(556),
  [955] = {.count = 1, .reusable = true}, SHIFT(557),
  [957] = {.count = 1, .reusable = false}, SHIFT(557),
  [959] = {.count = 1, .reusable = true}, SHIFT(558),
  [961] = {.count = 1, .reusable = false}, SHIFT(558),
  [963] = {.count = 1, .reusable = true}, SHIFT(559),
  [965] = {.count = 1, .reusable = false}, SHIFT(559),
  [967] = {.count = 1, .reusable = true}, SHIFT(560),
  [969] = {.count = 1, .reusable = false}, SHIFT(560),
  [971] = {.count = 1, .reusable = false}, SHIFT(555),
  [973] = {.count = 1, .reusable = true}, SHIFT(561),
  [975] = {.count = 1, .reusable = false}, SHIFT(562),
  [977] = {.count = 1, .reusable = true}, SHIFT(563),
  [979] = {.count = 1, .reusable = false}, SHIFT(564),
  [981] = {.count = 1, .reusable = true}, SHIFT(567),
  [983] = {.count = 1, .reusable = false}, SHIFT(567),
  [985] = {.count = 1, .reusable = false}, SHIFT(565),
  [987] = {.count = 1, .reusable = true}, REDUCE(sym_call, 2),
  [989] = {.count = 1, .reusable = false}, REDUCE(sym_call, 2),
  [991] = {.count = 1, .reusable = true}, REDUCE(sym_comparison_operator, 2),
  [993] = {.count = 1, .reusable = false}, REDUCE(sym_comparison_operator, 2),
  [995] = {.count = 1, .reusable = true}, REDUCE(sym_concatenated_string, 2),
  [997] = {.count = 1, .reusable = false}, REDUCE(sym_concatenated_string, 2),
  [999] = {.count = 2, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(2),
  [1002] = {.count = 1, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2),
  [1004] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(3),
  [1007] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(4),
  [1010] = {.count = 2, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(5),
  [1013] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(6),
  [1016] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(7),
  [1019] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(8),
  [1022] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(9),
  [1025] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(10),
  [1028] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(11),
  [1031] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(12),
  [1034] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(13),
  [1037] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(14),
  [1040] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(15),
  [1043] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(16),
  [1046] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(17),
  [1049] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(18),
  [1052] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(19),
  [1055] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(20),
  [1058] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(21),
  [1061] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(22),
  [1064] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(23),
  [1067] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(24),
  [1070] = {.count = 2, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(25),
  [1073] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(26),
  [1076] = {.count = 2, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(27),
  [1079] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(28),
  [1082] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(29),
  [1085] = {.count = 2, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(30),
  [1088] = {.count = 2, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(37),
  [1091] = {.count = 2, .reusable = true}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(31),
  [1094] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(37),
  [1097] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(32),
  [1100] = {.count = 1, .reusable = true}, REDUCE(sym_decorated_definition, 2),
  [1102] = {.count = 1, .reusable = false}, REDUCE(sym_decorated_definition, 2),
  [1104] = {.count = 1, .reusable = true}, REDUCE(aux_sym_decorated_definition_repeat1, 2),
  [1106] = {.count = 2, .reusable = true}, REDUCE(aux_sym_decorated_definition_repeat1, 2), SHIFT_REPEAT(25),
  [1109] = {.count = 1, .reusable = true}, SHIFT(573),
  [1111] = {.count = 1, .reusable = true}, SHIFT(575),
  [1113] = {.count = 1, .reusable = true}, SHIFT(576),
  [1115] = {.count = 1, .reusable = true}, SHIFT(577),
  [1117] = {.count = 1, .reusable = true}, SHIFT(578),
  [1119] = {.count = 1, .reusable = true}, SHIFT(579),
  [1121] = {.count = 1, .reusable = false}, SHIFT(580),
  [1123] = {.count = 1, .reusable = true}, SHIFT(581),
  [1125] = {.count = 1, .reusable = true}, SHIFT(582),
  [1127] = {.count = 1, .reusable = true}, SHIFT(580),
  [1129] = {.count = 1, .reusable = true}, SHIFT(583),
  [1131] = {.count = 1, .reusable = true}, SHIFT(584),
  [1133] = {.count = 1, .reusable = true}, SHIFT(585),
  [1135] = {.count = 1, .reusable = true}, SHIFT(586),
  [1137] = {.count = 1, .reusable = true}, SHIFT(587),
  [1139] = {.count = 1, .reusable = true}, SHIFT(588),
  [1141] = {.count = 1, .reusable = false}, SHIFT(582),
  [1143] = {.count = 1, .reusable = true}, SHIFT(589),
  [1145] = {.count = 1, .reusable = true}, REDUCE(sym_string, 3),
  [1147] = {.count = 1, .reusable = false}, REDUCE(sym_string, 3),
  [1149] = {.count = 2, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(207),
  [1152] = {.count = 1, .reusable = true}, REDUCE(aux_sym_string_repeat1, 2),
  [1154] = {.count = 2, .reusable = false}, REDUCE(aux_sym_string_repeat1, 2), SHIFT_REPEAT(43),
  [1157] = {.count = 1, .reusable = true}, SHIFT(592),
  [1159] = {.count = 1, .reusable = true}, REDUCE(sym_dotted_name, 2),
  [1161] = {.count = 1, .reusable = true}, REDUCE(sym__import_list, 2),
  [1163] = {.count = 1, .reusable = true}, SHIFT(596),
  [1165] = {.count = 1, .reusable = true}, SHIFT(598),
  [1167] = {.count = 1, .reusable = true}, SHIFT(600),
  [1169] = {.count = 1, .reusable = true}, REDUCE(sym_relative_import, 2),
  [1171] = {.count = 1, .reusable = true}, SHIFT(602),
  [1173] = {.count = 1, .reusable = true}, SHIFT(603),
  [1175] = {.count = 1, .reusable = false}, REDUCE(aux_sym_import_prefix_repeat1, 2),
  [1177] = {.count = 2, .reusable = true}, REDUCE(aux_sym_import_prefix_repeat1, 2), SHIFT_REPEAT(218),
  [1180] = {.count = 1, .reusable = true}, SHIFT(605),
  [1182] = {.count = 1, .reusable = true}, SHIFT(606),
  [1184] = {.count = 1, .reusable = true}, SHIFT(607),
  [1186] = {.count = 1, .reusable = true}, SHIFT(608),
  [1188] = {.count = 1, .reusable = true}, REDUCE(sym_tuple, 3),
  [1190] = {.count = 1, .reusable = false}, REDUCE(sym_tuple, 3),
  [1192] = {.count = 1, .reusable = true}, SHIFT(612),
  [1194] = {.count = 1, .reusable = true}, SHIFT(615),
  [1196] = {.count = 1, .reusable = true}, SHIFT(617),
  [1198] = {.count = 1, .reusable = true}, SHIFT(618),
  [1200] = {.count = 1, .reusable = true}, SHIFT(619),
  [1202] = {.count = 1, .reusable = true}, SHIFT(620),
  [1204] = {.count = 1, .reusable = false}, SHIFT(622),
  [1206] = {.count = 1, .reusable = true}, SHIFT(623),
  [1208] = {.count = 1, .reusable = true}, SHIFT(624),
  [1210] = {.count = 1, .reusable = true}, SHIFT(622),
  [1212] = {.count = 1, .reusable = true}, SHIFT(625),
  [1214] = {.count = 1, .reusable = true}, SHIFT(626),
  [1216] = {.count = 1, .reusable = true}, SHIFT(627),
  [1218] = {.count = 1, .reusable = true}, SHIFT(628),
  [1220] = {.count = 1, .reusable = true}, SHIFT(629),
  [1222] = {.count = 1, .reusable = true}, SHIFT(630),
  [1224] = {.count = 1, .reusable = false}, SHIFT(624),
  [1226] = {.count = 1, .reusable = true}, SHIFT(631),
  [1228] = {.count = 1, .reusable = true}, SHIFT(634),
  [1230] = {.count = 1, .reusable = true}, SHIFT(635),
  [1232] = {.count = 1, .reusable = true}, SHIFT(638),
  [1234] = {.count = 1, .reusable = true}, SHIFT(639),
  [1236] = {.count = 1, .reusable = true}, SHIFT(640),
  [1238] = {.count = 1, .reusable = true}, SHIFT(642),
  [1240] = {.count = 1, .reusable = false}, REDUCE(sym_await, 2),
  [1242] = {.count = 1, .reusable = true}, REDUCE(sym_parenthesized_expression, 3),
  [1244] = {.count = 1, .reusable = false}, REDUCE(sym_parenthesized_expression, 3),
  [1246] = {.count = 1, .reusable = true}, SHIFT(646),
  [1248] = {.count = 1, .reusable = true}, SHIFT(650),
  [1250] = {.count = 1, .reusable = true}, SHIFT(654),
  [1252] = {.count = 1, .reusable = true}, REDUCE(sym__comprehension_body, 1),
  [1254] = {.count = 1, .reusable = true}, SHIFT(655),
  [1256] = {.count = 1, .reusable = true}, SHIFT(657),
  [1258] = {.count = 1, .reusable = true}, SHIFT(659),
  [1260] = {.count = 1, .reusable = true}, SHIFT(660),
  [1262] = {.count = 1, .reusable = true}, SHIFT(661),
  [1264] = {.count = 1, .reusable = true}, SHIFT(664),
  [1266] = {.count = 1, .reusable = false}, SHIFT(664),
  [1268] = {.count = 1, .reusable = true}, SHIFT(665),
  [1270] = {.count = 1, .reusable = false}, SHIFT(665),
  [1272] = {.count = 1, .reusable = true}, SHIFT(666),
  [1274] = {.count = 1, .reusable = false}, SHIFT(666),
  [1276] = {.count = 1, .reusable = true}, SHIFT(667),
  [1278] = {.count = 1, .reusable = true}, SHIFT(668),
  [1280] = {.count = 1, .reusable = false}, SHIFT(668),
  [1282] = {.count = 1, .reusable = true}, SHIFT(669),
  [1284] = {.count = 1, .reusable = false}, SHIFT(669),
  [1286] = {.count = 1, .reusable = true}, SHIFT(670),
  [1288] = {.count = 1, .reusable = false}, SHIFT(670),
  [1290] = {.count = 1, .reusable = true}, SHIFT(671),
  [1292] = {.count = 1, .reusable = false}, SHIFT(671),
  [1294] = {.count = 1, .reusable = true}, SHIFT(672),
  [1296] = {.count = 1, .reusable = false}, SHIFT(672),
  [1298] = {.count = 1, .reusable = false}, SHIFT(667),
  [1300] = {.count = 1, .reusable = true}, SHIFT(677),
  [1302] = {.count = 1, .reusable = true}, SHIFT(678),
  [1304] = {.count = 1, .reusable = true}, SHIFT(679),
  [1306] = {.count = 1, .reusable = true}, SHIFT(680),
  [1308] = {.count = 1, .reusable = true}, REDUCE(sym_chevron, 2),
  [1310] = {.count = 1, .reusable = true}, SHIFT(684),
  [1312] = {.count = 1, .reusable = true}, SHIFT(685),
  [1314] = {.count = 1, .reusable = true}, SHIFT(686),
  [1316] = {.count = 1, .reusable = true}, SHIFT(689),
  [1318] = {.count = 1, .reusable = true}, SHIFT(690),
  [1320] = {.count = 1, .reusable = true}, SHIFT(691),
  [1322] = {.count = 1, .reusable = true}, SHIFT(693),
  [1324] = {.count = 1, .reusable = true}, REDUCE(sym_print_statement, 3),
  [1326] = {.count = 1, .reusable = true}, SHIFT(698),
  [1328] = {.count = 1, .reusable = true}, SHIFT(702),
  [1330] = {.count = 1, .reusable = true}, SHIFT(703),
  [1332] = {.count = 1, .reusable = true}, SHIFT(704),
  [1334] = {.count = 1, .reusable = true}, SHIFT(707),
  [1336] = {.count = 1, .reusable = false}, SHIFT(707),
  [1338] = {.count = 1, .reusable = true}, SHIFT(708),
  [1340] = {.count = 1, .reusable = false}, SHIFT(708),
  [1342] = {.count = 1, .reusable = true}, SHIFT(709),
  [1344] = {.count = 1, .reusable = false}, SHIFT(709),
  [1346] = {.count = 1, .reusable = true}, SHIFT(710),
  [1348] = {.count = 1, .reusable = true}, SHIFT(711),
  [1350] = {.count = 1, .reusable = false}, SHIFT(711),
  [1352] = {.count = 1, .reusable = true}, SHIFT(712),
  [1354] = {.count = 1, .reusable = false}, SHIFT(712),
  [1356] = {.count = 1, .reusable = true}, SHIFT(713),
  [1358] = {.count = 1, .reusable = false}, SHIFT(713),
  [1360] = {.count = 1, .reusable = true}, SHIFT(714),
  [1362] = {.count = 1, .reusable = false}, SHIFT(714),
  [1364] = {.count = 1, .reusable = true}, SHIFT(715),
  [1366] = {.count = 1, .reusable = false}, SHIFT(715),
  [1368] = {.count = 1, .reusable = false}, SHIFT(710),
  [1370] = {.count = 1, .reusable = true}, REDUCE(sym_assert_statement, 3),
  [1372] = {.count = 1, .reusable = true}, SHIFT(720),
  [1374] = {.count = 1, .reusable = true}, SHIFT(722),
  [1376] = {.count = 1, .reusable = true}, REDUCE(sym_raise_statement, 3),
  [1378] = {.count = 1, .reusable = true}, SHIFT(724),
  [1380] = {.count = 1, .reusable = true}, SHIFT(725),
  [1382] = {.count = 1, .reusable = true}, SHIFT(726),
  [1384] = {.count = 1, .reusable = false}, SHIFT(727),
  [1386] = {.count = 1, .reusable = true}, SHIFT(728),
  [1388] = {.count = 1, .reusable = true}, SHIFT(729),
  [1390] = {.count = 1, .reusable = true}, SHIFT(727),
  [1392] = {.count = 1, .reusable = true}, SHIFT(730),
  [1394] = {.count = 1, .reusable = true}, SHIFT(731),
  [1396] = {.count = 1, .reusable = true}, SHIFT(732),
  [1398] = {.count = 1, .reusable = true}, SHIFT(733),
  [1400] = {.count = 1, .reusable = true}, SHIFT(734),
  [1402] = {.count = 1, .reusable = true}, SHIFT(735),
  [1404] = {.count = 1, .reusable = false}, SHIFT(729),
  [1406] = {.count = 1, .reusable = true}, SHIFT(736),
  [1408] = {.count = 1, .reusable = true}, SHIFT(740),
  [1410] = {.count = 1, .reusable = false}, REDUCE(sym_expression_list, 2),
  [1412] = {.count = 1, .reusable = true}, SHIFT(745),
  [1414] = {.count = 1, .reusable = true}, SHIFT(747),
  [1416] = {.count = 1, .reusable = false}, SHIFT(747),
  [1418] = {.count = 1, .reusable = true}, SHIFT(748),
  [1420] = {.count = 1, .reusable = false}, SHIFT(748),
  [1422] = {.count = 1, .reusable = true}, SHIFT(749),
  [1424] = {.count = 1, .reusable = false}, SHIFT(749),
  [1426] = {.count = 1, .reusable = true}, SHIFT(750),
  [1428] = {.count = 1, .reusable = true}, SHIFT(751),
  [1430] = {.count = 1, .reusable = false}, SHIFT(751),
  [1432] = {.count = 1, .reusable = true}, SHIFT(752),
  [1434] = {.count = 1, .reusable = false}, SHIFT(752),
  [1436] = {.count = 1, .reusable = true}, SHIFT(753),
  [1438] = {.count = 1, .reusable = false}, SHIFT(753),
  [1440] = {.count = 1, .reusable = true}, SHIFT(754),
  [1442] = {.count = 1, .reusable = false}, SHIFT(754),
  [1444] = {.count = 1, .reusable = false}, SHIFT(750),
  [1446] = {.count = 1, .reusable = true}, SHIFT(758),
  [1448] = {.count = 1, .reusable = true}, SHIFT(760),
  [1450] = {.count = 1, .reusable = true}, SHIFT(763),
  [1452] = {.count = 1, .reusable = false}, SHIFT(763),
  [1454] = {.count = 1, .reusable = true}, SHIFT(764),
  [1456] = {.count = 1, .reusable = false}, SHIFT(764),
  [1458] = {.count = 1, .reusable = true}, SHIFT(765),
  [1460] = {.count = 1, .reusable = false}, SHIFT(765),
  [1462] = {.count = 1, .reusable = true}, SHIFT(766),
  [1464] = {.count = 1, .reusable = true}, SHIFT(767),
  [1466] = {.count = 1, .reusable = false}, SHIFT(767),
  [1468] = {.count = 1, .reusable = true}, SHIFT(768),
  [1470] = {.count = 1, .reusable = false}, SHIFT(768),
  [1472] = {.count = 1, .reusable = true}, SHIFT(769),
  [1474] = {.count = 1, .reusable = false}, SHIFT(769),
  [1476] = {.count = 1, .reusable = true}, SHIFT(770),
  [1478] = {.count = 1, .reusable = false}, SHIFT(770),
  [1480] = {.count = 1, .reusable = false}, SHIFT(766),
  [1482] = {.count = 1, .reusable = true}, SHIFT(773),
  [1484] = {.count = 1, .reusable = true}, SHIFT(774),
  [1486] = {.count = 1, .reusable = false}, REDUCE(sym_variables, 2),
  [1488] = {.count = 1, .reusable = true}, SHIFT(779),
  [1490] = {.count = 1, .reusable = false}, SHIFT(779),
  [1492] = {.count = 1, .reusable = true}, SHIFT(780),
  [1494] = {.count = 1, .reusable = false}, SHIFT(780),
  [1496] = {.count = 1, .reusable = true}, SHIFT(781),
  [1498] = {.count = 1, .reusable = false}, SHIFT(781),
  [1500] = {.count = 1, .reusable = true}, SHIFT(782),
  [1502] = {.count = 1, .reusable = false}, SHIFT(782),
  [1504] = {.count = 1, .reusable = true}, SHIFT(783),
  [1506] = {.count = 1, .reusable = false}, SHIFT(783),
  [1508] = {.count = 1, .reusable = true}, SHIFT(784),
  [1510] = {.count = 1, .reusable = false}, SHIFT(784),
  [1512] = {.count = 1, .reusable = true}, SHIFT(785),
  [1514] = {.count = 1, .reusable = false}, SHIFT(785),
  [1516] = {.count = 1, .reusable = true}, SHIFT(786),
  [1518] = {.count = 1, .reusable = true}, REDUCE(sym_variables, 2),
  [1520] = {.count = 1, .reusable = true}, SHIFT(790),
  [1522] = {.count = 1, .reusable = false}, SHIFT(791),
  [1524] = {.count = 1, .reusable = false}, SHIFT(792),
  [1526] = {.count = 1, .reusable = false}, SHIFT(793),
  [1528] = {.count = 1, .reusable = false}, SHIFT(794),
  [1530] = {.count = 1, .reusable = false}, SHIFT(795),
  [1532] = {.count = 1, .reusable = false}, SHIFT(796),
  [1534] = {.count = 1, .reusable = false}, SHIFT(797),
  [1536] = {.count = 1, .reusable = false}, SHIFT(798),
  [1538] = {.count = 1, .reusable = true}, SHIFT(802),
  [1540] = {.count = 1, .reusable = true}, SHIFT(803),
  [1542] = {.count = 1, .reusable = true}, SHIFT(805),
  [1544] = {.count = 1, .reusable = true}, SHIFT(806),
  [1546] = {.count = 1, .reusable = true}, SHIFT(810),
  [1548] = {.count = 1, .reusable = true}, SHIFT(817),
  [1550] = {.count = 1, .reusable = false}, SHIFT(817),
  [1552] = {.count = 1, .reusable = true}, SHIFT(818),
  [1554] = {.count = 1, .reusable = false}, SHIFT(818),
  [1556] = {.count = 1, .reusable = true}, SHIFT(819),
  [1558] = {.count = 1, .reusable = false}, SHIFT(819),
  [1560] = {.count = 1, .reusable = true}, SHIFT(820),
  [1562] = {.count = 1, .reusable = true}, SHIFT(821),
  [1564] = {.count = 1, .reusable = false}, SHIFT(821),
  [1566] = {.count = 1, .reusable = true}, SHIFT(822),
  [1568] = {.count = 1, .reusable = false}, SHIFT(822),
  [1570] = {.count = 1, .reusable = true}, SHIFT(823),
  [1572] = {.count = 1, .reusable = false}, SHIFT(823),
  [1574] = {.count = 1, .reusable = true}, SHIFT(824),
  [1576] = {.count = 1, .reusable = false}, SHIFT(824),
  [1578] = {.count = 1, .reusable = false}, SHIFT(820),
  [1580] = {.count = 1, .reusable = true}, SHIFT(827),
  [1582] = {.count = 1, .reusable = true}, SHIFT(828),
  [1584] = {.count = 1, .reusable = false}, SHIFT(829),
  [1586] = {.count = 1, .reusable = false}, SHIFT(830),
  [1588] = {.count = 1, .reusable = true}, SHIFT(834),
  [1590] = {.count = 1, .reusable = true}, SHIFT(835),
  [1592] = {.count = 1, .reusable = true}, SHIFT(836),
  [1594] = {.count = 1, .reusable = true}, REDUCE(sym_global_statement, 3),
  [1596] = {.count = 1, .reusable = true}, REDUCE(sym_nonlocal_statement, 3),
  [1598] = {.count = 1, .reusable = true}, SHIFT(838),
  [1600] = {.count = 1, .reusable = true}, SHIFT(842),
  [1602] = {.count = 1, .reusable = true}, REDUCE(sym_decorator, 3),
  [1604] = {.count = 1, .reusable = true}, SHIFT(845),
  [1606] = {.count = 1, .reusable = true}, SHIFT(848),
  [1608] = {.count = 1, .reusable = true}, REDUCE(sym_list_splat, 2),
  [1610] = {.count = 1, .reusable = true}, SHIFT(850),
  [1612] = {.count = 1, .reusable = true}, SHIFT(851),
  [1614] = {.count = 1, .reusable = true}, SHIFT(852),
  [1616] = {.count = 1, .reusable = false}, SHIFT(853),
  [1618] = {.count = 1, .reusable = true}, SHIFT(854),
  [1620] = {.count = 1, .reusable = true}, SHIFT(855),
  [1622] = {.count = 1, .reusable = true}, SHIFT(853),
  [1624] = {.count = 1, .reusable = true}, SHIFT(856),
  [1626] = {.count = 1, .reusable = true}, SHIFT(857),
  [1628] = {.count = 1, .reusable = true}, SHIFT(858),
  [1630] = {.count = 1, .reusable = true}, SHIFT(859),
  [1632] = {.count = 1, .reusable = true}, SHIFT(860),
  [1634] = {.count = 1, .reusable = true}, SHIFT(861),
  [1636] = {.count = 1, .reusable = false}, SHIFT(855),
  [1638] = {.count = 1, .reusable = true}, SHIFT(862),
  [1640] = {.count = 1, .reusable = false}, SHIFT(865),
  [1642] = {.count = 1, .reusable = true}, REDUCE(sym__parameters, 2, .alias_sequence_id = 1),
  [1644] = {.count = 1, .reusable = false}, SHIFT(866),
  [1646] = {.count = 1, .reusable = false}, SHIFT(869),
  [1648] = {.count = 1, .reusable = true}, SHIFT(870),
  [1650] = {.count = 1, .reusable = false}, SHIFT(871),
  [1652] = {.count = 1, .reusable = true}, SHIFT(874),
  [1654] = {.count = 1, .reusable = false}, SHIFT(874),
  [1656] = {.count = 1, .reusable = false}, SHIFT(872),
  [1658] = {.count = 1, .reusable = true}, SHIFT(878),
  [1660] = {.count = 1, .reusable = true}, REDUCE(sym_lambda, 3),
  [1662] = {.count = 1, .reusable = true}, REDUCE(sym__parameters, 2),
  [1664] = {.count = 1, .reusable = false}, SHIFT(880),
  [1666] = {.count = 1, .reusable = true}, SHIFT(881),
  [1668] = {.count = 1, .reusable = false}, SHIFT(882),
  [1670] = {.count = 1, .reusable = true}, SHIFT(885),
  [1672] = {.count = 1, .reusable = false}, SHIFT(885),
  [1674] = {.count = 1, .reusable = false}, SHIFT(883),
  [1676] = {.count = 1, .reusable = true}, SHIFT(889),
  [1678] = {.count = 1, .reusable = true}, REDUCE(sym_yield, 3),
  [1680] = {.count = 1, .reusable = true}, REDUCE(sym_list, 3),
  [1682] = {.count = 1, .reusable = false}, REDUCE(sym_list, 3),
  [1684] = {.count = 1, .reusable = true}, SHIFT(894),
  [1686] = {.count = 1, .reusable = true}, SHIFT(896),
  [1688] = {.count = 1, .reusable = true}, SHIFT(897),
  [1690] = {.count = 1, .reusable = true}, SHIFT(898),
  [1692] = {.count = 1, .reusable = false}, SHIFT(899),
  [1694] = {.count = 1, .reusable = true}, SHIFT(900),
  [1696] = {.count = 1, .reusable = true}, SHIFT(901),
  [1698] = {.count = 1, .reusable = true}, SHIFT(899),
  [1700] = {.count = 1, .reusable = true}, SHIFT(902),
  [1702] = {.count = 1, .reusable = true}, SHIFT(903),
  [1704] = {.count = 1, .reusable = true}, SHIFT(904),
  [1706] = {.count = 1, .reusable = true}, SHIFT(905),
  [1708] = {.count = 1, .reusable = true}, SHIFT(906),
  [1710] = {.count = 1, .reusable = true}, SHIFT(907),
  [1712] = {.count = 1, .reusable = false}, SHIFT(901),
  [1714] = {.count = 1, .reusable = true}, SHIFT(908),
  [1716] = {.count = 1, .reusable = true}, SHIFT(912),
  [1718] = {.count = 1, .reusable = true}, SHIFT(913),
  [1720] = {.count = 1, .reusable = true}, SHIFT(916),
  [1722] = {.count = 1, .reusable = true}, SHIFT(919),
  [1724] = {.count = 1, .reusable = true}, SHIFT(922),
  [1726] = {.count = 1, .reusable = true}, SHIFT(923),
  [1728] = {.count = 1, .reusable = true}, SHIFT(925),
  [1730] = {.count = 1, .reusable = false}, SHIFT(925),
  [1732] = {.count = 1, .reusable = true}, SHIFT(926),
  [1734] = {.count = 1, .reusable = false}, SHIFT(926),
  [1736] = {.count = 1, .reusable = true}, SHIFT(927),
  [1738] = {.count = 1, .reusable = false}, SHIFT(927),
  [1740] = {.count = 1, .reusable = true}, SHIFT(928),
  [1742] = {.count = 1, .reusable = true}, SHIFT(929),
  [1744] = {.count = 1, .reusable = false}, SHIFT(929),
  [1746] = {.count = 1, .reusable = true}, SHIFT(930),
  [1748] = {.count = 1, .reusable = false}, SHIFT(930),
  [1750] = {.count = 1, .reusable = true}, SHIFT(931),
  [1752] = {.count = 1, .reusable = false}, SHIFT(931),
  [1754] = {.count = 1, .reusable = true}, SHIFT(932),
  [1756] = {.count = 1, .reusable = false}, SHIFT(932),
  [1758] = {.count = 1, .reusable = false}, SHIFT(928),
  [1760] = {.count = 1, .reusable = true}, REDUCE(sym_dictionary, 3),
  [1762] = {.count = 1, .reusable = false}, REDUCE(sym_dictionary, 3),
  [1764] = {.count = 1, .reusable = true}, SHIFT(937),
  [1766] = {.count = 1, .reusable = true}, SHIFT(939),
  [1768] = {.count = 1, .reusable = true}, SHIFT(940),
  [1770] = {.count = 1, .reusable = true}, SHIFT(941),
  [1772] = {.count = 1, .reusable = false}, SHIFT(942),
  [1774] = {.count = 1, .reusable = true}, SHIFT(943),
  [1776] = {.count = 1, .reusable = true}, SHIFT(944),
  [1778] = {.count = 1, .reusable = true}, SHIFT(942),
  [1780] = {.count = 1, .reusable = true}, SHIFT(945),
  [1782] = {.count = 1, .reusable = true}, SHIFT(946),
  [1784] = {.count = 1, .reusable = true}, SHIFT(947),
  [1786] = {.count = 1, .reusable = true}, SHIFT(948),
  [1788] = {.count = 1, .reusable = true}, SHIFT(949),
  [1790] = {.count = 1, .reusable = true}, SHIFT(950),
  [1792] = {.count = 1, .reusable = false}, SHIFT(944),
  [1794] = {.count = 1, .reusable = true}, SHIFT(951),
  [1796] = {.count = 1, .reusable = true}, SHIFT(955),
  [1798] = {.count = 1, .reusable = true}, SHIFT(956),
  [1800] = {.count = 1, .reusable = true}, SHIFT(957),
  [1802] = {.count = 1, .reusable = true}, REDUCE(sym_set, 3),
  [1804] = {.count = 1, .reusable = false}, REDUCE(sym_set, 3),
  [1806] = {.count = 1, .reusable = true}, SHIFT(959),
  [1808] = {.count = 1, .reusable = true}, SHIFT(961),
  [1810] = {.count = 1, .reusable = true}, SHIFT(962),
  [1812] = {.count = 1, .reusable = true}, SHIFT(965),
  [1814] = {.count = 1, .reusable = false}, SHIFT(968),
  [1816] = {.count = 1, .reusable = true}, SHIFT(969),
  [1818] = {.count = 1, .reusable = false}, SHIFT(970),
  [1820] = {.count = 1, .reusable = true}, SHIFT(973),
  [1822] = {.count = 1, .reusable = false}, SHIFT(973),
  [1824] = {.count = 1, .reusable = false}, SHIFT(971),
  [1826] = {.count = 1, .reusable = true}, SHIFT(975),
  [1828] = {.count = 1, .reusable = true}, SHIFT(978),
  [1830] = {.count = 1, .reusable = true}, SHIFT(979),
  [1832] = {.count = 1, .reusable = true}, SHIFT(981),
  [1834] = {.count = 1, .reusable = false}, SHIFT(981),
  [1836] = {.count = 1, .reusable = true}, SHIFT(982),
  [1838] = {.count = 1, .reusable = false}, SHIFT(982),
  [1840] = {.count = 1, .reusable = true}, SHIFT(983),
  [1842] = {.count = 1, .reusable = false}, SHIFT(983),
  [1844] = {.count = 1, .reusable = true}, SHIFT(984),
  [1846] = {.count = 1, .reusable = true}, SHIFT(985),
  [1848] = {.count = 1, .reusable = false}, SHIFT(985),
  [1850] = {.count = 1, .reusable = true}, SHIFT(986),
  [1852] = {.count = 1, .reusable = false}, SHIFT(986),
  [1854] = {.count = 1, .reusable = true}, SHIFT(987),
  [1856] = {.count = 1, .reusable = false}, SHIFT(987),
  [1858] = {.count = 1, .reusable = true}, SHIFT(988),
  [1860] = {.count = 1, .reusable = false}, SHIFT(988),
  [1862] = {.count = 1, .reusable = false}, SHIFT(984),
  [1864] = {.count = 1, .reusable = true}, SHIFT(990),
  [1866] = {.count = 1, .reusable = true}, REDUCE(sym__simple_statements, 3),
  [1868] = {.count = 1, .reusable = false}, REDUCE(sym__simple_statements, 3),
  [1870] = {.count = 1, .reusable = true}, REDUCE(aux_sym__simple_statements_repeat1, 2),
  [1872] = {.count = 1, .reusable = true}, SHIFT(992),
  [1874] = {.count = 2, .reusable = true}, REDUCE(aux_sym__simple_statements_repeat1, 2), SHIFT_REPEAT(993),
  [1877] = {.count = 1, .reusable = true}, SHIFT(995),
  [1879] = {.count = 1, .reusable = true}, REDUCE(sym_type, 1),
  [1881] = {.count = 1, .reusable = true}, SHIFT(997),
  [1883] = {.count = 1, .reusable = true}, SHIFT(998),
  [1885] = {.count = 1, .reusable = true}, SHIFT(999),
  [1887] = {.count = 1, .reusable = false}, SHIFT(1000),
  [1889] = {.count = 1, .reusable = true}, SHIFT(1001),
  [1891] = {.count = 1, .reusable = true}, SHIFT(1002),
  [1893] = {.count = 1, .reusable = true}, SHIFT(1000),
  [1895] = {.count = 1, .reusable = true}, SHIFT(1003),
  [1897] = {.count = 1, .reusable = true}, SHIFT(1004),
  [1899] = {.count = 1, .reusable = true}, SHIFT(1005),
  [1901] = {.count = 1, .reusable = true}, SHIFT(1006),
  [1903] = {.count = 1, .reusable = true}, SHIFT(1007),
  [1905] = {.count = 1, .reusable = true}, SHIFT(1008),
  [1907] = {.count = 1, .reusable = false}, SHIFT(1002),
  [1909] = {.count = 1, .reusable = true}, SHIFT(1009),
  [1911] = {.count = 1, .reusable = true}, REDUCE(sym_assignment, 3),
  [1913] = {.count = 1, .reusable = true}, SHIFT(1011),
  [1915] = {.count = 1, .reusable = true}, REDUCE(sym__right_hand_side, 1),
  [1917] = {.count = 1, .reusable = true}, SHIFT(1013),
  [1919] = {.count = 1, .reusable = true}, REDUCE(sym_augmented_assignment, 3),
  [1921] = {.count = 1, .reusable = true}, REDUCE(aux_sym_print_statement_repeat1, 2),
  [1923] = {.count = 1, .reusable = true}, SHIFT(1016),
  [1925] = {.count = 1, .reusable = true}, SHIFT(1018),
  [1927] = {.count = 1, .reusable = true}, SHIFT(1019),
  [1929] = {.count = 1, .reusable = true}, SHIFT(1020),
  [1931] = {.count = 1, .reusable = true}, SHIFT(1021),
  [1933] = {.count = 1, .reusable = false}, SHIFT(1022),
  [1935] = {.count = 1, .reusable = true}, SHIFT(1023),
  [1937] = {.count = 1, .reusable = true}, SHIFT(1024),
  [1939] = {.count = 1, .reusable = true}, SHIFT(1022),
  [1941] = {.count = 1, .reusable = true}, SHIFT(1025),
  [1943] = {.count = 1, .reusable = true}, SHIFT(1026),
  [1945] = {.count = 1, .reusable = true}, SHIFT(1027),
  [1947] = {.count = 1, .reusable = true}, SHIFT(1028),
  [1949] = {.count = 1, .reusable = true}, SHIFT(1029),
  [1951] = {.count = 1, .reusable = true}, SHIFT(1030),
  [1953] = {.count = 1, .reusable = false}, SHIFT(1024),
  [1955] = {.count = 1, .reusable = true}, SHIFT(1031),
  [1957] = {.count = 1, .reusable = true}, REDUCE(sym_boolean_operator, 3),
  [1959] = {.count = 1, .reusable = true}, REDUCE(sym_expression_statement, 3),
  [1961] = {.count = 1, .reusable = true}, REDUCE(sym_expression_list, 3),
  [1963] = {.count = 2, .reusable = true}, REDUCE(aux_sym_print_statement_repeat1, 2), SHIFT_REPEAT(1034),
  [1966] = {.count = 1, .reusable = true}, REDUCE(sym_attribute, 3),
  [1968] = {.count = 1, .reusable = false}, REDUCE(sym_attribute, 3),
  [1970] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 2),
  [1972] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 2),
  [1974] = {.count = 1, .reusable = true}, SHIFT(1035),
  [1976] = {.count = 1, .reusable = true}, SHIFT(1036),
  [1978] = {.count = 1, .reusable = false}, SHIFT(1038),
  [1980] = {.count = 1, .reusable = false}, SHIFT(1039),
  [1982] = {.count = 1, .reusable = true}, SHIFT(1040),
  [1984] = {.count = 1, .reusable = true}, REDUCE(sym_binary_operator, 3),
  [1986] = {.count = 1, .reusable = false}, REDUCE(sym_binary_operator, 3),
  [1988] = {.count = 1, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2),
  [1990] = {.count = 1, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2),
  [1992] = {.count = 1, .reusable = true}, SHIFT(1042),
  [1994] = {.count = 1, .reusable = false}, SHIFT(1042),
  [1996] = {.count = 1, .reusable = true}, REDUCE(sym_slice, 1),
  [1998] = {.count = 1, .reusable = true}, SHIFT(1043),
  [2000] = {.count = 1, .reusable = true}, SHIFT(1046),
  [2002] = {.count = 1, .reusable = true}, SHIFT(1048),
  [2004] = {.count = 1, .reusable = true}, SHIFT(1049),
  [2006] = {.count = 1, .reusable = true}, SHIFT(1050),
  [2008] = {.count = 1, .reusable = true}, SHIFT(1051),
  [2010] = {.count = 1, .reusable = true}, SHIFT(1052),
  [2012] = {.count = 1, .reusable = true}, SHIFT(1053),
  [2014] = {.count = 1, .reusable = false}, SHIFT(1055),
  [2016] = {.count = 1, .reusable = true}, SHIFT(1056),
  [2018] = {.count = 1, .reusable = true}, SHIFT(1057),
  [2020] = {.count = 1, .reusable = true}, SHIFT(1055),
  [2022] = {.count = 1, .reusable = true}, SHIFT(1058),
  [2024] = {.count = 1, .reusable = true}, SHIFT(1059),
  [2026] = {.count = 1, .reusable = true}, SHIFT(1060),
  [2028] = {.count = 1, .reusable = true}, SHIFT(1061),
  [2030] = {.count = 1, .reusable = true}, SHIFT(1062),
  [2032] = {.count = 1, .reusable = true}, SHIFT(1063),
  [2034] = {.count = 1, .reusable = false}, SHIFT(1057),
  [2036] = {.count = 1, .reusable = true}, SHIFT(1064),
  [2038] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(183),
  [2041] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(184),
  [2044] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(183),
  [2047] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(190),
  [2050] = {.count = 1, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [2052] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(2),
  [2055] = {.count = 1, .reusable = false}, REDUCE(aux_sym_concatenated_string_repeat1, 2),
  [2057] = {.count = 1, .reusable = true}, SHIFT(1068),
  [2059] = {.count = 1, .reusable = true}, REDUCE(sym_interpolation, 3),
  [2061] = {.count = 1, .reusable = false}, REDUCE(sym_interpolation, 3),
  [2063] = {.count = 1, .reusable = true}, SHIFT(1071),
  [2065] = {.count = 1, .reusable = true}, SHIFT(1072),
  [2067] = {.count = 1, .reusable = false}, SHIFT(1072),
  [2069] = {.count = 1, .reusable = true}, SHIFT(1073),
  [2071] = {.count = 1, .reusable = false}, SHIFT(1073),
  [2073] = {.count = 1, .reusable = true}, SHIFT(1074),
  [2075] = {.count = 1, .reusable = false}, SHIFT(1074),
  [2077] = {.count = 1, .reusable = true}, SHIFT(1075),
  [2079] = {.count = 1, .reusable = true}, SHIFT(1076),
  [2081] = {.count = 1, .reusable = false}, SHIFT(1076),
  [2083] = {.count = 1, .reusable = true}, SHIFT(1077),
  [2085] = {.count = 1, .reusable = false}, SHIFT(1077),
  [2087] = {.count = 1, .reusable = true}, SHIFT(1078),
  [2089] = {.count = 1, .reusable = false}, SHIFT(1078),
  [2091] = {.count = 1, .reusable = true}, SHIFT(1079),
  [2093] = {.count = 1, .reusable = false}, SHIFT(1079),
  [2095] = {.count = 1, .reusable = false}, SHIFT(1075),
  [2097] = {.count = 1, .reusable = true}, REDUCE(aux_sym_dotted_name_repeat1, 2),
  [2099] = {.count = 2, .reusable = true}, REDUCE(aux_sym_dotted_name_repeat1, 2), SHIFT_REPEAT(208),
  [2102] = {.count = 1, .reusable = true}, REDUCE(aux_sym__import_list_repeat1, 2),
  [2104] = {.count = 1, .reusable = true}, REDUCE(sym__import_list, 3),
  [2106] = {.count = 2, .reusable = true}, REDUCE(aux_sym__import_list_repeat1, 2), SHIFT_REPEAT(1082),
  [2109] = {.count = 1, .reusable = true}, REDUCE(sym_aliased_import, 3),
  [2111] = {.count = 1, .reusable = true}, REDUCE(sym_future_import_statement, 4),
  [2113] = {.count = 2, .reusable = true}, REDUCE(aux_sym_dotted_name_repeat1, 2), SHIFT_REPEAT(214),
  [2116] = {.count = 1, .reusable = true}, SHIFT(1083),
  [2118] = {.count = 1, .reusable = true}, REDUCE(sym_wildcard_import, 1),
  [2120] = {.count = 1, .reusable = true}, REDUCE(sym_import_from_statement, 4),
  [2122] = {.count = 1, .reusable = true}, SHIFT(1087),
  [2124] = {.count = 1, .reusable = true}, SHIFT(1088),
  [2126] = {.count = 1, .reusable = true}, SHIFT(1089),
  [2128] = {.count = 1, .reusable = true}, SHIFT(1092),
  [2130] = {.count = 1, .reusable = true}, SHIFT(1096),
  [2132] = {.count = 1, .reusable = true}, SHIFT(1098),
  [2134] = {.count = 1, .reusable = false}, SHIFT(1098),
  [2136] = {.count = 1, .reusable = true}, SHIFT(1099),
  [2138] = {.count = 1, .reusable = false}, SHIFT(1099),
  [2140] = {.count = 1, .reusable = true}, SHIFT(1100),
  [2142] = {.count = 1, .reusable = false}, SHIFT(1100),
  [2144] = {.count = 1, .reusable = true}, SHIFT(1101),
  [2146] = {.count = 1, .reusable = true}, SHIFT(1102),
  [2148] = {.count = 1, .reusable = false}, SHIFT(1102),
  [2150] = {.count = 1, .reusable = true}, SHIFT(1103),
  [2152] = {.count = 1, .reusable = false}, SHIFT(1103),
  [2154] = {.count = 1, .reusable = true}, SHIFT(1104),
  [2156] = {.count = 1, .reusable = false}, SHIFT(1104),
  [2158] = {.count = 1, .reusable = true}, SHIFT(1105),
  [2160] = {.count = 1, .reusable = false}, SHIFT(1105),
  [2162] = {.count = 1, .reusable = false}, SHIFT(1101),
  [2164] = {.count = 1, .reusable = true}, SHIFT(1108),
  [2166] = {.count = 1, .reusable = true}, SHIFT(1109),
  [2168] = {.count = 1, .reusable = true}, SHIFT(1110),
  [2170] = {.count = 1, .reusable = true}, SHIFT(1111),
  [2172] = {.count = 1, .reusable = true}, SHIFT(1112),
  [2174] = {.count = 1, .reusable = true}, SHIFT(1113),
  [2176] = {.count = 1, .reusable = true}, SHIFT(1114),
  [2178] = {.count = 1, .reusable = true}, SHIFT(1115),
  [2180] = {.count = 1, .reusable = true}, SHIFT(1116),
  [2182] = {.count = 1, .reusable = true}, REDUCE(sym_tuple, 4),
  [2184] = {.count = 1, .reusable = false}, REDUCE(sym_tuple, 4),
  [2186] = {.count = 1, .reusable = true}, REDUCE(aux_sym_tuple_repeat1, 2),
  [2188] = {.count = 1, .reusable = true}, SHIFT(1117),
  [2190] = {.count = 1, .reusable = true}, SHIFT(1119),
  [2192] = {.count = 1, .reusable = false}, REDUCE(sym_boolean_operator, 3),
  [2194] = {.count = 1, .reusable = true}, REDUCE(sym_generator_expression, 4),
  [2196] = {.count = 1, .reusable = false}, REDUCE(sym_generator_expression, 4),
  [2198] = {.count = 1, .reusable = false}, SHIFT(1120),
  [2200] = {.count = 1, .reusable = true}, SHIFT(1121),
  [2202] = {.count = 1, .reusable = false}, SHIFT(1122),
  [2204] = {.count = 1, .reusable = true}, SHIFT(1125),
  [2206] = {.count = 1, .reusable = false}, SHIFT(1125),
  [2208] = {.count = 1, .reusable = false}, SHIFT(1123),
  [2210] = {.count = 1, .reusable = true}, REDUCE(sym__comprehension_body, 2),
  [2212] = {.count = 1, .reusable = true}, SHIFT(1128),
  [2214] = {.count = 2, .reusable = true}, REDUCE(aux_sym_tuple_repeat1, 2), SHIFT_REPEAT(1129),
  [2217] = {.count = 1, .reusable = true}, SHIFT(1130),
  [2219] = {.count = 1, .reusable = true}, SHIFT(1131),
  [2221] = {.count = 1, .reusable = true}, SHIFT(1133),
  [2223] = {.count = 1, .reusable = false}, SHIFT(1133),
  [2225] = {.count = 1, .reusable = true}, SHIFT(1134),
  [2227] = {.count = 1, .reusable = true}, SHIFT(1135),
  [2229] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(264),
  [2232] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(265),
  [2235] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(264),
  [2238] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(271),
  [2241] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(54),
  [2244] = {.count = 1, .reusable = true}, SHIFT(1137),
  [2246] = {.count = 1, .reusable = true}, SHIFT(1138),
  [2248] = {.count = 1, .reusable = true}, SHIFT(1139),
  [2250] = {.count = 1, .reusable = true}, SHIFT(1141),
  [2252] = {.count = 1, .reusable = true}, SHIFT(1142),
  [2254] = {.count = 1, .reusable = true}, SHIFT(1143),
  [2256] = {.count = 1, .reusable = true}, SHIFT(1144),
  [2258] = {.count = 1, .reusable = true}, SHIFT(1145),
  [2260] = {.count = 1, .reusable = true}, SHIFT(1146),
  [2262] = {.count = 1, .reusable = true}, SHIFT(1147),
  [2264] = {.count = 1, .reusable = true}, SHIFT(1148),
  [2266] = {.count = 1, .reusable = true}, SHIFT(1149),
  [2268] = {.count = 1, .reusable = true}, REDUCE(sym_print_statement, 4),
  [2270] = {.count = 2, .reusable = true}, REDUCE(aux_sym_print_statement_repeat1, 2), SHIFT_REPEAT(318),
  [2273] = {.count = 1, .reusable = true}, SHIFT(1150),
  [2275] = {.count = 1, .reusable = true}, SHIFT(1151),
  [2277] = {.count = 1, .reusable = true}, SHIFT(1152),
  [2279] = {.count = 1, .reusable = true}, SHIFT(1154),
  [2281] = {.count = 1, .reusable = false}, SHIFT(1154),
  [2283] = {.count = 1, .reusable = true}, SHIFT(1155),
  [2285] = {.count = 1, .reusable = true}, SHIFT(1156),
  [2287] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(306),
  [2290] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(307),
  [2293] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(306),
  [2296] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(313),
  [2299] = {.count = 2, .reusable = true}, REDUCE(aux_sym_concatenated_string_repeat1, 2), SHIFT_REPEAT(70),
  [2302] = {.count = 1, .reusable = true}, SHIFT(1159),
  [2304] = {.count = 1, .reusable = true}, SHIFT(1162),
  [2306] = {.count = 1, .reusable = false}, SHIFT(1162),
  [2308] = {.count = 1, .reusable = true}, SHIFT(1163),
  [2310] = {.count = 1, .reusable = false}, SHIFT(1163),
  [2312] = {.count = 1, .reusable = true}, SHIFT(1164),
  [2314] = {.count = 1, .reusable = false}, SHIFT(1164),
  [2316] = {.count = 1, .reusable = true}, SHIFT(1165),
  [2318] = {.count = 1, .reusable = true}, SHIFT(1166),
  [2320] = {.count = 1, .reusable = false}, SHIFT(1166),
  [2322] = {.count = 1, .reusable = true}, SHIFT(1167),
  [2324] = {.count = 1, .reusable = false}, SHIFT(1167),
  [2326] = {.count = 1, .reusable = true}, SHIFT(1168),
  [2328] = {.count = 1, .reusable = false}, SHIFT(1168),
  [2330] = {.count = 1, .reusable = true}, SHIFT(1169),
  [2332] = {.count = 1, .reusable = false}, SHIFT(1169),
  [2334] = {.count = 1, .reusable = false}, SHIFT(1165),
  [2336] = {.count = 1, .reusable = true}, REDUCE(sym_raise_statement, 4),
  [2338] = {.count = 1, .reusable = true}, SHIFT(1173),
  [2340] = {.count = 1, .reusable = false}, REDUCE(sym_expression_list, 3),
  [2342] = {.count = 2, .reusable = true}, REDUCE(aux_sym_print_statement_repeat1, 2), SHIFT_REPEAT(1174),
  [2345] = {.count = 1, .reusable = true}, SHIFT(1175),
  [2347] = {.count = 1, .reusable = false}, SHIFT(1175),
  [2349] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(340),
  [2352] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(341),
  [2355] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(340),
  [2358] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(347),
  [2361] = {.count = 1, .reusable = true}, SHIFT(1177),
  [2363] = {.count = 1, .reusable = true}, SHIFT(1178),
  [2365] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 4),
  [2367] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 4),
  [2369] = {.count = 1, .reusable = false}, SHIFT(1180),
  [2371] = {.count = 1, .reusable = false}, SHIFT(1181),
  [2373] = {.count = 1, .reusable = true}, SHIFT(1184),
  [2375] = {.count = 1, .reusable = false}, SHIFT(1184),
  [2377] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(359),
  [2380] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(360),
  [2383] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(359),
  [2386] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(366),
  [2389] = {.count = 1, .reusable = true}, SHIFT(1187),
  [2391] = {.count = 1, .reusable = true}, SHIFT(1188),
  [2393] = {.count = 1, .reusable = true}, SHIFT(1189),
  [2395] = {.count = 1, .reusable = true}, SHIFT(1190),
  [2397] = {.count = 1, .reusable = true}, SHIFT(1191),
  [2399] = {.count = 1, .reusable = true}, REDUCE(aux_sym_variables_repeat1, 2),
  [2401] = {.count = 1, .reusable = false}, REDUCE(sym_variables, 3),
  [2403] = {.count = 2, .reusable = true}, REDUCE(aux_sym_variables_repeat1, 2), SHIFT_REPEAT(1193),
  [2406] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 4),
  [2408] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 4),
  [2410] = {.count = 1, .reusable = true}, REDUCE(sym__suite, 2),
  [2412] = {.count = 1, .reusable = true}, SHIFT(1196),
  [2414] = {.count = 1, .reusable = true}, SHIFT(1197),
  [2416] = {.count = 1, .reusable = true}, SHIFT(1198),
  [2418] = {.count = 1, .reusable = true}, SHIFT(1201),
  [2420] = {.count = 1, .reusable = true}, SHIFT(1203),
  [2422] = {.count = 1, .reusable = true}, SHIFT(1204),
  [2424] = {.count = 1, .reusable = true}, SHIFT(1205),
  [2426] = {.count = 1, .reusable = true}, SHIFT(1206),
  [2428] = {.count = 1, .reusable = true}, SHIFT(1208),
  [2430] = {.count = 1, .reusable = true}, SHIFT(1210),
  [2432] = {.count = 1, .reusable = true}, SHIFT(797),
  [2434] = {.count = 1, .reusable = true}, SHIFT(798),
  [2436] = {.count = 1, .reusable = true}, SHIFT(1212),
  [2438] = {.count = 1, .reusable = true}, SHIFT(1213),
  [2440] = {.count = 1, .reusable = true}, SHIFT(1214),
  [2442] = {.count = 1, .reusable = true}, SHIFT(1216),
  [2444] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 4),
  [2446] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 4),
  [2448] = {.count = 1, .reusable = false}, SHIFT(805),
  [2450] = {.count = 1, .reusable = false}, SHIFT(806),
  [2452] = {.count = 1, .reusable = true}, REDUCE(aux_sym_with_statement_repeat1, 2),
  [2454] = {.count = 1, .reusable = true}, REDUCE(sym_with_statement, 4),
  [2456] = {.count = 1, .reusable = false}, REDUCE(sym_with_statement, 4),
  [2458] = {.count = 2, .reusable = true}, REDUCE(aux_sym_with_statement_repeat1, 2), SHIFT_REPEAT(390),
  [2461] = {.count = 1, .reusable = true}, REDUCE(sym_with_item, 3),
  [2463] = {.count = 1, .reusable = true}, SHIFT(1221),
  [2465] = {.count = 1, .reusable = true}, SHIFT(1222),
  [2467] = {.count = 1, .reusable = false}, SHIFT(1222),
  [2469] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(399),
  [2472] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(400),
  [2475] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(399),
  [2478] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(406),
  [2481] = {.count = 1, .reusable = true}, REDUCE(sym_parameters, 2),
  [2483] = {.count = 1, .reusable = true}, SHIFT(1223),
  [2485] = {.count = 1, .reusable = false}, SHIFT(1224),
  [2487] = {.count = 1, .reusable = true}, SHIFT(1225),
  [2489] = {.count = 1, .reusable = false}, SHIFT(1226),
  [2491] = {.count = 1, .reusable = true}, SHIFT(1229),
  [2493] = {.count = 1, .reusable = false}, SHIFT(1229),
  [2495] = {.count = 1, .reusable = false}, SHIFT(1227),
  [2497] = {.count = 1, .reusable = true}, SHIFT(1231),
  [2499] = {.count = 1, .reusable = true}, SHIFT(1232),
  [2501] = {.count = 1, .reusable = true}, SHIFT(1233),
  [2503] = {.count = 1, .reusable = true}, SHIFT(1235),
  [2505] = {.count = 1, .reusable = true}, SHIFT(1236),
  [2507] = {.count = 1, .reusable = true}, SHIFT(1237),
  [2509] = {.count = 1, .reusable = true}, SHIFT(1239),
  [2511] = {.count = 1, .reusable = true}, SHIFT(1240),
  [2513] = {.count = 1, .reusable = true}, REDUCE(aux_sym_global_statement_repeat1, 2),
  [2515] = {.count = 2, .reusable = true}, REDUCE(aux_sym_global_statement_repeat1, 2), SHIFT_REPEAT(411),
  [2518] = {.count = 1, .reusable = true}, REDUCE(sym_exec_statement, 4),
  [2520] = {.count = 1, .reusable = true}, REDUCE(sym_class_definition, 4),
  [2522] = {.count = 1, .reusable = false}, REDUCE(sym_class_definition, 4),
  [2524] = {.count = 1, .reusable = true}, REDUCE(sym_decorator, 4),
  [2526] = {.count = 1, .reusable = true}, REDUCE(sym_dictionary_splat, 3),
  [2528] = {.count = 1, .reusable = true}, SHIFT(1247),
  [2530] = {.count = 1, .reusable = true}, SHIFT(1250),
  [2532] = {.count = 1, .reusable = false}, SHIFT(1250),
  [2534] = {.count = 1, .reusable = true}, SHIFT(1251),
  [2536] = {.count = 1, .reusable = false}, SHIFT(1251),
  [2538] = {.count = 1, .reusable = true}, SHIFT(1252),
  [2540] = {.count = 1, .reusable = false}, SHIFT(1252),
  [2542] = {.count = 1, .reusable = true}, SHIFT(1253),
  [2544] = {.count = 1, .reusable = true}, SHIFT(1254),
  [2546] = {.count = 1, .reusable = false}, SHIFT(1254),
  [2548] = {.count = 1, .reusable = true}, SHIFT(1255),
  [2550] = {.count = 1, .reusable = false}, SHIFT(1255),
  [2552] = {.count = 1, .reusable = true}, SHIFT(1256),
  [2554] = {.count = 1, .reusable = false}, SHIFT(1256),
  [2556] = {.count = 1, .reusable = true}, SHIFT(1257),
  [2558] = {.count = 1, .reusable = false}, SHIFT(1257),
  [2560] = {.count = 1, .reusable = false}, SHIFT(1253),
  [2562] = {.count = 1, .reusable = true}, REDUCE(aux_sym__parameters_repeat1, 2, .alias_sequence_id = 2),
  [2564] = {.count = 1, .reusable = true}, REDUCE(aux_sym__parameters_repeat1, 2),
  [2566] = {.count = 1, .reusable = true}, SHIFT(1261),
  [2568] = {.count = 1, .reusable = true}, SHIFT(1263),
  [2570] = {.count = 1, .reusable = true}, SHIFT(1264),
  [2572] = {.count = 1, .reusable = true}, SHIFT(1265),
  [2574] = {.count = 1, .reusable = false}, SHIFT(1266),
  [2576] = {.count = 1, .reusable = true}, SHIFT(1267),
  [2578] = {.count = 1, .reusable = true}, SHIFT(1268),
  [2580] = {.count = 1, .reusable = true}, SHIFT(1266),
  [2582] = {.count = 1, .reusable = true}, SHIFT(1269),
  [2584] = {.count = 1, .reusable = true}, SHIFT(1270),
  [2586] = {.count = 1, .reusable = true}, SHIFT(1271),
  [2588] = {.count = 1, .reusable = true}, SHIFT(1272),
  [2590] = {.count = 1, .reusable = true}, SHIFT(1273),
  [2592] = {.count = 1, .reusable = true}, SHIFT(1274),
  [2594] = {.count = 1, .reusable = false}, SHIFT(1268),
  [2596] = {.count = 1, .reusable = true}, SHIFT(1275),
  [2598] = {.count = 1, .reusable = true}, SHIFT(1277),
  [2600] = {.count = 1, .reusable = true}, REDUCE(sym_default_parameter, 3, .alias_sequence_id = 1),
  [2602] = {.count = 1, .reusable = true}, REDUCE(sym__parameters, 3, .alias_sequence_id = 1),
  [2604] = {.count = 2, .reusable = true}, REDUCE(aux_sym__parameters_repeat1, 2), SHIFT_REPEAT(1279),
  [2607] = {.count = 1, .reusable = true}, SHIFT(1281),
  [2609] = {.count = 1, .reusable = true}, SHIFT(1283),
  [2611] = {.count = 1, .reusable = true}, SHIFT(1284),
  [2613] = {.count = 1, .reusable = true}, SHIFT(1285),
  [2615] = {.count = 1, .reusable = false}, SHIFT(1286),
  [2617] = {.count = 1, .reusable = true}, SHIFT(1287),
  [2619] = {.count = 1, .reusable = true}, SHIFT(1288),
  [2621] = {.count = 1, .reusable = true}, SHIFT(1286),
  [2623] = {.count = 1, .reusable = true}, SHIFT(1289),
  [2625] = {.count = 1, .reusable = true}, SHIFT(1290),
  [2627] = {.count = 1, .reusable = true}, SHIFT(1291),
  [2629] = {.count = 1, .reusable = true}, SHIFT(1292),
  [2631] = {.count = 1, .reusable = true}, SHIFT(1293),
  [2633] = {.count = 1, .reusable = true}, SHIFT(1294),
  [2635] = {.count = 1, .reusable = false}, SHIFT(1288),
  [2637] = {.count = 1, .reusable = true}, SHIFT(1295),
  [2639] = {.count = 1, .reusable = true}, REDUCE(sym_typed_parameter, 3),
  [2641] = {.count = 1, .reusable = true}, SHIFT(1297),
  [2643] = {.count = 1, .reusable = true}, REDUCE(sym_default_parameter, 3),
  [2645] = {.count = 1, .reusable = true}, REDUCE(sym__parameters, 3),
  [2647] = {.count = 1, .reusable = true}, REDUCE(sym_lambda, 4),
  [2649] = {.count = 1, .reusable = true}, SHIFT(1300),
  [2651] = {.count = 1, .reusable = true}, SHIFT(1303),
  [2653] = {.count = 1, .reusable = false}, SHIFT(1303),
  [2655] = {.count = 1, .reusable = true}, SHIFT(1304),
  [2657] = {.count = 1, .reusable = false}, SHIFT(1304),
  [2659] = {.count = 1, .reusable = true}, SHIFT(1305),
  [2661] = {.count = 1, .reusable = false}, SHIFT(1305),
  [2663] = {.count = 1, .reusable = true}, SHIFT(1306),
  [2665] = {.count = 1, .reusable = true}, SHIFT(1307),
  [2667] = {.count = 1, .reusable = false}, SHIFT(1307),
  [2669] = {.count = 1, .reusable = true}, SHIFT(1308),
  [2671] = {.count = 1, .reusable = false}, SHIFT(1308),
  [2673] = {.count = 1, .reusable = true}, SHIFT(1309),
  [2675] = {.count = 1, .reusable = false}, SHIFT(1309),
  [2677] = {.count = 1, .reusable = true}, SHIFT(1310),
  [2679] = {.count = 1, .reusable = false}, SHIFT(1310),
  [2681] = {.count = 1, .reusable = false}, SHIFT(1306),
  [2683] = {.count = 1, .reusable = true}, REDUCE(sym_list, 4),
  [2685] = {.count = 1, .reusable = false}, REDUCE(sym_list, 4),
  [2687] = {.count = 1, .reusable = true}, REDUCE(aux_sym_list_repeat1, 2),
  [2689] = {.count = 1, .reusable = true}, SHIFT(1314),
  [2691] = {.count = 2, .reusable = true}, REDUCE(aux_sym_list_repeat1, 2), SHIFT_REPEAT(1315),
  [2694] = {.count = 1, .reusable = true}, SHIFT(1316),
  [2696] = {.count = 1, .reusable = true}, SHIFT(1318),
  [2698] = {.count = 1, .reusable = true}, REDUCE(sym_list_comprehension, 4),
  [2700] = {.count = 1, .reusable = false}, REDUCE(sym_list_comprehension, 4),
  [2702] = {.count = 1, .reusable = false}, SHIFT(1319),
  [2704] = {.count = 1, .reusable = true}, SHIFT(1320),
  [2706] = {.count = 1, .reusable = false}, SHIFT(1321),
  [2708] = {.count = 1, .reusable = true}, SHIFT(1324),
  [2710] = {.count = 1, .reusable = false}, SHIFT(1324),
  [2712] = {.count = 1, .reusable = false}, SHIFT(1322),
  [2714] = {.count = 1, .reusable = true}, SHIFT(1327),
  [2716] = {.count = 1, .reusable = false}, SHIFT(1327),
  [2718] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(468),
  [2721] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(469),
  [2724] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(468),
  [2727] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(475),
  [2730] = {.count = 1, .reusable = true}, SHIFT(1329),
  [2732] = {.count = 1, .reusable = true}, SHIFT(1332),
  [2734] = {.count = 1, .reusable = false}, SHIFT(1332),
  [2736] = {.count = 1, .reusable = true}, SHIFT(1333),
  [2738] = {.count = 1, .reusable = false}, SHIFT(1333),
  [2740] = {.count = 1, .reusable = true}, SHIFT(1334),
  [2742] = {.count = 1, .reusable = false}, SHIFT(1334),
  [2744] = {.count = 1, .reusable = true}, SHIFT(1335),
  [2746] = {.count = 1, .reusable = true}, SHIFT(1336),
  [2748] = {.count = 1, .reusable = false}, SHIFT(1336),
  [2750] = {.count = 1, .reusable = true}, SHIFT(1337),
  [2752] = {.count = 1, .reusable = false}, SHIFT(1337),
  [2754] = {.count = 1, .reusable = true}, SHIFT(1338),
  [2756] = {.count = 1, .reusable = false}, SHIFT(1338),
  [2758] = {.count = 1, .reusable = true}, SHIFT(1339),
  [2760] = {.count = 1, .reusable = false}, SHIFT(1339),
  [2762] = {.count = 1, .reusable = false}, SHIFT(1335),
  [2764] = {.count = 1, .reusable = true}, REDUCE(sym_set, 4),
  [2766] = {.count = 1, .reusable = false}, REDUCE(sym_set, 4),
  [2768] = {.count = 1, .reusable = true}, SHIFT(1343),
  [2770] = {.count = 2, .reusable = true}, REDUCE(aux_sym_list_repeat1, 2), SHIFT_REPEAT(1344),
  [2773] = {.count = 1, .reusable = true}, REDUCE(sym_dictionary, 4),
  [2775] = {.count = 1, .reusable = false}, REDUCE(sym_dictionary, 4),
  [2777] = {.count = 1, .reusable = true}, REDUCE(aux_sym_dictionary_repeat1, 2),
  [2779] = {.count = 1, .reusable = true}, SHIFT(1345),
  [2781] = {.count = 1, .reusable = true}, SHIFT(1346),
  [2783] = {.count = 2, .reusable = true}, REDUCE(aux_sym_dictionary_repeat1, 2), SHIFT_REPEAT(1347),
  [2786] = {.count = 1, .reusable = true}, SHIFT(1348),
  [2788] = {.count = 1, .reusable = true}, SHIFT(1350),
  [2790] = {.count = 1, .reusable = true}, REDUCE(sym_pair, 3),
  [2792] = {.count = 1, .reusable = true}, SHIFT(1352),
  [2794] = {.count = 1, .reusable = true}, SHIFT(1353),
  [2796] = {.count = 1, .reusable = true}, SHIFT(1354),
  [2798] = {.count = 1, .reusable = false}, SHIFT(1355),
  [2800] = {.count = 1, .reusable = true}, SHIFT(1356),
  [2802] = {.count = 1, .reusable = true}, SHIFT(1357),
  [2804] = {.count = 1, .reusable = true}, SHIFT(1355),
  [2806] = {.count = 1, .reusable = true}, SHIFT(1358),
  [2808] = {.count = 1, .reusable = true}, SHIFT(1359),
  [2810] = {.count = 1, .reusable = true}, SHIFT(1360),
  [2812] = {.count = 1, .reusable = true}, SHIFT(1361),
  [2814] = {.count = 1, .reusable = true}, SHIFT(1362),
  [2816] = {.count = 1, .reusable = true}, SHIFT(1363),
  [2818] = {.count = 1, .reusable = false}, SHIFT(1357),
  [2820] = {.count = 1, .reusable = true}, SHIFT(1364),
  [2822] = {.count = 1, .reusable = true}, SHIFT(1368),
  [2824] = {.count = 1, .reusable = true}, REDUCE(sym_set_comprehension, 4),
  [2826] = {.count = 1, .reusable = false}, REDUCE(sym_set_comprehension, 4),
  [2828] = {.count = 1, .reusable = false}, SHIFT(1369),
  [2830] = {.count = 1, .reusable = true}, SHIFT(1370),
  [2832] = {.count = 1, .reusable = false}, SHIFT(1371),
  [2834] = {.count = 1, .reusable = true}, SHIFT(1374),
  [2836] = {.count = 1, .reusable = false}, SHIFT(1374),
  [2838] = {.count = 1, .reusable = false}, SHIFT(1372),
  [2840] = {.count = 1, .reusable = true}, SHIFT(1377),
  [2842] = {.count = 1, .reusable = false}, SHIFT(1377),
  [2844] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(505),
  [2847] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(506),
  [2850] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(505),
  [2853] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(512),
  [2856] = {.count = 1, .reusable = true}, REDUCE(sym_dictionary_comprehension, 4),
  [2858] = {.count = 1, .reusable = false}, REDUCE(sym_dictionary_comprehension, 4),
  [2860] = {.count = 1, .reusable = true}, REDUCE(sym__simple_statements, 4),
  [2862] = {.count = 1, .reusable = false}, REDUCE(sym__simple_statements, 4),
  [2864] = {.count = 1, .reusable = true}, SHIFT(1379),
  [2866] = {.count = 1, .reusable = true}, SHIFT(1382),
  [2868] = {.count = 1, .reusable = false}, SHIFT(1382),
  [2870] = {.count = 1, .reusable = true}, SHIFT(1383),
  [2872] = {.count = 1, .reusable = false}, SHIFT(1383),
  [2874] = {.count = 1, .reusable = true}, SHIFT(1384),
  [2876] = {.count = 1, .reusable = false}, SHIFT(1384),
  [2878] = {.count = 1, .reusable = true}, SHIFT(1385),
  [2880] = {.count = 1, .reusable = true}, SHIFT(1386),
  [2882] = {.count = 1, .reusable = false}, SHIFT(1386),
  [2884] = {.count = 1, .reusable = true}, SHIFT(1387),
  [2886] = {.count = 1, .reusable = false}, SHIFT(1387),
  [2888] = {.count = 1, .reusable = true}, SHIFT(1388),
  [2890] = {.count = 1, .reusable = false}, SHIFT(1388),
  [2892] = {.count = 1, .reusable = true}, SHIFT(1389),
  [2894] = {.count = 1, .reusable = false}, SHIFT(1389),
  [2896] = {.count = 1, .reusable = false}, SHIFT(1385),
  [2898] = {.count = 1, .reusable = true}, SHIFT(1393),
  [2900] = {.count = 1, .reusable = true}, SHIFT(1395),
  [2902] = {.count = 1, .reusable = true}, SHIFT(1399),
  [2904] = {.count = 1, .reusable = false}, SHIFT(1399),
  [2906] = {.count = 1, .reusable = true}, SHIFT(1400),
  [2908] = {.count = 1, .reusable = false}, SHIFT(1400),
  [2910] = {.count = 1, .reusable = true}, SHIFT(1401),
  [2912] = {.count = 1, .reusable = false}, SHIFT(1401),
  [2914] = {.count = 1, .reusable = true}, SHIFT(1402),
  [2916] = {.count = 1, .reusable = true}, SHIFT(1403),
  [2918] = {.count = 1, .reusable = false}, SHIFT(1403),
  [2920] = {.count = 1, .reusable = true}, SHIFT(1404),
  [2922] = {.count = 1, .reusable = false}, SHIFT(1404),
  [2924] = {.count = 1, .reusable = true}, SHIFT(1405),
  [2926] = {.count = 1, .reusable = false}, SHIFT(1405),
  [2928] = {.count = 1, .reusable = true}, SHIFT(1406),
  [2930] = {.count = 1, .reusable = false}, SHIFT(1406),
  [2932] = {.count = 1, .reusable = false}, SHIFT(1402),
  [2934] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 3),
  [2936] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 3),
  [2938] = {.count = 1, .reusable = true}, SHIFT(1412),
  [2940] = {.count = 1, .reusable = true}, SHIFT(1415),
  [2942] = {.count = 1, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 3),
  [2944] = {.count = 1, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 3),
  [2946] = {.count = 1, .reusable = true}, REDUCE(sym_slice, 2),
  [2948] = {.count = 1, .reusable = true}, SHIFT(1418),
  [2950] = {.count = 1, .reusable = true}, SHIFT(1420),
  [2952] = {.count = 1, .reusable = true}, SHIFT(1421),
  [2954] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 4),
  [2956] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 4),
  [2958] = {.count = 1, .reusable = true}, SHIFT(1427),
  [2960] = {.count = 1, .reusable = true}, SHIFT(1429),
  [2962] = {.count = 1, .reusable = false}, SHIFT(1429),
  [2964] = {.count = 1, .reusable = true}, SHIFT(1430),
  [2966] = {.count = 1, .reusable = false}, SHIFT(1430),
  [2968] = {.count = 1, .reusable = true}, SHIFT(1431),
  [2970] = {.count = 1, .reusable = false}, SHIFT(1431),
  [2972] = {.count = 1, .reusable = true}, SHIFT(1432),
  [2974] = {.count = 1, .reusable = true}, SHIFT(1433),
  [2976] = {.count = 1, .reusable = false}, SHIFT(1433),
  [2978] = {.count = 1, .reusable = true}, SHIFT(1434),
  [2980] = {.count = 1, .reusable = false}, SHIFT(1434),
  [2982] = {.count = 1, .reusable = true}, SHIFT(1435),
  [2984] = {.count = 1, .reusable = false}, SHIFT(1435),
  [2986] = {.count = 1, .reusable = true}, SHIFT(1436),
  [2988] = {.count = 1, .reusable = false}, SHIFT(1436),
  [2990] = {.count = 1, .reusable = false}, SHIFT(1432),
  [2992] = {.count = 1, .reusable = true}, SHIFT(1440),
  [2994] = {.count = 1, .reusable = true}, REDUCE(sym_interpolation, 4),
  [2996] = {.count = 1, .reusable = false}, REDUCE(sym_interpolation, 4),
  [2998] = {.count = 1, .reusable = true}, SHIFT(1441),
  [3000] = {.count = 1, .reusable = false}, SHIFT(1441),
  [3002] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(582),
  [3005] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(583),
  [3008] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(582),
  [3011] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(589),
  [3014] = {.count = 1, .reusable = true}, SHIFT(1443),
  [3016] = {.count = 1, .reusable = true}, SHIFT(1444),
  [3018] = {.count = 1, .reusable = true}, SHIFT(1446),
  [3020] = {.count = 1, .reusable = true}, SHIFT(1447),
  [3022] = {.count = 1, .reusable = true}, SHIFT(1449),
  [3024] = {.count = 2, .reusable = true}, REDUCE(aux_sym_print_statement_repeat1, 2), SHIFT_REPEAT(1450),
  [3027] = {.count = 1, .reusable = true}, SHIFT(1451),
  [3029] = {.count = 1, .reusable = false}, SHIFT(1451),
  [3031] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(624),
  [3034] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(625),
  [3037] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(624),
  [3040] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(631),
  [3043] = {.count = 1, .reusable = true}, SHIFT(1452),
  [3045] = {.count = 1, .reusable = true}, SHIFT(1453),
  [3047] = {.count = 1, .reusable = true}, SHIFT(1454),
  [3049] = {.count = 1, .reusable = true}, SHIFT(1456),
  [3051] = {.count = 1, .reusable = false}, SHIFT(1457),
  [3053] = {.count = 1, .reusable = true}, SHIFT(1461),
  [3055] = {.count = 1, .reusable = true}, REDUCE(sym_if_clause, 2),
  [3057] = {.count = 1, .reusable = true}, SHIFT(1464),
  [3059] = {.count = 1, .reusable = true}, SHIFT(1465),
  [3061] = {.count = 1, .reusable = false}, SHIFT(1466),
  [3063] = {.count = 1, .reusable = true}, SHIFT(1467),
  [3065] = {.count = 1, .reusable = true}, SHIFT(1468),
  [3067] = {.count = 1, .reusable = true}, SHIFT(1466),
  [3069] = {.count = 1, .reusable = true}, SHIFT(1469),
  [3071] = {.count = 1, .reusable = true}, SHIFT(1470),
  [3073] = {.count = 1, .reusable = true}, SHIFT(1471),
  [3075] = {.count = 1, .reusable = true}, SHIFT(1472),
  [3077] = {.count = 1, .reusable = true}, SHIFT(1473),
  [3079] = {.count = 1, .reusable = true}, SHIFT(1474),
  [3081] = {.count = 1, .reusable = false}, SHIFT(1468),
  [3083] = {.count = 1, .reusable = true}, SHIFT(1475),
  [3085] = {.count = 1, .reusable = true}, REDUCE(aux_sym__comprehension_body_repeat1, 2),
  [3087] = {.count = 2, .reusable = true}, REDUCE(aux_sym__comprehension_body_repeat1, 2), SHIFT_REPEAT(655),
  [3090] = {.count = 2, .reusable = true}, REDUCE(aux_sym__comprehension_body_repeat1, 2), SHIFT_REPEAT(253),
  [3093] = {.count = 2, .reusable = true}, REDUCE(aux_sym__comprehension_body_repeat1, 2), SHIFT_REPEAT(254),
  [3096] = {.count = 1, .reusable = true}, REDUCE(sym_tuple, 5),
  [3098] = {.count = 1, .reusable = false}, REDUCE(sym_tuple, 5),
  [3100] = {.count = 1, .reusable = true}, SHIFT(1478),
  [3102] = {.count = 1, .reusable = true}, SHIFT(1479),
  [3104] = {.count = 1, .reusable = true}, SHIFT(1480),
  [3106] = {.count = 1, .reusable = true}, SHIFT(1481),
  [3108] = {.count = 1, .reusable = true}, SHIFT(1482),
  [3110] = {.count = 1, .reusable = true}, SHIFT(1483),
  [3112] = {.count = 1, .reusable = true}, SHIFT(1484),
  [3114] = {.count = 1, .reusable = true}, SHIFT(1485),
  [3116] = {.count = 1, .reusable = true}, SHIFT(1487),
  [3118] = {.count = 1, .reusable = true}, SHIFT(1488),
  [3120] = {.count = 1, .reusable = true}, SHIFT(1489),
  [3122] = {.count = 1, .reusable = true}, SHIFT(1490),
  [3124] = {.count = 1, .reusable = true}, SHIFT(1492),
  [3126] = {.count = 1, .reusable = true}, SHIFT(1493),
  [3128] = {.count = 1, .reusable = false}, SHIFT(1493),
  [3130] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(729),
  [3133] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(730),
  [3136] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(729),
  [3139] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(736),
  [3142] = {.count = 1, .reusable = false}, REDUCE(sym__suite, 2),
  [3144] = {.count = 1, .reusable = true}, SHIFT(1496),
  [3146] = {.count = 1, .reusable = true}, SHIFT(1498),
  [3148] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 5),
  [3150] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 5),
  [3152] = {.count = 1, .reusable = true}, SHIFT(1501),
  [3154] = {.count = 1, .reusable = true}, REDUCE(sym_with_statement, 5),
  [3156] = {.count = 1, .reusable = false}, REDUCE(sym_with_statement, 5),
  [3158] = {.count = 1, .reusable = true}, SHIFT(1507),
  [3160] = {.count = 1, .reusable = true}, REDUCE(sym_while_statement, 5),
  [3162] = {.count = 1, .reusable = false}, REDUCE(sym_while_statement, 5),
  [3164] = {.count = 1, .reusable = true}, SHIFT(1509),
  [3166] = {.count = 1, .reusable = true}, SHIFT(1512),
  [3168] = {.count = 1, .reusable = true}, SHIFT(1513),
  [3170] = {.count = 1, .reusable = true}, SHIFT(1514),
  [3172] = {.count = 1, .reusable = true}, SHIFT(1516),
  [3174] = {.count = 1, .reusable = true}, SHIFT(1519),
  [3176] = {.count = 1, .reusable = true}, SHIFT(1521),
  [3178] = {.count = 1, .reusable = true}, SHIFT(1522),
  [3180] = {.count = 1, .reusable = true}, REDUCE(sym__suite, 3),
  [3182] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(791),
  [3185] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(792),
  [3188] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(793),
  [3191] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(794),
  [3194] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(795),
  [3197] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(796),
  [3200] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(797),
  [3203] = {.count = 2, .reusable = false}, REDUCE(aux_sym_module_repeat1, 2), SHIFT_REPEAT(798),
  [3206] = {.count = 1, .reusable = true}, SHIFT(1523),
  [3208] = {.count = 1, .reusable = true}, SHIFT(1525),
  [3210] = {.count = 1, .reusable = true}, SHIFT(1526),
  [3212] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 5),
  [3214] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 5),
  [3216] = {.count = 1, .reusable = true}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [3218] = {.count = 1, .reusable = false}, REDUCE(aux_sym_try_statement_repeat1, 2),
  [3220] = {.count = 2, .reusable = false}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(805),
  [3223] = {.count = 1, .reusable = true}, SHIFT(1532),
  [3225] = {.count = 1, .reusable = true}, SHIFT(1534),
  [3227] = {.count = 1, .reusable = true}, SHIFT(1535),
  [3229] = {.count = 1, .reusable = true}, SHIFT(1536),
  [3231] = {.count = 1, .reusable = false}, SHIFT(1537),
  [3233] = {.count = 1, .reusable = true}, SHIFT(1538),
  [3235] = {.count = 1, .reusable = true}, SHIFT(1539),
  [3237] = {.count = 1, .reusable = true}, SHIFT(1537),
  [3239] = {.count = 1, .reusable = true}, SHIFT(1540),
  [3241] = {.count = 1, .reusable = true}, SHIFT(1541),
  [3243] = {.count = 1, .reusable = true}, SHIFT(1542),
  [3245] = {.count = 1, .reusable = true}, SHIFT(1543),
  [3247] = {.count = 1, .reusable = true}, SHIFT(1544),
  [3249] = {.count = 1, .reusable = true}, SHIFT(1545),
  [3251] = {.count = 1, .reusable = false}, SHIFT(1539),
  [3253] = {.count = 1, .reusable = true}, SHIFT(1546),
  [3255] = {.count = 1, .reusable = false}, SHIFT(1549),
  [3257] = {.count = 1, .reusable = false}, SHIFT(1550),
  [3259] = {.count = 1, .reusable = true}, SHIFT(1554),
  [3261] = {.count = 1, .reusable = false}, SHIFT(1556),
  [3263] = {.count = 1, .reusable = true}, SHIFT(1557),
  [3265] = {.count = 1, .reusable = false}, SHIFT(1558),
  [3267] = {.count = 1, .reusable = true}, SHIFT(1561),
  [3269] = {.count = 1, .reusable = false}, SHIFT(1561),
  [3271] = {.count = 1, .reusable = false}, SHIFT(1559),
  [3273] = {.count = 1, .reusable = true}, SHIFT(1565),
  [3275] = {.count = 1, .reusable = true}, REDUCE(sym_parameters, 3),
  [3277] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 5),
  [3279] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 5),
  [3281] = {.count = 1, .reusable = true}, SHIFT(1567),
  [3283] = {.count = 1, .reusable = true}, REDUCE(sym_exec_statement, 5),
  [3285] = {.count = 1, .reusable = true}, REDUCE(sym_class_definition, 5),
  [3287] = {.count = 1, .reusable = false}, REDUCE(sym_class_definition, 5),
  [3289] = {.count = 1, .reusable = true}, SHIFT(1569),
  [3291] = {.count = 1, .reusable = true}, SHIFT(1570),
  [3293] = {.count = 1, .reusable = false}, SHIFT(1570),
  [3295] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(855),
  [3298] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(856),
  [3301] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(855),
  [3304] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(862),
  [3307] = {.count = 1, .reusable = true}, SHIFT(1572),
  [3309] = {.count = 1, .reusable = true}, SHIFT(1575),
  [3311] = {.count = 1, .reusable = false}, SHIFT(1575),
  [3313] = {.count = 1, .reusable = true}, SHIFT(1576),
  [3315] = {.count = 1, .reusable = false}, SHIFT(1576),
  [3317] = {.count = 1, .reusable = true}, SHIFT(1577),
  [3319] = {.count = 1, .reusable = false}, SHIFT(1577),
  [3321] = {.count = 1, .reusable = true}, SHIFT(1578),
  [3323] = {.count = 1, .reusable = true}, SHIFT(1579),
  [3325] = {.count = 1, .reusable = false}, SHIFT(1579),
  [3327] = {.count = 1, .reusable = true}, SHIFT(1580),
  [3329] = {.count = 1, .reusable = false}, SHIFT(1580),
  [3331] = {.count = 1, .reusable = true}, SHIFT(1581),
  [3333] = {.count = 1, .reusable = false}, SHIFT(1581),
  [3335] = {.count = 1, .reusable = true}, SHIFT(1582),
  [3337] = {.count = 1, .reusable = false}, SHIFT(1582),
  [3339] = {.count = 1, .reusable = false}, SHIFT(1578),
  [3341] = {.count = 1, .reusable = true}, SHIFT(1587),
  [3343] = {.count = 1, .reusable = true}, SHIFT(1590),
  [3345] = {.count = 1, .reusable = false}, SHIFT(1590),
  [3347] = {.count = 1, .reusable = true}, SHIFT(1591),
  [3349] = {.count = 1, .reusable = false}, SHIFT(1591),
  [3351] = {.count = 1, .reusable = true}, SHIFT(1592),
  [3353] = {.count = 1, .reusable = false}, SHIFT(1592),
  [3355] = {.count = 1, .reusable = true}, SHIFT(1593),
  [3357] = {.count = 1, .reusable = true}, SHIFT(1594),
  [3359] = {.count = 1, .reusable = false}, SHIFT(1594),
  [3361] = {.count = 1, .reusable = true}, SHIFT(1595),
  [3363] = {.count = 1, .reusable = false}, SHIFT(1595),
  [3365] = {.count = 1, .reusable = true}, SHIFT(1596),
  [3367] = {.count = 1, .reusable = false}, SHIFT(1596),
  [3369] = {.count = 1, .reusable = true}, SHIFT(1597),
  [3371] = {.count = 1, .reusable = false}, SHIFT(1597),
  [3373] = {.count = 1, .reusable = false}, SHIFT(1593),
  [3375] = {.count = 1, .reusable = true}, SHIFT(1602),
  [3377] = {.count = 1, .reusable = true}, SHIFT(1603),
  [3379] = {.count = 1, .reusable = false}, SHIFT(1603),
  [3381] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(901),
  [3384] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(902),
  [3387] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(901),
  [3390] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(908),
  [3393] = {.count = 1, .reusable = true}, REDUCE(sym_list, 5),
  [3395] = {.count = 1, .reusable = false}, REDUCE(sym_list, 5),
  [3397] = {.count = 1, .reusable = true}, SHIFT(1605),
  [3399] = {.count = 1, .reusable = false}, SHIFT(1606),
  [3401] = {.count = 1, .reusable = true}, SHIFT(1610),
  [3403] = {.count = 1, .reusable = true}, SHIFT(1613),
  [3405] = {.count = 1, .reusable = true}, SHIFT(1614),
  [3407] = {.count = 1, .reusable = false}, SHIFT(1615),
  [3409] = {.count = 1, .reusable = true}, SHIFT(1616),
  [3411] = {.count = 1, .reusable = true}, SHIFT(1617),
  [3413] = {.count = 1, .reusable = true}, SHIFT(1615),
  [3415] = {.count = 1, .reusable = true}, SHIFT(1618),
  [3417] = {.count = 1, .reusable = true}, SHIFT(1619),
  [3419] = {.count = 1, .reusable = true}, SHIFT(1620),
  [3421] = {.count = 1, .reusable = true}, SHIFT(1621),
  [3423] = {.count = 1, .reusable = true}, SHIFT(1622),
  [3425] = {.count = 1, .reusable = true}, SHIFT(1623),
  [3427] = {.count = 1, .reusable = false}, SHIFT(1617),
  [3429] = {.count = 1, .reusable = true}, SHIFT(1624),
  [3431] = {.count = 2, .reusable = true}, REDUCE(aux_sym__comprehension_body_repeat1, 2), SHIFT_REPEAT(923),
  [3434] = {.count = 2, .reusable = true}, REDUCE(aux_sym__comprehension_body_repeat1, 2), SHIFT_REPEAT(460),
  [3437] = {.count = 2, .reusable = true}, REDUCE(aux_sym__comprehension_body_repeat1, 2), SHIFT_REPEAT(461),
  [3440] = {.count = 1, .reusable = true}, SHIFT(1628),
  [3442] = {.count = 1, .reusable = true}, SHIFT(1629),
  [3444] = {.count = 1, .reusable = false}, SHIFT(1629),
  [3446] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(944),
  [3449] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(945),
  [3452] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(944),
  [3455] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(951),
  [3458] = {.count = 1, .reusable = true}, REDUCE(sym_set, 5),
  [3460] = {.count = 1, .reusable = false}, REDUCE(sym_set, 5),
  [3462] = {.count = 1, .reusable = true}, REDUCE(sym_dictionary, 5),
  [3464] = {.count = 1, .reusable = false}, REDUCE(sym_dictionary, 5),
  [3466] = {.count = 1, .reusable = true}, SHIFT(1633),
  [3468] = {.count = 1, .reusable = true}, SHIFT(1636),
  [3470] = {.count = 1, .reusable = false}, SHIFT(1636),
  [3472] = {.count = 1, .reusable = true}, SHIFT(1637),
  [3474] = {.count = 1, .reusable = false}, SHIFT(1637),
  [3476] = {.count = 1, .reusable = true}, SHIFT(1638),
  [3478] = {.count = 1, .reusable = false}, SHIFT(1638),
  [3480] = {.count = 1, .reusable = true}, SHIFT(1639),
  [3482] = {.count = 1, .reusable = true}, SHIFT(1640),
  [3484] = {.count = 1, .reusable = false}, SHIFT(1640),
  [3486] = {.count = 1, .reusable = true}, SHIFT(1641),
  [3488] = {.count = 1, .reusable = false}, SHIFT(1641),
  [3490] = {.count = 1, .reusable = true}, SHIFT(1642),
  [3492] = {.count = 1, .reusable = false}, SHIFT(1642),
  [3494] = {.count = 1, .reusable = true}, SHIFT(1643),
  [3496] = {.count = 1, .reusable = false}, SHIFT(1643),
  [3498] = {.count = 1, .reusable = false}, SHIFT(1639),
  [3500] = {.count = 1, .reusable = true}, SHIFT(1646),
  [3502] = {.count = 1, .reusable = false}, SHIFT(1647),
  [3504] = {.count = 1, .reusable = true}, SHIFT(1651),
  [3506] = {.count = 1, .reusable = true}, SHIFT(1654),
  [3508] = {.count = 1, .reusable = true}, SHIFT(1655),
  [3510] = {.count = 1, .reusable = false}, SHIFT(1656),
  [3512] = {.count = 1, .reusable = true}, SHIFT(1657),
  [3514] = {.count = 1, .reusable = true}, SHIFT(1658),
  [3516] = {.count = 1, .reusable = true}, SHIFT(1656),
  [3518] = {.count = 1, .reusable = true}, SHIFT(1659),
  [3520] = {.count = 1, .reusable = true}, SHIFT(1660),
  [3522] = {.count = 1, .reusable = true}, SHIFT(1661),
  [3524] = {.count = 1, .reusable = true}, SHIFT(1662),
  [3526] = {.count = 1, .reusable = true}, SHIFT(1663),
  [3528] = {.count = 1, .reusable = true}, SHIFT(1664),
  [3530] = {.count = 1, .reusable = false}, SHIFT(1658),
  [3532] = {.count = 1, .reusable = true}, SHIFT(1665),
  [3534] = {.count = 2, .reusable = true}, REDUCE(aux_sym__comprehension_body_repeat1, 2), SHIFT_REPEAT(979),
  [3537] = {.count = 2, .reusable = true}, REDUCE(aux_sym__comprehension_body_repeat1, 2), SHIFT_REPEAT(497),
  [3540] = {.count = 2, .reusable = true}, REDUCE(aux_sym__comprehension_body_repeat1, 2), SHIFT_REPEAT(498),
  [3543] = {.count = 1, .reusable = true}, SHIFT(1669),
  [3545] = {.count = 1, .reusable = true}, SHIFT(1670),
  [3547] = {.count = 1, .reusable = false}, SHIFT(1670),
  [3549] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1002),
  [3552] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1003),
  [3555] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1002),
  [3558] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1009),
  [3561] = {.count = 1, .reusable = true}, REDUCE(sym_assignment, 5),
  [3563] = {.count = 1, .reusable = true}, SHIFT(1672),
  [3565] = {.count = 1, .reusable = true}, REDUCE(sym_conditional_expression, 5),
  [3567] = {.count = 1, .reusable = true}, SHIFT(1673),
  [3569] = {.count = 1, .reusable = false}, SHIFT(1673),
  [3571] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1024),
  [3574] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1025),
  [3577] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1024),
  [3580] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1031),
  [3583] = {.count = 1, .reusable = true}, REDUCE(sym_keyword_argument, 3, .alias_sequence_id = 1),
  [3585] = {.count = 1, .reusable = true}, REDUCE(sym_keyword_argument, 3),
  [3587] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 4),
  [3589] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 4),
  [3591] = {.count = 1, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2),
  [3593] = {.count = 1, .reusable = true}, SHIFT(1674),
  [3595] = {.count = 2, .reusable = true}, REDUCE(aux_sym_argument_list_repeat1, 2), SHIFT_REPEAT(1675),
  [3598] = {.count = 1, .reusable = true}, REDUCE(sym_slice, 3),
  [3600] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 5),
  [3602] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 5),
  [3604] = {.count = 1, .reusable = true}, REDUCE(aux_sym_subscript_repeat1, 2),
  [3606] = {.count = 1, .reusable = true}, SHIFT(1678),
  [3608] = {.count = 1, .reusable = true}, SHIFT(1679),
  [3610] = {.count = 1, .reusable = true}, SHIFT(1680),
  [3612] = {.count = 2, .reusable = true}, REDUCE(aux_sym_subscript_repeat1, 2), SHIFT_REPEAT(1681),
  [3615] = {.count = 1, .reusable = true}, SHIFT(1682),
  [3617] = {.count = 1, .reusable = false}, SHIFT(1682),
  [3619] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1057),
  [3622] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1058),
  [3625] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1057),
  [3628] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1064),
  [3631] = {.count = 1, .reusable = true}, REDUCE(sym_import_from_statement, 6),
  [3633] = {.count = 1, .reusable = true}, SHIFT(1687),
  [3635] = {.count = 1, .reusable = true}, SHIFT(1689),
  [3637] = {.count = 1, .reusable = true}, SHIFT(1692),
  [3639] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_clause, 4),
  [3641] = {.count = 1, .reusable = true}, SHIFT(1694),
  [3643] = {.count = 1, .reusable = true}, REDUCE(sym__expression_within_for_in_clause, 1),
  [3645] = {.count = 1, .reusable = true}, SHIFT(1697),
  [3647] = {.count = 1, .reusable = true}, SHIFT(1700),
  [3649] = {.count = 1, .reusable = false}, SHIFT(1700),
  [3651] = {.count = 1, .reusable = true}, SHIFT(1701),
  [3653] = {.count = 1, .reusable = false}, SHIFT(1701),
  [3655] = {.count = 1, .reusable = true}, SHIFT(1702),
  [3657] = {.count = 1, .reusable = false}, SHIFT(1702),
  [3659] = {.count = 1, .reusable = true}, SHIFT(1703),
  [3661] = {.count = 1, .reusable = true}, SHIFT(1704),
  [3663] = {.count = 1, .reusable = false}, SHIFT(1704),
  [3665] = {.count = 1, .reusable = true}, SHIFT(1705),
  [3667] = {.count = 1, .reusable = false}, SHIFT(1705),
  [3669] = {.count = 1, .reusable = true}, SHIFT(1706),
  [3671] = {.count = 1, .reusable = false}, SHIFT(1706),
  [3673] = {.count = 1, .reusable = true}, SHIFT(1707),
  [3675] = {.count = 1, .reusable = false}, SHIFT(1707),
  [3677] = {.count = 1, .reusable = false}, SHIFT(1703),
  [3679] = {.count = 1, .reusable = true}, SHIFT(1710),
  [3681] = {.count = 1, .reusable = true}, SHIFT(1711),
  [3683] = {.count = 1, .reusable = true}, SHIFT(1712),
  [3685] = {.count = 1, .reusable = true}, SHIFT(1713),
  [3687] = {.count = 1, .reusable = false}, REDUCE(sym__suite, 3),
  [3689] = {.count = 1, .reusable = true}, SHIFT(1715),
  [3691] = {.count = 1, .reusable = true}, REDUCE(sym_if_statement, 6),
  [3693] = {.count = 1, .reusable = false}, REDUCE(sym_if_statement, 6),
  [3695] = {.count = 1, .reusable = true}, REDUCE(aux_sym_if_statement_repeat1, 2),
  [3697] = {.count = 1, .reusable = false}, REDUCE(aux_sym_if_statement_repeat1, 2),
  [3699] = {.count = 2, .reusable = false}, REDUCE(aux_sym_if_statement_repeat1, 2), SHIFT_REPEAT(1180),
  [3702] = {.count = 1, .reusable = true}, REDUCE(sym_with_statement, 6),
  [3704] = {.count = 1, .reusable = false}, REDUCE(sym_with_statement, 6),
  [3706] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 6),
  [3708] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 6),
  [3710] = {.count = 1, .reusable = true}, SHIFT(1718),
  [3712] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 6),
  [3714] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 6),
  [3716] = {.count = 2, .reusable = true}, REDUCE(aux_sym_print_statement_repeat1, 2), SHIFT_REPEAT(1720),
  [3719] = {.count = 1, .reusable = true}, SHIFT(1721),
  [3721] = {.count = 1, .reusable = true}, SHIFT(1723),
  [3723] = {.count = 1, .reusable = true}, SHIFT(1724),
  [3725] = {.count = 1, .reusable = true}, SHIFT(1729),
  [3727] = {.count = 1, .reusable = true}, SHIFT(1730),
  [3729] = {.count = 1, .reusable = true}, SHIFT(1734),
  [3731] = {.count = 1, .reusable = true}, SHIFT(1735),
  [3733] = {.count = 1, .reusable = true}, SHIFT(1737),
  [3735] = {.count = 1, .reusable = true}, SHIFT(1738),
  [3737] = {.count = 1, .reusable = true}, REDUCE(sym_except_clause, 3),
  [3739] = {.count = 1, .reusable = false}, REDUCE(sym_except_clause, 3),
  [3741] = {.count = 1, .reusable = true}, REDUCE(sym_finally_clause, 3),
  [3743] = {.count = 1, .reusable = false}, REDUCE(sym_finally_clause, 3),
  [3745] = {.count = 1, .reusable = true}, REDUCE(sym_try_statement, 6),
  [3747] = {.count = 1, .reusable = false}, REDUCE(sym_try_statement, 6),
  [3749] = {.count = 1, .reusable = true}, SHIFT(1742),
  [3751] = {.count = 1, .reusable = true}, SHIFT(1745),
  [3753] = {.count = 1, .reusable = false}, SHIFT(1745),
  [3755] = {.count = 1, .reusable = true}, SHIFT(1746),
  [3757] = {.count = 1, .reusable = false}, SHIFT(1746),
  [3759] = {.count = 1, .reusable = true}, SHIFT(1747),
  [3761] = {.count = 1, .reusable = false}, SHIFT(1747),
  [3763] = {.count = 1, .reusable = true}, SHIFT(1748),
  [3765] = {.count = 1, .reusable = true}, SHIFT(1749),
  [3767] = {.count = 1, .reusable = false}, SHIFT(1749),
  [3769] = {.count = 1, .reusable = true}, SHIFT(1750),
  [3771] = {.count = 1, .reusable = false}, SHIFT(1750),
  [3773] = {.count = 1, .reusable = true}, SHIFT(1751),
  [3775] = {.count = 1, .reusable = false}, SHIFT(1751),
  [3777] = {.count = 1, .reusable = true}, SHIFT(1752),
  [3779] = {.count = 1, .reusable = false}, SHIFT(1752),
  [3781] = {.count = 1, .reusable = false}, SHIFT(1748),
  [3783] = {.count = 1, .reusable = true}, SHIFT(1755),
  [3785] = {.count = 2, .reusable = true}, REDUCE(aux_sym__parameters_repeat1, 2), SHIFT_REPEAT(1756),
  [3788] = {.count = 1, .reusable = true}, SHIFT(1758),
  [3790] = {.count = 1, .reusable = true}, SHIFT(1760),
  [3792] = {.count = 1, .reusable = true}, SHIFT(1761),
  [3794] = {.count = 1, .reusable = true}, SHIFT(1762),
  [3796] = {.count = 1, .reusable = false}, SHIFT(1763),
  [3798] = {.count = 1, .reusable = true}, SHIFT(1764),
  [3800] = {.count = 1, .reusable = true}, SHIFT(1765),
  [3802] = {.count = 1, .reusable = true}, SHIFT(1763),
  [3804] = {.count = 1, .reusable = true}, SHIFT(1766),
  [3806] = {.count = 1, .reusable = true}, SHIFT(1767),
  [3808] = {.count = 1, .reusable = true}, SHIFT(1768),
  [3810] = {.count = 1, .reusable = true}, SHIFT(1769),
  [3812] = {.count = 1, .reusable = true}, SHIFT(1770),
  [3814] = {.count = 1, .reusable = true}, SHIFT(1771),
  [3816] = {.count = 1, .reusable = false}, SHIFT(1765),
  [3818] = {.count = 1, .reusable = true}, SHIFT(1772),
  [3820] = {.count = 1, .reusable = true}, SHIFT(1774),
  [3822] = {.count = 1, .reusable = true}, SHIFT(1779),
  [3824] = {.count = 1, .reusable = true}, SHIFT(1780),
  [3826] = {.count = 1, .reusable = false}, SHIFT(1780),
  [3828] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1268),
  [3831] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1269),
  [3834] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1268),
  [3837] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1275),
  [3840] = {.count = 1, .reusable = true}, REDUCE(sym_typed_default_parameter, 5, .alias_sequence_id = 1),
  [3842] = {.count = 1, .reusable = true}, SHIFT(1782),
  [3844] = {.count = 1, .reusable = true}, SHIFT(1783),
  [3846] = {.count = 1, .reusable = false}, SHIFT(1783),
  [3848] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1288),
  [3851] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1289),
  [3854] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1288),
  [3857] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1295),
  [3860] = {.count = 1, .reusable = true}, REDUCE(sym_typed_default_parameter, 5),
  [3862] = {.count = 1, .reusable = true}, SHIFT(1786),
  [3864] = {.count = 1, .reusable = true}, SHIFT(1788),
  [3866] = {.count = 1, .reusable = true}, SHIFT(1791),
  [3868] = {.count = 1, .reusable = true}, SHIFT(1794),
  [3870] = {.count = 1, .reusable = false}, SHIFT(1794),
  [3872] = {.count = 1, .reusable = true}, SHIFT(1795),
  [3874] = {.count = 1, .reusable = false}, SHIFT(1795),
  [3876] = {.count = 1, .reusable = true}, SHIFT(1796),
  [3878] = {.count = 1, .reusable = false}, SHIFT(1796),
  [3880] = {.count = 1, .reusable = true}, SHIFT(1797),
  [3882] = {.count = 1, .reusable = true}, SHIFT(1798),
  [3884] = {.count = 1, .reusable = false}, SHIFT(1798),
  [3886] = {.count = 1, .reusable = true}, SHIFT(1799),
  [3888] = {.count = 1, .reusable = false}, SHIFT(1799),
  [3890] = {.count = 1, .reusable = true}, SHIFT(1800),
  [3892] = {.count = 1, .reusable = false}, SHIFT(1800),
  [3894] = {.count = 1, .reusable = true}, SHIFT(1801),
  [3896] = {.count = 1, .reusable = false}, SHIFT(1801),
  [3898] = {.count = 1, .reusable = false}, SHIFT(1797),
  [3900] = {.count = 1, .reusable = true}, SHIFT(1806),
  [3902] = {.count = 1, .reusable = true}, SHIFT(1807),
  [3904] = {.count = 1, .reusable = false}, SHIFT(1807),
  [3906] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1357),
  [3909] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1358),
  [3912] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1357),
  [3915] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1364),
  [3918] = {.count = 1, .reusable = true}, SHIFT(1809),
  [3920] = {.count = 1, .reusable = true}, SHIFT(1811),
  [3922] = {.count = 1, .reusable = true}, SHIFT(1814),
  [3924] = {.count = 1, .reusable = true}, SHIFT(1817),
  [3926] = {.count = 1, .reusable = false}, SHIFT(1817),
  [3928] = {.count = 1, .reusable = true}, SHIFT(1818),
  [3930] = {.count = 1, .reusable = false}, SHIFT(1818),
  [3932] = {.count = 1, .reusable = true}, SHIFT(1819),
  [3934] = {.count = 1, .reusable = false}, SHIFT(1819),
  [3936] = {.count = 1, .reusable = true}, SHIFT(1820),
  [3938] = {.count = 1, .reusable = true}, SHIFT(1821),
  [3940] = {.count = 1, .reusable = false}, SHIFT(1821),
  [3942] = {.count = 1, .reusable = true}, SHIFT(1822),
  [3944] = {.count = 1, .reusable = false}, SHIFT(1822),
  [3946] = {.count = 1, .reusable = true}, SHIFT(1823),
  [3948] = {.count = 1, .reusable = false}, SHIFT(1823),
  [3950] = {.count = 1, .reusable = true}, SHIFT(1824),
  [3952] = {.count = 1, .reusable = false}, SHIFT(1824),
  [3954] = {.count = 1, .reusable = false}, SHIFT(1820),
  [3956] = {.count = 1, .reusable = true}, REDUCE(sym_argument_list, 5),
  [3958] = {.count = 1, .reusable = false}, REDUCE(sym_argument_list, 5),
  [3960] = {.count = 1, .reusable = true}, REDUCE(sym_slice, 4),
  [3962] = {.count = 1, .reusable = true}, REDUCE(sym_subscript, 6),
  [3964] = {.count = 1, .reusable = false}, REDUCE(sym_subscript, 6),
  [3966] = {.count = 2, .reusable = true}, REDUCE(aux_sym__import_list_repeat1, 2), SHIFT_REPEAT(1831),
  [3969] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_clause, 5),
  [3971] = {.count = 1, .reusable = true}, SHIFT(1832),
  [3973] = {.count = 1, .reusable = true}, SHIFT(1835),
  [3975] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_clause, 5),
  [3977] = {.count = 1, .reusable = true}, SHIFT(1463),
  [3979] = {.count = 1, .reusable = true}, SHIFT(1839),
  [3981] = {.count = 1, .reusable = true}, SHIFT(1840),
  [3983] = {.count = 1, .reusable = false}, SHIFT(1840),
  [3985] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1468),
  [3988] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1469),
  [3991] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1468),
  [3994] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1475),
  [3997] = {.count = 1, .reusable = true}, REDUCE(sym_else_clause, 3),
  [3999] = {.count = 1, .reusable = false}, REDUCE(sym_else_clause, 3),
  [4001] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 7),
  [4003] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 7),
  [4005] = {.count = 1, .reusable = true}, SHIFT(1844),
  [4007] = {.count = 1, .reusable = false}, SHIFT(1846),
  [4009] = {.count = 1, .reusable = false}, SHIFT(1847),
  [4011] = {.count = 1, .reusable = true}, SHIFT(1852),
  [4013] = {.count = 1, .reusable = true}, SHIFT(1853),
  [4015] = {.count = 1, .reusable = true}, SHIFT(1854),
  [4017] = {.count = 1, .reusable = true}, SHIFT(1855),
  [4019] = {.count = 1, .reusable = true}, SHIFT(1857),
  [4021] = {.count = 1, .reusable = true}, SHIFT(1859),
  [4023] = {.count = 1, .reusable = false}, SHIFT(1729),
  [4025] = {.count = 1, .reusable = false}, SHIFT(1730),
  [4027] = {.count = 1, .reusable = true}, SHIFT(1866),
  [4029] = {.count = 1, .reusable = true}, REDUCE(sym_except_clause, 4),
  [4031] = {.count = 1, .reusable = false}, REDUCE(sym_except_clause, 4),
  [4033] = {.count = 1, .reusable = true}, SHIFT(1868),
  [4035] = {.count = 1, .reusable = true}, SHIFT(1869),
  [4037] = {.count = 1, .reusable = false}, SHIFT(1869),
  [4039] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1539),
  [4042] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1540),
  [4045] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1539),
  [4048] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1546),
  [4051] = {.count = 1, .reusable = true}, SHIFT(1872),
  [4053] = {.count = 1, .reusable = true}, SHIFT(1875),
  [4055] = {.count = 1, .reusable = false}, SHIFT(1875),
  [4057] = {.count = 1, .reusable = true}, SHIFT(1876),
  [4059] = {.count = 1, .reusable = false}, SHIFT(1876),
  [4061] = {.count = 1, .reusable = true}, SHIFT(1877),
  [4063] = {.count = 1, .reusable = false}, SHIFT(1877),
  [4065] = {.count = 1, .reusable = true}, SHIFT(1878),
  [4067] = {.count = 1, .reusable = true}, SHIFT(1879),
  [4069] = {.count = 1, .reusable = false}, SHIFT(1879),
  [4071] = {.count = 1, .reusable = true}, SHIFT(1880),
  [4073] = {.count = 1, .reusable = false}, SHIFT(1880),
  [4075] = {.count = 1, .reusable = true}, SHIFT(1881),
  [4077] = {.count = 1, .reusable = false}, SHIFT(1881),
  [4079] = {.count = 1, .reusable = true}, SHIFT(1882),
  [4081] = {.count = 1, .reusable = false}, SHIFT(1882),
  [4083] = {.count = 1, .reusable = false}, SHIFT(1878),
  [4085] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 7),
  [4087] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 7),
  [4089] = {.count = 1, .reusable = true}, SHIFT(1888),
  [4091] = {.count = 1, .reusable = true}, SHIFT(1890),
  [4093] = {.count = 1, .reusable = true}, SHIFT(1612),
  [4095] = {.count = 1, .reusable = true}, SHIFT(1893),
  [4097] = {.count = 1, .reusable = true}, SHIFT(1894),
  [4099] = {.count = 1, .reusable = false}, SHIFT(1894),
  [4101] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1617),
  [4104] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1618),
  [4107] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1617),
  [4110] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1624),
  [4113] = {.count = 1, .reusable = true}, SHIFT(1896),
  [4115] = {.count = 1, .reusable = true}, SHIFT(1898),
  [4117] = {.count = 1, .reusable = true}, SHIFT(1653),
  [4119] = {.count = 1, .reusable = true}, SHIFT(1901),
  [4121] = {.count = 1, .reusable = true}, SHIFT(1902),
  [4123] = {.count = 1, .reusable = false}, SHIFT(1902),
  [4125] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1658),
  [4128] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1659),
  [4131] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1658),
  [4134] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1665),
  [4137] = {.count = 1, .reusable = true}, REDUCE(sym_slice, 5),
  [4139] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_clause, 6),
  [4141] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_clause, 6),
  [4143] = {.count = 1, .reusable = true}, SHIFT(1903),
  [4145] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_within_for_in_clause, 3),
  [4147] = {.count = 1, .reusable = true}, REDUCE(aux_sym_for_in_clause_repeat1, 2),
  [4149] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_in_clause_repeat1, 2), SHIFT_REPEAT(1905),
  [4152] = {.count = 1, .reusable = true}, REDUCE(sym_elif_clause, 4),
  [4154] = {.count = 1, .reusable = false}, REDUCE(sym_elif_clause, 4),
  [4156] = {.count = 1, .reusable = true}, REDUCE(sym_for_statement, 8),
  [4158] = {.count = 1, .reusable = false}, REDUCE(sym_for_statement, 8),
  [4160] = {.count = 1, .reusable = true}, REDUCE(sym_function_definition, 8),
  [4162] = {.count = 1, .reusable = false}, REDUCE(sym_function_definition, 8),
  [4164] = {.count = 1, .reusable = true}, SHIFT(1907),
  [4166] = {.count = 1, .reusable = true}, SHIFT(1909),
  [4168] = {.count = 1, .reusable = true}, SHIFT(1912),
  [4170] = {.count = 1, .reusable = true}, SHIFT(1918),
  [4172] = {.count = 1, .reusable = true}, SHIFT(1919),
  [4174] = {.count = 2, .reusable = false}, REDUCE(aux_sym_try_statement_repeat1, 2), SHIFT_REPEAT(1729),
  [4177] = {.count = 1, .reusable = true}, SHIFT(1922),
  [4179] = {.count = 1, .reusable = true}, SHIFT(1926),
  [4181] = {.count = 1, .reusable = true}, SHIFT(1927),
  [4183] = {.count = 1, .reusable = false}, SHIFT(1927),
  [4185] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1765),
  [4188] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1766),
  [4191] = {.count = 2, .reusable = false}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1765),
  [4194] = {.count = 2, .reusable = true}, REDUCE(aux_sym_comparison_operator_repeat1, 2), SHIFT_REPEAT(1772),
  [4197] = {.count = 1, .reusable = true}, SHIFT(1928),
  [4199] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_in_clause_repeat1, 2), SHIFT_REPEAT(1929),
  [4202] = {.count = 1, .reusable = true}, SHIFT(1931),
  [4204] = {.count = 2, .reusable = true}, REDUCE(aux_sym_for_in_clause_repeat1, 2), SHIFT_REPEAT(1932),
  [4207] = {.count = 1, .reusable = true}, REDUCE(sym_for_in_clause, 7),
  [4209] = {.count = 1, .reusable = false}, REDUCE(sym_for_in_clause, 7),
  [4211] = {.count = 1, .reusable = true}, REDUCE(sym_lambda_within_for_in_clause, 4),
  [4213] = {.count = 1, .reusable = true}, SHIFT(1934),
  [4215] = {.count = 2, .reusable = false}, REDUCE(aux_sym_if_statement_repeat1, 2), SHIFT_REPEAT(1846),
  [4218] = {.count = 1, .reusable = true}, SHIFT(1937),
  [4220] = {.count = 1, .reusable = true}, REDUCE(sym_except_clause, 6),
  [4222] = {.count = 1, .reusable = false}, REDUCE(sym_except_clause, 6),
  [4224] = {.count = 1, .reusable = true}, SHIFT(1946),
};

void *tree_sitter_python_external_scanner_create();
void tree_sitter_python_external_scanner_destroy(void *);
bool tree_sitter_python_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_python_external_scanner_serialize(void *, char *);
void tree_sitter_python_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef _WIN32
#define extern __declspec(dllexport)
#endif

extern const TSLanguage *tree_sitter_python() {
  static TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .symbol_metadata = ts_symbol_metadata,
    .parse_table = (const unsigned short *)ts_parse_table,
    .parse_actions = ts_parse_actions,
    .lex_modes = ts_lex_modes,
    .symbol_names = ts_symbol_names,
    .alias_sequences = (const TSSymbol *)ts_alias_sequences,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .lex_fn = ts_lex,
    .keyword_lex_fn = ts_lex_keywords,
    .keyword_capture_token = sym_identifier,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .external_scanner = {
      (const bool *)ts_external_scanner_states,
      ts_external_scanner_symbol_map,
      tree_sitter_python_external_scanner_create,
      tree_sitter_python_external_scanner_destroy,
      tree_sitter_python_external_scanner_scan,
      tree_sitter_python_external_scanner_serialize,
      tree_sitter_python_external_scanner_deserialize,
    },
  };
  return &language;
}
